/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(z){for(var e=[],S=0,t=z.length;S<t;S++)e[S]=te[z[S]];return e};define(te[118],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(D){return D?D.replace(/\$\((.*?)\)/g,(E,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(E,u,w){this.id=E,this.definition=u,this.description=w,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function M(D,E){const u=["codicon","codicon-"+D];return E&&u.push("codicon-modifier-"+E),u}e.getClassNamesArray=M;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(I){if(I instanceof t)return["codicon","codicon-"+I.id];const C=E.exec(I.id);if(!C)return u(t.error);const[,d,m]=C,P=["codicon","codicon-"+d];return m&&P.push("codicon-modifier-"+m.substr(1)),P}D.asClassNameArray=u;function w(I){return u(I).join(" ")}D.asClassName=w;function v(I){return"."+u(I).join(".")}D.asCSSSelector=v})(R=e.CSSIcon||(e.CSSIcon={}))}),define(te[119],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(E,u){const w=Math.pow(10,u);return Math.round(E*w)/w}class t{constructor(u,w,v,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=S(Math.max(Math.min(1,I),0),3)}static equals(u,w){return u.r===w.r&&u.g===w.g&&u.b===w.b&&u.a===w.a}}e.RGBA=t;class M{constructor(u,w,v,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.l=S(Math.max(Math.min(1,v),0),3),this.a=S(Math.max(Math.min(1,I),0),3)}static equals(u,w){return u.h===w.h&&u.s===w.s&&u.l===w.l&&u.a===w.a}static fromRGBA(u){const w=u.r/255,v=u.g/255,I=u.b/255,C=u.a,d=Math.max(w,v,I),m=Math.min(w,v,I);let P=0,b=0;const p=(m+d)/2,y=d-m;if(y>0){switch(b=Math.min(p<=.5?y/(2*p):y/(2-2*p),1),d){case w:P=(v-I)/y+(v<I?6:0);break;case v:P=(I-w)/y+2;break;case I:P=(w-v)/y+4;break}P*=60,P=Math.round(P)}return new M(P,b,p,C)}static _hue2rgb(u,w,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?u+(w-u)*6*v:v<1/2?w:v<2/3?u+(w-u)*(2/3-v)*6:u}static toRGBA(u){const w=u.h/360,{s:v,l:I,a:C}=u;let d,m,P;if(v===0)d=m=P=I;else{const b=I<.5?I*(1+v):I+v-I*v,p=2*I-b;d=M._hue2rgb(p,b,w+1/3),m=M._hue2rgb(p,b,w),P=M._hue2rgb(p,b,w-1/3)}return new t(Math.round(d*255),Math.round(m*255),Math.round(P*255),C)}}e.HSLA=M;class R{constructor(u,w,v,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.v=S(Math.max(Math.min(1,v),0),3),this.a=S(Math.max(Math.min(1,I),0),3)}static equals(u,w){return u.h===w.h&&u.s===w.s&&u.v===w.v&&u.a===w.a}static fromRGBA(u){const w=u.r/255,v=u.g/255,I=u.b/255,C=Math.max(w,v,I),d=Math.min(w,v,I),m=C-d,P=C===0?0:m/C;let b;return m===0?b=0:C===w?b=((v-I)/m%6+6)%6:C===v?b=(I-w)/m+2:b=(w-v)/m+4,new R(Math.round(b*60),P,C,u.a)}static toRGBA(u){const{h:w,s:v,v:I,a:C}=u,d=I*v,m=d*(1-Math.abs(w/60%2-1)),P=I-d;let[b,p,y]=[0,0,0];return w<60?(b=d,p=m):w<120?(b=m,p=d):w<180?(p=d,y=m):w<240?(p=m,y=d):w<300?(b=m,y=d):w<=360&&(b=d,y=m),b=Math.round((b+P)*255),p=Math.round((p+P)*255),y=Math.round((y+P)*255),new t(b,p,y,C)}}e.HSVA=R;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}static equals(u,w){return!u&&!w?!0:!u||!w?!1:u.equals(w)}get hsla(){return this._hsla?this._hsla:M.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof M)this._hsla=u,this.rgba=M.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&M.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),w=D._relativeLuminanceForComponent(this.rgba.g),v=D._relativeLuminanceForComponent(this.rgba.b),I=.2126*u+.7152*w+.0722*v;return S(I,4)}static _relativeLuminanceForComponent(u){const w=u/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w>v?(w+.05)/(v+.05):(v+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w>v}isDarkerThan(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w<v}lighten(u){return new D(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:w,g:v,b:I,a:C}=this.rgba;return new D(new t(w,v,I,C*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const w=u.rgba,v=this.rgba.a,I=w.a,C=v+I*(1-v);if(C<1e-6)return D.transparent;const d=this.rgba.r*v/C+w.r*I*(1-v)/C,m=this.rgba.g*v/C+w.g*I*(1-v)/C,P=this.rgba.b*v/C+w.b*I*(1-v)/C;return new D(new t(d,m,P,C))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:w,g:v,b:I,a:C}=this.rgba;return new D(new t(u.rgba.r-C*(u.rgba.r-w),u.rgba.g-C*(u.rgba.g-v),u.rgba.b-C*(u.rgba.b-I),1))}flatten(...u){const w=u.reduceRight((v,I)=>D._flatten(I,v));return D._flatten(this,w)}static _flatten(u,w){const v=1-u.rgba.a;return new D(new t(v*w.rgba.r+u.rgba.a*u.rgba.r,v*w.rgba.g+u.rgba.a*u.rgba.g,v*w.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,w,v){if(u.isLighterThan(w))return u;v=v||.5;const I=u.getRelativeLuminance(),C=w.getRelativeLuminance();return v=v*(C-I)/C,u.lighten(v)}static getDarkerColor(u,w,v){if(u.isDarkerThan(w))return u;v=v||.5;const I=u.getRelativeLuminance(),C=w.getRelativeLuminance();return v=v*(I-C)/I,u.darken(v)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(E){let u;(function(w){let v;(function(I){function C(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:E.Format.CSS.formatRGBA(i)}I.formatRGB=C;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}I.formatRGBA=d;function m(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(i)}I.formatHSL=m;function P(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}I.formatHSLA=P;function b(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function p(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}I.formatHex=p;function y(i,a=!1){return a&&i.rgba.a===1?E.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}I.formatHexA=y;function h(i){return i.isOpaque()?E.Format.CSS.formatHex(i):E.Format.CSS.formatRGBA(i)}I.format=h;function g(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const r=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),n=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),s=16*l(i.charCodeAt(5))+l(i.charCodeAt(6));return new E(new t(r,n,s,1))}if(a===9){const r=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),n=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),s=16*l(i.charCodeAt(5))+l(i.charCodeAt(6)),c=16*l(i.charCodeAt(7))+l(i.charCodeAt(8));return new E(new t(r,n,s,c/255))}if(a===4){const r=l(i.charCodeAt(1)),n=l(i.charCodeAt(2)),s=l(i.charCodeAt(3));return new E(new t(16*r+r,16*n+n,16*s+s))}if(a===5){const r=l(i.charCodeAt(1)),n=l(i.charCodeAt(2)),s=l(i.charCodeAt(3)),c=l(i.charCodeAt(4));return new E(new t(16*r+r,16*n+n,16*s+s,(16*c+c)/255))}return null}I.parseHex=g;function l(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=w.CSS||(w.CSS={}))})(u=E.Format||(E.Format={}))}(D=e.Color||(e.Color={}))}),define(te[53],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(D){return(E,u,w)=>{let v=null,I=null;if(typeof w.value=="function"?(v="value",I=w.value):typeof w.get=="function"&&(v="get",I=w.get),!I)throw new Error("not supported");w[v]=D(I,u)}}e.createDecorator=S;function t(D,E,u){let w=null,v=null;if(typeof u.value=="function"?(w="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(w="get",v=u.get),!v)throw new Error("not supported");const I=`$memoize$${E}`;u[w]=function(...C){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,C)}),this[I]}}e.memoize=t;function M(D,E,u){return S((w,v)=>{const I=`$debounce$${v}`,C=`$debounce$result$${v}`;return function(...d){this[C]||(this[C]=u?u():void 0),clearTimeout(this[I]),E&&(this[C]=E(this[C],...d),d=[this[C]]),this[I]=setTimeout(()=>{w.apply(this,d),this[C]=u?u():void 0},D)}})}e.debounce=M;function R(D,E,u){return S((w,v)=>{const I=`$throttle$timer$${v}`,C=`$throttle$result$${v}`,d=`$throttle$lastRun$${v}`,m=`$throttle$pending$${v}`;return function(...P){if(this[C]||(this[C]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),E&&(this[C]=E(this[C],...P)),this[m])return;const b=this[d]+D;b<=Date.now()?(this[d]=Date.now(),w.apply(this,[this[C]]),this[C]=u?u():void 0):(this[m]=!0,this[I]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),w.apply(this,[this[C]]),this[C]=u?u():void 0},b-Date.now()))}})}e.throttle=R}),define(te[16],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=S,e.errorHandler=new S;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function M(l){u(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=M;function R(l){u(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function D(l){if(l instanceof Error){const{name:i,message:a}=l,r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:a,stack:r,noTelemetry:h.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=D;const E="Canceled";function u(l){return l instanceof w?!0:l instanceof Error&&l.name===E&&l.message===E}e.isCancellationError=u;class w extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=w;function v(){const l=new Error(E);return l.name=l.message,l}e.canceled=v;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function C(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=C;function d(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function m(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=m;function P(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=P;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const a=new h;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class g extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(te[24],ie([0,1,16]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,re=0){return H[H.length-(1+re)]}e.tail=t;function M(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=M;function R(H,re,ne=(ce,ge)=>ce===ge){if(H===re)return!0;if(!H||!re||H.length!==re.length)return!1;for(let ce=0,ge=H.length;ce<ge;ce++)if(!ne(H[ce],re[ce]))return!1;return!0}e.equals=R;function D(H,re){const ne=H.length-1;re<ne&&(H[re]=H[ne]),H.pop()}e.removeFastWithoutKeepingOrder=D;function E(H,re,ne){return u(H.length,ce=>ne(H[ce],re))}e.binarySearch=E;function u(H,re){let ne=0,ce=H-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,Re=re(ge);if(Re<0)ne=ge+1;else if(Re>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=u;function w(H,re){let ne=0,ce=H.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(H[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=w;function v(H,re,ne){if(H=H|0,H>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],Re=[],Te=[];for(const Me of re){const Ae=ne(Me,ce);Ae<0?ge.push(Me):Ae>0?Re.push(Me):Te.push(Me)}return H<ge.length?v(H,ge,ne):H<ge.length+Te.length?Te[0]:v(H-(ge.length+Te.length),Re,ne)}e.quickSelect=v;function I(H,re){const ne=[];let ce;for(const ge of H.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=I;function C(H,re,ne){const ce=[];function ge(Me,Ae,ve){if(Ae===0&&ve.length===0)return;const pe=ce[ce.length-1];pe&&pe.start+pe.deleteCount===Me?(pe.deleteCount+=Ae,pe.toInsert.push(...ve)):ce.push({start:Me,deleteCount:Ae,toInsert:ve})}let Re=0,Te=0;for(;;){if(Re===H.length){ge(Re,0,re.slice(Te));break}if(Te===re.length){ge(Re,H.length-Re,[]);break}const Me=H[Re],Ae=re[Te],ve=ne(Me,Ae);ve===0?(Re+=1,Te+=1):ve<0?(ge(Re,1,[]),Re+=1):ve>0&&(ge(Re,0,[Ae]),Te+=1)}return ce}e.sortedDiff=C;function d(H,re,ne){const ce=C(H,re,ne),ge=[],Re=[];for(const Te of ce)ge.push(...H.slice(Te.start,Te.start+Te.deleteCount)),Re.push(...Te.toInsert);return{removed:ge,added:Re}}e.delta=d;function m(H,re,ne){if(ne===0)return[];const ce=H.slice(0,ne).sort(re);return b(H,re,ce,ne,H.length),ce}e.top=m;function P(H,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((Re,Te)=>{(async()=>{const Me=H.length,Ae=H.slice(0,ne).sort(re);for(let ve=ne,pe=Math.min(ne+ce,Me);ve<Me;ve=pe,pe=Math.min(pe+ce,Me)){if(ve>ne&&await new Promise(Se=>setTimeout(Se)),ge&&ge.isCancellationRequested)throw new S.CancellationError;b(H,re,Ae,ve,pe)}return Ae})().then(Re,Te)})}e.topAsync=P;function b(H,re,ne,ce,ge){for(const Re=ne.length;ce<ge;ce++){const Te=H[ce];if(re(Te,ne[Re-1])<0){ne.pop();const Me=w(ne,Ae=>re(Te,Ae)<0);ne.splice(Me,0,Te)}}}function p(H){return H.filter(re=>!!re)}e.coalesce=p;function y(H){let re=0;for(let ne=0;ne<H.length;ne++)H[ne]&&(H[re]=H[ne],re+=1);H.length=re}e.coalesceInPlace=y;function h(H,re,ne){H.splice(ne,0,H.splice(re,1)[0])}e.move=h;function g(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=g;function l(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=l;function i(H,re=ne=>ne){const ne=new Set;return H.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=i;function a(H){const re=new Set;return ne=>{const ce=H(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=a;function r(H,re){const ne=n(H,re);if(ne!==-1)return H[ne]}e.findLast=r;function n(H,re){for(let ne=H.length-1;ne>=0;ne--){const ce=H[ne];if(re(ce))return ne}return-1}e.lastIndex=n;function s(H,re){return H.length>0?H[0]:re}e.firstOrDefault=s;function c(H,re){return H.length>0?H[H.length-1]:re}e.lastOrDefault=c;function o(H,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,Re=Math.min(H.length,re.length);ge<Re&&ne(H[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=o;function f(H){return[].concat(...H)}e.flatten=f;function k(H,re){let ne=typeof re=="number"?H:0;typeof re=="number"?ne=H:(ne=0,re=H);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=k;function T(H,re,ne){return H.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=T;function _(H,re){return H.push(re),()=>G(H,re)}e.insert=_;function G(H,re){const ne=H.indexOf(re);if(ne>-1)return H.splice(ne,1),re}e.remove=G;function ae(H,re,ne){const ce=H.slice(0,re),ge=H.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function X(H,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=H.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),Re=H[ce];H[ce]=H[ge],H[ge]=Re}}e.shuffle=X;function Q(H,re){const ne=H.indexOf(re);ne>-1&&(H.splice(ne,1),H.unshift(re))}e.pushToStart=Q;function J(H,re){const ne=H.indexOf(re);ne>-1&&(H.splice(ne,1),H.push(re))}e.pushToEnd=J;function se(H,re){for(const ne of re)H.push(ne)}e.pushMany=se;function he(H,re){return Array.isArray(H)?H.map(re):re(H)}e.mapArrayOrNot=he;function V(H){return Array.isArray(H)?H:[H]}e.asArray=V;function j(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=j;function F(H,re){for(const ne of H){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=F;function A(H,re,ne){const ce=N(H,re),ge=H.length,Re=ne.length;H.length=ge+Re;for(let Te=ge-1;Te>=ce;Te--)H[Te+Re]=H[Te];for(let Te=0;Te<Re;Te++)H[Te+ce]=ne[Te]}e.insertInto=A;function W(H,re,ne,ce){const ge=N(H,re),Re=H.splice(ge,ne);return A(H,ge,ce),Re}e.splice=W;function N(H,re){return re<0?Math.max(re+H.length,0):Math.min(re,H.length)}var x;(function(H){function re(ge){return ge<0}H.isLessThan=re;function ne(ge){return ge>0}H.isGreaterThan=ne;function ce(ge){return ge===0}H.isNeitherLessOrGreaterThan=ce,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(x=e.CompareResult||(e.CompareResult={}));function B(H,re){return(ne,ce)=>re(H(ne),H(ce))}e.compareBy=B;function $(...H){return(re,ne)=>{for(const ce of H){const ge=ce(re,ne);if(!x.isNeitherLessOrGreaterThan(ge))return ge}return x.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(H,re)=>H-re;e.numberComparator=L;function O(H,re){if(H.length===0)return;let ne=H[0];for(let ce=1;ce<H.length;ce++){const ge=H[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function U(H,re){if(H.length===0)return;let ne=H[0];for(let ce=1;ce<H.length;ce++){const ge=H[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=U;function q(H,re){return O(H,(ne,ce)=>-re(ne,ce))}e.findMinBy=q;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class oe{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new oe(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new oe(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||x.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(H=>{})}),define(te[120],ie([0,1,16]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(u,w){if(!u)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=t;function M(u,w="Unreachable"){throw new Error(w)}e.assertNever=M;function R(u){if(!u)throw new S.BugIndicatingError("Assertion Failed")}e.assert=R;function D(u){if(!u()){debugger;u(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function E(u,w){let v=0;for(;v<u.length-1;){const I=u[v],C=u[v+1];if(!w(I,C))return!1;v++}return!0}e.checkAdjacentItems=E}),define(te[49],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const M=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(M,arguments)),D}}e.once=S}),define(te[57],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function M(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}t.is=M;const R=Object.freeze([]);function D(){return R}t.empty=D;function*E(a){yield a}t.single=E;function u(a){return a||R}t.from=u;function w(a){return!a||a[Symbol.iterator]().next().done===!0}t.isEmpty=w;function v(a){return a[Symbol.iterator]().next().value}t.first=v;function I(a,r){for(const n of a)if(r(n))return!0;return!1}t.some=I;function C(a,r){for(const n of a)if(r(n))return n}t.find=C;function*d(a,r){for(const n of a)r(n)&&(yield n)}t.filter=d;function*m(a,r){let n=0;for(const s of a)yield r(s,n++)}t.map=m;function*P(...a){for(const r of a)for(const n of r)yield n}t.concat=P;function*b(a){for(const r of a)for(const n of r)yield n}t.concatNested=b;function p(a,r,n){let s=n;for(const c of a)s=r(s,c);return s}t.reduce=p;function y(a,r){let n=0;for(const s of a)r(s,n++)}t.forEach=y;function*h(a,r,n=a.length){for(r<0&&(r+=a.length),n<0?n+=a.length:n>a.length&&(n=a.length);r<n;r++)yield a[r]}t.slice=h;function g(a,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,a];const s=a[Symbol.iterator]();for(let c=0;c<r;c++){const o=s.next();if(o.done)return[n,t.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=g;function l(a){return g(a)[0]}t.collect=l;function i(a,r,n=(s,c)=>s===c){const s=a[Symbol.iterator](),c=r[Symbol.iterator]();for(;;){const o=s.next(),f=c.next();if(o.done!==f.done)return!1;if(o.done)return!0;if(!n(o.value,f.value))return!1}}t.equals=i})(S=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,a=!1){let r=0;const n=i.length;let s="",c=0,o=16,f=0;function k(J){let se=0,he=0;for(;se<J;){const V=i.charCodeAt(r);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;r++,se++}return se<J&&(he=-1),he}function T(J){r=J,s="",c=0,o=16,f=0}function _(){const J=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&w(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&w(i.charCodeAt(r)))for(r++;r<i.length&&w(i.charCodeAt(r));)r++;else return f=3,i.substring(J,r);let se=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&w(i.charCodeAt(r))){for(r++;r<i.length&&w(i.charCodeAt(r));)r++;se=r}else f=3;return i.substring(J,se)}function G(){let J="",se=r;for(;;){if(r>=n){J+=i.substring(se,r),f=2;break}const he=i.charCodeAt(r);if(he===34){J+=i.substring(se,r),r++;break}if(he===92){if(J+=i.substring(se,r),r++,r>=n){f=2;break}switch(i.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const j=k(4);j>=0?J+=String.fromCharCode(j):f=4;break}default:f=5}se=r;continue}if(he>=0&&he<=31)if(u(he)){J+=i.substring(se,r),f=2;break}else f=6;r++}return J}function ae(){if(s="",f=0,c=r,r>=n)return c=n,o=17;let J=i.charCodeAt(r);if(E(J)){do r++,s+=String.fromCharCode(J),J=i.charCodeAt(r);while(E(J));return o=15}if(u(J))return r++,s+=String.fromCharCode(J),J===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),o=14;switch(J){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,s=G(),o=10;case 47:{const se=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!u(i.charCodeAt(r));)r++;return s=i.substring(se,r),o=12}if(i.charCodeAt(r+1)===42){r+=2;const he=n-1;let V=!1;for(;r<he;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,f=1),s=i.substring(se,r),o=13}return s+=String.fromCharCode(J),r++,o=16}case 45:if(s+=String.fromCharCode(J),r++,r===n||!w(i.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),o=11;default:for(;r<n&&X(J);)r++,J=i.charCodeAt(r);if(c!==r){switch(s=i.substring(c,r),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(J),r++,o=16}}function X(J){if(E(J)||u(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let J;do J=ae();while(J>=12&&J<=15);return J}return{setPosition:T,getPosition:()=>r,scan:a?Q:ae,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>f}}e.createScanner=D;function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var v;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(v||(v={}));function I(i,a){const r=[],n=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(k,T,_,G){c.value=k,c.offset=T,c.length=_,c.type=G,c.colonOffset=void 0,s=c}try{h(i,{onObjectBegin:(k,T)=>{if(a<=k)throw n;s=void 0,o=a>k,r.push("")},onObjectProperty:(k,T,_)=>{if(a<T||(f(k,T,_,"property"),r[r.length-1]=k,a<=T+_))throw n},onObjectEnd:(k,T)=>{if(a<=k)throw n;s=void 0,r.pop()},onArrayBegin:(k,T)=>{if(a<=k)throw n;s=void 0,r.push(0)},onArrayEnd:(k,T)=>{if(a<=k)throw n;s=void 0,r.pop()},onLiteralValue:(k,T,_)=>{if(a<T||(f(k,T,_,l(k)),a<=T+_))throw n},onSeparator:(k,T,_)=>{if(a<=T)throw n;if(k===":"&&s&&s.type==="property")s.colonOffset=T,o=!1,s=void 0;else if(k===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(o=!0,r[r.length-1]=""),s=void 0}}})}catch(k){if(k!==n)throw k}return{path:r,previousNode:s,isAtPropertyKey:o,matches:k=>{let T=0;for(let _=0;T<k.length&&_<r.length;_++)if(k[T]===r[_]||k[T]==="*")T++;else if(k[T]!=="**")return!1;return T===k.length}}}e.getLocation=I;function C(i,a=[],r=R.DEFAULT){let n=null,s=[];const c=[];function o(k){Array.isArray(s)?s.push(k):n!==null&&(s[n]=k)}return h(i,{onObjectBegin:()=>{const k={};o(k),c.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const k=[];o(k),c.push(s),s=k,n=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:o,onError:(k,T,_)=>{a.push({error:k,offset:T,length:_})}},r),s[0]}e.parse=C;function d(i,a=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){n.type==="property"&&(n.length=k-n.offset,n=n.parent)}function c(k){return n.children.push(k),k}h(i,{onObjectBegin:k=>{n=c({type:"object",offset:k,length:-1,parent:n,children:[]})},onObjectProperty:(k,T,_)=>{n=c({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:k,offset:T,length:_,parent:n})},onObjectEnd:(k,T)=>{n.length=k+T-n.offset,n=n.parent,s(k+T)},onArrayBegin:(k,T)=>{n=c({type:"array",offset:k,length:-1,parent:n,children:[]})},onArrayEnd:(k,T)=>{n.length=k+T-n.offset,n=n.parent,s(k+T)},onLiteralValue:(k,T,_)=>{c({type:l(k),offset:T,length:_,parent:n,value:k}),s(T+_)},onSeparator:(k,T,_)=>{n.type==="property"&&(k===":"?n.colonOffset=T:k===","&&s(T))},onError:(k,T,_)=>{a.push({error:k,offset:T,length:_})}},r);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=d;function m(i,a){if(!i)return;let r=i;for(const n of a)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===n){r=c.children[1],s=!0;break}if(!s)return}else{const s=n;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=m;function P(i){if(!i.parent||!i.parent.children)return[];const a=P(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=P;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const a=Object.create(null);for(const r of i.children){const n=r.children[1];n&&(a[r.children[0].value]=b(n))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function p(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=p;function y(i,a,r=!1){if(p(i,a,r)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=a;s++){const c=y(n[s],a,r);if(c)return c}return i}}e.findNodeAtOffset=y;function h(i,a,r=R.DEFAULT){const n=D(i,!1);function s(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function c(B){return B?$=>B($,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(a.onObjectBegin),f=c(a.onObjectProperty),k=s(a.onObjectEnd),T=s(a.onArrayBegin),_=s(a.onArrayEnd),G=c(a.onLiteralValue),ae=c(a.onSeparator),X=s(a.onComment),Q=c(a.onError),J=r&&r.disallowComments,se=r&&r.allowTrailingComma;function he(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:J||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:J?V(10):X();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(Q(B),$.length+L.length>0){let O=n.getToken();for(;O!==17;){if($.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function j(B){const $=n.getTokenValue();return B?G($):f($),he(),!0}function F(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}G(B);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return he(),!0}function A(){return n.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),n.getToken()===6?(ae(":"),he(),x()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function W(){o(),he();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||V(4,[],[]),ae(","),he(),n.getToken()===2&&se)break}else B&&V(6,[],[]);A()||V(4,[],[2,5]),B=!0}return k(),n.getToken()!==2?V(7,[2],[]):he(),!0}function N(){T(),he();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||V(4,[],[]),ae(","),he(),n.getToken()===4&&se)break}else B&&V(6,[],[]);x()||V(4,[],[4,5]),B=!0}return _(),n.getToken()!==4?V(8,[4],[]):he(),!0}function x(){switch(n.getToken()){case 3:return N();case 1:return W();case 10:return j(!0);default:return F()}}return he(),n.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):x()?(n.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=h;function g(i,a){const r=D(i),n=[];let s,c=0,o;do switch(o=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:c!==o&&n.push(i.substring(c,o)),a!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,a)),c=r.getPosition();break}while(s!==17);return n.join("")}e.stripComments=g;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[121],ie([0,1,43]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,v,I){let C,d,m,P,b;if(v){for(P=v.offset,b=P+v.length,m=P;m>0&&!u(w,m-1);)m--;let o=b;for(;o<w.length&&!u(w,o);)o++;d=w.substring(m,o),C=D(d,I)}else d=w,C=0,m=0,P=0,b=w.length;const p=E(I,w);let y=!1,h=0,g;I.insertSpaces?g=R(" ",I.tabSize||4):g="	";const l=(0,S.createScanner)(d,!1);let i=!1;function a(){return p+R(g,C+h)}function r(){let o=l.scan();for(y=!1;o===15||o===14;)y=y||o===14,o=l.scan();return i=o===16||l.getTokenError()!==0,o}const n=[];function s(o,f,k){!i&&f<b&&k>P&&w.substring(f,k)!==o&&n.push({offset:f,length:k-f,content:o})}let c=r();if(c!==17){const o=l.getTokenOffset()+m,f=R(g,C);s(f,m,o)}for(;c!==17;){let o=l.getTokenOffset()+l.getTokenLength()+m,f=r(),k="";for(;!y&&(f===12||f===13);){const _=l.getTokenOffset()+m;s(" ",o,_),o=l.getTokenOffset()+l.getTokenLength()+m,k=f===12?a():"",f=r()}if(f===2)c!==1&&(h--,k=a());else if(f===4)c!==3&&(h--,k=a());else{switch(c){case 3:case 1:h++,k=a();break;case 5:case 12:k=a();break;case 13:y?k=a():k=" ";break;case 6:k=" ";break;case 10:if(f===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?k=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}y&&(f===12||f===13)&&(k=a())}const T=l.getTokenOffset()+m;s(k,o,T),c=f}return n}e.format=t;function M(w,v){const I=JSON.stringify(w,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?I.replace(/\r\n|\r|\n/g,v.eol):I}e.toFormattedString=M;function R(w,v){let I="";for(let C=0;C<v;C++)I+=w;return I}function D(w,v){let I=0,C=0;const d=v.tabSize||4;for(;I<w.length;){const m=w.charAt(I);if(m===" ")C++;else if(m==="	")C+=d;else break;I++}return Math.floor(C/d)}function E(w,v){for(let I=0;I<v.length;I++){const C=v.charAt(I);if(C==="\r")return I+1<v.length&&v.charAt(I+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function u(w,v){return`\r
`.indexOf(w.charAt(v))!==-1}e.isEOL=u}),define(te[122],ie([0,1,43,121]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(w,v,I){return R(w,v,void 0,I)}e.removeProperty=M;function R(w,v,I,C,d){const m=v.slice(),P=[],b=(0,S.parseTree)(w,P);let p,y;for(;m.length>0&&(y=m.pop(),p=(0,S.findNodeAtLocation)(b,m),p===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(p)if(p.type==="object"&&typeof y=="string"&&Array.isArray(p.children)){const h=(0,S.findNodeAtLocation)(p,[y]);if(h!==void 0)if(I===void 0){if(!h.parent)throw new Error("Malformed AST");const g=p.children.indexOf(h.parent);let l,i=h.parent.offset+h.parent.length;if(g>0){const a=p.children[g-1];l=a.offset+a.length}else l=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return D(w,{offset:l,length:i-l,content:""},C)}else return D(w,{offset:h.offset,length:h.length,content:JSON.stringify(I)},C);else{if(I===void 0)return[];const g=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,l=d?d(p.children.map(a=>a.children[0].value)):p.children.length;let i;if(l>0){const a=p.children[l-1];i={offset:a.offset+a.length,length:0,content:","+g}}else p.children.length===0?i={offset:p.offset+1,length:0,content:g}:i={offset:p.offset+1,length:0,content:g+","};return D(w,i,C)}}else if(p.type==="array"&&typeof y=="number"&&Array.isArray(p.children))if(I!==void 0){const h=`${JSON.stringify(I)}`;let g;if(p.children.length===0||y===0)g={offset:p.offset+1,length:0,content:p.children.length===0?h:h+","};else{const l=y===-1||y>p.children.length?p.children.length:y,i=p.children[l-1];g={offset:i.offset+i.length,length:0,content:","+h}}return D(w,g,C)}else{const h=y,g=p.children[h];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===h){const i=p.children[h-1],a=i.offset+i.length,r=p.offset+p.length;l={offset:a,length:r-2-a,content:""}}else l={offset:g.offset,length:p.children[h+1].offset-g.offset,content:""};return D(w,l,C)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return D(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},C)}}e.setProperty=R;function D(w,v,I){let C=E(w,v),d=v.offset,m=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;d>0&&!(0,t.isEOL)(C,d-1);)d--;for(;m<C.length&&!(0,t.isEOL)(C,m);)m++}const P=(0,t.format)(C,{offset:d,length:m-d},I);for(let p=P.length-1;p>=0;p--){const y=P[p];C=E(C,y),d=Math.min(d,y.offset),m=Math.max(m,y.offset+y.length),m+=y.content.length-y.length}const b=w.length-(C.length-m)-d;return[{offset:d,length:b,content:C.substring(d,m)}]}e.withFormatting=D;function E(w,v){return w.substring(0,v.offset)+v.content+w.substring(v.offset+v.length)}e.applyEdit=E;function u(w,v){const I=v.slice(0).sort((d,m)=>{const P=d.offset-m.offset;return P===0?d.length-m.length:P});let C=w.length;for(let d=I.length-1;d>=0;d--){const m=I[d];if(m.offset+m.length<=C)w=E(w,m);else throw new Error("Overlapping edit");C=m.offset}return w}e.applyEdits=u}),define(te[123],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(M){this.executor=M,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(M){return new S(()=>M(this.getValue()))}}e.Lazy=S}),define(te[2],ie([0,1,49,57]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let R=null;function D(c){R=c}if(e.setDisposableTracker=D,M){const c="__is_disposable_tracked__";D(new class{trackDisposable(o){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(f)},3e3)}setParent(o,f){if(o&&o!==y.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==y.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function E(c){return R?.trackDisposable(c),c}function u(c){R?.markAsDisposed(c)}function w(c,o){R?.setParent(c,o)}function v(c,o){if(!!R)for(const f of c)R.setParent(f,o)}function I(c){return R?.markAsSingleton(c),c}e.markAsSingleton=I;function C(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=C;function d(c){if(t.Iterable.is(c)){const o=[];for(const f of c)if(f)try{f.dispose()}catch(k){o.push(k)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=d;function m(c){for(const o of c)C(o)&&o.dispose();return[]}e.disposeIfDisposable=m;function P(...c){const o=b(()=>d(c));return v(c,o),o}e.combinedDisposable=P;function b(c){const o=E({dispose:(0,S.once)(()=>{u(o),c()})});return o}e.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new p,E(this),w(this._store,this)}dispose(){u(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=h;class g{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(o){let f=o;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,u(this))},this}}e.SafeDisposable=l;class i{constructor(){this.references=new Map}acquire(o,...f){let k=this.references.get(o);k||(k={counter:0,object:this.createReferencedObject(o,...f)},this.references.set(o,k));const{object:T}=k,_=(0,S.once)(()=>{--k.counter===0&&(this.destroyReferencedObject(o,k.object),this.references.delete(o))});return k.counter++,{object:T,dispose:_}}}e.ReferenceCollection=i;class a{constructor(o){this.referenceCollection=o}async acquire(o,...f){const k=this.referenceCollection.acquire(o,...f);try{return{object:await k.object,dispose:()=>k.dispose()}}catch(T){throw k.dispose(),T}}}e.AsyncReferenceCollection=a;class r{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=r;function n(c){const o=new p;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=n;class s{constructor(){this._store=new Map,this._isDisposed=!1,E(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,f,k=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),k||this._store.get(o)?.dispose(),this._store.set(o,f)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(te[94],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let R=this._first;for(;R!==S.Undefined;){const D=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=D}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const E=new S(R);if(this._first===S.Undefined)this._first=E,this._last=E;else if(D){const w=this._last;this._last=E,E.prev=w,w.next=E}else{const w=this._first;this._first=E,E.next=w,w.prev=E}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(E))}}shift(){if(this._first!==S.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==S.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===S.Undefined&&R.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):R.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):R.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(M){const R=[];typeof M=="number"&&R.push("code/timeOrigin",M);function D(u){R.push(u,Date.now())}function E(){const u=[];for(let w=0;w<R.length;w+=2)u.push({name:R[w],startTime:R[w+1]});return u}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(M+D.startTime)});return R}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function S(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var t in S)(typeof exports=="object"?exports:z)[t]=S[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function S(t){if(e[t])return e[t].exports;var M=e[t]={i:t,l:!1,exports:{}};return z[t].call(M.exports,M,M.exports,S),M.l=!0,M.exports}return S.m=z,S.c=e,S.d=function(t,M,R){S.o(t,M)||Object.defineProperty(t,M,{enumerable:!0,get:R})},S.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},S.t=function(t,M){if(1&M&&(t=S(t)),8&M||4&M&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&M&&typeof t!="string")for(var D in t)S.d(R,D,function(E){return t[E]}.bind(null,D));return R},S.n=function(t){var M=t&&t.__esModule?function(){return t.default}:function(){return t};return S.d(M,"a",M),M},S.o=function(t,M){return Object.prototype.hasOwnProperty.call(t,M)},S.p="",S(S.s=0)}([function(z,e,S){(function(t){var M;e=z.exports=L,M=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],w=0,v=w++;u[v]="0|[1-9]\\d*";var I=w++;u[I]="[0-9]+";var C=w++;u[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=w++;u[d]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var m=w++;u[m]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var P=w++;u[P]="(?:"+u[v]+"|"+u[C]+")";var b=w++;u[b]="(?:"+u[I]+"|"+u[C]+")";var p=w++;u[p]="(?:-("+u[P]+"(?:\\."+u[P]+")*))";var y=w++;u[y]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var h=w++;u[h]="[0-9A-Za-z-]+";var g=w++;u[g]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var l=w++,i="v?"+u[d]+u[p]+"?"+u[g]+"?";u[l]="^"+i+"$";var a="[v=\\s]*"+u[m]+u[y]+"?"+u[g]+"?",r=w++;u[r]="^"+a+"$";var n=w++;u[n]="((?:<|>)?=?)";var s=w++;u[s]=u[I]+"|x|X|\\*";var c=w++;u[c]=u[v]+"|x|X|\\*";var o=w++;u[o]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[p]+")?"+u[g]+"?)?)?";var f=w++;u[f]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[y]+")?"+u[g]+"?)?)?";var k=w++;u[k]="^"+u[n]+"\\s*"+u[o]+"$";var T=w++;u[T]="^"+u[n]+"\\s*"+u[f]+"$";var _=w++;u[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=w++;u[G]="(?:~>?)";var ae=w++;u[ae]="(\\s*)"+u[G]+"\\s+",E[ae]=new RegExp(u[ae],"g");var X=w++;u[X]="^"+u[G]+u[o]+"$";var Q=w++;u[Q]="^"+u[G]+u[f]+"$";var J=w++;u[J]="(?:\\^)";var se=w++;u[se]="(\\s*)"+u[J]+"\\s+",E[se]=new RegExp(u[se],"g");var he=w++;u[he]="^"+u[J]+u[o]+"$";var V=w++;u[V]="^"+u[J]+u[f]+"$";var j=w++;u[j]="^"+u[n]+"\\s*("+a+")$|^$";var F=w++;u[F]="^"+u[n]+"\\s*("+i+")$|^$";var A=w++;u[A]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[o]+")",E[A]=new RegExp(u[A],"g");var W=w++;u[W]="^\\s*("+u[o]+")\\s+-\\s+("+u[o]+")\\s*$";var N=w++;u[N]="^\\s*("+u[f]+")\\s+-\\s+("+u[f]+")\\s*$";var x=w++;u[x]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)M(B,u[B]),E[B]||(E[B]=new RegExp(u[B]));function $(Z,ue){if(Z instanceof L)return Z;if(typeof Z!="string"||Z.length>R||!(ue?E[r]:E[l]).test(Z))return null;try{return new L(Z,ue)}catch{return null}}function L(Z,ue){if(Z instanceof L){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(Z,ue);M("SemVer",Z,ue),this.loose=ue;var de=Z.trim().match(ue?E[r]:E[l]);if(!de)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=$,e.valid=function(Z,ue){var de=$(Z,ue);return de?de.version:null},e.clean=function(Z,ue){var de=$(Z.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(Z){return M("SemVer.compare",this.version,this.loose,Z),Z instanceof L||(Z=new L(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},L.prototype.compareMain=function(Z){return Z instanceof L||(Z=new L(Z,this.loose)),U(this.major,Z.major)||U(this.minor,Z.minor)||U(this.patch,Z.patch)},L.prototype.comparePre=function(Z){if(Z instanceof L||(Z=new L(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],ye=Z.prerelease[ue];if(M("prerelease compare",ue,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return U(de,ye)}while(++ue)},L.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(Z,de).inc(ue,ye).version}catch{return null}},e.diff=function(Z,ue){if(H(Z,ue))return null;var de=$(Z),ye=$(ue);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=U;var O=/^[0-9]+$/;function U(Z,ue){var de=O.test(Z),ye=O.test(ue);return de&&ye&&(Z=+Z,ue=+ue),de&&!ye?-1:ye&&!de?1:Z<ue?-1:Z>ue?1:0}function q(Z,ue,de){return new L(Z,de).compare(new L(ue,de))}function Y(Z,ue,de){return q(Z,ue,de)>0}function oe(Z,ue,de){return q(Z,ue,de)<0}function H(Z,ue,de){return q(Z,ue,de)===0}function re(Z,ue,de){return q(Z,ue,de)!==0}function ne(Z,ue,de){return q(Z,ue,de)>=0}function ce(Z,ue,de){return q(Z,ue,de)<=0}function ge(Z,ue,de,ye){var Ce;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z===de;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z!==de;break;case"":case"=":case"==":Ce=H(Z,de,ye);break;case"!=":Ce=re(Z,de,ye);break;case">":Ce=Y(Z,de,ye);break;case">=":Ce=ne(Z,de,ye);break;case"<":Ce=oe(Z,de,ye);break;case"<=":Ce=ce(Z,de,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function Re(Z,ue){if(Z instanceof Re){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof Re))return new Re(Z,ue);M("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(Z,ue){return U(ue,Z)},e.major=function(Z,ue){return new L(Z,ue).major},e.minor=function(Z,ue){return new L(Z,ue).minor},e.patch=function(Z,ue){return new L(Z,ue).patch},e.compare=q,e.compareLoose=function(Z,ue){return q(Z,ue,!0)},e.rcompare=function(Z,ue,de){return q(ue,Z,de)},e.sort=function(Z,ue){return Z.sort(function(de,ye){return e.compare(de,ye,ue)})},e.rsort=function(Z,ue){return Z.sort(function(de,ye){return e.rcompare(de,ye,ue)})},e.gt=Y,e.lt=oe,e.eq=H,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=Re;var Te={};function Me(Z,ue){if(Z instanceof Me)return Z.loose===ue?Z:new Me(Z.raw,ue);if(Z instanceof Re)return new Me(Z.value,ue);if(!(this instanceof Me))return new Me(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Ae(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ve(Z,ue,de,ye,Ce,Fe,Oe,$e,Ne,He,Qe,Be,Ge){return((ue=Ae(de)?"":Ae(ye)?">="+de+".0.0":Ae(Ce)?">="+de+"."+ye+".0":">="+ue)+" "+($e=Ae(Ne)?"":Ae(He)?"<"+(+Ne+1)+".0.0":Ae(Qe)?"<"+Ne+"."+(+He+1)+".0":Be?"<="+Ne+"."+He+"."+Qe+"-"+Be:"<="+$e)).trim()}function pe(Z,ue){for(var de=0;de<Z.length;de++)if(!Z[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<Z.length;de++)if(M(Z[de].semver),Z[de].semver!==Te&&Z[de].semver.prerelease.length>0){var ye=Z[de].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function Se(Z,ue,de){try{ue=new Me(ue,de)}catch{return!1}return ue.test(Z)}function ke(Z,ue,de,ye){var Ce,Fe,Oe,$e,Ne;switch(Z=new L(Z,ye),ue=new Me(ue,ye),de){case">":Ce=Y,Fe=ce,Oe=oe,$e=">",Ne=">=";break;case"<":Ce=oe,Fe=ne,Oe=Y,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(Z,ue,ye))return!1;for(var He=0;He<ue.set.length;++He){var Qe=ue.set[He],Be=null,Ge=null;if(Qe.forEach(function(K){K.semver===Te&&(K=new Re(">=0.0.0")),Be=Be||K,Ge=Ge||K,Ce(K.semver,Be.semver,ye)?Be=K:Oe(K.semver,Ge.semver,ye)&&(Ge=K)}),Be.operator===$e||Be.operator===Ne||(!Ge.operator||Ge.operator===$e)&&Fe(Z,Ge.semver)||Ge.operator===Ne&&Oe(Z,Ge.semver))return!1}return!0}Re.prototype.parse=function(Z){var ue=this.loose?E[j]:E[F],de=Z.match(ue);if(!de)throw new TypeError("Invalid comparator: "+Z);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Te},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(Z){return M("Comparator.test",Z,this.loose),this.semver===Te||(typeof Z=="string"&&(Z=new L(Z,this.loose)),ge(Z,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(Z,ue){if(!(Z instanceof Re))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(Z.value,ue),Se(this.value,de,ue);if(Z.operator==="")return de=new Me(this.value,ue),Se(Z.semver,de,ue);var ye=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Fe=this.semver.version===Z.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),$e=ge(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ne=ge(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ye||Ce||Fe&&Oe||$e||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),M("range",Z,ue);var de=ue?E[N]:E[W];Z=Z.replace(de,ve),M("hyphen replace",Z),Z=Z.replace(E[A],"$1$2$3"),M("comparator trim",Z,E[A]),Z=(Z=(Z=Z.replace(E[ae],"$1~")).replace(E[se],"$1^")).split(/\s+/).join(" ");var ye=ue?E[j]:E[F],Ce=Z.split(" ").map(function(Fe){return function(Oe,$e){return M("comp",Oe),Oe=function(Ne,He){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){M("caret",Be,Ge);var K=Ge?E[V]:E[he];return Be.replace(K,function(le,fe,me,Ee,Le){var Ue;return M("caret",Be,le,fe,me,Ee,Le),Ae(fe)?Ue="":Ae(me)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(Ee)?Ue=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Le?(M("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=fe==="0"?me==="0"?">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+me+"."+(+Ee+1):">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Ee+Le+" <"+(+fe+1)+".0.0"):(M("no pr"),Ue=fe==="0"?me==="0"?">="+fe+"."+me+"."+Ee+" <"+fe+"."+me+"."+(+Ee+1):">="+fe+"."+me+"."+Ee+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Ee+" <"+(+fe+1)+".0.0"),M("caret return",Ue),Ue})}(Qe,He)}).join(" ")}(Oe,$e),M("caret",Oe),Oe=function(Ne,He){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){var K=Ge?E[Q]:E[X];return Be.replace(K,function(le,fe,me,Ee,Le){var Ue;return M("tilde",Be,le,fe,me,Ee,Le),Ae(fe)?Ue="":Ae(me)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(Ee)?Ue=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Le?(M("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+(+me+1)+".0"):Ue=">="+fe+"."+me+"."+Ee+" <"+fe+"."+(+me+1)+".0",M("tilde return",Ue),Ue})}(Qe,He)}).join(" ")}(Oe,$e),M("tildes",Oe),Oe=function(Ne,He){return M("replaceXRanges",Ne,He),Ne.split(/\s+/).map(function(Qe){return function(Be,Ge){Be=Be.trim();var K=Ge?E[T]:E[k];return Be.replace(K,function(le,fe,me,Ee,Le,Ue){M("xRange",Be,le,fe,me,Ee,Le,Ue);var it=Ae(me),xe=it||Ae(Ee),je=xe||Ae(Le);return fe==="="&&je&&(fe=""),it?le=fe===">"||fe==="<"?"<0.0.0":"*":fe&&je?(xe&&(Ee=0),je&&(Le=0),fe===">"?(fe=">=",xe?(me=+me+1,Ee=0,Le=0):je&&(Ee=+Ee+1,Le=0)):fe==="<="&&(fe="<",xe?me=+me+1:Ee=+Ee+1),le=fe+me+"."+Ee+"."+Le):xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":je&&(le=">="+me+"."+Ee+".0 <"+me+"."+(+Ee+1)+".0"),M("xRange return",le),le})}(Qe,He)}).join(" ")}(Oe,$e),M("xrange",Oe),Oe=function(Ne,He){return M("replaceStars",Ne,He),Ne.trim().replace(E[x],"")}(Oe,$e),M("stars",Oe),Oe}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(ye)})),Ce=Ce.map(function(Fe){return new Re(Fe,ue)})},Me.prototype.intersects=function(Z,ue){if(!(Z instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return Z.set.some(function(Ce){return Ce.every(function(Fe){return ye.intersects(Fe,ue)})})})})},e.toComparators=function(Z,ue){return new Me(Z,ue).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new L(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(pe(this.set[ue],Z))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(Z,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(Z,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(Z,ue){try{return new Me(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,de){return ke(Z,ue,"<",de)},e.gtr=function(Z,ue,de){return ke(Z,ue,">",de)},e.outside=ke,e.prerelease=function(Z,ue){var de=$(Z,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Z,ue,de){return Z=new Me(Z,de),ue=new Me(ue,de),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof L)return Z;if(typeof Z!="string")return null;var ue=Z.match(E[_]);return ue==null?null:$((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(z,e){var S,t,M=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(b){if(S===setTimeout)return setTimeout(b,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,w=[],v=!1,I=-1;function C(){v&&u&&(v=!1,u.length?w=u.concat(w):I=-1,w.length&&d())}function d(){if(!v){var b=E(C);v=!0;for(var p=w.length;p;){for(u=w,w=[];++I<p;)u&&u[I].run();I=-1,p=w.length}u=null,v=!1,function(y){if(t===clearTimeout)return clearTimeout(y);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(y);try{t(y)}catch{try{return t.call(null,y)}catch{return t.call(this,y)}}}(b)}}function m(b,p){this.fun=b,this.array=p}function P(){}M.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)p[y-1]=arguments[y];w.push(new m(b,p)),w.length!==1||v||E(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=P,M.addListener=P,M.once=P,M.off=P,M.removeListener=P,M.removeAllListeners=P,M.emit=P,M.prependListener=P,M.prependOnceListener=P,M.listeners=function(b){return[]},M.binding=function(b){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(b){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(te[124],ie([0,1]),function(z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,u,w){this.level=E,this.key=u,this.value=w,this.forward=[]}}const M=void 0;class R{constructor(E,u=2**16){this.comparator=E,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,M,M)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,M,M)}has(E){return Boolean(R._search(this,E,this.comparator))}get(E){return R._search(this,E,this.comparator)?.value}set(E,u){return R._insert(this,E,u,this.comparator)&&(this._size+=1),this}delete(E){const u=R._delete(this,E,this.comparator);return u&&(this._size-=1),u}forEach(E,u){let w=this._header.forward[0];for(;w;)E.call(u,w.value,w.key,this),w=w.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this._header.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static _search(E,u,w){let v=E._header;for(let I=E._level-1;I>=0;I--)for(;v.forward[I]&&w(v.forward[I].key,u)<0;)v=v.forward[I];if(v=v.forward[0],v&&w(v.key,u)===0)return v}static _insert(E,u,w,v){const I=[];let C=E._header;for(let d=E._level-1;d>=0;d--){for(;C.forward[d]&&v(C.forward[d].key,u)<0;)C=C.forward[d];I[d]=C}if(C=C.forward[0],C&&v(C.key,u)===0)return C.value=w,!1;{const d=R._randomLevel(E);if(d>E._level){for(let m=E._level;m<d;m++)I[m]=E._header;E._level=d}C=new t(d,u,w);for(let m=0;m<d;m++)C.forward[m]=I[m].forward[m],I[m].forward[m]=C;return!0}}static _randomLevel(E,u=.5){let w=1;for(;Math.random()<u&&w<E._maxLevel;)w+=1;return w}static _delete(E,u,w){const v=[];let I=E._header;for(let C=E._level-1;C>=0;C--){for(;I.forward[C]&&w(I.forward[C].key,u)<0;)I=I.forward[C];v[C]=I}if(I=I.forward[0],!I||w(I.key,u)!==0)return!1;for(let C=0;C<E._level&&v[C].forward[C]===I;C++)v[C].forward[C]=I.forward[C];for(;E._level>0&&E._header.forward[E._level-1]===M;)E._level-=1;return!0}}e.SkipList=R}),define(te[58],ie([0,1,16,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function M(g){const l=g;return l?typeof l.read=="function":!1}e.isReadable=M;function R(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function D(g){const l=g;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function E(g,l){return new u(g,l)}e.newWriteableStream=E;class u{constructor(l,i){this.reducer=l,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(i=>i(l))}emitError(l){this.listeners.error.length===0?(0,S.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(i=>i(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,i){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(l,i){if(this.state.destroyed)return;let a;switch(l){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const r=a.indexOf(i);r>=0&&a.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(g,l){const i=[];let a;for(;(a=g.read())!==null;)i.push(a);return l(i)}e.consumeReadable=w;function v(g,l,i){const a=[];let r;for(;(r=g.read())!==null&&a.length<i;)a.push(r);return r===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return g.read()}}}e.peekReadable=v;function I(g,l){return new Promise((i,a)=>{const r=[];C(g,{onData:n=>{l&&r.push(n)},onError:n=>{l?a(n):i(void 0)},onEnd:()=>{i(l?l(r):void 0)}})})}e.consumeStream=I;function C(g,l){let i=!1;return g.on("error",a=>{i||l.onError(a)}),g.on("end",()=>{i||l.onEnd()}),g.on("data",a=>{i||l.onData(a)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=C;function d(g,l){return new Promise((i,a)=>{const r=new t.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>l)return r.dispose(),g.pause(),i({stream:g,buffer:n,ended:!1})},c=f=>a(f),o=()=>i({stream:g,buffer:n,ended:!0});r.add((0,t.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),r.add((0,t.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),r.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=d;function m(g,l){const i=E(l);return i.end(g),i}e.toStream=m;function P(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=P;function b(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=b;function p(g,l,i){const a=E(i);return C(g,{onData:r=>a.write(l.data(r)),onError:r=>a.error(l.error?l.error(r):r),onEnd:()=>a.end()}),a}e.transform=p;function y(g,l,i){let a=!1;return{read:()=>{const r=l.read();return a?r:(a=!0,r!==null?i([g,r]):g)}}}e.prefixedReadable=y;function h(g,l,i){let a=!1;const r=E(i);return C(l,{onData:n=>a?r.write(n):(a=!0,r.write(i([g,n]))),onError:n=>r.error(n),onEnd:()=>{a||(a=!0,r.write(g)),r.end()}}),r}e.prefixedStream=h}),define(te[17],ie([0,1,58]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let M,R;class D{static alloc(f){return t?new D(Buffer.allocUnsafe(f)):new D(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new D(f)}static fromString(f,k){return!(k?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(f)):(M||(M=new TextEncoder),new D(M.encode(f)))}static fromByteArray(f){const k=D.alloc(f.length);for(let T=0,_=f.length;T<_;T++)k.buffer[T]=f[T];return k}static concat(f,k){if(typeof k>"u"){k=0;for(let G=0,ae=f.length;G<ae;G++)k+=f[G].byteLength}const T=D.alloc(k);let _=0;for(let G=0,ae=f.length;G<ae;G++){const X=f[G];T.set(X,_),_+=X.byteLength}return T}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=D.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,k){return new D(this.buffer.subarray(f,k))}set(f,k){if(f instanceof D)this.buffer.set(f.buffer,k);else if(f instanceof Uint8Array)this.buffer.set(f,k);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),k);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return w(this.buffer,f)}writeUInt32BE(f,k){v(this.buffer,f,k)}readUInt32LE(f){return I(this.buffer,f)}writeUInt32LE(f,k){C(this.buffer,f,k)}readUInt8(f){return d(this.buffer,f)}writeUInt8(f,k){m(this.buffer,f,k)}}e.VSBuffer=D;function E(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0}e.readUInt16LE=E;function u(o,f,k){o[k+0]=f&255,f=f>>>8,o[k+1]=f&255}e.writeUInt16LE=u;function w(o,f){return o[f]*2**24+o[f+1]*2**16+o[f+2]*2**8+o[f+3]}e.readUInt32BE=w;function v(o,f,k){o[k+3]=f,f=f>>>8,o[k+2]=f,f=f>>>8,o[k+1]=f,f=f>>>8,o[k]=f}e.writeUInt32BE=v;function I(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0|o[f+2]<<16>>>0|o[f+3]<<24>>>0}e.readUInt32LE=I;function C(o,f,k){o[k+0]=f&255,f=f>>>8,o[k+1]=f&255,f=f>>>8,o[k+2]=f&255,f=f>>>8,o[k+3]=f&255}e.writeUInt32LE=C;function d(o,f){return o[f]}e.readUInt8=d;function m(o,f,k){o[k]=f}e.writeUInt8=m;function P(o){return S.consumeReadable(o,f=>D.concat(f))}e.readableToBuffer=P;function b(o){return S.toReadable(o)}e.bufferToReadable=b;function p(o){return S.consumeStream(o,f=>D.concat(f))}e.streamToBuffer=p;async function y(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await p(o.stream)])}e.bufferedStreamToBuffer=y;function h(o){return S.toStream(o,f=>D.concat(f))}e.bufferToStream=h;function g(o){return S.transform(o,{data:f=>typeof f=="string"?D.fromString(f):D.wrap(f)},f=>D.concat(f))}e.streamToBufferReadableStream=g;function l(o){return S.newWriteableStream(f=>D.concat(f),o)}e.newWriteableBufferStream=l;function i(o,f){return S.prefixedReadable(o,f,k=>D.concat(k))}e.prefixedBufferReadable=i;function a(o,f){return S.prefixedStream(o,f,k=>D.concat(k))}e.prefixedBufferStream=a;function r(o){let f=0,k=0,T=0;const _=new Uint8Array(Math.floor(o.length/4*3)),G=X=>{switch(k){case 3:_[T++]=f|X,k=0;break;case 2:_[T++]=f|X>>>2,f=X<<6,k=3;break;case 1:_[T++]=f|X>>>4,f=X<<4,k=2;break;default:f=X<<2,k=1}};for(let X=0;X<o.length;X++){const Q=o.charCodeAt(X);if(Q>=65&&Q<=90)G(Q-65);else if(Q>=97&&Q<=122)G(Q-97+26);else if(Q>=48&&Q<=57)G(Q-48+52);else if(Q===43||Q===45)G(62);else if(Q===47||Q===95)G(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${o[X]}`)}}const ae=T;for(;k>0;)G(0);return D.wrap(_).slice(0,ae)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},f=!0,k=!1){const T=k?s:n;let _="";const G=o.byteLength%3;let ae=0;for(;ae<o.byteLength-G;ae+=3){const X=o[ae+0],Q=o[ae+1],J=o[ae+2];_+=T[X>>>2],_+=T[(X<<4|Q>>>4)&63],_+=T[(Q<<2|J>>>6)&63],_+=T[J&63]}if(G===1){const X=o[ae+0];_+=T[X>>>2],_+=T[X<<4&63],f&&(_+="==")}else if(G===2){const X=o[ae+0],Q=o[ae+1];_+=T[X>>>2],_+=T[(X<<4|Q>>>4)&63],_+=T[Q<<2&63],f&&(_+="=")}return _}e.encodeBase64=c}),define(te[12],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(a){return typeof a=="string"}e.isString=S;function t(a){return Array.isArray(a)&&a.every(r=>S(r))}e.isStringArray=t;function M(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=M;function R(a){const r=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof r}e.isTypedArray=R;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=E;function u(a){return a===!0||a===!1}e.isBoolean=u;function w(a){return typeof a>"u"}e.isUndefined=w;function v(a){return!I(a)}e.isDefined=v;function I(a){return w(a)||a===null}e.isUndefinedOrNull=I;function C(a,r){if(!a)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=C;function d(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=d;function m(...a){const r=[];for(let n=0;n<a.length;n++){const s=a[n];if(I(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);r.push(s)}return r}e.assertAllDefined=m;const P=Object.prototype.hasOwnProperty;function b(a){if(!M(a))return!1;for(const r in a)if(P.call(a,r))return!1;return!0}e.isEmptyObject=b;function p(a){return typeof a=="function"}e.isFunction=p;function y(...a){return a.length>0&&a.every(p)}e.areFunctions=y;function h(a,r){const n=Math.min(a.length,r.length);for(let s=0;s<n;s++)g(a[s],r[s])}e.validateConstraints=h;function g(a,r){if(S(r)){if(typeof a!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(p(r)){try{if(a instanceof r)return}catch{}if(!I(a)&&a.constructor===r||r.length===1&&r.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function l(a){return a===null?void 0:a}e.withNullAsUndefined=l;function i(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=i}),define(te[50],ie([0,1,12]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const y=Array.isArray(p)?[]:{};return Object.keys(p).forEach(h=>{p[h]&&typeof p[h]=="object"?y[h]=t(p[h]):y[h]=p[h]}),y}e.deepClone=t;function M(p){if(!p||typeof p!="object")return p;const y=[p];for(;y.length>0;){const h=y.shift();Object.freeze(h);for(const g in h)if(R.call(h,g)){const l=h[g];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.isTypedArray)(l)&&y.push(l)}}return p}e.deepFreeze=M;const R=Object.prototype.hasOwnProperty;function D(p,y){return E(p,y,new Set)}e.cloneAndChange=D;function E(p,y,h){if((0,S.isUndefinedOrNull)(p))return p;const g=y(p);if(typeof g<"u")return g;if(Array.isArray(p)){const l=[];for(const i of p)l.push(E(i,y,h));return l}if((0,S.isObject)(p)){if(h.has(p))throw new Error("Cannot clone recursive data-structure");h.add(p);const l={};for(const i in p)R.call(p,i)&&(l[i]=E(p[i],y,h));return h.delete(p),l}return p}function u(p,y,h=!0){return(0,S.isObject)(p)?((0,S.isObject)(y)&&Object.keys(y).forEach(g=>{g in p?h&&((0,S.isObject)(p[g])&&(0,S.isObject)(y[g])?u(p[g],y[g],h):p[g]=y[g]):p[g]=y[g]}),p):y}e.mixin=u;function w(p,y){if(p===y)return!0;if(p==null||y===null||y===void 0||typeof p!=typeof y||typeof p!="object"||Array.isArray(p)!==Array.isArray(y))return!1;let h,g;if(Array.isArray(p)){if(p.length!==y.length)return!1;for(h=0;h<p.length;h++)if(!w(p[h],y[h]))return!1}else{const l=[];for(g in p)l.push(g);l.sort();const i=[];for(g in y)i.push(g);if(i.sort(),!w(l,i))return!1;for(h=0;h<l.length;h++)if(!w(p[l[h]],y[l[h]]))return!1}return!0}e.equals=w;function v(p){const y=new Set;return JSON.stringify(p,(h,g)=>{if((0,S.isObject)(g)||Array.isArray(g)){if(y.has(g))return"[Circular]";y.add(g)}return g})}e.safeStringify=v;function I(p,y){const h=Object.create(null);return!p||!y||Object.keys(y).forEach(l=>{const i=p[l],a=y[l];w(i,a)||(h[l]=a)}),h}e.distinct=I;function C(p,y){const h=y.toLowerCase(),g=Object.keys(p).find(l=>l.toLowerCase()===h);return g?p[g]:p[y]}e.getCaseInsensitive=C;function d(p,y){const h=Object.create(null);for(const[g,l]of Object.entries(p))y(g,l)&&(h[g]=l);return h}e.filter=d;function m(p){let y=[],h=Object.getPrototypeOf(p);for(;Object.prototype!==h;)y=y.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return y}e.getAllPropertyNames=m;function P(p){const y=[];for(const h of m(p))typeof p[h]=="function"&&y.push(h);return y}e.getAllMethodNames=P;function b(p,y){const h=l=>function(){const i=Array.prototype.slice.call(arguments,0);return y(l,i)},g={};for(const l of p)g[l]=h(l);return g}e.createProxyObject=b}),define(te[30],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(M){return S.test(M)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){M(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,w="";return w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w}}()}),define(te[125],ie([0,1,76,40,49]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,E){if(await new Promise((v,I)=>{const C=t.createReadStream(D),d=S.createHash("sha1");C.pipe(d);const m=(0,M.once)((P,b)=>{C.removeAllListeners(),d.removeAllListeners(),P?I(P):v(b)});C.once("error",m),C.once("end",m),d.once("error",m),d.once("data",P=>m(void 0,P.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=R}),define(te[126],ie([0,1,25]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(D){const E=D.replace(/\-/g,":").toLowerCase();return!t.has(E)}function R(){const D=(0,S.networkInterfaces)();for(const E in D){const u=D[E];if(u){for(const{mac:w}of u)if(M(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[95],ie([0,1,77]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,u,w,v=1){let I=!1;return new Promise(C=>{const d=setTimeout(()=>{if(!I)return I=!0,C(0)},w);M(E,u,v,m=>{if(!I)return I=!0,clearTimeout(d),C(m)})})}e.findFreePort=t;function M(E,u,w,v){if(u===0)return v(0);const I=new S.Socket;I.once("connect",()=>(D(I),M(E+w,u-1,w,v))),I.once("data",()=>{}),I.once("error",C=>(D(I),C.code!=="ECONNREFUSED"?M(E+w,u-1,w,v):v(E))),I.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,u,w){let v=!1,I,C=1;const d=S.createServer({pauseOnConnect:!0});function m(P,b){v||(v=!0,d.removeAllListeners(),d.close(),I&&clearTimeout(I),b(P))}return new Promise(P=>{I=setTimeout(()=>{m(0,P)},w),d.on("listening",()=>{m(E,P)}),d.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&C<u?(E++,C++,d.listen(E,"127.0.0.1")):m(0,P)}),d.on("close",()=>{m(0,P)}),d.listen(E,"127.0.0.1")})}e.findFreePortFaster=R;function D(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(u){console.error(u)}}}),define(te[127],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[128],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(M,R){this.sender=M,this.onMessage=R}send(M){try{this.sender.send("vscode:message",M.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(te[41],ie([0,1,13,16]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class M{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,E){const u=(w,...v)=>{this.validateEvent(D,w)&&E(w,...v)};return this.mapListenerToWrapper.set(E,u),S.ipcMain.on(D,u),this}once(D,E){return S.ipcMain.once(D,(u,...w)=>{this.validateEvent(D,u)&&E(u,...w)}),this}handle(D,E){return S.ipcMain.handle(D,(u,...w)=>this.validateEvent(D,u)?E(u,...w):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,E){const u=this.mapListenerToWrapper.get(E);return u&&(S.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(E)),this}validateEvent(D,E){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=E.senderFrame,w=u.url;if(!w)return!0;let v="unknown";try{v=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${w}'.`),!1}return v!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${v}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new M}),define(te[129],ie([0,1,13,41,12,127]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,w,v,I,C)=>{const d=E(u,I,v);d.popup({window:(0,M.withNullAsUndefined)(S.BrowserWindow.fromWebContents(u.sender)),x:C?C.x:void 0,y:C?C.y:void 0,positioningItem:C?C.positioningItem:void 0,callback:()=>{d&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=D;function E(u,w,v){const I=new S.Menu;return v.forEach(C=>{let d;C.type==="separator"?d=new S.MenuItem({type:C.type}):Array.isArray(C.submenu)?d=new S.MenuItem({submenu:E(u,w,C.submenu),label:C.label}):d=new S.MenuItem({label:C.label,type:C.type,accelerator:C.accelerator,checked:C.checked,enabled:C.enabled,visible:C.visible,click:(m,P,b)=>u.sender.send(w,C.id,b)}),I.append(d)}),I}}),define(te[130],ie([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(te[131],ie([0,1,130]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,M=t*60,R=M*24,D=R*7,E=R*30,u=R*365;function w(I,C,d){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,S.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(m<30)return(0,S.localize)(1,null);let P;return m<t?(P=m,C?P===1?d?(0,S.localize)(2,null,P):(0,S.localize)(3,null,P):d?(0,S.localize)(4,null,P):(0,S.localize)(5,null,P):P===1?d?(0,S.localize)(6,null,P):(0,S.localize)(7,null,P):d?(0,S.localize)(8,null,P):(0,S.localize)(9,null,P)):m<M?(P=Math.floor(m/t),C?P===1?d?(0,S.localize)(10,null,P):(0,S.localize)(11,null,P):d?(0,S.localize)(12,null,P):(0,S.localize)(13,null,P):P===1?d?(0,S.localize)(14,null,P):(0,S.localize)(15,null,P):d?(0,S.localize)(16,null,P):(0,S.localize)(17,null,P)):m<R?(P=Math.floor(m/M),C?P===1?d?(0,S.localize)(18,null,P):(0,S.localize)(19,null,P):d?(0,S.localize)(20,null,P):(0,S.localize)(21,null,P):P===1?d?(0,S.localize)(22,null,P):(0,S.localize)(23,null,P):d?(0,S.localize)(24,null,P):(0,S.localize)(25,null,P)):m<D?(P=Math.floor(m/R),C?P===1?(0,S.localize)(26,null,P):(0,S.localize)(27,null,P):P===1?(0,S.localize)(28,null,P):(0,S.localize)(29,null,P)):m<E?(P=Math.floor(m/D),C?P===1?d?(0,S.localize)(30,null,P):(0,S.localize)(31,null,P):d?(0,S.localize)(32,null,P):(0,S.localize)(33,null,P):P===1?d?(0,S.localize)(34,null,P):(0,S.localize)(35,null,P):d?(0,S.localize)(36,null,P):(0,S.localize)(37,null,P)):m<u?(P=Math.floor(m/E),C?P===1?d?(0,S.localize)(38,null,P):(0,S.localize)(39,null,P):d?(0,S.localize)(40,null,P):(0,S.localize)(41,null,P):P===1?d?(0,S.localize)(42,null,P):(0,S.localize)(43,null,P):d?(0,S.localize)(44,null,P):(0,S.localize)(45,null,P)):(P=Math.floor(m/u),C?P===1?d?(0,S.localize)(46,null,P):(0,S.localize)(47,null,P):d?(0,S.localize)(48,null,P):(0,S.localize)(49,null,P):P===1?d?(0,S.localize)(50,null,P):(0,S.localize)(51,null,P):d?(0,S.localize)(52,null,P):(0,S.localize)(53,null,P))}e.fromNow=w;function v(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(te[132],ie([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(te[44],ie([0,1,24,12,132]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,C){return C&&(I.stack||I.stacktrace)?M.localize(0,null,E(I),D(I.stack)||D(I.stacktrace)):E(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function E(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?M.localize(1,null,I.message):I.message||M.localize(2,null)}function u(I=null,C=!1){if(!I)return M.localize(3,null);if(Array.isArray(I)){const d=S.coalesce(I),m=u(d[0],C);return d.length>1?M.localize(4,null,m,d.length):m}if(t.isString(I))return I;if(I.detail){const d=I.detail;if(d.error)return R(d.error,C);if(d.exception)return R(d.exception,C)}return I.stack?R(I,C):I.message?I.message:M.localize(5,null)}e.toErrorMessage=u;function w(I){const C=I;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=w;function v(I,C){let d;return typeof I=="string"?d=new Error(I):d=I,d.actions=C,d}e.createErrorWithActions=v}),define(te[133],ie([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(te[134],ie([0,1,133]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(M){switch(M){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[135],ie([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,135]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,M=!1,R=!1,D=!1,E=!1,u=!1,w=!1,v=!1,I=!1,C=!1,d,m=e.LANGUAGE_DEFAULT,P,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const y=typeof p?.versions?.electron=="string",h=y&&p?.type==="renderer";if(typeof navigator=="object"&&!h)b=navigator.userAgent,t=b.indexOf("Windows")>=0,M=b.indexOf("Macintosh")>=0,v=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,C=b?.indexOf("Mobi")>=0,u=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,m=d;else if(typeof p=="object"){t=p.platform==="win32",M=p.platform==="darwin",R=p.platform==="linux",D=R&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,w=y,I=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const f=JSON.parse(o),k=f.availableLanguages["*"];d=f.locale,m=k||e.LANGUAGE_DEFAULT,P=f._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var g;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let i=0;M?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=M,e.isLinux=R,e.isLinuxSnap=D,e.isNative=E,e.isElectron=w,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=v,e.isMobile=C,e.isCI=I,e.platform=i,e.userAgent=b,e.language=m;var a;(function(o){function f(){return e.language}o.value=f;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=k;function T(){return e.language==="en"}o.isDefault=T})(a=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let T=0,_=o.length;T<_;T++){const G=o[T];if(G.id===k.data.vscodeScheduleAsyncWork){o.splice(T,1),G.callback();return}}});let f=0;return k=>{const T=++f;o.push({id:T,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||v?2:t?1:3;let n=!0,s=!1;function c(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[34],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const M=S.globals.vscode.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,34]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,M=97,R=90,D=122,E=46,u=47,w=92,v=58,I=63;class C extends Error{constructor(g,l,i){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const r=g.indexOf(".")!==-1?"property":"argument";let n=`The "${g}" ${r} ${a} of type ${l}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function d(h,g){if(typeof h!="string")throw new C(g,"string",h)}function m(h){return h===u||h===w}function P(h){return h===u}function b(h){return h>=t&&h<=R||h>=M&&h<=D}function p(h,g,l,i){let a="",r=0,n=-1,s=0,c=0;for(let o=0;o<=h.length;++o){if(o<h.length)c=h.charCodeAt(o);else{if(i(c))break;c=u}if(i(c)){if(!(n===o-1||s===1))if(s===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==E||a.charCodeAt(a.length-2)!==E){if(a.length>2){const f=a.lastIndexOf(l);f===-1?(a="",r=0):(a=a.slice(0,f),r=a.length-1-a.lastIndexOf(l)),n=o,s=0;continue}else if(a.length!==0){a="",r=0,n=o,s=0;continue}}g&&(a+=a.length>0?`${l}..`:"..",r=2)}else a.length>0?a+=`${l}${h.slice(n+1,o)}`:a=h.slice(n+1,o),r=o-n-1;n=o,s=0}else c===E&&s!==-1?++s:s=-1}return a}function y(h,g){if(g===null||typeof g!="object")throw new C("pathObject","Object",g);const l=g.dir||g.root,i=g.base||`${g.name||""}${g.ext||""}`;return l?l===g.root?`${l}${i}`:`${l}${h}${i}`:i}e.win32={resolve(...h){let g="",l="",i=!1;for(let a=h.length-1;a>=-1;a--){let r;if(a>=0){if(r=h[a],d(r,"path"),r.length===0)continue}else g.length===0?r=S.cwd():(r=S.env[`=${g}`]||S.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==g.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${g}\\`));const n=r.length;let s=0,c="",o=!1;const f=r.charCodeAt(0);if(n===1)m(f)&&(s=1,o=!0);else if(m(f))if(o=!0,m(r.charCodeAt(1))){let k=2,T=k;for(;k<n&&!m(r.charCodeAt(k));)k++;if(k<n&&k!==T){const _=r.slice(T,k);for(T=k;k<n&&m(r.charCodeAt(k));)k++;if(k<n&&k!==T){for(T=k;k<n&&!m(r.charCodeAt(k));)k++;(k===n||k!==T)&&(c=`\\\\${_}\\${r.slice(T,k)}`,s=k)}}}else s=1;else b(f)&&r.charCodeAt(1)===v&&(c=r.slice(0,2),s=2,n>2&&m(r.charCodeAt(2))&&(o=!0,s=3));if(c.length>0)if(g.length>0){if(c.toLowerCase()!==g.toLowerCase())continue}else g=c;if(i){if(g.length>0)break}else if(l=`${r.slice(s)}\\${l}`,i=o,o&&g.length>0)break}return l=p(l,!i,"\\",m),i?`${g}\\${l}`:`${g}${l}`||"."},normalize(h){d(h,"path");const g=h.length;if(g===0)return".";let l=0,i,a=!1;const r=h.charCodeAt(0);if(g===1)return P(r)?"\\":h;if(m(r))if(a=!0,m(h.charCodeAt(1))){let s=2,c=s;for(;s<g&&!m(h.charCodeAt(s));)s++;if(s<g&&s!==c){const o=h.slice(c,s);for(c=s;s<g&&m(h.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!m(h.charCodeAt(s));)s++;if(s===g)return`\\\\${o}\\${h.slice(c)}\\`;s!==c&&(i=`\\\\${o}\\${h.slice(c,s)}`,l=s)}}}else l=1;else b(r)&&h.charCodeAt(1)===v&&(i=h.slice(0,2),l=2,g>2&&m(h.charCodeAt(2))&&(a=!0,l=3));let n=l<g?p(h.slice(l),!a,"\\",m):"";return n.length===0&&!a&&(n="."),n.length>0&&m(h.charCodeAt(g-1))&&(n+="\\"),i===void 0?a?`\\${n}`:n:a?`${i}\\${n}`:`${i}${n}`},isAbsolute(h){d(h,"path");const g=h.length;if(g===0)return!1;const l=h.charCodeAt(0);return m(l)||g>2&&b(l)&&h.charCodeAt(1)===v&&m(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let g,l;for(let r=0;r<h.length;++r){const n=h[r];d(n,"path"),n.length>0&&(g===void 0?g=l=n:g+=`\\${n}`)}if(g===void 0)return".";let i=!0,a=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++a;const r=l.length;r>1&&m(l.charCodeAt(1))&&(++a,r>2&&(m(l.charCodeAt(2))?++a:i=!1))}if(i){for(;a<g.length&&m(g.charCodeAt(a));)a++;a>=2&&(g=`\\${g.slice(a)}`)}return e.win32.normalize(g)},relative(h,g){if(d(h,"from"),d(g,"to"),h===g)return"";const l=e.win32.resolve(h),i=e.win32.resolve(g);if(l===i||(h=l.toLowerCase(),g=i.toLowerCase(),h===g))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let r=h.length;for(;r-1>a&&h.charCodeAt(r-1)===w;)r--;const n=r-a;let s=0;for(;s<g.length&&g.charCodeAt(s)===w;)s++;let c=g.length;for(;c-1>s&&g.charCodeAt(c-1)===w;)c--;const o=c-s,f=n<o?n:o;let k=-1,T=0;for(;T<f;T++){const G=h.charCodeAt(a+T);if(G!==g.charCodeAt(s+T))break;G===w&&(k=T)}if(T!==f){if(k===-1)return i}else{if(o>f){if(g.charCodeAt(s+T)===w)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}n>f&&(h.charCodeAt(a+T)===w?k=T:T===2&&(k=3)),k===-1&&(k=0)}let _="";for(T=a+k+1;T<=r;++T)(T===r||h.charCodeAt(T)===w)&&(_+=_.length===0?"..":"\\..");return s+=k,_.length>0?`${_}${i.slice(s,c)}`:(i.charCodeAt(s)===w&&++s,i.slice(s,c))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const g=e.win32.resolve(h);if(g.length<=2)return h;if(g.charCodeAt(0)===w){if(g.charCodeAt(1)===w){const l=g.charCodeAt(2);if(l!==I&&l!==E)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(b(g.charCodeAt(0))&&g.charCodeAt(1)===v&&g.charCodeAt(2)===w)return`\\\\?\\${g}`;return h},dirname(h){d(h,"path");const g=h.length;if(g===0)return".";let l=-1,i=0;const a=h.charCodeAt(0);if(g===1)return m(a)?h:".";if(m(a)){if(l=i=1,m(h.charCodeAt(1))){let s=2,c=s;for(;s<g&&!m(h.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&m(h.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!m(h.charCodeAt(s));)s++;if(s===g)return h;s!==c&&(l=i=s+1)}}}}else b(a)&&h.charCodeAt(1)===v&&(l=g>2&&m(h.charCodeAt(2))?3:2,i=l);let r=-1,n=!0;for(let s=g-1;s>=i;--s)if(m(h.charCodeAt(s))){if(!n){r=s;break}}else n=!1;if(r===-1){if(l===-1)return".";r=l}return h.slice(0,r)},basename(h,g){g!==void 0&&d(g,"ext"),d(h,"path");let l=0,i=-1,a=!0,r;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===v&&(l=2),g!==void 0&&g.length>0&&g.length<=h.length){if(g===h)return"";let n=g.length-1,s=-1;for(r=h.length-1;r>=l;--r){const c=h.charCodeAt(r);if(m(c)){if(!a){l=r+1;break}}else s===-1&&(a=!1,s=r+1),n>=0&&(c===g.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=s))}return l===i?i=s:i===-1&&(i=h.length),h.slice(l,i)}for(r=h.length-1;r>=l;--r)if(m(h.charCodeAt(r))){if(!a){l=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(l,i)},extname(h){d(h,"path");let g=0,l=-1,i=0,a=-1,r=!0,n=0;h.length>=2&&h.charCodeAt(1)===v&&b(h.charCodeAt(0))&&(g=i=2);for(let s=h.length-1;s>=g;--s){const c=h.charCodeAt(s);if(m(c)){if(!r){i=s+1;break}continue}a===-1&&(r=!1,a=s+1),c===E?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||a===-1||n===0||n===1&&l===a-1&&l===i+1?"":h.slice(l,a)},format:y.bind(null,"\\"),parse(h){d(h,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return g;const l=h.length;let i=0,a=h.charCodeAt(0);if(l===1)return m(a)?(g.root=g.dir=h,g):(g.base=g.name=h,g);if(m(a)){if(i=1,m(h.charCodeAt(1))){let k=2,T=k;for(;k<l&&!m(h.charCodeAt(k));)k++;if(k<l&&k!==T){for(T=k;k<l&&m(h.charCodeAt(k));)k++;if(k<l&&k!==T){for(T=k;k<l&&!m(h.charCodeAt(k));)k++;k===l?i=k:k!==T&&(i=k+1)}}}}else if(b(a)&&h.charCodeAt(1)===v){if(l<=2)return g.root=g.dir=h,g;if(i=2,m(h.charCodeAt(2))){if(l===3)return g.root=g.dir=h,g;i=3}}i>0&&(g.root=h.slice(0,i));let r=-1,n=i,s=-1,c=!0,o=h.length-1,f=0;for(;o>=i;--o){if(a=h.charCodeAt(o),m(a)){if(!c){n=o+1;break}continue}s===-1&&(c=!1,s=o+1),a===E?r===-1?r=o:f!==1&&(f=1):r!==-1&&(f=-1)}return s!==-1&&(r===-1||f===0||f===1&&r===s-1&&r===n+1?g.base=g.name=h.slice(n,s):(g.name=h.slice(n,r),g.base=h.slice(n,s),g.ext=h.slice(r,s))),n>0&&n!==i?g.dir=h.slice(0,n-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let g="",l=!1;for(let i=h.length-1;i>=-1&&!l;i--){const a=i>=0?h[i]:S.cwd();d(a,"path"),a.length!==0&&(g=`${a}/${g}`,l=a.charCodeAt(0)===u)}return g=p(g,!l,"/",P),l?`/${g}`:g.length>0?g:"."},normalize(h){if(d(h,"path"),h.length===0)return".";const g=h.charCodeAt(0)===u,l=h.charCodeAt(h.length-1)===u;return h=p(h,!g,"/",P),h.length===0?g?"/":l?"./":".":(l&&(h+="/"),g?`/${h}`:h)},isAbsolute(h){return d(h,"path"),h.length>0&&h.charCodeAt(0)===u},join(...h){if(h.length===0)return".";let g;for(let l=0;l<h.length;++l){const i=h[l];d(i,"path"),i.length>0&&(g===void 0?g=i:g+=`/${i}`)}return g===void 0?".":e.posix.normalize(g)},relative(h,g){if(d(h,"from"),d(g,"to"),h===g||(h=e.posix.resolve(h),g=e.posix.resolve(g),h===g))return"";const l=1,i=h.length,a=i-l,r=1,n=g.length-r,s=a<n?a:n;let c=-1,o=0;for(;o<s;o++){const k=h.charCodeAt(l+o);if(k!==g.charCodeAt(r+o))break;k===u&&(c=o)}if(o===s)if(n>s){if(g.charCodeAt(r+o)===u)return g.slice(r+o+1);if(o===0)return g.slice(r+o)}else a>s&&(h.charCodeAt(l+o)===u?c=o:o===0&&(c=0));let f="";for(o=l+c+1;o<=i;++o)(o===i||h.charCodeAt(o)===u)&&(f+=f.length===0?"..":"/..");return`${f}${g.slice(r+c)}`},toNamespacedPath(h){return h},dirname(h){if(d(h,"path"),h.length===0)return".";const g=h.charCodeAt(0)===u;let l=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===u){if(!i){l=a;break}}else i=!1;return l===-1?g?"/":".":g&&l===1?"//":h.slice(0,l)},basename(h,g){g!==void 0&&d(g,"ext"),d(h,"path");let l=0,i=-1,a=!0,r;if(g!==void 0&&g.length>0&&g.length<=h.length){if(g===h)return"";let n=g.length-1,s=-1;for(r=h.length-1;r>=0;--r){const c=h.charCodeAt(r);if(c===u){if(!a){l=r+1;break}}else s===-1&&(a=!1,s=r+1),n>=0&&(c===g.charCodeAt(n)?--n===-1&&(i=r):(n=-1,i=s))}return l===i?i=s:i===-1&&(i=h.length),h.slice(l,i)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===u){if(!a){l=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":h.slice(l,i)},extname(h){d(h,"path");let g=-1,l=0,i=-1,a=!0,r=0;for(let n=h.length-1;n>=0;--n){const s=h.charCodeAt(n);if(s===u){if(!a){l=n+1;break}continue}i===-1&&(a=!1,i=n+1),s===E?g===-1?g=n:r!==1&&(r=1):g!==-1&&(r=-1)}return g===-1||i===-1||r===0||r===1&&g===i-1&&g===l+1?"":h.slice(g,i)},format:y.bind(null,"/"),parse(h){d(h,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return g;const l=h.charCodeAt(0)===u;let i;l?(g.root="/",i=1):i=0;let a=-1,r=0,n=-1,s=!0,c=h.length-1,o=0;for(;c>=i;--c){const f=h.charCodeAt(c);if(f===u){if(!s){r=c+1;break}continue}n===-1&&(s=!1,n=c+1),f===E?a===-1?a=c:o!==1&&(o=1):a!==-1&&(o=-1)}if(n!==-1){const f=r===0&&l?1:r;a===-1||o===0||o===1&&a===n-1&&a===r+1?g.base=g.name=h.slice(f,n):(g.name=h.slice(f,a),g.base=h.slice(f,n),g.ext=h.slice(a,n))}return r>0?g.dir=h.slice(0,r-1):l&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[78],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var M;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(M=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(E,...u){const w=u.reduce((C,d)=>(C[d]=!0,C),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(C=>!w[C]).forEach(C=>{for(let d=0;d<v.length;d++)if(C.search(v[d])!==-1){delete E[C];break}})}e.sanitizeProcessEnvironment=R;function D(E){!E||(delete E.DEBUG,S.isMacintosh&&delete E.DYLD_LIBRARY_PATH,S.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(te[79],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class M{static create(D=!0){return new M(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=M}),define(te[3],ie([0,1,16,49,2,94,79]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,u=!1;var w;(function(c){c.None=()=>M.Disposable.None;function o(O){if(u){const{onListenerDidAdd:U}=O,q=m.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),U?.()}}}function f(O){return(U,q=null,Y)=>{let oe=!1,H;return H=O(re=>{if(!oe)return H?H.dispose():oe=!0,U.call(q,re)},null,Y),oe&&H.dispose(),H}}c.once=f;function k(O,U,q){return Q((Y,oe=null,H)=>O(re=>Y.call(oe,U(re)),null,H),q)}c.map=k;function T(O,U,q){return Q((Y,oe=null,H)=>O(re=>{U(re),Y.call(oe,re)},null,H),q)}c.forEach=T;function _(O,U,q){return Q((Y,oe=null,H)=>O(re=>U(re)&&Y.call(oe,re),null,H),q)}c.filter=_;function G(O){return O}c.signal=G;function ae(...O){return(U,q=null,Y)=>(0,M.combinedDisposable)(...O.map(oe=>oe(H=>U.call(q,H),null,Y)))}c.any=ae;function X(O,U,q,Y){let oe=q;return k(O,H=>(oe=U(oe,H),oe),Y)}c.reduce=X;function Q(O,U){let q;const Y={onFirstListenerAdd(){q=O(oe.fire,oe)},onLastListenerRemove(){q?.dispose()}};U||o(Y);const oe=new b(Y);return U?.add(oe),oe.event}function J(O,U,q=100,Y=!1,oe,H){let re,ne,ce,ge=0;const Re={leakWarningThreshold:oe,onFirstListenerAdd(){re=O(Me=>{ge++,ne=U(ne,Me),Y&&!ce&&(Te.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Te.fire(Ae),ge=0},q)})},onLastListenerRemove(){re.dispose()}};H||o(Re);const Te=new b(Re);return H?.add(Te),Te.event}c.debounce=J;function se(O,U=(Y,oe)=>Y===oe,q){let Y=!0,oe;return _(O,H=>{const re=Y||!U(H,oe);return Y=!1,oe=H,re},q)}c.latch=se;function he(O,U,q){return[c.filter(O,U,q),c.filter(O,Y=>!U(Y),q)]}c.split=he;function V(O,U=!1,q=[]){let Y=q.slice(),oe=O(ne=>{Y?Y.push(ne):re.fire(ne)});const H=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new b({onFirstListenerAdd(){oe||(oe=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(U?setTimeout(H):H())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return re.event}c.buffer=V;class j{constructor(U){this.event=U,this.disposables=new M.DisposableStore}map(U){return new j(k(this.event,U,this.disposables))}forEach(U){return new j(T(this.event,U,this.disposables))}filter(U){return new j(_(this.event,U,this.disposables))}reduce(U,q){return new j(X(this.event,U,q,this.disposables))}latch(){return new j(se(this.event,void 0,this.disposables))}debounce(U,q=100,Y=!1,oe){return new j(J(this.event,U,q,Y,oe,this.disposables))}on(U,q,Y){return this.event(U,q,Y)}once(U,q,Y){return f(this.event)(U,q,Y)}dispose(){this.disposables.dispose()}}function F(O){return new j(O)}c.chain=F;function A(O,U,q=Y=>Y){const Y=(...ne)=>re.fire(q(...ne)),oe=()=>O.on(U,Y),H=()=>O.removeListener(U,Y),re=new b({onFirstListenerAdd:oe,onLastListenerRemove:H});return re.event}c.fromNodeEventEmitter=A;function W(O,U,q=Y=>Y){const Y=(...ne)=>re.fire(q(...ne)),oe=()=>O.addEventListener(U,Y),H=()=>O.removeEventListener(U,Y),re=new b({onFirstListenerAdd:oe,onLastListenerRemove:H});return re.event}c.fromDOMEventEmitter=W;function N(O){return new Promise(U=>f(O)(U))}c.toPromise=N;function x(O,U){return U(void 0),O(q=>U(q))}c.runAndSubscribe=x;function B(O,U){let q=null;function Y(H){q?.dispose(),q=new M.DisposableStore,U(H,q)}Y(void 0);const oe=O(H=>Y(H));return(0,M.toDisposable)(()=>{oe.dispose(),q?.dispose()})}c.runAndSubscribeWithStore=B;class ${constructor(U,q){this.obs=U,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{U.addObserver(this)},onLastListenerRemove:()=>{U.removeObserver(this)}};q||o(Y),this.emitter=new b(Y),q&&q.add(this.emitter)}beginUpdate(U){this._counter++}handleChange(U,q){this._hasChanged=!0}endUpdate(U){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,U){return new $(O,U).emitter.event}c.fromObservable=L})(w=e.Event||(e.Event={}));class v{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${v._idPool++}`,v.all.add(this)}start(o){this._stopWatch=new D.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=v,v.all=new Set,v._idPool=0;let I=-1;function C(c){const o=I;return I=c,{dispose(){I=o}}}e.setGlobalLeakWarningThreshold=C;class d{constructor(o,f=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,f){let k=I;if(typeof this.customThreshold=="number"&&(k=this.customThreshold),k<=0||f<k)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=k*.5;let _,G=0;for(const[ae,X]of this._stacks)(!_||G<X)&&(_=ae,G=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${G}):`),console.warn(_)}return()=>{const _=this._stacks.get(o.value)||0;this._stacks.set(o.value,_-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class P{constructor(o,f,k){this.callback=o,this.callbackThis=f,this.stack=k,this.subscription=new M.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=I>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const f of o)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,f,k)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let _,G;this._leakageMon&&this._listeners.size>=30&&(G=m.create(),_=this._leakageMon.check(G,this._listeners.size+1)),E&&(G=G??m.create());const ae=new P(o,f,G),X=this._listeners.push(ae);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,f);const Q=ae.subscription.set(()=>{_?.(),this._disposed||(X(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return k instanceof M.DisposableStore?k.add(Q):Array.isArray(k)&&k.push(Q),Q}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y);for(const f of this._listeners)this._deliveryQueue.push(this,f,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(o,f,k){this._queue.push(new h(o,f,k))}clear(o){const f=new R.LinkedList;for(const k of this._queue)k.emitter!==o&&f.push(k);this._queue=f}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(f){(0,S.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=p;class y extends p{clear(o){this._queue.clear()}}class h{constructor(o,f,k){this.emitter=o,this.listener=f,this.event=k}}class g extends b{async fireAsync(o,f,k){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,o]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[T,_]=this._asyncDeliveryQueue.shift(),G=[],ae={..._,token:f,waitUntil:X=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");k&&(X=k(X,T.callback)),G.push(X)}};try{T.invoke(ae)}catch(X){(0,S.onUnexpectedError)(X);continue}Object.freeze(G),await Promise.allSettled(G).then(X=>{for(const Q of X)Q.status==="rejected"&&(0,S.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=g;class l extends b{constructor(o){super(o),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=l;class i extends l{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=i;class a extends b{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const f={event:o,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const k=()=>{this.hasListeners&&this.unhook(f);const T=this.events.indexOf(f);this.events.splice(T,1)};return(0,M.toDisposable)((0,t.once)(k))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(f=>this.emitter.fire(f))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class n{constructor(){this.buffers=[]}wrapEvent(o){return(f,k,T)=>o(_=>{const G=this.buffers[this.buffers.length-1];G?G.push(()=>f.call(k,_)):f.call(k,_)},void 0,T)}bufferEvents(o){const f=[];this.buffers.push(f);const k=o();return this.buffers.pop(),f.forEach(T=>T()),k}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=M.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(te[23],ie([0,1,3]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,u){const w=setTimeout(E.bind(u),0);return{dispose(){clearTimeout(w)}}});var M;(function(E){function u(w){return w===E.None||w===E.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}E.isCancellationToken=u,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(M=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=M.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=D}),define(te[136],ie([0,1,23]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new S.CancellationTokenSource,u=this.task(E.token);return this.result={promise:u,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class M{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const u=JSON.stringify(E);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=M;class R{get cachedValues(){return this._map}constructor(E){this.fn=E,this._map=new Map}get(E){if(this._map.has(E))return this._map.get(E);const u=this.fn(E);return this._map.set(E,u),u}}e.CachedFunction=R}),define(te[96],ie([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const M=D=>({onDidChange:S.Event.None,value:D});e.staticObservableValue=M;class R extends t.Disposable{get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}constructor(E){super(),this._value=E,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(te[26],ie([0,1,136,123]),function(z,e,S,t){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function E(K,...le){return le.length===0?K:K.replace(D,function(fe,me){const Ee=parseInt(me,10);return isNaN(Ee)||Ee<0||Ee>=le.length?fe:le[Ee]})}e.format=E;const u=/{([^}]+)}/g;function w(K,le){return K.replace(u,(fe,me)=>le[me]??fe)}e.format2=w;function v(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=v;function I(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function C(K,le){let fe=0;const me=le.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===me&&fe++;return fe}e.count=C;function d(K,le,fe="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${fe}`}e.truncate=d;function m(K,le=" "){const fe=P(K,le);return b(fe,le)}e.trim=m;function P(K,le){if(!K||!le)return K;const fe=le.length;if(fe===0||K.length===0)return K;let me=0;for(;K.indexOf(le,me)===me;)me=me+fe;return K.substring(me)}e.ltrim=P;function b(K,le){if(!K||!le)return K;const fe=le.length,me=K.length;if(fe===0||me===0)return K;let Ee=me,Le=-1;for(;Le=K.lastIndexOf(le,Ee-1),!(Le===-1||Le+fe!==Ee);){if(Le===0)return"";Ee=Le}return K.substring(0,Ee)}e.rtrim=b;function p(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function y(K){return K.replace(/\*/g,"")}e.stripWildcards=y;function h(K,le,fe={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=I(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=h;function g(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=i;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function r(K){for(let le=0,fe=K.length;le<fe;le++){const me=K.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=r;function n(K,le=0,fe=K.length){for(let me=le;me<fe;me++){const Ee=K.charCodeAt(me);if(Ee!==32&&Ee!==9)return K.substring(le,me)}return K.substring(le,fe)}e.getLeadingWhitespace=n;function s(K,le=K.length-1){for(let fe=le;fe>=0;fe--){const me=K.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function c(K,le,fe){const me=[];let Ee=0;for(const Le of K.matchAll(le)){if(me.push(K.slice(Ee,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ee=Le.index+Le[0].length,me.push(fe(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(Ee)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function o(K,le){return K<le?-1:K>le?1:0}e.compare=o;function f(K,le,fe=0,me=K.length,Ee=0,Le=le.length){for(;fe<me&&Ee<Le;fe++,Ee++){const xe=K.charCodeAt(fe),je=le.charCodeAt(Ee);if(xe<je)return-1;if(xe>je)return 1}const Ue=me-fe,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstring=f;function k(K,le){return T(K,le,0,K.length,0,le.length)}e.compareIgnoreCase=k;function T(K,le,fe=0,me=K.length,Ee=0,Le=le.length){for(;fe<me&&Ee<Le;fe++,Ee++){let xe=K.charCodeAt(fe),je=le.charCodeAt(Ee);if(xe===je)continue;if(xe>=128||je>=128)return f(K.toLowerCase(),le.toLowerCase(),fe,me,Ee,Le);G(xe)&&(xe-=32),G(je)&&(je-=32);const et=xe-je;if(et!==0)return et}const Ue=me-fe,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstringIgnoreCase=T;function _(K){return K>=48&&K<=57}e.isAsciiDigit=_;function G(K){return K>=97&&K<=122}e.isLowerAsciiLetter=G;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function X(K,le){return K.length===le.length&&T(K,le)===0}e.equalsIgnoreCase=X;function Q(K,le){const fe=le.length;return le.length>K.length?!1:T(K,le,0,fe)===0}e.startsWithIgnoreCase=Q;function J(K,le){const fe=Math.min(K.length,le.length);let me;for(me=0;me<fe;me++)if(K.charCodeAt(me)!==le.charCodeAt(me))return me;return fe}e.commonPrefixLength=J;function se(K,le){const fe=Math.min(K.length,le.length);let me;const Ee=K.length-1,Le=le.length-1;for(me=0;me<fe;me++)if(K.charCodeAt(Ee-me)!==le.charCodeAt(Le-me))return me;return fe}e.commonSuffixLength=se;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function j(K,le){return(K-55296<<10)+(le-56320)+65536}e.computeCodePoint=j;function F(K,le,fe){const me=K.charCodeAt(fe);if(he(me)&&fe+1<le){const Ee=K.charCodeAt(fe+1);if(V(Ee))return j(me,Ee)}return me}e.getNextCodePoint=F;function A(K,le){const fe=K.charCodeAt(le-1);if(V(fe)&&le>1){const me=K.charCodeAt(le-2);if(he(me))return j(me,fe)}return fe}class W{get offset(){return this._offset}constructor(le,fe=0){this._str=le,this._len=le.length,this._offset=fe}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class N{get offset(){return this._iterator.offset}constructor(le,fe=0){this._iterator=new W(le,fe)}nextGraphemeLength(){const le=Fe.getInstance(),fe=this._iterator,me=fe.offset;let Ee=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Le=fe.offset,Ue=le.getGraphemeBreakType(fe.nextCodePoint());if(ye(Ee,Ue)){fe.setOffset(Le);break}Ee=Ue}return fe.offset-me}prevGraphemeLength(){const le=Fe.getInstance(),fe=this._iterator,me=fe.offset;let Ee=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Le=fe.offset,Ue=le.getGraphemeBreakType(fe.prevCodePoint());if(ye(Ue,Ee)){fe.setOffset(Le);break}Ee=Ue}return me-fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=N;function x(K,le){return new N(K,le).nextGraphemeLength()}e.nextCharLength=x;function B(K,le){return new N(K,le).prevGraphemeLength()}e.prevCharLength=B;function $(K,le){le>0&&V(K.charCodeAt(le))&&le--;const fe=le+x(K,le);return[fe-B(K,fe),fe]}e.getCharContainingOffset=$;function L(K){const le=new N(K);let fe=0;for(;!le.eol();)fe++,le.nextGraphemeLength();return fe}e.charCount=L;let O;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(K){return O||(O=U()),O.test(K)}e.containsRTL=q;const Y=/^[\t\n\r\x20-\x7E]*$/;function oe(K){return Y.test(K)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=H;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,le){if(K.length<le)return K;const fe=/\b/g;let me=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<le);)me=fe.lastIndex,fe.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,Re=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Me(K){return K&&(K=K.replace(ge,""),K=K.replace(Re,""),K=K.replace(Te,"")),K}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function pe(K,le){if(!K||!le||K.length<le.length)return!1;const fe=le.length,me=K.toLowerCase();let Ee=0,Le=-1;for(;Ee<fe;){const Ue=me.indexOf(le[Ee],Le+1);if(Ue<0)return!1;Le=Ue,Ee++}return!0}e.fuzzyContains=pe;function Se(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=ke;function Z(K,le=1){if(le===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=Z;function ue(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ue;function de(K){return Fe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=de;function ye(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var Ce;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this._data,me=fe.length/3;let Ee=1;for(;Ee<=me;)if(le<fe[3*Ee])Ee=2*Ee;else if(le>fe[3*Ee+1])Ee=2*Ee+1;else return fe[3*Ee+2];return 0}}Fe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(K,le){if(K===0)return 0;const fe=Ne(K,le);if(fe!==void 0)return fe;const me=new W(le,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=$e;function Ne(K,le){const fe=new W(le,K);let me=fe.prevCodePoint();for(;He(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!ne(me))return;let Ee=fe.offset;return Ee>0&&fe.prevCodePoint()===8205&&(Ee=fe.offset),Ee}function He(K){return 127995<=K&&K<=127999}var Qe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,M=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new S.LRUCachedFunction(K=>{function le(je){const et=new Map;for(let nt=0;nt<je.length;nt+=2)et.set(je[nt],je[nt+1]);return et}function fe(je,et){const nt=new Map(je);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function me(je,et){if(!je)return et;const nt=new Map;for(const[lt,gt]of je)et.has(lt)&&nt.set(lt,gt);return nt}const Ee=M.ambiguousCharacterData.getValue();let Le=K.filter(je=>!je.startsWith("_")&&je in Ee);Le.length===0&&(Le=["_default"]);let Ue;for(const je of Le){const et=le(Ee[je]);Ue=me(Ue,et)}const it=le(Ee._common),xe=fe(it,Ue);return new Be(xe)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(le){return Ge.getData().has(le)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(te[31],ie([0,1,9,4,26,12]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function E(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=E;function u(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=u;function w(s,c=S.posix.sep){if(!s)return"";const o=s.length,f=s.charCodeAt(0);if(D(f)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const _=T;for(;T<o&&!D(s.charCodeAt(T));T++);if(_!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<o;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(p(f)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let k=s.indexOf("://");if(k!==-1){for(k+=3;k<o;k++)if(D(s.charCodeAt(k)))return s.slice(0,k+1)}return""}e.getRoot=w;function v(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let o=2;const f=o;for(;o<s.length&&(c=s.charCodeAt(o),c!==92);o++);return!(f===o||(c=s.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=v;const I=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(s,c=t.isWindows){const o=c?I:C;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||c&&d.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=m;function P(s,c,o){const f=s===c;return!o||f?f:!s||!c?!1:(0,M.equalsIgnoreCase)(s,c)}e.isEqual=P;function b(s,c,o,f=S.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(o){if(!(0,M.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===f&&T--,s.charAt(T)===f}return c.charAt(c.length-1)!==f&&(c+=f),s.indexOf(c)===0}e.isEqualOrParent=b;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function y(s,c){return t.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(c,s)),s=(0,S.normalize)(s),t.isWindows?(s=(0,M.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,M.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=y;function h(s){const c=(0,S.normalize)(s);return t.isWindows?s.length>3?!1:g(c)&&(s.length===2||c.charCodeAt(2)===92):c===S.posix.sep}e.isRootOrDriveLetter=h;function g(s,c=t.isWindows){return c?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function l(s){return g(s)?s[0]:void 0}e.getDriveLetter=l;function i(s,c,o){return c.length>s.length?-1:s===c?0:(o&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=i;function a(s){const c=s.split(":");let o,f,k;for(const T of c){const _=Number(T);(0,R.isNumber)(_)?f===void 0?f=_:k===void 0&&(k=_):o=o?[o,T].join(":"):T}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:f!==void 0?f:void 0,column:k!==void 0?k:f!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,c,o=8){let f="";for(let T=0;T<o;T++)f+=r.charAt(Math.floor(Math.random()*r.length));let k;return c?k=`${c}-${f}`:k=f,s?(0,S.join)(s,k):k}e.randomPath=n}),define(te[66],ie([0,1,26]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return M(p,0)}e.hash=t;function M(p,y){switch(typeof p){case"object":return p===null?R(349,y):Array.isArray(p)?u(p,y):w(p,y);case"string":return E(p,y);case"boolean":return D(p,y);case"number":return R(p,y);case"undefined":return R(937,y);default:return R(617,y)}}e.doHash=M;function R(p,y){return(y<<5)-y+p|0}e.numberHash=R;function D(p,y){return R(p?433:863,y)}function E(p,y){y=R(149417,y);for(let h=0,g=p.length;h<g;h++)y=R(p.charCodeAt(h),y);return y}e.stringHash=E;function u(p,y){return y=R(104579,y),p.reduce((h,g)=>M(g,h),y)}function w(p,y){return y=R(181387,y),Object.keys(p).sort().reduce((h,g)=>(h=E(g,h),M(p[g],h)),y)}class v{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=M(y,this._value),this._value}}e.Hasher=v;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function C(p,y,h=32){const g=h-y,l=~((1<<g)-1);return(p<<y|(l&p)>>>g)>>>0}function d(p,y=0,h=p.byteLength,g=0){for(let l=0;l<h;l++)p[y+l]=g}function m(p,y,h="0"){for(;p.length<y;)p=h+p;return p}function P(p,y=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(h=>h.toString(16).padStart(2,"0")).join(""):m((p>>>0).toString(16),y/4)}e.toHexString=P;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const h=y.length;if(h===0)return;const g=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,a,r;for(i!==0?(a=i,r=-1,i=0):(a=y.charCodeAt(0),r=0);;){let n=a;if(S.isHighSurrogate(a))if(r+1<h){const s=y.charCodeAt(r+1);S.isLowSurrogate(s)?(r++,n=S.computeCodePoint(a,s)):n=65533}else{i=a;break}else S.isLowSurrogate(a)&&(n=65533);if(l=this._push(g,l,n),r++,r<h)a=y.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(y,h,g){return g<128?y[h++]=g:g<2048?(y[h++]=192|(g&1984)>>>6,y[h++]=128|(g&63)>>>0):g<65536?(y[h++]=224|(g&61440)>>>12,y[h++]=128|(g&4032)>>>6,y[h++]=128|(g&63)>>>0):(y[h++]=240|(g&1835008)>>>18,y[h++]=128|(g&258048)>>>12,y[h++]=128|(g&4032)>>>6,y[h++]=128|(g&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=b._bigBlock32,h=this._buffDV;for(let o=0;o<64;o+=4)y.setUint32(o,h.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)y.setUint32(o,C(y.getUint32(o-12,!1)^y.getUint32(o-32,!1)^y.getUint32(o-56,!1)^y.getUint32(o-64,!1),1),!1);let g=this._h0,l=this._h1,i=this._h2,a=this._h3,r=this._h4,n,s,c;for(let o=0;o<80;o++)o<20?(n=l&i|~l&a,s=1518500249):o<40?(n=l^i^a,s=1859775393):o<60?(n=l&i|l&a|i&a,s=2400959708):(n=l^i^a,s=3395469782),c=C(g,5)+n+r+s+y.getUint32(o*4,!1)&4294967295,r=a,a=i,i=C(l,30),l=g,g=c;this._h0=this._h0+g&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[29],ie([0,1,24,26]),function(z,e,S,t){"use strict";var M,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(r,n,s){let c=r.get(n);return c===void 0&&(c=s,r.set(n,c)),c}e.getOrSet=E;function u(r){const n=[];return r.forEach((s,c)=>{n.push(`${c} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=u;function w(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=w;class v{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=v;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class C{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var d;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(d||(d={}));class m{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class p{static forUris(n=()=>!1,s=()=>!1){return new p(new m(n,s))}static forPaths(n=!1){return new p(new C(void 0,!n))}static forStrings(){return new p(new v)}static forConfigKeys(){return new p(new I)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const c=s.slice(0);(0,S.shuffle)(c);for(const o of c)this.set(o,n)}else{const c=n.slice(0);(0,S.shuffle)(c);for(const o of c)this.set(o[0],o[1])}}set(n,s){const c=this._iter.reset(n);let o;this._root||(this._root=new P,this._root.segment=c.value());const f=[];for(o=this._root;;){const T=c.cmp(o.segment);if(T>0)o.left||(o.left=new P,o.left.segment=c.value()),f.push([-1,o]),o=o.left;else if(T<0)o.right||(o.right=new P,o.right.segment=c.value()),f.push([1,o]),o=o.right;else if(c.hasNext())c.next(),o.mid||(o.mid=new P,o.mid.segment=c.value()),f.push([0,o]),o=o.mid;else break}const k=o.value;o.value=s,o.key=n;for(let T=f.length-1;T>=0;T--){const _=f[T][1];_.updateHeight();const G=_.balanceFactor();if(G<-1||G>1){const ae=f[T][0],X=f[T+1][0];if(ae===1&&X===1)f[T][1]=_.rotateLeft();else if(ae===-1&&X===-1)f[T][1]=_.rotateRight();else if(ae===1&&X===-1)_.right=f[T+1][1]=f[T+1][1].rotateRight(),f[T][1]=_.rotateLeft();else if(ae===-1&&X===1)_.left=f[T+1][1]=f[T+1][1].rotateLeft(),f[T][1]=_.rotateRight();else throw new Error;if(T>0)switch(f[T-1][0]){case-1:f[T-1][1].left=f[T][1];break;case 1:f[T-1][1].right=f[T][1];break;case 0:f[T-1][1].mid=f[T][1];break}else this._root=f[0][1]}}return k}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const o=s.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const c=this._iter.reset(n),o=[];let f=this._root;for(;f;){const k=c.cmp(f.segment);if(k>0)o.push([-1,f]),f=f.left;else if(k<0)o.push([1,f]),f=f.right;else if(c.hasNext())c.next(),o.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const k=this._min(f.right);if(k.key){const{key:T,value:_,segment:G}=k;this._delete(k.key,!1),f.key=T,f.value=_,f.segment=G}}else{const k=f.left??f.right;if(o.length>0){const[T,_]=o[o.length-1];switch(T){case-1:_.left=k;break;case 0:_.mid=k;break;case 1:_.right=k;break}}else this._root=k}for(let k=o.length-1;k>=0;k--){const T=o[k][1];T.updateHeight();const _=T.balanceFactor();if(_>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),o[k][1]=T.rotateLeft()):_<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),o[k][1]=T.rotateRight()),k>0)switch(o[k-1][0]){case-1:o[k-1][1].left=o[k][1];break;case 1:o[k-1][1].right=o[k][1];break;case 0:o[k-1][1].mid=o[k][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let c=this._root,o;for(;c;){const f=s.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(s.hasNext())s.next(),o=c.value||o,c=c.mid;else break}return c&&c.value||o}findSuperstr(n){const s=this._iter.reset(n);let c=this._root;for(;c;){const o=s.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[s,c]of this)n(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=p;class y{constructor(n,s){this.uri=n,this.value=s}}class h{constructor(n,s){this[M]="ResourceMap",n instanceof h?(this.map=new Map(n.map),this.toKey=s??h.defaultToKey):(this.map=new Map,this.toKey=n??h.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new y(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[c,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();class g{constructor(n,s){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new h(n):(this._map=new h(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((c,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class i{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const c=this._map.get(n);if(!!c)return s!==0&&this.touch(c,s),c.value}set(n,s,c=0){let o=this._map.get(n);if(o)o.value=s,c!==0&&this.touch(o,c);else{switch(o={key:n,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const c=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>n;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,c=n.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const c=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(c.previous=o,o.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const c=n.next,o=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=o,o.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,c)=>{n.push([c,s])}),n}fromJSON(n){this.clear();for(const[s,c]of n)this.set(s,c)}}e.LinkedMap=i;class a extends i{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a}),define(te[80],ie([0,1,29]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function M(w){return u(w,"NFC",t)}e.normalizeNFC=M;const R=new S.LRUCache(1e4);function D(w){return u(w,"NFD",R)}e.normalizeNFD=D;const E=/[^\u0000-\u0080]/;function u(w,v,I){if(!w)return w;const C=I.get(w);if(C)return C;let d;return E.test(w)?d=w.normalize(v):d=w,I.set(w,d),d}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(v){return D(v).replace(w,"")}}()}),define(te[97],ie([0,1,26]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(t||(t={})),function(M){const R="error",D="warning",E="warn",u="info",w="ignore";function v(C){return C?S.equalsIgnoreCase(R,C)?M.Error:S.equalsIgnoreCase(D,C)||S.equalsIgnoreCase(E,C)?M.Warning:S.equalsIgnoreCase(u,C)?M.Info:M.Ignore:M.Ignore}M.fromValue=v;function I(C){switch(C){case M.Error:return R;case M.Warning:return D;case M.Info:return u;default:return w}}M.toString=I}(t||(t={})),e.default=t}),define(te[7],ie([0,1,9,4]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function E(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!M.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(r,n){return!r&&!n?"file":r}function w(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const v="",I="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,c,o,f,k=!1){typeof n=="object"?(this.scheme=n.scheme||v,this.authority=n.authority||v,this.path=n.path||v,this.query=n.query||v,this.fragment=n.fragment||v):(this.scheme=u(n,k),this.authority=s||v,this.path=w(this.scheme,c||v),this.query=o||v,this.fragment=f||v,E(this,k))}get fsPath(){return h(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:c,path:o,query:f,fragment:k}=n;return s===void 0?s=this.scheme:s===null&&(s=v),c===void 0?c=this.authority:c===null&&(c=v),o===void 0?o=this.path:o===null&&(o=v),f===void 0?f=this.query:f===null&&(f=v),k===void 0?k=this.fragment:k===null&&(k=v),s===this.scheme&&c===this.authority&&o===this.path&&f===this.query&&k===this.fragment?this:new P(s,c,o,f,k)}static parse(n,s=!1){const c=C.exec(n);return c?new P(c[2]||v,a(c[4]||v),a(c[5]||v),a(c[7]||v),a(c[9]||v),s):new P(v,v,v,v,v)}static file(n){let s=v;if(t.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const c=n.indexOf(I,2);c===-1?(s=n.substring(2),n=I):(s=n.substring(2,c),n=n.substring(c)||I)}return new P("file",s,n,v,v)}static from(n){const s=new P(n.scheme,n.authority,n.path,n.query,n.fragment);return E(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&n.scheme==="file"?c=d.file(S.win32.join(h(n,!0),...s)).path:c=S.posix.join(n.path,...s),n.with({path:c})}toString(n=!1){return g(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const s=new P(n);return s._formatted=n.external,s._fsPath=n._sep===m?n.fsPath:null,s}}else return n}}e.URI=d;const m=t.isWindows?1:void 0;class P extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(n=!1){return n?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,n){let s,c=-1;for(let o=0;o<r.length;o++){const f=r.charCodeAt(o);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||n&&f===47)c!==-1&&(s+=encodeURIComponent(r.substring(c,o)),c=-1),s!==void 0&&(s+=r.charAt(o));else{s===void 0&&(s=r.substr(0,o));const k=b[f];k!==void 0?(c!==-1&&(s+=encodeURIComponent(r.substring(c,o)),c=-1),s+=k):c===-1&&(c=o)}}return c!==-1&&(s+=encodeURIComponent(r.substring(c))),s!==void 0?s:r}function y(r){let n;for(let s=0;s<r.length;s++){const c=r.charCodeAt(s);c===35||c===63?(n===void 0&&(n=r.substr(0,s)),n+=b[c]):n!==void 0&&(n+=r[s])}return n!==void 0?n:r}function h(r,n){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=h;function g(r,n){const s=n?y:p;let c="",{scheme:o,authority:f,path:k,query:T,fragment:_}=r;if(o&&(c+=o,c+=":"),(f||o==="file")&&(c+=I,c+=I),f){let G=f.indexOf("@");if(G!==-1){const ae=f.substr(0,G);f=f.substr(G+1),G=ae.indexOf(":"),G===-1?c+=s(ae,!1):(c+=s(ae.substr(0,G),!1),c+=":",c+=s(ae.substr(G+1),!1)),c+="@"}f=f.toLowerCase(),G=f.indexOf(":"),G===-1?c+=s(f,!1):(c+=s(f.substr(0,G),!1),c+=f.substr(G))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const G=k.charCodeAt(1);G>=65&&G<=90&&(k=`/${String.fromCharCode(G+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const G=k.charCodeAt(0);G>=65&&G<=90&&(k=`${String.fromCharCode(G+32)}:${k.substr(2)}`)}c+=s(k,!0)}return T&&(c+="?",c+=s(T,!1)),_&&(c+="#",c+=n?_:p(_,!1)),c}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(i)?r.replace(i,n=>l(n)):r}}),define(te[137],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const v=w;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=t;function M(w){const v=[];let I;try{const C=JSON.parse(w.arguments),d=C[C.length-1];d&&d.__$stack&&(C.pop(),I=d.__$stack),v.push(...C)}catch{v.push("Unable to log remote console arguments",w.arguments)}return{args:v,stack:I}}e.parse=M;function R(w){if(typeof w!="string")return R(M(w).stack);const v=w;if(v){const I=D(v),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(C&&C.length===4)return{uri:S.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=R;function D(w){if(!w)return w;const v=w.indexOf(`
`);return v===-1?w:w.substring(0,v)}function E(w,v){const{args:I,stack:C}=M(w),d=typeof I[0]=="string"&&I.length===1;let m=D(C);m&&(m=`(${m.trim()})`);let P=[];if(typeof I[0]=="string"?m&&d?P=[`%c[${v}] %c${I[0]} %c${m}`,u("blue"),u(""),u("grey")]:P=[`%c[${v}] %c${I[0]}`,u("blue"),u(""),...I.slice(1)]:P=[`%c[${v}]%`,u("blue"),...I],m&&!d&&P.push(m),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,P)}e.log=E;function u(w){return`color: ${w}`}}),define(te[67],ie([0,1,17,26,7]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,E)}e.stringify=R;function D(w){let v=JSON.parse(w);return v=u(v),v}e.parse=D;function E(w,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,t.regExpFlags)(v)}:v}function u(w,v=0){if(!w||v>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return M.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 14:return new Date(w.source)}if(w instanceof S.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let I=0;I<w.length;++I)w[I]=u(w[I],v+1);else for(const I in w)Object.hasOwnProperty.call(w,I)&&(w[I]=u(w[I],v+1))}return w}e.revive=u}),define(te[14],ie([0,1,4,7]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${M.vscodeRemoteResource}`}set(w,v,I){this._hosts[w]=v,this._ports[w]=I}setConnectionToken(w,v){this._connectionTokens[w]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const v=w.authority;let I=this._hosts[v];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const C=this._ports[v],d=this._connectionTokens[v];let m=`path=${encodeURIComponent(w.path)}`;return typeof d=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${I}:${C}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new R;class D{asBrowserUri(w,v){const I=this.toUri(w,v);return I.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===M.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${M.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:M.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,v){const I=this.toUri(w,v);return I.scheme===M.vscodeFileResource?I.with({scheme:M.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(w,v){return t.URI.isUri(w)?w:t.URI.parse(v.toUrl(w))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var E;(function(u){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(w.get("3"));const v="vscode-coi";function I(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:t.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const P=m?.get(v);if(!!P)return w.get(P)}u.getHeadersFromQuery=I;function C(d,m,P){if(!globalThis.crossOriginIsolated)return;const b=m&&P?"3":P?"2":"1";d instanceof URLSearchParams?d.set(v,b):d[v]=b}u.addSearchParam=C})(E=e.COI||(e.COI={}))}),define(te[18],ie([0,1,31,14,9,4,26,7]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(d){return(0,E.uriToFsPath)(d,!0)}e.originalFSPath=u;class w{constructor(m){this._ignorePathCasing=m}compare(m,P,b=!1){return m===P?0:(0,D.compare)(this.getComparisonKey(m,b),this.getComparisonKey(P,b))}isEqual(m,P,b=!1){return m===P?!0:!m||!P?!1:this.getComparisonKey(m,b)===this.getComparisonKey(P,b)}getComparisonKey(m,P=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:P?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,P,b=!1){if(m.scheme===P.scheme){if(m.scheme===t.Schemas.file)return S.isEqualOrParent(u(m),u(P),this._ignorePathCasing(m))&&m.query===P.query&&(b||m.fragment===P.fragment);if((0,e.isEqualAuthority)(m.authority,P.authority))return S.isEqualOrParent(m.path,P.path,this._ignorePathCasing(m),"/")&&m.query===P.query&&(b||m.fragment===P.fragment)}return!1}joinPath(m,...P){return E.URI.joinPath(m,...P)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return M.posix.basename(m.path)}extname(m){return M.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let P;return m.scheme===t.Schemas.file?P=E.URI.file(M.dirname(u(m))).path:(P=M.posix.dirname(m.path),m.authority&&P.length&&P.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),P="/")),m.with({path:P})}normalizePath(m){if(!m.path.length)return m;let P;return m.scheme===t.Schemas.file?P=E.URI.file(M.normalize(u(m))).path:P=M.posix.normalize(m.path),m.with({path:P})}relativePath(m,P){if(m.scheme!==P.scheme||!(0,e.isEqualAuthority)(m.authority,P.authority))return;if(m.scheme===t.Schemas.file){const y=M.relative(u(m),u(P));return R.isWindows?S.toSlashes(y):y}let b=m.path||"/";const p=P.path||"/";if(this._ignorePathCasing(m)){let y=0;for(const h=Math.min(b.length,p.length);y<h&&!(b.charCodeAt(y)!==p.charCodeAt(y)&&b.charAt(y).toLowerCase()!==p.charAt(y).toLowerCase());y++);b=p.substr(0,y)+b.substr(y)}return M.posix.relative(b,p)}resolvePath(m,P){if(m.scheme===t.Schemas.file){const b=E.URI.file(M.resolve(u(m),P));return m.with({authority:b.authority,path:b.path})}return P=S.toPosixPath(P),m.with({path:M.posix.resolve(m.path,P)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,P){return m===P||m!==void 0&&P!==void 0&&(0,D.equalsIgnoreCase)(m,P)}hasTrailingPathSeparator(m,P=M.sep){if(m.scheme===t.Schemas.file){const b=u(m);return b.length>S.getRoot(b).length&&b[b.length-1]===P}else{const b=m.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,P=M.sep){return(0,e.hasTrailingPathSeparator)(m,P)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,P=M.sep){let b=!1;if(m.scheme===t.Schemas.file){const p=u(m);b=p!==void 0&&p.length===S.getRoot(p).length&&p[p.length-1]===P}else{P="/";const p=m.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(m,P)?m.with({path:m.path+"/"}):m}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(d=>d.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(d,m){const P=[];for(let b=0;b<d.length;b++){const p=m(d[b]);d.some((y,h)=>h===b?!1:(0,e.isEqualOrParent)(p,m(y)))||P.push(d[b])}return P}e.distinctParents=v;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(P){const b=new Map;P.path.substring(P.path.indexOf(";")+1,P.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,l]=h.split(":");g&&l&&b.set(g,l)});const y=P.path.substring(0,P.path.indexOf(";"));return y&&b.set(d.META_DATA_MIME,y),b}d.parseMetaData=m})(I=e.DataUri||(e.DataUri={}));function C(d,m,P){if(m){let b=d.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),d.with({scheme:P,authority:m,path:b})}return d.with({scheme:P})}e.toLocalResource=C}),define(te[8],ie([0,1,23,16,3,2,18,4]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u($){return!!$&&typeof $.then=="function"}e.isThenable=u;function w($){const L=new S.CancellationTokenSource,O=$(L.token),U=new Promise((q,Y)=>{const oe=L.token.onCancellationRequested(()=>{oe.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(H=>{oe.dispose(),L.dispose(),q(H)},H=>{oe.dispose(),L.dispose(),Y(H)})});return new class{cancel(){L.cancel()}then(q,Y){return U.then(q,Y)}catch(q){return this.then(void 0,q)}finally(q){return U.finally(q)}}}e.createCancelablePromise=w;function v($,L,O){return new Promise((U,q)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),U(O)});$.then(U,q).finally(()=>Y.dispose())})}e.raceCancellation=v;function I($,L){return new Promise((O,U)=>{const q=L.onCancellationRequested(()=>{q.dispose(),U(new t.CancellationError)});$.then(O,U).finally(()=>q.dispose())})}e.raceCancellationError=I;async function C($){let L=-1;const O=$.map((q,Y)=>q.then(oe=>(L=Y,oe))),U=await Promise.race(O);return $.forEach((q,Y)=>{Y!==L&&q.cancel()}),U}e.raceCancellablePromises=C;function d($,L,O){let U;const q=setTimeout(()=>{U?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(Y=>U=Y)])}e.raceTimeout=d;function m($){return new Promise((L,O)=>{const U=$();u(U)?U.then(L,O):L(U)})}e.asPromise=m;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(O,O).then(U)})}return new Promise((O,U)=>{this.queuedPromise.then(O,U)})}return this.activePromise=L(),new Promise((O,U)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,U(q)})})}}e.Throttler=P;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,O){const q=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,q),q}}e.SequencerByKey=p;const y=($,L)=>{let O=!0;const U=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(U),O=!1}}},h=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,Y)=>{this.doResolve=q,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?h(U):y(O,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class l{constructor(L){this.delayer=new g(L),this.throttler=new P}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class a extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function r($,L){return L?new Promise((O,U)=>{const q=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(q),Y.dispose(),U(new t.CancellationError)})}):w(O=>r($,O))}e.timeout=r;function n($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function s($){const L=[];let O=0;const U=$.length;function q(){return O<U?$[O++]():null}function Y(oe){oe!=null&&L.push(oe);const H=q();return H?H.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=s;function c($,L=U=>!!U,O=null){let U=0;const q=$.length,Y=()=>{if(U>=q)return Promise.resolve(O);const oe=$[U++];return Promise.resolve(oe()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=c;function o($,L=U=>!!U,O=null){if($.length===0)return Promise.resolve(O);let U=$.length;const q=()=>{U=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,oe)=>{for(const H of $)H.then(re=>{--U>=0&&L(re)?(q(),Y(re)):U===0&&Y(O)}).catch(re=>{--U>=0&&(q(),oe(re))})})}e.firstParallel=o;class f{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new M.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,U)=>{this.outstandingPromises.push({factory:L,c:O,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class k extends f{constructor(){super(1)}}e.Queue=k;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const U=O.getComparisonKey(L);let q=this.queues.get(U);return q||(q=new k,M.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,q)),q}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class _{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=_;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=G;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class X{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class Q extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class J extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,E.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function he($,L,O){let U;for(let q=0;q<O;q++)try{return await $()}catch(Y){U=Y,await r(L)}throw U}e.retry=he;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,U){return this._pending={taskId:L,cancel:()=>U?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,U;const q=new Promise((Y,oe)=>{O=Y,U=oe});this._next={run:L,promise:q,promiseResolve:O,promiseReject:U}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class j{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class F{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function($){async function L(U){let q;const Y=await Promise.all(U.map(oe=>oe.then(H=>H,H=>{q||(q=H)})));if(typeof q<"u")throw q;return Y}$.settled=L;function O(U){return new Promise(async(q,Y)=>{try{await U(q,Y)}catch(oe){Y(oe)}})}$.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(W||(W={}));class N{static fromArray(L){return new N(O=>{O.emitMany(L)})}static fromPromise(L){return new N(async O=>{O.emitMany(await L)})}static fromPromises(L){return new N(async O=>{await Promise.all(L.map(async U=>O.emitOne(await U)))})}static merge(L){return new N(async O=>{await Promise.all(L.map(async U=>{for await(const q of U)O.emitOne(q)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const O={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(L(O)),this.resolve()}catch(U){this.reject(U)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new N(async U=>{for await(const q of L)U.emitOne(O(q))})}map(L){return N.map(this,L)}static filter(L,O){return new N(async U=>{for await(const q of L)O(q)&&U.emitOne(q)})}filter(L){return N.filter(this,L)}static coalesce(L){return N.filter(L,O=>!!O)}coalesce(){return N.coalesce(this)}static async toPromise(L){const O=[];for await(const U of L)O.push(U);return O}toPromise(){return N.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=N,N.EMPTY=N.fromArray([]);class x extends N{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function B($){const L=new S.CancellationTokenSource,O=$(L.token);return new x(L,async U=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),U.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;U.emitOne(Y)}q.dispose(),L.dispose()}catch(Y){q.dispose(),L.dispose(),U.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(te[98],ie([0,1,24,8,31,29,9,4,26]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",I="[^/\\\\]",C=/\//g;function d(F,A){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${v}|${I}+${v}${A?`|${v}${I}+`:""})*?`}}function m(F,A){if(!F)return[];const W=[];let N=!1,x=!1,B="";for(const $ of F){switch($){case A:if(!N&&!x){W.push(B),B="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":x=!0;break;case"]":x=!1;break}B+=$}return B&&W.push(B),W}e.splitGlobAware=m;function P(F){if(!F)return"";let A="";const W=m(F,e.GLOB_SPLIT);if(W.every(N=>N===e.GLOBSTAR))A=".*";else{let N=!1;W.forEach((x,B)=>{if(x===e.GLOBSTAR){if(N)return;A+=d(2,B===W.length-1)}else{let $=!1,L="",O=!1,U="";for(const q of x){if(q!=="}"&&$){L+=q;continue}if(O&&(q!=="]"||!U)){let Y;q==="-"?Y=q:(q==="^"||q==="!")&&!U?Y="^":q===e.GLOB_SPLIT?Y="":Y=(0,u.escapeRegExpCharacters)(q),U+=Y;continue}switch(q){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${m(L,",").map(H=>P(H)).join("|")})`,$=!1,L="";break}case"]":{A+="["+U+"]",O=!1,U="";break}case"?":A+=I;continue;case"*":A+=d(1);continue;default:A+=(0,u.escapeRegExpCharacters)(q)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=v)}N=x===e.GLOBSTAR})}return A}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),a=function(){return!1},r=function(){return null};function n(F,A){if(!F)return r;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const N=`${W}_${!!A.trimForExclusions}`;let x=i.get(N);if(x)return s(x,F);let B;return b.test(W)?x=o(W.substr(4),W):(B=p.exec(c(W,A)))?x=f(B[1],W):(A.trimForExclusions?h:y).test(W)?x=k(W,A):(B=g.exec(c(W,A)))?x=T(B[1].substr(1),W,!0):(B=l.exec(c(W,A)))?x=T(B[1],W,!1):x=_(W),i.set(N,x),s(x,F)}function s(F,A){if(typeof A=="string")return F;const W=function(N,x){return(0,M.isEqualOrParent)(N,A.base,!E.isLinux)?F(N.substr(A.base.length+1),x):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function c(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function o(F,A){return function(W,N){return typeof W=="string"&&W.endsWith(F)?A:null}}function f(F,A){const W=`/${F}`,N=`\\${F}`,x=function($,L){return typeof $!="string"?null:L?L===F?A:null:$===F||$.endsWith(W)||$.endsWith(N)?A:null},B=[F];return x.basenames=B,x.patterns=[A],x.allBasenames=B,x}function k(F,A){const W=V(F.slice(1,-1).split(",").map(L=>n(L,A)).filter(L=>L!==r),F),N=W.length;if(!N)return r;if(N===1)return W[0];const x=function(L,O){for(let U=0,q=W.length;U<q;U++)if(W[U](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(x.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(x.allPaths=$),x}function T(F,A,W){const N=D.sep===D.posix.sep,x=N?F:F.replace(C,D.sep),B=D.sep+x,$=D.posix.sep+F;let L;return W?L=function(O,U){return typeof O=="string"&&(O===x||O.endsWith(B)||!N&&(O===F||O.endsWith($)))?A:null}:L=function(O,U){return typeof O=="string"&&(O===x||!N&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function _(F){try{const A=new RegExp(`^${P(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return r}}function G(F,A,W){return!F||typeof A!="string"?!1:ae(F)(A,void 0,W)}e.match=G;function ae(F,A={}){if(!F)return a;if(typeof F=="string"||X(F)){const W=n(F,A);if(W===r)return a;const N=function(x,B){return!!W(x,B)};return W.allBasenames&&(N.allBasenames=W.allBasenames),W.allPaths&&(N.allPaths=W.allPaths),N}return se(F,A)}e.parse=ae;function X(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=X;function Q(F){return F.allBasenames||[]}e.getBasenameTerms=Q;function J(F){return F.allPaths||[]}e.getPathTerms=J;function se(F,A){const W=V(Object.getOwnPropertyNames(F).map(L=>he(L,F[L],A)).filter(L=>L!==r)),N=W.length;if(!N)return r;if(!W.some(L=>!!L.requiresSiblings)){if(N===1)return W[0];const L=function(q,Y){let oe;for(let H=0,re=W.length;H<re;H++){const ne=W[H](q,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const H of oe){const re=await H;if(typeof re=="string")return re}return null})():null},O=W.find(q=>!!q.allBasenames);O&&(L.allBasenames=O.allBasenames);const U=W.reduce((q,Y)=>Y.allPaths?q.concat(Y.allPaths):q,[]);return U.length&&(L.allPaths=U),L}const x=function(L,O,U){let q,Y;for(let oe=0,H=W.length;oe<H;oe++){const re=W[oe];re.requiresSiblings&&U&&(O||(O=(0,D.basename)(L)),q||(q=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,q,U);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const oe of Y){const H=await oe;if(typeof H=="string")return H}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(x.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(x.allPaths=$),x}function he(F,A,W){if(A===!1)return r;const N=n(F,W);if(N===r)return r;if(typeof A=="boolean")return N;if(A){const x=A.when;if(typeof x=="string"){const B=($,L,O,U)=>{if(!U||!N($,L))return null;const q=x.replace("$(basename)",O),Y=U(q);return(0,t.isThenable)(Y)?Y.then(oe=>oe?F:null):Y?F:null};return B.requiresSiblings=!0,B}}return N}function V(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const N=W.reduce((L,O)=>{const U=O.basenames;return U?L.concat(U):L},[]);let x;if(A){x=[];for(let L=0,O=N.length;L<O;L++)x.push(A)}else x=W.reduce((L,O)=>{const U=O.patterns;return U?L.concat(U):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let q;for(q=L.length;q>0;q--){const Y=L.charCodeAt(q-1);if(Y===47||Y===92)break}O=L.substr(q)}const U=N.indexOf(O);return U!==-1?x[U]:null};B.basenames=N,B.patterns=x,B.allBasenames=N;const $=F.filter(L=>!L.basenames);return $.push(B),$}function j(F,A){return(0,S.equals)(F,A,(W,N)=>typeof W=="string"&&typeof N=="string"?W===N:typeof W!="string"&&typeof N!="string"?W.base===N.base&&W.pattern===N.pattern:!1)}e.patternsEquals=j}),define(te[35],ie([0,1,24,31,9,4,18,26]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(r,n){const{os:s,tildify:c,relative:o}=n;if(o){const T=w(r,o,s);if(typeof T=="string")return T}let f=r.fsPath;if(s===1&&!R.isWindows?f=f.replace(/\//g,"\\"):s!==1&&R.isWindows&&(f=f.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let _;r.scheme!==c.userHome.scheme&&r.path.startsWith(M.posix.sep)?_=c.userHome.with({path:r.path}).fsPath:_=r.fsPath,f=C(_,T,s)}return(s===1?M.win32:M.posix).normalize(v(f,s===1))}e.getPathLabel=u;function w(r,n,s){const c=s===1?M.win32:M.posix,o=s===3?D.extUri:D.extUriIgnorePathCase,f=n.getWorkspace(),k=(0,S.firstOrDefault)(f.folders);if(!k)return;r.scheme!==k.uri.scheme&&r.path.startsWith(M.posix.sep)&&(r=k.uri.with({path:r.path}));const T=n.getWorkspaceFolder(r);if(!T)return;let _;if(o.isEqual(T.uri,r)?_="":_=o.relativePath(T.uri,r)??"",_&&(_=c.normalize(_)),f.folders.length>1&&!n.noPrefix){const G=T.name?T.name:o.basenameOrAuthority(T.uri);_=_?`${G} \u2022 ${_}`:G}return _}function v(r,n=R.isWindows){return(0,t.hasDriveLetter)(r,n)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=v;let I=Object.create(null);function C(r,n,s=R.OS){if(s===1||!r||!n)return r;let c=I.original===n?I.normalized:void 0;c||(c=n,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,E.rtrim)(c,M.posix.sep)}${M.posix.sep}`,I={original:n,normalized:c});let o=r;return R.isWindows&&(o=(0,t.toSlashes)(o)),(s===3?o.startsWith(c):(0,E.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:r}e.tildify=C;function d(r,n){return r.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=d;const m="\u2026",P="\\\\",b="~";function p(r,n=M.sep){const s=new Array(r.length);let c=!1;for(let o=0;o<r.length;o++){const f=r[o];if(f===""){s[o]=`.${n}`;continue}if(!f){s[o]=f;continue}c=!0;let k="",T=f;T.indexOf(P)===0?(k=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(n)===0?(k=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(b)===0&&(k=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const _=T.split(n);for(let G=1;c&&G<=_.length;G++)for(let ae=_.length-G;c&&ae>=0;ae--){c=!1;let X=_.slice(ae,ae+G).join(n);for(let Q=0;!c&&Q<r.length;Q++)if(Q!==o&&r[Q]&&r[Q].indexOf(X)>-1){const J=ae+G===_.length,se=ae>0&&r[Q].indexOf(n)>-1?n+X:X,he=r[Q].endsWith(se);c=!J||he}if(!c){let Q="";(_[0].endsWith(":")||k!=="")&&(ae===1&&(ae=0,G++,X=_[0]+n+X),ae>0&&(Q=_[0]+n),Q=k+Q),ae>0&&(Q=Q+m+n),Q=Q+X,ae+G<_.length&&(Q=Q+n+m),s[o]=Q}}c&&(s[o]=f)}return s}e.shorten=p;var y;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(y||(y={}));function h(r,n=Object.create(null)){const s=[];let c=!1,o="";for(const f of r)if(f==="$"||c&&f==="{")o&&s.push({value:o,type:y.TEXT}),o="",c=!0;else if(f==="}"&&c){const k=n[o];if(typeof k=="string")k.length&&s.push({value:k,type:y.VARIABLE});else if(k){const T=s[s.length-1];(!T||T.type!==y.SEPARATOR)&&s.push({value:k.label,type:y.SEPARATOR})}o="",c=!1}else o+=f;return o&&!c&&s.push({value:o,type:y.TEXT}),s.filter((f,k)=>{if(f.type===y.SEPARATOR){const T=s[k-1],_=s[k+1];return[T,_].every(G=>G&&(G.type===y.VARIABLE||G.type===y.TEXT)&&G.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=h;function g(r,n){return R.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function l(r,n){return R.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,s=>s==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(r){const n=r.indexOf("/")!==-1?M.posix:M.win32,s=n.basename(r),c=n.dirname(r);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(te[138],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(v){return v.toJSON()}class M{constructor(I){this._uriTransformer=I}transformIncoming(I){const C=this._uriTransformer.transformIncoming(I);return C===I?I:t(S.URI.from(C))}transformOutgoing(I){const C=this._uriTransformer.transformOutgoing(I);return C===I?I:t(S.URI.from(C))}transformOutgoingURI(I){const C=this._uriTransformer.transformOutgoing(I);return C===I?I:S.URI.from(C)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function R(v,I,C){if(!v||C>200)return null;if(typeof v=="object"){if(v instanceof S.URI)return I.transformOutgoing(v);for(const d in v)if(Object.hasOwnProperty.call(v,d)){const m=R(v[d],I,C+1);m!==null&&(v[d]=m)}}return null}function D(v,I){const C=R(v,I,0);return C===null?v:C}e.transformOutgoingURIs=D;function E(v,I,C,d){if(!v||d>200)return null;if(typeof v=="object"){if(v.$mid===1)return C?S.URI.revive(I.transformIncoming(v)):I.transformIncoming(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const P=E(v[m],I,C,d+1);P!==null&&(v[m]=P)}}return null}function u(v,I){const C=E(v,I,!1,0);return C===null?v:C}e.transformIncomingURIs=u;function w(v,I){const C=E(v,I,!0,0);return C===null?v:C}e.transformAndReviveIncomingURIs=w}),define(te[81],ie([0,1,25,16,29,30,126]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,I=0;const C=(0,S.networkInterfaces)();for(const d in C){const m=C[d];if(m)for(const{mac:P,internal:b}of m)b||(I+=1,this._isVirtualMachineMacAddress(P.toUpperCase())&&(v+=1))}this._value=I>0?v/I:0}return this._value}};let E;async function u(){return E||(E=(async()=>await w()||R.generateUuid())()),E}e.getMachineId=u;async function w(){try{const v=await new Promise((C,d)=>{z(["crypto"],C,d)}),I=(0,D.getMac)();return v.createHash("sha256").update(I,"utf8").digest("hex")}catch(v){t.onUnexpectedError(v);return}}}),define(te[21],ie([0,1,40,25,139,8,31,80,9,4,18,7]),function(z,e,S,t,M,R,D,E,u,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function d(se,he=C.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return he===C.UNLINK?P(se):m(se)}async function m(se){try{const he=(0,D.randomPath)((0,t.tmpdir)());try{await S.promises.rename(se,he)}catch(V){return V.code==="ENOENT"?void 0:P(se)}P(he).catch(V=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function P(se){return(0,M.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(se,he){return g(await(he?y(se):(0,M.promisify)(S.readdir)(se)))}async function y(se){try{return await(0,M.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const he=[],V=await p(se);for(const j of V){let F=!1,A=!1,W=!1;try{const N=await e.Promises.lstat((0,u.join)(se,j));F=N.isFile(),A=N.isDirectory(),W=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}he.push({name:j,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return he}function h(se){return g(S.readdirSync(se))}e.readdirSync=h;function g(se){return se.map(he=>typeof he=="string"?w.isMacintosh?(0,E.normalizeNFC)(he):he:(he.name=w.isMacintosh?(0,E.normalizeNFC)(he.name):he.name,he))}async function l(se){const he=await p(se),V=[];for(const j of he)await a.existsDirectory((0,u.join)(se,j))&&V.push(j);return V}function i(se,he=1e3){return new Promise(V=>{let j=!1;const F=setInterval(()=>{j||(j=!0,S.access(se,A=>{j=!1,A&&(clearInterval(F),V(void 0))}))},he)})}e.whenDeleted=i;var a;(function(se){async function he(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(w.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw N}throw W}}se.stat=he;async function V(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=V;async function j(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=j})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function n(se,he,V){return r.queueFor(I.URI.file(se),v.extUriBiasedIgnorePathCase).queue(()=>{const j=k(V);return new Promise((F,A)=>o(se,he,j,W=>W?A(W):F()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function o(se,he,V,j){if(!s)return S.writeFile(se,he,{mode:V.mode,flag:V.flag},j);S.open(se,V.flag,V.mode,(F,A)=>{if(F)return j(F);S.writeFile(A,he,W=>{if(W)return S.close(A,()=>j(W));S.fdatasync(A,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c(!1)),S.close(A,x=>j(x))))})})}function f(se,he,V){const j=k(V);if(!s)return S.writeFileSync(se,he,{mode:j.mode,flag:j.flag});const F=S.openSync(se,j.flag,j.mode);try{S.writeFileSync(F,he);try{S.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{S.closeSync(F)}}e.writeFileSync=f;function k(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,he){if(se!==he)try{await e.Promises.rename(se,he)}catch(V){if(se.toLowerCase()!==he.toLowerCase()&&V.code==="EXDEV"||se.endsWith("."))await _(se,he,{preserveSymlinks:!1}),await d(se,C.MOVE);else throw V}}async function _(se,he,V){return ae(se,he,{root:{source:se,target:he},options:V,handledSourcePaths:new Set})}const G=511;async function ae(se,he,V){if(V.handledSourcePaths.has(se))return;V.handledSourcePaths.add(se);const{stat:j,symbolicLink:F}=await a.stat(se);if(F){if(V.options.preserveSymlinks)try{return await J(se,he,V)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return j.isDirectory()?X(se,he,j.mode&G,V):Q(se,he,j.mode&G)}async function X(se,he,V,j){await e.Promises.mkdir(he,{recursive:!0,mode:V});const F=await p(se);for(const A of F)await ae((0,u.join)(se,A),(0,u.join)(he,A),j)}async function Q(se,he,V){await e.Promises.copyFile(se,he),await e.Promises.chmod(he,V)}async function J(se,he,V){let j=await e.Promises.readlink(se);(0,D.isEqualOrParent)(j,V.root.source,!w.isLinux)&&(j=(0,u.join)(V.root.target,j.substr(V.root.source.length+1))),await e.Promises.symlink(j,he)}e.Promises=new class{get access(){return(0,M.promisify)(S.access)}get stat(){return(0,M.promisify)(S.stat)}get lstat(){return(0,M.promisify)(S.lstat)}get utimes(){return(0,M.promisify)(S.utimes)}get read(){return(se,he,V,j,F)=>new Promise((A,W)=>{S.read(se,he,V,j,F,(N,x,B)=>N?W(N):A({bytesRead:x,buffer:B}))})}get readFile(){return(0,M.promisify)(S.readFile)}get write(){return(se,he,V,j,F)=>new Promise((A,W)=>{S.write(se,he,V,j,F,(N,x,B)=>N?W(N):A({bytesWritten:x,buffer:B}))})}get appendFile(){return(0,M.promisify)(S.appendFile)}get fdatasync(){return(0,M.promisify)(S.fdatasync)}get truncate(){return(0,M.promisify)(S.truncate)}get rename(){return(0,M.promisify)(S.rename)}get copyFile(){return(0,M.promisify)(S.copyFile)}get open(){return(0,M.promisify)(S.open)}get close(){return(0,M.promisify)(S.close)}get symlink(){return(0,M.promisify)(S.symlink)}get readlink(){return(0,M.promisify)(S.readlink)}get chmod(){return(0,M.promisify)(S.chmod)}get mkdir(){return(0,M.promisify)(S.mkdir)}get unlink(){return(0,M.promisify)(S.unlink)}get rmdir(){return(0,M.promisify)(S.rmdir)}get realpath(){return(0,M.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return d}get move(){return T}get copy(){return _}}}),define(te[99],ie([0,1,40,9,4,26,21]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(C){if(M.isLinux)return C;const d=(0,t.dirname)(C);if(C===d)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const b=(0,D.readdirSync)(d).filter(p=>p.toLowerCase()===m);if(b.length===1){const p=E(d);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(m);if(p>=0){const y=E(d);if(y)return(0,t.join)(y,b[p])}}}catch{}return null}e.realcaseSync=E;async function u(C){if(M.isLinux)return C;const d=(0,t.dirname)(C);if(C===d)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const b=(await D.Promises.readdir(d)).filter(p=>p.toLowerCase()===m);if(b.length===1){const p=await u(d);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(m);if(p>=0){const y=await u(d);if(y)return(0,t.join)(y,b[p])}}}catch{}return null}e.realcase=u;async function w(C){try{return await D.Promises.realpath(C)}catch{const m=I(C);return await D.Promises.access(m,S.constants.R_OK),m}}e.realpath=w;function v(C){try{return S.realpathSync(C)}catch{const m=I(C);return S.accessSync(m,S.constants.R_OK),m}}e.realpathSync=v;function I(C){return(0,R.rtrim)((0,t.normalize)(C),t.sep)}}),define(te[140],ie([0,1,25,9,21]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class I{constructor(l,i,a){this.exePath=l,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:g=!1}={}){return g?w===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:g=!1,findPreview:l=!1}={}){const i=C({useAlternateBitness:g});if(!i)return null;const a=t.join(i,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(a))return null;let r=-1,n=null;for(const o of await M.Promises.readdir(a)){let f=-1;if(l){const T=o.indexOf("-");if(T<0)continue;const _=o.substring(0,T);if(!R.test(_)||o.substring(T+1)!=="preview")continue;f=parseInt(_,10)}else{if(!R.test(o))continue;f=parseInt(o,10)}if(f<=r)continue;const k=t.join(a,o,"pwsh.exe");!await M.SymlinkSupport.existsFile(k)||(n=k,r=f)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",c=l?" Preview":"";return new I(n,`PowerShell${c}${s}`,!0)}async function m({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await M.Promises.readdir(l))if(i.test(r)){const n=t.join(l,r,"pwsh.exe");return new I(n,a)}return null}function P(){const g=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new I(g,".NET Core PowerShell Global Tool")}function b(){const g=t.join(process.env.windir,w===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(g,"Windows PowerShell",!0)}async function*p(){let g=await d();g&&(yield g),g=await d({useAlternateBitness:!0}),g&&(yield g),g=await m(),g&&(yield g),g=P(),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await m({findPreview:!0}),g&&(yield g),g=await d({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=b(),g&&(yield g)}async function*y(){for await(const g of p())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=y;async function h(){for await(const g of y())return g;return null}e.getFirstAvailablePowerShellInstallation=h}),define(te[82],ie([0,1,9,4,34,78,12,21]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(I=M.env){return I.comspec||"cmd.exe"}e.getWindowsShell=u;function w(I){let C=[],d=!1;const m=function(P){if(d){C.push(P);return}(!I.send(P,p=>{if(p&&console.error(p),d=!1,C.length>0){const y=C.slice(0);C=[],y.forEach(h=>m(h))}})||t.isWindows)&&(d=!0)};return{send:m}}e.createQueuedSender=w;var v;(function(I){async function C(d,m,P){if(S.isAbsolute(d))return d;if(m===void 0&&(m=M.cwd()),S.dirname(d)!=="."||(P===void 0&&D.isString(M.env.PATH)&&(P=M.env.PATH.split(S.delimiter)),P===void 0||P.length===0))return S.join(m,d);async function p(y){if(await E.Promises.exists(y)){let h;try{h=await E.Promises.stat(y)}catch(g){g.message.startsWith("EACCES")&&(h=await E.Promises.lstat(y))}return h?!h.isDirectory():!1}return!1}for(const y of P){let h;if(S.isAbsolute(y)?h=S.join(y,d):h=S.join(m,y,d),await p(h))return h;let g=h+".com";if(await p(g)||(g=h+".exe",await p(g)))return g}return S.join(m,d)}I.findExecutable=C})(v=e.win32||(e.win32={}))}),define(te[100],ie([0,1,45,14]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(D){return new Promise((E,u)=>{let w;const v=new Map;function I(d,m,P,b,p){const y=v.get(m);if(d===D||y){const h={name:C(P),cmd:P,pid:d,ppid:m,load:b,mem:p};v.set(d,h),d===D&&(w=h),y&&(y.children||(y.children=[]),y.children.push(h),y.children.length>1&&(y.children=y.children.sort((g,l)=>g.pid-l.pid)))}}function C(d){const m=/--vscode-window-kind=shared-process/,P=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,y=/--utility-sub-type=node.mojom.NodeService/,h=/--crashes-directory/,g=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(h.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-process";if(l.exec(d))return"console-window-host (Windows internal process)";let a=i.exec(d);if(a&&a.length===2){if(a[1]==="renderer")return m.exec(d)?"shared-process":P.exec(d)?"issue-reporter":b.exec(d)?"process-explorer":"window";if(a[1]==="utility"){if(p.exec(d))return"utility-network-service";if(y.exec(d))return"extension-host"}return a[1]}const r=/[a-zA-Z-]+\.js/g;let n="";do a=r.exec(d),a&&(n+=a+" ");while(a);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${n}`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,P)=>{z(["windows-process-tree"],m,P)}).then(m=>{m.getProcessList(D,P=>{if(!P){u(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(P,b=>{const p=new Map;b.forEach(y=>{const h=d(y.commandLine||"");p.set(y.pid,{name:C(h),cmd:h,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),w=p.get(D),w?(p.forEach(y=>{const h=p.get(y.ppid);h&&(h.children||(h.children=[]),h.children.push(y))}),p.forEach(y=>{y.children&&(y.children=y.children.sort((h,g)=>h.pid-g.pid))}),E(w)):u(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[w];const P=[];for(;m.length;){const p=m.shift();p&&(P.push(p.pid),p.children&&(m=m.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);b+=" "+P.join(" "),(0,S.exec)(b,{},(p,y,h)=>{if(p||h)u(p||new Error(h.toString()));else{const g=y.toString().split(`
`);for(let l=0;l<P.length;l++){const i=v.get(P[l]);i.load=parseFloat(g[l])}if(!w){u(new Error(`Root process ${D} not found`));return}E(w)}})};(0,S.exec)("which ps",{},(m,P,b)=>{if(m||b)if(process.platform!=="linux")u(m||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,S.exec)(p,{},(y,h,g)=>{y||g?u(y||new Error(g.toString())):(R(h,I),d())})}else{const p=P.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${p} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,g,l)=>{h||l&&!l.includes("screen size is bogus")?u(h||new Error(l.toString())):(R(g,I),process.platform==="linux"?d():w?E(w):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=M;function R(D,E){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=D.toString().split(`
`);for(const v of w){const I=u.exec(v.trim());I&&I.length===6&&E(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[141],ie([0,1,25,4,140,82]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(d,m){return d===1?t.isWindows?I():R.getWindowsShell(m):w(d,m)}e.getSystemShell=D;function E(d,m){return d===1?t.isWindows?C(m):R.getWindowsShell(m):w(d,m)}e.getSystemShellSync=E;let u=null;function w(d,m){if(t.isLinux&&d===2||t.isMacintosh&&d===3)return"/bin/bash";if(!u){let P;if(t.isWindows)P="/bin/bash";else{if(P=m.SHELL,!P)try{P=(0,S.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}u=P}return u}let v=null;async function I(){return v||(v=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),v}function C(d){if(v)return v;const m=t.isWindows&&parseFloat((0,S.release)())>=10,P=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${d.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?b:R.getWindowsShell(d)}});var we=this&&this.__decorate||function(z,e,S,t){var M=arguments.length,R=M<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,S,t);else for(var E=z.length-1;E>=0;E--)(D=z[E])&&(R=(M<3?D(R):M>3?D(e,S,R):D(e,S))||R);return M>3&&R&&Object.defineProperty(e,S,R),R};define(te[46],ie([0,1,24,8,17,23,53,16,3,2,67,26,12]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function b(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(p||(p={}));class y{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class h{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var g;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(g||(g={}));function l(F){const A=M.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function i(F){return F.read(4).readUInt32BE(0)}function a(F){const A=M.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const r={Undefined:a(g.Undefined),String:a(g.String),Buffer:a(g.Buffer),VSBuffer:a(g.VSBuffer),Array:a(g.Array),Object:a(g.Object)},n=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(r.Undefined);else if(typeof A=="string"){const W=M.VSBuffer.fromString(A);F.write(r.String),F.write(l(W.byteLength)),F.write(W)}else if(n&&Buffer.isBuffer(A)){const W=M.VSBuffer.wrap(A);F.write(r.Buffer),F.write(l(W.byteLength)),F.write(W)}else if(A instanceof M.VSBuffer)F.write(r.VSBuffer),F.write(l(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(r.Array),F.write(l(A.length));for(const W of A)s(F,W)}else{const W=M.VSBuffer.fromString(JSON.stringify(A));F.write(r.Object),F.write(l(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return F.read(i(F)).toString();case g.Buffer:return F.read(i(F)).buffer;case g.VSBuffer:return F.read(i(F));case g.Array:{const W=i(F),N=[];for(let x=0;x<W;x++)N.push(c(F));return N}case g.Object:return JSON.parse(F.read(i(F)).toString())}}class o{constructor(A,W,N=null,x=1e3){this.protocol=A,this.ctx=W,this.logger=N,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,b(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,b(A.type),A.data);return}}}send(A,W=void 0){const N=new h;return s(N,A),s(N,W),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new y(A),N=c(W),x=c(W),B=N[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,N[1],1,`${m(B)}: ${N[2]}.${N[3]}`,x),this.onPromise({type:B,id:N[1],channelName:N[2],name:N[3],arg:x});case 102:return this.logger?.logIncoming(A.byteLength,N[1],1,`${m(B)}: ${N[2]}.${N[3]}`,x),this.onEventListen({type:B,id:N[1],channelName:N[2],name:N[3],arg:x});case 101:return this.logger?.logIncoming(A.byteLength,N[1],1,`${m(B)}`),this.disposeActiveRequest({type:B,id:N[1]});case 103:return this.logger?.logIncoming(A.byteLength,N[1],1,`${m(B)}`),this.disposeActiveRequest({type:B,id:N[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const N=new R.CancellationTokenSource;let x;try{x=W.call(this.ctx,A.name,A.arg,N.token)}catch(L){x=Promise.reject(L)}const B=A.id;x.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,w.toDisposable)(()=>N.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const N=A.id,B=W.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:N,data:$,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const N=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:N})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const N of W)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var f;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=W}getChannel(A){const W=this;return{call(N,x,B){return W.isDisposed?Promise.reject(new E.CancellationError):W.requestPromise(A,N,x,B)},listen(N,x){return W.isDisposed?u.Event.None:W.requestEvent(A,N,x)}}}requestPromise(A,W,N,x=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:N};if(x.isCancellationRequested)return Promise.reject(new E.CancellationError);let O;return new Promise((q,Y)=>{if(x.isCancellationRequested)return Y(new E.CancellationError);const oe=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),q(ge.data);break;case 202:{this.handlers.delete(B);const Re=new Error(ge.data.message);Re.stack=ge.data.stack,Re.name=ge.data.name,Y(Re);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let H=null;this.state===p.Idle?oe():(H=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),H.then(()=>{H=null,oe()}));const re=()=>{H?(H.cancel(),H=null):this.sendRequest({id:B,type:101}),Y(new E.CancellationError)},ne=x.onCancellationRequested(re);O=(0,w.combinedDisposable)((0,w.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,N){const x=this.lastRequestId++,$={id:x,type:102,channelName:A,name:W,arg:N};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(q=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:x,type:103}))}}),U=q=>O.fire(q.data);return this.handlers.set(x,U),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${m(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,m(A.type));return}}}send(A,W=void 0){const N=new h;return s(N,A),s(N,W),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new y(A),N=c(W),x=c(W),B=N[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,b(B)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,N[1],0,b(B),x),this.onResponse({type:N[0],id:N[1],data:x})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([D.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class T{get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:N})=>{u.Event.once(W.onMessage)(B=>{const $=new y(B),L=c($),O=new o(W,L),U=new k(W);this.channels.forEach((Y,oe)=>O.registerChannel(oe,Y));const q={channelServer:O,channelClient:U,ctx:L};this._connections.add(q),this._onDidAddConnection.fire(q),N(()=>{O.dispose(),U.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}getChannel(A,W){const N=this;return{call(x,B,$){let L;if((0,C.isFunction)(W)){const U=(0,S.getRandomElement)(N.connections.filter(W));L=U?Promise.resolve(U):u.Event.toPromise(u.Event.filter(N.onDidAddConnection,W))}else L=W.routeCall(N,x,B);const O=L.then(U=>U.channelClient.getChannel(A));return G(O).call(x,B,$)},listen(x,B){if((0,C.isFunction)(W))return N.getMulticastEvent(A,W,x,B);const $=W.routeEvent(N,x,B).then(L=>L.channelClient.getChannel(A));return G($).listen(x,B)}}}getMulticastEvent(A,W,N,x){const B=this;let $=new w.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{$=new w.DisposableStore;const O=new u.EventMultiplexer,U=new Map,q=oe=>{const re=oe.channelClient.getChannel(A).listen(N,x),ne=O.add(re);U.set(oe,ne)},Y=oe=>{const H=U.get(oe);!H||(H.dispose(),U.delete(oe))};B.connections.filter(W).forEach(q),u.Event.filter(B.onDidAddConnection,W)(q,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(N=>{N.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor(A,W,N=null){const x=new h;s(x,W),A.send(x.buffer),this.channelClient=new k(A,N),this.channelServer=new o(A,W,N)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function G(F){return{call(A,W,N){return F.then(x=>x.call(A,W,N))},listen(A,W){const N=new u.Relay;return F.then(x=>N.input=x.listen(A,W)),N.event}}}e.getDelayedChannel=G;function ae(F){let A=!1;return{call(W,N,x){return A?F.call(W,N,x):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,N,x))},listen(W,N){if(A)return F.listen(W,N);const x=new u.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>x.input=F.listen(W,N)),x.event}}}e.getNextTickChannel=ae;class X{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=X;var Q;(function(F){function A(B,$){const L=B,O=$&&$.disableMarshalling,U=new Map;for(const q in L)N(q)&&U.set(q,u.Event.buffer(L[q],!0));return new class{listen(q,Y,oe){const H=U.get(Y);if(H)return H;if(x(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,oe)}throw new Error(`Event not found: ${Y}`)}call(q,Y,oe){const H=L[Y];if(typeof H=="function"){if(!O&&Array.isArray(oe))for(let re=0;re<oe.length;re++)oe[re]=(0,v.revive)(oe[re]);return H.apply(L,oe)}throw new Error(`Method not found: ${Y}`)}}}F.fromService=A;function W(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return $?.properties?.has(U)?$.properties.get(U):x(U)?function(q){return B.listen(U,q)}:N(U)?B.listen(U):async function(...q){let Y;$&&!(0,C.isUndefinedOrNull)($.context)?Y=[$.context,...q]:Y=q;const oe=await B.call(U,Y);return L?oe:(0,v.revive)(oe)};throw new Error(`Property not found: ${String(U)}`)}})}F.toService=W;function N(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function x(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function he(F){return Array.isArray(F)?F.map(se):se(F)}function V(F,A,W,N,x,B,$){$=he($);const L=J[x],O=L[N%L.length];let U=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(U=U.concat($),U.push(")")):U.push($),console.log.apply(console,U)}e.logWithColors=V;class j{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,N,x,B){this._totalOutgoing+=A,V(this._outgoingPrefix,this._totalOutgoing,A,W,N,x,B)}logIncoming(A,W,N,x,B){this._totalIncoming+=A,V(this._incomingPrefix,this._totalIncoming,A,W,N,x,B)}}e.IPCLogger=j}),define(te[142],ie([0,1,17,3,46]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",w=>S.VSBuffer.wrap(w.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends M.IPCClient{constructor(u,w){const v=new R(u);super(v,w),this.protocol=v}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[101],ie([0,1,17,3,2,46]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let c=0;function o(k,T){if(!s.has(k)){const _=String(++c);s.set(k,_)}return s.get(k)}function f(k,T,_,G){if(!n.enableDiagnostics)return;const ae=o(k,T);if(G instanceof S.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const X=S.VSBuffer.alloc(G.byteLength);X.set(G),n.records.push({timestamp:Date.now(),id:ae,label:T,type:_,buff:X})}else n.records.push({timestamp:Date.now(),id:ae,label:T,type:_,data:G})}n.traceSocketEvent=f})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function v(){return w||(w=S.VSBuffer.alloc(0)),w}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return v();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const o=S.VSBuffer.alloc(s);let f=0,k=0;for(;s>0;){const T=this._chunks[k];if(T.byteLength>s){const _=T.slice(0,s);o.set(_,f),f+=s,c&&(this._chunks[k]=T.slice(s),this._totalLength-=s),s-=s}else o.set(T,f),f+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):k++,s-=T.byteLength}return o}}e.ChunkStream=I;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(C||(C={}));function d(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class P{constructor(s,c,o,f){this.type=s,this.id=c,this.ack=o,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends M.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,f=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new P(o,f,k,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const o=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,o}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends M.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new P(1,0,0,s))}}e.Protocol=y;class h extends R.IPCClient{static fromSocket(s,c){return new h(new y(s),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,c,o=null){super(s,c,o),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=h;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class l{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,o=this._first;for(;o;)s[c++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new l(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class a{static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<a._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=a._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),c=(1+a._HISTORY_LENGTH)*1e3;let o=0;for(let f=0;f<a._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=c&&o++;return 1-o/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class r{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,c=null,o=a.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new P(5,0,0,v());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new P(7,0,0,v());this._socketWriter.write(s)}sendResume(){const s=new P(8,0,0,v());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,v());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let o=0,f=c.length;o<f;o++)this._socketWriter.write(c[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new P(6,0,0,v())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let o=0,f=c.length;o<f;o++)this._socketWriter.write(c[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new P(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const c=new P(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,o=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&o>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const k=Math.max(2e4-c,2e4-o,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,v());this._socketWriter.write(s)}_sendKeepAlive(){const s=new P(9,0,0,v());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(te[143],ie([0,1,41,17,3,2,46,128]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(v,I){const C=M.Event.fromNodeEventEmitter(S.validatedIpcMain,I,(m,P)=>({event:m,message:P})),d=M.Event.filter(C,({event:m})=>m.sender.id===v);return M.Event.map(d,({message:m})=>m&&t.VSBuffer.wrap(m))}class w extends D.IPCServer{static getOnDidClientConnect(){const I=M.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:C})=>C);return M.Event.map(I,C=>{const d=C.id;w.Clients.get(d)?.dispose();const P=new M.Emitter;w.Clients.set(d,(0,R.toDisposable)(()=>P.fire()));const b=u(d,"vscode:message"),p=M.Event.any(M.Event.signal(u(d,"vscode:disconnect")),P.event);return{protocol:new E.Protocol(C,b),onDidClientDisconnect:p}})}constructor(){super(w.getOnDidClientConnect())}}e.Server=w,w.Clients=new Map}),define(te[102],ie([0,1,41,3,30,142]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(w,v){super({addEventListener:(I,C)=>w.addListener(I,C),removeEventListener:(I,C)=>w.removeListener(I,C),postMessage:I=>w.postMessage(I),start:()=>w.start(),close:()=>w.close()},v)}}e.Client=D;async function E(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,M.generateUuid)();u.webContents.send("vscode:createMessageChannel",w);const v=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(C,d)=>({nonce:d,port:C.ports[0]})),{port:I}=await t.Event.toPromise(t.Event.once(t.Event.filter(v,C=>C.nonce===w)));return I}e.connect=E}),define(te[144],ie([0,1,45,8,17,23,137,16,3,2,50,82,78,46]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(p){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",y=>M.VSBuffer.wrap(Buffer.from(y,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=m;class P{constructor(p,y){this.modulePath=p,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new t.Delayer(h),this.child=null,this._client=null}getChannel(p){const y=this;return{call(h,g,l){return y.requestPromise(p,h,g,l)},listen(h,g){return y.requestEvent(p,h,g)}}}requestPromise(p,y,h,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(n=>l.call(y,h,n)),a=g.onCancellationRequested(()=>i.cancel()),r=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,y,h){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let g;const l=new u.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(y,h)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,C.removeDangerousEnvVariables)(y.env),this.child=(0,S.fork)(this.modulePath,p,y);const h=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}h.fire(M.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),a=h.event,r={send:i,onMessage:a};this._client=new d.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,w.dispose)(o)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(p){let y=this.channels.get(p);return y||(y=this.client.getChannel(p),this.channels.set(p,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(te[83],ie([0,1,17,16,3,2,9,4,30,46,101]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class C{traceSocketEvent(o,f){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,f)}constructor(o,f=""){this._canWrite=!0,this.debugLabel=f,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,t.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener),this._closeListener=k=>{this.traceSocketEvent("close",{hadError:k}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const f=k=>{this.traceSocketEvent("read",k),o(S.VSBuffer.wrap(k))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(o){const f=k=>{o({type:0,hadError:k,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(o){const f=()=>{o()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=C;var d;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var m;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(m||(m={}));class P extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,f){this.socket.traceSocketEvent(o,f)}constructor(o,f,k,T){super(),this._onData=this._register(new M.Emitter),this._onClose=this._register(new M.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:k?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new b(this,f,k,T,this._onData,(_,G)=>this._write(_,G))),this._register(this._flowManager.onError(_=>{console.error(_),(0,t.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,f){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let k=2;o.byteLength<126?k+=0:o.byteLength<2**16?k+=2:k+=8;const T=S.VSBuffer.alloc(k);if(f?T.writeUInt8(194,0):T.writeUInt8(130,0),o.byteLength<126)T.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(o.byteLength>>>8&255,++_),T.writeUInt8(o.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(o.byteLength>>>24&255,++_),T.writeUInt8(o.byteLength>>>16&255,++_),T.writeUInt8(o.byteLength>>>8&255,++_),T.writeUInt8(o.byteLength>>>0&255,++_)}this.socket.write(S.VSBuffer.concat([T,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),k=f.readUInt8(0),T=(k&128)>>>7,_=(k&64)>>>6,G=f.readUInt8(1),ae=(G&128)>>>7,X=G&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),k=f.readUInt8(1),T=(k&128)>>>7;let _=k&127,G=1;_===126?_=f.readUInt8(++G)*2**8+f.readUInt8(++G):_===127&&(_=f.readUInt8(++G)*0+f.readUInt8(++G)*0+f.readUInt8(++G)*0+f.readUInt8(++G)*0+f.readUInt8(++G)*2**24+f.readUInt8(++G)*2**16+f.readUInt8(++G)*2**8+f.readUInt8(++G));let ae=0;T&&(ae=f.readUInt8(++G)*2**24+f.readUInt8(++G)*2**16+f.readUInt8(++G)*2**8+f.readUInt8(++G)),this._state.state=3,this._state.readLen=_,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),h(f,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(f,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await M.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class b extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}constructor(o,f,k,T,_,G){super(),this._tracer=o,this._onData=_,this._writeFn=G,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new M.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,f?(this._zlibInflateStream=this._register(new p(this._tracer,T,k,{windowBits:15})),this._zlibDeflateStream=this._register(new y(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const f=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(f,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,f){return new Promise((k,T)=>{o.write(f),o.flush(_=>k(_))})}acceptFrame(o,f,k){this._readQueue.push({data:o,isCompressed:f,isLastFrameOfMessage:k}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const f=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(f)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,f,k){return new Promise((T,_)=>{o.write(f),k&&o.write(S.VSBuffer.fromByteArray([0,0,255,255])),o.flush(G=>T(G))})}}class p extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}constructor(o,f,k,T){super(),this._tracer=o,this._recordInflateBytes=f,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(T),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(S.VSBuffer.wrap(_))}),k&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this._zlibInflate.write(k.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const f=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(f)})}}class y extends R.Disposable{constructor(o,f){super(),this._tracer=o,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibDeflate.on("data",k=>{this._tracer.traceSocketEvent("zlibDeflateData",k),this._pendingDeflateData.push(S.VSBuffer.wrap(k))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let f=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.byteLength-4),o(f)})}}function h(c,o){if(o===0)return;const f=c.byteLength>>>2;for(let X=0;X<f;X++){const Q=c.readUInt32BE(X*4);c.writeUInt32BE(Q^o,X*4)}const k=f*4,T=c.byteLength-k,_=o>>>24&255,G=o>>>16&255,ae=o>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(k)^_,k),T>=2&&c.writeUInt8(c.readUInt8(k+1)^G,k+1),T>=3&&c.writeUInt8(c.readUInt8(k+2)^ae,k+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function l(){const c=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,D.join)(I().os.tmpdir(),`vscode-ipc-${c}.sock`),a(o),o}e.createRandomIPCHandle=l;function i(c,o,f){const k=I().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${f}-${o}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${k.substr(0,8)}-${f}-${o}.sock`):T=(0,D.join)(c,`${f}-${o}.sock`),a(T),T}e.createStaticIPCHandle=i;function a(c){const o=g[E.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class r extends w.IPCServer{static toClientConnectionEvent(o){const f=M.Event.fromNodeEventEmitter(o,"connection");return M.Event.map(f,k=>({protocol:new v.Protocol(new C(k,"ipc-server-connection")),onDidClientDisconnect:M.Event.once(M.Event.fromNodeEventEmitter(k,"close"))}))}constructor(o){super(r.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(c){return new Promise((o,f)=>{const k=I().net.createServer();k.on("error",f),k.listen(c,()=>{k.removeListener("error",f),o(new r(k))})})}e.serve=n;function s(c,o){return new Promise((f,k)=>{const T=I().net.createConnection(c,()=>{T.removeListener("error",k),f(v.Client.fromSocket(new C(T,`ipc-client${o}`),o))});T.once("error",k)})}e.connect=s}),define(te[103],ie([0,1,8,3,2,12]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function E(I){const C=I;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var u;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class w extends M.Disposable{constructor(C,d=Object.create(null)){super(),this.database=C,this.options=d,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((d,m)=>this.accept(m,d)),C.deleted?.forEach(d=>this.accept(d,void 0))}accept(C,d){if(this.state===u.Closed)return;let m=!1;(0,R.isUndefinedOrNull)(d)?m=this.cache.delete(C):this.cache.get(C)!==d&&(this.cache.set(C,d),m=!0),m&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,d){const m=this.cache.get(C);return(0,R.isUndefinedOrNull)(m)?d:m}getBoolean(C,d){const m=this.get(C);return(0,R.isUndefinedOrNull)(m)?d:m==="true"}getNumber(C,d){const m=this.get(C);return(0,R.isUndefinedOrNull)(m)?d:parseInt(m,10)}async set(C,d){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(C);const m=String(d);if(this.cache.get(C)!==m)return this.cache.set(C,m),this.pendingInserts.set(C,m),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===u.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((d,m)=>this.items.set(m,d)),C.delete?.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=v}),define(te[145],ie([0,1,8,3,29,9,21]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{get onDidChangeItemsExternal(){return t.Event.None}constructor(v,I=Object.create(null)){this.path=v,this.options=I,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,I=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(d=>I.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(v){const I=await this.whenConnected;return this.doUpdateItems(I,v)}doUpdateItems(v,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,M.mapToString)(I.insert):"0"}), delete(${I.delete?(0,M.setToString)(I.delete):"0"})`),this.transaction(v,()=>{const C=I.insert,d=I.delete;if(C&&C.size>0){const m=[];m.push([]);let P=0;C.forEach((b,p)=>{let y=m[P];y.length>E.MAX_HOST_PARAMETERS&&(P++,y=[],m.push(y)),y.push(p,b)}),m.forEach(b=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let y=0;return C.forEach((h,g)=>{p.push(g),y+=h.length}),`Keys: ${p.join(", ")} Length: ${y}`})})}if(d&&d.size){const m=[];m.push([]);let P=0;d.forEach(b=>{let p=m[P];p.length>E.MAX_HOST_PARAMETERS&&(P++,p=[],m.push(p)),p.push(b)}),m.forEach(b=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return d.forEach(y=>{p.push(y)}),`Keys: ${p.join(", ")}`})})}})}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,v)}doClose(v,I){return new Promise((C,d)=>{v.db.close(m=>(m&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${m}`),this.path===E.IN_MEMORY_PATH?C():!v.isErroneous&&!v.isInMemory?this.backup().then(C,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),C())):typeof I=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const b=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:I()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(C,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return D.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const I=await this.whenConnected,C=await this.get(I,v?"PRAGMA integrity_check":"PRAGMA quick_check"),d=v?C.integrity_check:C.quick_check;return I.isErroneous?`${d} (last error: ${I.lastError})`:I.isInMemory?`${d} (in-memory!)`:d}async connect(v,I=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${I})`);try{return await this.doConnect(v)}catch(C){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${C}`),C.code==="SQLITE_BUSY"&&I)return await(0,S.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await D.Promises.unlink(v);try{await D.Promises.rename(this.toBackupPath(v),v)}catch{}return await this.doConnect(v)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(v,I){v.isErroneous=!0,v.lastError=I,this.logger.error(I)}doConnect(v){return new Promise((I,C)=>{new Promise((d,m)=>{z(["@vscode/sqlite3"],d,m)}).then(d=>{const m={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(v,P=>P?m.db&&P.code!=="SQLITE_CANTOPEN"?m.db.close(()=>C(P)):C(P):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(m),b=>m.db.close(()=>C(b)))),isInMemory:v===E.IN_MEMORY_PATH};m.db.on("error",P=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&m.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},C)})}exec(v,I){return new Promise((C,d)=>{v.db.exec(I,m=>m?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${m}`),d(m)):C())})}get(v,I){return new Promise((C,d)=>{v.db.get(I,(m,P)=>m?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${m}`),d(m)):C(P))})}all(v,I){return new Promise((C,d)=>{v.db.all(I,(m,P)=>m?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${m}`),d(m)):C(P))})}transaction(v,I){return new Promise((C,d)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),I(),v.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${m}`),d(m)):C())})})}prepare(v,I,C,d){const m=v.db.prepare(I),P=b=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${d()}`)};m.on("error",P),C(m),m.finalize(b=>{b&&P(b),m.removeListener("error",P)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class u{constructor(v){v&&typeof v.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[146],ie([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(te[147],ie([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[148],ie([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[149],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(te[150],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(te[151],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[152],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[153],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[154],ie([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[155],ie([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[156],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(te[157],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(te[158],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(te[159],ie([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[160],ie([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[161],ie([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[162],ie([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[163],ie([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[164],ie([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(te[165],ie([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(te[166],ie([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[167],ie([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(te[168],ie([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[169],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[170],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[171],ie([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(te[172],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[173],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[174],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[175],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function M(D){let E=[];try{Array.isArray(D.workspaces)&&(E=D.workspaces.map(u=>({workspace:{id:u.id,configPath:S.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return E}e.deserializeWorkspaceInfos=M;function R(D){let E=[];try{Array.isArray(D.folders)&&(E=D.folders.map(u=>({folderUri:S.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return E}e.deserializeFolderInfos=R}),define(te[176],ie([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(E,u,w){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(E,u,w){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(E){super(),this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,u,w){this.channel.call("attach",[E,u,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,u){this.channel.call("terminate",[E,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,u){return this.channel.call("openExtensionDevelopmentHostWindow",[E,u])}}e.ExtensionHostDebugChannelClient=R}),define(te[177],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(M){this.machineId=M}encryption(){return new Promise((M,R)=>z(["vscode-encrypt"],M,R))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch{return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch{return M}}}e.EncryptionMainService=S}),define(te[178],ie([0,1,131,53,14,9,34,18,7]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,R.dirname)(M.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,R.resolve)(P):(0,R.normalize)((0,R.join)(M.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,R.resolve)(P):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,R.resolve)(P);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,R.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(P=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(P))}get extensionLogLevel(){const P=[];for(const b of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);p&&p[1]&&p[2]&&P.push([p[1],p[2]])}return P.length?P:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,b,p){this._args=P,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}}we([t.memoize],w.prototype,"appRoot",null),we([t.memoize],w.prototype,"userHome",null),we([t.memoize],w.prototype,"userDataPath",null),we([t.memoize],w.prototype,"appSettingsHome",null),we([t.memoize],w.prototype,"tmpDir",null),we([t.memoize],w.prototype,"cacheHome",null),we([t.memoize],w.prototype,"stateResource",null),we([t.memoize],w.prototype,"userRoamingDataHome",null),we([t.memoize],w.prototype,"userDataSyncHome",null),we([t.memoize],w.prototype,"userDataSyncLogResource",null),we([t.memoize],w.prototype,"editSessionsLogResource",null),we([t.memoize],w.prototype,"sync",null),we([t.memoize],w.prototype,"machineSettingsResource",null),we([t.memoize],w.prototype,"workspaceStorageHome",null),we([t.memoize],w.prototype,"localHistoryHome",null),we([t.memoize],w.prototype,"keyboardLayoutResource",null),we([t.memoize],w.prototype,"argvResource",null),we([t.memoize],w.prototype,"isExtensionDevelopment",null),we([t.memoize],w.prototype,"untitledWorkspacesHome",null),we([t.memoize],w.prototype,"installSourcePath",null),we([t.memoize],w.prototype,"builtinExtensionsPath",null),we([t.memoize],w.prototype,"extensionsPath",null),we([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),we([t.memoize],w.prototype,"extensionDevelopmentKind",null),we([t.memoize],w.prototype,"extensionTestsLocationURI",null),we([t.memoize],w.prototype,"debugExtensionHost",null),we([t.memoize],w.prototype,"logLevel",null),we([t.memoize],w.prototype,"extensionLogLevel",null),we([t.memoize],w.prototype,"serviceMachineIdResource",null),we([t.memoize],w.prototype,"telemetryLogResource",null),we([t.memoize],w.prototype,"disableWorkspaceTrust",null),we([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function v(m,P){return d(m["inspect-extensions"],m["inspect-brk-extensions"],5870,P,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=v;function I(m,P){return d(m["inspect-search"],m["inspect-brk-search"],5876,P,m.extensionEnvironment)}e.parseSearchPort=I;function C(m,P){return d(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,P,m.extensionEnvironment)}e.parsePtyHostPort=C;function d(m,P,b,p,y,h){const l=Number(P||m)||(p?null:b),i=l?Boolean(!!P):!1;let a;if(h)try{a=JSON.parse(h)}catch{}return{port:l,break:i,debugId:y,env:a}}}),define(te[104],ie([0,1,276,4,149]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,M.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,M.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,M.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,M.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(17,null)},category:{type:"string",cat:"e",description:(0,M.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,M.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,M.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,M.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,M.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,M.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,M.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,M.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,M.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,M.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,M.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(P,b,p=D){const y=P.find(c=>c.length>0&&c[0]!=="-"),h={},g=["_"],l=[],i={};let a;for(const c in b){const o=b[c];o.type==="subcommand"?c===y&&(a=o):(o.alias&&(h[c]=o.alias),o.type==="string"||o.type==="string[]"?(g.push(c),o.deprecates&&g.push(...o.deprecates)):o.type==="boolean"&&(l.push(c),o.deprecates&&l.push(...o.deprecates)),o.global&&(i[c]=o))}if(a&&y){const c=i;for(const T in a.options)c[T]=a.options[T];const o=P.filter(T=>T!==y),f=p.getSubcommandReporter?p.getSubcommandReporter(y):void 0,k=E(o,c,f);return{[y]:k}}const r=S(P,{string:g,boolean:l,alias:h}),n={},s=r;n._=r._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in b){const o=b[c];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let f=s[c];if(o.deprecates)for(const k of o.deprecates)s.hasOwnProperty(k)&&(f||(f=s[k],f&&p.onDeprecatedOption(k,o.deprecationMessage||(0,M.localize)(36,null,c))),delete s[k]);if(typeof f<"u"){if(o.type==="string[]"){if(Array.isArray(f)||(f=[f]),!o.allowEmptyValue){const k=f.filter(T=>T.length>0);k.length!==f.length&&(p.onEmptyValue(c),f=k.length>0?k:void 0)}}else o.type==="string"&&(Array.isArray(f)?(f=f.pop(),p.onMultipleValues(c,f)):!f&&!o.allowEmptyValue&&(p.onEmptyValue(c),f=void 0));n[c]=f,o.deprecationMessage&&p.onDeprecatedOption(c,o.deprecationMessage)}delete s[c]}for(const c in s)p.onUnknownOption(c);return n}e.parseArgs=E;function u(P,b){let p="";return b.args&&(Array.isArray(b.args)?p=` <${b.args.join("> <")}>`:p=` <${b.args}>`),b.alias?`-${b.alias} --${P}${p}`:`--${P}${p}`}function w(P,b){const p=[];for(const y in P){const h=P[y],g=u(y,h);p.push([g,h.description])}return v(p,b)}e.formatOptions=w;function v(P,b){const y=P.reduce((l,i)=>Math.max(l,i[0].length),12)+2+1;if(b-y<25)return P.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const h=b-y-1,g=[];for(const l of P){const i=l[0],a=C(l[1],h),r=I(y-i.length-2);g.push("  "+i+r+a[0]);for(let n=1;n<a.length;n++)g.push(I(y)+a[n])}return g}function I(P){return" ".repeat(P)}function C(P,b){const p=[];for(;P.length;){const y=P.length<b?P.length:P.lastIndexOf(" ",b),h=P.slice(0,y).trim();P=P.slice(y),p.push(h)}return p}function d(P,b,p,y,h){const g=process.stdout.isTTY&&process.stdout.columns||80,l=h?.noInputFiles!==!0?`[${(0,M.localize)(37,null)}...]`:"",i=[`${P} ${p}`];i.push(""),i.push(`${(0,M.localize)(38,null)}: ${b} [${(0,M.localize)(39,null)}]${l}`),i.push(""),h?.noPipe!==!0&&(t.isWindows?i.push((0,M.localize)(40,null,b)):i.push((0,M.localize)(41,null,b)),i.push(""));const a={},r=[];for(const n in y){const s=y[n];if(s.type==="subcommand")s.description&&r.push({command:n,description:s.description});else if(s.description&&s.cat){let c=a[s.cat];c||(a[s.cat]=c={}),c[n]=s}}for(const n in a){const s=n,c=a[s];c&&(i.push(R[s]),i.push(...w(c,g)),i.push(""))}return r.length&&(i.push((0,M.localize)(42,null)),i.push(...v(r.map(n=>[n.command,n.description]),g)),i.push("")),i.join(`
`)}e.buildHelpMessage=d;function m(P,b){return`${P||(0,M.localize)(43,null)}
${b||(0,M.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(te[179],ie([0,1,77,176,104]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(E,u){super(),this.windowsMainService=E,this.userDataProfilesMainService=u}call(E,u,w){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(E,u,w)}async openExtensionDevelopmentHostWindow(E,u){const w=(0,M.parseArgs)(E,M.OPTIONS);w.debugRenderer=u;const v=w.extensionDevelopmentPath;if(!v)return{success:!1};const[I]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:w,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(w)});if(!u)return{success:!0};const C=I.win;if(!C)return{success:!0};const d=C.webContents.debugger;let m=d.isAttached()?1/0:0;const P=(0,S.createServer)(b=>{m++===0&&d.attach();let p=!1;const y=l=>{p||b.write(JSON.stringify(l)+"\0")},h=(l,i,a,r)=>y({method:i,params:a,sessionId:r});C.on("close",()=>{d.removeListener("message",h),b.end(),p=!0}),d.addListener("message",h);let g=Buffer.alloc(0);b.on("data",l=>{g=Buffer.concat([g,l]);for(let i=g.indexOf(0);i!==-1;i=g.indexOf(0)){let a;try{const r=g.slice(0,i).toString("utf8");g=g.slice(i+1),a=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(a.method,a.params,a.sessionId).then(r=>y({id:a.id,sessionId:a.sessionId,result:r})).catch(r=>y({id:a.id,sessionId:a.sessionId,error:{code:0,message:r.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{p=!0,--m===0&&d.detach()})});return await new Promise(b=>P.listen(0,b)),C.on("close",()=>P.close()),{rendererDebugPort:P.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(te[59],ie([0,1,277,150,104]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(C,d){const m=(g,l)=>{console.warn((0,t.localize)(0,null,g,l))},P=g=>{console.warn((0,t.localize)(1,null,g))},b=(g,l)=>{console.warn((0,t.localize)(2,null,g,l))},p=g=>({onUnknownOption:l=>{g!=="tunnel"&&console.warn((0,t.localize)(3,null,l,g))},onMultipleValues:m,onEmptyValue:P,onDeprecatedOption:b,getSubcommandReporter:g!=="tunnel"?p:void 0}),y={onUnknownOption:g=>{console.warn((0,t.localize)(4,null,g))},onMultipleValues:m,onEmptyValue:P,onDeprecatedOption:b,getSubcommandReporter:p},h=(0,M.parseArgs)(C,M.OPTIONS,d?y:void 0);return h.goto&&h._.forEach(g=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,t.localize)(5,null))),h["max-memory"]&&S(parseInt(h["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),h}function E(C){const d=C.findIndex(m=>!/^-/.test(m));if(d>-1)return[...C.slice(0,d),...C.slice(d+1)]}function u(C){let[,...d]=C;process.env.VSCODE_DEV&&(d=E(d)||[]);const m=!I(process.env);return D(d,m)}e.parseMainProcessArgv=u;function w(C){let[,,...d]=C;return process.env.VSCODE_DEV&&(d=E(d)||[]),D(d,!0)}e.parseCLIProcessArgv=w;function v(C,...d){const m=C.indexOf("--");return m===-1?C.push(...d):C.splice(m,0,...d),C}e.addArg=v;function I(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function z(e,S,t){function M(D,E){const u=R(D,E),w=[u];return e.isAbsolute(u)||w.unshift(t),e.resolve(...w)}function R(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,E);const v=D["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(I,"AppData","Roaming")}break;case"darwin":w=e.join(S.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,E)}return{getUserDataPath:M}}if(typeof define=="function")define(te[180],ie([181,25,34]),function(e,S,t){return z(e,S,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=z(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[182],ie([0,1,25,178,180]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(E,u){super(E,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,M.getUserDataPath)(E,u.nameShort)},u)}}e.NativeEnvironmentService=R}),define(te[183],ie([0,1,40,25,31]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const E=(0,M.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(E,""),D&&console.log(`Marker file for --wait created: ${E}`),E}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=R}),define(te[184],ie([0,1,12,152]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function M(D,E,u){try{R(D,E,u)}catch{}return D}e.localizeManifest=M;function R(D,E,u){const w=(v,I,C)=>{const d=v[I];if((0,S.isString)(d)){const m=d,P=m.length;if(P>1&&m[0]==="%"&&m[P-1]==="%"){const b=m.substr(1,P-2);let p=E[b];p===void 0&&u&&(p=u[b]);const y=typeof p=="string"?p:p.message;if(y!==void 0){const h=u?.[b],g=typeof h=="string"?h:h?.message;if(C&&(I==="title"||I==="category")&&g&&g!==y){const l={value:y,original:g};v[I]=l}else v[I]=y}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,b)}`)}}else if((0,S.isObject)(d))for(const m in d)d.hasOwnProperty(m)&&(m==="commands"?w(d,m,!0):w(d,m,C));else if(Array.isArray(d))for(let m=0;m<d.length;m++)w(d,m,C)};for(const v in D)D.hasOwnProperty(v)&&w(D,v)}}),define(te[185],ie([0,1,18,97,154,186]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=u;function w(p){if(!u(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=p.match(D);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=w;function v(p){if(!p)return null;const y=p.majorBase,h=p.majorMustEqual,g=p.minorBase;let l=p.minorMustEqual;const i=p.patchBase;let a=p.patchMustEqual;p.hasCaret&&(y===0||(l=!1),a=!1);let r=0;if(p.preRelease){const n=E.exec(p.preRelease);if(n){const[,s,c,o]=n;r=Date.UTC(Number(s),Number(c)-1,Number(o))}}return{majorBase:y,majorMustEqual:h,minorBase:g,minorMustEqual:l,patchBase:i,patchMustEqual:a,isMinimum:p.hasGreaterEquals,notBefore:r}}e.normalizeVersion=v;function I(p,y,h){let g;typeof p=="string"?g=v(w(p)):g=p;let l;y instanceof Date?l=y.getTime():typeof y=="string"&&(l=new Date(y).getTime());let i;if(typeof h=="string"?i=v(w(h)):i=h,!g||!i)return!1;const a=g.majorBase,r=g.minorBase,n=g.patchBase;let s=i.majorBase,c=i.minorBase,o=i.patchBase;const f=i.notBefore;let k=i.majorMustEqual,T=i.minorMustEqual,_=i.patchMustEqual;return i.isMinimum?a>s?!0:a<s?!1:r>c?!0:r<c||l&&l<f?!1:n>=o:(a===1&&s===0&&(!k||!T||!_)&&(s=1,c=0,o=0,k=!0,T=!1,_=!1),a<s?!1:a>s?!k:r<c?!1:r>c?!T:n<o?!1:n>o?!_:!(l&&l<f))}e.isValidVersion=I;function C(p,y,h,g,l){const i=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return i.push([t.default.Error,M.localize(0,null)]),i;if(typeof g.name!="string")return i.push([t.default.Error,M.localize(1,null,"name")]),i;if(typeof g.version!="string")return i.push([t.default.Error,M.localize(2,null,"version")]),i;if(!g.engines)return i.push([t.default.Error,M.localize(3,null,"engines")]),i;if(typeof g.engines.vscode!="string")return i.push([t.default.Error,M.localize(4,null,"engines.vscode")]),i;if(typeof g.extensionDependencies<"u"&&!b(g.extensionDependencies))return i.push([t.default.Error,M.localize(5,null,"extensionDependencies")]),i;if(typeof g.activationEvents<"u"){if(!b(g.activationEvents))return i.push([t.default.Error,M.localize(6,null,"activationEvents")]),i;if(typeof g.main>"u"&&typeof g.browser>"u")return i.push([t.default.Error,M.localize(7,null,"activationEvents","main")]),i}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&i.push([t.default.Warning,M.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return i.push([t.default.Error,M.localize(9,null,"main")]),i;{const n=(0,S.joinPath)(h,g.main);(0,S.isEqualOrParent)(n,h)||i.push([t.default.Warning,M.localize(10,null,n.path,h.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,M.localize(11,null,"activationEvents","main")]),i}if(typeof g.browser<"u"){if(typeof g.browser!="string")return i.push([t.default.Error,M.localize(12,null,"browser")]),i;{const n=(0,S.joinPath)(h,g.browser);(0,S.isEqualOrParent)(n,h)||i.push([t.default.Warning,M.localize(13,null,n.path,h.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,M.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(g.version))return i.push([t.default.Error,M.localize(15,null)]),i;const a=[];if(!d(p,y,g,l,a))for(const n of a)i.push([t.default.Error,n]);return i}e.validateExtensionManifest=C;function d(p,y,h,g,l){return g||typeof h.main>"u"&&typeof h.browser>"u"?!0:P(p,y,h.engines.vscode,l)}e.isValidExtensionVersion=d;function m(p,y,h){return p==="*"||P(y,h,p)}e.isEngineValid=m;function P(p,y,h,g=[]){const l=v(w(h));if(!l)return g.push(M.localize(16,null,h)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(M.localize(17,null,h)),!1}else if(!l.majorMustEqual)return g.push(M.localize(18,null,h)),!1;return I(p,y,l)?!0:(g.push(M.localize(19,null,p,h)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let y=0,h=p.length;y<h;y++)if(typeof p[y]!="string")return!1;return!0}}),define(te[187],ie([0,1,17,30]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(R,D,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const v=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(v)?v:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=M}),define(te[68],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(M,R=[],D=!1){this.ctor=M,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=S}),define(te[188],ie([0,1,68]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var M;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(M=e.InstantiationType||(e.InstantiationType={}));function R(E,u,w){u instanceof S.SyncDescriptor||(u=new S.SyncDescriptor(u,[],Boolean(w))),t.push([E,u])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(te[189],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const E=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const E of this._nodes.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let E=this._nodes.get(D);return E||(E=new S(D,R),this._nodes.set(D,E)),E}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,E]of this._nodes)R.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const E=new Set([R]),u=this._findCycle(D,E);if(u)return u}}_findCycle(R,D){for(const[E,u]of R.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const w=this._findCycle(u,D);if(w)return w;D.delete(E)}}}e.Graph=t}),define(te[5],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function E(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=E})(S=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function t(D,E,u){E[S.DI_TARGET]===E?E[S.DI_DEPENDENCIES].push({id:D,index:u}):(E[S.DI_DEPENDENCIES]=[{id:D,index:u}],E[S.DI_TARGET]=E)}function M(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const E=function(u,w,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,u,v)};return E.toString=()=>D,S.serviceIds.set(D,E),E}e.createDecorator=M;function R(D){return D}e.refineServiceDecorator=R}),define(te[60],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(te[19],ie([0,1,12,7,5]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function w(p,y){const h=Object.create(null);for(const g in p)v(h,g,p[g],y);return h}e.toValuesTree=w;function v(p,y,h,g){const l=y.split("."),i=l.pop();let a=p;for(let r=0;r<l.length;r++){const n=l[r];let s=a[n];switch(typeof s){case"undefined":s=a[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${y} as ${l.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[i]=h}catch{g(`Ignoring ${y} as ${l.join(".")} is ${JSON.stringify(a)}`)}else g(`Ignoring ${y} as ${l.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=v;function I(p,y){const h=y.split(".");C(p,h)}e.removeFromValueTree=I;function C(p,y){const h=y.shift();if(y.length===0){delete p[h];return}if(Object.keys(p).indexOf(h)!==-1){const g=p[h];typeof g=="object"&&!Array.isArray(g)&&(C(g,y),Object.keys(g).length===0&&delete p[h])}}function d(p,y,h){function g(a,r){let n=a;for(const s of r){if(typeof n!="object"||n===null)return;n=n[s]}return n}const l=y.split("."),i=g(p,l);return typeof i>"u"?h:i}e.getConfigurationValue=d;function m(p,y,h){Object.keys(y).forEach(g=>{g!=="__proto__"&&(g in p?S.isObject(p[g])&&S.isObject(y[g])?m(p[g],y[g],h):h&&(p[g]=y[g]):p[g]=y[g])})}e.merge=m;function P(p,y,h){const g=p.inspect(y),l=p.inspect(h);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:g.defaultValue}e.getMigratedSettingValue=P;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(te[69],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,E){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=E}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const E of Object.keys(this.secretVault[R]||{}))D.push({account:E,password:this.secretVault[R][E]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(te[84],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class M{async getPerformanceInfo(D,E){return{}}async getSystemInfo(D,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,E){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=M}),define(te[105],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(te[36],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ie([0,1,53,9,83,36,182,5]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([S.memoize],u.prototype,"cachedLanguagesPath",null),we([S.memoize],u.prototype,"backupHome",null),we([S.memoize],u.prototype,"mainIPCHandle",null),we([S.memoize],u.prototype,"mainLockfile",null),we([S.memoize],u.prototype,"disableUpdates",null),we([S.memoize],u.prototype,"disableKeytar",null),we([S.memoize],u.prototype,"crossOriginIsolated",null),we([S.memoize],u.prototype,"codeCachePath",null),we([S.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(te[190],ie([0,1,151,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function M(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=M;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,y){switch(p){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function E(p,y){return y==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function u(p,y,h){return E(y,h)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===h?!0:w(h).includes(p)}e.isTargetPlatformCompatible=u;function w(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=v;var I;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var C;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var P;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(y,h){super(y),this.code=h,this.name=h}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[191],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(te[192],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[106],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(te[193],ie([0,1,45,14,9,4,78,21,82,155,106]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=w.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await P.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends C{openTerminal(g,l){return this.spawnTerminal(S,g,u.getWindowsShell(),l)}spawnTerminal(g,l,i,a){const r=l.windowsExec||d.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const n=M.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return g.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(n==="wt"||n==="wt.exe")&&s.push("-d ."),new Promise((c,o)=>{const f=b(process),k=g.spawn(i,s,{cwd:a,env:f});k.on("error",o),k.on("exit",()=>c())})}runInTerminal(g,l,i,a,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((s,c)=>{const o=`"${l} - ${I}"`,f=`""${i.join('" "')}" & pause"`,k=["/c","start",o,"/wait",n,"/c",f],T=Object.assign({},b(process),a);Object.keys(T).filter(ae=>T[ae]===null).forEach(ae=>delete T[ae]);const _={cwd:l,env:T,windowsVerbatimArguments:!0};S.spawn(d.CMD,k,_).on("error",ae=>{c(p(ae))}),s(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d,d.CMD="cmd.exe";class m extends C{openTerminal(g,l){return this.spawnTerminal(S,g,l)}runInTerminal(g,l,i,a,r){const n=r.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(n===v.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const o=n===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,z).fsPath,"-t",g||I,"-w",l];for(const G of i)k.push("-a"),k.push(G);if(a){const G=Object.assign({},b(process),a);for(const ae in G){const X=G[ae];X===null?(k.push("-u"),k.push(ae)):(k.push("-e"),k.push(`${ae}=${X}`))}}let T="";const _=S.spawn(m.OSASCRIPT,k);_.on("error",G=>{c(p(G))}),_.stderr.on("data",G=>{T+=G.toString()}),_.on("exit",G=>{if(G===0)s(void 0);else if(T){const ae=T.split(`
`,1);c(new Error(ae[0]))}else c(new Error(w.localize(1,null,o,G)))})}else c(new Error(w.localize(2,null,n)))})}spawnTerminal(g,l,i){const a=l.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const s=["-a",a];i&&s.push(i);const c=b(process),o=g.spawn("/usr/bin/open",s,{cwd:i,env:c});o.on("error",n),o.on("exit",()=>r())})}}e.MacExternalTerminalService=m,m.OSASCRIPT="/usr/bin/osascript";class P extends C{openTerminal(g,l){return this.spawnTerminal(S,g,l)}runInTerminal(g,l,i,a,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const o=[];n.then(f=>{f.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const k=`${y(i)}; echo; read -p "${P.WAIT_MESSAGE}" -n1;`;o.push(`''${k}''`);const T=Object.assign({},b(process),a);Object.keys(T).filter(X=>T[X]===null).forEach(X=>delete T[X]);const _={cwd:l,env:T};let G="";const ae=S.spawn(f,o,_);ae.on("error",X=>{c(p(X))}),ae.stderr.on("data",X=>{G+=X.toString()}),ae.on("exit",X=>{if(X===0)s(void 0);else if(G){const Q=G.split(`
`,1);c(new Error(Q[0]))}else c(new Error(w.localize(4,null,f,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!P._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)P._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await E.Promises.exists("/etc/debian_version");P._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{g?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return P._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,l,i){const a=l.linuxExec?Promise.resolve(l.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{a.then(s=>{const c=b(process),o=g.spawn(s,[],{cwd:i,env:c});o.on("error",n),o.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=P,P.WAIT_MESSAGE=w.localize(3,null);function b(h){const g={...h.env};return(0,D.sanitizeProcessEnvironment)(g),g}function p(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function y(h){let g="";for(const l of h)l.indexOf(" ")>=0?g+='"'+l+'"':g+=l,g+=" ";return g}}),define(te[15],ie([0,1,29,9,26,12,7,157,5]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function w(V){return V.create===!0}e.isFileOpenForWriteOptions=w;var v;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var I;(function(V){V[V.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var C;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function m(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=m;function P(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=P;function b(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function y(V){return d(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var h;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(j,F){super(j),this.code=F}}e.FileSystemProviderError=g;function l(V,j){const F=new g(V.toString(),j);return a(F,j),F}e.createFileSystemProviderError=l;function i(V){return V||l((0,E.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=i;function a(V,j){return V.name=j?`${j} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=a;function r(V){if(!V)return h.Unknown;if(V instanceof g)return V.code;const j=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!j)return h.Unknown;switch(j[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=r;function n(V){if(V instanceof T)return V.fileOperationResult;switch(r(V)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(j,F,A){this.resource=j,this.operation=F,this.target=A}isOperation(j){return this.operation===j}}e.FileOperationEvent=c;var o;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class f{constructor(j,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const A=new Map;for(const W of j){const N=A.get(W.type);switch(N?N.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,N]of A)switch(W){case 1:this.added=S.TernarySearchTree.forUris(()=>F),this.added.fill(N);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>F),this.updated.fill(N);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>F),this.deleted.fill(N);break}}contains(j,...F){return this.doContains(j,{includeChildren:!1},...F)}affects(j,...F){return this.doContains(j,{includeChildren:!0},...F)}doContains(j,F,...A){if(!j)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get(j)||F.includeChildren&&this.added?.findSuperstr(j))||(!W||A.includes(0))&&(this.updated?.get(j)||F.includeChildren&&this.updated?.findSuperstr(j))||(!W||A.includes(2))&&(this.deleted?.findSubstr(j)||F.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function k(V,j,F){return!V||!j||V===j||j.length>V.length?!1:(j.charAt(j.length-1)!==t.sep&&(j+=t.sep),F?(0,M.startsWithIgnoreCase)(V,j):V.indexOf(j)===0)}e.isParent=k;class T extends Error{constructor(j,F,A){super(j),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class _ extends T{constructor(j,F,A){super(j,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=_;var G;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=X;async function Q(V,j){if(!j.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(F=>{const A=j.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===V.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class J{static formatSize(j){return(0,R.isNumber)(j)||(j=0),j<J.KB?(0,E.localize)(1,null,j.toFixed(0)):j<J.MB?(0,E.localize)(2,null,(j/J.KB).toFixed(2)):j<J.GB?(0,E.localize)(3,null,(j/J.MB).toFixed(2)):j<J.TB?(0,E.localize)(4,null,(j/J.GB).toFixed(2)):(0,E.localize)(5,null,(j/J.TB).toFixed(2))}}e.ByteSize=J,J.KB=1024,J.MB=J.KB*J.KB,J.GB=J.MB*J.KB,J.TB=J.GB*J.KB;var se;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*J.MB:16*J.GB,maxHeapSize:V===0?700*J.MB:2*700*J.MB}}e.getPlatformLimits=he}),define(te[194],ie([0,1,17,44,16,3,2,58,7,30,15]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends D.Disposable{constructor(d,m){super(),this.channel=d,this.extraCapabilities=m,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,m){const{buffer:P}=await this.channel.call("readFile",[d,m]);return P}readFileStream(d,m,P){const b=(0,E.newWriteableStream)(y=>S.VSBuffer.concat(y.map(h=>S.VSBuffer.wrap(h))).buffer),p=this.channel.listen("readFileStream",[d,m])(y=>{if(y instanceof S.VSBuffer)b.write(y.buffer);else{if(y==="end")b.end();else{let h=y;h instanceof Error||(h=(0,v.createFileSystemProviderError)((0,t.toErrorMessage)(h),v.FileSystemProviderErrorCode.Unknown)),b.error(h),b.end()}p.dispose()}});return P.onCancellationRequested(()=>{b.error((0,M.canceled)()),b.end(),p.dispose()}),b}writeFile(d,m,P){return this.channel.call("writeFile",[d,S.VSBuffer.wrap(m),P])}open(d,m){return this.channel.call("open",[d,m])}close(d){return this.channel.call("close",[d])}async read(d,m,P,b,p){const[y,h]=await this.channel.call("read",[d,m,p]);return P.set(y.buffer.slice(0,h),b),h}write(d,m,P,b,p){return this.channel.call("write",[d,m,S.VSBuffer.wrap(P),b,p])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,m){return this.channel.call("delete",[d,m])}rename(d,m,P){return this.channel.call("rename",[d,m,P])}copy(d,m,P){return this.channel.call("copy",[d,m,P])}cloneFile(d,m){return this.channel.call("cloneFile",[d,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const m=d;this._onDidChange.fire(m.map(P=>({resource:u.URI.revive(P.resource),type:P.type})))}else{const m=d;this._onDidWatchError.fire(m)}}))}watch(d,m){const P=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,P,d,m]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,P]))}}e.DiskFileSystemProviderClient=I}),define(te[107],ie([0,1,17,16,158,15]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(v,I,C,d,m,P){let b;try{await E(v,I,C,d,m,P)}catch(p){b=p}finally{b&&m.errorTransformer&&(b=m.errorTransformer(b)),typeof b<"u"&&C.error(b),C.end()}}e.readFileIntoStream=D;async function E(v,I,C,d,m,P){u(P);const b=await v.open(I,{create:!1});try{u(P);let p=0,y=0,h=m&&typeof m.length=="number"?m.length:void 0,g=S.VSBuffer.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),l=m&&typeof m.position=="number"?m.position:0,i=0;do y=await v.read(b,l,g.buffer,i,g.byteLength-i),l+=y,i+=y,p+=y,typeof h=="number"&&(h-=y),i===g.byteLength&&(await C.write(d(g)),g=S.VSBuffer.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),i=0);while(y>0&&(typeof h!="number"||h>0)&&u(P)&&w(p,m));if(i>0){let a=i;typeof h=="number"&&(a=Math.min(i,h)),C.write(d(g.slice(0,a)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await v.close(b)}}function u(v){if(v.isCancellationRequested)throw(0,t.canceled)();return!0}function w(v,I){if(I?.limits){if(typeof I.limits.memory=="number"&&v>I.limits.memory)throw(0,R.createFileSystemProviderError)((0,M.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&v>I.limits.size)throw(0,R.createFileSystemProviderError)((0,M.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[70],ie([0,1,98,2,9,4,7,15]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(p){return p.recursive===!0}e.isRecursiveWatchRequest=u;class w extends t.Disposable{constructor(y,h,g,l){super(),this.onFileChanges=y,this.onLogMessage=h,this.verboseLogging=g,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const y=new t.DisposableStore;this.watcherDisposables.value=y,this.watcher=this.createWatcher(y),this.watcher.setVerboseLogging(this.verboseLogging),y.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),y.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),y.add(this.watcher.onDidError(h=>this.onError(h)))}onError(y){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${y}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${y}`):this.error(y)}restart(y){this.restartCounter++,this.init(),this.watch(y)}async watch(y){this.requests=y,await this.watcher?.watch(y)}async setVerboseLogging(y){this.verboseLogging=y,await this.watcher?.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${y}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class v extends w{constructor(y,h,g){super(y,h,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class I extends w{constructor(y,h,g){super(y,h,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function C(p){return p.map(y=>({type:y.type,resource:D.URI.file(y.path)}))}e.toFileChanges=C;function d(p){const y=new b;for(const h of p)y.processEvent(h);return y.coalesce()}e.coalesceEvents=d;function m(p,y){return typeof y=="string"&&!y.startsWith(S.GLOBSTAR)&&!(0,M.isAbsolute)(y)?{base:p,pattern:y}:y}e.normalizeWatcherPattern=m;function P(p,y){const h=[];for(const g of y)h.push((0,S.parse)(m(p,g)));return h}e.parseWatcherPatterns=P;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(y){return R.isLinux?y.path:y.path.toLowerCase()}processEvent(y){const h=this.mapPathToChange.get(this.toKey(y));let g=!1;if(h){const l=h.type,i=y.type;h.path!==y.path&&(y.type===2||y.type===1)?g=!0:l===1&&i===2?(this.mapPathToChange.delete(this.toKey(y)),this.coalesced.delete(h)):l===2&&i===1?h.type=0:l===1&&i===0||(h.type=i)}else g=!0;g&&(this.coalesced.add(y),this.mapPathToChange.set(this.toKey(y),y))}coalesce(){const y=[],h=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(y.push(g),!1):!0).sort((g,l)=>g.path.length-l.path.length).filter(g=>h.some(l=>(0,E.isParent)(g.path,l,!R.isLinux))?!1:(h.push(g.path),!0)).concat(y)}}}),define(te[195],ie([0,1,40,8,23,31,2,80,9,4,99,21,70]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends D.Disposable{constructor(b,p,y,h){super(),this.request=b,this.onDidFilesChange=p,this.onLogMessage=y,this.verboseLogging=h,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new M.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await I.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await I.Promises.realpath(b.path),b.path===p&&(p=await(0,v.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(w.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const y=new M.CancellationTokenSource(this.cts.token),h=new D.DisposableStore;try{const g=(0,u.basename)(b),l=(0,S.watch)(b);h.add((0,D.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${b}'`);const i=new Set;if(p)try{for(const r of await I.Promises.readdir(b))i.add(r)}catch(r){this.error(r)}const a=new Map;h.add((0,D.toDisposable)(()=>{for(const[,r]of a)r.dispose();a.clear()})),l.on("error",(r,n)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${r}, ${n})`),this.dispose()}),l.on("change",(r,n)=>{if(y.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${n}`);let s="";if(n&&(s=n.toString(),w.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!(!s||r!=="change"&&r!=="rename"))if(p)if(r==="rename"){a.get(s)?.dispose();const c=setTimeout(async()=>{if(a.delete(s),s===g&&!await I.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,u.join)(b,s));if(y.token.isCancellationRequested)return;let f;o?i.has(s)?f=0:(f=1,i.add(s)):(i.delete(s),f=2),this.onFileChange({path:(0,u.join)(this.request.path,s),type:f})},d.FILE_DELETE_HANDLER_DELAY);a.set(s,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(s)?c=0:(c=1,i.add(s)),this.onFileChange({path:(0,u.join)(this.request.path,s),type:c})}else if(r==="rename"||s!==g){const c=setTimeout(async()=>{const o=await I.Promises.exists(b);y.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),h.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);h.clear(),h.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await I.Promises.exists(b)&&!y.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${g.toString()})`)}return(0,D.toDisposable)(()=>{y.dispose(!0),h.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(y=>y(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(y=>y(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const h=(0,C.coalesceEvents)(y);if(h.length>0){if(this.verboseLogging)for(const l of h)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(h)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(w.isLinux)return I.Promises.exists(b);try{const p=(0,u.basename)(b);return(await I.Promises.readdir((0,u.dirname)(b))).some(h=>h===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function m(P,b,p,y,h=512){const g=await I.Promises.open(P,"r"),l=Buffer.allocUnsafe(h),i=new M.CancellationTokenSource(y);let a,r=!1;const n={path:P,excludes:[],recursive:!1},s=new d(n,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await I.Promises.read(g,l,0,h,null);if(!f||i.token.isCancellationRequested)break;b(l.slice(0,f))}}catch(f){a=new Error(f),i.dispose(!0)}finally{r=!1}}})()});return await s.ready,p(),new Promise((c,o)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await I.Promises.close(g)}catch(f){a=new Error(f)}a?o(a):c()})})}e.watchFileContents=m}),define(te[196],ie([0,1,3,98,2,4,195]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends M.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const v=this.normalizeRequests(w),I=v.filter(d=>{const m=this.watchers.get(d.path);return m?!(0,t.patternsEquals)(m.request.excludes,d.excludes)||!(0,t.patternsEquals)(m.request.includes,d.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:d})=>!v.find(m=>m.path===d.path&&(0,t.patternsEquals)(m.excludes,d.excludes)&&(0,t.patternsEquals)(m.includes,d.includes))).map(({request:d})=>d.path);I.length&&this.trace(`Request to start watching: ${I.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const d of C)this.stopWatching(d);for(const d of I)this.startWatching(d)}startWatching(w){const v=new D.NodeJSFileWatcherLibrary(w,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),I={request:w,instance:v};this.watchers.set(w.path,I)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const v=this.watchers.get(w);v&&(this.watchers.delete(w),v.instance.dispose())}normalizeRequests(w){const v=new Map;for(const I of w){const C=R.isLinux?I.path:I.path.toLowerCase();v.set(C,I)}return Array.from(v.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,v]of this.watchers)v.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,v){return v?`[File Watcher (node.js)] ${w} (path: ${v.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=E}),define(te[197],ie([0,1,70,196]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class M extends S.AbstractNonRecursiveWatcherClient{constructor(D,E,u){super(D,E,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=M}),define(te[198],ie([0,1,14,46,144,70]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,w,v){super(u,w,v),this.init()}createWatcher(u){const w=u.add(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(w.onDidProcessExit(({code:v,signal:I})=>this.onError(`terminated by itself with code ${v}, signal: ${I}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(te[85],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...M){this._entries=new Map;for(const[R,D]of M)this.set(R,D)}set(M,R){const D=this._entries.get(M);return this._entries.set(M,R),D}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=S}),define(te[199],ie([0,1,8,16,2,68,189,5,85,94]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class I extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class C{constructor(b=new u.ServiceCollection,p=!1,y,h=v){this._services=b,this._strict=p,this._parent=y,this._enableTracing=h,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=h?y?._globalGraph??new D.Graph(g=>g):void 0}createChild(b){return new C(b,this._strict,this,this._enableTracing)}invokeFunction(b,...p){const y=m.traceInvocation(this._enableTracing,b);let h=!1;try{return b({get:l=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(l,y);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...p)}finally{h=!0,y.stop()}}createInstance(b,...p){let y,h;return b instanceof R.SyncDescriptor?(y=m.traceCreation(this._enableTracing,b.ctor),h=this._createInstance(b.ctor,b.staticArguments.concat(p),y)):(y=m.traceCreation(this._enableTracing,b),h=this._createInstance(b,p,y)),y.stop(),h}_createInstance(b,p=[],y){const h=E._util.getServiceDependencies(b).sort((i,a)=>i.index-a.index),g=[];for(const i of h){const a=this._getOrCreateServiceInstance(i.id,y);a||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),g.push(a)}const l=h.length>0?h[0].index:p.length;if(p.length!==l){console.trace(`[createInstance] First service dependency of ${b.name} at position ${l+1} conflicts with ${p.length} static arguments`);const i=l-p.length;i>0?p=p.concat(new Array(i)):p=p.slice(0,l)}return Reflect.construct(b,p.concat(g))}_setServiceInstance(b,p){if(this._services.get(b)instanceof R.SyncDescriptor)this._services.set(b,p);else if(this._parent)this._parent._setServiceInstance(b,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){const p=this._services.get(b);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):p}_getOrCreateServiceInstance(b,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(b));const y=this._getServiceInstanceOrDescriptor(b);return y instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,y,p.branch(b,!0)):(p.branch(b,!1),y)}_safeCreateAndCacheServiceInstance(b,p,y){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,p,y)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,p,y){const h=new D.Graph(i=>i.id.toString());let g=0;const l=[{id:b,desc:p,_trace:y}];for(;l.length;){const i=l.pop();if(h.lookupOrInsertNode(i),g++>1e3)throw new I(h);for(const a of E._util.getServiceDependencies(i.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(a.id);if(r||this._throwIfStrict(`[createInstance] ${b} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),r instanceof R.SyncDescriptor){const n={id:a.id,desc:r,_trace:i._trace.branch(a.id,!0)};h.insertEdge(i,n),l.push(n)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new I(h);break}for(const{data:a}of i){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const n=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,n)}h.removeNode(a)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,p,y=[],h,g){if(this._services.get(b)instanceof R.SyncDescriptor)return this._createServiceInstance(b,p,y,h,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,p,y,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(b,p,y=[],h,g){if(h){const l=new C(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(b);const i=new Map,a=new S.IdleValue(()=>{const r=l._createInstance(p,y,g);for(const[n,s]of i){const c=r[n];if(typeof c=="function")for(const o of s)c.apply(r,o)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=i.get(n);return o||(o=new w.LinkedList,i.set(n,o)),(k,T,_)=>{const G=o.push([k,T,_]);return(0,M.toDisposable)(G)}}if(n in r)return r[n];const s=a.value;let c=s[n];return typeof c!="function"||(c=c.bind(s),r[n]=c),c},set(r,n,s){return a.value[n]=s,!0}})}else return this._createInstance(p,y,g)}_throwIfStrict(b,p){if(p&&console.warn(b),this._strict)throw new Error(b)}}e.InstantiationService=C;var d;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(d||(d={}));class m{static traceInvocation(b,p){return b?new m(1,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(b,p){return b?new m(0,p.name):m._None}constructor(b,p){this.type=b,this.name=p,this._start=Date.now(),this._dep=[]}branch(b,p){const y=new m(2,b.toString());return this._dep.push([b,p,y]),y}stop(){const b=Date.now()-this._start;m._totals+=b;let p=!1;function y(g,l){const i=[],a=new Array(g+1).join("	");for(const[r,n,s]of l._dep)if(n&&s){p=!0,i.push(`${a}CREATES -> ${r}`);const c=y(g+1,s);c&&i.push(c)}else i.push(`${a}uses -> ${r}`);return i.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(b>2||p)&&m.all.add(h.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(te[6],ie([0,1,44,3,2,29,4,7,5]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function w(){return new Date().toISOString()}var v;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function I(c,o,f){switch(o){case v.Trace:c.trace(f);break;case v.Debug:c.debug(f);break;case v.Info:c.info(f);break;case v.Warning:c.warn(f);break;case v.Error:c.error(f);break;case v.Critical:c.critical(f);break;default:throw new Error("Invalid log level")}}e.log=I;function C(c){let o="";for(let f=0;f<c.length;f++){let k=c[f];if(typeof k=="object")try{k=JSON.stringify(k)}catch{}o+=(f>0?" ":"")+k}return o}e.format=C;class d extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class m extends d{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...f){this.checkLogLevel(v.Trace)&&this.log(v.Trace,C([o,...f]))}debug(o,...f){this.checkLogLevel(v.Debug)&&this.log(v.Debug,C([o,...f]))}info(o,...f){this.checkLogLevel(v.Info)&&this.log(v.Info,C([o,...f]))}warn(o,...f){this.checkLogLevel(v.Warning)&&this.log(v.Warning,C([o,...f]))}error(o,...f){if(this.checkLogLevel(v.Error))if(o instanceof Error){const k=Array.prototype.slice.call(arguments);k[0]=o.stack,this.log(v.Error,C(k))}else this.log(v.Error,C([o,...f]))}critical(o,...f){this.checkLogLevel(v.Critical)&&this.log(v.Critical,C([o,...f]))}flush(){}}e.AbstractMessageLogger=m;class P extends d{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!D.isWindows}trace(o,...f){this.getLevel()<=v.Trace&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...f):console.log(`[main ${w()}]`,o,...f))}debug(o,...f){this.getLevel()<=v.Debug&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...f):console.log(`[main ${w()}]`,o,...f))}info(o,...f){this.getLevel()<=v.Info&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...f):console.log(`[main ${w()}]`,o,...f))}warn(o,...f){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,o,...f):console.warn(`[main ${w()}]`,o,...f))}error(o,...f){this.getLevel()<=v.Error&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,o,...f):console.error(`[main ${w()}]`,o,...f))}critical(o,...f){this.getLevel()<=v.Critical&&(this.useColors?console.error(`\x1B[90m[main ${w()}]\x1B[0m`,o,...f):console.error(`[main ${w()}]`,o,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends d{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...f){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",o,...f)}debug(o,...f){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...f)}info(o,...f){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",o,...f)}warn(o,...f){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",o,...f)}error(o,...f){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",o,...f)}critical(o,...f){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...f)}dispose(){}flush(){}}e.ConsoleLogger=b;class p extends d{constructor(o,f=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(f)}trace(o,...f){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(o),...f])}debug(o,...f){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(o),...f])}info(o,...f){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(o),...f])}warn(o,...f){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(o),...f])}error(o,...f){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(o),...f])}critical(o,...f){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(o),...f])}extractMessage(o){return typeof o=="string"?o:(0,S.toErrorMessage)(o,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class y extends d{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const f of this.logServices)f.setLevel(o);super.setLevel(o)}trace(o,...f){for(const k of this.logServices)k.trace(o,...f)}debug(o,...f){for(const k of this.logServices)k.debug(o,...f)}info(o,...f){for(const k of this.logServices)k.info(o,...f)}warn(o,...f){for(const k of this.logServices)k.warn(o,...f)}error(o,...f){for(const k of this.logServices)k.error(o,...f)}critical(o,...f){for(const k of this.logServices)k.critical(o,...f)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=y;class h extends M.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...f){this.logger.trace(o,...f)}debug(o,...f){this.logger.debug(o,...f)}info(o,...f){this.logger.info(o,...f)}warn(o,...f){this.logger.warn(o,...f)}error(o,...f){this.logger.error(o,...f)}critical(o,...f){this.logger.critical(o,...f)}flush(){this.logger.flush()}}e.LogService=h;class g extends M.Disposable{constructor(o,f){super(),this.logLevel=o,this.loggerItems=new R.ResourceMap,this._register(f(k=>this.setLevel(k)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:o})=>o)}getLogger(o){return this.loggerItems.get(o)?.logger}createLogger(o,f,k){let T=this.loggerItems.get(o)?.logger;return T||(k=f?.always?v.Trace:k,T=this.doCreateLogger(o,k??this.logLevel,f),this.loggerItems.set(o,{logger:T,logLevel:k})),T}setLevel(o,f){const k=E.URI.isUri(o)?o:void 0,T=k?f:o;if(k){const _=this.loggerItems.get(k);_&&_.logLevel!==T&&(_.logLevel=T,_.logger.setLevel(T))}else this.logLevel=T,this.loggerItems.forEach(({logLevel:_,logger:G})=>{_===void 0&&G.setLevel(this.logLevel)})}getLogLevel(o){return this.loggerItems.get(o)?.logLevel}dispose(){this.loggerItems.forEach(({logger:o})=>o.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=g;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return v.Info}trace(o,...f){}debug(o,...f){}info(o,...f){}warn(o,...f){}error(o,...f){}critical(o,...f){}dispose(){}flush(){}}e.NullLogger=l;class i extends l{}e.NullLogService=i;class a extends g{constructor(){super(v.Info,t.Event.None)}doCreateLogger(o,f,k){return new l}}e.NullLoggerService=a;function r(c){if(c.verbose)return v.Trace;if(typeof c.logLevel=="string"){const o=n(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function n(c){switch(c){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=n;function s(c){switch(c){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=s});var ee=this&&this.__param||function(z,e){return function(S,t){e(S,t,z)}};define(te[200],ie([0,1,69,3,2,6,4,8]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=class Et extends M.Disposable{constructor(v){super(),this.logService=v,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(v,I){this.logService.trace("Getting password from keytar:",v,I);let C;try{C=await this.withKeytar()}catch{return null}const d=await(0,E.retry)(()=>C.getPassword(v,I),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",I),d;let m,P;try{const b=JSON.parse(d);m=b.content,P=b.hasNextChunk}catch{}if(!m||!P)return this.logService.trace("Got password from keytar for account:",I),d;try{let b=1;for(;P;){const p=await(0,E.retry)(()=>C.getPassword(v,`${I}-${b}`),50,3),y=JSON.parse(p);m+=y.content,P=y.hasNextChunk,b++}return this.logService.trace(`Got ${b}-chunked password from keytar for account:`,I),m}catch(b){return this.logService.error(b),d}}async setPassword(v,I,C){this.logService.trace("Setting password using keytar:",v,I);let d;try{d=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}if(D.isWindows&&C.length>Et.MAX_PASSWORD_LENGTH){let m=0,P=0,b=!0;for(;b;){const p=C.substring(m,m+Et.PASSWORD_CHUNK_SIZE);m+=Et.PASSWORD_CHUNK_SIZE,b=C.length-m>0;const y={content:p,hasNextChunk:b};await(0,E.retry)(()=>d.setPassword(v,P?`${I}-${P}`:I,JSON.stringify(y)),50,3),P++}this.logService.trace(`Got${P?` ${P}-chunked`:""} password from keytar for account:`,I)}else await(0,E.retry)(()=>d.setPassword(v,I,C),50,3),this.logService.trace("Got password from keytar for account:",I);this._onDidChangePassword.fire({service:v,account:I})}async deletePassword(v,I){this.logService.trace("Deleting password using keytar:",v,I);let C;try{C=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const d=await C.getPassword(v,I);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",I),!1;let m,P;try{const p=JSON.parse(d);m=p.content,P=p.hasNextChunk}catch{}let b=0;if(m&&P)try{for(b++;P;){const p=`${I}-${b}`,y=await C.getPassword(v,p);await C.deletePassword(v,p),P=JSON.parse(y).hasNextChunk,b++}}catch(p){this.logService.error(p)}return await C.deletePassword(v,I)?(this._onDidChangePassword.fire({service:v,account:I}),this.logService.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,I),!0):(this.logService.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,I),!1)}async findPassword(v){let I;try{I=await this.withKeytar()}catch{return null}return await I.findPassword(v)}async findCredentials(v){let I;try{I=await this.withKeytar()}catch{return[]}return await I.findCredentials(v)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,u=we([ee(0,R.ILogService)],u),e.BaseCredentialsMainService=u}),define(te[201],ie([0,1,24,8,16,3,2,9,70,6]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends D.Disposable{constructor(C,d){super(),this.logService=C,this.options=d,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,d):this.watchNonRecursive(C,d)}watchUniversal(C,d){const m={path:this.toFilePath(C),excludes:d.excludes,includes:d.includes,recursive:d.recursive},P=(0,S.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,M.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&C.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,d){const m={path:this.toFilePath(C),excludes:d.excludes,includes:d.includes,recursive:!1},P=(0,S.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,M.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,u.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,E.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(te[202],ie([0,1,24,8,17,23,3,66,57,2,29,14,71,18,58,156,15,107,6]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends w.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${l}`);const a=new w.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),a.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&a.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),a.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,w.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){i.push(a)}}),!this.provider.has(l)&&await t.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&i)}listCapabilities(){return u.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,d.isAbsolutePath)(l))throw new b.FileOperationError((0,P.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const a=new Error;throw a.name="ENOPRO",a.message=(0,P.localize)(1,null,l.toString()),a}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(a){throw(0,b.toFileSystemProviderErrorCode)(a)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,P.localize)(2,null,this.resourceForError(l)),1):(0,b.ensureFileSystemProviderError)(a)}}async doResolveFile(l,i){const a=await this.withProvider(l),r=this.isPathCaseSensitive(a),n=i?.resolveTo,s=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,o=await a.stat(l);let f;return this.toFileStat(a,l,o,void 0,!!c,(k,T)=>(f||(f=v.TernarySearchTree.forUris(()=>!r),f.set(l,!0),n&&f.fill(!0,n)),f.get(k.resource)||f.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&s?T===1:!1))}async toFileStat(l,i,a,r,n,s){const{providerExtUri:c}=this.getExtUri(l),o={resource:i,name:c.basename(i),isFile:(a.type&b.FileType.File)!==0,isDirectory:(a.type&b.FileType.Directory)!==0,isSymbolicLink:(a.type&b.FileType.SymbolicLink)!==0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&b.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,b.etag)({mtime:a.mtime,size:a.size}),children:void 0};if(o.isDirectory&&s(o,r)){try{const f=await l.readdir(i),k=await t.Promises.settled(f.map(async([T,_])=>{try{const G=c.joinPath(i,T),ae=n?await l.stat(G):{type:_};return await this.toFileStat(l,G,ae,f.length,n,s)}catch(G){return this.logService.trace(G),null}}));o.children=(0,S.coalesce)(k)}catch(f){this.logService.trace(f),o.children=[]}return o}return o}async resolveAll(l){return t.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.withProvider(l),a=await i.stat(l);return this.toFileStat(i,l,a,void 0,!0,()=>!1)}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(a){return a}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new b.FileOperationError((0,P.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=M.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const r=await this.writeFile(l,i);return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,r)),r}async writeFile(l,i,a){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,l,a)||await this.mkdirp(r,n.dirname(l));let c;if((0,b.hasReadWriteCapability)(r)&&!(i instanceof M.VSBuffer))if((0,m.isReadableStream)(i)){const o=await(0,m.peekStream)(i,3);o.ended?c=M.VSBuffer.concat(o.buffer):c=o}else c=(0,m.peekReadable)(i,o=>M.VSBuffer.concat(o),3);else c=i;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&c instanceof M.VSBuffer?await this.doWriteUnbuffered(r,l,a,c):await this.doWriteBuffered(r,l,a,c instanceof M.VSBuffer?(0,M.bufferToReadable)(c):c),this._onDidRunOperation.fire(new b.FileOperationEvent(l,4))}catch(s){throw new b.FileOperationError((0,P.localize)(4,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(i)));let n;try{n=await l.stat(i)}catch{return}if((n.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,P.localize)(6,null,this.resourceForError(i)),0,a);if(this.throwIfFileIsReadonly(i,n),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&a.mtime<n.mtime&&a.etag!==(0,b.etag)({mtime:a.mtime,size:n.size}))throw new b.FileOperationError((0,P.localize)(7,null),3,a);return n}async readFile(l,i,a){const r=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(r,l,i,a):this.doReadFile(r,l,i,a)}async doReadFileAtomic(l,i,a,r){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,i,a,r);n(c)}catch(c){s(c)}})})}async doReadFile(l,i,a,r){const n=await this.doReadFileStream(l,i,{...a,preferUnbuffered:!0},r);return{...n,value:await(0,M.streamToBuffer)(n.value)}}async readFileStream(l,i,a){const r=await this.withReadProvider(l);return this.doReadFileStream(r,l,i,a)}async doReadFileStream(l,i,a,r){const n=new R.CancellationTokenSource(r),s=this.validateReadFile(i,a).then(o=>o,o=>{throw n.cancel(),o});let c;try{return typeof a?.etag=="string"&&a.etag!==b.ETAG_DISABLED&&await s,a?.atomic&&(0,b.hasFileAtomicReadCapability)(l)||!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&a?.preferUnbuffered?c=this.readFileUnbuffered(l,i,a):(0,b.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,i,n.token,a):c=this.readFileBuffered(l,i,n.token,a),{...await s,value:c}}catch(o){c&&await(0,m.consumeStream)(c);const f=(0,P.localize)(8,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(f,o.stat,a):new b.FileOperationError(f,(0,b.toFileOperationResult)(o),a)}}readFileStreamed(l,i,a,r=Object.create(null)){const n=l.readFileStream(i,r,a);return(0,m.transform)(n,{data:s=>s instanceof M.VSBuffer?s:M.VSBuffer.wrap(s),error:s=>new b.FileOperationError((0,P.localize)(9,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)},s=>M.VSBuffer.concat(s))}readFileBuffered(l,i,a,r=Object.create(null)){const n=(0,M.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,i,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new b.FileOperationError((0,P.localize)(10,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)},a),n}readFileUnbuffered(l,i,a){const r=(0,m.newWriteableStream)(n=>M.VSBuffer.concat(n));return(async()=>{try{let n;a?.atomic&&(0,b.hasFileAtomicReadCapability)(l)?n=await l.readFile(i,{atomic:!0}):n=await l.readFile(i),typeof a?.position=="number"&&(n=n.slice(a.position)),typeof a?.length=="number"&&(n=n.slice(0,a.length)),this.validateReadFileLimits(i,n.byteLength,a),r.end(M.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(l,i){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new b.FileOperationError((0,P.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===a.etag)throw new b.NotModifiedSinceFileOperationError((0,P.localize)(12,null),a,i);return this.validateReadFileLimits(l,a.size,i),a}validateReadFileLimits(l,i,a){if(a?.limits){let r;if(typeof a.limits.memory=="number"&&i>a.limits.memory&&(r=9),typeof a.limits.size=="number"&&i>a.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,P.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,i,a){return this.doCanMoveCopy(l,i,"move",a)}async canCopy(l,i,a){return this.doCanMoveCopy(l,i,"copy",a)}async doCanMoveCopy(l,i,a,r){if(l.toString()!==i.toString())try{const n=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,l,s,i,a,r)}catch(n){return n}return!0}async move(l,i,a){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,l,n,i,"move",!!a),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,s==="move"?2:3,c)),c}async copy(l,i,a){const r=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,l,n,i,"copy",!!a),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,s==="copy"?3:2,c)),c}async doMoveCopy(l,i,a,r,n,s){if(i.toString()===r.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,i,a,r,n,s);if(c&&!o&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(r)),n==="copy"){if(l===a&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(i,r,{overwrite:s});else{const f=await this.resolve(i);f.isDirectory?await this.doCopyFolder(l,f,a,r):await this.doCopyFile(l,i,a,r)}return n}else return l===a?(await l.rename(i,r,{overwrite:s}),n):(await this.doMoveCopy(l,i,a,r,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,a,r){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,i,a,r);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,i,a,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,i,a,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,i,a,r)}async doCopyFolder(l,i,a,r){await a.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async n=>{const s=this.getExtUri(a).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),a,s):this.doCopyFile(l,n.resource,a,s)}))}async doValidateMoveCopy(l,i,a,r,n,s){let c=!1;if(l===a){const{providerExtUri:f,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(c=f.isEqual(i,r)),c&&n==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!c&&f.isEqualOrParent(r,i))throw new Error((0,P.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const o=await this.exists(r);if(o&&!c){if(!s)throw new b.FileOperationError((0,P.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(l===a){const{providerExtUri:f}=this.getExtUri(l);if(f.isEqualOrParent(i,r))throw new Error((0,P.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,a)),a}async mkdirp(l,i){const a=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(i,r.dirname(i));)try{if(((await l.stat(i)).type&b.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;a.push(r.basename(i)),i=r.dirname(i)}for(let n=a.length-1;n>=0;n--){i=r.joinPath(i,a[n]);try{await l.mkdir(i)}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(a){return a}return!0}async doValidateDelete(l,i){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(a.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(l)));let n;try{n=await a.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new b.FileOperationError((0,P.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(l)))}return a}async del(l,i){const a=await this.doValidateDelete(l,i),r=!!i?.useTrash,n=!!i?.recursive;await a.delete(l,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(l,1))}async cloneFile(l,i){const a=await this.withProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(a===r&&this.getExtUri(a).providerExtUri.isEqual(l,i))return;if(a===r&&(0,b.hasFileCloneCapability)(a))return a.cloneFile(l,i);await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri);return a===r&&(0,b.hasFileFolderCopyCapability)(a)?n.queue(()=>a.copy(l,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(a,l,r,i))}watch(l,i={recursive:!1,excludes:[]}){const a=new w.DisposableStore;let r=!1,n=()=>{r=!0};return a.add((0,w.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(l,i);r?(0,w.dispose)(s):n=()=>(0,w.dispose)(s)}catch(s){this.logService.error(s)}})(),a}async doWatch(l,i){const a=await this.withProvider(l),r=(0,E.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),i]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:a.watch(l,i)},this.activeWatchers.set(r,n)),n.count+=1,(0,w.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,w.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,w.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,a,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(i,{create:!0,unlock:a?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,n,r):await this.doWriteReadableBufferedQueued(l,n,r)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,i,a){let r=0,n;if((0,m.isReadableBufferedStream)(a)){if(a.buffer.length>0){const s=M.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,i,s,s.byteLength,r,0),r+=s.byteLength}if(a.ended)return;n=a.stream}else n=a;return new Promise((s,c)=>{(0,m.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(l,i,o,o.byteLength,r,0)}catch(f){return c(f)}r+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>c(o),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,i,a){let r=0,n;for(;(n=a.read())!==null;)await this.doWriteBuffer(l,i,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(l,i,a,r,n,s){let c=0;for(;c<r;)c+=await l.write(i,n+c,a.buffer,s+c,r-c)}async doWriteUnbuffered(l,i,a,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,a,r))}async doWriteUnbufferedQueued(l,i,a,r){let n;r instanceof M.VSBuffer?n=r:(0,m.isReadableStream)(r)?n=await(0,M.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?n=await(0,M.bufferedStreamToBuffer)(r):n=(0,M.readableToBuffer)(r),await l.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,a,r))}async doPipeBufferedQueued(l,i,a,r){let n,s;try{n=await l.open(i,{create:!1}),s=await a.open(r,{create:!0,unlock:!1});const c=M.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,f=0,k=0;do k=await l.read(n,o,c.buffer,f,c.byteLength-f),await this.doWriteBuffer(a,s,c,k,o,f),o+=k,f+=k,f===c.byteLength&&(f=0);while(k>0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof s=="number"?a.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,a,r))}async doPipeUnbufferedQueued(l,i,a,r){return a.writeFile(r,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,a,r){return this.writeQueue.queueFor(r,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,a,r))}async doPipeUnbufferedToBufferedQueued(l,i,a,r){const n=await a.open(r,{create:!0,unlock:!1});try{const s=await l.readFile(i);await this.doWriteBuffer(a,n,M.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await a.close(n)}}async doPipeBufferedToUnbuffered(l,i,a,r){const n=await(0,M.streamToBuffer)(this.readFileBuffered(l,i,R.CancellationToken.None));await this.doWriteUnbuffered(a,r,void 0,n)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new b.FileOperationError((0,P.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,P.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===I.Schemas.file?l.fsPath:l.toString(!0)}};h=we([ee(0,y.ILogService)],h),e.FileService=h}),define(te[86],ie([0,1,40,278,8,29,17,3,31,2,9,4,18,58,21,160,15,107,201,44,198,197]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(a)}`)}})();class i extends y.AbstractDiskFileSystemProvider{constructor(r,n){super(r,n),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new R.ResourceMap(s=>C.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:s}=await m.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(r){try{const n=await m.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,C.joinPath)(r,c.name))).type:o=this.toType(c),s.push([c.name,o])}catch(o){this.logService.trace(o)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let s;return n?.dangling?s=b.FileType.Unknown:r.isFile()?s=b.FileType.File:r.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async createResourceLock(r){const n=this.toFilePath(r);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(r);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const c=new M.Barrier;return this.resourceLocks.set(r,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(r)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(r)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),c.open()})}async readFile(r,n){let s;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const c=this.toFilePath(r);return await m.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}traceLock(r){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(r)}readFileStream(r,n,s){const c=(0,d.newWriteableStream)(o=>D.VSBuffer.concat(o.map(f=>D.VSBuffer.wrap(f))).buffer);return(0,p.readFileIntoStream)(this,r,c,o=>o.buffer,{...n,bufferSize:256*1024},s),c}async writeFile(r,n,s){let c;try{const o=this.toFilePath(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(o)){if(!s.overwrite)throw(0,b.createFileSystemProviderError)((0,P.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.createFileSystemProviderError)((0,P.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(c,0,n,0,n.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(r,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){i.canFlush=r}async open(r,n){const s=this.toFilePath(r);let c;(0,b.isFileOpenForWriteOptions)(n)&&(c=await this.createResourceLock(r));let o;try{if((0,b.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:k}=await m.SymlinkSupport.stat(s);k.mode&128||await m.Promises.chmod(s,k.mode|128)}catch(k){this.logService.trace(k)}let f;if((0,b.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await m.Promises.truncate(s,0),f="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}f||(f="w")}else f="r";o=await m.Promises.open(s,f)}catch(f){throw c?.dispose(),(0,b.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(o,0),(0,b.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,r),c){const f=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.mapHandleToLock.set(o,c),f&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),f.dispose())}return o}async close(r){const n=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&i.canFlush)try{await m.Promises.fdatasync(r)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await m.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(r)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,s,c,o){const f=this.normalizePos(r,n);let k=null;try{k=(await m.Promises.read(r,s,c,o,f)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(r,f,k)}return k}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,s){const c=this.mapHandleToPos.get(r);typeof c=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,c+s):this.mapHandleToPos.delete(r)))}async write(r,n,s,c,o){return(0,M.retry)(()=>this.doWrite(r,n,s,c,o),100,3)}async doWrite(r,n,s,c,o){const f=this.normalizePos(r,n);let k=null;try{k=(await m.Promises.write(r,s,c,o,f)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),T)}finally{this.updatePos(r,f,k)}return k}async mkdir(r){try{await m.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const s=this.toFilePath(r);n.recursive?await m.Promises.rm(s,m.RimRafMode.MOVE):await m.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,n,s){const c=this.toFilePath(r),o=this.toFilePath(n);if(c!==o)try{await this.validateTargetDeleted(r,n,"move",s.overwrite),await m.Promises.move(c,o)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(2,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(r,n,s){const c=this.toFilePath(r),o=this.toFilePath(n);if(c!==o)try{await this.validateTargetDeleted(r,n,"copy",s.overwrite),await m.Promises.copy(c,o,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(3,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(r,n,s,c){const o=this.toFilePath(r),f=this.toFilePath(n);let k=!1;if(!!(this.capabilities&1024)||(k=(0,u.isEqual)(o,f,!0)),k&&s==="copy")throw(0,b.createFileSystemProviderError)((0,P.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!k&&await m.Promises.exists(f)){if(!c)throw(0,b.createFileSystemProviderError)((0,P.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(r,n){return this.doCloneFile(r,n,!1)}async doCloneFile(r,n,s){const c=this.toFilePath(r),o=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,u.isEqual)(c,o,!f))return;const k=new w.DisposableStore;try{const[T,_]=await Promise.all([this.createResourceLock(r),this.createResourceLock(n)]);k.add(T),k.add(_),s&&await m.Promises.mkdir((0,v.dirname)(o),{recursive:!0}),await m.Promises.copyFile(c,o)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(r,n,!0);throw this.toFileSystemProviderError(T)}finally{k.dispose()}}createUniversalWatcher(r,n,s){return new g.UniversalWatcherClient(c=>r(c),c=>n(c),s)}createNonRecursiveWatcher(r,n,s){return new l.NodeJSWatcherClient(c=>r(c),c=>n(c),s)}toFileSystemProviderError(r){if(r instanceof b.FileSystemProviderError)return r;let n;switch(r.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(r,n){let s=this.toFileSystemProviderError(n);if(r&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.toFilePath(r));c.mode&128||(s=(0,b.createFileSystemProviderError)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(te[203],ie([0,1,3,86,2,17,58,23]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends M.Disposable{constructor(I,C){super(),this.provider=I,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(I,C,d){const m=this.getUriTransformer(I);switch(C){case"stat":return this.stat(m,d[0]);case"readdir":return this.readdir(m,d[0]);case"open":return this.open(m,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(m,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(m,d[0],d[1],d[2]);case"rename":return this.rename(m,d[0],d[1],d[2]);case"copy":return this.copy(m,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(m,d[0],d[1]);case"mkdir":return this.mkdir(m,d[0]);case"delete":return this.delete(m,d[0],d[1]);case"watch":return this.watch(m,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${C} not found`)}listen(I,C,d){const m=this.getUriTransformer(I);switch(C){case"fileChange":return this.onFileChange(m,d[0]);case"readFileStream":return this.onReadFileStream(m,d[0],d[1])}throw new Error(`Unknown event ${C}`)}stat(I,C){const d=this.transformIncoming(I,C,!0);return this.provider.stat(d)}readdir(I,C){const d=this.transformIncoming(I,C);return this.provider.readdir(d)}async readFile(I,C,d){const m=this.transformIncoming(I,C,!0),P=await this.provider.readFile(m,d);return R.VSBuffer.wrap(P)}onReadFileStream(I,C,d){const m=this.transformIncoming(I,C,!0),P=new E.CancellationTokenSource,b=new S.Emitter({onLastListenerRemove:()=>{P.cancel()}}),p=this.provider.readFileStream(m,d,P.token);return(0,D.listenStream)(p,{onData:y=>b.fire(R.VSBuffer.wrap(y)),onError:y=>b.fire(y),onEnd:()=>{b.fire("end"),b.dispose(),P.dispose()}}),b.event}writeFile(I,C,d,m){const P=this.transformIncoming(I,C);return this.provider.writeFile(P,d.buffer,m)}open(I,C,d){const m=this.transformIncoming(I,C,!0);return this.provider.open(m,d)}close(I){return this.provider.close(I)}async read(I,C,d){const m=R.VSBuffer.alloc(d),P=0,b=await this.provider.read(I,C,m.buffer,P,d);return[m,b]}write(I,C,d,m,P){return this.provider.write(I,C,d.buffer,m,P)}mkdir(I,C){const d=this.transformIncoming(I,C);return this.provider.mkdir(d)}delete(I,C,d){const m=this.transformIncoming(I,C);return this.provider.delete(m,d)}rename(I,C,d,m){const P=this.transformIncoming(I,C),b=this.transformIncoming(I,d);return this.provider.rename(P,b,m)}copy(I,C,d,m){const P=this.transformIncoming(I,C),b=this.transformIncoming(I,d);return this.provider.copy(P,b,m)}cloneFile(I,C,d){const m=this.transformIncoming(I,C),P=this.transformIncoming(I,d);return this.provider.cloneFile(m,P)}onFileChange(I,C){const d=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(I,d))},onLastListenerRemove:()=>{(0,M.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return d.event}async watch(I,C,d,m,P){const b=this.sessionToWatcher.get(C);if(b){const p=this.transformIncoming(I,m),y=b.watch(d,p,P);this.watchRequests.set(C+d,y)}}async unwatch(I,C){const d=I+C,m=this.watchRequests.get(d);m&&((0,M.dispose)(m),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,I]of this.watchRequests)I.dispose();this.watchRequests.clear();for(const[,I]of this.sessionToWatcher)I.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class w extends M.Disposable{constructor(I,C,d,m){super(),this.uriTransformer=I,this.logService=d,this.environmentService=m,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(I){const C=this._register(new S.Emitter);this._register(C.event(d=>{I.fire(d.map(m=>({resource:this.uriTransformer.transformOutgoingURI(m.resource),type:m.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>C.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>I.fire(d)))}getRecursiveWatcherOptions(I){}getExtraExcludes(I){}watch(I,C,d){const m=this.getExtraExcludes(this.environmentService);return Array.isArray(m)&&(d.excludes=[...d.excludes,...m]),this.watcherRequests.set(I,this.fileWatcher.watch(C,d)),(0,M.toDisposable)(()=>{(0,M.dispose)(this.watcherRequests.get(I)),this.watcherRequests.delete(I)})}dispose(){super.dispose();for(const[,I]of this.watcherRequests)I.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=w}),define(te[204],ie([0,1,13,159,4,7,15,9,203,138]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class v extends u.AbstractDiskFileSystemProviderChannel{constructor(d,m,P){super(d,m),this.environmentService=P}getUriTransformer(d){return w.DefaultURITransformer}transformIncoming(d,m){return R.URI.revive(m)}async delete(d,m,P){if(!P.useTrash)return super.delete(d,m,P);const b=this.transformIncoming(d,m),p=(0,E.normalize)(b.fsPath);try{await S.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(M.isWindows?(0,t.localize)(0,null,(0,E.basename)(p)):(0,t.localize)(1,null,(0,E.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,m){return new I(d,m,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=v;class I extends u.AbstractSessionFileWatcher{watch(d,m,P){if(P.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,m,P)}}}),define(te[205],ie([0,1,6]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case S.LogLevel.Trace:return R.trace;case S.LogLevel.Debug:return R.debug;case S.LogLevel.Info:return R.info;case S.LogLevel.Warning:return R.warn;case S.LogLevel.Error:return R.error;case S.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class M extends S.AbstractLogger{constructor(D=S.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}set logger(D){this._logger=D;for(const{level:E,args:u}of this.buffer)t(D,E).apply(D,u);this.buffer=[]}_log(D,...E){this._logger?t(this._logger,D).apply(this._logger,E):this.getLevel()<=D&&this.buffer.push({level:D,args:E})}trace(D,...E){this._log(S.LogLevel.Trace,D,...E)}debug(D,...E){this._log(S.LogLevel.Debug,D,...E)}info(D,...E){this._log(S.LogLevel.Info,D,...E)}warn(D,...E){this._log(S.LogLevel.Warning,D,...E)}error(D,...E){this._log(S.LogLevel.Error,D,...E)}critical(D,...E){this._log(S.LogLevel.Critical,D,...E)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=M}),define(te[206],ie([0,1,3,7,6]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(C,d){this.logService=C,this.loggerService=d,this.onDidChangeLogLevel=S.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(C,d,m){switch(d){case"setLevel":return m[1]?this.loggerService.setLevel(t.URI.revive(m[1]),m[0]):this.logService.setLevel(m[0])}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=R;class D{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C,d){D.setLevel(this.channel,C,d)}static setLevel(C,d,m){return C.call("setLevel",[d,m])}}e.LogLevelChannelClient=D;class E{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,d){throw new Error(`Event not found: ${d}`)}async call(C,d,m){switch(d){case"createLogger":this.createLogger(t.URI.revive(m[0]),m[1]);return;case"log":return this.log(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.consoleLog(m[0],m[1])}throw new Error(`Call not found: ${d}`)}createLogger(C,d){this.loggers.set(C.toString(),this.loggerService.createLogger(C,d))}consoleLog(C,d){let m=console.log;switch(C){case M.LogLevel.Error:m=console.error;break;case M.LogLevel.Warning:m=console.warn;break;case M.LogLevel.Info:m=console.info;break}m.call(console,...d)}log(C,d){const m=this.loggers.get(C.toString());if(!m)throw new Error("Create the logger before logging");for(const[P,b]of d)(0,M.log)(m,P,b)}}e.LoggerChannel=E;class u extends M.AbstractLoggerService{constructor(C,d,m){super(C,d),this.channel=m}createConsoleMainLogger(){return new M.AdapterLogger({log:(C,d)=>{this.channel.call("consoleLog",[C,d])}})}doCreateLogger(C,d,m){return new w(this.channel,C,d,m)}}e.LoggerChannelClient=u;class w extends M.AbstractMessageLogger{constructor(C,d,m,P){super(P?.always),this.channel=C,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.channel.call("createLogger",[d,P]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,d){const m=[[C,d]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(C){this.channel.call("log",[this.file,C])}}class v extends M.LogService{constructor(C,d){super(d),this.parent=C,this._register(C.onDidChangeLogLevel(m=>d.setLevel(m)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=v}),define(te[207],ie([0,1,15,6]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function M(E,u,w,v,I){try{const C=await new Promise((m,P)=>{z(["spdlog"],m,P)});C.setFlushOn(t.LogLevel.Trace);const d=await C.createAsyncRotatingLogger(E,u,w,v);return I?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(C){console.error(C)}return null}function R(E,u,w){switch(u){case t.LogLevel.Trace:E.trace(w);break;case t.LogLevel.Debug:E.debug(w);break;case t.LogLevel.Info:E.info(w);break;case t.LogLevel.Warning:E.warn(w);break;case t.LogLevel.Error:E.error(w);break;case t.LogLevel.Critical:E.critical(w);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,w,v,I,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(u,w,v,I),this._register(this.onDidChangeLogLevel(d=>{this._logger?.setLevel(d)}))}async _createSpdLogLogger(u,w,v,I){const C=v?6:1,d=30/C*S.ByteSize.MB,m=await M(u,w,d,C,I);if(m){this._logger=m,this._logger.setLevel(this.getLevel());for(const{level:P,message:b}of this.buffer)R(this._logger,P,b);this.buffer=[]}}log(u,w){this._logger?R(this._logger,u,w):this.getLevel()<=u&&this.buffer.push({level:u,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(te[208],ie([0,1,30,6,207]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(E){super(E.getLevel(),E.onDidChangeLogLevel)}doCreateLogger(E,u,w){return new M.SpdLogLogger(w?.name||(0,S.generateUuid)(),E.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,u)}};R=we([ee(0,t.ILogService)],R),e.LoggerService=R}),define(te[209],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function M(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function R(D){return!S(D)&&!t(D)&&!M(D)}e.isMenubarMenuItemAction=R}),define(te[37],ie([0,1,3,57,2,5]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends M.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),t.Iterable.reduce(this.policies.entries(),(I,[C,d])=>({...I,[C]:d}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[v,I])=>({...w,[v]:{definition:I,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=D;class E{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(te[210],ie([0,1,8,3,57,12,15,6,37]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(I,C){const d=[];for(const m of M.Iterable.concat(I.keys(),C.keys()))I.get(m)!==C.get(m)&&d.push(m);return d}let v=class extends u.AbstractPolicyService{constructor(C,d,m){super(),this.file=C,this.fileService=d,this.logService=m,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const P=t.Event.filter(d.onDidFilesChange,b=>b.affects(C));this._register(d.watch(C)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(C){await this.refresh()}async read(){const C=new Map;try{const d=await this.fileService.readFile(this.file),m=JSON.parse(d.value.toString());if(!(0,R.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(m))this.policyDefinitions[P]&&C.set(P,m[P])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return C}async refresh(){const C=await this.read(),d=w(this.policies,C);this.policies=C,d.length>0&&this._onDidChange.fire(d)}};v=we([ee(1,D.IFileService),ee(2,E.ILogService)],v),e.FilePolicyService=v}),define(te[211],ie([0,1,3,2,37]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,w){switch(w){case"onDidChange":return S.Event.map(this.service.onDidChange,v=>v.reduce((I,C)=>({...I,[C]:this.service.getPolicyValue(C)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(u,w,v){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(v)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends M.AbstractPolicyService{constructor(u,w){super(),this.channel=w;for(const v in u){const{definition:I,value:C}=u[v];this.policyDefinitions[v]=I,C!==void 0&&this.policies.set(v,C)}this.channel.listen("onDidChange")(v=>{for(const I in v){const C=v[I];C===null?this.policies.delete(I):this.policies.set(I,C)}this._onDidChange.fire(Object.keys(v))})}async initializePolicies(u){const w=await this.channel.call("registerPolicyDefinitions",u);for(const v in w)this.policies.set(v,w[v])}}e.PolicyChannelClient=D}),define(te[54],ie([0,1,14,4,34,18]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const E=t.globals.vscode.context.configuration();if(E)D=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const E=(0,R.dirname)(S.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(E,"product.json").fsPath),M.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const u=z.__$__nodeRequire((0,R.joinPath)(E,"package.json").fsPath);Object.assign(D,{version:u.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(te[20],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[212],ie([0,1,76,6,20]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(E,u){this.productService=E,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(u);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,v,I]=w;let C=this.trustedExtensionUrlPublicKeys.get(E);if(!C){if(C=this.productService.trustedExtensionUrlPublicKeys[E],!C||C.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...C])}const d=Buffer.from(decodeURIComponent(I),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const m=d.slice(0,6),P=d.readUIntBE(0,6),b=Date.now()-P;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const p=d.slice(6),y=S.createVerify("SHA256");y.write(m),y.write(Buffer.from(v)),y.end();for(let h=0;h<C.length;h++){let g=C[h];if(g!==null){if(typeof g=="string")try{g=S.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),C[h]=g}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${E}:`,l),C[h]=null;continue}if(y.verify(g,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=we([ee(0,M.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(te[213],ie([0,1,9,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var M;(function(R){function D(E,u="noAbsolutePaths"){for(const w of E.nodes)w.callFrame&&w.callFrame.url&&((0,S.isAbsolute)(w.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(w.callFrame.url))&&(w.callFrame.url=(0,S.join)(u,(0,S.basename)(w.callFrame.url)));return E}R.rewriteAbsolutePaths=D})(M=e.Utils||(e.Utils={}))}),define(te[61],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,120,12]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(D,E){S.ok(t.isString(D)),S.ok(t.isObject(E)),S.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,E)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new M}),define(te[214],ie([0,1,3,47]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,w){this.schemasById[M(u)]=w,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(te[62],ie([0,1,24,3,12,147,19,214,47]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=u.Registry.as(E.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const r=this.doRegisterConfigurations(i,a);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(i){const a=this.doDeregisterConfigurations(i);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:i,remove:a}){const r=[];r.push(...this.doDeregisterConfigurations(a)),r.push(...this.doRegisterConfigurations(i,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(r)})}registerDefaultConfigurations(i){const a=[],r=[];for(const{overrides:n,source:s}of i)for(const c in n)if(a.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.configurationDefaultsOverrides.get(c),f=o?.valuesSources??new Map;if(s)for(const G of Object.keys(n[c]))f.set(G,s);const k={...o?.value||{},...n[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:k,valuesSources:f});const T=(0,D.getLanguageTagSettingPlainKey)(c),_={type:"object",default:k,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:M.isString(s)?void 0:s,defaultValueSource:s};r.push(...P(c)),this.configurationProperties[c]=_,this.defaultLanguageConfigurationOverridesNode.properties[c]=_}else{this.configurationDefaultsOverrides.set(c,{value:n[c],source:s});const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const a=[];for(const{overrides:r,source:n}of i)for(const s in r){const c=this.configurationDefaultsOverrides.get(s),o=M.isString(n)?n:n?.id,f=M.isString(c?.source)?c?.source:c?.source?.id;if(o===f)if(a.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const k=this.configurationProperties[s];k&&(this.updatePropertyDefaultValue(s,k),this.updateSchema(s,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const a of i)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,a){const r=[];return i.forEach(n=>{r.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),r}doDeregisterConfigurations(i){const a=[],r=n=>{if(n.properties)for(const s in n.properties){a.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>r(s))};for(const n of i){r(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return a}validateAndRegisterProperties(i,a=!0,r,n,s=3){s=M.isUndefinedOrNull(i.scope)?s:i.scope;const c=[],o=i.properties;if(o)for(const k in o){const T=o[k];if(a&&h(k,T)){delete o[k];continue}if(T.source=r,T.defaultDefaultValue=o[k].default,this.updatePropertyDefaultValue(k,T),e.OVERRIDE_PROPERTY_REGEX.test(k)?T.scope=void 0:(T.scope=M.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=M.isUndefinedOrNull(T.restricted)?!!n?.includes(k):T.restricted),o[k].hasOwnProperty("included")&&!o[k].included){this.excludedConfigurationProperties[k]=o[k],delete o[k];continue}else this.configurationProperties[k]=o[k],o[k].policy?.name&&this.policyConfigurations.set(o[k].policy.name,k);!o[k].deprecationMessage&&o[k].markdownDeprecationMessage&&(o[k].deprecationMessage=o[k].markdownDeprecationMessage),c.push(k)}const f=i.allOf;if(f)for(const k of f)c.push(...this.validateAndRegisterProperties(k,a,r,n,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const a=r=>{const n=r.properties;if(n)for(const c in n)this.updateSchema(c,n[c]);r.allOf?.forEach(a)};a(i)}updateSchema(i,a){switch(e.allSettings.properties[i]=a,a.scope){case 1:e.applicationSettings.properties[i]=a;break;case 2:e.machineSettings.properties[i]=a;break;case 6:e.machineOverridableSettings.properties[i]=a;break;case 3:e.windowSettings.properties[i]=a;break;case 4:e.resourceSettings.properties[i]=a;break;case 5:e.resourceSettings.properties[i]=a,this.resourceLanguageSettingsSchema.properties[i]=a;break}}removeFromSchema(i,a){switch(delete e.allSettings.properties[i],a.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const a=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,a){const r=this.configurationDefaultsOverrides.get(i);let n=r?.value,s=r?.source;M.isUndefined(n)&&(n=a.defaultDefaultValue,s=void 0),M.isUndefined(n)&&(n=p(a.type)),a.default=n,a.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let a=m.exec(l);for(;a?.length;){const r=a[1].trim();r&&i.push(r),a=m.exec(l)}}return(0,S.distinct)(i)}e.overrideIdentifiersFromKey=P;function b(l){return l.reduce((i,a)=>`${i}[${a}]`,"")}e.keyFromOverrideIdentifiers=b;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const y=new C;u.Registry.add(e.Extensions.Configuration,y);function h(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):y.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):i.policy?.name&&y.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,l,i.policy?.name,y.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=h;function g(){const l=[],i=y.getConfigurationProperties();for(const a of Object.keys(i))l.push([a,i[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=g}),define(te[108],ie([0,1,24,3,43,2,29,50,12,7,19,62,47]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class d{constructor(i={},a=[],r=[],n){this._contents=i,this._keys=a,this._overrides=r,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(a=>{if(a instanceof d)return a;const r=new m("");return r.parseRaw(a),r.configurationModel});this._rawConfiguration=i.reduce((a,r)=>r===a?r:a.merge(r),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,v.getConfigurationValue)(this.contents,i):this.contents}inspect(i,a){const r=this.rawConfiguration.getValue(i),n=a?this.rawConfiguration.getOverrideValue(i,a):void 0,s=a?this.rawConfiguration.override(a).getValue(i):r;return{value:r,override:n,merged:s}}getOverrideValue(i,a){const r=this.getContentsForOverrideIdentifer(a);return r?i?(0,v.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const a=[];for(const r of this.overrides)r.identifiers.includes(i)&&a.push(...r.keys);return S.distinct(a)}getAllOverrideIdentifiers(){const i=[];for(const a of this.overrides)i.push(...a.identifiers);return S.distinct(i)}override(i){let a=this.overrideConfigurations.get(i);return a||(a=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,a)),a}merge(...i){const a=E.deepClone(this.contents),r=E.deepClone(this.overrides),n=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of i)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.mergeContents(a,c.contents);for(const o of c.overrides){const[f]=r.filter(k=>S.equals(k.identifiers,o.identifiers));f?(this.mergeContents(f.contents,o.contents),f.keys.push(...o.keys),f.keys=S.distinct(f.keys)):r.push(E.deepClone(o))}for(const o of c.keys)n.indexOf(o)===-1&&n.push(o)}return new d(a,n,r,s.every(c=>c instanceof d)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new d(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const r={};for(const n of S.distinct([...Object.keys(this.contents),...Object.keys(a)])){let s=this.contents[n];const c=a[n];c&&(typeof s=="object"&&typeof c=="object"?(s=E.deepClone(s),this.mergeContents(s,c)):s=c),r[n]=s}return new d(r,this.keys,this.overrides)}mergeContents(i,a){for(const r of Object.keys(a)){if(r in i&&u.isObject(i[r])&&u.isObject(a[r])){this.mergeContents(i[r],a[r]);continue}i[r]=E.deepClone(a[r])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?E.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let a=null,r=null;const n=s=>{s&&(r?this.mergeContents(r,s):r=E.deepClone(s))};for(const s of this.overrides)S.equals(s.identifiers,[i])?a=s.contents:s.identifiers.includes(i)&&n(s.contents);return n(a),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,v.addToValueTree)(this.contents,i,a,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,v.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let r=0;r<a;r++)i.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,i)}removeKey(i){const a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=d;class m{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!u.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:r,keys:n,overrides:s,restricted:c,hasExcludedProperties:o}=this.doParseRaw(i,a);this._configurationModel=new d(r,n,s,o?[i]:void 0),this._restrictedConfigurations=c||[]}doParseContent(i){let a={},r=null,n=[];const s=[],c=[];function o(k){Array.isArray(n)?n.push(k):r!==null&&(n[r]=k)}const f={onObjectBegin:()=>{const k={};o(k),s.push(n),n=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const k=[];o(k),s.push(n),n=k,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:o,onError:(k,T,_)=>{c.push({error:k,offset:T,length:_})}};if(i)try{M.visit(i,f),a=n[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return a}doParseRaw(i,a){const r=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,r,!0,a);i=n.raw;const s=(0,v.toValuesTree)(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),c=Object.keys(i),o=this.toOverrides(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:s,keys:c,overrides:o,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(i,a,r,n){let s=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const c={},o=[];for(const f in i)if(I.OVERRIDE_PROPERTY_REGEX.test(f)&&r){const k=this.filter(i[f],a,!1,n);c[f]=k.raw,s=s||k.hasExcludedProperties,o.push(...k.restricted)}else{const k=a[f],T=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&o.push(f),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&k?.restricted)?c[f]=i[f]:s=!0}return{raw:c,restricted:o,hasExcludedProperties:s}}toOverrides(i,a){const r=[];for(const n of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const c in i[n])s[c]=i[n][c];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,v.toValuesTree)(s,a)})}return r}}e.ConfigurationModelParser=m;class P extends R.Disposable{constructor(i,a,r,n){super(),this.userSettingsResource=i,this.scopes=a,this.fileService=n,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class b{constructor(i,a,r,n,s=new d,c=new d,o=new D.ResourceMap,f=new d,k=new D.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=a,this._applicationConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=o,this._memoryConfiguration=f,this._memoryConfigurationByResource=k,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,a,r){return this.getConsolidatedConfigurationModel(i,a,r).getValue(i)}updateValue(i,a,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new d,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,a===void 0?n.removeValue(i):n.setValue(i,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,r){const n=this.getConsolidatedConfigurationModel(i,a,r),s=this.getFolderConfigurationModelForResource(a.resource,r),c=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,o=this._defaultConfiguration.inspect(i,a.overrideIdentifier),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),k=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),T=this.userConfiguration.freeze().inspect(i,a.overrideIdentifier),_=this.localUserConfiguration.freeze().inspect(i,a.overrideIdentifier),G=this.remoteUserConfiguration.freeze().inspect(i,a.overrideIdentifier),ae=r?this._workspaceConfiguration.freeze().inspect(i,a.overrideIdentifier):void 0,X=s?s.freeze().inspect(i,a.overrideIdentifier):void 0,Q=c.inspect(i,a.overrideIdentifier),J=n.getValue(i),se=S.distinct(n.overrides.map(he=>he.identifiers).flat()).filter(he=>n.getOverrideValue(i,he)!==void 0);return{defaultValue:o?o.merged:void 0,policyValue:f?f.merged:void 0,applicationValue:k?k.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:_?_.merged:void 0,userRemoteValue:G?G.merged:void 0,workspaceValue:ae?ae.merged:void 0,workspaceFolderValue:X?X.merged:void 0,memoryValue:Q?Q.merged:void 0,value:J,default:o.value!==void 0||o.override!==void 0?{value:o.value,override:o.override}:void 0,policy:f?.value!==void 0?{value:f.value}:void 0,application:k?.value!==void 0||k?.override!==void 0?{value:k.value,override:k.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userRemote:G.value!==void 0||G.override!==void 0?{value:G.value,override:G.override}:void 0,workspace:ae?.value!==void 0||ae?.override!==void 0?{value:ae.value,override:ae.override}:void 0,workspaceFolder:X?.value!==void 0||X?.override!==void 0?{value:X.value,override:X.override}:void 0,memory:Q.value!==void 0||Q.override!==void 0?{value:Q.value,override:Q.override}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const r=[];if(!a){const{added:n,updated:s,removed:c}=h(this._defaultConfiguration,i);a=[...n,...s,...c]}for(const n of a)for(const s of(0,I.overrideIdentifiersFromKey)(n)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),o=i.getKeysForOverrideIdentifier(s),f=[...o.filter(k=>c.indexOf(k)===-1),...c.filter(k=>o.indexOf(k)===-1),...c.filter(k=>!E.equals(this._defaultConfiguration.override(s).getValue(k),i.override(s).getValue(k)))];r.push([s,f])}return this.updateDefaultConfiguration(i),{keys:a,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:a,updated:r,removed:n}=h(this._policyConfiguration,i),s=[...a,...r,...n];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:a,updated:r,removed:n,overrides:s}=h(this.applicationConfiguration,i),c=[...a,...r,...n];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:r,removed:n,overrides:s}=h(this.localUserConfiguration,i),c=[...a,...r,...n];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:r,removed:n,overrides:s}=h(this.remoteUserConfiguration,i),c=[...a,...r,...n];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:r,removed:n,overrides:s}=h(this.workspaceConfiguration,i),c=[...a,...r,...n];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,a){const r=this.folderConfigurations.get(i),{added:n,updated:s,removed:c,overrides:o}=h(r,a),f=[...n,...s,...c];return(f.length||!r)&&this.updateFolderConfiguration(i,a),{keys:f,overrides:o}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:n,removed:s,overrides:c}=h(a,void 0);return{keys:[...r,...n,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,a,r){let n=this.getConsolidatedConfigurationModelForResource(a,r);return a.overrideIdentifier&&(n=n.override(a.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const n=a.getFolder(i);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const s=this._memoryConfigurationByResource.get(i);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(a=r.merge(n),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=r}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const r=a.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:r,overrides:n,keys:s}=this._folderConfigurations.get(a);return i.push([a,{contents:r,overrides:n,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>i.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),o=i.folders.reduce((f,k)=>(f.set(w.URI.revive(k[0]),this.parseConfigurationModel(k[1])),f),new D.ResourceMap);return new b(a,r,n,s,new d,c,o,new d,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,a=new Map;for(const n of l)n.keys.forEach(s=>i.add(s)),n.overrides.forEach(([s,c])=>{const o=(0,D.getOrSet)(a,s,new Set);c.forEach(f=>o.add(f))});const r=[];return a.forEach((n,s)=>r.push([s,[...n.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class y{constructor(i,a,r,n){this.change=i,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(o=>s.add(o)),i.overrides.forEach(([,o])=>o.forEach(f=>s.add(f))),this.affectedKeys=[...s.values()];const c=new d;this.affectedKeys.forEach(o=>c.setValue(o,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!E.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let r=(0,v.toValuesTree)({[a]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(i=i[n],!i)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=y;function h(l,i){const{added:a,removed:r,updated:n}=g(i,l),s=[],c=l?.getAllOverrideIdentifiers()||[],o=i?.getAllOverrideIdentifiers()||[];if(i){const f=o.filter(k=>!c.includes(k));for(const k of f)s.push([k,i.getKeysForOverrideIdentifier(k)])}if(l){const f=c.filter(k=>!o.includes(k));for(const k of f)s.push([k,l.getKeysForOverrideIdentifier(k)])}if(i&&l){for(const f of c)if(o.includes(f)){const k=g({contents:l.getOverrideValue(void 0,f)||{},keys:l.getKeysForOverrideIdentifier(f)},{contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)});s.push([f,[...k.added,...k.removed,...k.updated]])}}return{added:a,removed:r,updated:n,overrides:s}}function g(l,i){const a=l?i?l.keys.filter(s=>i.keys.indexOf(s)===-1):[...l.keys]:[],r=i?l?i.keys.filter(s=>l.keys.indexOf(s)===-1):[...i.keys]:[],n=[];if(l&&i){for(const s of i.keys)if(l.keys.indexOf(s)!==-1){const c=(0,v.getConfigurationValue)(i.contents,s),o=(0,v.getConfigurationValue)(l.contents,s);E.equals(c,o)||n.push(s)}}return{added:a,removed:r,updated:n}}}),define(te[215],ie([0,1,24,3,2,50,12,19,108,62,6,37,47]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class d extends M.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new m(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(C.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:h})=>this.onDidUpdateConfiguration(y,h))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(y,h){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:y})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=d;class m extends u.ConfigurationModel{constructor(y={}){const h=C.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(h),l=Object.create(null),i=[];for(const a in h){const r=y[a],n=r!==void 0?r:h[a].default;(0,E.addToValueTree)(l,a,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const a of Object.keys(l))w.OVERRIDE_PROPERTY_REGEX.test(a)&&i.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(l[a]),contents:(0,E.toValuesTree)(l[a],r=>console.error(`Conflict in default settings file: ${r}`))});super(l,g,i)}}e.DefaultConfigurationModel=m;class P{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let b=class extends M.Disposable{get configurationModel(){return this._configurationModel}constructor(y,h,g){super(),this.defaultConfiguration=y,this.policyService=h,this.logService=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(y=>this.onDidChangePolicies(y))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:y})=>this.update(await this.registerPolicyDefinitions(y),!0))),this._configurationModel}async registerPolicyDefinitions(y){const h={},g=[],l=C.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const i of y){const a=l[i];if(!a){g.push(i);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}g.push(i),h[a.policy.name]={type:a.type}}}return(0,D.isEmptyObject)(h)||await this.policyService.registerPolicyDefinitions(h),g}onDidChangePolicies(y){const h=C.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),g=(0,S.coalesce)(y.map(l=>h.get(l)));this.update(g,!0)}update(y,h){const g=C.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=[],i=this._configurationModel.isEmpty();for(const a of y){const r=g[a]?.policy?.name;if(r){const n=this.policyService.getPolicyValue(r);(i?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(a),n))&&l.push([a,n])}else this._configurationModel.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){const a=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const r of a.keys)this._configurationModel.setValue(r,a.getValue(r));for(const[r,n]of l)n===void 0?this._configurationModel.removeValue(r):this._configurationModel.setValue(r,n);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=we([ee(1,I.IPolicyService),ee(2,v.ILogService)],b),e.PolicyConfiguration=b}),define(te[216],ie([0,1,8,3,2,18,19,108,215,37]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends M.Disposable{constructor(C,d,m,P){super(),this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=m instanceof w.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,m,P)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,d)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[C,d,m]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(C,d,new E.ConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(C,d){const m=typeof C=="string"?C:void 0,P=(0,D.isConfigurationOverrides)(C)?C:(0,D.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(m,P,void 0)}updateValue(C,d,m,P){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const d=this.configuration.toData(),m=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(m,d,2)}onDidDefaultConfigurationChange(C,d){const m=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(C,d);this.trigger(P,m,7)}onDidPolicyConfigurationChange(C){const d=this.configuration.toData(),m=this.configuration.compareAndUpdatePolicyConfiguration(C);this.trigger(m,d,7)}trigger(C,d,m){const P=new E.ConfigurationChangeEvent(C,{data:d},this.configuration);P.source=m,P.sourceConfig=this.getTargetConfiguration(m),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(C){switch(C){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(te[217],ie([0,1,16,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var M;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{static isTemporarilyNotAvailable(E){return E instanceof R&&E._code===M.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof R&&E._code===M.NoResolverFound}static isHandled(E){return E instanceof R&&E.isHandled}constructor(E,u=M.Unknown,w){super(E),this._message=E,this._code=u,this._detail=w,this.isHandled=u===M.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(te[63],ie([0,1,14]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function M(w){if(!w)return;const v=w.indexOf("+");return v<0?w:w.substr(0,v)}e.getRemoteName=M;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(w){const{host:v,port:I}=u(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:I}}e.parseAuthorityWithPort=D;function E(w,v){let{host:I,port:C}=u(w);return typeof C>"u"&&(C=v),{host:I,port:C}}e.parseAuthorityWithOptionalPort=E;function u(w){const v=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const C=w.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:w,port:void 0}}}),define(te[109],ie([0,1,26,5,63]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=R;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var u;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,b){if(typeof P>"u"||P===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof P=="string"||typeof b=="string"){const p=typeof P=="string"?P:P.value,y=typeof b=="string"?b:b.value;return S.equalsIgnoreCase(p,y)}return P._lower===b._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=w;function v(m){return I(m)}e.isApplicationScopedExtension=v;function I(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function C(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function d(m,P){if(P){const b=`onResolveRemoteAuthority:${(0,M.getRemoteName)(P)}`;return m.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[110],ie([0,1,26,190,109,4,7,16,34]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(a,r){return a.uuid&&r.uuid?a.uuid===r.uuid:a.id===r.id?!0:(0,S.compareIgnoreCase)(a.id,r.id)===0}e.areSameExtensions=w;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(r){const n=r.manifest?r.manifest.version:r.version,s=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new I(r.identifier,n,s)}static parse(r){const n=v.exec(r);return n&&n[1]&&n[2]?new I({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof I?w(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=I;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(a){const r=C.exec(a);return r&&r[1]?[P(r[1]),r[2]]:[P(a),void 0]}e.getIdAndVersion=d;function m(a,r){return`${a}.${r}`}e.getExtensionId=m;function P(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function b(a,r){return P(m(a,r))}e.getGalleryExtensionId=b;function p(a,r){const n=[],s=c=>{for(const o of n)if(o.some(f=>w(r(f),r(c))))return o;return null};for(const c of a){const o=s(c);o?o.push(c):n.push([c])}return n}e.groupByExtension=p;function y(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function h(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function g(a,r){const n=[],s=r.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&n.every(o=>!w(o.identifier,{id:c}))){const o=a.filter(f=>w(f.identifier,{id:c}));o.length===1&&(n.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=g;async function l(a,r){if(!R.isLinux)return!1;let n;try{n=(await a.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await a.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){r.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(a,r){const n=await l(a,r),s=(0,t.getTargetPlatform)(n?"alpine":R.platform,u.arch);return r.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(te[72],ie([0,1,8,17,2,29,7,110,15,5,6]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let I=class extends M.Disposable{constructor(d,m){super(),this.fileService=d,this.logService=m,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(d){return this.withProfileExtensions(d)}addExtensionsToProfile(d,m){return this.withProfileExtensions(m,P=>(P=P.filter(b=>d.some(([p])=>!(0,E.areSameExtensions)(b.identifier,p.identifier))),P.push(...d.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),P))}removeExtensionFromProfile(d,m){return this.withProfileExtensions(m,P=>P.filter(b=>!(0,E.areSameExtensions)(b.identifier,d)))}async withProfileExtensions(d,m){return this.getResourceAccessQueue(d).queue(async()=>{let P=[];try{const b=await this.fileService.readFile(d),p=JSON.parse(b.value.toString());for(const y of p){if(!y.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",y);continue}if(!y.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",y);continue}if(!y.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",y);continue}P.push({identifier:y.identifier,location:D.URI.revive(y.location),version:y.version,metadata:y.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(m){P=m(P);const b=P.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(d,t.VSBuffer.fromString(JSON.stringify(b)))}return P})}getResourceAccessQueue(d){let m=this.resourcesAccessQueueMap.get(d);return m||(m=new S.Queue,this.resourcesAccessQueueMap.set(d,m)),m}};I=we([ee(0,u.IFileService),ee(1,v.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(te[218],ie([0,1,8,17,23,16,3,2,30,101,217,63]),function(z,e,S,t,M,R,D,E,u,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var d;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function m(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function P(B){const $=new M.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function b(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return M.CancellationToken.Cancelled;const L=new M.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class p{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function y(B,$){const L=new p($);return L.registerDisposable(B.onControlMessage(O=>{const U=JSON.parse(O.toString()),q=F(U);q?L.reject(q):L.resolve(U)})),L.promise}function h(B,$,L,O,U,q,Y,oe){const H=new p(oe);return $.connect(L,O,U,q,Y,(re,ne)=>{H.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?H.reject(re):H.resolve(ne)}),H.promise}function g(B,$){const L=new p($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function l(B,$,L,O){const U=N(B,$);B.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let q;try{q=await h(B.logService,B.socketFactory,B.host,B.port,(0,I.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${m($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Y,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(q,null),Y=B.reconnectionProtocol,oe=!1):(Y=new w.PersistentProtocol(q,null),oe=!0),B.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const H=await g(B.signService.createNewMessage((0,u.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:H.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await y(Y,b(O,P(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(B.logService.trace(`${U} 4/6. received SignRequest control message.`),!await g(B.signService.validate(H,ne.signedData),O)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ge=await g(B.signService.sign(ne.data),O),Re={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(Re.args=L),B.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Re))),{protocol:Y,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${U} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${U} received error control message when negotiating connection. Error:`),B.logService.error(ne)),oe&&j(Y),ne}}async function i(B,$,L,O){const U=Date.now(),q=N(B,$),{protocol:Y,ownsProtocol:oe}=await l(B,$,L,O),H=new p(O);return H.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=F(ne);ce?(B.logService.error(`${q} received error control message when negotiating connection. Error:`),B.logService.error(ce),oe&&j(Y),H.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${x(U)}!`),H.resolve({protocol:Y,firstMessage:ne}))})),H.promise}async function a(B,$){const{protocol:L}=await i(B,1,void 0,$);return{protocol:L}}async function r(B,$,L){const{protocol:O,firstMessage:U}=await i(B,2,$,L),q=U&&U.debugPort;return{protocol:O,debugPort:q}}async function n(B,$,L){const O=Date.now(),U=N(B,3),{protocol:q}=await l(B,3,$,L);return B.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${x(O)}!`),q}async function s(B,$,L){const{host:O,port:U,connectionToken:q}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:U,connectionToken:q,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,$,L){return f(B,async O=>{const{protocol:U}=await a(O,M.CancellationToken.None);return new he(B,$,L,O.reconnectionToken,U)})}e.connectRemoteAgentManagement=c;async function o(B,$){return f(B,async L=>{const{protocol:O,debugPort:U}=await r(L,$,M.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,U)})}e.connectRemoteAgentExtensionHost=o;async function f(B,$){for(let O=1;;O++)try{const U=(0,u.generateUuid)(),q=await s(B,U,null);return await $(q)}catch(U){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(U);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(U),se.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(U)),U}}async function k(B,$,L){const O=await s(B,(0,u.generateUuid)(),null);return await n(O,{host:$,port:L},M.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function T(B){return(0,S.createCancelablePromise)($=>new Promise((L,O)=>{const U=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(U),L()})}))}var _;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class G{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=G;class ae{constructor($,L,O,U){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=U,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class X{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class Q{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Q;class J{constructor($,L,O,U){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=J;class se extends E.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor($,L,O,U,q){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=U,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(U.onSocketClose(Y=>{const oe=W(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(Y=>{const oe=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,E.toDisposable)(()=>{const Y=se._instances.indexOf(this);Y>=0&&se._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const U=O<L.length?L[O]:L[L.length-1];try{if(U>0){const Y=T(U);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Y)),this._options.logService.info(`${$} waiting for ${U} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const q=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,P(C)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,R.isCancellationError)(q)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,v.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new J(this.reconnectionToken,$,L,O)),j(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class he extends se{constructor($,L,O,U,q){super(1,$,U,q,!0),this.client=this._register(new w.Client(q,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await a($,L)}}e.ManagementPersistentConnection=he;class V extends se{constructor($,L,O,U,q){super(2,$,O,U,!1),this._startArguments=L,this.debugPort=q}async _reconnect($,L){await r($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function j(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function F(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(B,$){for(;B.length<$;)B+=" ";return B}function W(B,$,L){return`[remote-connection][${A(m(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function N(B,$){return`${W($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function x(B){return`${Date.now()-B} ms`}}),define(te[219],ie([0,1,77,83]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,R,D,E,u,w){const v=C=>w(C,void 0),I=S.createConnection({host:M,port:R},()=>{I.removeListener("error",v);const C=Buffer.alloc(16);for(let b=0;b<16;b++)C[b]=Math.round(Math.random()*256);const d=C.toString("base64"),m=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${R}${D}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];I.write(m.join(`\r
`)+`\r
\r
`);const P=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",P),w(void 0,new t.NodeSocket(I,u)))};I.on("data",P)});I.setNoDelay(!0),I.once("error",v)}}}),define(te[220],ie([0,1,25,45,40,181]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function E(d=!1){return(D===void 0||d)&&(D=u()),D}e.hasWSLFeatureInstalled=E;async function u(){const d=w();if(d===void 0)return!1;if(d>=22e3){const m=I();if(m)return new Promise(P=>{t.execFile(m,["--status"],b=>P(!b))})}else{const m=C();if(m)try{if((await M.promises.stat(m)).isFile())return!0}catch{}}return!1}function w(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(d)return parseInt(d[3])}function v(d){const m=process.env.SystemRoot;if(m){const P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(m,P?"Sysnative":"System32",d)}}function I(){return v("wsl.exe")}function C(){return v("lxss\\LxssManager.dll")}}),define(te[55],ie([0,1,17,164,62,5,47]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function E(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=E;function u(P){return P.res.statusCode===204}async function w(P){return u(P)?null:(await(0,S.streamToBuffer)(P.stream)).toString()}e.asText=w;async function v(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);return w(P)}e.asTextOrError=v;async function I(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);if(u(P))return null;const p=(await(0,S.streamToBuffer)(P.stream)).toString();try{return JSON.parse(p)}catch(y){throw y.message+=`:
`+p,y}}e.asJson=I;function C(P){m(P)}e.updateProxyConfigurationsScope=C;let d;function m(P){const b=D.Registry.as(M.Extensions.Configuration),p=d;d={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[d],remove:p?[p]:[]})}m(2)}),define(te[221],ie([0,1,17,23]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class M{constructor(E){this.service=E}listen(E,u){throw new Error("Invalid listen")}call(E,u,w,v=t.CancellationToken.None){switch(u){case"request":return this.service.request(w[0],v).then(async({res:I,stream:C})=>{const d=await(0,S.streamToBuffer)(C);return[{statusCode:I.statusCode,headers:I.headers},d]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=M;class R{constructor(E){this.channel=E}async request(E,u){const[w,v]=await this.channel.call("request",[E],u);return{res:w,stream:(0,S.bufferToStream)(v)}}async resolveProxy(E){return this.channel.call("resolveProxy",[E])}}e.RequestChannelClient=R}),define(te[222],ie([0,1,223,12]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(D,E,u={}){const w=(0,S.parse)(D),v=u.proxyUrl||M(w,E);if(!v)return null;const I=(0,S.parse)(v);if(!/^https?:$/.test(I.protocol||""))return null;const C={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((d,m)=>{z(["http-proxy-agent"],d,m)}))(C):new(await new Promise((d,m)=>{z(["https-proxy-agent"],d,m)}))(C)}e.getProxyAgent=R}),define(te[111],ie([0,1,45,9,165,23,44,16,4,30,141,59,8]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const d=1e4;let m;async function P(p,y,h){return y["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(h)&&!y["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(h)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=C.Promises.withAsyncBody(async(g,l)=>{const i=new R.CancellationTokenSource,a=setTimeout(()=>{i.dispose(!0),l(new Error((0,M.localize)(0,null)))},d);try{g(await b(p,i.token))}catch(r){!(0,E.isCancellationError)(r)&&!i.token.isCancellationRequested?l(new Error((0,M.localize)(1,null,(0,D.toErrorMessage)(r)))):g({})}finally{clearTimeout(a),i.dispose()}})),m)}e.getResolvedShellEnv=P;async function b(p,y){const h=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",h);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",g);const l=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",a);const r=await(0,v.getSystemShell)(u.OS,a);return p.trace("getUnixShellEnvironment#shell",r),new Promise((n,s)=>{if(y.isCancellationRequested)return s((0,E.canceled)());const c=(0,t.basename)(r);let o,f;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${k} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(o=`'${process.execPath}' ${k} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),o);const T=(0,S.spawn)(r,[...f,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});y.onCancellationRequested(()=>(T.kill(),s((0,E.canceled)()))),T.on("error",ae=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),s(ae)});const _=[];T.stdout.on("data",ae=>_.push(ae));const G=[];T.stderr.on("data",ae=>G.push(ae)),T.on("close",(ae,X)=>{const Q=Buffer.concat(_).toString("utf8");p.trace("getUnixShellEnvironment#raw",Q);const J=Buffer.concat(G).toString("utf8");if(J.trim()&&p.trace("getUnixShellEnvironment#stderr",J),ae||X)return s(new Error((0,M.localize)(2,null,ae,X)));const se=i.exec(Q),he=se?se[1]:"{}";try{const V=JSON.parse(he);h?V.ELECTRON_RUN_AS_NODE=h:delete V.ELECTRON_RUN_AS_NODE,g?V.ELECTRON_NO_ATTACH_CONSOLE=g:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",V),n(V)}catch(V){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),s(V)}})})}}),define(te[87],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[224],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((M,R)=>z(["vsda"],M,R))}async createNewMessage(M){try{const R=await this.vsda(),D=new R.validator;if(D){const E=String(S._nextId++);return this.validators.set(E,D),{id:E,data:D.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,R){if(!M.id)return!0;const D=this.validators.get(M.id);if(!D)return!1;this.validators.delete(M.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(M){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(M)}catch{}return M}}e.SignService=S,S._nextId=1}),define(te[38],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(te[22],ie([0,1,13,41,8,3,2,4,34,12,5,6,38,27]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var m;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var P;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(P=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(y,h,g){super(),this.logService=y,this.stateMainService=h,this.environmentMainService=g,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",y);const h=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",h),S.app.once("will-quit",g=>{this.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",y),S.app.removeListener("window-all-closed",h),S.app.quit()})})}fireOnWillShutdown(y){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const h=[];return this._onWillShutdown.fire({reason:y,join(g){h.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await M.Promises.settled(h)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const h=this.phaseWhen.get(this._phase);h&&(h.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let h=this.phaseWhen.get(y);h||(h=new M.Barrier,this.phaseWhen.set(y,h)),await h.wait()}registerWindow(y){const h=new D.DisposableStore;this.windowCounter++,h.add(y.onWillLoad(l=>this._onWillLoadWindow.fire({window:y,workspace:l.workspace,reason:l.reason})));const g=(0,w.assertIsDefined)(y.win);g.on("close",l=>{const i=y.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),l.preventDefault(),this.unload(y,1).then(a=>{if(a){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(y),y.close()})}),g.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,h.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(y,h){await this.unload(y,3)||y.reload(h)}unload(y,h){const g=this.mapWindowIdToPendingUnload.get(y.id);if(g)return g;const l=this.doUnload(y,h).finally(()=>{this.mapWindowIdToPendingUnload.delete(y.id)});return this.mapWindowIdToPendingUnload.set(y.id,l),l}async doUnload(y,h){if(!y.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${y.id}`);const g=this._quitRequested?2:h,l=await this.onBeforeUnloadWindowInRenderer(y,g);return l?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(l)):(await this.onWillUnloadWindowInRenderer(y,g),!1)}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,h){return new Promise(g=>{const l=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${l}`,a=`vscode:cancel${l}`;t.validatedIpcMain.once(i,()=>{g(!1)}),t.validatedIpcMain.once(a,()=>{g(!0)}),y.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:a,reason:h})})}onWillUnloadWindowInRenderer(y,h){return new Promise(g=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>g()),y.send("vscode:onWillUnload",{replyChannel:i,reason:h})})}quit(y){return this.trace(`Lifecycle#quit() - begin (willRestart: ${y})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(y&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(h=>{this.pendingQuitPromiseResolve=h,this.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}trace(y){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(y):this.logService.trace(y)}async relaunch(y){this.trace("Lifecycle#relaunch()");const h=process.argv.slice(1);if(y?.addArgs&&h.push(...y.addArgs),y?.removeArgs)for(const i of y.removeArgs){const a=h.indexOf(i);a>=0&&h.splice(a,1)}const g=()=>{try{if(E.isWindows){const i=(0,u.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:h})};S.app.once("quit",g),await this.quit(!0)&&S.app.removeListener("quit",g)}async kill(y){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,M.timeout)(1e3),(async()=>{for(const h of S.BrowserWindow.getAllWindows())if(h&&!h.isDestroyed()){let g;h.webContents&&!h.webContents.isDestroyed()?g=new Promise(l=>h.once("closed",l)):g=Promise.resolve(),h.destroy(),await g}})()]),S.app.exit(y)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=we([ee(0,I.ILogService),ee(1,C.IStateMainService),ee(2,d.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(te[225],ie([0,1,4,3,2,5,22]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let E=class extends M.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((I,C)=>{z(["native-keymap"],I,C)});this._keyboardLayoutData=u(v),S.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=we([ee(0,D.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function u(w){const v=w.getKeyMap(),I=w.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:I}}}),define(te[226],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(te[227],ie([0,1,8,17,12,36,15,6]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(I,C,d){this.storagePath=I,this.logService=C,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,C){const d=this.storage[I];return(0,M.isUndefinedOrNull)(d)?C:d}setItem(I,C){this.setItems([{key:I,data:C}])}setItems(I){let C=!1;for(const{key:d,data:m}of I)this.storage[d]!==m&&((0,M.isUndefinedOrNull)(m)?(0,M.isUndefined)(this.storage[d])||(this.storage[d]=void 0,C=!0):(this.storage[d]=m,C=!0));C&&this.save()}removeItem(I){(0,M.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(C){this.logService.error(C)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let w=class{constructor(I,C,d){this.fileStorage=new u(I.stateResource,C,d)}async init(){await this.fileStorage.init()}getItem(I,C){return this.fileStorage.getItem(I,C)}};w=we([ee(0,R.IEnvironmentService),ee(1,E.ILogService),ee(2,D.IFileService)],w),e.StateService=w}),define(te[228],ie([0,1,227]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(te[112],ie([0,1,4,34,7,30]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function E(w,v,I,C,d,m,P,b,p,y){const h=Object.create(null);h["common.machineId"]=P,h.sessionID=(0,R.generateUuid)()+Date.now(),h.commitHash=d,h.version=m,h["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,S.PlatformToString)(S.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=C,h["common.product"]=y||"desktop",b&&(h["common.msftInternal"]=b);let g=0;const l=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),S.isLinuxSnap&&(h["common.snap"]="true");const i=D(I);i&&(h["common.platformDetail"]=i);try{const a=await w.readFile(M.URI.file(p));h["common.source"]=a.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=E;function u(w){const v=t.env.USERDNSDOMAIN;if(!v)return!1;const I=v.toLowerCase();return w.some(C=>I===C)}e.verifyMicrosoftInternalDomain=u}),define(te[32],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[229],ie([0,1,25,57,8,43,14,9,4,7,81,21,100,84,15,20,32]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function y(a,r){const n=`${a}::${r.join(":")}`,s=p.get(n);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,f=new Map,k=2e4;function T(G,ae,X,Q){const J=ae.substring(G.length+1);return M.Promises.withAsyncBody(async se=>{let he;try{he=await I.Promises.readdir(ae,{withFileTypes:!0})}catch{se();return}if(Q.count>=k){Q.count+=he.length,Q.maxReached=!0,se();return}let V=he.length;if(V===0){se();return}let j=he;Q.count+he.length>k&&(Q.maxReached=!0,V=k-Q.count,j=he.slice(0,V)),Q.count+=he.length;for(const F of j)if(F.isDirectory()){if(X.includes(F.name)||await T(G,(0,E.join)(ae,F.name),X,Q),--V===0){se();return}}else{const A=F.name.lastIndexOf(".");if(A>=0){const W=F.name.substring(A+1);W&&o.set(W,(o.get(W)??0)+1)}for(const W of c)W.relativePathPattern?.test(J)!==!1&&W.filePattern.test(F.name)&&f.set(W.tag,(f.get(W.tag)??0)+1);if(--V===0){se();return}}})}const _=M.Promises.withAsyncBody(async G=>{const ae={count:0,maxReached:!1};await T(a,a,r,ae);const X=await l(a);G({configFiles:h(f),fileTypes:h(o),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:X})});return p.set(n,_),_}e.collectWorkspaceStats=y;function h(a){return[...t.Iterable.map(a.entries(),([r,n])=>({name:r,count:n}))].sort((r,n)=>n.count-r.count)}function g(){const a={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},r=S.cpus();return r&&r.length>0&&(a.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),a}e.getMachineInfo=g;async function l(a){try{const r=new Map,n=(0,E.join)(a,".vscode","launch.json"),s=await I.Promises.readFile(n),c=[],o=(0,R.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(o)==="object"&&o.configurations)for(const f of o.configurations){const k=f.type;k&&(r.has(k)?r.set(k,r.get(k)+1):r.set(k,1))}return h(r)}catch{return[]}}e.collectLaunchConfigs=l;let i=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const s=S.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||n.push(`Load (avg):       ${S.loadavg().map(c=>Math.round(c)).join(", ")}`),n.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,C.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[c,o]=s,f=this.formatProcessList(r,c);return n.forEach(k=>{if((0,d.isRemoteDiagnosticError)(k))f+=`
${k.errorMessage}`,o+=`
${k.errorMessage}`;else if(f+=`

Remote: ${k.hostName}`,k.processes&&(f+=`
${this.formatProcessList(r,k.processes)}`),k.workspaceMetadata){o+=`
|  Remote: ${k.hostName}`;for(const T of Object.keys(k.workspaceMetadata)){const _=k.workspaceMetadata[T];let G=`${_.fileCount} files`;_.maxFilesReached&&(G=`more than ${G}`),o+=`|    Folder (${T}): ${G}`,o+=this.formatWorkspaceStats(_)}}}),{processInfo:f,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:c,os:o,cpus:f}=g(),k={os:o,memory:s,cpus:f,vmHint:c,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return u.isWindows||(k.load=`${S.loadavg().map(T=>Math.round(T)).join(", ")}`),u.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(r,n){const s=[];return(0,C.listProcesses)(r.mainPID).then(async c=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,c)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),n.forEach(o=>{if((0,d.isRemoteDiagnosticError)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.formatMachineInfo(o.machineInfo)),o.processes&&s.push(this.formatProcessList(r,o.processes)),o.workspaceMetadata)for(const f of Object.keys(o.workspaceMetadata)){const k=o.workspaceMetadata[f];let T=`${k.fileCount} files`;k.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${f}): ${T}`),s.push(this.formatWorkspaceStats(k))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const n=[];let c=0;const o=(_,G)=>{const ae=` ${_}(${G})`;c+ae.length>60?(n.push(f),f="|                 ",c=f.length):c+=ae.length,f+=ae};let f="|      File types:";const k=10,T=r.fileTypes.length>k?k:r.fileTypes.length;for(let _=0;_<T;_++){const G=r.fileTypes[_];o(G.name,G.count)}if(n.push(f),r.configFiles.length>=0&&(f="|      Conf files:",c=0,r.configFiles.forEach(_=>{o(_.name,_.count)}),n.push(f)),r.launchConfigFiles.length>0){let _="|      Launch Configs:";r.launchConfigFiles.forEach(G=>{_+=G.count>1?` ${G.name}(${G.count})`:` ${G.name}`}),n.push(_)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],s=[];return r.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(n.push(`|  Window (${c.title})`),c.folderURIs.forEach(o=>{const f=w.URI.revive(o);if(f.scheme===D.Schemas.file){const k=f.fsPath;s.push(y(k,["node_modules",".git"]).then(T=>{let _=`${T.fileCount} files`;T.maxFilesReached&&(_=`more than ${_}`),n.push(`|    Folder (${(0,E.basename)(k)}): ${_}`),n.push(this.formatWorkspaceStats(T))}).catch(T=>{n.push(`|      Error: Unable to collect workspace stats for folder ${k} (${T.toString()})`)}))}else n.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>n.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,o.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,s,c,n,0),c.join(`
`)}formatProcessItem(r,n,s,c,o){const f=o===0;let k;f?k=c.pid===r?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(o)} ${c.name}`,c.name==="window"&&(k=`${k} (${n.get(c.pid)})`));const T=process.platform==="win32"?c.mem:S.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(c.children)&&c.children.forEach(_=>this.formatProcessItem(r,n,s,_,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const c=w.URI.revive(s);if(c.scheme!==D.Schemas.file)continue;const o=c.fsPath;try{(await y(o,["node_modules",".git"])).fileTypes.forEach(k=>n.add(k.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=w.URI.revive(n);if(s.scheme!==D.Schemas.file)continue;const c=s.fsPath;try{const o=await y(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:f.name,count:f.count})}),o.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:f.name,count:f.count})}),o.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};i=we([ee(0,b.ITelemetryService),ee(1,P.IProductService)],i),e.DiagnosticsService=i}),define(te[230],ie([0,1,8,2,6,21,25,9,32,213]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;class v{constructor(d,m){this.node=d,this.callFrame=m,this.children=[],this.selfTime=-1,this.totalTime=-1}toString(){return`${this.callFrame.url}#${this.callFrame.functionName}@${this.callFrame.lineNumber}:${this.callFrame.columnNumber}`}static makeTotals(d){if(d.totalTime!==-1)return d.totalTime;let m=d.selfTime;for(const P of d.children)m+=v.makeTotals(P);return d.totalTime=m,m}}let I=class{constructor(d,m,P,b){this._window=d,this._sessionId=m,this._logService=P,this._telemetryService=b,this._profileAtOrAfter=0,this._session=new t.DisposableStore,this._isStarted=!1}async stop(){await this._isProfiling,this._logService.warn("[perf] STOPPING to monitor renderer",this._sessionId),this._session.clear();try{const d=this._window.webContents.debugger;await d.sendCommand("Profiler.disable"),d.detach()}catch{this._logService.error("[perf] FAILED to disable profiler",this._sessionId)}}receiveHeartbeat(){this._profileAtOrAfter=Date.now()+1e3}async start(){if(this._isStarted){this._logService.warn("[perf] already STARTED, ignoring request",this._sessionId);return}try{const m=this._window.webContents.debugger;m.attach(),await m.sendCommand("Profiler.enable")}catch{this._logService.error("[perf] FAILED to enable profiler",this._sessionId);return}this._logService.warn("[perf] started to EXPECT frequent heartbeat",this._sessionId),this._session.clear(),this._profileAtOrAfter=Date.now();const d=setInterval(()=>{Date.now()>=this._profileAtOrAfter&&(clearInterval(d),this._captureRendererProfile())},500);this._session.add((0,t.toDisposable)(()=>{this._isStarted=!1,clearInterval(d)}))}async _captureRendererProfile(){this._logService.warn("[perf] MISSED heartbeat, trying to profile renderer",this._sessionId);const d=(async()=>{const m=this._window.webContents.debugger;await m.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,S.timeout)(5e3);const P=await m.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId),await this._store(P.profile),this._digest(P.profile)})();this._isProfiling=d.catch(m=>{this._logService.error("[perf] profiling the renderer FAILED",this._sessionId),this._logService.error(m)}).finally(()=>{this._isProfiling=void 0})}async _store(d){try{const m=(0,E.join)((0,D.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await R.Promises.writeFile(m,JSON.stringify(d)),this._logService.info("[perf] stored profile to DISK",this._sessionId,m)}catch(m){this._logService.error("[perf] FAILED to write profile to disk",this._sessionId,m)}}_digest(d){if(!d.samples||!d.timeDeltas){this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId);return}w.Utils.rewriteAbsolutePaths(d,"piiRemoved");const m=new Map;for(const h of d.nodes)m.set(h.id,new v(h,h.callFrame));for(const h of d.nodes)if(h.children){const g=m.get(h.id);for(const l of h.children){const i=m.get(l);g.children.push(i),i.parent=g}}let b=d.endTime-d.startTime-d.timeDeltas[0];for(let h=0;h<d.samples.length-1;h++){const g=d.samples[h],l=m.get(g);if(l){const i=d.timeDeltas[h+1];l.selfTime+=i,b-=i}}const p=m.get(d.samples[d.samples.length-1]);p&&(p.selfTime+=b),m.forEach(v.makeTotals);const y=Array.from(m.values()).sort((h,g)=>g.selfTime-h.selfTime);if(y[0].callFrame.functionName==="(idle)"){this._logService.warn("[perf] top stack is IDLE, ignoring this profile...",this._sessionId),this._telemetryService.publicLog2("prof.sample",{sessionId:this._sessionId,selfTime:0,totalTime:0,functionName:"(idle)",callstack:""});return}for(let h=0;h<y.length&&!(h>4);h++){const g=y[h],l=[];let i=g;for(;i;)l.push(i.toString()),i=i.parent;const a={sessionId:this._sessionId,selfTime:g.selfTime/1e3,totalTime:g.totalTime/1e3,functionName:g.callFrame.functionName,callstack:l.join(`
`)};this._telemetryService.publicLog2("prof.freeze.sample",a)}}};I=we([ee(2,M.ILogService),ee(3,u.ITelemetryService)],I),e.WindowProfiler=I}),define(te[231],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:E,data:u}){return this.appenders.forEach(w=>w.log(E,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[73],ie([0,1,50,96,12,19,112,32]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,s){return Promise.resolve(void 0)}publicLog2(n,s){return this.publicLog(n,s)}publicLogError(n,s){return Promise.resolve(void 0)}publicLogError2(n,s){return this.publicLogError(n,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class w{async publicLog(n,s,c){}async publicLogError(n,s,c){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(r,n){return n.onDidChangeConfiguration(s=>{s.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=v;function I(r,n){return!(n.disableTelemetry||!r.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=I;function C(r){const n=r.getValue(E.TELEMETRY_SETTING_ID),s=r.getValue("telemetry.enableCrashReporter");if(r.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function d(r){const n={},s={},c={};b(r,c);for(let o in c){o=o.length>150?o.substr(o.length-149):o;const f=c[o];typeof f=="number"?s[o]=f:typeof f=="boolean"?s[o]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${f.length}`),n[o]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(n[o]=f)}return{properties:n,measurements:s}}e.validateTelemetryData=d;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function P(r){if(!r)return"none";for(const n of m)if(r.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=P;function b(r,n,s=0,c){if(!!r)for(const o of Object.getOwnPropertyNames(r)){const f=r[o],k=c?c+o:o;Array.isArray(f)?n[k]=(0,S.safeStringify)(f):f instanceof Date?n[k]=f.toISOString():(0,M.isObject)(f)?s<2?b(f,n,s+1,k+"."):n[k]=(0,S.safeStringify)(f):n[k]=f}}function p(r){if(!r)return[];const n=[];return y(n,"",r),n}function y(r,n,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(c=>y(r,n?`${n}.${c}`:c,s[c])):r.push(n)}function h(r,n){const s=r.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||c}e.isInternalTelemetry=h;function g(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=g;function l(r,n){let s=r;const c=[];for(const T of n)for(;;){const _=T.exec(r);if(!_)break;c.push([_.index,T.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(s="";;){const T=f.exec(r);if(!T)break;!o.test(T[0])&&c.every(([_,G])=>T.index<_||T.index>=G)&&(s+=r.substring(k,T.index)+"<REDACTED: user-file-path>",k=f.lastIndex)}return k<r.length&&(s+=r.substr(k)),s}function i(r){if(!r)return r;const n=r.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of s)if(c.regex.test(n))return`<REDACTED: ${c.label}>`;return r}function a(r,n){return(0,S.cloneAndChange)(r,s=>{if(typeof s=="string"){let c=s;c=l(c,n);for(const o of n)c=c.replace(o,"");return c=i(c),c}})}e.cleanData=a}),define(te[232],ie([0,1,187,73]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function M(R,D,E,u,w,v,I){const C={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,E)&&(0,t.getTelemetryLevel)(u)===3){const d=await(0,S.getServiceMachineId)(E,w,v),{sessionId:m}=await I.getTelemetryInfo();C["X-Market-User-Id"]=d,C["VSCode-SessionId"]=m}return C}e.resolveMarketplaceHeaders=M}),define(te[233],ie([0,1,2,50,96,4,26,166,19,62,54,20,47,32,73]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(y,h,g){this._configurationService=h,this._productService=g,this._experimentProperties={},this.telemetryLevel=new M.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(y,h){this._experimentProperties[y]=h}_updateTelemetryLevel(){let y=(0,m.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;y=Math.min(y,g)}this.telemetryLevel.value=y}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const y=await this._commonProperties,h=y.sessionID,g=y["common.machineId"],l=y["common.firstSessionDate"],i=y["common.msftInternal"];return{sessionId:h,machineId:g,firstSessionDate:l,msftInternal:i}}dispose(){this._disposables.dispose()}_log(y,h,g,l){return this.telemetryLevel.value<h?Promise.resolve(void 0):this._commonProperties.then(i=>{g=(0,t.mixin)(g,i),g=(0,t.mixin)(g,this._experimentProperties),g=(0,m.cleanData)(g,this._cleanupPatterns),this._appenders.forEach(a=>a.log(y,g))},i=>{console.error(i)})}publicLog(y,h,g){return this._log(y,3,h,g)}publicLog2(y,h,g){return this.publicLog(y,h,g)}publicLogError(y,h){return this._sendErrorTelemetry?this._log(y,2,h,!0):Promise.resolve(void 0)}publicLogError2(y,h){return this.publicLogError(y,h)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=we([ee(1,u.IConfigurationService),ee(2,I.IProductService)],P),e.TelemetryService=P;function b(){const p=(0,E.localize)(0,null,v.default.nameLong),y=v.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=R.isWeb?"":(0,E.localize)(3,null),g=(0,E.localize)(4,null),l=(0,E.localize)(5,null),i=(0,E.localize)(6,null),a=(0,E.localize)(7,null),r=`
|       | ${g} | ${l} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,E.localize)(8,null);return`
${p} ${y} ${h}

&nbsp;

${a}
${r}

&nbsp;

${n}
`}C.Registry.as(w.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(w.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,E.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,E.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[234],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function M(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=M}),define(te[235],ie([0,1,118,3,2,5,47,234]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(b){function p(y){return y&&typeof y=="object"&&typeof y.id=="string"}b.isThemeColor=p})(u=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var v;(function(b){function p(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||u.isThemeColor(n.color))}b.isThemeIcon=p;const y=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function h(n){const s=y.exec(n);if(!s)return;const[,c]=s;return{id:c}}b.fromString=h;function g(n){return{id:n}}b.fromId=g;function l(n,s){let c=n.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),s&&(c=`${c}~${s}`),{id:c}}b.modify=l;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}b.getModifier=i;function a(n,s){return n.id===s.id&&n.color?.id===s.color?.id}b.isEqual=a;function r(n,s){return{id:n.id,color:s?w(s):void 0}}b.asThemeIcon=r,b.asClassNameArray=S.CSSIcon.asClassNameArray,b.asClassName=S.CSSIcon.asClassName,b.asCSSSelector=S.CSSIcon.asCSSSelector})(v=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function I(b){switch(b){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,M.toDisposable)(()=>{const y=this.themingParticipants.indexOf(p);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const d=new C;D.Registry.add(e.Extensions.ThemingContribution,d);function m(b){return d.onColorThemeChange(b)}e.registerThemingParticipant=m;class P extends M.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,y){let h=this.theme.getColor(p);return h&&y&&(h=y(h,this.theme)),h?h.toString():null}}e.Themable=P}),define(te[64],ie([0,1,13,3,2,4,19,5,38]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",v="#1E1E1E",I="#000000",C="#FFFFFF",d="theme",m="themeBackground",P="windowSplash";e.IThemeMainService=(0,E.createDecorator)("themeMainService");let b=class extends M.Disposable{constructor(y,h){super(),this.stateMainService=y,this.configurationService=h,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const y=this.getColorScheme();if(y.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return y.dark?I:C;let h=this.stateMainService.getItem(m,null);if(!h)switch(this.stateMainService.getItem(d,"vs-dark").split(" ")[0]){case"vs":h=w;break;case"hc-black":h=I;break;case"hc-light":h=C;break;default:h=v}return R.isMacintosh&&h.toUpperCase()===v&&(h="#171717"),h}saveWindowSplash(y,h){this.stateMainService.setItems([{key:d,data:h.baseTheme},{key:m,data:h.colorInfo.background},{key:P,data:h}]),typeof y=="number"&&this.updateBackgroundColor(y,h)}updateBackgroundColor(y,h){for(const g of S.BrowserWindow.getAllWindows())if(g.id===y){g.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};b=we([ee(0,u.IStateMainService),ee(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(te[113],ie([0,1,3,4,5,6]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var D;(function(P){P.Http="http",P.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=I;function C(P,b){return b?b!==1&&P<1024:!t.isWindows&&P<1024}e.isPortPrivileged=C;class d{constructor(b,p,y){this.remoteAddress=b,this.localAddress=p,this._dispose=y,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let m=class{constructor(b){this.logService=b,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const y of p){const h=Array.from(y.values());for(const g of h){const l=await g.value;l&&b.push(l)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(y=>y?.dispose());b.clear()}this._tunnels.clear()}setEnvironmentTunnel(b,p,y,h,g){this.addTunnelToMap(b,p,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:p,localAddress:y,privacy:h,protocol:g,dispose:()=>Promise.resolve()}))}openTunnel(b,p,y,h,g=!1,l,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${y} on local port ${h}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(y)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.retainOrCreateTunnel(b,p,y,h,g,l,i);return a?a.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==p||r.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const y=p.get(b.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,y))}}}}async tryDisposeTunnel(b,p,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const h=y.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),h}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const y=this._tunnels.get(b);if(y&&y.has(p)){const h=y.get(p);h.refcount=0,await this.tryDisposeTunnel(b,p,h)}}addTunnelToMap(b,p,y){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:y})}async removeEmptyTunnelFromMap(b,p){const y=this._tunnels.get(b);y&&(await y.get(p)||y.delete(p),y.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const y=[b];v(b)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):I(b)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const h=y.map(g=>this._tunnels.get(g));for(const g of h){const l=g?.get(p);if(l)return l}}canTunnel(b){return!!w(b)}doIsPortPrivileged(b,p,y,h){if(p)return!1;if(y){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(g?.length===4){const l=parseInt(g[1]),i=parseInt(g[2]);if(l>10||l===10&&i>=14)return!1}}return b<1024}createWithProvider(b,p,y,h,g,l,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${y} on local port ${h}.`);const a=y;this._factoryInProgress.add(a);const r=h===void 0?y:h,n={elevationRequired:g?this.isPortPrivileged(r):!1},s={remoteAddress:{host:p,port:y},localAddressPort:h,privacy:l,public:l?l!==E.Private:void 0,protocol:i},c=b.forwardPort(s,n);return c?(this.addTunnelToMap(p,y,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),c}};m=we([ee(0,R.ILogService)],m),e.AbstractTunnelService=m}),define(te[236],ie([0,1,77,25,95,219,8,2,19,6,20,218,113,87,4]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function P(g,l,i,a,r){let n;for(let s=3;s&&(n?.dispose(),n=await new b(g,l,i,a,r).waitForReady(),!(r&&M.BROWSER_RESTRICTED_PORTS[r]||!M.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class b extends E.Disposable{constructor(l,i,a,r,n){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=n,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=S.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){let l=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),i=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(l){l.pause();const i=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,I.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),r=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&l.write(n.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),r.end()}),l.on("close",()=>r.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),r.destroy()}),r.on("end",()=>l.end()),r.on("close",()=>l.end()),r.on("error",()=>{l.destroy()}),l.pipe(r),r.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),r.end()})}}let p=class extends C.AbstractTunnelService{constructor(l,i,a,r,n){super(i),this.socketFactory=l,this.signService=a,this.productService=r,this.configurationService=n}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(l){return this.doIsPortPrivileged(l,m.isWindows,m.isMacintosh,t.release())}retainOrCreateTunnel(l,i,a,r,n,s,c){const o=this.getTunnelFromMap(i,a);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,a,r,n,s,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${a} on local port ${r}.`);const f={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},k=P(f,this.defaultTunnelHost,i,a,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,a,k),k}}};p=we([ee(1,w.ILogService),ee(2,d.ISignService),ee(3,v.IProductService),ee(4,u.IConfigurationService)],p),e.BaseTunnelService=p;let y=class extends p{constructor(l,i,a,r){super(R.nodeSocketFactory,l,i,a,r)}};y=we([ee(0,w.ILogService),ee(1,d.ISignService),ee(2,v.IProductService),ee(3,u.IConfigurationService)],y),e.TunnelService=y;let h=class extends E.Disposable{constructor(l,i,a,r){super(),this.logService=l,this.productService=i,this.signService=a,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(l,i,a,r,n,s,c,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${r} on local port ${n}.`),!this._tunnelServices.has(l)){const f=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(f),this._tunnelServices.set(l,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(i,a,r,n,s,c,o)}};h=we([ee(0,w.ILogService),ee(1,v.IProductService),ee(2,d.ISignService),ee(3,u.IConfigurationService)],h),e.SharedTunnelsService=h}),define(te[48],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var M;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(te[237],ie([0,1,4,167,62,47]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[238],ie([0,1,3,48]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(E){this.service=E}listen(E,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(E,u,w){switch(u){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(w)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=M;class R{get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}constructor(E){this.channel=E,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(E){return this.channel.call("_applySpecificUpdate",E)}}e.UpdateChannelClient=R}),define(te[88],ie([0,1,8,23,3,19,27,22,6,20,55,48]),function(z,e,S,t,M,R,D,E,u,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function C(m,P,b){return`${b.updateUrl}/api/update/${m}/${P}/${b.commit}`}e.createUpdateURL=C;let d=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,b,p,y,h,g){this.lifecycleMainService=P,this.configurationService=b,this.environmentMainService=p,this.requestService=y,this.logService=h,this.productService=g,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const P=this.getUpdateMode(),b=this.getProductQuality(P);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),P==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}P==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(P){return P==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(P=60*60*1e3){return(0,S.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(P){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(P){}getUpdateType(){return 1}doQuitAndInstall(){}};d=we([ee(0,E.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,v.IRequestService),ee(4,u.ILogService),ee(5,w.IProductService)],d),e.AbstractUpdateService=d}),define(te[239],ie([0,1,13,53,3,2,19,27,22,6,20,55,32,48,88]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let P=class extends m.AbstractUpdateService{get onRawError(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"error",(p,y)=>y)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(p,y,h)=>({url:y,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(p,y,h,g)=>({releaseNotes:y,version:h,productVersion:h,date:g}))}constructor(p,y,h,g,l,i,a){super(p,y,g,l,i,a),this.telemetryService=h,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(d.State.Idle(1,h))}buildUpdateFeedUrl(p){let y;this.productService.darwinUniversalAssetId?y=this.productService.darwinUniversalAssetId:y=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,m.createUpdateURL)(y,p,this.productService);try{S.autoUpdater.setFeedURL({url:h})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return h}doCheckForUpdates(p){this.setState(d.State.CheckingForUpdates(p)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(d.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([t.memoize],P.prototype,"onRawError",null),we([t.memoize],P.prototype,"onRawUpdateNotAvailable",null),we([t.memoize],P.prototype,"onRawUpdateAvailable",null),we([t.memoize],P.prototype,"onRawUpdateDownloaded",null),P=we([ee(0,u.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,C.ITelemetryService),ee(3,E.IEnvironmentMainService),ee(4,I.IRequestService),ee(5,w.ILogService),ee(6,v.IProductService)],P),e.DarwinUpdateService=P}),define(te[240],ie([0,1,45,40,8,3,9,27,22,6,32,48]),function(z,e,S,t,M,R,D,E,u,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let C=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,b,p){if(this.lifecycleMainService=P,this.logService=p,this._state=I.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}scheduleCheckForUpdates(P=60*60*1e3){return(0,M.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(P){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(P){}};C=we([ee(0,u.ILifecycleMainService),ee(1,E.IEnvironmentMainService),ee(2,w.ILogService)],C);let d=class extends C{constructor(P,b,p,y,h,g){super(p,y,h),this.snap=P,this.snapRevision=b,this.telemetryService=g;const l=(0,t.watch)(D.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(l,"change",(s,c)=>c),a=R.Event.filter(i,s=>s==="current"),n=R.Event.debounce(a,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{n.dispose(),l.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(P=>{P?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,P.message||P))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const P=await new Promise((p,y)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(h,g)=>h?y(h):p(g))),b=D.basename(P);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,P=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=we([ee(2,u.ILifecycleMainService),ee(3,E.IEnvironmentMainService),ee(4,w.ILogService),ee(5,v.ITelemetryService)],d),e.SnapUpdateService=d}),define(te[51],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(te[241],ie([0,1,51,188,15,18,124,3,2]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(C){this.uri=C,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let v=class{constructor(C){this._fileService=C,this._dispooables=new u.DisposableStore,this._limit=2**16;const d=new Map,m=P=>{let b=d.get(P.scheme);return b===void 0&&(b=C.hasProvider(P)&&!this._fileService.hasCapability(P,1024),d.set(P.scheme,b)),b};this._dispooables.add(E.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(P=>{d.delete(P.scheme)})),this.extUri=new R.ExtUri(m),this._canonicalUris=new D.SkipList((P,b)=>this.extUri.compare(P,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(C){this._fileService.hasProvider(C)&&(C=(0,R.normalizePath)(C));const d=this._canonicalUris.get(C);return d?d.touch().uri.with({fragment:C.fragment}):(this._canonicalUris.set(C,new w(C)),this._checkTrim(),C)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const C=[...this._canonicalUris.entries()].sort((m,P)=>m[1].touch<P[1].touch?1:m[1].touch>P[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let m=0;m<d;m++)this._canonicalUris.set(C[m][0],C[m][1].touch())}};v=we([ee(0,M.IFileService)],v),e.UriIdentityService=v,(0,t.registerSingleton)(S.IUriIdentityService,v,1)}),define(te[114],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(te[242],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(E){this.handler=E}listen(E,u){throw new Error(`Event not found: ${u}`)}call(E,u,w){switch(u){case"handleURL":return this.handler.handleURL(S.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class M{constructor(E){this.channel=E}handleURL(E,u){return this.channel.call("handleURL",[E.toJSON(),u])}}e.URLHandlerChannelClient=M;class R{constructor(E){this.next=E}async routeCall(E,u,w,v){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(w){const I=S.URI.revive(w);if(I&&I.query){const C=/\bwindowId=(\d+)/.exec(I.query);if(C){const d=C[1],m=new RegExp(`window:${d}`),P=E.connections.find(b=>m.test(b.ctx));if(P)return P}}}return this.next.routeCall(E,u,w,v)}routeEvent(E,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(te[243],ie([0,1,8,2,7,20]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(w,v){const I=[...this.handlers.values()];return(0,S.first)(I.map(C=>()=>C.handleURL(w,v)),void 0,!1).then(C=>C||!1)}registerHandler(w){return this.handlers.add(w),(0,t.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=D;let E=class extends D{constructor(w){super(),this.productService=w}create(w){let{authority:v,path:I,query:C,fragment:d}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&I&&I.indexOf("/")!==0&&(I=`/${I}`),M.URI.from({scheme:this.productService.urlProtocol,authority:v,path:I,query:C,fragment:d})}};E=we([ee(0,R.IProductService)],E),e.NativeURLService=E}),define(te[244],ie([0,1,13,8,3,2,4,7]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(v){try{return E.URI.parse(v)}catch{return null}}class w{constructor(I,C,d,m,P){if(this.urlService=C,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=I,D.isWindows){const y=m.isBuilt?[]:[`"${m.appRoot}"`];y.push("--open-url","--"),S.app.setAsDefaultProtocolClient(P.urlProtocol,process.execPath,y)}const b=M.Event.map(M.Event.fromNodeEventEmitter(S.app,"open-url",(y,h)=>({event:y,url:h})),({event:y,url:h})=>(y.preventDefault(),h));this.disposables.add(b(y=>{const h=u(y);!h||this.urlService.open(h,{originalUrl:y})})),d.getWindows().filter(y=>y.isReady).length>0?this.flush():M.Event.once(d.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const C of this.uris)await this.urlService.open(C.uri,{originalUrl:C.url})||I.push(C);I.length!==0&&(this.uris=I,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(te[245],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(te[246],ie([0,1,13,2,14,7]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(M.Schemas.vscodeWebview,u)}handleWebviewRequest(u,w){try{const v=R.URI.parse(u.url),I=D.validWebviewFilePaths.get(v.path);if(typeof I=="string"){const C=`vs/workbench/contrib/webview/browser/pre/${I}`,d=M.FileAccess.asFileUri(C,z);return w({path:decodeURIComponent(d.fsPath),headers:{...M.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(v){return!!v.workspaceUri}e.isWorkspaceToOpen=t;function M(v){return!!v.folderUri}e.isFolderToOpen=M;function R(v){return!!v.fileUri}e.isFileToOpen=R;function D(v){const I=E(v),C=v.getValue("window.menuBarVisibility");return C==="default"||I==="native"&&C==="compact"||S.isMacintosh&&S.isNative?"classic":C}e.getMenuBarVisibility=D;function E(v){if(S.isWeb)return"custom";const I=v.getValue("window");if(I){if(S.isMacintosh&&I.nativeTabs===!0||S.isMacintosh&&I.nativeFullScreen===!1)return"native";const m=I.titleBarStyle;if(m==="native"||m==="custom")return m}return S.isLinux?"native":"custom"}e.getTitleBarStyle=E;function u(v){if(!S.isWindows||S.isWeb||E(v)==="native")return!1;const I=v.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!1}e.useWindowControlsOverlay=u;function w(v=0){return Math.pow(1.2,v)}e.zoomLevelToZoomFactor=w}),define(te[115],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const M=function(E=1){return{width:1024,height:768,mode:E}};e.defaultWindowState=M;var R;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(te[33],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(M){M[M.CLI=0]="CLI",M[M.DOCK=1]="DOCK",M[M.MENU=2]="MENU",M[M.DIALOG=3]="DIALOG",M[M.DESKTOP=4]="DESKTOP",M[M.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[247],ie([0,1,13,23,3,66,2,30,69,105,6,20,33]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(P){P[P.Initial=1]="Initial",P[P.StoredCredentialsUsed=2]="StoredCredentialsUsed",P[P.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let m=class extends D.Disposable{constructor(b,p,y,h,g){super(),this.logService=b,this.windowsMainService=p,this.credentialsService=y,this.encryptionMainService=h,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=d.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(S.app,"login",(p,y,h,g,l)=>({event:p,webContents:y,req:h,authInfo:g,callback:l}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:y,callback:h}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===d.LoginDialogShown&&y.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(g?.username,g?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let y,h;try{const a=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(a){const r=JSON.parse(await this.encryptionMainService.decrypt(a));y=r.username,h=r.password}}catch(a){this.logService.error(a)}if(this.state!==d.StoredCredentialsUsed&&typeof y=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=d.StoredCredentialsUsed,{username:y,password:h};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const l={authInfo:b,username:this.sessionCredentials?.username??y,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=d.LoginDialogShown;const i=await new Promise(a=>{const r=async(n,s,c)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",r),c){const o={username:c.username,password:c.password};try{if(c.remember){const f=await this.encryptionMainService.encrypt(JSON.stringify(o));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,f)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(f){this.logService.error(f)}a({username:o.username,password:o.password})}else a(void 0)};g.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};m=we([ee(0,v.ILogService),ee(1,C.IWindowsMainService),ee(2,u.ICredentialsMainService),ee(3,w.IEncryptionMainService),ee(4,I.IProductService)],m),e.ProxyAuthHandler=m}),define(te[248],ie([0,1,69,6,36,20,33,200]),function(z,e,S,t,M,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends E.BaseCredentialsMainService{constructor(v,I,C,d){super(v),this.environmentMainService=I,this.productService=C,this.windowsMainService=d,this.surfaceKeytarLoadError=m=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",m.message??m)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const v=await new Promise((I,C)=>{z(["keytar"],I,C)});return await v.findCredentials("test-keytar-loads"),this._keytarCache=v,this._keytarCache}};u=we([ee(0,t.ILogService),ee(1,M.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(te[249],ie([0,1,16,2,3,6,22,79,45,279,8,14,50,4,34,13,33]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=P.UtilityProcess,y=typeof p<"u";let h=class Ut{constructor(a,r,n){this._logService=a,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,r.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(a){const r=this._extHosts.get(a);if(!r)throw new Error("Unknown extension host!");return r}onDynamicStdout(a){return this._getExtHost(a).onStdout}onDynamicStderr(a){return this._getExtHost(a).onStderr}onDynamicMessage(a){return this._getExtHost(a).onMessage}onDynamicError(a){return this._getExtHost(a).onError}onDynamicExit(a){return this._getExtHost(a).onExit}async canUseUtilityProcess(){return y}async createExtensionHost(a){if(this._shutdown)throw(0,S.canceled)();const r=String(++Ut._lastId);let n;if(a){if(!y)throw new Error("Cannot use UtilityProcess!");n=new l(r,this._logService,this._windowsMainService)}else n=new g(r,this._logService);return this._extHosts.set(r,n),n.onExit(({pid:s,code:c,signal:o})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(r)})}),{id:r}}async start(a,r){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(a).start(r)}async enableInspectPort(a){if(this._shutdown)throw(0,S.canceled)();const r=this._extHosts.get(a);return r?r.enableInspectPort():!1}async kill(a){if(this._shutdown)throw(0,S.canceled)();const r=this._extHosts.get(a);!r||r.kill()}async _killAllNow(){for(const[,a]of this._extHosts)a.kill()}async _waitForAllExit(a){const r=[];for(const[,n]of this._extHosts)r.push(n.waitForExit(a));return v.Promises.settled(r).then(()=>{})}};h._lastId=0,h=we([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,b.IWindowsMainService)],h),e.ExtensionHostStarter=h;let g=class extends t.Disposable{constructor(a,r){super(),this.id=a,this._logService=r,this._onStdout=this._register(new M.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new M.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new M.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onExit=this._register(new M.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(a){d.isCI&&this._logService.info("Calling fork to start extension host...");const r=E.StopWatch.create(!1);this._process=(0,u.fork)(I.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,C.mixin)({cwd:(0,m.cwd)()},a));const n=r.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${n} ms).`);const c=new w.StringDecoder("utf-8");this._process.stdout?.on("data",f=>{const k=typeof f=="string"?f:c.write(f);this._onStdout.fire(k)});const o=new w.StringDecoder("utf-8");this._process.stderr?.on("data",f=>{const k=typeof f=="string"?f:o.write(f);this._onStderr.fire(k)}),this._process.on("message",f=>{this._onMessage.fire(f)}),this._process.on("error",f=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(f)})}),this._process.on("exit",(f,k)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:f,signal:k})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):d.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(a){if(!this._process)return;const r=this._process.pid;this._logService.info(`Waiting for extension host with pid ${r} to exit.`),await Promise.race([M.Event.toPromise(this.onExit),(0,v.timeout)(a)]),this._hasExited||(this._logService.info(`Extension host with pid ${r} did not exit within ${a}ms.`),this._process.kill())}};g=we([ee(1,R.ILogService)],g);let l=class extends t.Disposable{constructor(a,r,n){super(),this.id=a,this._logService=r,this._windowsMainService=n,this.onError=M.Event.None,this._onStdout=this._register(new M.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new M.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new M.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new M.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(a){const r=this._windowsMainService.getWindowById(a.responseWindowId);if(!r){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=r.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=I.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],f=a.execArgv||[],k={...a.env},T=!0;for(const J of Object.keys(k))k[J]=String(k[J]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,o,{serviceName:s,env:k,execArgv:f,allowLoadingUnsignedLibraries:T});const _=new w.StringDecoder("utf-8");this._process.stdout?.on("data",J=>{const se=typeof J=="string"?J:_.write(J);this._onStdout.fire(se)});const G=new w.StringDecoder("utf-8");this._process.stderr?.on("data",J=>{const se=typeof J=="string"?J:G.write(J);this._onStderr.fire(se)}),this._process.on("message",J=>{this._onMessage.fire(J)}),this._register(M.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=M.Event.fromNodeEventEmitter(this._process,"exit",(J,se)=>se);this._register(ae(J=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${J}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:J,signal:""})}));const{port1:X,port2:Q}=new P.MessageChannelMain;this._process.postMessage("null",[Q]),n.webContents.postMessage(a.responseChannel,a.responseNonce,[X])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(a){if(!this._process)return;const r=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${r} to exit.`),await Promise.race([M.Event.toPromise(this.onExit),(0,v.timeout)(a)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${r} did not exit within ${a}ms, will kill it now.`),this._process.kill())}};l=we([ee(1,R.ILogService),ee(2,b.IWindowsMainService)],l)}),define(te[250],ie([0,1,13,3,2,246,33]),function(z,e,S,t,M,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends M.Disposable{constructor(w){super(),this.windowsMainService=w,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,v){let I;if(typeof w.windowId=="number"){const{windowId:C}=w,d=this.windowsMainService.getWindowById(C);if(!d?.win)throw new Error(`Invalid windowId: ${C}`);I=d.win.webContents}else{const{webContentsId:C}=w;if(I=S.webContents.fromId(C),!I)throw new Error(`Invalid webContentsId: ${C}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(v)}async findInFrame(w,v,I,C){const m=this.getFrameByName(w,v);if(typeof m.findInFrame=="function"){m.findInFrame(I,{findNext:C.findNext,forward:C.forward});const P=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),m.removeListener("found-in-frame",P))};m.on("found-in-frame",P)}}async stopFindInFrame(w,v,I){const d=this.getFrameByName(w,v);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,v){const I=this.windowsMainService.getWindowById(w.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${w}`);const C=I.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===v);if(!C)throw new Error(`Unknown frame: ${v}`);return C}};E=we([ee(0,D.IWindowsMainService)],E),e.WebviewMainService=E}),define(te[251],ie([0,1,8,3,2]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends M.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:u,getActiveWindowId:w}){super(),this.disposables=this._register(new M.DisposableStore),t.Event.latch(t.Event.any(E,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>w()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[28],ie([0,1,171,9,29,18,7,5,14]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function w(a){const r=a;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function v(a,r){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,t.basename)(a)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=a;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=v;function I(a){const r=a;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=I;function C(a){const r=a;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const n=a;if(n?.configPath)return{id:n.id,configPath:D.URI.revive(n.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=C;var d;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function m(a){const r=a;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=m;function P(a){const r=a;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=P;class b{constructor(r,n,s,c,o){this._id=r,this._transient=s,this._configuration=c,this._ignorePathCasing=o,this._foldersMap=M.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=M.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(r,n){this.raw=n,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function y(a){return new p({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(a,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,r.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function g(a){let r;return D.URI.isUri(a)?r=a:r=a.configuration,r?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=g;function l(a,r){return!h(a,r)&&!g(a)}e.isSavedWorkspace=l;function i(a){return(typeof a=="string"?(0,t.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[56],ie([0,1,13,8,66,35,2,80,4,12,21,148,5,6,28]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,C.createDecorator)("dialogMainService");let P=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,y){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},y)}pickFolder(p,y){return this.doPick({...p,pickFolders:!0,title:(0,I.localize)(1,null)},y)}pickFile(p,y){return this.doPick({...p,pickFiles:!0,title:(0,I.localize)(2,null)},y)}pickWorkspace(p,y){const h=(0,I.localize)(3,null),g=(0,R.mnemonicButtonLabel)((0,I.localize)(4,null)),l=m.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:h,filters:l,buttonLabel:g},y)}async doPick(p,y){const h={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(h.properties=void 0,p.pickFiles&&p.pickFolders&&(h.properties=["multiSelections","openDirectory","openFile","createDirectory"])),h.properties||(h.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&h.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(h,(0,w.withNullAsUndefined)(y||S.BrowserWindow.getFocusedWindow()));if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}getWindowDialogQueue(p){if(p){let y=this.windowDialogQueues.get(p.id);return y||(y=new t.Queue,this.windowDialogQueues.set(p.id,y)),y}else return this.noWindowDialogueQueue}showMessageBox(p,y){return this.getWindowDialogQueue(y).queue(async()=>y?S.dialog.showMessageBox(y,p):S.dialog.showMessageBox(p))}async showSaveDialog(p,y){const h=this.acquireFileDialogLock(p,y);if(!h)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(y).queue(async()=>{let g;return y?g=await S.dialog.showSaveDialog(y,p):g=await S.dialog.showSaveDialog(p),g.filePath=this.normalizePath(g.filePath),g})}finally{(0,D.dispose)(h)}}normalizePath(p){return p&&u.isMacintosh&&(p=(0,E.normalizeNFC)(p)),p}normalizePaths(p){return p.map(y=>this.normalizePath(y))}async showOpenDialog(p,y){p.defaultPath&&(await v.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const h=this.acquireFileDialogLock(p,y);if(!h)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(y).queue(async()=>{let g;return y?g=await S.dialog.showOpenDialog(y,p):g=await S.dialog.showOpenDialog(p),g.filePaths=this.normalizePaths(g.filePaths),g})}finally{(0,D.dispose)(h)}}acquireFileDialogLock(p,y){if(!y)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let h=this.windowFileDialogLocks.get(y.id);h||(h=new Set,this.windowFileDialogLocks.set(y.id,h));const g=(0,M.hash)(p);if(!h.has(g))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),h.add(g),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),h?.delete(g),h?.size===0&&this.windowFileDialogLocks.delete(y.id)})}};P=we([ee(0,d.ILogService)],P),e.DialogMainService=P}),define(te[252],ie([0,1,3,2,67,28]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,w){super(),this.logService=u,this.storageMainService=w,this.onDidChangeApplicationStorageEmitter=this._register(new S.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(w.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,w){this._register(S.Event.debounce(u.onDidChangeStorage,(v,I)=>(v?v.push(I):v=[I],v),D.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&w.fire(this.serializeStorageChangeEvents(v,u))}))}serializeStorageChangeEvents(u,w){const v=new Map,I=new Set;return u.forEach(C=>{const d=w.get(C.key);typeof d=="string"?v.set(C.key,d):I.add(C.key)}),{changed:Array.from(v.entries()),deleted:Array.from(I.values())}}listen(u,w,v){switch(w){case"onDidChangeStorage":{const I=v.profile?(0,M.revive)(v.profile):void 0;if(!I)return this.onDidChangeApplicationStorageEmitter.event;let C=this.mapProfileToOnDidChangeProfileStorageEmitter.get(I.id);return C||(C=this._register(new S.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(I),C),this.mapProfileToOnDidChangeProfileStorageEmitter.set(I.id,C)),C.event}}throw new Error(`Event not found: ${w}`)}async call(u,w,v){const I=v.profile?(0,M.revive)(v.profile):void 0,C=(0,R.reviveIdentifier)(v.workspace),d=await this.withStorageInitialized(I,C);switch(w){case"getItems":return Array.from(d.items.entries());case"updateItems":{const m=v;if(m.insert)for(const[P,b]of m.insert)d.set(P,b);m.delete?.forEach(P=>d.delete(P));break}case"isUsed":{const m=v.payload;if(typeof m=="string")return this.storageMainService.isUsed(m)}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(u,w){let v;w?v=this.storageMainService.workspaceStorage(w):u?v=this.storageMainService.profileStorage(u):v=this.storageMainService.applicationStorage;try{await v.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${w?"workspace":u?"profile":"application"} storage due to ${I}`)}return v}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[39],ie([0,1,66,3,2,18,12,7,168,36,15,5,6,28,29,51,8,30,26]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function h(r){const n=r;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&E.URI.isUri(n.location)&&E.URI.isUri(n.globalStorageHome)&&E.URI.isUri(n.settingsResource)&&E.URI.isUri(n.keybindingsResource)&&E.URI.isUri(n.tasksResource)&&E.URI.isUri(n.snippetsHome)&&((0,D.isUndefined)(n.extensionsResource)||E.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=h,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function g(r,n){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:E.URI.revive(r.location).with({scheme:n}),globalStorageHome:E.URI.revive(r.globalStorageHome).with({scheme:n}),settingsResource:E.URI.revive(r.settingsResource).with({scheme:n}),keybindingsResource:E.URI.revive(r.keybindingsResource).with({scheme:n}),tasksResource:E.URI.revive(r.tasksResource).with({scheme:n}),snippetsHome:E.URI.revive(r.snippetsHome).with({scheme:n}),extensionsResource:E.URI.revive(r.extensionsResource)?.with({scheme:n}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(r,n,s,c){return{id:r,name:n,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=l;let i=class extends M.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,c,o){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=c,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(f=>l((0,R.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags})):[];let s;const c=new m.ResourceMap,o=l((0,S.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?o.extensionsResource:void 0}),n.length){const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[k,T]of Object.entries(f.workspaces)){const _=E.URI.parse(k),G=E.URI.parse(T),ae=n.find(X=>this.uriIdentityService.extUri.isEqual(X.location,G));ae&&c.set(_,ae)}if(f.emptyWindow){const k=E.URI.parse(f.emptyWindow);s=n.find(T=>this.uriIdentityService.extUri.isEqual(T.location,k))}}this._profilesObject={profiles:n,workspaces:c,emptyWindow:s}}return this._profilesObject}async createTransientProfile(n){const s="Temp",c=new RegExp(`${(0,y.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const k of this.profiles){const T=c.exec(k.name),_=T?parseInt(T[1]):0;o=_>o?_:o}const f=`${s} ${o+1}`;return this.createProfile((0,S.hash)((0,p.generateUuid)()).toString(16),f,{transient:!0},n)}async createNamedProfile(n,s,c){return this.createProfile((0,S.hash)((0,p.generateUuid)()).toString(16),n,s,c)}async createProfile(n,s,c,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.doCreateProfile(n,s,c);return o&&await this.setProfileForWorkspace(o,f),f}async doCreateProfile(n,s,c){let o=this.profileCreationPromises.get(s);return o||(o=(async()=>{try{const f=this.profiles.find(_=>_.name===s||_.id===n);if(f)return f;const k=l(n,s,(0,R.joinPath)(this.profilesHome,n),c);await this.fileService.createFolder(k.location);const T=[];return this._onWillCreateProfile.fire({profile:k,join(_){T.push(_)}}),await b.Promises.settled(T),this.updateProfiles([k],[],[]),k}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,o)),o}async updateProfile(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=l(c.id,s.name??c.name,c.location,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:s,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.logService.error(o)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(o){this.logService.error(o)}}getOrSetProfileForWorkspace(n,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(n);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,c)),c}async setProfileForWorkspace(n,s){this.setProfileForWorkspaceSync(n,s)}setProfileForWorkspaceSync(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,c)}unsetWorkspace(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return E.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,c){const o=[...this.profiles,...n],f=[];this.transientProfilesObject.profiles=[];for(let k of o)k.isDefault||s.some(T=>k.id===T.id)||(k=c.find(T=>k.id===T.id)??k,k.isTransient?this.transientProfilesObject.profiles.push(k):f.push({location:k.location,name:k.name,shortName:k.shortName,useDefaultFlags:k.useDefaultFlags}));this.saveStoredProfiles(f),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,c)}triggerProfilesChanges(n,s,c){this._onDidChangeProfiles.fire({added:n,removed:s,updated:c,all:this.profiles})}updateWorkspaceAssociation(n,s,c){c=s?.isTransient?!0:c,c||this.updateWorkspaceAssociation(n,void 0,!0);const o=this.getWorkspace(n),f=c?this.transientProfilesObject:this.profilesObject;E.URI.isUri(o)?(f.workspaces.delete(o),s&&f.workspaces.set(o,s)):f.emptyWindow=s,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[c,o]of this.profilesObject.workspaces.entries())n[c.toString()]=o.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=we([ee(0,w.IEnvironmentService),ee(1,v.IFileService),ee(2,P.IUriIdentityService),ee(3,C.ILogService)],i),e.UserDataProfilesService=i;class a extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=a}),define(te[89],ie([0,1,24,8,50,17,16,43,134,2,14,9,4,18,186,97,12,7,153,36,110,109,185,15,5,6,20,3,67,72,39,51,184]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(V){function j(F,A){if(F===A)return!0;const W=Object.keys(F),N=new Set;for(const x of Object.keys(A))N.add(x);if(W.length!==N.size)return!1;for(const x of W){if(F[x]!==A[x])return!1;N.delete(x)}return N.size===0}V.equals=j})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let ae=class extends w.Disposable{constructor(j,F,A,W,N,x,B,$,L,O,U){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=N,this.extensionsProfileScannerService=x,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=U,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,(0,d.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(J,(0,d.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Q,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,F,A){const[W,N]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(F)]),x=A?await this.scanExtensionsUnderDevelopment(j,[...W,...N]):[];return this.dedupExtensions(W,N,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const F=[];F.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),F.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,j,!1)}async scanUserExtensions(j){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(j.profileLocation??this.userExtensionsLocation,!!j.profileLocation,1,!j.includeUninstalled,j.language);let W=await(j.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,j,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(j,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===v.Schemas.file).map(async W=>{const N=await this.createExtensionScannerInput(W,!1,1,!0,j.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map(B=>(B.type=F.find($=>(0,g.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,N)))}))).flat();return this.applyScanOptions(A,"development",j,!0)}return[]}async scanExistingExtension(j,F,A){const W=await this.createExtensionScannerInput(j,!1,F,!0,A.language),N=await this.extensionsScanner.scanExtension(W);return!N||!A.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(j,F,A){const W=await this.createExtensionScannerInput(j,!1,F,!0,A.language),N=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(N,F,A,!0)}async scanMetadata(j){const F=(0,d.joinPath)(j,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(j,F){const A=(0,d.joinPath)(j,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),N=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,N.__metadata={...N.__metadata,...F},await this.fileService.writeFile((0,d.joinPath)(j,"package.json"),R.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async applyScanOptions(j,F,A,W){return A.includeAllVersions||(j=this.dedupExtensions(F===0?j:void 0,F===1?j:void 0,F==="development"?j:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(j=j.filter(N=>N.isValid)),j.sort((N,x)=>{const B=I.basename(N.location.fsPath),$=I.basename(x.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(j,F,A,W,N){const x=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(N&&m.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(m.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return j?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||x(O,$,!1))&&B.set(L,$)}),F?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&j&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||x(O,$,!1))&&B.set(L,$)}),A?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||x(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(j,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),N=await(j&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(j,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},N=[],x=p.URI.file(I.normalize(I.join(v.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=W[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":N.push((0,d.joinPath)(x,$.name));break;default:N.push(p.URI.file(L));break}}const B=await Promise.all(N.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,j))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,S.coalesce)(B)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,F,A,W,N,x=!0){const B=await this.getTranslations(N??C.language),$=await this.getMtime(j),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new X(j,$,L,O,F,A,W,x,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,N,B)}async getMtime(j){try{const F=await this.fileService.stat(j);if(typeof F.mtime=="number")return F.mtime}catch{}}};ae=we([ee(4,k.IUserDataProfilesService),ee(5,f.IExtensionsProfileScannerService),ee(6,a.IFileService),ee(7,n.ILogService),ee(8,h.IEnvironmentService),ee(9,s.IProductService),ee(10,r.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class X{constructor(j,F,A,W,N,x,B,$,L,O,U,q,Y,oe){this.location=j,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=N,this.type=x,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=U,this.devMode=q,this.language=Y,this.translations=oe}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,F){return(0,d.isEqual)(j.location,F.location)&&j.mtime===F.mtime&&(0,d.isEqual)(j.applicationExtensionslocation,F.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&j.profile===F.profile&&j.type===F.type&&j.excludeObsolete===F.excludeObsolete&&j.validate===F.validate&&j.productVersion===F.productVersion&&j.productDate===F.productDate&&j.productCommit===F.productCommit&&j.devMode===F.devMode&&j.language===F.language&&G.equals(j.translations,F.translations)}}let Q=class extends w.Disposable{constructor(j,F,A,W,N){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=N}async scanExtensions(j){const F=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let A={};if(j.excludeObsolete&&j.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,b.isEmptyObject)(A)?F:F.filter(W=>!A[g.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(j){const F=await this.fileService.resolve(j.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||j.type===1&&(0,d.basename)(W.resource).indexOf(".")===0)return null;const N=new X(W.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(N)}));return(0,S.coalesce)(A).sort((W,N)=>W.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(j){let F=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,j);F.push(...A)}return F}async scanExtensionsFromProfileResource(j,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(j);if(!W.length)return[];const N=await Promise.all(W.map(async x=>{if(F(x)){const B=new X(x.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,x.metadata)}return null}));return(0,S.coalesce)(N)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,d.joinPath)(j.location,"package.json"))){const F=await this.scanExtension(j);return F?[F]:[]}else return await this.scanExtensions(j)}catch(F){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(j,F){try{let A=await this.scanExtensionManifest(j.location);if(A){A.publisher||(A.publisher=l.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,g.getGalleryExtensionId)(A.publisher,A.name),N=F?.id?{id:W,uuid:F.id}:{id:W},x=F?.isSystem?0:j.type,B=x===0||!!F?.isBuiltin;A=await this.translateManifest(j.location,A,X.createNlsConfiguration(j));const $={type:x,identifier:N,manifest:A,location:j.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return j.validate?this.validate($,j):$}}catch(A){j.type!==0&&this.logService.error(A)}return null}validate(j,F){let A=!0;const W=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,j.manifest,j.isBuiltin);for(const[N,x]of W)N===P.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,x)));return j.isValid=A,j.validations=W,j}async scanExtensionManifest(j){const F=(0,d.joinPath)(j,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(N){return(0,a.toFileOperationResult)(N)!==1&&this.logService.error(this.formatMessage(j,(0,y.localize)(0,null,F.path,N.message))),null}let W;try{W=JSON.parse(A)}catch{const x=[];(0,E.parse)(A,x);for(const B of x)this.logService.error(this.formatMessage(j,(0,y.localize)(1,null,F.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,E.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(j,(0,y.localize)(2,null,F.path))),null):W}async translateManifest(j,F,A){const W=await this.getLocalizedMessages(j,F,A);if(W)try{const N=[],x=await this.resolveOriginalMessageBundle(W.default,N);if(N.length>0)return N.forEach($=>{this.logService.error(this.formatMessage(j,(0,y.localize)(3,null,W.default?.path,(0,u.getParseErrorMessage)($.error))))}),F;if((0,E.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(j,(0,y.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,_.localizeManifest)(F,B,x)}catch{}return F}async getLocalizedMessages(j,F,A){const W=(0,d.joinPath)(j,"package.nls.json"),N=(L,O)=>{O.forEach(U=>{this.logService.error(this.formatMessage(j,(0,y.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(U.error))))})},x=L=>{this.logService.error(this.formatMessage(j,(0,y.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,$=A.translations[B];if($)try{const L=p.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),U=[],q=(0,E.parse)(O,U);return U.length>0?(N(L,U),{values:void 0,default:W}):(0,E.getNodeType)(q)!=="object"?(x(L),{values:void 0,default:W}):{values:q.contents?q.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(j,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const U=(await this.fileService.readFile(O.localized)).value.toString(),q=[],Y=(0,E.parse)(U,q);return q.length>0?(N(O.localized,q),{values:void 0,default:O.original}):(0,E.getNodeType)(Y)!=="object"?(x(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(j,F){if(j)try{const A=(await this.fileService.readFile(j)).value.toString();return(0,E.parse)(A,F)}catch{}}findMessageBundles(j,F){return new Promise((A,W)=>{const N=x=>{const B=(0,d.joinPath)(j,`package.nls.${x}.json`);this.fileService.exists(B).then($=>{$&&A({localized:B,original:(0,d.joinPath)(j,"package.nls.json")});const L=x.lastIndexOf("-");L===-1?A({localized:(0,d.joinPath)(j,"package.nls.json"),original:null}):(x=x.substring(0,L),N(x))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,d.joinPath)(j,"package.nls.json"),original:null});N(F.language)})}formatMessage(j,F){return`[${j.path}]: ${F}`}};Q=we([ee(1,f.IExtensionsProfileScannerService),ee(2,T.IUriIdentityService),ee(3,a.IFileService),ee(4,n.ILogService)],Q);let J=class extends Q{constructor(j,F,A,W,N,x){super(F,A,W,N,x),this.cacheFile=j,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const F=await this.readExtensionCache();if(this.input=j,F&&F.input&&X.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=p.URI.revive(W.location),W));const A=await super.scanExtensions(j);return await this.writeExtensionCache({input:j,result:A}),A}async readExtensionCache(){try{const j=await this.fileService.readFile(this.cacheFile),F=JSON.parse(j.value.toString());return{result:F.result,input:(0,o.revive)(F.input)}}catch(j){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(j))}return null}async writeExtensionCache(j){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(j)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const j=await this.readExtensionCache();if(!j)return;const F=j.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!M.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};J=we([ee(2,f.IExtensionsProfileScannerService),ee(3,T.IUriIdentityService),ee(4,a.IFileService),ee(5,n.ILogService)],J);function se(V,j){const F=(0,g.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:F,identifier:new l.ExtensionIdentifier(F),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:j,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=se;class he extends ae{constructor(j,F,A,W,N,x,B,$,L,O,U){super(j,F,(0,d.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(W,l.MANIFEST_CACHE_FOLDER),N,x,B,$,L,O,U),this.translationsPromise=(async()=>{if(C.translationsConfigFile)try{const q=await this.fileService.readFile(p.URI.file(C.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(te[253],ie([0,1,7,36,72,89,15,5,6,20,39]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends R.NativeExtensionsScannerService{constructor(d,m,P,b,p,y,h){super(S.URI.file(p.builtinExtensionsPath),S.URI.file(p.extensionsPath),p.userHome,S.URI.file(p.userDataPath),d,m,P,b,p,y,h)}};I=we([ee(0,v.IUserDataProfilesService),ee(1,M.IExtensionsProfileScannerService),ee(2,D.IFileService),ee(3,u.ILogService),ee(4,t.INativeEnvironmentService),ee(5,w.IProductService),ee(6,E.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(te[254],ie([0,1,13,41,2,29,14,9,4,7,30,36,6,39]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends M.Disposable{constructor(b,p,y){super(),this.environmentService=b,this.logService=y,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=S.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,y)=>this.handleResourceRequest(p,y)),b.protocol.interceptFileProtocol(D.Schemas.file,(p,y)=>this.handleFileRequest(p,y)),this._register((0,M.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const p=(0,E.normalize)(b);return this.validRoots.get(p)?M.Disposable.None:(this.validRoots.set(p,!0),(0,M.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const y=w.URI.parse(b.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const y=this.requestToNormalizedFilePath(b);let h;return this.environmentService.crossOriginIsolated&&((0,E.basename)(y)==="workbench.html"||(0,E.basename)(y)==="workbench-dev.html"?h=D.COI.CoopAndCoep:h=D.COI.getHeadersFromQuery(b.url)),this.validRoots.findSubstr(y)?p({path:y,headers:h}):this.validExtensions.has((0,E.extname)(y).toLowerCase())?p({path:y}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${y} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=w.URI.parse(b.url),y=D.FileAccess.asFileUri(p);return(0,E.normalize)(y.fsPath)}createIPCObjectUrl(){let b;const p=w.URI.from({scheme:"vscode",path:(0,v.generateUuid)()}),y=p.toString(),h=async()=>b;return t.validatedIpcMain.handle(y,h),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:p,update:g=>b=g,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),t.validatedIpcMain.removeHandler(y)}}}};m=we([ee(0,I.INativeEnvironmentService),ee(1,d.IUserDataProfilesService),ee(2,C.ILogService)],m),e.ProtocolMainService=m}),define(te[255],ie([0,1,13,41,8,3,2,14,12,102,27,22,6,54,61,64,44,39,37]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let h=class extends D.Disposable{constructor(l,i,a,r,n,s,c,o,f){super(),this.machineId=l,this.userEnv=i,this.environmentMainService=a,this.userDataProfilesService=r,this.lifecycleMainService=n,this.logService=s,this.policyService=c,this.themeMainService=o,this.protocolMainService=f,this.firstWindowConnectionBarrier=new M.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,i)=>this.onWindowConnection(l,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,i)=>this.onWorkerConnection(l,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(l.sender.isDestroyed())return a.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[a])}onWorkerConnection(l,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const a=new D.DisposableStore,r=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},n=S.BrowserWindow.fromId(i.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!i.reply.channel){r("unavailable");return}a.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===n)(()=>r("load"))),a.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>r("closed"))),n.webContents.postMessage(i.reply.channel,i.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...i)}catch(a){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,b.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:d.default,policiesData:this.policyService.serialize()}),this.window.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,i,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:i}})))}async connect(){await this.whenIpcReady;const l=(0,u.assertIsDefined)(this.window);return(0,w.connect)(l)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};h=we([ee(2,v.IEnvironmentMainService),ee(3,p.IUserDataProfilesService),ee(4,I.ILifecycleMainService),ee(5,C.ILogService),ee(6,y.IPolicyService),ee(7,P.IThemeMainService),ee(8,m.IProtocolMainService)],h),e.SharedProcess=h}),define(te[90],ie([0,1,8,3,2,71,12,103,5,39]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var v;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var C;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));function d(y){const h=y.get(e.TARGET_KEY);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.loadKeyTargets=d;class m extends M.Disposable{constructor(h={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=h,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,g){if(g===e.TARGET_KEY){switch(h){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:h})}else this._onDidChangeValue.fire({scope:h,key:g,target:this.getKeyTargets(h)[g]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,g,l){return this.getStorage(g)?.get(h,l)}getBoolean(h,g,l){return this.getStorage(g)?.getBoolean(h,l)}getNumber(h,g,l){return this.getStorage(g)?.getNumber(h,l)}store(h,g,l,i){if((0,D.isUndefinedOrNull)(g)){this.remove(h,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,l,i),this.getStorage(l)?.set(h,g)})}remove(h,g){this.withPausedEmitters(()=>{this.updateKeyTarget(h,g,void 0),this.getStorage(g)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,g){const l=[],i=this.getKeyTargets(h);for(const a of Object.keys(i))i[a]===g&&l.push(a);return l}updateKeyTarget(h,g,l){const i=this.getKeyTargets(g);typeof l=="number"?i[h]!==l&&(i[h]=l,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[h]=="number"&&(delete i[h],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(h){switch(h){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(h){const g=this.getStorage(h);return g?d(g):Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=v.NONE){this._onWillSaveState.fire({reason:h});const g=this.getStorage(-1),l=this.getStorage(0),i=this.getStorage(1);switch(h){case v.NONE:await S.Promises.settled([g?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await S.Promises.settled([g?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return p(h,g,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(h,g){return this.emitWillSaveState(v.NONE),(0,w.isUserDataProfile)(h)?this.switchToProfile(h,g):this.switchToWorkspace(h,g)}canSwitchProfile(h,g){return!(h.id===g.id||P(g)&&P(h))}switchData(h,g,l,i){this.withPausedEmitters(()=>{if(i)for(const[a,r]of h)g.set(a,r);else{const a=new Set;for(const[r,n]of h)a.add(r),g.get(r)!==n&&this.emitDidChangeValue(l,r);for(const[r]of g.items)a.has(r)||this.emitDidChangeValue(l,r)}})}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class b extends m{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.profileStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),this._register(this.applicationStorage.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h)))}getStorage(h){switch(h){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(h){return!1}}e.InMemoryStorageService=b;async function p(y,h,g,l,i,a){const r=G=>{try{return JSON.parse(G)}catch{return G}},n=new Map,s=new Map;y.forEach((G,ae)=>{n.set(ae,G),s.set(ae,r(G))});const c=new Map,o=new Map;h.forEach((G,ae)=>{c.set(ae,G),o.set(ae,r(G))});const f=new Map,k=new Map;g.forEach((G,ae)=>{f.set(ae,G),k.set(ae,r(G))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const T=[];if(n.forEach((G,ae)=>{T.push({key:ae,value:G})}),console.table(T),console.groupEnd(),console.log(s),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const G=[];c.forEach((ae,X)=>{G.push({key:X,value:ae})}),console.table(G),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const _=[];f.forEach((G,ae)=>{_.push({key:ae,value:G})}),console.table(_),console.groupEnd(),console.log(k)}e.logStorage=p}),define(te[256],ie([0,1,24,8,3,2,9,79,7,21,103,145,6,90,32,28]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{get storage(){return this._storage}constructor(a,r){super(),this.logService=a,this.fileService=r,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new v.Storage(new v.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const a=await this.doCreate();this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(a);const r=a.getBoolean(d.IS_NEW_KEY);r===void 0?a.set(d.IS_NEW_KEY,!0):r&&a.set(d.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===C.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,r){return this._storage.get(a,r)}set(a,r){return this._storage.set(a,r)}delete(a){return this._storage.delete(a)}async close(){const a=new E.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(!!this.path)try{const r=(0,S.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),n=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${n}b, Large Keys: ${r}`)}catch(r){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}constructor(a,r,n,s){super(n,s),this.profile=a,this.options=r}async doCreate(){return new v.Storage(new I.SQLiteStorageDatabase(this.path??I.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class y extends p{constructor(a,r,n,s){super(a,r,n,s)}}e.ProfileStorageMain=y;class h extends p{constructor(a,r,n,s){super(r.defaultProfile,a,n,s)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(m.firstSessionDateStorageKey,void 0)===void 0&&a.set(m.firstSessionDateStorageKey,new Date().toUTCString());const n=a.get(m.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();a.set(m.lastSessionDateStorageKey,typeof n>"u"?null:n),a.set(m.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=h;class g extends b{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,g.WORKSPACE_STORAGE_NAME)}constructor(a,r,n,s,c){super(n,c),this.workspace=a,this.options=r,this.environmentService=s}async doCreate(){const{storageFilePath:a,wasCreated:r}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new I.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:r?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),r=(0,D.join)(a,g.WORKSPACE_STORAGE_NAME);return await w.Promises.exists(a)?{storageFilePath:r,wasCreated:!1}:(await w.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:r,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let r;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?r={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(r={workspace:this.workspace.configPath.toString()}),r)try{const n=(0,D.join)(a,g.WORKSPACE_META_NAME);await w.Promises.exists(n)||await w.Promises.writeFile(n,JSON.stringify(r,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json";class l extends b{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(te[257],ie([0,1,67,36,15,6,226,51,39]),function(z,e,S,t,M,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let w=class At extends u.UserDataProfilesService{constructor(I,C,d,m,P){super(d,m,C,P),this.stateService=I}getStoredProfiles(){return(0,S.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,S.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};w=we([ee(0,D.IStateService),ee(1,E.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,M.IFileService),ee(4,R.ILogService)],w),e.UserDataProfilesService=w}),define(te[42],ie([0,1,7,36,15,5,6,38,51,39,257]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let I=class ht extends v.UserDataProfilesService{constructor(d,m,P,b,p){super(d,m,P,b,p),this.stateMainService=d}setEnablement(d){super.setEnablement(d),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(d){if(!!this.isEnabled()){if(d.profile){const m=this.profiles.find(P=>P.name===d.profile);return m?Promise.resolve(m):this.createNamedProfile(d.profile)}if(d["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(d){d.length?this.stateMainService.setItem(ht.PROFILES_KEY,d):this.stateMainService.removeItem(ht.PROFILES_KEY)}saveStoredProfileAssociations(d){d.emptyWindow||d.workspaces?this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,d):this.stateMainService.removeItem(ht.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",m=this.stateMainService.getItem(d,void 0);if(m){this.stateMainService.removeItem(d);const P=m.reduce((b,{workspace:p,profile:y})=>(b[S.URI.revive(p).toString()]=S.URI.revive(y).toString(),b),{});this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}return super.getStoredProfileAssociations()}};I=we([ee(0,E.IStateMainService),ee(1,u.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,M.IFileService),ee(4,D.ILogService)],I),e.UserDataProfilesMainService=I}),define(te[258],ie([0,1,2,18,72,89,15,6,39,42]),function(z,e,S,t,M,R,D,E,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let v=class extends S.Disposable{constructor(C,d,m,P,b){super(),this.userDataProfilesService=C,this.fileService=d,this.extensionsScannerService=m,this.extensionsProfileScannerService=P,C.isEnabled()?(this._register(C.onWillCreateProfile(p=>{C.profiles.length===1&&p.join(this.initialize())})),this._register(C.onDidChangeProfiles(p=>{C.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>b.error(p))}async initialize(){const C=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(C)}catch{}const d=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(d.map(m=>[m,m.metadata]),C)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};v=we([ee(0,w.IUserDataProfilesMainService),ee(1,D.IFileService),ee(2,R.IExtensionsScannerService),ee(3,M.IExtensionsProfileScannerService),ee(4,E.ILogService)],v),e.DefaultExtensionsProfileInitHandler=v}),define(te[259],ie([0,1,13,24,4,7,21,19,59,5,6,114,33,42]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,w.createDecorator)(e.ID);let m=class{constructor(b,p,y,h,g){this.logService=b,this.windowsMainService=p,this.urlService=y,this.configurationService=h,this.userDataProfilesMainService=g}async start(b,p){this.logService.trace("Received data from other instance: ",b,p),M.isMacintosh&&S.app.focus({steal:!0});const y=this.parseOpenUrl(b);if(y.length){let h=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(h=g.ready())}h.then(()=>{for(const{uri:g,url:l}of y)this.urlService.open(g,{originalUrl:l})})}else return this.startOpenWindow(b,p)}parseOpenUrl(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,t.coalesce)(b._urls.map(p=>{try{return{uri:R.URI.parse(p),url:p}}catch{return null}})):[]}async startOpenWindow(b,p){const y=(0,u.isLaunchedFromCli)(p)?0:4;let h=[];const g=b.wait&&b.waitMarkerFilePath?R.URI.file(b.waitMarkerFilePath):void 0,l=b.remote||void 0,i=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(b),a={context:y,cli:b,userEnv:p,waitMarkerFileURI:g,remoteAuthority:l,profile:i};if(b.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,a);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let r=!1;if(b["new-window"]||b["unity-launch"]||i)r=!0;else if(b["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!M.isMacintosh}if(r)h=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const n=this.windowsMainService.getLastActiveWindow();n?(this.windowsMainService.openExistingWindow(n,a),h=[n]):h=await this.windowsMainService.open({...a,forceEmpty:!0})}}else h=await this.windowsMainService.open({...a,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(g&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};m=we([ee(0,v.ILogService),ee(1,C.IWindowsMainService),ee(2,I.IURLService),ee(3,E.IConfigurationService),ee(4,d.IUserDataProfilesMainService)],m),e.LaunchMainService=m}),define(te[91],ie([0,1,7,49,3,2,36,15,5,22,6,90,256,39,42,51]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let b=class extends R.Disposable{constructor(h,g,l,i,a,r){super(),this.logService=h,this.environmentService=g,this.userDataProfilesService=l,this.lifecycleMainService=i,this.fileService=a,this.uriIdentityService=r,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new M.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(h=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=h.reason,h.join(this.applicationStorage.close());for(const[,g]of this.mapProfileToStorage)h.join(g.close());for(const[,g]of this.mapWorkspaceToStorage)h.join(g.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(h=>{h.join((async()=>{await this.fileService.exists(h.profile.globalStorageHome)||await this.fileService.createFolder(h.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(h=>{const g=this.mapProfileToStorage.get(h.profile.id);g&&h.join(g.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const h=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),h}profileStorage(h){if((0,I.isProfileUsingDefaultStorage)(h))return this.applicationStorage;let g=this.mapProfileToStorage.get(h.id);if(!g){this.logService.trace(`StorageMainService: creating profile storage (${h.name})`),g=this.createProfileStorage(h),this.mapProfileToStorage.set(h.id,g);const l=this._register(g.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:g,profile:h})));(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${h.name})`),this.mapProfileToStorage.delete(h.id),l.dispose()})}return g}createProfileStorage(h){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(h,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(h){let g=this.mapWorkspaceToStorage.get(h.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${h.id})`),g=this.createWorkspaceStorage(h),this.mapWorkspaceToStorage.set(h.id,g),(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${h.id})`),this.mapWorkspaceToStorage.delete(h.id)})),g}createWorkspaceStorage(h){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(h,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(h){const g=S.URI.file(h);for(const l of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!l.path&&this.uriIdentityService.extUri.isEqualOrParent(S.URI.file(l.path),g))return!0;return!1}};b=we([ee(0,v.ILogService),ee(1,D.IEnvironmentService),ee(2,m.IUserDataProfilesMainService),ee(3,w.ILifecycleMainService),ee(4,E.IFileService),ee(5,P.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let p=class extends I.AbstractStorageService{constructor(h,g){super(),this.userDataProfilesService=h,this.storageMainService=g,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(h){if(h===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(h){if(h===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};p=we([ee(0,d.IUserDataProfilesService),ee(1,e.IStorageMainService)],p),e.ApplicationStorageMainService=p}),define(te[260],ie([0,1,2,22,42]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends S.Disposable{constructor(E,u){super(),this.userDataProfilesService=u,this._register(E.onWillLoadWindow(w=>{w.reason===2&&this.unsetTransientProfileForWorkspace(w.window.openedWorkspace??"empty-window")})),this._register(E.onBeforeCloseWindow(w=>this.unsetTransientProfileForWorkspace(w.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(E){this.userDataProfilesService.getOrSetProfileForWorkspace(E).isTransient&&(this.userDataProfilesService.unsetWorkspace(E,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=we([ee(0,t.ILifecycleMainService),ee(1,M.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(te[261],ie([0,1,3,2,90]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(E,u,w){super(),this.storageMainService=E,this.userDataProfilesService=u,this.logService=w;const v=this._register(new t.MutableDisposable);this._onDidChange=this._register(new S.Emitter({onFirstListenerAdd:()=>v.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new t.DisposableStore;return E.add(S.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,w)=>(u?u.push(w.key):u=[w.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),E.add(S.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,w)=>{u||(u=new Map);let v=u.get(w.profile.id);return v||u.set(w.profile.id,v={profile:w.profile,keys:[],storage:w.storage}),v.keys.push(w.key),u},100)(u=>this.onDidChangeProfileStorage(u))),E}onDidChangeApplicationStorage(E){const u=E.includes(M.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],w=[];if(E=E.filter(v=>v!==M.TARGET_KEY),E.length){const v=(0,M.loadKeyTargets)(this.storageMainService.applicationStorage.storage);w.push({profile:this.userDataProfilesService.defaultProfile,changes:E.map(I=>({key:I,scope:0,target:v[I]}))})}this.triggerEvents(u,w)}onDidChangeProfileStorage(E){const u=[],w=new Map;for(const[v,I]of E.entries()){I.keys.includes(M.TARGET_KEY)&&u.push(I.profile);const C=I.keys.filter(d=>d!==M.TARGET_KEY);if(C.length){const d=(0,M.loadKeyTargets)(I.storage.storage);w.set(v,{profile:I.profile,changes:C.map(m=>({key:m,scope:0,target:d[m]}))})}}this.triggerEvents(u,[...w.values()])}triggerEvents(E,u){(E.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:E})}listen(E,u,w){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(E,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=R}),define(te[116],ie([0,1,18,7,28]),function(z,e,S,t,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(u,w,v){for(const C of u){const d=C.openedWorkspace;if((0,M.isWorkspaceIdentifier)(d)){const m=await v(d);if(m){if(m.folders.some(P=>S.extUriBiasedIgnorePathCase.isEqualOrParent(w,P.uri)))return C}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(w,d.configPath))return C}}const I=u.filter(C=>(0,M.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(w,C.openedWorkspace.uri));if(I.length)return I.sort((C,d)=>-(C.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,w){for(const v of u)if((0,M.isWorkspaceIdentifier)(v.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,w)||(0,M.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,w))return v}e.findWindowOnWorkspaceOrFolder=D;function E(u,w){const v=I=>w.some(C=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(C),t.URI.file(I)));for(const I of u)if(I.config?.extensionDevelopmentPath?.some(C=>v(C)))return I}e.findWindowOnExtensionDevelopmentPath=E}),define(te[262],ie([0,1,13,2,4,18,7,19,22,6,38,33,115,28]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class Tt extends t.Disposable{get state(){return this._state}constructor(g,l,i,a,r){super(),this.windowsMainService=g,this.stateMainService=l,this.lifecycleMainService=i,this.logService=a,this.configurationService=r,this._state=P(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(g=>this.onBeforeCloseWindow(g)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(g=>this.onBeforeCloseWindow(g))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const g=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),r&&(l.lastActiveWindow=this.toWindowState(r),l.lastActiveWindow.uiState.mode===3&&g.add(l.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);i&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(i),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(l.lastPluginDevelopmentHostWindow.uiState.display)?M.isMacintosh&&!i.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const n=this.toWindowState(r);return n.uiState.mode===3&&(g.has(n.uiState.display)?M.isMacintosh&&n.windowId!==l.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(n.uiState.mode=1):g.add(n.uiState.display)),n}));const a=p(l);this.stateMainService.setItem(Tt.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(g){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this._state.openedWindows.forEach(i=>{const a=(0,d.isWorkspaceIdentifier)(g.openedWorkspace)&&i.workspace?.id===g.openedWorkspace.id,r=(0,d.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,g.openedWorkspace.uri);(a||r)&&(i.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(g){return{windowId:g.id,workspace:(0,d.isWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const l=this.doGetNewWindowState(g),i=this.configurationService.getValue("window");if(l.mode===3){let a;l.hasDefaultState?a=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):a=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),a||(l.mode=1)}return l}doGetNewWindowState(g){const l=this.windowsMainService.getLastActiveWindow();if(!g.extensionTestsPath){if(!!g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=g.workspace;if((0,d.isWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===c.id).map(k=>k.uiState);if(f.length)return f[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(k=>k.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(k.folderUri,c.uri)).map(k=>k.uiState);if(f.length)return f[0]}else if(g.backupPath){const f=this.state.openedWindows.filter(k=>k.backupPath===g.backupPath).map(k=>k.uiState);if(f.length)return f[0]}const o=this.lastClosedState||this.state.lastActiveWindow;if(!l&&o)return o.uiState}let i;const a=S.screen.getAllDisplays();if(a.length===1)i=a[0];else{if(M.isMacintosh){const c=S.screen.getCursorScreenPoint();i=S.screen.getDisplayNearestPoint(c)}!i&&l&&(i=S.screen.getDisplayMatching(l.getBounds())),i||(i=S.screen.getPrimaryDisplay()||a[0])}let r=(0,C.defaultWindowState)();r.x=Math.round(i.bounds.x+i.bounds.width/2-r.width/2),r.y=Math.round(i.bounds.y+i.bounds.height/2-r.height/2);const n=this.configurationService.getValue("window");let s=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(n.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?r.mode=3:r=c,s=r.mode!==3&&n.newWindowDimensions==="offset"}}return s&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(g){if(this.windowsMainService.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const l=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;l.some(i=>i.x===g.x||i.y===g.y);)g.x+=30,g.y+=30;return g}};m.windowsStateStorageKey="windowsState",m=we([ee(0,I.IWindowsMainService),ee(1,v.IStateMainService),ee(2,u.ILifecycleMainService),ee(3,w.ILogService),ee(4,E.IConfigurationService)],m),e.WindowsStateHandler=m;function P(h){const g={openedWindows:[]},l=h||{openedWindows:[]};return l.lastActiveWindow&&(g.lastActiveWindow=b(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=b(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(g.openedWindows=l.openedWindows.map(i=>b(i))),g}e.restoreWindowsState=P;function b(h){const g={uiState:h.uiState};return h.backupPath&&(g.backupPath=h.backupPath),h.remoteAuthority&&(g.remoteAuthority=h.remoteAuthority),h.folder&&(g.folderUri=D.URI.parse(h.folder)),h.workspaceIdentifier&&(g.workspace={id:h.workspaceIdentifier.id,configPath:D.URI.parse(h.workspaceIdentifier.configURIPath)}),g}function p(h){return{lastActiveWindow:h.lastActiveWindow&&y(h.lastActiveWindow),lastPluginDevelopmentHostWindow:h.lastPluginDevelopmentHostWindow&&y(h.lastPluginDevelopmentHostWindow),openedWindows:h.openedWindows.map(g=>y(g))}}e.getWindowsStateStoreData=p;function y(h){return{workspaceIdentifier:h.workspace&&{id:h.workspace.id,configURIPath:h.workspace.configPath.toString()},folder:h.folderUri&&h.folderUri.toString(),backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.uiState}}}),define(te[92],ie([0,1,31,43,122,35,14,9,4,18,7,5,63,28]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function m(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function P(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=P;function b(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(k){return y(k)||h(k)}e.isStoredWorkspaceFolder=p;function y(k){const T=k;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function h(k){const T=k;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function g(k,T,_,G,ae){if(k.scheme!==G.scheme)return{name:_,uri:k.toString(!0)};let X=T?void 0:ae.relativePath(G,k);if(X!==void 0)X.length===0?X=".":u.isWindows&&(X=l(X));else if(k.scheme===D.Schemas.file)X=k.fsPath,u.isWindows&&(X=l(X));else if(ae.isEqualAuthority(k.authority,G.authority))X=k.path;else return{name:_,uri:k.toString(!0)};return{name:_,path:X}}e.getStoredWorkspaceFolder=g;function l(k){return k=(0,R.normalizeDriveLetter)(k),(0,S.isUNC)(k)||(k=(0,S.toSlashes)(k)),k}function i(k,T,_){const G=[],ae=new Set,X=_.dirname(T);for(const Q of k){let J;if(y(Q))Q.path&&(J=_.resolvePath(X,Q.path));else if(h(Q))try{J=v.URI.parse(Q.uri),J.path[0]!==E.posix.sep&&(J=J.with({path:E.posix.sep+J.path}))}catch(se){console.warn(se)}if(J){const se=_.getComparisonKey(J);if(!ae.has(se)){ae.add(se);const he=Q.name||_.basenameOrAuthority(J);G.push(new d.WorkspaceFolder({uri:J,name:he,index:G.length},Q))}}}return G}e.toWorkspaceFolders=i;function a(k,T,_,G,ae){const X=r(T,k),Q=ae.dirname(T),J=ae.dirname(G),se=[];for(const F of X.folders){const A=y(F)?ae.resolvePath(Q,F.path):v.URI.parse(F.uri);let W;_?W=!1:W=!y(F)||(0,E.isAbsolute)(F.path),se.push(g(A,W,F.name,J,ae))}const he={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},V=M.setProperty(k,["folders"],se,he);let j=M.applyEdits(k,V);return(0,w.isEqualAuthority)(X.remoteAuthority,(0,C.getRemoteAuthority)(G))&&(j=M.applyEdits(j,M.removeProperty(j,["remoteAuthority"],he))),j}e.rewriteWorkspaceFileForNewLocation=a;function r(k,T){const _=t.parse(T);if(_&&Array.isArray(_.folders))_.folders=_.folders.filter(G=>p(G));else throw new Error(`${k} looks like an invalid workspace file.`);return _}function n(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function s(k){return typeof k.folderUri=="string"}function c(k){return typeof k.fileUri=="string"}function o(k,T){const _={workspaces:[],files:[]};if(k){const G=function(X,Q){for(let J=0;J<X.length;J++)try{Q(X[J],J)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(X[J])}: ${se.toString()}. Skip entry.`)}},ae=k;Array.isArray(ae.entries)&&G(ae.entries,X=>{const Q=X.label,J=X.remoteAuthority;n(X)?_.workspaces.push({label:Q,remoteAuthority:J,workspace:{id:X.workspace.id,configPath:v.URI.parse(X.workspace.configPath)}}):s(X)?_.workspaces.push({label:Q,remoteAuthority:J,folderUri:v.URI.parse(X.folderUri)}):c(X)&&_.files.push({label:Q,remoteAuthority:J,fileUri:v.URI.parse(X.fileUri)})})}return _}e.restoreRecentlyOpened=o;function f(k){const T={entries:[]};for(const _ of k.workspaces)P(_)?T.entries.push({folderUri:_.folderUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority}):T.entries.push({workspace:{id:_.workspace.id,configPath:_.workspace.configPath.toString()},label:_.label,remoteAuthority:_.remoteAuthority});for(const _ of k.files)T.entries.push({fileUri:_.fileUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority});return T}e.toStoreData=f}),define(te[93],ie([0,1,76,14,4,18]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(w){function v(){let I=w.scheme===t.Schemas.file?(0,R.originalFSPath)(w):w.toString();return M.isLinux||(I=I.toLowerCase()),(0,S.createHash)("md5").update(I).digest("hex")}return{id:v(),configPath:w}}e.getWorkspaceIdentifier=D;function E(w,v){function I(){if(w.scheme!==t.Schemas.file)return(0,S.createHash)("md5").update(w.toString()).digest("hex");if(!v)return;let d;return M.isLinux?d=v.ino:M.isMacintosh?d=v.birthtime.getTime():M.isWindows&&(typeof v.birthtimeMs=="number"?d=Math.floor(v.birthtimeMs):d=v.birthtime.getTime()),(0,S.createHash)("md5").update(w.fsPath).update(d?String(d):"").digest("hex")}const C=I();if(typeof C=="string")return{id:C,uri:w}}e.getSingleFolderWorkspaceIdentifier=E;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(te[263],ie([0,1,76,31,14,9,4,18,21,175,19,27,38,15,6,174,28,93]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class Ot{constructor(g,l,i,a){this.environmentMainService=g,this.configurationService=l,this.logService=i,this.stateMainService=a,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=E.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,n)=>(0,t.isEqual)(r,n,!D.isLinux)}}async initialize(){const g=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(g.emptyWindows),this.workspaces=await this.validateWorkspaces((0,w.deserializeWorkspaceInfos)(g)),this.folders=await this.validateFolders((0,w.deserializeFolderInfos)(g)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let g=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!g)try{const l=(0,R.join)(this.backupHome,"workspaces.json"),i=await u.Promises.readFile(l,"utf8");try{await u.Promises.unlink(l)}catch{}const a=JSON.parse(i);g={workspaces:Array.isArray(a.rootURIWorkspaces)?a.rootURIWorkspaces:[],folders:Array.isArray(a.folderWorkspaceInfos)?a.folderWorkspaceInfos:[],emptyWindows:Array.isArray(a.emptyWorkspaceInfos)?a.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return g??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(g,l){this.workspaces.some(a=>g.workspace.id===a.workspace.id)||(this.workspaces.push(g),this.storeWorkspacesMetadata());const i=(0,R.join)(this.backupHome,g.workspace.id);return l?this.moveBackupFolder(i,l).then(()=>i):i}async moveBackupFolder(g,l){if(await u.Promises.exists(g)&&await this.convertToEmptyWindowBackup(g),await u.Promises.exists(l))try{await u.Promises.rename(l,g)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(g){return this.folders.some(l=>this.backupUriComparer.isEqual(g.folderUri,l.folderUri))||(this.folders.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(g))}registerEmptyWindowBackup(g){return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,g.backupFolder))||(this.emptyWindows.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,g.backupFolder)}async validateWorkspaces(g){if(!Array.isArray(g))return[];const l=new Set,i=[];for(const a of g){const r=a.workspace;if(!(0,b.isWorkspaceIdentifier)(r))return[];if(!l.has(r.id)){l.add(r.id);const n=(0,R.join)(this.backupHome,r.id);await this.doHasBackups(n)?r.configPath.scheme!==M.Schemas.file||await u.Promises.exists(r.configPath.fsPath)?i.push(a):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return i}async validateFolders(g){if(!Array.isArray(g))return[];const l=[],i=new Set;for(const a of g){const r=a.folderUri,n=this.backupUriComparer.getComparisonKey(r);if(!i.has(n)){i.add(n);const s=(0,R.join)(this.backupHome,this.getFolderHash(a));await this.doHasBackups(s)?r.scheme!==M.Schemas.file||await u.Promises.exists(r.fsPath)?l.push(a):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(g){if(!Array.isArray(g))return[];const l=[],i=new Set;for(const a of g){const r=a.backupFolder;if(typeof r!="string")return[];if(!i.has(r)){i.add(r);const n=(0,R.join)(this.backupHome,r);await this.doHasBackups(n)?l.push(a):await this.deleteStaleBackup(n)}}return l}async deleteStaleBackup(g){try{await u.Promises.rm(g,u.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}prepareNewEmptyWindowBackup(){let g=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,g.id));)g=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:g.id}}async convertToEmptyWindowBackup(g){const l=this.prepareNewEmptyWindowBackup(),i=(0,R.join)(this.backupHome,l.backupFolder);try{await u.Promises.rename(g,i)}catch(a){return this.logService.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.emptyWindows.push(l),!0}async getDirtyWorkspaces(){const g=[];for(const l of this.workspaces)await this.hasBackups(l)&&g.push(l);for(const l of this.folders)await this.hasBackups(l)&&g.push(l);return g}hasBackups(g){let l;return(0,w.isEmptyWindowBackupInfo)(g)?l=(0,R.join)(this.backupHome,g.backupFolder):(0,P.isFolderBackupInfo)(g)?l=(0,R.join)(this.backupHome,this.getFolderHash(g)):l=(0,R.join)(this.backupHome,g.workspace.id),this.doHasBackups(l)}async doHasBackups(g){try{const l=await u.Promises.readdir(g);for(const i of l)try{if((await u.Promises.readdir((0,R.join)(g,i))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const g={workspaces:this.workspaces.map(({workspace:l,remoteAuthority:i})=>{const a={id:l.id,configURIPath:l.configPath.toString()};return i&&(a.remoteAuthority=i),a}),folders:this.folders.map(({folderUri:l,remoteAuthority:i})=>{const a={folderUri:l.toString()};return i&&(a.remoteAuthority=i),a}),emptyWindows:this.emptyWindows.map(({backupFolder:l,remoteAuthority:i})=>{const a={backupFolder:l};return i&&(a.remoteAuthority=i),a})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,g)}getFolderHash(g){const l=g.folderUri;let i;return l.scheme===M.Schemas.file?i=D.isLinux?l.fsPath:l.fsPath.toLowerCase():i=l.toString().toLowerCase(),(0,S.createHash)("md5").update(i).digest("hex")}};y.backupWorkspacesMetadataStorageKey="backupWorkspaces",y=we([ee(0,I.IEnvironmentMainService),ee(1,v.IConfigurationService),ee(2,m.ILogService),ee(3,C.IStateMainService)],y),e.BackupMainService=y}),define(te[52],ie([0,1,13,3,43,35,2,14,9,18,12,21,173,60,56,27,5,6,20,42,116,28,92,93]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let r=class extends D.Disposable{constructor(s,c,o,f,k,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=o,this.backupMainService=f,this.dialogMainService=k,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await I.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,w.joinPath)(this.untitledWorkspacesHome,c,l.UNTITLED_WORKSPACE_NAME));for(const c of s){const o=(0,a.getWorkspaceIdentifier)(c),f=await this.resolveLocalWorkspace(c);f?this.untitledWorkspaces.push({workspace:o,remoteAuthority:f.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>I.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===E.Schemas.file)try{const o=c(s.fsPath);return o instanceof Promise?o.then(f=>this.doResolveWorkspace(s,f),f=>{}):this.doResolveWorkspace(s,o)}catch{return}}isWorkspacePath(s){return(0,l.isUntitledWorkspace)(s,this.environmentMainService)||(0,l.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const o=this.doParseStoredWorkspace(s,c),f=(0,a.getWorkspaceIdentifier)(s);return{id:f.id,configPath:f.configPath,folders:(0,i.toWorkspaceFolders)(o.folders,f.configPath,w.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.logService.warn(o.toString())}}doParseStoredWorkspace(s,c){const o=(0,M.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(f=>(0,i.isStoredWorkspaceFolder)(f));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(s,c){const{workspace:o,storedWorkspace:f}=this.newUntitledWorkspace(s,c),k=o.configPath.fsPath;return await I.Promises.mkdir((0,u.dirname)(k),{recursive:!0}),await I.Promises.writeFile(k,JSON.stringify(f,null,"	")),this.untitledWorkspaces.push({workspace:o,remoteAuthority:c}),o}newUntitledWorkspace(s=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),f=(0,w.joinPath)(this.untitledWorkspacesHome,o),k=(0,w.joinPath)(f,l.UNTITLED_WORKSPACE_NAME),T=[];for(const _ of s)T.push((0,i.getStoredWorkspaceFolder)(_.uri,!0,_.name,f,w.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(k),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,a.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,l.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,w.originalFSPath)(s.configPath);try{await I.Promises.rm((0,u.dirname)(c));const o=(0,u.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await I.Promises.exists(o)&&await I.Promises.writeFile((0,u.join)(o,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(f=>f.workspace.id!==s.id)}catch(o){this.logService.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,o){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,o))return;const k=await this.doEnterWorkspace(s,(0,a.getWorkspaceIdentifier)(o));if(!!k)return this._onDidEnterWorkspace.fire({window:s,workspace:k.workspace}),k}async isValidTargetWorkspacePath(s,c,o){if(!o)return!0;if((0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,o))return!1;if((0,g.findWindowOnWorkspaceOrFolder)(c,o)){const f={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(0,null))],message:(0,C.localize)(1,null,(0,w.basename)(o)),detail:(0,C.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(f,(0,v.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let o;return s.config.extensionDevelopmentPath||(s.config.backupPath?o=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):o=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=o,{workspace:c,backupPath:o}}};r=we([ee(0,P.IEnvironmentMainService),ee(1,p.ILogService),ee(2,h.IUserDataProfilesMainService),ee(3,d.IBackupMainService),ee(4,m.IDialogMainService),ee(5,y.IProductService)],r),e.WorkspacesManagementMainService=r}),define(te[117],ie([0,1,13,41,23,5,33,28,52,12,6]),function(z,e,S,t,M,R,D,E,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let I=class{constructor(d,m,P){this.windowsMainService=d,this.workspacesManagementMainService=m,this.logService=P}async getRemoteDiagnostics(d){const m=this.windowsMainService.getWindows();return(await Promise.all(m.map(async b=>{const p=b.remoteAuthority;if(!p)return;const y=`vscode:getDiagnosticInfoResponse${b.id}`,h={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(b):void 0};return new Promise(g=>{b.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:y,args:h}),t.validatedIpcMain.once(y,(l,i)=>{i||g({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),g(i)}),setTimeout(()=>{g({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const m of S.BrowserWindow.getAllWindows()){const P=this.windowsMainService.getWindowById(m.id);P?d.push(await this.codeWindowToInfo(P)):d.push(this.browserWindowToInfo(m))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const m=await this.getFolderURIs(d),P=(0,w.assertIsDefined)(d.win);return this.browserWindowToInfo(P,m,d.remoteAuthority)}browserWindowToInfo(d,m=[],P){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:m,remoteAuthority:P}}async getFolderURIs(d){const m=[],P=d.openedWorkspace;if((0,E.isSingleFolderWorkspaceIdentifier)(P))m.push(P.uri);else if((0,E.isWorkspaceIdentifier)(P)){const b=await this.workspacesManagementMainService.resolveLocalWorkspace(P.configPath);b&&b.folders.forEach(y=>{m.push(y.uri)})}return m}};I=we([ee(0,D.IWindowsMainService),ee(1,u.IWorkspacesManagementMainService),ee(2,v.ILogService)],I),e.DiagnosticsMainService=I}),define(te[65],ie([0,1,45,13,25,139,53,3,35,2,14,9,4,7,99,81,21,95,163,56,27,5,22,6,20,64,33,28,52,17,220,230,32]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let G=class extends w.Disposable{constructor(X,Q,J,se,he,V,j,F,A,W){super(),this.sharedProcess=X,this.windowsMainService=Q,this.dialogMainService=J,this.lifecycleMainService=se,this.environmentMainService=he,this.logService=V,this.productService=j,this.themeMainService=F,this.workspacesManagementMainService=A,this.telemetryService=W,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x,y:B})=>({windowId:N.id,x,y:B})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,x)=>x.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,x)=>x.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,x)=>x.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,x)=>x.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,x,B)=>B),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),E.Event.fromNodeEventEmitter(t.screen,"display-added"),E.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100),this._profilingSessions=new Map}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(Q=>({id:Q.id,workspace:Q.openedWorkspace??(0,c.toWorkspaceIdentifier)(Q.backupPath,Q.isExtensionDevelopmentHost),title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename(),dirty:Q.isDocumentEdited()}))}async getWindowCount(X){return this.windowsMainService.getWindowCount()}async getActiveWindowId(X){const Q=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(Q)return Q.id}openWindow(X,Q,J){return Array.isArray(Q)?this.doOpenWindow(X,Q,J):this.doOpenEmptyWindow(X,Q)}async doOpenWindow(X,Q,J=Object.create(null)){Q.length>0&&await this.windowsMainService.open({context:5,contextWindowId:X,urisToOpen:Q,cli:this.environmentMainService.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0})}async doOpenEmptyWindow(X,Q){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:X},Q)}async toggleFullScreen(X){this.windowById(X)?.toggleFullScreen()}async handleTitleDoubleClick(X){this.windowById(X)?.handleTitleDoubleClick()}async isMaximized(X){const Q=this.windowById(X);return Q?.win?Q.win.isMaximized():!1}async maximizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.maximize()}async unmaximizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.unmaximize()}async minimizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.minimize()}async updateWindowControls(X,Q){const J=this.windowById(X);J&&J.updateWindowControls(Q)}async focusWindow(X,Q){Q&&typeof Q.windowId=="number"&&(X=Q.windowId),this.windowById(X)?.focus({force:Q?.force??!1})}async setMinimumSize(X,Q,J){const se=this.windowById(X);if(se?.win){const[he,V]=se.win.getSize(),[j,F]=se.win.getMinimumSize(),[A,W]=[Q??j,J??F],[N,x]=[Math.max(he,A),Math.max(V,W)];(j!==A||F!==W)&&se.win.setMinimumSize(A,W),(he!==N||V!==x)&&se.win.setSize(N,x)}}async saveWindowSplash(X,Q){this.themeMainService.saveWindowSplash(X,Q)}async installShellCommand(X){const{source:Q,target:J}=await this.getShellCommandLink();try{const{symbolicLink:se}=await b.SymlinkSupport.stat(Q);if(se&&!se.dangling){const he=await(0,m.realpath)(Q);if(J===he)return}await b.Promises.unlink(Q)}catch(se){if(se.code!=="ENOENT")throw se}try{await b.Promises.symlink(J,Q)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:he}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${Q}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(V)}catch{throw new Error((0,y.localize)(3,null,Q))}}}async uninstallShellCommand(X){const{source:Q}=await this.getShellCommandLink();try{await b.Promises.unlink(Q)}catch(J){switch(J.code){case"EACCES":{const{response:se}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const he=`osascript -e "do shell script \\"rm '${Q}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(he)}catch{throw new Error((0,y.localize)(7,null,Q))}break}case"ENOENT":break;default:throw J}}}async getShellCommandLink(){const X=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),Q=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(X))throw new Error((0,y.localize)(8,null,X));return{source:Q,target:X}}async showMessageBox(X,Q){return this.dialogMainService.showMessageBox(Q,this.toBrowserWindow(X))}async showSaveDialog(X,Q){return this.dialogMainService.showSaveDialog(Q,this.toBrowserWindow(X))}async showOpenDialog(X,Q){return this.dialogMainService.showOpenDialog(Q,this.toBrowserWindow(X))}toBrowserWindow(X){const Q=this.windowById(X);if(Q?.win)return Q.win}async pickFileFolderAndOpen(X,Q){const J=await this.dialogMainService.pickFileFolder(Q);J&&await this.doOpenPicked(await Promise.all(J.map(async se=>await b.SymlinkSupport.existsDirectory(se)?{folderUri:d.URI.file(se)}:{fileUri:d.URI.file(se)})),Q,X)}async pickFolderAndOpen(X,Q){const J=await this.dialogMainService.pickFolder(Q);J&&await this.doOpenPicked(J.map(se=>({folderUri:d.URI.file(se)})),Q,X)}async pickFileAndOpen(X,Q){const J=await this.dialogMainService.pickFile(Q);J&&await this.doOpenPicked(J.map(se=>({fileUri:d.URI.file(se)})),Q,X)}async pickWorkspaceAndOpen(X,Q){const J=await this.dialogMainService.pickWorkspace(Q);J&&await this.doOpenPicked(J.map(se=>({workspaceUri:d.URI.file(se)})),Q,X)}async doOpenPicked(X,Q,J){await this.windowsMainService.open({context:3,contextWindowId:J,cli:this.environmentMainService.args,urisToOpen:X,forceNewWindow:Q.forceNewWindow})}async showItemInFolder(X,Q){t.shell.showItemInFolder(Q)}async setRepresentedFilename(X,Q){this.windowById(X)?.setRepresentedFilename(Q)}async setDocumentEdited(X,Q){this.windowById(X)?.setDocumentEdited(Q)}async openExternal(X,Q){return C.isLinuxSnap?this.safeSnapOpenExternal(Q):t.shell.openExternal(Q),!0}safeSnapOpenExternal(X){const Q=process.env.GDK_PIXBUF_MODULE_FILE,J=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(X),process.env.GDK_PIXBUF_MODULE_FILE=Q,process.env.GDK_PIXBUF_MODULEDIR=J}moveItemToTrash(X,Q){return t.shell.trashItem(Q)}async isAdmin(){let X;return C.isWindows?X=(await new Promise((Q,J)=>{z(["native-is-elevated"],Q,J)}))():X=process.getuid()===0,X}async writeElevated(X,Q,J,se){const he=await new Promise((V,j)=>{z(["@vscode/sudo-prompt"],V,j)});return new Promise((V,j)=>{const F=[`"${this.cliPath}"`];se?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${Q.fsPath}"`,`"${J.fsPath}"`);const A={name:this.productService.nameLong.replace("-",""),icns:C.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};he.exec(F.join(" "),A,(W,N,x)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),x&&this.logService.trace(`[sudo-prompt] received stderr: ${x}`),W?j(W):V(void 0)})})}get cliPath(){return C.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):C.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return P.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return C.isWindows&&(0,k.hasWSLFeatureInstalled)()}async killProcess(X,Q,J){process.kill(Q,J)}async readClipboardText(X,Q){return t.clipboard.readText(Q)}async writeClipboardText(X,Q,J){return t.clipboard.writeText(Q,J)}async readClipboardFindText(X){return t.clipboard.readFindText()}async writeClipboardFindText(X,Q){return t.clipboard.writeFindText(Q)}async writeClipboardBuffer(X,Q,J,se){return t.clipboard.writeBuffer(Q,Buffer.from(J.buffer),se)}async readClipboardBuffer(X,Q){return f.VSBuffer.wrap(t.clipboard.readBuffer(Q))}async hasClipboard(X,Q,J){return t.clipboard.has(Q,J)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(X,Q){this.windowById(X)?.updateTouchBar(Q)}async notifyReady(X){this.windowById(X)?.setReady()}async relaunch(X,Q){return this.lifecycleMainService.relaunch(Q)}async reload(X,Q){const J=this.windowById(X);if(J){if((0,c.isWorkspaceIdentifier)(J.openedWorkspace)){const se=J.openedWorkspace.configPath;if(se.scheme===v.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(J,Q?.disableExtensions!==void 0?{_:[],"disable-extensions":Q.disableExtensions}:void 0)}}async closeWindow(X){this.closeWindowById(X,X)}async closeWindowById(X,Q){const J=this.windowById(Q);if(J?.win)return J.win.close()}async quit(X){const Q=this.windowsMainService.getLastActiveWindow();Q?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&Q.win?Q.win.close():this.lifecycleMainService.quit()}async exit(X,Q){await this.lifecycleMainService.kill(Q)}async resolveProxy(X,Q){const se=this.windowById(X)?.win?.webContents?.session;if(se)return se.resolveProxy(Q)}findFreePort(X,Q,J,se,he=1){return(0,p.findFreePort)(Q,J,se,he)}async openDevTools(X,Q){const J=this.windowById(X);J?.win&&J.win.webContents.openDevTools(Q)}async toggleDevTools(X){const Q=this.windowById(X);Q?.win&&Q.win.webContents.toggleDevTools()}async sendInputEvent(X,Q){const J=this.windowById(X);J?.win&&(Q.type==="mouseDown"||Q.type==="mouseUp")&&J.win.webContents.sendInputEvent(Q)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async startHeartbeat(X,Q){const J=this.windowById(X);if(!J||!J.win)return!1;if(!this._profilingSessions.has(J.id)){const se=new T.WindowProfiler(J.win,Q,this.logService,this.telemetryService);this._profilingSessions.set(J.id,se),se.start()}return!0}async sendHeartbeat(X,Q){const J=this.windowById(X);return!J||!this._profilingSessions.has(J.id)||this._profilingSessions.get(J.id).receiveHeartbeat(),!1}async stopHeartbeat(X,Q){const J=this.windowById(X);return!J||!this._profilingSessions.has(J.id)||(this._profilingSessions.get(J.id).stop(),this._profilingSessions.delete(J.id)),!1}async windowsGetStringRegKey(X,Q,J,se){if(!C.isWindows)return;const he=await new Promise((V,j)=>{z(["@vscode/windows-registry"],V,j)});try{return he.GetStringRegKey(Q,J,se)}catch{return}}windowById(X){if(typeof X=="number")return this.windowsMainService.getWindowById(X)}};we([D.memoize],G.prototype,"cliPath",null),G=we([ee(1,s.IWindowsMainService),ee(2,h.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,g.IEnvironmentMainService),ee(5,a.ILogService),ee(6,r.IProductService),ee(7,n.IThemeMainService),ee(8,o.IWorkspacesManagementMainService),ee(9,_.ITelemetryService)],G),e.NativeHostMainService=G}),define(te[264],ie([0,1,13,41,25,35,2,14,4,100,161,84,117,56,27,5,6,65,54,20,61,74,31,12]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,P.createDecorator)("issueMainService");let r=class Nt{constructor(s,c,o,f,k,T,_,G,ae){this.userEnv=s,this.environmentMainService=c,this.logService=o,this.diagnosticsService=f,this.diagnosticsMainService=k,this.dialogMainService=T,this.nativeHostMainService=_,this.protocolMainService=G,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,o]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),f=await this.diagnosticsService.getSystemInfo(c,o);this.safeSend(s,"vscode:issueSystemInfoResponse",f)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,v.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,I.isRemoteDiagnosticError)(f)?c.push({name:f.hostName,rootProcess:f}):f.processes&&c.push({name:f.hostName,rootProcess:f.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,v.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,v.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,v.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,v.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:o,from:f,args:k}=c;let T;switch(f){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${f}`)}T?.webContents.send("vscode:runAction",{id:o,from:f,args:k})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...o){s.sender.isDestroyed()||s.sender.send(c,...o)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new D.DisposableStore,o=c.add(this.protocolMainService.createIPCObjectUrl()),f=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(f,o,{backgroundColor:s.styles.backgroundColor,title:(0,v.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,M.type)(),arch:(0,M.arch)(),release:(0,M.release)()},product:y.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new D.DisposableStore,o=c.add(this.protocolMainService.createIPCObjectUrl()),f=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(f,o,{backgroundColor:s.styles.backgroundColor,title:(0,v.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:y.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,o,f){const k=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${f}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return k.setMenuBarVisibility(!1),k}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,o){let f;const k=S.screen.getAllDisplays();if(k.length===1)f=k[0];else{if(u.isMacintosh){const G=S.screen.getCursorScreenPoint();f=S.screen.getDisplayNearestPoint(G)}!f&&s&&(f=S.screen.getDisplayMatching(s.getBounds())),f||(f=S.screen.getPrimaryDisplay()||k[0])}const T={width:c,height:o},_=f.bounds;return T.x=_.x+_.width/2-T.width/2,T.y=_.y+_.height/2-T.height/2,_.width>0&&_.height>0&&(T.x<_.x&&(T.x=_.x),T.y<_.y&&(T.y=_.y),T.x>_.x+_.width&&(T.x=_.x),T.y>_.y+_.height&&(T.y=_.y),T.width>_.width&&(T.width=_.width),T.height>_.height&&(T.height=_.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await S.contentTracing.stopRecording(`${(0,i.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,v.localize)(9,null),detail:(0,v.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(11,null))],defaultId:0,noLink:!0},(0,a.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=we([ee(1,m.IEnvironmentMainService),ee(2,b.ILogService),ee(3,I.IDiagnosticsService),ee(4,C.IDiagnosticsMainService),ee(5,d.IDialogMainService),ee(6,p.INativeHostMainService),ee(7,g.IProtocolMainService),ee(8,h.IProductService)],r),e.IssueMainService=r}),define(te[265],ie([0,1,23,19,27,22,6,65,20,55,32,48,88]),function(z,e,S,t,M,R,D,E,u,w,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends C.AbstractUpdateService{constructor(P,b,p,y,h,g,l,i){super(P,b,y,h,g,i),this.telemetryService=p,this.nativeHostMainService=l}buildUpdateFeedUrl(P){return(0,C.createUpdateURL)(`linux-${process.arch}`,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(I.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},S.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const p=P?b.message||b:void 0;this.setState(I.State.Idle(1,p))}))}async doDownloadUpdate(P){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(I.State.Idle(1))}};d=we([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,v.ITelemetryService),ee(3,M.IEnvironmentMainService),ee(4,w.IRequestService),ee(5,D.ILogService),ee(6,E.INativeHostMainService),ee(7,u.IProductService)],d),e.LinuxUpdateService=d}),define(te[266],ie([0,1,45,40,25,8,23,53,9,7,125,21,19,27,15,22,6,65,20,55,32,48,88]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(c,o=1e3){for(;!c();)await(0,R.timeout)(o)}let r;function n(){return typeof r>"u"&&(r=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends i.AbstractUpdateService{get cachePath(){const o=u.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,f,k,T,_,G,ae,X,Q){super(o,f,T,_,G,Q),this.telemetryService=k,this.fileService=ae,this.nativeHostMainService=X}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(o){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),n()===1?f+="-archive":this.productService.target==="user"&&(f+="-user"),(0,i.createUpdateURL)(f,o,this.productService)}doCheckForUpdates(o){!this.url||(this.setState(l.State.CheckingForUpdates(o)),this.requestService.request({url:this.url},D.CancellationToken.None).then(h.asJson).then(f=>{const k=n();return!f||!f.url||!f.version||!f.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o}),this.setState(l.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(l.State.AvailableForDownload(f)),Promise.resolve(null)):(this.setState(l.State.Downloading(f)),this.cleanup(f.version).then(()=>this.getUpdatePackagePath(f.version).then(T=>I.Promises.exists(T).then(_=>{if(_)return Promise.resolve(T);const G=f.url,ae=f.hash,X=`${T}.tmp`;return this.requestService.request({url:G},D.CancellationToken.None).then(Q=>this.fileService.writeFile(w.URI.file(X),Q.stream)).then(ae?()=>(0,v.checksum)(X,f.hash):()=>{}).then(()=>I.Promises.rename(X,T)).then(()=>T)})).then(T=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},_&&f.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(f)):this.setState(l.State.Ready(f))})))}).then(void 0,f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o});const k=o?f.message||f:void 0;this.setState(l.State.Idle(n(),k))}))}async doDownloadUpdate(o){o.update.url&&this.nativeHostMainService.openExternal(void 0,o.update.url),this.setState(l.State.Idle(n()))}async getUpdatePackagePath(o){const f=await this.cachePath;return u.join(f,`CodeSetup-${this.productService.quality}-${o}.exe`)}async cleanup(o=null){const f=o?G=>!new RegExp(`${this.productService.quality}-${o}\\.exe$`).test(G):()=>!0,k=await this.cachePath,_=(await I.Promises.readdir(k)).filter(f).map(async G=>{try{await I.Promises.unlink(u.join(k,G))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const o=this.state.update;this.setState(l.State.Updating(o));const f=await this.cachePath;this.availableUpdate.updateFilePath=u.join(f,`CodeSetup-${this.productService.quality}-${o.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(n()))});const T=`${this.productService.win32MutexName}-ready`,_=await new Promise((G,ae)=>{z(["windows-mutex"],G,ae)});a(()=>_.isActive(T)).then(()=>this.setState(l.State.Ready(o)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const f=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!f};this.setState(l.State.Downloading(k)),this.availableUpdate={packagePath:o},f?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(k)):this.setState(l.State.Ready(k))}};we([E.memoize],s.prototype,"cachePath",null),s=we([ee(0,P.ILifecycleMainService),ee(1,C.IConfigurationService),ee(2,g.ITelemetryService),ee(3,d.IEnvironmentMainService),ee(4,h.IRequestService),ee(5,b.ILogService),ee(6,m.IFileService),ee(7,p.INativeHostMainService),ee(8,y.IProductService)],s),e.Win32UpdateService=s}),define(te[267],ie([0,1,13,8,23,44,3,35,2,14,9,71,4,7,169,60,19,56,27,59,15,22,6,20,61,232,91,32,235,64,74,33,28,52,115,119,37,38,54,42]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_,G,ae,X,Q,J,se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(V||(V={}));let j=class Wt extends u.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,W,N,x,B,$,L,O,U,q,Y,oe,H,re,ne,ce,ge,Re,Te){super(),this.logService=W,this.environmentMainService=N,this.policyService=x,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=U,this.themeMainService=q,this.workspacesManagementMainService=Y,this.backupMainService=oe,this.telemetryService=H,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=Re,this.stateMainService=Te,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const ve=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Se=!1;typeof pe?.experimental?.useSandbox=="boolean"?Se=pe.experimental.useSandbox:Se=typeof se.default.quality=="string"&&se.default.quality!=="stable";const ke={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ve,title:this.productService.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(pe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Se?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};C.isLinux?ke.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):C.isWindows&&!this.environmentMainService.isBuilt&&(ke.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&!this.useNativeFullScreen()&&(ke.fullscreenable=!1),C.isMacintosh&&(ke.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const Z=C.isMacintosh&&pe?.nativeTabs===!0;Z&&(ke.tabbingIdentifier=this.productService.nameShort);const ue=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ke.titleBarStyle="hidden",C.isMacintosh||(ke.frame=!1),(0,k.useWindowControlsOverlay)(this.configurationService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=X.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(ke),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,C.isMacintosh&&ue&&this._win.setSheetOffset(22),ue&&(C.isWindows&&(0,k.useWindowControlsOverlay)(this.configurationService)||C.isMacintosh)){const de=this.stateMainService.getItem(Wt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}C.isWindows&&ue&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Fe=S.screen.getCursorScreenPoint(),Oe=Fe.x-ye,$e=Fe.y-Ce;return(()=>!(Oe>30&&$e>=0&&$e<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:$e})),0}),(C.isMacintosh||C.isWindows)&&Ae&&(!Z||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ve&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){C.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return C.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){C.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return C.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){C.isMacintosh&&A?.force&&S.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){N.dispose(),x.dispose(),A()}const N=this.onDidClose(()=>W()),x=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(W,N,x)=>this.onWindowError(3,{reason:x,exitCode:N})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,N)=>{const x=await this.getMarketplaceHeaders();N({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,x)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,m.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,m.localize)(2,null))],message:(0,m.localize)(3,null),detail:(0,m.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,m.localize)(5,null):void 0},this._win);if(N.response!==1){const x=N.response===0;await this.destroyWindow(x,N.checkboxChecked)}}else if(A===2){let N;W?N=(0,m.localize)(7,null,W.reason,W.exitCode??"<unknown>"):N=(0,m.localize)(6,null);const x=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,m.localize)(8,null)),(0,E.mnemonicButtonLabel)((0,m.localize)(9,null))],message:N,detail:(0,m.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,m.localize)(11,null):void 0},this._win),B=x.response===0;await this.destroyWindow(B,x.checkboxChecked)}break}}async destroyWindow(A,W){const N=this._config?.workspace;if(W&&N)try{const x=this.storageMainService.workspaceStorage(N);await x.init(),x.delete("memento/workbench.parts.editor"),await x.close()}catch(x){this.logService.error(x)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let x,B;(0,_.isSingleFolderWorkspaceIdentifier)(N)?x={folderUri:N.uri}:(0,_.isWorkspaceIdentifier)(N)?x={workspaceUri:N.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const x=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||x!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=x;const B=N||"",$=x?`${x},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){C.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const N=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:N?2:1})}updateConfiguration(A,W){const N=(this._config??this.pendingLoadConfig)?.userEnv;if(N){const x=(0,h.isLaunchedFromCli)(N)&&!(0,h.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(x||B)&&(A.userEnv={...N,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),A.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.continueOn=this.environmentMainService.continueOn,W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,_.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===w.Schemas.file&&!await this.fileService.exists(W))return}else if((0,_.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===w.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let N;try{N=S.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,ae.defaultWindowState)();return{mode:3,display:N?N.id:void 0,width:this.windowState.width||x.width,height:this.windowState.height||x.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!C.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let N;W===1?N=this.getBounds():N=this._win.getNormalBounds(),A.x=N.x,A.y=N.y,A.width=N.width,A.height=N.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Wt.windowControlHeightStateStorageKey,A.height),C.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):C.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,I.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const N=S.screen.getAllDisplays();W=N.length>1,A=this.validateWindowState(A,N)}catch(N){this.logService.warn(`Unexpected error validating window state: ${N}
${N.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[A||(0,ae.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),$()}return A}if(A.display&&A.mode===3){const B=W.find($=>$.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let N,x;try{N=S.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),x=this.getWorkingArea(N)}catch{}if(N&&x&&A.x+A.width>x.x&&A.y+A.height>x.y&&A.x<x.x+x.width&&A.y<x.y+x.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",x),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[N,x]=this._win.getSize();return{x:A,y:W,width:N,height:x}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return C.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){C.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){C.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,m.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(C.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...N){this.isReady?this.send(A,...N):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...N)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(N){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(N)}`)}}}updateTouchBar(A){!C.isMacintosh||this.touchBarGroups.forEach((W,N)=>{const x=A[N];W.segments=this.createTouchBarGroupSegments(x)})}createTouchBar(){if(!!C.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),N=new S.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:N.segments[x].id,from:"touchbar"})}});return N}createTouchBarGroupSegments(A=[]){return A.map(N=>{let x;N.icon&&!o.ThemeIcon.isThemeIcon(N.icon)&&N.icon?.dark?.scheme===w.Schemas.file&&(x=S.nativeImage.createFromPath(d.URI.revive(N.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let B;return typeof N.title=="string"?B=N.title:B=N.title.value,{id:N.id,label:x?void 0:B,icon:x}})}dispose(){super.dispose(),this._win=null}};j.windowControlHeightStateStorageKey="windowControlHeight",j=we([ee(1,i.ILogService),ee(2,y.IEnvironmentMainService),ee(3,Q.IPolicyService),ee(4,he.IUserDataProfilesMainService),ee(5,g.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,b.IConfigurationService),ee(9,f.IThemeMainService),ee(10,G.IWorkspacesManagementMainService),ee(11,P.IBackupMainService),ee(12,c.ITelemetryService),ee(13,p.IDialogMainService),ee(14,l.ILifecycleMainService),ee(15,a.IProductService),ee(16,r.IProtocolMainService),ee(17,T.IWindowsMainService),ee(18,J.IStateMainService)],j),e.CodeWindow=j}),define(te[75],ie([0,1,13,24,8,3,35,2,14,4,18,7,21,172,5,22,6,91,92,28,52,29]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let i=class rt extends E.Disposable{constructor(r,n,s,c){super(),this.logService=r,this.workspacesManagementMainService=n,this.lifecycleMainService=s,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let n=[],s=[];for(const o of r)if((0,y.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&!this.containsWorkspace(n,o.workspace)&&n.push(o);else if((0,y.isRecentFolder)(o))this.containsFolder(n,o.folderUri)||n.push(o);else{const f=this.containsFile(s,o.fileUri),k=o.fileUri.scheme===u.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,v.basename)(o.fileUri))>=0;!f&&!k&&(s.push(o),w.isWindows&&o.fileUri.scheme===u.Schemas.file&&S.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:n,files:s});n=c.workspaces,s=c.files,n.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:s}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const n=f=>{const k=this.location(f);for(const T of r)if(v.extUriBiasedIgnorePathCase.isEqual(T,k))return!1;return!0},s=await this.getRecentlyOpened(),c=s.workspaces.filter(n),o=s.files.filter(n);(c.length!==s.workspaces.length||o.length!==s.files.length)&&(await this.saveRecentlyOpened({files:o,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(r){const n=new l.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(r?.workspaces)for(const o of r.workspaces)n.set(this.location(o),o);const s=new l.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(r?.files)for(const o of r.files)s.set(this.location(o),o);const c=await this.getRecentlyOpenedFromStorage();for(const o of c.workspaces){const f=n.get(this.location(o));f?f.label=f.label??o.label:n.set(this.location(o),o)}for(const o of c.files){const f=s.get(this.location(o));f?f.label=f.label??o.label:s.set(this.location(o),o)}return{workspaces:[...n.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const n=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{r=JSON.parse(n)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,y.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,y.toStoreData)(r)),-1,1)}location(r){return(0,y.isRecentFolder)(r)?r.folderUri:(0,y.isRecentFile)(r)?r.fileUri:r.workspace.configPath}containsWorkspace(r,n){return!!r.find(s=>(0,y.isRecentWorkspace)(s)&&s.workspace.id===n.id)}containsFolder(r,n){return!!r.find(s=>(0,y.isRecentFolder)(s)&&v.extUriBiasedIgnorePathCase.isEqual(s.folderUri,n))}containsFile(r,n){return!!r.find(s=>v.extUriBiasedIgnorePathCase.isEqual(s.fileUri,n))}async handleWindowsJumpList(){!w.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!w.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const o of S.app.getJumpListSettings().removedItems){const f=o.args;if(f){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(f);k&&n.push(I.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let s=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const f=(0,y.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:k,description:T}=this.getWindowsJumpListLabel(f,o.label);let _;return I.URI.isUri(f)?_=`--folder-uri "${f.toString()}"`:(s=!0,_=`--file-uri "${f.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:T.substr(0,255),program:process.execPath,args:_,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&r.push({type:"custom",name:s?(0,d.localize)(2,null):(0,d.localize)(3,null),items:c})}r.push({type:"recent"});try{const n=S.app.setJumpList(r);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(r,n){if(n)return{title:(0,D.splitName)(n).name,description:n};if(I.URI.isUri(r))return{title:(0,v.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,d.localize)(4,null),description:""};let s=(0,v.basename)(r.configPath);return s.endsWith(h.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-h.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;S.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),n=[];let s=0;for(let o=0;o<r.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const f=this.location(r.workspaces[o]);if(f.scheme===u.Schemas.file){const k=(0,v.originalFSPath)(f);await C.Promises.exists(k)&&(n.push(k),s++)}}const c=[];for(let o=0;o<r.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const f=this.location(r.files[o]);if(f.scheme===u.Schemas.file){const k=(0,v.originalFSPath)(f);if(rt.COMMON_FILES_FILTER.includes((0,v.basename)(f))||n.includes(k))continue;await C.Promises.exists(k)&&(c.push(k),s++)}}c.reverse().forEach(o=>S.app.addRecentDocument(o)),n.reverse().forEach(o=>S.app.addRecentDocument(o))}};i.MAX_TOTAL_RECENT_ENTRIES=500,i.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",i.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,i.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,i.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,i.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],i=we([ee(0,b.ILogService),ee(1,g.IWorkspacesManagementMainService),ee(2,P.ILifecycleMainService),ee(3,p.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[268],ie([0,1,13,8,23,35,4,7,162,19,27,22,6,209,65,20,38,32,48,74,33,75]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class Ft{constructor(s,c,o,f,k,T,_,G,ae,X,Q){this.updateService=s,this.configurationService=c,this.windowsMainService=o,this.environmentMainService=f,this.telemetryService=k,this.workspacesHistoryMainService=T,this.stateMainService=_,this.lifecycleMainService=G,this.logService=ae,this.nativeHostMainService=X,this.productService=Q,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Ft.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,_,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,_,G)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,_,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const o=this.productService.reportIssueUrl;o&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(o,"openReportIssues"));const f=this.productService.licenseUrl;f&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=f.indexOf("?")>0?"&":"?";this.openUrl(`${f}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(f,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&f&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Ft.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=S.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(D.isMacintosh?new S.Menu:null);return}const c=new S.Menu;let o;if(D.isMacintosh){const k=new S.Menu;o=new S.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),c.append(o)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:k});this.setMenuById(k,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:k});this.setMenuById(k,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),c.append(T)}let f;if(this.shouldDrawMenu("Window")){const k=new S.Menu;f=new S.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(f&&c.append(f),this.shouldDrawMenu("Help")){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),c.append(T)}c.items&&c.items.length>0?S.Menu.setApplicationMenu(c):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),o=this.getUpdateMenuItems();let f;if(this.shouldDrawMenu("Preferences")){const J=new S.Menu;this.setMenuById(J,"Preferences"),f=new S.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:J})}const k=new S.Menu,T=new S.MenuItem({label:u.localize(12,null),role:"services",submenu:k}),_=new S.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new S.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new S.MenuItem({label:u.localize(15,null),role:"unhide"}),X=new S.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(J,se,he)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),Q=[c];Q.push(...o),f&&Q.push(r(),f),Q.push(r(),T,r(),_,G,ae,r(),X),Q.forEach(J=>s.append(J))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const o={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,o);return f===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(o=>{if((0,d.isMenubarMenuItemSeparator)(o))s.append(r());else if((0,d.isMenubarMenuItemSubmenu)(o)){const f=new S.Menu,k=new S.MenuItem({label:this.mnemonicLabel(o.label),submenu:f});this.setMenu(f,o.submenu.items),s.append(k)}else(0,d.isMenubarMenuItemRecentAction)(o)?s.append(this.createOpenRecentMenuItem(o)):(0,d.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[o.id]?s.append(new S.MenuItem(this.likeAction(o.id,{label:this.mnemonicLabel(o.label),click:this.fallbackMenuHandlers[o.id]}))):s.append(this.createMenuItem(o.label,o.id,!1,o.checked)):s.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)):s.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(o=>s.append(o)),s.append(r()))}createOpenRecentMenuItem(s){const c=E.URI.revive(s.uri),o=s.id,f=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new S.MenuItem(this.likeAction(o,{label:s.label,click:async(k,T,_)=>{const G=this.isOptionClick(_);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[f],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,o){const f={label:this.mnemonicLabel(s),role:o,enabled:!0};return new S.MenuItem(this.withKeybinding(c,f))}setMacWindowMenu(s){const c=new S.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),o=new S.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),f=new S.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(r()),T.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,r(),k,...T,r(),f].forEach(_=>s.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,o,f){const k=this.mnemonicLabel(s),T=typeof c=="function"?c:(Q,J,se)=>{const he=Q?Q.userSettingsLabel:null;let V=c;Array.isArray(c)&&(V=this.isOptionClick(se)?c[1]:c[0]),he&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:V})},_=typeof o=="boolean"?o:this.windowsMainService.getWindowCount()>0,G=typeof f=="boolean"?f:!1,ae={label:k,click:T,enabled:_};G&&(ae.type="checkbox",ae.checked=G);let X;return typeof c=="string"?X=c:Array.isArray(c)&&(X=c[0]),D.isMacintosh&&(X==="editor.action.clipboardCutAction"?ae.role="cut":X==="editor.action.clipboardCopyAction"?ae.role="copy":X==="editor.action.clipboardPasteAction"&&(ae.role="paste"),X==="undo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(X,ae))}makeContextAwareClickHandler(s,c){return(o,f,k)=>{const T=S.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(o,f||T,k)}}runActionInRenderer(s){let c=S.BrowserWindow.getFocusedWindow();if(!c){const f=this.windowsMainService.getLastActiveWindow();f?.isMinimized()&&(c=f.win)}const o=c?this.windowsMainService.getWindowById(c.id):void 0;if(o){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!o.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const f={id:s.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",M.CancellationToken.None,f)}else{const f={userSettingsLabel:s.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,f)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const o=typeof s=="string"?this.keybindings[s]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const f=c.label.indexOf("[");f>=0?c.label=`${c.label.substr(0,f)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,o=!c.accelerator){o&&(c=this.withKeybinding(s,c));const f=c.click;return c.click=(k,T,_)=>{this.reportMenuActionTelemetry(s),f?.(k,T,_)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=we([ee(0,y.IUpdateService),ee(1,w.IConfigurationService),ee(2,g.IWindowsMainService),ee(3,v.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,b.IStateMainService),ee(7,I.ILifecycleMainService),ee(8,C.ILogService),ee(9,m.INativeHostMainService),ee(10,P.IProductService)],a),e.Menubar=a;function r(){return new S.MenuItem({type:"separator"})}}),define(te[269],ie([0,1,5,22,6,268]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let D=class{constructor(u,w,v){this.instantiationService=u,this.lifecycleMainService=w,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,w){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(w,u)}};D=we([ee(0,S.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,M.ILogService)],D),e.MenubarMainService=D}),define(te[270],ie([0,1,13,21,25,24,23,3,31,49,35,2,14,9,71,4,34,18,12,7,170,60,19,56,27,15,5,22,6,54,20,61,63,38,74,267,116,262,28,93,75,52,64,37,42]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_,G,ae,X,Q,J,se,he,V,j,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function x($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends I.Disposable{constructor(L,O,U,q,Y,oe,H,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se){super(),this.machineId=L,this.initialUserEnv=O,this.logService=U,this.stateMainService=q,this.policyService=Y,this.environmentMainService=oe,this.userDataProfilesMainService=H,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Re,this.instantiationService=Te,this.dialogMainService=Me,this.fileService=Ae,this.productService=ve,this.protocolMainService=pe,this.themeMainService=Se,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new E.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new I.DisposableStore;if(O.add(E.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const U of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(U));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const U=this.environmentMainService.args,q=O?.remoteAuthority||void 0,Y=!0,oe=O?.forceReuseWindow,H=!oe;return this.open({...L,cli:U,forceEmpty:Y,forceNewWindow:H,forceReuseWindow:oe,remoteAuthority:q})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],U=[],q=[],Y=[],oe=[];let H,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const Me of ne)x(Me)?L.addMode?O.push(Me):U.push(Me):N(Me)?q.push(Me):Me.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),H.filesToOpenOrCreate.push(Me)):Me.backupPath?oe.push({backupFolder:(0,d.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):re++;L.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),L.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&L.waitMarkerFileURI&&(H.filesToWait={paths:(0,R.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...Y),oe.push(...this.backupMainService.getEmptyWindowBackups())):oe.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,q,U,oe,re,H,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${U.length}, emptyToRestore: ${oe.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,ve=!0;if(Me){const pe=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Ae=!1,ve=!1)}if(Ae)for(let pe=ce.length-1;pe>=0;pe--){const Se=ce[pe];if(!(Se.openedWorkspace&&Y.some(ke=>Se.openedWorkspace&&ke.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&oe.some(ke=>Se.backupPath&&ke.backupFolder===(0,d.basename)(Se.backupPath)))){Se.focus(),ve=!1;break}}ve&&ce[ce.length-1].focus()}const Re=H&&H.filesToDiff.length>0,Te=H&&H.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!Re&&!Te&&!L.noRecentEntry){const Me=[];for(const Ae of ne)N(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):x(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const U=L.waitMarkerFileURI;L.context===0&&U&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(U)}catch{}})()}async doOpen(L,O,U,q,Y,oe,H){const re=[];let ne;function ce(pe,Se){re.push(pe),Se&&(ne=pe,oe=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Re}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&H.length>0){const pe=H[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(pe);Se&&ce(this.doAddFoldersToExistingWindow(Se,H.map(ke=>ke.workspace.uri)))}const Te=U.length+O.length+q.length;if(oe&&Te===0){const pe=oe.filesToOpenOrCreate[0]||oe.filesToDiff[0]||oe.filesToMerge[3],Se=this.getWindows().filter(Z=>oe&&(0,p.isEqualAuthority)(Z.remoteAuthority,oe.remoteAuthority));let ke;pe?.fileUri&&!Re&&((L.context===4||L.context===0||L.context===1)&&(ke=await(0,Q.findWindowOnFile)(Se,pe.fileUri,async Z=>Z.configPath.scheme===C.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Z.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(Se))),ke?(0,se.isWorkspaceIdentifier)(ke.openedWorkspace)?O.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?U.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,ke,oe),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:oe,forceNewWindow:!0,remoteAuthority:oe.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const Me=(0,R.distinct)(O,pe=>pe.workspace.id);if(Me.length>0){const pe=(0,R.coalesce)(Me.map(Se=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],ke=(0,p.isEqualAuthority)(oe?.remoteAuthority,Se.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Me){if(pe.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Se.workspace.id))continue;const ke=Se.remoteAuthority,Z=(0,p.isEqualAuthority)(oe?.remoteAuthority,ke)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,Z),!!Z),ge=!0}}const Ae=(0,R.distinct)(U,pe=>p.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Ae.length>0){const pe=(0,R.coalesce)(Ae.map(Se=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],ke=(0,p.isEqualAuthority)(oe?.remoteAuthority,Se.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Ae){if(pe.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Se.workspace.uri)))continue;const ke=Se.remoteAuthority,Z=(0,p.isEqualAuthority)(oe?.remoteAuthority,ke)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,Z),!!Z),ge=!0}}const ve=(0,R.distinct)(q,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const Se=pe.remoteAuthority,ke=(0,p.isEqualAuthority)(oe?.remoteAuthority,Se)?oe:void 0;ce(this.doOpenEmpty(L,!0,Se,ke,pe),!!ke),ge=!0}if(re.length===0||oe){oe&&!Y&&Y++;const pe=oe?oe.remoteAuthority:L.remoteAuthority;for(let Se=0;Se<Y;Se++)ce(this.doOpenEmpty(L,ge,pe,oe),!!oe),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,U){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),O.focus();const q={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,q),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const U={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,U),L}doOpenEmpty(L,O,U,q,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:U,filesToOpen:q,forceNewWindow:O});let oe;return!O&&typeof L.contextWindowId=="number"&&(oe=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:U,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:oe,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,U,q,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:q}),!U&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,U=!1,q=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),U=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),U=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),q=!0),!L.addMode&&U){const Y=O.filter(oe=>x(oe));if(Y.length>1){const oe=Y[0].remoteAuthority;if(Y.every(H=>(0,p.isEqualAuthority)(H.remoteAuthority,oe))){const H=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:H,remoteAuthority:oe}),O=O.filter(re=>!x(re))}}}if(L.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(oe=>N(oe)||x(oe)||oe.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},U=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async q=>{const Y=await this.resolveOpenable(q,O);if(Y)return Y.label=q.label,Y;const oe=this.resourceFromOpenable(q),H={title:this.productService.nameLong,type:"info",buttons:[(0,v.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:oe.scheme===C.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:oe.scheme===C.Schemas.file?(0,g.localize)(3,null,(0,v.getPathLabel)(oe,{os:P.OS,tildify:this.environmentMainService})):(0,g.localize)(4,null,oe.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(H,(0,y.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(U)}async doExtractPathsFromCLI(L){const O=[],U={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},q=L["folder-uri"];if(q){const H=await Promise.all(q.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},U)}));O.push(...(0,R.coalesce)(H))}const Y=L["file-uri"];if(Y){const H=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},U)}));O.push(...(0,R.coalesce)(H))}const oe=await Promise.all(L._.map(H=>U.remoteAuthority?this.doResolveRemotePath(H,U):this.doResolveFilePath(H,U)));return O.push(...(0,R.coalesce)(oe)),O}cliArgToUri(L){try{const O=h.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const U=await Promise.all(O.map(async q=>{if(q.workspace){const Y=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(N(Y))return Y}else if(q.folderUri){const Y=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(x(Y))return Y}else if(L!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,R.coalesce)(U)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const U=this.resourceFromOpenable(L);return U.scheme===C.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(U.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let U=this.resourceFromOpenable(L);const q=(0,_.getRemoteAuthority)(U)||O.remoteAuthority;if(U=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(U)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:oe,column:H}=(0,u.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:Y}),options:{selection:oe?{startLineNumber:oe,startColumn:H||1}:void 0},remoteAuthority:q}}return{fileUri:U,remoteAuthority:q}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(U),remoteAuthority:q};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:q}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let U,q;O.gotoLineMode&&({path:L,line:U,column:q}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,d.normalize)(L),(0,b.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const oe=await this.workspacesManagementMainService.resolveLocalWorkspace(h.URI.file(L));if(oe)return oe.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:oe.id,configPath:oe.configPath},type:n.FileType.File,exists:!0,remoteAuthority:oe.remoteAuthority,transient:oe.transient}}return{fileUri:h.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:q||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(h.URI.file(L),Y),type:n.FileType.Directory,exists:!0};if(!P.isWindows&&L==="/dev/null")return{fileUri:h.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const oe=h.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([oe]),O.ignoreFileNotFound)return{fileUri:oe,type:n.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const U=L.charCodeAt(0),q=O.remoteAuthority;let Y,oe;O.gotoLineMode&&({path:L,line:Y,column:oe}=(0,u.parseLineAndColumnAware)(L)),U!==47&&((0,u.isWindowsDriveLetter)(U)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const H=h.URI.from({scheme:C.Schemas.vscodeRemote,authority:q,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(H),remoteAuthority:q};if(O.gotoLineMode||d.posix.basename(L).indexOf(".")!==-1)return{fileUri:H,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:q}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:q}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),U=O?.openFoldersInNewWindow||"default",q=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(U==="on"||U==="off")&&(Y=U==="on");let oe=!1;return L.forceNewWindow||L.forceReuseWindow?oe=!!L.forceNewWindow&&!L.forceReuseWindow:(P.isMacintosh?L.context===1&&(oe=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(oe=!0),!L.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(oe=q==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:oe}}async openExtensionDevelopmentHostWindow(L,O){const U=(0,Q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(U)return this.lifecycleMainService.reload(U,O.cli),U.focus(),[U];let q=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],oe=O.cli._;if(!oe.length&&!q.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(h.URI.isUri(ce)?ce.scheme===C.Schemas.file?oe=[ce.fsPath]:q=[ce.toString()]:ce.configPath.scheme===C.Schemas.file?oe=[(0,p.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let H=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=h.URI.parse(ne),ge=(0,_.getRemoteAuthority)(ce);ge&&(H?(0,p.isEqualAuthority)(ge,H)||this.logService.error("more than one extension development path authority"):H=ge)}oe=oe.filter(ne=>{const ce=h.URI.file(ne);return(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H)}),q=q.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H):!1}),O.cli._=oe,O.cli["folder-uri"]=q,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!oe.length&&!q.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:H,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),U={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,d.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:f.default,isInitialStartup:L.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let q;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||this.getLastActiveWindow(),q&&q.focus()),q){const Y=q.config;!U.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=Y.extensionDevelopmentPath,U.extensionDevelopmentKind=Y.extensionDevelopmentKind,U["enable-proposed-api"]=Y["enable-proposed-api"],U.verbose=Y.verbose,U["inspect-extensions"]=Y["inspect-extensions"],U["inspect-brk-extensions"]=Y["inspect-brk-extensions"],U.debugId=Y.debugId,U.extensionEnvironment=Y.extensionEnvironment,U["extensions-dir"]=Y["extensions-dir"],U["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(U);(0,m.mark)("code/willCreateCodeWindow");const oe=q=this.instantiationService.createInstance(X.CodeWindow,{state:Y,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),ft.WINDOWS.push(oe),this._onDidOpenWindow.fire(oe),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(oe.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(oe)),(0,w.once)(oe.onDidClose)(()=>this.onWindowClosed(oe)),(0,w.once)(oe.onDidDestroy)(()=>this._onDidDestroyWindow.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:oe,x:re,y:ne}));const H=(0,y.assertIsDefined)(oe.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(oe)),this.lifecycleMainService.registerWindow(oe)}return U.windowId=q.id,q.isReady?this.lifecycleMainService.unload(q,4).then(Y=>{Y||this.doOpenInBrowserWindow(q,U,L)}):this.doOpenInBrowserWindow(q,U,L),q}doOpenInBrowserWindow(L,O,U){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(U=>U.lastFocusTime));return L.find(U=>U.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,U){for(const q of this.getWindows())U&&U.indexOf(q.id)>=0||q.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(U=>U.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=S.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=we([ee(2,o.ILogService),ee(3,G.IStateMainService),ee(4,A.IPolicyService),ee(5,r.IEnvironmentMainService),ee(6,W.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,l.IBackupMainService),ee(9,i.IConfigurationService),ee(10,V.IWorkspacesHistoryMainService),ee(11,j.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,a.IDialogMainService),ee(14,n.IFileService),ee(15,k.IProductService),ee(16,T.IProtocolMainService),ee(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(te[271],ie([0,1,60,33,75,52]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,w,v,I){this.workspacesManagementMainService=u,this.windowsMainService=w,this.workspacesHistoryMainService=v,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,w){const v=this.windowsMainService.getWindowById(u);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(u,w,v){return this.workspacesManagementMainService.createUntitledWorkspace(w,v)}deleteUntitledWorkspace(u,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(u,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}removeRecentlyOpened(u,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=we([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,M.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],D),e.WorkspacesMainService=D}),define(te[272],ie([0,1,13,41,25,17,44,16,31,49,43,35,2,14,9,4,12,7,30,81,129,46,143,102,247,146,60,263,19,69,179,84,117,56,105,177,27,59,111,191,212,192,249,106,193,194,15,204,86,68,5,85,264,225,259,22,6,206,269,65,20,63,255,87,38,252,91,112,32,231,233,73,48,238,239,265,240,266,114,242,243,244,245,250,33,270,251,28,92,75,271,52,248,37,211,42,258,221,55,72,89,253,260,261,8]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_,G,ae,X,Q,J,se,he,V,j,F,A,W,N,x,B,$,L,O,U,q,Y,oe,H,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se,ke,Z,ue,de,ye,Ce,Fe,Oe,$e,Ne,He,Qe,Be,Ge,K,le,fe,me,Ee,Le,Ue,it,xe,je,et,nt,lt,gt,St,Bt,zt,$t,_t,Ht,qt,jt,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends C.Disposable{constructor(be,Pe,De,Ie,We,ze,Ze,tt,_e,Ve,Ke){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=De,this.logService=Ie,this.environmentMainService=We,this.lifecycleMainService=ze,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const be=_e=>_e?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((_e,Ve,Ke,Je)=>be(Je.requestingUrl)?Ke(Pe.has(Ve)):Ke(!1)),S.session.defaultSession.setPermissionCheckHandler((_e,Ve,Ke,Je)=>be(Je.requestingUrl)?Pe.has(Ve):!1);const De=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ve=_e;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},We=_e=>_e.resourceType==="xhr"||Ie(_e.frame),ze=_e=>{const Ve=_e.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=S.BrowserWindow.getAllWindows();for(const Je of Ke)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ve)=>{if(_e.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Ke.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((_e,Ve)=>{const Ke=p.URI.parse(_e.url);return Ke.scheme===d.Schemas.vscodeWebview&&!Ze(Ke,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ve({cancel:!0})):Ke.scheme===d.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!De.has(Ke.scheme)?Ve({cancel:!We(_e)}):Ve({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((_e,Ve)=>{const Ke=_e.responseHeaders,Je=Ke["content-type"]||Ke["Content-Type"];if(Je&&Array.isArray(Je)){const ot=p.URI.parse(_e.url);if(ot.path.endsWith(".svg")&&De.has(ot.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!ot.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!We(_e)})}return Ve({cancel:!1})});const tt=S.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,m.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(De=>this.onUnexpectedError(De)),process.on("uncaughtException",De=>(0,E.onUnexpectedError)(De)),process.on("unhandledRejection",De=>(0,E.onUnexpectedError)(De)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(De,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),S.app.on("activate",async(De,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(De,Ie)=>{Ie.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Ie.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let be=[],Pe;S.app.on("open-file",(De,Ie)=>{this.logService.trace("app#open-file: ",Ie),De.preventDefault(),be.push((0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:p.URI.file(Ie)}:{fileUri:p.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",De=>{const Ie=this.windowsMainService?.getWindowByWebContents(De.sender);let We,ze;return Ie?.config?(We=Ie.config,ze={...process.env,...Ie.config.userEnv}):(We=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(De,Ie,We)=>{const ze=this.validateNlsPath([Ie]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,R.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(De,...Ie)=>{const We=this.validateNlsPath(Ie);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",De=>De.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",De=>De.sender.reload())}validateNlsPath(be){let Pe;for(const De of be)typeof De=="string"&&(typeof Pe!="string"?Pe=De:Pe=(0,m.join)(Pe,De));if(!(typeof Pe!="string"||!(0,m.isAbsolute)(Pe)||!(0,u.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!P.isLinux)))return p.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;P.isWindows&&be&&S.app.setAppUserModelId(be);try{P.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new i.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const De=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${De}`);const{sharedProcess:Ie,sharedProcessReady:We,sharedProcessClient:ze}=this.setupSharedProcess(De),Ze=await this.initServices(De,Ie,We);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,ze)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(r.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(Z.machineIdKey);return(!be||P.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,h.getMachineId)(),this.stateMainService.setItem(Z.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,be,this.userEnv)),De=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(We,"main")})(),Ie=(async()=>(await Pe.whenReady(),De))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:De}}async initServices(be,Pe,De){const Ie=new U.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(He.Win32UpdateService));break;case"linux":P.isLinuxSnap?Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ce.IUpdateService,new L.SyncDescriptor($e.LinuxUpdateService));break;case"darwin":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ie.set(me.IWindowsMainService,new L.SyncDescriptor(Ee.WindowsMainService,[be,this.userEnv],!1));const We=new G.DialogMainService(this.logService);Ie.set(G.IDialogMainService,We),Ie.set(oe.ILaunchMainService,new L.SyncDescriptor(oe.LaunchMainService,void 0,!1)),Ie.set(_.IDiagnosticsMainService,new L.SyncDescriptor(_.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(De.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(q.IIssueMainService,new L.SyncDescriptor(q.IssueMainService,[this.userEnv])),Ie.set(ae.IEncryptionMainService,new L.SyncDescriptor(X.EncryptionMainService,[be])),Ie.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ie.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ie.set(f.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ie.set(le.IWebviewManagerService,new L.SyncDescriptor(fe.WebviewMainService)),Ie.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ie.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ie.set(j.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(Se.IStorageMainService,new L.SyncDescriptor(Se.StorageMainService)),Ie.set(Se.IApplicationStorageMainService,new L.SyncDescriptor(Se.ApplicationStorageMainService)),P.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.WindowsExternalTerminalService)):P.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.MacExternalTerminalService)):P.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.LinuxExternalTerminalService));const ze=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(s.IBackupMainService,ze);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,ze,We,this.productService);if(Ie.set(et.IWorkspacesManagementMainService,Ze),Ie.set(it.IWorkspacesService,new L.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Ie.set(xe.IWorkspacesHistoryMainService,new L.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Qe.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,l.getDelayedChannel)(De.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new ue.TelemetryAppenderClient(_e),Ke=(0,ke.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Je=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Ke,piiPaths:Je,sendErrorTelemetry:!0};Ie.set(Z.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[ot],!1))}else Ie.set(Z.ITelemetryService,ye.NullTelemetryService);return Ie.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ie.set(Ht.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([ze.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(be,Pe,De){const Ie=l.ProxyChannel.fromService(be.get(oe.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const We=l.ProxyChannel.fromService(be.get(_.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const ze=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",ze),De.then(Ye=>Ye.registerChannel("policy",ze));const Ze=this.fileService.getProvider(d.Schemas.file);(0,b.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),De.then(Ye=>Ye.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=l.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),De.then(Ye=>Ye.registerChannel("userDataProfiles",_e));const Ve=new zt.RequestChannel(be.get($t.IRequestService));De.then(Ye=>Ye.registerChannel("request",Ve));const Ke=new Fe.UpdateChannel(be.get(Ce.IUpdateService));Pe.registerChannel("update",Ke);const Je=l.ProxyChannel.fromService(be.get(q.IIssueMainService));Pe.registerChannel("issue",Je);const ot=l.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=l.ProxyChannel.fromService(be.get(f.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=l.ProxyChannel.fromService(be.get(Ae.ISignService));Pe.registerChannel("sign",kt);const Xe=l.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=l.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),De.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=l.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=l.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=l.ProxyChannel.fromService(be.get(Qe.IURLService));Pe.registerChannel("url",Mt);const Dt=l.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=l.ProxyChannel.fromService(be.get(le.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new pe.StorageDatabaseChannel(this.logService,be.get(Se.IStorageMainService)));Pe.registerChannel("storage",ut),De.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(Se.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));De.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=l.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const qe=new ne.LogLevelChannel(be.get(re.ILogService),be.get(re.ILoggerService));Pe.registerChannel("logLevel",qe),De.then(Ye=>Ye.registerChannel("logLevel",qe));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),De.then(Ye=>Ye.registerChannel("logger",st));const dt=new k.ElectronExtensionHostDebugBroadcastChannel(be.get(me.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",dt);const at=l.ProxyChannel.fromService(be.get(j.IExtensionHostStarter));Pe.registerChannel(j.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const De=this.windowsMainService=be.get(me.IWindowsMainService),Ie=be.get(Qe.IURLService),We=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const ze=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(qe=>{try{return{uri:p.URI.parse(qe),url:qe}}catch{return}}).filter(qe=>{if(!qe||this.shouldBlockURI(qe.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(qe.uri);return st?(ze.push(st),!1):!0}),tt=this,_e=this.environmentMainService,Ve=this.productService,Ke=this.logService;Ie.registerHandler({async handleURL(qe,st){if(Ke.trace("app#handleURL: ",qe.toString(!0),st),qe.scheme===Ve.urlProtocol&&qe.path==="workspace"&&(qe=qe.with({authority:"file",path:p.URI.parse(qe.query).path,query:""})),tt.shouldBlockURI(qe))return!0;let dt=!1;const at=new URLSearchParams(qe.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),qe=qe.with({query:at.toString()}),dt=!0),dt||=P.isMacintosh&&De.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(_e.continueOn=Ye??void 0,at.delete("continueOn"),qe=qe.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(qe);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await De.open({context:5,cli:{..._e.args},urisToOpen:[Rt],forceNewWindow:dt,gotoLineMode:!0});return Lt.focus(),!0}if(dt){const[Lt]=await De.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Te.getRemoteAuthority)(qe)});return await Lt.ready(),Ie.open(qe,st)}return!1}});const Je=this._register(new Le.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),ot=new l.StaticRouter(qe=>Je.getActiveClientId().then(st=>qe===st)),ct=new Be.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ie.registerHandler(new Be.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ie,De,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,J.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?p.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if(ze.length>0)return De.open({context:pt,cli:Xe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return De.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return De.open({context:1,cli:Xe,urisToOpen:mt.map(qe=>(0,Ue.hasWorkspaceFileExtension)(qe)?{workspaceUri:p.URI.file(qe)}:{fileUri:p.URI.file(qe)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return De.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===d.Schemas.file&&P.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,I.getPathLabel)(be,{os:P.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===d.Schemas.file){const Pe=p.URI.file(be.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===d.Schemas.vscodeRemote){const Pe=be.path.indexOf(m.posix.sep,1);if(Pe!==-1){const De=be.path.substring(1,Pe),Ie=be.path.substring(Pe),We=p.URI.from({scheme:d.Schemas.vscodeRemote,authority:De,path:Ie,query:be.query,fragment:be.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:We}:/:[\d]+$/.test(Ie)?{fileUri:We}:{folderUri:We}}}}}afterWindowOpen(be,Pe){const De=be.get(Z.ITelemetryService),Ie=be.get(Ce.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(De,Pe),this.installMutex(),S.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Ie instanceof He.Win32UpdateService||Ie instanceof $e.LinuxUpdateService||Ie instanceof Oe.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(P.isWindows&&be)try{const Pe=await new Promise((Ie,We)=>{z(["windows-mutex"],Ie,We)}),De=new Pe.Mutex(be);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let De=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>De=!0),this._register(Pe.onDidError(({type:Ie,details:We})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(ze)),be.publicLog2("sharedprocesserror",{type:Ie,reason:We?.reason,code:We?.exitCode,visible:Pe.isVisible(),shuttingdown:De})}))}async resolveShellEnvironment(be,Pe,De){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ie){const We=(0,D.toErrorMessage)(Ie);De?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),De=JSON.parse((0,v.stripComments)(Pe)),We=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(De["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,y.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(ze))}}catch(be){this.logService.error(be)}}};Pt=we([ee(2,O.IInstantiationService),ee(3,re.ILogService),ee(4,Q.IEnvironmentMainService),ee(5,H.ILifecycleMainService),ee(6,o.IConfigurationService),ee(7,ve.IStateMainService),ee(8,x.IFileService),ee(9,Re.IProductService),ee(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(te[273],ie([0,1,37,8,280,2]),function(z,e,S,t,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends S.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((w,v)=>{try{this.watcher.value=(0,M.createWatcher)(this.productName,u,I=>{for(const C in I){const d=I[C];d===void 0?this.policies.delete(C):this.policies.set(C,d)}this._onDidChange.fire(Object.keys(I)),w()})}catch(I){v(I)}}))}}e.NativePolicyService=D}),define(te[274],ie([0,1,223,8,17,16,2,12,19,36,111,6,222,281]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends D.Disposable{constructor(b,p,y){super(),this.environmentService=p,this.logService=y,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:y,strictSSL:h}=this;let g;try{g=await(0,v.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",a))}const l={...process.env,...g},i=b.agent?b.agent:await(0,C.getProxyAgent)(b.url||"",l,{proxyUrl:y,strictSSL:h});b.agent=i,b.strictSSL=h,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const a=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),a}catch(a){throw this.logService.trace("RequestService#request (node) - error",b.url,a),a}}async getNodeRequest(b){return((0,S.parse)(b.url).protocol==="https:"?await new Promise((h,g)=>{z(["https"],h,g)}):await new Promise((h,g)=>{z(["http"],h,g)})).request}_request(b,p){return t.Promises.withAsyncBody(async(y,h)=>{const g=(0,S.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),i={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,E.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const a=l(i,r=>{const n=(0,E.isNumber)(b.followRedirects)?b.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&n>0&&r.headers.location)this._request({...b,url:r.headers.location,followRedirects:n-1},p).then(y,h);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,d.createGunzip)())),y({res:r,stream:(0,M.streamToBufferReadableStream)(s)})}});a.on("error",h),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),p.onCancellationRequested(()=>{a.abort(),h(new R.CancellationError)})})}async resolveProxy(b){}};m=we([ee(0,u.IConfigurationService),ee(1,w.INativeEnvironmentService),ee(2,I.ILogService)],m),e.RequestService=m}),define(te[275],ie([0,1,13,274]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(D){return S.net.request}class R extends t.RequestService{request(E,u){return super.request({...E||{},getRawRequest:M},u)}}e.RequestMainService=R}),define(te[282],ie([0,1,13,40,7,24,8,44,16,31,49,35,14,9,71,4,34,26,21,46,83,272,10,19,216,229,27,59,183,15,202,86,68,199,85,22,205,6,208,54,20,61,254,113,236,55,275,87,224,38,228,73,64,42,37,273,210,2,51,241,39,237]),function(z,e,S,t,M,R,D,E,u,w,v,I,C,d,m,P,b,p,y,h,g,l,i,a,r,n,s,c,o,f,k,T,_,G,ae,X,Q,J,se,he,V,j,F,A,W,N,x,B,$,L,O,U,q,Y,oe,H,re,ne,ce,ge,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(ve){console.error(ve.message),S.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,pe,Se,ke,Z,ue,de,ye]=this.createServices();try{try{await this.initServices(Se,ye,ke,Z,de)}catch(Ce){throw this.handleStartupDataDirError(Se,de.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const Fe=Ce.get(J.ILogService),Oe=Ce.get(X.ILifecycleMainService),$e=Ce.get(f.IFileService),Ne=Ce.get(J.ILoggerService),He=await this.claimInstance(Fe,Se,Oe,ve,de,!0);return y.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Qe=>{Fe.warn(`Error writing main lockfile: ${Qe.stack}`)}),ue.logger=Ne.createLogger(M.URI.file((0,d.join)(Se.logsPath,"main.log")),{name:"main"}),(0,v.once)(Oe.onWillShutdown)(Qe=>{$e.dispose(),ke.dispose(),Qe.join(y.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),ve.createInstance(l.CodeApplication,He,pe).startup()})}catch(Ce){ve.invokeFunction(this.quit,Ce)}}createServices(){const ve=new ae.ServiceCollection,pe=new ne.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...he.default};ve.set(V.IProductService,Se);const ke=new s.EnvironmentMainService(this.resolveArgs(),Se),Z=this.patchEnvironment(ke);ve.set(s.IEnvironmentMainService,ke);const ue=new Q.BufferLogService,de=pe.add(new J.MultiplexLogService([new J.ConsoleMainLogger((0,J.getLogLevel)(ke)),ue]));ve.set(J.ILogService,de);const ye=new k.FileService(de);ve.set(f.IFileService,ye);const Ce=new T.DiskFileSystemProvider(de);ye.registerProvider(C.Schemas.file,Ce);const Fe=new ge.UriIdentityService(ye);ve.set(ce.IUriIdentityService,Fe),ve.set(J.ILoggerService,new se.LoggerService(de));const Oe=new O.StateMainService(ke,de,ye);ve.set(L.IStateMainService,Oe);const $e=new Y.UserDataProfilesMainService(Oe,Fe,ke,ye,de);ve.set(Y.IUserDataProfilesMainService,$e);const Ne=P.isWindows&&Se.win32RegValueName?pe.add(new H.NativePolicyService(Se.win32RegValueName)):ke.policyFile?pe.add(new re.FilePolicyService(ke.policyFile,ye,de)):new oe.NullPolicyService;ve.set(oe.IPolicyService,Ne);const He=new r.ConfigurationService($e.defaultProfile.settingsResource,ye,Ne,de);return ve.set(a.IConfigurationService,He),ve.set(X.ILifecycleMainService,new _.SyncDescriptor(X.LifecycleMainService,void 0,!1)),ve.set(N.IRequestService,new _.SyncDescriptor(x.RequestMainService,void 0,!0)),ve.set(q.IThemeMainService,new _.SyncDescriptor(q.ThemeMainService)),ve.set(B.ISignService,new _.SyncDescriptor($.SignService,void 0,!1)),ve.set(A.ITunnelService,new _.SyncDescriptor(W.TunnelService)),ve.set(j.IProtocolMainService,new F.ProtocolMainService(ke,$e,de)),[new G.InstantiationService(ve,!0),Z,ke,He,Oe,ue,Se,$e]}patchEnvironment(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const ke=process.env[Se];typeof ke=="string"&&(pe[Se]=ke)}),Object.assign(process.env,pe),pe}async initServices(ve,pe,Se,ke,Z){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?y.Promises.mkdir(ue,{recursive:!0}):void 0)),ke.init(),Se.initialize()]),pe.setEnablement(Z.quality!=="stable"||Se.getValue(Re.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ve,pe,Se,ke,Z,ue){let de;try{(0,m.mark)("code/willStartMainServer"),de=await(0,g.serve)(pe.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,v.once)(Se.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,Z.nameLong,ye),ye;let Ce;try{Ce=await(0,g.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!ue||P.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(0,null,Z.nameShort),(0,i.localize)(1,null),Z.nameLong),Ne;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(He){throw ve.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(ve,pe,Se,ke,Z,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ve.error(Ne),Ce.dispose(),new Error(Ne)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(2,null,Z.nameShort),(0,i.localize)(3,null),Z.nameLong)},1e4));const Oe=h.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),$e=h.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ke.invokeFunction(async()=>{const Ne=new n.DiagnosticsService(U.NullTelemetryService,Z),He=await $e.getMainDiagnostics(),Qe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,Qe);throw console.log(Be),new u.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,ve),ve.trace("Sending env to running instance..."),await Oe.start(pe.args,process.env),Ce.dispose(),Fe&&clearTimeout(Fe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ve.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(ve,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const ke=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,g.XDG_RUNTIME_DIR]).map(Z=>(0,I.getPathLabel)(M.URI.file(Z),{os:P.OS,tildify:ve}));this.showStartupWarningDialog((0,i.localize)(4,null),(0,i.localize)(5,null,(0,E.toErrorMessage)(Se),ke.join(`
`)),pe)}}showStartupWarningDialog(ve,pe,Se){S.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ve,pe){if(P.isWindows){const Se=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((ke,Z)=>{z(["windows-foreground-love"],ke,Z)})).allowSetForegroundWindow(Se)}catch(ke){pe.error(ke)}}}quit(ve,pe){const Se=ve.get(J.ILogService),ke=ve.get(X.ILifecycleMainService);let Z=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(Z=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),ke.kill(Z)}resolveArgs(){const ve=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,o.createWaitMarkerFileSync)(ve.verbose);pe&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.doValidatePaths(ve._,ve.goto);ve._=pe}return ve}doValidatePaths(ve,pe){const Se=(0,b.cwd)(),ke=ve.map(de=>{let ye=String(de),Ce;pe&&(Ce=(0,w.parseLineAndColumnAware)(ye),ye=Ce.path),ye&&(ye=this.preparePath(Se,ye));const Fe=(0,w.sanitizeFilePath)(ye,Se),Oe=(0,d.basename)(Fe);return Oe&&!(0,w.isValidBasename)(Oe)?null:pe&&Ce?(Ce.path=Fe,this.toPath(Ce)):Fe}),Z=P.isWindows||P.isMacintosh,ue=(0,R.distinct)(ke,de=>de&&Z?de.toLowerCase():de||"");return(0,R.coalesce)(ue)}preparePath(ve,pe){return P.isWindows&&(pe=(0,p.rtrim)(pe,'"')),pe=(0,p.trim)((0,p.trim)(pe," "),"	"),P.isWindows&&(pe=(0,d.resolve)(ve,pe),pe=(0,p.rtrim)(pe,".")),pe}toPath(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ef8e6b87a2a5a25ba1ef946bd1640ca3510956c/core/vs/code/electron-main/main.js.map
