/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var t=[],C=0,R=B.length;C<R;C++)t[C]=Q[B[C]];return t};define(Q[49],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(L){return(E,g,h)=>{let w=null,I=null;if(typeof h.value=="function"?(w="value",I=h.value):typeof h.get=="function"&&(w="get",I=h.get),!I)throw new Error("not supported");h[w]=L(I,g)}}t.createDecorator=C;function R(L,E,g){let h=null,w=null;if(typeof g.value=="function"?(h="value",w=g.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(h="get",w=g.get),!w)throw new Error("not supported");const I=`$memoize$${E}`;g[h]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[I]}}t.memoize=R;function D(L,E,g){return C((h,w)=>{const I=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...y){this[m]||(this[m]=g?g():void 0),clearTimeout(this[I]),E&&(this[m]=E(this[m],...y),y=[this[m]]),this[I]=setTimeout(()=>{h.apply(this,y),this[m]=g?g():void 0},L)}})}t.debounce=D;function k(L,E,g){return C((h,w)=>{const I=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,y=`$throttle$lastRun$${w}`,p=`$throttle$pending$${w}`;return function(...P){if(this[m]||(this[m]=g?g():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),E&&(this[m]=E(this[m],...P)),this[p])return;const S=this[y]+L;S<=Date.now()?(this[y]=Date.now(),h.apply(this,[this[m]]),this[m]=g?g():void 0):(this[p]=!0,this[I]=setTimeout(()=>{this[p]=!1,this[y]=Date.now(),h.apply(this,[this[m]]),this[m]=g?g():void 0},S-Date.now()))}})}t.throttle=k}),define(Q[68],Z([0,1,11]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function R(g,h){if(!g)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=R;function D(g,h="Unreachable"){throw new Error(h)}t.assertNever=D;function k(g){if(!g)throw new C.BugIndicatingError("Assertion Failed")}t.assert=k;function L(g){if(!g()){debugger;g(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}t.assertFn=L;function E(g,h){let w=0;for(;w<g.length-1;){const I=g[w],m=g[w+1];if(!h(I,m))return!1;w++}return!0}t.checkAdjacentItems=E}),define(Q[50],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var R;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(R=t.SyntaxKind||(t.SyntaxKind={}));var D;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(D=t.ParseErrorCode||(t.ParseErrorCode={}));var k;(function(e){e.DEFAULT={allowTrailingComma:!0}})(k=t.ParseOptions||(t.ParseOptions={}));function L(e,r=!1){let i=0;const n=e.length;let o="",u=0,a=16,f=0;function b(se){let fe=0,le=0;for(;fe<se;){const ie=e.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,fe++}return fe<se&&(le=-1),le}function U(se){i=se,o="",u=0,a=16,f=0}function _(){const se=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&h(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&h(e.charCodeAt(i)))for(i++;i<e.length&&h(e.charCodeAt(i));)i++;else return f=3,e.substring(se,i);let fe=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&h(e.charCodeAt(i))){for(i++;i<e.length&&h(e.charCodeAt(i));)i++;fe=i}else f=3;return e.substring(se,fe)}function H(){let se="",fe=i;for(;;){if(i>=n){se+=e.substring(fe,i),f=2;break}const le=e.charCodeAt(i);if(le===34){se+=e.substring(fe,i),i++;break}if(le===92){if(se+=e.substring(fe,i),i++,i>=n){f=2;break}switch(e.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const V=b(4);V>=0?se+=String.fromCharCode(V):f=4;break}default:f=5}fe=i;continue}if(le>=0&&le<=31)if(g(le)){se+=e.substring(fe,i),f=2;break}else f=6;i++}return se}function K(){if(o="",f=0,u=i,i>=n)return u=n,a=17;let se=e.charCodeAt(i);if(E(se)){do i++,o+=String.fromCharCode(se),se=e.charCodeAt(i);while(E(se));return a=15}if(g(se))return i++,o+=String.fromCharCode(se),se===13&&e.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(se){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=H(),a=10;case 47:{const fe=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(e.charCodeAt(i));)i++;return o=e.substring(fe,i),a=12}if(e.charCodeAt(i+1)===42){i+=2;const le=n-1;let ie=!1;for(;i<le;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,f=1),o=e.substring(fe,i),a=13}return o+=String.fromCharCode(se),i++,a=16}case 45:if(o+=String.fromCharCode(se),i++,i===n||!h(e.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),a=11;default:for(;i<n&&ne(se);)i++,se=e.charCodeAt(i);if(u!==i){switch(o=e.substring(u,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(se),i++,a=16}}function ne(se){if(E(se)||g(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=K();while(se>=12&&se<=15);return se}return{setPosition:U,getPosition:()=>i,scan:r?re:K,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>f}}t.createScanner=L;function E(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function g(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var w;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(w||(w={}));function I(e,r){const i=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(b,U,_,H){u.value=b,u.offset=U,u.length=_,u.type=H,u.colonOffset=void 0,o=u}try{v(e,{onObjectBegin:(b,U)=>{if(r<=b)throw n;o=void 0,a=r>b,i.push("")},onObjectProperty:(b,U,_)=>{if(r<U||(f(b,U,_,"property"),i[i.length-1]=b,r<=U+_))throw n},onObjectEnd:(b,U)=>{if(r<=b)throw n;o=void 0,i.pop()},onArrayBegin:(b,U)=>{if(r<=b)throw n;o=void 0,i.push(0)},onArrayEnd:(b,U)=>{if(r<=b)throw n;o=void 0,i.pop()},onLiteralValue:(b,U,_)=>{if(r<U||(f(b,U,_,s(b)),r<=U+_))throw n},onSeparator:(b,U,_)=>{if(r<=U)throw n;if(b===":"&&o&&o.type==="property")o.colonOffset=U,a=!1,o=void 0;else if(b===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(b){if(b!==n)throw b}return{path:i,previousNode:o,isAtPropertyKey:a,matches:b=>{let U=0;for(let _=0;U<b.length&&_<i.length;_++)if(b[U]===i[_]||b[U]==="*")U++;else if(b[U]!=="**")return!1;return U===b.length}}}t.getLocation=I;function m(e,r=[],i=k.DEFAULT){let n=null,o=[];const u=[];function a(b){Array.isArray(o)?o.push(b):n!==null&&(o[n]=b)}return v(e,{onObjectBegin:()=>{const b={};a(b),u.push(o),o=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const b=[];a(b),u.push(o),o=b,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:a,onError:(b,U,_)=>{r.push({error:b,offset:U,length:_})}},i),o[0]}t.parse=m;function y(e,r=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function u(b){return n.children.push(b),b}v(e,{onObjectBegin:b=>{n=u({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,U,_)=>{n=u({type:"property",offset:U,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:U,length:_,parent:n})},onObjectEnd:(b,U)=>{n.length=b+U-n.offset,n=n.parent,o(b+U)},onArrayBegin:(b,U)=>{n=u({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,U)=>{n.length=b+U-n.offset,n=n.parent,o(b+U)},onLiteralValue:(b,U,_)=>{u({type:s(b),offset:U,length:_,parent:n,value:b}),o(U+_)},onSeparator:(b,U,_)=>{n.type==="property"&&(b===":"?n.colonOffset=U:b===","&&o(U))},onError:(b,U,_)=>{r.push({error:b,offset:U,length:_})}},i);const f=n.children[0];return f&&delete f.parent,f}t.parseTree=y;function p(e,r){if(!e)return;let i=e;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===n){i=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}t.findNodeAtLocation=p;function P(e){if(!e.parent||!e.parent.children)return[];const r=P(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=P;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":{const r=Object.create(null);for(const i of e.children){const n=i.children[1];n&&(r[i.children[0].value]=S(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function l(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=l;function d(e,r,i=!1){if(l(e,r,i)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const u=d(n[o],r,i);if(u)return u}return e}}t.findNodeAtOffset=d;function v(e,r,i=k.DEFAULT){const n=L(e,!1);function o(A){return A?()=>A(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(A){return A?x=>A(x,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),f=u(r.onObjectProperty),b=o(r.onObjectEnd),U=o(r.onArrayBegin),_=o(r.onArrayEnd),H=u(r.onLiteralValue),K=u(r.onSeparator),ne=o(r.onComment),re=u(r.onError),se=i&&i.disallowComments,fe=i&&i.allowTrailingComma;function le(){for(;;){const A=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:se||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:se?ie(10):ne();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,x=[],T=[]){if(re(A),x.length+T.length>0){let O=n.getToken();for(;O!==17;){if(x.indexOf(O)!==-1){le();break}else if(T.indexOf(O)!==-1)break;O=le()}}}function V(A){const x=n.getTokenValue();return A?H(x):f(x),le(),!0}function N(){switch(n.getToken()){case 11:{let A=0;try{A=JSON.parse(n.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}H(A);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function F(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(K(":"),le(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function j(){a(),le();let A=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),K(","),le(),n.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return b(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){U(),le();let A=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),K(","),le(),n.getToken()===4&&fe)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return _(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return j();case 10:return V(!0);default:return N()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}t.visit=v;function c(e,r){const i=L(e),n=[];let o,u=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==a&&n.push(e.substring(u,a)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),u=i.getPosition();break}while(o!==17);return n.join("")}t.stripComments=c;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function B(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function L(g){k.push(g,Date.now())}function E(){const g=[];for(let h=0;h<k.length;h+=2)g.push({name:k[h],startTime:k[h+1]});return g}return{mark:L,getMarks:E}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(D+L.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function C(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=t()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=C(R))}(),function(B,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var R in C)(typeof exports=="object"?exports:B)[R]=C[R]}}(typeof self<"u"?self:this,function(){return function(B){var t={};function C(R){if(t[R])return t[R].exports;var D=t[R]={i:R,l:!1,exports:{}};return B[R].call(D.exports,D,D.exports,C),D.l=!0,D.exports}return C.m=B,C.c=t,C.d=function(R,D,k){C.o(R,D)||Object.defineProperty(R,D,{enumerable:!0,get:k})},C.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},C.t=function(R,D){if(1&D&&(R=C(R)),8&D||4&D&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(C.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&D&&typeof R!="string")for(var L in R)C.d(k,L,function(E){return R[E]}.bind(null,L));return k},C.n=function(R){var D=R&&R.__esModule?function(){return R.default}:function(){return R};return C.d(D,"a",D),D},C.o=function(R,D){return Object.prototype.hasOwnProperty.call(R,D)},C.p="",C(C.s=0)}([function(B,t,C){(function(R){var D;t=B.exports=T,D=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,E=t.re=[],g=t.src=[],h=0,w=h++;g[w]="0|[1-9]\\d*";var I=h++;g[I]="[0-9]+";var m=h++;g[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=h++;g[y]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var p=h++;g[p]="("+g[I]+")\\.("+g[I]+")\\.("+g[I]+")";var P=h++;g[P]="(?:"+g[w]+"|"+g[m]+")";var S=h++;g[S]="(?:"+g[I]+"|"+g[m]+")";var l=h++;g[l]="(?:-("+g[P]+"(?:\\."+g[P]+")*))";var d=h++;g[d]="(?:-?("+g[S]+"(?:\\."+g[S]+")*))";var v=h++;g[v]="[0-9A-Za-z-]+";var c=h++;g[c]="(?:\\+("+g[v]+"(?:\\."+g[v]+")*))";var s=h++,e="v?"+g[y]+g[l]+"?"+g[c]+"?";g[s]="^"+e+"$";var r="[v=\\s]*"+g[p]+g[d]+"?"+g[c]+"?",i=h++;g[i]="^"+r+"$";var n=h++;g[n]="((?:<|>)?=?)";var o=h++;g[o]=g[I]+"|x|X|\\*";var u=h++;g[u]=g[w]+"|x|X|\\*";var a=h++;g[a]="[v=\\s]*("+g[u]+")(?:\\.("+g[u]+")(?:\\.("+g[u]+")(?:"+g[l]+")?"+g[c]+"?)?)?";var f=h++;g[f]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[c]+"?)?)?";var b=h++;g[b]="^"+g[n]+"\\s*"+g[a]+"$";var U=h++;g[U]="^"+g[n]+"\\s*"+g[f]+"$";var _=h++;g[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=h++;g[H]="(?:~>?)";var K=h++;g[K]="(\\s*)"+g[H]+"\\s+",E[K]=new RegExp(g[K],"g");var ne=h++;g[ne]="^"+g[H]+g[a]+"$";var re=h++;g[re]="^"+g[H]+g[f]+"$";var se=h++;g[se]="(?:\\^)";var fe=h++;g[fe]="(\\s*)"+g[se]+"\\s+",E[fe]=new RegExp(g[fe],"g");var le=h++;g[le]="^"+g[se]+g[a]+"$";var ie=h++;g[ie]="^"+g[se]+g[f]+"$";var V=h++;g[V]="^"+g[n]+"\\s*("+r+")$|^$";var N=h++;g[N]="^"+g[n]+"\\s*("+e+")$|^$";var F=h++;g[F]="(\\s*)"+g[n]+"\\s*("+r+"|"+g[a]+")",E[F]=new RegExp(g[F],"g");var j=h++;g[j]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var $=h++;g[$]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var Y=h++;g[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)D(A,g[A]),E[A]||(E[A]=new RegExp(g[A]));function x(z,G){if(z instanceof T)return z;if(typeof z!="string"||z.length>k||!(G?E[i]:E[s]).test(z))return null;try{return new T(z,G)}catch{return null}}function T(z,G){if(z instanceof T){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof T))return new T(z,G);D("SemVer",z,G),this.loose=G;var J=z.trim().match(G?E[i]:E[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}t.parse=x,t.valid=function(z,G){var J=x(z,G);return J?J.version:null},t.clean=function(z,G){var J=x(z.trim().replace(/^[=v]+/,""),G);return J?J.version:null},t.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(z){return D("SemVer.compare",this.version,this.loose,z),z instanceof T||(z=new T(z,this.loose)),this.compareMain(z)||this.comparePre(z)},T.prototype.compareMain=function(z){return z instanceof T||(z=new T(z,this.loose)),M(this.major,z.major)||M(this.minor,z.minor)||M(this.patch,z.patch)},T.prototype.comparePre=function(z){if(z instanceof T||(z=new T(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var J=this.prerelease[G],ue=z.prerelease[G];if(D("prerelease compare",G,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return M(J,ue)}while(++G)},T.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,G,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new T(z,J).inc(G,ue).version}catch{return null}},t.diff=function(z,G){if(ae(z,G))return null;var J=x(z),ue=x(G);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},t.compareIdentifiers=M;var O=/^[0-9]+$/;function M(z,G){var J=O.test(z),ue=O.test(G);return J&&ue&&(z=+z,G=+G),J&&!ue?-1:ue&&!J?1:z<G?-1:z>G?1:0}function W(z,G,J){return new T(z,J).compare(new T(G,J))}function q(z,G,J){return W(z,G,J)>0}function X(z,G,J){return W(z,G,J)<0}function ae(z,G,J){return W(z,G,J)===0}function ce(z,G,J){return W(z,G,J)!==0}function pe(z,G,J){return W(z,G,J)>=0}function Se(z,G,J){return W(z,G,J)<=0}function te(z,G,J,ue){var me;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z!==J;break;case"":case"=":case"==":me=ae(z,J,ue);break;case"!=":me=ce(z,J,ue);break;case">":me=q(z,J,ue);break;case">=":me=pe(z,J,ue);break;case"<":me=X(z,J,ue);break;case"<=":me=Se(z,J,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function oe(z,G){if(z instanceof oe){if(z.loose===G)return z;z=z.value}if(!(this instanceof oe))return new oe(z,G);D("comparator",z,G),this.loose=G,this.parse(z),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}t.rcompareIdentifiers=function(z,G){return M(G,z)},t.major=function(z,G){return new T(z,G).major},t.minor=function(z,G){return new T(z,G).minor},t.patch=function(z,G){return new T(z,G).patch},t.compare=W,t.compareLoose=function(z,G){return W(z,G,!0)},t.rcompare=function(z,G,J){return W(G,z,J)},t.sort=function(z,G){return z.sort(function(J,ue){return t.compare(J,ue,G)})},t.rsort=function(z,G){return z.sort(function(J,ue){return t.rcompare(J,ue,G)})},t.gt=q,t.lt=X,t.eq=ae,t.neq=ce,t.gte=pe,t.lte=Se,t.cmp=te,t.Comparator=oe;var ge={};function de(z,G){if(z instanceof de)return z.loose===G?z:new de(z.raw,G);if(z instanceof oe)return new de(z.value,G);if(!(this instanceof de))return new de(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ve(z){return!z||z.toLowerCase()==="x"||z==="*"}function ke(z,G,J,ue,me,De,we,Le,be,Ce,Me,Re,Te){return((G=ve(J)?"":ve(ue)?">="+J+".0.0":ve(me)?">="+J+"."+ue+".0":">="+G)+" "+(Le=ve(be)?"":ve(Ce)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+Ce+1)+".0":Re?"<="+be+"."+Ce+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(z,G){for(var J=0;J<z.length;J++)if(!z[J].test(G))return!1;if(G.prerelease.length){for(J=0;J<z.length;J++)if(D(z[J].semver),z[J].semver!==ge&&z[J].semver.prerelease.length>0){var ue=z[J].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(z,G,J){try{G=new de(G,J)}catch{return!1}return G.test(z)}function xe(z,G,J,ue){var me,De,we,Le,be;switch(z=new T(z,ue),G=new de(G,ue),J){case">":me=q,De=Se,we=X,Le=">",be=">=";break;case"<":me=X,De=pe,we=q,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,G,ue))return!1;for(var Ce=0;Ce<G.set.length;++Ce){var Me=G.set[Ce],Re=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===ge&&(Ae=new oe(">=0.0.0")),Re=Re||Ae,Te=Te||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Te.semver,ue)&&(Te=Ae)}),Re.operator===Le||Re.operator===be||(!Te.operator||Te.operator===Le)&&De(z,Te.semver)||Te.operator===be&&we(z,Te.semver))return!1}return!0}oe.prototype.parse=function(z){var G=this.loose?E[V]:E[N],J=z.match(G);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new T(J[2],this.loose):this.semver=ge},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(z){return D("Comparator.test",z,this.loose),this.semver===ge||(typeof z=="string"&&(z=new T(z,this.loose)),te(z,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(z,G){if(!(z instanceof oe))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new de(z.value,G),Ue(this.value,J,G);if(z.operator==="")return J=new de(this.value,G),Ue(z.semver,J,G);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),De=this.semver.version===z.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=te(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),be=te(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||me||De&&we||Le||be},t.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),D("range",z,G);var J=G?E[$]:E[j];z=z.replace(J,ke),D("hyphen replace",z),z=z.replace(E[F],"$1$2$3"),D("comparator trim",z,E[F]),z=(z=(z=z.replace(E[K],"$1~")).replace(E[fe],"$1^")).split(/\s+/).join(" ");var ue=G?E[V]:E[N],me=z.split(" ").map(function(De){return function(we,Le){return D("comp",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){D("caret",Re,Te);var Ae=Te?E[ie]:E[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return D("caret",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(D("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),D("caret return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),D("caret",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){var Ae=Te?E[re]:E[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return D("tilde",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",D("tilde return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),D("tildes",we),we=function(be,Ce){return D("replaceXRanges",be,Ce),be.split(/\s+/).map(function(Me){return function(Re,Te){Re=Re.trim();var Ae=Te?E[U]:E[b];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,Oe){D("xRange",Re,Ne,ye,Ee,Pe,Ie,Oe);var Ve=ve(Ee),ze=Ve||ve(Pe),je=ze||ve(Ie);return ye==="="&&je&&(ye=""),Ve?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ne),Ne})}(Me,Ce)}).join(" ")}(we,Le),D("xrange",we),we=function(be,Ce){return D("replaceStars",be,Ce),be.trim().replace(E[Y],"")}(we,Le),D("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(ue)})),me=me.map(function(De){return new oe(De,G)})},de.prototype.intersects=function(z,G){if(!(z instanceof de))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return z.set.some(function(me){return me.every(function(De){return ue.intersects(De,G)})})})})},t.toComparators=function(z,G){return new de(z,G).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new T(z,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,G,J){var ue=null,me=null;try{var De=new de(G,J)}catch{return null}return z.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==-1||(me=new T(ue=we,J)))}),ue},t.minSatisfying=function(z,G,J){var ue=null,me=null;try{var De=new de(G,J)}catch{return null}return z.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==1||(me=new T(ue=we,J)))}),ue},t.validRange=function(z,G){try{return new de(z,G).range||"*"}catch{return null}},t.ltr=function(z,G,J){return xe(z,G,"<",J)},t.gtr=function(z,G,J){return xe(z,G,">",J)},t.outside=xe,t.prerelease=function(z,G){var J=x(z,G);return J&&J.prerelease.length?J.prerelease:null},t.intersects=function(z,G,J){return z=new de(z,J),G=new de(G,J),z.intersects(G)},t.coerce=function(z){if(z instanceof T)return z;if(typeof z!="string")return null;var G=z.match(E[_]);return G==null?null:x((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,C(1))},function(B,t){var C,R,D=B.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function E(S){if(C===setTimeout)return setTimeout(S,0);if((C===k||!C)&&setTimeout)return C=setTimeout,setTimeout(S,0);try{return C(S,0)}catch{try{return C.call(null,S,0)}catch{return C.call(this,S,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:k}catch{C=k}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var g,h=[],w=!1,I=-1;function m(){w&&g&&(w=!1,g.length?h=g.concat(h):I=-1,h.length&&y())}function y(){if(!w){var S=E(m);w=!0;for(var l=h.length;l;){for(g=h,h=[];++I<l;)g&&g[I].run();I=-1,l=h.length}g=null,w=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(S)}}function p(S,l){this.fun=S,this.array=l}function P(){}D.nextTick=function(S){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];h.push(new p(S,l)),h.length!==1||w||E(y)},p.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=P,D.addListener=P,D.once=P,D.off=P,D.removeListener=P,D.removeAllListeners=P,D.emit=P,D.prependListener=P,D.prependOnceListener=P,D.listeners=function(S){return[]},D.binding=function(S){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(S){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class R{constructor(E,g,h){this.level=E,this.key=g,this.value=h,this.forward=[]}}const D=void 0;class k{constructor(E,g=2**16){this.comparator=E,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new R(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,D,D)}has(E){return Boolean(k._search(this,E,this.comparator))}get(E){return k._search(this,E,this.comparator)?.value}set(E,g){return k._insert(this,E,g,this.comparator)&&(this._size+=1),this}delete(E){const g=k._delete(this,E,this.comparator);return g&&(this._size-=1),g}forEach(E,g){let h=this._header.forward[0];for(;h;)E.call(g,h.value,h.key,this),h=h.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",g=this._header.forward[0];for(;g;)E+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return E}static _search(E,g,h){let w=E._header;for(let I=E._level-1;I>=0;I--)for(;w.forward[I]&&h(w.forward[I].key,g)<0;)w=w.forward[I];if(w=w.forward[0],w&&h(w.key,g)===0)return w}static _insert(E,g,h,w){const I=[];let m=E._header;for(let y=E._level-1;y>=0;y--){for(;m.forward[y]&&w(m.forward[y].key,g)<0;)m=m.forward[y];I[y]=m}if(m=m.forward[0],m&&w(m.key,g)===0)return m.value=h,!1;{const y=k._randomLevel(E);if(y>E._level){for(let p=E._level;p<y;p++)I[p]=E._header;E._level=y}m=new R(y,g,h);for(let p=0;p<y;p++)m.forward[p]=I[p].forward[p],I[p].forward[p]=m;return!0}}static _randomLevel(E,g=.5){let h=1;for(;Math.random()<g&&h<E._maxLevel;)h+=1;return h}static _delete(E,g,h){const w=[];let I=E._header;for(let m=E._level-1;m>=0;m--){for(;I.forward[m]&&h(I.forward[m].key,g)<0;)I=I.forward[m];w[m]=I}if(I=I.forward[0],!I||h(I.key,g)!==0)return!1;for(let m=0;m<E._level&&w[m].forward[m]===I;m++)w[m].forward[m]=I.forward[m];for(;E._level>0&&E._header.forward[E._level-1]===D;)E._level-=1;return!0}}t.SkipList=k}),define(Q[43],Z([0,1,11,2]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function D(c){const s=c;return s?typeof s.read=="function":!1}t.isReadable=D;function k(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}t.isReadableStream=k;function L(c){const s=c;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=L;function E(c,s){return new g(c,s)}t.newWriteableStream=E;class g{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(e);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,s){const e=[];let r;for(;(r=c.read())!==null;)e.push(r);return s(e)}t.consumeReadable=h;function w(c,s,e){const r=[];let i;for(;(i=c.read())!==null&&r.length<e;)r.push(i);return i===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return c.read()}}}t.peekReadable=w;function I(c,s){return new Promise((e,r)=>{const i=[];m(c,{onData:n=>{s&&i.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(i):void 0)}})})}t.consumeStream=I;function m(c,s){let e=!1;return c.on("error",r=>{e||s.onError(r)}),c.on("end",()=>{e||s.onEnd()}),c.on("data",r=>{e||s.onData(r)}),(0,R.toDisposable)(()=>e=!0)}t.listenStream=m;function y(c,s){return new Promise((e,r)=>{const i=new R.DisposableStore,n=[],o=f=>{if(n.push(f),n.length>s)return i.dispose(),c.pause(),e({stream:c,buffer:n,ended:!1})},u=f=>r(f),a=()=>e({stream:c,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),i.add((0,R.toDisposable)(()=>c.removeListener("end",a))),c.on("end",a),i.add((0,R.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}t.peekStream=y;function p(c,s){const e=E(s);return e.end(c),e}t.toStream=p;function P(){const c=E(()=>{throw new Error("not supported")});return c.end(),c}t.emptyStream=P;function S(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}t.toReadable=S;function l(c,s,e){const r=E(e);return m(c,{onData:i=>r.write(s.data(i)),onError:i=>r.error(s.error?s.error(i):i),onEnd:()=>r.end()}),r}t.transform=l;function d(c,s,e){let r=!1;return{read:()=>{const i=s.read();return r?i:(r=!0,i!==null?e([c,i]):c)}}}t.prefixedReadable=d;function v(c,s,e){let r=!1;const i=E(e);return m(s,{onData:n=>r?i.write(n):(r=!0,i.write(e([c,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(c)),i.end()}}),i}t.prefixedStream=v}),define(Q[15],Z([0,1,43]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const R=typeof Buffer<"u";let D,k;class L{static alloc(f){return R?new L(Buffer.allocUnsafe(f)):new L(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new L(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&R?new L(Buffer.from(f)):(D||(D=new TextEncoder),new L(D.encode(f)))}static fromByteArray(f){const b=L.alloc(f.length);for(let U=0,_=f.length;U<_;U++)b.buffer[U]=f[U];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let H=0,K=f.length;H<K;H++)b+=f[H].byteLength}const U=L.alloc(b);let _=0;for(let H=0,K=f.length;H<K;H++){const ne=f[H];U.set(ne,_),_+=ne.byteLength}return U}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=L.alloc(this.byteLength);return f.set(this),f}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(f,b){return new L(this.buffer.subarray(f,b))}set(f,b){if(f instanceof L)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return h(this.buffer,f)}writeUInt32BE(f,b){w(this.buffer,f,b)}readUInt32LE(f){return I(this.buffer,f)}writeUInt32LE(f,b){m(this.buffer,f,b)}readUInt8(f){return y(this.buffer,f)}writeUInt8(f,b){p(this.buffer,f,b)}}t.VSBuffer=L;function E(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0}t.readUInt16LE=E;function g(a,f,b){a[b+0]=f&255,f=f>>>8,a[b+1]=f&255}t.writeUInt16LE=g;function h(a,f){return a[f]*2**24+a[f+1]*2**16+a[f+2]*2**8+a[f+3]}t.readUInt32BE=h;function w(a,f,b){a[b+3]=f,f=f>>>8,a[b+2]=f,f=f>>>8,a[b+1]=f,f=f>>>8,a[b]=f}t.writeUInt32BE=w;function I(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0|a[f+2]<<16>>>0|a[f+3]<<24>>>0}t.readUInt32LE=I;function m(a,f,b){a[b+0]=f&255,f=f>>>8,a[b+1]=f&255,f=f>>>8,a[b+2]=f&255,f=f>>>8,a[b+3]=f&255}t.writeUInt32LE=m;function y(a,f){return a[f]}t.readUInt8=y;function p(a,f,b){a[b]=f}t.writeUInt8=p;function P(a){return C.consumeReadable(a,f=>L.concat(f))}t.readableToBuffer=P;function S(a){return C.toReadable(a)}t.bufferToReadable=S;function l(a){return C.consumeStream(a,f=>L.concat(f))}t.streamToBuffer=l;async function d(a){return a.ended?L.concat(a.buffer):L.concat([...a.buffer,await l(a.stream)])}t.bufferedStreamToBuffer=d;function v(a){return C.toStream(a,f=>L.concat(f))}t.bufferToStream=v;function c(a){return C.transform(a,{data:f=>typeof f=="string"?L.fromString(f):L.wrap(f)},f=>L.concat(f))}t.streamToBufferReadableStream=c;function s(a){return C.newWriteableStream(f=>L.concat(f),a)}t.newWriteableBufferStream=s;function e(a,f){return C.prefixedReadable(a,f,b=>L.concat(b))}t.prefixedBufferReadable=e;function r(a,f){return C.prefixedStream(a,f,b=>L.concat(b))}t.prefixedBufferStream=r;function i(a){let f=0,b=0,U=0;const _=new Uint8Array(Math.floor(a.length/4*3)),H=ne=>{switch(b){case 3:_[U++]=f|ne,b=0;break;case 2:_[U++]=f|ne>>>2,f=ne<<6,b=3;break;case 1:_[U++]=f|ne>>>4,f=ne<<4,b=2;break;default:f=ne<<2,b=1}};for(let ne=0;ne<a.length;ne++){const re=a.charCodeAt(ne);if(re>=65&&re<=90)H(re-65);else if(re>=97&&re<=122)H(re-97+26);else if(re>=48&&re<=57)H(re-48+52);else if(re===43||re===45)H(62);else if(re===47||re===95)H(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ne]}`)}}const K=U;for(;b>0;)H(0);return L.wrap(_).slice(0,K)}t.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},f=!0,b=!1){const U=b?o:n;let _="";const H=a.byteLength%3;let K=0;for(;K<a.byteLength-H;K+=3){const ne=a[K+0],re=a[K+1],se=a[K+2];_+=U[ne>>>2],_+=U[(ne<<4|re>>>4)&63],_+=U[(re<<2|se>>>6)&63],_+=U[se&63]}if(H===1){const ne=a[K+0];_+=U[ne>>>2],_+=U[ne<<4&63],f&&(_+="==")}else if(H===2){const ne=a[K+0],re=a[K+1];_+=U[ne>>>2],_+=U[(ne<<4|re>>>4)&63],_+=U[re<<2&63],f&&(_+="=")}return _}t.encodeBase64=u}),define(Q[26],Z([0,1,5]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.keys(l).forEach(v=>{l[v]&&typeof l[v]=="object"?d[v]=R(l[v]):d[v]=l[v]}),d}t.deepClone=R;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const c in v)if(k.call(v,c)){const s=v[c];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.isTypedArray)(s)&&d.push(s)}}return l}t.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function L(l,d){return E(l,d,new Set)}t.cloneAndChange=L;function E(l,d,v){if((0,C.isUndefinedOrNull)(l))return l;const c=d(l);if(typeof c<"u")return c;if(Array.isArray(l)){const s=[];for(const e of l)s.push(E(e,d,v));return s}if((0,C.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const s={};for(const e in l)k.call(l,e)&&(s[e]=E(l[e],d,v));return v.delete(l),s}return l}function g(l,d,v=!0){return(0,C.isObject)(l)?((0,C.isObject)(d)&&Object.keys(d).forEach(c=>{c in l?v&&((0,C.isObject)(l[c])&&(0,C.isObject)(d[c])?g(l[c],d[c],v):l[c]=d[c]):l[c]=d[c]}),l):d}t.mixin=g;function h(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let v,c;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(v=0;v<l.length;v++)if(!h(l[v],d[v]))return!1}else{const s=[];for(c in l)s.push(c);s.sort();const e=[];for(c in d)e.push(c);if(e.sort(),!h(s,e))return!1;for(v=0;v<s.length;v++)if(!h(l[s[v]],d[s[v]]))return!1}return!0}t.equals=h;function w(l){const d=new Set;return JSON.stringify(l,(v,c)=>{if((0,C.isObject)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}t.safeStringify=w;function I(l,d){const v=Object.create(null);return!l||!d||Object.keys(d).forEach(s=>{const e=l[s],r=d[s];h(e,r)||(v[s]=r)}),v}t.distinct=I;function m(l,d){const v=d.toLowerCase(),c=Object.keys(l).find(s=>s.toLowerCase()===v);return c?l[c]:l[d]}t.getCaseInsensitive=m;function y(l,d){const v=Object.create(null);for(const[c,s]of Object.entries(l))d(c,s)&&(v[c]=s);return v}t.filter=y;function p(l){let d=[],v=Object.getPrototypeOf(l);for(;Object.prototype!==v;)d=d.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return d}t.getAllPropertyNames=p;function P(l){const d=[];for(const v of p(l))typeof l[v]=="function"&&d.push(v);return d}t.getAllMethodNames=P;function S(l,d){const v=s=>function(){const e=Array.prototype.slice.call(arguments,0);return d(s,e)},c={};for(const s of l)c[s]=v(s);return c}t.createProxyObject=S}),define(Q[30],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return C.test(D)}t.isUUID=R,t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(E){for(let g=0;g<E.length;g++)E[g]=Math.floor(Math.random()*256);return E};const k=new Uint8Array(16),L=[];for(let E=0;E<256;E++)L.push(E.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,h="";return h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h+="-",h+=L[k[g++]],h+=L[k[g++]],h+="-",h+=L[k[g++]],h+=L[k[g++]],h+="-",h+=L[k[g++]],h+=L[k[g++]],h+="-",h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h+=L[k[g++]],h}}()}),define(Q[70],Z([6,7]),function(B,t){return B.create("vs/base/common/date",t)}),define(Q[71],Z([0,1,70]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const R=60,D=R*60,k=D*24,L=k*7,E=k*30,g=k*365;function h(I,m,y){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,C.localize)(0,null,h(new Date().getTime()+p*1e3,!1));if(p<30)return(0,C.localize)(1,null);let P;return p<R?(P=p,m?P===1?y?(0,C.localize)(2,null,P):(0,C.localize)(3,null,P):y?(0,C.localize)(4,null,P):(0,C.localize)(5,null,P):P===1?y?(0,C.localize)(6,null,P):(0,C.localize)(7,null,P):y?(0,C.localize)(8,null,P):(0,C.localize)(9,null,P)):p<D?(P=Math.floor(p/R),m?P===1?y?(0,C.localize)(10,null,P):(0,C.localize)(11,null,P):y?(0,C.localize)(12,null,P):(0,C.localize)(13,null,P):P===1?y?(0,C.localize)(14,null,P):(0,C.localize)(15,null,P):y?(0,C.localize)(16,null,P):(0,C.localize)(17,null,P)):p<k?(P=Math.floor(p/D),m?P===1?y?(0,C.localize)(18,null,P):(0,C.localize)(19,null,P):y?(0,C.localize)(20,null,P):(0,C.localize)(21,null,P):P===1?y?(0,C.localize)(22,null,P):(0,C.localize)(23,null,P):y?(0,C.localize)(24,null,P):(0,C.localize)(25,null,P)):p<L?(P=Math.floor(p/k),m?P===1?(0,C.localize)(26,null,P):(0,C.localize)(27,null,P):P===1?(0,C.localize)(28,null,P):(0,C.localize)(29,null,P)):p<E?(P=Math.floor(p/L),m?P===1?y?(0,C.localize)(30,null,P):(0,C.localize)(31,null,P):y?(0,C.localize)(32,null,P):(0,C.localize)(33,null,P):P===1?y?(0,C.localize)(34,null,P):(0,C.localize)(35,null,P):y?(0,C.localize)(36,null,P):(0,C.localize)(37,null,P)):p<g?(P=Math.floor(p/E),m?P===1?y?(0,C.localize)(38,null,P):(0,C.localize)(39,null,P):y?(0,C.localize)(40,null,P):(0,C.localize)(41,null,P):P===1?y?(0,C.localize)(42,null,P):(0,C.localize)(43,null,P):y?(0,C.localize)(44,null,P):(0,C.localize)(45,null,P)):(P=Math.floor(p/g),m?P===1?y?(0,C.localize)(46,null,P):(0,C.localize)(47,null,P):y?(0,C.localize)(48,null,P):(0,C.localize)(49,null,P):P===1?y?(0,C.localize)(50,null,P):(0,C.localize)(51,null,P):y?(0,C.localize)(52,null,P):(0,C.localize)(53,null,P))}t.fromNow=h;function w(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=w}),define(Q[72],Z([6,7]),function(B,t){return B.create("vs/base/common/errorMessage",t)}),define(Q[31],Z([0,1,19,5,72]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function k(I,m){return m&&(I.stack||I.stacktrace)?D.localize(0,null,E(I),L(I.stack)||L(I.stacktrace)):E(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function E(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function g(I=null,m=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const y=C.coalesce(I),p=g(y[0],m);return y.length>1?D.localize(4,null,p,y.length):p}if(R.isString(I))return I;if(I.detail){const y=I.detail;if(y.error)return k(y.error,m);if(y.exception)return k(y.exception,m)}return I.stack?k(I,m):I.message?I.message:D.localize(5,null)}t.toErrorMessage=g;function h(I){const m=I;return m instanceof Error&&Array.isArray(m.actions)}t.isErrorWithActions=h;function w(I,m){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=m,y}t.createErrorWithActions=w}),define(Q[73],Z([6,7]),function(B,t){return B.create("vs/base/common/jsonErrorMessages",t)}),define(Q[74],Z([0,1,73]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0;function R(D){switch(D){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}t.getParseErrorMessage=R}),define(Q[51],Z([0,1,12]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeDangerousEnvVariables=t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R=t.Source||(t.Source={}));var D;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(D=t.TerminateResponseCode||(t.TerminateResponseCode={}));function k(E,...g){const h=g.reduce((m,y)=>(m[y]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(m=>!h[m]).forEach(m=>{for(let y=0;y<w.length;y++)if(m.search(w[y])!==-1){delete E[m];break}})}t.sanitizeProcessEnvironment=k;function L(E){!E||(delete E.DEBUG,C.isMacintosh&&delete E.DYLD_LIBRARY_PATH,C.isLinux&&delete E.LD_PRELOAD)}t.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MutableObservableValue=t.staticObservableValue=void 0;const D=L=>({onDidChange:C.Event.None,value:L});t.staticObservableValue=D;class k extends R.Disposable{get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}constructor(E){super(),this._value=E,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}}t.MutableObservableValue=k}),define(Q[53],Z([0,1,27]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function R(l){return D(l,0)}t.hash=R;function D(l,d){switch(typeof l){case"object":return l===null?k(349,d):Array.isArray(l)?g(l,d):h(l,d);case"string":return E(l,d);case"boolean":return L(l,d);case"number":return k(l,d);case"undefined":return k(937,d);default:return k(617,d)}}t.doHash=D;function k(l,d){return(d<<5)-d+l|0}t.numberHash=k;function L(l,d){return k(l?433:863,d)}function E(l,d){d=k(149417,d);for(let v=0,c=l.length;v<c;v++)d=k(l.charCodeAt(v),d);return d}t.stringHash=E;function g(l,d){return d=k(104579,d),l.reduce((v,c)=>D(c,v),d)}function h(l,d){return d=k(181387,d),Object.keys(l).sort().reduce((v,c)=>(v=E(c,v),D(l[c],v)),d)}class w{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=D(d,this._value),this._value}}t.Hasher=w;var I;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(l,d,v=32){const c=v-d,s=~((1<<c)-1);return(l<<d|(s&l)>>>c)>>>0}function y(l,d=0,v=l.byteLength,c=0){for(let s=0;s<v;s++)l[d+s]=c}function p(l,d,v="0"){for(;l.length<d;)l=v+l;return l}function P(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):p((l>>>0).toString(16),d/4)}t.toHexString=P;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const v=d.length;if(v===0)return;const c=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,i;for(e!==0?(r=e,i=-1,e=0):(r=d.charCodeAt(0),i=0);;){let n=r;if(C.isHighSurrogate(r))if(i+1<v){const o=d.charCodeAt(i+1);C.isLowSurrogate(o)?(i++,n=C.computeCodePoint(r,o)):n=65533}else{e=r;break}else C.isLowSurrogate(r)&&(n=65533);if(s=this._push(c,s,n),i++,i<v)r=d.charCodeAt(i);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(d,v,c){return c<128?d[v++]=c:c<2048?(d[v++]=192|(c&1984)>>>6,d[v++]=128|(c&63)>>>0):c<65536?(d[v++]=224|(c&61440)>>>12,d[v++]=128|(c&4032)>>>6,d[v++]=128|(c&63)>>>0):(d[v++]=240|(c&1835008)>>>18,d[v++]=128|(c&258048)>>>12,d[v++]=128|(c&4032)>>>6,d[v++]=128|(c&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=S._bigBlock32,v=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,v.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,m(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this._h0,s=this._h1,e=this._h2,r=this._h3,i=this._h4,n,o,u;for(let a=0;a<80;a++)a<20?(n=s&e|~s&r,o=1518500249):a<40?(n=s^e^r,o=1859775393):a<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),u=m(c,5)+n+i+o+d.getUint32(a*4,!1)&4294967295,i=r,r=e,e=m(s,30),s=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}t.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const k="error",L="warning",E="warn",g="info",h="ignore";function w(m){return m?C.equalsIgnoreCase(k,m)?D.Error:C.equalsIgnoreCase(L,m)||C.equalsIgnoreCase(E,m)?D.Warning:C.equalsIgnoreCase(g,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=w;function I(m){switch(m){case D.Error:return k;case D.Warning:return L;case D.Info:return g;default:return h}}D.toString=I}(R||(R={})),t.default=R}),define(Q[75],Z([0,1,8]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function R(h){const w=h;return w&&typeof w.type=="string"&&typeof w.severity=="string"}t.isRemoteConsoleLog=R;function D(h){const w=[];let I;try{const m=JSON.parse(h.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),I=y.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",h.arguments)}return{args:w,stack:I}}t.parse=D;function k(h){if(typeof h!="string")return k(D(h).stack);const w=h;if(w){const I=L(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(m&&m.length===4)return{uri:C.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}t.getFirstFrame=k;function L(h){if(!h)return h;const w=h.indexOf(`
`);return w===-1?h:h.substring(0,w)}function E(h,w){const{args:I,stack:m}=D(h),y=typeof I[0]=="string"&&I.length===1;let p=L(m);p&&(p=`(${p.trim()})`);let P=[];if(typeof I[0]=="string"?p&&y?P=[`%c[${w}] %c${I[0]} %c${p}`,g("blue"),g(""),g("grey")]:P=[`%c[${w}] %c${I[0]}`,g("blue"),g(""),...I.slice(1)]:P=[`%c[${w}]%`,g("blue"),...I],p&&!y&&P.push(p),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,P)}t.log=E;function g(h){return`color: ${h}`}}),define(Q[44],Z([0,1,15,27,8]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function k(h){return JSON.stringify(h,E)}t.stringify=k;function L(h){let w=JSON.parse(h);return w=g(w),w}t.parse=L;function E(h,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,R.regExpFlags)(w)}:w}function g(h,w=0){if(!h||w>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 14:return new Date(h.source)}if(h instanceof C.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let I=0;I<h.length;++I)h[I]=g(h[I],w+1);else for(const I in h)Object.hasOwnProperty.call(h,I)&&(h[I]=g(h[I],w+1))}return h}t.revive=g}),define(Q[76],Z([0,1,38,14,20]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var g;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(g||(g={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class I{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:c=!1}={}){return c?h===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:c=!1,findPreview:s=!1}={}){const e=m({useAlternateBitness:c});if(!e)return null;const r=R.join(e,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const a of await D.Promises.readdir(r)){let f=-1;if(s){const U=a.indexOf("-");if(U<0)continue;const _=a.substring(0,U);if(!k.test(_)||a.substring(U+1)!=="preview")continue;f=parseInt(_,10)}else{if(!k.test(a))continue;f=parseInt(a,10)}if(f<=i)continue;const b=R.join(r,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(b)||(n=b,i=f)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",u=s?" Preview":"";return new I(n,`PowerShell${u}${o}`,!0)}async function p({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=c?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(s))if(e.test(i)){const n=R.join(s,i,"pwsh.exe");return new I(n,r)}return null}function P(){const c=R.join(C.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function S(){const c=R.join(process.env.windir,h===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}async function*l(){let c=await y();c&&(yield c),c=await y({useAlternateBitness:!0}),c&&(yield c),c=await p(),c&&(yield c),c=P(),c&&(yield c),c=await y({findPreview:!0}),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await y({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=S(),c&&(yield c)}async function*d(){for await(const c of l())await c.exists()&&(yield c)}t.enumeratePowerShellInstallations=d;async function v(){for await(const c of d())return c;return null}t.getFirstAvailablePowerShellInstallation=v}),define(Q[55],Z([0,1,14,12,32,51,5,20]),function(B,t,C,R,D,k,L,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(I=D.env){return I.comspec||"cmd.exe"}t.getWindowsShell=g;function h(I){let m=[],y=!1;const p=function(P){if(y){m.push(P);return}(!I.send(P,l=>{if(l&&console.error(l),y=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(v=>p(v))}})||R.isWindows)&&(y=!0)};return{send:p}}t.createQueuedSender=h;var w;(function(I){async function m(y,p,P){if(C.isAbsolute(y))return y;if(p===void 0&&(p=D.cwd()),C.dirname(y)!=="."||(P===void 0&&L.isString(D.env.PATH)&&(P=D.env.PATH.split(C.delimiter)),P===void 0||P.length===0))return C.join(p,y);async function l(d){if(await E.Promises.exists(d)){let v;try{v=await E.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(v=await E.Promises.lstat(d))}return v?!v.isDirectory():!1}return!1}for(const d of P){let v;if(C.isAbsolute(d)?v=C.join(d,y):v=C.join(p,d,y),await l(v))return v;let c=v+".com";if(await l(c)||(c=v+".exe",await l(c)))return c}return C.join(p,y)}I.findExecutable=m})(w=t.win32||(t.win32={}))}),define(Q[77],Z([0,1,38,12,76,55]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(y,p){return y===1?R.isWindows?I():k.getWindowsShell(p):h(y,p)}t.getSystemShell=L;function E(y,p){return y===1?R.isWindows?m(p):k.getWindowsShell(p):h(y,p)}t.getSystemShellSync=E;let g=null;function h(y,p){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!g){let P;if(R.isWindows)P="/bin/bash";else{if(P=p.SHELL,!P)try{P=(0,C.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}g=P}return g}let w=null;async function I(){return w||(w=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),w}function m(y){if(w)return w;const p=R.isWindows&&parseFloat((0,C.release)())>=10,P=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${y.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?S:k.getWindowsShell(y)}});var he=this&&this.__decorate||function(B,t,C,R){var D=arguments.length,k=D<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,C):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(B,t,C,R);else for(var E=B.length-1;E>=0;E--)(L=B[E])&&(k=(D<3?L(k):D>3?L(t,C,k):L(t,C))||k);return D>3&&k&&Object.defineProperty(t,C,k),k};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(B,t,C,R,D,k,L,E,g,h,w,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function p(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(P=t.ResponseType||(t.ResponseType={}));function S(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(l||(l={}));class d{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class v{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(c||(c={}));function s(N){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function r(N){const F=D.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const i={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object)},n=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(i.Undefined);else if(typeof F=="string"){const j=D.VSBuffer.fromString(F);N.write(i.String),N.write(s(j.byteLength)),N.write(j)}else if(n&&Buffer.isBuffer(F)){const j=D.VSBuffer.wrap(F);N.write(i.Buffer),N.write(s(j.byteLength)),N.write(j)}else if(F instanceof D.VSBuffer)N.write(i.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(i.Array),N.write(s(F.length));for(const j of F)o(N,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(F));N.write(i.Object),N.write(s(j.byteLength)),N.write(j)}}function u(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(e(N)).toString();case c.Buffer:return N.read(e(N)).buffer;case c.VSBuffer:return N.read(e(N));case c.Array:{const j=e(N),$=[];for(let Y=0;Y<j;Y++)$.push(u(N));return $}case c.Object:return JSON.parse(N.read(e(N)).toString())}}class a{constructor(F,j,$=null,Y=1e3){this.protocol=F,this.ctx=j,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger?.logOutgoing(j,0,1,S(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(j,F.id,1,S(F.type),F.data);return}}}send(F,j=void 0){const $=new v;return o($,F),o($,j),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const j=new d(F),$=u(j),Y=u(j),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const $=new k.CancellationTokenSource;let Y;try{Y=j.call(this.ctx,F.name,F.arg,$.token)}catch(T){Y=Promise.reject(T)}const A=F.id;Y.then(T=>{this.sendResponse({id:A,data:T,type:201}),this.activeRequests.delete(F.id)},T=>{T instanceof Error?this.sendResponse({id:A,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:A,data:T,type:203}),this.activeRequests.delete(F.id)});const x=(0,h.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,x)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const $=F.id,A=j.listen(this.ctx,F.name,F.arg)(x=>this.sendResponse({id:$,data:x,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const $ of j)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=a;var f;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(f=t.RequestInitiator||(t.RequestInitiator={}));class b{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=j}getChannel(F){const j=this;return{call($,Y,A){return j.isDisposed?Promise.reject(new E.CancellationError):j.requestPromise(F,$,Y,A)},listen($,Y){return j.isDisposed?g.Event.None:j.requestEvent(F,$,Y)}}}requestPromise(F,j,$,Y=k.CancellationToken.None){const A=this.lastRequestId++,T={id:A,type:100,channelName:F,name:j,arg:$};if(Y.isCancellationRequested)return Promise.reject(new E.CancellationError);let O;return new Promise((W,q)=>{if(Y.isCancellationRequested)return q(new E.CancellationError);const X=()=>{const Se=te=>{switch(te.type){case 201:this.handlers.delete(A),W(te.data);break;case 202:{this.handlers.delete(A);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,q(oe);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,Se),this.sendRequest(T)};let ae=null;this.state===l.Idle?X():(ae=(0,R.createCancelablePromise)(Se=>this.whenInitialized()),ae.then(()=>{ae=null,X()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new E.CancellationError)},pe=Y.onCancellationRequested(ce);O=(0,h.combinedDisposable)((0,h.toDisposable)(ce),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(F,j,$){const Y=this.lastRequestId++,x={id:Y,type:102,channelName:F,name:j,arg:$};let T=null;const O=new g.Emitter({onFirstListenerAdd:()=>{T=(0,R.createCancelablePromise)(W=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(O),this.sendRequest(x)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(O),this.sendRequest({id:Y,type:103}))}}),M=W=>O.fire(W.data);return this.handlers.set(Y,M),O.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(j,F.id,0,`${p(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger?.logOutgoing(j,F.id,0,p(F.type));return}}}send(F,j=void 0){const $=new v;return o($,F),o($,j),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const j=new d(F),$=u(j),Y=u(j),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,S(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,S(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([L.memoize],b.prototype,"onDidInitializePromise",null),t.ChannelClient=b;class U{get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:$})=>{g.Event.once(j.onMessage)(A=>{const x=new d(A),T=u(x),O=new a(j,T),M=new b(j);this.channels.forEach((q,X)=>O.registerChannel(X,q));const W={channelServer:O,channelClient:M,ctx:T};this._connections.add(W),this._onDidAddConnection.fire(W),$(()=>{O.dispose(),M.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,j){const $=this;return{call(Y,A,x){let T;if((0,m.isFunction)(j)){const M=(0,C.getRandomElement)($.connections.filter(j));T=M?Promise.resolve(M):g.Event.toPromise(g.Event.filter($.onDidAddConnection,j))}else T=j.routeCall($,Y,A);const O=T.then(M=>M.channelClient.getChannel(F));return H(O).call(Y,A,x)},listen(Y,A){if((0,m.isFunction)(j))return $.getMulticastEvent(F,j,Y,A);const x=j.routeEvent($,Y,A).then(T=>T.channelClient.getChannel(F));return H(x).listen(Y,A)}}}getMulticastEvent(F,j,$,Y){const A=this;let x=new h.DisposableStore;const T=new g.Emitter({onFirstListenerAdd:()=>{x=new h.DisposableStore;const O=new g.EventMultiplexer,M=new Map,W=X=>{const ce=X.channelClient.getChannel(F).listen($,Y),pe=O.add(ce);M.set(X,pe)},q=X=>{const ae=M.get(X);!ae||(ae.dispose(),M.delete(X))};A.connections.filter(j).forEach(W),g.Event.filter(A.onDidAddConnection,j)(W,void 0,x),A.onDidRemoveConnection(q,void 0,x),O.event(T.fire,T,x),x.add(O)},onLastListenerRemove:()=>{x.dispose()}});return T.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach($=>{$.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=U;class _{constructor(F,j,$=null){const Y=new v;o(Y,j),F.send(Y.buffer),this.channelClient=new b(F,$),this.channelServer=new a(F,j,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=_;function H(N){return{call(F,j,$){return N.then(Y=>Y.call(F,j,$))},listen(F,j){const $=new g.Relay;return N.then(Y=>$.input=Y.listen(F,j)),$.event}}}t.getDelayedChannel=H;function K(N){let F=!1;return{call(j,$,Y){return F?N.call(j,$,Y):(0,R.timeout)(0).then(()=>F=!0).then(()=>N.call(j,$,Y))},listen(j,$){if(F)return N.listen(j,$);const Y=new g.Relay;return(0,R.timeout)(0).then(()=>F=!0).then(()=>Y.input=N.listen(j,$)),Y.event}}}t.getNextTickChannel=K;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await g.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ne;var re;(function(N){function F(A,x){const T=A,O=x&&x.disableMarshalling,M=new Map;for(const W in T)$(W)&&M.set(W,g.Event.buffer(T[W],!0));return new class{listen(W,q,X){const ae=M.get(q);if(ae)return ae;if(Y(q)){const ce=T[q];if(typeof ce=="function")return ce.call(T,X)}throw new Error(`Event not found: ${q}`)}call(W,q,X){const ae=T[q];if(typeof ae=="function"){if(!O&&Array.isArray(X))for(let ce=0;ce<X.length;ce++)X[ce]=(0,w.revive)(X[ce]);return ae.apply(T,X)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function j(A,x){const T=x&&x.disableMarshalling;return new Proxy({},{get(O,M){if(typeof M=="string")return x?.properties?.has(M)?x.properties.get(M):Y(M)?function(W){return A.listen(M,W)}:$(M)?A.listen(M):async function(...W){let q;x&&!(0,m.isUndefinedOrNull)(x.context)?q=[x.context,...W]:q=W;const X=await A.call(M,q);return T?X:(0,w.revive)(X)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=j;function $(A){return A[0]==="o"&&A[1]==="n"&&I.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&I.isUpperAsciiLetter(A.charCodeAt(9))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,j,$,Y,A,x){x=le(x);const T=se[Y],O=T[$%T.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(A)?(M=M.concat(x),M.push(")")):M.push(x),console.log.apply(console,M)}t.logWithColors=ie;class V{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,j,$,Y,A)}logIncoming(F,j,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,j,$,Y,A)}}t.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class p extends y.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}t.Server=p;class P{constructor(l,d){this.modulePath=l,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new R.Delayer(v),this.child=null,this._client=null}getChannel(l){const d=this;return{call(v,c,s){return d.requestPromise(l,v,c,s)},listen(v,c){return d.requestEvent(l,v,c)}}}requestPromise(l,d,v,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),e=(0,R.createCancelablePromise)(n=>s.call(d,v,n)),r=c.onCancellationRequested(()=>e.cancel()),i=(0,h.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(l,d,v){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let c;const s=new g.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(l).listen(d,v)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(d.env),this.child=(0,C.fork)(this.modulePath,l,d);const v=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}v.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=v.event,i={send:e,onMessage:r};this._client=new y.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,h.dispose)(a)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(l){let d=this.channels.get(l);return d||(d=this.client.getChannel(l),this.channels.set(l,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=P}),define(Q[79],Z([0,1,3,4,2,5]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function E(I){const m=I;return m?.changed instanceof Map||m?.deleted instanceof Set}t.isStorageItemsChangeEvent=E;var g;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(g=t.StorageState||(t.StorageState={}));class h extends D.Disposable{constructor(m,y=Object.create(null)){super(),this.database=m,this.options=y,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((y,p)=>this.accept(p,y)),m.deleted?.forEach(y=>this.accept(y,void 0))}accept(m,y){if(this.state===g.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(y)?p=this.cache.delete(m):this.cache.get(m)!==y&&(this.cache.set(m,y),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,y){const p=this.cache.get(m);return(0,k.isUndefinedOrNull)(p)?y:p}getBoolean(m,y){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?y:p==="true"}getNumber(m,y){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?y:parseInt(p,10)}async set(m,y){if(this.state===g.Closed)return;if((0,k.isUndefinedOrNull)(y))return this.delete(m);const p=String(y);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===g.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((y,p)=>this.items.set(p,y)),m.delete?.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=w}),define(Q[80],Z([6,7]),function(B,t){return B.create("vs/base/node/zip",t)}),define(Q[81],Z([6,7]),function(B,t){return B.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[82],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[83],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[84],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(Q[85],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(Q[86],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(Q[87],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[88],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[89],Z([6,7]),function(B,t){return B.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[90],Z([6,7]),function(B,t){return B.create("vs/platform/files/common/fileService",t)}),define(Q[91],Z([6,7]),function(B,t){return B.create("vs/platform/files/common/io",t)}),define(Q[92],Z([6,7]),function(B,t){return B.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[93],Z([6,7]),function(B,t){return B.create("vs/platform/languagePacks/common/languagePacks",t)}),define(Q[94],Z([6,7]),function(B,t){return B.create("vs/platform/request/common/request",t)}),define(Q[95],Z([6,7]),function(B,t){return B.create("vs/platform/shell/node/shellEnv",t)}),define(Q[96],Z([6,7]),function(B,t){return B.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[97],Z([6,7]),function(B,t){return B.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(Q[98],Z([6,7]),function(B,t){return B.create("vs/platform/workspace/common/workspace",t)}),define(Q[99],Z([0,1,71,49,17,14,32,18,8]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",B).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(g.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=L.env.VSCODE_PORTABLE;return P?g.URI.file((0,k.join)(P,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,k.resolve)(P):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,k.resolve)(P):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,k.resolve)(P);const S=L.env.VSCODE_EXTENSIONS;if(S)return S;const l=L.env.VSCODE_PORTABLE;return l?(0,k.join)(l,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(S=>/^[^:/?#]+?:\/\//.test(S)?g.URI.parse(S):g.URI.file((0,k.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?g.URI.parse(P):g.URI.file((0,k.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(P=>!t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(P))}get extensionLogLevel(){const P=[];for(const S of this.args.log||[]){const l=t.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);l&&l[1]&&l[2]&&P.push([l[1],l[2]])}return P.length?P:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=L.env.VSCODE_PORTABLE;return P?g.URI.file((0,k.join)(P,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,S,l){this._args=P,this.paths=S,this.productService=l,this.editSessionId=this.args.editSessionId}}he([R.memoize],h.prototype,"appRoot",null),he([R.memoize],h.prototype,"userHome",null),he([R.memoize],h.prototype,"userDataPath",null),he([R.memoize],h.prototype,"appSettingsHome",null),he([R.memoize],h.prototype,"tmpDir",null),he([R.memoize],h.prototype,"cacheHome",null),he([R.memoize],h.prototype,"stateResource",null),he([R.memoize],h.prototype,"userRoamingDataHome",null),he([R.memoize],h.prototype,"userDataSyncHome",null),he([R.memoize],h.prototype,"userDataSyncLogResource",null),he([R.memoize],h.prototype,"editSessionsLogResource",null),he([R.memoize],h.prototype,"sync",null),he([R.memoize],h.prototype,"machineSettingsResource",null),he([R.memoize],h.prototype,"workspaceStorageHome",null),he([R.memoize],h.prototype,"localHistoryHome",null),he([R.memoize],h.prototype,"keyboardLayoutResource",null),he([R.memoize],h.prototype,"argvResource",null),he([R.memoize],h.prototype,"isExtensionDevelopment",null),he([R.memoize],h.prototype,"untitledWorkspacesHome",null),he([R.memoize],h.prototype,"installSourcePath",null),he([R.memoize],h.prototype,"builtinExtensionsPath",null),he([R.memoize],h.prototype,"extensionsPath",null),he([R.memoize],h.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],h.prototype,"extensionDevelopmentKind",null),he([R.memoize],h.prototype,"extensionTestsLocationURI",null),he([R.memoize],h.prototype,"debugExtensionHost",null),he([R.memoize],h.prototype,"logLevel",null),he([R.memoize],h.prototype,"extensionLogLevel",null),he([R.memoize],h.prototype,"serviceMachineIdResource",null),he([R.memoize],h.prototype,"telemetryLogResource",null),he([R.memoize],h.prototype,"disableWorkspaceTrust",null),he([R.memoize],h.prototype,"policyFile",null),t.AbstractNativeEnvironmentService=h;function w(p,P){return y(p["inspect-extensions"],p["inspect-brk-extensions"],5870,P,p.debugId,p.extensionEnvironment)}t.parseExtensionHostPort=w;function I(p,P){return y(p["inspect-search"],p["inspect-brk-search"],5876,P,p.extensionEnvironment)}t.parseSearchPort=I;function m(p,P){return y(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,P,p.extensionEnvironment)}t.parsePtyHostPort=m;function y(p,P,S,l,d,v){const s=Number(P||p)||(l?null:S),e=s?Boolean(!!P):!1;let r;if(v)try{r=JSON.parse(v)}catch{}return{port:s,break:e,debugId:d,env:r}}}),function(){"use strict";function B(t,C,R){function D(L,E){const g=k(L,E),h=[g];return t.isAbsolute(g)||h.unshift(R),t.resolve(...h)}function k(L,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return t.join(g,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return t.join(h,E);const w=L["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=t.join(I,"AppData","Roaming")}break;case"darwin":h=t.join(C.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(h,E)}return{getUserDataPath:D}}if(typeof define=="function")define(Q[100],Z([149,38,32]),function(t,C,R){return B(t,C,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),C=require("os");module.exports=B(t,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(E,g){super(E,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,D.getUserDataPath)(E,g.nameShort)},g)}}t.NativeEnvironmentService=k}),define(Q[102],Z([0,1,5,85]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;function D(L,E,g){try{k(L,E,g)}catch{}return L}t.localizeManifest=D;function k(L,E,g){const h=(w,I,m)=>{const y=w[I];if((0,C.isString)(y)){const p=y,P=p.length;if(P>1&&p[0]==="%"&&p[P-1]==="%"){const S=p.substr(1,P-2);let l=E[S];l===void 0&&g&&(l=g[S]);const d=typeof l=="string"?l:l.message;if(d!==void 0){const v=g?.[S],c=typeof v=="string"?v:v?.message;if(m&&(I==="title"||I==="category")&&c&&c!==d){const s={value:d,original:c};w[I]=s}else w[I]=d}else console.warn(`[${L.name}]: ${(0,R.localize)(0,null,S)}`)}}else if((0,C.isObject)(y))for(const p in y)y.hasOwnProperty(p)&&(p==="commands"?h(y,p,!0):h(y,p,m));else if(Array.isArray(y))for(let p=0;p<y.length;p++)h(y,p,m)};for(const w in L)L.hasOwnProperty(w)&&h(L,w)}}),define(Q[45],Z([0,1,18,54,89,39]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.validateExtensionManifest=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||L.test(l)}t.isValidVersionStr=g;function h(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}t.parseVersion=h;function w(l){if(!l)return null;const d=l.majorBase,v=l.majorMustEqual,c=l.minorBase;let s=l.minorMustEqual;const e=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(d===0||(s=!1),r=!1);let i=0;if(l.preRelease){const n=E.exec(l.preRelease);if(n){const[,o,u,a]=n;i=Date.UTC(Number(o),Number(u)-1,Number(a))}}return{majorBase:d,majorMustEqual:v,minorBase:c,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:i}}t.normalizeVersion=w;function I(l,d,v){let c;typeof l=="string"?c=w(h(l)):c=l;let s;d instanceof Date?s=d.getTime():typeof d=="string"&&(s=new Date(d).getTime());let e;if(typeof v=="string"?e=w(h(v)):e=v,!c||!e)return!1;const r=c.majorBase,i=c.minorBase,n=c.patchBase;let o=e.majorBase,u=e.minorBase,a=e.patchBase;const f=e.notBefore;let b=e.majorMustEqual,U=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:i>u?!0:i<u||s&&s<f?!1:n>=a:(r===1&&o===0&&(!b||!U||!_)&&(o=1,u=0,a=0,b=!0,U=!1,_=!1),r<o?!1:r>o?!b:i<u?!1:i>u?!U:n<a?!1:n>a?!_:!(s&&s<f))}t.isValidVersion=I;function m(l,d,v,c,s){const e=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return e.push([R.default.Error,D.localize(0,null)]),e;if(typeof c.name!="string")return e.push([R.default.Error,D.localize(1,null,"name")]),e;if(typeof c.version!="string")return e.push([R.default.Error,D.localize(2,null,"version")]),e;if(!c.engines)return e.push([R.default.Error,D.localize(3,null,"engines")]),e;if(typeof c.engines.vscode!="string")return e.push([R.default.Error,D.localize(4,null,"engines.vscode")]),e;if(typeof c.extensionDependencies<"u"&&!S(c.extensionDependencies))return e.push([R.default.Error,D.localize(5,null,"extensionDependencies")]),e;if(typeof c.activationEvents<"u"){if(!S(c.activationEvents))return e.push([R.default.Error,D.localize(6,null,"activationEvents")]),e;if(typeof c.main>"u"&&typeof c.browser>"u")return e.push([R.default.Error,D.localize(7,null,"activationEvents","main")]),e}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&e.push([R.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return e.push([R.default.Error,D.localize(9,null,"main")]),e;{const n=(0,C.joinPath)(v,c.main);(0,C.isEqualOrParent)(n,v)||e.push([R.default.Warning,D.localize(10,null,n.path,v.path)])}if(typeof c.activationEvents>"u")return e.push([R.default.Error,D.localize(11,null,"activationEvents","main")]),e}if(typeof c.browser<"u"){if(typeof c.browser!="string")return e.push([R.default.Error,D.localize(12,null,"browser")]),e;{const n=(0,C.joinPath)(v,c.browser);(0,C.isEqualOrParent)(n,v)||e.push([R.default.Warning,D.localize(13,null,n.path,v.path)])}if(typeof c.activationEvents>"u")return e.push([R.default.Error,D.localize(14,null,"activationEvents","browser")]),e}if(!k.valid(c.version))return e.push([R.default.Error,D.localize(15,null)]),e;const r=[];if(!y(l,d,c,s,r))for(const n of r)e.push([R.default.Error,n]);return e}t.validateExtensionManifest=m;function y(l,d,v,c,s){return c||typeof v.main>"u"&&typeof v.browser>"u"?!0:P(l,d,v.engines.vscode,s)}t.isValidExtensionVersion=y;function p(l,d,v){return l==="*"||P(d,v,l)}t.isEngineValid=p;function P(l,d,v,c=[]){const s=w(h(v));if(!s)return c.push(D.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(D.localize(17,null,v)),!1}else if(!s.majorMustEqual)return c.push(D.localize(18,null,v)),!1;return I(l,d,s)?!0:(c.push(D.localize(19,null,l,v)),!1)}function S(l){if(!Array.isArray(l))return!1;for(let d=0,v=l.length;d<v;d++)if(typeof l[d]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function D(k,L,E){let g=E&&E.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const w=(await L.readFile(k.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(w)?w:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,C.VSBuffer.fromString(g))}catch{}}return E?.store("storage.serviceMachineId",g,-1,1),g}t.getServiceMachineId=D}),define(Q[46],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(D,k=[],L=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=C}),define(Q[104],Z([0,1,46]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const R=[];var D;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(D=t.InstantiationType||(t.InstantiationType={}));function k(E,g,h){g instanceof C.SyncDescriptor||(g=new C.SyncDescriptor(g,[],Boolean(h))),R.push([E,g])}t.registerSingleton=k;function L(){return R}t.getSingletonServiceDescriptors=L}),define(Q[105],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.Node=C;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const L of this._nodes.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const E=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(L);E.outgoing.set(g.key,g),g.incoming.set(E.key,E)}removeNode(k){const L=this._hashFn(k);this._nodes.delete(L);for(const E of this._nodes.values())E.outgoing.delete(L),E.incoming.delete(L)}lookupOrInsertNode(k){const L=this._hashFn(k);let E=this._nodes.get(L);return E||(E=new C(L,k),this._nodes.set(L,E)),E}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[L,E]of this._nodes)k.push(`${L}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this._nodes){const E=new Set([k]),g=this._findCycle(L,E);if(g)return g}}_findCycle(k,L){for(const[E,g]of k.outgoing){if(L.has(E))return[...L,E].join(" -> ");L.add(E);const h=this._findCycle(g,L);if(h)return h;L.delete(E)}}}t.Graph=R}),define(Q[21],Z([0,1,5,8,9]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLanguageTagSettingPlainKey=t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}t.isConfigurationOverrides=k;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}t.isConfigurationUpdateOverrides=L;var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(E=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}t.ConfigurationTargetToString=g;function h(l,d){const v=Object.create(null);for(const c in l)w(v,c,l[c],d);return v}t.toValuesTree=h;function w(l,d,v,c){const s=d.split("."),e=s.pop();let r=l;for(let i=0;i<s.length;i++){const n=s[i];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=v}catch{c(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(r)}`)}t.addToValueTree=w;function I(l,d){const v=d.split(".");m(l,v)}t.removeFromValueTree=I;function m(l,d){const v=d.shift();if(d.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const c=l[v];typeof c=="object"&&!Array.isArray(c)&&(m(c,d),Object.keys(c).length===0&&delete l[v])}}function y(l,d,v){function c(r,i){let n=r;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=d.split("."),e=c(l,s);return typeof e>"u"?v:e}t.getConfigurationValue=y;function p(l,d,v){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in l?C.isObject(l[c])&&C.isObject(d[c])?p(l[c],d[c],v):v&&(l[c]=d[c]):l[c]=d[c])})}t.merge=p;function P(l,d,v){const c=l.inspect(d),s=l.inspect(v);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:c.defaultValue}t.getMigratedSettingValue=P;function S(l){return l.replace(/[\[\]]/g,"")}t.getLanguageTagSettingPlainKey=S}),define(Q[58],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[16],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[22],Z([0,1,83,9]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=D;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=k;function L(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=L;function E(l,d){return d==="web"&&!l.includes("web")}t.isNotWebExtensionInWebTargetPlatform=E;function g(l,d,v){return E(d,v)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===v?!0:h(v).includes(l)}t.isTargetPlatformCompatible=g;function h(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=h;function w(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=w;var I;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(I=t.SortBy||(t.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=t.SortOrder||(t.SortOrder={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y=t.StatisticType||(t.StatisticType={}));var p;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(p=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var P;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(P=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class S extends Error{constructor(d,v){super(d),this.code=v,this.name=v}}t.ExtensionManagementError=S,t.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,C.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.PreferencesLabel=(0,C.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,13]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(w,I,m,y,p,P){let S;try{await E(w,I,m,y,p,P)}catch(l){S=l}finally{S&&p.errorTransformer&&(S=p.errorTransformer(S)),typeof S<"u"&&m.error(S),m.end()}}t.readFileIntoStream=L;async function E(w,I,m,y,p,P){g(P);const S=await w.open(I,{create:!1});try{g(P);let l=0,d=0,v=p&&typeof p.length=="number"?p.length:void 0,c=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof v=="number"?v:p.bufferSize)),s=p&&typeof p.position=="number"?p.position:0,e=0;do d=await w.read(S,s,c.buffer,e,c.byteLength-e),s+=d,e+=d,l+=d,typeof v=="number"&&(v-=d),e===c.byteLength&&(await m.write(y(c)),c=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof v=="number"?v:p.bufferSize)),e=0);while(d>0&&(typeof v!="number"||v>0)&&g(P)&&h(l,p));if(e>0){let r=e;typeof v=="number"&&(r=Math.min(e,v)),m.write(y(c.slice(0,r)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await w.close(S)}}function g(w){if(w.isCancellationRequested)throw(0,R.canceled)();return!0}function h(w,I){if(I?.limits){if(typeof I.limits.memory=="number"&&w>I.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&w>I.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,12,151]),function(B,t,C,R,D,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class E extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(h){const w=this.normalizeRequests(h),I=w.filter(y=>{const p=this.watchers.get(y.path);return p?!(0,R.patternsEquals)(p.request.excludes,y.excludes)||!(0,R.patternsEquals)(p.request.includes,y.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:y})=>!w.find(p=>p.path===y.path&&(0,R.patternsEquals)(p.excludes,y.excludes)&&(0,R.patternsEquals)(p.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.trace(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const y of m)this.stopWatching(y);for(const y of I)this.startWatching(y)}startWatching(h){const w=new L.NodeJSFileWatcherLibrary(h,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),I={request:h,instance:w};this.watchers.set(h.path,I)}async stop(){for(const[h]of this.watchers)this.stopWatching(h);this.watchers.clear()}stopWatching(h){const w=this.watchers.get(h);w&&(this.watchers.delete(h),w.instance.dispose())}normalizeRequests(h){const w=new Map;for(const I of h){const m=k.isLinux?I.path:I.path.toLowerCase();w.set(m,I)}return Array.from(w.values())}async setVerboseLogging(h){this.verboseLogging=h;for(const[,w]of this.watchers)w.instance.setVerboseLogging(h)}trace(h){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h)})}toMessage(h,w){return w?`[File Watcher (node.js)] ${h} (path: ${w.request.path})`:`[File Watcher (node.js)] ${h}`}}t.NodeJSWatcher=E}),define(Q[107],Z([0,1,60,106]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class D extends C.AbstractNonRecursiveWatcherClient{constructor(L,E,g){super(L,E,g),this.init()}createWatcher(){return new R.NodeJSWatcher}}t.NodeJSWatcherClient=D}),define(Q[108],Z([0,1,17,56,78,60]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(g,h,w){super(g,h,w),this.init()}createWatcher(g){const h=g.add(new D.Client(C.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(h.onDidProcessExit(({code:w,signal:I})=>this.onError(`terminated by itself with code ${w}, signal: ${I}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(h.getChannel("watcher")))}}t.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...D){this._entries=new Map;for(const[k,L]of D)this.set(k,L)}set(D,k){const L=this._entries.get(D);return this._entries.set(D,k),L}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}t.ServiceCollection=C}),define(Q[109],Z([0,1,3,11,2,46,105,9,61,152]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const w=!1;class I extends Error{constructor(S){super("cyclic dependency between services"),this.message=S.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${S.toString()}`}}class m{constructor(S=new g.ServiceCollection,l=!1,d,v=w){this._services=S,this._strict=l,this._parent=d,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=v?d?._globalGraph??new L.Graph(c=>c):void 0}createChild(S){return new m(S,this._strict,this,this._enableTracing)}invokeFunction(S,...l){const d=p.traceInvocation(this._enableTracing,S);let v=!1;try{return S({get:s=>{if(v)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const e=this._getOrCreateServiceInstance(s,d);if(!e)throw new Error(`[invokeFunction] unknown service '${s}'`);return e}},...l)}finally{v=!0,d.stop()}}createInstance(S,...l){let d,v;return S instanceof k.SyncDescriptor?(d=p.traceCreation(this._enableTracing,S.ctor),v=this._createInstance(S.ctor,S.staticArguments.concat(l),d)):(d=p.traceCreation(this._enableTracing,S),v=this._createInstance(S,l,d)),d.stop(),v}_createInstance(S,l=[],d){const v=E._util.getServiceDependencies(S).sort((e,r)=>e.index-r.index),c=[];for(const e of v){const r=this._getOrCreateServiceInstance(e.id,d);r||this._throwIfStrict(`[createInstance] ${S.name} depends on UNKNOWN service ${e.id}.`,!1),c.push(r)}const s=v.length>0?v[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${S.name} at position ${s+1} conflicts with ${l.length} static arguments`);const e=s-l.length;e>0?l=l.concat(new Array(e)):l=l.slice(0,s)}return Reflect.construct(S,l.concat(c))}_setServiceInstance(S,l){if(this._services.get(S)instanceof k.SyncDescriptor)this._services.set(S,l);else if(this._parent)this._parent._setServiceInstance(S,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(S){const l=this._services.get(S);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(S):l}_getOrCreateServiceInstance(S,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(S));const d=this._getServiceInstanceOrDescriptor(S);return d instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(S,d,l.branch(S,!0)):(l.branch(S,!1),d)}_safeCreateAndCacheServiceInstance(S,l,d){if(this._activeInstantiations.has(S))throw new Error(`illegal state - RECURSIVELY instantiating service '${S}'`);this._activeInstantiations.add(S);try{return this._createAndCacheServiceInstance(S,l,d)}finally{this._activeInstantiations.delete(S)}}_createAndCacheServiceInstance(S,l,d){const v=new L.Graph(e=>e.id.toString());let c=0;const s=[{id:S,desc:l,_trace:d}];for(;s.length;){const e=s.pop();if(v.lookupOrInsertNode(e),c++>1e3)throw new I(v);for(const r of E._util.getServiceDependencies(e.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(r.id);if(i||this._throwIfStrict(`[createInstance] ${S} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(e.id),String(r.id)),i instanceof k.SyncDescriptor){const n={id:r.id,desc:i,_trace:e._trace.branch(r.id,!0)};v.insertEdge(e,n),s.push(n)}}}for(;;){const e=v.roots();if(e.length===0){if(!v.isEmpty())throw new I(v);break}for(const{data:r}of e){if(this._getServiceInstanceOrDescriptor(r.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,n)}v.removeNode(r)}}return this._getServiceInstanceOrDescriptor(S)}_createServiceInstanceWithOwner(S,l,d=[],v,c){if(this._services.get(S)instanceof k.SyncDescriptor)return this._createServiceInstance(S,l,d,v,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(S,l,d,v,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(S,l,d=[],v,c){if(v){const s=new m(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(S);const e=new Map,r=new C.IdleValue(()=>{const i=s._createInstance(l,d,c);for(const[n,o]of e){const u=i[n];if(typeof u=="function")for(const a of o)u.apply(i,a)}return e.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=e.get(n);return a||(a=new h.LinkedList,e.set(n,a)),(b,U,_)=>{const H=a.push([b,U,_]);return(0,D.toDisposable)(H)}}if(n in i)return i[n];const o=r.value;let u=o[n];return typeof u!="function"||(u=u.bind(o),i[n]=u),u},set(i,n,o){return r.value[n]=o,!0}})}else return this._createInstance(l,d,c)}_throwIfStrict(S,l){if(l&&console.warn(S),this._strict)throw new Error(S)}}t.InstantiationService=m;var y;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(y||(y={}));class p{static traceInvocation(S,l){return S?new p(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(S,l){return S?new p(0,l.name):p._None}constructor(S,l){this.type=S,this.name=l,this._start=Date.now(),this._dep=[]}branch(S,l){const d=new p(2,S.toString());return this._dep.push([S,l,d]),d}stop(){const S=Date.now()-this._start;p._totals+=S;let l=!1;function d(c,s){const e=[],r=new Array(c+1).join("	");for(const[i,n,o]of s._dep)if(n&&o){l=!0,e.push(`${r}CREATES -> ${i}`);const u=d(c+1,o);u&&e.push(u)}else e.push(`${r}uses -> ${i}`);return e.join(`
`)}const v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${S.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(S>2||l)&&p.all.add(v.join(`
`))}}t.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0});var ee=this&&this.__param||function(B,t){return function(C,R){t(C,R,B)}};define(Q[62],Z([0,1,24,2,12,93,22,9]),function(B,t,C,R,D,k,L,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.ILanguagePackService=(0,E.createDecorator)("languagePackService");let g=class extends R.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new C.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let I;try{I=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const y=I.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(P=>P.startsWith("lp-"))).map(p=>{const P=p.properties.localizedLanguages?.[0],S=this.getLocale(p);return{...this.createQuickPickItem(S,P,p),extensionId:p.identifier.id,galleryExtension:p}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(w){return w.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(w,I,m){const y=I??w;let p;if(y!==w&&(p=`(${w})`),w.toLowerCase()===D.language.toLowerCase()&&(p??="",p+=(0,k.localize)(0,null)),m?.installCount){p??="";const P=m.installCount;let S;P>1e6?S=`${Math.floor(P/1e5)/10}M`:P>1e3?S=`${Math.floor(P/1e3)}K`:S=String(P),p+=` $(cloud-download) ${S}`}return{id:w,label:y,description:p}}};g=he([ee(0,L.IExtensionGalleryService)],g),t.LanguagePackBaseService=g}),define(Q[10],Z([0,1,31,4,2,33,12,8,9]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLoggerService=t.NullLogService=t.NullLogger=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,g.createDecorator)("logService"),t.ILoggerService=(0,g.createDecorator)("loggerService");function h(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=w.Info;function I(u,a,f){switch(a){case w.Trace:u.trace(f);break;case w.Debug:u.debug(f);break;case w.Info:u.info(f);break;case w.Warning:u.warn(f);break;case w.Error:u.error(f);break;case w.Critical:u.critical(f);break;default:throw new Error("Invalid log level")}}t.log=I;function m(u){let a="";for(let f=0;f<u.length;f++){let b=u[f];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}a+=(f>0?" ":"")+b}return a}t.format=m;class y extends D.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=y;class p extends y{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...f){this.checkLogLevel(w.Trace)&&this.log(w.Trace,m([a,...f]))}debug(a,...f){this.checkLogLevel(w.Debug)&&this.log(w.Debug,m([a,...f]))}info(a,...f){this.checkLogLevel(w.Info)&&this.log(w.Info,m([a,...f]))}warn(a,...f){this.checkLogLevel(w.Warning)&&this.log(w.Warning,m([a,...f]))}error(a,...f){if(this.checkLogLevel(w.Error))if(a instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=a.stack,this.log(w.Error,m(b))}else this.log(w.Error,m([a,...f]))}critical(a,...f){this.checkLogLevel(w.Critical)&&this.log(w.Critical,m([a,...f]))}flush(){}}t.AbstractMessageLogger=p;class P extends y{constructor(a=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!L.isWindows}trace(a,...f){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}debug(a,...f){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}info(a,...f){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.log(`[main ${h()}]`,a,...f))}warn(a,...f){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,a,...f):console.warn(`[main ${h()}]`,a,...f))}error(a,...f){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,a,...f):console.error(`[main ${h()}]`,a,...f))}critical(a,...f){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${h()}]\x1B[0m`,a,...f):console.error(`[main ${h()}]`,a,...f))}dispose(){}flush(){}}t.ConsoleMainLogger=P;class S extends y{constructor(a=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...f){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",a,...f)}debug(a,...f){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...f)}info(a,...f){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",a,...f)}warn(a,...f){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",a,...f)}error(a,...f){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",a,...f)}critical(a,...f){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...f)}dispose(){}flush(){}}t.ConsoleLogger=S;class l extends y{constructor(a,f=t.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(f)}trace(a,...f){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(a),...f])}debug(a,...f){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(a),...f])}info(a,...f){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(a),...f])}warn(a,...f){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(a),...f])}error(a,...f){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(a),...f])}critical(a,...f){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(a),...f])}extractMessage(a){return typeof a=="string"?a:(0,C.toErrorMessage)(a,this.getLevel()<=w.Trace)}dispose(){}flush(){}}t.AdapterLogger=l;class d extends y{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const f of this.logServices)f.setLevel(a);super.setLevel(a)}trace(a,...f){for(const b of this.logServices)b.trace(a,...f)}debug(a,...f){for(const b of this.logServices)b.debug(a,...f)}info(a,...f){for(const b of this.logServices)b.info(a,...f)}warn(a,...f){for(const b of this.logServices)b.warn(a,...f)}error(a,...f){for(const b of this.logServices)b.error(a,...f)}critical(a,...f){for(const b of this.logServices)b.critical(a,...f)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}t.MultiplexLogService=d;class v extends D.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...f){this.logger.trace(a,...f)}debug(a,...f){this.logger.debug(a,...f)}info(a,...f){this.logger.info(a,...f)}warn(a,...f){this.logger.warn(a,...f)}error(a,...f){this.logger.error(a,...f)}critical(a,...f){this.logger.critical(a,...f)}flush(){this.logger.flush()}}t.LogService=v;class c extends D.Disposable{constructor(a,f){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(f(b=>this.setLevel(b)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,f,b){let U=this.loggerItems.get(a)?.logger;return U||(b=f?.always?w.Trace:b,U=this.doCreateLogger(a,b??this.logLevel,f),this.loggerItems.set(a,{logger:U,logLevel:b})),U}setLevel(a,f){const b=E.URI.isUri(a)?a:void 0,U=b?f:a;if(b){const _=this.loggerItems.get(b);_&&_.logLevel!==U&&(_.logLevel=U,_.logger.setLevel(U))}else this.logLevel=U,this.loggerItems.forEach(({logLevel:_,logger:H})=>{_===void 0&&H.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}t.AbstractLoggerService=c;class s{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(a){}getLevel(){return w.Info}trace(a,...f){}debug(a,...f){}info(a,...f){}warn(a,...f){}error(a,...f){}critical(a,...f){}dispose(){}flush(){}}t.NullLogger=s;class e extends s{}t.NullLogService=e;class r extends c{constructor(){super(w.Info,R.Event.None)}doCreateLogger(a,f,b){return new s}}t.NullLoggerService=r;function i(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const a=n(u.logLevel.toLowerCase());if(a!==void 0)return a}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=i;function n(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}t.parseLogLevel=n;function o(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}t.LogLevelToString=o}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,10]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class w extends L.Disposable{constructor(m,y){super(),this.logService=m,this.options=y,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(m,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,y):this.watchNonRecursive(m,y)}watchUniversal(m,y){const p={path:this.toFilePath(m),excludes:y.excludes,includes:y.includes,recursive:y.recursive},P=(0,C.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,g.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const y of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const y of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(y)&&m.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,y){const p={path:this.toFilePath(m),excludes:y.excludes,includes:y.includes,recursive:!1},P=(0,C.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,g.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,E.normalize)(m.fsPath)}}t.AbstractDiskFileSystemProvider=w}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,33,17,112,18,43,90,13,59,10]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let v=class extends h.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const r=new h.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,h.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await R.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return g.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,y.isAbsolutePath)(s))throw new S.FileOperationError((0,P.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,P.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e)||(0,S.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,S.toFileSystemProviderErrorCode)(r)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,P.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),i=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,u=e?.resolveMetadata,a=await r.stat(s);let f;return this.toFileStat(r,s,a,void 0,!!u,(b,U)=>(f||(f=w.TernarySearchTree.forUris(()=>!i),f.set(s,!0),n&&f.fill(!0,n)),f.get(b.resource)||f.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?U===1:!1))}async toFileStat(s,e,r,i,n,o){const{providerExtUri:u}=this.getExtUri(s),a={resource:e,name:u.basename(e),isFile:(r.type&S.FileType.File)!==0,isDirectory:(r.type&S.FileType.Directory)!==0,isSymbolicLink:(r.type&S.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const f=await s.readdir(e),b=await R.Promises.settled(f.map(async([U,_])=>{try{const H=u.joinPath(e,U),K=n?await s.stat(H):{type:_};return await this.toFileStat(s,H,K,f.length,n,o)}catch(H){return this.logService.trace(H),null}}));a.children=(0,C.coalesce)(b)}catch(f){this.logService.trace(f),a.children=[]}return a}return a}async resolveAll(s){return R.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new S.FileOperationError((0,P.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const i=await this.writeFile(s,e);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,i)),i}async writeFile(s,e,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,r)||await this.mkdirp(i,n.dirname(s));let u;if((0,S.hasReadWriteCapability)(i)&&!(e instanceof D.VSBuffer))if((0,p.isReadableStream)(e)){const a=await(0,p.peekStream)(e,3);a.ended?u=D.VSBuffer.concat(a.buffer):u=a}else u=(0,p.peekReadable)(e,a=>D.VSBuffer.concat(a),3);else u=e;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&u instanceof D.VSBuffer?await this.doWriteUnbuffered(i,s,r,u):await this.doWriteBuffered(i,s,r,u instanceof D.VSBuffer?(0,D.bufferToReadable)(u):u),this._onDidRunOperation.fire(new S.FileOperationEvent(s,4))}catch(o){throw new S.FileOperationError((0,P.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&S.FileType.Directory)!==0)throw new S.FileOperationError((0,P.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,S.etag)({mtime:r.mtime,size:n.size}))throw new S.FileOperationError((0,P.localize)(7,null),3,r);return n}async readFile(s,e,r){const i=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(i,s,e,r):this.doReadFile(i,s,e,r)}async doReadFileAtomic(s,e,r,i){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(s,e,r,i);n(u)}catch(u){o(u)}})})}async doReadFile(s,e,r,i){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,e,r)}async doReadFileStream(s,e,r,i){const n=new k.CancellationTokenSource(i),o=this.validateReadFile(e,r).then(a=>a,a=>{throw n.cancel(),a});let u;try{return typeof r?.etag=="string"&&r.etag!==S.ETAG_DISABLED&&await o,r?.atomic&&(0,S.hasFileAtomicReadCapability)(s)||!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&r?.preferUnbuffered?u=this.readFileUnbuffered(s,e,r):(0,S.hasFileReadStreamCapability)(s)?u=this.readFileStreamed(s,e,n.token,r):u=this.readFileBuffered(s,e,n.token,r),{...await o,value:u}}catch(a){u&&await(0,p.consumeStream)(u);const f=(0,P.localize)(8,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(a).toString());throw a instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(f,a.stat,r):new S.FileOperationError(f,(0,S.toFileOperationResult)(a),r)}}readFileStreamed(s,e,r,i=Object.create(null)){const n=s.readFileStream(e,i,r);return(0,p.transform)(n,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,P.localize)(9,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},o=>D.VSBuffer.concat(o))}readFileBuffered(s,e,r,i=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,e,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,P.localize)(10,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},r),n}readFileUnbuffered(s,e,r){const i=(0,p.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,S.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),i.end(D.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new S.FileOperationError((0,P.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==S.ETAG_DISABLED&&e.etag===r.etag)throw new S.NotModifiedSinceFileOperationError((0,P.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&e>r.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,P.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,i){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,i)}catch(n){return n}return!0}async move(s,e,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(i,s,n,e,"move",!!r),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,e,r){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(i,s,n,e,"copy",!!r),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,e,r,i,n,o){if(e.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,e,r,i,n,o);if(u&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(s===r&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(e,i,{overwrite:o});else{const f=await this.resolve(e);f.isDirectory?await this.doCopyFolder(s,f,r,i):await this.doCopyFile(s,e,r,i)}return n}else return s===r?(await s.rename(e,i,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,i,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,i){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,i);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,i)}async doCopyFolder(s,e,r,i){await r.mkdir(i),Array.isArray(e.children)&&await R.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,i,n,o){let u=!1;if(s===r){const{providerExtUri:f,isPathCaseSensitive:b}=this.getExtUri(s);if(b||(u=f.isEqual(e,i)),u&&n==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(e),this.resourceForError(i)));if(!u&&f.isEqualOrParent(i,e))throw new Error((0,P.localize)(15,null,this.resourceForError(e),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!u){if(!o)throw new S.FileOperationError((0,P.localize)(16,null,this.resourceForError(e),this.resourceForError(i)),4);if(s===r){const{providerExtUri:f}=this.getExtUri(s);if(f.isEqualOrParent(e,i))throw new Error((0,P.localize)(17,null,this.resourceForError(e),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(e,i.dirname(e));)try{if(((await s.stat(e)).type&S.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(e)),e=i.dirname(e)}for(let n=r.length-1;n>=0;n--){e=i.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new S.FileOperationError((0,P.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),i=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===i&&(0,S.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===i&&(0,S.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,i,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new h.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,h.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);i?(0,h.dispose)(o):n=()=>(0,h.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),i=(0,E.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(i,n)),n.count+=1,(0,h.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,h.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,h.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,i){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,n,i):await this.doWriteReadableBufferedQueued(s,n,i)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let i=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,u)=>{(0,p.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(s,e,a,a.byteLength,i,0)}catch(f){return u(f)}i+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>u(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,e,r,i,n,o){let u=0;for(;u<i;)u+=await s.write(e,n+u,r.buffer,o+u,i-u)}async doWriteUnbuffered(s,e,r,i){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,i))}async doWriteUnbufferedQueued(s,e,r,i){let n;i instanceof D.VSBuffer?n=i:(0,p.isReadableStream)(i)?n=await(0,D.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?n=await(0,D.bufferedStreamToBuffer)(i):n=(0,D.readableToBuffer)(i),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,i))}async doPipeBufferedQueued(s,e,r,i){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const u=D.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,f=0,b=0;do b=await s.read(n,a,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(r,o,u,b,a,f),a+=b,f+=b,f===u.byteLength&&(f=0);while(b>0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await R.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,i))}async doPipeUnbufferedQueued(s,e,r,i){return r.writeFile(i,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,i))}async doPipeUnbufferedToBufferedQueued(s,e,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,i){const n=await(0,D.streamToBuffer)(this.readFileBuffered(s,e,k.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new S.FileOperationError((0,P.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,P.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===I.Schemas.file?s.fsPath:s.toString(!0)}};v=he([ee(0,d.ILogService)],v),t.FileService=v}),define(Q[113],Z([0,1,114,153,3,33,15,4,154,2,14,12,18,43,20,92,13,59,110,31,108,107]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d,v,c,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(r)}`)}})();class e extends d.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new k.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await p.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await p.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,u.name))).type:a=this.toType(u),o.push([u.name,a])}catch(a){this.logService.trace(a)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=S.FileType.Unknown:i.isFile()?o=S.FileType.File:i.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,n&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const u=new D.Barrier;return this.resourceLocks.set(i,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,h.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const u=this.toFilePath(i);return await p.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}traceLock(i){e.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,o){const u=(0,y.newWriteableStream)(a=>L.VSBuffer.concat(a.map(f=>L.VSBuffer.wrap(f))).buffer);return(0,l.readFileIntoStream)(this,i,u,a=>a.buffer,{...n,bufferSize:256*1024},o),u}async writeFile(i,n,o){let u;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await p.Promises.exists(a)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,P.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,P.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){e.canFlush=i}async open(i,n){const o=this.toFilePath(i);let u;(0,S.isFileOpenForWriteOptions)(n)&&(u=await this.createResourceLock(i));let a;try{if((0,S.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:b}=await p.SymlinkSupport.stat(o);b.mode&128||await p.Promises.chmod(o,b.mode|128)}catch(b){this.logService.trace(b)}let f;if((0,S.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await p.Promises.truncate(o,0),f="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}f||(f="w")}else f="r";a=await p.Promises.open(o,f)}catch(f){throw u?.dispose(),(0,S.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(a,0),(0,S.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,i),u){const f=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,u),f&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),f.dispose())}return a}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&e.canFlush)try{await p.Promises.fdatasync(i)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await p.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,u,a){const f=this.normalizePos(i,n);let b=null;try{b=(await p.Promises.read(i,o,u,a,f)).bytesRead}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(i,f,b)}return b}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,u+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,u,a){return(0,D.retry)(()=>this.doWrite(i,n,o,u,a),100,3)}async doWrite(i,n,o,u,a){const f=this.normalizePos(i,n);let b=null;try{b=(await p.Promises.write(i,o,u,a,f)).bytesWritten}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),U)}finally{this.updatePos(i,f,b)}return b}async mkdir(i){try{await p.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const u=this.toFilePath(i),a=this.toFilePath(n);if(u!==a)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await p.Promises.move(u,a)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,n,o){const u=this.toFilePath(i),a=this.toFilePath(n);if(u!==a)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await p.Promises.copy(u,a,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,P.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(a)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,n,o,u){const a=this.toFilePath(i),f=this.toFilePath(n);let b=!1;if(!!(this.capabilities&1024)||(b=(0,g.isEqual)(a,f,!0)),b&&o==="copy")throw(0,S.createFileSystemProviderError)((0,P.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!b&&await p.Promises.exists(f)){if(!u)throw(0,S.createFileSystemProviderError)((0,P.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const u=this.toFilePath(i),a=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,g.isEqual)(u,a,!f))return;const b=new h.DisposableStore;try{const[U,_]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);b.add(U),b.add(_),o&&await p.Promises.mkdir((0,w.dirname)(a),{recursive:!0}),await p.Promises.copyFile(u,a)}catch(U){if(U.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(U)}finally{b.dispose()}}createUniversalWatcher(i,n,o){return new c.UniversalWatcherClient(u=>i(u),u=>n(u),o)}createNonRecursiveWatcher(i,n,o){return new s.NodeJSWatcherClient(u=>i(u),u=>n(u),o)}toFileSystemProviderError(i){if(i instanceof S.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=S.FileSystemProviderErrorCode.NoPermissions;break;default:n=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await p.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(o=(0,S.createFileSystemProviderError)(n,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}t.DiskFileSystemProvider=e,e.TRACE_LOG_RESOURCE_LOCKS=!1,e.canFlush=!0}),define(Q[115],Z([0,1,13,10]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function D(E,g,h,w,I){try{const m=await new Promise((p,P)=>{B(["spdlog"],p,P)});m.setFlushOn(R.LogLevel.Trace);const y=await m.createAsyncRotatingLogger(E,g,h,w);return I?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(m){console.error(m)}return null}function k(E,g,h){switch(g){case R.LogLevel.Trace:E.trace(h);break;case R.LogLevel.Debug:E.debug(h);break;case R.LogLevel.Info:E.info(h);break;case R.LogLevel.Warning:E.warn(h);break;case R.LogLevel.Error:E.error(h);break;case R.LogLevel.Critical:E.critical(h);break;default:throw new Error("Invalid log level")}}class L extends R.AbstractMessageLogger{constructor(g,h,w,I,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(g,h,w,I),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}async _createSpdLogLogger(g,h,w,I){const m=w?6:1,y=30/m*C.ByteSize.MB,p=await D(g,h,y,m,I);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:P,message:S}of this.buffer)k(this._logger,P,S);this.buffer=[]}}log(g,h){this._logger?k(this._logger,g,h):this.getLevel()<=g&&this.buffer.push({level:g,message:h})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,9]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,k.createDecorator)("policy");class L extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(h){const w=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...h,...this.policyDefinitions},w!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(h),R.Iterable.reduce(this.policies.entries(),(I,[m,y])=>({...I,[m]:y}),{})}getPolicyValue(h){return this.policies.get(h)}serialize(){return R.Iterable.reduce(Object.entries(this.policyDefinitions),(h,[w,I])=>({...h,[w]:{definition:I,value:this.policies.get(w)}}),{})}}t.AbstractPolicyService=L;class E{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=E}),define(Q[116],Z([0,1,3,4,63,5,13,10,37]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function h(I,m){const y=[];for(const p of D.Iterable.concat(I.keys(),m.keys()))I.get(p)!==m.get(p)&&y.push(p);return y}let w=class extends g.AbstractPolicyService{constructor(m,y,p){super(),this.file=m,this.fileService=y,this.logService=p,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const P=R.Event.filter(y.onDidFilesChange,S=>S.affects(m));this._register(y.watch(m)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(m){await this.refresh()}async read(){const m=new Map;try{const y=await this.fileService.readFile(this.file),p=JSON.parse(y.value.toString());if(!(0,k.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(p))this.policyDefinitions[P]&&m.set(P,p[P])}catch(y){y.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",y)}return m}async refresh(){const m=await this.read(),y=h(this.policies,m);this.policies=m,y.length>0&&this._onDidChange.fire(y)}};w=he([ee(1,L.IFileService),ee(2,E.ILogService)],w),t.FilePolicyService=w}),define(Q[28],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Q[34],Z([0,1,68,5]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class D{constructor(){this.data=new Map}add(L,E){C.ok(R.isString(L)),C.ok(R.isObject(E)),C.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,E)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new D}),define(Q[117],Z([0,1,4,34]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function D(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class k{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,h){this.schemasById[D(g)]=h,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new k;R.Registry.add(t.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,34]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var h;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(h=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var w;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=g.Registry.as(E.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const i=this.doRegisterConfigurations(e,r);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(e,!1)),I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(i)})}registerDefaultConfigurations(e){const r=[],i=[];for(const{overrides:n,source:o}of e)for(const u in n)if(r.push(u),t.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.configurationDefaultsOverrides.get(u),f=a?.valuesSources??new Map;if(o)for(const H of Object.keys(n[u]))f.set(H,o);const b={...a?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:b,valuesSources:f});const U=(0,L.getLanguageTagSettingPlainKey)(u),_={type:"object",default:b,description:k.localize(1,null,U),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:D.isString(o)?void 0:o,defaultValueSource:o};i.push(...P(u)),this.configurationProperties[u]=_,this.defaultLanguageConfigurationOverridesNode.properties[u]=_}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:o});const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:i,source:n}of e)for(const o in i){const u=this.configurationDefaultsOverrides.get(o),a=D.isString(n)?n:n?.id,f=D.isString(u?.source)?u?.source:u?.source?.id;if(a===f)if(r.push(o),this.configurationDefaultsOverrides.delete(o),t.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const b=this.configurationProperties[o];b&&(this.updatePropertyDefaultValue(o,b),this.updateSchema(o,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const i=[];return e.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(e){const r=[],i=n=>{if(n.properties)for(const o in n.properties){r.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of e){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,i,n,o=3){o=D.isUndefinedOrNull(e.scope)?o:e.scope;const u=[],a=e.properties;if(a)for(const b in a){const U=a[b];if(r&&v(b,U)){delete a[b];continue}if(U.source=i,U.defaultDefaultValue=a[b].default,this.updatePropertyDefaultValue(b,U),t.OVERRIDE_PROPERTY_REGEX.test(b)?U.scope=void 0:(U.scope=D.isUndefinedOrNull(U.scope)?o:U.scope,U.restricted=D.isUndefinedOrNull(U.restricted)?!!n?.includes(b):U.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.excludedConfigurationProperties[b]=a[b],delete a[b];continue}else this.configurationProperties[b]=a[b],a[b].policy?.name&&this.policyConfigurations.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),u.push(b)}const f=e.allOf;if(f)for(const b of f)u.push(...this.validateAndRegisterProperties(b,r,i,n,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=i=>{const n=i.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);i.allOf?.forEach(r)};r(e)}updateSchema(e,r){switch(t.allSettings.properties[e]=r,r.scope){case 1:t.applicationSettings.properties[e]=r;break;case 2:t.machineSettings.properties[e]=r;break;case 6:t.machineOverridableSettings.properties[e]=r;break;case 3:t.windowSettings.properties[e]=r;break;case 4:t.resourceSettings.properties[e]=r;break;case 5:t.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete t.allSettings.properties[e],r.scope){case 1:delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,i={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),t.allSettings.properties[r]=i,t.applicationSettings.properties[r]=i,t.machineSettings.properties[r]=i,t.machineOverridableSettings.properties[r]=i,t.windowSettings.properties[r]=i,t.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const i=this.configurationDefaultsOverrides.get(e);let n=i?.value,o=i?.source;D.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),D.isUndefined(n)&&(n=l(r.type)),r.default=n,r.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",p=new RegExp(y,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function P(s){const e=[];if(t.OVERRIDE_PROPERTY_REGEX.test(s)){let r=p.exec(s);for(;r?.length;){const i=r[1].trim();i&&e.push(i),r=p.exec(s)}}return(0,C.distinct)(e)}t.overrideIdentifiersFromKey=P;function S(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}t.keyFromOverrideIdentifiers=S;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const d=new m;g.Registry.add(t.Extensions.Configuration,d);function v(s,e){return s.trim()?t.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):d.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):e.policy?.name&&d.getPolicyConfigurations().get(e.policy?.name)!==void 0?k.localize(9,null,s,e.policy?.name,d.getPolicyConfigurations().get(e.policy?.name)):null:k.localize(6,null)}t.validateProperty=v;function c(){const s=[],e=d.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}t.getScopes=c}),define(Q[64],Z([0,1,19,4,50,2,33,26,5,8,21,40,34]),function(B,t,C,R,D,k,L,E,g,h,w,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0;class y{constructor(e={},r=[],i=[],n){this._contents=e,this._keys=r,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map(r=>{if(r instanceof y)return r;const i=new p("");return i.parseRaw(r),i.configurationModel});this._rawConfiguration=e.reduce((r,i)=>i===r?i:r.merge(i),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,w.getConfigurationValue)(this.contents,e):this.contents}inspect(e,r){const i=this.rawConfiguration.getValue(e),n=r?this.rawConfiguration.getOverrideValue(e,r):void 0,o=r?this.rawConfiguration.override(r).getValue(e):i;return{value:i,override:n,merged:o}}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?(0,w.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){const r=[];for(const i of this.overrides)i.identifiers.includes(e)&&r.push(...i.keys);return C.distinct(r)}getAllOverrideIdentifiers(){const e=[];for(const r of this.overrides)e.push(...r.identifiers);return C.distinct(e)}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=E.deepClone(this.contents),i=E.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const u of e)if(o.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(r,u.contents);for(const a of u.overrides){const[f]=i.filter(b=>C.equals(b.identifiers,a.identifiers));f?(this.mergeContents(f.contents,a.contents),f.keys.push(...a.keys),f.keys=C.distinct(f.keys)):i.push(E.deepClone(a))}for(const a of u.keys)n.indexOf(a)===-1&&n.push(a)}return new y(r,n,i,o.every(u=>u instanceof y)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new y(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const i={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n];const u=r[n];u&&(typeof o=="object"&&typeof u=="object"?(o=E.deepClone(o),this.mergeContents(o,u)):o=u),i[n]=o}return new y(i,this.keys,this.overrides)}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&g.isObject(e[i])&&g.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=E.deepClone(r[i])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?E.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let r=null,i=null;const n=o=>{o&&(i?this.mergeContents(i,o):i=E.deepClone(o))};for(const o of this.overrides)C.equals(o.identifiers,[e])?r=o.contents:o.identifiers.includes(e)&&n(o.contents);return n(r),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,w.addToValueTree)(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,w.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){const r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=y;class p{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!g.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:i,keys:n,overrides:o,restricted:u,hasExcludedProperties:a}=this.doParseRaw(e,r);this._configurationModel=new y(i,n,o,a?[e]:void 0),this._restrictedConfigurations=u||[]}doParseContent(e){let r={},i=null,n=[];const o=[],u=[];function a(b){Array.isArray(n)?n.push(b):i!==null&&(n[i]=b)}const f={onObjectBegin:()=>{const b={};a(b),o.push(n),n=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const b=[];a(b),o.push(n),n=b,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:a,onError:(b,U,_)=>{u.push({error:b,offset:U,length:_})}};if(e)try{D.visit(e,f),r=n[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return r}doParseRaw(e,r){const i=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,i,!0,r);e=n.raw;const o=(0,w.toValuesTree)(e,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),u=Object.keys(e),a=this.toOverrides(e,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:o,keys:u,overrides:a,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(e,r,i,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[],hasExcludedProperties:o};const u={},a=[];for(const f in e)if(I.OVERRIDE_PROPERTY_REGEX.test(f)&&i){const b=this.filter(e[f],r,!1,n);u[f]=b.raw,o=o||b.hasExcludedProperties,a.push(...b.restricted)}else{const b=r[f],U=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&a.push(f),(U===void 0||n.scopes===void 0||n.scopes.includes(U))&&!(n.skipRestricted&&b?.restricted)?u[f]=e[f]:o=!0}return{raw:u,restricted:a,hasExcludedProperties:o}}toOverrides(e,r){const i=[];for(const n of Object.keys(e))if(I.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const u in e[n])o[u]=e[n][u];i.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,w.toValuesTree)(o,r)})}return i}}t.ConfigurationModelParser=p;class P extends k.Disposable{constructor(e,r,i,n){super(),this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=P;class S{constructor(e,r,i,n,o=new y,u=new y,a=new L.ResourceMap,f=new y,b=new L.ResourceMap,U=!0){this._defaultConfiguration=e,this._policyConfiguration=r,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=b,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidatedConfigurationModel(e,r,i).getValue(e)}updateValue(e,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new y,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const n=this.getConsolidatedConfigurationModel(e,r,i),o=this.getFolderConfigurationModelForResource(r.resource,i),u=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,a=this._defaultConfiguration.inspect(e,r.overrideIdentifier),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(e),b=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(e),U=this.userConfiguration.freeze().inspect(e,r.overrideIdentifier),_=this.localUserConfiguration.freeze().inspect(e,r.overrideIdentifier),H=this.remoteUserConfiguration.freeze().inspect(e,r.overrideIdentifier),K=i?this._workspaceConfiguration.freeze().inspect(e,r.overrideIdentifier):void 0,ne=o?o.freeze().inspect(e,r.overrideIdentifier):void 0,re=u.inspect(e,r.overrideIdentifier),se=n.getValue(e),fe=C.distinct(n.overrides.map(le=>le.identifiers).flat()).filter(le=>n.getOverrideValue(e,le)!==void 0);return{defaultValue:a?a.merged:void 0,policyValue:f?f.merged:void 0,applicationValue:b?b.merged:void 0,userValue:U?U.merged:void 0,userLocalValue:_?_.merged:void 0,userRemoteValue:H?H.merged:void 0,workspaceValue:K?K.merged:void 0,workspaceFolderValue:ne?ne.merged:void 0,memoryValue:re?re.merged:void 0,value:se,default:a.value!==void 0||a.override!==void 0?{value:a.value,override:a.override}:void 0,policy:f?.value!==void 0?{value:f.value}:void 0,application:b?.value!==void 0||b?.override!==void 0?{value:b.value,override:b.override}:void 0,user:U.value!==void 0||U.override!==void 0?{value:U.value,override:U.override}:void 0,userLocal:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userRemote:H.value!==void 0||H.override!==void 0?{value:H.value,override:H.override}:void 0,workspace:K?.value!==void 0||K?.override!==void 0?{value:K.value,override:K.override}:void 0,workspaceFolder:ne?.value!==void 0||ne?.override!==void 0?{value:ne.value,override:ne.override}:void 0,memory:re.value!==void 0||re.override!==void 0?{value:re.value,override:re.override}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=[];if(!r){const{added:n,updated:o,removed:u}=v(this._defaultConfiguration,e);r=[...n,...o,...u]}for(const n of r)for(const o of(0,I.overrideIdentifiersFromKey)(n)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),a=e.getKeysForOverrideIdentifier(o),f=[...a.filter(b=>u.indexOf(b)===-1),...u.filter(b=>a.indexOf(b)===-1),...u.filter(b=>!E.equals(this._defaultConfiguration.override(o).getValue(b),e.override(o).getValue(b)))];i.push([o,f])}return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdatePolicyConfiguration(e){const{added:r,updated:i,removed:n}=v(this._policyConfiguration,e),o=[...r,...i,...n];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=v(this.applicationConfiguration,e),u=[...r,...i,...n];return u.length&&this.updateApplicationConfiguration(e),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=v(this.localUserConfiguration,e),u=[...r,...i,...n];return u.length&&this.updateLocalUserConfiguration(e),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=v(this.remoteUserConfiguration,e),u=[...r,...i,...n];return u.length&&this.updateRemoteUserConfiguration(e),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=v(this.workspaceConfiguration,e),u=[...r,...i,...n];return u.length&&this.updateWorkspaceConfiguration(e),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:n,updated:o,removed:u,overrides:a}=v(i,r),f=[...n,...o,...u];return(f.length||!i)&&this.updateFolderConfiguration(e,r),{keys:f,overrides:a}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:o,overrides:u}=v(r,void 0);return{keys:[...i,...n,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,r,i){let n=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const o=this._memoryConfigurationByResource.get(e);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.policy),n=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),u=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((f,b)=>(f.set(h.URI.revive(b[0]),this.parseConfigurationModel(b[1])),f),new L.ResourceMap);return new S(r,i,n,o,new y,u,a,new y,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=S;function l(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const n of s)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,u])=>{const a=(0,L.getOrSet)(r,o,new Set);u.forEach(f=>a.add(f))});const i=[];return r.forEach((n,o)=>i.push([o,[...n.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=l;class d{constructor(e,r,i,n){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(a=>o.add(a)),e.overrides.forEach(([,a])=>a.forEach(f=>o.add(f))),this.affectedKeys=[...o.values()];const u=new y;this.affectedKeys.forEach(a=>u.setValue(a,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!E.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(e=e[n],!e)return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=d;function v(s,e){const{added:r,removed:i,updated:n}=c(e,s),o=[],u=s?.getAllOverrideIdentifiers()||[],a=e?.getAllOverrideIdentifiers()||[];if(e){const f=a.filter(b=>!u.includes(b));for(const b of f)o.push([b,e.getKeysForOverrideIdentifier(b)])}if(s){const f=u.filter(b=>!a.includes(b));for(const b of f)o.push([b,s.getKeysForOverrideIdentifier(b)])}if(e&&s){for(const f of u)if(a.includes(f)){const b=c({contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)},{contents:e.getOverrideValue(void 0,f)||{},keys:e.getKeysForOverrideIdentifier(f)});o.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:r,removed:i,updated:n,overrides:o}}function c(s,e){const r=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],i=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],n=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const u=(0,w.getConfigurationValue)(e.contents,o),a=(0,w.getConfigurationValue)(s.contents,o);E.equals(u,a)||n.push(o)}}return{added:r,removed:i,updated:n}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,10,37,34]),function(B,t,C,R,D,k,L,E,g,h,w,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfigurationModel=t.DefaultConfiguration=void 0;class y extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new p(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:v})=>this.onDidUpdateConfiguration(d,v))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(d,v){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:d})}getConfigurationDefaultOverrides(){return{}}}t.DefaultConfiguration=y;class p extends g.ConfigurationModel{constructor(d={}){const v=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(v),s=Object.create(null),e=[];for(const r in v){const i=d[r],n=i!==void 0?i:v[r].default;(0,E.addToValueTree)(s,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(s))h.OVERRIDE_PROPERTY_REGEX.test(r)&&e.push({identifiers:(0,h.overrideIdentifiersFromKey)(r),keys:Object.keys(s[r]),contents:(0,E.toValuesTree)(s[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,c,e)}}t.DefaultConfigurationModel=p;class P{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=P;let S=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(d,v,c){super(),this.defaultConfiguration=d,this.policyService=v,this.logService=c,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new g.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(d=>this.onDidChangePolicies(d))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:d})=>this.update(await this.registerPolicyDefinitions(d),!0))),this._configurationModel}async registerPolicyDefinitions(d){const v={},c=[],s=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const e of d){const r=s[e];if(!r){c.push(e);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}c.push(e),v[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(v)||await this.policyService.registerPolicyDefinitions(v),c}onDidChangePolicies(d){const v=m.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),c=(0,C.coalesce)(d.map(s=>v.get(s)));this.update(c,!0)}update(d,v){const c=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const r of d){const i=c[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(e?n!==void 0:!(0,k.equals)(this._configurationModel.getValue(r),n))&&s.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&s.push([r,void 0])}if(s.length){const r=this._configurationModel;this._configurationModel=new g.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of s)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);v&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};S=he([ee(1,I.IPolicyService),ee(2,w.ILogService)],S),t.PolicyConfiguration=S}),define(Q[119],Z([0,1,3,4,2,18,21,64,118,37]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class w extends D.Disposable{constructor(m,y,p,P){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration),this.policyConfiguration=p instanceof h.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,p,P)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:l})=>this.onDidDefaultConfigurationChange(S,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,y,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(m,y,new E.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,y){const p=typeof m=="string"?m:void 0,P=(0,L.isConfigurationOverrides)(m)?m:(0,L.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(p,P,void 0)}updateValue(m,y,p,P){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const y=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,y,2)}onDidDefaultConfigurationChange(m,y){const p=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(m,y);this.trigger(P,p,7)}onDidPolicyConfigurationChange(m){const y=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,y,7)}trigger(m,y,p){const P=new E.ConfigurationChangeEvent(m,{data:y},this.configuration);P.source=p,P.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=w}),define(Q[120],Z([0,1,17]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseAuthorityWithOptionalPort=t.parseAuthorityWithPort=t.getRemoteServerRootPath=t.getRemoteName=t.getRemoteAuthority=void 0;function R(h){return h.scheme===C.Schemas.vscodeRemote?h.authority:void 0}t.getRemoteAuthority=R;function D(h){if(!h)return;const w=h.indexOf("+");return w<0?h:h.substr(0,w)}t.getRemoteName=D;function k(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}t.getRemoteServerRootPath=k;function L(h){const{host:w,port:I}=g(h);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:I}}t.parseAuthorityWithPort=L;function E(h,w){let{host:I,port:m}=g(h);return typeof m>"u"&&(m=w),{host:I,port:m}}t.parseAuthorityWithOptionalPort=E;function g(h){const w=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const I=h.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const m=h.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:h,port:void 0}}}),define(Q[35],Z([0,1,27,9,120]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.isApplicationScopedExtension=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}t.getWorkspaceSupportTypeMessage=k;function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(E=t.ExtensionType||(t.ExtensionType={}));var g;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(g=t.TargetPlatform||(t.TargetPlatform={}));class h{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,S){if(typeof P>"u"||P===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof P=="string"||typeof S=="string"){const l=typeof P=="string"?P:P.value,d=typeof S=="string"?S:S.value;return C.equalsIgnoreCase(l,d)}return P._lower===S._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}t.ExtensionIdentifier=h;function w(p){return I(p)}t.isApplicationScopedExtension=w;function I(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}t.isLanguagePackExtension=I;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=m;function y(p,P){if(P){const S=`onResolveRemoteAuthority:${(0,D.getRemoteName)(P)}`;return p.activationEvents?.indexOf(S)!==-1}return!1}t.isResolverExtension=y,t.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,35,12,8,11,32]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeTargetPlatform=t.isAlpineLinux=t.getExtensionDependencies=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.getIdAndVersion=t.ExtensionKey=t.areSameExtensions=void 0;function h(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,C.compareIgnoreCase)(r.id,i.id)===0}t.areSameExtensions=h;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new I(i.identifier,n,o)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new I({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof I?h(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}t.ExtensionKey=I;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=m.exec(r);return i&&i[1]?[P(i[1]),i[2]]:[P(r),void 0]}t.getIdAndVersion=y;function p(r,i){return`${r}.${i}`}t.getExtensionId=p;function P(r){return r.toLocaleLowerCase()}t.adoptToGalleryExtensionId=P;function S(r,i){return P(p(r,i))}t.getGalleryExtensionId=S;function l(r,i){const n=[],o=u=>{for(const a of n)if(a.some(f=>h(i(f),i(u))))return a;return null};for(const u of r){const a=o(u);a?a.push(u):n.push([u])}return n}t.groupByExtension=l;function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=d;function v(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function c(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&n.every(a=>!h(a.identifier,{id:u}))){const a=r.filter(f=>h(f.identifier,{id:u}));a.length===1&&(n.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}t.getExtensionDependencies=c;async function s(r,i){if(!k.isLinux)return!1;let n;try{n=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}t.isAlpineLinux=s;async function e(r,i){const n=await s(r,i),o=(0,R.getTargetPlatform)(n?"alpine":k.platform,g.arch);return i.debug("ComputeTargetPlatform:",o),o}t.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,11,17,18,39,8,84,22,23,35]),function(B,t,C,R,D,k,L,E,g,h,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLI=void 0;const m=S=>(0,g.localize)(0,null,S),y=(0,g.localize)(1,null,"ms-dotnettools.csharp");function p(S,l){return l?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}let P=class{constructor(l,d){this.extensionManagementService=l,this.extensionGalleryService=d}get location(){}async listExtensions(l,d,v,c=console){let s=await this.extensionManagementService.getInstalled(1,v);const e=I.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(d&&d!==""){if(e.indexOf(d.toLowerCase())<0){c.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){c.log("Possible Categories: "),e.forEach(i=>{c.log(i)});return}this.location&&c.log((0,g.localize)(2,null,this.location)),s=s.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let r;for(const i of s)r!==i.identifier.id&&(r=i.identifier.id,c.log(p(i.manifest,l)))}async installExtensions(l,d,v,c,s=console){const e=[],r=[];l.length&&s.log(this.location?(0,g.localize)(3,null,this.location):(0,g.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,v.profileLocation),n=(f,b)=>{const U=i.find(_=>(0,w.areSameExtensions)(_.identifier,{id:f}));if(U){if(!c&&(!b||b==="prerelease"&&U.preRelease))return s.log((0,g.localize)(5,null,f,U.manifest.version,f)),!1;if(b&&U.manifest.version===b)return s.log((0,g.localize)(6,null,`${f}@${b}`)),!1}return!0},o=(f,b,U)=>{a.push({id:f,version:b!=="prerelease"?b:void 0,installOptions:{...v,isBuiltin:U,installPreReleaseVersion:b==="prerelease"||v.installPreReleaseVersion}})},u=[],a=[];for(const f of l)if(f instanceof E.URI)u.push(f);else{const[b,U]=(0,w.getIdAndVersion)(f);n(b,U)&&o(b,U,!1)}for(const f of d){const[b,U]=(0,w.getIdAndVersion)(f);n(b,U)&&o(b,U,!0)}if(u.length&&await Promise.all(u.map(async f=>{try{const b=await this.installVSIX(f,{...v,isBuiltin:!1},c,s);b&&r.push(b)}catch(b){s.error(b.message||b.stack||b),e.push(f.toString())}})),a.length){const f=await this.getGalleryExtensions(a);await Promise.all(a.map(async b=>{const U=f.get(b.id.toLowerCase());if(U)try{const _=await this.installFromGallery(b,U,i,c,s);_&&r.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(b.id)}else s.error(`${m(b.version?`${b.id}@${b.version}`:b.id)}
${y}`),e.push(b.id)}))}if(e.length)throw new Error((0,g.localize)(7,null,e.join(", ")))}async installVSIX(l,d,v,c){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,v,d.profileLocation,c))try{return await this.extensionManagementService.install(l,d),c.log((0,g.localize)(8,null,(0,k.basename)(l))),s}catch(r){if((0,R.isCancellationError)(r))return c.log((0,g.localize)(9,null,(0,k.basename)(l))),null;throw r}return null}async getGalleryExtensions(l){const d=new Map,v=l.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:v})),C.CancellationToken.None);for(const s of c)d.set(s.identifier.id.toLowerCase(),s);return d}async installFromGallery({id:l,version:d,installOptions:v},c,s,e,r){const i=await this.extensionGalleryService.getManifest(c,C.CancellationToken.None);if(i&&!this.validateExtensionKind(i,r))return null;const n=s.find(o=>(0,w.areSameExtensions)(o.identifier,c.identifier));if(n){if(c.version===n.manifest.version)return r.log((0,g.localize)(10,null,d?`${l}@${d}`:l)),null;r.log((0,g.localize)(11,null,l,c.version))}try{v.isBuiltin?r.log(d?(0,g.localize)(12,null,l,d):(0,g.localize)(13,null,l)):r.log(d?(0,g.localize)(14,null,l,d):(0,g.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(c,{...v,installGivenVersion:!!d});return r.log((0,g.localize)(16,null,l,o.manifest.version)),i}catch(o){if((0,R.isCancellationError)(o))return r.log((0,g.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,d){return!0}async validateVSIX(l,d,v,c){const s={id:(0,w.getGalleryExtensionId)(l.publisher,l.name)},r=(await this.extensionManagementService.getInstalled(1,v)).find(i=>(0,w.areSameExtensions)(s,i.identifier)&&(0,L.gt)(i.manifest.version,l.version));return r&&!d?(c.log((0,g.localize)(18,null,r.identifier.id,r.manifest.version,l.version)),!1):this.validateExtensionKind(l,c)}async uninstallExtensions(l,d,v,c=console){const s=async r=>{if(r instanceof E.URI){const i=await this.extensionManagementService.getManifest(r);return p(i)}return r},e=[];for(const r of l){const i=await s(r),o=(await this.extensionManagementService.getInstalled(void 0,v)).filter(u=>(0,w.areSameExtensions)(u.identifier,{id:i}));if(!o.length)throw new Error(`${this.notInstalled(i)}
${y}`);if(o.some(u=>u.type===0)){c.log((0,g.localize)(19,null,i));return}if(!d&&o.some(u=>u.isBuiltin)){c.log((0,g.localize)(20,null,i));return}c.log((0,g.localize)(21,null,i));for(const u of o)await this.extensionManagementService.uninstall(u,{profileLocation:v}),e.push(u);this.location?c.log((0,g.localize)(22,null,i,this.location)):c.log((0,g.localize)(23,null,i))}}async locateExtension(l,d=console){const v=await this.extensionManagementService.getInstalled();l.forEach(c=>{v.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===D.Schemas.file){d.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,g.localize)(24,null,l,this.location):(0,g.localize)(25,null,l)}};P=he([ee(0,h.IExtensionManagementService),ee(1,h.IExtensionGalleryService)],P),t.ExtensionManagementCLI=P}),define(Q[41],Z([0,1,3,15,2,33,8,23,13,9,10]),function(B,t,C,R,D,k,L,E,g,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=t.IExtensionsProfileScannerService=void 0,t.IExtensionsProfileScannerService=(0,h.createDecorator)("IExtensionsProfileScannerService");let I=class extends D.Disposable{constructor(y,p){super(),this.fileService=y,this.logService=p,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,p){return this.withProfileExtensions(p,P=>(P=P.filter(S=>y.some(([l])=>!(0,E.areSameExtensions)(S.identifier,l.identifier))),P.push(...y.map(([S,l])=>({identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:l}))),P))}removeExtensionFromProfile(y,p){return this.withProfileExtensions(p,P=>P.filter(S=>!(0,E.areSameExtensions)(S.identifier,y)))}async withProfileExtensions(y,p){return this.getResourceAccessQueue(y).queue(async()=>{let P=[];try{const S=await this.fileService.readFile(y),l=JSON.parse(S.value.toString());for(const d of l){if(!d.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",d);continue}if(!d.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",d);continue}if(!d.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",d);continue}P.push({identifier:d.identifier,location:L.URI.revive(d.location),version:d.version,metadata:d.metadata})}}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}if(p){P=p(P);const S=P.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(y,R.VSBuffer.fromString(JSON.stringify(S)))}return P})}getResourceAccessQueue(y){let p=this.resourcesAccessQueueMap.get(y);return p||(p=new C.Queue,this.resourcesAccessQueueMap.set(y,p)),p}};I=he([ee(0,g.IFileService),ee(1,w.ILogService)],I),t.ExtensionsProfileScannerService=I}),define(Q[122],Z([0,1,3,11,2,12,18,39,8,30,20,16,22,23,13,10]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let S=class extends D.Disposable{constructor(d,v,c,s){super(),this.fileService=v,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=g.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,v){await this.cleanUpPromise;const c=this.getName(d),s=(0,L.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(d,e,v);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,v,c){try{await w.Promises.rename(d.fsPath,v.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${d} to ${v} with 'EPERM' error. Trying again...`),this.rename(d,v,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const v=[],c=[];for(const r of d.children){const i=y.ExtensionKey.parse(r.name);i&&c.push([i,r])}const s=(0,y.groupByExtension)(c,([r])=>r),e=[];for(const r of s)r.sort((i,n)=>E.rcompare(i[0].version,n[0].version)),v.push(...r.slice(1).map(i=>i[1].resource)),e.push(r[0][1]);e.sort((r,i)=>r.mtime-i.mtime),v.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await C.Promises.settled(v.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?y.ExtensionKey.create(d).toString().toLowerCase():(0,h.generateUuid)()}};S=he([ee(0,I.INativeEnvironmentService),ee(1,p.IFileService),ee(2,m.IExtensionGalleryService),ee(3,P.ILogService)],S),t.ExtensionsDownloader=S}),define(Q[123],Z([0,1,2,14,20,35]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends C.Disposable{constructor(g,h){super(),this.environmentService=g,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(h.onDidUninstallExtension(w=>this.onDidUnInstallExtension(w)))}onDidInstallExtensions(g){g.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,155,19,3,2,17,14,20,16,22,23,10,62,12,8]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let S=class extends y.LanguagePackBaseService{constructor(c,s,e,r){super(e),this.extensionManagementService=c,this.logService=r,this.cache=this._register(new l(s,r)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getTranslationsUri(c){const e=(await this.cache.getLanguagePacks())[p.locale];if(!e){this.logService.warn(`No language pack found for ${p.locale}`);return}const r=e.translations[c];return r?P.URI.file(r):void 0}async getInstalledLanguages(){const c=await this.cache.getLanguagePacks(),s=Object.keys(c).map(e=>{const r=c[e];return{...this.createQuickPickItem(e,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((e,r)=>e.label.localeCompare(r.label)),s}async postInstallExtension(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",c.identifier.id),await this.update())}async postUninstallExtension(c){const s=await this.cache.getLanguagePacks();Object.keys(s).some(e=>s[e]&&s[e].extensions.some(r=>(0,I.areSameExtensions)(r.extensionIdentifier,c.identifier)))&&(this.logService.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),e=await this.cache.update(s);return!(0,R.equals)(Object.keys(c),Object.keys(e))}};S=he([ee(0,w.IExtensionManagementService),ee(1,h.INativeEnvironmentService),ee(2,w.IExtensionGalleryService),ee(3,m.ILogService)],S),t.NativeLanguagePackService=S;let l=class extends k.Disposable{constructor(c,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,E.join)(c.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(c){return this.withLanguagePacks(s=>{Object.keys(s).forEach(e=>delete s[e]),this.createLanguagePacksFromExtensions(s,...c)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(c,...s){for(const e of s)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(c,e);Object.keys(c).forEach(e=>this.updateHash(c[e]))}createLanguagePacksFromExtension(c,s){const e=s.identifier,r=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of r)if(s.location.scheme===L.Schemas.file&&d(i)){let n=c[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},c[i.languageId]=n);const o=n.extensions.filter(u=>(0,I.areSameExtensions)(u.extensionIdentifier,e))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:e,version:s.manifest.version});for(const u of i.translations)n.translations[u.id]=(0,E.join)(s.location.fsPath,u.path)}}updateHash(c){if(c){const s=(0,C.createHash)("md5");for(const e of c.extensions)s.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);c.hash=s.digest("hex")}}withLanguagePacks(c=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(s=c(e),e)).then(e=>{for(const i of Object.keys(e))e[i]||delete e[i];this.languagePacks=e,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),g.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>s,e=>this.logService.error(e))})}};l=he([ee(0,h.INativeEnvironmentService),ee(1,m.ILogService)],l);function d(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const c of v.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,9,34]),function(B,t,C,R,D,k,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asTextOrError=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,k.createDecorator)("requestService");function E(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}t.isSuccess=E;function g(P){return P.res.statusCode===204}async function h(P){return g(P)?null:(await(0,C.streamToBuffer)(P.stream)).toString()}t.asText=h;async function w(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);return h(P)}t.asTextOrError=w;async function I(P){if(!E(P))throw new Error("Server returned "+P.res.statusCode);if(g(P))return null;const l=(await(0,C.streamToBuffer)(P.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}t.asJson=I;function m(P){p(P)}t.updateProxyConfigurationsScope=m;let y;function p(P){const S=L.Registry.as(D.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[y],remove:l?[l]:[]})}p(2)}),define(Q[125],Z([0,1,24,17,13,47]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(g,h){this.requestService=g,this.fileService=h}async download(g,h,w=C.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(g,h);return}const I={type:"GET",url:g.toString(!0)},m=await this.requestService.request(I,w);if(m.res.statusCode===200)await this.fileService.writeFile(h,m.stream);else{const y=await(0,k.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${y}`)}}};L=he([ee(0,k.IRequestService),ee(1,D.IFileService)],L),t.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function D(L,E){return L.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:L.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function k(L,E,g={}){const h=(0,C.parse)(L),w=g.proxyUrl||D(h,E);if(!w)return null;const I=(0,C.parse)(w);if(!/^https?:$/.test(I.protocol||""))return null;const m={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((y,p)=>{B(["http-proxy-agent"],y,p)}))(m):new(await new Promise((y,p)=>{B(["https-proxy-agent"],y,p)}))(m)}t.getProxyAgent=k}),define(Q[128],Z([0,1,57,14,95,24,31,11,12,30,77,156,3]),function(B,t,C,R,D,k,L,E,g,h,w,I,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const y=1e4;let p;async function P(l,d,v){return d["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(v)&&!d["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(v)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(c,s)=>{const e=new k.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,D.localize)(0,null)))},y);try{c(await S(l,e.token))}catch(i){!(0,E.isCancellationError)(i)&&!e.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,L.toErrorMessage)(i)))):c({})}finally{clearTimeout(r),e.dispose()}})),p)}t.getResolvedShellEnv=P;async function S(l,d){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",c);const s=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",r);const i=await(0,w.getSystemShell)(g.OS,r);return l.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(d.isCancellationRequested)return o((0,E.canceled)());const u=(0,R.basename)(i);let a,f;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${b} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,f=["-Login","-Command"]):(a=`'${process.execPath}' ${b} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?f=["-ic"]:f=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),a);const U=(0,C.spawn)(i,[...f,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});d.onCancellationRequested(()=>(U.kill(),o((0,E.canceled)()))),U.on("error",K=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(K)),o(K)});const _=[];U.stdout.on("data",K=>_.push(K));const H=[];U.stderr.on("data",K=>H.push(K)),U.on("close",(K,ne)=>{const re=Buffer.concat(_).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(H).toString("utf8");if(se.trim()&&l.trace("getUnixShellEnvironment#stderr",se),K||ne)return o(new Error((0,D.localize)(2,null,K,ne)));const fe=e.exec(re),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);v?ie.ELECTRON_RUN_AS_NODE=v:delete ie.ELECTRON_RUN_AS_NODE,c?ie.ELECTRON_NO_ATTACH_CONSOLE=c:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,C.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,16,13,10]),function(B,t,C,R,D,k,L,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class g{constructor(I,m,y){this.storagePath=I,this.logService=m,this.fileService=y,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new C.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,m){const y=this.storage[I];return(0,D.isUndefinedOrNull)(y)?m:y}setItem(I,m){this.setItems([{key:I,data:m}])}setItems(I){let m=!1;for(const{key:y,data:p}of I)this.storage[y]!==p&&((0,D.isUndefinedOrNull)(p)?(0,D.isUndefined)(this.storage[y])||(this.storage[y]=void 0,m=!0):(this.storage[y]=p,m=!0));m&&this.save()}removeItem(I){(0,D.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(I)),this.lastSavedStorageContents=I}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=g;let h=class{constructor(I,m,y){this.fileStorage=new g(I.stateResource,m,y)}async init(){await this.fileStorage.init()}getItem(I,m){return this.fileStorage.getItem(I,m)}};h=he([ee(0,k.IEnvironmentService),ee(1,E.ILogService),ee(2,L.IFileService)],h),t.StateService=h}),define(Q[66],Z([0,1,12,32,8,30]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(h){if(C.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function E(h,w,I,m,y,p,P,S,l,d){const v=Object.create(null);v["common.machineId"]=P,v.sessionID=(0,k.generateUuid)()+Date.now(),v.commitHash=y,v.version=p,v["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,C.PlatformToString)(C.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=m,v["common.product"]=d||"desktop",S&&(v["common.msftInternal"]=S);let c=0;const s=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),C.isLinuxSnap&&(v["common.snap"]="true");const e=L(I);e&&(v["common.platformDetail"]=e);try{const r=await h.readFile(D.URI.file(l));v["common.source"]=r.value.toString().slice(0,30)}catch{}return v}t.resolveCommonProperties=E;function g(h){const w=R.env.USERDNSDOMAIN;if(!w)return!1;const I=w.toLowerCase();return h.some(m=>I===m)}t.verifyMicrosoftInternalDomain=g}),define(Q[36],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=t.TelemetryLevel||(t.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,36]),function(B,t,C,R,D,k,L,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanData=t.getPiiPathsFromEnvironment=t.isInternalTelemetry=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class g{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,R.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=g,t.NullTelemetryService=new g;class h{async publicLog(n,o,u){}async publicLogError(n,o,u){}}t.NullEndpointTelemetryService=h,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:l(o.sourceConfig)})})}t.configurationTelemetry=w;function I(i,n){return!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}t.supportsTelemetry=I;function m(i){const n=i.getValue(E.TELEMETRY_SETTING_ID),o=i.getValue("telemetry.enableCrashReporter");if(i.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=m;function y(i){const n={},o={},u={};S(i,u);for(let a in u){a=a.length>150?a.substr(a.length-149):a;const f=u[a];typeof f=="number"?o[a]=f:typeof f=="boolean"?o[a]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${f.length}`),n[a]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(n[a]=f)}return{properties:n,measurements:o}}t.validateTelemetryData=y;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function P(i){if(!i)return"none";for(const n of p)if(i.startsWith(`${n}+`))return n;return"other"}t.cleanRemoteAuthority=P;function S(i,n,o=0,u){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const f=i[a],b=u?u+a:a;Array.isArray(f)?n[b]=(0,C.safeStringify)(f):f instanceof Date?n[b]=f.toISOString():(0,D.isObject)(f)?o<2?S(f,n,o+1,b+"."):n[b]=(0,C.safeStringify)(f):n[b]=f}}function l(i){if(!i)return[];const n=[];return d(n,"",i),n}function d(i,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(u=>d(i,n?`${n}.${u}`:u,o[u])):i.push(n)}function v(i,n){const o=i.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(o)||u}t.isInternalTelemetry=v;function c(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}t.getPiiPathsFromEnvironment=c;function s(i,n){let o=i;const u=[];for(const U of n)for(;;){const _=U.exec(i);if(!_)break;u.push([_.index,U.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(o="";;){const U=f.exec(i);if(!U)break;!a.test(U[0])&&u.every(([_,H])=>U.index<_||U.index>=H)&&(o+=i.substring(b,U.index)+"<REDACTED: user-file-path>",b=f.lastIndex)}return b<i.length&&(o+=i.substr(b)),o}function e(i){if(!i)return i;const n=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of o)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return i}function r(i,n){return(0,C.cloneAndChange)(i,o=>{if(typeof o=="string"){let u=o;u=s(u,n);for(const a of n)u=u.replace(a,"");return u=e(u),u}})}t.cleanData=r}),define(Q[130],Z([0,1,103,42]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function D(k,L,E,g,h,w,I){const m={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,R.supportsTelemetry)(L,E)&&(0,R.getTelemetryLevel)(g)===3){const y=await(0,C.getServiceMachineId)(E,h,w),{sessionId:p}=await I.getTelemetryInfo();m["X-Market-User-Id"]=y,m["VSCode-SessionId"]=p}return m}t.resolveMarketplaceHeaders=D}),define(Q[131],Z([0,1,11,26,42]),function(B,t,C,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(g,h,w){const I=await new Promise((S,l)=>{B(["@microsoft/1ds-core-js"],S,l)}),m=await new Promise((S,l)=>{B(["@microsoft/1ds-post-js"],S,l)}),y=new I.AppInsightsCore,p=new m.PostChannel,P={instrumentationKey:g,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(w){P.extensionConfig={};const S={alwaysUseXhrOverride:!0,httpXHROverride:w};P.extensionConfig[p.identifier]=S}return y.initialize(P,[]),y.addTelemetryInitializer(S=>{h&&(S.ext=S.ext??{},S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),y}class E{constructor(h,w,I,m,y){this._isInternalTelemetry=h,this._eventPrefix=w,this._defaultData=I,this._xhrOverride=y,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(h){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){h(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(w=>{h(w)},w=>{(0,C.onUnexpectedError)(w),console.error(w)})}}log(h,w){if(!this._aiCoreOrKey)return;w=(0,R.mixin)(w,this._defaultData),w=(0,D.validateTelemetryData)(w);const I=this._eventPrefix+"/"+h;try{this._withAIClient(m=>{m.pluginVersionString=w?.properties.version??"Unknown",m.track({name:I,baseData:{name:I,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(h=>{this._withAIClient(w=>{w.unload(!0,()=>{this._aiCoreOrKey=void 0,h(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=E}),define(Q[132],Z([0,1,2,26,52,12,27,96,21,40,133,28,34,36,42]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let P=class{constructor(d,v,c){this._configurationService=v,this._productService=c,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(d,v){this._experimentProperties[d]=v}_updateTelemetryLevel(){let d=(0,p.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const c=v.usage?3:v.error?2:0;d=Math.min(d,c)}this.telemetryLevel.value=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const d=await this._commonProperties,v=d.sessionID,c=d["common.machineId"],s=d["common.firstSessionDate"],e=d["common.msftInternal"];return{sessionId:v,machineId:c,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(d,v,c,s){return this.telemetryLevel.value<v?Promise.resolve(void 0):this._commonProperties.then(e=>{c=(0,R.mixin)(c,e),c=(0,R.mixin)(c,this._experimentProperties),c=(0,p.cleanData)(c,this._cleanupPatterns),this._appenders.forEach(r=>r.log(d,c))},e=>{console.error(e)})}publicLog(d,v,c){return this._log(d,3,v,c)}publicLog2(d,v,c){return this.publicLog(d,v,c)}publicLogError(d,v){return this._sendErrorTelemetry?this._log(d,2,v,!0):Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=he([ee(1,g.IConfigurationService),ee(2,I.IProductService)],P),t.TelemetryService=P;function S(){const l=(0,E.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.isWeb?"":(0,E.localize)(3,null),c=(0,E.localize)(4,null),s=(0,E.localize)(5,null),e=(0,E.localize)(6,null),r=(0,E.localize)(7,null),i=`
|       | ${c} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,E.localize)(8,null);return`
${l} ${d} ${v}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,E.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,E.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,157,131]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;class D extends R.AbstractOneDataSystemAppender{constructor(L,E,g,h){const w={sendPOST:(I,m)=>{const y={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const p=C.request(I.urlString,y,P=>{P.on("data",function(S){m(P.statusCode??200,P.headers,S.toString())}),P.on("error",function(S){m(0,{})})});p.write(I.data),p.end()}catch{m(0,{})}}};super(L,E,g,h,w)}}t.OneDataSystemAppender=D}),define(Q[135],Z([0,1,14,20]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function D(k,L){const E=Object.create(null),g=(w,I)=>{const m=JSON.parse(w);E[I]=m};if(L){const w=[],I=await R.Promises.readdir(L);for(const y of I)try{(await R.Promises.stat((0,C.join)(L,y))).isDirectory()&&w.push(y)}catch{}const m=[];for(const y of w)(await R.Promises.readdir((0,C.join)(L,y))).filter(P=>P==="telemetry.json").length===1&&m.push(y);for(const y of m){const p=(await R.Promises.readFile((0,C.join)(L,y,"telemetry.json"))).toString();g(p,y)}}let h=(await R.Promises.readFile((0,C.join)(k,"telemetry-core.json"))).toString();return g(h,"vscode-core"),h=(await R.Promises.readFile((0,C.join)(k,"telemetry-extensions.json"))).toString(),g(h,"vscode-extensions"),JSON.stringify(E,null,4)}t.buildTelemetryMessage=D}),define(Q[29],Z([0,1,9]),function(B,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,8,16,23,13,10,29]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let w=class extends R.Disposable{constructor(m,y,p,P,S){super(),this.extensionsManagementService=m,this.logService=P,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(d=>{this.installedExtensions=d.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(d=>this.onInstallExtension(d))),this._register(m.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(m.onDidUninstallExtension(d=>this.onDidUninstallExtension(d)));const l=D.URI.file(p.extensionsPath);this._register(y.watch(l)),this._register(C.Event.filter(y.onDidFilesChange,d=>d.rawChanges.some(v=>this.doesChangeAffects(v,l)))(()=>this.onDidChange()))}doesChangeAffects(m,y){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),y)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const y of m)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(y=>!(0,L.areSameExtensions)(y,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,L.areSameExtensions)(y,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),y=m.filter(P=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,L.areSameExtensions)(S,P.identifier))?!1:P.installedTimestamp&&P.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",P.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",P.identifier.id),!1)),p=this.installedExtensions.filter(P=>this.installingExtensions.some(S=>(0,L.areSameExtensions)(S,P))?!1:m.every(S=>!(0,L.areSameExtensions)(S.identifier,P))?(this.logService.info("Detected extension removed from another source",P.id),!0):!1);this.installedExtensions=m.map(P=>P.identifier),(y.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:p})}}};w=he([ee(1,E.IFileService),ee(2,k.INativeEnvironmentService),ee(3,g.ILogService),ee(4,h.IUriIdentityService)],w),t.ExtensionsWatcher=w}),define(Q[137],Z([0,1,29,104,13,18,69,4,2]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class h{constructor(m){this.uri=m,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let w=class{constructor(m){this._fileService=m,this._dispooables=new g.DisposableStore,this._limit=2**16;const y=new Map,p=P=>{let S=y.get(P.scheme);return S===void 0&&(S=m.hasProvider(P)&&!this._fileService.hasCapability(P,1024),y.set(P.scheme,S)),S};this._dispooables.add(E.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(P=>{y.delete(P.scheme)})),this.extUri=new k.ExtUri(p),this._canonicalUris=new L.SkipList((P,S)=>this.extUri.compare(P,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,k.normalizePath)(m));const y=this._canonicalUris.get(m);return y?y.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new h(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,P)=>p[1].touch<P[1].touch?1:p[1].touch>P[1].touch?-1:0);h._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let p=0;p<y;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};w=he([ee(0,D.IFileService)],w),t.UriIdentityService=w,(0,R.registerSingleton)(C.IUriIdentityService,w,1)}),define(Q[138],Z([0,1,98,14,33,18,8,9,17]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.hasWorkspaceFileExtension=t.isSavedWorkspace=t.isTemporaryWorkspace=t.isUntitledWorkspace=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_SUFFIX=t.WORKSPACE_EXTENSION=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.isWorkspaceFolder=t.isWorkspace=t.WorkbenchState=t.reviveIdentifier=t.isWorkspaceIdentifier=t.toWorkspaceIdentifier=t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=t.isSingleFolderWorkspaceIdentifier=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=(0,E.createDecorator)("contextService");function h(r){const i=r;return typeof i?.id=="string"&&L.URI.isUri(i.uri)}t.isSingleFolderWorkspaceIdentifier=h,t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function w(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,R.basename)(r)}:i?t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=r;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}t.toWorkspaceIdentifier=w;function I(r){const i=r;return typeof i?.id=="string"&&L.URI.isUri(i.configPath)}t.isWorkspaceIdentifier=I;function m(r){const i=r;if(i?.uri)return{id:i.id,uri:L.URI.revive(i.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:L.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}t.reviveIdentifier=m;var y;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(y=t.WorkbenchState||(t.WorkbenchState={}));function p(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}t.isWorkspace=p;function P(r){const i=r;return!!(i&&typeof i=="object"&&L.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}t.isWorkspaceFolder=P;class S{constructor(i,n,o,u,a){this._id=i,this._transient=o,this._configuration=u,this._ignorePathCasing=a,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=S;class l{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,k.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=l;function d(r){return new l({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}t.toWorkspaceFolder=d,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_SUFFIX=`.${t.WORKSPACE_EXTENSION}`,t.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function v(r,i){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}t.isUntitledWorkspace=v;function c(r){let i;return L.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===g.Schemas.tmp}t.isTemporaryWorkspace=c;function s(r,i){return!v(r,i)&&!c(r)}t.isSavedWorkspace=s;function e(r){return(typeof r=="string"?(0,R.extname)(r):(0,k.extname)(r))===t.WORKSPACE_SUFFIX}t.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,18,5,8,97,16,13,9,10,138,33,29,3,30,27]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryUserDataProfilesService=t.UserDataProfilesService=t.toUserDataProfile=t.EXTENSIONS_RESOURCE_NAME=t.reviveProfile=t.IUserDataProfilesService=t.PROFILES_ENABLEMENT_CONFIG=t.isUserDataProfile=void 0;function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&E.URI.isUri(n.location)&&E.URI.isUri(n.globalStorageHome)&&E.URI.isUri(n.settingsResource)&&E.URI.isUri(n.keybindingsResource)&&E.URI.isUri(n.tasksResource)&&E.URI.isUri(n.snippetsHome)&&((0,L.isUndefined)(n.extensionsResource)||E.URI.isUri(n.extensionsResource)))}t.isUserDataProfile=v,t.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",t.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function c(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:E.URI.revive(i.location).with({scheme:n}),globalStorageHome:E.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:E.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:E.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:E.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:E.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:E.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}t.reviveProfile=c,t.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(i,n,o,u){return{id:i,name:n,location:o,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,t.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}t.toUserDataProfile=s;let e=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,u,a){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=u,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new R.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new R.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new R.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(f=>s((0,k.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags})):[];let o;const u=new p.ResourceMap,a=s((0,C.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,g.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),n.length){const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[b,U]of Object.entries(f.workspaces)){const _=E.URI.parse(b),H=E.URI.parse(U),K=n.find(ne=>this.uriIdentityService.extUri.isEqual(ne.location,H));K&&u.set(_,K)}if(f.emptyWindow){const b=E.URI.parse(f.emptyWindow);o=n.find(U=>this.uriIdentityService.extUri.isEqual(U.location,b))}}this._profilesObject={profiles:n,workspaces:u,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",u=new RegExp(`${(0,d.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const b of this.profiles){const U=u.exec(b.name),_=U?parseInt(U[1]):0;a=_>a?_:a}const f=`${o} ${a+1}`;return this.createProfile((0,C.hash)((0,l.generateUuid)()).toString(16),f,{transient:!0},n)}async createNamedProfile(n,o,u){return this.createProfile((0,C.hash)((0,l.generateUuid)()).toString(16),n,o,u)}async createProfile(n,o,u,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.doCreateProfile(n,o,u);return a&&await this.setProfileForWorkspace(a,f),f}async doCreateProfile(n,o,u){let a=this.profileCreationPromises.get(o);return a||(a=(async()=>{try{const f=this.profiles.find(_=>_.name===o||_.id===n);if(f)return f;const b=s(n,o,(0,k.joinPath)(this.profilesHome,n),u);await this.fileService.createFolder(b.location);const U=[];return this._onWillCreateProfile.fire({profile:b,join(_){U.push(_)}}),await S.Promises.settled(U),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,a)),a}async updateProfile(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);let u=this.profiles.find(a=>a.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=s(u.id,o.name??u.name,u.location,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.updateProfiles([],[],[u]),u}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:o,join(a){u.push(a)}});try{await Promise.allSettled(u)}catch(a){this.logService.error(a)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let u=this.getProfileForWorkspace(n);return u||(u=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,u)),u}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=this.profiles.find(a=>a.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return E.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,y.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,y.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,u){const a=[...this.profiles,...n],f=[];this.transientProfilesObject.profiles=[];for(let b of a)b.isDefault||o.some(U=>b.id===U.id)||(b=u.find(U=>b.id===U.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):f.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(f),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,u)}triggerProfilesChanges(n,o,u){this._onDidChangeProfiles.fire({added:n,removed:o,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,o,u){u=o?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const a=this.getWorkspace(n),f=u?this.transientProfilesObject:this.profilesObject;E.URI.isUri(a)?(f.workspaces.delete(a),o&&f.workspaces.set(a,o)):f.emptyWindow=o,u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,a]of this.profilesObject.workspaces.entries())n[u.toString()]=a.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=he([ee(0,h.IEnvironmentService),ee(1,w.IFileService),ee(2,P.IUriIdentityService),ee(3,m.ILogService)],e),t.UserDataProfilesService=e;class r extends e{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}t.InMemoryUserDataProfilesService=r}),define(Q[139],Z([0,1,19,3,24,11,4,2,12,8,82,22,23,35,10,28,36,25]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let d=class extends E.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,n,o,u,a){super(),this.galleryService=i,this.telemetryService=n,this.logService=o,this.productService=u,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,E.toDisposable)(()=>{this.installingExtensions.forEach(({task:f})=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,I.isTargetPlatformCompatible)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(w.localize(0,null),I.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),c(o)}}async uninstall(i,n={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,n)}async reinstallFromGallery(i){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",i.identifier.id),!this.galleryService.isEnabled())throw new Error(w.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...i.identifier,preRelease:i.preRelease}],{targetPlatform:n,compatible:!0},D.CancellationToken.None);if(!o)throw new Error(w.localize(2,null));await this.createUninstallExtensionTask(i,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,n,o){const u=H=>`${m.ExtensionKey.create(H).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!h.URI.isUri(n)){const H=this.installingExtensions.get(u(n));if(H){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:K}=await H.task.waitUntilTaskIsFinished();return K}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],f=[],b=[],U=this.createInstallExtensionTask(i,n,o);h.URI.isUri(n)||this.installingExtensions.set(u(n),{task:U,waitingTasks:[]}),this._onInstallExtension.fire({identifier:U.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",U.identifier.id),a.push({task:U,manifest:i});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const K=await this.getAllDepsAndPackExtensions(U.identifier,i,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:re,manifest:se}of K){_=_||!!se.extensionDependencies?.some(ie=>(0,m.areSameExtensions)({id:ie},U.identifier));const fe=u(re),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(U,le.task)){this.logService.info("Waiting for already requested installing extension",re.identifier.id,U.identifier.id),le.waitingTasks.push(U);const ie=le.task.identifier;f.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(N=>(0,m.areSameExtensions)(N.identifier,ie)))).then(V=>{if(!V.find(F=>(0,m.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!ne.some(({identifier:ie})=>(0,m.areSameExtensions)(ie,re.identifier))){const ie=this.createInstallExtensionTask(se,re,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[U]}),this._onInstallExtension.fire({identifier:ie.identifier,source:re,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,U.identifier.id),a.push({task:ie,manifest:se})}}}catch(K){if(h.URI.isUri(U.source))(0,C.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",U.identifier.id,K.message),(0,C.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",U.identifier.id,K.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),K}const H=a.reduce((K,{task:ne,manifest:re})=>(K.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:re}),K),new Map);for(;H.size;){let K;const ne=[...H.values()].filter(({manifest:re})=>!re.extensionDependencies?.some(se=>H.has(se.toLowerCase())));ne.length?K=H.size===1?ne:ne.filter(({task:re})=>!(re===U&&!_)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:re})=>re.identifier.id)),K=[...H.values()]),await this.joinAllSettled(K.map(async({task:re})=>{const se=new Date().getTime();try{const{local:fe}=await re.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,re.source,o,D.CancellationToken.None))),!h.URI.isUri(re.source)){const le=re.operation===3,ie=le?void 0:(new Date().getTime()-re.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,durationSinceUpdate:ie}),g.isWeb&&re.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}b.push({local:fe,identifier:re.identifier,operation:re.operation,source:re.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw h.URI.isUri(re.source)||s(this.telemetryService,re.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,error:fe}),this.logService.error("Error while installing the extension:",re.identifier.id),fe}finally{H.delete(re.identifier.id.toLowerCase())}}))}return f.length&&await this.joinAllSettled(f),b.forEach(({identifier:K})=>this.logService.info("Extension installed successfully:",K.id)),this._onDidInstallExtensions.fire(b),b.filter(({identifier:K})=>(0,m.areSameExtensions)(K,U.identifier))[0].local}catch(H){if(a.forEach(({task:K})=>K.cancel()),b.length)try{const K=await Promise.allSettled(b.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<K.length;ne++){const re=K[ne],{identifier:se}=b[ne];re.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,k.getErrorMessage)(re.reason))}}catch(K){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(K),b.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(a.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:o.context,profileLocation:o.profileLocation}))),H}finally{for(const[H,{task:K,waitingTasks:ne}]of this.installingExtensions.entries()){const re=ne.indexOf(U);re!==-1&&ne.splice(re,1),ne.length===0&&(K===U||re!==-1)&&this.installingExtensions.delete(H)}}}canWaitForTask(i,n){for(const[,{task:o,waitingTasks:u}]of this.installingExtensions.entries())if(o===i&&(u.includes(n)||u.some(a=>this.canWaitForTask(a,n)))||o===n&&u[0]&&!this.canWaitForTask(i,u[0]))return!1;return!0}async joinAllSettled(i){const n=[],o=[],u=await Promise.allSettled(i);for(const a of u)a.status==="fulfilled"?n.push(a.value):o.push(a.reason);if(o.length)throw v(o);return n}async getAllDepsAndPackExtensions(i,n,o,u,a){if(!this.galleryService.isEnabled())return[];const f=await this.getInstalled(void 0,a),b=[i],U=[],_=async(H,K)=>{const ne=K.extensionDependencies||[],re=[...ne];if(K.extensionPack){const se=o?f.find(fe=>(0,m.areSameExtensions)(fe.identifier,H)):void 0;for(const fe of K.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(le=>(0,m.areSameExtensions)({id:le},{id:fe}))||re.every(le=>!(0,m.areSameExtensions)({id:le},{id:fe}))&&re.push(fe)}if(re.length){const se=[...b,...U.map(le=>le.gallery.identifier)],fe=re.filter(le=>se.every(ie=>!(0,m.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:u})),D.CancellationToken.None);for(const ie of le){if(se.find(F=>(0,m.areSameExtensions)(F,ie.identifier)))continue;const V=ne.some(F=>(0,m.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,u)}catch(F){if(F instanceof I.ExtensionManagementError&&F.code===I.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}U.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(i,n),U}async checkAndGetCompatibleVersion(i,n,o){if((await this.getExtensionsControlManifest()).malicious.some(b=>(0,m.areSameExtensions)(i.identifier,b)))throw new I.ExtensionManagementError(w.localize(3,null,i.identifier.id),I.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const b=await this.getTargetPlatform();throw new I.ExtensionManagementError(w.localize(4,null,i.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(b)),I.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(i,n,o);if(a){if(o&&!n&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new I.ExtensionManagementError(w.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],D.CancellationToken.None))[0]?new I.ExtensionManagementError(w.localize(6,null,i.identifier.id),I.ExtensionManagementErrorCode.ReleaseVersionNotFound):new I.ExtensionManagementError(w.localize(7,null,i.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const f=await this.galleryService.getManifest(a,D.CancellationToken.None);if(f===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);if(f.version!==a.version)throw new I.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:f}}async getCompatibleVersion(i,n,o){const u=await this.getTargetPlatform();let a=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(i,o,u)&&(a=i),a||(n?a=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:u,compatible:!0},D.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(i,o,u)),a}async uninstallExtension(i,n){const o=_=>`${_.id.toLowerCase()}${n.versionOnly?`-${i.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(o(i.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),u.waitUntilTaskIsFinished();const a=(_,H)=>{const K=this.createUninstallExtensionTask(_,H);return this.uninstallingExtensions.set(o(K.extension.identifier),K),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped}),K},f=(_,H)=>{H?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString(),H.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,H.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(_),error:H}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:H?.code,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped})},b=[],U=[];try{b.push(a(i,n));const _=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const H=this.getAllPackExtensionsToUninstall(i,_);for(const K of H)this.uninstallingExtensions.has(o(K.identifier))?this.logService.info("Extensions is already requested to uninstall",K.identifier.id):b.push(a(K,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(b.map(H=>H.extension),_,i),await this.joinAllSettled(b.map(async H=>{try{if(await H.run(),await this.joinAllSettled(this.participants.map(K=>K.postUninstall(H.extension,n,D.CancellationToken.None))),H.extension.identifier.uuid)try{await this.galleryService.reportStatistic(H.extension.manifest.publisher,H.extension.manifest.name,H.extension.manifest.version,"uninstall")}catch{}f(H.extension)}catch(K){const ne=K instanceof I.ExtensionManagementError?K:new I.ExtensionManagementError((0,k.getErrorMessage)(K),I.ExtensionManagementErrorCode.Internal);throw f(H.extension,ne),ne}finally{U.push(H)}}))}catch(_){const H=_ instanceof I.ExtensionManagementError?_:new I.ExtensionManagementError((0,k.getErrorMessage)(_),I.ExtensionManagementErrorCode.Internal);for(const K of b){try{K.cancel()}catch{}U.includes(K)||f(K.extension,H)}throw H}finally{for(const _ of b)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(i,n,o){for(const u of i){const a=this.getDependents(u,n);if(a.length){const f=a.filter(b=>!i.some(U=>(0,m.areSameExtensions)(U.identifier,b.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(u,f,o))}}}getDependentsErrorMessage(i,n,o){return o===i?n.length===1?w.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?w.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):w.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?w.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?w.localize(12,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):w.localize(13,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const u=i.manifest.extensionPack?i.manifest.extensionPack:[];if(u.length){const a=n.filter(b=>!b.isBuiltin&&u.some(U=>(0,m.areSameExtensions)({id:U},b.identifier))),f=[];for(const b of a)f.push(...this.getAllPackExtensionsToUninstall(b,n,o));return[...a,...f]}return[]}getDependents(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,m.areSameExtensions)({id:u},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(i,n,o){return o.profileLocation&&(0,y.isApplicationScopedExtension)(i)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(i,n,o)}createUninstallExtensionTask(i,n){return n.profileLocation&&i.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(i,n)}};d=he([ee(0,I.IExtensionGalleryService),ee(1,S.ITelemetryService),ee(2,p.ILogService),ee(3,P.IProductService),ee(4,l.IUserDataProfilesService)],d),t.AbstractExtensionManagementService=d;function v(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=v;function c(r){if(r instanceof I.ExtensionManagementError)return r;const i=new I.ExtensionManagementError(r.message,I.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function s(r,i,{extensionData:n,duration:o,error:u,durationSinceUpdate:a}){const f=u?u instanceof I.ExtensionManagementError?u.code:I.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(i,{...n,success:!u,duration:o,errorcode:f,durationSinceUpdate:a})}t.reportTelemetry=s;class e{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(i=>new Promise((n,o)=>{const u=i.onCancellationRequested(()=>{u.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,17,14,12,18,39,54,5,8,86,16,23,35,45,13,9,10,28,4,44,41,25,29,102]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d,v,c,s,e,r,i,n,o,u,a,f,b,U,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.toExtensionDescription=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0;var H;(function(ie){function V(N,F){if(N===F)return!0;const j=Object.keys(N),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(j.length!==$.size)return!1;for(const Y of j){if(N[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=V})(H=t.Translations||(t.Translations={})),t.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let K=class extends h.Disposable{constructor(V,N,F,j,$,Y,A,x,T,O,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=j,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=x,this.environmentService=T,this.productService=O,this.instantiationService=M,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,y.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,y.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[j,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),Y=F?await this.scanExtensionsUnderDevelopment(V,[...j,...$]):[];return this.dedupExtensions(j,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,j]=await Promise.all(N);return this.applyScanOptions([...F,...j],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let j=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return j=await this.applyScanOptions(j,1,V,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===w.Schemas.file).map(async j=>{const $=await this.createExtensionScannerInput(j,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(x=>(0,c.areSameExtensions)(x.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const j=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(j);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const j=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,y.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,y.joinPath)(V,"package.json"),j=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(j);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,y.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,j){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),j)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,Y)=>{const A=I.basename($.location.fsPath),x=I.basename(Y.location.fsPath);return A<x?-1:A>x?1:0})}dedupExtensions(V,N,F,j,$){const Y=(x,T,O)=>{if(x.isValid&&!T.isValid)return!1;if(x.isValid===T.isValid){if($&&p.gt(x.manifest.version,T.manifest.version))return this.logService.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(p.eq(x.manifest.version,T.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${T.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===j)return this.logService.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${x.location.path} with ${T.location.path}.`):this.logService.debug(`Overwriting user extension ${x.location.path} with ${T.location.path}.`),!0},A=new Map;return V?.forEach(x=>{const T=s.ExtensionIdentifier.toKey(x.identifier.id),O=A.get(T);(!O||Y(O,x,!1))&&A.set(T,x)}),N?.forEach(x=>{const T=s.ExtensionIdentifier.toKey(x.identifier.id),O=A.get(T);if(!O&&V&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!O||Y(O,x,!1))&&A.set(T,x)}),F?.forEach(x=>{const T=s.ExtensionIdentifier.toKey(x.identifier.id),O=A.get(T);(!O||Y(O,x,!0))&&A.set(T,x),A.set(T,x)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=N?await this.getBuiltInExtensionControl():{},$=[],Y=l.URI.file(I.normalize(I.join(w.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const x of F){const T=j[x.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":$.push((0,y.joinPath)(Y,x.name));break;default:$.push(l.URI.file(T));break}}const A=await Promise.all($.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,C.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,j,$,Y=!0){const A=await this.getTranslations($??m.language),x=await this.getMtime(V),T=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=T?await this.getMtime(T):void 0;return new ne(V,x,T,O,N,F,j,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};K=he([ee(4,b.IUserDataProfilesService),ee(5,f.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,n.ILogService),ee(8,v.IEnvironmentService),ee(9,o.IProductService),ee(10,i.IInstantiationService)],K),t.AbstractExtensionsScannerService=K;class ne{constructor(V,N,F,j,$,Y,A,x,T,O,M,W,q,X){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=j,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=x,this.productVersion=T,this.productDate=O,this.productCommit=M,this.devMode=W,this.language=q,this.translations=X}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,y.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,y.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&H.equals(V.translations,N.translations)}}let re=class extends h.Disposable{constructor(V,N,F,j,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=j,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const j=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(j)}catch{}return(0,S.isEmptyObject)(F)?N:N.filter(j=>!F[c.ExtensionKey.create(j).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async j=>{if(!j.isDirectory||V.type===1&&(0,y.basename)(j.resource).indexOf(".")===0)return null;const $=new ne(j.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,C.coalesce)(F).sort((j,$)=>j.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(j=>!j.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const j=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!j.length)return[];const $=await Promise.all(j.map(async Y=>{if(N(Y)){const A=new ne(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,C.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,y.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const j=(0,c.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:j,uuid:N.id}:{id:j},Y=N?.isSystem?0:V.type,A=Y===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,ne.createNlsConfiguration(V));const x={type:Y,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(x,V):x}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const j=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,Y]of j)$===P.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,Y)));return V.isValid=F,V.validations=j,V}async scanExtensionManifest(V){const N=(0,y.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,r.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,d.localize)(0,null,N.path,$.message))),null}let j;try{j=JSON.parse(F)}catch{const Y=[];(0,E.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(V,(0,d.localize)(1,null,N.path,A.offset,A.length,(0,g.getParseErrorMessage)(A.error))));return null}return(0,E.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(V,(0,d.localize)(2,null,N.path))),null):j}async translateManifest(V,N,F){const j=await this.getLocalizedMessages(V,N,F);if(j)try{const $=[],Y=await this.resolveOriginalMessageBundle(j.default,$);if($.length>0)return $.forEach(x=>{this.logService.error(this.formatMessage(V,(0,d.localize)(3,null,j.default?.path,(0,g.getParseErrorMessage)(x.error))))}),N;if((0,E.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(V,(0,d.localize)(4,null,j.default?.path))),N;const A=j.values||Object.create(null);return(0,_.localizeManifest)(N,A,Y)}catch{}return N}async getLocalizedMessages(V,N,F){const j=(0,y.joinPath)(V,"package.nls.json"),$=(T,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage(V,(0,d.localize)(5,null,T?.path,(0,g.getParseErrorMessage)(M.error))))})},Y=T=>{this.logService.error(this.formatMessage(V,(0,d.localize)(6,null,T?.path)))},A=`${N.publisher}.${N.name}`,x=F.translations[A];if(x)try{const T=l.URI.file(x),O=(await this.fileService.readFile(T)).value.toString(),M=[],W=(0,E.parse)(O,M);return M.length>0?($(T,M),{values:void 0,default:j}):(0,E.getNodeType)(W)!=="object"?(Y(T),{values:void 0,default:j}):{values:W.contents?W.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let O;try{O=await this.findMessageBundles(V,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),W=[],q=(0,E.parse)(M,W);return W.length>0?($(O.localized,W),{values:void 0,default:O.original}):(0,E.getNodeType)(q)!=="object"?(Y(O.localized),{values:void 0,default:O.original}):{values:q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,E.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,j)=>{const $=Y=>{const A=(0,y.joinPath)(V,`package.nls.${Y}.json`);this.fileService.exists(A).then(x=>{x&&F({localized:A,original:(0,y.joinPath)(V,"package.nls.json")});const T=Y.lastIndexOf("-");T===-1?F({localized:(0,y.joinPath)(V,"package.nls.json"),original:null}):(Y=Y.substring(0,T),$(Y))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,y.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};re=he([ee(1,f.IExtensionsProfileScannerService),ee(2,U.IUriIdentityService),ee(3,r.IFileService),ee(4,n.ILogService)],re);let se=class extends re{constructor(V,N,F,j,$,Y){super(N,F,j,$,Y),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new R.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&ne.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(j=>(j.location=l.URI.revive(j.location),j));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,a.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}};se=he([ee(2,f.IExtensionsProfileScannerService),ee(3,U.IUriIdentityService),ee(4,r.IFileService),ee(5,n.ILogService)],se);function fe(ie,V){const N=(0,c.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}t.toExtensionDescription=fe;class le extends K{constructor(V,N,F,j,$,Y,A,x,T,O,M){super(V,N,(0,y.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(j,s.MANIFEST_CACHE_FOLDER),$,Y,A,x,T,O,M),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const W=await this.fileService.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}t.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,17,14,20,10,25]),function(B,t,C,R,D,k,L,E,g,h,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let m=class extends L.Disposable{constructor(p,P){super(),this.userDataProfilesService=p,this.logService=P,this.processesLimiter=new R.Limiter(5)}async postUninstall(p){const P=this.parseScript(p,"uninstall");return P&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(P.script,"uninstall",P.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${S}`)))),h.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(p,P){const S=`vscode:${P}`;if(p.location.scheme===E.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[S]=="string"){const l=p.manifest.scripts[S].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${S} should be a node script`),null):{script:(0,g.join)(p.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(p,P,S,l,d){return new Promise((v,c)=>{const s=this.start(p,P,S,d);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?c(i):v(void 0)};s.on("error",i=>{r((0,D.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,n)=>{r(i?`post-${P} process exited with code ${i}`:void 0)}),l&&(e=setTimeout(()=>{e=null,s.kill(),c("timed out")},5e3))})}start(p,P,S,l){const d={silent:!0,execArgv:void 0},v=(0,C.fork)(p,[`--type=extension-post-${P}`,...S],d);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(v.stdout,"data"),s=k.Event.fromNodeEventEmitter(v.stderr,"data");c(i=>this.logService.info(l.identifier.id,l.manifest.version,`post-${P}`,i)),s(i=>this.logService.error(l.identifier.id,l.manifest.version,`post-${P}`,i));const e=k.Event.any(k.Event.map(c,i=>({data:`%c${i}`,format:[""]})),k.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(p){return(0,g.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=he([ee(0,I.IUserDataProfilesService),ee(1,w.ILogService)],m),t.ExtensionsLifecycle=m}),define(Q[141],Z([0,1,8,16,41,48,13,9,10,28,25]),function(B,t,C,R,D,k,L,E,g,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let I=class extends k.NativeExtensionsScannerService{constructor(y,p,P,S,l,d,v){super(C.URI.file(l.builtinExtensionsPath),C.URI.file(l.extensionsPath),l.userHome,C.URI.file(l.userDataPath),y,p,P,S,l,d,v)}};I=he([ee(0,w.IUserDataProfilesService),ee(1,D.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,g.ILogService),ee(4,R.INativeEnvironmentService),ee(5,h.IProductService),ee(6,E.IInstantiationService)],I),t.ExtensionsScannerService=I}),define(Q[142],Z([0,1,3,4,2,112,5,79,9,25]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.isProfileUsingDefaultStorage=t.AbstractStorageService=t.loadKeyTargets=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.TARGET_KEY=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker",t.TARGET_KEY="__$__targetStorageMarker",t.IStorageService=(0,g.createDecorator)("storageService");var w;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(w=t.WillSaveStateReason||(t.WillSaveStateReason={}));var I;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(I=t.StorageScope||(t.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=t.StorageTarget||(t.StorageTarget={}));function y(d){const v=d.get(t.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}t.loadKeyTargets=y;class p extends D.Disposable{constructor(v={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,c){if(c===t.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:c,target:this.getKeyTargets(v)[c]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,c,s){return this.getStorage(c)?.get(v,s)}getBoolean(v,c,s){return this.getStorage(c)?.getBoolean(v,s)}getNumber(v,c,s){return this.getStorage(c)?.getNumber(v,s)}store(v,c,s,e){if((0,L.isUndefinedOrNull)(c)){this.remove(v,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,s,e),this.getStorage(s)?.set(v,c)})}remove(v,c){this.withPausedEmitters(()=>{this.updateKeyTarget(v,c,void 0),this.getStorage(c)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,c){const s=[],e=this.getKeyTargets(v);for(const r of Object.keys(e))e[r]===c&&s.push(r);return s}updateKeyTarget(v,c,s){const e=this.getKeyTargets(c);typeof s=="number"?e[v]!==s&&(e[v]=s,this.getStorage(c)?.set(t.TARGET_KEY,JSON.stringify(e))):typeof e[v]=="number"&&(delete e[v],this.getStorage(c)?.set(t.TARGET_KEY,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const c=this.getStorage(v);return c?y(c):Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(v=w.NONE){this._onWillSaveState.fire({reason:v});const c=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(v){case w.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(v,c,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,c){return this.emitWillSaveState(w.NONE),(0,h.isUserDataProfile)(v)?this.switchToProfile(v,c):this.switchToWorkspace(v,c)}canSwitchProfile(v,c){return!(v.id===c.id||P(c)&&P(v))}switchData(v,c,s,e){this.withPausedEmitters(()=>{if(e)for(const[r,i]of v)c.set(r,i);else{const r=new Set;for(const[i,n]of v)r.add(i),c.get(i)!==n&&this.emitDidChangeValue(s,i);for(const[i]of c.items)r.has(i)||this.emitDidChangeValue(s,i)}})}}t.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(d){return d.isDefault||!!d.useDefaultFlags?.uiState}t.isProfileUsingDefaultStorage=P;class S extends p{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(v){return!1}}t.InMemoryStorageService=S;async function l(d,v,c,s,e,r){const i=H=>{try{return JSON.parse(H)}catch{return H}},n=new Map,o=new Map;d.forEach((H,K)=>{n.set(K,H),o.set(K,i(H))});const u=new Map,a=new Map;v.forEach((H,K)=>{u.set(K,H),a.set(K,i(H))});const f=new Map,b=new Map;c.forEach((H,K)=>{f.set(K,H),b.set(K,i(H))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const U=[];if(n.forEach((H,K)=>{U.push({key:K,value:H})}),console.table(U),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const H=[];u.forEach((K,ne)=>{H.push({key:ne,value:K})}),console.table(H),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const _=[];f.forEach((H,K)=>{_.push({key:K,value:H})}),console.table(_),console.groupEnd(),console.log(b)}t.logStorage=l}),define(Q[143],Z([0,1,19,24,11,12,32,5,8,21,16,22,23,45,13,10,28,47,130,142,36]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,I.getTargetPlatform)(k.platform,L.arch);var e;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function r(...T){return String(T.reduce((O,M)=>O|M,0))}var i;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class f{constructor(O=a){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,M=this.state.pageSize){return new f({...this.state,pageNumber:O,pageSize:M})}withFilter(O,...M){const W=[...this.state.criteria,...M.length?M.map(q=>({filterType:O,value:q})):[{filterType:O}]];return new f({...this.state,criteria:W})}withSortBy(O){return new f({...this.state,sortBy:O})}withSortOrder(O){return new f({...this.state,sortOrder:O})}withFlags(...O){return new f({...this.state,flags:O.reduce((M,W)=>M|W,0)})}withAssetTypes(...O){return new f({...this.state,assetTypes:O})}withSource(O){return new f({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:X,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:X}],assetTypes:ce,flags:ae}}get searchText(){const O=this.state.criteria.filter(M=>M.filterType===i.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function b(T,O){const M=(T||[]).filter(W=>W.statisticName===O)[0];return M?M.value:0}function U(T){const O="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(W=>W.assetType.indexOf(O)===0).reduce((W,q)=>{const X=K(T,q.assetType);return X&&W.push([q.assetType.substring(O.length),X]),W},[])}function _(T){if(T.properties){const O=T.properties.filter(q=>q.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=O.filter(q=>M.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return K(T,n.Repository)}function H(T){return{uri:`${T.fallbackAssetUri}/${n.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${n.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function K(T,O){return T.files.filter(W=>W.assetType===O)[0]?{uri:`${T.assetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function ne(T,O){const M=T.properties?T.properties.filter(q=>q.key===O):[],W=M.length>0&&M[0].value;return W?W.split(",").map(q=>(0,m.adoptToGalleryExtensionId)(q)):[]}function re(T){const O=T.properties?T.properties.filter(M=>M.key===o.Engine):[];return O.length>0&&O[0].value||""}function se(T){const O=T.properties?T.properties.filter(M=>M.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function fe(T){const O=T.properties?T.properties.filter(W=>W.key===o.LocalizedLanguages):[],M=O.length>0&&O[0].value||"";return M?M.split(","):[]}function le(T){return T.properties?.find(O=>O.key===o.SponsorLink)?.value}function ie(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,I.toTargetPlatform)(T.targetPlatform):"undefined"}function N(T){const O=(0,C.distinct)(T.versions.map(V)),M=!!T.tags?.includes(I.WEB_EXTENSION_TAG),W=O.indexOf("web");return M?W===-1&&O.push("web"):W!==-1&&O.splice(W,1),O}function F(T,O){const M=(0,I.getFallbackTargetPlarforms)(O);for(let W=0;W<T.length;W++){const q=T[W];if(q.version===T[W-1]?.version){let X=W;const ae=V(q);if(ae===O)for(;X>0&&T[X-1].version===q.version;)X--;else if(M.includes(ae))for(;X>0&&T[X-1].version===q.version&&V(T[X-1])!==O;)X--;X!==W&&(T.splice(W,1),T.splice(X,0,q))}}return T}t.sortExtensionVersions=F;function j(T,O,M){T.telemetryData={index:O,querySource:M}}function $(T,O,M){const W=T.versions[0],q={manifest:K(O,n.Manifest),readme:K(O,n.Details),changelog:K(O,n.Changelog),license:K(O,n.License),repository:_(O),download:H(O),icon:K(O,n.Icon),coreTranslations:U(O)};return{identifier:{id:(0,m.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:O.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(W),description:T.shortDescription||"",installCount:b(T.statistics,"install"),rating:b(T.statistics,"averagerating"),ratingCount:b(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:re(O),localizedLanguages:fe(O),targetPlatform:V(O),isPreReleaseVersion:se(O)},hasPreReleaseVersion:se(W),hasReleaseVersion:!0,preview:ie(T.flags)}}let Y=class{constructor(O,M,W,q,X,ae,ce,pe){this.requestService=M,this.logService=W,this.environmentService=q,this.telemetryService=X,this.fileService=ae,this.productService=ce,this.configurationService=pe;const Se=ce.extensionsGallery;this.extensionsGalleryUrl=Se?.serviceUrl,this.extensionsGallerySearchUrl=Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,M,W){const q=R.CancellationToken.isCancellationToken(M)?{}:M,X=R.CancellationToken.isCancellationToken(M)?M:W,ae=[],ce=[],pe=[],Se=[];let te=!0;for(const de of O){de.uuid?ce.push(de.uuid):ae.push(de.id);const ve=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:ve}),de.version&&Se.push({id:de.id,uuid:de.uuid,version:de.version}),te=te&&!!de.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let oe=new f().withPage(1,O.length);ce.length&&(oe=oe.withFilter(i.ExtensionId,...ce)),ae.length&&(oe=oe.withFilter(i.ExtensionName,...ae)),(q.queryAllVersions||te)&&(oe=oe.withFlags(oe.flags,e.IncludeVersions)),q.source&&(oe=oe.withSource(q.source));const{extensions:ge}=await this.queryGalleryExtensions(oe,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:Se,compatible:!!q.compatible},X);return q.source&&ge.forEach((de,ve)=>j(de,ve,q.source)),ge}async getCompatibleExtension(O,M,W){if((0,I.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(O,M,W))return O;const q=new f().withFlags(e.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,O.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:M},R.CancellationToken.None);return X[0]||null}async isExtensionCompatible(O,M,W){if(!(0,I.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,W)||!M&&O.properties.isPreReleaseVersion)return!1;let q=O.properties.engine;if(!q){const X=await this.getManifest(O,R.CancellationToken.None);if(!X)throw new Error("Manifest was not found");q=X.engines.vscode}return(0,y.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(O,M,W,q,X){if(!(0,I.isTargetPlatformCompatible)(V(O),q,X)||M!=="any"&&se(O)!==(M==="prerelease"))return!1;if(W)try{const ae=await this.getEngine(O);if(!(0,y.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,D.getErrorMessage)(ae)),!1}return!0}async query(O,M){let W=O.text||"";const q=O.pageSize??50;let X=new f().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,ge)=>(X=X.withFilter(i.Category,ge||oe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,ge)=>(X=X.withFilter(i.Tag,ge||oe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),X=X.withFilter(i.SearchText,W)),X=X.withSortBy(0)):O.ids?X=X.withFilter(i.ExtensionId,...O.ids):O.names?X=X.withFilter(i.ExtensionName,...O.names):X=X.withSortBy(4),typeof O.sortBy=="number"&&(X=X.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(X=X.withSortOrder(O.sortOrder)),O.source&&(X=X.withSource(O.source));const ae=async(te,oe)=>{const{extensions:ge,total:de}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},oe);return ge.forEach((ve,ke)=>j(ve,(te.pageNumber-1)*te.pageSize+ke,O.source)),{extensions:ge,total:de}},{extensions:ce,total:pe}=await ae(X,M),Se=async(te,oe)=>{if(oe.isCancellationRequested)throw new D.CancellationError;const{extensions:ge}=await ae(X.withPage(te+1),oe);return ge};return{firstPage:ce,total:pe,pageSize:X.pageSize,getPage:Se}}async queryGalleryExtensions(O,M,W){const q=O.flags;!!(O.flags&e.IncludeLatestVersionOnly)&&!!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(O.flags&e.IncludeLatestVersionOnly)&&!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(O=O.withFlags(O.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),O=O.withFlags(O.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:X,total:ae}=await this.queryRawGalleryExtensions(O,W);if(!(O.flags&e.IncludeLatestVersionOnly)){const te=[];for(const oe of X){const ge=await this.toGalleryExtensionWithCriteria(oe,M);ge&&te.push(ge)}return{extensions:te,total:ae}}const pe=[],Se=new Map;for(let te=0;te<X.length;te++){const oe=X[te],ge={id:(0,m.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},de=(0,E.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ke=>(0,m.areSameExtensions)(ke,ge))?.includePreRelease;if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(N(oe),M.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(oe,M);!ve||ve.properties.isPreReleaseVersion&&(!de||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==M.targetPlatform&&ve.hasPreReleaseVersion?Se.set(oe.extensionId,te):pe.push([te,ve])}if(Se.size){const te=new Date().getTime(),oe=new f().withFlags(q&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:ge}=await this.queryGalleryExtensions(oe,M,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:Se.size});for(const de of ge){const ve=Se.get(de.identifier.uuid);pe.push([ve,de])}}return{extensions:pe.sort((te,oe)=>te[0]-oe[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(O,M){const W={id:(0,m.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},q=M.versions?.find(pe=>(0,m.areSameExtensions)(pe,W))?.version,X=(0,E.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,m.areSameExtensions)(pe,W))?.includePreRelease,ae=N(O),ce=F(O.versions,M.targetPlatform);if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const Se=ce[pe];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,X?"any":"release",M.compatible,ae,M.targetPlatform))return $(O,Se,ae);if(q&&Se.version===q)return null}}return q||M.compatible?null:$(O,O.versions[0],ae)}async queryRawGalleryExtensions(O,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,e.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(e.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(O.raw),X={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,Se=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(oe=>oe.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:X},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Se};const te=await(0,l.asJson)(ce);if(te){const oe=te.results[0],ge=oe.extensions,de=oe.resultMetadata&&oe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return Se=de&&de.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:Se}}return{galleryExtensions:[],total:Se}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,l.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,D.isCancellationError)(pe)?"canceled":(0,D.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(O,M,W,q){if(!this.isEnabled())return;const X=k.isWeb?this.api(`/itemName/${O}.${M}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${M}/${W}/stats?statType=${q}`),ae=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:X,headers:pe},R.CancellationToken.None)}catch{}}async download(O,M,W){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const q=(0,m.getGalleryExtensionTelemetryData)(O),X=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=W===2?"install":W===3?"update":"",pe=ce?{uri:`${O.assets.download.uri}${g.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${g.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,Se=await this.getAsset(pe);await this.fileService.writeFile(M,Se.stream),ae(new Date().getTime()-X)}async getReadme(O,M){if(O.assets.readme){const W=await this.getAsset(O.assets.readme,{},M);return await(0,l.asTextOrError)(W)||""}return""}async getManifest(O,M){if(O.assets.manifest){const W=await this.getAsset(O.assets.manifest,{},M),q=await(0,l.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(O,M){const W=K(O,n.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},X=await this.getAsset(W,{headers:q});return await(0,l.asJson)(X)}async getCoreTranslation(O,M){const W=O.assets.coreTranslations.filter(q=>q[0]===M.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),X=await(0,l.asTextOrError)(q);return X?JSON.parse(X):null}return null}async getChangelog(O,M){if(O.assets.changelog){const W=await this.getAsset(O.assets.changelog,{},M);return await(0,l.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(O,M,W){let q=new f().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?q=q.withFilter(i.ExtensionId,O.identifier.uuid):q=q.withFilter(i.ExtensionName,O.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(q,R.CancellationToken.None);if(!X.length)return[];const ae=N(X[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ae,W))return[];const ce=[];await Promise.all(X[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,W)&&ce.push(te)}catch{}}));const pe=[],Se=new Set;for(const te of F(ce,W))Se.has(te.version)||(Se.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:se(te)}));return pe}async getAsset(O,M={},W=R.CancellationToken.None){const q=await this.commonHeadersPromise,X={type:"GET"},ae={...q,...M.headers||{}};M={...M,...X,headers:ae};const ce=O.uri,pe=O.fallbackUri,Se={...M,url:ce};try{const te=await this.requestService.request(Se,W);if(te.res.statusCode===200)return te;const oe=await(0,l.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${oe}`)}catch(te){if((0,D.isCancellationError)(te))throw te;const oe=(0,D.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:oe});const ge={...M,url:pe};return this.requestService.request(ge,W)}}async getEngine(O){let M=re(O);if(!M){const W=await this.getManifestFromRawExtensionVersion(O,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.asJson)(O),W=[],q={};if(M){for(const X of M.malicious)W.push({id:X});if(M.migrateToPreRelease)for(const[X,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,y.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[X.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[X,ae]of Object.entries(M.deprecated))ae&&(q[X.toLowerCase()]=(0,E.isBoolean)(ae)?{}:ae)}return{malicious:W,deprecated:q}}};Y=he([ee(1,l.IRequestService),ee(2,P.ILogService),ee(3,w.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,p.IFileService),ee(6,S.IProductService),ee(7,h.IConfigurationService)],Y);let A=class extends Y{constructor(O,M,W,q,X,ae,ce,pe){super(O,M,W,q,X,ae,ce,pe)}};A=he([ee(0,v.IStorageService),ee(1,l.IRequestService),ee(2,P.ILogService),ee(3,w.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,p.IFileService),ee(6,S.IProductService),ee(7,h.IConfigurationService)],A),t.ExtensionGalleryService=A;let x=class extends Y{constructor(O,M,W,q,X,ae,ce){super(void 0,O,M,W,q,X,ae,ce)}};x=he([ee(0,l.IRequestService),ee(1,P.ILogService),ee(2,w.IEnvironmentService),ee(3,c.ITelemetryService),ee(4,p.IFileService),ee(5,S.IProductService),ee(6,h.IConfigurationService)],x),t.ExtensionGalleryServiceWithNoStorageService=x}),define(Q[144],Z([0,1,44,16,13,10,65,29,25]),function(B,t,C,R,D,k,L,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=void 0;let h=class We extends g.UserDataProfilesService{constructor(I,m,y,p,P){super(y,p,m,P),this.stateService=I}getStoredProfiles(){return(0,C.revive)(this.stateService.getItem(We.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,C.revive)(this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{}))}};h=he([ee(0,L.IStateService),ee(1,E.IUriIdentityService),ee(2,R.IEnvironmentService),ee(3,D.IFileService),ee(4,k.ILogService)],h),t.UserDataProfilesService=h}),define(Q[145],Z([0,1,37,3,158,2]),function(B,t,C,R,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;class L extends C.AbstractPolicyService{constructor(g){super(),this.productName=g,this.throttler=new R.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(g){await this.throttler.queue(()=>new Promise((h,w)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,g,I=>{for(const m in I){const y=I[m];y===void 0?this.policies.delete(m):this.policies.set(m,y)}this._onDidChange.fire(Object.keys(I)),h()})}catch(I){w(I)}}))}}t.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,159,160]),function(B,t,C,R,D,k,L,E,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class w extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=e,this.cause=r}}t.ExtractError=w;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function m(s){if(s instanceof w)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new w(e,s)}function y(s,e,r,i,n,o){const u=D.dirname(e),a=D.join(i,u);if(!a.startsWith(i))return Promise.reject(new Error(E.localize(0,null,e)));const f=D.join(i,e);let b;return o.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(L.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((U,_)=>{if(!o.isCancellationRequested)try{b=(0,C.createWriteStream)(f,{mode:r}),b.once("close",()=>U()),b.once("error",_),s.once("error",_),s.pipe(b)}catch(H){_(H)}}))}function p(s,e,r,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((u,a)=>{const f=new R.Sequencer,b=U=>{U.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===o?u():a(new w("Incomplete",new Error(E.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",U=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(U.fileName)){b(i);return}const _=U.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(_)){const ne=D.join(e,_);n=(0,R.createCancelablePromise)(re=>L.Promises.mkdir(ne,{recursive:!0}).then(()=>b(re)).then(void 0,a));return}const H=S(s,U),K=I(U);n=(0,R.createCancelablePromise)(ne=>f.queue(()=>H.then(re=>y(re,_,K,e,r,ne).then(()=>b(ne)))).then(null,a))})})}function P(s,e=!1){return new Promise((r,i)=>{(0,g.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?i(m(n)):r((0,k.assertIsDefined)(o))})})}function S(s,e){return new Promise((r,i)=>{s.openReadStream(e,(n,o)=>{n?i(m(n)):r((0,k.assertIsDefined)(o))})})}function l(s,e){return new Promise((r,i)=>{const n=new h.ZipFile;e.forEach(u=>{u.contents?n.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&n.addFile(u.localPath,u.path)}),n.end();const o=(0,C.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>r(s))})}t.zip=l;function d(s,e,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=P(s,!0);return r.overwrite&&(o=o.then(u=>L.Promises.rm(e).then(()=>u))),o.then(u=>p(u,e,{sourcePathRegex:n},i))}t.extract=d;function v(s,e){return P(s).then(r=>new Promise((i,n)=>{r.on("entry",o=>{o.fileName===e&&S(r,o).then(u=>i(u),u=>n(u))}),r.once("close",()=>n(new Error(E.localize(2,null,e))))}))}function c(s,e){return v(s,e).then(r=>new Promise((i,n)=>{const o=[];r.once("error",n),r.on("data",u=>o.push(u)),r.on("end",()=>i(Buffer.concat(o)))}))}t.buffer=c}),define(Q[146],Z([0,1,67,88]),function(B,t,C,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function D(k){return(0,C.buffer)(k,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}t.getManifest=D}),define(Q[147],Z([0,1,3,31,11,2,17,14,12,18,39,5,8,30,20,67,87,58,16,139,22,23,41,48,122,140,146,123,136,35,45,13,9,10,28,36,29,25]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d,v,c,s,e,r,i,n,o,u,a,f,b,U,_,H,K,ne,re,se){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(c.IExtensionManagementService);let fe=class extends v.AbstractExtensionManagementService{constructor(A,x,T,O,M,W,q,X,ae,ce,pe,Se){super(A,x,T,ce,Se),this.extensionsScannerService=M,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(X.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(le,ge=>te.postUninstall(ge))),this.manifestCache=this._register(new u.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(X.createInstance(i.ExtensionsDownloader));const oe=this._register(new a.ExtensionsWatcher(this,ae,O,T,pe));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:ge,removed:de})=>{ge.length&&this._onDidInstallExtensions.fire(ge.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),de.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const x=await this.collectFiles(A),T=await(0,P.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,x);return m.URI.file(T)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:x,cleanup:T}=await this.downloadVsix(A),O=E.resolve(x.fsPath);try{return await(0,o.getManifest)(O)}finally{await T()}}getInstalled(A,x){return this.extensionsScanner.scanExtensions(A??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,x={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:T,cleanup:O}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(E.resolve(T.fsPath));if(M.engines&&M.engines.vscode&&!(0,b.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(S.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,T,x)}finally{await O()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,x){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const T={...x};return x.isPreReleaseVersion&&(T.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,T),this.manifestCache.invalidate(),A}async updateExtensionScope(A,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:x}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const x=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(A,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(O){this.logService.error(O)}}}}doCreateInstallExtensionTask(A,x,T){let O;if(m.URI.isUri(x))O=new N(A,x,T,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(x).toString();O=this.installGalleryExtensionsTasks.get(M),O||(this.installGalleryExtensionsTasks.set(M,O=new V(A,x,T,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return T.profileLocation?new F(O,T.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(A,x){return x.profileLocation?new $(A,x.profileLocation,this.extensionsProfileScannerService):new j(A,x,this.extensionsScanner)}async collectFiles(A){const x=async O=>{let M=await p.Promises.readdir(O);M=M.map(X=>E.join(O,X));const W=await Promise.all(M.map(X=>p.Promises.stat(X)));let q=Promise.resolve([]);return W.forEach((X,ae)=>{const ce=M[ae];X.isFile()&&(q=q.then(pe=>[...pe,ce])),X.isDirectory()&&(q=q.then(pe=>x(ce).then(Se=>[...pe,...Se])))}),q};return(await x(A.location.fsPath)).map(O=>({path:`extension/${E.relative(A.location.fsPath,O)}`,localPath:O}))}};fe=he([ee(0,c.IExtensionGalleryService),ee(1,ne.ITelemetryService),ee(2,H.ILogService),ee(3,d.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,l.IDownloadService),ee(7,_.IInstantiationService),ee(8,U.IFileService),ee(9,K.IProductService),ee(10,re.IUriIdentityService),ee(11,se.IUserDataProfilesService)],fe),t.ExtensionManagementService=fe;let le=class extends k.Disposable{constructor(A,x,T,O){super(),this.beforeRemovingExtension=A,this.fileService=x,this.extensionsScannerService=T,this.logService=O,this.uninstalledPath=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,x){const T={includeInvalid:!0,profileLocation:x};let O=[];return A===null||A===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},T,!1)):A===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(T)),O=A!==null?O.filter(M=>M.type===A):O,Promise.all(O.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(x.map(T=>this.toLocalExtension(T)))}async extractUserExtension(A,x,T,O){const M=A.toString(),W=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),q=E.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await p.Promises.rm(q)}catch{throw new c.ExtensionManagementError(S.localize(1,null,q,A.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,x,W,O),await this.extensionsScannerService.updateMetadata(m.URI.file(W),T);try{await this.rename(A,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(X){try{await p.Promises.rm(W)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(X)}. Deleted from extracted location`,W),X}return this.scanLocalExtension(m.URI.file(q),1)}async updateMetadata(A,x){return await this.extensionsScannerService.updateMetadata(A.location,x),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const x=A.map(T=>s.ExtensionKey.create(T));await this.withUninstalledExtensions(T=>{x.forEach(O=>T[O.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(O=>delete O[A.toString()]);const T=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(A))||null;return T?this.updateMetadata(T,{installedTimestamp:Date.now()}):null}async removeExtension(A,x){this.logService.trace(`Deleting ${x} extension from disk`,A.identifier.id,A.location.fsPath),await p.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(x)try{T=JSON.parse(x)}catch{}return A&&(A(T),Object.keys(T).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await p.Promises.rm(this.uninstalledPath)),T})}async extractAtLocation(A,x,T,O){this.logService.trace(`Started extracting the extension from ${x} to ${T}`);try{await p.Promises.rm(T)}catch(M){throw new c.ExtensionManagementError(this.joinErrors(M).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,P.extract)(x,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,A.id)}catch(M){try{await p.Promises.rm(T)}catch{}let W=c.ExtensionManagementErrorCode.Extract;throw M instanceof P.ExtractError&&(M.type==="CorruptZip"?W=c.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(W=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(M.message,W)}}async rename(A,x,T,O){try{await p.Promises.rename(x,T)}catch(M){if(g.isWindows&&M&&M.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${x} to ${T} with 'EPERM' error. Trying again...`,A.id),this.rename(A,x,T,O);throw new c.ExtensionManagementError(M.message||S.localize(2,null,x,T),M.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,x){const T=await this.extensionsScannerService.scanExistingExtension(A,x,{includeInvalid:!0});if(T)return this.toLocalExtension(T);throw new Error(S.localize(3,null,A.path))}async toLocalExtension(A){const x=await this.fileService.resolve(A.location);let T,O;return x.children&&(T=x.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,O=x.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:T,changelogUrl:O,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const W of x)A[s.ExtensionKey.create(W).toString()]||T.add(W.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(x,W=>W.identifier);await C.Promises.settled(O.map(async W=>{const q=W.sort((X,ae)=>w.rcompare(X.manifest.version,ae.manifest.version))[0];T.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const M=x.filter(W=>A[s.ExtensionKey.create(W).toString()]);await C.Promises.settled(M.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=[],O=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(x,W=>W.identifier);for(const W of M)if(W.length>1&&T.push(...W.sort((q,X)=>{const ae=w.rcompare(q.manifest.version,X.manifest.version);return ae!==0?ae:q.targetPlatform===O?-1:1}).slice(1)),W[0].type===0){const q=A.find(X=>(0,s.areSameExtensions)(X.identifier,W[0].identifier));(!q||w.gte(q.manifest.version,W[0].manifest.version))&&T.push(W[0])}await C.Promises.settled(T.map(W=>this.removeExtension(W,"outdated")))}joinErrors(A){const x=Array.isArray(A)?A:[A];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};le=he([ee(1,U.IFileService),ee(2,r.IExtensionsScannerService),ee(3,H.ILogService)],le);class ie extends v.AbstractExtensionTask{get operation(){return(0,I.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,x,T,O,M){super(),this.identifier=A,this.source=x,this.options=T,this.extensionsScanner=O,this.logService=M,this._operation=2}async installExtension(A,x){try{const T=await this.unsetUninstalledAndGetLocal(A.key);if(T)return this.extensionsScanner.updateMetadata(T,A.metadata)}catch{throw g.isMacintosh?new c.ExtensionManagementError(S.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(S.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(A,x)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const T=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),T}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:x,metadata:T},O){const M=await this.extensionsScanner.extractUserExtension(x,A,T,O);return this.logService.info("Extracting completed.",x.id),M}}class V extends ie{constructor(A,x,T,O,M,W){super(x.identifier,x,T,M,W),this.manifest=A,this.gallery=x,this.extensionsDownloader=O}async doRun(A){const T=(await this.extensionsScanner.scanExtensions(null,void 0)).find(W=>(0,s.areSameExtensions)(W.identifier,this.gallery.identifier));T&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,f.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,I.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(T,O),metadata:O};const M=await this.downloadExtension(this.gallery,this._operation);try{const W=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:O},A);return T&&!this.options.profileLocation&&(T.targetPlatform!==W.targetPlatform||w.neq(T.manifest.version,W.manifest.version))&&await this.extensionsScanner.setUninstalled(T),{local:W,metadata:O}}catch(W){throw await this.deleteDownloadedVSIX(M),W}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(m.URI.file(A))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,D.getErrorMessage)(x))}}async downloadExtension(A,x){let T;try{this.logService.trace("Started downloading extension:",A.identifier.id),T=(await this.extensionsDownloader.downloadExtension(A,x)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,T)}catch(O){throw new c.ExtensionManagementError((0,v.joinErrors)(O).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(T),T}catch(O){throw await this.deleteDownloadedVSIX(T),new c.ExtensionManagementError((0,v.joinErrors)(O).message,c.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,x,T,O,M,W){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},x,T,M,W),this.manifest=A,this.location=x,this.galleryService=O}async doRun(A){const x=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,f.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||O?.isBuiltin,M.installedTimestamp=Date.now(),O)if(this._operation=3,x.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(S.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&w.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const q=await this.unsetUninstalledAndGetLocal(x);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(S.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:E.resolve(this.location.fsPath),key:x,metadata:M},A),metadata:M}}async getMetadata(A,x,T){try{let[O]=await this.galleryService.getExtensions([{id:A,version:x}],T);if(O||([O]=await this.galleryService.getExtensions([{id:A}],T)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,x,T){this.task=A,this.profileLocation=x,this.extensionsProfileScannerService=T,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class j extends v.AbstractExtensionTask{constructor(A,x,T){super(),this.extension=A,this.options=x,this.extensionsScanner=T}async doRun(A){const x=[],T=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);x.push(...T.filter(M=>O.equals(s.ExtensionKey.create(M))))}else x.push(...T.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!x.length)throw new Error(S.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const O of x)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(M){throw new Error(S.localize(9,null,(0,R.toErrorMessage)(M)))}}}class $ extends v.AbstractExtensionTask{constructor(A,x,T){super(),this.extension=A,this.profileLocation=x,this.extensionsProfileScannerService=T}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,11,2,5,21,16,128,10,126,161]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let p=class extends L.Disposable{constructor(S,l,d){super(),this.environmentService=l,this.logService=d,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,l){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:d,strictSSL:v}=this;let c;try{c=await(0,w.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...c},e=S.agent?S.agent:await(0,m.getProxyAgent)(S.url||"",s,{proxyUrl:d,strictSSL:v});S.agent=e,S.strictSSL=v,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(S,l);return this.logService.trace("RequestService#request (node) - success",S.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",S.url,r),r}}async getNodeRequest(S){return((0,C.parse)(S.url).protocol==="https:"?await new Promise((v,c)=>{B(["https"],v,c)}):await new Promise((v,c)=>{B(["http"],v,c)})).request}_request(S,l){return R.Promises.withAsyncBody(async(d,v)=>{const c=(0,C.parse)(S.url),s=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),e={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,E.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(e.auth=S.user+":"+S.password);const r=s(e,i=>{const n=(0,E.isNumber)(S.followRedirects)?S.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...S,url:i.headers.location,followRedirects:n-1},l).then(d,v);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,y.createGunzip)())),d({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});r.on("error",v),S.timeout&&r.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&r.write(S.data),r.end(),l.onCancellationRequested(()=>{r.abort(),v(new k.CancellationError)})})}async resolveProxy(S){}};p=he([ee(0,g.IConfigurationService),ee(1,h.INativeEnvironmentService),ee(2,I.ILogService)],p),t.RequestService=p}),define(Q[162],Z([0,1,38,3,15,31,11,2,17,14,12,32,8,20,21,119,58,125,16,101,143,22,121,41,48,147,141,13,111,113,46,109,61,62,124,10,115,116,37,145,133,28,47,148,65,129,66,36,132,42,134,135,29,137,25,144]),function(B,t,C,R,D,k,L,E,g,h,w,I,m,y,p,P,S,l,d,v,c,s,e,r,i,n,o,u,a,f,b,U,_,H,K,ne,re,se,fe,le,ie,V,N,F,j,$,Y,A,x,T,O,M,W,q,X,ae){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class ce extends E.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,oe]=await this.initServices();return te.invokeFunction(async ge=>{const de=ge.get(ne.ILogService),ve=ge.get(u.IFileService),ke=ge.get(d.INativeEnvironmentService),Fe=ge.get(X.IUserDataProfilesService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(ke,ve,Fe,te),await Promise.all(oe.map(Ue=>{(0,R.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,oe={_serviceBrand:void 0,...ie.default};te.set(V.IProductService,oe);const ge=new v.NativeEnvironmentService(this.argv,oe);te.set(d.INativeEnvironmentService,ge),await Promise.all([ge.appSettingsHome.fsPath,ge.extensionsPath].map(we=>we?y.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(ge),ve=[];ve.push(new re.SpdLogLogger("cli",(0,h.join)(ge.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&ve.push(new ne.ConsoleLogger(de));const ke=this._register(new ne.MultiplexLogService(ve));te.set(ne.ILogService,ke);const Fe=this._register(new a.FileService(ke));te.set(u.IFileService,Fe);const Ue=this._register(new f.DiskFileSystemProvider(ke));Fe.registerProvider(g.Schemas.file,Ue);const xe=new $.StateService(ge,ke,Fe);te.set(j.IStateService,xe);const z=new q.UriIdentityService(Fe);te.set(W.IUriIdentityService,z);const G=new ae.UserDataProfilesService(xe,z,ge,Fe,ke);te.set(X.IUserDataProfilesService,G);const J=w.isWindows&&oe.win32RegValueName?this._register(new le.NativePolicyService(oe.win32RegValueName)):ge.policyFile?this._register(new se.FilePolicyService(ge.policyFile,Fe,ke)):new fe.NullPolicyService;te.set(fe.IPolicyService,J);const ue=this._register(new P.ConfigurationService(G.defaultProfile.settingsResource,Fe,J,ke));te.set(p.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(oe.quality!=="stable"||ue.getValue(X.PROFILES_ENABLEMENT_CONFIG)),te.set(W.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(N.IRequestService,new b.SyncDescriptor(F.RequestService,void 0,!0)),te.set(S.IDownloadService,new b.SyncDescriptor(l.DownloadService,void 0,!0)),te.set(r.IExtensionsProfileScannerService,new b.SyncDescriptor(r.ExtensionsProfileScannerService,void 0,!0)),te.set(i.IExtensionsScannerService,new b.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(n.INativeServerExtensionManagementService,new b.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new b.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(H.ILanguagePackService,new b.SyncDescriptor(K.NativeLanguagePackService,void 0,!1));const me=[],De=(0,T.isInternalTelemetry)(oe,ue);if((0,T.supportsTelemetry)(oe,ge)){oe.aiConfig&&oe.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(De,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:we}=ge,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const Ce=await y.Promises.readFile(ge.stateResource.fsPath);be=JSON.parse(Ce.toString())[A.machineIdKey]}catch(Ce){Ce.code!=="ENOENT"&&ke.error(Ce)}return(0,Y.resolveCommonProperties)(Fe,(0,C.release)(),(0,C.hostname)(),process.arch,oe.commit,oe.version,be,De,we)})(),piiPaths:(0,T.getPiiPathsFromEnvironment)(ge)};te.set(A.ITelemetryService,new b.SyncDescriptor(x.TelemetryService,[Le],!1))}else te.set(A.ITelemetryService,T.NullTelemetryService);return[new U.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(oe=>{const ge=(0,k.toErrorMessage)(oe,!0);!ge||te.error(`[uncaught exception in CLI]: ${ge}`)}),process.on("uncaughtException",oe=>(0,L.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,L.onUnexpectedError)(oe))}async doRun(te,oe,ge,de){const ve=te.args.profile?ge.profiles.find(ke=>ke.name===te.args.profile)?.extensionsResource:ge.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,oe,this.argv["install-source"]);if(this.argv["list-extensions"])return de.createInstance(e.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ke={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return de.createInstance(e.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ke,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return de.createInstance(e.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return de.createInstance(e.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(oe=>/\.vsix$/i.test(oe)?m.URI.file((0,h.isAbsolute)(oe)?oe:(0,h.join)((0,I.cwd)(),oe)):oe)}async setInstallSource(te,oe,ge){await oe.writeFile(m.URI.file(te.installSourcePath),D.VSBuffer.fromString(ge.slice(0,30)))}}async function pe(Se){const te=new ce(Se);try{await te.run()}finally{te.dispose()}}t.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ef8e6b87a2a5a25ba1ef946bd1640ca3510956c/core/vs/code/node/cliProcessMain.js.map
