/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","fs","vs/editor/common/languages","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(y){return y?y.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(I,E,D){this.id=I,this.definition=E,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function C(y,I){const E=["codicon","codicon-"+y];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=C;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function E(k){if(k instanceof t)return["codicon","codicon-"+k.id];const w=I.exec(k.id);if(!w)return E(t.error);const[,T,S]=w,g=["codicon","codicon-"+T];return S&&g.push("codicon-modifier-"+S.substr(1)),g}y.asClassNameArray=E;function D(k){return E(k).join(" ")}y.asClassName=D;function A(k){return"."+E(k).join(".")}y.asCSSSelector=A})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(y,I){const E=Object.create(null);for(const D of y){const A=I(D);let k=E[A];k||(k=E[A]=[]),k.push(D)}return E}e.groupBy=l;function t(y,I){const E=[],D=[];for(const A of y)I.has(A)||E.push(A);for(const A of I)y.has(A)||D.push(A);return{removed:E,added:D}}e.diffSets=t;function C(y,I){const E=[],D=[];for(const[A,k]of y)I.has(A)||E.push(k);for(const[A,k]of I)y.has(A)||D.push(k);return{removed:E,added:D}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(I,E){let D=this.map.get(I);D||(D=new Set,this.map.set(I,D)),D.add(E)}delete(I,E){const D=this.map.get(I);!D||(D.delete(E),D.size===0&&this.map.delete(I))}forEach(I,E){const D=this.map.get(I);!D||D.forEach(E)}}e.SetMap=P}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(y){return(I,E,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=y(k,E)}}e.createDecorator=l;function t(y,I,E){let D=null,A=null;if(typeof E.value=="function"?(D="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(D="get",A=E.get),!A)throw new Error("not supported");const k=`$memoize$${I}`;E[D]=function(...w){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[k]}}e.memoize=t;function C(y,I,E){return l((D,A)=>{const k=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...T){this[w]||(this[w]=E?E():void 0),clearTimeout(this[k]),I&&(this[w]=I(this[w],...T),T=[this[w]]),this[k]=setTimeout(()=>{D.apply(this,T),this[w]=E?E():void 0},y)}})}e.debounce=C;function P(y,I,E){return l((D,A)=>{const k=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,T=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...g){if(this[w]||(this[w]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...g)),this[S])return;const v=this[T]+y;v<=Date.now()?(this[T]=Date.now(),D.apply(this,[this[w]]),this[w]=E?E():void 0):(this[S]=!0,this[k]=setTimeout(()=>{this[S]=!1,this[T]=Date.now(),D.apply(this,[this[w]]),this[w]=E?E():void 0},v-Date.now()))}})}e.throttle=P}),define(De[11],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(d=>{d(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=l,e.errorHandler=new l;function t(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=t;function C(p){E(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=C;function P(p){E(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=P;function y(p){if(p instanceof Error){const{name:i,message:d}=p,a=p.stacktrace||p.stack;return{$isError:!0,name:i,message:d,stack:a,noTelemetry:f.isErrorNoTelemetry(p)}}return p}e.transformErrorForSerialization=y;const I="Canceled";function E(p){return p instanceof D?!0:p instanceof Error&&p.name===I&&p.message===I}e.isCancellationError=E;class D extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=D;function A(){const p=new Error(I);return p.name=p.message,p}e.canceled=A;function k(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=k;function w(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=w;function T(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function S(p){const i=new Error(`${p} has been disposed`);return i.name="DISPOSED",i}e.disposed=S;function g(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=g;class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const d=new f;return d.message=i.message,d.stack=i.stack,d}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(De[17],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function C(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=C;function P(oe,le,ge=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!ge(oe[Z],le[Z]))return!1;return!0}e.equals=P;function y(oe,le){const ge=oe.length-1;le<ge&&(oe[le]=oe[ge]),oe.pop()}e.removeFastWithoutKeepingOrder=y;function I(oe,le,ge){return E(oe.length,Z=>ge(oe[Z],le))}e.binarySearch=I;function E(oe,le){let ge=0,Z=oe-1;for(;ge<=Z;){const ae=(ge+Z)/2|0,ne=le(ae);if(ne<0)ge=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(ge+1)}e.binarySearch2=E;function D(oe,le){let ge=0,Z=oe.length;if(Z===0)return 0;for(;ge<Z;){const ae=Math.floor((ge+Z)/2);le(oe[ae])?Z=ae:ge=ae+1}return ge}e.findFirstInSorted=D;function A(oe,le,ge){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const O of le){const j=ge(O,Z);j<0?ae.push(O):j>0?ne.push(O):ie.push(O)}return oe<ae.length?A(oe,ae,ge):oe<ae.length+ie.length?ie[0]:A(oe-(ae.length+ie.length),ne,ge)}e.quickSelect=A;function k(oe,le){const ge=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],ge.push(Z)):Z.push(ae);return ge}e.groupBy=k;function w(oe,le,ge){const Z=[];function ae(O,j,G){if(j===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===O?(X.deleteCount+=j,X.toInsert.push(...G)):Z.push({start:O,deleteCount:j,toInsert:G})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const O=oe[ne],j=le[ie],G=ge(O,j);G===0?(ne+=1,ie+=1):G<0?(ae(ne,1,[]),ne+=1):G>0&&(ae(ne,0,[j]),ie+=1)}return Z}e.sortedDiff=w;function T(oe,le,ge){const Z=w(oe,le,ge),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=T;function S(oe,le,ge){if(ge===0)return[];const Z=oe.slice(0,ge).sort(le);return v(oe,le,Z,ge,oe.length),Z}e.top=S;function g(oe,le,ge,Z,ae){return ge===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const O=oe.length,j=oe.slice(0,ge).sort(le);for(let G=ge,X=Math.min(ge+Z,O);G<O;G=X,X=Math.min(X+Z,O)){if(G>ge&&await new Promise(pe=>setTimeout(pe)),ae&&ae.isCancellationRequested)throw new l.CancellationError;v(oe,le,j,G,X)}return j})().then(ne,ie)})}e.topAsync=g;function v(oe,le,ge,Z,ae){for(const ne=ge.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,ge[ne-1])<0){ge.pop();const O=D(ge,j=>le(ie,j)<0);ge.splice(O,0,ie)}}}function m(oe){return oe.filter(le=>!!le)}e.coalesce=m;function b(oe){let le=0;for(let ge=0;ge<oe.length;ge++)oe[ge]&&(oe[le]=oe[ge],le+=1);oe.length=le}e.coalesceInPlace=b;function f(oe,le,ge){oe.splice(ge,0,oe.splice(le,1)[0])}e.move=f;function c(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=c;function p(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=p;function i(oe,le=ge=>ge){const ge=new Set;return oe.filter(Z=>{const ae=le(Z);return ge.has(ae)?!1:(ge.add(ae),!0)})}e.distinct=i;function d(oe){const le=new Set;return ge=>{const Z=oe(ge);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=d;function a(oe,le){const ge=r(oe,le);if(ge!==-1)return oe[ge]}e.findLast=a;function r(oe,le){for(let ge=oe.length-1;ge>=0;ge--){const Z=oe[ge];if(le(Z))return ge}return-1}e.lastIndex=r;function o(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=o;function u(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=u;function n(oe,le,ge=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&ge(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=n;function s(oe){return[].concat(...oe)}e.flatten=s;function h(oe,le){let ge=typeof le=="number"?oe:0;typeof le=="number"?ge=oe:(ge=0,le=oe);const Z=[];if(ge<=le)for(let ae=ge;ae<le;ae++)Z.push(ae);else for(let ae=ge;ae>le;ae--)Z.push(ae);return Z}e.range=h;function _(oe,le,ge){return oe.reduce((Z,ae)=>(Z[le(ae)]=ge?ge(ae):ae,Z),Object.create(null))}e.index=_;function L(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=L;function M(oe,le){const ge=oe.indexOf(le);if(ge>-1)return oe.splice(ge,1),le}e.remove=M;function U(oe,le,ge){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(ge,ae)}e.arrayInsert=U;function R(oe,le){let ge;if(typeof le=="number"){let Z=le;ge=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else ge=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(ge()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=R;function z(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.unshift(le))}e.pushToStart=z;function H(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.push(le))}e.pushToEnd=H;function N(oe,le){for(const ge of le)oe.push(ge)}e.pushMany=N;function V(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=V;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function F(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=F;function x(oe,le){for(const ge of oe){const Z=le(ge);if(Z!==void 0)return Z}}e.mapFind=x;function $(oe,le,ge){const Z=K(oe,le),ae=oe.length,ne=ge.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=ge[ie]}e.insertInto=$;function Q(oe,le,ge,Z){const ae=K(oe,le),ne=oe.splice(ae,ge);return $(oe,ae,Z),ne}e.splice=Q;function K(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var de;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function ge(ae){return ae>0}oe.isGreaterThan=ge;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function ee(oe,le){return(ge,Z)=>le(oe(ge),oe(Z))}e.compareBy=ee;function he(...oe){return(le,ge)=>{for(const Z of oe){const ae=Z(le,ge);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function me(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>0&&(ge=ae)}return ge}e.findMaxBy=me;function be(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>=0&&(ge=ae)}return ge}e.findLastMaxBy=be;function ke(oe,le){return me(oe,(ge,Z)=>-le(ge,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ge=this.firstIdx;for(;ge<this.items.length&&le(this.items[ge]);)ge++;const Z=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,Z}takeFromEndWhile(le){let ge=this.lastIdx;for(;ge>=0&&le(this.items[ge]);)ge--;const Z=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const ge=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,ge}}e.ArrayQueue=Re;class ze{constructor(le){this.iterate=le}forEach(le){this.iterate(ge=>(le(ge),!0))}toArray(){const le=[];return this.iterate(ge=>(le.push(ge),!0)),le}filter(le){return new ze(ge=>this.iterate(Z=>le(Z)?ge(Z):!0))}map(le){return new ze(ge=>this.iterate(Z=>ge(le(Z))))}some(le){let ge=!1;return this.iterate(Z=>(ge=le(Z),!ge)),ge}findFirst(le){let ge;return this.iterate(Z=>le(Z)?(ge=Z,!1):!0),ge}findLast(le){let ge;return this.iterate(Z=>(le(Z)&&(ge=Z),!0)),ge}findLastMaxBy(le){let ge,Z=!0;return this.iterate(ae=>((Z||de.isGreaterThan(le(ae,ge)))&&(Z=!1,ge=ae),!0)),ge}}e.CallbackIterable=ze,ze.empty=new ze(oe=>{})}),define(De[48],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(E,D){if(!E)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function C(E,D="Unreachable"){throw new Error(D)}e.assertNever=C;function P(E){if(!E)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function y(E){if(!E()){debugger;E(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function I(E,D){let A=0;for(;A<E.length-1;){const k=E[A],w=E[A+1];if(!D(k,w))return!1;A++}return!0}e.checkAdjacentItems=I}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const C=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(C,arguments)),y}}e.once=l}),define(De[97],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[61],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function C(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=C;const P=Object.freeze([]);function y(){return P}t.empty=y;function*I(d){yield d}t.single=I;function E(d){return d||P}t.from=E;function D(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=D;function A(d){return d[Symbol.iterator]().next().value}t.first=A;function k(d,a){for(const r of d)if(a(r))return!0;return!1}t.some=k;function w(d,a){for(const r of d)if(a(r))return r}t.find=w;function*T(d,a){for(const r of d)a(r)&&(yield r)}t.filter=T;function*S(d,a){let r=0;for(const o of d)yield a(o,r++)}t.map=S;function*g(...d){for(const a of d)for(const r of a)yield r}t.concat=g;function*v(d){for(const a of d)for(const r of a)yield r}t.concatNested=v;function m(d,a,r){let o=r;for(const u of d)o=a(o,u);return o}t.reduce=m;function b(d,a){let r=0;for(const o of d)a(o,r++)}t.forEach=b;function*f(d,a,r=d.length){for(a<0&&(a+=d.length),r<0?r+=d.length:r>d.length&&(r=d.length);a<r;a++)yield d[a]}t.slice=f;function c(d,a=Number.POSITIVE_INFINITY){const r=[];if(a===0)return[r,d];const o=d[Symbol.iterator]();for(let u=0;u<a;u++){const n=o.next();if(n.done)return[r,t.empty()];r.push(n.value)}return[r,{[Symbol.iterator](){return o}}]}t.consume=c;function p(d){return c(d)[0]}t.collect=p;function i(d,a,r=(o,u)=>o===u){const o=d[Symbol.iterator](),u=a[Symbol.iterator]();for(;;){const n=o.next(),s=u.next();if(n.done!==s.done)return!1;if(n.done)return!0;if(!r(n.value,s.value))return!1}}t.equals=i})(l=e.Iterable||(e.Iterable={}))}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(i){i.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(i,d=!1){let a=0;const r=i.length;let o="",u=0,n=16,s=0;function h(H){let N=0,V=0;for(;N<H;){const B=i.charCodeAt(a);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;a++,N++}return N<H&&(V=-1),V}function _(H){a=H,o="",u=0,n=16,s=0}function L(){const H=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&D(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&D(i.charCodeAt(a)))for(a++;a<i.length&&D(i.charCodeAt(a));)a++;else return s=3,i.substring(H,a);let N=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&D(i.charCodeAt(a))){for(a++;a<i.length&&D(i.charCodeAt(a));)a++;N=a}else s=3;return i.substring(H,N)}function M(){let H="",N=a;for(;;){if(a>=r){H+=i.substring(N,a),s=2;break}const V=i.charCodeAt(a);if(V===34){H+=i.substring(N,a),a++;break}if(V===92){if(H+=i.substring(N,a),a++,a>=r){s=2;break}switch(i.charCodeAt(a++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const F=h(4);F>=0?H+=String.fromCharCode(F):s=4;break}default:s=5}N=a;continue}if(V>=0&&V<=31)if(E(V)){H+=i.substring(N,a),s=2;break}else s=6;a++}return H}function U(){if(o="",s=0,u=a,a>=r)return u=r,n=17;let H=i.charCodeAt(a);if(I(H)){do a++,o+=String.fromCharCode(H),H=i.charCodeAt(a);while(I(H));return n=15}if(E(H))return a++,o+=String.fromCharCode(H),H===13&&i.charCodeAt(a)===10&&(a++,o+=`
`),n=14;switch(H){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,o=M(),n=10;case 47:{const N=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!E(i.charCodeAt(a));)a++;return o=i.substring(N,a),n=12}if(i.charCodeAt(a+1)===42){a+=2;const V=r-1;let B=!1;for(;a<V;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,B=!0;break}a++}return B||(a++,s=1),o=i.substring(N,a),n=13}return o+=String.fromCharCode(H),a++,n=16}case 45:if(o+=String.fromCharCode(H),a++,a===r||!D(i.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),n=11;default:for(;a<r&&R(H);)a++,H=i.charCodeAt(a);if(u!==a){switch(o=i.substring(u,a),o){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return o+=String.fromCharCode(H),a++,n=16}}function R(H){if(I(H)||E(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=U();while(H>=12&&H<=15);return H}return{setPosition:_,getPosition:()=>a,scan:d?z:U,getToken:()=>n,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>s}}e.createScanner=y;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,d){const a=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function s(h,_,L,M){u.value=h,u.offset=_,u.length=L,u.type=M,u.colonOffset=void 0,o=u}try{f(i,{onObjectBegin:(h,_)=>{if(d<=h)throw r;o=void 0,n=d>h,a.push("")},onObjectProperty:(h,_,L)=>{if(d<_||(s(h,_,L,"property"),a[a.length-1]=h,d<=_+L))throw r},onObjectEnd:(h,_)=>{if(d<=h)throw r;o=void 0,a.pop()},onArrayBegin:(h,_)=>{if(d<=h)throw r;o=void 0,a.push(0)},onArrayEnd:(h,_)=>{if(d<=h)throw r;o=void 0,a.pop()},onLiteralValue:(h,_,L)=>{if(d<_||(s(h,_,L,p(h)),d<=_+L))throw r},onSeparator:(h,_,L)=>{if(d<=_)throw r;if(h===":"&&o&&o.type==="property")o.colonOffset=_,n=!1,o=void 0;else if(h===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:(n=!0,a[a.length-1]=""),o=void 0}}})}catch(h){if(h!==r)throw h}return{path:a,previousNode:o,isAtPropertyKey:n,matches:h=>{let _=0;for(let L=0;_<h.length&&L<a.length;L++)if(h[_]===a[L]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=k;function w(i,d=[],a=P.DEFAULT){let r=null,o=[];const u=[];function n(h){Array.isArray(o)?o.push(h):r!==null&&(o[r]=h)}return f(i,{onObjectBegin:()=>{const h={};n(h),u.push(o),o=h,r=null},onObjectProperty:h=>{r=h},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const h=[];n(h),u.push(o),o=h,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:n,onError:(h,_,L)=>{d.push({error:h,offset:_,length:L})}},a),o[0]}e.parse=w;function T(i,d=[],a=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(h){r.type==="property"&&(r.length=h-r.offset,r=r.parent)}function u(h){return r.children.push(h),h}f(i,{onObjectBegin:h=>{r=u({type:"object",offset:h,length:-1,parent:r,children:[]})},onObjectProperty:(h,_,L)=>{r=u({type:"property",offset:_,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:h,offset:_,length:L,parent:r})},onObjectEnd:(h,_)=>{r.length=h+_-r.offset,r=r.parent,o(h+_)},onArrayBegin:(h,_)=>{r=u({type:"array",offset:h,length:-1,parent:r,children:[]})},onArrayEnd:(h,_)=>{r.length=h+_-r.offset,r=r.parent,o(h+_)},onLiteralValue:(h,_,L)=>{u({type:p(h),offset:_,length:L,parent:r,value:h}),o(_+L)},onSeparator:(h,_,L)=>{r.type==="property"&&(h===":"?r.colonOffset=_:h===","&&o(_))},onError:(h,_,L)=>{d.push({error:h,offset:_,length:L})}},a);const s=r.children[0];return s&&delete s.parent,s}e.parseTree=T;function S(i,d){if(!i)return;let a=i;for(const r of d)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let o=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===r){a=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(a.type!=="array"||o<0||!Array.isArray(a.children)||o>=a.children.length)return;a=a.children[o]}return a}e.findNodeAtLocation=S;function g(i){if(!i.parent||!i.parent.children)return[];const d=g(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;d.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&d.push(a)}return d}e.getNodePath=g;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const d=Object.create(null);for(const a of i.children){const r=a.children[1];r&&(d[a.children[0].value]=v(r))}return d}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function m(i,d,a=!1){return d>=i.offset&&d<i.offset+i.length||a&&d===i.offset+i.length}e.contains=m;function b(i,d,a=!1){if(m(i,d,a)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=d;o++){const u=b(r[o],d,a);if(u)return u}return i}}e.findNodeAtOffset=b;function f(i,d,a=P.DEFAULT){const r=y(i,!1);function o(ee){return ee?()=>ee(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(ee){return ee?he=>ee(he,r.getTokenOffset(),r.getTokenLength()):()=>!0}const n=o(d.onObjectBegin),s=u(d.onObjectProperty),h=o(d.onObjectEnd),_=o(d.onArrayBegin),L=o(d.onArrayEnd),M=u(d.onLiteralValue),U=u(d.onSeparator),R=o(d.onComment),z=u(d.onError),H=a&&a.disallowComments,N=a&&a.allowTrailingComma;function V(){for(;;){const ee=r.scan();switch(r.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:H||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ee){case 12:case 13:H?B(10):R();break;case 16:B(1);break;case 15:case 14:break;default:return ee}}}function B(ee,he=[],Y=[]){if(z(ee),he.length+Y.length>0){let me=r.getToken();for(;me!==17;){if(he.indexOf(me)!==-1){V();break}else if(Y.indexOf(me)!==-1)break;me=V()}}}function F(ee){const he=r.getTokenValue();return ee?M(he):s(he),V(),!0}function x(){switch(r.getToken()){case 11:{let ee=0;try{ee=JSON.parse(r.getTokenValue()),typeof ee!="number"&&(B(2),ee=0)}catch{B(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return V(),!0}function $(){return r.getToken()!==10?(B(3,[],[2,5]),!1):(F(!1),r.getToken()===6?(U(":"),V(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){n(),V();let ee=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ee||B(4,[],[]),U(","),V(),r.getToken()===2&&N)break}else ee&&B(6,[],[]);$()||B(4,[],[2,5]),ee=!0}return h(),r.getToken()!==2?B(7,[2],[]):V(),!0}function K(){_(),V();let ee=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ee||B(4,[],[]),U(","),V(),r.getToken()===4&&N)break}else ee&&B(6,[],[]);de()||B(4,[],[4,5]),ee=!0}return L(),r.getToken()!==4?B(8,[4],[]):V(),!0}function de(){switch(r.getToken()){case 3:return K();case 1:return Q();case 10:return F(!0);default:return x()}}return V(),r.getToken()===17?a.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(r.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=f;function c(i,d){const a=y(i),r=[];let o,u=0,n;do switch(n=a.getPosition(),o=a.scan(),o){case 12:case 13:case 17:u!==n&&r.push(i.substring(u,n)),d!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,d)),u=a.getPosition();break}while(o!==17);return r.join("")}e.stripComments=c;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(De[78],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new l(()=>C(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,60,61]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let P=null;function y(u){P=u}if(e.setDisposableTracker=y,C){const u="__is_disposable_tracked__";y(new class{trackDisposable(n){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[u]||console.log(s)},3e3)}setParent(n,s){if(n&&n!==b.None)try{n[u]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[u]=!0}catch{}}markAsSingleton(n){}})}function I(u){return P?.trackDisposable(u),u}function E(u){P?.markAsDisposed(u)}function D(u,n){P?.setParent(u,n)}function A(u,n){if(!!P)for(const s of u)P.setParent(s,n)}function k(u){return P?.markAsSingleton(u),u}e.markAsSingleton=k;function w(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=w;function T(u){if(t.Iterable.is(u)){const n=[];for(const s of u)if(s)try{s.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=T;function S(u){for(const n of u)w(n)&&n.dispose();return[]}e.disposeIfDisposable=S;function g(...u){const n=v(()=>T(u));return A(u,n),n}e.combinedDisposable=g;function v(u){const n=I({dispose:(0,l.once)(()=>{E(n),u()})});return n}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{T(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new m,I(this),D(this._store,this)}dispose(){E(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&D(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&D(n,null),n}}e.MutableDisposable=f;class c{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(n){let s=n;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,E(this))},this}}e.SafeDisposable=p;class i{constructor(){this.references=new Map}acquire(n,...s){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...s)},this.references.set(n,h));const{object:_}=h,L=(0,l.once)(()=>{--h.counter===0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:_,dispose:L}}}e.ReferenceCollection=i;class d{constructor(n){this.referenceCollection=n}async acquire(n,...s){const h=this.referenceCollection.acquire(n,...s);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(_){throw h.dispose(),_}}}e.AsyncReferenceCollection=d;class a{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=a;function r(u){const n=new m;try{u(n)}finally{n.dispose()}}e.disposeOnReturn=r;class o{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{T(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,s,h=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this._store.get(n)?.dispose(),this._store.set(n,s)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=o}),define(De[62],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const y=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=y}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const I=new l(P);if(this._first===l.Undefined)this._first=I,this._last=I;else if(y){const D=this._last;this._last=I,I.prev=D,D.next=I}else{const D=this._first;this._first=I,I.next=D,D.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[144],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var ge=0;ge<le.length;ge++){var Z=le[ge];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,ge){return le&&e(oe.prototype,le),ge&&e(oe,ge),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return C(oe,le);var ge=Object.prototype.toString.call(oe).slice(8,-1);if(ge==="Object"&&oe.constructor&&(ge=oe.constructor.name),ge==="Map"||ge==="Set")return Array.from(oe);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return C(oe,le)}}function C(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ge=0,Z=new Array(le);ge<le;ge++)Z[ge]=oe[ge];return Z}function P(oe,le){var ge=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ge)return(ge=ge.call(oe)).next.bind(ge);if(Array.isArray(oe)||(ge=t(oe))||le&&oe&&typeof oe.length=="number"){ge&&(oe=ge);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function I(oe){J.defaults=oe}var E=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return w[le]};function S(oe,le){if(le){if(E.test(oe))return oe.replace(D,T)}else if(A.test(oe))return oe.replace(k,T);return oe}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(oe){return oe.replace(g,function(le,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var m=/(^|[^\[])\^/g;function b(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ge={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(m,"$1"),oe=oe.replace(ae,ne),ge},getRegex:function(){return new RegExp(oe,le)}};return ge}var f=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(oe,le,ge){if(oe){var Z;try{Z=decodeURIComponent(v(ge)).replace(f,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!c.test(ge)&&(ge=o(le,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},d=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(oe,le){i[" "+oe]||(d.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=h(oe,"/",!0)),oe=i[" "+oe];var ge=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ge?le:oe.replace(a,"$1")+le:le.charAt(0)==="/"?ge?le:oe.replace(r,"$1")+le:oe+le}var u={exec:function(){}};function n(oe){for(var le=1,ge,Z;le<arguments.length;le++){ge=arguments[le];for(Z in ge)Object.prototype.hasOwnProperty.call(ge,Z)&&(oe[Z]=ge[Z])}return oe}function s(oe,le){var ge=oe.replace(/\|/g,function(ne,ie,O){for(var j=!1,G=ie;--G>=0&&O[G]==="\\";)j=!j;return j?"|":" |"}),Z=ge.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function h(oe,le,ge){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!ge)ae++;else if(ne!==le&&ge)ae++;else break}return oe.slice(0,Z-ae)}function _(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ge=oe.length,Z=0,ae=0;ae<ge;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function L(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var ge="";le>1;)le&1&&(ge+=oe),le>>=1,oe+=oe;return ge+oe}function U(oe,le,ge,Z){var ae=le.href,ne=le.title?S(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var O={type:"link",raw:ge,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,O}return{type:"image",raw:ge,href:ae,title:ne,text:S(ie)}}function R(oe,le){var ge=oe.match(/^(\s+)(?:```)/);if(ge===null)return le;var Z=ge[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:h(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=R(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=h(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe=ae[1].trim(),Ze=qe.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(We=!1,!(!(ae=Ne.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(j=2,ye=we.trimLeft()):(j=ae[2].search(/[^ ]/),j=j>4?1:j,ye=we.slice(j),j+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),We=!0),!We)for(var at=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||at.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=j||!we.trim())ye+=`
`+we.slice(j);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}Ye.loose||(pe?Ye.loose=!0:/\n *\n *$/.test(ne)&&(pe=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(O=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ie,checked:O,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Ve=Ye.items.length;for(G=0;G<Ve;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var fe=Ye.items[G].tokens.filter(function(Le){return Le.type==="space"}),Ae=fe.every(function(Le){for(var Me=Le.raw.split(""),Ke=0,Je=P(Me),st;!(st=Je()).done;){var ot=st.value;if(ot===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&fe.length&&Ae&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:s(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,O,j,G,X;for(O=0;O<ie;O++)/^ *-+: *$/.test(ne.align[O])?ne.align[O]="right":/^ *:-+: *$/.test(ne.align[O])?ne.align[O]="center":/^ *:-+ *$/.test(ne.align[O])?ne.align[O]="left":ne.align[O]=null;for(ie=ne.rows.length,O=0;O<ie;O++)ne.rows[O]=s(ne.rows[O],ne.header.length).map(function(pe){return{text:pe}});for(ie=ne.header.length,j=0;j<ie;j++)ne.header[j].tokens=this.lexer.inline(ne.header[j].text);for(ie=ne.rows.length,j=0;j<ie;j++)for(X=ne.rows[j],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:S(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):S(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=h(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var O=_(ae[2],"()");if(O>-1){var j=ae[0].indexOf("!")===0?5:4,G=j+ae[1].length+O;ae[2]=ae[2].substring(0,O),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],pe="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],pe=we[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),U(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var O=ne[0].charAt(0);return{type:"text",raw:O,text:O}}return U(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ie[1]||ie[2]||"";if(!O||O&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=ie[0].length-1,G,X,pe=j,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+j);(ie=ce.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){pe+=X;continue}else if((ie[5]||ie[6])&&j%3&&!((j+X)%3)){we+=X;continue}if(pe-=X,!(pe>0)){if(X=Math.min(X,X+pe+we),Math.min(j,X)%2){var Ce=Z.slice(1,j+ie.index+X);return{type:"em",raw:Z.slice(0,j+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,j+ie.index+X-1);return{type:"strong",raw:Z.slice(0,j+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),O=/^ /.test(ne)&&/ $/.test(ne);return ie&&O&&(ne=ne.substring(1,ne.length-1)),ne=S(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,O;return ne[2]==="@"?(ie=S(this.options.mangle?ae(ne[1]):ne[1]),O="mailto:"+ie):(ie=S(ne[1]),O=ie),{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,O;if(ne[2]==="@")ie=S(this.options.mangle?ae(ne[0]):ne[0]),O="mailto:"+ie;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);ie=S(ne[0]),ne[1]==="www."?O="http://"+ie:O=ie}return{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):S(ne[0]):ne[0]:ie=S(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=b(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=b(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=b(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=b(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=b(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=b(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=n({},H),H.gfm=n({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=b(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.gfm.paragraph=b(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",H.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=n({},H.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:b(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=b(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=b(H._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=b(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=b(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=b(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=b(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=b(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=b(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=b(N.reflink).replace("label",N._label).replace("ref",H._label).getRegex(),N.nolink=b(N.nolink).replace("ref",H._label).getRegex(),N.reflinkSearch=b(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:b(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=b(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:b(N.br).replace("{2,}","*").getRegex(),text:b(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var le="",ge,Z,ae=oe.length;for(ge=0;ge<ae;ge++)Z=oe.charCodeAt(ge),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var F=function(){function oe(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:H.normal,inline:N.normal};this.options.pedantic?(Z.block=H.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=H.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(pe,we,ce){return we+"    ".repeat(ce.length)});for(var ie,O,j,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ie=pe.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(pe=Math.min(pe,ce))}),pe<1/0&&pe>=0&&(j=Z.substring(0,pe+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(j))){O=ae[ae.length-1],G&&O.type==="paragraph"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie),G=j.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,O,j,G=Z,X,pe,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(pe||(we=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,B)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,B))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,We=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},We),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(j=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(j,V)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),pe=!0,O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:H,inline:N}}}]),oe}(),x=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(Z,ie);O!=null&&O!==Z&&(ne=!0,Z=O)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+S(ie,!0)+'">'+(ne?Z:S(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:S(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var O=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+O+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",O=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+O+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=p(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+S(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=p(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),$=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),Q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),K=function(){function oe(ge){this.options=ge||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new Q}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve=Z.length;for(ie=0;ie<Ve;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,v(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",G=ye.header.length,O=0;O<G;O++)we+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(we),Ce="",G=ye.rows.length,O=0;O<G;O++){for(pe=ye.rows[O],we="",X=pe.length,j=0;j<X;j++)we+=this.renderer.tablecell(this.parseInline(pe[j].tokens),{header:!1,align:ye.align[j]});Ce+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(We=ye.ordered,qe=ye.start,Ze=ye.loose,G=ye.items.length,Ce="",O=0;O<G;O++)Ne=ye.items[O],at=Ne.checked,re=Ne.task,Ye="",Ne.task&&(se=this.renderer.checkbox(at),Ze?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=se+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=se+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Ne.tokens,Ze),Ce+=this.renderer.listitem(Ye,re,at);ne+=this.renderer.list(Ce,We,qe);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<Ve&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var fe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,O,j,G=Z.length;for(ie=0;ie<G;ie++){if(O=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(j=this.options.extensions.renderers[O.type].call({parser:this},O),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ne+=j||"";continue}switch(O.type){case"escape":{ne+=ae.text(O.text);break}case"html":{ne+=ae.html(O.text);break}case"link":{ne+=ae.link(O.href,O.title,this.parseInline(O.tokens,ae));break}case"image":{ne+=ae.image(O.href,O.title,O.text);break}case"strong":{ne+=ae.strong(this.parseInline(O.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(O.tokens,ae));break}case"codespan":{ne+=ae.codespan(O.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(O.tokens,ae));break}case"text":{ne+=ae.text(O.text);break}default:{var X='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},oe}();function de(oe,le,ge){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ge=le,le=null),le=n({},de.defaults,le||{}),L(le),ge){var Z=le.highlight,ae;try{ae=F.lex(oe,le)}catch(G){return ge(G)}var ne=function(X){var pe;if(!X)try{le.walkTokens&&de.walkTokens(ae,le.walkTokens),pe=K.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?ge(X):ge(null,pe)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;de.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,pe){if(X)return ne(X);pe!=null&&pe!==G.text&&(G.text=pe,G.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function O(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}try{var j=F.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(de.walkTokens(j,le.walkTokens)).then(function(){return K.parse(j,le)}).catch(O);de.walkTokens(j,le.walkTokens)}return K.parse(j,le)}catch(G){O(G)}}de.options=de.setOptions=function(oe){return n(de.defaults,oe),I(de.defaults),de},de.getDefaults=y,de.defaults=J.defaults,de.use=function(){for(var oe=arguments.length,le=new Array(oe),ge=0;ge<oe;ge++)le[ge]=arguments[ge];var Z=n.apply(void 0,[{}].concat(le)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var G=ae.renderers?ae.renderers[j.name]:null;G?ae.renderers[j.name]=function(){for(var X=arguments.length,pe=new Array(X),we=0;we<X;we++)pe[we]=arguments[we];var ce=j.renderer.apply(this,pe);return ce===!1&&(ce=G.apply(this,pe)),ce}:ae.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[j.level]?ae[j.level].unshift(j.tokenizer):ae[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ae.startBlock?ae.startBlock.push(j.start):ae.startBlock=[j.start]:j.level==="inline"&&(ae.startInline?ae.startInline.push(j.start):ae.startInline=[j.start]))}j.childTokens&&(ae.childTokens[j.name]=j.childTokens)})),ie.renderer&&function(){var j=de.defaults.renderer||new x,G=function(we){var ce=j[we];j[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.renderer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.renderer)G(X);Z.renderer=j}(),ie.tokenizer&&function(){var j=de.defaults.tokenizer||new z,G=function(we){var ce=j[we];j[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.tokenizer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.tokenizer)G(X);Z.tokenizer=j}(),ie.walkTokens){var O=de.defaults.walkTokens;Z.walkTokens=function(j){var G=[];return G.push(ie.walkTokens.call(this,j)),O&&(G=G.concat(O.call(this,j))),G}}ne&&(Z.extensions=ae),de.setOptions(Z)})},de.walkTokens=function(oe,le){for(var ge=[],Z=function(){var O=ne.value;switch(ge=ge.concat(le.call(de,O)),O.type){case"table":{for(var j=P(O.header),G;!(G=j()).done;){var X=G.value;ge=ge.concat(de.walkTokens(X.tokens,le))}for(var pe=P(O.rows),we;!(we=pe()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var We=ye.value;ge=ge.concat(de.walkTokens(We.tokens,le))}break}case"list":{ge=ge.concat(de.walkTokens(O.items,le));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[O.type]?de.defaults.extensions.childTokens[O.type].forEach(function(qe){ge=ge.concat(de.walkTokens(O[qe],le))}):O.tokens&&(ge=ge.concat(de.walkTokens(O.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return ge},de.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=n({},de.defaults,le||{}),L(le);try{var ge=F.lexInline(oe,le);return le.walkTokens&&de.walkTokens(ge,le.walkTokens),K.parseInline(ge,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+S(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=K,de.parser=K.parse,de.Renderer=x,de.TextRenderer=$,de.Lexer=F,de.lexer=F.lex,de.Tokenizer=z,de.Slugger=Q,de.parse=de;var ee=de.options,he=de.setOptions,Y=de.use,me=de.walkTokens,be=de.parseInline,ke=de,Re=K.parse,ze=F.lex;J.Lexer=F,J.Parser=K,J.Renderer=x,J.Slugger=Q,J.TextRenderer=$,J.Tokenizer=z,J.getDefaults=y,J.lexer=ze,J.marked=de,J.options=ee,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=he,J.use=Y,J.walkTokens=me,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[98],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(I,E,D){return Math.min(Math.max(I,E),D)}e.clamp=l;function t(I,E){return(E+I%E)%E}e.rot=t;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class P{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const D=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function J(C){const P=[];typeof C=="number"&&P.push("code/timeOrigin",C);function y(E){P.push(E,Date.now())}function I(){const E=[];for(let D=0;D<P.length;D+=2)E.push({name:P[D],startTime:P[D+1]});return E}return{mark:y,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(C+y.startTime)});return P}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return J[t].call(C.exports,C,C.exports,l),C.l=!0,C.exports}return l.m=J,l.c=e,l.d=function(t,C,P){l.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,C){if(1&C&&(t=l(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var y in t)l.d(P,y,function(I){return t[I]}.bind(null,y));return P},l.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(C,"a",C),C},l.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var C;e=J.exports=Y,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],D=0,A=D++;E[A]="0|[1-9]\\d*";var k=D++;E[k]="[0-9]+";var w=D++;E[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=D++;E[T]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var S=D++;E[S]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var g=D++;E[g]="(?:"+E[A]+"|"+E[w]+")";var v=D++;E[v]="(?:"+E[k]+"|"+E[w]+")";var m=D++;E[m]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var b=D++;E[b]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var f=D++;E[f]="[0-9A-Za-z-]+";var c=D++;E[c]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var p=D++,i="v?"+E[T]+E[m]+"?"+E[c]+"?";E[p]="^"+i+"$";var d="[v=\\s]*"+E[S]+E[b]+"?"+E[c]+"?",a=D++;E[a]="^"+d+"$";var r=D++;E[r]="((?:<|>)?=?)";var o=D++;E[o]=E[k]+"|x|X|\\*";var u=D++;E[u]=E[A]+"|x|X|\\*";var n=D++;E[n]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[m]+")?"+E[c]+"?)?)?";var s=D++;E[s]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[b]+")?"+E[c]+"?)?)?";var h=D++;E[h]="^"+E[r]+"\\s*"+E[n]+"$";var _=D++;E[_]="^"+E[r]+"\\s*"+E[s]+"$";var L=D++;E[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;E[M]="(?:~>?)";var U=D++;E[U]="(\\s*)"+E[M]+"\\s+",I[U]=new RegExp(E[U],"g");var R=D++;E[R]="^"+E[M]+E[n]+"$";var z=D++;E[z]="^"+E[M]+E[s]+"$";var H=D++;E[H]="(?:\\^)";var N=D++;E[N]="(\\s*)"+E[H]+"\\s+",I[N]=new RegExp(E[N],"g");var V=D++;E[V]="^"+E[H]+E[n]+"$";var B=D++;E[B]="^"+E[H]+E[s]+"$";var F=D++;E[F]="^"+E[r]+"\\s*("+d+")$|^$";var x=D++;E[x]="^"+E[r]+"\\s*("+i+")$|^$";var $=D++;E[$]="(\\s*)"+E[r]+"\\s*("+d+"|"+E[n]+")",I[$]=new RegExp(E[$],"g");var Q=D++;E[Q]="^\\s*("+E[n]+")\\s+-\\s+("+E[n]+")\\s*$";var K=D++;E[K]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var de=D++;E[de]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)C(ee,E[ee]),I[ee]||(I[ee]=new RegExp(E[ee]));function he(ce,Ce){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?I[a]:I[p]).test(ce))return null;try{return new Y(ce,Ce)}catch{return null}}function Y(ce,Ce){if(ce instanceof Y){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ce);C("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?I[a]:I[p]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var qe=+We;if(qe>=0&&qe<y)return qe}return We}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=he,e.valid=function(ce,Ce){var ye=he(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=he(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return C("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],We=ce.prerelease[Ce];if(C("prerelease compare",Ce,ye,We),ye===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ye===void 0)return-1;if(ye!==We)return be(ye,We)}while(++Ce)},Y.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,We){typeof ye=="string"&&(We=ye,ye=void 0);try{return new Y(ce,ye).inc(Ce,We).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=he(ce),We=he(Ce);if(ye.prerelease.length||We.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return qe},e.compareIdentifiers=be;var me=/^[0-9]+$/;function be(ce,Ce){var ye=me.test(ce),We=me.test(Ce);return ye&&We&&(ce=+ce,Ce=+Ce),ye&&!We?-1:We&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function ke(ce,Ce,ye){return new Y(ce,ye).compare(new Y(Ce,ye))}function Re(ce,Ce,ye){return ke(ce,Ce,ye)>0}function ze(ce,Ce,ye){return ke(ce,Ce,ye)<0}function oe(ce,Ce,ye){return ke(ce,Ce,ye)===0}function le(ce,Ce,ye){return ke(ce,Ce,ye)!==0}function ge(ce,Ce,ye){return ke(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return ke(ce,Ce,ye)<=0}function ae(ce,Ce,ye,We){var qe;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=oe(ce,ye,We);break;case"!=":qe=le(ce,ye,We);break;case">":qe=Re(ce,ye,We);break;case">=":qe=ge(ce,ye,We);break;case"<":qe=ze(ce,ye,We);break;case"<=":qe=Z(ce,ye,We);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ce);C("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new Y(ce,Ce).major},e.minor=function(ce,Ce){return new Y(ce,Ce).minor},e.patch=function(ce,Ce){return new Y(ce,Ce).patch},e.compare=ke,e.compareLoose=function(ce,Ce){return ke(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return ke(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,We){return e.compare(ye,We,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,We){return e.rcompare(ye,We,Ce)})},e.gt=Re,e.lt=ze,e.eq=oe,e.neq=le,e.gte=ge,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function O(ce,Ce){if(ce instanceof O)return ce.loose===Ce?ce:new O(ce.raw,Ce);if(ce instanceof ne)return new O(ce.value,Ce);if(!(this instanceof O))return new O(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function j(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function G(ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve){return((Ce=j(ye)?"":j(We)?">="+ye+".0.0":j(qe)?">="+ye+"."+We+".0":">="+Ce)+" "+(Ne=j(at)?"":j(re)?"<"+(+at+1)+".0.0":j(se)?"<"+at+"."+(+re+1)+".0":Ee?"<="+at+"."+re+"."+se+"-"+Ee:"<="+Ne)).trim()}function X(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(C(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var We=ce[ye].semver;if(We.major===Ce.major&&We.minor===Ce.minor&&We.patch===Ce.patch)return!0}return!1}return!0}function pe(ce,Ce,ye){try{Ce=new O(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,We){var qe,Ze,Ye,Ne,at;switch(ce=new Y(ce,We),Ce=new O(Ce,We),ye){case">":qe=Re,Ze=Z,Ye=ze,Ne=">",at=">=";break;case"<":qe=ze,Ze=ge,Ye=Re,Ne="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ce,Ce,We))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,Ve=null;if(se.forEach(function(fe){fe.semver===ie&&(fe=new ne(">=0.0.0")),Ee=Ee||fe,Ve=Ve||fe,qe(fe.semver,Ee.semver,We)?Ee=fe:Ye(fe.semver,Ve.semver,We)&&(Ve=fe)}),Ee.operator===Ne||Ee.operator===at||(!Ve.operator||Ve.operator===Ne)&&Ze(ce,Ve.semver)||Ve.operator===at&&Ye(ce,Ve.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ce=this.loose?I[F]:I[x],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return C("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ce){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,Ce),pe(this.value,ye,Ce);if(ce.operator==="")return ye=new O(this.value,Ce),pe(ce.semver,ye,Ce);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ne=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),at=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||qe||Ze&&Ye||Ne||at},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),C("range",ce,Ce);var ye=Ce?I[K]:I[Q];ce=ce.replace(ye,G),C("hyphen replace",ce),ce=ce.replace(I[$],"$1$2$3"),C("comparator trim",ce,I[$]),ce=(ce=(ce=ce.replace(I[U],"$1~")).replace(I[N],"$1^")).split(/\s+/).join(" ");var We=Ce?I[F]:I[x],qe=ce.split(" ").map(function(Ze){return function(Ye,Ne){return C("comp",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){C("caret",Ee,Ve);var fe=Ve?I[B]:I[V];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return C("caret",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=Le==="0"?">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+".0 <"+(+Le+1)+".0.0":Je?(C("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+Je+" <"+(+Le+1)+".0.0"):(C("no pr"),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+" <"+(+Le+1)+".0.0"),C("caret return",st),st})}(se,re)}).join(" ")}(Ye,Ne),C("caret",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){var fe=Ve?I[z]:I[R];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return C("tilde",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":Je?(C("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0"):st=">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0",C("tilde return",st),st})}(se,re)}).join(" ")}(Ye,Ne),C("tildes",Ye),Ye=function(at,re){return C("replaceXRanges",at,re),at.split(/\s+/).map(function(se){return function(Ee,Ve){Ee=Ee.trim();var fe=Ve?I[_]:I[h];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je,st){C("xRange",Ee,Ae,Le,Me,Ke,Je,st);var ot=j(Me),it=ot||j(Ke),lt=it||j(Je);return Le==="="&&lt&&(Le=""),ot?Ae=Le===">"||Le==="<"?"<0.0.0":"*":Le&&lt?(it&&(Ke=0),lt&&(Je=0),Le===">"?(Le=">=",it?(Me=+Me+1,Ke=0,Je=0):lt&&(Ke=+Ke+1,Je=0)):Le==="<="&&(Le="<",it?Me=+Me+1:Ke=+Ke+1),Ae=Le+Me+"."+Ke+"."+Je):it?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":lt&&(Ae=">="+Me+"."+Ke+".0 <"+Me+"."+(+Ke+1)+".0"),C("xRange return",Ae),Ae})}(se,re)}).join(" ")}(Ye,Ne),C("xrange",Ye),Ye=function(at,re){return C("replaceStars",at,re),at.trim().replace(I[de],"")}(Ye,Ne),C("stars",Ye),Ye}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(We)})),qe=qe.map(function(Ze){return new ne(Ze,Ce)})},O.prototype.intersects=function(ce,Ce){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(We){return ce.set.some(function(qe){return qe.every(function(Ze){return We.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new O(ce,Ce).set.map(function(ye){return ye.map(function(We){return We.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],ce))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==-1||(qe=new Y(We=Ye,ye)))}),We},e.minSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==1||(qe=new Y(We=Ye,ye)))}),We},e.validRange=function(ce,Ce){try{return new O(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=he(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new O(ce,ye),Ce=new O(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ce=ce.match(I[L]);return Ce==null?null:he((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,C=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function I(v){if(l===setTimeout)return setTimeout(v,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(v,0);try{return l(v,0)}catch{try{return l.call(null,v,0)}catch{return l.call(this,v,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var E,D=[],A=!1,k=-1;function w(){A&&E&&(A=!1,E.length?D=E.concat(D):k=-1,D.length&&T())}function T(){if(!A){var v=I(w);A=!0;for(var m=D.length;m;){for(E=D,D=[];++k<m;)E&&E[k].run();k=-1,m=D.length}E=null,A=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(v)}}function S(v,m){this.fun=v,this.array=m}function g(){}C.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)m[b-1]=arguments[b];D.push(new S(v,m)),D.length!==1||A||I(T)},S.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(v){return[]},C.binding=function(v){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(v){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(De[99],Ie([1,0,11,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(c){const p=c;return p?typeof p.read=="function":!1}e.isReadable=C;function P(c){const p=c;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=P;function y(c){const p=c;return p?P(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=y;function I(c,p){return new E(c,p)}e.newWriteableStream=I;class E{constructor(p,i){this.reducer=p,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(i=>i(p))}emitError(p){this.listeners.error.length===0?(0,l.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(i=>i(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,i){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(p,i){if(this.state.destroyed)return;let d;switch(p){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const a=d.indexOf(i);a>=0&&d.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(c,p){const i=[];let d;for(;(d=c.read())!==null;)i.push(d);return p(i)}e.consumeReadable=D;function A(c,p,i){const d=[];let a;for(;(a=c.read())!==null&&d.length<i;)d.push(a);return a===null&&d.length>0?p(d):{read:()=>{if(d.length>0)return d.shift();if(typeof a<"u"){const r=a;return a=void 0,r}return c.read()}}}e.peekReadable=A;function k(c,p){return new Promise((i,d)=>{const a=[];w(c,{onData:r=>{p&&a.push(r)},onError:r=>{p?d(r):i(void 0)},onEnd:()=>{i(p?p(a):void 0)}})})}e.consumeStream=k;function w(c,p){let i=!1;return c.on("error",d=>{i||p.onError(d)}),c.on("end",()=>{i||p.onEnd()}),c.on("data",d=>{i||p.onData(d)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=w;function T(c,p){return new Promise((i,d)=>{const a=new t.DisposableStore,r=[],o=s=>{if(r.push(s),r.length>p)return a.dispose(),c.pause(),i({stream:c,buffer:r,ended:!1})},u=s=>d(s),n=()=>i({stream:c,buffer:r,ended:!0});a.add((0,t.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),a.add((0,t.toDisposable)(()=>c.removeListener("end",n))),c.on("end",n),a.add((0,t.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=T;function S(c,p){const i=I(p);return i.end(c),i}e.toStream=S;function g(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=g;function v(c){let p=!1;return{read:()=>p?null:(p=!0,c)}}e.toReadable=v;function m(c,p,i){const d=I(i);return w(c,{onData:a=>d.write(p.data(a)),onError:a=>d.error(p.error?p.error(a):a),onEnd:()=>d.end()}),d}e.transform=m;function b(c,p,i){let d=!1;return{read:()=>{const a=p.read();return d?a:(d=!0,a!==null?i([c,a]):c)}}}e.prefixedReadable=b;function f(c,p,i){let d=!1;const a=I(i);return w(p,{onData:r=>d?a.write(r):(d=!0,a.write(i([c,r]))),onError:r=>a.error(r),onEnd:()=>{d||(d=!0,a.write(c)),a.end()}}),a}e.prefixedStream=f}),define(De[23],Ie([1,0,99]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,P;class y{static alloc(s){return t?new y(Buffer.allocUnsafe(s)):new y(new Uint8Array(s))}static wrap(s){return t&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new y(s)}static fromString(s,h){return!(h?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(s)):(C||(C=new TextEncoder),new y(C.encode(s)))}static fromByteArray(s){const h=y.alloc(s.length);for(let _=0,L=s.length;_<L;_++)h.buffer[_]=s[_];return h}static concat(s,h){if(typeof h>"u"){h=0;for(let M=0,U=s.length;M<U;M++)h+=s[M].byteLength}const _=y.alloc(h);let L=0;for(let M=0,U=s.length;M<U;M++){const R=s[M];_.set(R,L),L+=R.byteLength}return _}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=y.alloc(this.byteLength);return s.set(this),s}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(s,h){return new y(this.buffer.subarray(s,h))}set(s,h){if(s instanceof y)this.buffer.set(s.buffer,h);else if(s instanceof Uint8Array)this.buffer.set(s,h);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),h);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return D(this.buffer,s)}writeUInt32BE(s,h){A(this.buffer,s,h)}readUInt32LE(s){return k(this.buffer,s)}writeUInt32LE(s,h){w(this.buffer,s,h)}readUInt8(s){return T(this.buffer,s)}writeUInt8(s,h){S(this.buffer,s,h)}}e.VSBuffer=y;function I(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=I;function E(n,s,h){n[h+0]=s&255,s=s>>>8,n[h+1]=s&255}e.writeUInt16LE=E;function D(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=D;function A(n,s,h){n[h+3]=s,s=s>>>8,n[h+2]=s,s=s>>>8,n[h+1]=s,s=s>>>8,n[h]=s}e.writeUInt32BE=A;function k(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=k;function w(n,s,h){n[h+0]=s&255,s=s>>>8,n[h+1]=s&255,s=s>>>8,n[h+2]=s&255,s=s>>>8,n[h+3]=s&255}e.writeUInt32LE=w;function T(n,s){return n[s]}e.readUInt8=T;function S(n,s,h){n[h]=s}e.writeUInt8=S;function g(n){return l.consumeReadable(n,s=>y.concat(s))}e.readableToBuffer=g;function v(n){return l.toReadable(n)}e.bufferToReadable=v;function m(n){return l.consumeStream(n,s=>y.concat(s))}e.streamToBuffer=m;async function b(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=b;function f(n){return l.toStream(n,s=>y.concat(s))}e.bufferToStream=f;function c(n){return l.transform(n,{data:s=>typeof s=="string"?y.fromString(s):y.wrap(s)},s=>y.concat(s))}e.streamToBufferReadableStream=c;function p(n){return l.newWriteableStream(s=>y.concat(s),n)}e.newWriteableBufferStream=p;function i(n,s){return l.prefixedReadable(n,s,h=>y.concat(h))}e.prefixedBufferReadable=i;function d(n,s){return l.prefixedStream(n,s,h=>y.concat(h))}e.prefixedBufferStream=d;function a(n){let s=0,h=0,_=0;const L=new Uint8Array(Math.floor(n.length/4*3)),M=R=>{switch(h){case 3:L[_++]=s|R,h=0;break;case 2:L[_++]=s|R>>>2,s=R<<6,h=3;break;case 1:L[_++]=s|R>>>4,s=R<<4,h=2;break;default:s=R<<2,h=1}};for(let R=0;R<n.length;R++){const z=n.charCodeAt(R);if(z>=65&&z<=90)M(z-65);else if(z>=97&&z<=122)M(z-97+26);else if(z>=48&&z<=57)M(z-48+52);else if(z===43||z===45)M(62);else if(z===47||z===95)M(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${n[R]}`)}}const U=_;for(;h>0;)M(0);return y.wrap(L).slice(0,U)}e.decodeBase64=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},s=!0,h=!1){const _=h?o:r;let L="";const M=n.byteLength%3;let U=0;for(;U<n.byteLength-M;U+=3){const R=n[U+0],z=n[U+1],H=n[U+2];L+=_[R>>>2],L+=_[(R<<4|z>>>4)&63],L+=_[(z<<2|H>>>6)&63],L+=_[H&63]}if(M===1){const R=n[U+0];L+=_[R>>>2],L+=_[R<<4&63],s&&(L+="==")}else if(M===2){const R=n[U+0],z=n[U+1];L+=_[R>>>2],L+=_[(R<<4|z>>>4)&63],L+=_[z<<2&63],s&&(L+="=")}return L}e.encodeBase64=u}),define(De[12],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(d){return typeof d=="string"}e.isString=l;function t(d){return Array.isArray(d)&&d.every(a=>l(a))}e.isStringArray=t;function C(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=C;function P(d){const a=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof a}e.isTypedArray=P;function y(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=y;function I(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=I;function E(d){return d===!0||d===!1}e.isBoolean=E;function D(d){return typeof d>"u"}e.isUndefined=D;function A(d){return!k(d)}e.isDefined=A;function k(d){return D(d)||d===null}e.isUndefinedOrNull=k;function w(d,a){if(!d)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=w;function T(d){if(k(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=T;function S(...d){const a=[];for(let r=0;r<d.length;r++){const o=d[r];if(k(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);a.push(o)}return a}e.assertAllDefined=S;const g=Object.prototype.hasOwnProperty;function v(d){if(!C(d))return!1;for(const a in d)if(g.call(d,a))return!1;return!0}e.isEmptyObject=v;function m(d){return typeof d=="function"}e.isFunction=m;function b(...d){return d.length>0&&d.every(m)}e.areFunctions=b;function f(d,a){const r=Math.min(d.length,a.length);for(let o=0;o<r;o++)c(d[o],a[o])}e.validateConstraints=f;function c(d,a){if(l(a)){if(typeof d!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(m(a)){try{if(d instanceof a)return}catch{}if(!k(d)&&d.constructor===a||a.length===1&&a.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function p(d){return d===null?void 0:d}e.withNullAsUndefined=p;function i(d){return typeof d>"u"?null:d}e.withUndefinedAsNull=i}),define(De[24],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.keys(m).forEach(f=>{m[f]&&typeof m[f]=="object"?b[f]=t(m[f]):b[f]=m[f]}),b}e.deepClone=t;function C(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const f=b.shift();Object.freeze(f);for(const c in f)if(P.call(f,c)){const p=f[c];typeof p=="object"&&!Object.isFrozen(p)&&!(0,l.isTypedArray)(p)&&b.push(p)}}return m}e.deepFreeze=C;const P=Object.prototype.hasOwnProperty;function y(m,b){return I(m,b,new Set)}e.cloneAndChange=y;function I(m,b,f){if((0,l.isUndefinedOrNull)(m))return m;const c=b(m);if(typeof c<"u")return c;if(Array.isArray(m)){const p=[];for(const i of m)p.push(I(i,b,f));return p}if((0,l.isObject)(m)){if(f.has(m))throw new Error("Cannot clone recursive data-structure");f.add(m);const p={};for(const i in m)P.call(m,i)&&(p[i]=I(m[i],b,f));return f.delete(m),p}return m}function E(m,b,f=!0){return(0,l.isObject)(m)?((0,l.isObject)(b)&&Object.keys(b).forEach(c=>{c in m?f&&((0,l.isObject)(m[c])&&(0,l.isObject)(b[c])?E(m[c],b[c],f):m[c]=b[c]):m[c]=b[c]}),m):b}e.mixin=E;function D(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let f,c;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(f=0;f<m.length;f++)if(!D(m[f],b[f]))return!1}else{const p=[];for(c in m)p.push(c);p.sort();const i=[];for(c in b)i.push(c);if(i.sort(),!D(p,i))return!1;for(f=0;f<p.length;f++)if(!D(m[p[f]],b[p[f]]))return!1}return!0}e.equals=D;function A(m){const b=new Set;return JSON.stringify(m,(f,c)=>{if((0,l.isObject)(c)||Array.isArray(c)){if(b.has(c))return"[Circular]";b.add(c)}return c})}e.safeStringify=A;function k(m,b){const f=Object.create(null);return!m||!b||Object.keys(b).forEach(p=>{const i=m[p],d=b[p];D(i,d)||(f[p]=d)}),f}e.distinct=k;function w(m,b){const f=b.toLowerCase(),c=Object.keys(m).find(p=>p.toLowerCase()===f);return c?m[c]:m[b]}e.getCaseInsensitive=w;function T(m,b){const f=Object.create(null);for(const[c,p]of Object.entries(m))b(c,p)&&(f[c]=p);return f}e.filter=T;function S(m){let b=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)b=b.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return b}e.getAllPropertyNames=S;function g(m){const b=[];for(const f of S(m))typeof m[f]=="function"&&b.push(f);return b}e.getAllMethodNames=g;function v(m,b){const f=p=>function(){const i=Array.prototype.slice.call(arguments,0);return b(p,i)},c={};for(const p of m)c[p]=f(p);return c}e.createProxyObject=v}),define(De[100],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function C(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=C}),define(De[31],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return l.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(I){for(let E=0;E<I.length;E++)I[E]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),y=[];for(let I=0;I<256;I++)y.push(I.toString(16).padStart(2,"0"));return function(){C(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let E=0,D="";return D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D+="-",D+=y[P[E++]],D+=y[P[E++]],D+="-",D+=y[P[E++]],D+=y[P[E++]],D+="-",D+=y[P[E++]],D+=y[P[E++]],D+="-",D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D+=y[P[E++]],D}}()}),define(De[101],Ie([1,0,100]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(I){const E=(0,l.toUint8)(I);this._defaultValue=E,this._asciiMap=t._createAsciiMap(E),this._map=new Map}static _createAsciiMap(I){const E=new Uint8Array(256);for(let D=0;D<256;D++)E[D]=I;return E}set(I,E){const D=(0,l.toUint8)(E);I>=0&&I<256?this._asciiMap[I]=D:this._map.set(I,D)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=t;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class P{constructor(){this._actual=new t(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(C,P){this.lineNumber=C,this.column=P}with(C=this.lineNumber,P=this.column){return C===this.lineNumber&&P===this.column?this:new l(C,P)}delta(C=0,P=0){return this.with(this.lineNumber+C,this.column+P)}equals(C){return l.equals(this,C)}static equals(C,P){return!C&&!P?!0:!!C&&!!P&&C.lineNumber===P.lineNumber&&C.column===P.column}isBefore(C){return l.isBefore(this,C)}static isBefore(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<P.column}isBeforeOrEqual(C){return l.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<=P.column}static compare(C,P){const y=C.lineNumber|0,I=P.lineNumber|0;if(y===I){const E=C.column|0,D=P.column|0;return E-D}return y-I}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new l(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,I,E){P>I||P===I&&y>E?(this.startLineNumber=I,this.startColumn=E,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=I,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let I,E,D,A;return y.startLineNumber<P.startLineNumber?(I=y.startLineNumber,E=y.startColumn):y.startLineNumber===P.startLineNumber?(I=y.startLineNumber,E=Math.min(y.startColumn,P.startColumn)):(I=P.startLineNumber,E=P.startColumn),y.endLineNumber>P.endLineNumber?(D=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(D=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(D=P.endLineNumber,A=P.endColumn),new t(I,E,D,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let I=P.startLineNumber,E=P.startColumn,D=P.endLineNumber,A=P.endColumn;const k=y.startLineNumber,w=y.startColumn,T=y.endLineNumber,S=y.endColumn;return I<k?(I=k,E=w):I===k&&(E=Math.max(E,w)),D>T?(D=T,A=S):D===T&&(A=Math.min(A,S)),I>D||I===D&&E>A?null:new t(I,E,D,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const D=P.startLineNumber|0,A=y.startLineNumber|0;if(D===A){const k=P.startColumn|0,w=y.startColumn|0;if(k===w){const T=P.endLineNumber|0,S=y.endLineNumber|0;if(T===S){const g=P.endColumn|0,v=y.endColumn|0;return g-v}return T-S}return k-w}return D-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[145],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(I,E,D,A){super(I,E,D,A),this.selectionStartLineNumber=I,this.selectionStartColumn=E,this.positionLineNumber=D,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return P.selectionsEqual(this,I)}static selectionsEqual(I,E){return I.selectionStartLineNumber===E.selectionStartLineNumber&&I.selectionStartColumn===E.selectionStartColumn&&I.positionLineNumber===E.positionLineNumber&&I.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,I,E):new P(I,E,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,E){return this.getDirection()===0?new P(I,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,I,E)}static fromPositions(I,E=I){return new P(I.lineNumber,I.column,E.lineNumber,E.column)}static fromRange(I,E){return E===0?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new P(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new P(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,E){if(I&&!E||!I&&E)return!1;if(!I&&!E)return!0;if(I.length!==E.length)return!1;for(let D=0,A=I.length;D<A;D++)if(!this.selectionsEqual(I[D],E[D]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,E,D,A,k){return k===0?new P(I,E,D,A):new P(D,A,I,E)}}e.Selection=P}),define(De[146],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[147],Ie([1,0,101]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends l.CharacterClassifier{constructor(I){super(0);for(let E=0,D=I.length;E<D;E++)this.set(I.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function P(y){const I={};return E=>(I.hasOwnProperty(E)||(I[E]=y(E)),I[E])}e.getMapForWordSeparators=P(y=>new C(y))}),define(De[102],Ie([1,0,61,6,62]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(w+="\\"+T);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=P();function y(k){let w=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)w=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),w=new RegExp(k.source,T)}return w.lastIndex=0,w}e.ensureValidWordDefinition=y;const I=new C.LinkedList;I.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(k){const w=I.unshift(k);return(0,t.toDisposable)(w)}e.setDefaultGetWordAtTextConfig=E;function D(k,w,T,S,g){if(g||(g=l.Iterable.first(I)),T.length>g.maxLen){let c=k-g.maxLen/2;return c<0?c=0:S+=c,T=T.substring(c,k+g.maxLen/2),D(k,w,T,S,g)}const v=Date.now(),m=k-1-S;let b=-1,f=null;for(let c=1;!(Date.now()-v>=g.timeBudget);c++){const p=m-g.windowSize*c;w.lastIndex=Math.max(0,p);const i=A(w,T,m,b);if(!i&&f||(f=i,p<=0))break;b=p}if(f){const c={word:f[0],startColumn:S+1+f.index,endColumn:S+1+f.index+f[0].length};return w.lastIndex=0,c}return null}e.getWordAtText=D;function A(k,w,T,S){let g;for(;g=k.exec(w);){const v=g.index||0;if(v<=T&&k.lastIndex>=T)return g;if(S>0&&v>S)return null}return null}}),define(De[148],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let E=0,D=I.notIn.length;E<D;E++)switch(I.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,E){if(I.getTokenCount()===0)return!0;const D=I.findTokenIndexAtOffset(E-2),A=I.getStandardTokenType(D);return this.isOK(A)}_findNeutralCharacterInRange(I,E){for(let D=I;D<=E;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of I)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=C;function P(y,I,E){y.has(I)?y.get(I).push(E):y.set(I,[E])}}),define(De[149],Ie([1,0,101]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class C{constructor(S,g,v){const m=new Uint8Array(S*g);for(let b=0,f=S*g;b<f;b++)m[b]=v;this._data=m,this.rows=S,this.cols=g}get(S,g){return this._data[S*this.cols+g]}set(S,g,v){this._data[S*this.cols+g]=v}}e.Uint8Matrix=C;class P{constructor(S){let g=0,v=0;for(let b=0,f=S.length;b<f;b++){const[c,p,i]=S[b];p>g&&(g=p),c>v&&(v=c),i>v&&(v=i)}g++,v++;const m=new C(v,g,0);for(let b=0,f=S.length;b<f;b++){const[c,p,i]=S[b];m.set(c,p,i)}this._states=m,this._maxCharCode=g}nextState(S,g){return g<0||g>=this._maxCharCode?0:this._states.get(S,g)}}e.StateMachine=P;let y=null;function I(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var E;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let D=null;function A(){if(D===null){D=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<T.length;g++)D.set(T.charCodeAt(g),1);const S=".,;:";for(let g=0;g<S.length;g++)D.set(S.charCodeAt(g),2)}return D}class k{static _createLink(S,g,v,m,b){let f=b-1;do{const c=g.charCodeAt(f);if(S.get(c)!==2)break;f--}while(f>m);if(m>0){const c=g.charCodeAt(m-1),p=g.charCodeAt(f);(c===40&&p===41||c===91&&p===93||c===123&&p===125)&&f--}return{range:{startLineNumber:v,startColumn:m+1,endLineNumber:v,endColumn:f+2},url:g.substring(m,f+1)}}static computeLinks(S,g=I()){const v=A(),m=[];for(let b=1,f=S.getLineCount();b<=f;b++){const c=S.getLineContent(b),p=c.length;let i=0,d=0,a=0,r=1,o=!1,u=!1,n=!1,s=!1;for(;i<p;){let h=!1;const _=c.charCodeAt(i);if(r===13){let L;switch(_){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:n=!0,u=!0,L=0;break;case 93:n=!1,L=u?0:1;break;case 123:s=!0,L=0;break;case 125:L=s?0:1;break;case 39:L=a===39?1:0;break;case 34:L=a===34?1:0;break;case 96:L=a===96?1:0;break;case 42:L=a===42?1:0;break;case 124:L=a===124?1:0;break;case 32:L=n?0:1;break;default:L=v.get(_)}L===1&&(m.push(k._createLink(v,c,b,d,i)),h=!0)}else if(r===12){let L;_===91?(u=!0,L=0):L=v.get(_),L===1?h=!0:r=13}else r=g.nextState(r,_),r===0&&(h=!0);h&&(r=1,o=!1,u=!1,s=!1,d=i+1,a=_),i++}r===13&&m.push(k._createLink(v,c,b,d,p))}return m}}e.LinkComputer=k;function w(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=w}),define(De[103],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class A{constructor(c,p){this._findMatchBrand=void 0,this.range=c,this.matches=p}}e.FindMatch=A;var k;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function w(f){return f&&typeof f.read=="function"}e.isITextSnapshot=w;var T;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var S;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(S=e.ModelConstants||(e.ModelConstants={}));class g{constructor(c,p,i,d,a,r){this.identifier=c,this.range=p,this.text=i,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=a,this._isTracked=r}}e.ValidAnnotatedEditOperation=g;class v{constructor(c,p,i){this.regex=c,this.wordSeparators=p,this.simpleSearch=i}}e.SearchData=v;class m{constructor(c,p,i){this.reverseEdits=c,this.changes=p,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=m;function b(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(De[150],Ie([1,0,17,100]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class C{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,D){E=(0,t.toUint32)(E);const A=this.values,k=this.prefixSum,w=D.length;return w===0?!1:(this.values=new Uint32Array(A.length+w),this.values.set(A.subarray(0,E),0),this.values.set(A.subarray(E),E+w),this.values.set(D,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,D){return E=(0,t.toUint32)(E),D=(0,t.toUint32)(D),this.values[E]===D?!1:(this.values[E]=D,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,D){E=(0,t.toUint32)(E),D=(0,t.toUint32)(D);const A=this.values,k=this.prefixSum;if(E>=A.length)return!1;const w=A.length-E;return D>=w&&(D=w),D===0?!1:(this.values=new Uint32Array(A.length-D),this.values.set(A.subarray(0,E),0),this.values.set(A.subarray(E+D),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,t.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),E>=this.values.length&&(E=this.values.length-1);for(let A=D;A<=E;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let D=0,A=this.values.length-1,k=0,w=0,T=0;for(;D<=A;)if(k=D+(A-D)/2|0,w=this.prefixSum[k],T=w-this.values[k],E<T)A=k-1;else if(E>=w)D=k+1;else break;return new y(k,E-T)}}e.PrefixSumComputer=C;class P{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const D=this._indexBySum[E],A=D>0?this._prefixSum[D-1]:0;return new y(D,E-A)}removeValues(E,D){this._values.splice(E,D),this._invalidate(E)}insertValues(E,D){this._values=(0,l.arrayInsert)(this._values,E,D),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,D=this._values.length;E<D;E++){const A=this._values[E],k=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=k+A;for(let w=0;w<A;w++)this._indexBySum[k+w]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,D){this._values[E]!==D&&(this._values[E]=D,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(E,D){this.index=E,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=D}}e.PrefixSumIndexOfResult=y}),define(De[151],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[152],Ie([1,0,151]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,P=C*24,y=P*7,I=P*30,E=P*365;function D(k,w,T){typeof k!="number"&&(k=k.getTime());const S=Math.round((new Date().getTime()-k)/1e3);if(S<-30)return(0,l.localize)(0,null,D(new Date().getTime()+S*1e3,!1));if(S<30)return(0,l.localize)(1,null);let g;return S<t?(g=S,w?g===1?T?(0,l.localize)(2,null,g):(0,l.localize)(3,null,g):T?(0,l.localize)(4,null,g):(0,l.localize)(5,null,g):g===1?T?(0,l.localize)(6,null,g):(0,l.localize)(7,null,g):T?(0,l.localize)(8,null,g):(0,l.localize)(9,null,g)):S<C?(g=Math.floor(S/t),w?g===1?T?(0,l.localize)(10,null,g):(0,l.localize)(11,null,g):T?(0,l.localize)(12,null,g):(0,l.localize)(13,null,g):g===1?T?(0,l.localize)(14,null,g):(0,l.localize)(15,null,g):T?(0,l.localize)(16,null,g):(0,l.localize)(17,null,g)):S<P?(g=Math.floor(S/C),w?g===1?T?(0,l.localize)(18,null,g):(0,l.localize)(19,null,g):T?(0,l.localize)(20,null,g):(0,l.localize)(21,null,g):g===1?T?(0,l.localize)(22,null,g):(0,l.localize)(23,null,g):T?(0,l.localize)(24,null,g):(0,l.localize)(25,null,g)):S<y?(g=Math.floor(S/P),w?g===1?(0,l.localize)(26,null,g):(0,l.localize)(27,null,g):g===1?(0,l.localize)(28,null,g):(0,l.localize)(29,null,g)):S<I?(g=Math.floor(S/y),w?g===1?T?(0,l.localize)(30,null,g):(0,l.localize)(31,null,g):T?(0,l.localize)(32,null,g):(0,l.localize)(33,null,g):g===1?T?(0,l.localize)(34,null,g):(0,l.localize)(35,null,g):T?(0,l.localize)(36,null,g):(0,l.localize)(37,null,g)):S<E?(g=Math.floor(S/I),w?g===1?T?(0,l.localize)(38,null,g):(0,l.localize)(39,null,g):T?(0,l.localize)(40,null,g):(0,l.localize)(41,null,g):g===1?T?(0,l.localize)(42,null,g):(0,l.localize)(43,null,g):T?(0,l.localize)(44,null,g):(0,l.localize)(45,null,g)):(g=Math.floor(S/E),w?g===1?T?(0,l.localize)(46,null,g):(0,l.localize)(47,null,g):T?(0,l.localize)(48,null,g):(0,l.localize)(49,null,g):g===1?T?(0,l.localize)(50,null,g):(0,l.localize)(51,null,g):T?(0,l.localize)(52,null,g):(0,l.localize)(53,null,g))}e.fromNow=D;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(De[153],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,12,153]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,w){return w&&(k.stack||k.stacktrace)?C.localize(0,null,I(k),y(k.stack)||y(k.stacktrace)):I(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function E(k=null,w=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const T=l.coalesce(k),S=E(T[0],w);return T.length>1?C.localize(4,null,S,T.length):S}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,w);if(T.exception)return P(T.exception,w)}return k.stack?P(k,w):k.message?k.message:C.localize(5,null)}e.toErrorMessage=E;function D(k){const w=k;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=D;function A(k,w){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=w,T}e.createErrorWithActions=A}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[10],Ie([1,0,154]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,P=!1,y=!1,I=!1,E=!1,D=!1,A=!1,k=!1,w=!1,T,S=e.LANGUAGE_DEFAULT,g,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const b=typeof m?.versions?.electron=="string",f=b&&m?.type==="renderer";if(typeof navigator=="object"&&!f)v=navigator.userAgent,t=v.indexOf("Windows")>=0,C=v.indexOf("Macintosh")>=0,A=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=v.indexOf("Linux")>=0,w=v?.indexOf("Mobi")>=0,E=!0,T=l.getConfiguredDefaultLocale(l.localize(0,null))||e.LANGUAGE_DEFAULT,S=T;else if(typeof m=="object"){t=m.platform==="win32",C=m.platform==="darwin",P=m.platform==="linux",y=P&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,D=b,k=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const n=m.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),h=s.availableLanguages["*"];T=s.locale,S=h||e.LANGUAGE_DEFAULT,g=s._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var c;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let i=0;C?i=1:t?i=3:P&&(i=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=P,e.isLinuxSnap=y,e.isNative=I,e.isElectron=D,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=w,e.isCI=k,e.platform=i,e.userAgent=v,e.language=S;var d;(function(n){function s(){return e.language}n.value=s;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=h;function _(){return e.language==="en"}n.isDefault=_})(d=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let _=0,L=n.length;_<L;_++){const M=n[_];if(M.id===h.data.vscodeScheduleAsyncWork){n.splice(_,1),M.callback();return}}});let s=0;return h=>{const _=++s;n.push({id:_,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return n=>setTimeout(n)})();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||A?2:t?1:3;let r=!0,o=!1;function u(){if(!o){o=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,r=new Uint16Array(n.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const C=l.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,36]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,P=90,y=122,I=46,E=47,D=92,A=58,k=63;class w extends Error{constructor(c,p,i){let d;typeof p=="string"&&p.indexOf("not ")===0?(d="must not be",p=p.replace(/^not /,"")):d="must be";const a=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${a} ${d} of type ${p}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function T(f,c){if(typeof f!="string")throw new w(c,"string",f)}function S(f){return f===E||f===D}function g(f){return f===E}function v(f){return f>=t&&f<=P||f>=C&&f<=y}function m(f,c,p,i){let d="",a=0,r=-1,o=0,u=0;for(let n=0;n<=f.length;++n){if(n<f.length)u=f.charCodeAt(n);else{if(i(u))break;u=E}if(i(u)){if(!(r===n-1||o===1))if(o===2){if(d.length<2||a!==2||d.charCodeAt(d.length-1)!==I||d.charCodeAt(d.length-2)!==I){if(d.length>2){const s=d.lastIndexOf(p);s===-1?(d="",a=0):(d=d.slice(0,s),a=d.length-1-d.lastIndexOf(p)),r=n,o=0;continue}else if(d.length!==0){d="",a=0,r=n,o=0;continue}}c&&(d+=d.length>0?`${p}..`:"..",a=2)}else d.length>0?d+=`${p}${f.slice(r+1,n)}`:d=f.slice(r+1,n),a=n-r-1;r=n,o=0}else u===I&&o!==-1?++o:o=-1}return d}function b(f,c){if(c===null||typeof c!="object")throw new w("pathObject","Object",c);const p=c.dir||c.root,i=c.base||`${c.name||""}${c.ext||""}`;return p?p===c.root?`${p}${i}`:`${p}${f}${i}`:i}e.win32={resolve(...f){let c="",p="",i=!1;for(let d=f.length-1;d>=-1;d--){let a;if(d>=0){if(a=f[d],T(a,"path"),a.length===0)continue}else c.length===0?a=l.cwd():(a=l.env[`=${c}`]||l.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==c.toLowerCase()&&a.charCodeAt(2)===D)&&(a=`${c}\\`));const r=a.length;let o=0,u="",n=!1;const s=a.charCodeAt(0);if(r===1)S(s)&&(o=1,n=!0);else if(S(s))if(n=!0,S(a.charCodeAt(1))){let h=2,_=h;for(;h<r&&!S(a.charCodeAt(h));)h++;if(h<r&&h!==_){const L=a.slice(_,h);for(_=h;h<r&&S(a.charCodeAt(h));)h++;if(h<r&&h!==_){for(_=h;h<r&&!S(a.charCodeAt(h));)h++;(h===r||h!==_)&&(u=`\\\\${L}\\${a.slice(_,h)}`,o=h)}}}else o=1;else v(s)&&a.charCodeAt(1)===A&&(u=a.slice(0,2),o=2,r>2&&S(a.charCodeAt(2))&&(n=!0,o=3));if(u.length>0)if(c.length>0){if(u.toLowerCase()!==c.toLowerCase())continue}else c=u;if(i){if(c.length>0)break}else if(p=`${a.slice(o)}\\${p}`,i=n,n&&c.length>0)break}return p=m(p,!i,"\\",S),i?`${c}\\${p}`:`${c}${p}`||"."},normalize(f){T(f,"path");const c=f.length;if(c===0)return".";let p=0,i,d=!1;const a=f.charCodeAt(0);if(c===1)return g(a)?"\\":f;if(S(a))if(d=!0,S(f.charCodeAt(1))){let o=2,u=o;for(;o<c&&!S(f.charCodeAt(o));)o++;if(o<c&&o!==u){const n=f.slice(u,o);for(u=o;o<c&&S(f.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&!S(f.charCodeAt(o));)o++;if(o===c)return`\\\\${n}\\${f.slice(u)}\\`;o!==u&&(i=`\\\\${n}\\${f.slice(u,o)}`,p=o)}}}else p=1;else v(a)&&f.charCodeAt(1)===A&&(i=f.slice(0,2),p=2,c>2&&S(f.charCodeAt(2))&&(d=!0,p=3));let r=p<c?m(f.slice(p),!d,"\\",S):"";return r.length===0&&!d&&(r="."),r.length>0&&S(f.charCodeAt(c-1))&&(r+="\\"),i===void 0?d?`\\${r}`:r:d?`${i}\\${r}`:`${i}${r}`},isAbsolute(f){T(f,"path");const c=f.length;if(c===0)return!1;const p=f.charCodeAt(0);return S(p)||c>2&&v(p)&&f.charCodeAt(1)===A&&S(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,p;for(let a=0;a<f.length;++a){const r=f[a];T(r,"path"),r.length>0&&(c===void 0?c=p=r:c+=`\\${r}`)}if(c===void 0)return".";let i=!0,d=0;if(typeof p=="string"&&S(p.charCodeAt(0))){++d;const a=p.length;a>1&&S(p.charCodeAt(1))&&(++d,a>2&&(S(p.charCodeAt(2))?++d:i=!1))}if(i){for(;d<c.length&&S(c.charCodeAt(d));)d++;d>=2&&(c=`\\${c.slice(d)}`)}return e.win32.normalize(c)},relative(f,c){if(T(f,"from"),T(c,"to"),f===c)return"";const p=e.win32.resolve(f),i=e.win32.resolve(c);if(p===i||(f=p.toLowerCase(),c=i.toLowerCase(),f===c))return"";let d=0;for(;d<f.length&&f.charCodeAt(d)===D;)d++;let a=f.length;for(;a-1>d&&f.charCodeAt(a-1)===D;)a--;const r=a-d;let o=0;for(;o<c.length&&c.charCodeAt(o)===D;)o++;let u=c.length;for(;u-1>o&&c.charCodeAt(u-1)===D;)u--;const n=u-o,s=r<n?r:n;let h=-1,_=0;for(;_<s;_++){const M=f.charCodeAt(d+_);if(M!==c.charCodeAt(o+_))break;M===D&&(h=_)}if(_!==s){if(h===-1)return i}else{if(n>s){if(c.charCodeAt(o+_)===D)return i.slice(o+_+1);if(_===2)return i.slice(o+_)}r>s&&(f.charCodeAt(d+_)===D?h=_:_===2&&(h=3)),h===-1&&(h=0)}let L="";for(_=d+h+1;_<=a;++_)(_===a||f.charCodeAt(_)===D)&&(L+=L.length===0?"..":"\\..");return o+=h,L.length>0?`${L}${i.slice(o,u)}`:(i.charCodeAt(o)===D&&++o,i.slice(o,u))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===D){if(c.charCodeAt(1)===D){const p=c.charCodeAt(2);if(p!==k&&p!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===D)return`\\\\?\\${c}`;return f},dirname(f){T(f,"path");const c=f.length;if(c===0)return".";let p=-1,i=0;const d=f.charCodeAt(0);if(c===1)return S(d)?f:".";if(S(d)){if(p=i=1,S(f.charCodeAt(1))){let o=2,u=o;for(;o<c&&!S(f.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&S(f.charCodeAt(o));)o++;if(o<c&&o!==u){for(u=o;o<c&&!S(f.charCodeAt(o));)o++;if(o===c)return f;o!==u&&(p=i=o+1)}}}}else v(d)&&f.charCodeAt(1)===A&&(p=c>2&&S(f.charCodeAt(2))?3:2,i=p);let a=-1,r=!0;for(let o=c-1;o>=i;--o)if(S(f.charCodeAt(o))){if(!r){a=o;break}}else r=!1;if(a===-1){if(p===-1)return".";a=p}return f.slice(0,a)},basename(f,c){c!==void 0&&T(c,"ext"),T(f,"path");let p=0,i=-1,d=!0,a;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===A&&(p=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let r=c.length-1,o=-1;for(a=f.length-1;a>=p;--a){const u=f.charCodeAt(a);if(S(u)){if(!d){p=a+1;break}}else o===-1&&(d=!1,o=a+1),r>=0&&(u===c.charCodeAt(r)?--r===-1&&(i=a):(r=-1,i=o))}return p===i?i=o:i===-1&&(i=f.length),f.slice(p,i)}for(a=f.length-1;a>=p;--a)if(S(f.charCodeAt(a))){if(!d){p=a+1;break}}else i===-1&&(d=!1,i=a+1);return i===-1?"":f.slice(p,i)},extname(f){T(f,"path");let c=0,p=-1,i=0,d=-1,a=!0,r=0;f.length>=2&&f.charCodeAt(1)===A&&v(f.charCodeAt(0))&&(c=i=2);for(let o=f.length-1;o>=c;--o){const u=f.charCodeAt(o);if(S(u)){if(!a){i=o+1;break}continue}d===-1&&(a=!1,d=o+1),u===I?p===-1?p=o:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||d===-1||r===0||r===1&&p===d-1&&p===i+1?"":f.slice(p,d)},format:b.bind(null,"\\"),parse(f){T(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const p=f.length;let i=0,d=f.charCodeAt(0);if(p===1)return S(d)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(S(d)){if(i=1,S(f.charCodeAt(1))){let h=2,_=h;for(;h<p&&!S(f.charCodeAt(h));)h++;if(h<p&&h!==_){for(_=h;h<p&&S(f.charCodeAt(h));)h++;if(h<p&&h!==_){for(_=h;h<p&&!S(f.charCodeAt(h));)h++;h===p?i=h:h!==_&&(i=h+1)}}}}else if(v(d)&&f.charCodeAt(1)===A){if(p<=2)return c.root=c.dir=f,c;if(i=2,S(f.charCodeAt(2))){if(p===3)return c.root=c.dir=f,c;i=3}}i>0&&(c.root=f.slice(0,i));let a=-1,r=i,o=-1,u=!0,n=f.length-1,s=0;for(;n>=i;--n){if(d=f.charCodeAt(n),S(d)){if(!u){r=n+1;break}continue}o===-1&&(u=!1,o=n+1),d===I?a===-1?a=n:s!==1&&(s=1):a!==-1&&(s=-1)}return o!==-1&&(a===-1||s===0||s===1&&a===o-1&&a===r+1?c.base=c.name=f.slice(r,o):(c.name=f.slice(r,a),c.base=f.slice(r,o),c.ext=f.slice(a,o))),r>0&&r!==i?c.dir=f.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",p=!1;for(let i=f.length-1;i>=-1&&!p;i--){const d=i>=0?f[i]:l.cwd();T(d,"path"),d.length!==0&&(c=`${d}/${c}`,p=d.charCodeAt(0)===E)}return c=m(c,!p,"/",g),p?`/${c}`:c.length>0?c:"."},normalize(f){if(T(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E,p=f.charCodeAt(f.length-1)===E;return f=m(f,!c,"/",g),f.length===0?c?"/":p?"./":".":(p&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return T(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let c;for(let p=0;p<f.length;++p){const i=f[p];T(i,"path"),i.length>0&&(c===void 0?c=i:c+=`/${i}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(T(f,"from"),T(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const p=1,i=f.length,d=i-p,a=1,r=c.length-a,o=d<r?d:r;let u=-1,n=0;for(;n<o;n++){const h=f.charCodeAt(p+n);if(h!==c.charCodeAt(a+n))break;h===E&&(u=n)}if(n===o)if(r>o){if(c.charCodeAt(a+n)===E)return c.slice(a+n+1);if(n===0)return c.slice(a+n)}else d>o&&(f.charCodeAt(p+n)===E?u=n:n===0&&(u=0));let s="";for(n=p+u+1;n<=i;++n)(n===i||f.charCodeAt(n)===E)&&(s+=s.length===0?"..":"/..");return`${s}${c.slice(a+u)}`},toNamespacedPath(f){return f},dirname(f){if(T(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E;let p=-1,i=!0;for(let d=f.length-1;d>=1;--d)if(f.charCodeAt(d)===E){if(!i){p=d;break}}else i=!1;return p===-1?c?"/":".":c&&p===1?"//":f.slice(0,p)},basename(f,c){c!==void 0&&T(c,"ext"),T(f,"path");let p=0,i=-1,d=!0,a;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let r=c.length-1,o=-1;for(a=f.length-1;a>=0;--a){const u=f.charCodeAt(a);if(u===E){if(!d){p=a+1;break}}else o===-1&&(d=!1,o=a+1),r>=0&&(u===c.charCodeAt(r)?--r===-1&&(i=a):(r=-1,i=o))}return p===i?i=o:i===-1&&(i=f.length),f.slice(p,i)}for(a=f.length-1;a>=0;--a)if(f.charCodeAt(a)===E){if(!d){p=a+1;break}}else i===-1&&(d=!1,i=a+1);return i===-1?"":f.slice(p,i)},extname(f){T(f,"path");let c=-1,p=0,i=-1,d=!0,a=0;for(let r=f.length-1;r>=0;--r){const o=f.charCodeAt(r);if(o===E){if(!d){p=r+1;break}continue}i===-1&&(d=!1,i=r+1),o===I?c===-1?c=r:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||i===-1||a===0||a===1&&c===i-1&&c===p+1?"":f.slice(c,i)},format:b.bind(null,"/"),parse(f){T(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const p=f.charCodeAt(0)===E;let i;p?(c.root="/",i=1):i=0;let d=-1,a=0,r=-1,o=!0,u=f.length-1,n=0;for(;u>=i;--u){const s=f.charCodeAt(u);if(s===E){if(!o){a=u+1;break}continue}r===-1&&(o=!1,r=u+1),s===I?d===-1?d=u:n!==1&&(n=1):d!==-1&&(n=-1)}if(r!==-1){const s=a===0&&p?1:a;d===-1||n===0||n===1&&d===r-1&&d===a+1?c.base=c.name=f.slice(s,r):(c.name=f.slice(s,d),c.base=f.slice(s,r),c.ext=f.slice(d,r))}return a>0?c.dir=f.slice(0,a-1):p&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[104],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const k=(0,l.extname)(A),w=t[k.toLowerCase()];return w!==void 0?w:y(A)}e.getMediaOrTextMime=P;function y(A){const k=(0,l.extname)(A);return C[k.toLowerCase()]}e.getMediaMime=y;function I(A){for(const k in C)if(C[k]===A)return k}e.getExtensionForMimeType=I;const E=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const w=E.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:k?void 0:A}e.normalizeMimeType=D}),define(De[105],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(I,...E){const D=E.reduce((w,T)=>(w[T]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!D[w]).forEach(w=>{for(let T=0;T<A.length;T++)if(w.search(A[T])!==-1){delete I[w];break}})}e.sanitizeProcessEnvironment=P;function y(I){!I||(delete I.DEBUG,l.isMacintosh&&delete I.DYLD_LIBRARY_PATH,l.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(De[51],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class C{static create(y=!0){return new C(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=C}),define(De[3],Ie([1,0,11,60,6,62,51]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,E=!1;var D;(function(u){u.None=()=>C.Disposable.None;function n(me){if(E){const{onListenerDidAdd:be}=me,ke=S.create();let Re=0;me.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function s(me){return(be,ke=null,Re)=>{let ze=!1,oe;return oe=me(le=>{if(!ze)return oe?oe.dispose():ze=!0,be.call(ke,le)},null,Re),ze&&oe.dispose(),oe}}u.once=s;function h(me,be,ke){return z((Re,ze=null,oe)=>me(le=>Re.call(ze,be(le)),null,oe),ke)}u.map=h;function _(me,be,ke){return z((Re,ze=null,oe)=>me(le=>{be(le),Re.call(ze,le)},null,oe),ke)}u.forEach=_;function L(me,be,ke){return z((Re,ze=null,oe)=>me(le=>be(le)&&Re.call(ze,le),null,oe),ke)}u.filter=L;function M(me){return me}u.signal=M;function U(...me){return(be,ke=null,Re)=>(0,C.combinedDisposable)(...me.map(ze=>ze(oe=>be.call(ke,oe),null,Re)))}u.any=U;function R(me,be,ke,Re){let ze=ke;return h(me,oe=>(ze=be(ze,oe),ze),Re)}u.reduce=R;function z(me,be){let ke;const Re={onFirstListenerAdd(){ke=me(ze.fire,ze)},onLastListenerRemove(){ke?.dispose()}};be||n(Re);const ze=new v(Re);return be?.add(ze),ze.event}function H(me,be,ke=100,Re=!1,ze,oe){let le,ge,Z,ae=0;const ne={leakWarningThreshold:ze,onFirstListenerAdd(){le=me(O=>{ae++,ge=be(ge,O),Re&&!Z&&(ie.fire(ge),ge=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=ge;ge=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(j),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||n(ne);const ie=new v(ne);return oe?.add(ie),ie.event}u.debounce=H;function N(me,be=(Re,ze)=>Re===ze,ke){let Re=!0,ze;return L(me,oe=>{const le=Re||!be(oe,ze);return Re=!1,ze=oe,le},ke)}u.latch=N;function V(me,be,ke){return[u.filter(me,be,ke),u.filter(me,Re=>!be(Re),ke)]}u.split=V;function B(me,be=!1,ke=[]){let Re=ke.slice(),ze=me(ge=>{Re?Re.push(ge):le.fire(ge)});const oe=()=>{Re?.forEach(ge=>le.fire(ge)),Re=null},le=new v({onFirstListenerAdd(){ze||(ze=me(ge=>le.fire(ge)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){ze&&ze.dispose(),ze=null}});return le.event}u.buffer=B;class F{constructor(be){this.event=be,this.disposables=new C.DisposableStore}map(be){return new F(h(this.event,be,this.disposables))}forEach(be){return new F(_(this.event,be,this.disposables))}filter(be){return new F(L(this.event,be,this.disposables))}reduce(be,ke){return new F(R(this.event,be,ke,this.disposables))}latch(){return new F(N(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,ze){return new F(H(this.event,be,ke,Re,ze,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return s(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function x(me){return new F(me)}u.chain=x;function $(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.on(be,Re),oe=()=>me.removeListener(be,Re),le=new v({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}u.fromNodeEventEmitter=$;function Q(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.addEventListener(be,Re),oe=()=>me.removeEventListener(be,Re),le=new v({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}u.fromDOMEventEmitter=Q;function K(me){return new Promise(be=>s(me)(be))}u.toPromise=K;function de(me,be){return be(void 0),me(ke=>be(ke))}u.runAndSubscribe=de;function ee(me,be){let ke=null;function Re(oe){ke?.dispose(),ke=new C.DisposableStore,be(oe,ke)}Re(void 0);const ze=me(oe=>Re(oe));return(0,C.toDisposable)(()=>{ze.dispose(),ke?.dispose()})}u.runAndSubscribeWithStore=ee;class he{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||n(Re),this.emitter=new v(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(me,be){return new he(me,be).emitter.event}u.fromObservable=Y})(D=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new y.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let k=-1;function w(u){const n=k;return k=u,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=w;class T{constructor(n,s=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,s){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||s<h)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let L,M=0;for(const[U,R]of this._stacks)(!L||M<R)&&(L=U,M=R);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${M}):`),console.warn(L)}return()=>{const L=this._stacks.get(n.value)||0;this._stacks.set(n.value,L-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(n,s,h){this.callback=n,this.callbackThis=s,this.stack=h,this.subscription=new C.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class v{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const s of n)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,s,h)=>{this._listeners||(this._listeners=new P.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,M;this._leakageMon&&this._listeners.size>=30&&(M=S.create(),L=this._leakageMon.check(M,this._listeners.size+1)),I&&(M=M??S.create());const U=new g(n,s,M),R=this._listeners.push(U);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,s);const z=U.subscription.set(()=>{L?.(),this._disposed||(R(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(z):Array.isArray(h)&&h.push(z),z}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b);for(const s of this._listeners)this._deliveryQueue.push(this,s,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class m{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,s,h){this._queue.push(new f(n,s,h))}clear(n){const s=new P.LinkedList;for(const h of this._queue)h.emitter!==n&&s.push(h);this._queue=s}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(s){(0,l.onUnexpectedError)(s)}}}}e.EventDeliveryQueue=m;class b extends m{clear(n){this._queue.clear()}}class f{constructor(n,s,h){this.emitter=n,this.listener=s,this.event=h}}class c extends v{async fireAsync(n,s,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,n]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[_,L]=this._asyncDeliveryQueue.shift(),M=[],U={...L,token:s,waitUntil:R=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");h&&(R=h(R,_.callback)),M.push(R)}};try{_.invoke(U)}catch(R){(0,l.onUnexpectedError)(R);continue}Object.freeze(M),await Promise.allSettled(M).then(R=>{for(const z of R)z.status==="rejected"&&(0,l.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=c;class p extends v{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=p;class i extends p{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=i;class d extends v{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const s={event:n,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const h=()=>{this.hasListeners&&this.unhook(s);const _=this.events.indexOf(s);this.events.splice(_,1)};return(0,C.toDisposable)((0,t.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(s=>this.emitter.fire(s))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class r{constructor(){this.buffers=[]}wrapEvent(n){return(s,h,_)=>n(L=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>s.call(h,L)):s.call(h,L)},void 0,_)}bufferEvents(n){const s=[];this.buffers.push(s);const h=n();return this.buffers.pop(),s.forEach(_=>_()),h}}e.EventBufferer=r;class o{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=C.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(De[21],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,E){const D=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(D)}}});var C;(function(I){function E(D){return D===I.None||D===I.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=C.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(De[155],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new l.CancellationTokenSource,E=this.task(I.token);return this.result={promise:E,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class C{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const E=JSON.stringify(I);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=C;class P{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const E=this.fn(I);return this._map.set(I,E),E}}e.CachedFunction=P}),define(De[156],Ie([1,0,3,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const C=y=>({onDidChange:l.Event.None,value:y});e.staticObservableValue=C;class P extends t.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new l.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(De[8],Ie([1,0,155,78]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function I(fe,...Ae){return Ae.length===0?fe:fe.replace(y,function(Le,Me){const Ke=parseInt(Me,10);return isNaN(Ke)||Ke<0||Ke>=Ae.length?Le:Ae[Ke]})}e.format=I;const E=/{([^}]+)}/g;function D(fe,Ae){return fe.replace(E,(Le,Me)=>Ae[Me]??Le)}e.format2=D;function A(fe){return fe.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=A;function k(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function w(fe,Ae){let Le=0;const Me=Ae.charCodeAt(0);for(let Ke=fe.length-1;Ke>=0;Ke--)fe.charCodeAt(Ke)===Me&&Le++;return Le}e.count=w;function T(fe,Ae,Le="\u2026"){return fe.length<=Ae?fe:`${fe.substr(0,Ae)}${Le}`}e.truncate=T;function S(fe,Ae=" "){const Le=g(fe,Ae);return v(Le,Ae)}e.trim=S;function g(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length;if(Le===0||fe.length===0)return fe;let Me=0;for(;fe.indexOf(Ae,Me)===Me;)Me=Me+Le;return fe.substring(Me)}e.ltrim=g;function v(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length,Me=fe.length;if(Le===0||Me===0)return fe;let Ke=Me,Je=-1;for(;Je=fe.lastIndexOf(Ae,Ke-1),!(Je===-1||Je+Le!==Ke);){if(Je===0)return"";Ke=Je}return fe.substring(0,Ke)}e.rtrim=v;function m(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function b(fe){return fe.replace(/\*/g,"")}e.stripWildcards=b;function f(fe,Ae,Le={}){if(!fe)throw new Error("Cannot create regex from empty string");Ae||(fe=k(fe)),Le.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Me="";return Le.global&&(Me+="g"),Le.matchCase||(Me+="i"),Le.multiline&&(Me+="m"),Le.unicode&&(Me+="u"),new RegExp(fe,Me)}e.createRegExp=f;function c(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function p(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function i(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=i;function d(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=d;function a(fe){for(let Ae=0,Le=fe.length;Ae<Le;Ae++){const Me=fe.charCodeAt(Ae);if(Me!==32&&Me!==9)return Ae}return-1}e.firstNonWhitespaceIndex=a;function r(fe,Ae=0,Le=fe.length){for(let Me=Ae;Me<Le;Me++){const Ke=fe.charCodeAt(Me);if(Ke!==32&&Ke!==9)return fe.substring(Ae,Me)}return fe.substring(Ae,Le)}e.getLeadingWhitespace=r;function o(fe,Ae=fe.length-1){for(let Le=Ae;Le>=0;Le--){const Me=fe.charCodeAt(Le);if(Me!==32&&Me!==9)return Le}return-1}e.lastNonWhitespaceIndex=o;function u(fe,Ae,Le){const Me=[];let Ke=0;for(const Je of fe.matchAll(Ae)){if(Me.push(fe.slice(Ke,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ke=Je.index+Je[0].length,Me.push(Le(Je[0],...Je.slice(1),Je.index,fe,Je.groups))}return Me.push(fe.slice(Ke)),Promise.all(Me).then(Je=>Je.join(""))}e.replaceAsync=u;function n(fe,Ae){return fe<Ae?-1:fe>Ae?1:0}e.compare=n;function s(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){const it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it<lt)return-1;if(it>lt)return 1}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstring=s;function h(fe,Ae){return _(fe,Ae,0,fe.length,0,Ae.length)}e.compareIgnoreCase=h;function _(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){let it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it===lt)continue;if(it>=128||lt>=128)return s(fe.toLowerCase(),Ae.toLowerCase(),Le,Me,Ke,Je);M(it)&&(it-=32),M(lt)&&(lt-=32);const vt=it-lt;if(vt!==0)return vt}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstringIgnoreCase=_;function L(fe){return fe>=48&&fe<=57}e.isAsciiDigit=L;function M(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=M;function U(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=U;function R(fe,Ae){return fe.length===Ae.length&&_(fe,Ae)===0}e.equalsIgnoreCase=R;function z(fe,Ae){const Le=Ae.length;return Ae.length>fe.length?!1:_(fe,Ae,0,Le)===0}e.startsWithIgnoreCase=z;function H(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Me)!==Ae.charCodeAt(Me))return Me;return Le}e.commonPrefixLength=H;function N(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;const Ke=fe.length-1,Je=Ae.length-1;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Ke-Me)!==Ae.charCodeAt(Je-Me))return Me;return Le}e.commonSuffixLength=N;function V(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=V;function B(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=B;function F(fe,Ae){return(fe-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=F;function x(fe,Ae,Le){const Me=fe.charCodeAt(Le);if(V(Me)&&Le+1<Ae){const Ke=fe.charCodeAt(Le+1);if(B(Ke))return F(Me,Ke)}return Me}e.getNextCodePoint=x;function $(fe,Ae){const Le=fe.charCodeAt(Ae-1);if(B(Le)&&Ae>1){const Me=fe.charCodeAt(Ae-2);if(V(Me))return F(Me,Le)}return Le}class Q{get offset(){return this._offset}constructor(Ae,Le=0){this._str=Ae,this._len=Ae.length,this._offset=Le}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=$(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=x(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ae,Le=0){this._iterator=new Q(Ae,Le)}nextGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.nextCodePoint());if(We(Ke,st)){Le.setOffset(Je);break}Ke=st}return Le.offset-Me}prevGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.prevCodePoint());if(We(st,Ke)){Le.setOffset(Je);break}Ke=st}return Me-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function de(fe,Ae){return new K(fe,Ae).nextGraphemeLength()}e.nextCharLength=de;function ee(fe,Ae){return new K(fe,Ae).prevGraphemeLength()}e.prevCharLength=ee;function he(fe,Ae){Ae>0&&B(fe.charCodeAt(Ae))&&Ae--;const Le=Ae+de(fe,Ae);return[Le-ee(fe,Le),Le]}e.getCharContainingOffset=he;function Y(fe){const Ae=new K(fe);let Le=0;for(;!Ae.eol();)Le++,Ae.nextGraphemeLength();return Le}e.charCount=Y;let me;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(fe){return me||(me=be()),me.test(fe)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(fe){return Re.test(fe)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=oe;function le(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=le;function ge(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=ge;function Z(fe,Ae){if(fe.length<Ae)return fe;const Le=/\b/g;let Me=0;for(;Le.test(fe)&&!(fe.length-Le.lastIndex<Ae);)Me=Le.lastIndex,Le.lastIndex+=1;return fe.substring(Me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function O(fe){return fe&&(fe=fe.replace(ae,""),fe=fe.replace(ne,""),fe=fe.replace(ie,"")),fe}e.removeAnsiEscapeCodes=O,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=j;function G(fe){return j(fe)?fe.substr(1):fe}e.stripUTF8BOM=G;function X(fe,Ae){if(!fe||!Ae||fe.length<Ae.length)return!1;const Le=Ae.length,Me=fe.toLowerCase();let Ke=0,Je=-1;for(;Ke<Le;){const st=Me.indexOf(Ae[Ke],Je+1);if(st<0)return!1;Je=st,Ke++}return!0}e.fuzzyContains=X;function pe(fe,Ae=!1){return fe?(Ae&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=pe;function we(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=we;function ce(fe,Ae=1){if(Ae===0)return"";let Le=-1;do Le=fe.indexOf(`
`,Le+1),Ae--;while(Ae>0&&Le>=0);return Le===-1?fe:(fe[Le-1]==="\r"&&Le--,fe.substr(0,Le))}e.getNLines=ce;function Ce(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=Ce;function ye(fe){return Ze.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=ye;function We(fe,Ae){return fe===0?Ae!==5&&Ae!==7:fe===2&&Ae===3?!1:fe===4||fe===2||fe===3||Ae===4||Ae===2||Ae===3?!0:!(fe===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(fe===11||fe===9)&&(Ae===9||Ae===10)||(fe===12||fe===10)&&Ae===10||Ae===5||Ae===13||Ae===7||fe===1||fe===13&&Ae===14||fe===6&&Ae===6)}var qe;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze._INSTANCE||(Ze._INSTANCE=new Ze),Ze._INSTANCE}constructor(){this._data=Ye()}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Le=this._data,Me=Le.length/3;let Ke=1;for(;Ke<=Me;)if(Ae<Le[3*Ke])Ke=2*Ke;else if(Ae>Le[3*Ke+1])Ke=2*Ke+1;else return Le[3*Ke+2];return 0}}Ze._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(fe,Ae){if(fe===0)return 0;const Le=at(fe,Ae);if(Le!==void 0)return Le;const Me=new Q(Ae,fe);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Ne;function at(fe,Ae){const Le=new Q(Ae,fe);let Me=Le.prevCodePoint();for(;re(Me)||Me===65039||Me===8419;){if(Le.offset===0)return;Me=Le.prevCodePoint()}if(!ge(Me))return;let Ke=Le.offset;return Ke>0&&Le.prevCodePoint()===8205&&(Ke=Le.offset),Ke}function re(fe){return 127995<=fe&&fe<=127999}var se;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class Ee{static getInstance(Ae){return Ee.cache.get(Array.from(Ae))}static getLocales(){return Ee._locales.getValue()}constructor(Ae){this.confusableDictionary=Ae}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ee,C=Ee,Ee.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new l.LRUCachedFunction(fe=>{function Ae(lt){const vt=new Map;for(let wt=0;wt<lt.length;wt+=2)vt.set(lt[wt],lt[wt+1]);return vt}function Le(lt,vt){const wt=new Map(lt);for(const[ft,Et]of vt)wt.set(ft,Et);return wt}function Me(lt,vt){if(!lt)return vt;const wt=new Map;for(const[ft,Et]of lt)vt.has(ft)&&wt.set(ft,Et);return wt}const Ke=C.ambiguousCharacterData.getValue();let Je=fe.filter(lt=>!lt.startsWith("_")&&lt in Ke);Je.length===0&&(Je=["_default"]);let st;for(const lt of Je){const vt=Ae(Ke[lt]);st=Me(st,vt)}const ot=Ae(Ke._common),it=Le(ot,st);return new Ee(it)}),Ee._locales=new t.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.getValue()).filter(fe=>!fe.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(Ae){return Ve.getData().has(Ae)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(De[32],Ie([1,0,9,10,8,12]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(o){return o===47||o===92}e.isPathSeparator=y;function I(o){return o.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=I;function E(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function D(o,u=l.posix.sep){if(!o)return"";const n=o.length,s=o.charCodeAt(0);if(y(s)){if(y(o.charCodeAt(1))&&!y(o.charCodeAt(2))){let _=3;const L=_;for(;_<n&&!y(o.charCodeAt(_));_++);if(L!==_&&!y(o.charCodeAt(_+1))){for(_+=1;_<n;_++)if(y(o.charCodeAt(_)))return o.slice(0,_+1).replace(/[\\/]/g,u)}}return u}else if(m(s)&&o.charCodeAt(1)===58)return y(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let h=o.indexOf("://");if(h!==-1){for(h+=3;h<n;h++)if(y(o.charCodeAt(h)))return o.slice(0,h+1)}return""}e.getRoot=D;function A(o){if(!t.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let n=2;const s=n;for(;n<o.length&&(u=o.charCodeAt(n),u!==92);n++);return!(s===n||(u=o.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=A;const k=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(o,u=t.isWindows){const n=u?k:w;return!(!o||o.length===0||/^\s+$/.test(o)||(n.lastIndex=0,n.test(o))||u&&T.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=S;function g(o,u,n){const s=o===u;return!n||s?s:!o||!u?!1:(0,C.equalsIgnoreCase)(o,u)}e.isEqual=g;function v(o,u,n,s=l.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(n){if(!(0,C.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let _=u.length;return u.charAt(u.length-1)===s&&_--,o.charAt(_)===s}return u.charAt(u.length-1)!==s&&(u+=s),o.indexOf(u)===0}e.isEqualOrParent=v;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function b(o,u){return t.isWindows&&o.endsWith(":")&&(o+=l.sep),(0,l.isAbsolute)(o)||(o=(0,l.join)(u,o)),o=(0,l.normalize)(o),t.isWindows?(o=(0,C.rtrim)(o,l.sep),o.endsWith(":")&&(o+=l.sep)):(o=(0,C.rtrim)(o,l.sep),o||(o=l.sep)),o}e.sanitizeFilePath=b;function f(o){const u=(0,l.normalize)(o);return t.isWindows?o.length>3?!1:c(u)&&(o.length===2||u.charCodeAt(2)===92):u===l.posix.sep}e.isRootOrDriveLetter=f;function c(o,u=t.isWindows){return u?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function p(o){return c(o)?o[0]:void 0}e.getDriveLetter=p;function i(o,u,n){return u.length>o.length?-1:o===u?0:(n&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=i;function d(o){const u=o.split(":");let n,s,h;for(const _ of u){const L=Number(_);(0,P.isNumber)(L)?s===void 0?s=L:h===void 0&&(h=L):n=n?[n,_].join(":"):_}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:s!==void 0?s:void 0,column:h!==void 0?h:s!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,u,n=8){let s="";for(let _=0;_<n;_++)s+=a.charAt(Math.floor(Math.random()*a.length));let h;return u?h=`${u}-${s}`:h=s,o?(0,l.join)(o,h):h}e.randomPath=r}),define(De[79],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return C(m,0)}e.hash=t;function C(m,b){switch(typeof m){case"object":return m===null?P(349,b):Array.isArray(m)?E(m,b):D(m,b);case"string":return I(m,b);case"boolean":return y(m,b);case"number":return P(m,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=C;function P(m,b){return(b<<5)-b+m|0}e.numberHash=P;function y(m,b){return P(m?433:863,b)}function I(m,b){b=P(149417,b);for(let f=0,c=m.length;f<c;f++)b=P(m.charCodeAt(f),b);return b}e.stringHash=I;function E(m,b){return b=P(104579,b),m.reduce((f,c)=>C(c,f),b)}function D(m,b){return b=P(181387,b),Object.keys(m).sort().reduce((f,c)=>(f=I(c,f),C(m[c],f)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=A;var k;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function w(m,b,f=32){const c=f-b,p=~((1<<c)-1);return(m<<b|(p&m)>>>c)>>>0}function T(m,b=0,f=m.byteLength,c=0){for(let p=0;p<f;p++)m[b+p]=c}function S(m,b,f="0"){for(;m.length<b;)m=f+m;return m}function g(m,b=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):S((m>>>0).toString(16),b/4)}e.toHexString=g;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const f=b.length;if(f===0)return;const c=this._buff;let p=this._buffLen,i=this._leftoverHighSurrogate,d,a;for(i!==0?(d=i,a=-1,i=0):(d=b.charCodeAt(0),a=0);;){let r=d;if(l.isHighSurrogate(d))if(a+1<f){const o=b.charCodeAt(a+1);l.isLowSurrogate(o)?(a++,r=l.computeCodePoint(d,o)):r=65533}else{i=d;break}else l.isLowSurrogate(d)&&(r=65533);if(p=this._push(c,p,r),a++,a<f)d=b.charCodeAt(a);else break}this._buffLen=p,this._leftoverHighSurrogate=i}_push(b,f,c){return c<128?b[f++]=c:c<2048?(b[f++]=192|(c&1984)>>>6,b[f++]=128|(c&63)>>>0):c<65536?(b[f++]=224|(c&61440)>>>12,b[f++]=128|(c&4032)>>>6,b[f++]=128|(c&63)>>>0):(b[f++]=240|(c&1835008)>>>18,b[f++]=128|(c&258048)>>>12,b[f++]=128|(c&4032)>>>6,b[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,f=this._buffDV;for(let n=0;n<64;n+=4)b.setUint32(n,f.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,w(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let c=this._h0,p=this._h1,i=this._h2,d=this._h3,a=this._h4,r,o,u;for(let n=0;n<80;n++)n<20?(r=p&i|~p&d,o=1518500249):n<40?(r=p^i^d,o=1859775393):n<60?(r=p&i|p&d|i&d,o=2400959708):(r=p^i^d,o=3395469782),u=w(c,5)+r+a+o+b.getUint32(n*4,!1)&4294967295,a=d,d=i,i=w(p,30),p=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[26],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var C,P,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(a,r,o){let u=a.get(r);return u===void 0&&(u=o,a.set(r,u)),u}e.getOrSet=I;function E(a){const r=[];return a.forEach((o,u)=>{r.push(`${u} => ${o}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=E;function D(a){const r=[];return a.forEach(o=>{r.push(o)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=D;class A{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return o-u}value(){return this._value[this._pos]}}e.StringIterator=A;class k{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class w{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let o=r.length-1;o>=0;o--,this._valueLen--){const u=this._value.charCodeAt(o);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var T;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(r,o){this._ignorePathCasing=r,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(v||(v={}));class m{static forUris(r=()=>!1,o=()=>!1){return new m(new S(r,o))}static forPaths(r=!1){return new m(new w(void 0,!r))}static forStrings(){return new m(new A)}static forConfigKeys(){return new m(new k)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,o){if(o){const u=o.slice(0);(0,l.shuffle)(u);for(const n of u)this.set(n,r)}else{const u=r.slice(0);(0,l.shuffle)(u);for(const n of u)this.set(n[0],n[1])}}set(r,o){const u=this._iter.reset(r);let n;this._root||(this._root=new g,this._root.segment=u.value());const s=[];for(n=this._root;;){const _=u.cmp(n.segment);if(_>0)n.left||(n.left=new g,n.left.segment=u.value()),s.push([-1,n]),n=n.left;else if(_<0)n.right||(n.right=new g,n.right.segment=u.value()),s.push([1,n]),n=n.right;else if(u.hasNext())u.next(),n.mid||(n.mid=new g,n.mid.segment=u.value()),s.push([0,n]),n=n.mid;else break}const h=n.value;n.value=o,n.key=r;for(let _=s.length-1;_>=0;_--){const L=s[_][1];L.updateHeight();const M=L.balanceFactor();if(M<-1||M>1){const U=s[_][0],R=s[_+1][0];if(U===1&&R===1)s[_][1]=L.rotateLeft();else if(U===-1&&R===-1)s[_][1]=L.rotateRight();else if(U===1&&R===-1)L.right=s[_+1][1]=s[_+1][1].rotateRight(),s[_][1]=L.rotateLeft();else if(U===-1&&R===1)L.left=s[_+1][1]=s[_+1][1].rotateLeft(),s[_][1]=L.rotateRight();else throw new Error;if(_>0)switch(s[_-1][0]){case-1:s[_-1][1].left=s[_][1];break;case 1:s[_-1][1].right=s[_][1];break;case 0:s[_-1][1].mid=s[_][1];break}else this._root=s[0][1]}}return h}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let u=this._root;for(;u;){const n=o.cmp(u.segment);if(n>0)u=u.left;else if(n<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else break}return u}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const u=this._iter.reset(r),n=[];let s=this._root;for(;s;){const h=u.cmp(s.segment);if(h>0)n.push([-1,s]),s=s.left;else if(h<0)n.push([1,s]),s=s.right;else if(u.hasNext())u.next(),n.push([0,s]),s=s.mid;else break}if(!!s){if(o?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const h=this._min(s.right);if(h.key){const{key:_,value:L,segment:M}=h;this._delete(h.key,!1),s.key=_,s.value=L,s.segment=M}}else{const h=s.left??s.right;if(n.length>0){const[_,L]=n[n.length-1];switch(_){case-1:L.left=h;break;case 0:L.mid=h;break;case 1:L.right=h;break}}else this._root=h}for(let h=n.length-1;h>=0;h--){const _=n[h][1];_.updateHeight();const L=_.balanceFactor();if(L>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),n[h][1]=_.rotateLeft()):L<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),n[h][1]=_.rotateRight()),h>0)switch(n[h-1][0]){case-1:n[h-1][1].left=n[h][1];break;case 1:n[h-1][1].right=n[h][1];break;case 0:n[h-1][1].mid=n[h][1];break}else this._root=n[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const o=this._iter.reset(r);let u=this._root,n;for(;u;){const s=o.cmp(u.segment);if(s>0)u=u.left;else if(s<0)u=u.right;else if(o.hasNext())o.next(),n=u.value||n,u=u.mid;else break}return u&&u.value||n}findSuperstr(r){const o=this._iter.reset(r);let u=this._root;for(;u;){const n=o.cmp(u.segment);if(n>0)u=u.left;else if(n<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[o,u]of this)r(u,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const o=[];return this._dfsEntries(r,o),o[Symbol.iterator]()}_dfsEntries(r,o){!r||(r.left&&this._dfsEntries(r.left,o),r.value&&o.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,o),r.right&&this._dfsEntries(r.right,o))}_isBalanced(){const r=o=>{if(!o)return!0;const u=o.balanceFactor();return u<-1||u>1?!1:r(o.left)&&r(o.right)};return r(this._root)}}e.TernarySearchTree=m;class b{constructor(r,o){this.uri=r,this.value=o}}class f{constructor(r,o){this[C]="ResourceMap",r instanceof f?(this.map=new Map(r.map),this.toKey=o??f.defaultToKey):(this.map=new Map,this.toKey=r??f.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),new b(r,o)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[u,n]of this.map)r(n.value,n.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=f,f.defaultToKey=a=>a.toString();class c{constructor(r,o){this[P]="ResourceSet",!r||typeof r=="function"?this._map=new f(r):(this._map=new f(o),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,o){this._map.forEach((u,n)=>r.call(o,n,n,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var p;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class i{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const u=this._map.get(r);if(!!u)return o!==0&&this.touch(u,o),u.value}set(r,o,u=0){let n=this._map.get(r);if(n)n.value=o,u!==0&&this.touch(n,u);else{switch(n={key:r,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(r,n),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const u=this._state;let n=this._head;for(;n;){if(o?r.bind(o)(n.value,n.key,this):r(n.value,n.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const r=this,o=this._state;let u=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const s={value:u.key,done:!1};return u=u.next,s}else return{value:void 0,done:!0}}};return n}values(){const r=this,o=this._state;let u=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const s={value:u.value,done:!1};return u=u.next,s}else return{value:void 0,done:!0}}};return n}entries(){const r=this,o=this._state;let u=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const s={value:[u.key,u.value],done:!1};return u=u.next,s}else return{value:void 0,done:!0}}};return n}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>r;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,u=r.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const u=r.next,n=r.previous;r===this._tail?(n.next=void 0,this._tail=n):(u.previous=n,n.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const u=r.next,n=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=n,n.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,u)=>{r.push([u,o])}),r}fromJSON(r){this.clear();for(const[o,u]of r)this.set(o,u)}}e.LinkedMap=i;class d extends i{constructor(r,o=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(De[106],Ie([1,0,26,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ne){return function(ie,O){for(let j=0,G=ne.length;j<G;j++){const X=ne[j](ie,O);if(X)return X}return null}}e.or=C,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,O){if(!O||O.length<ie.length)return null;let j;return ne?j=t.startsWithIgnoreCase(O,ie):j=O.indexOf(ie)===0,j?ie.length>0?[{start:0,end:ie.length}]:[]:null}function y(ne,ie){const O=ie.toLowerCase().indexOf(ne.toLowerCase());return O===-1?null:[{start:O,end:O+ne.length}]}e.matchesContiguousSubString=y;function I(ne,ie){return E(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=I;function E(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]===ie[j]){let G=null;return(G=E(ne,ie,O+1,j+1))?m({start:j,end:j+1},G):null}return E(ne,ie,O,j+1)}function D(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.isUpper=A;function k(ne){return 48<=ne&&ne<=57}function w(ne){return ne===32||ne===9||ne===10||ne===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>T.add(ne.charCodeAt(0)));function S(ne){return w(ne)||T.has(ne)}function g(ne,ie){return ne===ie||S(ne)&&S(ie)}function v(ne){return D(ne)||A(ne)||k(ne)}function m(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function b(ne,ie){for(let O=ie;O<ne.length;O++){const j=ne.charCodeAt(O);if(A(j)||k(j)||O>0&&!v(ne.charCodeAt(O-1)))return O}return ne.length}function f(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]!==ie[j].toLowerCase())return null;{let G=null,X=j+1;for(G=f(ne,ie,O+1,j+1);!G&&(X=b(ie,X))<ie.length;)G=f(ne,ie,O+1,X),X++;return G===null?null:m({start:j,end:j+1},G)}}function c(ne){let ie=0,O=0,j=0,G=0,X=0;for(let ye=0;ye<ne.length;ye++)X=ne.charCodeAt(ye),A(X)&&ie++,D(X)&&O++,v(X)&&j++,k(X)&&G++;const pe=ie/ne.length,we=O/ne.length,ce=j/ne.length,Ce=G/ne.length;return{upperPercent:pe,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function p(ne){const{upperPercent:ie,lowerPercent:O}=ne;return O===0&&ie>.6}function i(ne){const{upperPercent:ie,lowerPercent:O,alphaPercent:j,numericPercent:G}=ne;return O>.2&&ie<.8&&j>.6&&G<.2}function d(ne){let ie=0,O=0,j=0,G=0;for(let X=0;X<ne.length;X++)j=ne.charCodeAt(X),A(j)&&ie++,D(j)&&O++,w(j)&&G++;return(ie===0||O===0)&&G===0?ne.length<=30:ie<=5}function a(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(ne)||ie.length>60)return null;const O=c(ie);if(!i(O)){if(!p(O))return null;ie=ie.toLowerCase()}let j=null,G=0;for(ne=ne.toLowerCase();G<ie.length&&(j=f(ne,ie,0,G))===null;)G=b(ie,G+1);return j}e.matchesCamelCase=a;function r(ne,ie,O=!1){if(!ie||ie.length===0)return null;let j=null,G=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(j=o(ne,ie,0,G,O))===null;)G=u(ie,G+1);return j}e.matchesWords=r;function o(ne,ie,O,j,G){if(O===ne.length)return[];if(j===ie.length)return null;if(g(ne.charCodeAt(O),ie.charCodeAt(j))){let X=null,pe=j+1;if(X=o(ne,ie,O+1,j+1,G),!G)for(;!X&&(pe=u(ie,pe))<ie.length;)X=o(ne,ie,O+1,pe,G),pe++;return X?ne.charCodeAt(O)!==ie.charCodeAt(j)?X:m({start:j,end:j+1},X):null}else return null}function u(ne,ie){for(let O=ie;O<ne.length;O++)if(S(ne.charCodeAt(O))||O>0&&S(ne.charCodeAt(O-1)))return O;return ne.length}const n=C(e.matchesPrefix,a,y),s=C(e.matchesPrefix,a,I),h=new l.LRUCache(1e4);function _(ne,ie,O=!1){if(typeof ne!="string"||typeof ie!="string")return null;let j=h.get(ne);j||(j=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),h.set(ne,j));const G=j.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:O?s(ne,ie):n(ne,ie)}e.matchesFuzzy=_;function L(ne,ie){const O=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?U(O):null}e.matchesFuzzy2=L;function M(ne,ie,O,j,G,X){const pe=Math.min(13,ne.length);for(;O<pe;O++){const we=Re(ne,ie,O,j,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function U(ne){if(typeof ne>"u")return[];const ie=[],O=ne[1];for(let j=ne.length-1;j>1;j--){const G=ne[j]+O,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=U;const R=128;function z(){const ne=[],ie=[];for(let O=0;O<=R;O++)ie[O]=0;for(let O=0;O<=R;O++)ne.push(ie.slice(0));return ne}function H(ne){const ie=[];for(let O=0;O<=ne;O++)ie[O]=0;return ie}const N=H(2*R),V=H(2*R),B=z(),F=z(),x=z(),$=!1;function Q(ne,ie,O,j,G){function X(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let pe=` |   |${j.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?pe+=" |":pe+=`${ie[we-1]}|`,pe+=ne[we].slice(0,G+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return pe}function K(ne,ie,O,j){ne=ne.substr(ie),O=O.substr(j),console.log(Q(F,ne,ne.length,O,O.length)),console.log(Q(x,ne,ne.length,O,O.length)),console.log(Q(B,ne,ne.length,O,O.length))}function de(ne,ie){if(ie<0||ie>=ne.length)return!1;const O=ne.codePointAt(ie);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function ee(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function he(ne,ie,O){return ie[ne]!==O[ne]}function Y(ne,ie,O,j,G,X,pe=!1){for(;ie<O&&G<X;)ne[ie]===j[G]&&(pe&&(N[ie]=G),ie+=1),G+=1;return ie===O}e.isPatternInWord=Y;var me;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(me||(me={}));var be;(function(ne){ne.Default=[-100,0];function ie(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,O){this.firstMatchCanBeWeak=ie,this.boostFullMatch=O}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,O,j,G,X,pe=ke.default){const we=ne.length>R?R:ne.length,ce=j.length>R?R:j.length;if(O>=we||X>=ce||we-O>ce-X||!Y(ie,O,we,G,X,ce,!0))return;ze(we,ce,O,X,ie,G);let Ce=1,ye=1,We=O,qe=X;const Ze=[!1];for(Ce=1,We=O;We<we;Ce++,We++){const se=N[We],Ee=V[We],Ve=We+1<we?V[We+1]:ce;for(ye=se-X+1,qe=se;qe<Ve;ye++,qe++){let fe=Number.MIN_SAFE_INTEGER,Ae=!1;qe<=Ee&&(fe=oe(ne,ie,We,O,j,G,qe,ce,X,B[Ce-1][ye-1]===0,Ze));let Le=0;fe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=fe+F[Ce-1][ye-1]);const Me=qe>se,Ke=Me?F[Ce][ye-1]+(B[Ce][ye-1]>0?-5:0):0,Je=qe>se+1&&B[Ce][ye-1]>0,st=Je?F[Ce][ye-2]+(B[Ce][ye-2]>0?-5:0):0;if(Je&&(!Me||st>=Ke)&&(!Ae||st>=Le))F[Ce][ye]=st,x[Ce][ye]=3,B[Ce][ye]=0;else if(Me&&(!Ae||Ke>=Le))F[Ce][ye]=Ke,x[Ce][ye]=2,B[Ce][ye]=0;else if(Ae)F[Ce][ye]=Le,x[Ce][ye]=1,B[Ce][ye]=B[Ce-1][ye-1]+1;else throw new Error("not possible")}}if($&&K(ne,O,j,X),!Ze[0]&&!pe.firstMatchCanBeWeak)return;Ce--,ye--;const Ye=[F[Ce][ye],X];let Ne=0,at=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Ne>1&&ie[O+Ce-1]===G[X+ye-1]&&!he(se+X-1,j,G)&&Ne+1>B[Ce][se]&&(se=ye),se===ye?Ne++:Ne=1,at||(at=se),Ce--,ye=se-1,Ye.push(ye)}ce===we&&pe.boostFullMatch&&(Ye[0]+=2);const re=at-we;return Ye[0]-=re,Ye}e.fuzzyScore=Re;function ze(ne,ie,O,j,G,X){let pe=ne-1,we=ie-1;for(;pe>=O&&we>=j;)G[pe]===X[we]&&(V[pe]=we,pe--),we--}function oe(ne,ie,O,j,G,X,pe,we,ce,Ce,ye){if(ie[O]!==X[pe])return Number.MIN_SAFE_INTEGER;let We=1,qe=!1;return pe===O-j?We=ne[O]===G[pe]?7:5:he(pe,G,X)&&(pe===0||!he(pe-1,G,X))?(We=ne[O]===G[pe]?7:5,qe=!0):de(X,pe)&&(pe===0||!de(X,pe-1))?We=5:(de(X,pe-1)||ee(X,pe-1))&&(We=5,qe=!0),We>1&&O===j&&(ye[0]=!0),qe||(qe=he(pe,G,X)||de(X,pe-1)||ee(X,pe-1)),O===j?pe>ce&&(We-=qe?3:5):Ce?We+=qe?2:0:We+=qe?0:1,pe+1===we&&(We-=qe?3:5),We}function le(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!0,pe)}e.fuzzyScoreGracefulAggressive=le;function ge(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!1,pe)}e.fuzzyScoreGraceful=ge;function Z(ne,ie,O,j,G,X,pe,we){let ce=Re(ne,ie,O,j,G,X,we);if(ce&&!pe)return ce;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ye=O+1;ye<Ce;ye++){const We=ae(ne,ye);if(We){const qe=Re(We,We.toLowerCase(),O,j,G,X,we);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const O=ne[ie],j=ne[ie+1];if(O!==j)return ne.slice(0,ie)+j+O+ne.slice(ie+2)}}),define(De[157],Ie([1,0,76,106,8]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(l.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function E(v){return v.replace(I,(m,b)=>b?m:`\\${m}`)}e.escapeIcons=E;const D=new RegExp(`\\\\${P.source}`,"g");function A(v){return v.replace(D,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=A;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function w(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(k,(m,b,f,c)=>f?m:b||c||"")}e.stripIcons=w;function T(v){const m=v.indexOf(e.iconStartMarker);return m===-1?{text:v}:S(v,m)}e.parseLabelWithIcons=T;function S(v,m){const b=[];let f="";function c(n){if(n){f+=n;for(const s of n)b.push(d)}}let p=-1,i="",d=0,a,r,o=m;const u=v.length;for(c(v.substr(0,m));o<u;)a=v[o],r=v[o+1],a===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(p=o,c(i),i=e.iconStartMarker,o++):a===")"&&p!==-1?(d+=o-p+1,p=-1,i=""):p!==-1?y.test(a)?i+=a:(c(i),p=-1,i=""):c(a),o++;return c(i),{text:f,iconOffsets:b}}function g(v,m,b=!1){const{text:f,iconOffsets:c}=m;if(!c||c.length===0)return(0,t.matchesFuzzy)(v,f,b);const p=(0,C.ltrim)(f," "),i=f.length-p.length,d=(0,t.matchesFuzzy)(v,p,b);if(d)for(const a of d){const r=c[a.start+i]+i;a.start+=r,a.end+=r}return d}e.matchesFuzzyIconAware=g}),define(De[80],Ie([1,0,26]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function C(D){return E(D,"NFC",t)}e.normalizeNFC=C;const P=new l.LRUCache(1e4);function y(D){return E(D,"NFD",P)}e.normalizeNFD=y;const I=/[^\u0000-\u0080]/;function E(D,A,k){if(!D)return D;const w=k.get(D);if(w)return w;let T;return I.test(D)?T=D.normalize(A):T=D,k.set(D,T),T}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(A){return y(A).replace(D,"")}}()}),define(De[42],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const P="error",y="warning",I="warn",E="info",D="ignore";function A(w){return w?l.equalsIgnoreCase(P,w)?C.Error:l.equalsIgnoreCase(y,w)||l.equalsIgnoreCase(I,w)?C.Warning:l.equalsIgnoreCase(E,w)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function k(w){switch(w){case C.Error:return P;case C.Warning:return y;case C.Info:return E;default:return D}}C.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,10]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function I(a,r){if(!a.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!C.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!P.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(a,r){return!a&&!r?"file":a}function D(a,r){switch(a){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const A="",k="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(r){return r instanceof T?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,u,n,s,h=!1){typeof r=="object"?(this.scheme=r.scheme||A,this.authority=r.authority||A,this.path=r.path||A,this.query=r.query||A,this.fragment=r.fragment||A):(this.scheme=E(r,h),this.authority=o||A,this.path=D(this.scheme,u||A),this.query=n||A,this.fragment=s||A,I(this,h))}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:u,path:n,query:s,fragment:h}=r;return o===void 0?o=this.scheme:o===null&&(o=A),u===void 0?u=this.authority:u===null&&(u=A),n===void 0?n=this.path:n===null&&(n=A),s===void 0?s=this.query:s===null&&(s=A),h===void 0?h=this.fragment:h===null&&(h=A),o===this.scheme&&u===this.authority&&n===this.path&&s===this.query&&h===this.fragment?this:new g(o,u,n,s,h)}static parse(r,o=!1){const u=w.exec(r);return u?new g(u[2]||A,d(u[4]||A),d(u[5]||A),d(u[7]||A),d(u[9]||A),o):new g(A,A,A,A,A)}static file(r){let o=A;if(t.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const u=r.indexOf(k,2);u===-1?(o=r.substring(2),r=k):(o=r.substring(2,u),r=r.substring(u)||k)}return new g("file",o,r,A,A)}static from(r){const o=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return I(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&r.scheme==="file"?u=T.file(l.win32.join(f(r,!0),...o)).path:u=l.posix.join(r.path,...o),r.with({path:u})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof T)return r;{const o=new g(r);return o._formatted=r.external,o._fsPath=r._sep===S?r.fsPath:null,o}}else return r}}e.URI=T;const S=t.isWindows?1:void 0;class g extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=S),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(a,r){let o,u=-1;for(let n=0;n<a.length;n++){const s=a.charCodeAt(n);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||s===45||s===46||s===95||s===126||r&&s===47)u!==-1&&(o+=encodeURIComponent(a.substring(u,n)),u=-1),o!==void 0&&(o+=a.charAt(n));else{o===void 0&&(o=a.substr(0,n));const h=v[s];h!==void 0?(u!==-1&&(o+=encodeURIComponent(a.substring(u,n)),u=-1),o+=h):u===-1&&(u=n)}}return u!==-1&&(o+=encodeURIComponent(a.substring(u))),o!==void 0?o:a}function b(a){let r;for(let o=0;o<a.length;o++){const u=a.charCodeAt(o);u===35||u===63?(r===void 0&&(r=a.substr(0,o)),r+=v[u]):r!==void 0&&(r+=a[o])}return r!==void 0?r:a}function f(a,r){let o;return a.authority&&a.path.length>1&&a.scheme==="file"?o=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?r?o=a.path.substr(1):o=a.path[1].toLowerCase()+a.path.substr(2):o=a.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=f;function c(a,r){const o=r?b:m;let u="",{scheme:n,authority:s,path:h,query:_,fragment:L}=a;if(n&&(u+=n,u+=":"),(s||n==="file")&&(u+=k,u+=k),s){let M=s.indexOf("@");if(M!==-1){const U=s.substr(0,M);s=s.substr(M+1),M=U.indexOf(":"),M===-1?u+=o(U,!1):(u+=o(U.substr(0,M),!1),u+=":",u+=o(U.substr(M+1),!1)),u+="@"}s=s.toLowerCase(),M=s.indexOf(":"),M===-1?u+=o(s,!1):(u+=o(s.substr(0,M),!1),u+=s.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}u+=o(h,!0)}return _&&(u+="?",u+=o(_,!1)),L&&(u+="#",u+=r?L:m(L,!1)),u}function p(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+p(a.substr(3)):a}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(a){return a.match(i)?a.replace(i,r=>p(r)):a}}),define(De[81],Ie([1,0,23,8,2]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,I)}e.stringify=P;function y(D){let A=JSON.parse(D);return A=E(A),A}e.parse=y;function I(D,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function E(D,A=0){if(!D||A>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return C.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 14:return new Date(D.source)}if(D instanceof l.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let k=0;k<D.length;++k)D[k]=E(D[k],A+1);else for(const k in D)Object.hasOwnProperty.call(D,k)&&(D[k]=E(D[k],A+1))}return D}e.revive=E}),define(De[14],Ie([1,0,10,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${C.vscodeRemoteResource}`}set(D,A,k){this._hosts[D]=A,this._ports[D]=k}setConnectionToken(D,A){this._connectionTokens[D]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let k=this._hosts[A];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const w=this._ports[A],T=this._connectionTokens[A];let S=`path=${encodeURIComponent(D.path)}`;return typeof T=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${k}:${w}`,path:this._remoteResourcesPath,query:S})}}e.RemoteAuthorities=new P;class y{asBrowserUri(D,A){const k=this.toUri(D,A);return k.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===C.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${C.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?k.with({scheme:C.vscodeFileResource,authority:k.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(D,A){const k=this.toUri(D,A);return k.scheme===C.vscodeFileResource?k.with({scheme:C.file,authority:k.authority!==y.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(D,A){return t.URI.isUri(D)?D:t.URI.parse(A.toUrl(D))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var I;(function(E){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(D.get("3"));const A="vscode-coi";function k(T){let S;typeof T=="string"?S=new URL(T).searchParams:T instanceof URL?S=T.searchParams:t.URI.isUri(T)&&(S=new URL(T.toString(!0)).searchParams);const g=S?.get(A);if(!!g)return D.get(g)}E.getHeadersFromQuery=k;function w(T,S,g){if(!globalThis.crossOriginIsolated)return;const v=S&&g?"3":g?"2":"1";T instanceof URLSearchParams?T.set(A,v):T[A]=v}E.addSearchParam=w})(I=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,32,14,9,10,8,2]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,I.uriToFsPath)(T,!0)}e.originalFSPath=E;class D{constructor(S){this._ignorePathCasing=S}compare(S,g,v=!1){return S===g?0:(0,y.compare)(this.getComparisonKey(S,v),this.getComparisonKey(g,v))}isEqual(S,g,v=!1){return S===g?!0:!S||!g?!1:this.getComparisonKey(S,v)===this.getComparisonKey(g,v)}getComparisonKey(S,g=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,g,v=!1){if(S.scheme===g.scheme){if(S.scheme===t.Schemas.file)return l.isEqualOrParent(E(S),E(g),this._ignorePathCasing(S))&&S.query===g.query&&(v||S.fragment===g.fragment);if((0,e.isEqualAuthority)(S.authority,g.authority))return l.isEqualOrParent(S.path,g.path,this._ignorePathCasing(S),"/")&&S.query===g.query&&(v||S.fragment===g.fragment)}return!1}joinPath(S,...g){return I.URI.joinPath(S,...g)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return C.posix.basename(S.path)}extname(S){return C.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let g;return S.scheme===t.Schemas.file?g=I.URI.file(C.dirname(E(S))).path:(g=C.posix.dirname(S.path),S.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),g="/")),S.with({path:g})}normalizePath(S){if(!S.path.length)return S;let g;return S.scheme===t.Schemas.file?g=I.URI.file(C.normalize(E(S))).path:g=C.posix.normalize(S.path),S.with({path:g})}relativePath(S,g){if(S.scheme!==g.scheme||!(0,e.isEqualAuthority)(S.authority,g.authority))return;if(S.scheme===t.Schemas.file){const b=C.relative(E(S),E(g));return P.isWindows?l.toSlashes(b):b}let v=S.path||"/";const m=g.path||"/";if(this._ignorePathCasing(S)){let b=0;for(const f=Math.min(v.length,m.length);b<f&&!(v.charCodeAt(b)!==m.charCodeAt(b)&&v.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);v=m.substr(0,b)+v.substr(b)}return C.posix.relative(v,m)}resolvePath(S,g){if(S.scheme===t.Schemas.file){const v=I.URI.file(C.resolve(E(S),g));return S.with({authority:v.authority,path:v.path})}return g=l.toPosixPath(g),S.with({path:C.posix.resolve(S.path,g)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,g){return S===g||S!==void 0&&g!==void 0&&(0,y.equalsIgnoreCase)(S,g)}hasTrailingPathSeparator(S,g=C.sep){if(S.scheme===t.Schemas.file){const v=E(S);return v.length>l.getRoot(v).length&&v[v.length-1]===g}else{const v=S.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,g=C.sep){return(0,e.hasTrailingPathSeparator)(S,g)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,g=C.sep){let v=!1;if(S.scheme===t.Schemas.file){const m=E(S);v=m!==void 0&&m.length===l.getRoot(m).length&&m[m.length-1]===g}else{g="/";const m=S.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(S,g)?S.with({path:S.path+"/"}):S}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(T,S){const g=[];for(let v=0;v<T.length;v++){const m=S(T[v]);T.some((b,f)=>f===v?!1:(0,e.isEqualOrParent)(m,S(b)))||g.push(T[v])}return g}e.distinctParents=A;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function S(g){const v=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,p]=f.split(":");c&&p&&v.set(c,p)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&v.set(T.META_DATA_MIME,b),v}T.parseMetaData=S})(k=e.DataUri||(e.DataUri={}));function w(T,S,g){if(S){let v=T.path;return v&&v[0]!==C.posix.sep&&(v=C.posix.sep+v),T.with({scheme:g,authority:S,path:v})}return T.with({scheme:g})}e.toLocalResource=w}),define(De[18],Ie([1,0,21,11,3,6,22,10]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(he){return!!he&&typeof he.then=="function"}e.isThenable=E;function D(he){const Y=new l.CancellationTokenSource,me=he(Y.token),be=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(me).then(oe=>{ze.dispose(),Y.dispose(),ke(oe)},oe=>{ze.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=D;function A(he,Y,me){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(me)});he.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=A;function k(he,Y){return new Promise((me,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});he.then(me,be).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function w(he){let Y=-1;const me=he.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),be=await Promise.race(me);return he.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=w;function T(he,Y,me){let be;const ke=setTimeout(()=>{be?.(void 0),me?.()},Y);return Promise.race([he.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=T;function S(he){return new Promise((Y,me)=>{const be=he();E(be)?be.then(Y,me):Y(be)})}e.asPromise=S;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(me,me).then(be)})}return new Promise((me,be)=>{this.queuedPromise.then(me,be)})}return this.activePromise=Y(),new Promise((me,be)=>{this.activePromise.then(ke=>{this.activePromise=null,me(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=g;class v{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=v;class m{constructor(){this.promiseMap=new Map}queue(Y,me){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=m;const b=(he,Y)=>{let me=!0;const be=setTimeout(()=>{me=!1,Y()},he);return{isTriggered:()=>me,dispose:()=>{clearTimeout(be),me=!1}}},f=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,me=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?f(be):b(me,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class p{constructor(Y){this.delayer=new c(Y),this.throttler=new g}trigger(Y,me){return this.delayer.trigger(()=>this.throttler.queue(Y),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class i{constructor(){this._isOpen=!1,this._promise=new Promise((Y,me)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class d extends i{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function a(he,Y){return Y?new Promise((me,be)=>{const ke=setTimeout(()=>{Re.dispose(),me()},he),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):D(me=>a(he,me))}e.timeout=a;function r(he,Y=0){const me=setTimeout(he,Y);return(0,P.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=r;function o(he){const Y=[];let me=0;const be=he.length;function ke(){return me<be?he[me++]():null}function Re(ze){ze!=null&&Y.push(ze);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=o;function u(he,Y=be=>!!be,me=null){let be=0;const ke=he.length,Re=()=>{if(be>=ke)return Promise.resolve(me);const ze=he[be++];return Promise.resolve(ze()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=u;function n(he,Y=be=>!!be,me=null){if(he.length===0)return Promise.resolve(me);let be=he.length;const ke=()=>{be=-1;for(const Re of he)Re.cancel?.()};return new Promise((Re,ze)=>{for(const oe of he)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(me)}).catch(le=>{--be>=0&&(ke(),ze(le))})})}e.firstParallel=n;class s{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((me,be)=>{this.outstandingPromises.push({factory:Y,c:me,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const me=Y.factory();me.then(Y.c,Y.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=s;class h extends s{constructor(){super(1)}}e.Queue=h;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,me=y.extUri){const be=me.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new h,C.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class L{constructor(Y,me){this._token=-1,typeof Y=="function"&&typeof me=="number"&&this.setIfNotSet(Y,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},me)}setIfNotSet(Y,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},me))}}e.TimeoutTimer=L;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setInterval(()=>{Y()},me)}}e.IntervalTimer=M;class U{constructor(Y,me){this.timeoutToken=-1,this.runner=Y,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class R{constructor(Y,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=R;class z extends U{constructor(Y,me){super(Y,me),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class H extends P.Disposable{constructor(Y,me){super(),this.options=Y,this.handler=me,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,I.setTimeout0)(()=>{if(Y)return;const me=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const me=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(me))}}}}();class N{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function V(he,Y,me){let be;for(let ke=0;ke<me;ke++)try{return await he()}catch(Re){be=Re,await a(Y)}throw be}e.retry=V;class B{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,me,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:me},me.then(()=>this.donePending(Y),()=>this.donePending(Y)),me}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let me,be;const ke=new Promise((Re,ze)=>{me=Re,be=ze});this._next={run:Y,promise:ke,promiseResolve:me,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class F{constructor(Y,me=()=>Date.now()){this.interval=Y,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class x{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,me)=>{this.completeCallback=Y,this.errorCallback=me})}complete(Y){return new Promise(me=>{this.completeCallback(Y),this.resolved=!0,me()})}error(Y){return new Promise(me=>{this.errorCallback(Y),this.rejected=!0,me()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var $;(function(he){async function Y(be){let ke;const Re=await Promise.all(be.map(ze=>ze.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}he.settled=Y;function me(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(ze){Re(ze)}})}he.withAsyncBody=me})($=e.Promises||(e.Promises={}));var Q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(me=>{me.emitMany(Y)})}static fromPromise(Y){return new K(async me=>{me.emitMany(await Y)})}static fromPromises(Y){return new K(async me=>{await Promise.all(Y.map(async be=>me.emitOne(await be)))})}static merge(Y){return new K(async me=>{await Promise.all(Y.map(async be=>{for await(const ke of be)me.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const me={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(me)),this.resolve()}catch(be){this.reject(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,me){return new K(async be=>{for await(const ke of Y)be.emitOne(me(ke))})}map(Y){return K.map(this,Y)}static filter(Y,me){return new K(async be=>{for await(const ke of Y)me(ke)&&be.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,me=>!!me)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const me=[];for await(const be of Y)me.push(be);return me}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class de extends K{constructor(Y,me){super(me),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function ee(he){const Y=new l.CancellationTokenSource,me=he(Y.token);return new de(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of me){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=ee}),define(De[107],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new l.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(h,_,L=!1){const M=h||"",U=_||"",R=C.value.collator.compare(M,U);return C.value.collatorIsNumeric&&R===0&&M!==U?M<U?-1:1:R}e.compareFileNames=I;function E(h,_){const L=P.value.collator;return h=h||"",_=_||"",p(L,h,_)}e.compareFileNamesDefault=E;function D(h,_){const L=P.value.collator;return h=h||"",_=_||"",r(h,_)||p(L,h,_)}e.compareFileNamesUpper=D;function A(h,_){const L=P.value.collator;return h=h||"",_=_||"",a(h,_)||p(L,h,_)}e.compareFileNamesLower=A;function k(h,_){return h=h||"",_=_||"",h===_?0:h<_?-1:1}e.compareFileNamesUnicode=k;function w(h,_,L=!1){L||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase());const[M,U]=f(h),[R,z]=f(_);return M!==R?M<R?-1:1:U===z?0:U<z?-1:1}e.noIntlCompareFileNames=w;function T(h,_){const[L,M]=f(h),[U,R]=f(_);let z=C.value.collator.compare(M,R);if(z===0){if(C.value.collatorIsNumeric&&M!==R)return M<R?-1:1;if(z=C.value.collator.compare(L,U),C.value.collatorIsNumeric&&z===0&&L!==U)return L<U?-1:1}return z}e.compareFileExtensions=T;function S(h,_){h=h||"",_=_||"";const L=c(h),M=c(_),U=P.value.collator,R=y.value.collator;return p(R,L,M)||p(U,h,_)}e.compareFileExtensionsDefault=S;function g(h,_){h=h||"",_=_||"";const L=c(h),M=c(_),U=P.value.collator,R=y.value.collator;return p(R,L,M)||r(h,_)||p(U,h,_)}e.compareFileExtensionsUpper=g;function v(h,_){h=h||"",_=_||"";const L=c(h),M=c(_),U=P.value.collator,R=y.value.collator;return p(R,L,M)||a(h,_)||p(U,h,_)}e.compareFileExtensionsLower=v;function m(h,_){h=h||"",_=_||"";const L=c(h).toLowerCase(),M=c(_).toLowerCase();return L!==M?L<M?-1:1:h!==_?h<_?-1:1:0}e.compareFileExtensionsUnicode=m;const b=/^(.*?)(\.([^.]*))?$/;function f(h,_=!1){const L=h?b.exec(h):[];let M=[L&&L[1]||"",L&&L[3]||""];return _&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function c(h){const _=h?b.exec(h):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function p(h,_,L){const M=h.compare(_,L);return M!==0?M:_.length!==L.length?_.length<L.length?-1:1:0}function i(h){const _=h.charAt(0);return _.toLocaleUpperCase()!==_}function d(h){const _=h.charAt(0);return _.toLocaleLowerCase()!==_}function a(h,_){return i(h)&&d(_)?-1:d(h)&&i(_)?1:0}function r(h,_){return d(h)&&i(_)?-1:i(h)&&d(_)?1:0}function o(h,_,L=!1){return L||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase()),h===_?0:h<_?-1:1}function u(h,_,L=!1){const M=h.split(t.sep),U=_.split(t.sep),R=M.length-1,z=U.length-1;let H,N;for(let V=0;;V++){if(H=R===V,N=z===V,H&&N)return I(M[V],U[V],L);if(H)return-1;if(N)return 1;const B=o(M[V],U[V],L);if(B!==0)return B}}e.comparePaths=u;function n(h,_,L){const M=h.toLowerCase(),U=_.toLowerCase(),R=s(h,_,L);if(R)return R;const z=M.endsWith(L),H=U.endsWith(L);if(z!==H)return z?-1:1;const N=I(M,U);return N!==0?N:M.localeCompare(U)}e.compareAnything=n;function s(h,_,L){const M=h.toLowerCase(),U=_.toLowerCase(),R=M.startsWith(L),z=U.startsWith(L);if(R!==z)return R?-1:1;if(R&&z){if(M.length<U.length)return-1;if(M.length>U.length)return 1}return 0}e.compareByPrefix=s}),define(De[108],Ie([1,0,107,106,79,9,10,8]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,D=[E,[]];function A(B,F,x,$){if(!B||!F)return D;const Q=B.length,K=F.length;if(Q<K)return D;const de=B.toLowerCase();return k(F,x,K,B,de,Q,$)}e.scoreFuzzy=A;function k(B,F,x,$,Q,K,de){const ee=[],he=[];for(let ke=0;ke<x;ke++){const Re=ke*K,ze=Re-K,oe=ke>0,le=B[ke],ge=F[ke];for(let Z=0;Z<K;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,O=ze+Z-1,j=ae?ee[ie]:0,G=oe&&ae?ee[O]:0,X=oe&&ae?he[O]:0;let pe;!G&&oe?pe=0:pe=w(le,ge,$,Q,Z,X),pe&&G+pe>=j&&(de||oe||Q.startsWith(F,Z))?(he[ne]=X+1,ee[ne]=G+pe):(he[ne]=E,ee[ne]=j)}}const Y=[];let me=x-1,be=K-1;for(;me>=0&&be>=0;){const ke=me*K+be;he[ke]===E||(Y.push(be),me--),be--}return[ee[x*K-1],Y.reverse()]}function w(B,F,x,$,Q,K){let de=0;if(!T(F,$[Q]))return de;if(de+=1,K>0&&(de+=K*5),B===x[Q]&&(de+=1),Q===0)de+=8;else{const ee=S(x.charCodeAt(Q-1));ee?de+=ee:(0,t.isUpper)(x.charCodeAt(Q))&&K===0&&(de+=2)}return de}function T(B,F){return B===F?!0:B==="/"||B==="\\"?F==="/"||F==="\\":!1}function S(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function v(B,F,x=0,$=0){const Q=F;return Q.values&&Q.values.length>1?m(B,Q.values,x,$):b(B,F,x,$)}e.scoreFuzzy2=v;function m(B,F,x,$){let Q=0;const K=[];for(const de of F){const[ee,he]=b(B,de,x,$);if(typeof ee!="number")return g;Q+=ee,K.push(...he)}return[Q,s(K)]}function b(B,F,x,$){const Q=(0,t.fuzzyScore)(F.original,F.originalLowercase,x,B,B.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:g}const f=Object.freeze({score:0}),c=1<<18,p=1<<17,i=1<<16;function d(B,F,x,$){const Q=$.values?$.values:[$];return(0,C.hash)({[$.normalized]:{values:Q.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:B,description:F,allowNonContiguousMatches:x}})}function a(B,F,x,$,Q){if(!B||!F.normalized)return f;const K=$.getItemLabel(B);if(!K)return f;const de=$.getItemDescription(B),ee=d(K,de,x,F),he=Q[ee];if(he)return he;const Y=r(K,de,$.getItemPath(B),F,x);return Q[ee]=Y,Y}e.scoreItemFuzzy=a;function r(B,F,x,$,Q){const K=!x||!$.containsPathSeparator;return x&&(y.isLinux?$.pathNormalized===x:(0,I.equalsIgnoreCase)($.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:$.values&&$.values.length>1?o(B,F,x,$.values,K,Q):u(B,F,x,$,K,Q)}function o(B,F,x,$,Q,K){let de=0;const ee=[],he=[];for(const Y of $){const{score:me,labelMatch:be,descriptionMatch:ke}=u(B,F,x,Y,Q,K);if(me===E)return f;de+=me,be&&ee.push(...be),ke&&he.push(...ke)}return{score:de,labelMatch:s(ee),descriptionMatch:s(he)}}function u(B,F,x,$,Q,K){if(Q||!F){const[de,ee]=A(B,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(de){const he=(0,t.matchesPrefix)($.normalized,B);let Y;return he?(Y=p,Y+=Math.round($.normalized.length/B.length*100)):Y=i,{score:Y+de,labelMatch:he||n(ee)}}}if(F){let de=F;x&&(de=`${F}${P.sep}`);const ee=de.length,he=`${de}${B}`,[Y,me]=A(he,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(Y){const be=n(me),ke=[],Re=[];return be.forEach(ze=>{ze.start<ee&&ze.end>ee?(ke.push({start:0,end:ze.end-ee}),Re.push({start:ze.start,end:ee})):ze.start>=ee?ke.push({start:ze.start-ee,end:ze.end-ee}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return f}function n(B){const F=[];if(!B)return F;let x;for(const $ of B)x&&x.end===$?x.end+=1:(x={start:$,end:$+1},F.push(x));return F}function s(B){const F=B.sort((Q,K)=>Q.start-K.start),x=[];let $;for(const Q of F)!$||!h($,Q)?($=Q,x.push(Q)):($.start=Math.min($.start,Q.start),$.end=Math.max($.end,Q.end));return x}function h(B,F){return!(B.end<F.start||F.end<B.start)}function _(B,F,x,$,Q,K){const de=a(B,x,$,Q,K),ee=a(F,x,$,Q,K),he=de.score,Y=ee.score;if((he===c||Y===c)&&he!==Y)return he===c?-1:1;if(he>i||Y>i){if(he!==Y)return he>Y?-1:1;if(he<p&&Y<p){const le=M(de.labelMatch,ee.labelMatch);if(le!==0)return le}const ze=Q.getItemLabel(B)||"",oe=Q.getItemLabel(F)||"";if(ze.length!==oe.length)return ze.length-oe.length}if(he!==Y)return he>Y?-1:1;const me=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(me&&!be)return-1;if(be&&!me)return 1;const ke=L(B,de,Q),Re=L(F,ee,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:U(B,F,x,Q)}e.compareItemsByFuzzyScore=_;function L(B,F,x){let $=-1,Q=-1;if(F.descriptionMatch&&F.descriptionMatch.length?$=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&($=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(Q=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const K=x.getItemDescription(B);K&&(Q+=K.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(Q=F.descriptionMatch[F.descriptionMatch.length-1].end);return Q-$}function M(B,F){if(!B&&!F||(!B||!B.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!B||!B.length)return 1;const x=B[0].start,Q=B[B.length-1].end-x,K=F[0].start,ee=F[F.length-1].end-K;return Q===ee?0:ee<Q?1:-1}function U(B,F,x,$){const Q=$.getItemLabel(B)||"",K=$.getItemLabel(F)||"",de=$.getItemDescription(B),ee=$.getItemDescription(F),he=Q.length+(de?de.length:0),Y=K.length+(ee?ee.length:0);if(he!==Y)return he-Y;const me=$.getItemPath(B),be=$.getItemPath(F);return me&&be&&me.length!==be.length?me.length-be.length:Q!==K?(0,l.compareAnything)(Q,K,x.normalized):de&&ee&&de!==ee?(0,l.compareAnything)(de,ee,x.normalized):me&&be&&me!==be?(0,l.compareAnything)(me,be,x.normalized):0}function R(B){return B.startsWith('"')&&B.endsWith('"')}const z=" ";function H(B){typeof B!="string"&&(B="");const F=B.toLowerCase(),{pathNormalized:x,normalized:$,normalizedLowercase:Q}=N(B),K=x.indexOf(P.sep)>=0,de=R(B);let ee;const he=B.split(z);if(he.length>1)for(const Y of he){const me=R(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=N(Y);ke&&(ee||(ee=[]),ee.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:me}))}return{original:B,originalLowercase:F,pathNormalized:x,normalized:$,normalizedLowercase:Q,values:ee,containsPathSeparator:K,expectContiguousMatch:de}}e.prepareQuery=H;function N(B){let F;y.isWindows?F=B.replace(/\//g,P.sep):F=B.replace(/\\/g,P.sep);const x=(0,I.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:x,normalizedLowercase:x.toLowerCase()}}function V(B){return Array.isArray(B)?H(B.map(F=>F.original).join(z)):H(B.original)}e.pieceToQuery=V}),define(De[37],Ie([1,0,17,18,32,26,9,10,8]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",k="[^/\\\\]",w=/\//g;function T(x,$){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${$?`|${A}${k}+`:""})*?`}}function S(x,$){if(!x)return[];const Q=[];let K=!1,de=!1,ee="";for(const he of x){switch(he){case $:if(!K&&!de){Q.push(ee),ee="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":de=!0;break;case"]":de=!1;break}ee+=he}return ee&&Q.push(ee),Q}e.splitGlobAware=S;function g(x){if(!x)return"";let $="";const Q=S(x,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))$=".*";else{let K=!1;Q.forEach((de,ee)=>{if(de===e.GLOBSTAR){if(K)return;$+=T(2,ee===Q.length-1)}else{let he=!1,Y="",me=!1,be="";for(const ke of de){if(ke!=="}"&&he){Y+=ke;continue}if(me&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,E.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":he=!0;continue;case"[":me=!0;continue;case"}":{$+=`(?:${S(Y,",").map(oe=>g(oe)).join("|")})`,he=!1,Y="";break}case"]":{$+="["+be+"]",me=!1,be="";break}case"?":$+=k;continue;case"*":$+=T(1);continue;default:$+=(0,E.escapeRegExpCharacters)(ke)}}ee<Q.length-1&&(Q[ee+1]!==e.GLOBSTAR||ee+2<Q.length)&&($+=A)}K=de===e.GLOBSTAR})}return $}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new P.LRUCache(1e4),d=function(){return!1},a=function(){return null};function r(x,$){if(!x)return a;let Q;typeof x!="string"?Q=x.pattern:Q=x,Q=Q.trim();const K=`${Q}_${!!$.trimForExclusions}`;let de=i.get(K);if(de)return o(de,x);let ee;return v.test(Q)?de=n(Q.substr(4),Q):(ee=m.exec(u(Q,$)))?de=s(ee[1],Q):($.trimForExclusions?f:b).test(Q)?de=h(Q,$):(ee=c.exec(u(Q,$)))?de=_(ee[1].substr(1),Q,!0):(ee=p.exec(u(Q,$)))?de=_(ee[1],Q,!1):de=L(Q),i.set(K,de),o(de,x)}function o(x,$){if(typeof $=="string")return x;const Q=function(K,de){return(0,C.isEqualOrParent)(K,$.base,!I.isLinux)?x(K.substr($.base.length+1),de):null};return Q.allBasenames=x.allBasenames,Q.allPaths=x.allPaths,Q.basenames=x.basenames,Q.patterns=x.patterns,Q}function u(x,$){return $.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function n(x,$){return function(Q,K){return typeof Q=="string"&&Q.endsWith(x)?$:null}}function s(x,$){const Q=`/${x}`,K=`\\${x}`,de=function(he,Y){return typeof he!="string"?null:Y?Y===x?$:null:he===x||he.endsWith(Q)||he.endsWith(K)?$:null},ee=[x];return de.basenames=ee,de.patterns=[$],de.allBasenames=ee,de}function h(x,$){const Q=B(x.slice(1,-1).split(",").map(Y=>r(Y,$)).filter(Y=>Y!==a),x),K=Q.length;if(!K)return a;if(K===1)return Q[0];const de=function(Y,me){for(let be=0,ke=Q.length;be<ke;be++)if(Q[be](Y,me))return x;return null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function _(x,$,Q){const K=y.sep===y.posix.sep,de=K?x:x.replace(w,y.sep),ee=y.sep+de,he=y.posix.sep+x;let Y;return Q?Y=function(me,be){return typeof me=="string"&&(me===de||me.endsWith(ee)||!K&&(me===x||me.endsWith(he)))?$:null}:Y=function(me,be){return typeof me=="string"&&(me===de||!K&&me===x)?$:null},Y.allPaths=[(Q?"*/":"./")+x],Y}function L(x){try{const $=new RegExp(`^${g(x)}$`);return function(Q){return $.lastIndex=0,typeof Q=="string"&&$.test(Q)?x:null}}catch{return a}}function M(x,$,Q){return!x||typeof $!="string"?!1:U(x)($,void 0,Q)}e.match=M;function U(x,$={}){if(!x)return d;if(typeof x=="string"||R(x)){const Q=r(x,$);if(Q===a)return d;const K=function(de,ee){return!!Q(de,ee)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return N(x,$)}e.parse=U;function R(x){const $=x;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=R;function z(x){return x.allBasenames||[]}e.getBasenameTerms=z;function H(x){return x.allPaths||[]}e.getPathTerms=H;function N(x,$){const Q=B(Object.getOwnPropertyNames(x).map(Y=>V(Y,x[Y],$)).filter(Y=>Y!==a)),K=Q.length;if(!K)return a;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let oe=0,le=Q.length;oe<le;oe++){const ge=Q[oe](ke,Re);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(ze||(ze=[]),ze.push(ge))}return ze?(async()=>{for(const oe of ze){const le=await oe;if(typeof le=="string")return le}return null})():null},me=Q.find(ke=>!!ke.allBasenames);me&&(Y.allBasenames=me.allBasenames);const be=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const de=function(Y,me,be){let ke,Re;for(let ze=0,oe=Q.length;ze<oe;ze++){const le=Q[ze];le.requiresSiblings&&be&&(me||(me=(0,y.basename)(Y)),ke||(ke=me.substr(0,me.length-(0,y.extname)(Y).length)));const ge=le(Y,me,ke,be);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(Re||(Re=[]),Re.push(ge))}return Re?(async()=>{for(const ze of Re){const oe=await ze;if(typeof oe=="string")return oe}return null})():null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function V(x,$,Q){if($===!1)return a;const K=r(x,Q);if(K===a)return a;if(typeof $=="boolean")return K;if($){const de=$.when;if(typeof de=="string"){const ee=(he,Y,me,be)=>{if(!be||!K(he,Y))return null;const ke=de.replace("$(basename)",me),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return ee.requiresSiblings=!0,ee}}return K}function B(x,$){const Q=x.filter(Y=>!!Y.basenames);if(Q.length<2)return x;const K=Q.reduce((Y,me)=>{const be=me.basenames;return be?Y.concat(be):Y},[]);let de;if($){de=[];for(let Y=0,me=K.length;Y<me;Y++)de.push($)}else de=Q.reduce((Y,me)=>{const be=me.patterns;return be?Y.concat(be):Y},[]);const ee=function(Y,me){if(typeof Y!="string")return null;if(!me){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}me=Y.substr(ke)}const be=K.indexOf(me);return be!==-1?de[be]:null};ee.basenames=K,ee.patterns=de,ee.allBasenames=K;const he=x.filter(Y=>!Y.basenames);return he.push(ee),he}function F(x,$){return(0,l.equals)(x,$,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=F}),define(De[109],Ie([1,0,11,157,22,8,2]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(m="",b=!1){if(this.value=m,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(m,b=0){return this.value+=w(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(f,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,b){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(m,b,f){return this.value+="[",this.value+=this._escape(b,"]"),this.value+="](",this.value+=this._escape(String(m),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(m,b){const f=new RegExp((0,P.escapeRegExpCharacters)(b),"g");return m.replace(f,(c,p)=>m.charAt(p-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function D(v){return A(v)?!v.value:Array.isArray(v)?v.every(D):!0}e.isEmptyMarkdownString=D;function A(v){return v instanceof E?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function k(v,m){return v===m?!0:!v||!m?!1:v.value===m.value&&v.isTrusted===m.isTrusted&&v.supportThemeIcons===m.supportThemeIcons&&v.supportHtml===m.supportHtml&&(v.baseUri===m.baseUri||!!v.baseUri&&!!m.baseUri&&(0,C.isEqual)(y.URI.from(v.baseUri),y.URI.from(m.baseUri)))}e.markdownStringEqual=k;function w(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function T(v){return v.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function S(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=S;function g(v){const m=[],b=v.split("|").map(c=>c.trim());v=b[0];const f=b[1];if(f){const c=/height=(\d+)/.exec(f),p=/width=(\d+)/.exec(f),i=c?c[1]:"",d=p?p[1]:"",a=isFinite(parseInt(d)),r=isFinite(parseInt(i));a&&m.push(`width="${d}"`),r&&m.push(`height="${i}"`)}return{href:v,dimensions:m}}e.parseHrefAndDimensions=g}),define(De[110],Ie([1,0,17,32,9,10,22,8]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(a,r){const{os:o,tildify:u,relative:n}=r;if(n){const _=D(a,n,o);if(typeof _=="string")return _}let s=a.fsPath;if(o===1&&!P.isWindows?s=s.replace(/\//g,"\\"):o!==1&&P.isWindows&&(s=s.replace(/\\/g,"/")),o!==1&&u?.userHome){const _=u.userHome.fsPath;let L;a.scheme!==u.userHome.scheme&&a.path.startsWith(C.posix.sep)?L=u.userHome.with({path:a.path}).fsPath:L=a.fsPath,s=w(L,_,o)}return(o===1?C.win32:C.posix).normalize(A(s,o===1))}e.getPathLabel=E;function D(a,r,o){const u=o===1?C.win32:C.posix,n=o===3?y.extUri:y.extUriIgnorePathCase,s=r.getWorkspace(),h=(0,l.firstOrDefault)(s.folders);if(!h)return;a.scheme!==h.uri.scheme&&a.path.startsWith(C.posix.sep)&&(a=h.uri.with({path:a.path}));const _=r.getWorkspaceFolder(a);if(!_)return;let L;if(n.isEqual(_.uri,a)?L="":L=n.relativePath(_.uri,a)??"",L&&(L=u.normalize(L)),s.folders.length>1&&!r.noPrefix){const M=_.name?_.name:n.basenameOrAuthority(_.uri);L=L?`${M} \u2022 ${L}`:M}return L}function A(a,r=P.isWindows){return(0,t.hasDriveLetter)(a,r)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=A;let k=Object.create(null);function w(a,r,o=P.OS){if(o===1||!a||!r)return a;let u=k.original===r?k.normalized:void 0;u||(u=r,P.isWindows&&(u=(0,t.toSlashes)(u)),u=`${(0,I.rtrim)(u,C.posix.sep)}${C.posix.sep}`,k={original:r,normalized:u});let n=a;return P.isWindows&&(n=(0,t.toSlashes)(n)),(o===3?n.startsWith(u):(0,I.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:a}e.tildify=w;function T(a,r){return a.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=T;const S="\u2026",g="\\\\",v="~";function m(a,r=C.sep){const o=new Array(a.length);let u=!1;for(let n=0;n<a.length;n++){const s=a[n];if(s===""){o[n]=`.${r}`;continue}if(!s){o[n]=s;continue}u=!0;let h="",_=s;_.indexOf(g)===0?(h=_.substr(0,_.indexOf(g)+g.length),_=_.substr(_.indexOf(g)+g.length)):_.indexOf(r)===0?(h=_.substr(0,_.indexOf(r)+r.length),_=_.substr(_.indexOf(r)+r.length)):_.indexOf(v)===0&&(h=_.substr(0,_.indexOf(v)+v.length),_=_.substr(_.indexOf(v)+v.length));const L=_.split(r);for(let M=1;u&&M<=L.length;M++)for(let U=L.length-M;u&&U>=0;U--){u=!1;let R=L.slice(U,U+M).join(r);for(let z=0;!u&&z<a.length;z++)if(z!==n&&a[z]&&a[z].indexOf(R)>-1){const H=U+M===L.length,N=U>0&&a[z].indexOf(r)>-1?r+R:R,V=a[z].endsWith(N);u=!H||V}if(!u){let z="";(L[0].endsWith(":")||h!=="")&&(U===1&&(U=0,M++,R=L[0]+r+R),U>0&&(z=L[0]+r),z=h+z),U>0&&(z=z+S+r),z=z+R,U+M<L.length&&(z=z+r+S),o[n]=z}}u&&(o[n]=s)}return o}e.shorten=m;var b;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function f(a,r=Object.create(null)){const o=[];let u=!1,n="";for(const s of a)if(s==="$"||u&&s==="{")n&&o.push({value:n,type:b.TEXT}),n="",u=!0;else if(s==="}"&&u){const h=r[n];if(typeof h=="string")h.length&&o.push({value:h,type:b.VARIABLE});else if(h){const _=o[o.length-1];(!_||_.type!==b.SEPARATOR)&&o.push({value:h.label,type:b.SEPARATOR})}n="",u=!1}else n+=s;return n&&!u&&o.push({value:n,type:b.TEXT}),o.filter((s,h)=>{if(s.type===b.SEPARATOR){const _=o[h-1],L=o[h+1];return[_,L].every(M=>M&&(M.type===b.VARIABLE||M.type===b.TEXT)&&M.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=f;function c(a,r){return P.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):a.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function p(a,r){return P.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,""):P.isWindows?a.replace(/&&|&/g,o=>o==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function d(a){const r=a.indexOf("/")!==-1?C.posix:C.win32,o=r.basename(a),u=r.dirname(a);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=d}),define(De[111],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const w=this._uriTransformer.transformIncoming(k);return w===k?k:t(l.URI.from(w))}transformOutgoing(k){const w=this._uriTransformer.transformOutgoing(k);return w===k?k:t(l.URI.from(w))}transformOutgoingURI(k){const w=this._uriTransformer.transformOutgoing(k);return w===k?k:l.URI.from(w)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,k,w){if(!A||w>200)return null;if(typeof A=="object"){if(A instanceof l.URI)return k.transformOutgoing(A);for(const T in A)if(Object.hasOwnProperty.call(A,T)){const S=P(A[T],k,w+1);S!==null&&(A[T]=S)}}return null}function y(A,k){const w=P(A,k,0);return w===null?A:w}e.transformOutgoingURIs=y;function I(A,k,w,T){if(!A||T>200)return null;if(typeof A=="object"){if(A.$mid===1)return w?l.URI.revive(k.transformIncoming(A)):k.transformIncoming(A);for(const S in A)if(Object.hasOwnProperty.call(A,S)){const g=I(A[S],k,w,T+1);g!==null&&(A[S]=g)}}return null}function E(A,k){const w=I(A,k,!1,0);return w===null?A:w}e.transformIncomingURIs=E;function D(A,k){const w=I(A,k,!0,0);return w===null?A:w}e.transformAndReviveIncomingURIs=D}),define(De[29],Ie([1,0,63,82,305,18,32,80,9,10,22,2]),function(J,e,l,t,C,P,y,I,E,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function T(N,V=w.UNLINK){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return V===w.UNLINK?g(N):S(N)}async function S(N){try{const V=(0,y.randomPath)((0,t.tmpdir)());try{await l.promises.rename(N,V)}catch(B){return B.code==="ENOENT"?void 0:g(N)}g(V).catch(B=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(N){return(0,C.promisify)(l.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function v(N){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function m(N,V){return c(await(V?b(N):(0,C.promisify)(l.readdir)(N)))}async function b(N){try{return await(0,C.promisify)(l.readdir)(N,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const V=[],B=await m(N);for(const F of B){let x=!1,$=!1,Q=!1;try{const K=await e.Promises.lstat((0,E.join)(N,F));x=K.isFile(),$=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}V.push({name:F,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>Q})}return V}function f(N){return c(l.readdirSync(N))}e.readdirSync=f;function c(N){return N.map(V=>typeof V=="string"?D.isMacintosh?(0,I.normalizeNFC)(V):V:(V.name=D.isMacintosh?(0,I.normalizeNFC)(V.name):V.name,V))}async function p(N){const V=await m(N),B=[];for(const F of V)await d.existsDirectory((0,E.join)(N,F))&&B.push(F);return B}function i(N,V=1e3){return new Promise(B=>{let F=!1;const x=setInterval(()=>{F||(F=!0,l.access(N,$=>{F=!1,$&&(clearInterval(x),B(void 0))}))},V)})}e.whenDeleted=i;var d;(function(N){async function V(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(D.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw K}throw Q}}N.stat=V;async function B(x){try{const{stat:$,symbolicLink:Q}=await N.stat(x);return $.isFile()&&Q?.dangling!==!0}catch{}return!1}N.existsFile=B;async function F(x){try{const{stat:$,symbolicLink:Q}=await N.stat(x);return $.isDirectory()&&Q?.dangling!==!0}catch{}return!1}N.existsDirectory=F})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new P.ResourceQueue;function r(N,V,B){return a.queueFor(k.URI.file(N),A.extUriBiasedIgnorePathCase).queue(()=>{const F=h(B);return new Promise((x,$)=>n(N,V,F,Q=>Q?$(Q):x()))})}let o=!0;function u(N){o=N}e.configureFlushOnWrite=u;function n(N,V,B,F){if(!o)return l.writeFile(N,V,{mode:B.mode,flag:B.flag},F);l.open(N,B.flag,B.mode,(x,$)=>{if(x)return F(x);l.writeFile($,V,Q=>{if(Q)return l.close($,()=>F(Q));l.fdatasync($,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),u(!1)),l.close($,de=>F(de))))})})}function s(N,V,B){const F=h(B);if(!o)return l.writeFileSync(N,V,{mode:F.mode,flag:F.flag});const x=l.openSync(N,F.flag,F.mode);try{l.writeFileSync(x,V);try{l.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),u(!1)}}finally{l.closeSync(x)}}e.writeFileSync=s;function h(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function _(N,V){if(N!==V)try{await e.Promises.rename(N,V)}catch(B){if(N.toLowerCase()!==V.toLowerCase()&&B.code==="EXDEV"||N.endsWith("."))await L(N,V,{preserveSymlinks:!1}),await T(N,w.MOVE);else throw B}}async function L(N,V,B){return U(N,V,{root:{source:N,target:V},options:B,handledSourcePaths:new Set})}const M=511;async function U(N,V,B){if(B.handledSourcePaths.has(N))return;B.handledSourcePaths.add(N);const{stat:F,symbolicLink:x}=await d.stat(N);if(x){if(B.options.preserveSymlinks)try{return await H(N,V,B)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return F.isDirectory()?R(N,V,F.mode&M,B):z(N,V,F.mode&M)}async function R(N,V,B,F){await e.Promises.mkdir(V,{recursive:!0,mode:B});const x=await m(N);for(const $ of x)await U((0,E.join)(N,$),(0,E.join)(V,$),F)}async function z(N,V,B){await e.Promises.copyFile(N,V),await e.Promises.chmod(V,B)}async function H(N,V,B){let F=await e.Promises.readlink(N);(0,y.isEqualOrParent)(F,B.root.source,!D.isLinux)&&(F=(0,E.join)(B.root.target,F.substr(B.root.source.length+1))),await e.Promises.symlink(F,V)}e.Promises=new class{get access(){return(0,C.promisify)(l.access)}get stat(){return(0,C.promisify)(l.stat)}get lstat(){return(0,C.promisify)(l.lstat)}get utimes(){return(0,C.promisify)(l.utimes)}get read(){return(N,V,B,F,x)=>new Promise(($,Q)=>{l.read(N,V,B,F,x,(K,de,ee)=>K?Q(K):$({bytesRead:de,buffer:ee}))})}get readFile(){return(0,C.promisify)(l.readFile)}get write(){return(N,V,B,F,x)=>new Promise(($,Q)=>{l.write(N,V,B,F,x,(K,de,ee)=>K?Q(K):$({bytesWritten:de,buffer:ee}))})}get appendFile(){return(0,C.promisify)(l.appendFile)}get fdatasync(){return(0,C.promisify)(l.fdatasync)}get truncate(){return(0,C.promisify)(l.truncate)}get rename(){return(0,C.promisify)(l.rename)}get copyFile(){return(0,C.promisify)(l.copyFile)}get open(){return(0,C.promisify)(l.open)}get close(){return(0,C.promisify)(l.close)}get symlink(){return(0,C.promisify)(l.symlink)}get readlink(){return(0,C.promisify)(l.readlink)}get chmod(){return(0,C.promisify)(l.chmod)}get mkdir(){return(0,C.promisify)(l.mkdir)}get unlink(){return(0,C.promisify)(l.unlink)}get rmdir(){return(0,C.promisify)(l.rmdir)}get realpath(){return(0,C.promisify)(l.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return p}get writeFile(){return r}get rm(){return T}get move(){return _}get copy(){return L}}}),define(De[112],Ie([1,0,63,9,10,8,29]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(w){if(C.isLinux)return w;const T=(0,t.dirname)(w);if(w===T)return w;const S=((0,t.basename)(w)||w).toLowerCase();try{const v=(0,y.readdirSync)(T).filter(m=>m.toLowerCase()===S);if(v.length===1){const m=I(T);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(S);if(m>=0){const b=I(T);if(b)return(0,t.join)(b,v[m])}}}catch{}return null}e.realcaseSync=I;async function E(w){if(C.isLinux)return w;const T=(0,t.dirname)(w);if(w===T)return w;const S=((0,t.basename)(w)||w).toLowerCase();try{const v=(await y.Promises.readdir(T)).filter(m=>m.toLowerCase()===S);if(v.length===1){const m=await E(T);if(m)return(0,t.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(S);if(m>=0){const b=await E(T);if(b)return(0,t.join)(b,v[m])}}}catch{}return null}e.realcase=E;async function D(w){try{return await y.Promises.realpath(w)}catch{const S=k(w);return await y.Promises.access(S,l.constants.R_OK),S}}e.realpath=D;function A(w){try{return l.realpathSync(w)}catch{const S=k(w);return l.accessSync(S,l.constants.R_OK),S}}e.realpathSync=A;function k(w){return(0,P.rtrim)((0,t.normalize)(w),t.sep)}}),define(De[113],Ie([1,0,9,10,36,105,12,29]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function E(k=C.env){return k.comspec||"cmd.exe"}e.getWindowsShell=E;function D(k){let w=[],T=!1;const S=function(g){if(T){w.push(g);return}(!k.send(g,m=>{if(m&&console.error(m),T=!1,w.length>0){const b=w.slice(0);w=[],b.forEach(f=>S(f))}})||t.isWindows)&&(T=!0)};return{send:S}}e.createQueuedSender=D;var A;(function(k){async function w(T,S,g){if(l.isAbsolute(T))return T;if(S===void 0&&(S=C.cwd()),l.dirname(T)!=="."||(g===void 0&&y.isString(C.env.PATH)&&(g=C.env.PATH.split(l.delimiter)),g===void 0||g.length===0))return l.join(S,T);async function m(b){if(await I.Promises.exists(b)){let f;try{f=await I.Promises.stat(b)}catch(c){c.message.startsWith("EACCES")&&(f=await I.Promises.lstat(b))}return f?!f.isDirectory():!1}return!1}for(const b of g){let f;if(l.isAbsolute(b)?f=l.join(b,T):f=l.join(S,b,T),await m(f))return f;let c=f+".com";if(await m(c)||(c=f+".exe",await m(c)))return c}return l.join(S,T)}k.findExecutable=w})(A=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(J,e,l,t){var C=arguments.length,P=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var I=J.length-1;I>=0;I--)(y=J[I])&&(P=(C<3?y(P):C>3?y(e,l,P):y(e,l))||P);return C>3&&P&&Object.defineProperty(e,l,P),P};define(De[114],Ie([1,0,17,18,23,21,59,11,3,6,81,8,12]),function(J,e,l,t,C,P,y,I,E,D,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function S(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function v(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class b{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}class f{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function p(x){const $=C.VSBuffer.alloc(4);return $.writeUInt32BE(x,0),$}function i(x){return x.read(4).readUInt32BE(0)}function d(x){const $=C.VSBuffer.alloc(1);return $.writeUInt8(x,0),$}const a={Undefined:d(c.Undefined),String:d(c.String),Buffer:d(c.Buffer),VSBuffer:d(c.VSBuffer),Array:d(c.Array),Object:d(c.Object)},r=typeof Buffer<"u";function o(x,$){if(typeof $>"u")x.write(a.Undefined);else if(typeof $=="string"){const Q=C.VSBuffer.fromString($);x.write(a.String),x.write(p(Q.byteLength)),x.write(Q)}else if(r&&Buffer.isBuffer($)){const Q=C.VSBuffer.wrap($);x.write(a.Buffer),x.write(p(Q.byteLength)),x.write(Q)}else if($ instanceof C.VSBuffer)x.write(a.VSBuffer),x.write(p($.byteLength)),x.write($);else if(Array.isArray($)){x.write(a.Array),x.write(p($.length));for(const Q of $)o(x,Q)}else{const Q=C.VSBuffer.fromString(JSON.stringify($));x.write(a.Object),x.write(p(Q.byteLength)),x.write(Q)}}function u(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(i(x)).toString();case c.Buffer:return x.read(i(x)).buffer;case c.VSBuffer:return x.read(i(x));case c.Array:{const Q=i(x),K=[];for(let de=0;de<Q;de++)K.push(u(x));return K}case c.Object:return JSON.parse(x.read(i(x)).toString())}}class n{constructor($,Q,K=null,de=1e3){this.protocol=$,this.ctx=Q,this.logger=K,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,v($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,v($.type),$.data);return}}}send($,Q=void 0){const K=new f;return o(K,$),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new b($),K=u(Q),de=u(Q),ee=K[0];switch(ee){case 100:return this.logger?.logIncoming($.byteLength,K[1],1,`${S(ee)}: ${K[2]}.${K[3]}`,de),this.onPromise({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.logger?.logIncoming($.byteLength,K[1],1,`${S(ee)}: ${K[2]}.${K[3]}`,de),this.onEventListen({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.logger?.logIncoming($.byteLength,K[1],1,`${S(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]});case 103:return this.logger?.logIncoming($.byteLength,K[1],1,`${S(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=new P.CancellationTokenSource;let de;try{de=Q.call(this.ctx,$.name,$.arg,K.token)}catch(Y){de=Promise.reject(Y)}const ee=$.id;de.then(Y=>{this.sendResponse({id:ee,data:Y,type:201}),this.activeRequests.delete($.id)},Y=>{Y instanceof Error?this.sendResponse({id:ee,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ee,data:Y,type:203}),this.activeRequests.delete($.id)});const he=(0,D.toDisposable)(()=>K.cancel());this.activeRequests.set($.id,he)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=$.id,ee=Q.listen(this.ctx,$.name,$.arg)(he=>this.sendResponse({id:K,data:he,type:204}));this.activeRequests.set($.id,ee)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:K})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var s;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel($){const Q=this;return{call(K,de,ee){return Q.isDisposed?Promise.reject(new I.CancellationError):Q.requestPromise($,K,de,ee)},listen(K,de){return Q.isDisposed?E.Event.None:Q.requestEvent($,K,de)}}}requestPromise($,Q,K,de=P.CancellationToken.None){const ee=this.lastRequestId++,Y={id:ee,type:100,channelName:$,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new I.CancellationError);let me;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new I.CancellationError);const ze=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(ee),ke(ae.data);break;case 202:{this.handlers.delete(ee);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(ee),Re(ae.data);break}};this.handlers.set(ee,Z),this.sendRequest(Y)};let oe=null;this.state===m.Idle?ze():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,ze()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:ee,type:101}),Re(new I.CancellationError)},ge=de.onCancellationRequested(le);me=(0,D.combinedDisposable)((0,D.toDisposable)(le),ge),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent($,Q,K){const de=this.lastRequestId++,he={id:de,type:102,channelName:$,name:Q,arg:K};let Y=null;const me=new E.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(me),this.sendRequest(he)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(me),this.sendRequest({id:de,type:103}))}}),be=ke=>me.fire(ke.data);return this.handlers.set(de,be),me.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(Q,$.id,0,`${S($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger?.logOutgoing(Q,$.id,0,S($.type));return}}}send($,Q=void 0){const K=new f;return o(K,$),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new b($),K=u(Q),de=u(Q),ee=K[0];switch(ee){case 200:return this.logger?.logIncoming($.byteLength,0,0,v(ee)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,K[1],0,v(ee),de),this.onResponse({type:K[0],id:K[1],data:de})}}onResponse($){if($.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([y.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class _{get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Q,onDidClientDisconnect:K})=>{E.Event.once(Q.onMessage)(ee=>{const he=new b(ee),Y=u(he),me=new n(Q,Y),be=new h(Q);this.channels.forEach((Re,ze)=>me.registerChannel(ze,Re));const ke={channelServer:me,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{me.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel($,Q){const K=this;return{call(de,ee,he){let Y;if((0,w.isFunction)(Q)){const be=(0,l.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):E.Event.toPromise(E.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,de,ee);const me=Y.then(be=>be.channelClient.getChannel($));return M(me).call(de,ee,he)},listen(de,ee){if((0,w.isFunction)(Q))return K.getMulticastEvent($,Q,de,ee);const he=Q.routeEvent(K,de,ee).then(Y=>Y.channelClient.getChannel($));return M(he).listen(de,ee)}}}getMulticastEvent($,Q,K,de){const ee=this;let he=new D.DisposableStore;const Y=new E.Emitter({onFirstListenerAdd:()=>{he=new D.DisposableStore;const me=new E.EventMultiplexer,be=new Map,ke=ze=>{const le=ze.channelClient.getChannel($).listen(K,de),ge=me.add(le);be.set(ze,ge)},Re=ze=>{const oe=be.get(ze);!oe||(oe.dispose(),be.delete(ze))};ee.connections.filter(Q).forEach(ke),E.Event.filter(ee.onDidAddConnection,Q)(ke,void 0,he),ee.onDidRemoveConnection(Re,void 0,he),me.event(Y.fire,Y,he),he.add(me)},onLastListenerRemove:()=>{he.dispose()}});return Y.event}registerChannel($,Q){this.channels.set($,Q),this._connections.forEach(K=>{K.channelServer.registerChannel($,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class L{constructor($,Q,K=null){const de=new f;o(de,Q),$.send(de.buffer),this.channelClient=new h($,K),this.channelServer=new n($,Q,K)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(x){return{call($,Q,K){return x.then(de=>de.call($,Q,K))},listen($,Q){const K=new E.Relay;return x.then(de=>K.input=de.listen($,Q)),K.event}}}e.getDelayedChannel=M;function U(x){let $=!1;return{call(Q,K,de){return $?x.call(Q,K,de):(0,t.timeout)(0).then(()=>$=!0).then(()=>x.call(Q,K,de))},listen(Q,K){if($)return x.listen(Q,K);const de=new E.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>de.input=x.listen(Q,K)),de.event}}}e.getNextTickChannel=U;class R{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=R;var z;(function(x){function $(ee,he){const Y=ee,me=he&&he.disableMarshalling,be=new Map;for(const ke in Y)K(ke)&&be.set(ke,E.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const oe=be.get(Re);if(oe)return oe;if(de(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const oe=Y[Re];if(typeof oe=="function"){if(!me&&Array.isArray(ze))for(let le=0;le<ze.length;le++)ze[le]=(0,A.revive)(ze[le]);return oe.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}x.fromService=$;function Q(ee,he){const Y=he&&he.disableMarshalling;return new Proxy({},{get(me,be){if(typeof be=="string")return he?.properties?.has(be)?he.properties.get(be):de(be)?function(ke){return ee.listen(be,ke)}:K(be)?ee.listen(be):async function(...ke){let Re;he&&!(0,w.isUndefinedOrNull)(he.context)?Re=[he.context,...ke]:Re=ke;const ze=await ee.call(be,Re);return Y?ze:(0,A.revive)(ze)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=Q;function K(ee){return ee[0]==="o"&&ee[1]==="n"&&k.isUpperAsciiLetter(ee.charCodeAt(2))}function de(ee){return/^onDynamic/.test(ee)&&k.isUpperAsciiLetter(ee.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const $=x.toString();if($!=="[object Object]")return $}return x}function V(x){return Array.isArray(x)?x.map(N):N(x)}function B(x,$,Q,K,de,ee,he){he=V(he);const Y=H[de],me=Y[K%Y.length];let be=[`%c[${x}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(ee)?(be=be.concat(he),be.push(")")):be.push(he),console.log.apply(console,be)}e.logWithColors=B;class F{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,K,de,ee){this._totalOutgoing+=$,B(this._outgoingPrefix,this._totalOutgoing,$,Q,K,de,ee)}logIncoming($,Q,K,de,ee){this._totalIncoming+=$,B(this._incomingPrefix,this._totalIncoming,$,Q,K,de,ee)}}e.IPCLogger=F}),define(De[115],Ie([1,0,23,3,6,114]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(r){r.enableDiagnostics=!1,r.records=[];const o=new WeakMap;let u=0;function n(h,_){if(!o.has(h)){const L=String(++u);o.set(h,L)}return o.get(h)}function s(h,_,L,M){if(!r.enableDiagnostics)return;const U=n(h,_);if(M instanceof l.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const R=l.VSBuffer.alloc(M.byteLength);R.set(M),r.records.push({timestamp:Date.now(),id:U,label:_,type:L,buff:R})}else r.records.push({timestamp:Date.now(),id:U,label:_,type:L,data:M})}r.traceSocketEvent=s})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function A(){return D||(D=l.VSBuffer.alloc(0)),D}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return A();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const _=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),_}if(this._chunks[0].byteLength>o){const _=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),_}const n=l.VSBuffer.alloc(o);let s=0,h=0;for(;o>0;){const _=this._chunks[h];if(_.byteLength>o){const L=_.slice(0,o);n.set(L,s),s+=o,u&&(this._chunks[h]=_.slice(o),this._totalLength-=o),o-=o}else n.set(_,s),s+=_.byteLength,u?(this._chunks.shift(),this._totalLength-=_.byteLength):h++,o-=_.byteLength}return n}}e.ChunkStream=k;var w;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(w||(w={}));function T(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,u,n,s){this.type=o,this.id=u,this.ack=n,this.data=s,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.Disposable{constructor(o){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,s=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new g(n,s,h,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=l.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(u,o.data)}_bufferAdd(o,u){const n=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,n}_bufferTake(){const o=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class b extends C.Disposable{constructor(o){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=b;class f extends P.IPCClient{static fromSocket(o,u){return new f(new b(o),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,u,n=null){super(o,u,n),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class p{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,u=this._first;for(;u;)u=u.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let u=0,n=this._first;for(;n;)o[u++]=n.data,n=n.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new p(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class d{static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<d._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=d._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),u=(1+d._HISTORY_LENGTH)*1e3;let n=0;for(let s=0;s<d._HISTORY_LENGTH;s++)o-this.lastRuns[s]<=u&&n++;return 1-n/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class a{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o,u=null,n=d.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,A());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new g(7,0,0,A());this._socketWriter.write(o)}sendResume(){const o=new g(8,0,0,A());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,A());this._socketWriter.write(o);const u=this._outgoingUnackMsg.toArray();for(let n=0,s=u.length;n<s;n++)this._socketWriter.write(u[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new g(6,0,0,A())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let n=0,s=u.length;n<s;n++)this._socketWriter.write(u[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new g(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(o){const u=new g(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime,n=Date.now()-this._socketReader.lastReadTime,s=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&n>=2e4&&s>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:n});return}const h=Math.max(2e4-u,2e4-n,2e4-s,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,A());this._socketWriter.write(o)}_sendKeepAlive(){const o=new g(9,0,0,A());this._socketWriter.write(o)}}e.PersistentProtocol=a}),define(De[116],Ie([1,0,23,11,3,6,9,10,31,114,115]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class w{traceSocketEvent(n,s){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,s)}constructor(n,s=""){this._canWrite=!0,this.debugLabel=s,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener),this._closeListener=h=>{this.traceSocketEvent("close",{hadError:h}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const s=h=>{this.traceSocketEvent("read",h),n(l.VSBuffer.wrap(h))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(n){const s=h=>{n({type:0,hadError:h,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(n){const s=()=>{n()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,t.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,t.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=w;var T;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var S;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(S||(S={}));class g extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,s){this.socket.traceSocketEvent(n,s)}constructor(n,s,h,_){super(),this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:h?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new v(this,s,h,_,this._onData,(L,M)=>this._write(L,M))),this._register(this._flowManager.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,s){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let h=2;n.byteLength<126?h+=0:n.byteLength<2**16?h+=2:h+=8;const _=l.VSBuffer.alloc(h);if(s?_.writeUInt8(194,0):_.writeUInt8(130,0),n.byteLength<126)_.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){_.writeUInt8(126,1);let L=1;_.writeUInt8(n.byteLength>>>8&255,++L),_.writeUInt8(n.byteLength>>>0&255,++L)}else{_.writeUInt8(127,1);let L=1;_.writeUInt8(0,++L),_.writeUInt8(0,++L),_.writeUInt8(0,++L),_.writeUInt8(0,++L),_.writeUInt8(n.byteLength>>>24&255,++L),_.writeUInt8(n.byteLength>>>16&255,++L),_.writeUInt8(n.byteLength>>>8&255,++L),_.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(l.VSBuffer.concat([_,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const s=this._incomingData.peek(this._state.readLen),h=s.readUInt8(0),_=(h&128)>>>7,L=(h&64)>>>6,M=s.readUInt8(1),U=(M&128)>>>7,R=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const s=this._incomingData.read(this._state.readLen),h=s.readUInt8(1),_=(h&128)>>>7;let L=h&127,M=1;L===126?L=s.readUInt8(++M)*2**8+s.readUInt8(++M):L===127&&(L=s.readUInt8(++M)*0+s.readUInt8(++M)*0+s.readUInt8(++M)*0+s.readUInt8(++M)*0+s.readUInt8(++M)*2**24+s.readUInt8(++M)*2**16+s.readUInt8(++M)*2**8+s.readUInt8(++M));let U=0;_&&(U=s.readUInt8(++M)*2**24+s.readUInt8(++M)*2**16+s.readUInt8(++M)*2**8+s.readUInt8(++M)),this._state.state=3,this._state.readLen=L,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const s=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),f(s,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(s,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await C.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class v extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}constructor(n,s,h,_,L,M){super(),this._tracer=n,this._onData=L,this._writeFn=M,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new C.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,s?(this._zlibInflateStream=this._register(new m(this._tracer,_,h,{windowBits:15})),this._zlibDeflateStream=this._register(new b(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const s=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(s,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,s){return new Promise((h,_)=>{n.write(s),n.flush(L=>h(L))})}acceptFrame(n,s,h){this._readQueue.push({data:n,isCompressed:s,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const s=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(s)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,s,h){return new Promise((_,L)=>{n.write(s),h&&n.write(l.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>_(M))})}}class m extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}constructor(n,s,h,_){super(),this._tracer=n,this._recordInflateBytes=s,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(_),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(l.VSBuffer.wrap(L))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const s=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(s)})}}class b extends P.Disposable{constructor(n,s){super(),this._tracer=n,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(l.VSBuffer.wrap(h))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let s=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,s=s.slice(0,s.byteLength-4),n(s)})}}function f(u,n){if(n===0)return;const s=u.byteLength>>>2;for(let R=0;R<s;R++){const z=u.readUInt32BE(R*4);u.writeUInt32BE(z^n,R*4)}const h=s*4,_=u.byteLength-h,L=n>>>24&255,M=n>>>16&255,U=n>>>8&255;_>=1&&u.writeUInt8(u.readUInt8(h)^L,h),_>=2&&u.writeUInt8(u.readUInt8(h+1)^M,h+1),_>=3&&u.writeUInt8(u.readUInt8(h+2)^U,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function p(){const u=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):n=(0,y.join)(k().os.tmpdir(),`vscode-ipc-${u}.sock`),d(n),n}e.createRandomIPCHandle=p;function i(u,n,s){const h=k().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${s}-${n}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${s}-${n}.sock`):_=(0,y.join)(u,`${s}-${n}.sock`),d(_),_}e.createStaticIPCHandle=i;function d(u){const n=c[I.platform];typeof n=="number"&&u.length>=n&&console.warn(`WARNING: IPC handle "${u}" is longer than ${n} chars, try a shorter --user-data-dir`)}class a extends D.IPCServer{static toClientConnectionEvent(n){const s=C.Event.fromNodeEventEmitter(n,"connection");return C.Event.map(s,h=>({protocol:new A.Protocol(new w(h,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(h,"close"))}))}constructor(n){super(a.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function r(u){return new Promise((n,s)=>{const h=k().net.createServer();h.on("error",s),h.listen(u,()=>{h.removeListener("error",s),n(new a(h))})})}e.serve=r;function o(u,n){return new Promise((s,h)=>{const _=k().net.createConnection(u,()=>{_.removeListener("error",h),s(A.Client.fromSocket(new w(_,`ipc-client${n}`),n))});_.once("error",h)})}e.connect=o}),define(De[158],Ie([1,0,37,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(P,y,I,E,D,A){if(Array.isArray(P)){let k=0;for(const w of P){const T=C(w,y,I,E,D,A);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return E?P==="*"?5:P===I?10:0:0;if(P){const{language:k,pattern:w,scheme:T,hasAccessToAllModels:S,notebookType:g}=P;if(!E&&!S)return 0;g&&D&&(y=D);let v=0;if(T)if(T===y.scheme)v=10;else if(T==="*")v=5;else return 0;if(k)if(k===I)v=10;else if(k==="*")v=Math.max(v,5);else return 0;if(g)if(g===A)v=10;else if(g==="*"&&A!==void 0)v=Math.max(v,5);else return 0;if(w){let m;if(typeof w=="string"?m=w:m={...w,base:(0,t.normalize)(w.base)},m===y.fsPath||(0,l.match)(m,y.fsPath))v=10;else return 0}return v}else return 0}}e.score=C}),define(De[159],Ie([1,0,8,49,150]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(I,E,D,A){this._uri=I,this._lines=E,this._eol=D,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const E=I.changes;for(const D of E)this._acceptDeleteRange(D.range),this._acceptInsertText(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,E=this._lines.length,D=new Uint32Array(E);for(let A=0;A<E;A++)D[A]=this._lines[A].length+I;this._lineStarts=new C.PrefixSumComputer(D)}}_setLineText(I,E){this._lines[I]=E,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,E){if(E.length===0)return;const D=(0,l.splitLines)(E);if(D.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+D[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}D[D.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+D[0]);const A=new Uint32Array(D.length-1);for(let k=1;k<D.length;k++)this._lines.splice(I.lineNumber+k-1,0,D[k]),A[k-1]=D[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,A)}}e.MirrorTextModel=P}),define(De[160],Ie([1,0,8,147,49,35,103]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class E{constructor(b,f,c,p){this.searchString=b,this.isRegex=f,this.matchCase=c,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=D(this.searchString):b=this.searchString.indexOf(`
`)>=0;let f=null;try{f=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!f)return null;let c=!this.isRegex&&!b;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new y.SearchData(f,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=E;function D(m){if(!m||m.length===0)return!1;for(let b=0,f=m.length;b<f;b++){const c=m.charCodeAt(b);if(c===10)return!0;if(c===92){if(b++,b>=f)break;const p=m.charCodeAt(b);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=D;function A(m,b,f){if(!f)return new y.FindMatch(m,null);const c=[];for(let p=0,i=b.length;p<i;p++)c[p]=b[p];return new y.FindMatch(m,c)}e.createFindMatch=A;class k{constructor(b){const f=[];let c=0;for(let p=0,i=b.length;p<i;p++)b.charCodeAt(p)===10&&(f[c++]=p);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(b){const f=this._lineFeedsOffsets;let c=0,p=f.length-1;if(p===-1||b<=f[0])return 0;for(;c<p;){const i=c+((p-c)/2>>0);f[i]>=b?p=i-1:f[i+1]>=b?(c=i,p=i):c=i+1}return c+1}}class w{static findMatches(b,f,c,p,i){const d=f.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(b,c,new v(d.wordSeparators,d.regex),p,i):this._doFindMatchesLineByLine(b,c,d,p,i):[]}static _getMultilineMatchRange(b,f,c,p,i,d){let a,r=0;p?(r=p.findLineFeedCountBeforeOffset(i),a=f+i+r):a=f+i;let o;if(p){const h=p.findLineFeedCountBeforeOffset(i+d.length)-r;o=a+d.length+h}else o=a+d.length;const u=b.getPositionAt(a),n=b.getPositionAt(o);return new P.Range(u.lineNumber,u.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(b,f,c,p,i){const d=b.getOffsetAt(f.getStartPosition()),a=b.getValueInRange(f,1),r=b.getEOL()===`\r
`?new k(a):null,o=[];let u=0,n;for(c.reset(0);n=c.next(a);)if(o[u++]=A(this._getMultilineMatchRange(b,d,a,r,n.index,n[0]),n,p),u>=i)return o;return o}static _doFindMatchesLineByLine(b,f,c,p,i){const d=[];let a=0;if(f.startLineNumber===f.endLineNumber){const o=b.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return a=this._findMatchesInLine(c,o,f.startLineNumber,f.startColumn-1,a,d,p,i),d}const r=b.getLineContent(f.startLineNumber).substring(f.startColumn-1);a=this._findMatchesInLine(c,r,f.startLineNumber,f.startColumn-1,a,d,p,i);for(let o=f.startLineNumber+1;o<f.endLineNumber&&a<i;o++)a=this._findMatchesInLine(c,b.getLineContent(o),o,0,a,d,p,i);if(a<i){const o=b.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);a=this._findMatchesInLine(c,o,f.endLineNumber,0,a,d,p,i)}return d}static _findMatchesInLine(b,f,c,p,i,d,a,r){const o=b.wordSeparators;if(!a&&b.simpleSearch){const s=b.simpleSearch,h=s.length,_=f.length;let L=-h;for(;(L=f.indexOf(s,L+h))!==-1;)if((!o||g(o,f,_,L,h))&&(d[i++]=new y.FindMatch(new P.Range(c,L+1+p,c,L+1+h+p),null),i>=r))return i;return i}const u=new v(b.wordSeparators,b.regex);let n;u.reset(0);do if(n=u.next(f),n&&(d[i++]=A(new P.Range(c,n.index+1+p,c,n.index+1+n[0].length+p),n,a),i>=r))return i;while(n);return i}static findNextMatch(b,f,c,p){const i=f.parseSearchRequest();if(!i)return null;const d=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(b,c,d,p):this._doFindNextMatchLineByLine(b,c,d,p)}static _doFindNextMatchMultiline(b,f,c,p){const i=new C.Position(f.lineNumber,1),d=b.getOffsetAt(i),a=b.getLineCount(),r=b.getValueInRange(new P.Range(i.lineNumber,i.column,a,b.getLineMaxColumn(a)),1),o=b.getEOL()===`\r
`?new k(r):null;c.reset(f.column-1);const u=c.next(r);return u?A(this._getMultilineMatchRange(b,d,r,o,u.index,u[0]),u,p):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(b,new C.Position(1,1),c,p):null}static _doFindNextMatchLineByLine(b,f,c,p){const i=b.getLineCount(),d=f.lineNumber,a=b.getLineContent(d),r=this._findFirstMatchInLine(c,a,d,f.column,p);if(r)return r;for(let o=1;o<=i;o++){const u=(d+o-1)%i,n=b.getLineContent(u+1),s=this._findFirstMatchInLine(c,n,u+1,1,p);if(s)return s}return null}static _findFirstMatchInLine(b,f,c,p,i){b.reset(p-1);const d=b.next(f);return d?A(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,i):null}static findPreviousMatch(b,f,c,p){const i=f.parseSearchRequest();if(!i)return null;const d=new v(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(b,c,d,p):this._doFindPreviousMatchLineByLine(b,c,d,p)}static _doFindPreviousMatchMultiline(b,f,c,p){const i=this._doFindMatchesMultiline(b,new P.Range(1,1,f.lineNumber,f.column),c,p,10*I);if(i.length>0)return i[i.length-1];const d=b.getLineCount();return f.lineNumber!==d||f.column!==b.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(b,new C.Position(d,b.getLineMaxColumn(d)),c,p):null}static _doFindPreviousMatchLineByLine(b,f,c,p){const i=b.getLineCount(),d=f.lineNumber,a=b.getLineContent(d).substring(0,f.column-1),r=this._findLastMatchInLine(c,a,d,p);if(r)return r;for(let o=1;o<=i;o++){const u=(i+d-o-1)%i,n=b.getLineContent(u+1),s=this._findLastMatchInLine(c,n,u+1,p);if(s)return s}return null}static _findLastMatchInLine(b,f,c,p){let i=null,d;for(b.reset(0);d=b.next(f);)i=A(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,p);return i}}e.TextModelSearch=w;function T(m,b,f,c,p){if(c===0)return!0;const i=b.charCodeAt(c-1);if(m.get(i)!==0||i===13||i===10)return!0;if(p>0){const d=b.charCodeAt(c);if(m.get(d)!==0)return!0}return!1}function S(m,b,f,c,p){if(c+p===f)return!0;const i=b.charCodeAt(c+p);if(m.get(i)!==0||i===13||i===10)return!0;if(p>0){const d=b.charCodeAt(c+p-1);if(m.get(d)!==0)return!0}return!1}function g(m,b,f,c,p){return T(m,b,f,c,p)&&S(m,b,f,c,p)}e.isValidMatch=g;class v{constructor(b,f){this._wordSeparators=b,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const f=b.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(c=this._searchRegex.exec(b),!c))return null;const p=c.index,i=c[0].length;if(p===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){l.getNextCodePoint(b,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=p,this._prevMatchLength=i,!this._wordSeparators||g(this._wordSeparators,b,f,p,i))return c}while(c);return null}}e.Searcher=v}),define(De[117],Ie([1,0,23,10]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function P(k){for(let w=0,T=k.length;w<T;w+=4){const S=k[w+0],g=k[w+1],v=k[w+2],m=k[w+3];k[w+0]=m,k[w+1]=v,k[w+2]=g,k[w+3]=S}}function y(k){const w=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(w),l.VSBuffer.wrap(w)}function I(k){const w=k.buffer;if(t.isLittleEndian()||P(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const T=new Uint8Array(w.byteLength);return T.set(w),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(k){const w=new Uint32Array(D(k));let T=0;if(w[T++]=k.id,k.type==="full")w[T++]=1,w[T++]=k.data.length,w.set(k.data,T),T+=k.data.length;else{w[T++]=2,w[T++]=k.deltas.length;for(const S of k.deltas)w[T++]=S.start,w[T++]=S.deleteCount,S.data?(w[T++]=S.data.length,w.set(S.data,T),T+=S.data.length):w[T++]=0}return y(w)}e.encodeSemanticTokensDto=E;function D(k){let w=0;if(w+=1+1,k.type==="full")w+=1+k.data.length;else{w+=1,w+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(w+=T.data.length)}return w}function A(k){const w=I(k);let T=0;const S=w[T++];if(w[T++]===1){const b=w[T++],f=w.subarray(T,T+b);return T+=b,{id:S,type:"full",data:f}}const v=w[T++],m=[];for(let b=0;b<v;b++){const f=w[T++],c=w[T++],p=w[T++];let i;p>0&&(i=w.subarray(T,T+p),T+=p),m[b]={start:f,deleteCount:c,data:i}}return{id:S,type:"delta",deltas:m}}e.decodeSemanticTokensDto=A}),define(De[161],Ie([1,0,3,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,E){return this._map.set(I,E),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===E&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,E){this._factories.get(I)?.dispose();const D=new P(this,I,E);return this._factories.set(I,D),(0,t.toDisposable)(()=>{const A=this._factories.get(I);!A||A!==D||(this._factories.delete(I),A.dispose())})}async getOrCreate(I){const E=this.get(I);if(E)return E;const D=this._factories.get(I);return!D||D.isResolved?null:(await D.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const D=this._factories.get(I);return!!(!D||D.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=C;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(I,E,D){super(),this._registry=I,this._languageId=E,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(De[64],Ie([1,0,76,2,35,161]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(h,_,L){this._tokenBrand=void 0,this.offset=h,this.type=_,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class I{constructor(h,_){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=_}}e.TokenizationResult=I;class E{constructor(h,_){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=_}}e.EncodedTokenizationResult=E;var D;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(s){const h=new Map;h.set(0,l.Codicon.symbolMethod),h.set(1,l.Codicon.symbolFunction),h.set(2,l.Codicon.symbolConstructor),h.set(3,l.Codicon.symbolField),h.set(4,l.Codicon.symbolVariable),h.set(5,l.Codicon.symbolClass),h.set(6,l.Codicon.symbolStruct),h.set(7,l.Codicon.symbolInterface),h.set(8,l.Codicon.symbolModule),h.set(9,l.Codicon.symbolProperty),h.set(10,l.Codicon.symbolEvent),h.set(11,l.Codicon.symbolOperator),h.set(12,l.Codicon.symbolUnit),h.set(13,l.Codicon.symbolValue),h.set(15,l.Codicon.symbolEnum),h.set(14,l.Codicon.symbolConstant),h.set(15,l.Codicon.symbolEnum),h.set(16,l.Codicon.symbolEnumMember),h.set(17,l.Codicon.symbolKeyword),h.set(27,l.Codicon.symbolSnippet),h.set(18,l.Codicon.symbolText),h.set(19,l.Codicon.symbolColor),h.set(20,l.Codicon.symbolFile),h.set(21,l.Codicon.symbolReference),h.set(22,l.Codicon.symbolCustomColor),h.set(23,l.Codicon.symbolFolder),h.set(24,l.Codicon.symbolTypeParameter),h.set(25,l.Codicon.account),h.set(26,l.Codicon.issues);function _(U){let R=h.get(U);return R||(console.info("No codicon found for CompletionItemKind "+U),R=l.Codicon.symbolProperty),R}s.toIcon=_;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function M(U,R){let z=L.get(U);return typeof z>"u"&&!R&&(z=9),z}s.fromString=M})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(s){s[s.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(s){return s&&t.URI.isUri(s.uri)&&C.Range.isIRange(s.range)&&(C.Range.isIRange(s.originSelectionRange)||C.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=b;var f;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var c;(function(s){s[s.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var p;(function(s){const h=new Map;h.set(0,l.Codicon.symbolFile),h.set(1,l.Codicon.symbolModule),h.set(2,l.Codicon.symbolNamespace),h.set(3,l.Codicon.symbolPackage),h.set(4,l.Codicon.symbolClass),h.set(5,l.Codicon.symbolMethod),h.set(6,l.Codicon.symbolProperty),h.set(7,l.Codicon.symbolField),h.set(8,l.Codicon.symbolConstructor),h.set(9,l.Codicon.symbolEnum),h.set(10,l.Codicon.symbolInterface),h.set(11,l.Codicon.symbolFunction),h.set(12,l.Codicon.symbolVariable),h.set(13,l.Codicon.symbolConstant),h.set(14,l.Codicon.symbolString),h.set(15,l.Codicon.symbolNumber),h.set(16,l.Codicon.symbolBoolean),h.set(17,l.Codicon.symbolArray),h.set(18,l.Codicon.symbolObject),h.set(19,l.Codicon.symbolKey),h.set(20,l.Codicon.symbolNull),h.set(21,l.Codicon.symbolEnumMember),h.set(22,l.Codicon.symbolStruct),h.set(23,l.Codicon.symbolEvent),h.set(24,l.Codicon.symbolOperator),h.set(25,l.Codicon.symbolTypeParameter);function _(L){let M=h.get(L);return M||(console.info("No codicon found for SymbolKind "+L),M=l.Codicon.symbolProperty),M}s.toIcon=_})(p=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(h){this.value=h}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var d;(function(s){function h(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}s.is=h})(d=e.Command||(e.Command={}));var a;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var r;(function(s){s[s.Unresolved=0]="Unresolved",s[s.Resolved=1]="Resolved"})(r=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var u;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[118],Ie([1,0,162,10,102,17,24,146]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,Ve){return Ve}}class w{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=w;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new w(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const Ve=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new w(se,!Ve)}let Ee=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const fe=T(re[Ve],se[Ve]);fe.didChange&&(re[Ve]=fe.newValue,Ee=!0)}return new w(re,Ee)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class g{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,Ve){return Ve}}function v(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=v;class m extends g{constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="boolean",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return v(se,this.defaultValue)}}function b(re,se,Ee,Ve){if(typeof re>"u")return se;let fe=parseInt(re,10);return isNaN(fe)?se:(fe=Math.max(Ee,fe),fe=Math.min(Ve,fe),fe|0)}e.clampedInt=b;class f extends g{static clampedInt(se,Ee,Ve,fe){return b(se,Ee,Ve,fe)}constructor(se,Ee,Ve,fe,Ae,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=Ve,Le.minimum=fe,Le.maximum=Ae),super(se,Ee,Ve,Le),this.minimum=fe,this.maximum=Ae}validate(se){return f.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class c extends g{static clamp(se,Ee,Ve){return se<Ee?Ee:se>Ve?Ve:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const Ve=parseFloat(se);return isNaN(Ve)?Ee:Ve}constructor(se,Ee,Ve,fe,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=Ve),super(se,Ee,Ve,Ae),this.validationFn=fe}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class p extends g{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="string",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return p.string(se,this.defaultValue)}}function i(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=i;class d extends g{constructor(se,Ee,Ve,fe,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=fe,Ae.default=Ve),super(se,Ee,Ve,Ae),this._allowedValues=fe}validate(se){return i(se,this.defaultValue,this._allowedValues)}}class a extends k{constructor(se,Ee,Ve,fe,Ae,Le,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ae,Me.default=fe),super(se,Ee,Ve,Me),this._allowedValues=Ae,this._convert=Le}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function r(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,Ve){return Ve===0?se.accessibilitySupport:Ve}}class u extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:v(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(re){switch(re){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function L(re){switch(re){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends S{constructor(){super(130)}compute(se,Ee,Ve){const fe=["monaco-editor"];return Ee.get(34)&&fe.push(Ee.get(34)),se.extraEditorClassName&&fe.push(se.extraEditorClassName),Ee.get(67)==="default"?fe.push("mouse-default"):Ee.get(67)==="copy"&&fe.push("mouse-copy"),Ee.get(101)&&fe.push("showUnused"),Ee.get(128)&&fe.push("showDeprecated"),fe.join(" ")}}class U extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,Ve){return Ve&&se.emptySelectionClipboard}}class R extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:v(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":i(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":i(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(Ee.loop,this.defaultValue.loop)}}}class z extends k{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class H extends S{constructor(){super(45)}compute(se,Ee,Ve){return se.fontInfo}}class N extends g{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=c.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ee,6,100)}compute(se,Ee,Ve){return se.fontInfo.fontSize}}class V extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(f.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class B extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:i(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??i(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??i(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??i(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??i(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??i(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),delay:f.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:v(Ee.sticky,this.defaultValue.sticky),above:v(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends S{constructor(){super(133)}compute(se,Ee,Ve){return $.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,Ve=se.scrollBeyondLastLine?Ee-1:0,fe=(se.viewLineCount+Ve)/(se.pixelRatio*se.height),Ae=Math.floor(se.viewLineCount/fe);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ve,desiredRatio:fe,minimapLineCount:Ae}}static _computeMinimapLayout(se,Ee){const Ve=se.outerWidth,fe=se.outerHeight,Ae=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*fe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:fe};const Le=Ee.stableMinimapLayoutInput,Me=Le&&se.outerHeight===Le.outerHeight&&se.lineHeight===Le.lineHeight&&se.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&se.pixelRatio===Le.pixelRatio&&se.scrollBeyondLastLine===Le.scrollBeyondLastLine&&se.minimap.enabled===Le.minimap.enabled&&se.minimap.side===Le.minimap.side&&se.minimap.size===Le.minimap.size&&se.minimap.showSlider===Le.minimap.showSlider&&se.minimap.renderCharacters===Le.minimap.renderCharacters&&se.minimap.maxColumn===Le.minimap.maxColumn&&se.minimap.scale===Le.minimap.scale&&se.verticalScrollbarWidth===Le.verticalScrollbarWidth&&se.isViewportWrapping===Le.isViewportWrapping,Ke=se.lineHeight,Je=se.typicalHalfwidthCharacterWidth,st=se.scrollBeyondLastLine,ot=se.minimap.renderCharacters;let it=Ae>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const lt=se.minimap.maxColumn,vt=se.minimap.size,wt=se.minimap.side,ft=se.verticalScrollbarWidth,Et=se.viewLineCount,Ft=se.remainingWidth,Mt=se.isViewportWrapping,Qe=ot?2:3;let zt=Math.floor(Ae*fe);const Ot=zt/Ae;let Pt=!1,gt=!1,kt=Qe*it,Pe=it/Ae,Oe=1;if(vt==="fill"||vt==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:pt,desiredRatio:St,minimapLineCount:Tt}=$.computeContainedMinimapLineCount({viewLineCount:Et,scrollBeyondLastLine:st,height:fe,lineHeight:Ke,pixelRatio:Ae});if(Et/Tt>1)Pt=!0,gt=!0,it=1,kt=1,Pe=it/Ae;else{let _t=!1,bt=it+1;if(vt==="fit"){const Ct=Math.ceil((Et+pt)*kt);Mt&&Me&&Ft<=Ee.stableFitRemainingWidth?(_t=!0,bt=Ee.stableFitMaxMinimapScale):_t=Ct>zt}if(vt==="fill"||_t){Pt=!0;const Ct=it;kt=Math.min(Ke*Ae,Math.max(1,Math.floor(1/St))),Mt&&Me&&Ft<=Ee.stableFitRemainingWidth&&(bt=Ee.stableFitMaxMinimapScale),it=Math.min(bt,Math.max(1,Math.floor(kt/Qe))),it>Ct&&(Oe=Math.min(2,it/Ct)),Pe=it/Ae/Oe,zt=Math.ceil(Math.max(rt,Et+pt)*kt),Mt?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=it):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(lt*Pe),te=Math.min(_e,Math.max(0,Math.floor((Ft-ft-2)*Pe/(Je+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ae*te);const xe=Fe/Ae;Fe=Math.floor(Fe*Oe);const nt=ot?1:2,Ge=wt==="left"?0:Ve-te-ft;return{renderMinimap:nt,minimapLeft:Ge,minimapWidth:te,minimapHeightIsEditorHeight:Pt,minimapIsSampling:gt,minimapScale:it,minimapLineHeight:kt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Ot}}static computeLayout(se,Ee){const Ve=Ee.outerWidth|0,fe=Ee.outerHeight|0,Ae=Ee.lineHeight|0,Le=Ee.lineNumbersDigitCount|0,Me=Ee.typicalHalfwidthCharacterWidth,Ke=Ee.maxDigitWidth,Je=Ee.pixelRatio,st=Ee.viewLineCount,ot=se.get(125),it=ot==="inherit"?se.get(124):ot,lt=it==="inherit"?se.get(120):it,vt=se.get(123),wt=se.get(2),ft=Ee.isDominatedByLongLines,Et=se.get(51),Ft=se.get(61).renderType!==0,Mt=se.get(62),Qe=se.get(95),zt=se.get(66),Ot=se.get(93),Pt=Ot.verticalScrollbarSize,gt=Ot.verticalHasArrows,kt=Ot.arrowSize,Pe=Ot.horizontalScrollbarSize,Oe=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const Ht=parseFloat(Oe.substr(0,Oe.length-2));Fe=f.clampedInt(Ht*Me,0,0,1e3)}else Fe=f.clampedInt(Oe,0,0,1e3);_e&&te&&(Fe+=16);let xe=0;if(Ft){const Ht=Math.max(Le,Mt);xe=Math.round(Ht*Ke)}let nt=0;Et&&(nt=Ae);let Ge=0,rt=Ge+nt,pt=rt+xe,St=pt+Fe;const Tt=Ve-nt-xe-Fe;let It=!1,_t=!1,bt=-1;wt!==2&&(it==="inherit"&&ft?(It=!0,_t=!0):lt==="on"||lt==="bounded"?_t=!0:lt==="wordWrapColumn"&&(bt=vt));const Ct=$._computeMinimapLayout({outerWidth:Ve,outerHeight:fe,lineHeight:Ae,typicalHalfwidthCharacterWidth:Me,pixelRatio:Je,scrollBeyondLastLine:Qe,minimap:zt,verticalScrollbarWidth:Pt,viewLineCount:st,remainingWidth:Tt,isViewportWrapping:_t},Ee.memory||new A);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Ge+=Ct.minimapWidth,rt+=Ct.minimapWidth,pt+=Ct.minimapWidth,St+=Ct.minimapWidth);const en=Tt-Ct.minimapWidth,yt=Math.max(1,Math.floor((en-Pt-2)/Me)),qt=gt?kt:0;return _t&&(bt=Math.max(1,yt),lt==="bounded"&&(bt=Math.min(bt,vt))),{width:Ve,height:fe,glyphMarginLeft:Ge,glyphMarginWidth:nt,lineNumbersLeft:rt,lineNumbersWidth:xe,decorationsLeft:pt,decorationsWidth:Fe,contentLeft:St,contentWidth:en,minimap:Ct,viewportColumn:yt,isWordWrapMinified:It,isViewportWrapping:_t,wrappingColumn:bt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Pe,overviewRuler:{top:qt,width:Pt,height:fe-2*qt,right:0}}}}e.EditorLayoutInfoComputer=$;class Q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}class K extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:i(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:v(Ee.padding,this.defaultValue.padding)}}}class ee extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,Ve){return se.fontInfo.lineHeight}}class he extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),autohide:v(Ee.autohide,this.defaultValue.autohide),size:i(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ee.side,this.defaultValue.side,["right","left"]),showSlider:i(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Ee.scale,1,1,3),maxColumn:f.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:f.clampedInt(Ee.top,0,0,1e3),bottom:f.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),cycle:v(Ee.cycle,this.defaultValue.cycle)}}}class ke extends S{constructor(){super(131)}compute(se,Ee,Ve){return se.pixelRatio}}class Re extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Je=se?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:Ve,strings:fe}=se,Ae=["on","inline","off"];let Le,Me,Ke;return typeof Ee=="boolean"?Le=Ee?"on":"off":Le=i(Ee,this.defaultValue.other,Ae),typeof Ve=="boolean"?Me=Ve?"on":"off":Me=i(Ve,this.defaultValue.comments,Ae),typeof fe=="boolean"?Ke=fe?"on":"off":Ke=i(fe,this.defaultValue.strings,Ae),{other:Le,comments:Me,strings:Ke}}}var ze;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ze=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,Ve=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ve}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class ge extends k{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const Ve of se)if(typeof Ve=="number")Ee.push({column:f.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const fe=Ve;Ee.push({column:f.clampedInt(fe.column,0,0,1e4),color:fe.color})}return Ee.sort((Ve,fe)=>Ve.column-fe.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,Ve=f.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),fe=f.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:v(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:f.clampedInt(Ee.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:fe,verticalSliderSize:f.clampedInt(Ee.verticalSliderSize,fe,0,1e3),scrollByPage:v(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let Ve=!1;Ee.allowedCharacters&&se&&(y.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},Ve=!0)),Ee.allowedLocales&&se&&(y.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},Ve=!0));const fe=super.applyUpdate(se,Ee);return Ve?new w(fe.newValue,!0):fe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const Ve={};for(const[fe,Ae]of Object.entries(se))Ae===!0&&(Ve[fe]=!0);return Ve}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),mode:i(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends k{constructor(){const se={enabled:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:v(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:v(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const Ve=Ee.indexOf(re);return Ve===-1?se:Ee[Ve]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:i(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:v(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:v(Ee.preview,this.defaultValue.preview),previewMode:i(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(Ee.showMethods,this.defaultValue.showMethods),showFunctions:v(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:v(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:v(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:v(Ee.showFields,this.defaultValue.showFields),showVariables:v(Ee.showVariables,this.defaultValue.showVariables),showClasses:v(Ee.showClasses,this.defaultValue.showClasses),showStructs:v(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:v(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:v(Ee.showModules,this.defaultValue.showModules),showProperties:v(Ee.showProperties,this.defaultValue.showProperties),showEvents:v(Ee.showEvents,this.defaultValue.showEvents),showOperators:v(Ee.showOperators,this.defaultValue.showOperators),showUnits:v(Ee.showUnits,this.defaultValue.showUnits),showValues:v(Ee.showValues,this.defaultValue.showValues),showConstants:v(Ee.showConstants,this.defaultValue.showConstants),showEnums:v(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:v(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(Ee.showKeywords,this.defaultValue.showKeywords),showWords:v(Ee.showWords,this.defaultValue.showWords),showColors:v(Ee.showColors,this.defaultValue.showColors),showFiles:v(Ee.showFiles,this.defaultValue.showFiles),showReferences:v(Ee.showReferences,this.defaultValue.showReferences),showFolders:v(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:v(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:v(Ee.showUsers,this.defaultValue.showUsers),showIssues:v(Ee.showIssues,this.defaultValue.showIssues)}}}class pe extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends S{constructor(){super(132)}compute(se,Ee,Ve){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends S{constructor(){super(134)}compute(se,Ee,Ve){const fe=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:fe.isWordWrapMinified,isViewportWrapping:fe.isViewportWrapping,wrappingColumn:fe.wrappingColumn}}}class We extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(re){return e.editorOptionsRegistry[re.id]=re,re}var at;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Ne(new o),accessibilityPageSize:Ne(new f(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null),tags:["accessibility"]})),ariaLabel:Ne(new p(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Ne(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Ne(new m(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Ne(new O),bracketPairGuides:Ne(new j),stickyTabStops:Ne(new m(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Ne(new m(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Ne(new p(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Ne(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Ne(new m(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Ne(new m(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Ne(new u),contextmenu:Ne(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new m(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Ne(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Ne(new m(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Ne(new a(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:l.localize(199,null)})),cursorSurroundingLines:Ne(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Ne(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Ne(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Ne(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new m(30,"domReadOnly",!1)),dragAndDrop:Ne(new m(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Ne(new U),dropIntoEditor:Ne(new We),stickyScroll:Ne(new K),extraEditorClassName:Ne(new p(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new c(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Ne(new R),fixedOverflowWidgets:Ne(new m(37,"fixedOverflowWidgets",!1)),folding:Ne(new m(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Ne(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Ne(new m(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Ne(new m(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Ne(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Ne(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Ne(new p(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Ne(new H),fontLigatures2:Ne(new z),fontSize:Ne(new N),fontWeight:Ne(new V),formatOnPaste:Ne(new m(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Ne(new m(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Ne(new m(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Ne(new B),hideCursorInOverviewRuler:Ne(new m(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Ne(new F),inDiffEditor:Ne(new m(55,"inDiffEditor",!1)),letterSpacing:Ne(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Ne(new Q),lineDecorationsWidth:Ne(new g(59,"lineDecorationsWidth",10)),lineHeight:Ne(new ee),lineNumbers:Ne(new oe),lineNumbersMinChars:Ne(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new m(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Ne(new m(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Ne(new d(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Ne(new he),mouseStyle:Ne(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new c(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Ne(new m(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Ne(new m(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Ne(new a(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Ne(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Ne(new m(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Ne(new m(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Ne(new f(75,"overviewRulerLanes",3,0,3)),padding:Ne(new me),parameterHints:Ne(new be),peekWidgetDefaultFocus:Ne(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Ne(new m(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Ne(new Re),quickSuggestionsDelay:Ne(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Ne(new m(82,"readOnly",!1)),renameOnType:Ne(new m(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Ne(new m(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Ne(new m(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Ne(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Ne(new m(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Ne(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Ne(new f(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new m(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Ne(new ge),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new f(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Ne(new m(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Ne(new m(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Ne(new m(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Ne(new m(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Ne(new m(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Ne(new m(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Ne(new m(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Ne(new de),snippetSuggestions:Ne(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Ne(new pe),smoothScrolling:Ne(new m(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Ne(new f(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new X),inlineSuggest:Ne(new ie),suggestFontSize:Ne(new f(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new f(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new m(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Ne(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Ne(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Ne(new f(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ne),unusualLineTerminators:Ne(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Ne(new m(117,"useShadowDOM",!0)),useTabStops:Ne(new m(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Ne(new p(119,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Ne(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Ne(new p(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new p(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new f(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Ne(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new a(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Ne(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new ke),tabFocusMode:Ne(new we),layoutInfo:Ne(new $),wrappingInfo:Ne(new ye)}}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[187],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[188],Ie([1,0,22,42,165,306]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(m){return m=m.trim(),m==="*"||y.test(m)}e.isValidVersionStr=E;function D(m){if(!E(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=m.match(y);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=D;function A(m){if(!m)return null;const b=m.majorBase,f=m.majorMustEqual,c=m.minorBase;let p=m.minorMustEqual;const i=m.patchBase;let d=m.patchMustEqual;m.hasCaret&&(b===0||(p=!1),d=!1);let a=0;if(m.preRelease){const r=I.exec(m.preRelease);if(r){const[,o,u,n]=r;a=Date.UTC(Number(o),Number(u)-1,Number(n))}}return{majorBase:b,majorMustEqual:f,minorBase:c,minorMustEqual:p,patchBase:i,patchMustEqual:d,isMinimum:m.hasGreaterEquals,notBefore:a}}e.normalizeVersion=A;function k(m,b,f){let c;typeof m=="string"?c=A(D(m)):c=m;let p;b instanceof Date?p=b.getTime():typeof b=="string"&&(p=new Date(b).getTime());let i;if(typeof f=="string"?i=A(D(f)):i=f,!c||!i)return!1;const d=c.majorBase,a=c.minorBase,r=c.patchBase;let o=i.majorBase,u=i.minorBase,n=i.patchBase;const s=i.notBefore;let h=i.majorMustEqual,_=i.minorMustEqual,L=i.patchMustEqual;return i.isMinimum?d>o?!0:d<o?!1:a>u?!0:a<u||p&&p<s?!1:r>=n:(d===1&&o===0&&(!h||!_||!L)&&(o=1,u=0,n=0,h=!0,_=!1,L=!1),d<o?!1:d>o?!h:a<u?!1:a>u?!_:r<n?!1:r>n?!L:!(p&&p<s))}e.isValidVersion=k;function w(m,b,f,c,p){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([t.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([t.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([t.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([t.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([t.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!v(c.extensionDependencies))return i.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!v(c.activationEvents))return i.push([t.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([t.default.Error,C.localize(9,null,"main")]),i;{const r=(0,l.joinPath)(f,c.main);(0,l.isEqualOrParent)(r,f)||i.push([t.default.Warning,C.localize(10,null,r.path,f.path)])}if(typeof c.activationEvents>"u")return i.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),i}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([t.default.Error,C.localize(12,null,"browser")]),i;{const r=(0,l.joinPath)(f,c.browser);(0,l.isEqualOrParent)(r,f)||i.push([t.default.Warning,C.localize(13,null,r.path,f.path)])}if(typeof c.activationEvents>"u")return i.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),i}if(!P.valid(c.version))return i.push([t.default.Error,C.localize(15,null)]),i;const d=[];if(!T(m,b,c,p,d))for(const r of d)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=w;function T(m,b,f,c,p){return c||typeof f.main>"u"&&typeof f.browser>"u"?!0:g(m,b,f.engines.vscode,p)}e.isValidExtensionVersion=T;function S(m,b,f){return m==="*"||g(b,f,m)}e.isEngineValid=S;function g(m,b,f,c=[]){const p=A(D(f));if(!p)return c.push(C.localize(16,null,f)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return c.push(C.localize(17,null,f)),!1}else if(!p.majorMustEqual)return c.push(C.localize(18,null,f)),!1;return k(m,b,p)?!0:(c.push(C.localize(19,null,m,f)),!1)}function v(m){if(!Array.isArray(m))return!1;for(let b=0,f=m.length;b<f;b++)if(typeof m[b]!="string")return!1;return!0}}),define(De[119],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(C,P=[],y=!1){this.ctor=C,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=l}),define(De[83],Ie([1,0,119]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function P(I,E,D){E instanceof l.SyncDescriptor||(E=new l.SyncDescriptor(E,[],Boolean(D))),t.push([I,E])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(De[189],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const I=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(y);I.outgoing.set(E.key,E),E.incoming.set(I.key,I)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const I of this._nodes.values())I.outgoing.delete(y),I.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let I=this._nodes.get(y);return I||(I=new l(y,P),this._nodes.set(y,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,I]of this._nodes)P.push(`${y}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const I=new Set([P]),E=this._findCycle(y,I);if(E)return E}}_findCycle(P,y){for(const[I,E]of P.outgoing){if(y.has(I))return[...y,I].join(" -> ");y.add(I);const D=this._findCycle(E,y);if(D)return D;y.delete(I)}}}e.Graph=t}),define(De[4],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=I})(l=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(y,I,E){I[l.DI_TARGET]===I?I[l.DI_DEPENDENCIES].push({id:y,index:E}):(I[l.DI_DEPENDENCIES]=[{id:y,index:E}],I[l.DI_TARGET]=I)}function C(y){if(l.serviceIds.has(y))return l.serviceIds.get(y);const I=function(E,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,E,A)};return I.toString=()=>y,l.serviceIds.set(y,I),I}e.createDecorator=C;function P(y){return y}e.refineServiceDecorator=P}),define(De[65],Ie([1,0,12,2,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function D(m,b){const f=Object.create(null);for(const c in m)A(f,c,m[c],b);return f}e.toValuesTree=D;function A(m,b,f,c){const p=b.split("."),i=p.pop();let d=m;for(let a=0;a<p.length;a++){const r=p[a];let o=d[r];switch(typeof o){case"undefined":o=d[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${b} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(o)}`);return}d=o}if(typeof d=="object"&&d!==null)try{d[i]=f}catch{c(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=A;function k(m,b){const f=b.split(".");w(m,f)}e.removeFromValueTree=k;function w(m,b){const f=b.shift();if(b.length===0){delete m[f];return}if(Object.keys(m).indexOf(f)!==-1){const c=m[f];typeof c=="object"&&!Array.isArray(c)&&(w(c,b),Object.keys(c).length===0&&delete m[f])}}function T(m,b,f){function c(d,a){let r=d;for(const o of a){if(typeof r!="object"||r===null)return;r=r[o]}return r}const p=b.split("."),i=c(m,p);return typeof i>"u"?f:i}e.getConfigurationValue=T;function S(m,b,f){Object.keys(b).forEach(c=>{c!=="__proto__"&&(c in m?l.isObject(m[c])&&l.isObject(b[c])?S(m[c],b[c],f):f&&(m[c]=b[c]):m[c]=b[c])})}e.merge=S;function g(m,b,f){const c=m.inspect(b),p=m.inspect(f);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:c.defaultValue}e.getMigratedSettingValue=g;function v(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(De[52],Ie([1,0,10,8,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const y=Object.prototype.hasOwnProperty;var I;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return k.INSTANCE}static true(){return w.INSTANCE}static has(R){return T.create(R)}static equals(R,z){return S.create(R,z)}static notEquals(R,z){return m.create(R,z)}static regex(R,z){return a.create(R,z)}static in(R,z){return g.create(R,z)}static notIn(R,z){return v.create(R,z)}static not(R){return b.create(R)}static and(...R){return u.create(R,null)}static or(...R){return n.create(R,null,!0)}static greater(R,z){return c.create(R,z)}static greaterEquals(R,z){return p.create(R,z)}static smaller(R,z){return i.create(R,z)}static smallerEquals(R,z){return d.create(R,z)}static deserialize(R,z=!1){if(!!R)return this._deserializeOrExpression(R,z)}static _deserializeOrExpression(R,z){const H=R.split("||");return n.create(H.map(N=>this._deserializeAndExpression(N,z)),null,!0)}static _deserializeAndExpression(R,z){const H=R.split("&&");return u.create(H.map(N=>this._deserializeOne(N,z)),null)}static _deserializeOne(R,z){if(R=R.trim(),R.indexOf("!=")>=0){const H=R.split("!=");return m.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf("==")>=0){const H=R.split("==");return S.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf("=~")>=0){const H=R.split("=~");return a.create(H[0].trim(),this._deserializeRegexValue(H[1],z))}if(R.indexOf(" not in ")>=0){const H=R.split(" not in ");return v.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf(" in ")>=0){const H=R.split(" in ");return g.create(H[0].trim(),this._deserializeValue(H[1],z))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const H=R.split(">=");return p.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const H=R.split(">");return c.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const H=R.split("<=");return d.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const H=R.split("<");return i.create(H[0].trim(),H[1].trim())}return/^\!\s*/.test(R)?b.create(R.substr(1).trim()):T.create(R)}static _deserializeValue(R,z){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const H=/^'([^']*)'$/.exec(R);return H?H[1].trim():R}static _deserializeRegexValue(R,z){if((0,t.isFalsyOrWhitespace)(R)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const H=R.indexOf("/"),N=R.lastIndexOf("/");if(H===N||H<0){if(z)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const V=R.slice(H+1,N),B=R[N+1]==="i"?"i":"";try{return new RegExp(V,B)}catch(F){if(z)throw new Error(`bad regexp-value '${R}', parse error: ${F}`);return console.warn(`bad regexp-value '${R}', parse error: ${F}`),null}}}e.ContextKeyExpr=E;function D(U,R){const z=U?U.substituteConstants():void 0,H=R?R.substituteConstants():void 0;return!z&&!H?!0:!z||!H?!1:z.equals(H)}e.expressionsAreEqualWithConstantSubstitution=D;function A(U,R){return U.cmp(R)}class k{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class w{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class T{static create(R,z=null){const H=P.get(R);return typeof H=="boolean"?H?w.INSTANCE:k.INSTANCE:new T(R,z)}constructor(R,z){this.key=R,this.negated=z,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:h(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=P.get(this.key);return typeof R=="boolean"?R?w.INSTANCE:k.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class S{static create(R,z,H=null){if(typeof z=="boolean")return z?T.create(R,H):b.create(R,H);const N=P.get(R);return typeof N=="boolean"?z===(N?"true":"false")?w.INSTANCE:k.INSTANCE:new S(R,z,H)}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=P.get(this.key);if(typeof R=="boolean"){const z=R?"true":"false";return this.value===z?w.INSTANCE:k.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class g{static create(R,z){return new g(R,z)}constructor(R,z){this.key=R,this.valueKey=z,this.type=10,this.negated=null}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const z=R.getValue(this.valueKey),H=R.getValue(this.key);return Array.isArray(z)?z.includes(H):typeof H=="string"&&typeof z=="object"&&z!==null?y.call(z,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class v{static create(R,z){return new v(R,z)}constructor(R,z){this.key=R,this.valueKey=z,this.type=11,this._negated=g.create(R,z)}cmp(R){return R.type!==this.type?this.type-R.type:this._negated.cmp(R._negated)}equals(R){return R.type===this.type?this._negated.equals(R._negated):!1}substituteConstants(){return this}evaluate(R){return!this._negated.evaluate(R)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(R){return R.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=v;class m{static create(R,z,H=null){if(typeof z=="boolean")return z?b.create(R,H):T.create(R,H);const N=P.get(R);return typeof N=="boolean"?z===(N?"true":"false")?k.INSTANCE:w.INSTANCE:new m(R,z,H)}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=P.get(this.key);if(typeof R=="boolean"){const z=R?"true":"false";return this.value===z?k.INSTANCE:w.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class b{static create(R,z=null){const H=P.get(R);return typeof H=="boolean"?H?k.INSTANCE:w.INSTANCE:new b(R,z)}constructor(R,z){this.key=R,this.negated=z,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:h(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=P.get(this.key);return typeof R=="boolean"?R?k.INSTANCE:w.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function f(U,R){if(typeof U=="string"){const z=parseFloat(U);isNaN(z)||(U=z)}return typeof U=="string"||typeof U=="number"?R(U):k.INSTANCE}class c{static create(R,z,H=null){return f(z,N=>new c(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class p{static create(R,z,H=null){return f(z,N=>new p(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=p;class i{static create(R,z,H=null){return f(z,N=>new i(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class d{static create(R,z,H=null){return f(z,N=>new d(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class a{static create(R,z){return new a(R,z)}constructor(R,z){this.key=R,this.regexp=z,this.type=7,this.negated=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const z=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return z<H?-1:z>H?1:0}equals(R){if(R.type===this.type){const z=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return this.key===R.key&&z===H}return!1}substituteConstants(){return this}evaluate(R){const z=R.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{static create(R){return new r(R)}constructor(R){this._actual=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new r(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function o(U){let R=null;for(let z=0,H=U.length;z<H;z++){const N=U[z].substituteConstants();if(U[z]!==N&&R===null){R=[];for(let V=0;V<z;V++)R[V]=U[V]}R!==null&&(R[z]=N)}return R===null?U:R}class u{static create(R,z){return u._normalizeArr(R,z)}constructor(R,z){this.expr=R,this.negated=z,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const N=A(this.expr[z],R.expr[z]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(R.expr[z]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:u.create(R,this.negated)}evaluate(R){for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].evaluate(R))return!1;return!0}static _normalizeArr(R,z){const H=[];let N=!1;for(const V of R)if(!!V){if(V.type===1){N=!0;continue}if(V.type===0)return k.INSTANCE;if(V.type===6){H.push(...V.expr);continue}H.push(V)}if(H.length===0&&N)return w.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(A);for(let V=1;V<H.length;V++)H[V-1].equals(H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0];for(;H.length>1;){const V=H[H.length-1];if(V.type!==9)break;H.pop();const B=H.pop(),F=H.length===0,x=n.create(V.expr.map($=>u.create([$,B],null)),null,F);x&&(H.push(x),H.sort(A))}return H.length===1?H[0]:new u(H,z)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const z of this.expr)R.push(...z.keys());return R}map(R){return new u(this.expr.map(z=>z.map(R)),null)}negate(){if(!this.negated){const R=[];for(const z of this.expr)R.push(z.negate());this.negated=n.create(R,this,!0)}return this.negated}}class n{static create(R,z,H){return n._normalizeArr(R,z,H)}constructor(R,z){this.expr=R,this.negated=z,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const N=A(this.expr[z],R.expr[z]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(R.expr[z]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:n.create(R,this.negated,!1)}evaluate(R){for(let z=0,H=this.expr.length;z<H;z++)if(this.expr[z].evaluate(R))return!0;return!1}static _normalizeArr(R,z,H){let N=[],V=!1;if(R){for(let B=0,F=R.length;B<F;B++){const x=R[B];if(!!x){if(x.type===0){V=!0;continue}if(x.type===1)return w.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&V)return k.INSTANCE;N.sort(A)}if(N.length!==0){if(N.length===1)return N[0];for(let B=1;B<N.length;B++)N[B-1].equals(N[B])&&(N.splice(B,1),B--);if(N.length===1)return N[0];if(H){for(let B=0;B<N.length;B++)for(let F=B+1;F<N.length;F++)L(N[B],N[F])&&(N.splice(F,1),F--);if(N.length===1)return N[0]}return new n(N,z)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const z of this.expr)R.push(...z.keys());return R}map(R){return new n(this.expr.map(z=>z.map(R)),null)}negate(){if(!this.negated){const R=[];for(const z of this.expr)R.push(z.negate());for(;R.length>1;){const z=R.shift(),H=R.shift(),N=[];for(const B of M(z))for(const F of M(H))N.push(u.create([B,F],null));const V=R.length===0;R.unshift(n.create(N,null,V))}this.negated=R[0]}return this.negated}}class s extends T{static all(){return s._info.values()}constructor(R,z,H){super(R,null),this._defaultValue=z,typeof H=="object"?s._info.push({...H,key:R}):H!==!0&&s._info.push({key:R,description:H,type:z!=null?typeof z:void 0})}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return S.create(this.key,R)}notEqualsTo(R){return m.create(this.key,R)}}e.RawContextKey=s,s._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(U,R){return U<R?-1:U>R?1:0}function _(U,R,z,H){return U<z?-1:U>z?1:R<H?-1:R>H?1:0}function L(U,R){if(R.type===6&&U.type!==9&&U.type!==6){for(const N of R.expr)if(U.equals(N))return!0}const z=U.negate(),H=M(z).concat(M(R));H.sort(A);for(let N=0;N<H.length;N++){const B=H[N].negate();for(let F=N+1;F<H.length;F++){const x=H[F];if(B.equals(x))return!0}}return!1}e.implies=L;function M(U){return U.type===9?U.expr:[U]}}),define(De[190],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[120],Ie([1,0,164,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(m,b){switch(m){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function I(m,b){return b==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function E(m,b,f){return I(b,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f?!0:D(f).includes(m)}e.isTargetPlatformCompatible=E;function D(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A;var k;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var w;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var T;(function(m){m.Install="install",m.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var S;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(b,f){super(b),this.code=f,this.name=f}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[191],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[192],Ie([1,0,44,14,9,10,105,29,113,166,191]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=D.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends w{openTerminal(c,p){return this.spawnTerminal(l,c,E.getWindowsShell(),p)}spawnTerminal(c,p,i,d){const a=p.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const r=C.basename(a).toLowerCase();if(r==="cmder"||r==="cmder.exe")return c.spawn(a,d?[d]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return a.indexOf(" ")>=0&&o.push('""'),o.push(a),(r==="wt"||r==="wt.exe")&&o.push("-d ."),new Promise((u,n)=>{const s=v(process),h=c.spawn(i,o,{cwd:d,env:s});h.on("error",n),h.on("exit",()=>u())})}runInTerminal(c,p,i,d,a){const r="windowsExec"in a&&a.windowsExec?a.windowsExec:T.getDefaultTerminalWindows();return new Promise((o,u)=>{const n=`"${p} - ${k}"`,s=`""${i.join('" "')}" & pause"`,h=["/c","start",n,"/wait",r,"/c",s],_=Object.assign({},v(process),d);Object.keys(_).filter(U=>_[U]===null).forEach(U=>delete _[U]);const L={cwd:p,env:_,windowsVerbatimArguments:!0};l.spawn(T.CMD,h,L).on("error",U=>{u(m(U))}),o(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class S extends w{openTerminal(c,p){return this.spawnTerminal(l,c,p)}runInTerminal(c,p,i,d,a){const r=a.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(r===A.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const n=r===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`,J).fsPath,"-t",c||k,"-w",p];for(const M of i)h.push("-a"),h.push(M);if(d){const M=Object.assign({},v(process),d);for(const U in M){const R=M[U];R===null?(h.push("-u"),h.push(U)):(h.push("-e"),h.push(`${U}=${R}`))}}let _="";const L=l.spawn(S.OSASCRIPT,h);L.on("error",M=>{u(m(M))}),L.stderr.on("data",M=>{_+=M.toString()}),L.on("exit",M=>{if(M===0)o(void 0);else if(_){const U=_.split(`
`,1);u(new Error(U[0]))}else u(new Error(D.localize(1,null,n,M)))})}else u(new Error(D.localize(2,null,r)))})}spawnTerminal(c,p,i){const d=p.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((a,r)=>{const o=["-a",d];i&&o.push(i);const u=v(process),n=c.spawn("/usr/bin/open",o,{cwd:i,env:u});n.on("error",r),n.on("exit",()=>a())})}}e.MacExternalTerminalService=S,S.OSASCRIPT="/usr/bin/osascript";class g extends w{openTerminal(c,p){return this.spawnTerminal(l,c,p)}runInTerminal(c,p,i,d,a){const r=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const n=[];r.then(s=>{s.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const h=`${b(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;n.push(`''${h}''`);const _=Object.assign({},v(process),d);Object.keys(_).filter(R=>_[R]===null).forEach(R=>delete _[R]);const L={cwd:p,env:_};let M="";const U=l.spawn(s,n,L);U.on("error",R=>{u(m(R))}),U.stderr.on("data",R=>{M+=R.toString()}),U.on("exit",R=>{if(R===0)o(void 0);else if(M){const z=M.split(`
`,1);u(new Error(z[0]))}else u(new Error(D.localize(4,null,s,R)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{c?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,p,i){const d=p.linuxExec?Promise.resolve(p.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,r)=>{d.then(o=>{const u=v(process),n=c.spawn(o,[],{cwd:i,env:u});n.on("error",r),n.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=D.localize(3,null);function v(f){const c={...f.env};return(0,y.sanitizeProcessEnvironment)(c),c}function m(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(D.localize(5,null,f.path)):f}function b(f){let c="";for(const p of f)p.indexOf(" ")>=0?c+='"'+p+'"':c+=p,c+=" ";return c}}),define(De[38],Ie([1,0,26,9,8,12,2,167,4]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function D(B){return B.create===!0}e.isFileOpenForWriteOptions=D;var A;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var k;(function(B){B[B.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var w;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function S(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=S;function g(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=g;function v(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function m(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=m;function b(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var f;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(F,x){super(F),this.code=x}}e.FileSystemProviderError=c;function p(B,F){const x=new c(B.toString(),F);return d(x,F),x}e.createFileSystemProviderError=p;function i(B){return B||p((0,I.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=i;function d(B,F){return B.name=F?`${F} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=d;function a(B){if(!B)return f.Unknown;if(B instanceof c)return B.code;const F=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!F)return f.Unknown;switch(F[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=a;function r(B){if(B instanceof _)return B.fileOperationResult;switch(a(B)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class u{constructor(F,x,$){this.resource=F,this.operation=x,this.target=$}isOperation(F){return this.operation===F}}e.FileOperationEvent=u;var n;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class s{constructor(F,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const $=new Map;for(const Q of F){const K=$.get(Q.type);switch(K?K.push([Q.resource,Q]):$.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of $)switch(Q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(K);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(K);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(K);break}}contains(F,...x){return this.doContains(F,{includeChildren:!1},...x)}affects(F,...x){return this.doContains(F,{includeChildren:!0},...x)}doContains(F,x,...$){if(!F)return!1;const Q=$.length>0;return!!((!Q||$.includes(1))&&(this.added?.get(F)||x.includeChildren&&this.added?.findSuperstr(F))||(!Q||$.includes(0))&&(this.updated?.get(F)||x.includeChildren&&this.updated?.findSuperstr(F))||(!Q||$.includes(2))&&(this.deleted?.findSubstr(F)||x.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=s;function h(B,F,x){return!B||!F||B===F||F.length>B.length?!1:(F.charAt(F.length-1)!==t.sep&&(F+=t.sep),x?(0,C.startsWithIgnoreCase)(B,F):B.indexOf(F)===0)}e.isParent=h;class _ extends Error{constructor(F,x,$){super(F),this.fileOperationResult=x,this.options=$}}e.FileOperationError=_;class L extends _{constructor(F,x,$){super(F,2,$),this.stat=x}}e.NotModifiedSinceFileOperationError=L;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=R;async function z(B,F){if(!F.hasProvider(y.URI.from({scheme:B.scheme})))return new Promise(x=>{const $=F.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===B.scheme&&Q.added&&($.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(F){return(0,P.isNumber)(F)||(F=0),F<H.KB?(0,I.localize)(1,null,F.toFixed(0)):F<H.MB?(0,I.localize)(2,null,(F/H.KB).toFixed(2)):F<H.GB?(0,I.localize)(3,null,(F/H.MB).toFixed(2)):F<H.TB?(0,I.localize)(4,null,(F/H.GB).toFixed(2)):(0,I.localize)(5,null,(F/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var N;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function V(B){return{maxFileSize:B===0?300*H.MB:16*H.GB,maxHeapSize:B===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=V}),define(De[84],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...C){this._entries=new Map;for(const[P,y]of C)this.set(P,y)}set(C,P){const y=this._entries.get(C);return this._entries.set(C,P),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=l}),define(De[193],Ie([1,0,18,11,6,119,189,4,84,62]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class k extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class w{constructor(v=new E.ServiceCollection,m=!1,b,f=A){this._services=v,this._strict=m,this._parent=b,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=f?b?._globalGraph??new y.Graph(c=>c):void 0}createChild(v){return new w(v,this._strict,this,this._enableTracing)}invokeFunction(v,...m){const b=S.traceInvocation(this._enableTracing,v);let f=!1;try{return v({get:p=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(p,b);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...m)}finally{f=!0,b.stop()}}createInstance(v,...m){let b,f;return v instanceof P.SyncDescriptor?(b=S.traceCreation(this._enableTracing,v.ctor),f=this._createInstance(v.ctor,v.staticArguments.concat(m),b)):(b=S.traceCreation(this._enableTracing,v),f=this._createInstance(v,m,b)),b.stop(),f}_createInstance(v,m=[],b){const f=I._util.getServiceDependencies(v).sort((i,d)=>i.index-d.index),c=[];for(const i of f){const d=this._getOrCreateServiceInstance(i.id,b);d||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(d)}const p=f.length>0?f[0].index:m.length;if(m.length!==p){console.trace(`[createInstance] First service dependency of ${v.name} at position ${p+1} conflicts with ${m.length} static arguments`);const i=p-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,p)}return Reflect.construct(v,m.concat(c))}_setServiceInstance(v,m){if(this._services.get(v)instanceof P.SyncDescriptor)this._services.set(v,m);else if(this._parent)this._parent._setServiceInstance(v,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const m=this._services.get(v);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):m}_getOrCreateServiceInstance(v,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const b=this._getServiceInstanceOrDescriptor(v);return b instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,b,m.branch(v,!0)):(m.branch(v,!1),b)}_safeCreateAndCacheServiceInstance(v,m,b){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,m,b)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,m,b){const f=new y.Graph(i=>i.id.toString());let c=0;const p=[{id:v,desc:m,_trace:b}];for(;p.length;){const i=p.pop();if(f.lookupOrInsertNode(i),c++>1e3)throw new k(f);for(const d of I._util.getServiceDependencies(i.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(d.id);if(a||this._throwIfStrict(`[createInstance] ${v} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(d.id)),a instanceof P.SyncDescriptor){const r={id:d.id,desc:a,_trace:i._trace.branch(d.id,!0)};f.insertEdge(i,r),p.push(r)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new k(f);break}for(const{data:d}of i){if(this._getServiceInstanceOrDescriptor(d.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,r)}f.removeNode(d)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,m,b=[],f,c){if(this._services.get(v)instanceof P.SyncDescriptor)return this._createServiceInstance(v,m,b,f,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,m,b,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(v,m,b=[],f,c){if(f){const p=new w(void 0,this._strict,this,this._enableTracing);p._globalGraphImplicitDependency=String(v);const i=new Map,d=new l.IdleValue(()=>{const a=p._createInstance(m,b,c);for(const[r,o]of i){const u=a[r];if(typeof u=="function")for(const n of o)u.apply(a,n)}return i.clear(),a});return new Proxy(Object.create(null),{get(a,r){if(!d.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let n=i.get(r);return n||(n=new D.LinkedList,i.set(r,n)),(h,_,L)=>{const M=n.push([h,_,L]);return(0,C.toDisposable)(M)}}if(r in a)return a[r];const o=d.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),a[r]=u),u},set(a,r,o){return d.value[r]=o,!0}})}else return this._createInstance(m,b,c)}_throwIfStrict(v,m){if(m&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=w;var T;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(T||(T={}));class S{static traceInvocation(v,m){return v?new S(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(v,m){return v?new S(0,m.name):S._None}constructor(v,m){this.type=v,this.name=m,this._start=Date.now(),this._dep=[]}branch(v,m){const b=new S(2,v.toString());return this._dep.push([v,m,b]),b}stop(){const v=Date.now()-this._start;S._totals+=v;let m=!1;function b(c,p){const i=[],d=new Array(c+1).join("	");for(const[a,r,o]of p._dep)if(r&&o){m=!0,i.push(`${d}CREATES -> ${a}`);const u=b(c+1,o);u&&i.push(u)}else i.push(`${d}uses -> ${a}`);return i.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(v>2||m)&&S.all.add(f.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[13],Ie([1,0,50,3,6,26,10,2,4]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function D(){return new Date().toISOString()}var A;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function k(u,n,s){switch(n){case A.Trace:u.trace(s);break;case A.Debug:u.debug(s);break;case A.Info:u.info(s);break;case A.Warning:u.warn(s);break;case A.Error:u.error(s);break;case A.Critical:u.critical(s);break;default:throw new Error("Invalid log level")}}e.log=k;function w(u){let n="";for(let s=0;s<u.length;s++){let h=u[s];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}n+=(s>0?" ":"")+h}return n}e.format=w;class T extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class S extends T{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...s){this.checkLogLevel(A.Trace)&&this.log(A.Trace,w([n,...s]))}debug(n,...s){this.checkLogLevel(A.Debug)&&this.log(A.Debug,w([n,...s]))}info(n,...s){this.checkLogLevel(A.Info)&&this.log(A.Info,w([n,...s]))}warn(n,...s){this.checkLogLevel(A.Warning)&&this.log(A.Warning,w([n,...s]))}error(n,...s){if(this.checkLogLevel(A.Error))if(n instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=n.stack,this.log(A.Error,w(h))}else this.log(A.Error,w([n,...s]))}critical(n,...s){this.checkLogLevel(A.Critical)&&this.log(A.Critical,w([n,...s]))}flush(){}}e.AbstractMessageLogger=S;class g extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!y.isWindows}trace(n,...s){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...s):console.log(`[main ${D()}]`,n,...s))}debug(n,...s){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...s):console.log(`[main ${D()}]`,n,...s))}info(n,...s){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...s):console.log(`[main ${D()}]`,n,...s))}warn(n,...s){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...s):console.warn(`[main ${D()}]`,n,...s))}error(n,...s){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...s):console.error(`[main ${D()}]`,n,...s))}critical(n,...s){this.getLevel()<=A.Critical&&(this.useColors?console.error(`\x1B[90m[main ${D()}]\x1B[0m`,n,...s):console.error(`[main ${D()}]`,n,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class v extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...s){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...s)}debug(n,...s){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...s)}info(n,...s){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...s)}warn(n,...s){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...s)}error(n,...s){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...s)}critical(n,...s){this.getLevel()<=A.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...s)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends T{constructor(n,s=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(s)}trace(n,...s){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...s])}debug(n,...s){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...s])}info(n,...s){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...s])}warn(n,...s){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...s])}error(n,...s){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...s])}critical(n,...s){this.getLevel()<=A.Critical&&this.adapter.log(A.Critical,[this.extractMessage(n),...s])}extractMessage(n){return typeof n=="string"?n:(0,l.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class b extends T{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const s of this.logServices)s.setLevel(n);super.setLevel(n)}trace(n,...s){for(const h of this.logServices)h.trace(n,...s)}debug(n,...s){for(const h of this.logServices)h.debug(n,...s)}info(n,...s){for(const h of this.logServices)h.info(n,...s)}warn(n,...s){for(const h of this.logServices)h.warn(n,...s)}error(n,...s){for(const h of this.logServices)h.error(n,...s)}critical(n,...s){for(const h of this.logServices)h.critical(n,...s)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=b;class f extends C.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...s){this.logger.trace(n,...s)}debug(n,...s){this.logger.debug(n,...s)}info(n,...s){this.logger.info(n,...s)}warn(n,...s){this.logger.warn(n,...s)}error(n,...s){this.logger.error(n,...s)}critical(n,...s){this.logger.critical(n,...s)}flush(){this.logger.flush()}}e.LogService=f;class c extends C.Disposable{constructor(n,s){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(s(h=>this.setLevel(h)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,s,h){let _=this.loggerItems.get(n)?.logger;return _||(h=s?.always?A.Trace:h,_=this.doCreateLogger(n,h??this.logLevel,s),this.loggerItems.set(n,{logger:_,logLevel:h})),_}setLevel(n,s){const h=I.URI.isUri(n)?n:void 0,_=h?s:n;if(h){const L=this.loggerItems.get(h);L&&L.logLevel!==_&&(L.logLevel=_,L.logger.setLevel(_))}else this.logLevel=_,this.loggerItems.forEach(({logLevel:L,logger:M})=>{L===void 0&&M.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=c;class p{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...s){}debug(n,...s){}info(n,...s){}warn(n,...s){}error(n,...s){}critical(n,...s){}dispose(){}flush(){}}e.NullLogger=p;class i extends p{}e.NullLogService=i;class d extends c{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,s,h){return new p}}e.NullLoggerService=d;function a(u){if(u.verbose)return A.Trace;if(typeof u.logLevel=="string"){const n=r(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function r(u){switch(u){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Critical;case"off":return A.Off}}e.parseLogLevel=r;function o(u){switch(u){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Critical:return"critical";case A.Off:return"off"}}e.LogLevelToString=o}),define(De[194],Ie([1,0,38,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(I,E,D,A,k){try{const w=await new Promise((S,g)=>{J(["spdlog"],S,g)});w.setFlushOn(t.LogLevel.Trace);const T=await w.createAsyncRotatingLogger(I,E,D,A);return k?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(w){console.error(w)}return null}function P(I,E,D){switch(E){case t.LogLevel.Trace:I.trace(D);break;case t.LogLevel.Debug:I.debug(D);break;case t.LogLevel.Info:I.info(D);break;case t.LogLevel.Warning:I.warn(D);break;case t.LogLevel.Error:I.error(D);break;case t.LogLevel.Critical:I.critical(D);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(E,D,A,k,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(E,D,A,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(E,D,A,k){const w=A?6:1,T=30/w*l.ByteSize.MB,S=await C(E,D,T,w,k);if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:g,message:v}of this.buffer)P(this._logger,g,v);this.buffer=[]}}log(E,D){this._logger?P(this._logger,E,D):this.getLevel()<=E&&this.buffer.push({level:E,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[121],Ie([1,0,42,168,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function D(S,g){return g-S}E.compare=D;const A=Object.create(null);A[E.Error]=(0,t.localize)(0,null),A[E.Warning]=(0,t.localize)(1,null),A[E.Info]=(0,t.localize)(2,null);function k(S){return A[S]||""}E.toString=k;function w(S){switch(S){case l.default.Error:return E.Error;case l.default.Warning:return E.Warning;case l.default.Info:return E.Info;case l.default.Ignore:return E.Hint}}E.fromSeverity=w;function T(S){switch(S){case E.Error:return l.default.Error;case E.Warning:return l.default.Warning;case E.Info:return l.default.Info;case E.Hint:return l.default.Ignore}}E.toSeverity=T}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(E){const D="";function A(w){return k(w,!0)}E.makeKey=A;function k(w,T){const S=[D];return w.source?S.push(w.source.replace("\xA6","\\\xA6")):S.push(D),w.code?typeof w.code=="string"?S.push(w.code.replace("\xA6","\\\xA6")):S.push(w.code.value.replace("\xA6","\\\xA6")):S.push(D),w.severity!==void 0&&w.severity!==null?S.push(y.toString(w.severity)):S.push(D),w.message&&T?S.push(w.message.replace("\xA6","\\\xA6")):S.push(D),w.startLineNumber!==void 0&&w.startLineNumber!==null?S.push(w.startLineNumber.toString()):S.push(D),w.startColumn!==void 0&&w.startColumn!==null?S.push(w.startColumn.toString()):S.push(D),w.endLineNumber!==void 0&&w.endLineNumber!==null?S.push(w.endLineNumber.toString()):S.push(D),w.endColumn!==void 0&&w.endColumn!==null?S.push(w.endColumn.toString()):S.push(D),S.push(D),S.join("\xA6")}E.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(De[195],Ie([1,0,3,42,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new E,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=I;class E{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=E}),define(De[122],Ie([1,0,6,8,2,4]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(A){return{resolved:A,dispose(){}}}});function y(A,k){return C.URI.isUri(A)?(0,t.equalsIgnoreCase)(A.scheme,k):(0,t.startsWithIgnoreCase)(A,k+":")}e.matchesScheme=y;function I(A,...k){return k.some(w=>y(A,w))}e.matchesSomeScheme=I;function E(A,k){return A.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=E;function D(A){let k;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(A.fragment);return w&&(k={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},A=A.with({fragment:""})),{selection:k,uri:A}}e.extractSelection=D}),define(De[196],Ie([1,0,14,10,36,22]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)y=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const I=(0,P.dirname)(l.FileAccess.asFileUri("",J));if(y=J.__$__nodeRequire((0,P.joinPath)(I,"product.json").fsPath),C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const E=J.__$__nodeRequire((0,P.joinPath)(I,"package.json").fsPath);Object.assign(y,{version:E.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(De[197],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[123],Ie([1,0,18,21,6,4]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let E=class extends C.Disposable{constructor(k,w){super(),this.deferred=new l.DeferredPromise,w.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};E=je([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class D extends C.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const w=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:T.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,12]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,I){l.ok(t.isString(y)),l.ok(t.isObject(I)),l.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,I)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(De[124],Ie([1,0,3,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,D){this.schemasById[C(E)]=D,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(De[125],Ie([1,0,17,3,12,163,65,124,43]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=E.Registry.as(I.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,d=!0){this.registerConfigurations([i],d)}registerConfigurations(i,d=!0){const a=this.doRegisterConfigurations(i,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(i){const d=this.doDeregisterConfigurations(i);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:i,remove:d}){const a=[];a.push(...this.doDeregisterConfigurations(d)),a.push(...this.doRegisterConfigurations(i,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(a)})}registerDefaultConfigurations(i){const d=[],a=[];for(const{overrides:r,source:o}of i)for(const u in r)if(d.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.configurationDefaultsOverrides.get(u),s=n?.valuesSources??new Map;if(o)for(const M of Object.keys(r[u]))s.set(M,o);const h={...n?.value||{},...r[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:h,valuesSources:s});const _=(0,y.getLanguageTagSettingPlainKey)(u),L={type:"object",default:h,description:P.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:C.isString(o)?void 0:o,defaultValueSource:o};a.push(...g(u)),this.configurationProperties[u]=L,this.defaultLanguageConfigurationOverridesNode.properties[u]=L}else{this.configurationDefaultsOverrides.set(u,{value:r[u],source:o});const n=this.configurationProperties[u];n&&(this.updatePropertyDefaultValue(u,n),this.updateSchema(u,n))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const d=[];for(const{overrides:a,source:r}of i)for(const o in a){const u=this.configurationDefaultsOverrides.get(o),n=C.isString(r)?r:r?.id,s=C.isString(u?.source)?u?.source:u?.source?.id;if(n===s)if(d.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const d of i)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,d){const a=[];return i.forEach(r=>{a.push(...this.validateAndRegisterProperties(r,d,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),a}doDeregisterConfigurations(i){const d=[],a=r=>{if(r.properties)for(const o in r.properties){d.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>a(o))};for(const r of i){a(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return d}validateAndRegisterProperties(i,d=!0,a,r,o=3){o=C.isUndefinedOrNull(i.scope)?o:i.scope;const u=[],n=i.properties;if(n)for(const h in n){const _=n[h];if(d&&f(h,_)){delete n[h];continue}if(_.source=a,_.defaultDefaultValue=n[h].default,this.updatePropertyDefaultValue(h,_),e.OVERRIDE_PROPERTY_REGEX.test(h)?_.scope=void 0:(_.scope=C.isUndefinedOrNull(_.scope)?o:_.scope,_.restricted=C.isUndefinedOrNull(_.restricted)?!!r?.includes(h):_.restricted),n[h].hasOwnProperty("included")&&!n[h].included){this.excludedConfigurationProperties[h]=n[h],delete n[h];continue}else this.configurationProperties[h]=n[h],n[h].policy?.name&&this.policyConfigurations.set(n[h].policy.name,h);!n[h].deprecationMessage&&n[h].markdownDeprecationMessage&&(n[h].deprecationMessage=n[h].markdownDeprecationMessage),u.push(h)}const s=i.allOf;if(s)for(const h of s)u.push(...this.validateAndRegisterProperties(h,d,a,r,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const d=a=>{const r=a.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);a.allOf?.forEach(d)};d(i)}updateSchema(i,d){switch(e.allSettings.properties[i]=d,d.scope){case 1:e.applicationSettings.properties[i]=d;break;case 2:e.machineSettings.properties[i]=d;break;case 6:e.machineOverridableSettings.properties[i]=d;break;case 3:e.windowSettings.properties[i]=d;break;case 4:e.resourceSettings.properties[i]=d;break;case 5:e.resourceSettings.properties[i]=d,this.resourceLanguageSettingsSchema.properties[i]=d;break}}removeFromSchema(i,d){switch(delete e.allSettings.properties[i],d.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const d=`[${i}]`,a={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,a),e.allSettings.properties[d]=a,e.applicationSettings.properties[d]=a,e.machineSettings.properties[d]=a,e.machineOverridableSettings.properties[d]=a,e.windowSettings.properties[d]=a,e.resourceSettings.properties[d]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,d){const a=this.configurationDefaultsOverrides.get(i);let r=a?.value,o=a?.source;C.isUndefined(r)&&(r=d.defaultDefaultValue,o=void 0),C.isUndefined(r)&&(r=m(d.type)),d.default=r,d.defaultValueSource=o}}const T="\\[([^\\]]+)\\]",S=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let d=S.exec(p);for(;d?.length;){const a=d[1].trim();a&&i.push(a),d=S.exec(p)}}return(0,l.distinct)(i)}e.overrideIdentifiersFromKey=g;function v(p){return p.reduce((i,d)=>`${i}[${d}]`,"")}e.keyFromOverrideIdentifiers=v;function m(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const b=new w;E.Registry.add(e.Extensions.Configuration,b);function f(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?P.localize(7,null,p):b.getConfigurationProperties()[p]!==void 0?P.localize(8,null,p):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?P.localize(9,null,p,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:P.localize(6,null)}e.validateProperty=f;function c(){const p=[],i=b.getConfigurationProperties();for(const d of Object.keys(i))p.push([d,i[d].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=c}),define(De[198],Ie([1,0,17,3,143,6,26,24,12,2,65,125,43]),function(J,e,l,t,C,P,y,I,E,D,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(i={},d=[],a=[],r){this._contents=i,this._keys=d,this._overrides=a,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(d=>{if(d instanceof T)return d;const a=new S("");return a.parseRaw(d),a.configurationModel});this._rawConfiguration=i.reduce((d,a)=>a===d?a:d.merge(a),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,A.getConfigurationValue)(this.contents,i):this.contents}inspect(i,d){const a=this.rawConfiguration.getValue(i),r=d?this.rawConfiguration.getOverrideValue(i,d):void 0,o=d?this.rawConfiguration.override(d).getValue(i):a;return{value:a,override:r,merged:o}}getOverrideValue(i,d){const a=this.getContentsForOverrideIdentifer(d);return a?i?(0,A.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){const d=[];for(const a of this.overrides)a.identifiers.includes(i)&&d.push(...a.keys);return l.distinct(d)}getAllOverrideIdentifiers(){const i=[];for(const d of this.overrides)i.push(...d.identifiers);return l.distinct(i)}override(i){let d=this.overrideConfigurations.get(i);return d||(d=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,d)),d}merge(...i){const d=I.deepClone(this.contents),a=I.deepClone(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const u of i)if(o.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(d,u.contents);for(const n of u.overrides){const[s]=a.filter(h=>l.equals(h.identifiers,n.identifiers));s?(this.mergeContents(s.contents,n.contents),s.keys.push(...n.keys),s.keys=l.distinct(s.keys)):a.push(I.deepClone(n))}for(const n of u.keys)r.indexOf(n)===-1&&r.push(n)}return new T(d,r,a,o.every(u=>u instanceof T)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new T(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(i){const d=this.getContentsForOverrideIdentifer(i);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const a={};for(const r of l.distinct([...Object.keys(this.contents),...Object.keys(d)])){let o=this.contents[r];const u=d[r];u&&(typeof o=="object"&&typeof u=="object"?(o=I.deepClone(o),this.mergeContents(o,u)):o=u),a[r]=o}return new T(a,this.keys,this.overrides)}mergeContents(i,d){for(const a of Object.keys(d)){if(a in i&&E.isObject(i[a])&&E.isObject(d[a])){this.mergeContents(i[a],d[a]);continue}i[a]=I.deepClone(d[a])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let d=null,a=null;const r=o=>{o&&(a?this.mergeContents(a,o):a=I.deepClone(o))};for(const o of this.overrides)l.equals(o.identifiers,[i])?d=o.contents:o.identifiers.includes(i)&&r(o.contents);return r(d),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,d){this.addKey(i),(0,A.addToValueTree)(this.contents,i,d,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,A.removeFromValueTree)(this.contents,i)}addKey(i){let d=this.keys.length;for(let a=0;a<d;a++)i.indexOf(this.keys[a])===0&&(d=a);this.keys.splice(d,1,i)}removeKey(i){const d=this.keys.indexOf(i);return d!==-1?(this.keys.splice(d,1),!0):!1}}e.ConfigurationModel=T;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,d){if(!E.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,d)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,d){this._raw=i;const{contents:a,keys:r,overrides:o,restricted:u,hasExcludedProperties:n}=this.doParseRaw(i,d);this._configurationModel=new T(a,r,o,n?[i]:void 0),this._restrictedConfigurations=u||[]}doParseContent(i){let d={},a=null,r=[];const o=[],u=[];function n(h){Array.isArray(r)?r.push(h):a!==null&&(r[a]=h)}const s={onObjectBegin:()=>{const h={};n(h),o.push(r),r=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const h=[];n(h),o.push(r),r=h,a=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:n,onError:(h,_,L)=>{u.push({error:h,offset:_,length:L})}};if(i)try{C.visit(i,s),d=r[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return d}doParseRaw(i,d){const a=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,d);i=r.raw;const o=(0,A.toValuesTree)(i,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),u=Object.keys(i),n=this.toOverrides(i,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:o,keys:u,overrides:n,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(i,d,a,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const u={},n=[];for(const s in i)if(k.OVERRIDE_PROPERTY_REGEX.test(s)&&a){const h=this.filter(i[s],d,!1,r);u[s]=h.raw,o=o||h.hasExcludedProperties,n.push(...h.restricted)}else{const h=d[s],_=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&n.push(s),(_===void 0||r.scopes===void 0||r.scopes.includes(_))&&!(r.skipRestricted&&h?.restricted)?u[s]=i[s]:o=!0}return{raw:u,restricted:n,hasExcludedProperties:o}}toOverrides(i,d){const a=[];for(const r of Object.keys(i))if(k.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const u in i[r])o[u]=i[r][u];a.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,A.toValuesTree)(o,d)})}return a}}e.ConfigurationModelParser=S;class g extends P.Disposable{constructor(i,d,a,r){super(),this.userSettingsResource=i,this.scopes=d,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&a.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class v{constructor(i,d,a,r,o=new T,u=new T,n=new y.ResourceMap,s=new T,h=new y.ResourceMap,_=!0){this._defaultConfiguration=i,this._policyConfiguration=d,this._applicationConfiguration=a,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=n,this._memoryConfiguration=s,this._memoryConfigurationByResource=h,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(i,d,a){return this.getConsolidatedConfigurationModel(i,d,a).getValue(i)}updateValue(i,d,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new T,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,d===void 0?r.removeValue(i):r.setValue(i,d),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,d,a){const r=this.getConsolidatedConfigurationModel(i,d,a),o=this.getFolderConfigurationModelForResource(d.resource,a),u=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,n=this._defaultConfiguration.inspect(i,d.overrideIdentifier),s=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),h=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),_=this.userConfiguration.freeze().inspect(i,d.overrideIdentifier),L=this.localUserConfiguration.freeze().inspect(i,d.overrideIdentifier),M=this.remoteUserConfiguration.freeze().inspect(i,d.overrideIdentifier),U=a?this._workspaceConfiguration.freeze().inspect(i,d.overrideIdentifier):void 0,R=o?o.freeze().inspect(i,d.overrideIdentifier):void 0,z=u.inspect(i,d.overrideIdentifier),H=r.getValue(i),N=l.distinct(r.overrides.map(V=>V.identifiers).flat()).filter(V=>r.getOverrideValue(i,V)!==void 0);return{defaultValue:n?n.merged:void 0,policyValue:s?s.merged:void 0,applicationValue:h?h.merged:void 0,userValue:_?_.merged:void 0,userLocalValue:L?L.merged:void 0,userRemoteValue:M?M.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:R?R.merged:void 0,memoryValue:z?z.merged:void 0,value:H,default:n.value!==void 0||n.override!==void 0?{value:n.value,override:n.override}:void 0,policy:s?.value!==void 0?{value:s.value}:void 0,application:h?.value!==void 0||h?.override!==void 0?{value:h.value,override:h.override}:void 0,user:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userLocal:L.value!==void 0||L.override!==void 0?{value:L.value,override:L.override}:void 0,userRemote:M.value!==void 0||M.override!==void 0?{value:M.value,override:M.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:R?.value!==void 0||R?.override!==void 0?{value:R.value,override:R.override}:void 0,memory:z.value!==void 0||z.override!==void 0?{value:z.value,override:z.override}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(i){const d=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:d?d.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,d){this._folderConfigurations.set(i,d),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,d){const a=[];if(!d){const{added:r,updated:o,removed:u}=f(this._defaultConfiguration,i);d=[...r,...o,...u]}for(const r of d)for(const o of(0,k.overrideIdentifiersFromKey)(r)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),n=i.getKeysForOverrideIdentifier(o),s=[...n.filter(h=>u.indexOf(h)===-1),...u.filter(h=>n.indexOf(h)===-1),...u.filter(h=>!I.equals(this._defaultConfiguration.override(o).getValue(h),i.override(o).getValue(h)))];a.push([o,s])}return this.updateDefaultConfiguration(i),{keys:d,overrides:a}}compareAndUpdatePolicyConfiguration(i){const{added:d,updated:a,removed:r}=f(this._policyConfiguration,i),o=[...d,...a,...r];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:d,updated:a,removed:r,overrides:o}=f(this.applicationConfiguration,i),u=[...d,...a,...r];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:d,updated:a,removed:r,overrides:o}=f(this.localUserConfiguration,i),u=[...d,...a,...r];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:d,updated:a,removed:r,overrides:o}=f(this.remoteUserConfiguration,i),u=[...d,...a,...r];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:d,updated:a,removed:r,overrides:o}=f(this.workspaceConfiguration,i),u=[...d,...a,...r];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(i,d){const a=this.folderConfigurations.get(i),{added:r,updated:o,removed:u,overrides:n}=f(a,d),s=[...r,...o,...u];return(s.length||!a)&&this.updateFolderConfiguration(i,d),{keys:s,overrides:n}}compareAndDeleteFolderConfiguration(i){const d=this.folderConfigurations.get(i);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:o,overrides:u}=f(d,void 0);return{keys:[...a,...r,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,d,a){let r=this.getConsolidatedConfigurationModelForResource(d,a);return d.overrideIdentifier&&(r=r.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},d){let a=this.getWorkspaceConsolidatedConfiguration();if(d&&i){const r=d.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const o=this._memoryConfigurationByResource.get(i);o&&(a=a.merge(o))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let d=this._foldersConsolidatedConfigurations.get(i);if(!d){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(d=a.merge(r),this._freeze&&(d=d.freeze()),this._foldersConsolidatedConfigurations.set(i,d)):d=a}return d}getFolderConfigurationModelForResource(i,d){if(d&&i){const a=d.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,d)=>{const{contents:a,overrides:r,keys:o}=this._folderConfigurations.get(d);return i.push([d,{contents:a,overrides:r,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(d=>i.add(d)),this.userConfiguration.freeze().keys.forEach(d=>i.add(d)),this._workspaceConfiguration.freeze().keys.forEach(d=>i.add(d)),this._folderConfigurations.forEach(d=>d.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>i.add(d)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>i.add(d)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>i.add(d)),this._folderConfigurations.forEach(d=>d.freeze().getAllOverrideIdentifiers().forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>d.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>d.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>d.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>d.add(r))),[...d.values()]}static parse(i){const d=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),u=this.parseConfigurationModel(i.workspace),n=i.folders.reduce((s,h)=>(s.set(D.URI.revive(h[0]),this.parseConfigurationModel(h[1])),s),new y.ResourceMap);return new v(d,a,r,o,new T,u,n,new T,new y.ResourceMap,!1)}static parseConfigurationModel(i){return new T(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function m(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const i=new Set,d=new Map;for(const r of p)r.keys.forEach(o=>i.add(o)),r.overrides.forEach(([o,u])=>{const n=(0,y.getOrSet)(d,o,new Set);u.forEach(s=>n.add(s))});const a=[];return d.forEach((r,o)=>a.push([o,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=m;class b{constructor(i,d,a,r){this.change=i,this.previous=d,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(n=>o.add(n)),i.overrides.forEach(([,n])=>n.forEach(s=>o.add(s))),this.affectedKeys=[...o.values()];const u=new T;this.affectedKeys.forEach(n=>u.setValue(n,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,d){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(d){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,d,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,d,this.currentWorkspace);return!I.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,d){let a=(0,A.toValuesTree)({[d]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=b;function f(p,i){const{added:d,removed:a,updated:r}=c(i,p),o=[],u=p?.getAllOverrideIdentifiers()||[],n=i?.getAllOverrideIdentifiers()||[];if(i){const s=n.filter(h=>!u.includes(h));for(const h of s)o.push([h,i.getKeysForOverrideIdentifier(h)])}if(p){const s=u.filter(h=>!n.includes(h));for(const h of s)o.push([h,p.getKeysForOverrideIdentifier(h)])}if(i&&p){for(const s of u)if(n.includes(s)){const h=c({contents:p.getOverrideValue(void 0,s)||{},keys:p.getKeysForOverrideIdentifier(s)},{contents:i.getOverrideValue(void 0,s)||{},keys:i.getKeysForOverrideIdentifier(s)});o.push([s,[...h.added,...h.removed,...h.updated]])}}return{added:d,removed:a,updated:r,overrides:o}}function c(p,i){const d=p?i?p.keys.filter(o=>i.keys.indexOf(o)===-1):[...p.keys]:[],a=i?p?i.keys.filter(o=>p.keys.indexOf(o)===-1):[...i.keys]:[],r=[];if(p&&i){for(const o of i.keys)if(p.keys.indexOf(o)!==-1){const u=(0,A.getConfigurationValue)(i.contents,o),n=(0,A.getConfigurationValue)(p.contents,o);I.equals(u,n)||r.push(o)}}return{added:d,removed:a,updated:r}}}),define(De[126],Ie([1,0,11,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{static isTemporarilyNotAvailable(I){return I instanceof P&&I._code===C.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof P&&I._code===C.NoResolverFound}static isHandled(I){return I instanceof P&&I.isHandled}constructor(I,E=C.Unknown,D){super(I),this._message=I,this._code=E,this._detail=D,this.isHandled=E===C.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(De[85],Ie([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===l.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function C(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.getRemoteName=C;function P(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(D){const{host:A,port:k}=E(D);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.parseAuthorityWithPort=y;function I(D,A){let{host:k,port:w}=E(D);return typeof w>"u"&&(w=A),{host:k,port:w}}e.parseAuthorityWithOptionalPort=I;function E(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const w=D.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:D,port:void 0}}}),define(De[27],Ie([1,0,8,4,85]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=P;function y(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var E;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,v){if(typeof g>"u"||g===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof g=="string"||typeof v=="string"){const m=typeof g=="string"?g:g.value,b=typeof v=="string"?v:v.value;return l.equalsIgnoreCase(m,b)}return g._lower===v._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=D;function A(S){return k(S)}e.isApplicationScopedExtension=A;function k(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function w(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function T(S,g){if(g){const v=`onResolveRemoteAuthority:${(0,C.getRemoteName)(g)}`;return S.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[199],Ie([1,0,8,120,27,10,2,11,36]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(d,a){return d.uuid&&a.uuid?d.uuid===a.uuid:d.id===a.id?!0:(0,l.compareIgnoreCase)(d.id,a.id)===0}e.areSameExtensions=D;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(a){const r=a.manifest?a.manifest.version:a.version,o=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new k(a.identifier,r,o)}static parse(a){const r=A.exec(a);return r&&r[1]&&r[2]?new k({id:r[1]},r[2],r[4]||void 0):null}constructor(a,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof k?D(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=k;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const a=w.exec(d);return a&&a[1]?[g(a[1]),a[2]]:[g(d),void 0]}e.getIdAndVersion=T;function S(d,a){return`${d}.${a}`}e.getExtensionId=S;function g(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function v(d,a){return g(S(d,a))}e.getGalleryExtensionId=v;function m(d,a){const r=[],o=u=>{for(const n of r)if(n.some(s=>D(a(s),a(u))))return n;return null};for(const u of d){const n=o(u);n?n.push(u):r.push([u])}return r}e.groupByExtension=m;function b(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function f(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function c(d,a){const r=[],o=a.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every(n=>!D(n.identifier,{id:u}))){const n=d.filter(s=>D(s.identifier,{id:u}));n.length===1&&(r.push(n[0]),o.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=c;async function p(d,a){if(!P.isLinux)return!1;let r;try{r=(await d.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await d.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){a.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=p;async function i(d,a){const r=await p(d,a),o=(0,t.getTargetPlatform)(r?"alpine":P.platform,E.arch);return a.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((C,P)=>J(["vsda"],C,P))}async createNewMessage(C){try{const P=await this.vsda(),y=new P.validator;if(y){const I=String(l._nextId++);return this.validators.set(I,y),{id:I,data:y.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,P){if(!C.id)return!0;const y=this.validators.get(C.id);if(!y)return!1;this.validators.delete(C.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(C){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(C)}catch{}return C}}e.SignService=l,l._nextId=1}),define(De[201],Ie([1,0,10,36,2,31]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(D){if(l.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function I(D,A,k,w,T,S,g,v,m,b){const f=Object.create(null);f["common.machineId"]=g,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=T,f.version=S,f["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,l.PlatformToString)(l.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=w,f["common.product"]=b||"desktop",v&&(f["common.msftInternal"]=v);let c=0;const p=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),l.isLinuxSnap&&(f["common.snap"]="true");const i=y(k);i&&(f["common.platformDetail"]=i);try{const d=await D.readFile(C.URI.file(m));f["common.source"]=d.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=I;function E(D){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const k=A.toLowerCase();return D.some(w=>k===w)}e.verifyMicrosoftInternalDomain=E}),define(De[202],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,l.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,l.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[203],Ie([1,0,24,156,12,65,201,202]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class D{async publicLog(r,o,u){}async publicLogError(r,o,u){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(a,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(o.source),configurationKeys:m(o.sourceConfig)})})}e.configurationTelemetry=A;function k(a,r){return!(r.disableTelemetry||!a.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=k;function w(a){const r=a.getValue(I.TELEMETRY_SETTING_ID),o=a.getValue("telemetry.enableCrashReporter");if(a.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function T(a){const r={},o={},u={};v(a,u);for(let n in u){n=n.length>150?n.substr(n.length-149):n;const s=u[n];typeof s=="number"?o[n]=s:typeof s=="boolean"?o[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),r[n]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(r[n]=s)}return{properties:r,measurements:o}}e.validateTelemetryData=T;const S=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(a){if(!a)return"none";for(const r of S)if(a.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=g;function v(a,r,o=0,u){if(!!a)for(const n of Object.getOwnPropertyNames(a)){const s=a[n],h=u?u+n:n;Array.isArray(s)?r[h]=(0,l.safeStringify)(s):s instanceof Date?r[h]=s.toISOString():(0,C.isObject)(s)?o<2?v(s,r,o+1,h+"."):r[h]=(0,l.safeStringify)(s):r[h]=s}}function m(a){if(!a)return[];const r=[];return b(r,"",a),r}function b(a,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(u=>b(a,r?`${r}.${u}`:u,o[u])):a.push(r)}function f(a,r){const o=a.msftInternalDomains||[],u=r.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(o)||u}e.isInternalTelemetry=f;function c(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=c;function p(a,r){let o=a;const u=[];for(const _ of r)for(;;){const L=_.exec(a);if(!L)break;u.push([L.index,_.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(o="";;){const _=s.exec(a);if(!_)break;!n.test(_[0])&&u.every(([L,M])=>_.index<L||_.index>=M)&&(o+=a.substring(h,_.index)+"<REDACTED: user-file-path>",h=s.lastIndex)}return h<a.length&&(o+=a.substr(h)),o}function i(a){if(!a)return a;const r=a.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of o)if(u.regex.test(r))return`<REDACTED: ${u.label}>`;return a}function d(a,r){return(0,l.cloneAndChange)(a,o=>{if(typeof o=="string"){let u=o;u=p(u,r);for(const n of r)u=u.replace(n,"");return u=i(u),u}})}e.cleanData=d}),define(De[204],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,P,y=5){const I=P(E=>{const D=typeof E=="string"?E:E.data;let A=this._terminalBufferMap.get(C);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(C),y);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,A)});return I}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const P=this._terminalBufferMap.get(C);P&&(this._terminalBufferMap.delete(C),this._callback(C,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[205],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=C}),define(De[86],Ie([1,0,76,3,6,4,43,205]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var E;(function(v){function m(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function D(v){return{id:v}}e.themeColorFromId=D;var A;(function(v){function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||E.isThemeColor(r.color))}v.isThemeIcon=m;const b=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const o=b.exec(r);if(!o)return;const[,u]=o;return{id:u}}v.fromString=f;function c(r){return{id:r}}v.fromId=c;function p(r,o){let u=r.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),o&&(u=`${u}~${o}`),{id:u}}v.modify=p;function i(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}v.getModifier=i;function d(r,o){return r.id===o.id&&r.color?.id===o.color?.id}v.isEqual=d;function a(r,o){return{id:r.id,color:o?D(o):void 0}}v.asThemeIcon=a,v.asClassNameArray=l.CSSIcon.asClassNameArray,v.asClassName=l.CSSIcon.asClassName,v.asCSSSelector=l.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function k(v){switch(v){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(m);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new w;y.Registry.add(e.Extensions.ThemingContribution,T);function S(v){return T.onColorThemeChange(v)}e.registerThemingParticipant=S;class g extends C.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,b){let f=this.theme.getColor(m);return f&&b&&(f=b(f,this.theme)),f?f.toString():null}}e.Themable=g}),define(De[127],Ie([1,0,3,10,4,13]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var y;(function(g){g.Http="http",g.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=k;function w(g,v){return v?v!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=w;class T{constructor(v,m,b){this.remoteAddress=v,this.localAddress=m,this._dispose=b,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let S=class{constructor(v){this.logService=v,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],m=Array.from(this._tunnels.values());for(const b of m){const f=Array.from(b.values());for(const c of f){const p=await c.value;p&&v.push(p)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:m}of v.values())await m.then(b=>b?.dispose());v.clear()}this._tunnels.clear()}setEnvironmentTunnel(v,m,b,f,c){this.addTunnelToMap(v,m,Promise.resolve({tunnelRemoteHost:v,tunnelRemotePort:m,localAddress:b,privacy:f,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(v,m,b,f,c=!1,p,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${b} on local port ${f}.`),!v)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(b)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(v,m,b,f,c,p,i);return d?d.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(a);return(a.tunnelRemoteHost!==m||a.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const m=this._tunnels.get(v.tunnelRemoteHost);if(m){const b=m.get(v.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,b))}}}}async tryDisposeTunnel(v,m,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${m}.`);const f=b.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(m),f}}async closeTunnel(v,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${m} `);const b=this._tunnels.get(v);if(b&&b.has(m)){const f=b.get(m);f.refcount=0,await this.tryDisposeTunnel(v,m,f)}}addTunnelToMap(v,m,b){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(m,{refcount:1,value:b})}async removeEmptyTunnelFromMap(v,m){const b=this._tunnels.get(v);b&&(await b.get(m)||b.delete(m),b.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,m){const b=[v];A(v)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):k(v)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const f=b.map(c=>this._tunnels.get(c));for(const c of f){const p=c?.get(m);if(p)return p}}canTunnel(v){return!!D(v)}doIsPortPrivileged(v,m,b,f){if(m)return!1;if(b){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(c?.length===4){const p=parseInt(c[1]),i=parseInt(c[2]);if(p>10||p===10&&i>=14)return!1}}return v<1024}createWithProvider(v,m,b,f,c,p,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${b} on local port ${f}.`);const d=b;this._factoryInProgress.add(d);const a=f===void 0?b:f,r={elevationRequired:c?this.isPortPrivileged(a):!1},o={remoteAddress:{host:m,port:b},localAddressPort:f,privacy:p,public:p?p!==I.Private:void 0,protocol:i},u=v.forwardPort(o,r);return u?(this.addTunnelToMap(m,b,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),u}};S=je([$e(0,P.ILogService)],S),e.AbstractTunnelService=S}),define(De[206],Ie([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(E){return E.scheme!==l.Schemas.file&&E.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function C(E){if(E.folders.length)return E.folders.every(D=>t(D.uri))?E.folders[0].uri:void 0;if(E.configuration&&t(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=C;function P(E){return C(E)?.scheme}e.getVirtualWorkspaceScheme=P;function y(E){return C(E)?.authority}e.getVirtualWorkspaceAuthority=y;function I(E){return C(E)!==void 0}e.isVirtualWorkspace=I}),define(De[45],Ie([1,0,169,9,26,22,2,4,14]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function D(d){const a=d;return typeof a?.id=="string"&&y.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(d,a){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,t.basename)(d)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=d;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=A;function k(d){const a=d;return typeof a?.id=="string"&&y.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=k;function w(d){const a=d;if(a?.uri)return{id:a.id,uri:y.URI.revive(a.uri)};const r=d;if(r?.configPath)return{id:r.id,configPath:y.URI.revive(r.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=w;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function S(d){const a=d;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=S;function g(d){const a=d;return!!(a&&typeof a=="object"&&y.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=g;class v{constructor(a,r,o,u,n){this._id=a,this._transient=o,this._configuration=u,this._ignorePathCasing=n,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class m{constructor(a,r){this.raw=r,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,P.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(d){return new m({uri:d,index:0,name:(0,P.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(d,a){return P.extUriBiasedIgnorePathCase.isEqualOrParent(d,a.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function c(d){let a;return y.URI.isUri(d)?a=d:a=d.configuration,a?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=c;function p(d,a){return!f(d,a)&&!c(d)}e.isSavedWorkspace=p;function i(d){return(typeof d=="string"?(0,t.extname)(d):(0,P.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const P=this._idPool++;return this._data.set(P,C),this.logDebugInfo(),P}get(C,P){return this._data.has(C)?this._data.get(C)[P]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,14,22,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const E=this._providerInfo.get(I.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(I,E){E===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,E)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(De[25],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[207],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,I,E){this._deferredPromises=new Map,this._id=y,this._shared=I,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,I){let E=this._value[y];return typeof E>"u"&&(E=I),E}update(y,I){this._value[y]=I;const E=this._deferredPromises.get(y);if(E!==void 0)return E.p;const D=new l.DeferredPromise;return this._deferredPromises.set(y,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class C extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,I){super(y.identifier.value,!0,I),this._extension=y}}e.ExtensionGlobalMemento=C}),define(De[208],Ie([1,0,3,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,I,E,D){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(I.value,E,D);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(y,I){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(I)}$acceptModelSaved(y){const I=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(I.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(De[16],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[209],Ie([1,0,27,3]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,E){C.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(I.identifier),tt(this,C,E,"f"),Be(this,C,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(I){return Be(this,C,"f").get(this._id,I)}store(I,E){return Be(this,C,"f").store(this._id,I,E)}delete(I){return Be(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=P,C=new WeakMap}),define(De[53],Ie([1,0,4,127,3,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(E){function D(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}E.fromApiTunnel=D;function A(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}E.fromServiceTunnel=A})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let I=class{constructor(D){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,k,w,T){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=je([$e(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I}),define(De[54],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(De[210],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(E){let D=this.buffers.indexOf(E);return D<0&&(D=this.buffers.length,this.buffers.push(E)),D}}function C(I,E){if(E.serializeBuffersForPostMessage){const D=new t,A=(T,S)=>{if(S instanceof ArrayBuffer){const g=D.add(S);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(S)){const g=P(S);if(g){const v=D.add(S.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:g,byteLength:S.byteLength,byteOffset:S.byteOffset}}}}return S},k=JSON.stringify(I,A),w=D.buffers.map(T=>{const S=new Uint8Array(T);return l.VSBuffer.wrap(S)});return{message:k,buffers:w}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(I,E){const D=E.map(w=>{const T=new ArrayBuffer(w.byteLength);return new Uint8Array(T).set(w.buffer),T}),A=E.length?(w,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const S=T,{index:g}=S,v=D[g];if(S.view)switch(S.view.type){case 1:return new Int8Array(v,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return T}:void 0;return{message:JSON.parse(I,A),arrayBuffers:D}}e.deserializeWebviewMessage=y}),define(De[211],Ie([1,0,111]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function C(P){return new l.URITransformer(t(P))}e.createURITransformer=C}),define(De[128],Ie([1,0,179,12,2,6,4,43,38,14]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function w(x){const $=x;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=w;function T(x,$,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===$&&x.matches(K.input))return K.getViewState()}e.findViewStateForEditor=T;function S(x){if(o(x))return!1;const $=x;return C.URI.isUri($?.resource)}e.isResourceEditorInput=S;function g(x){if(o(x))return!1;const $=x;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=g;function v(x){if(o(x)||g(x))return!1;const $=x;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function m(x){if(o(x))return!1;const $=x;return $?$.resource===void 0||$.resource.scheme===D.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const b=/Untitled-\d+/;function f(x){return x.scheme===D.Schemas.untitled&&x.path.length>1&&!b.test(x.path)}e.isUntitledWithAssociatedResource=f;function c(x){if(o(x))return!1;const $=x;return C.URI.isUri($?.base?.resource)&&C.URI.isUri($?.input1?.resource)&&C.URI.isUri($?.input2?.resource)&&C.URI.isUri($?.result?.resource)}e.isResourceMergeEditorInput=c;var p;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var i;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class d{constructor(){this.mapIdToSaveSource=new Map}registerSource($,Q){let K=this.mapIdToSaveSource.get($);return K||(K={source:$,label:Q},this.mapIdToSaveSource.set($,K)),K.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new d;var a;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends P.Disposable{}e.AbstractEditorInput=r;function o(x){return x instanceof r}e.isEditorInput=o;function u(x){const $=x;return C.URI.isUri($?.preferredResource)}function n(x){const $=x;return o($?.primary)&&o($?.secondary)}e.isSideBySideEditorInput=n;function s(x){const $=x;return o($?.modified)&&o($?.original)}e.isDiffEditorInput=s;function h(x){return o(x?.editor)}e.isEditorInputWithOptions=h;function _(x){const $=x;return h(x)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=_;function L(x){const $=x;return typeof $?.groupId=="number"&&o($.editor)}e.isEditorIdentifier=L;var M;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var R;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(R=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getOriginalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors($);if(de&&ee){if(Q?.supportSideBySide===R.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===R.ANY)return this.getOriginalUri(de,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===R.PRIMARY?de:ee}}if(g($)||v($)||c($))return;const K=u($)?$.preferredResource:$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors($){return n($)||v($)?{primary:$.primary,secondary:$.secondary}:s($)||g($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getCanonicalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors($);if(de&&ee){if(Q?.supportSideBySide===R.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===R.ANY)return this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===R.PRIMARY?de:ee}}if(g($)||v($)||c($))return;const K=$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri($,Q){if(Array.isArray(Q)){if(Q.some(K=>$.scheme===K))return $}else if(Q===$.scheme)return $}}e.EditorResourceAccessor=new z;var H;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(H=e.CloseDirection||(e.CloseDirection={}));class N{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const Q=this.instantiationService=$.get(y.IInstantiationService);for(const[K,de]of this.editorSerializerConstructors)this.createEditorSerializer(K,de,Q);this.editorSerializerConstructors.clear()}createEditorSerializer($,Q,K){const de=K.createInstance(Q);this.editorSerializerInstances.set($,de)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,Q){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,Q,this.instantiationService):this.editorSerializerConstructors.set($,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}I.Registry.add(e.EditorExtensions.EditorFactory,new N);async function V(x,$){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const K=C.URI.revive(Q.fileUri);if(!K||!await $.canHandleResource(K))return;let ee=Q.exists,he=Q.type;if(typeof ee!="boolean"||typeof he!="number")try{he=(await $.stat(K)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&Q.openOnlyIfExists||he===E.FileType.Directory)return;const Y={...Q.options,pinned:!0};return ee?{resource:K,options:Y}:{resource:K,options:Y,forceUntitled:!0}}))}e.pathsToEditors=V;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function F(x){const $=x;if(!$)return!1;const Q=$;if(Q.modified)return F(Q.modified);const K=$;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=F}),define(De[88],Ie([1,0,14,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(I,E){return I.scheme===l.Schemas.http||I.scheme===l.Schemas.https?I:(E&&E.authority&&E.isRemote&&I.scheme===l.Schemas.file&&(I=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:E.authority,path:I.path})),t.URI.from({scheme:l.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=C;function P(I){return I.replace(/./g,E=>{const D=E.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?E:"-"+D.toString(16).padStart(4,"0")})}function y(I){return I.replace(/-([0-9a-f]{4})/g,(E,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=y}),define(De[212],Ie([1,0,3,6,88]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,E,D){this._proxy=I,this._editors=E,this._remoteInfo=D,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const k of this._insets.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,E,D,A,k){let w;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===I){w=f;break}if(!w)throw new Error("not a visible editor");const T=this,S=this._handlePool++,g=new l.Emitter,v=new l.Emitter,m=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,C.asWebviewUri)(f,T._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(f){this._options=f,T._proxy.$setOptions(S,f)}get options(){return this._options}set html(f){this._html=f,T._proxy.$setHtml(S,f)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(f){return T._proxy.$postMessage(S,f)}},b=new class{constructor(){this.editor=I,this.line=E,this.height=D,this.webview=m,this.onDidDispose=v.event}dispose(){T._insets.has(S)&&(T._insets.delete(S),T._proxy.$disposeEditorInset(S),v.fire(),v.dispose(),g.dispose())}};return this._proxy.$createEditorInset(S,w.id,w.value.document.uri,E+1,D,A||{},k.identifier,k.extensionLocation),this._insets.set(S,{editor:I,inset:b,onDidReceiveMessage:g}),b}$onDidDispose(I){const E=this._insets.get(I);E&&E.inset.dispose()}$onDidReceiveMessage(I,E){this._insets.get(I)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=P}),define(De[129],Ie([1,0,3,18,180]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,E,D,A){const k={command:I};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.internalSend("request",k),typeof A=="number"){const w=setTimeout(()=>{clearTimeout(w);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const S={type:"response",seq:0,request_seq:k.seq,success:!1,command:I,message:(0,C.localize)(0,null,A,I)};T(S)}},A)}return D&&this.pendingRequests.set(k.seq,D),k.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,E){return I.type!=="event"||E.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback?.(I);break;case"request":this.requestCallback?.(I);break;case"response":{const E=I,D=this.pendingRequests.get(E.request_seq);D&&(this.pendingRequests.delete(E.request_seq),D(E));break}}}}internalSend(I,E){E.type=I,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((E,D)=>I.set(D,E)),await(0,t.timeout)(500),I.forEach((E,D)=>{E({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[213],Ie([1,0,181,52,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=w=>l.localize(51,null,w);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var y;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(y=e.State||(e.State={}));function I(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=I;var E;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[214],Ie([1,0,8,2,9,24,14]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function E(a,r,o){return a.replace(I,function(u,n){return r&&n.length>0&&n[0]!=="_"?u:o&&o.hasOwnProperty(n)?o[n]:u})}e.formatPII=E;function D(a){const r={};for(const o of Object.keys(a))o.startsWith("!")||(r[o]=a[o]);return r}e.filterExceptionsFromTelemetry=D;function A(a){return a.configuration.request==="attach"&&!k(a)&&(!a.parentSession||A(a.parentSession))}e.isSessionAttach=A;function k(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(r,"extensionhost")||(0,l.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?k(a.parentSession):void 0}e.getExtensionHostDebugSession=k;function w(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=w;function T(a,r,o){let u,n=0;const s=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=s.exec(a);){const _=h.index+1,L=_+h[0].length;if(_<=r&&L>=o){u=h[0],n=_;break}}if(u){const _=/\w+/g;let L=null;for(;(L=_.exec(u))&&!(L.index+1+n+L[0].length>=o););L&&(u=u.substring(0,_.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const S=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(a){return!!(a&&a.match(S))}e.isUri=g;function v(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(g(a.path))return t.URI.parse(a.path);if((0,C.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function m(a){if(typeof a.path=="object"){const r=t.URI.revive(a.path);if(r)return r.scheme===y.Schemas.file?r.fsPath:r.toString()}return a.path}function b(a,r){const o=r?v:m,u=(0,P.deepClone)(a);return c(u,(n,s)=>{n&&s&&(s.path=o(s))}),u}e.convertToDAPaths=b;function f(a,r){const o=r?v:m,u=(0,P.deepClone)(a);return c(u,(n,s)=>{!n&&s&&(s.path=o(s))}),u}e.convertToVSCPaths=f;function c(a,r){switch(a.type){case"event":{const o=a;switch(o.event){case"output":r(!1,o.body.source);break;case"loadedSource":r(!1,o.body.source);break;case"breakpoint":r(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=a;switch(o.command){case"setBreakpoints":r(!0,o.arguments.source);break;case"breakpointLocations":r(!0,o.arguments.source);break;case"source":r(!0,o.arguments.source);break;case"gotoTargets":r(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(u=>r(!1,u));break;default:break}break}case"response":{const o=a;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>r(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>r(!1,u));break;case"scopes":o.body.scopes.forEach(u=>r(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>r(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>r(!1,u.source));break;case"disassemble":o.body?.instructions.forEach(n=>r(!1,n.location));break;default:break}break}}}function p(a){return a.filter(r=>!r.presentation?.hidden).sort((r,o)=>r.presentation?o.presentation?r.presentation.group?o.presentation.group?r.presentation.group!==o.presentation.group?r.presentation.group.localeCompare(o.presentation.group):i(r.presentation.order,o.presentation.order):-1:o.presentation.group?1:i(r.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=p;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function d(a,r){const o=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(o!=="none"&&(await r.saveAll(),o==="allEditorsInActiveGroup")){const u=r.activeEditorPane;u&&u.input.resource?.scheme===y.Schemas.untitled&&await r.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[215],Ie([1,0,44,216,24,9,10,8,29,182,129]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(m,b){this.outputStream=b,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,m.on("data",f=>this.handleData(f))}sendMessage(m){if(this.outputStream){const b=JSON.stringify(m);this.outputStream.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${k.TWO_CRLF}${b}`,"utf8")}}handleData(m){for(this.rawData=Buffer.concat([this.rawData,m]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const b=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+b))}continue}}else{const b=this.rawData.indexOf(k.TWO_CRLF);if(b!==-1){const c=this.rawData.toString("utf8",0,b).split(k.HEADER_LINESEPARATOR);for(const p of c){const i=p.split(k.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(b+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class w extends k{startSession(){return new Promise((m,b)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),m(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.socket.on("error",c=>{f?this._onError.fire(c):b(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class T extends w{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",m)}}e.SocketDebugAdapter=T;class S extends w{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.path,m)}}e.NamedPipeDebugAdapter=S;class g extends k{constructor(m,b){super(),this.adapterExecutable=m,this.debugType=b}async startSession(){const m=this.adapterExecutable.command,b=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(m)if(P.isAbsolute(m)){if(!await E.Promises.exists(m))throw new Error(D.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let c=process.env;if(f.env&&Object.keys(f.env).length>0&&(c=C.mixin(C.deepClone(process.env),f.env)),m==="node")if(Array.isArray(b)&&b.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:c,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(i.cwd=f.cwd);const d=l.fork(b[0],b.slice(1),i);if(!d.pid)throw new Error(D.localize(2,null,b[0]));this.serverProcess=d}else throw new Error(D.localize(3,null));else{const p={env:c};f.cwd&&(p.cwd=f.cwd),this.serverProcess=l.spawn(m,b,p)}this.serverProcess.on("error",p=>{this._onError.fire(p)}),this.serverProcess.on("exit",(p,i)=>{this._onExit.fire(p)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stdin.on("error",p=>{this._onError.fire(p)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((m,b)=>{const f=l.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,p,i){if(c)return b(c)});f.on("exit",m),f.on("error",b)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(m,b){if(!m)return;const f=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?f.runtime=P.join(b,m.runtime):f.runtime=m.runtime),m.runtimeArgs&&(f.runtimeArgs=m.runtimeArgs),m.program&&(P.isAbsolute(m.program)?f.program=m.program:f.program=P.join(b,m.program)),m.args&&(f.args=m.args);const c=m;return c.win&&(f.win=g.extract(c.win,b)),c.winx86&&(f.winx86=g.extract(c.winx86,b)),c.windows&&(f.windows=g.extract(c.windows,b)),c.osx&&(f.osx=g.extract(c.osx,b)),c.linux&&(f.linux=g.extract(c.linux,b)),f}static platformAdapterExecutable(m,b){let f=Object.create(null);b=b.toLowerCase();for(const r of m)if(r.contributes){const o=r.contributes.debuggers;o&&o.length>0&&o.filter(u=>typeof u.type=="string"&&I.equalsIgnoreCase(u.type,b)).forEach(u=>{const n=g.extract(u,r.extensionLocation.fsPath);f=C.mixin(f,n,r.isBuiltin)})}let c;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=f.winx86||f.win||f.windows:y.isWindows?c=f.win||f.windows:y.isMacintosh?c=f.osx:y.isLinux&&(c=f.linux),c=c||f;const p=c.program||f.program,i=c.args||f.args,d=c.runtime||f.runtime,a=c.runtimeArgs||f.runtimeArgs;if(d)return{type:"executable",command:d,args:(a||[]).concat(typeof p=="string"?[p]:[]).concat(i||[])};if(p)return{type:"executable",command:p,args:i||[]}}}e.ExecutableDebugAdapter=g}),define(De[217],Ie([1,0,44,32,10]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(D,A){return new Promise((k,w)=>{let T="";const S=l.spawn(D,A);S.pid&&S.stdout.on("data",g=>{T+=g.toString()}),S.on("error",g=>{w(g)}),S.on("close",g=>{k(T)})})}async function y(D){if(D)if(C.isWindows){const A=await new Promise((k,w)=>{J(["windows-process-tree"],k,w)});return new Promise(k=>{A.getProcessTree(D,w=>{k(!!w&&w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(D)]).then(A=>{const k=A.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var I;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(I||(I={}));function E(D,A,k,w,T){D=D.trim().toLowerCase();let S;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?S=1:D.indexOf("cmd.exe")>=0?S=0:D.indexOf("bash")>=0?S=2:C.isWindows?S=0:S=2;let g,v=" ";switch(S){case 1:if(g=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),w){const m=(0,t.getDriveLetter)(w);m&&(v+=`${m}:; `),v+=`cd ${g(w)}; `}if(T)for(const m in T){const b=T[m];b===null?v+=`Remove-Item env:${m}; `:v+=`\${env:${m}}='${b}'; `}if(A.length>0){const m=A.shift(),b=k?m:g(m);v+=b[0]==="'"?`& ${b} `:`${b} `;for(const f of A)v+=f==="<"||f===">"||k?f:g(f),v+=" "}break;case 0:if(g=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>m.includes(b))||m.length===0?`"${m}"`:m),w){const m=(0,t.getDriveLetter)(w);m&&(v+=`${m}: && `),v+=`cd ${g(w)} && `}if(T){v+='cmd /C "';for(const m in T){let b=T[m];b===null?v+=`set "${m}=" && `:(b=b.replace(/[&^|<>]/g,f=>`^${f}`),v+=`set "${m}=${b}" && `)}}for(const m of A)v+=m==="<"||m===">"||k?m:g(m),v+=" ";T&&(v+='"');break;case 2:{g=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const m=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(w&&(v+=`cd ${g(w)} ; `),T){v+="/usr/bin/env";for(const b in T){const f=T[b];f===null?v+=` -u ${m(b)}`:v+=` ${m(`${b}=${f}`)}`}v+=" "}for(const b of A)v+=b==="<"||b===">"||k?b:g(b),v+=" ";break}}return v}e.prepareCommand=E}),define(De[89],Ie([1,0,23,37,61,104,14,9,10,52]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var b;(function(V){V.scheme=y.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],F=new RegExp(`^[${B.join("")}]+`),x=7;function $(Y,me){const be=me.toString(x),Re=`${be.length<B.length?B[be.length-1]:"z"}${be}s${(0,l.encodeBase64)(l.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:V.scheme,fragment:Re})}V.generate=$;function Q(Y){if(Y.scheme!==V.scheme)return;const me=Y.fragment.indexOf("s");if(me<0)return;const be=parseInt(Y.fragment.substring(0,me).replace(F,""),x),ke=(0,l.decodeBase64)(Y.fragment.substring(me+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:ke,fragment:null})}}V.parse=Q;function K(Y,me){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}V.generateCellOutputUri=K;function de(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const be=me[1]&&me[1]!==""?me[1]:void 0,ke=me[2];return{outputId:be,notebook:Y.with({scheme:ke||y.Schemas.file,fragment:null})}}V.parseCellOutputUri=de;function ee(Y,me,be){return V.generate(Y,me).with({scheme:be})}V.generateCellPropertyUri=ee;function he(Y,me){if(Y.scheme===me)return V.parse(Y.with({scheme:V.scheme}))}V.parseCellPropertyUri=he})(b=e.CellUri||(e.CellUri={}));const f=V=>E.isWindows?V.replace(/\//g,"\\"):V;class c{constructor(B=[],F=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=F,this.order=[...new Set(B)].map(x=>({pattern:x,matches:t.parse(f(x))}))}sort(B){const F=new Map(C.Iterable.map(B,$=>[$,f($)]));let x=[];for(const{matches:$}of this.order)for(const[Q,K]of F)if($(K)){x.push(Q),F.delete(Q);break}return F.size&&(x=x.concat([...F.keys()].sort(($,Q)=>this.defaultOrder.indexOf($)-this.defaultOrder.indexOf(Q)))),x}prioritize(B,F){const x=this.findIndex(B);if(x===-1){this.order.unshift({pattern:B,matches:t.parse(f(B))});return}const $=new Set(F.map(K=>this.findIndex(K,x)));$.delete(-1);const Q=Array.from($).sort();this.order.splice(x+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(B=>B.pattern)}findIndex(B,F=this.order.length){const x=f(B);for(let $=0;$<F;$++)if(this.order[$].matches(x))return $;return-1}}e.MimeTypeDisplayOrder=c;function p(V,B,F,x=($,Q)=>$===Q){const $=[];function Q(ee,he,Y){if(he===0&&Y.length===0)return;const me=$[$.length-1];me&&me.start+me.deleteCount===ee?(me.deleteCount+=he,me.toInsert.push(...Y)):$.push({start:ee,deleteCount:he,toInsert:Y})}let K=0,de=0;for(;;){if(K===V.length){Q(K,0,B.slice(de));break}if(de===B.length){Q(K,V.length-K,[]);break}const ee=V[K],he=B[de];if(x(ee,he)){K+=1,de+=1;continue}F(he)?(Q(K,1,[]),K+=1):(Q(K,0,[he]),de+=1)}return $}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(V){V.default="default",V.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(V){const B=V;return!!((typeof B.include=="string"||t.isRelativePattern(B.include))&&(typeof B.exclude=="string"||t.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=d;function a(V,B,F){if(Array.isArray(V.viewType)&&V.viewType.indexOf(B)>=0||V.viewType===B)return!0;if(V.filenamePattern){const x=d(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,$=d(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(t.match(x,(0,I.basename)(F.fsPath).toLowerCase()))return!($&&t.match($,(0,I.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(B){return`${o._prefix}${B}`}static parse(B){if(B.startsWith(o._prefix))return B.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function u(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.isTextStreamMime=u;const n=new TextDecoder;function s(V){const B=[];let F=!1;for(const x of V)(B.length===0||F)&&(B.push(x),F=!0);return M(B),N(l.VSBuffer.concat(B.map(x=>l.VSBuffer.wrap(x))))}e.compressOutputItemStreams=s;const h=`${String.fromCharCode(27)}[A`,_=h.split("").map(V=>V.charCodeAt(0)),L=10;function M(V){V.forEach((B,F)=>{if(F===0||B.length<h.length)return;const x=V[F-1],$=B.subarray(0,h.length);if($[0]===_[0]&&$[1]===_[1]&&$[2]===_[2]){const Q=x.lastIndexOf(L);if(Q===-1)return;V[F-1]=x.subarray(0,Q),V[F]=B.subarray(h.length)}})}function U(V){let B=V;do V=B,B=V.replace(/[^\n]\x08/gm,"");while(B.length<V.length);return V}function R(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const B=V.match(/^(.*)\r+/m)[1];let F=V.match(/\r+(.*)$/m)[1];F=F+B.slice(F.length,B.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,F)}return V}const z="\b".charCodeAt(0),H="\r".charCodeAt(0);function N(V){return!V.buffer.includes(z)&&!V.buffer.includes(H)?V:l.VSBuffer.fromString(R(U(n.decode(V.buffer))))}}),define(De[218],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[219],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=l;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function C(y){return Array.from(y.entries()).map(I=>[I[0],l(I[1].map)])}e.serializeEnvironmentVariableCollections=C;function P(y){return new Map(y.map(I=>[I[0],{map:t(I[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(y,I,E=y.parent){if(y._isRoot)return new C([I]);const D=[y.id];for(let A=E;A&&A.id!==I;A=A.parent)D.push(A.id);return D.push(I),new C(D.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const I=y.indexOf("\0");return I===-1?y:y.slice(0,I)}static fromString(y){return new C(y.split("\0"))}static join(y,I){return new C([...y.path,I])}static joinToString(y,I){return y.toString()+"\0"+I}static parentId(y){const I=y.lastIndexOf("\0");return I===-1?void 0:y.slice(0,I)}static compare(y,I){return y===I?0:I.startsWith(y+"\0")?2:y.startsWith(I+"\0")?3:1}constructor(y,I=y.length){if(this.path=y,this.viewEnd=I,y.length===0||I<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new C(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new C(this.path,y)}compare(y){if(typeof y=="string")return C.compare(this.toString(),y);for(let I=0;I<y.viewEnd&&I<this.viewEnd;I++)if(y.path[I]!==this.path[I])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=C}),define(De[66],Ie([1,0,2,35,55]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),n.deserialize=s=>({range:t.Range.lift(s.range),uri:l.URI.revive(s.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var E;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var D;(function(n){n.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&I.serialize(s.location)}),n.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&I.deserialize(s.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,s)=>`${s?"s":"e"}${n}`;e.getMarkId=A;var k;(function(n){n.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&I.serialize(s.location)}),n.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&I.deserialize(s.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var w;(function(n){n.serialize=s=>s.type===0?D.serialize(s):k.serialize(s),n.deserialize=s=>s.type===0?D.deserialize(s):k.deserialize(s)})(w=e.ITestMessage||(e.ITestMessage={}));var T;(function(n){n.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),n.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(w.serialize)}),n.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(w.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",g=(n,s)=>n+S+s;e.namespaceTestTag=g;const v=n=>{const s=n.indexOf(S);return{ctrlId:n.slice(0,s),tagId:n.slice(s+1)}};e.denamespaceTestTag=v;var m;(function(n){n.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),n.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?l.URI.revive(s.uri):void 0,range:s.range?t.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(m=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(n){n.serialize=s=>({expand:s.expand,item:m.serialize(s.item)}),n.deserialize=s=>({controllerId:C.TestId.root(s.item.extId),expand:s.expand,item:m.deserialize(s.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(n){n.serialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.uri!==void 0&&(h.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(h.range=s.item.range?.toJSON()),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}},n.deserialize=s=>{let h;return s.item&&(h={},s.item.label!==void 0&&(h.label=s.item.label),s.item.tags!==void 0&&(h.tags=s.item.tags),s.item.busy!==void 0&&(h.busy=s.item.busy),s.item.range!==void 0&&(h.range=s.item.range?t.Range.lift(s.item.range):null),s.item.description!==void 0&&(h.description=s.item.description),s.item.error!==void 0&&(h.error=s.item.error),s.item.sortText!==void 0&&(h.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:h}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const p=(n,s)=>{s.expand!==void 0&&(n.expand=s.expand),s.item!==void 0&&(n.item=n.item?Object.assign(n.item,s.item):s.item)};e.applyTestItemUpdate=p;var i;(function(n){n.serializeWithoutMessages=s=>({...f.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(T.serializeWithoutMessages),retired:s.retired}),n.serialize=s=>({...f.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(T.serialize),retired:s.retired}),n.deserialize=s=>({...f.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(T.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var d;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(d=e.DetailType||(e.DetailType={}));var a;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var r;(function(n){n.deserialize=s=>s.op===0?{op:s.op,item:f.deserialize(s.item)}:s.op===1?{op:s.op,item:c.deserialize(s.item)}:s.op===2?{op:s.op,uri:l.URI.revive(s.uri),docv:s.docv}:s,n.serialize=s=>s.op===0?{op:s.op,item:f.serialize(s.item)}:s.op===1?{op:s.op,item:c.serialize(s.item)}:s})(r=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(s){}update(s){}remove(s,h){}complete(){}}e.IncrementalChangeCollector=o;class u{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const h=this.createChangeCollector();for(const _ of s)switch(_.op){case 0:{const L=f.deserialize(_.item),M=C.TestId.parentId(L.item.extId)?.toString();if(M){if(this.items.has(M)){const U=this.items.get(M);U.children.add(L.item.extId);const R=this.createItem(L,U);this.items.set(L.item.extId,R),h.add(R)}}else{const U=this.createItem(L);this.roots.add(U),this.items.set(L.item.extId,U),h.add(U)}L.expand===2&&this.busyControllerCount++;break}case 1:{const L=c.deserialize(_.item),M=this.items.get(L.extId);if(!M)break;L.expand!==void 0&&(M.expand===2&&this.busyControllerCount--,L.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(M,L),h.update(M);break}case 3:{const L=this.items.get(_.itemId);if(!L)break;const M=C.TestId.parentId(L.item.extId)?.toString();M?this.items.get(M).children.delete(L.item.extId):this.roots.delete(L);const U=[[_.itemId]];for(;U.length;)for(const R of U.pop()){const z=this.items.get(R);z&&(U.push(z.children),this.items.delete(R),h.remove(z,z!==L),z.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(_.itemId);break;case 4:this.updatePendingRoots(_.amount);break;case 6:this._tags.set(_.tag.id,_.tag);break;case 7:this._tags.delete(_.id);break}h.complete()}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=u}),define(De[90],Ie([1,0,18,3,6,48,66,55]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(m,b)=>m===b,A={range:(m,b)=>m===b?!0:!m||!b?!1:m.equalsRange(b),busy:D,label:D,description:D,error:D,tags:(m,b)=>!(m.length!==b.length||m.some(f=>!b.includes(f)))},k=(m,b)=>{let f;for(const[c,p]of Object.entries(A))p(m[c],b[c])||(f?f[c]=b[c]:f={[c]:b[c]});return f};class w extends C.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const f of this.diff)if(f.op===2&&f.uri===b.uri){f.docv=b.docv;return}break}case 1:{const f=this.diff[this.diff.length-1];if(f){if(f.op===1&&f.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(f.item,b.item);return}if(f.op===0&&f.item.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(f.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,f){const c=this.tree.get(b);if(!!c){if((c.expandLevels===void 0||f>c.expandLevels)&&(c.expandLevels=f),c.expand===1){const p=this.resolveChildren(c);return p.isOpen()?this.expandChildren(c,f-1):p.wait().then(()=>this.expandChildren(c,f-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,f-1)):this.expandChildren(c,f-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,f){switch(f.op){case 3:this.removeItem(I.TestId.joinToString(b.fullId,f.id));break;case 0:this.upsertItem(f.item,b);break;case 5:for(const c of f.ops)this.onTestItemEvent(b,c);break;case 1:this.diffTagRefs(f.new,f.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:f.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,P.assertNever)(f)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,f){const c=I.TestId.fromExtHostTestItem(b,this.root.id,f?.actual),p=this.options.getApiFor(b);p.parent&&p.parent!==f?.actual&&this.options.getChildren(p.parent).delete(b.id);let i=this.tree.get(c.toString());if(!i){i={fullId:c,actual:b,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(b,f),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,i,f);return}if(i.actual===b){this.connectItem(b,i,f);return}const d=this.options.getChildren(i.actual),a=i.actual,r=k(this.options.toITestItem(a),this.options.toITestItem(b));this.options.getApiFor(a).listener=void 0,i.actual=b,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,a.tags,c.toString()),delete r.tags),this.onTestItemEvent(i,{op:4,update:r})),this.connectItemAndChildren(b,i,f);for(const[o,u]of d)this.options.getChildren(b).get(u.id)||this.removeItem(I.TestId.joinToString(c,u.id));this.documentSynced(i.actual.uri)}diffTagRefs(b,f,c){const p=new Set(f.map(i=>i.id));for(const i of b)p.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:c,item:{tags:b.map(i=>(0,y.namespaceTestTag)(this.options.controllerId,i.id))}}}),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const f=this.tags.get(b.id);f?f.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const f=this.tags.get(b);f&&!--f.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,f){this.options.getApiFor(b).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(b,f,c){this.setItemParent(b,c);const p=this.options.getApiFor(b);p.parent=c?.actual,p.listener=i=>this.onTestItemEvent(f,i),this.updateExpandability(f)}connectItemAndChildren(b,f,c){this.connectItem(b,f,c);for(const[p,i]of this.options.getChildren(b))this.upsertItem(i,f)}updateExpandability(b){let f;this._resolveHandler?b.resolveBarrier?f=b.resolveBarrier.isOpen()?3:2:f=b.actual.canResolveChildren?1:0:f=0,f!==b.expand&&(b.expand=f,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:f}}),f===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,f){if(f<0)return;const c=[];for(const[p,i]of this.options.getChildren(b.actual)){const d=this.expand(I.TestId.joinToString(b.fullId,i.id),f);(0,l.isThenable)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const i=new l.Barrier;return i.open(),i}b.expand=2,this.pushExpandStateUpdate(b);const f=b.resolveBarrier=new l.Barrier,c=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let p;try{p=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(i){c(i)}return(0,l.isThenable)(p)?p.catch(c).then(()=>{f.open(),this.updateExpandability(b)}):(f.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const f=this.tree.get(b);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const c=[f];for(;c.length;){const p=c.pop();if(!!p){this.options.getApiFor(p.actual).listener=void 0;for(const i of p.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(p.fullId.toString());for(const[i,d]of this.options.getChildren(p.actual))c.push(this.tree.get(I.TestId.joinToString(p.fullId,d.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=w;class T extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=T;class S extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=S;class g extends Error{constructor(b,f,c){super(`TestItem with ID "${b}" is from controller "${f}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=g;const v=(m,b,f)=>{let c=new Map;return{get size(){return c.size},forEach(p,i){for(const d of c.values())p.call(i,d,this)},[Symbol.iterator](){return c.entries()},replace(p){const i=new Map,d=new Set(c.keys()),a={op:5,ops:[]};for(const r of p){if(!(r instanceof f))throw new S(r.id);const o=b(r).controllerId;if(o!==m.controllerId)throw new g(r.id,o,m.controllerId);if(i.has(r.id))throw new T(r.id);i.set(r.id,r),d.delete(r.id),a.ops.push({op:0,item:r})}for(const r of d.keys())a.ops.push({op:3,id:r});m.listener?.(a),c=i},add(p){if(!(p instanceof f))throw new S(p.id);c.set(p.id,p),m.listener?.({op:0,item:p})},delete(p){c.delete(p)&&m.listener?.({op:3,id:p})},get(p){return c.get(p)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=v}),define(De[130],Ie([1,0,90]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,C=(y,I)=>{const E={controllerId:I};return t.set(y,E),E};e.createPrivateApiFor=C;const P=y=>{const I=t.get(y);if(!I)throw new l.InvalidTestItemError(y?.id||"<unknown>");return I};e.getPrivateApiFor=P}),define(De[220],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(y,I){super(I),this.variable=y}}e.VariableError=C}),define(De[221],Ie([1,0,9,36,12,24,10,110,185,220,8]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,S,g,v){this._contributedVariables=new Map,this._context=T,this._labelService=S,this._userHomePromise=g,v&&(this._envVariablesPromise=v.then(m=>this.prepareEnv(m)))}prepareEnv(T){if(y.isWindows){const S=Object.create(null);return Object.keys(T).forEach(g=>{S[g.toLowerCase()]=T[g]}),S}return T}resolveWithEnvironment(T,S,g){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},S?S.uri:void 0,g)}async resolveAsync(T,S){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,T?T.uri:void 0,S)}async resolveAnyBase(T,S,g,v){const m=P.deepClone(S);y.isWindows&&m.windows?Object.keys(m.windows).forEach(f=>m[f]=m.windows[f]):y.isMacintosh&&m.osx?Object.keys(m.osx).forEach(f=>m[f]=m.osx[f]):y.isLinux&&m.linux&&Object.keys(m.linux).forEach(f=>m[f]=m.linux[f]),delete m.windows,delete m.osx,delete m.linux;const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,T?T.uri:void 0,m,g,v)}async resolveAnyAsync(T,S,g){return this.resolveAnyBase(T,S,g)}async resolveAnyMap(T,S,g){const v=new Map;return{newConfig:await this.resolveAnyBase(T,S,g,v),resolvedVariables:v}}resolveWithInteractionReplace(T,S,g,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,S,g,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,S){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,S)}async recursiveResolve(T,S,g,v,m){if(C.isString(g))return this.resolveString(T,S,g,v,m);if(Array.isArray(g))return Promise.all(g.map(b=>this.recursiveResolve(T,S,b,v,m)));if(C.isObject(g)){const b=Object.create(null),f=await Promise.all(Object.keys(g).map(async c=>[await this.resolveString(T,S,c,v,m),await this.recursiveResolve(T,S,g[c],v,m)]));for(const[c,p]of f)b[c]=p;return b}return g}resolveString(T,S,g,v,m){return(0,A.replaceAsync)(g,k.VARIABLE_REGEXP,async(b,f)=>{if(f.includes(k.VARIABLE_LHS))return b;let c=await this.evaluateSingleVariable(T,b,f,S,v);return m?.set(f,c),c!==b&&C.isString(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.resolveString(T,S,c,v,m)),c})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,S,g,v,m){let b;const f=g.split(":");f.length>1&&(g=f[0],b=f[1]);const c=d=>{const a=this._context.getFilePath();if(a)return a;throw new D.VariableError(d,(0,E.localize)(0,null,S))},p=d=>{const a=c(d);if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new D.VariableError(d,(0,E.localize)(1,null,S,l.basename(a)))},i=d=>{if(b){const a=this._context.getFolderUri(b);if(a)return a;throw new D.VariableError(d,(0,E.localize)(2,null,S,b))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new D.VariableError(d,(0,E.localize)(3,null,S)):new D.VariableError(d,(0,E.localize)(4,null,S))};switch(g){case"env":if(b){if(T.env){const d=T.env[y.isWindows?b.toLowerCase():b];if(C.isString(d))return d}return""}throw new D.VariableError(D.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(b){const d=this._context.getConfigurationValue(v,b);if(C.isUndefinedOrNull(d))throw new D.VariableError(D.VariableKind.Config,(0,E.localize)(6,null,S,b));if(C.isObject(d))throw new D.VariableError(D.VariableKind.Config,(0,E.localize)(7,null,S,b));return d}throw new D.VariableError(D.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.resolveFromMap(D.VariableKind.Command,S,b,m,"command");case"input":return this.resolveFromMap(D.VariableKind.Input,S,b,m,"input");case"extensionInstallFolder":if(b){const d=await this._context.getExtension(b);if(!d)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,b));return this.fsPath(d.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(i(D.VariableKind.WorkspaceFolder)));case"cwd":return v||b?(0,I.normalizeDriveLetter)(this.fsPath(i(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(i(D.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new D.VariableError(D.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new D.VariableError(D.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return c(D.VariableKind.File);case"fileWorkspaceFolder":return p(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return v||b?l.relative(this.fsPath(i(D.VariableKind.RelativeFile)),c(D.VariableKind.RelativeFile)):c(D.VariableKind.RelativeFile);case"relativeFileDirname":{const d=l.dirname(c(D.VariableKind.RelativeFileDirname));if(v||b){const a=l.relative(this.fsPath(i(D.VariableKind.RelativeFileDirname)),d);return a.length===0?".":a}return d}case"fileDirname":return l.dirname(c(D.VariableKind.FileDirname));case"fileExtname":return l.extname(c(D.VariableKind.FileExtname));case"fileBasename":return l.basename(c(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=l.basename(c(D.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-l.extname(d).length)}case"fileDirnameBasename":return l.basename(l.dirname(c(D.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||S}case"execInstallFolder":{const d=this._context.getAppRoot();return d||S}case"pathSeparator":return l.sep;default:try{const d=b?`${g}:${b}`:g;return this.resolveFromMap(D.VariableKind.Unknown,S,d,m,void 0)}catch{return S}}}}resolveFromMap(T,S,g,v,m){if(g&&v){const b=m===void 0?v[g]:v[m+":"+g];if(typeof b=="string")return b;throw new D.VariableError(T,(0,E.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[131],Ie([1,0,4,128]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var C;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var I;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function D(S){const g=S;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=D;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function w(S){const g=S;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=w;function T(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[222],Ie([1,0,4,131]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=C}),define(De[223],Ie([1,0,4,190]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[224],Ie([1,0,27,3,9]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class y{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let w of k.activationEvents)w==="onUri"&&(w=`onUri:${l.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,w){this._extensionDescriptions=D(this._extensionDescriptions,w),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,T.map(S=>S.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,b){this.addNode(m),this.addNode(b),this._arcs.has(m)?this._arcs.get(m).push(b):this._arcs.set(m,[b])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,b){const f=w.getArcs(m);for(let c=0;c<f.length;c++)if(!b.has(f[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const m of k){const b=l.ExtensionIdentifier.toKey(m.identifier);if(T.set(b,m),m.extensionDependencies)for(const f of m.extensionDependencies){const c=l.ExtensionIdentifier.toKey(f);w.addArc(b,c)}}const S=new Set;w.getNodes().filter(m=>w.getArcs(m).length===0).forEach(m=>S.add(m));const g=w.getNodes().filter(m=>!S.has(m));let v;do{v=!1;for(let m=0;m<g.length;m++){const b=g[m];w.hasOnlyGoodArcs(b,S)&&(g.splice(m,1),m--,S.add(b),v=!0)}}while(v);return g.map(m=>T.get(m))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const w=this._activationMap.get(k);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const w=this._extensionsMap.get(l.ExtensionIdentifier.toKey(k));return w||void 0}getExtensionDescriptionByUUID(k){for(const w of this._extensionsArr)if(w.uuid===k)return w}getExtensionDescriptionByIdOrUUID(k,w){return this.getExtensionDescription(k)??(w?this.getExtensionDescriptionByUUID(w):void 0)}}e.ExtensionDescriptionRegistry=y;var I;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(I||(I={}));function E(A,k){const w=A.isBuiltin?0:A.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(w!==T)return w-T;const S=C.posix.basename(A.extensionLocation.path),g=C.posix.basename(k.extensionLocation.path);return S<g?-1:S>g?1:0}function D(A,k){const w=new Set;return k.forEach(T=>w.add(l.ExtensionIdentifier.toKey(T))),A.filter(T=>!w.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[225],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class C{constructor(){this.type=2}serialize(k){k[C.ENV_KEY]="1"}}e.SocketExtHostConnection=C,C.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(A){delete A[t.ENV_KEY],delete A[C.ENV_KEY],delete A[P.ENV_KEY]}function I(A,k){y(k),A.serialize(k)}e.writeExtHostConnection=I;function E(A){if(A[t.ENV_KEY])return D(A,new t(A[t.ENV_KEY]));if(A[C.ENV_KEY])return D(A,new C);if(A[P.ENV_KEY])return D(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function D(A,k){return y(A),k}}),define(De[91],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var C;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(D){const A=l.VSBuffer.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=y;function I(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=I;var E;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[92],Ie([1,0,4,3,13,25,91,85,203,24,2]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class{constructor(g,v){this.initData=g,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,console.log(this.initData.environment.extensionTelemetryLogResource),this._outputLogger=v.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(g,v){const m=this.getTelemetryDetails(),b=new w(v,g,this._outputLogger,this.getBuiltInCommonProperties(g),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled});return this._telemetryLoggers.set(g.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(g,v){this._level=g,this._productConfig=v||{usage:!0,error:!0}}getBuiltInCommonProperties(g){const v={};switch(v["common.extname"]=g.name,v["common.extversion"]=g.version,v["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,v["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,v["common.vscodeversion"]=this.initData.version,v["common.isnewappinstall"]=T(this.initData.telemetryInfo.firstSessionDate),v["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:v["common.uikind"]="web";break;case y.UIKind.Desktop:v["common.uikind"]="desktop";break;default:v["common.uikind"]="unknown"}return v["common.remotename"]=(0,I.getRemoteName)((0,E.cleanRemoteAuthority)(this.initData.remote.authority)),v}$onDidChangeTelemetryLevel(g){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=g;const v=this.getTelemetryDetails();this._telemetryLoggers.forEach(m=>{m.updateTelemetryEnablements(v.isUsageEnabled,v.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(g,v){const m=this._telemetryLoggers.get(g.value);return m?(m.logError(v),!0):!1}};k=je([$e(0,P.IExtHostInitDataService),$e(1,C.ILoggerService)],k),e.ExtHostTelemetry=k;class w{constructor(g,v,m,b,f){this._extension=v,this._logger=m,this._commonProperties=b,this._onDidChangeEnableStates=new t.Emitter,this._appender=g,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(g,v){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:g,isErrorsEnabled:v},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(g){return this._appender.ignoreBuiltInCommonProperties||(g=(0,D.mixin)(g,this._commonProperties)),this._appender.additionalCommonProperties&&(g=(0,D.mixin)(g,this._appender.additionalCommonProperties)),g=(0,E.cleanData)(g,[]),g}logEvent(g,v){g=this._extension.identifier.value+"/"+g,v=this.mixInCommonPropsAndCleanData(v||{}),this._appender.logEvent(g,v),this._logger.trace(g,v)}logUsage(g,v){!this._telemetryEnablements.isUsageEnabled||this.logEvent(g,v)}logError(g,v){!this._telemetryEnablements.isErrorsEnabled||(typeof g=="string"?this.logEvent(g,v):this._appender.logException(g,v))}get apiTelemetryLogger(){if(!this._apiObject){const g=this,v={logUsage:g.logUsage,get isUsageEnabled(){return g._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return g._telemetryEnablements.isErrorsEnabled},logError:g.logError,dispose:g.dispose,onDidChangeEnableStates:g._onDidChangeEnableStates.event};this._apiObject=Object.freeze(v)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=w;function T(S){const g=Date.now()-new Date(S).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.isNewAppInstall=T,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[28],Ie([1,0,3,2,4,27,199]),function(J,e,l,t,C,P,y){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class E{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class D{constructor(){this.kind=2,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=D;class A{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class k{constructor(u){this.dependency=u}}e.MissingExtensionDependency=k;var w;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(w=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class S{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(u,n){const s=[],h=[],_=[],L=[],M=m(this._allExtensions),U=m(u),R=(V,B)=>V.extensionLocation.toString()===B.extensionLocation.toString()||V.isBuiltin===B.isBuiltin||V.isUserBuiltin===B.isUserBuiltin||V.isUnderDevelopment===B.isUnderDevelopment;for(const V of this._allExtensions){const B=U.get(P.ExtensionIdentifier.toKey(V.identifier));if(!B){s.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}if(!R(V,B)){s.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}}for(const V of u){const B=M.get(P.ExtensionIdentifier.toKey(V.identifier));if(!B){h.push(V);continue}if(!R(B,V)){s.push(B.identifier),M.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}const z=v(this._myExtensions),H=v(n);for(const V of this._myExtensions)H.has(P.ExtensionIdentifier.toKey(V))||_.push(V);for(const V of n)z.has(P.ExtensionIdentifier.toKey(V))||L.push(V);const N={toRemove:s,toAdd:h,myToRemove:_,myToAdd:L};return this.delta(N),N}delta(u){const{toRemove:n,toAdd:s,myToRemove:h,myToAdd:_}=u,L=v(n),M=v(h);for(let U=0;U<this._allExtensions.length;U++)L.has(P.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of s)this._allExtensions.push(U);for(const U of _)this._myExtensions.push(U)}containsExtension(u){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=S;class g{constructor(u){if(this[I]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this._map.size}add(u){return this._map.set(this._toKey(u),u),this}clear(){this._map.clear()}delete(u){return this._map.delete(this._toKey(u))}has(u){return this._map.has(this._toKey(u))}forEach(u,n){this._map.forEach(s=>u.call(n,s,s,this))}*entries(){for(const[u,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function v(o){const u=new Set;for(const n of o)u.add(P.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=v;function m(o){const u=new Map;for(const n of o)u.set(P.ExtensionIdentifier.toKey(n.identifier),n);return u}function b(o,u){return o.enabledApiProposals?o.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=b;function f(o,u){if(!b(o,u))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=f;class c{constructor(u,n,s,h){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=h}}e.ActivationTimes=c;class p{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function d(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function a(o,u){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!u,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=a;class r{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,n){return Promise.resolve()}}e.NullExtensionService=r}),define(De[226],Ie([1,0,11,27,28,13,18]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class I{constructor(v,m,b,f){this.startup=v,this.codeLoadingTime=m,this.activateCallTime=b,this.activateResolvedTime=f}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class E{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,m){return v===-1||m===-1?-1:m-v}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class D{constructor(v,m,b,f,c,p){this.activationFailed=v,this.activationFailedError=m,this.activationTimes=b,this.module=f,this.exports=c,this.subscriptions=p}}e.ActivatedExtension=D;class A extends D{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class k extends D{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class w extends D{constructor(v){super(!0,v,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=w;let T=class{constructor(v,m,b,f,c){this._logService=c,this._registry=v,this._resolvedExtensionsSet=new Set,m.forEach(p=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(p))),this._externalExtensionsMap=new Map,b.forEach(p=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(p),p)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[v,m]of this._operations)m.dispose()}isActivated(v){const m=this._operations.get(t.ExtensionIdentifier.toKey(v));return Boolean(m&&m.value)}getActivatedExtension(v){const m=this._operations.get(t.ExtensionIdentifier.toKey(v));if(!m||!m.value)throw new Error(`Extension '${v.value}' is not known or not activated`);return m.value}async activateByEvent(v,m){if(this._alreadyActivatedEvents[v])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(v);await this._activateExtensions(b.map(f=>({id:f.identifier,reason:{startup:m,extensionId:f.identifier,activationEvent:v}}))),this._alreadyActivatedEvents[v]=!0}activateById(v,m){const b=this._registry.getExtensionDescription(v);if(!b)throw new Error(`Extension '${v}' is not known`);return this._activateExtensions([{id:b.identifier,reason:m}])}async _activateExtensions(v){const m=v.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(m.map(b=>b.wait()))}_handleActivationRequest(v){if(this._operations.has(t.ExtensionIdentifier.toKey(v.id)))return this._operations.get(t.ExtensionIdentifier.toKey(v.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(v.id)))return this._createAndSaveOperation(v,null,[],null);const m=this._registry.getExtensionDescription(v.id);if(!m){const c=new Error(`Cannot activate unknown extension '${v.id.value}'`),p=this._createAndSaveOperation(v,null,[],new w(c));return this._host.onExtensionActivationError(v.id,c,new C.MissingExtensionDependency(v.id.value)),p}const b=[],f=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const c of f){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const p=this._operations.get(t.ExtensionIdentifier.toKey(c));if(p){b.push(p);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){b.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:v.reason}));continue}const i=this._registry.getExtensionDescription(c);if(i){if(!i.main&&!i.browser)continue;b.push(this._handleActivationRequest({id:i.identifier,reason:v.reason}));continue}const d=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),r=this._createAndSaveOperation(v,m.displayName,[],new w(a));return this._host.onExtensionActivationError(m.identifier,a,new C.MissingExtensionDependency(c)),r}return this._createAndSaveOperation(v,m.displayName,b,null)}_createAndSaveOperation(v,m,b,f){const c=new S(v.id,m,v.reason,b,f,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(v.id),c),c}};T=je([$e(4,P.ILogService)],T),e.ExtensionsActivator=T;let S=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(v,m,b,f,c,p,i){this._id=v,this._displayName=m,this._reason=b,this._deps=f,this._value=c,this._host=p,this._logService=i,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let v=0;v<this._deps.length;v++){const m=this._deps[v];if(m.value&&!m.value.activationFailed){this._deps.splice(v,1),v--;continue}if(m.value&&m.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);b.detail=m.value.activationFailedError,this._value=new w(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(v=>v.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(v){const m=new Error;if(v&&v.name&&(m.name=v.name),v&&v.message?m.message=`Activating extension '${this._id.value}' failed: ${v.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${v}.`,v&&v.stack&&(m.stack=v.stack),this._value=new w(m),this._isDisposed&&l.isCancellationError(v))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(v)}}};S=je([$e(6,P.ILogService)],S)}),define(De[227],Ie([1,0,13,25,28]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(I,E){super(I.createLogger(E.logFile,{name:C.ExtensionHostLogFileName}))}};P=je([$e(0,l.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,11,109,26,104,8,12,2,31,38,126,89,28]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S){"use strict";var g,v,m,b,f,c,p,i,d,a,r,o,u,n,s,h,_,L,M,U,R,z,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N(q){return Object.assign(q,{apply:function(){const ue=arguments.length===1?[]:arguments[1];return Reflect.construct(q,ue,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[ue,...Te]=arguments;return Reflect.construct(q,Te,ue.constructor)}}})}let V=c=class{static from(...W){let ue=W;return new c(function(){if(ue){for(const Te of ue)Te&&typeof Te.dispose=="function"&&Te.dispose();ue=void 0}})}constructor(W){g.set(this,void 0),tt(this,g,W,"f")}dispose(){typeof Be(this,g,"f")=="function"&&(Be(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,V=c=je([N],V),e.Disposable=V;let B=p=class{static Min(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isBefore(ue)&&(ue=Xe)}return ue}static Max(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isAfter(ue)&&(ue=Xe)}return ue}static isPosition(W){if(!W)return!1;if(W instanceof p)return!0;const{line:ue,character:Te}=W;return typeof ue=="number"&&typeof Te=="number"}static of(W){if(W instanceof p)return W;if(this.isPosition(W))return new p(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=ue}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ue=0){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,ue=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&ue===0?this:new p(this.line+Te,this.character+ue)}with(W,ue=this.character){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,ue=typeof W.character=="number"?W.character:this.character),Te===this.line&&ue===this.character?this:new p(Te,ue)}toJSON(){return{line:this.line,character:this.character}}};B=p=je([N],B),e.Position=B;let F=i=class{static isRange(W){return W instanceof i?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");et.isBefore(ut)?(this._start=et,this._end=ut):(this._start=ut,this._end=et)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ue=B.Max(W.start,this._start),Te=B.Min(W.end,this._end);if(!ue.isAfter(Te))return new i(ue,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ue=B.Min(W.start,this._start),Te=B.Max(W.end,this.end);return new i(ue,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ue=this.end){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return W?B.isPosition(W)?Te=W:(Te=W.start||this.start,ue=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&ue.isEqual(this.end)?this:new i(Te,ue)}toJSON(){return[this.start,this.end]}};F=i=je([N],F),e.Range=F;let x=d=class extends F{static isSelection(W){return W instanceof d?!0:W?F.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");super(et,ut),this._anchor=et,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=je([N],x),e.Selection=x;class ${constructor(W,ue,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ue),this.connectionToken=Te}}e.ResolvedAuthority=$;class Q extends Error{static NotAvailable(W,ue){return new Q(W,w.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(W){return new Q(W,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ue=w.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=ue,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var de;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=a=class{static isTextEdit(W){return W instanceof a?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ue){return new a(W,ue)}static insert(W,ue){return a.replace(new F(W,W),ue)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const ue=new a(new F(new B(0,0),new B(0,0)),"");return ue.newEol=W,ue}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,ue){this._range=W,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=a=je([N],ee),e.TextEdit=ee;let he=r=class{static isNotebookCellEdit(W){return W instanceof r?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ue){return new r(W,ue)}static insertCells(W,ue){return new r(new Vt(W,W),ue)}static deleteCells(W){return new r(W,[])}static updateCellMetadata(W,ue){const Te=new r(new Vt(W,W),[]);return Te.newCellMetadata=ue,Te}static updateNotebookMetadata(W){const ue=new r(new Vt(0,0),[]);return ue.newNotebookMetadata=W,ue}constructor(W,ue){this.range=W,this.newCells=ue}};he=r=je([N],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?F.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,ue){return new Y(W,ue)}static insert(W,ue){return Y.replace(new F(W,W),ue)}constructor(W,ue){this.range=W,this.snippet=ue}}e.SnippetTextEdit=Y;var me;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(me=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ue,Te,Xe){this._edits.push({_type:1,from:W,to:ue,options:Te,metadata:Xe})}createFile(W,ue,Te){this._edits.push({_type:1,from:void 0,to:W,options:ue,metadata:Te})}deleteFile(W,ue,Te){this._edits.push({_type:1,from:W,to:void 0,options:ue,metadata:Te})}replaceNotebookMetadata(W,ue,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(W,ue,Te,Xe){const et=ue.start,ut=ue.end;(et!==ut||Te.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ut-et,cells:Te,metadata:Xe})}replaceNotebookCellMetadata(W,ue,Te,Xe){this._edits.push({_type:3,metadata:Xe,uri:W,edit:{editType:8,index:ue,metadata:Te}})}replace(W,ue,Te,Xe){this._edits.push({_type:2,uri:W,edit:new ee(ue,Te),metadata:Xe})}insert(W,ue,Te,Xe){this.replace(W,new F(ue,ue),Te,Xe)}delete(W,ue,Te){this.replace(W,ue,"",Te)}has(W){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===W.toString())}set(W,ue){if(ue)for(const Te of ue){if(!Te)continue;let Xe,et;Array.isArray(Te)?(Xe=Te[0],et=Te[1]):Xe=Te,he.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(W,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.replaceNotebookMetadata(W,Xe.newNotebookMetadata,et):this.replaceNotebookCells(W,Xe.range,Xe.newCells,et):Y.isSnippetTextEdit(Xe)?this._edits.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Xe,metadata:et})}else{for(let Te=0;Te<this._edits.length;Te++){const Xe=this._edits[Te];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,l.coalesceInPlace)(this._edits)}}get(W){const ue=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&ue.push(Te.edit);return ue}entries(){const W=new P.ResourceMap;for(const ue of this._edits)if(ue._type===2){let Te=W.get(ue.uri);Te||(Te=[ue.uri,[]],W.set(ue.uri,Te)),Te[1].push(ue.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([N],be),e.WorkspaceEdit=be;let ke=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ue=this._tabstop++){if(typeof W=="function"){const Te=new o;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=o._escape(W);return this.value+="${",this.value+=ue,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ue=this._tabstop++){const Te=W.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,ue){if(typeof ue=="function"){const Te=new o;Te._tabstop=this._tabstop,ue(Te),this._tabstop=Te._tabstop,ue=Te.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};ke=o=je([N],ke),e.SnippetString=ke;var Re;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=u=class{static isLocation(W){return W instanceof u?!0:W?F.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,ue){if(this.uri=W,ue)if(F.isRange(ue))this.range=F.of(ue);else if(B.isPosition(ue))this.range=new F(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};oe=u=je([N],oe),e.Location=oe;let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,ue){this.location=W,this.message=ue}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.location.range.isEqual(ue.location.range)&&W.location.uri.toString()===ue.location.uri.toString()}};le=je([N],le),e.DiagnosticRelatedInformation=le;let ge=class{constructor(W,ue,Te=ze.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=W,this.message=ue,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.severity===ue.severity&&W.code===ue.code&&W.severity===ue.severity&&W.source===ue.source&&W.range.isEqual(ue.range)&&(0,l.equals)(W.tags,ue.tags)&&(0,l.equals)(W.relatedInformation,ue.relatedInformation,le.isEqual)}};ge=je([N],ge),e.Diagnostic=ge;let Z=class{constructor(W,ue){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ue}};Z=je([N],Z),e.Hover=Z;var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,ue=ae.Text){this.range=W,this.kind=ue}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=je([N],ne),e.DocumentHighlight=ne;var ie;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var O;(function(q){q[q.Deprecated=1]="Deprecated"})(O=e.SymbolTag||(e.SymbolTag={}));let j=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ue,Te,Xe,et){this.name=W,this.kind=ue,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Xe instanceof oe?this.location=Xe:Te instanceof F&&(this.location=new oe(Xe,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};j=n=je([N],j),e.SymbolInformation=j;let G=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,ue,Te,Xe,et){this.name=W,this.detail=ue,this.kind=Te,this.range=Xe,this.selectionRange=et,this.children=[],s.validate(this)}};G=s=je([N],G),e.DocumentSymbol=G;var X;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,ue){this.title=W,this.kind=ue}};pe=je([N],pe),e.CodeAction=pe;let we=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.sep)}};we.sep=".",we=h=je([N],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,ue){if(this.range=W,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=je([N],ce),e.SelectionRange=ce;class Ce{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.CallHierarchyItem=Ce;class ye{constructor(W,ue){this.fromRanges=ue,this.from=W}}e.CallHierarchyIncomingCall=ye;class We{constructor(W,ue){this.fromRanges=ue,this.to=W}}e.CallHierarchyOutgoingCall=We;var qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,ue){this.range=W,this.command=ue}get isResolved(){return!!this.command}};Ze=je([N],Ze),e.CodeLens=Ze;let Ye=_=class{static isMarkdownString(W){return W instanceof _?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ue=!1){v.set(this,void 0),tt(this,v,new C.MarkdownString(W,{supportThemeIcons:ue}),"f")}get value(){return Be(this,v,"f").value}set value(W){Be(this,v,"f").value=W}get isTrusted(){return Be(this,v,"f").isTrusted}set isTrusted(W){Be(this,v,"f").isTrusted=W}get supportThemeIcons(){return Be(this,v,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,v,"f").supportThemeIcons=W}get supportHtml(){return Be(this,v,"f").supportHtml}set supportHtml(W){Be(this,v,"f").supportHtml=W}get baseUri(){return Be(this,v,"f").baseUri}set baseUri(W){Be(this,v,"f").baseUri=W}appendText(W){return Be(this,v,"f").appendText(W),this}appendMarkdown(W){return Be(this,v,"f").appendMarkdown(W),this}appendCodeblock(W,ue){return Be(this,v,"f").appendCodeblock(ue??"",W),this}};v=new WeakMap,Ye=_=je([N],Ye),e.MarkdownString=Ye;let Ne=class{constructor(W,ue){this.label=W,this.documentation=ue}};Ne=je([N],Ne),e.ParameterInformation=Ne;let at=class{constructor(W,ue){this.label=W,this.documentation=ue,this.parameters=[]}};at=je([N],at),e.SignatureInformation=at;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=je([N],re),e.SignatureHelp=re;var se;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Ve=class{constructor(W){this.value=W}};Ve=je([N],Ve),e.InlayHintLabelPart=Ve;let fe=class{constructor(W,ue,Te){this.position=W,this.label=ue,this.kind=Te}};fe=je([N],fe),e.InlayHint=fe;var Ae;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Me;(function(q){q[q.Deprecated=1]="Deprecated"})(Me=e.CompletionItemTag||(e.CompletionItemTag={}));let Ke=class{constructor(W,ue){this.label=W,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ke=je([N],Ke),e.CompletionItem=Ke;let Je=class{constructor(W=[],ue=!1){this.items=W,this.isIncomplete=ue}};Je=je([N],Je),e.CompletionList=Je;let st=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};st=je([N],st),e.InlineSuggestion=st;let ot=class{constructor(W){this.commands=void 0,this.items=W}};ot=je([N],ot),e.InlineSuggestionList=ot;let it=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};it=je([N],it),e.InlineSuggestionNew=it;let lt=class{constructor(W,ue){this.items=W,this.commands=ue}};lt=je([N],lt),e.InlineSuggestionsNew=lt;var vt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(vt=e.ViewColumn||(e.ViewColumn={}));var wt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Et;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(ue){switch(ue){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,ue){if(ue&&!D.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=ue}};Ot=je([N],Ot),e.DocumentLink=Ot;let Pt=class{constructor(W,ue,Te,Xe){this.red=W,this.green=ue,this.blue=Te,this.alpha=Xe}};Pt=je([N],Pt),e.Color=Pt;let gt=class{constructor(W,ue){if(ue&&!(ue instanceof Pt))throw(0,t.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=ue}};gt=je([N],gt),e.ColorInformation=gt;let kt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};kt=je([N],kt),e.ColorPresentation=kt;var Pe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Pe=e.ColorFormat||(e.ColorFormat={}));var Oe;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Oe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class te{constructor(W,ue,Te){if(this.startIndex=W,this.length=ue,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=te;var Fe;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=xe;var nt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=L=class{static from(W){switch(W){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(W,ue){if(this.label=ue,typeof W!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};rt.Clean=new L("clean","Clean"),rt.Build=new L("build","Build"),rt.Rebuild=new L("rebuild","Rebuild"),rt.Test=new L("test","Test"),rt=L=je([N],rt),e.TaskGroup=rt;function pt(q){let W="";for(let ue=0;ue<q.length;ue++)W+=q[ue].replace(/,/g,",,")+",";return W}let St=class{constructor(W,ue,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Te):this._options=ue)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ue of this._args)W.push(ue);return pt(W)}};St=je([N],St),e.ProcessExecution=St;let Tt=class{constructor(W,ue,Te){if(this._args=[],Array.isArray(ue)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=ue,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ue of this._args)W.push(typeof ue=="string"?ue:ue.value);return pt(W)}};Tt=je([N],Tt),e.ShellExecution=Tt;var It;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class bt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=bt;let Ct=M=class{constructor(W,ue,Te,Xe,et,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Te,this.execution=Xe,ht=et,this.__deprecated=!0):ue===_t.Global||ue===_t.Workspace?(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut):(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof St?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ue=this._definition.type;(M.EmptyType===ue||M.ProcessType===ue||M.ShellType===ue||M.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ct.ExtensionCallbackType="customExecution",Ct.ProcessType="process",Ct.ShellType="shell",Ct.EmptyType="$empty",Ct=M=je([N],Ct),e.Task=Ct;var en;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(en=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(q){function W(ue){const Te=ue;return(0,E.isNumber)(Te.value)?Te.tooltip&&!(0,E.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(yt=e.ViewBadge||(e.ViewBadge={}));let qt=U=class{static isTreeItem(W,ue){if(W instanceof U)return!0;const Te=W;if(Te.label!==void 0&&!(0,E.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,E.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,E.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,E.isString)(Te.iconPath.id))){const Xe=Te.iconPath;if(!Xe||!(0,E.isString)(Xe.light)&&!D.URI.isUri(Xe.light)&&!(0,E.isString)(Xe.dark)&&!D.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,E.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,E.isString)(Te.tooltip)&&!(Te.tooltip instanceof Ye))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Ht.None&&Te.collapsibleState>Ht.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,E.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,S.checkProposedApiEnabled)(ue,"treeItemCheckbox");const Xe=(0,E.isNumber)(Te.checkboxState)?Te.checkboxState:(0,E.isObject)(Te.checkboxState)&&(0,E.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,et=!(0,E.isNumber)(Te.checkboxState)&&(0,E.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==tn.Checked&&Xe!==tn.Unchecked||et!==void 0&&!(0,E.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,ue=Ht.None){this.collapsibleState=ue,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};qt=U=je([N],qt),e.TreeItem=qt;var Ht;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var tn;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(tn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let un=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,ue){this.value=W,this.id=ue??(0,A.generateUuid)()}};un=je([N],un),e.DataTransferItem=un;let At=class{constructor(W){m.set(this,new Map);for(const[ue,Te]of W??[]){const Xe=Be(this,m,"f").get(ue);Xe?Xe.push(Te):Be(this,m,"f").set(ue,[Te])}}get(W){return Be(this,m,"f").get(W)?.[0]}set(W,ue){Be(this,m,"f").set(W,[ue])}forEach(W,ue){for(const[Te,Xe]of Be(this,m,"f"))for(const et of Xe)W.call(ue,et,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[W,ue]of Be(this,m,"f"))for(const Te of ue)yield[W,Te]}};At=je([N],At),e.DataTransfer=At;let nn=class{constructor(W){this.insertText=W}};nn=je([N],nn),e.DocumentDropEdit=nn;let dn=class{constructor(W){this.insertText=W}};dn=je([N],dn),e.DocumentPasteEdit=dn;let Ut=class{constructor(W,ue){this.id=W,this.color=ue}};Ut=je([N],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(W){this.id=W}};Jt=je([N],Jt),e.ThemeColor=Jt;var dt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(dt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let hn=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=D.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ue){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};hn=je([N],hn),e.RelativePattern=hn;let Nt=class{constructor(W,ue,Te,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof ue=="string"&&(this.condition=ue),typeof Te=="string"&&(this.hitCondition=Te),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Nt=je([N],Nt),e.Breakpoint=Nt;let Gt=class extends Nt{constructor(W,ue,Te,Xe,et){if(super(ue,Te,Xe,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Gt=je([N],Gt),e.SourceBreakpoint=Gt;let rn=class extends Nt{constructor(W,ue,Te,Xe,et){super(ue,Te,Xe,et),this.functionName=W}};rn=je([N],rn),e.FunctionBreakpoint=rn;let fn=class extends Nt{constructor(W,ue,Te,Xe,et,ut,ht){if(super(Xe,et,ut,ht),!ue)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=ue,this.canPersist=Te}};fn=je([N],fn),e.DataBreakpoint=fn;let sn=class{constructor(W,ue,Te){this.command=W,this.args=ue||[],this.options=Te}};sn=je([N],sn),e.DebugAdapterExecutable=sn;let mn=class{constructor(W,ue){this.port=W,this.host=ue}};mn=je([N],mn),e.DebugAdapterServer=mn;let on=class{constructor(W){this.path=W}};on=je([N],on),e.DebugAdapterNamedPipeServer=on;let Zt=class{constructor(W){this.implementation=W}};Zt=je([N],Zt),e.DebugAdapterInlineImplementation=Zt;let gn=class{constructor(W,ue){this.range=W,this.expression=ue}};gn=je([N],gn),e.EvaluatableExpression=gn;var pn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let bn=class{constructor(W,ue){this.range=W,this.text=ue}};bn=je([N],bn),e.InlineValueText=bn;let wn=class{constructor(W,ue,Te=!0){this.range=W,this.variableName=ue,this.caseSensitiveLookup=Te}};wn=je([N],wn),e.InlineValueVariableLookup=wn;let Kt=class{constructor(W,ue){this.range=W,this.expression=ue}};Kt=je([N],Kt),e.InlineValueEvaluatableExpression=Kt;let En=class{constructor(W,ue){this.frameId=W,this.stoppedLocation=ue}};En=je([N],En),e.InlineValueContext=En;var Fn;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Sn=R=class extends Error{static FileExists(W){return new R(W,k.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(W){return new R(W,k.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(W){return new R(W,k.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(W){return new R(W,k.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(W){return new R(W,k.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(W){return new R(W,k.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(W,ue=k.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Sn=R=je([N],Sn),e.FileSystemError=Sn;let _n=class{constructor(W,ue,Te){this.start=W,this.end=ue,this.kind=Te}};_n=je([N],_n),e.FoldingRange=_n;var yn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Tn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Tn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var He;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(He=e.CommentThreadState||(e.CommentThreadState={}));class xt{constructor(W,ue=[]){this.tokenTypes=W,this.tokenModifiers=ue}}e.SemanticTokensLegend=xt;function An(q){return typeof q>"u"||(0,E.isStringArray)(q)}class mt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ue=0,Te=W.tokenTypes.length;ue<Te;ue++)this._tokenTypeStrToInt.set(W.tokenTypes[ue],ue);for(let ue=0,Te=W.tokenModifiers.length;ue<Te;ue++)this._tokenModifierStrToInt.set(W.tokenModifiers[ue],ue)}}push(W,ue,Te,Xe,et){if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,ue,Te,Xe,et);if(F.isRange(W)&&typeof ue=="string"&&An(Te))return this._push(W,ue,Te);throw(0,t.illegalArgument)()}_push(W,ue,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,et=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(ue);let Lt=0;if(Te)for(const Wt of Te){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Wt);Lt|=1<<$t>>>0}this._pushEncoded(Xe,et,ut,ht,Lt)}_pushEncoded(W,ue,Te,Xe,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Wt=0,$t=0;for(let jt=0;jt<Lt;jt++){let Qt=this._data[5*jt],In=this._data[5*jt+1];Qt===0?(Qt=Wt,In+=$t):Qt+=Wt,this._data[5*jt]=Qt,this._data[5*jt+1]=In,Wt=Qt,$t=In}}let ut=W,ht=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=ue}static _sortAndDeltaEncode(W){const ue=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)ue[ht]=ht;ue.sort((ht,Lt)=>{const Wt=W[5*ht],$t=W[5*Lt];if(Wt===$t){const jt=W[5*ht+1],Qt=W[5*Lt+1];return jt-Qt}return Wt-$t});const Xe=new Uint32Array(W.length);let et=0,ut=0;for(let ht=0;ht<Te;ht++){const Lt=5*ue[ht],Wt=W[Lt+0],$t=W[Lt+1],jt=W[Lt+2],Qt=W[Lt+3],In=W[Lt+4],Jn=Wt-et,Di=Jn===0?$t-ut:$t,kn=5*ht;Xe[kn+0]=Jn,Xe[kn+1]=Di,Xe[kn+2]=jt,Xe[kn+3]=Qt,Xe[kn+4]=In,et=Wt,ut=$t}return Xe}build(W){return this._dataIsSortedAndDeltaEncoded?new Cn(new Uint32Array(this._data),W):new Cn(mt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=mt;class Cn{constructor(W,ue){this.resultId=ue,this.data=W}}e.SemanticTokens=Cn;class Mn{constructor(W,ue,Te){this.start=W,this.deleteCount=ue,this.data=Te}}e.SemanticTokensEdit=Mn;class Rn{constructor(W,ue){this.resultId=ue,this.edits=W}}e.SemanticTokensEdits=Rn;var Un;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=je([N],Xt),e.QuickInputButtons=Xt;var Bn;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class Ln{static validate(W){if(W.badge){let ue=(0,I.nextCharLength)(W.badge,0);if(ue<W.badge.length&&(ue+=(0,I.nextCharLength)(W.badge,ue)),W.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ue,Te){this.badge=W,this.tooltip=ue,this.color=Te}}e.FileDecoration=Ln;let Dn=class{constructor(W){this.kind=W}};Dn=je([N],Dn),e.ColorTheme=Dn;var Hn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(Hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");W<=ue?(this._start=W,this._end=ue):(this._start=ue,this._end=W)}with(W){let ue=this._start,Te=this._end;return W.start!==void 0&&(ue=W.start),W.end!==void 0&&(Te=W.end),ue===this._start&&Te===this._end?this:new Vt(ue,Te)}}e.NotebookRange=Vt;class an{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ue=>an.isNotebookCellData(ue))}static isNotebookCellData(W){return!0}constructor(W,ue,Te,Xe,et,ut,ht){this.kind=W,this.value=ue,this.languageId=Te,this.mime=Xe,this.outputs=et??[],this.metadata=ut,this.executionSummary=ht,an.validate(this)}}e.NotebookCellData=an;class $n{constructor(W){this.cells=W}}e.NotebookData=$n;class Bt{static isNotebookCellOutputItem(W){return W instanceof Bt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ue={name:W.name,message:W.message,stack:W.stack};return Bt.json(ue,"application/vnd.code.notebook.error")}static stdout(W){return Bt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Bt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ue="application/octet-stream"){return new Bt(W,ue)}static text(W,ue=y.Mimes.text){const Te=Be(Bt,b,"f",f).encode(String(W));return new Bt(Te,ue)}static json(W,ue="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Bt.text(Te,ue)}constructor(W,ue){this.data=W,this.mime=ue;const Te=(0,y.normalizeMimeType)(ue,!0);if(!Te)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Bt,b=Bt,f={value:new TextEncoder};class ve{static isNotebookCellOutput(W){return W instanceof ve?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ue=!1){const Te=new Set,Xe=new Set;for(let et=0;et<W.length;et++){const ut=W[et],ht=(0,y.normalizeMimeType)(ut.mime);if(!Te.has(ht)||(0,T.isTextStreamMime)(ht)){Te.add(ht);continue}Xe.add(et),ue&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Xe.size===0?W:W.filter((et,ut)=>!Xe.has(ut))}constructor(W,ue,Te){this.items=ve.ensureUniqueMimeTypes(W,!0),typeof ue=="string"?(this.id=ue,this.metadata=Te):(this.id=(0,A.generateUuid)(),this.metadata=ue??Te)}}e.NotebookCellOutput=ve;var Se;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Se=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ue=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ct;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ct=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Dt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Rt{constructor(W,ue){this.text=W,this.alignment=ue}}e.NotebookCellStatusBarItem=Rt;var ni;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(ni=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ii;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(ii=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,ue=[]){this.uri=W,this.provides=(0,l.asArray)(ue)}}e.NotebookRendererScript=ri;let xn=class{constructor(W,ue){this.label=W,this.timestamp=ue}};xn=je([N],xn),e.TimelineItem=xn;var si;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,ue){this.ranges=W,this.wordPattern=ue}}e.LinkedEditingRanges=ci;class li{constructor(W,ue){this._port=W,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vn=class{constructor(W=void 0,ue=void 0,Te=void 0){this.include=W,this.exclude=ue,this.profile=Te}};Vn=je([N],Vn),e.TestRunRequest=Vn;let jn=z=class{static diff(W,ue,Te){const Xe=new z(W);return Xe.expectedOutput=ue,Xe.actualOutput=Te,Xe}constructor(W){this.message=W}};jn=z=je([N],jn),e.TestMessage=jn;let qn=class{constructor(W){this.id=W}};qn=je([N],qn),e.TestTag=qn;let cn=class{constructor(W,ue){this.covered=W,this.total=ue}};cn=je([N],cn),e.CoveredCount=cn;let Gn=H=class{static fromDetails(W,ue){const Te=new cn(0,0),Xe=new cn(0,0),et=new cn(0,0);for(const ht of ue)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)Xe.total+=1,Xe.covered+=Lt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ut=new H(W,Te,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return ut.detailedCoverage=ue,ut}constructor(W,ue,Te,Xe){this.uri=W,this.statementCoverage=ue,this.branchCoverage=Te,this.functionCoverage=Xe}};Gn=H=je([N],Gn),e.FileCoverage=Gn;let Kn=class{constructor(W,ue,Te=[]){this.executionCount=W,this.location=ue,this.branches=Te}};Kn=je([N],Kn),e.StatementCoverage=Kn;let Xn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Xn=je([N],Xn),e.BranchCoverage=Xn;let Qn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Qn=je([N],Qn),e.FunctionCoverage=Qn;var hi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,ue){this.original=W,this.modified=ue}}e.TextDiffTabInput=vi;class bi{constructor(W,ue,Te,Xe){this.base=W,this.input1=ue,this.input2=Te,this.result=Xe}}e.TextMergeTabInput=bi;class wi{constructor(W,ue){this.uri=W,this.viewType=ue}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,ue){this.uri=W,this.notebookType=ue}}e.NotebookEditorTabInput=Si;class _i{constructor(W,ue,Te){this.original=W,this.modified=ue,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,ue){this.uri=W,this.inputBoxUri=ue}}e.InteractiveWindowInput=Ci}),define(De[132],Ie([1,0,48,14,8,159,102,7,17]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function A(S,g){g?D.set(S,g):D.delete(S)}e.setWordDefinitionFor=A;function k(S){return D.get(S)}e.getWordDefinitionFor=k;class w extends P.MirrorTextModel{constructor(g,v,m,b,f,c,p,i){super(v,m,b,f),this._proxy=g,this._languageId=c,this._isDirty=p,this.notebook=i,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,E.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},save(){return g._save()},getText(v){return v?g._getTextInRange(v):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(v){return g._lineAt(v)},offsetAt(v){return g._offsetAt(v)},positionAt(v){return g._positionAt(v)},validateRange(v){return g._validateRange(v)},validatePosition(v){return g._validatePosition(v)},getWordRangeAtPosition(v,m){return g._getWordRangeAtPosition(v,m)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,l.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,l.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const v=this._validateRange(g);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const m=this._eol,b=v.start.line,f=v.end.line,c=[];c.push(this._lines[b].substring(v.start.character));for(let p=b+1;p<f;p++)c.push(this._lines[p]);return c.push(this._lines[f].substring(0,v.end.character)),c.join(m)}_lineAt(g){let v;if(g instanceof I.Position?v=g.line:typeof g=="number"&&(v=g),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new T(v,this._lines[v],v===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(g),m=this._lines[v.index].length;return new I.Position(v.index,Math.min(v.remainder,m))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const v=this._validatePosition(g.start),m=this._validatePosition(g.end);return v===g.start&&m===g.end?g:new I.Range(v.line,v.character,m.line,m.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:v,character:m}=g,b=!1;if(v<0)v=0,m=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,m=this._lines[v].length,b=!0;else{const f=this._lines[v].length;m<0?(m=0,b=!0):m>f&&(m=f,b=!0)}return b?new I.Position(v,m):g}_getWordRangeAtPosition(g,v){const m=this._validatePosition(g);if(!v)v=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(v),this._lines[m.line],0);if(b)return new I.Range(m.line,b.startColumn-1,m.line,b.endColumn-1)}}e.ExtHostDocumentData=w;class T{constructor(g,v,m){this._line=g,this._text=v,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[228],Ie([1,0,7,16,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let E;switch(I){case"light":E=l.ColorThemeKind.Light;break;case"hcDark":E=l.ColorThemeKind.HighContrast;break;case"hcLight":E=l.ColorThemeKind.HighContrastLight;break;default:E=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[15],Ie([1,0,17,23,109,26,144,81,24,12,2,35,64,121,130,128,89,55,66,222,7,60]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Pe){function Oe(te){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:nt,positionColumn:Ge}=te,rt=new c.Position(Fe-1,xe-1),pt=new c.Position(nt-1,Ge-1);return new c.Selection(rt,pt)}Pe.to=Oe;function _e(te){const{anchor:Fe,active:xe}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Pe.from=_e})(i=e.Selection||(e.Selection={}));var d;(function(Pe){function Oe(te){if(!te)return;const{start:Fe,end:xe}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Pe.from=Oe;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:nt,endColumn:Ge}=te;return new c.Range(Fe-1,xe-1,nt-1,Ge-1)}Pe.to=_e})(d=e.Range||(e.Range={}));var a;(function(Pe){function Oe(_e){switch(_e){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Pe.to=Oe})(a=e.TokenType||(e.TokenType={}));var r;(function(Pe){function Oe(te){return new c.Position(te.lineNumber-1,te.column-1)}Pe.to=Oe;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Pe.from=_e})(r=e.Position||(e.Position={}));var o;(function(Pe){function Oe(Fe,xe){return(0,l.coalesce)((0,l.asArray)(Fe).map(nt=>_e(nt,xe)))}Pe.from=Oe;function _e(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,xe),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(o=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(Pe){function Oe(te){switch(te){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Pe){function Oe(te){let Fe;return te.code&&((0,D.isString)(te.code)||(0,D.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...d.from(te.range),message:te.message,source:te.source,code:Fe,severity:h.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(s.from),tags:Array.isArray(te.tags)?(0,l.coalesce)(te.tags.map(u.from)):void 0}}Pe.from=Oe;function _e(te){const Fe=new c.Diagnostic(d.to(te),te.message,h.to(te.severity));return Fe.source=te.source,Fe.code=(0,D.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(s.to),Fe.tags=te.tags&&(0,l.coalesce)(te.tags.map(u.to)),Fe}Pe.to=_e})(n=e.Diagnostic||(e.Diagnostic={}));var s;(function(Pe){function Oe(te){return{...d.from(te.location.range),message:te.message,resource:te.location.uri}}Pe.from=Oe;function _e(te){return new c.DiagnosticRelatedInformation(new c.Location(te.resource,d.to(te)),te.message)}Pe.to=_e})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Pe){function Oe(te){switch(te){case c.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Pe.from=Oe;function _e(te){switch(te){case T.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Pe.to=_e})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var _;(function(Pe){function Oe(te){return typeof te=="number"&&te>=c.ViewColumn.One?te-1:te===c.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Pe.from=Oe;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(_=e.ViewColumn||(e.ViewColumn={}));function L(Pe){return typeof Pe.range<"u"}function M(Pe){return Pe.length===0?!0:!!L(Pe[0])}e.isDecorationOptionsArr=M;var U;(function(Pe){function Oe(Ge){return Ge.map(Pe.from)}Pe.fromMany=Oe;function _e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let rt;if(_e(Ge)){const{language:It,value:_t}=Ge;rt={value:"```"+It+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const St=It=>{try{let _t=A.URI.parse(It,!0);_t=_t.with({query:Fe(_t.query,pt)}),pt[It]=_t}catch{}return""},Tt=new y.marked.Renderer;return Tt.link=St,Tt.image=It=>typeof It=="string"?St(C.parseHrefAndDimensions(It).href):"",(0,y.marked)(rt.value,{renderer:Tt}),rt}Pe.from=te;function Fe(Ge,rt){if(!Ge)return Ge;let pt;try{pt=(0,I.parse)(Ge)}catch{}if(!pt)return Ge;let St=!1;return pt=(0,E.cloneAndChange)(pt,Tt=>{if(A.URI.isUri(Tt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[It]=Tt,St=!0,It}else return}),St?JSON.stringify(pt):Ge}function xe(Ge){const rt=new c.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?A.URI.from(Ge.baseUri):void 0,rt}Pe.to=xe;function nt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Pe.from(Ge)}Pe.fromStrict=nt})(U=e.MarkdownString||(e.MarkdownString={}));function R(Pe){return M(Pe)?Pe.map(Oe=>({range:d.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?U.fromMany(Oe.hoverMessage):Oe.hoverMessage?U.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Pe.map(Oe=>({range:d.from(Oe)}))}e.fromRangeOrRangeWithMessage=R;function z(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?A.URI.file(Pe):Pe}e.pathOrURIToURI=z;var H;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Oe})(H=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Oe})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Pe){function Oe(_e){if(typeof _e>"u")return _e;switch(_e){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Oe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Pe){function Oe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?V.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Oe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(Pe){function Oe(te){return{text:te.newText,eol:te.newEol&&Ye.from(te.newEol),range:d.from(te.range)}}Pe.from=Oe;function _e(te){const Fe=new c.TextEdit(d.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Ye.to(te.eol),Fe}Pe.to=_e})(F=e.TextEdit||(e.TextEdit={}));var x;(function(Pe){function Oe(te,Fe){const xe={edits:[]};if(te instanceof c.WorkspaceEdit){const nt=new P.ResourceSet;for(const Ge of te._allEntries())Ge._type===1&&A.URI.isUri(Ge.to)&&Ge.from===void 0&&nt.add(Ge.to);for(const Ge of te._allEntries())Ge._type===1?xe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?xe.edits.push({resource:Ge.uri,textEdit:F.from(Ge.edit),versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?xe.edits.push({resource:Ge.uri,textEdit:{range:d.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Je.from)}})}return xe}Pe.from=Oe;function _e(te){const Fe=new c.WorkspaceEdit;for(const xe of te.edits)xe.textEdit?Fe.replace(A.URI.revive(xe.resource),d.to(xe.textEdit.range),xe.textEdit.text):Fe.renameFile(A.URI.revive(xe.oldResource),A.URI.revive(xe.newResource),xe.options);return Fe}Pe.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(Pe){const Oe=Object.create(null);Oe[c.SymbolKind.File]=0,Oe[c.SymbolKind.Module]=1,Oe[c.SymbolKind.Namespace]=2,Oe[c.SymbolKind.Package]=3,Oe[c.SymbolKind.Class]=4,Oe[c.SymbolKind.Method]=5,Oe[c.SymbolKind.Property]=6,Oe[c.SymbolKind.Field]=7,Oe[c.SymbolKind.Constructor]=8,Oe[c.SymbolKind.Enum]=9,Oe[c.SymbolKind.Interface]=10,Oe[c.SymbolKind.Function]=11,Oe[c.SymbolKind.Variable]=12,Oe[c.SymbolKind.Constant]=13,Oe[c.SymbolKind.String]=14,Oe[c.SymbolKind.Number]=15,Oe[c.SymbolKind.Boolean]=16,Oe[c.SymbolKind.Array]=17,Oe[c.SymbolKind.Object]=18,Oe[c.SymbolKind.Key]=19,Oe[c.SymbolKind.Null]=20,Oe[c.SymbolKind.EnumMember]=21,Oe[c.SymbolKind.Struct]=22,Oe[c.SymbolKind.Event]=23,Oe[c.SymbolKind.Operator]=24,Oe[c.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Pe.from=_e;function te(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return c.SymbolKind.Property}Pe.to=te})($=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Pe){function Oe(te){switch(te){case c.SymbolTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.SymbolTag.Deprecated}}Pe.to=_e})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Pe){function Oe(te){return{name:te.name,kind:$.from(te.kind),tags:te.tags&&te.tags.map(Q.from),containerName:te.containerName,location:me.from(te.location)}}Pe.from=Oe;function _e(te){const Fe=new c.SymbolInformation(te.name,$.to(te.kind),te.containerName,me.to(te.location));return Fe.tags=te.tags&&te.tags.map(Q.to),Fe}Pe.to=_e})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Pe){function Oe(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:d.from(te.range),selectionRange:d.from(te.selectionRange),kind:$.from(te.kind),tags:te.tags?.map(Q.from)??[]};return te.children&&(Fe.children=te.children.map(Oe)),Fe}Pe.from=Oe;function _e(te){const Fe=new c.DocumentSymbol(te.name,te.detail,$.to(te.kind),d.to(te.range),d.to(te.selectionRange));return(0,l.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(Q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Pe.to=_e})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Pe){function Oe(te){const Fe=new c.CallHierarchyItem($.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:te.name,detail:te.detail,kind:$.from(te.kind),uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Pe){function Oe(_e){return new c.CallHierarchyIncomingCall(ee.to(_e.from),_e.fromRanges.map(te=>d.to(te)))}Pe.to=Oe})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Pe){function Oe(_e){return new c.CallHierarchyOutgoingCall(ee.to(_e.to),_e.fromRanges.map(te=>d.to(te)))}Pe.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(Pe){function Oe(te){return{range:te.range&&d.from(te.range),uri:te.uri}}Pe.from=Oe;function _e(te){return new c.Location(A.URI.revive(te.uri),d.to(te.range))}Pe.to=_e})(me=e.location||(e.location={}));var be;(function(Pe){function Oe(te){const Fe=te,xe=te;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:d.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Pe.from=Oe;function _e(te){return{targetUri:A.URI.revive(te.uri),targetRange:d.to(te.range),targetSelectionRange:te.targetSelectionRange?d.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?d.to(te.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Oe(te){return{range:d.from(te.range),contents:U.fromMany(te.contents)}}Pe.from=Oe;function _e(te){return new c.Hover(te.contents.map(U.to),d.to(te.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Pe){function Oe(te){return{range:d.from(te.range),expression:te.expression}}Pe.from=Oe;function _e(te){return new c.EvaluatableExpression(d.to(te.range),te.expression)}Pe.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Pe){function Oe(te){if(te instanceof c.InlineValueText)return{type:"text",range:d.from(te.range),text:te.text};if(te instanceof c.InlineValueVariableLookup)return{type:"variable",range:d.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Oe;function _e(te){switch(te.type){case"text":return{range:d.to(te.range),text:te.text};case"variable":return{range:d.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:d.to(te.range),expression:te.expression}}}Pe.to=_e})(ze=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Oe(te){return{frameId:te.frameId,stoppedLocation:d.from(te.stoppedLocation)}}Pe.from=Oe;function _e(te){return new c.InlineValueContext(te.frameId,d.to(te.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Pe){function Oe(te){return{range:d.from(te.range),kind:te.kind}}Pe.from=Oe;function _e(te){return new c.DocumentHighlight(d.to(te.range),te.kind)}Pe.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Pe.to=Oe})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Oe(_e){return{triggerKind:ge.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Oe(te){switch(te){case c.CompletionItemTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Pe){const Oe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function _e(xe){return Oe.get(xe)??9}Pe.from=_e;const te=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(xe){return te.get(xe)??c.CompletionItemKind.Property}Pe.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Oe(_e,te){const Fe=new c.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ne.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=C.isMarkdownString(_e.documentation)?U.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=d.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:d.to(_e.range.insert),replacing:d.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new c.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(xe=>F.to(xe))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Pe.to=Oe})(ie=e.CompletionItem||(e.CompletionItem={}));var O;(function(Pe){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:U.fromStrict(te.documentation)}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation}}Pe.to=_e})(O=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(Pe){function Oe(te){return{label:te.label,documentation:U.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(O.from):[],activeParameter:te.activeParameter}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(O.to):[],activeParameter:te.activeParameter}}Pe.to=_e})(j=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.from):[]}}Pe.from=Oe;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.to):[]}}Pe.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHint(r.to(te.position),typeof te.label=="string"?te.label:te.label.map(pe.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(F.to),Fe.tooltip=C.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Pe.to=Oe})(X=e.InlayHint||(e.InlayHint={}));var pe;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHintLabelPart(te.label);return Fe.tooltip=C.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,w.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=me.to(te.location)),Fe}Pe.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Oe(te){return te}Pe.from=Oe;function _e(te){return te}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Pe){function Oe(te){return{range:d.from(te.range),url:te.target,tooltip:te.tooltip}}Pe.from=Oe;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?A.URI.parse(te.url,!0):A.URI.revive(te.url)}catch{}return new c.DocumentLink(d.to(te.range),Fe)}Pe.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Pe){function Oe(te){const Fe=new c.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=F.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(xe=>F.to(xe))),Fe}Pe.to=Oe;function _e(te){return{label:te.label,textEdit:te.textEdit?F.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>F.from(Fe)):void 0}}Pe.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Oe(te){return new c.Color(te[0],te[1],te[2],te[3])}Pe.to=Oe;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var We;(function(Pe){function Oe(te){return{range:d.from(te.range)}}Pe.from=Oe;function _e(te){return new c.SelectionRange(d.to(te.range))}Pe.to=_e})(We=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Pe){function Oe(_e){switch(_e){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Pe.to=Oe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Oe(te){switch(te){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Oe;function _e(te){switch(te){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Oe(te){if(te===c.EndOfLine.CRLF)return 1;if(te===c.EndOfLine.LF)return 0}Pe.from=Oe;function _e(te){if(te===1)return c.EndOfLine.CRLF;if(te===0)return c.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(Pe){function Oe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Oe})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var at;(function(Pe){function Oe(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Pe.from=Oe})(at=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Oe(_e){if(_e)switch(_e){case c.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}Pe.from=Oe})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Oe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?d.from(_e.selection):void 0,override:typeof _e.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Oe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Oe(xe){return xe instanceof c.RelativePattern?xe.toJSON():typeof xe=="string"?xe:_e(xe)||te(xe)?new c.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Pe.from=Oe;function _e(xe){const nt=xe;return nt?A.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function te(xe){const nt=xe;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new c.RelativePattern(A.URI.revive(xe.baseUri),xe.pattern)}Pe.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var Ve;(function(Pe){function Oe(_e){if(_e){if(Array.isArray(_e))return _e.map(Oe);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Pe.from=Oe})(Ve=e.LanguageSelector||(e.LanguageSelector={}));var fe;(function(Pe){function Oe(te){return{start:te.start,end:te.end}}Pe.from=Oe;function _e(te){return new c.NotebookRange(te.start,te.end)}Pe.to=_e})(fe=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Pe){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Pe.to=Oe;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Pe.from=_e})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Pe){function Oe(_e){if(_e===v.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(_e===v.NotebookCellExecutionState.Pending)return;if(_e===v.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(Pe){function Oe(te){switch(te){case c.NotebookCellKind.Markup:return v.CellKind.Markup;case c.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Oe;function _e(te){switch(te){case v.CellKind.Markup:return c.NotebookCellKind.Markup;case v.CellKind.Code:default:return c.NotebookCellKind.Code}}Pe.to=_e})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(Pe){function Oe(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const xe of te.cells)c.NotebookCellData.validate(xe),Fe.cells.push(Je.from(xe));return Fe}Pe.from=Oe;function _e(te){const Fe=new c.NotebookData(te.cells.map(Je.to));return(0,D.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Pe.to=_e})(Ke=e.NotebookData||(e.NotebookData={}));var Je;(function(Pe){function Oe(te){return{cellKind:Me.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ae.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(ot.from):[]}}Pe.from=Oe;function _e(te){return new c.NotebookCellData(Me.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(ot.to):void 0,te.metadata,te.internalMetadata?Ae.to(te.internalMetadata):void 0)}Pe.to=_e})(Je=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Pe.from=Oe;function _e(te){return new c.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Pe.to=_e})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(Pe){function Oe(te){return{outputId:te.id,items:te.items.map(st.from),metadata:te.metadata}}Pe.from=Oe;function _e(te){const Fe=te.items.map(st.to);return new c.NotebookCellOutput(Fe,te.outputId,te.metadata)}Pe.to=_e})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Pe){function Oe(Fe){return te(Fe)?{include:(0,D.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,D.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,D.withNullAsUndefined)(Ee.from(Fe))}Pe.from=Oe;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Pe.to=_e;function te(Fe){const xe=Fe;return xe?!(0,D.isUndefinedOrNull)(xe.include)&&!(0,D.isUndefinedOrNull)(xe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Pe){function Oe(_e,te,Fe){const xe=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(xe,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var vt;(function(Pe){function Oe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Oe})(vt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var wt;(function(Pe){function Oe(te){return{uri:te.uri,provides:te.provides}}Pe.from=Oe;function _e(te){return new c.NotebookRendererScript(A.URI.revive(te.uri),te.provides)}Pe.to=_e})(wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Oe(te){return{message:U.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:d.from(te.location.range),uri:te.location.uri}}}Pe.from=Oe;function _e(te){const Fe=new c.TestMessage(typeof te.message=="string"?te.message:U.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?me.to(te.location):void 0,Fe}Pe.to=_e})(ft=e.TestMessage||(e.TestMessage={}));var Et;(function(Pe){Pe.namespace=b.namespaceTestTag,Pe.denamespace=b.denamespaceTestTag})(Et=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){function Oe(te){const Fe=(0,S.getPrivateApiFor)(te).controllerId;return{extId:m.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:A.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(xe=>Et.namespace(Fe,xe.id)),range:k.Range.lift(d.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&U.fromStrict(te.error)||null}}Pe.from=Oe;function _e(te){return{parent:void 0,error:void 0,id:m.TestId.fromString(te.extId).localId,label:te.label,uri:A.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:xe}=Et.denamespace(Fe);return new c.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Pe.toPlain=_e})(Ft=e.TestItem||(e.TestItem={})),function(Pe){function Oe(te){return{id:te.id}}Pe.from=Oe;function _e(te){return new c.TestTag(te.id)}Pe.to=_e}(Et=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){const Oe=(te,Fe)=>{const xe=[];for(const[Ge,rt]of Fe)m.TestId.compare(rt.item.extId,Ge)===2&&(Fe.delete(Ge),xe.push(rt));const nt={...Ft.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(ft.to)})),children:xe.map(Ge=>Oe(Ge,Fe))};for(const Ge of nt.children)Ge.parent=nt;return nt};function _e(te){const Fe=[],xe=new Map;for(const nt of te.items){xe.set(nt.item.extId,nt);const Ge=m.TestId.root(nt.item.extId);te.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(nt.item.extId))&&Fe.push(nt)}return{completedAt:te.completedAt,results:Fe.map(nt=>Oe(nt,xe))}}Pe.to=_e})(Mt=e.TestResults||(e.TestResults={}));var Qe;(function(Pe){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function _e(xe){return"line"in xe?r.from(xe):d.from(xe)}function te(xe){return"branches"in xe?{count:xe.executionCount,location:_e(xe.location),type:1,branches:xe.branches.length?xe.branches.map(nt=>({count:nt.executionCount,location:nt.location&&_e(nt.location)})):void 0}:{type:0,count:xe.executionCount,location:_e(xe.location)}}Pe.fromDetailed=te;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(te)}}Pe.fromFile=Fe})(Qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Pe.to=Oe})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Pe){function Oe(te){const Fe=new c.TypeHierarchyItem($.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:$.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(Pe){function Oe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Oe})(Pt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Pe){function Oe(_e,te){const Fe=_e.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:A.URI.revive(Fe.uri),data:(0,p.once)(()=>te())}}}("",_e.id):new c.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Oe})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(Pe){function Oe(te,Fe){const xe=te.items.map(([nt,Ge])=>[nt,gt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new c.DataTransfer(xe)}Pe.toDataTransfer=Oe;async function _e(te){const Fe={items:[]},xe=[];return te.forEach((nt,Ge)=>{xe.push((async()=>{const rt=await nt.asString(),pt=nt.asFile();Fe.items.push([Ge,{id:nt.id,asString:rt,fileData:pt?{name:pt.name,uri:pt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Pe.toDataTransferDTO=_e})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(De[229],Ie([1,0,2,11,7,15,62]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(D,A,k,w={timeout:1500,errors:3}){this._logService=D,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=w,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,w)=>{const S={dispose:this._callbacks.push([A,k,D])};return Array.isArray(w)&&w.push(S),S}}async $participateInSave(D,A){const k=l.URI.revive(D);let w=!1;const T=setTimeout(()=>w=!0,this._thresholds.timeout),S=[];try{for(const g of[...this._callbacks]){if(w)break;const v=this._documents.getDocument(k),m=await this._deliverEventAsyncAndBlameBadListeners(g,{document:v,reason:P.TextDocumentSaveReason.to(A)});S.push(m)}}finally{clearTimeout(T)}return S}_deliverEventAsyncAndBlameBadListeners([D,A,k],w){const T=this._badListeners.get(D);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,D,A,w).then(()=>!0,S=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const g=this._badListeners.get(D);this._badListeners.set(D,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,A,k,w){const T=[],S=Date.now(),{document:g,reason:v}=w,{version:m}=g,b=Object.freeze({document:g,reason:v,waitUntil(f){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(f))}});try{A.apply(k,[b])}catch(f){return Promise.reject(f)}return Object.freeze(T),new Promise((f,c)=>{const p=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(p),f(i)}).catch(i=>{clearTimeout(p),c(i)})}).then(f=>{const c={edits:[]};for(const p of f)if(Array.isArray(p)&&p.every(i=>i instanceof C.TextEdit))for(const{newText:i,newEol:d,range:a}of p)c.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&P.Range.from(a),text:i,eol:d&&P.EndOfLine.from(d)}});if(c.edits.length!==0)return m===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(De[230],Ie([1,0,14,2,15,7,89]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(k,w,T,S){this.start=k,this.deletedCount=w,this.deletedItems=T,this.items=S}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(k,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,w,T){this.notebook=k,this._extHostDocument=w,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,w=this._extHostDocument.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:w.document,get mime(){return k._mime},set mime(S){k._mime=S},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(C.NotebookCellOutput.to)}setOutputItems(k,w,T){const S=T.map(C.NotebookCellOutputItem.to),g=this._outputs.find(v=>v.id===k);if(g&&(w||(g.items.length=0),g.items.push(...S),g.items.length>1&&g.items.every(v=>y.isTextStreamMime(v.mime)))){const v=new Map,m=[];g.items.forEach(b=>{let f;v.has(b.mime)?f=v.get(b.mime):(f=[],v.set(b.mime,f),m.push(b.mime)),f.push(b.data)}),g.items.length=0,m.forEach(b=>{const f=y.compressOutputItemStreams(v.get(b));g.items.push({mime:b,data:f.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=E;class D{constructor(k,w,T,S,g){this._proxy=k,this._textDocumentsAndEditors=w,this._textDocuments=T,this.uri=S,this.handle=D._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=g.viewType,this._metadata=Object.freeze(g.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,g.cells]],!0,void 0),this._versionId=g.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,w={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===l.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(g=>g.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(w)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,w,T){this._versionId=k.versionId,this._isDirty=w,this.acceptDocumentPropertiesChanged({metadata:T});const S={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},g=[];for(const m of k.rawEvents)m.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1,S.contentChanges):m.kind===y.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx,S.contentChanges):m.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(m.index,m.outputs),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(m.index,m.language),g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document})):m.kind===y.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document}):m.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(m.index,m.metadata),g.push({cell:this._cells[m.index].apiCell,metadata:this._cells[m.index].apiCell.metadata})):m.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(m.index,m.internalMetadata),g.push({cell:this._cells[m.index].apiCell,executionSummary:this._cells[m.index].apiCell.executionSummary}));const v=new Map;for(let m=0;m<g.length;m++){const b=g[m],f=v.get(b.cell);if(f===void 0){const c=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});v.set(b.cell,c-1)}else S.cellChanges[f]={...S.cellChanges[f],...b}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let w=k.start|0,T=k.end|0;return w<0&&(w=0),T>this._cells.length&&(T=this._cells.length),k.with({start:w,end:T})}_getCells(k){k=this._validateRange(k);const w=[];for(let T=k.start;T<k.end;T++)w.push(this._cells[T]);return w}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,w,T){if(this._disposed)return;const S=[],g=[],v=[];if(k.reverse().forEach(m=>{const f=m[2].map(i=>{const d=new E(this,this._textDocumentsAndEditors,i);return w||g.push(E.asModelAddData(this.apiNotebook,i)),d}),c=new I(m[0],m[1],[],f),p=this._cells.splice(m[0],m[1],...f);for(const i of p)v.push(i.uri),c.deletedItems.push(i.apiCell);S.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:v}),T)for(const m of S)T.push(m.asApiEvent())}_moveCell(k,w,T){const S=this._cells.splice(k,1);this._cells.splice(w,0,...S);const g=[new I(k,1,S.map(v=>v.apiCell),[]),new I(w,0,[],S)];for(const v of g)T.push(v.asApiEvent())}_setCellOutputs(k,w){this._cells[k].setOutputs(w)}_setCellOutputItems(k,w,T,S){this._cells[k].setOutputItems(w,T,S)}_changeCellLanguage(k,w){const T=this._cells[k];T.apiCell.document.languageId!==w&&this._textDocuments.$acceptModelLanguageChanged(T.uri,w)}_changeCellMime(k,w){const T=this._cells[k];T.apiCell.mime=w}_changeCellMetadata(k,w){this._cells[k].setMetadata(w)}_changeCellInternalMetadata(k,w){this._cells[k].setInternalMetadata(w)}getCellFromApiCell(k){return this._cells.find(w=>w.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(w=>w.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=D,D._handlePool=0}),define(De[133],Ie([1,0,11,15,7]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(I,E,D,A,k,w){this.id=I,this._proxy=E,this.notebookData=D,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=A,this._viewColumn=w}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get notebook(){return I.notebookData.apiNotebook},get selection(){return I._selections[0]},set selection(E){this.selections=[E]},get selections(){return I._selections},set selections(E){if(!Array.isArray(E)||!E.every(C.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");I._selections=E,I._trySetSelections(E)},get visibleRanges(){return I._visibleRanges},revealRange(E,D){I._proxy.$tryRevealRange(I.id,t.NotebookRange.from(E),D??C.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_trySetSelections(I){this._proxy.$trySetSelections(this.id,I.map(t.NotebookRange.from))}_acceptViewColumn(I){this._viewColumn=I}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[231],Ie([1,0,3,13,15]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(I,E){this._logService=I,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(I,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,E);const D=this._notebooksAndEditors.getEditorById(I);E.visibleRanges&&D._acceptVisibleRanges(E.visibleRanges.ranges.map(C.NotebookRange.to)),E.selections&&D._acceptSelections(E.selections.selections.map(C.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const E in I)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(C.ViewColumn.to(I[E]))}};P=je([$e(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[232],Ie([1,0,15,123,172,21,59,11]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(w){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=w}async withProgress(w,T,S){const g=this._handles++,{title:v,location:m,cancellable:b}=T,f={label:(0,C.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this._proxy.$startProgress(g,{location:l.ProgressLocation.from(m),title:v,source:f,cancellable:b},w.isUnderDevelopment?void 0:w.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(g,S,!!b)}_withProgress(w,T,S){let g;S&&(g=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(w,g));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),g?.dispose()};let m;try{m=T(new A(this._proxy,w),S&&g?g.token:P.CancellationToken.None)}catch(b){throw v(w),b}return m.then(b=>v(w),b=>v(w)),m}$acceptProgressCanceled(w){const T=this._mapHandleToCancellationSource.get(w);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(w))}}e.ExtHostProgress=E;function D(k,w){return k.message=w.message,typeof w.increment=="number"&&(typeof k.increment=="number"?k.increment+=w.increment:k.increment=w.increment),k}class A extends t.Progress{constructor(w,T){super(S=>this.throttledReport(S)),this._proxy=w,this._handle=T}throttledReport(w){this._proxy.$progressReport(this._handle,w)}}je([(0,y.throttle)(100,(k,w)=>D(k,w),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(De[134],Ie([1,0,35,130,55,90,66,15,2]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(f,c,p,i)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(a){if(!p(d,a)){const r=d;d=a,f.listener?.(i(a,r))}}}},A=(f,c)=>f===c,k={range:(f,c)=>f===c?!0:!f||!c?!1:f.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(f,c)=>!(f.length!==c.length||f.some(p=>!c.find(i=>p.id===i.id)))},w=f=>c=>({op:4,update:f(c)}),T=(f,c)=>({range:(()=>{let p;const i=w(d=>({range:l.Range.lift(I.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return p},set(d){f.listener?.({op:6}),k.range(p,d)||(p=d,f.listener?.(i(d)))}}})(),label:D(f,c,k.label,w(p=>({label:p}))),description:D(f,void 0,k.description,w(p=>({description:p}))),sortText:D(f,void 0,k.sortText,w(p=>({sortText:p}))),canResolveChildren:D(f,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:D(f,!1,k.busy,w(p=>({busy:p}))),error:D(f,void 0,k.error,w(p=>({error:I.MarkdownString.fromStrict(p)||null}))),tags:D(f,[],k.tags,(p,i)=>({op:1,new:p.map(I.TestTag.from),old:i.map(I.TestTag.from)}))}),S=f=>{const c=C.TestId.fromString(f.extId),p=new v(c.controllerId,c.localId,f.label,E.URI.revive(f.uri)||void 0);return p.range=I.Range.to(f.range||void 0),p.description=f.description||void 0,p.sortText=f.sortText||void 0,p.tags=f.tags.map(i=>I.TestTag.to({id:(0,y.denamespaceTestTag)(i).tagId})),p},g=f=>{let c;for(const p of f.tests){const i=S(p.item);(0,t.getPrivateApiFor)(i).parent=c,c=i}return c};e.toItemFromContext=g;class v{constructor(c,p,i,d){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const a=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof m?void 0:a.parent}},children:{value:(0,P.createTestItemChildren)(a,t.getPrivateApiFor,v),enumerable:!0,writable:!1},...T(a,i)})}}e.TestItemImpl=v;class m extends v{constructor(c,p){super(c,c,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class b extends P.TestItemCollection{constructor(c,p,i){super({controllerId:c,getDocumentVersion:d=>d&&i.getDocument(d)?.version,getApiFor:t.getPrivateApiFor,getChildren:d=>d.children,root:new m(c,p),toITestItem:I.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(De[135],Ie([1,0,48,11,97,15,7]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(w,T,S){const g=I._Keys.nextId();w.$registerTextEditorDecorationType(T.identifier,g,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:g,dispose(){w.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class E{constructor(w,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,T){this._throwIfFinalized();let S=null;if(w instanceof y.Position)S=new y.Range(w,w);else if(w instanceof y.Range)S=w;else throw new Error("Unrecognized location");this._pushEdit(S,T,!1)}insert(w,T){this._throwIfFinalized(),this._pushEdit(new y.Range(w,w),T,!0)}delete(w){this._throwIfFinalized();let T=null;if(w instanceof y.Range)T=w;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(w,T,S){const g=this._document.validateRange(w);this._collectedEdits.push({range:g,text:T,forceMoveMarkers:S})}setEndOfLine(w){if(this._throwIfFinalized(),w!==y.EndOfLine.LF&&w!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=w}}e.TextEditorEdit=E;class D{constructor(w,T,S,g){this._proxy=w,this._id=T,this._accept(S),this._logService=g;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(m){v._setTabSize(m)},get insertSpaces(){return v._insertSpaces},set insertSpaces(m){v._setInsertSpaces(m)},get cursorStyle(){return v._cursorStyle},set cursorStyle(m){v._setCursorStyle(m)},get lineNumbers(){return v._lineNumbers},set lineNumbers(m){v._setLineNumbers(m)}}}_accept(w){this._tabSize=w.tabSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const T=Math.floor(w);return T>0?T:null}if(typeof w=="string"){const T=parseInt(w,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(w){const T=this._validateTabSize(w);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}_setInsertSpaces(w){const T=this._validateInsertSpaces(w);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(w)})))}assign(w){const T={};let S=!1;if(typeof w.tabSize<"u"){const g=this._validateTabSize(w.tabSize);g==="auto"?(S=!0,T.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,S=!0,T.tabSize=g)}if(typeof w.insertSpaces<"u"){const g=this._validateInsertSpaces(w.insertSpaces);g==="auto"?(S=!0,T.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,S=!0,T.insertSpaces=g)}typeof w.cursorStyle<"u"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,S=!0,T.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,S=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(w.lineNumbers)),S&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(w,T){T.catch(S=>{this._logService.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this._logService.warn(S)})}}e.ExtHostTextEditorOptions=D;class A{constructor(w,T,S,g,v,m,b,f){this.id=w,this._proxy=T,this._logService=S,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new D(this._proxy,this.id,m,S),this._visibleRanges=b,this._viewColumn=f;const c=this;this.value=Object.freeze({get document(){return g.getValue()},set document(p){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(p){if(!(p instanceof y.Selection))throw(0,t.illegalArgument)("selection");c._selections=[p],c._trySetSelection()},get selections(){return c._selections},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof y.Selection)))throw(0,t.illegalArgument)("selections");c._selections=p,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(p){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(p){c._disposed||c._options.assign(p)},get viewColumn(){return c._viewColumn},set viewColumn(p){throw(0,t.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new E(g.getValue(),i);return p(d),c._applyEdit(d)},insertSnippet(p,i,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c._selections.map(r=>P.Range.from(r));else if(i instanceof y.Position){const{lineNumber:r,column:o}=P.Position.from(i);a=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(i instanceof y.Range)a=[P.Range.from(i)];else{a=[];for(const r of i)if(r instanceof y.Range)a.push(P.Range.from(r));else{const{lineNumber:o,column:u}=P.Position.from(r);a.push({startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u})}}return T.$tryInsertSnippet(w,g.getValue().version,p.value,a,d)},setDecorations(p,i){const d=i.length===0;d&&!c._hasDecorationsForKey.has(p.key)||(d?c._hasDecorationsForKey.delete(p.key):c._hasDecorationsForKey.add(p.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(i))return T.$trySetDecorations(w,p.key,P.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,o=i.length;r<o;r++){const u=i[r];a[4*r]=u.start.line+1,a[4*r+1]=u.start.character+1,a[4*r+2]=u.end.line+1,a[4*r+3]=u.end.character+1}return T.$trySetDecorationsFast(w,p.key,a)}}))},revealRange(p,i){c._runOnProxy(()=>T.$tryRevealRange(w,P.Range.from(p),i||y.TextEditorRevealType.Default))},show(p){T.$tryShowEditor(w,P.ViewColumn.from(p))},hide(){T.$tryHideEditor(w)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,l.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,l.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,l.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,l.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const T=w.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const S=T.edits.map(v=>v.range);S.sort((v,m)=>v.end.line===m.end.line?v.end.character===m.end.character?v.start.line===m.start.line?v.start.character-m.start.character:v.start.line-m.start.line:v.end.character-m.end.character:v.end.line-m.end.line);for(let v=0,m=S.length-1;v<m;v++){const b=S[v].end;if(S[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=T.edits.map(v=>({range:P.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,g,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=A}),define(De[233],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[234],Ie([1,0,186,11,42,120,124,43,27,233,197]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=I.Registry.as(y.Extensions.JSONContribution);class w{constructor(c,p,i){this._messageHandler=c,this._extension=p,this._extensionPointId=i}_msg(c,p){this._messageHandler({type:c,message:p,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(C.default.Error,c)}warn(c){this._msg(C.default.Warning,c)}info(c){this._msg(C.default.Info,c)}}e.ExtensionMessageCollector=w;class T{static _toSet(c){const p=new Set;for(let i=0,d=c.length;i<d;i++)p.add(E.ExtensionIdentifier.toKey(c[i].description.identifier));return p}static compute(c,p){if(!c||!c.length)return new T(p,[]);if(!p||!p.length)return new T([],c);const i=this._toSet(c),d=this._toSet(p),a=p.filter(o=>!i.has(E.ExtensionIdentifier.toKey(o.description.identifier))),r=c.filter(o=>!d.has(E.ExtensionIdentifier.toKey(o.description.identifier)));return new T(a,r)}constructor(c,p){this.added=c,this.removed=p}}e.ExtensionPointUserDelta=T;class S{constructor(c,p){this.name=c,this.defaultExtensionKind=p,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=S;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},v="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)},l10n:{type:"string",description:l.localize(74,null)}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const p=new S(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,p),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,k.registerSchema(v,e.schema),p}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const b={ExtensionsRegistry:"ExtensionsRegistry"};I.Registry.add(b.ExtensionsRegistry,new m),e.ExtensionsRegistry=I.Registry.as(b.ExtensionsRegistry),k.registerSchema(v,e.schema),k.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(De[235],Ie([1,0,183,12,24,234,52,3]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var D;(function(w){function T(S,g,v){if(!S)return;const m=t.isString(S.type)?S.type:void 0;if(!m||m.length===0){v.error(l.localize(3,null));return}const b=[];if(Array.isArray(S.required))for(const f of S.required)t.isString(f)&&b.push(f);return{extensionId:g.value,taskType:m,required:b,properties:S.properties?C.deepClone(S.properties):{},when:S.when?y.ContextKeyExpr.deserialize(S.when):void 0}}w.from=T})(D||(D={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:E}});class k{constructor(){this._onDefinitionsChanged=new I.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,S)=>{A.setHandler((g,v)=>{this._schema=void 0;try{for(const m of v.removed){const b=m.value;for(const f of b)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const m of v.added){const b=m.value;for(const f of b){const c=D.from(f,m.description.identifier,m.collector);c&&(this.taskTypes[c.taskType]=c)}}(v.removed.length>0||v.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const S of this.all()){const g={type:"object",additionalProperties:!1};S.required.length>0&&(g.required=S.required.slice(0)),S.properties!==void 0?g.properties=C.deepClone(S.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[S.taskType]},T.push(g)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[236],Ie([1,0,184,12,22,24,52,235]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var E;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function V(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(E=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(N){function V(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(A=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function V(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var w;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(w=e.PanelKind||(e.PanelKind={})),function(N){function V(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(w=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S=e.RuntimeType||(e.RuntimeType={})),function(N){function V(F){switch(F.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function B(F){switch(F){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(S=e.RuntimeType||(e.RuntimeType={}));var g;(function(N){function V(B){return t.isString(B)?B:B.value}N.value=V})(g=e.CommandString||(e.CommandString={}));var v;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(F){return F===N.Clean._id||F===N.Build._id||F===N.Rebuild._id||F===N.Test._id}N.is=V;function B(F){if(F!==void 0)return t.isString(F)?V(F)?{_id:F,isDefault:!1}:void 0:F}N.from=B})(v=e.TaskGroup||(e.TaskGroup={}));var m;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var b;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=V})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(N){N.parallel="parallel",N.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor(V,B,F,x,$,Q){this._label="",this._id=V,B&&(this._label=B),F&&(this.type=F),this.runOptions=x,this.configurationProperties=$,this._source=Q}getDefinition(V){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const V={folder:this.getFolderId(),id:this._id};return JSON.stringify(V)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,B=!1){if(V===void 0)return!1;if(t.isString(V))return V===this._label||V===this.configurationProperties.identifier||B&&V===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),V&&(this._taskLoadMessages=this._taskLoadMessages.concat(V))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class d extends i{constructor(V,B,F,x,$,Q,K,de){super(V,F,void 0,K,de,B),this.command={},this._source=B,this.hasDefinedMatchers=Q,$&&(this.command=$)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case S.Shell:B="shell";break;case S.Process:B="process";break;case S.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(V){return V instanceof d}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let B=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(B+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:B};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(V){return new d(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.CustomTask=d;class a extends i{constructor(V,B,F,x,$,Q,K){super(V,F,x,Q,K,B),this._source=B,this.configures=$}static is(V){return V instanceof a}fromObject(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let B=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(B+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:B};return JSON.stringify(F)}}e.ConfiguringTask=a;class r extends i{constructor(V,B,F,x,$,Q,K,de,ee){super(V,F,x,de,ee,B),this.defines=$,this.hasDefinedMatchers=K,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof r}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.getFolderId(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(V){return new r(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.ContributedTask=r;class o extends i{constructor(V,B,F,x,$,Q){super(V,F,x,$,Q,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(V){return new o(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.InMemoryTask=o;var u;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(V){this._order=new Map;for(let B=0;B<V.length;B++)this._order.set(V[B].uri.toString(),B)}compare(V,B){const F=V.getWorkspaceFolder(),x=B.getWorkspaceFolder();if(F&&x){let $=this._order.get(F.uri.toString());$=$===void 0?0:$+1;let Q=this._order.get(x.uri.toString());return Q=Q===void 0?0:Q+1,$===Q?V._label.localeCompare(B._label):$-Q}else return!F&&x?-1:F&&!x?1:0}}e.TaskSorter=s;var h;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var _;(function(N){N.SingleRun="singleRun",N.Background="background"})(_=e.TaskRunType||(e.TaskRunType={}));var L;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function V(B,F,x,$,Q){if(F){const K={kind:B,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return B==="start"?(K.terminalId=x,K.resolvedVariables=$):B==="processStarted"?K.processId=x:B==="processEnded"&&(K.exitCode=x),Object.freeze(K)}else return Object.freeze({kind:"changed"})}N.create=V})(M=e.TaskEvent||(e.TaskEvent={}));var U;(function(N){function V(F){const x=Object.keys(F).sort();let $="";for(const Q of x){let K=F[Q];K instanceof Object?K=V(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),$+=Q+","+K+","}return $}function B(F){const $={_key:V(F),type:F.taskType};return Object.assign($,F),$}N.create=B})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var R;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(R=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var H;(function(N){function V(B,F){const x=I.TaskDefinitionRegistry.get(B.type);if(x===void 0){const de=P.deepClone(B);return delete de._key,U.create(de)}const $=Object.create(null);$.type=x.taskType;const Q=new Set;x.required.forEach(de=>Q.add(de));const K=x.properties;for(const de of Object.keys(K)){const ee=B[de];if(ee!=null)$[de]=ee;else if(Q.has(de)){const he=K[de];if(he.default!==void 0)$[de]=P.deepClone(he.default);else switch(he.type){case"boolean":$[de]=!1;break;case"number":case"integer":$[de]=0;break;case"string":$[de]="";break;default:F.error(l.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return U.create($)}N.createTaskIdentifier=V})(H=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[237],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,I)=>{this._actualOk=y,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,l.onUnexpectedError)(y))}then(y,I){return this._ensureActual().then(y,I)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class C extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=C}),define(De[56],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function C(I){const E=new l(I);return t[E.nid]=E,E}e.createProxyIdentifier=C;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class y{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=y}),define(De[5],Ie([1,0,56]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var P;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(I=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(v){return v._id=k._n++,v}}e.IdObject=k,k._n=0;var w;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.command="m",g.kindModifier="n"})(w=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,l.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,l.createProxyIdentifier)("ExtHostLocalization")}}),define(De[67],Ie([1,0,4,13,5,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(C.MainContext.MainThreadTelemetry)}report(E,D,A){const k=this.getUsageKey(E,D);this._reportedUsages.has(k)||(this._reportedUsages.add(k),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:E}))}getUsageKey(E,D){return`${E}-${D.identifier.value}`}};y=je([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(I,E,D){}})}),define(De[238],Ie([1,0,3,5,7,27]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,D,A,k={}){const w=P.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(w)||[],S=[...A].sort().join(" ");let g=T.find(v=>v.providerId===D&&v.scopes===S);if(g)return g.result;{const v=this._getSession(E,w,D,A,k);g={providerId:D,scopes:S,result:v},T.push(g),this._inFlightRequests.set(w,T);try{await v}finally{const m=T.findIndex(b=>b.providerId===D&&b.scopes===S);m>-1&&(T.splice(m),this._inFlightRequests.set(w,T))}return v}}async _getSession(E,D,A,k,w={}){await this._proxy.$ensureProvider(A);const T=E.displayName||E.name;return this._proxy.$getSession(A,k,D,T,w)}async removeSession(E,D){const A=this._authenticationProviders.get(E);return A?A.provider.removeSession(D):this._proxy.$removeSession(E,D)}registerAuthenticationProvider(E,D,A,k){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:D,provider:A,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:D});const w=A.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,D,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{w.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(S=>S.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,D){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,D){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,D){const A=this._authenticationProviders.get(E);if(A)return Promise.resolve(A.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,D){return this._onDidChangeSessions.fire({provider:{id:E,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(De[239],Ie([1,0,5,16,15]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,E){this._proxy=I.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:D=>E.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(I,E,D){const A=C.WorkspaceEdit.from(I,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(De[240],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(I){return y.$writeText(I)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,12,7,15,24,5,17,13,81,35,49,2,6,4,16,134,23,56,50]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f){"use strict";var c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(n,s){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,p.set(this,void 0),tt(this,c,n.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=s,tt(this,p,n.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const _=this._apiCommands.get(h);return _?.result===r.Void?_:void 0},s),this._argumentProcessors=[{processArgument(h){return(0,D.revive)(h)}},{processArgument(h){return(0,P.cloneAndChange)(h,function(_){if(A.Range.isIRange(_))return C.Range.to(_);if(k.Position.isIPosition(_))return C.Position.to(_);if(A.Range.isIRange(_.range)&&w.URI.isUri(_.uri))return C.location.to(_);if(_ instanceof m.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const s=this.registerCommand(!1,n.id,async(...h)=>{const _=n.args.map((M,U)=>{if(!M.validate(h[U]))throw new Error(`Invalid argument '${M.name}' when running '${n.id}', received: ${h[U]}`);return M.convert(h[U])}),L=await this.executeCommand(n.internalId,..._);return n.result.convert(L,h,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{s.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,s,h,_,L,M){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:h,thisArg:_,description:L,extension:M}),n&&Be(this,c,"f").$registerCommand(s),new t.Disposable(()=>{this._commands.delete(s)&&n&&Be(this,c,"f").$unregisterCommand(s)})}executeCommand(n,...s){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,s,!0)}async _doExecuteCommand(n,s,h){if(this._commands.has(n))return Be(this,c,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,s,!1);{let _=!1;const L=(0,P.cloneAndChange)(s,function(M){if(M instanceof t.Position)return C.Position.from(M);if(M instanceof t.Range)return C.Range.from(M);if(M instanceof t.Location)return C.location.from(M);if(t.NotebookRange.isNotebookRange(M))return C.NotebookRange.from(M);if(M instanceof ArrayBuffer)return _=!0,m.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return _=!0,m.VSBuffer.wrap(M);if(M instanceof m.VSBuffer)return _=!0,M;if(!Array.isArray(M))return M});try{const M=await Be(this,c,"f").$executeCommand(n,_?new b.SerializableObjectWithBuffers(L):L,h);return(0,D.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(n,s,!1);throw M}}}async _executeContributedCommand(n,s,h){const _=this._commands.get(n);if(!_)throw new Error("Unknown command");this._reportTelemetry(_,n);const{callback:L,thisArg:M,description:U}=_;if(U)for(let R=0;R<U.args.length;R++)try{(0,l.validateConstraint)(s[R],U.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${U.args[R].name}' - ${U.args[R].description}`)}try{return await L.apply(M,s)}catch(R){if(n===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...s);z&&(n=z.command)}throw this._logService.error(R,n,_.extension?.identifier),h?new class extends Error{constructor(){super((0,f.toErrorMessage)(R)),this.id=n,this.source=_.extension?.displayName??_.extension?.name}}:R}}_reportTelemetry(n,s){!n.extension||n.extension.isBuiltin||Be(this,p,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:s})}$executeContributedCommand(n,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(s=s.map(h=>this._argumentProcessors.reduce((_,L)=>L.processArgument(_),h)),this._executeContributedCommand(n,s,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Be(this,c,"f").$getCommands().then(s=>(n&&(s=s.filter(h=>h[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[s,h]of this._commands){const{description:_}=h;_&&(n[s]=_)}return Promise.resolve(n)}};c=new WeakMap,p=new WeakMap,i=je([$e(0,g.IExtHostRpcService),$e(1,E.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class d{constructor(n,s,h){this._commands=n,this._lookupApiCommand=s,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,s){if(!n)return;const h={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return h;const _=this._lookupApiCommand(n.command);if(_)h.id=_.internalId,h.arguments=_.args.map((L,M)=>L.convert(n.arguments&&n.arguments[M]));else if((0,I.isNonEmptyArray)(n.arguments)){const L=++this._cachIdPool;this._cache.set(L,n),s.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),h.$ident=L,h.id=this.delegatingCommandId,h.arguments=[L],this._logService.trace("CommandsConverter#CREATE",n.command,L)}return h}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const s=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class a{constructor(n,s,h,_){this.name=n,this.description=s,this.validate=h,this.convert=_}optional(){return new a(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,s){return new a(n??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",u=>w.URI.isUri(u),u=>u),a.Position=new a("position","A position in a text document",u=>t.Position.isPosition(u),C.Position.from),a.Range=new a("range","A range in a text document",u=>t.Range.isRange(u),C.Range.from),a.Selection=new a("selection","A selection in a text document",u=>t.Selection.isSelection(u),C.Selection.from),a.Number=new a("number","",u=>typeof u=="number",u=>u),a.String=new a("string","",u=>typeof u=="string",u=>u),a.CallHierarchyItem=new a("item","A call hierarchy item",u=>u instanceof t.CallHierarchyItem,C.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",u=>u instanceof t.TypeHierarchyItem,C.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",u=>u instanceof v.TestItemImpl,C.TestItem.from);class r{constructor(n,s){this.description=n,this.convert=s}}e.ApiCommandResult=r,r.Void=new r("no result",u=>u);class o{constructor(n,s,h,_,L){this.id=n,this.internalId=s,this.description=h,this.args=_,this.result=L}}e.ApiCommand=o}),define(De[241],Ie([1,0,2,15,7,64,39,17,117,122,14]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(g,v)=>{if((0,I.isFalsyOrEmpty)(g))return;class m extends C.SymbolInformation{static to(f){const c=new m(f.name,t.SymbolKind.to(f.kind),f.containerName||"",new C.Location(v[0],t.Range.to(f.range)));return c.detail=f.detail,c.range=c.location.range,c.selectionRange=t.Range.to(f.selectionRange),c.children=f.children?f.children.map(m.to):[],c}}return g.map(m.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",g=>typeof g=="string",g=>g),new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",g=>Array.isArray(g)&&g.every(v=>C.Position.isPosition(v)),g=>g.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",g=>g.map(v=>{let m;for(const b of v.reverse())m=new C.SelectionRange(t.Range.to(b),m);return m}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",g=>g.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",g=>{if(!!g)return{range:t.Range.to(g.range),placeholder:g.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",g=>{if(!!g){if(g.rejectReason)throw new Error(g.rejectReason);return t.WorkspaceEdit.to(g)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",g=>g.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new C.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const v=(0,E.decodeSemanticTokensDto)(g);if(v.type==="full")return new C.SemanticTokens(v.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new C.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const v=(0,E.decodeSemanticTokensDto)(g);if(v.type==="full")return new C.SemanticTokens(v.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(g,v,m)=>{if(!g)return new C.CompletionList([]);const b=g.suggestions.map(f=>t.CompletionItem.to(f,m));return new C.CompletionList(b,g.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",g=>{if(g)return t.SignatureHelp.to(g)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(g,v,m)=>T(b=>new C.CodeLens(t.Range.to(b.range),b.command&&m.fromInternal(b.command)))(g))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",g=>C.Range.isRange(g),g=>C.Selection.isSelection(g)?t.Selection.from(g):t.Range.from(g)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(g,v,m)=>T(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(b.command)}else{const f=new C.CodeAction(b.title,b.kind?new C.CodeActionKind(b.kind):void 0);return b.edit&&(f.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(f.command=m.fromInternal(b.command)),f.isPreferred=b.isPreferred,f}})(g))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",g=>g?g.map(v=>new C.ColorInformation(t.Range.to(v.range),t.Color.to(v.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",g=>g instanceof C.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",g=>!0,g=>({uri:g.uri,range:t.Range.from(g.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",g=>g?g.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(g,v,m)=>g.map(t.InlayHint.to.bind(void 0,m)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(g=>({viewType:g.viewType,displayName:g.displayName,options:{transientOutputs:g.options.transientOutputs,transientCellMetadata:g.options.transientCellMetadata,transientDocumentMetadata:g.options.transientDocumentMetadata},filenamePattern:g.filenamePattern.map(v=>t.NotebookExclusiveDocumentPattern.to(v))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",g=>g.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",g=>l.URI.isUri(g)||typeof g=="string"&&(0,D.matchesSomeScheme)(g,A.Schemas.http,A.Schemas.https),g=>g),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="object",g=>g&&[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class w{static register(v){k.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=w;function T(g){return v=>{if(Array.isArray(v))return v.map(g)}}function S(g){if(!Array.isArray(g))return;const v=[];for(const m of g)P.isLocationLink(m)?v.push(t.DefinitionLink.to(m)):v.push(t.location.to(m));return v}}),define(De[242],Ie([1,0,18,59,3,6,2,64,27,15,7,28,5]),function(J,e,l,t,C,P,y,I,E,D,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(S,g,v){const m=S.getProxy(w.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this._commentControllers.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this._commentControllers.get(u.commentControlHandle);if(!n)return u;const s=n.getCommentThread(u.commentThreadHandle);return s?s.value:u}else if(u&&u.$mid===8){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const s=n.getCommentThread(u.thread.commentThreadHandle);return s?{thread:s.value,text:u.text}:u}else if(u&&u.$mid===9){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const s=n.getCommentThread(u.thread.commentThreadHandle);if(!s)return u;const h=u.commentUniqueId,_=s.getCommentByUniqueId(h);return _||u}else if(u&&u.$mid===10){const n=this._commentControllers.get(u.thread.commentControlHandle);if(!n)return u;const s=n.getCommentThread(u.thread.commentThreadHandle);if(!s)return u;const h=u.text,_=u.commentUniqueId,L=s.getCommentByUniqueId(_);return L?(typeof L.body=="string"?L.body=h:L.body.value=h,L):u}return u}})}createCommentController(u,n,s){const h=b.handlePool++,_=new c(u,h,n,s);this._commentControllers.set(_.handle,_);const L=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(u.identifier))||[];return L.push(_),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(u.identifier),L),_.value}$createCommentThreadTemplate(u,n,s){const h=this._commentControllers.get(u);!h||h.$createCommentThreadTemplate(n,s)}async $updateCommentThreadTemplate(u,n,s){const h=this._commentControllers.get(u);!h||h.$updateCommentThreadTemplate(n,s)}$deleteCommentThread(u,n){this._commentControllers.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,s){const h=this._commentControllers.get(u);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const _=v.getDocument(y.URI.revive(n));return(0,l.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(_,s)).then(L=>L?L.map(M=>D.Range.from(M)):void 0)}$toggleReaction(u,n,s,h,_){const L=this._commentControllers.get(u);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const M=L.getCommentThread(n);if(M){const U=M.getCommentByUniqueId(h.uniqueIdInThread);if(L!==void 0&&U&&L.reactionHandler)return L.reactionHandler(U,d(_))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class f{set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(u){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,n,s,h,_,L,M,U){this._commentControllerHandle=n,this._id=s,this._uri=h,this._range=_,this._comments=L,this.extensionDescription=M,this._isTemplate=U,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),m.$createCommentThread(n,this.handle,this._id,this._uri,D.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(n,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(z){R.range=z},get comments(){return R.comments},set comments(z){R.comments=z},get collapsibleState(){return R.collapsibleState},set collapsibleState(z){R.collapsibleState=z},get canReply(){return R.canReply},set canReply(z){R.canReply=z},get contextValue(){return R.contextValue},set contextValue(z){R.contextValue=z},get label(){return R.label},set label(z){R.label=z},get state(){return R.state},set state(z){R.state=z},dispose:()=>{R.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=s=>Object.prototype.hasOwnProperty.call(this.modifications,s),n={};u("range")&&(n.range=D.Range.from(this._range)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this._comments.map(s=>p(this,s,this._commentsMap))),u("collapsibleState")&&(n.collapseState=a(this._collapseState)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=r(this._state)),u("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(u){for(const n of this._commentsMap){const s=n[0],h=n[1];if(u===h)return s}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}f._handlePool=0,je([(0,t.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,n,s,h){this._extension=u,this._handle=n,this._id=s,this._label=h,this._threads=new Map,m.$registerCommentController(this.handle,s,h);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(L){_.options=L},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(L){_.commentingRangeProvider=L},get reactionHandler(){return _.reactionHandler},set reactionHandler(L){_.reactionHandler=L},createCommentThread(L,M,U){return _.createCommentThread(L,M,U).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,s,h){if(typeof u=="string"){const _=new f(this.id,this.handle,u,n,s,h,this._extension,!1);return this._threads.set(_.handle,_),_}else{const _=new f(this.id,this.handle,void 0,u,n,s,this._extension,!1);return this._threads.set(_.handle,_),_}}$createCommentThreadTemplate(u,n){const s=new f(this.id,this.handle,void 0,y.URI.revive(u),D.Range.to(n),[],this._extension,!0);return s.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(s.handle,s),s}$updateCommentThreadTemplate(u,n){const s=this._threads.get(u);s&&(s.range=D.Range.to(n))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function p(o,u,n){let s=n.get(u);s||(s=++o.commentHandle,n.set(u,s));const h=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:s,body:typeof u.body=="string"?u.body:D.MarkdownString.from(u.body),userName:u.author.name,userIconPath:h,label:u.label,commentReactions:u.reactions?u.reactions.map(_=>i(_)):void 0,timestamp:u.timestamp?.toJSON()}}function i(o){return{label:o.label,iconPath:o.iconPath?D.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function d(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?y.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function a(o){if(o!==void 0)switch(o){case A.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}function r(o){if(o!==void 0)switch(o){case A.CommentThreadState.Unresolved:return I.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return I.CommentThreadState.Resolved}return I.CommentThreadState.Unresolved}return new b}e.createExtHostComments=T}),define(De[243],Ie([1,0,24,5,25,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(A,k){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,k){const w=this,T=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){w._handleConsoleCall(A,k,T,arguments)}})}_handleConsoleCall(A,k,w,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,w,T)}};y=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const I=1e5;function E(D,A){const k=[];if(D.length)for(let w=0;w<D.length;w++){let T=D[w];if(typeof T>"u")T="undefined";else if(T instanceof Error){const S=T;S.stack?T=S.stack:T=S.toString()}k.push(T)}if(A){const w=new Error().stack;w&&k.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,l.safeStringify)(k);return w.length>I?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[136],Ie([1,0,2,5,7,4,16,13,17,8,9]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class On{constructor(T,S){this._logService=S,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,S){const g=On._handlePool++;this._provider.set(g,{provider:T,extensionId:S}),this._proxy.$registerDecorationProvider(g,S.value);const v=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(g,null);return}const b=(0,E.asArray)(m);if(b.length<=On._maxEventSize){this._proxy.$onDidChange(g,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",S.value,b.length);const f=b.map(i=>({uri:i,rank:(0,D.count)(i.path,"/")})),c=(0,E.groupBy)(f,(i,d)=>i.rank-d.rank||(0,D.compare)(i.uri.path,d.uri.path)),p=[];e:for(const i of c){let d;for(const a of i){const r=(0,A.dirname)(a.uri.path);if(d!==r&&(d=r,p.push(a.uri)>=On._maxEventSize))break e}}this._proxy.$onDidChange(g,p)});return new C.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(T,S,g){if(!this._provider.has(T))return Object.create(null);const v=Object.create(null),{provider:m,extensionId:b}=this._provider.get(T);return await Promise.all(S.map(async f=>{try{const{uri:c,id:p}=f,i=await Promise.resolve(m.provideFileDecoration(l.URI.revive(c),g));if(!i)return;try{C.FileDecoration.validate(i),v[p]=[i.propagate,i.tooltip,i.badge,i.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${b.value}': ${d}`)}}catch(c){this._logService.error(c)}})),v}};k._handlePool=0,k._maxEventSize=250,k=je([$e(0,y.IExtHostRpcService),$e(1,I.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[244],Ie([1,0,170,121,2,5,7,15,3,13,26,46]),function(J,e,l,t,C,P,y,I,E,D,A,k){"use strict";var w,T,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(b,f,c,p,i,d){this._name=b,this._owner=f,this._maxDiagnosticsPerFile=c,w.set(this,void 0),T.set(this,void 0),S.set(this,void 0),this._isDisposed=!1,tt(this,S,new A.ResourceMap(a=>p.getComparisonKey(a)),"f"),tt(this,w,i,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Be(this,T,"f").fire([...Be(this,S,"f").keys()]),Be(this,w,"f")?.$clear(this._owner),Be(this,S,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,f){if(!b){this.clear();return}this._checkDisposed();let c=[];if(C.URI.isUri(b)){if(!f){this.delete(b);return}Be(this,S,"f").set(b,f.slice()),c=[b]}else if(Array.isArray(b)){c=[];let i;b=[...b].sort(g._compareIndexedTuplesByUri);for(const d of b){const[a,r]=d;if((!i||a.toString()!==i.toString())&&(i&&Be(this,S,"f").get(i).length===0&&Be(this,S,"f").delete(i),i=a,c.push(a),Be(this,S,"f").set(a,[])),r)Be(this,S,"f").get(a)?.push(...r);else{const o=Be(this,S,"f").get(a);o&&(o.length=0)}}}if(Be(this,T,"f").fire(c),!Be(this,w,"f"))return;const p=[];for(const i of c){let d=[];const a=Be(this,S,"f").get(i);if(a)if(a.length>this._maxDiagnosticsPerFile){d=[];const r=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const u of a)if(u.severity===r[o]&&d.push(I.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;d.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=a.map(r=>I.Diagnostic.from(r));p.push([i,d])}Be(this,w,"f").$changeMany(this._owner,p)}delete(b){this._checkDisposed(),Be(this,T,"f").fire([b]),Be(this,S,"f").delete(b),Be(this,w,"f")?.$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Be(this,T,"f").fire([...Be(this,S,"f").keys()]),Be(this,S,"f").clear(),Be(this,w,"f")?.$clear(this._owner)}forEach(b,f){this._checkDisposed();for(const[c,p]of this)b.call(f,c,p,this)}*[(w=new WeakMap,T=new WeakMap,S=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const b of Be(this,S,"f").keys())yield[b,this.get(b)]}get(b){this._checkDisposed();const f=Be(this,S,"f").get(b);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Be(this,S,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,f){return b[0].toString()<f[0].toString()?-1:b[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=g;let v=class ln{static _mapper(b){const f=new A.ResourceMap;for(const c of b)f.set(c,c);return{uris:Object.freeze(Array.from(f.values()))}}constructor(b,f,c){this._logService=f,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,ln._mapper),this._proxy=b.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,f){const{_collections:c,_proxy:p,_onDidChangeDiagnostics:i,_logService:d,_fileSystemInfoService:a}=this,r=new class{$changeMany(n,s){p.$changeMany(n,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,n,s.length===0?"CLEARING":s)}$clear(n){p.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,n)}dispose(){p.dispose()}};let o;if(!f)f="_generated_diagnostic_collection_name_#"+ln._idPool++,o=f;else if(!c.has(f))o=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do o=f+ln._idPool++;while(c.has(o))}return new class extends g{constructor(){super(f,o,ln._maxDiagnosticsPerFile,a.extUri,r,i),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const f=new Map,c=[];for(const p of this._collections.values())p.forEach((i,d)=>{let a=f.get(i.toString());typeof a>"u"&&(a=c.length,f.set(i.toString(),a),c.push([i,[]])),c[a][1]=c[a][1].concat(...d)});return c}}_getDiagnostics(b){let f=[];for(const c of this._collections.values())c.has(b)&&(f=f.concat(c.get(b)));return f}$acceptMarkersChange(b){if(!this._mirrorCollection){const f="_generated_mirror",c=new g(f,f,ln._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,c),this._mirrorCollection=c}for(const[f,c]of b)this._mirrorCollection.set(C.URI.revive(f),c.map(I.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([$e(1,D.ILogService),$e(2,k.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(De[245],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(I=>I?I.map(E=>l.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(I=>I?l.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(De[246],Ie([1,0,11,2,7,5,14,21,8]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(k,w,T){this._documentsAndEditors=w,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,w){if(Object.keys(y.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=D._handlePool++;this._documentContentProviders.set(T,w),this._proxy.$registerTextContentProvider(T,k);let S;return typeof w.onDidChange=="function"&&(S=w.onDidChange(g=>{if(g.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(T,g).then(v=>{if(!v&&typeof v!="string")return;const m=this._documentsAndEditors.getDocument(g);if(!m)return;const b=(0,E.splitLines)(v);if(!m.equalLines(b))return this._proxy.$onVirtualDocumentChange(g,v)},l.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(k,w){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(w),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(De[247],Ie([1,0,3,6,2,5,132,15,12,24,7]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,S){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=S,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const v of g)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const v of g)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const S=this._documentsAndEditors.getDocument(T);if(S)return S}getDocument(T){const S=this.getDocumentData(T);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return S.document}ensureDocumentData(T){const S=this._documentsAndEditors.getDocument(T);if(S)return Promise.resolve(S);let g=this._documentLoader.get(T.toString());return g||(g=this._proxy.$tryOpenDocument(T).then(v=>{this._documentLoader.delete(T.toString());const m=C.URI.revive(v);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(m))},v=>(this._documentLoader.delete(T.toString()),Promise.reject(v))),this._documentLoader.set(T.toString(),g)),g}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(S=>C.URI.revive(S))}$acceptModelLanguageChanged(T,S){const g=C.URI.revive(T),v=this._documentsAndEditors.getDocument(g);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(S),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(T){const S=C.URI.revive(T),g=this._documentsAndEditors.getDocument(S);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(T,S){const g=C.URI.revive(T),v=this._documentsAndEditors.getDocument(g);if(!v)throw new Error("unknown document");v._acceptIsDirty(S),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,S,g){const v=C.URI.revive(T),m=this._documentsAndEditors.getDocument(v);if(!m)throw new Error("unknown document");m._acceptIsDirty(g),m.onEvents(S);let b;S.isUndoing?b=A.TextDocumentChangeReason.Undo:S.isRedoing&&(b=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:m.document,contentChanges:S.changes.map(f=>({range:I.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:b}))}setWordDefinitionFor(T,S){(0,y.setWordDefinitionFor)(T,S)}}e.ExtHostDocuments=k}),define(De[57],Ie([1,0,48,3,6,2,4,5,132,16,135,15,13,26,14,61,78]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let b=class{constructor(c,p){this._extHostRpc=c,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const p=[],i=[],d=[];if(c.removedDocuments)for(const a of c.removedDocuments){const r=P.URI.revive(a),o=this._documents.get(r);o?.unref()&&(this._documents.delete(r),p.push(o.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const r=P.URI.revive(a.uri);let o=this._documents.get(r);if(o&&r.scheme!==S.Schemas.vscodeNotebookCell&&r.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);o||(o=new m(new E.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(r,o),i.push(o.value)),o.ref()}if(c.removedEditors)for(const a of c.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&d.push(r)}if(c.addedEditors)for(const a of c.addedEditors){const r=P.URI.revive(a.documentUri);l.ok(this._documents.has(r),`document '${r}' does not exist`),l.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const o=this._documents.get(r).value,u=new A.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>o.document),a.selections.map(k.Selection.to),a.options,a.visibleRanges.map(n=>k.Range.to(n)),typeof a.editorPosition=="number"?k.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,u)}c.newActiveEditor!==void 0&&(l.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(p),(0,C.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(p),c.addedDocuments&&this._onDidAddDocuments.fire(i),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return c?p:p?.value}allEditors(){return[...this._editors.values()]}};b=je([$e(0,D.IExtHostRpcService),$e(1,w.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[58],Ie([1,0,15,5,2,3,4,7,16,12,77]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class k{constructor(v,m,b){this._activeTabIdGetter=b,this._parentGroup=m,this.acceptDtoUpdate(v)}get apiObject(){if(!this._apiObject){const v=this,m={get isActive(){return v._dto.id===v._activeTabIdGetter()},get label(){return v._dto.label},get input(){return v._input},get isDirty(){return v._dto.isDirty},get isPinned(){return v._dto.isPinned},get isPreview(){return v._dto.isPreview},get group(){return v._parentGroup.apiObject}};this._apiObject=Object.freeze(m)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(v){this._dto=v,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new I.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new I.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new I.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new I.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new I.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new I.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new I.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new I.TerminalEditorTabInput;case 9:return new I.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class w{constructor(v,m){this._tabs=[],this._activeTabId="",this._dto=v,this._activeGroupIdGetter=m;for(const b of v.tabs)b.isActive&&(this._activeTabId=b.id),this._tabs.push(new k(b,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const v=this,m={get isActive(){return v._dto.groupId===v._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(v._dto.viewColumn)},get activeTab(){return v._tabs.find(b=>b.tabId===v._activeTabId)?.apiObject},get tabs(){return Object.freeze(v._tabs.map(b=>b.apiObject))}};this._apiObject=Object.freeze(m)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(v){this._dto=v}acceptTabOperation(v){if(v.kind===0){const b=new k(v.tabDto,this,()=>this.activeTabId());return this._tabs.splice(v.index,0,b),v.tabDto.isActive&&(this._activeTabId=b.tabId),b}else if(v.kind===1){const b=this._tabs.splice(v.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${v.index} which does not exist`);return b.tabId===this._activeTabId&&(this._activeTabId=""),b}else if(v.kind===3){if(v.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this._tabs.splice(v.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${v.oldIndex} which does not exist`);return this._tabs.splice(v.index,0,b),b}const m=this._tabs.find(b=>b.tabId===v.tabDto.id);if(!m)throw new Error("INVALID tab");return v.tabDto.isActive?this._activeTabId=v.tabDto.id:this._activeTabId===v.tabDto.id&&!v.tabDto.isActive&&(this._activeTabId=""),m.acceptDtoUpdate(v.tabDto),m}activeTabId(){return this._activeTabId}}let T=class{constructor(v){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=v.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const v=this,m={onDidChangeTabGroups:v._onDidChangeTabGroups.event,onDidChangeTabs:v._onDidChangeTabs.event,get all(){return Object.freeze(v._extHostTabGroups.map(b=>b.apiObject))},get activeTabGroup(){const b=v._activeGroupId;return(0,D.assertIsDefined)(v._extHostTabGroups.find(c=>c.groupId===b)?.apiObject)},close:async(b,f)=>{const c=Array.isArray(b)?b:[b];return c.length?S(c[0])?this._closeGroups(c,f):this._closeTabs(c,f):!0}};this._apiObject=Object.freeze(m)}return this._apiObject}$acceptEditorTabModel(v){const m=new Set(this._extHostTabGroups.map(a=>a.groupId)),b=new Set(v.map(a=>a.groupId)),f=(0,A.diffSets)(m,b),c=this._extHostTabGroups.filter(a=>f.removed.includes(a.groupId)).map(a=>a.apiObject),p=[],i=[];this._extHostTabGroups=v.map(a=>{const r=new w(a,()=>this._activeGroupId);return f.added.includes(r.groupId)?p.push(r.apiObject):i.push(r.apiObject),r});const d=(0,D.assertIsDefined)(v.find(a=>a.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:p,closed:c,changed:i}))}$acceptTabGroupUpdate(v){const m=this._extHostTabGroups.find(b=>b.groupId===v.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(v),v.isActive&&(this._activeGroupId=v.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(v){const m=this._extHostTabGroups.find(f=>f.groupId===v.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const b=m.acceptTabOperation(v);switch(v.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}_findExtHostTabFromApi(v){for(const m of this._extHostTabGroups)for(const b of m.tabs)if(b.apiObject===v)return b}_findExtHostTabGroupFromApi(v){return this._extHostTabGroups.find(m=>m.apiObject===v)}async _closeTabs(v,m){const b=[];for(const f of v){const c=this._findExtHostTabFromApi(f);if(!c)throw new Error("Tab close: Invalid tab not found!");b.push(c.tabId)}return this._proxy.$closeTab(b,m)}async _closeGroups(v,m){const b=[];for(const f of v){const c=this._findExtHostTabGroupFromApi(f);if(!c)throw new Error("Group close: Invalid group not found!");b.push(c.groupId)}return this._proxy.$closeGroup(b,m)}};T=je([$e(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function S(g){return g.tabs!==void 0}}),define(De[248],Ie([1,0,2,5,6,7,15,149,8,23,28]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(S){this._stateMachine=void 0,this._schemes.push(S)}delete(S){const g=this._schemes.indexOf(S);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const S=this._schemes.sort(),g=[];let v,m,b=14,f=14;for(const c of S){let p=v?(0,E.commonPrefixLength)(v,c):0;for(p===0?m=1:m=f;p<c.length;p++)p+1===c.length?(b=f,f=9):f+=1,g.push([m,c.toUpperCase().charCodeAt(p),f]),g.push([m,c.toLowerCase().charCodeAt(p),f]),m=f;v=c,f=b}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new I.StateMachine(g)}}provideDocumentLinks(S){this._initStateMachine();const g=[],v=I.LinkComputer.computeLinks({getLineContent(m){return S.lineAt(m-1).text},getLineCount(){return S.lineCount}},this._stateMachine);for(const m of v){const b=y.DocumentLink.to(m);b.target&&g.push(b)}return g}}class w{constructor(S,g){this._extHostLanguageFeatures=g,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=S.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(S,g,v,m={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(S,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(b,v);let f=2;m.isCaseSensitive&&(f+=1024),m.isReadonly&&(f+=2048),typeof v.copy=="function"&&(f+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,A.checkProposedApiEnabled)(S,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(b,g,f).catch(p=>{console.error(`FAILED to register filesystem provider of ${S.identifier.value}-extension for the scheme ${g}`),console.error(p)});const c=v.onDidChangeFile(p=>{const i=[];for(const d of p){const{uri:a,type:r}=d;if(a.scheme!==g)continue;let o;switch(r){case P.FileChangeType.Changed:o=0;break;case P.FileChangeType.Created:o=1;break;case P.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:a,type:o})}this._proxy.$onFileSystemChange(b,i)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(S){const{type:g,ctime:v,mtime:m,size:b,permissions:f}=S;return{type:g,ctime:v,mtime:m,size:b,permissions:f}}$stat(S,g){return Promise.resolve(this._getFsProvider(S).stat(l.URI.revive(g))).then(v=>w._asIStat(v))}$readdir(S,g){return Promise.resolve(this._getFsProvider(S).readDirectory(l.URI.revive(g)))}$readFile(S,g){return Promise.resolve(this._getFsProvider(S).readFile(l.URI.revive(g))).then(v=>D.VSBuffer.wrap(v))}$writeFile(S,g,v,m){return Promise.resolve(this._getFsProvider(S).writeFile(l.URI.revive(g),v.buffer,m))}$delete(S,g,v){return Promise.resolve(this._getFsProvider(S).delete(l.URI.revive(g),v))}$rename(S,g,v,m){return Promise.resolve(this._getFsProvider(S).rename(l.URI.revive(g),l.URI.revive(v),m))}$copy(S,g,v,m){const b=this._getFsProvider(S);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(l.URI.revive(g),l.URI.revive(v),m))}$mkdir(S,g){return Promise.resolve(this._getFsProvider(S).createDirectory(l.URI.revive(g)))}$watch(S,g,v,m){const b=this._getFsProvider(S).watch(l.URI.revive(v),m);this._watches.set(g,b)}$unwatch(S,g){const v=this._watches.get(g);v&&(v.dispose(),this._watches.delete(g))}$open(S,g,v){const m=this._getFsProvider(S);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(l.URI.revive(g),v))}$close(S,g){const v=this._getFsProvider(S);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(g))}$read(S,g,v,m){const b=this._getFsProvider(S);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const f=D.VSBuffer.alloc(m);return Promise.resolve(b.read(g,v,f.buffer,0,m)).then(c=>f.slice(0,c))}$write(S,g,v,m){const b=this._getFsProvider(S);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(g,v,m.buffer,0,m.byteLength))}_getFsProvider(S){const g=this._fsProvider.get(S);if(!g){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return g}}e.ExtHostFileSystem=w}),define(De[68],Ie([1,0,5,38,7,23,4,16,46,6]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Yt{constructor(w,T){this._fileSystemProvider=new Map,this._proxy=w.getProxy(l.MainContext.MainThreadFileSystem);const S=this;this.value=Object.freeze({async stat(g){try{const v=S._fileSystemProvider.get(g.scheme);if(!v)return await S._proxy.$stat(g);await S._proxy.$ensureActivation(g.scheme);const m=await v.stat(g);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(v){Yt._handleError(v)}},async readDirectory(g){try{const v=S._fileSystemProvider.get(g.scheme);return v?(await S._proxy.$ensureActivation(g.scheme),(await v.readDirectory(g)).slice()):await S._proxy.$readdir(g)}catch(v){return Yt._handleError(v)}},async createDirectory(g){try{return await S._proxy.$mkdir(g)}catch(v){return Yt._handleError(v)}},async readFile(g){try{const v=S._fileSystemProvider.get(g.scheme);return v?(await S._proxy.$ensureActivation(g.scheme),(await v.readFile(g)).slice()):(await S._proxy.$readFile(g)).buffer}catch(v){return Yt._handleError(v)}},async writeFile(g,v){try{return await S._proxy.$writeFile(g,P.VSBuffer.wrap(v))}catch(m){return Yt._handleError(m)}},async delete(g,v){try{const m=S._fileSystemProvider.get(g.scheme);return m?(await S._proxy.$ensureActivation(g.scheme),await m.delete(g,{recursive:!1,...v})):await S._proxy.$delete(g,{recursive:!1,useTrash:!1,...v})}catch(m){return Yt._handleError(m)}},async rename(g,v,m){try{return await S._proxy.$rename(g,v,{overwrite:!1,...m})}catch(b){return Yt._handleError(b)}},async copy(g,v,m){try{return await S._proxy.$copy(g,v,{overwrite:!1,...m})}catch(b){return Yt._handleError(b)}},isWritableFileSystem(g){const v=T.getCapabilities(g);if(typeof v=="number")return!(v&2048)}})}static _handleError(w){if(w instanceof C.FileSystemError)throw w;if(!(w instanceof Error))throw new C.FileSystemError(String(w));if(w.name==="ENOPRO")throw C.FileSystemError.Unavailable(w.message);switch(w.name){case t.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(w.message);case t.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(w.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(w.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(w.message);case t.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(w.message);case t.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(w.message);default:throw new C.FileSystemError(w.message,w.name)}}addFileSystemProvider(w,T){return this._fileSystemProvider.set(w,T),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(w))}};A=je([$e(0,I.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(De[249],Ie([1,0,3,37,2,5,15,7]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(k,w,T,S,g,v,m,b){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const f=this.ensureWatching(k,T,g);this._config=0,v&&(this._config+=1),m&&(this._config+=2),b&&(this._config+=4);const c=(0,t.parse)(g),p=typeof g=="string",i=S(d=>{if(!v)for(const a of d.created){const r=C.URI.revive(a);c(r.fsPath)&&(!p||w.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!m)for(const a of d.changed){const r=C.URI.revive(a);c(r.fsPath)&&(!p||w.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!b)for(const a of d.deleted){const r=C.URI.revive(a);c(r.fsPath)&&(!p||w.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=I.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(k,w,T){const S=I.Disposable.from();if(typeof T=="string")return S;const g=k.getProxy(P.MainContext.MainThreadFileSystem);let v=!1;(T.pattern.includes(t.GLOBSTAR)||T.pattern.includes(t.GLOB_SPLIT))&&(v=!0);const m=Math.random();return g.$watch(w.identifier.value,m,T.baseUri,{recursive:v,excludes:[]}),I.Disposable.from({dispose:()=>g.$unwatch(m)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(k,w,T){this._mainContext=k,this._logService=w,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,w,T,S,g,v){return new E(this._mainContext,k,w,this._onFileSystemEvent.event,y.GlobPattern.from(T),S,g,v)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,w){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(T=>({oldUri:C.URI.revive(T.source),newUri:C.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(T=>C.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:w.map(T=>C.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,w){return(T,S,g)=>{const v=function(b){T.call(S,b)};return v.extension=k,w.event(v,void 0,g)}}async $onWillRunFileOperation(k,w,T,S){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))},T,S);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(g=>C.URI.revive(g.target))},T,S);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(g=>C.URI.revive(g.target))},T,S)}}async _fireWillEvent(k,w,T,S){const g=new Set,v=[];if(await k.fireAsync(w,S,async(b,f)=>{const c=Date.now(),p=await Promise.resolve(b);p instanceof I.WorkspaceEdit&&(v.push([f.extension,p]),g.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-c>T&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),S.isCancellationRequested||v.length===0)return;const m={edits:[]};for(const[,b]of v){const{edits:f}=y.WorkspaceEdit.from(b,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=D}),define(De[250],Ie([1,0,2,39]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(y,I,E,D,A){this._extHostNotebooks=I,this._textDocumentsAndEditors=E,this._commands=D;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(w.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(w.notebookUri),inputUri:l.URI.revive(w.inputUri),notebookEditor:T.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:l.URI.revive(w.notebookUri),inputUri:l.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(y,I,E,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:E,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=C}),define(De[251],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,y),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(De[252],Ie([1,0,2,24,15,7,64,5,8,35,17,12,145,21,6,117,97,87,51,11,18,28]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentSymbols(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(G,j);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(C.DocumentSymbol.from):i._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,pe)=>{let we=X.location.range.start.compareTo(pe.location.range.start);return we===0&&(we=pe.location.range.end.compareTo(X.location.range.end)),we});const j=[],G=[];for(const X of O){const pe={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(pe),j.push(pe);break}const we=G[G.length-1];if(D.Range.containsRange(we.range,pe.range)&&!D.Range.equalsRange(we.range,pe.range)){we.children?.push(pe),G.push(pe);break}G.pop()}}return j}}class d{constructor(O,j,G){this._documents=O,this._commands=j,this._provider=G,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(G,j);if(!X||j.isCancellationRequested)return;const pe=this._cache.add(X),we=new S.DisposableStore;this._disposables.set(pe,we);const ce={cacheId:pe,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)ce.lenses.push({cacheId:[pe,Ce],range:C.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return ce}async resolveCodeLens(O,j){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,j),X||(X=G),j.isCancellationRequested)return;const pe=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!pe)return O.command=this._commands.toInternal(X.command??d._badCmd,pe),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(ie){return Array.isArray(ie)?ie.map(C.DefinitionLink.from):ie?[C.DefinitionLink.from(ie)]:[]}class r{constructor(O,j){this._documents=O,this._provider=j}async provideDefinition(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDefinition(X,pe,G);return a(we)}}class o{constructor(O,j){this._documents=O,this._provider=j}async provideDeclaration(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDeclaration(X,pe,G);return a(we)}}class u{constructor(O,j){this._documents=O,this._provider=j}async provideImplementation(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideImplementation(X,pe,G);return a(we)}}class n{constructor(O,j){this._documents=O,this._provider=j}async provideTypeDefinition(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideTypeDefinition(X,pe,G);return a(we)}}class s{constructor(O,j){this._documents=O,this._provider=j}async provideHover(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideHover(X,pe,G);if(!(!we||(0,A.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(pe)),we.range||(we.range=new P.Range(pe,pe)),C.Hover.from(we)}}class h{constructor(O,j){this._documents=O,this._provider=j}async provideEvaluatableExpression(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideEvaluatableExpression(X,pe,G);if(we)return C.EvaluatableExpression.from(we)}}class _{constructor(O,j){this._documents=O,this._provider=j}async provideInlineValues(O,j,G,X){const pe=this._documents.getDocument(O),we=await this._provider.provideInlineValues(pe,C.Range.to(j),C.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(ce=>C.InlineValue.from(ce))}}class L{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentHighlights(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDocumentHighlights(X,pe,G);if(Array.isArray(we))return we.map(C.DocumentHighlight.from)}}class M{constructor(O,j){this._documents=O,this._provider=j}async provideLinkedEditingRanges(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideLinkedEditingRanges(X,pe,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,A.coalesce)(we.ranges.map(C.Range.from)),wordPattern:we.wordPattern}}}class U{constructor(O,j){this._documents=O,this._provider=j}async provideReferences(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideReferences(pe,we,G,X);if(Array.isArray(ce))return ce.map(C.location.from)}}class R{constructor(O,j,G,X,pe,we,ce){this._documents=O,this._commands=j,this._diagnostics=G,this._provider=X,this._logService=pe,this._extension=we,this._apiDeprecation=ce,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,j,G,X){const pe=this._documents.getDocument(O),we=w.Selection.isISelection(j)?C.Selection.to(j):C.Range.to(j),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(we.intersection(Ye.range)&&ce.push(Ye)>R._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(pe,we,Ce,X);if(!(0,A.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const We=this._cache.add(ye),qe=new S.DisposableStore;this._disposables.set(We,qe);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Ne=ye[Ye];!Ne||(R._isCommand(Ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ne.title,command:this._commands.toInternal(Ne,qe)})):(Ce.only&&(Ne.kind?Ce.only.contains(Ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[We,Ye],title:Ne.title,command:Ne.command&&this._commands.toInternal(Ne.command,qe),diagnostics:Ne.diagnostics&&Ne.diagnostics.map(C.Diagnostic.from),edit:Ne.edit&&C.WorkspaceEdit.from(Ne.edit,void 0),kind:Ne.kind&&Ne.kind.value,isPreferred:Ne.isPreferred,disabled:Ne.disabled?.reason})))}return{cacheId:We,actions:Ze}}async resolveCodeAction(O,j){const[G,X]=O,pe=this._cache.get(G,X);if(!pe||R._isCommand(pe)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(pe,j)??pe;return we?.edit?C.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}R._maxCodeActionsPerFile=1e3;class z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async prepareDocumentPaste(O,j,G,X){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(O),we=j.map(Ce=>C.Range.to(Ce)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(pe,we,ce,X),C.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=G.map(We=>C.Range.to(We)),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class H{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentFormattingEdits(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentFormattingEdits(X,j,G);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class N{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeFormattingEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Range.to(j),ce=await this._provider.provideDocumentRangeFormattingEdits(pe,we,G,X);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class V{constructor(O,j){this._documents=O,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,j,G,X,pe){const we=this._documents.getDocument(O),ce=C.Position.to(j),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,G,X,pe);if(Array.isArray(Ce))return Ce.map(C.TextEdit.from)}}class B{constructor(O,j){this._provider=O,this._logService=j,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,j){const G=await this._provider.provideWorkspaceSymbols(O,j);if(!(0,A.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),pe={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const ce=G[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}pe.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return pe}async resolveWorkspaceSymbol(O,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,j);return X&&(0,t.mixin)(O,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class F{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideRenameEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j);try{const ce=await this._provider.provideRenameEdits(pe,we,G,X);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=F._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,j,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),pe=C.Position.to(j);try{const we=await this._provider.prepareRename(X,pe,G);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=X.getText(we)):(0,k.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>pe.line||ce.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ce}}catch(we){const ce=F._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,j){this.resultId=O,this.tokens=j}}class ${constructor(O,j){this._documents=O,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=j!==0?this._previousResults.get(j):null;let we=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,pe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return pe&&this._previousResults.delete(j),we?(we=$._fixProvidedSemanticTokens(we),this._send($._convertToEdits(pe,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(j=>new P.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const j of O.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,j){if(!$._isSemanticTokens(j)||!O||!O.tokens)return j;const G=O.tokens,X=G.length,pe=j.data,we=pe.length;let ce=0;const Ce=Math.min(X,we);for(;ce<Ce&&G[ce]===pe[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],j.resultId);let ye=0;const We=Ce-ce;for(;ye<We&&G[X-ye-1]===pe[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:pe.subarray(ce,we-ye)}],j.resultId)}_send(O,j){if($._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new x(O.resultId,O.data)),(0,g.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const G=this._nextResultId++;return $._isSemanticTokens(j)?this._previousResults.set(G,new x(j.resultId,j.data)):this._previousResults.set(G,new x(O.resultId)),(0,g.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class Q{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentRangeSemanticTokens(X,C.Range.to(j),G);return pe?this._send(pe):null}_send(O){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._apiDeprecation=X,this._extension=pe,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=pe.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new b.StopWatch(!0),We=await this._provider.provideCompletionItems(pe,we,X,C.CompletionContext.to(G));if(!We||X.isCancellationRequested)return;const qe=Array.isArray(We)?new P.CompletionList(We):We,Ze=K.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Ye=new S.DisposableStore;this._disposables.set(Ze,Ye);const Ne=[],at={x:Ze,b:Ne,a:{replace:C.Range.from(ce),insert:C.Range.from(Ce)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<qe.items.length;re++){const se=qe.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,ce);Ne.push(Ee)}return at}async resolveCompletionItem(O,j){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveCompletionItem(G,j);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,j,G,X){const pe=this._disposables.get(j[0]);if(!pe)throw Error("DisposableStore is missing...");const we={x:j,a:O.label,b:O.kind!==void 0?C.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(C.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:C.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(O.command,pe)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof P.SnippetString&&(we.h=O.insertText.value,we.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),P.Range.isRange(ce)?we.j=C.Range.from(ce):ce&&(!G?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:C.Range.from(ce.inserting),replace:C.Range.from(ce.replacing)}),we}}class de{async provideInlineCompletions(O,j,G,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,j){}}class ee extends de{constructor(O,j,G,X){super(),this._extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,p.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new S.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new S.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class he extends de{constructor(O,j,G,X){super(),this.extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,p.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new S.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new S.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const j=this._idPool++;return this._references.set(j,O),j}disposeReferenceId(O){const j=this._references.get(O);return this._references.delete(O),j}get(O){return this._references.get(O)}}class me{constructor(O,j){this._documents=O,this._provider=j,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=this.reviveContext(G),Ce=await this._provider.provideSignatureHelp(pe,we,X,ce);if(Ce){const ye=this._cache.add([Ce]);return{...C.SignatureHelp.from(Ce),id:ye}}}reviveContext(O){let j;if(O.activeSignatureHelp){const G=C.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(j=X,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...O,activeSignatureHelp:j}}releaseSignatureHelp(O){this._cache.delete(O)}}class be{constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._logService=X,this._extension=pe,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,j,G){const X=this._documents.getDocument(O),pe=C.Range.to(j),we=await this._provider.provideInlayHints(X,pe,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(G.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new S.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],pe)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),Ce}async resolveInlayHint(O,j){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveInlayHint(G,j);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,j){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(j&&!j.contains(O.position))}_convertInlayHint(O,j){const G=this._disposables.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:j,tooltip:C.MarkdownString.fromStrict(O.tooltip),position:C.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(C.TextEdit.from),kind:O.kind&&C.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(pe=>{const we={label:pe.value};return we.tooltip=C.MarkdownString.fromStrict(pe.tooltip),P.Location.isLocation(pe.location)&&(we.location=C.location.from(pe.location)),pe.command&&(we.command=this._commands.toInternal(pe.command,G)),we}),X}}class ke{constructor(O,j){this._documents=O,this._provider=j,this._cache=new m.Cache("DocumentLink")}async provideLinks(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(G,j);if(!(!Array.isArray(X)||X.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(C.DocumentLink.from)};{const pe=this._cache.add(X),we={links:[],cacheId:pe};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ce=C.DocumentLink.from(X[ce]);Ce.cacheId=[pe,ce],we.links.push(Ce)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,j){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveDocumentLink(G,j);if(!(!X||!ke._validateLink(X)))return C.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Re{constructor(O,j){this._documents=O,this._provider=j}async provideColors(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(G,j);return Array.isArray(X)?X.map(we=>({color:C.Color.from(we.color),range:C.Range.from(we.range)})):[]}async provideColorPresentations(O,j,G){const X=this._documents.getDocument(O),pe=C.Range.to(j.range),we=C.Color.to(j.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:pe},G);if(!!Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ze{constructor(O,j){this._documents=O,this._provider=j}async provideFoldingRanges(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideFoldingRanges(X,j,G);if(!!Array.isArray(pe))return pe.map(C.FoldingRange.from)}}class oe{constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideSelectionRanges(O,j,G){const X=this._documents.getDocument(O),pe=j.map(C.Position.to),we=await this._provider.provideSelectionRanges(X,pe,G);if(!(0,A.isNonEmptyArray)(we))return[];if(we.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<pe.length;Ce++){const ye=[];ce.push(ye);let We=pe[Ce],qe=we[Ce];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(C.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class le{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.prepareCallHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!pe)return pe.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!pe)return pe.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=C.CallHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class ge{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new v.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.prepareTypeHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=C.TypeHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class Z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=C.Position.to(G),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(O,j){this.adapter=O,this.extension=j}}class ne{constructor(O,j,G,X,pe,we,ce,Ce){this._uriTransformer=j,this._documents=G,this._commands=X,this._diagnostics=pe,this._logService=we,this._apiDeprecation=ce,this._extensionTelemetry=Ce,this._adapter=new Map,this._proxy=O.getProxy(I.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return C.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ne._handlePool++}async _withAdapter(O,j,G,X,pe,we=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof j))return X;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(ce.adapter,ce.extension);return Promise.resolve(ye).catch(We=>{(0,f.isCancellationError)(We)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(We),this._extensionTelemetry.onExtensionError(ce.extension.identifier,We))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(pe)?(0,c.raceCancellationError)(ye,pe):ye}_addNewAdapter(O,j){const G=this._nextHandle();return this._adapter.set(G,new ae(O,j)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,j,G,X){const pe=this._addNewAdapter(new i(this._documents,G),O),we=X&&X.label||ne._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(j),we),this._createDisposable(pe)}$provideDocumentSymbols(O,j,G){return this._withAdapter(O,i,X=>X.provideDocumentSymbols(l.URI.revive(j),G),void 0,G)}registerCodeLensProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new d(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(O,j,G){return this._withAdapter(O,d,X=>X.provideCodeLenses(l.URI.revive(j),G),void 0,G)}$resolveCodeLens(O,j,G){return this._withAdapter(O,d,X=>X.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(O,j){this._withAdapter(O,d,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(O,j,G){const X=this._addNewAdapter(new r(this._documents,G),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDefinition(O,j,G,X){return this._withAdapter(O,r,pe=>pe.provideDefinition(l.URI.revive(j),G,X),[],X)}registerDeclarationProvider(O,j,G){const X=this._addNewAdapter(new o(this._documents,G),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDeclaration(O,j,G,X){return this._withAdapter(O,o,pe=>pe.provideDeclaration(l.URI.revive(j),G,X),[],X)}registerImplementationProvider(O,j,G){const X=this._addNewAdapter(new u(this._documents,G),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideImplementation(O,j,G,X){return this._withAdapter(O,u,pe=>pe.provideImplementation(l.URI.revive(j),G,X),[],X)}registerTypeDefinitionProvider(O,j,G){const X=this._addNewAdapter(new n(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideTypeDefinition(O,j,G,X){return this._withAdapter(O,n,pe=>pe.provideTypeDefinition(l.URI.revive(j),G,X),[],X)}registerHoverProvider(O,j,G,X){const pe=this._addNewAdapter(new s(this._documents,G),O);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideHover(O,j,G,X){return this._withAdapter(O,s,pe=>pe.provideHover(l.URI.revive(j),G,X),void 0,X)}registerEvaluatableExpressionProvider(O,j,G,X){const pe=this._addNewAdapter(new h(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideEvaluatableExpression(O,j,G,X){return this._withAdapter(O,h,pe=>pe.provideEvaluatableExpression(l.URI.revive(j),G,X),void 0,X)}registerInlineValuesProvider(O,j,G,X){const pe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new _(this._documents,G),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(j),pe);let ce=this._createDisposable(we);if(pe!==void 0){const Ce=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(pe));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(O,j,G,X,pe){return this._withAdapter(O,_,we=>we.provideInlineValues(l.URI.revive(j),G,X,pe),void 0,pe)}registerDocumentHighlightProvider(O,j,G){const X=this._addNewAdapter(new L(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentHighlights(O,j,G,X){return this._withAdapter(O,L,pe=>pe.provideDocumentHighlights(l.URI.revive(j),G,X),void 0,X)}registerLinkedEditingRangeProvider(O,j,G){const X=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideLinkedEditingRanges(O,j,G,X){return this._withAdapter(O,M,async pe=>{const we=await pe.provideLinkedEditingRanges(l.URI.revive(j),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,j,G){const X=this._addNewAdapter(new U(this._documents,G),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideReferences(O,j,G,X,pe){return this._withAdapter(O,U,we=>we.provideReferences(l.URI.revive(j),G,X,pe),void 0,pe)}registerCodeActionProvider(O,j,G,X){const pe=new S.DisposableStore,we=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(j),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,pe)}))},ne._extLabel(O),Boolean(G.resolveCodeAction)),pe.add(this._createDisposable(we)),pe}$provideCodeActions(O,j,G,X,pe){return this._withAdapter(O,R,we=>we.provideCodeActions(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveCodeAction(O,j,G){return this._withAdapter(O,R,X=>X.resolveCodeAction(j,G),void 0,void 0)}$releaseCodeActions(O,j){this._withAdapter(O,R,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new H(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,j,G,X){return this._withAdapter(O,H,pe=>pe.provideDocumentFormattingEdits(l.URI.revive(j),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new N(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,j,G,X,pe){return this._withAdapter(O,N,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(j),G,X,pe),void 0,pe)}registerOnTypeFormattingEditProvider(O,j,G,X){const pe=this._addNewAdapter(new V(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(j),X,O.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(O,j,G,X,pe,we){return this._withAdapter(O,V,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(j),G,X,pe,we),void 0,we)}registerWorkspaceSymbolProvider(O,j){const G=this._addNewAdapter(new B(j,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,j,G){return this._withAdapter(O,B,X=>X.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,j,G){return this._withAdapter(O,B,X=>X.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(O,j){this._withAdapter(O,B,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(O,j,G){const X=this._addNewAdapter(new F(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(j),F.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(O,j,G,X,pe){return this._withAdapter(O,F,we=>we.provideRenameEdits(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveRenameLocation(O,j,G,X){return this._withAdapter(O,F,pe=>pe.resolveRenameLocation(l.URI.revive(j),G,X),void 0,X)}registerDocumentSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new $(this._documents,G),O),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(j),X,we);let ce=this._createDisposable(pe);if(we){const Ce=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(O,j,G,X){return this._withAdapter(O,$,pe=>pe.provideDocumentSemanticTokens(l.URI.revive(j),G,X),null,X)}$releaseDocumentSemanticTokens(O,j){this._withAdapter(O,$,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new Q(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(j),X),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(O,j,G,X){return this._withAdapter(O,Q,pe=>pe.provideDocumentRangeSemanticTokens(l.URI.revive(j),G,X),null,X)}registerCompletionItemProvider(O,j,G,X){const pe=this._addNewAdapter(new K(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(j),X,K.supportsResolving(G),`${O.identifier.value}(${X.join("")})`),this._createDisposable(pe)}$provideCompletionItems(O,j,G,X,pe){return this._withAdapter(O,K,we=>we.provideCompletionItems(l.URI.revive(j),G,X,pe),void 0,pe)}$resolveCompletionItem(O,j,G){return this._withAdapter(O,K,X=>X.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(O,j){this._withAdapter(O,K,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(O,j,G){const X=new ee(O,this._documents,G,this._commands.converter),pe=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(pe,this._transformDocumentSelector(j),X.supportsHandleDidShowCompletionItem),this._createDisposable(pe)}registerInlineCompletionsProviderNew(O,j,G){const X=this._addNewAdapter(new he(O,this._documents,G,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(j),!0),this._createDisposable(X)}$provideInlineCompletions(O,j,G,X,pe){return this._withAdapter(O,de,we=>we.provideInlineCompletions(l.URI.revive(j),G,X,pe),void 0,pe)}$handleInlineCompletionDidShow(O,j,G){this._withAdapter(O,de,async X=>{X.handleDidShowCompletionItem(j,G)},void 0,void 0)}$freeInlineCompletionsList(O,j){this._withAdapter(O,de,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(O,j,G,X){const pe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new me(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(j),pe),this._createDisposable(we)}$provideSignatureHelp(O,j,G,X,pe){return this._withAdapter(O,me,we=>we.provideSignatureHelp(l.URI.revive(j),G,X,pe),void 0,pe)}$releaseSignatureHelp(O,j){this._withAdapter(O,me,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(O,j,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(j),typeof G.resolveInlayHint=="function",X,ne._extLabel(O));let we=this._createDisposable(pe);if(X!==void 0){const ce=G.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(O,j,G,X){return this._withAdapter(O,be,pe=>pe.provideInlayHints(l.URI.revive(j),G,X),void 0,X)}$resolveInlayHint(O,j,G){return this._withAdapter(O,be,X=>X.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(O,j){this._withAdapter(O,be,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(O,j,G){const X=this._addNewAdapter(new ke(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(j),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,j,G){return this._withAdapter(O,ke,X=>X.provideLinks(l.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(O,j,G){return this._withAdapter(O,ke,X=>X.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(O,j){this._withAdapter(O,ke,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(O,j,G){const X=this._addNewAdapter(new Re(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentColors(O,j,G){return this._withAdapter(O,Re,X=>X.provideColors(l.URI.revive(j),G),[],G)}$provideColorPresentations(O,j,G,X){return this._withAdapter(O,Re,pe=>pe.provideColorPresentations(l.URI.revive(j),G,X),void 0,X)}registerFoldingRangeProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(O,j,G,X){return this._withAdapter(O,ze,pe=>pe.provideFoldingRanges(l.URI.revive(j),G,X),void 0,X)}registerSelectionRangeProvider(O,j,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideSelectionRanges(O,j,G,X){return this._withAdapter(O,oe,pe=>pe.provideSelectionRanges(l.URI.revive(j),G,X),[],X)}registerCallHierarchyProvider(O,j,G){const X=this._addNewAdapter(new le(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareCallHierarchy(O,j,G,X){return this._withAdapter(O,le,pe=>Promise.resolve(pe.prepareSession(l.URI.revive(j),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsTo(j,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsFrom(j,G,X),void 0,X)}$releaseCallHierarchy(O,j){this._withAdapter(O,le,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(O,j,G){const X=this._addNewAdapter(new ge(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareTypeHierarchy(O,j,G,X){return this._withAdapter(O,ge,pe=>Promise.resolve(pe.prepareSession(l.URI.revive(j),G,X)),void 0,X)}$provideTypeHierarchySupertypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSupertypes(j,G,X),void 0,X)}$provideTypeHierarchySubtypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSubtypes(j,G,X),void 0,X)}$releaseTypeHierarchy(O,j){this._withAdapter(O,ge,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(O,j,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,j,G,X,pe,we){return this._withAdapter(O,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(j,l.URI.revive(G),X,pe,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,j,G,X){const pe=this._nextHandle();return this._adapter.set(pe,new ae(new z(this._proxy,this._documents,G,pe),O)),this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(j),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(pe)}$prepareDocumentPaste(O,j,G,X,pe){return this._withAdapter(O,z,we=>we.prepareDocumentPaste(l.URI.revive(j),G,X,pe),void 0,pe)}$providePasteEdits(O,j,G,X,pe,we){return this._withAdapter(O,z,ce=>ce.providePasteEdits(j,l.URI.revive(G),X,pe,we),void 0,we)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,E.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ne._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ne._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ne._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ne._serializeRegExp(O.beforeText),afterText:O.afterText?ne._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ne._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ne._serializeOnEnterRule)}setLanguageConfiguration(O,j,G){const{wordPattern:X}=G;if(X&&(0,E.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(j,X):this._documents.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const pe=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ne._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ne._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ne._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,j,we),this._createDisposable(pe)}$setWordDefinitions(O){for(const j of O)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(De[253],Ie([1,0,5,15,7,42,18,6]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(A,k,w,T){this._documents=k,this._commands=w,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,k){await this._proxy.$changeLanguage(A,k);const w=this._documents.getDocumentData(A);if(!w)throw new Error(`document '${A.toString()}' NOT found`);return w.document}async tokenAtPosition(A,k){const w=A.version,T=t.Position.from(k),S=await this._proxy.$tokensAtPosition(A.uri,T),g={type:C.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!S)return g;const v={range:t.Range.to(S.range),type:t.TokenType.to(S.type)};return!v.range.contains(k)||w!==A.version?g:v}createLanguageStatusItem(A,k,w){const T=this._handlePool++,S=this._proxy,g=this._ids,v=`${A.identifier.value}/${k}`;if(g.has(v))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);g.add(v);const m={selector:w,id:k,name:A.displayName??A.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const f=new I.DisposableStore,c=()=>{b?.dispose(),b=(0,y.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(T,{id:v,name:m.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(m.selector,this._uriTransformer),label:m.text,detail:m.detail??"",severity:m.severity===C.LanguageStatusSeverity.Error?P.default.Error:m.severity===C.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:m.command&&this._commands.toInternal(m.command,f),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},p={dispose(){f.dispose(),b?.dispose(),S.$removeLanguageStatus(T),g.delete(v)},get id(){return m.id},get name(){return m.name},set name(i){m.name=i,c()},get selector(){return m.selector},set selector(i){m.selector=i,c()},get text(){return m.text},set text(i){m.text=i,c()},get detail(){return m.detail},set detail(i){m.detail=i,c()},get severity(){return m.severity},set severity(i){m.severity=i,c()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(i){m.accessibilityInformation=i,c()},get command(){return m.command},set command(i){m.command=i,c()},get busy(){return m.busy},set busy(i){m.busy=i,c()}};return c(),p}}e.ExtHostLanguages=E}),define(De[93],Ie([1,0,10,8,2,4,13,5,25,16]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(w,T,S){this.logService=S,this.bundleCache=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadLocalization),this.currentLanguage=w.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===l.LANGUAGE_DEFAULT}getMessage(w,T){const{message:S,args:g,comment:v}=T;if(this.isDefaultLanguage)return(0,t.format2)(S,g??{});let m=S;v&&v.length>0&&(m+=`/${Array.isArray(v)?v.join():v}`);const b=this.bundleCache.get(w)?.contents[m];return b||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(b??m,g??{})}getBundle(w){return this.bundleCache.get(w)?.contents}getBundleUri(w){return this.bundleCache.get(w)?.uri}async initializeLocalizedMessages(w){if(this.isDefaultLanguage||!w.l10n&&!w.isBuiltin||this.bundleCache.has(w.identifier.value))return;let T;const S=await this.getBundleLocation(w);if(!S){this.logService.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const g=await this._proxy.$fetchBundleContents(S),v=JSON.parse(g);T=w.isBuiltin?v.contents?.bundle:v}catch(g){this.logService.error(`Failed to load translations for ${w.identifier.value} from ${S}: ${g.message}`);return}T&&this.bundleCache.set(w.identifier.value,{contents:T,uri:S})}async getBundleLocation(w){if(w.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(w.identifier.value);return C.URI.revive(T)}return w.l10n?C.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=je([$e(0,E.IExtHostInitDataService),$e(1,D.IExtHostRpcService),$e(2,y.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(De[137],Ie([1,0,13,5,25,16,2,3,12]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends l.AbstractLoggerService{constructor(w,T){super(T.logLevel,I.Event.None),this._proxy=w.getProxy(t.MainContext.MainThreadLogger)}$setLevel(w,T){T?this.setLevel(y.URI.revive(T),w):(0,E.isUndefined)(w)||this.setLevel(w)}doCreateLogger(w,T,S){return new A(this._proxy,w,T,S)}};D=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class A extends l.AbstractMessageLogger{constructor(w,T,S,g){super(g?.always),this.proxy=w,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(T,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,T){const S=[[w,T]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(w){this.proxy.$log(this.file,w)}}}),define(De[254],Ie([1,0,5,13,28]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let y=class{constructor(E,D){this._logService=D,this._proxy=E.getProxy(l.MainContext.MainThreadMessageService)}showMessage(E,D,A,k,w){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof k=="string"||P(k)?S=[k,...w]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,S=w),T.useCustom&&(0,C.checkProposedApiEnabled)(E,"resolvers");const g=[];for(let v=0;v<S.length;v++){const m=S[v];if(typeof m=="string")g.push({title:m,handle:v,isCloseAffordance:!1});else if(typeof m=="object"){const{title:b,isCloseAffordance:f}=m;g.push({title:b,isCloseAffordance:!!f,handle:v})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(D,A,T,g).then(v=>{if(typeof v=="number")return S[v]})}};y=je([$e(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(De[255],Ie([1,0,23,3,6,26,8,12,2,87,5,39,15,7,56,230,133]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}constructor(f,c,p,i){this._textDocumentsAndEditors=p,this._textDocuments=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=f.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const a=d.notebookEditor?.notebookUri,r=d.cell.handle,u=this._documents.get(a)?.getCell(r);if(u)return u.apiCell}return d}}),m._registerApiCommands(c)}getEditorById(f){const c=this._editors.get(f);if(!c)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(f){for(const[c,p]of this._editors)if(p.apiEditor===f)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,c){const p=this._documents.get(f);if(!p&&!c)throw new Error(`NO notebook document for '${f}'`);return p}_getProviderData(f){const c=this._notebookContentProviders.get(f);if(!c)throw new Error(`NO provider for '${f}'`);return c}registerNotebookContentProvider(f,c,p,i,d){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:f,provider:p}),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},c,w.NotebookDocumentContentOptions.from(i),m._convertNotebookRegistrationData(f,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(f,c){if(!c)return;const p=c.filenamePattern.map(i=>w.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(c.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:c.displayName,filenamePattern:p,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,c,p){const i=m._notebookStatusBarItemProviderHandlePool++,d=typeof p.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,d,c);let a;return d!==void 0&&(a=p.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,d),a?.dispose()})}async createNotebookDocument(f){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&w.NotebookData.from(f.content)});return E.URI.revive(c)}async openNotebookDocument(f){const c=this._documents.get(f);if(c)return c.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(f),i=this._documents.get(E.URI.revive(p));return(0,I.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(f,c){E.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let p;typeof c=="object"?p={position:w.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(w.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:p={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,p),d=i&&this._editors.get(i)?.apiEditor;if(d)return d;throw i?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,c,p,i){const d=this._notebookStatusBarItemProviders.get(f),a=E.URI.revive(c),r=this._documents.get(a);if(!r||!d)return;const o=r.getCellFromIndex(p);if(!o)return;const u=await d.provideCellStatusBarItems(o.apiCell,i);if(!u)return;const n=new C.DisposableStore,s=this._statusBarCache.add([n]),_=(Array.isArray(u)?u:[u]).map(L=>w.NotebookStatusBarItem.from(L,this._commandsConverter,n));return{cacheId:s,items:_}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,c,p,i,d){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,p),this._notebookProxy.$registerNotebookSerializer(a,{id:f.identifier,location:f.extensionLocation},c,w.NotebookDocumentContentOptions.from(i),m._convertNotebookRegistrationData(f,d)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(f,c,p){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const d=await i.deserializeNotebook(c.buffer,p);return new S.SerializableObjectWithBuffers(w.NotebookData.from(d))}async $notebookToData(f,c,p){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const d=await i.serializeNotebook(w.NotebookData.to(c.value),p);return l.VSBuffer.wrap(d)}async $openNotebook(f,c,p,i,d){const{provider:a}=this._getProviderData(f),r=await a.openNotebook(E.URI.revive(c),{backupId:p,untitledDocumentData:i?.buffer},d);return new S.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(w.NotebookCellData.from)})}_createExtHostEditor(f,c,p){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const i=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,f,p.visibleRanges.map(w.NotebookRange.to),p.selections.map(w.NotebookRange.to),typeof p.viewColumn=="number"?w.ViewColumn.to(p.viewColumn):void 0);this._editors.set(c,i)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const p of f.value.removedDocuments){const i=E.URI.revive(p),d=this._documents.get(i);d&&(d.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(f.value.addedDocuments){const p=[];for(const i of f.value.addedDocuments){const d=E.URI.revive(i.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const a=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,i);p.push(...i.cells.map(r=>g.ExtHostCell.asModelAddData(a.apiNotebook,r))),this._documents.get(d)?.dispose(),this._documents.set(d,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(f.value.addedEditors)for(const p of f.value.addedEditors){if(this._editors.has(p.id))return;const i=E.URI.revive(p.documentUri),d=this._documents.get(i);d&&this._createExtHostEditor(d,p.id,p)}const c=[];if(f.value.removedEditors)for(const p of f.value.removedEditors){const i=this._editors.get(p);i&&(this._editors.delete(p),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),c.push(i))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const p=new Set;this._visibleNotebookEditors.forEach(i=>p.add(i.id));for(const i of this._editors.values()){const d=p.has(i.id);i._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(f){const c=k.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new k.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>l.VSBuffer.wrap(d))],new k.ApiCommandResult("Notebook Data",d=>w.NotebookData.to(d.value))),i=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new S.SerializableObjectWithBuffers(w.NotebookData.from(d)))],new k.ApiCommandResult("Bytes",d=>d.buffer));f.registerApiCommand(p),f.registerApiCommand(i)}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0}),define(De[256],Ie([1,0,17,18,21,3,6,26,2,27,13,5,39,15,7,88,218,28,56]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(r,o,u,n,s){this._initData=o,this._extHostNotebook=u,this._commands=n,this._logService=s,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(k.MainContext.MainThreadNotebookKernels);const h=new w.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const L=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:L}}else if(_&&"notebookEditor"in _){const L=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return _})],w.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(r,o,u,n,s,h){for(const K of this._kernelData.values())if(K.controller.id===o&&D.ExtensionIdentifier.equals(r.identifier,K.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const _=this._handlePool++,L=this;this._logService.trace(`NotebookController[${_}], CREATED by ${r.identifier.value}, ${o}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${r.identifier}'`);let U=!1;const R=new y.DisposableStore,z=new P.Emitter,H=new P.Emitter,N={id:d(r.identifier,o),notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:n||r.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let V=s??M,B;this._proxy.$addKernel(_,N).catch(K=>{console.log(K),U=!0});let F=0;const x=()=>{if(U)return;const K=++F;Promise.resolve().then(()=>{K===F&&this._proxy.$updateKernel(_,N)})},$=new I.ResourceMap,Q={get id(){return o},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(K){N.label=K??r.displayName??r.name,x()},get detail(){return N.detail??""},set detail(K){N.detail=K,x()},get description(){return N.description??""},set description(K){N.description=K,x()},get kind(){return(0,m.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind??""},set kind(K){(0,m.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind=K,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(K){N.supportedLanguages=K,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(K){N.supportsExecutionOrder=K,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(K){V=K??M},get interruptHandler(){return B},set interruptHandler(K){B=K,N.supportsInterrupt=Boolean(K),x()},createNotebookCellExecution(K){if(U)throw new Error("notebook controller is DISPOSED");if(!$.has(K.notebook.uri))throw L._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return L._createNotebookCellExecution(K,d(r.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${_}], DISPOSED`),U=!0,this._kernelData.delete(_),R.dispose(),z.dispose(),H.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(K,de){de===S.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(_,K.uri,de)},onDidReceiveMessage:H.event,postMessage(K,de){return(0,m.checkProposedApiEnabled)(r,"notebookMessaging"),L._proxy.$postMessage(_,de&&L._extHostNotebook.getIdByEditor(de),K)},asWebviewUri(K){return(0,m.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(K,L._initData.remote)}};return this._kernelData.set(_,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:H,onDidChangeSelection:z,associatedNotebooks:$}),Q}getIdByController(r){for(const[o,u]of this._kernelData)if(u.controller===r)return d(u.extensionId,r.id);return null}$acceptNotebookAssociation(r,o,u){const n=this._kernelData.get(r);if(n){const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));u?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,s.uri.toString(),u),n.onDidChangeSelection.fire({selected:u,notebook:s.apiNotebook})}}async $executeCells(r,o,u){const n=this._kernelData.get(r);if(!n)return;const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(o)),h=[];for(const _ of u){const L=s.getCell(_);L&&h.push(L.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,s.uri.toString(),h.length),await n.controller.executeHandler.call(n.controller,h,s.apiNotebook,n.controller)}catch(_){this._logService.error(`NotebookController[${r}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(r,o,u){const n=this._kernelData.get(r);if(!n)return;const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,s.apiNotebook);else for(const h of u){const _=s.getCell(h);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,o,u){const n=this._kernelData.get(r);if(!n)return;const s=this._extHostNotebook.getEditorById(o);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:u}))}$cellExecutionChanged(r,o,u){const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)).getCell(o);if(s){const h=u?T.NotebookCellExecutionState.to(u):S.NotebookCellExecutionState.Idle;h!==void 0&&this._onDidChangeCellExecutionState.fire({cell:s.apiCell,state:h})}}_createNotebookCellExecution(r,o){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const s=new p(o,n,this._proxy);this._activeExecutions.set(n.uri,s);const h=s.onDidChangeState(()=>{s.state===c.Resolved&&(s.dispose(),h.dispose(),this._activeExecutions.delete(n.uri))});return s.asApiObject()}};f=je([$e(4,A.ILogService)],f),e.ExtHostNotebookKernels=f;var c;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(c||(c={}));class p extends y.Disposable{get state(){return this._state}constructor(r,o,u){super(),this._cell=o,this._proxy=u,this._handle=p.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new i(10,n=>this.update(n)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,r,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const o=Array.isArray(r)?r:[r];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let o=this._cell;if(r&&(o=this._cell.notebook.getCellFromApiCell(r)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(r){return r.map(o=>{const u=S.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return u===o.items?T.NotebookCellOutput.from(o):T.NotebookCellOutput.from({items:u,id:o.id,metadata:o.metadata})})}async updateOutputs(r,o,u){const n=this.cellIndexToHandle(o),s=this.validateAndConvertOutputs((0,l.asArray)(r));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,cellHandle:n,append:u,outputs:s})}async updateOutputItems(r,o,u){return r=S.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(r),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:r.map(T.NotebookCellOutputItem.from),outputId:o.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:r._executionOrder}])},start(u){if(r._state===c.Resolved||r._state===c.Started)throw new Error("Cannot call start again");r._state=c.Started,r._onDidChangeState.fire(),r.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,n){if(r._state===c.Resolved)throw new Error("Cannot call resolve twice");r._state=c.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._handle,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:u}))},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,n){return r.verifyStateForOutput(),r.updateOutputs(u,n,!0)},replaceOutput(u,n){return r.verifyStateForOutput(),r.updateOutputs(u,n,!1)},appendOutputItems(u,n){return r.verifyStateForOutput(),r.updateOutputItems(u,n,!0)},replaceOutputItems(u,n){return r.verifyStateForOutput(),r.updateOutputItems(u,n,!1)}})}}p.HANDLE=0;class i{constructor(r,o){this.delay=r,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>r.complete())}}function d(a,r){return`${a.value}/${r}`}e.createKernelId=d}),define(De[257],Ie([1,0,3,5,133]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(I,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,E,D){const A=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(E)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(I,E){if(!I.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,k,w)=>this.getOrCreateEmitterFor(E).event(A,k,w),postMessage:(A,k)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const w=k&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(w?.id,E,A)}}}getOrCreateEmitterFor(I){let E=this._rendererMessageEmitters.get(I);return E||(E=new l.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,E),E)}}e.ExtHostNotebookRenderers=P}),define(De[258],Ie([1,0,21,3,6,5,2,7,11,17,42,86]),function(J,e,l,t,C,P,y,I,E,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(T,S,g){const v=T.getProxy(P.MainContext.MainThreadQuickOpen);class m{constructor(o,u){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=u}showQuickPick(o,u,n=l.CancellationToken.None){this._onDidSelectItem=void 0;const s=Promise.resolve(o),h=++this._instances,_=v.$show(h,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),L={},M=_.then(()=>L);return Promise.race([M,s]).then(U=>{if(U!==L)return s.then(R=>{const z=[];for(let H=0;H<R.length;H++){const N=R[H];typeof N=="string"?z.push({label:N,handle:H}):N.kind===I.QuickPickItemKind.Separator?z.push({type:"separator",label:N.label}):z.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:H})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{u.onDidSelectItem(R[H])}),v.$setItems(h,z),_.then(H=>{if(typeof H=="number")return R[H];if(Array.isArray(H))return H.map(N=>R[N])})})}).then(void 0,U=>{if(!(0,E.isCancellationError)(U))return v.$setError(h,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,u=l.CancellationToken.None){return this._validateInput=o?.validateInput,v.$input(o,typeof this._validateInput=="function",u).then(void 0,n=>{if(!(0,E.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(o){if(!this._validateInput)return;const u=await this._validateInput(o);if(!u||typeof u=="string")return u;let n;switch(u.severity){case I.InputBoxValidationSeverity.Info:n=A.default.Info;break;case I.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case I.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=u.message?A.default.Error:A.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(o,u=l.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!n)return;const s=await this._workspace.getWorkspaceFolders2();if(!!s)return s.find(h=>h.uri.toString()===n.uri.toString())}createQuickPick(o){const u=new d(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(o){const u=new a(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(o,u){this._sessions.get(o)?._fireDidChangeValue(u)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,u){const n=this._sessions.get(o);n instanceof d&&n._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const n=this._sessions.get(o);n instanceof d&&n._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){this._sessions.get(o)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(o,u,n){const s=this._sessions.get(o);s instanceof d&&s._fireDidTriggerItemButton(u,n)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class b{constructor(o,u){this._extensionId=o,this._onDidDispose=u,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((u,n)=>{const s=u===I.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(s,u)}),this.update({buttons:o.map((u,n)=>({...i(u),tooltip:u.tooltip,handle:u===I.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const u=this._handlesToButtons.get(o);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(o){if(!this._disposed){for(const u of Object.keys(o)){const n=o[u];this._pendingUpdate[u]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function f(r){if(r instanceof I.ThemeIcon)return{id:r.id};const o=p(r),u=c(r);return{dark:typeof o=="string"?y.URI.file(o):o,light:typeof u=="string"?y.URI.file(u):u}}function c(r){return typeof r=="object"&&"light"in r?r.light:r}function p(r){return typeof r=="object"&&"dark"in r?r.dark:r}function i(r){const o=f(r.iconPath);let u,n;return"id"in o?n=k.ThemeIcon.asClassName(o):u=o,{iconPath:u,iconClass:n}}class d extends b{constructor(o,u){super(o.identifier,u),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((n,s)=>{this._handlesToItems.set(s,n),this._itemsToHandles.set(n,s)});const u=[];for(let n=0;n<o.length;n++){const s=o[n];s.kind===I.QuickPickItemKind.Separator?u.push({type:"separator",label:s.label}):u.push({handle:n,label:s.label,description:s.description,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow,buttons:s.buttons?.map((h,_)=>({...i(h),tooltip:h.tooltip,handle:_}))})}this.update({items:u})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(o){const u=(0,D.coalesce)(o.map(n=>this._handlesToItems.get(n)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(o){const u=(0,D.coalesce)(o.map(n=>this._handlesToItems.get(n)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(o,u){const n=this._handlesToItems.get(o);if(!n||!n.buttons||!n.buttons.length)return;const s=n.buttons[u];s&&this._onDidTriggerItemButtonEmitter.fire({button:s,item:n})}}class a extends b{constructor(o,u){super(o.identifier,u),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:A.default.Error}):this.update({validationMessage:o.message,severity:o.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new m(S,g)}e.createExtHostQuickOpen=w});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l};define(De[259],Ie([1,0,2,3,59,6,18,5,17,107,13,27,86,15,28]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S){"use strict";var g,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(s){if(s)return typeof s.iconPath=="string"?l.URI.file(s.iconPath):l.URI.isUri(s.iconPath)||w.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function b(s,h){if(!s.iconPath&&!h.iconPath)return 0;if(s.iconPath){if(!h.iconPath)return 1}else return-1;const _=typeof s.iconPath=="string"?s.iconPath:l.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,L=typeof h.iconPath=="string"?h.iconPath:l.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,D.comparePaths)(_,L)}function f(s,h){let _=0;if(s.strikeThrough!==h.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==h.faded)return s.faded?1:-1;if(s.tooltip!==h.tooltip)return(s.tooltip||"").localeCompare(h.tooltip||"");if(_=b(s,h),_!==0)return _;if(s.light&&h.light)_=b(s.light,h.light);else{if(s.light)return 1;if(h.light)return-1}if(_!==0)return _;if(s.dark&&h.dark)_=b(s.dark,h.dark);else{if(s.dark)return 1;if(h.dark)return-1}return _}function c(s,h){if(s.command!==h.command)return s.command<h.command?-1:1;if(s.title!==h.title)return s.title<h.title?-1:1;if(s.tooltip!==h.tooltip){if(s.tooltip!==void 0&&h.tooltip!==void 0)return s.tooltip<h.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(s.arguments===h.arguments)return 0;if(s.arguments)if(h.arguments){if(s.arguments.length!==h.arguments.length)return s.arguments.length-h.arguments.length}else return 1;else return-1;for(let _=0;_<s.arguments.length;_++){const L=s.arguments[_],M=h.arguments[_];if(L!==M)return L<M?-1:1}return 0}function p(s,h){let _=(0,D.comparePaths)(s.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(_!==0)return _;if(s.command&&h.command)_=c(s.command,h.command);else{if(s.command)return 1;if(h.command)return-1}if(_!==0)return _;if(s.decorations&&h.decorations)_=f(s.decorations,h.decorations);else{if(s.decorations)return 1;if(h.decorations)return-1}return _}function i(s,h){for(let _=0;_<s.length;_++)if(s[_]!==h[_])return!1;return!0}function d(s,h){return s.command===h.command&&s.title===h.title&&s.tooltip===h.tooltip&&(s.arguments&&h.arguments?i(s.arguments,h.arguments):s.arguments===h.arguments)}function a(s,h){return(0,E.equals)(s,h,d)}class r{get value(){return this._value}set value(h){h=h??"",Be(this,g,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Be(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Be(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Be(this,g,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Be(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}constructor(h,_,L){this._extension=h,this._sourceControlHandle=L,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,g,_,"f")}showValidationMessage(h,_){(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),Be(this,g,"f").$showValidationMessage(this._sourceControlHandle,h,_)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=r,g=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}constructor(h,_,L,M,U){this._proxy=h,this._commands=_,this._sourceControlHandle=L,this._id=M,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,_){const L=this._resourceStatesCommandsMap.get(h);return L?(0,y.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(p),L=(0,E.sortedDiff)(this._resourceSnapshot,h,p).map(R=>{const z=R.toInsert.map(H=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,H);const V=H.resourceUri;let B;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const me=new P.DisposableStore;B=this._commands.converter.toInternal(H.command,me),this._resourceStatesDisposablesMap.set(N,me)}else this._resourceStatesCommandsMap.set(N,H.command);const F=m(H.decorations),x=H.decorations&&m(H.decorations.light)||F,$=H.decorations&&m(H.decorations.dark)||F,Q=[x,$],K=H.decorations&&H.decorations.tooltip||"",de=H.decorations&&!!H.decorations.strikeThrough,ee=H.decorations&&!!H.decorations.faded,he=H.contextValue||"";return{rawResource:[N,V,Q,K,de,ee,he,B],handle:N}});return{start:R.start,deleteCount:R.deleteCount,toInsert:z}}),M=L.map(({start:R,deleteCount:z,toInsert:H})=>[R,z,H.map(N=>N.rawResource)]),U=L.reverse();for(const{start:R,deleteCount:z,toInsert:H}of U){const N=H.map(B=>B.handle),V=this._handlesSnapshot.splice(R,z,...N);for(const B of V)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=h,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class u{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Be(this,v,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Be(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Be(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=h;const _=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Be(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=h;const _=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(L=>L.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Be(this,v,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&a(this._statusBarCommands,h))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=h;const _=(h||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Be(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}constructor(h,_,L,M,U,R){this._extension=h,this._commands=L,this._id=M,this._label=U,this._rootUri=R,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,v,_,"f"),this._inputBox=new r(h,Be(this,v,"f"),this.handle),Be(this,v,"f").$registerSourceControl(this.handle,M,U,R)}createResourceGroup(h,_){const L=new o(Be(this,v,"f"),this._commands,this.handle,h,_),M=t.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,M),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const h=[],_=[];for(const[L,M]of this.createdResourceGroups){M.dispose();const U=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),U.dispose(),this._groups.delete(L.handle),Be(this,v,"f").$unregisterGroup(this.handle,L.handle)}),h.push([L.handle,L.id,L.label,L.features]);const R=L._takeResourceStateSnapshot();R.length>0&&_.push([L.handle,R]),this._groups.set(L.handle,L)}Be(this,v,"f").$registerGroups(this.handle,h,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(_=>{const L=_._takeResourceStateSnapshot();L.length!==0&&h.push([_.handle,L])}),h.length>0&&Be(this,v,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Be(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,u._handlePool=0,je([(0,C.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class Zn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(h,_,L){this._commands=_,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(I.MainContext.MainThreadSCM),this._telemetry=h.getProxy(I.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const U=this._sourceControls.get(M.sourceControlHandle);if(!U)return M;const R=U.getResourceGroup(M.groupHandle);return R?R.getResourceState(M.handle):M}else if(M&&M.$mid===4){const U=this._sourceControls.get(M.sourceControlHandle);return U?U.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const U=this._sourceControls.get(M.handle);return U||M}return M}})}createSourceControl(h,_,L,M){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,_,L,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const U=Zn._handlePool++,R=new u(h,this._proxy,this._commands,_,L,M);this._sourceControls.set(U,R);const z=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return z.push(R),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),z),R}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const _=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),L=_&&_[_.length-1];return L&&L.inputBox}$provideOriginalResource(h,_,L){const M=l.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,M.toString());const U=this._sourceControls.get(h);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(M,L)).then(R=>R||null)}$onInputBoxValueChange(h,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const L=this._sourceControls.get(h);return L&&L.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(h,_,L,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,_,L);const U=this._sourceControls.get(h);if(!U)return Promise.resolve(void 0);const R=U.getResourceGroup(_);return R?R.$executeResourceCommand(L,M):Promise.resolve(void 0)}$validateInput(h,_,L){this.logService.trace("ExtHostSCM#$validateInput",h);const M=this._sourceControls.get(h);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>M.inputBox.validateInput(_,L)).then(U=>{if(!U)return Promise.resolve(void 0);const R=T.MarkdownString.fromStrict(U.message);return R?Promise.resolve([R,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};n._handlePool=0,n=je([$e(2,A.ILogService)],n),e.ExtHostSCM=n}),define(De[94],Ie([1,0,5,3,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,E){return this._proxy.$getPassword(I,E)}store(I,E,D){return this._proxy.$setPassword(I,E,D)}delete(I,E){return this._proxy.$deletePassword(I,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[260],Ie([1,0,7,5,173,6,15,12]),function(J,e,l,t,C,P,y,I){"use strict";var E,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(S,g,v,m,b=l.StatusBarAlignment.Left,f){E.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,E,S,"f"),tt(this,D,g,"f"),this._entryId=A.ID_GEN++,this._extension=v,this._id=m,this._alignment=b,this._priority=this.validatePriority(f)}validatePriority(S){if(!!(0,I.isNumber)(S))return S===Number.POSITIVE_INFINITY?Number.MAX_VALUE:S===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(S){this._text=S,this.update()}set name(S){this._name=S,this.update()}set tooltip(S){this._tooltip=S,this.update()}set color(S){this._color=S,this.update()}set backgroundColor(S){S&&!A.ALLOWED_BACKGROUND_COLORS.has(S.id)&&(S=void 0),this._backgroundColor=S,this.update()}set command(S){this._command?.fromApi!==S&&(this._internalCommandRegistration.clear(),typeof S=="string"?this._command={fromApi:S,internal:Be(this,D,"f").toInternal({title:"",command:S},this._internalCommandRegistration)}:S?this._command={fromApi:S,internal:Be(this,D,"f").toInternal(S,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(S){this._accessibilityInformation=S,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let S;this._extension?this._id?S=`${this._extension.identifier.value}.${this._id}`:S=this._extension.identifier.value:S=this._id;let g;this._name?g=this._name:g=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const m=y.MarkdownString.fromStrict(this._tooltip);Be(this,E,"f").$setEntry(this._entryId,S,g,this._text,m,this._command?.internal,v,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,E=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(S){this._messages=[],this._item=S.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(S){const g={message:S};return this._messages.unshift(g),this._update(),new l.Disposable(()=>{const v=this._messages.indexOf(g);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class w{constructor(S,g){this._proxy=S.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(S,g,v,m){return new A(this._proxy,this._commands,S,g,v,m)}setStatusBarMessage(S,g){const v=this._statusMessage.setMessage(S);let m;return typeof g=="number"?m=setTimeout(()=>v.dispose(),g):typeof g<"u"&&g.then(()=>v.dispose(),()=>v.dispose()),new l.Disposable(()=>{v.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=w}),define(De[95],Ie([1,0,5,3,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,E){this._proxy.$registerExtensionStorageKeysToSync(I,E)}initializeExtensionStorage(I,E,D){return this._proxy.$initializeExtensionStorage(I,E).then(A=>A||D)}setValue(I,E,D){return this._proxy.$setValue(I,E,D)}$acceptValue(I,E,D){this._onDidChangeStorage.fire({shared:I,key:E,value:D})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(De[69],Ie([1,0,4,25,13,68,2]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let I=class{constructor(D,A,k){this._logService=A,this._extHostFileSystem=k,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(w=>this._value=w)}async _getWorkspaceStorageURI(D){return y.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,A=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this._value)return y.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return y.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([$e(0,t.IExtHostInitDataService),$e(1,C.ILogService),$e(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(De[40],Ie([1,0,3,5,4,2,16,6,7,174,11,219,21,31,204,86,12,18,15]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class f{constructor(n,s,h,_){this._proxy=n,this._id=s,this._creationOptions=h,this._name=_,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(M,U=!0){L._checkDisposed(),L._proxy.$sendText(L._id,M,U)},show(M){L._checkDisposed(),L._proxy.$show(L._id,M)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(n,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,v.withNullAsUndefined)(n.shellPath),shellArgs:(0,v.withNullAsUndefined)(n.shellArgs),cwd:(0,v.withNullAsUndefined)(n.cwd),env:(0,v.withNullAsUndefined)(n.env),icon:(0,v.withNullAsUndefined)(r(n.iconPath)),color:g.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,v.withNullAsUndefined)(n.message),strictEnv:(0,v.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(n.location,s?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,s,h,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:g.ThemeColor.isThemeColor(_)?_.id:void 0,location:this._serializeParentTerminal(n,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,s){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,s){this._exitStatus=Object.freeze({code:n,reason:s})}setDimensions(n,s){return n===this._cols&&s===this._rows||n===0||s===0?!1:(this._cols=n,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=f;class c{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,s){this._pty.setDimensions?.({columns:n,rows:s})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let p=1,i=class extends I.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,s){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new l.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new S.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[h,_]of this._terminalProcesses)_.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,s){const h=new f(this._proxy,(0,T.generateUuid)(),n,n.name),_=new c(n.pty);return h.createExtensionTerminal(n.location,this._serializeParentTerminal(n,s).resolvedExtHostIdentifier,r(n.iconPath),o(n.color)).then(L=>{const M=this._setupExtHostProcessListeners(L,_);this._terminalProcessDisposables[L]=M}),this._terminals.push(h),h.value}_serializeParentTerminal(n,s){if(s=s||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const h=n.location.parentTerminal;if(h){const _=this._terminals.find(L=>L.value===h);_&&(s.resolvedExtHostIdentifier=_._id)}}else n.location&&typeof n.location!="object"?s.location=n.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(n,s){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const _=new c(s),L=this._setupExtHostProcessListeners(n,_);this._terminalProcessDisposables[n]=L}async $acceptActiveTerminalChanged(n){const s=this._activeTerminal;if(n===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(n);h&&(this._activeTerminal=h,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,s){const h=this._getTerminalById(n);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:s})}async $acceptTerminalDimensions(n,s,h){const _=this._getTerminalById(n);_&&_.setDimensions(s,h)&&this._onDidChangeTerminalDimensions.fire({terminal:_.value,dimensions:_.value.dimensions})}async $acceptTerminalMaximumDimensions(n,s,h){this._terminalProcesses.get(n)?.resize(s,h)}async $acceptTerminalTitleChange(n,s){const h=this._getTerminalById(n);h&&(h.name=s)}async $acceptTerminalClosed(n,s,h){const _=this._getTerminalObjectIndexById(this._terminals,n);if(_!==null){const L=this._terminals.splice(_,1)[0];L.setExitStatus(s,h),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(n,s,h,_){if(s){const U=this._getTerminalObjectIndexById(this._terminals,s);if(U!==null){this._terminals[U]._id=n,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const L={name:_.name,shellPath:_.executable,shellArgs:_.args,cwd:typeof _.cwd=="string"?_.cwd:P.URI.revive(_.cwd),env:_.env,hideFromUser:_.hideFromUser},M=new f(this._proxy,n,L,h);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,s){this._getTerminalById(n)?._setProcessId(s)}async $startExtensionTerminal(n,s){const h=this._getTerminalById(n);if(!h)return{message:(0,D.localize)(0,null,n)};h.isOpen||await new Promise(L=>{const M=this.onDidOpenTerminal(async U=>{U===h.value&&(M.dispose(),L())})});const _=this._terminalProcesses.get(n);_?_.startSendingEvents(s):this._extensionTerminalAwaitingStart[n]={initialDimensions:s}}_setupExtHostProcessListeners(n,s){const h=new I.DisposableStore;h.add(s.onProcessReady(L=>this._proxy.$sendProcessReady(n,L.pid,L.cwd))),h.add(s.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(n,L))),this._bufferer.startBuffering(n,s.onProcessData),h.add(s.onProcessExit(L=>this._onProcessExit(n,L))),this._terminalProcesses.set(n,s);const _=this._extensionTerminalAwaitingStart[n];return _&&s instanceof c&&(s.startSendingEvents(_.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),h}$acceptProcessAckDataEvent(n,s){this._terminalProcesses.get(n)?.acknowledgeDataEvent(s)}$acceptProcessInput(n,s){this._terminalProcesses.get(n)?.input(s)}$acceptTerminalInteraction(n){const s=this._getTerminalById(n);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(n,s,h){try{this._terminalProcesses.get(n)?.resize(s,h)}catch(_){if(_.code!=="EPIPE"&&_.code!=="ERR_IPC_CHANNEL_CLOSED")throw _}}$acceptProcessShutdown(n,s){this._terminalProcesses.get(n)?.shutdown(s)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:s}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,s,h){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,h),this._proxy.$registerProfileProvider(s,n.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(n,s){const h=new w.CancellationTokenSource().token;let _=await this._profileProviders.get(n)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(_&&!("options"in _)&&(_={options:_}),!_||!("options"in _))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in _.options){this.createExtensionTerminal(_.options,s);return}this.createTerminalFromOptions(_.options,s)}}async $provideLinks(n,s){const h=this._getTerminalById(n);if(!h)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const L=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,L);const M=[],U={terminal:h.value,line:s},R=[];for(const N of this._linkProviders)R.push(m.Promises.withAsyncBody(async V=>{L.token.onCancellationRequested(()=>V({provider:N,links:[]}));const B=await N.provideTerminalLinks(U,L.token)||[];L.token.isCancellationRequested||V({provider:N,links:B})}));const z=await Promise.all(R);if(L.token.isCancellationRequested)return[];const H=new Map;for(const N of z)N&&N.links.length>0&&M.push(...N.links.map(V=>{const B={id:p++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return H.set(B.id,{provider:N.provider,link:V}),B}));return this._terminalLinkCache.set(n,H),M}$activateLink(n,s){const h=this._terminalLinkCache.get(n)?.get(s);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(n,s){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const h=this._terminalProcessDisposables[n];h&&(h.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,s)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,s){const h=this._getTerminalObjectIndexById(n,s);return h!==null?n[h]:null}_getTerminalObjectIndexById(n,s){let h=null;return n.some((_,L)=>_._id===s?(h=L,!0):!1),h}getEnvironmentVariableCollection(n){let s=this._environmentVariableCollections.get(n.identifier.value);return s||(s=new d,this._setEnvironmentVariableCollection(n.identifier.value,s)),s}_syncEnvironmentVariableCollection(n,s){const h=(0,k.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(n,s.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(n){n.forEach(s=>{const h=s[0],_=new d(s[1]);this._setEnvironmentVariableCollection(h,_)})}$acceptDefaultProfile(n,s){const h=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=s,h?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,s){this._environmentVariableCollections.set(n,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,s)})}};i=je([$e(1,y.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class d{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Replace})}append(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,s){const h=this.map.get(n);(!h||h.value!==s.value||h.type!==s.type)&&(this.map.set(n,s),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,s){this.map.forEach((h,_)=>n.call(s,_,h,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let a=class extends i{constructor(n){super(!1,n)}createTerminal(n,s,h){throw new A.NotSupportedError}createTerminalFromOptions(n,s){throw new A.NotSupportedError}};a=je([$e(0,y.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function r(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function o(u){return g.ThemeColor.isThemeColor(u)?u:void 0}});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l};define(De[261],Ie([1,0,17,23,21,3,60,79,6,24,12,31,5,16,134,15,7,55,90,66]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f){"use strict";var c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(U,R,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(w.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new a(this.proxy),R.registerArgumentProcessor({processArgument:H=>{if(H?.$mid!==13)return H;const N=H,V=N.tests[N.tests.length-1].item.extId;return this.controllers.get(m.TestId.root(V))?.collection.tree.get(V)?.actual??(0,S.toItemFromContext)(H)}})}createTestController(U,R,z){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const H=new E.DisposableStore,N=H.add(new S.ExtHostTestItemCollection(U,R,this.editors));N.root.label=R;const V=new Map,B=this.proxy,F={items:N.root.children,get label(){return R},set label($){R=$,N.root.label=$,B.$updateController(U,{label:R})},get refreshHandler(){return z},set refreshHandler($){z=$,B.$updateController(U,{canRefresh:!!$})},get id(){return U},createRunProfile:($,Q,K,de,ee)=>{let he=(0,I.hash)($);for(;V.has(he);)he++;return new _(this.proxy,V,U,he,$,Q,K,de,ee)},createTestItem($,Q,K){return new S.TestItemImpl(U,$,Q,K)},createTestRun:($,Q,K=!0)=>this.runTracker.createTestRun(U,N,$,Q,K),set resolveHandler($){N.resolveHandler=$},get resolveHandler(){return N.resolveHandler},dispose:()=>{H.dispose()}};B.$registerTestController(U,R,!!z),H.add((0,E.toDisposable)(()=>B.$unregisterTestController(U)));const x={controller:F,collection:N,profiles:V};return this.controllers.set(U,x),H.add((0,E.toDisposable)(()=>this.controllers.delete(U))),H.add(N.onDidGenerateDiff($=>B.$publishDiff(U,$.map(f.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(U,R=C.CancellationToken.None){const z=r(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(z.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(N=>m.TestId.fromExtHostTestItem(N,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:L[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(N=>N.id)},R)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,R,z){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===U?N.getCoverage(R):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,R,z,H){return(0,l.mapFind)(this.runTracker.trackers,V=>V.id===U?V.getCoverage(R):void 0)?.resolveFileCoverage(z,H)??Promise.resolve([])}$configureRunProfile(U,R){this.controllers.get(U)?.profiles.get(R)?.configureHandler?.()}async $refreshTests(U,R){await this.controllers.get(U)?.controller.refreshHandler?.(R)}$publishTestResults(U){this.results=Object.freeze(U.map(R=>(0,D.deepFreeze)(g.TestResults.to(R))).concat(this.results).sort((R,z)=>z.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,R){const z=this.controllers.get(m.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,R<0?1/0:R),z.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(f.TestsDiffOp.deserialize))}async $runControllerTests(U,R){return Promise.all(U.map(z=>this.runControllerTestRequest(z,R)))}async runControllerTestRequest(U,R){const z=this.controllers.get(U.controllerId);if(!z)return{};const{collection:H,profiles:N}=z,V=N.get(U.profileId);if(!V)return{};const B=U.testIds.map(Q=>H.tree.get(Q)).filter(A.isDefined),F=U.excludeExtIds.map(Q=>z.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>B.some(K=>K.fullId.compare(Q.fullId)===2));if(!B.length)return{};const x=new v.TestRunRequest(B.some(Q=>Q.actual instanceof S.TestItemRootImpl)?void 0:B.map(Q=>Q.actual),F.map(Q=>Q.actual),V),$=this.runTracker.prepareForMainThreadTestRun(x,o.fromInternal(U,z.collection),R);try{return await V.runHandler(x,R),{}}catch(Q){return{error:String(Q)}}finally{$.isRunning&&!R.isCancellationRequested&&await P.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};i=je([$e(0,T.IExtHostRpcService)],i),e.ExtHostTesting=i;class d extends E.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,R,z){super(),this.dto=U,this.proxy=R,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const R=this.dto.id,z=this.dto.controllerId,H=(0,k.generateUuid)(),N=new u(this.proxy,R,H),V=$=>(Q,...K)=>{if(F){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),$(Q,...K))},B=($,Q)=>{const K=Q instanceof Array?Q.map(g.TestMessage.from):[g.TestMessage.from(Q)];if($.uri&&$.range){const de={range:g.Range.from($.range),uri:$.uri};for(const ee of K)ee.location=ee.location||de}this.proxy.$appendTestMessagesInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),K)};let F=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return N.coverageProvider},set coverageProvider($){N.coverageProvider=$},enqueued:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),1)}),skipped:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),5)}),started:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),2)}),errored:V(($,Q,K)=>{B($,Q),this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),6,K)}),failed:V(($,Q,K)=>{B($,Q),this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),4,K)}),passed:V(($,Q)=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,Q)}),appendOutput:($,Q,K)=>{F||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(R,H,t.VSBuffer.fromString($),Q&&g.location.from(Q),K&&m.TestId.fromExtHostTestItem(K,z).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(R,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:x,coverage:N}),this.proxy.$startedTestRunTask(R,{id:H,name:U,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof S.TestItemImpl))throw new b.InvalidTestItemError(U.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const R=[],z=this.dto.colllection.root;for(;;){const H=g.TestItem.from(U);if(R.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),U===z))break;U=U.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,R)}}class a{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,R,z){return this.getTracker(U,R,z)}cancelRunById(U){for(const R of this.tracked.values())if(R.id===U){R.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,R,z,H,N){const V=this.tracked.get(z);if(V)return V.createRun(H);const B=o.fromPublic(U,R,z,N),F=r(z);this.proxy.$startedExtensionTestRun({controllerId:U,profile:F&&{group:L[F.kind],id:F.profileId},exclude:z.exclude?.map($=>m.TestId.fromExtHostTestItem($,R.root.id).toString())??[],id:B.id,include:z.include?.map($=>m.TestId.fromExtHostTestItem($,R.root.id).toString())??[R.root.id],persist:N});const x=this.getTracker(z,B);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),x.createRun(H)}getTracker(U,R,z){const H=new d(R,this.proxy,z);return this.tracked.set(U,H),H.onEnd(()=>this.tracked.delete(U)),H}}e.TestRunCoordinator=a;const r=M=>{if(!!M.profile){if(!(M.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class o{static fromPublic(U,R,z,H){return new o(U,(0,k.generateUuid)(),z.include?.map(N=>m.TestId.fromExtHostTestItem(N,U).toString())??[U],z.exclude?.map(N=>m.TestId.fromExtHostTestItem(N,U).toString())??[],H,R)}static fromInternal(U,R){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,R)}constructor(U,R,z,H,N,V){this.controllerId=U,this.id=R,this.isPersisted=N,this.colllection=V,this.includePrefix=z.map(B=>B+"\0"),this.excludePrefix=H.map(B=>B+"\0")}isIncluded(U){const R=m.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(R===z||R.startsWith(z))return!1;for(const z of this.includePrefix)if(R===z||R.startsWith(z))return!0;return!1}}e.TestRunDto=o;class u{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,R,z){this.proxy=U,this.runId=R,this.taskId=z}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(R){throw this.fileCoverage=void 0,R}}async resolveFileCoverage(U,R){const z=await this.fileCoverage;let H=z?.[U];return!this._coverageProvider||!z||!H?[]:(H.detailedCoverage||(H=z[U]=await this._coverageProvider.resolveFileCoverage?.(H,R)??H),H.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class n extends f.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,g.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const R=m.TestId.parentId(U.item.extId);if(R&&this.alreadyRemoved.has(R.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:R,removed:z}=this;return{get added(){return[...U].map(H=>H.revived)},get updated(){return[...R].map(H=>H.revived)},get removed(){return[...z].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,R){return{...U,revived:g.TestItem.toPlain(U.item),depth:R?R.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=s;class h{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(R=>R.revived)},dispose:(0,y.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class _{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?g.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,R,z,H,N,V,B,F=!1,x=void 0){this.controllerId=z,this.profileId=H,this._label=N,this.kind=V,this.runHandler=B,this._isDefault=F,this._tag=x,c.set(this,void 0),p.set(this,void 0),tt(this,c,U,"f"),tt(this,p,R,"f"),R.set(H,this);const $=L[V];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Be(this,c,"f").$publishTestRunProfile({profileId:H,controllerId:z,tag:x?g.TestTag.namespace(this.controllerId,x.id):null,label:N,group:$,isDefault:F,hasConfigurationHandler:!1})}dispose(){Be(this,p,"f")?.delete(this.profileId)&&(tt(this,p,void 0,"f"),Be(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,c=new WeakMap,p=new WeakMap;const L={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(De[262],Ie([1,0,17,3,5,135,15,7]),function(J,e,l,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(A,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const k=this._extHostDocumentsAndEditors.allEditors();return A?k:k.map(w=>w.value)}async showTextDocument(A,k,w){let T;typeof k=="number"?T={position:y.ViewColumn.from(k),preserveFocus:w}:typeof k=="object"?T={position:y.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?y.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const S=await this._proxy.$tryShowTextDocument(A.uri,T),g=S&&this._extHostDocumentsAndEditors.getEditor(S);if(g)return g.value;throw S?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new P.TextEditorDecorationType(this._proxy,A,k).value}$acceptEditorPropertiesChanged(A,k){const w=this._extHostDocumentsAndEditors.getEditor(A);if(!w)throw new Error("unknown text editor");if(k.options&&w._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(y.Selection.to);w._acceptSelections(T)}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(y.Range.to));w._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:{...k.options,lineNumbers:y.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=I.TextEditorSelectionChangeKind.fromValue(k.selections.source),S=k.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:S,kind:T})}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:T})}}$acceptEditorPositionData(A){for(const k in A){const w=this._extHostDocumentsAndEditors.getEditor(k);if(!w)throw new Error("Unknown text editor");const T=y.ViewColumn.to(A[k]);w.value.viewColumn!==T&&(w._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:T}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=E}),define(De[263],Ie([1,0,2,4,5,6,7,15,12]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class D{constructor(w,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=w.getProxy(C.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===11){const g=S.uri===void 0?void 0:l.URI.revive(S.uri);return this._itemsBySourceAndUriMap.get(S.source)?.get(A(g))?.get(S.handle)}return S}})}async $getTimeline(w,T,S,g){return this._providers.get(w)?.provideTimeline(l.URI.revive(T),S,g)}registerTimelineProvider(w,T,S,g){const v=new P.DisposableStore,m=this.convertTimelineItem(T.id,g,v).bind(this);let b;T.onDidChange&&(b=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:w,onDidChange:void 0,async provideTimeline(c,p,i){p?.resetCache&&(v.clear(),f.get(T.id)?.clear());const d=await T.provideTimeline(c,p,i);if(d==null)return;const a=m(c,p);return{...d,source:T.id,items:d.items.map(a)}},dispose(){for(const c of f.values())c.get(T.id)?.clear();b?.dispose(),v.dispose()}})}convertTimelineItem(w,T,S){return(g,v)=>{let m;if(v?.cacheResults){let b=this._itemsBySourceAndUriMap.get(w);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(w,b));const f=A(g);m=b.get(f),m===void 0&&(m=new Map,b.set(f,m))}return b=>{const{iconPath:f,...c}=b,p=`${w}|${b.id??b.timestamp}`;m?.set(p,b);let i,d,a;b.iconPath&&(f instanceof y.ThemeIcon?a={id:f.id,color:f.color}:l.URI.isUri(f)?(i=f,d=f):{light:i,dark:d}=f);let r;return y.MarkdownString.isMarkdownString(c.tooltip)?r=I.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?r=c.tooltip:y.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=I.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=c.detail),{...c,id:c.id??void 0,handle:p,source:w,command:b.command?T.toInternal(b.command,S):void 0,icon:i,iconDark:d,themeIcon:a,tooltip:r,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(w){if(this._providers.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this._proxy.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this._providers.set(w.id,w),(0,P.toDisposable)(()=>{for(const S of this._itemsBySourceAndUriMap.values())S.get(w.id)?.clear();this._providers.delete(w.id),this._proxy.$unregisterTimelineProvider(w.id),w.dispose()})}}e.ExtHostTimeline=D;function A(k){return k?.toString()}}),define(De[264],Ie([1,0,6,14,2,5]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,D,A,k){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const w=k.schemes.find(T=>!y.supportedSchemes.has(T));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,A),this._proxy.$registerUriOpener(D,k.schemes,E,k.label),(0,l.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(E,D,A){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const w=C.URI.revive(D);return k.canOpenExternalUri(w,A)}async $openUri(E,D,A){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(C.URI.revive(D.resolvedUri),{sourceUri:C.URI.revive(D.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[265],Ie([1,0,5,2,6,11,27]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(D,A){if(this.handles.has(y.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const k=I.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(D)),this.handlers.set(k,A),this._proxy.$registerUriHandler(k,D),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(D)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(D,A){const k=this.handlers.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(A))}catch(w){(0,P.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,3,14,2,188,210,88,5]),function(J,e,l,t,C,P,y,I,E){"use strict";var D,A,k,w,T,S,g,v,m,b,f,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class i{constructor(_,L,M,U,R,z,H){D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),w.set(this,void 0),T.set(this,void 0),S.set(this,void 0),g.set(this,""),v.set(this,void 0),m.set(this,!1),b.set(this,!1),f.set(this,void 0),c.set(this,void 0),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new l.Emitter),this._onDidDispose=Be(this,p,"f").event,tt(this,D,_,"f"),tt(this,A,L,"f"),tt(this,v,M,"f"),tt(this,w,U,"f"),tt(this,T,R,"f"),tt(this,S,z,"f"),tt(this,f,d(z),"f"),tt(this,c,a(z),"f"),tt(this,k,H,"f")}dispose(){tt(this,m,!0,"f"),Be(this,p,"f").fire(),Be(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return tt(this,b,!0,"f"),(0,I.asWebviewUri)(_,Be(this,w,"f"))}get cspSource(){const _=Be(this,S,"f").extensionLocation;if(_.scheme===t.Schemas.https||_.scheme===t.Schemas.http){let L=_.toString();return L.endsWith("/")||(L+="/"),L+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,g,"f")}set html(_){this.assertNotDisposed(),Be(this,g,"f")!==_&&(tt(this,g,_,"f"),Be(this,c,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(tt(this,b,!0,"f"),Be(this,k,"f").report("Webview vscode-resource: uris",Be(this,S,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A,"f").$setHtml(Be(this,D,"f"),this.rewriteOldResourceUrlsIfNeeded(_)))}get options(){return this.assertNotDisposed(),Be(this,v,"f")}set options(_){this.assertNotDisposed(),Be(this,A,"f").$setOptions(Be(this,D,"f"),u(Be(this,S,"f"),Be(this,T,"f"),_)),tt(this,v,_,"f")}async postMessage(_){if(Be(this,m,"f"))return!1;const L=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Be(this,f,"f")});return Be(this,A,"f").$postMessage(Be(this,D,"f"),L.message,...L.buffers)}assertNotDisposed(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(_){if(!Be(this,c,"f"))return _;const L=Be(this,S,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,M=Be(this,S,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Be(this,S,"f").extensionLocation.authority:void 0;return _.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,R,z,H,N,V)=>{const B=C.URI.from({scheme:H||"file",path:decodeURIComponent(N)}),F=(0,I.asWebviewUri)(B,{isRemote:L,authority:M}).toString();return`${R}${F}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,R,z,H,N,V)=>{const B=C.URI.from({scheme:H||"file",path:decodeURIComponent(N)}),F=(0,I.asWebviewUri)(B,{isRemote:L,authority:M}).toString();return`${R}${F}${V}`})}}e.ExtHostWebview=i,D=new WeakMap,A=new WeakMap,k=new WeakMap,w=new WeakMap,T=new WeakMap,S=new WeakMap,g=new WeakMap,v=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,c=new WeakMap,p=new WeakMap;function d(h){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(h.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=d;function a(h){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(h.engines.vscode));return _?_.majorBase<1||_.majorBase===1&&_.minorBase<60:!1}catch{return!1}}class r{constructor(_,L,M,U,R){this.remoteInfo=L,this.workspace=M,this._logService=U,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=_.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(_,L,M){const U=this.getWebview(_);if(U){const{message:R}=(0,y.deserializeWebviewMessage)(L,M.value);U._onMessageEmitter.fire(R)}}$onMissingCsp(_,L){this._logService.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,L,M){const U=new i(_,this._webviewProxy,n(L),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=r;function o(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=o;function u(h,_,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||s(h,_)}}e.serializeWebviewOptions=u;function n(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(_=>C.URI.from(_))}}e.reviveOptions=n;function s(h,_){return[...(_?.getWorkspaceFolders()||[]).map(L=>L.uri),h.extensionLocation]}}),define(De[266],Ie([1,0,21,79,6,14,22,2,15,70,87,5,7]),function(J,e,l,t,C,P,y,I,E,D,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(d,a){this.document=d,this._storagePath=a,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,a){await this.getEdit(d).undo(),a||this.disposeBackup()}async redo(d,a){await this.getEdit(d).redo(),a||this.disposeBackup()}disposeEdits(d){for(const a of d)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=p(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const a=this._edits.get(d,0);if(!a)throw new Error("No edit found");return a}}class S{constructor(){this._documents=new Map}get(d,a){return this._documents.get(this.key(d,a))}add(d,a,r){const o=this.key(d,a.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${d} resource:${a.uri}`);const u=new T(a,r);return this._documents.set(o,u),u}delete(d,a){const r=this.key(d,a.uri);this._documents.delete(r)}key(d,a){return`${d}@@@${a}`}}var g;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(g||(g={}));class v{constructor(){this._providers=new Map}addTextProvider(d,a,r){return this.add(0,d,a,r)}addCustomProvider(d,a,r){return this.add(1,d,a,r)}get(d){return this._providers.get(d)}add(d,a,r,o){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:d,extension:r,provider:o}),new w.Disposable(()=>this._providers.delete(a))}}class m{constructor(d,a,r,o,u){this._extHostDocuments=a,this._extensionStoragePaths=r,this._extHostWebview=o,this._extHostWebviewPanels=u,this._editorProviders=new v,this._documents=new S,this._proxy=d.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,a,r,o){const u=new C.DisposableStore;return f(r)?(u.add(this._editorProviders.addTextProvider(a,d,r)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(d),a,o.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(d))):(u.add(this._editorProviders.addCustomProvider(a,d,r)),b(r)&&u.add(r.onDidChangeCustomDocument(n=>{const s=this.getCustomDocumentEntry(a,n.document.uri);if(c(n)){const h=s.addEdit(n);this._proxy.$onDidEdit(n.document.uri,a,h,n.label)}else this._proxy.$onContentChange(n.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(d),a,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(d))),w.Disposable.from(u,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(d,a,r,o,u){const n=this._editorProviders.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const s=I.URI.revive(d),h=await n.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:o?.buffer},u);let _;return b(n.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(a,h,_),{editable:b(n.provider)}}async $disposeCustomDocument(d,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${a}'`);const o=I.URI.revive(d),{document:u}=this.getCustomDocumentEntry(a,o);this._documents.delete(a,u),u.dispose()}async $resolveWebviewEditor(d,a,r,o,u,n){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const h=E.ViewColumn.to(u),_=this._extHostWebview.createNewWebview(a,o.contentOptions,s.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(a,r,o.title,h,o.options,_,!0),M=I.URI.revive(d);switch(s.type){case 1:{const{document:U}=this.getCustomDocumentEntry(r,M);return s.provider.resolveCustomEditor(U,L,n)}case 0:{const U=this._extHostDocuments.getDocument(M);return s.provider.resolveCustomTextEditor(U,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,a,r){this.getCustomDocumentEntry(a,d).disposeEdits(r)}async $onMoveCustomEditor(d,a,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(d);if(!u)throw new Error("No webview found");const n=I.URI.revive(a),s=this._extHostDocuments.getDocument(n);await o.provider.moveCustomTextEditor(s,u,l.CancellationToken.None)}async $undo(d,a,r,o){return this.getCustomDocumentEntry(a,d).undo(r,o)}async $redo(d,a,r,o){return this.getCustomDocumentEntry(a,d).redo(r,o)}async $revert(d,a,r){const o=this.getCustomDocumentEntry(a,d);await this.getCustomEditorProvider(a).revertCustomDocument(o.document,r),o.disposeBackup()}async $onSave(d,a,r){const o=this.getCustomDocumentEntry(a,d);await this.getCustomEditorProvider(a).saveCustomDocument(o.document,r),o.disposeBackup()}async $onSaveAs(d,a,r,o){const u=this.getCustomDocumentEntry(a,d);return this.getCustomEditorProvider(a).saveCustomDocumentAs(u.document,I.URI.revive(r),o)}async $backup(d,a,r){const o=this.getCustomDocumentEntry(a,d),n=await this.getCustomEditorProvider(a).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},r);return o.updateBackup(n),n.id}getCustomDocumentEntry(d,a){const r=this._documents.get(d,I.URI.revive(a));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(d){const r=this._editorProviders.get(d)?.provider;if(!r||!b(r))throw new Error("Custom document is not editable");return r}}e.ExtHostCustomEditors=m;function b(i){return!!i.onDidChangeCustomDocument}function f(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const d=i.scheme===P.Schemas.file||i.scheme===P.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(d)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[267],Ie([1,0,3,6,2,31,15,70,5,7]),function(J,e,l,t,C,P,y,I,E,D){"use strict";var A,k,w,T,S,g,v,m,b,f,c,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends t.Disposable{constructor(u,n,s,h){super(),A.set(this,void 0),k.set(this,void 0),w.set(this,void 0),T.set(this,void 0),S.set(this,void 0),g.set(this,void 0),v.set(this,void 0),m.set(this,void 0),b.set(this,!0),f.set(this,void 0),c.set(this,!1),p.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,p,"f").event,i.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,tt(this,A,u,"f"),tt(this,k,n,"f"),tt(this,T,s,"f"),tt(this,w,h.viewType,"f"),tt(this,S,h.panelOptions,"f"),tt(this,m,h.viewColumn,"f"),tt(this,g,h.title,"f"),tt(this,f,h.active,"f")}dispose(){Be(this,c,"f")||(tt(this,c,!0,"f"),Be(this,p,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,A,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,T,"f")}get viewType(){return this.assertNotDisposed(),Be(this,w,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(u){this.assertNotDisposed(),Be(this,g,"f")!==u&&(tt(this,g,u,"f"),Be(this,k,"f").$setTitle(Be(this,A,"f"),u))}get iconPath(){return this.assertNotDisposed(),Be(this,v,"f")}set iconPath(u){this.assertNotDisposed(),Be(this,v,"f")!==u&&(tt(this,v,u,"f"),Be(this,k,"f").$setIconPath(Be(this,A,"f"),C.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Be(this,S,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,m,"f")=="number"&&Be(this,m,"f")<0))return Be(this,m,"f")}get active(){return this.assertNotDisposed(),Be(this,f,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(u){Be(this,c,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,f,u.active,"f"),tt(this,b,u.visible,"f"),tt(this,m,u.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(u,n){this.assertNotDisposed(),Be(this,k,"f").$reveal(Be(this,A,"f"),{viewColumn:typeof u>"u"?void 0:y.ViewColumn.from(u),preserveFocus:!!n})}assertNotDisposed(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,w=new WeakMap,T=new WeakMap,S=new WeakMap,g=new WeakMap,v=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,c=new WeakMap,p=new WeakMap,i=new WeakMap;class a{static newHandle(){return(0,P.generateUuid)()}constructor(u,n,s){this.webviews=n,this.workspace=s,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(E.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,s,h,_={}){const L=typeof h=="object"?h.viewColumn:h,M={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof h=="object"&&!!h.preserveFocus},U=(0,I.shouldSerializeBuffersForPostMessage)(u),R=a.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(u),R,n,{title:s,panelOptions:r(_),webviewOptions:(0,I.serializeWebviewOptions)(u,this.workspace,_),serializeBuffersForPostMessage:U},M);const z=this.webviews.createNewWebview(R,_,u);return this.createNewWebviewPanel(R,n,s,L,_,z,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((s,h)=>{const _=u[s],L=u[h];return _.active?1:L.active?-1:+_.visible-+L.visible});for(const s of n){const h=this.getWebviewPanel(s);if(!h)continue;const _=u[s];h._updateViewState({active:_.active,visible:_.visible,viewColumn:y.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,n,s){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:s,extension:u}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(u)}),new D.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,s,h){const _=this._serializers.get(n);if(!_)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:M}=_,U=this.webviews.createNewWebview(u,s.webviewOptions,M),R=this.createNewWebviewPanel(u,n,s.title,h,s.panelOptions,U,s.active);await L.deserializeWebviewPanel(R,s.state)}createNewWebviewPanel(u,n,s,h,_,L,M){const U=new d(u,this._proxy,L,{viewType:n,title:s,viewColumn:h,panelOptions:_,active:M});return this._webviewPanels.set(u,U),U}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=a;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[268],Ie([1,0,3,6,70,15,5,7]),function(J,e,l,t,C,P,y,I){"use strict";var E,D,A,k,w,T,S,g,v,m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends t.Disposable{constructor(i,d,a,r,o,u,n){super(),E.set(this,void 0),D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),w.set(this,!1),T.set(this,void 0),S.set(this,void 0),g.set(this,void 0),v.set(this,void 0),m.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Be(this,m,"f").event,b.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,b,"f").event,tt(this,A,a,"f"),tt(this,S,r,"f"),tt(this,E,i,"f"),tt(this,D,d,"f"),tt(this,k,o,"f"),tt(this,T,n,"f")}dispose(){Be(this,w,"f")||(tt(this,w,!0,"f"),Be(this,b,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,S,"f")}set title(i){this.assertNotDisposed(),Be(this,S,"f")!==i&&(tt(this,S,i,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,E,"f"),i))}get description(){return this.assertNotDisposed(),Be(this,g,"f")}set description(i){this.assertNotDisposed(),Be(this,g,"f")!==i&&(tt(this,g,i,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,E,"f"),i))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,A,"f")}_setVisible(i){i===Be(this,T,"f")||Be(this,w,"f")||(tt(this,T,i,"f"),Be(this,m,"f").fire())}get badge(){return this.assertNotDisposed(),Be(this,v,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Be(this,v,"f")?.value&&i?.tooltip===Be(this,v,"f")?.tooltip)&&(tt(this,v,P.ViewBadge.from(i),"f"),Be(this,D,"f").$setWebviewViewBadge(Be(this,E,"f"),i))}show(i){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,E,"f"),!!i)}assertNotDisposed(){if(Be(this,w,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,D=new WeakMap,A=new WeakMap,k=new WeakMap,w=new WeakMap,T=new WeakMap,S=new WeakMap,g=new WeakMap,v=new WeakMap,m=new WeakMap,b=new WeakMap;class c{constructor(i,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,d,a,r){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:a,extension:i}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(i),d,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(i)}),new I.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(i,d,a,r,o){const u=this._viewProviders.get(d);if(!u)throw new Error(`No view provider found for '${d}'`);const{provider:n,extension:s}=u,h=this._extHostWebview.createNewWebview(i,{},s),_=new f(i,this._proxy,d,a,h,s,!0);this._webviewViews.set(i,_),await n.resolveWebviewView(_,{state:r},o)}async $onDidChangeWebviewViewVisibility(i,d){this.getWebviewView(i)._setVisible(d)}async $disposeWebviewView(i){const d=this.getWebviewView(i);this._webviewViews.delete(i),d.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const d=this._webviewViews.get(i);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=c}),define(De[138],Ie([1,0,3,5,2,14,8,4,16]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ei{get state(){return this._state}constructor(k){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ei.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,w){let T;if(typeof k=="string"){T=k;try{k=C.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,y.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,w)}async asExternalUri(k,w){if((0,y.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,w);return C.URI.from(T)}};D.InitialState={focused:!0},D=je([$e(0,E.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(De[269],Ie([1,0,116,270,63,39,2,13,45]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(w,T,S){this._commands=w,this.logService=T,this._ipcHandlePath=S,this._server=t.createServer((g,v)=>this.onRequest(g,v)),this.setup().catch(g=>(T.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,T){const S=(v,m)=>{T.writeHead(v,{"content-type":"application/json"}),T.end(JSON.stringify(m||null),b=>b&&this.logService.error(b))},g=[];w.setEncoding("utf8"),w.on("data",v=>g.push(v)),w.on("end",async()=>{try{const v=JSON.parse(g.join(""));let m;switch(v.type){case"open":m=await this.open(v);break;case"openExternal":m=await this.openExternal(v);break;case"status":m=await this.getStatus(v);break;case"extensionManagement":m=await this.manageExtensions(v);break;default:S(404,`Unknown message type: ${v.type}`);break}S(200,m)}catch(v){const m=v instanceof Error?v.message:JSON.stringify(v);S(500,m),this.logService.error("Error while processing pipe request",v)}})}async open(w){const{fileURIs:T,folderURIs:S,forceNewWindow:g,diffMode:v,mergeMode:m,addMode:b,forceReuseWindow:f,gotoLineMode:c,waitMarkerFilePath:p,remoteAuthority:i}=w,d=[];if(Array.isArray(S))for(const u of S)try{d.push({folderUri:y.URI.parse(u)})}catch{}if(Array.isArray(T))for(const u of T)try{(0,E.hasWorkspaceFileExtension)(u)?d.push({workspaceUri:y.URI.parse(u)}):d.push({fileUri:y.URI.parse(u)})}catch{}const a=p?y.URI.file(p):void 0,o={forceNewWindow:g,diffMode:v,mergeMode:m,addMode:b,gotoLineMode:c,forceReuseWindow:f,preferNewWindow:!f&&!a&&!b,waitMarkerFileURI:a,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",d,o),""}async openExternal(w){for(const T of w.uris){const S=y.URI.parse(T),g=S.scheme==="file"?S:T;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(w){const T=g=>g?.map(v=>/\.vsix$/i.test(v)?y.URI.parse(v):v),S={list:w.list,install:T(w.install),uninstall:T(w.uninstall),force:w.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",S)}async getStatus(w){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let A=class extends D{constructor(w,T){super(w,T,(0,l.createRandomIPCHandle)())}};A=je([$e(0,P.IExtHostCommands),$e(1,I.ILogService)],A),e.CLIServer=A}),define(De[271],Ie([1,0,243,25,16]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends l.AbstractExtHostConsoleForwarder{constructor(E,D){super(E,D),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,D,A){const k=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),D.apply(console,A),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,D){const A=process[E],k=A.write;let w="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(T,S,g)=>{if(!this._isMakingConsoleCall){w+=T.toString(S);const v=w.length>P?w.length:w.lastIndexOf(`
`);v!==-1&&(console[D](w.slice(0,v)),w=w.slice(v+1))}k.call(A,T,S,g)}})}};y=je([$e(0,C.IExtHostRpcService),$e(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(De[272],Ie([1,0,9,82,31,39,6,5,2,16]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends y.Disposable{constructor(w,T){super();const S=w.getProxy(I.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async g=>{const v=E.URI.file((0,l.join)((0,t.tmpdir)(),(0,C.generateUuid)()));return await S.$download(g,v),v})}};A=je([$e(0,D.IExtHostRpcService),$e(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(De[273],Ie([1,0,137,14,194,31]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends l.ExtHostLoggerService{doCreateLogger(E,D,A){return E.scheme===t.Schemas.file?new C.SpdLogLogger(A?.name||(0,P.generateUuid)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,D):super.doCreateLogger(E,D,A)}}e.ExtHostLoggerService=y}),define(De[274],Ie([1,0,63,9,2,69,6,14,18,29]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const d=await super._getWorkspaceStorageURI(i);if(d.scheme!==I.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const a=d.fsPath;let r=0;do{let o;r===0?o=a:o=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${r}`:`${a}-${r}`,await k(o);const u=t.join(o,"vscode.lock"),n=await g(this._logService,u,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),C.URI.file(o);r++}while(r<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function k(p){try{await D.Promises.stat(p);return}catch{}try{await D.Promises.mkdir(p,{recursive:!0})}catch{}}const w=1e3,T=10*60*1e3;class S extends y.Disposable{constructor(i,d){super(),this.logService=i,this.filename=d,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await v(i,d);(!a||a.pid!==process.pid)&&(i.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(d,new Date,new Date)}catch(r){i.error(r),i.info(`Lock '${d}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+i};await D.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function g(p,i,d){try{const r={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(i,JSON.stringify(r),{flag:"wx"})}catch(r){p.error(r)}const a=await v(p,i);return!a||a.pid!==process.pid?d?(p.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),f(p,i)):(p.info(`Lock '${i}': Lock acquired.`),new S(p,i))}async function v(p,i){let d;try{d=await D.Promises.readFile(i)}catch(a){return p.error(a),null}try{return JSON.parse(String(d))}catch(a){return p.error(a),null}}async function m(p,i){let d;try{d=await D.Promises.stat(i)}catch(a){return p.error(a),0}return d.mtime.getTime()}function b(p){try{return process.kill(p,0),!0}catch{return!1}}async function f(p,i){const d=await v(p,i);if(!d)return p.info(`Lock '${i}': Could not read pid of lock holder.`),c(p,i);if(d.willReleaseAt){let n=d.willReleaseAt-Date.now();if(n<5e3){for(n>0?p.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):p.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,E.timeout)(Math.min(100,n)),await m(p,i)===0)return c(p,i);n=d.willReleaseAt-Date.now()}return c(p,i)}}if(!b(d.pid))return p.info(`Lock '${i}': The pid ${d.pid} appears to be gone.`),c(p,i);const a=await m(p,i),r=Date.now()-a;if(r<=T)return p.info(`Lock '${i}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;p.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const o=await m(p,i),u=Date.now()-o;return u<=T?(p.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(p.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),c(p,i))}async function c(p,i){p.info(`Lock '${i}': Deleting a stale lock.`);try{await D.Promises.unlink(i)}catch{}return g(p,i,!0)}}),define(De[275],Ie([1,0,31,16,40]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,E,D){return this.createTerminalFromOptions({name:I,shellPath:E,shellArgs:D})}createTerminalFromOptions(I,E){const D=new C.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),I,I.name);return this._terminals.push(D),D.create(I,this._serializeParentTerminal(I,E)),D.value}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[276],Ie([1,0,5,16,178,6,25,2,44,22,29,7,10,53,3,127,98,13]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b extends g.DisposableTunnel{}function f(n){const s=n.trim().split(`
`),h=[];return s.forEach(L=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);M&&M.length>=3&&h.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),h.reduce((L,M)=>(L[M.socket]=M,L),{})}e.getSockets=f;function c(...n){const s=[].concat(...n.map(i));return[...new Map(s.filter(h=>h.st==="0A").map(h=>{const _=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:p(_[0]),port:parseInt(_[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function p(n){let s="";if(n.length===8)for(let h=n.length-2;h>=0;h-=2)s+=parseInt(n.substr(h,2),16),h!==0&&(s+=".");else for(let h=n.length-4;h>=0;h-=4)s+=parseInt(n.substr(h,4),16).toString(16),h!==0&&(s+=":");return s}e.parseIpAddress=p;function i(n){const s=n.trim().split(`
`),h=s.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return s.map(L=>L.trim().split(/\s+/).reduce((M,U,R)=>(M[h[R]||R]=U,M),{}))}e.loadConnectionTable=i;function d(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function a(n){const s=n.trim().split(`
`),h=[];return s.forEach(_=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);L&&L.length>=4&&h.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),h}e.getRootProcesses=a;async function r(n,s,h){const _=h.reduce((M,U)=>(M[U.pid]=U,M),{}),L=[];return n.forEach(({socket:M,ip:U,port:R})=>{const z=s[M]?s[M].pid:void 0,H=z?_[z]?.cmd:void 0;z&&H&&!d(H)&&L.push({host:U,port:R,detail:H,pid:z})}),L}e.findPorts=r;function o(n,s,h){const _=new Map,L=a(s);for(const M of n){const U=h.get(M.port);if(U){_.set(M.port,U);continue}const R=L.find(z=>z.cmd.includes(`${M.port}`));if(R){let z=R,H;do H=L.find(N=>N.ppid===z.pid),H&&(z=H);while(H);_.set(M.port,{host:M.ip,port:M.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else _.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=o;let u=class extends P.Disposable{constructor(s,h,_){super(),this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new S.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(l.MainContext.MainThreadTunnelService),w.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(s,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(h,s.displayName);if(_){const L=new b(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(s){return Math.max(s*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,h){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:s,provider:h}),this._proxy.$registerPortsAttributesProvider(s,_),new k.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(s,h,_,L,M){const U=[];for(const z of s){const H=this._portAttributesProviders.get(z);if(!H)return[];U.push(...await Promise.all(h.map(async N=>H.provider.providePortAttributes(N,_,L,M))))}const R=U.filter(z=>!!z);return R.length>0?R.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(s){if(s&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=s;const h=new v.MovingAverage;let _;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),M=(await this.findCandidatePorts()).filter(R=>(0,g.isLocalhost)(R.host)||(0,g.isAllInterfaces)(R.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(R=>R.port).join(", ")}`);const U=new Date().getTime()-L;h.update(U),(!_||JSON.stringify(_)!==JSON.stringify(M))&&(_=M,await this._proxy.$onFoundNewCandidates(_)),await new Promise(R=>setTimeout(()=>R(),this.calculateDelay(h.value)))}}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter()),s.tunnelFactory){this._forwardPortProvider=s.tunnelFactory;let h=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]);const _=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(_)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(s,h){if(this._extensionTunnels.has(s.host)){const _=this._extensionTunnels.get(s.host);_.has(s.port)&&(h&&_.get(s.port).disposeListener.dispose(),await _.get(s.port).tunnel.dispose(),_.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(s,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const L=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const M=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:L,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const h=await Promise.all(s.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),_=s.filter((L,M)=>h[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(L=>L.port).join(", ")} to ${_.map(L=>L.port).join(", ")}`),_}async findCandidatePorts(){let s="",h="";try{s=await A.Promises.readFile("/proc/net/tcp","utf8"),h=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const _=c(s,h),L=await new Promise(B=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,x,$)=>{B(x)})}),M=f(L),U=await A.Promises.readdir("/proc"),R=[];for(const B of U)try{const F=Number(B),x=D.joinPath(I.URI.file("/proc"),B);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(F)){const Q=await A.Promises.readlink(D.joinPath(x,"cwd").fsPath),K=await A.Promises.readFile(D.joinPath(x,"cmdline").fsPath,"utf8");R.push({pid:F,cwd:Q,cmd:K})}}catch{}const z=[],H=_.filter(B=>{const F=M[B.socket];return F||z.push(B),F}),N=r(H,M,R);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const B=await new Promise(F=>{(0,E.exec)("ps -F -A -l | grep root",(x,$,Q)=>{F($)})});this._foundRootPorts=o(z,B,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return N.then(B=>V?B.concat(V):B)}};u=je([$e(0,t.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,m.ILogService)],u),e.ExtHostTunnelService=u}),define(De[277],Ie([1,0,18,23,21,11,3,6,111,237,56]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function w(_,L){try{return JSON.stringify(_,L)}catch{return"null"}}const T="$$ref$$",S={[T]:-1};class g{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function v(_,L=null,M=!1){const U=[];return{jsonString:(M?w:JSON.stringify)(_,(z,H)=>{if(typeof H>"u")return S;if(typeof H=="object"){if(H instanceof t.VSBuffer){const N=U.push(H)-1;return{[T]:N}}if(L)return L(z,H)}return H}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=v;function m(_,L,M){return JSON.parse(_,(U,R)=>{if(R){const z=R[T];if(typeof z=="number")return L[z];if(M&&R.$mid===1)return M.transformIncoming(R)}return R})}e.parseJsonAndRestoreBufferRefs=m;function b(_,L){return JSON.stringify(_,L)}function f(_){return _?(L,M)=>M&&M.$mid===1?_.transformOutgoing(M):M:null}var c;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},d=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends I.Disposable{constructor(L,M=null,U=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=U,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,z=A.ProxyIdentifier.count;R<z;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,E.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:U}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,U)),this._proxies[M]}_createProxy(L,M){const U={get:(R,z)=>(typeof z=="string"&&!R[z]&&z.charCodeAt(0)===36&&(R[z]=(...H)=>this._remoteCall(L,z,H)),z===a?M:R[z])};return new Proxy(Object.create(null),U)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,U=L.length;M<U;M++){const R=L[M];if(!this._locals[R.nid])throw new Error(`Missing proxy instance ${R.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,U=o.read(L,0),R=U.readUInt8(),z=U.readUInt32();switch(R){case 1:case 2:{let{rpcId:H,method:N,args:V}=n.deserializeRequestJSONArgs(U);this._uriTransformer&&(V=(0,E.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,H,N,V,R===2);break}case 3:case 4:{let{rpcId:H,method:N,args:V}=n.deserializeRequestMixedArgs(U);this._uriTransformer&&(V=(0,E.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,H,N,V,R===4);break}case 5:{this._logger?.logIncoming(M,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(M,z);break}case 7:{this._receiveReply(M,z,void 0);break}case 9:{let H=n.deserializeReplyOKJSON(U);this._uriTransformer&&(H=(0,E.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(M,z,H);break}case 10:{const H=n.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(M,z,H);break}case 8:{const H=n.deserializeReplyOKVSBuffer(U);this._receiveReply(M,z,H);break}case 11:{let H=n.deserializeReplyErrError(U);this._uriTransformer&&(H=(0,E.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(M,z,H);break}case 12:{this._receiveReplyErr(M,z,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,U,R,z,H){this._logger?.logIncoming(L,M,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(U)}.${R}(`,z);const N=String(M);let V,B;if(H){const x=new C.CancellationTokenSource;z.push(x.token),V=this._invokeHandler(U,R,z),B=()=>x.cancel()}else V=this._invokeHandler(U,R,z),B=i;this._cancelInvokedHandlers[N]=B;const F=n.serializeAcknowledged(M);this._logger?.logOutgoing(F.byteLength,M,1,"ack"),this._protocol.send(F),V.then(x=>{delete this._cancelInvokedHandlers[N];const $=n.serializeReplyOK(M,x,this._uriReplacer);this._logger?.logOutgoing($.byteLength,M,1,"reply:",x),this._protocol.send($)},x=>{delete this._cancelInvokedHandlers[N];const $=n.serializeReplyErr(M,x);this._logger?.logOutgoing($.byteLength,M,1,"replyErr:",x),this._protocol.send($)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,1,"receiveCancel");const U=String(M);this._cancelInvokedHandlers[U]?.()}_receiveReply(L,M,U){this._logger?.logIncoming(L,M,0,"receiveReply:",U);const R=String(M);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const z=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],z.resolveOk(U)}_receiveReplyErr(L,M,U){this._logger?.logIncoming(L,M,0,"receiveReplyErr:",U);const R=String(M);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const z=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let H;U&&(U.$isError?(H=new Error,H.name=U.name,H.message=U.message,H.stack=U.stack):H=U),z.resolveErr(H)}_invokeHandler(L,M,U){try{return Promise.resolve(this._doInvokeHandler(L,M,U))}catch(R){return Promise.reject(R)}}_doInvokeHandler(L,M,U){const R=this._locals[L];if(!R)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(L));const z=R[M];if(typeof z!="function")throw new Error("Unknown method "+M+" on actor "+(0,A.getStringIdentifierForProxy)(L));return z.apply(R,U)}_remoteCall(L,M,U){if(this._isDisposed)return new D.CanceledLazyPromise;let R=null;if(U.length>0&&C.CancellationToken.isCancellationToken(U[U.length-1])&&(R=U.pop()),R&&R.isCancellationRequested)return Promise.reject(P.canceled());const z=n.serializeRequestArguments(U,this._uriReplacer),H=++this._lastMessageId,N=String(H),V=new D.LazyPromise;R&&R.onCancellationRequested(()=>{const F=n.serializeCancel(H);this._logger?.logOutgoing(F.byteLength,H,0,"cancel"),this._protocol.send(n.serializeCancel(H))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(H);const B=n.serializeRequest(H,L,M,z,!!R);return this._logger?.logOutgoing(B.byteLength,H,0,`request: ${(0,A.getStringIdentifierForProxy)(L)}.${M}(`,U),this._protocol.send(B),V}}e.RPCProtocol=r,k=d,r.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(L,M,U){const R=new o(t.VSBuffer.alloc(U+1+4),0);return R.writeUInt8(L),R.writeUInt32(M),R}static read(L,M){return new o(L,M)}get buffer(){return this._buff}constructor(L,M){this._buff=L,this._offset=M}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,U}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,U}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let U=0,R=L.length;U<R;U++){const z=L[U];switch(M+=1,z.type){case 1:M+=this.sizeLongString(z.value);break;case 2:M+=this.sizeVSBuffer(z.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(z.value);for(let H=0;H<z.buffers.length;++H)M+=this.sizeVSBuffer(z.buffers[H]);break;case 4:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,U=L.length;M<U;M++){const R=L[M];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let z=0;z<R.buffers.length;++z)this.writeBuffer(R.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let U=0;U<L;U++)switch(this.readUInt8()){case 1:M[U]=this.readLongString();break;case 2:M[U]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),H=this.readLongString(),N=[];for(let V=0;V<z;++V)N.push(this.readVSBuffer());M[U]=new A.SerializableObjectWithBuffers(m(H,N,null));break}case 4:M[U]=void 0;break}return M}}o.sizeUInt32=4;var u;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(u||(u={}));class n{static _useMixedArgSerialization(L){for(let M=0,U=L.length;M<U;M++)if(L[M]instanceof t.VSBuffer||L[M]instanceof A.SerializableObjectWithBuffers||typeof L[M]>"u")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const U=[];for(let R=0,z=L.length;R<z;R++){const H=L[R];if(H instanceof t.VSBuffer)U[R]={type:2,value:H};else if(typeof H>"u")U[R]={type:4};else if(H instanceof A.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=v(H.value,M);U[R]={type:3,value:t.VSBuffer.fromString(N),buffers:V}}else U[R]={type:1,value:t.VSBuffer.fromString(b(H,M))}}return{type:1,args:U}}return{type:0,args:b(L,M)}}static serializeRequest(L,M,U,R,z){switch(R.type){case 0:return this._requestJSONArgs(L,M,U,R.args,z);case 1:return this._requestMixedArgs(L,M,U,R.args,z)}}static _requestJSONArgs(L,M,U,R,z){const H=t.VSBuffer.fromString(U),N=t.VSBuffer.fromString(R);let V=0;V+=o.sizeUInt8(),V+=o.sizeShortString(H),V+=o.sizeLongString(N);const B=o.alloc(z?2:1,L,V);return B.writeUInt8(M),B.writeShortString(H),B.writeLongString(N),B.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),U=L.readShortString(),R=L.readLongString();return{rpcId:M,method:U,args:JSON.parse(R)}}static _requestMixedArgs(L,M,U,R,z){const H=t.VSBuffer.fromString(U);let N=0;N+=o.sizeUInt8(),N+=o.sizeShortString(H),N+=o.sizeMixedArray(R);const V=o.alloc(z?4:3,L,N);return V.writeUInt8(M),V.writeShortString(H),V.writeMixedArray(R),V.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),U=L.readShortString(),R=L.readMixedArray(),z=new Array(R.length);for(let H=0,N=R.length;H<N;H++){const V=R[H];typeof V=="string"?z[H]=JSON.parse(V):z[H]=V}return{rpcId:M,method:U,args:z}}static serializeAcknowledged(L){return o.alloc(5,L,0).buffer}static serializeCancel(L){return o.alloc(6,L,0).buffer}static serializeReplyOK(L,M,U){if(typeof M>"u")return this._serializeReplyOKEmpty(L);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof A.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:z}=v(M.value,U,!0);return this._serializeReplyOKJSONWithBuffers(L,R,z)}else return this._serializeReplyOKJSON(L,w(M,U))}static _serializeReplyOKEmpty(L){return o.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let U=0;U+=o.sizeVSBuffer(M);const R=o.alloc(8,L,U);return R.writeVSBuffer(M),R.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const U=t.VSBuffer.fromString(M);let R=0;R+=o.sizeLongString(U);const z=o.alloc(9,L,R);return z.writeLongString(U),z.buffer}static _serializeReplyOKJSONWithBuffers(L,M,U){const R=t.VSBuffer.fromString(M);let z=0;z+=o.sizeUInt32,z+=o.sizeLongString(R);for(const N of U)z+=o.sizeVSBuffer(N);const H=o.alloc(10,L,z);H.writeUInt32(U.length),H.writeLongString(R);for(const N of U)H.writeBuffer(N);return H.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const U=L.readUInt32(),R=L.readLongString(),z=[];for(let H=0;H<U;++H)z.push(L.readVSBuffer());return new A.SerializableObjectWithBuffers(m(R,z,M))}static serializeReplyErr(L,M){const U=M?w(P.transformErrorForSerialization(M),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(L);const R=t.VSBuffer.fromString(U);let z=0;z+=o.sizeLongString(R);const H=o.alloc(11,L,z);return H.writeLongString(R),H.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return o.alloc(12,L,0).buffer}}var s;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var h;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(h||(h={}))}),define(De[278],Ie([1,0,3,43,52,4,38,11,18]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(S){this.channels.has(S.id)||(this.channels.set(S.id,S),this._onDidRegisterChannel.fire(S.id))}getChannels(){const S=[];return this.channels.forEach(g=>S.push(g)),S}getChannel(S){return this.channels.get(S)}removeChannel(S){this.channels.delete(S),this._onDidRemoveChannel.fire(S)}}t.Registry.add(e.Extensions.OutputChannels,new A);function k(T,S,g,v,m){return(0,E.createCancelablePromise)(async b=>{await(0,y.whenProviderRegistered)(g,v);const f=t.Registry.as(e.Extensions.OutputChannels);try{await w(g,1,v,m,b),f.registerChannel({id:T,label:S,file:g,log:!0})}catch(c){(0,I.isCancellationError)(c)||m.error("Error while registering log channel",g.toString(),(0,I.getErrorMessage)(c))}})}e.registerLogChannel=k;async function w(T,S,g,v,m){if(!await g.exists(T)){if(m.isCancellationRequested)throw new I.CancellationError;if(S>10)throw new Error("Timed out while waiting for file to be created");v.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,m),await w(T,S+1,g,v,m)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(De[139],Ie([1,0,5,4,16,27,13,278,68,25,46,152,23,12,38,3,6,28]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class b extends y.AbstractMessageLogger{get disposed(){return this._disposed}constructor(i,d,a,r,o){super(),this.id=i,this.name=d,this.logger=a,this.proxy=r,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this._register(a.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.logger.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const i=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,i)}replace(i){const d=this.offset;this.info(i),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,d),this.visible&&this.logger.flush()}show(i,d){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof i=="boolean"?i:d))}hide(){this.proxy.$close(this.id)}log(i,d){this.offset+=w.VSBuffer.fromString(d).byteLength,(0,y.log)(this.logger,i,d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class f extends b{appendLine(i){this.append(i)}}let c=class{constructor(i,d,a,r,o,u){this.initData=d,this.extHostFileSystem=a,this.extHostFileSystemInfo=r,this.loggerService=o,this.logService=u,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=i.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(d.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.visibleChannelId=i;for(const[d,a]of this.channels)a.visible=d===this.visibleChannelId}createOutputChannel(i,d,a){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const r=typeof d=="object"&&d.log;r&&(0,m.checkProposedApiEnabled)(a,"extensionLog");const o=(0,T.isString)(d)?d:void 0;if((0,T.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=this.getDefaultLogLevel(a),n=r?this.doCreateLogOutputChannel(i,u,a):this.doCreateOutputChannel(i,o,a);return n.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),r?this.createExtHostLogOutputChannel(i,u,n):this.createExtHostOutputChannel(i,n)}async doCreateOutputChannel(i,d,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const r=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(r,`${this.namePool++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(i,o,!1,d,a.identifier.value);return new b(n,i,u,this.proxy,a)}async doCreateLogOutputChannel(i,d,a){const r=await this.createExtensionLogDirectory(a),o=this.extHostFileSystemInfo.extUri.joinPath(r,`${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(o,{name:i},d),n=await this.proxy.$register(i,o,!0,void 0,a.identifier.value);return new f(n,i,u,this.proxy,a)}getDefaultLogLevel(i){let d;const a=this.initData.environment.extensionLogLevel?.find(([r])=>P.ExtensionIdentifier.equals(i.identifier,r))?.[1];return a&&(d=(0,y.parseLogLevel)(a)),d??this.logService.getLevel()}createExtensionLogDirectory(i){let d=this.extensionLogDirectoryPromise.get(i.identifier.value);if(!d){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,i.identifier.value);this.extensionLogDirectoryPromise.set(i.identifier.value,d=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return d}createExtHostOutputChannel(i,d){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return i},append(o){r(),d.then(u=>u.append(o))},appendLine(o){r(),d.then(u=>u.appendLine(o))},clear(){r(),d.then(o=>o.clear())},replace(o){r(),d.then(u=>u.replace(o))},show(o,u){r(),d.then(n=>n.show(o,u))},hide(){r(),d.then(o=>o.hide())},dispose(){a=!0,d.then(o=>o.dispose())}}}createExtHostLogOutputChannel(i,d,a){const r=new v.DisposableStore,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},u=r.add(new g.Emitter);return a.then(n=>{r.add(n),r.add(n.onDidChangeLogLevel(s=>{d=s,u.fire(s)}))}),{...this.createExtHostOutputChannel(i,a),get logLevel(){return d},onDidChangeLogLevel:u.event,trace(n,...s){o(),a.then(h=>h.trace(n,...s))},debug(n,...s){o(),a.then(h=>h.debug(n,...s))},info(n,...s){o(),a.then(h=>h.info(n,...s))},warn(n,...s){o(),a.then(h=>h.warn(n,...s))},error(n,...s){o(),a.then(h=>h.error(n,...s))},dispose(){r.dispose()}}}};c=je([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,E.IExtHostConsumerFileSystem),$e(3,A.IExtHostFileSystemInfo),$e(4,y.ILoggerService),$e(5,y.ILogService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(De[279],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[280],Ie([1,0,32,14,9,10,22,2,4,206,45,223,279]),function(J,e,l,t,C,P,y,I,E,D,A,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class ti{constructor(g,v,m,b){this.localUserHome=g,this.remoteAgentService=v,this.environmentService=m,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??g})()}hasValidBasename(g,v,m){return typeof v=="string"||typeof v>"u"?this.resolveOS.then(b=>this.doHasValidBasename(g,b,v)):this.doHasValidBasename(g,v,m)}doHasValidBasename(g,v,m){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(m??(0,y.basename)(g),v===1):!0}get defaultUriScheme(){return ti.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,v){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,D.getVirtualWorkspaceScheme)(v.getWorkspace());if(m)return m;const b=v.getWorkspace().folders[0];if(b)return b.uri.scheme;const f=v.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?C.win32:C.posix)}async fileURI(g){let v="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const b=g.indexOf("/",2);b===-1?(v=g.substring(2),g="/"):(v=g.substring(2,b),g=g.substring(b)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:v,path:g,query:"",fragment:""})}};T=je([$e(1,w.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,A.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[71],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(y,I){this.line=y,this.character=I}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,I){return new l(0,0)}with(y){return new l(0,0)}}e.Position=l;class t{constructor(y,I,E,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(y,I),this.end=new l(E,D)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var C;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,37,24,32,8,4,9,11,71,18]),function(J,e,l,t,C,P,y,I,E,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const w="\u27EA ",T=" characters skipped \u27EB",S=(w.length+T.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var g;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function m(K){return!!K.preview}e.resultIsMatch=m;function b(K){return!!K.resource}e.isFileMatch=b;function f(K){return!!K.message}e.isProgressMessage=f;var c;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class i{constructor(de,ee,he){this.ranges=ee;const Y=Array.isArray(ee)?ee:[ee];if(he&&he.matchLines===1&&d(Y)){de=(0,y.getNLines)(de,he.matchLines);let me="",be=0,ke=0;const Re=Math.floor(he.charsPerLine/5),ze=[];for(const oe of Y){const le=Math.max(oe.startColumn-Re,0),ge=oe.startColumn+he.charsPerLine;if(le>ke+Re+S){const Z=w+(le-ke)+T;me+=Z+de.slice(le,ge),be+=le-(ke+Z.length)}else me+=de.slice(ke,ge);ze.push(new r(0,oe.startColumn-be,oe.endColumn-be)),ke=ge}this.preview={text:me,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const me=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:de,matches:(0,l.mapArrayOrNot)(ee,be=>new a(be.startLineNumber-me,be.startColumn,be.endLineNumber-me,be.endColumn))}}}}e.TextSearchMatch=i;function d(K){const de=K[0].startLineNumber;for(const ee of K)if(ee.startLineNumber!==de||ee.endLineNumber!==de)return!1;return!0}class a{constructor(de,ee,he,Y){this.startLineNumber=de,this.startColumn=ee,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=a;class r extends a{constructor(de,ee,he){super(de,ee,de,he)}}e.OneLineRange=r;var o;(function(K){K.List="list",K.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var u;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,de=!0){const ee=K&&K.files&&K.files.exclude,he=de&&K&&K.search&&K.search.exclude;if(!ee&&!he)return;if(!ee||!he)return ee||he;let Y=Object.create(null);return Y=C.mixin(Y,C.deepClone(ee)),Y=C.mixin(Y,C.deepClone(he),!0),Y}e.getExcludes=n;function s(K,de){return K.excludePattern&&t.match(K.excludePattern,de)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,de)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ee=>{const he=ee.folder.fsPath;if(P.isEqualOrParent(de,he)){const Y=E.relative(he,de);return!ee.includePattern||!!t.match(ee.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var h;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(de,ee){super(de),this.code=ee}}e.SearchError=_;function L(K){const de=K.message;if((0,D.isCancellationError)(K))return new _(de,h.canceled);try{const ee=JSON.parse(de);return new _(ee.message,ee.code)}catch{return new _(de,h.other)}}e.deserializeSearchError=L;function M(K){const de={message:K.message,code:K.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function U(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=U;function R(K){return K.type==="success"}e.isSerializedSearchSuccess=R;function z(K){return!!K.path}e.isSerializedFileMatch=z;function H(K,de){const ee=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(ee,de)}e.isFilePatternMatch=H;class N{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function V(K,de){const ee={...K||{},...de||{}};return Object.keys(ee).filter(he=>{const Y=ee[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=V;class B{constructor(de,ee){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=de.includePattern;ee.includePattern&&(he?he={...he,...ee.includePattern}:he=ee.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(de,ee,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he))}includedInQuerySync(de,ee,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,ee,he))}includedInQuery(de,ee,he){const Y=this._parsedExcludeExpression(de,ee,he),me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,ee,he):!0;return(0,k.isThenable)(Y)?Y.then(be=>be?!1:me()):me()}hasSiblingExcludeClauses(){return F(this._excludeExpression)}}e.QueryGlobTester=B;function F(K){for(const de in K)if(typeof K[de]!="boolean")return!0;return!1}function x(K){if(!K)return;let de;return ee=>(de||(de=(K()||Promise.resolve([])).then(he=>he?Q(he):{})),de.then(he=>!!he[ee]))}e.hasSiblingPromiseFn=x;function $(K){if(!K)return;let de;return ee=>{if(!de){const he=K();de=he?Q(he):{}}return!!de[ee]}}e.hasSiblingFn=$;function Q(K){const de={};for(const ee of K)de[ee]=!0;return de}}),define(De[33],Ie([1,0,17,18,21,3,6,26,14,98,22,8,12,2,176,4,13,195,45,46,25,16,15,7,54,30,5]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p,i,d,a,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(R,z,H){return new A.ExtUri(N=>_(N,H)).isEqual(R,z)}function n(R,z,H){return u(R.uri,z.uri,H)?0:(0,k.compare)(R.uri.toString(),z.uri.toString())}function s(R,z,H){return R.index!==z.index?R.index<z.index?-1:1:u(R.uri,z.uri,H)?(0,k.compare)(R.name,z.name):(0,k.compare)(R.uri.toString(),z.uri.toString())}function h(R,z,H,N){const V=R.slice(0).sort((F,x)=>H(F,x,N)),B=z.slice(0).sort((F,x)=>H(F,x,N));return(0,l.delta)(V,B,(F,x)=>H(F,x,N))}function _(R,z){const H=z.getCapabilities(R.scheme);return!(H&&H&1024)}class L extends b.Workspace{static toExtHostWorkspace(z,H,N,V){if(!z)return{workspace:null,added:[],removed:[]};const{id:B,name:F,folders:x,configuration:$,transient:Q,isUntitled:K}=z,de=[],ee=H;H?x.forEach((be,ke)=>{const Re=T.URI.revive(be.uri),ze=L._findFolder(N||H,Re,V);ze?(ze.name=be.name,ze.index=be.index,de.push(ze)):de.push({uri:Re,name:be.name,index:ke})}):de.push(...x.map(({uri:be,name:ke,index:Re})=>({uri:T.URI.revive(be),name:ke,index:Re}))),de.sort((be,ke)=>be.index<ke.index?-1:1);const he=new L(B,F,de,!!Q,$?T.URI.revive($):null,!!K,be=>_(be,V)),{added:Y,removed:me}=h(ee?ee.workspaceFolders:[],he.workspaceFolders,n,V);return{workspace:he,added:Y,removed:me}}static _findFolder(z,H,N){for(let V=0;V<z.folders.length;V++){const B=z.workspaceFolders[V];if(u(B.uri,H,N))return B}}constructor(z,H,N,V,B,F,x){super(z,N.map($=>new b.WorkspaceFolder($)),V,B,x),this._name=H,this._isUntitled=F,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(x),N.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,H){return H&&this._structure.get(z)&&(z=(0,A.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let M=class{constructor(z,H,N,V,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=V,this._extHostFileSystemInfo=N,this._uriTransformerService=B,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(o.MainContext.MainThreadMessageService);const F=H.workspace;this._confirmedWorkspace=F?new L(F.id,F.name,[],!!F.transient,F.configuration?T.URI.revive(F.configuration):null,!!F.isUntitled,x=>_(x,N)):void 0}$initializeWorkspace(z,H){this._trusted=H,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:E.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,H,N,...V){const B=[];if(Array.isArray(V)&&V.forEach(K=>{T.URI.isUri(K.uri)&&!B.some(de=>u(de.uri,K.uri,this._extHostFileSystemInfo))&&B.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[H,N].some(K=>typeof K!="number"||K<0)||N===0&&B.length===0)return!1;const F=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+N>F.length)return!1;const x=F.slice(0);x.splice(H,N,...B.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<x.length;K++){const de=x[K];if(x.some((ee,he)=>he!==K&&u(de.uri,ee.uri,this._extHostFileSystemInfo)))return!1}x.forEach((K,de)=>K.index=de);const{added:$,removed:Q}=h(F,x,s,this._extHostFileSystemInfo);if($.length===0&&Q.length===0)return!1;if(this._proxy){const K=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(K,H,N,B).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(m.Severity.Error,(0,S.localize)(0,null,K,de.toString()),ee,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(z,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async getWorkspaceFolder2(z,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,H){let N,V="";if(typeof z=="string"?(N=T.URI.file(z),V=z):typeof z<"u"&&(N=z,V=z.fsPath),!N)return V;const B=this.getWorkspaceFolder(N,!0);if(!B)return V;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let F=(0,A.relativePath)(B.uri,N);return H&&B.name&&(F=`${B.name}/${F}`),F}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:H,added:N,removed:V}=L.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:V}))}findFiles(z,H,N,V,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let F;if(H===null?F=!1:H&&(typeof H=="string"?F=H:F=H.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:$}=U(i.GlobPattern.from(z));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(x),(0,w.withUndefinedAsNull)($),(0,w.withUndefinedAsNull)(F),(0,w.withUndefinedAsNull)(N),B).then(Q=>Array.isArray(Q)?Q.map(K=>T.URI.revive(K)):[])}async findTextInFiles(z,H,N,V,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const F=this._requestIdProvider.getNext(),x=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:$,folder:Q}=U(i.GlobPattern.from(H.include)),K=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,de={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:x,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:$,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[F]=he=>{if(ee)return;const Y=T.URI.revive(he.resource);he.results.forEach(me=>{(0,r.resultIsMatch)(me)?N({uri:Y,preview:{text:me.preview.text,matches:(0,l.mapArrayOrNot)(me.preview.matches,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(me.ranges,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:Y,text:me.text,lineNumber:me.lineNumber})})},B.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(z,(0,w.withUndefinedAsNull)(Q),de,F,B);return delete this._activeSearchCallbacks[F],he||{}}catch(he){throw delete this._activeSearchCallbacks[F],he}}$handleTextSearchResult(z,H){this._activeSearchCallbacks[H]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,H){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,H);const N=this._uriTransformerService.transformOutgoingScheme(z),V=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(V,N),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(z,H){this._logService.info("Getting edit session identifier for workspaceFolder",z);const N=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const B=await V.provideEditSessionIdentity(N,H);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}};M=je([$e(0,p.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,f.IExtHostFileSystemInfo),$e(3,v.ILogService),$e(4,a.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function U(R){let z,H;return R&&(typeof R=="string"?z=R:(z=R.pattern,H=T.URI.revive(R.baseUri))),{includePattern:z,folder:H}}}),define(De[34],Ie([1,0,24,3,33,5,7,198,125,12,18,4,16,13,2]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(d,a){if(a){const r=a.split(".");let o=d;for(let u=0;o&&u<r.length;u++)o=o[r[u]];return o}}function v(d){return d instanceof S.URI}function m(d){return d&&d.uri instanceof S.URI&&d.languageId&&typeof d.languageId=="string"}function b(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function f(d){return d&&d.uri instanceof S.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(v(d))return{resource:d};if(m(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(b(d))return{overrideIdentifier:d.languageId};if(f(d))return{resource:d.uri};if(d===null)return{resource:null}}let p=class{constructor(a,r,o){this._proxy=a.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(a,r))}};p=je([$e(0,w.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,T.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(a,r,o,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=a,this._logService=u,this._extHostWorkspace=r,this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(a,r,o){const u=c(r)||{},n=this._toReadonlyValue(a?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,u,o?.identifier);function s(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(_){return typeof g(n,_)<"u"},get:(_,L)=>{this._validateConfigurationAccess(a?`${a}.${_}`:_,u,o?.identifier);let M=g(n,_);if(typeof M>"u")M=L;else{let U;const R=(z,H)=>{let N;const V=()=>{U=U||(0,l.deepClone)(n),N=N||g(U,H)};return(0,D.isObject)(z)?new Proxy(z,{get:(B,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return V(),()=>N;if(U)return N=N||g(U,H),N[F];const x=B[F];return typeof F=="string"?R(x,`${H}.${F}`):x},set:(B,F,x)=>(V(),N&&(N[F]=x),!0),deleteProperty:(B,F)=>(V(),N&&delete N[F],!0),defineProperty:(B,F,x)=>(V(),N&&Object.defineProperty(N,F,x),!0)}):z};M=R(M,_)}return M},update:(_,L,M,U)=>{_=a?`${a}.${_}`:_;const R=s(M);return L!==void 0?this._proxy.$updateConfigurationOption(R,_,L,u,U):this._proxy.$removeConfigurationOption(R,_,u,U)},inspect:_=>{_=a?`${a}.${_}`:_;const L=(0,l.deepClone)(this._configuration.inspect(_,u,this._extHostWorkspace.workspace));if(L)return{key:_,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof n=="object"&&(0,l.mixin)(h,n,!1),Object.freeze(h)}_toReadonlyValue(a){const r=o=>(0,D.isObject)(o)?new Proxy(o,{get:(u,n)=>r(u[n]),set:(u,n,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(a)}_validateConfigurationAccess(a,r,o){const u=E.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),n=o?`[${o.value}] `:"";if(u===4){typeof r?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){r?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const o=new I.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,n)=>o.affectsConfiguration(u,c(n))})}_toMap(a){return a.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[72],Ie([1,0,2,18,3,5,7,33,57,34,21,40,16,25,4,14,10,13,67,236,11]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(H){function N(B){if(B!=null)return B}H.from=N;function V(B){if(B!=null)return B}H.to=V})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(H){function N(B){if(B!=null)return B}H.from=N;function V(B){if(B!=null)return B}H.to=V})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(H){function N(B){if(B!=null)return B}H.from=N;function V(B){if(B!=null)return B}H.to=V})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(H){function N(F){if(F){const x=F;return x&&!!x.process}else return!1}H.is=N;function V(F){if(F==null)return;const x={process:F.process,args:F.args};return F.options&&(x.options=a.from(F.options)),x}H.from=V;function B(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}H.to=B})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(H){function N(B){if(B!=null)return B}H.from=N;function V(B){if(B!=null)return B}H.to=V})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(H){function N(F){if(F){const x=F;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=N;function V(F){if(F==null)return;const x={};return F.commandLine!==void 0?x.commandLine=F.commandLine:(x.command=F.command,x.args=F.args),F.options&&(x.options=o.from(F.options)),x}H.from=V;function B(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}H.to=B})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var n;(function(H){function N(F){if(F){const x=F;return x&&x.customExecution==="customExecution"}else return!1}H.is=N;function V(F){return{customExecution:"customExecution"}}H.from=V;function B(F,x){return x.get(F)}H.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(H){function N(V,B){let F;return V.scope!==void 0&&typeof V.scope!="number"?F=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&B&&B.workspaceFile?F=B.workspaceFile:F=f.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:F}}H.from=N})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(H){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}H.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(H){function N(F,x){if(F==null)return[];const $=[];for(const Q of F){const K=V(Q,x);K&&$.push(K)}return $}H.fromMany=N;function V(F,x){if(F==null)return;let $;F.execution instanceof y.ProcessExecution?$=r.from(F.execution):F.execution instanceof y.ShellExecution?$=u.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&($=n.from(F.execution));const Q=i.from(F.definition);let K;return F.scope?typeof F.scope=="number"?K=F.scope:K=F.scope.uri:K=y.TaskScope.Workspace,!Q||!K?void 0:{_id:F._id,definition:Q,name:F.name,source:{extensionId:x.identifier.value,label:F.source,scope:K},execution:$,isBackground:F.isBackground,group:h.from(F.group),presentationOptions:d.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}H.from=V;async function B(F,x,$){if(F==null)return;let Q;r.is(F.execution)?Q=r.to(F.execution):u.is(F.execution)?Q=u.to(F.execution):n.is(F.execution)&&(Q=n.to(F._id,$));const K=i.to(F.definition);let de;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?de=F.source.scope:de=await x.resolveWorkspaceFolder(l.URI.revive(F.source.scope)):de=y.TaskScope.Workspace),!K||!de)return;const ee=new y.Task(K,de,F.name,F.source.label,Q,F.problemMatchers);return F.isBackground!==void 0&&(ee.isBackground=F.isBackground),F.group!==void 0&&(ee.group=y.TaskGroup.from(F.group._id),ee.group&&F.group.isDefault&&(ee.group=new y.TaskGroup(ee.group.id,ee.group.label),F.group.isDefault===!0&&(ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ee.presentationOptions=d.to(F.presentationOptions)),F._id&&(ee._id=F._id),F.detail&&(ee.detail=F.detail),ee}H.to=B})(_=e.TaskDTO||(e.TaskDTO={}));var L;(function(H){function N(B){return B}H.from=N;function V(B){if(!!B)return Object.assign(Object.create(null),B)}H.to=V})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(N,V,B){this._id=V,this._task=B,p.set(this,void 0),tt(this,p,N,"f")}get task(){return this._task}terminate(){Be(this,p,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}p=new WeakMap;var U;(function(H){function N(V){return{id:V._id,task:void 0}}H.from=N})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(N,V,B,F,x,$,Q,K){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=F,this._configurationService=x,this._terminalService=$,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,B){if(!B)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:V,provider:B,extension:N}),this._proxy.$registerTaskProvider(F,V),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(L.from(N)).then(async V=>{const B=[];for(const F of V){const x=await _.to(F,this._workspaceProvider,this._providedCustomExecutions2);x&&B.push(x)}return B})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,B){const F=this._providedCustomExecutions2.get(N.id);F&&(this._activeCustomExecutions2.set(N.id,F),this._terminalService.attachPtyToTerminal(V,await F.callback(B))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));const F=[],x=(0,t.asPromise)(()=>B.provider.provideTasks(A.CancellationToken.None)).then($=>this.provideTasksInternal(V,F,B,$));return new Promise($=>{x.then(Q=>{Promise.all(F).then(()=>{$(Q)})})})}async $resolveTask(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));if(V.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${B.type}].`);const F=await _.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const x=await B.provider.resolveTask(F,A.CancellationToken.None);if(!x)return;this.checkDeprecation(x,B);const $=_.from(x,B.extension);if(!$)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is($.execution)&&await this.addCustomExecution($,x,!0),await this.resolveTaskInternal($)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,B){const F=await this._proxy.$createTaskId(N);!B&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,V.execution)),this._providedCustomExecutions2.set(F,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const B=this._taskExecutionPromises.get(N.id);if(B)return B;const F=new Promise((x,$)=>{function Q(K,de,ee){ee?x(new M(K,de.id,ee)):$("Unexpected: Task does not exist.")}V?Q(this,N,V):_.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,N,K))});return this._taskExecutionPromises.set(N.id,F),F.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const B=this._notProvidedCustomExecutions.values();let F=B.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=B.next()}};R=je([$e(0,w.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,m.ILogService),$e(7,b.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let z=class extends R{constructor(N,V,B,F,x,$,Q,K){super(N,V,B,F,x,$,Q,K),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const B=_.from(V,N);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.addCustomExecution(B,V,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),V);return this._proxy.$executeTask(B).catch(x=>{throw new Error(x)}),F}provideTasksInternal(N,V,B,F){const x=[];if(F)for(const $ of F){this.checkDeprecation($,B),(!$.definition||!N[$.definition.type])&&this._logService.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=_.from($,B.extension);Q&&n.is(Q.execution)?(x.push(Q),V.push(this.addCustomExecution(Q,$,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:B.extension}}async resolveTaskInternal(N){if(n.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,B){}};z=je([$e(0,w.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,m.ILogService),$e(7,b.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(De[281],Ie([1,0,9,21,50,37,22,51,30]),function(J,e,l,t,C,P,y,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(w,T,S){this.config=w,this.provider=T,this.sessionToken=S,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&P.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&P.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const T=this.config.folderQueries||[];return new Promise((S,g)=>{const v=m=>{this.resultCount++,w(m)};if(this.isCanceled)return S({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const b=m.toString(),f=l.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,f)||this.matchFile(v,{base:m,basename:f})}),Promise.all(T.map(m=>this.searchInFolder(m,v))).then(m=>{S({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{g(new Error((0,C.toErrorMessage)(m)))})})}async searchInFolder(w,T){const S=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(w),v=this.initDirectoryTree(),m=new E.QueryGlobTester(this.config,w),b=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(S),f=I.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,S.token),p=f.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const a=l.posix.relative(w.folder.path,d.path);if(b){const r=l.basename(d.path);this.matchFile(T,{base:w.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(v,w.folder,a,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,m,T),{providerTime:p,postProcessTime:i.elapsed()})}finally{S.dispose(),this.activeCancellationTokens.delete(S)}}getSearchOptionsForFolder(w){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),S=(0,E.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:S,includes:T,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},T,S,g){if(S===this.filePattern){const m=l.basename(this.filePattern);this.matchFile(g,{base:T,relativePath:this.filePattern,basename:m})}function v(m){const b=l.basename(m),f=l.dirname(m);let c=w[f];c||(c=w[f]=[],v(f)),c.push({base:T,relativePath:m,basename:b})}v(S)}matchDirectoryTree({rootEntries:w,pathToEntries:T},S,g){const v=this,m=this.filePattern;function b(f){const c=(0,E.hasSiblingFn)(()=>f.map(p=>p.basename));for(let p=0,i=f.length;p<i;p++){const d=f[p],{relativePath:a,basename:r}=d;if(S.matchesExcludesSync(a,r,m!==r?c:void 0))continue;const o=T[a];if(o)b(o);else{if(a===m)continue;v.matchFile(g,d)}if(v.isLimitHit)break}}b(w)}matchFile(w,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(T))}}class A{constructor(){this.sessions=new Map}fileSearch(w,T,S,g){const v=this.getSessionTokenSource(w.cacheKey),m=new D(w,T,v&&v.token);let b=0;const f=c=>{b+=c.length,S(c.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(m,A.BATCH_SIZE,f,g).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:c.stats}}))}clearCache(w){this.getSessionTokenSource(w)?.cancel()}getSessionTokenSource(w){if(!!w)return this.sessions.has(w)||this.sessions.set(w,new t.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:y.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,T,S,g){g.onCancellationRequested(()=>{w.cancel()});const v=b=>{b&&(m.push(b),T>0&&m.length>=T&&(S(m),m=[]))};let m=[];return w.search(v).then(b=>(m.length&&S(m),b),b=>(m.length&&S(m),Promise.reject(b)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(De[282],Ie([1,0,17,77,37,110,26,14,9,22,8,12,2,160,187,65,13,45,131,280,30]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(h,_,L,M,U){this.configurationService=h,this.workspaceContextService=_,this.editorGroupsService=L,this.logService=M,this.pathService=U}text(h,_,L={}){h=this.getContentPattern(h,L);const M=this.configurationService.getValue(),U=_&&_.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(_?.map(m.toWorkspaceFolder),L),type:2,contentPattern:h,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:M.search.usePCRE2||U||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(h,_){const L=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(h,_)&&(M.isCaseSensitive=!0),this.isMultiline(h)&&(M.isMultiline=!0),M}file(h,_={}){return{...this.commonQuery(h,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(h,_){return h?(h=Array.isArray(h)?h.map(o):o(h),_?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],_={}){const L=this.handleIncludeExclude(_.includePattern,_.expandPatterns),M=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),U=h.length>1,R=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,_,M)):h.map(N=>this.getFolderQueryForRoot(N,_,M,U))).filter(N=>!!N),z={_reason:_._reason,folderQueries:R,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:M.pattern,includePattern:L.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const V=N.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath)),B=this.commonQueryFromFileList(V);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...z,...B}}const H=_.extraFileResources&&_.extraFileResources.filter(N=>(0,c.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=H&&H.length?H:void 0,z}commonQueryFromFileList(h){const _=[],L=new y.ResourceMap,M={};let U=!1;return h.forEach(R=>{if(R.scheme===I.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(R)){const H=this.workspaceContextService.getWorkspaceFolder(R)?.uri??R.with({path:E.dirname(R.fsPath)});let N=L.get(H);N||(U=!0,N={folder:H,includePattern:{}},_.push(N),L.set(H,N));const V=E.relative(H.fsPath,R.fsPath);(0,k.assertIsDefined)(N.includePattern)[V.replace(/\\/g,"/")]=!0}else R.fsPath&&(U=!0,M[R.fsPath]=!0)}),{folderQueries:_,includePattern:M,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(h,_){if(_.isSmartCase){if(h.isRegExp){if(A.containsUppercaseCharacter(h.pattern,!0))return!0}else if(A.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const _=B=>E.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(h)?h:a(h)).map(B=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(B,F.scheme===I.Schemas.file?F.fsPath:F.path):B}),U=t.groupBy(M,B=>_(B)?"searchPaths":"exprSegments"),R=(U.exprSegments||[]).map(B=>A.rtrim(B,"/")).map(B=>A.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),r(B))),z={},H=this.expandSearchPathPatterns(U.searchPaths||[]);H&&H.length&&(z.searchPaths=H);const N=l.flatten(R),V=d(...N);return V&&(z.pattern=V),z}getExcludesForFolder(h,_){return _.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const _=l.flatten(h.map(M=>{let{pathPortion:U,globPortion:R}=i(M);R&&(R=u(R));const z=this.expandOneSearchPath(U);return l.flatten(z.map(H=>this.resolveOneSearchPathPattern(H,R)))})),L=new Map;return _.forEach(M=>{const U=M.searchPath.toString(),R=L.get(U);R?M.pattern&&(R.pattern=R.pattern||{},R.pattern[M.pattern]=!0):L.set(U,{searchPath:M.searchPath,pattern:M.pattern?d(M.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(h){if(E.isAbsolute(h)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==I.Schemas.file?[{searchPath:_[0].uri.with({path:h})}]:[{searchPath:w.URI.file(E.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=o(h),h.startsWith("../")||h===".."){const M=E.posix.resolve(_.path,h);return[{searchPath:_.with({path:M})}]}const L=u(h);return[{searchPath:_,pattern:L}]}else{if(h==="./"||h===".\\")return[];{const _=h.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(U=>{const R=_.match(new RegExp(`^${A.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return R?{match:R,folder:U}:null}).filter(k.isDefined);if(M.length)return M.map(U=>{const R=U.match[1];return{searchPath:U.folder.uri,pattern:R&&u(R)}});{const U=h.match(/\.[\/\\](.+)[\/\\]?/),R=U?U[1]:h,z=S.localize(0,null,R);throw new Error(z)}}}}resolveOneSearchPathPattern(h,_){const L=h.pattern&&_?`${h.pattern}/${_}`:h.pattern||_,M=[{searchPath:h.searchPath,pattern:L}];return L&&!L.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:L+"/**"}),M}getFolderQueryForSearchPath(h,_,L){const M=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(h.searchPath),_,L,!1);return M?{...M,includePattern:h.pattern}:null}getFolderQueryForRoot(h,_,L,M){let U;const R=w.URI.isUri(h)?h:h.uri;if(L.searchPaths){const B=L.searchPaths.filter(F=>(0,D.isEqual)(F.searchPath,R))[0];if(B&&!B.pattern)return null;B&&(U=B.pattern)}const z=this.configurationService.getValue({resource:R}),N={...this.getExcludesForFolder(z,_)||{},...U||{}},V=w.URI.isUri(h)?(0,D.basename)(h):h.name;return{folder:R,folderName:M?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!z.search.followSymlinks}}};p=je([$e(0,g.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,v.ILogService),$e(4,f.IPathService)],p),e.QueryBuilder=p;function i(s){const h=s.match(/[\*\{\}\(\)\[\]\?]/);if(h){const _=h.index,L=s.substr(0,_).match(/[/|\\][^/\\]*$/);if(L){let M=s.substr(0,L.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:s.substr((L.index||0)+1)}}}return{pathPortion:s}}function d(...s){return s.length?s.reduce((h,_)=>(h[_]=!0,h),Object.create(null)):void 0}function a(s){return C.splitGlobAware(s,",").map(h=>h.trim()).filter(h=>!!h.length)}function r(s){return[`**/${s}/**`,`**/${s}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function o(s){return s.replace(/\\/g,"/")}function u(s){return o(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(s,h){s=l.distinct(s,M=>M.toString());const _=[],L=h.getWorkspace();return s&&s.forEach(M=>{let U;if(h.getWorkbenchState()===2)U=(0,D.relativePath)(L.folders[0].uri,M),U&&U!=="."&&(U="./"+U);else{const R=h.getWorkspaceFolder(M);if(R){const z=R.name;if(L.folders.filter(N=>N.name===z).length===1){const N=(0,D.relativePath)(R.uri,M);N===""?U=`./${R.name}`:U=`./${R.name}/${N}`}else U=M.fsPath}}U&&_.push(U)}),_}e.resolveResourcesForSearchIncludes=n}),define(De[283],Ie([1,0,22,2,21,11,4,282,30,45]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(g,v){const m=v.activationEvents;if(!m)return Promise.resolve(void 0);const b=[],f=[];for(const r of m)if(/^workspaceContains:/.test(r)){const o=r.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||g.forceUsingSearch?f.push(o):b.push(o)}if(b.length===0&&f.length===0)return Promise.resolve(void 0);let c;const p=new Promise((r,o)=>{c=r}),i=r=>c({activationEvent:r}),d=Promise.all(b.map(r=>w(g,r,i))).then(()=>{}),a=T(g,v.identifier,f,i);return Promise.all([d,a]).then(()=>{c(void 0)}),p}e.checkActivateWorkspaceContainsExtension=k;async function w(g,v,m){for(const b of g.folders)if(await g.exists(l.joinPath(t.URI.revive(b),v))){m(`workspaceContains:${v}`);return}}async function T(g,v,m,b){if(m.length===0)return Promise.resolve(void 0);const f=new C.CancellationTokenSource,c=g.checkExists(g.folders,m,f.token),p=setTimeout(async()=>{f.cancel(),g.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},A);let i=!1;try{i=await c}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}f.dispose(),clearTimeout(p),i&&b(`workspaceContains:${m.join(",")}`)}function S(g,v,m,b){const f=g.get(y.IInstantiationService),c=g.get(E.ISearchService),i=f.createInstance(I.QueryBuilder).file(v.map(d=>(0,D.toWorkspaceFolder)(t.URI.revive(d))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(i,b).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[41],Ie([1,0,171,9,73,22,18,6,26,2,13,5,34,226,95,33,28,224,11,27,23,207,7,126,4,25,69,16,84,53,40,3,283,94,209,14,93]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p,i,d,a,r,o,u,n,s,h,_,L,M,U,R,z){"use strict";var H,N,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let B=class Nn extends I.Disposable{constructor(ee,he,Y,me,be,ke,Re,ze,oe,le,ge){super(),this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=me,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new m.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,v.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new m.ExtensionDescriptionRegistry($(this._globalRegistry,Z)),this._storage=new S.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=ee.createChild(new n.ServiceCollection([S.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(O=>!O.main&&!O.browser).map(O=>O.identifier),ne=this._initData.allExtensions.filter(O=>!Z.has(f.ExtensionIdentifier.toKey(O.identifier.value))).filter(O=>(O.main||O.browser)&&O.api==="none").map(O=>O.identifier));const ie=(0,v.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(O,j,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,b.transformErrorForSerialization(j),G)},actualActivateExtension:async(O,j)=>{if(ie.has(f.ExtensionIdentifier.toKey(O)))return await this._mainThreadExtensionsProxy.$activateExtension(O,j),new T.HostExtension;const G=this._myRegistry.getExtensionDescription(O);return this._activateExtension(G,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){b.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(ee)}terminate(ee,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),b.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const he=await this._mainThreadExtensionsProxy.$getExtension(ee);let Y;if(he?.browserNlsBundleUris){Y={};for(const me of Object.keys(he.browserNlsBundleUris))Y[me]=D.URI.revive(he.browserNlsBundleUris[me])}return he&&{...he,identifier:new f.ExtensionIdentifier(he.identifier.value),extensionLocation:D.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ee,he){return this._activator.activateByEvent(ee,he)}_activateById(ee,he){return this._activator.activateById(ee,he)}activateByIdWithErrors(ee,he){return this._activateById(ee,he).then(()=>{const Y=this._activator.getActivatedExtension(ee);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==R.Schemas.file)return ee;const he=await this._hostUtils.realpath(ee.fsPath);return D.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new K(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const he=E.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ee.map(async Y=>{if(this._getEntryPoint(Y)){const me=await this._realPathExtensionUri(Y.extensionLocation);he.set(me,Y)}})),he}_deactivate(ee){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return he;const Y=this._activator.getActivatedExtension(ee);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(me)}try{(0,I.dispose)(Y.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(me)}return he}async _activateExtension(ee,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,he).then(Y=>{const me=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,he),this._logExtensionActivationTimes(ee,he,"success",me),Y},Y=>{throw this._logExtensionActivationTimes(ee,he,"failure"),Y})}_logExtensionActivationTimes(ee,he,Y,me){const be=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...me||{},outcome:Y})}_doActivateExtension(ee,he){const Y=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const me=this._getEntryPoint(ee);if(!me)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${ee.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const be=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(ee,(0,P.joinPath)(ee.extensionLocation,me),be),this._loadExtensionContext(ee)]).then(ke=>(C.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Nn._callActivate(this._logService,ee.identifier,ke[0],ke[1],be))).then(ke=>(C.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),ke))}_loadExtensionContext(ee){const he=new p.ExtensionGlobalMemento(ee,this._storage),Y=new p.ExtensionMemento(ee.identifier.value,!1,this._storage),me=new U.ExtensionSecrets(ee,this._secretState),be=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,oe;const le=(0,v.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:me,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(ge){return t.join(ee.extensionLocation.fsPath,ge)},get storagePath(){return Re._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(ee).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return D.URI.joinPath(Re._initData.logsLocation,ee.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(ee)},get globalStorageUri(){return Re._storagePath.globalValue(ee)},get extensionMode(){return be},get extension(){return ze===void 0&&(ze=new x(Re,ee.identifier,ee,ke,!1)),ze},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(ee,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!oe){if(!le)return;const ge=_.Event.buffer(_.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:ge,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(ee,he,Y,me,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,he,Y,me,be).then(ke=>new T.ActivatedExtension(!1,null,be.build(),Y,ke,me.subscriptions))}static _callActivateOptional(ee,he,Y,me,be){if(typeof Y.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[me]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(ze=>(be.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(ee,he){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:he}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const he of ee.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(ee,he)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(he),me=Promise.all([ee,Y]).then(()=>{});return Promise.race([me,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(ee,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,he){if(this.isActivated(he.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:ee.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},be=await(0,L.checkActivateWorkspaceContainsExtension)(me,he);if(!!be)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:he}=this._initData.environment;if(!ee||!he)throw new Error(l.localize(0,null));const Y=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(l.localize(1,null,he.toString()));return new Promise((me,be)=>{const ke=(oe,le)=>{oe?be(oe):me(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(he),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{me(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,he){return this._resolvers[ee]=he,(0,I.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const he=ee.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=ee.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ee,he){this._logService.info(`$resolveAuthority invoked for authority (${Q(ee)})`);const{authorityPrefix:Y,resolver:me}=await this._activateAndGetResolver(ee);if(!me)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),C.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await me.resolve(ee,{resolveAttempt:he});C.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:ee,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(C.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(ee,he){this._logService.info(`$getCanonicalURI invoked for authority (${Q(ee)})`);const{resolver:Y}=await this._activateAndGetResolver(ee);if(!Y)return null;const me=D.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return me;const be=await(0,y.asPromise)(()=>Y.getCanonicalURI(me));return be||me}static _applyExtensionsDelta(ee,he,Y){const me=new m.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());me.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,v.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(f.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(f.ExtensionIdentifier.toKey(Re));const ke=$(me,be);return{globalRegistry:me,myExtensions:ke}}$startExtensionHost(ee){ee.toAdd.forEach(me=>me.extensionLocation=D.URI.revive(me.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ee,he){return he===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ee,!1))}async $activate(ee,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,he),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(ke=>ke.extensionLocation=D.URI.revive(ke.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),me=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const he=c.VSBuffer.alloc(ee),Y=Math.random()%256;for(let me=0;me<ee;me++)he.writeUInt8(Y,me);return he}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};B=je([$e(0,a.IInstantiationService),$e(1,e.IHostUtils),$e(2,u.IExtHostRpcService),$e(3,g.IExtHostWorkspace),$e(4,w.IExtHostConfiguration),$e(5,A.ILogService),$e(6,r.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,s.IExtHostTunnelService),$e(9,h.IExtHostTerminalService),$e(10,z.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function F(de,ee){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class x{constructor(ee,he,Y,me,be){H.set(this,void 0),N.set(this,void 0),V.set(this,void 0),tt(this,H,ee,"f"),tt(this,N,he,"f"),tt(this,V,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=me,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,H,"f").isActivated(Be(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,H,"f").getExtensionExports(Be(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,H,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,H=new WeakMap,N=new WeakMap,V=new WeakMap;function $(de,ee){return de.getAllExtensionDescriptions().filter(he=>ee.has(f.ExtensionIdentifier.toKey(he.identifier)))}function Q(de){const ee=de.indexOf("+");return ee===-1?de:de.substring(0,ee)}class K{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=K}),define(De[284],Ie([1,0,73,2,5,34,28,27,16,25,4,41,36,13,8]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(p,i,d,a,r,o,u){this._apiFactory=p,this._extensionRegistry=i,this._instaService=d,this._extHostConfiguration=a,this._extHostExtensionService=r,this._initData=o,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,i,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(b,i)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,i,this._initData.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this._factories.set(i,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(i=>p.alternativeModuleName(i))}};g=je([$e(2,A.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,T.ILogService)],g),e.RequireInterceptor=g;let v=class Yn{constructor(p){if(p.environment.appRoot&&Yn.aliased.size){const i=(0,S.escapeRegExpCharacters)(this.forceForwardSlashes(p.environment.appRoot.fsPath)),d="[a-z0-9_.-]",a=`@${d}+\\/${d}+|${d}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${r}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(p){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(p));if(!i)return;const[,d,a,r]=i,o=Yn.aliased.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),d+o+r}forceForwardSlashes(p){return p.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=je([$e(0,D.IExtHostInitDataService)],v);class m{constructor(p,i,d,a,r){this._apiFactory=p,this._extensionPaths=i,this._extensionRegistry=d,this._configProvider=a,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,i){const d=this._extensionPaths.findSubstr(i);if(d){let a=this._extApiImpl.get(I.ExtensionIdentifier.toKey(d.identifier));return a||(a=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(d.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((r,o)=>a+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(p,i,d){this._extensionPaths=p,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(C.MainContext.MainThreadTelemetry);const{environment:a}=d,r=i.getProxy(C.MainContext.MainThreadKeytar);if(a.appRoot){let o=a.appRoot.fsPath;w.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,u)=>r.$getPassword(o,u),setPassword:(o,u,n)=>r.$setPassword(o,u,n),deletePassword:(o,u)=>r.$deletePassword(o,u),findPassword:o=>r.$findPassword(o),findCredentials(o){return r.$findCredentials(o)}}}load(p,i){const d=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(p){const i=p.length;if(i<=7||!this.alternativeNames)return;const d=i-7;if((p.charAt(d)==="/"||p.charAt(d)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}};b=je([$e(1,E.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],b);let f=class{constructor(p,i,d){this._extensionPaths=p,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(C.MainContext.MainThreadTelemetry);const a=d.getProxy(C.MainContext.MainThreadWindow);this._impl=(r,o)=>{const u=t.URI.parse(r);return o?this.callOriginal(r,o):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,r,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?a.$openUri(u,r,{}):this.callOriginal(r,o)}}load(p,i,d){const a=this._extensionPaths.findSubstr(i);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=d(p),this._impl}callOriginal(p,i){return this.sendNoForwardTelemetry(),this._original(p,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=je([$e(2,E.IExtHostRpcService)],f)}),define(De[47],Ie([1,0,78,6,9,36,4,57,58,41,7,33,221,34]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class S extends w.AbstractVariableResolverService{constructor(m,b,f,c,p,i,d){function a(){if(f){const r=f.activeEditor();if(r)return r.document.uri;const o=c.tabGroups.all.find(u=>u.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof A.TextDiffTabInput||o.input instanceof A.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof A.TextTabInput||o.input instanceof A.NotebookEditorTabInput||o.input instanceof A.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:r=>{const o=i.folders.filter(u=>u.name===r);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(r,o)=>p.getConfiguration(void 0,r).get(o),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=a();if(r)return C.normalize(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const r=a();if(r){const o=b.getWorkspaceFolder(r);if(o)return C.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(f){const r=f.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(f){const r=f.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>m.getExtension(r)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let g=class extends t.Disposable{constructor(m,b,f,c,p){super(),this.extensionService=m,this.workspaceService=b,this.editorService=f,this.configurationService=c,this.editorTabs=p,this._resolver=new l.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),a={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async r=>{a.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new S(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,a,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};g=je([$e(0,D.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,I.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs)],g),e.ExtHostVariableResolverProviderService=g}),define(De[74],Ie([1,0,18,3,12,2,4,5,58,41,16,7,33,129,214,34,47]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(a,r,o,u,n,s){this._workspaceService=r,this._extensionService=o,this._configurationService=u,this._editorTabs=n,this._variableResolver=s,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=a.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(_=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}asDebugSourceUri(a,r){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let u=`debug:${encodeURIComponent(o.path||"")}`,n="?";return r&&(u+=`${n}session=${encodeURIComponent(r.id)}`,n="&"),u+=`${n}ref=${o.sourceReference}`,P.URI.parse(u)}else{if(o.path)return P.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const r=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,S.isDebuggerMainContribution)(n)&&r.push(n.type)}this._debugServiceProxy.$registerDebugTypes(r)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(r=>a.push(r)),a}addBreakpoints(a){this.startBreakpoints();const r=a.filter(n=>{const s=n.id;return this._breakpoints.has(s)?!1:(this._breakpoints.set(s,n),!0)});this.fireBreakpointChanges(r,[],[]);const o=[],u=new Map;for(const n of r)if(n instanceof k.SourceBreakpoint){let s=u.get(n.location.uri.toString());s||(s={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),s),o.push(s)),s.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&o.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(a){this.startBreakpoints();const r=a.filter(s=>this._breakpoints.delete(s.id));this.fireBreakpointChanges([],r,[]);const o=r.filter(s=>s instanceof k.SourceBreakpoint).map(s=>s.id),u=r.filter(s=>s instanceof k.FunctionBreakpoint).map(s=>s.id),n=r.filter(s=>s instanceof k.DataBreakpoint).map(s=>s.id);return this._debugServiceProxy.$unregisterBreakpoints(o,u,n)}startDebugging(a,r,o){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,r,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,r,o){if(!r)return new k.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:u,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,o,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,u),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,r,o){if(!o)return new k.Disposable(()=>{});if(!this.definesDebugType(a,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:u,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,u),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,r){if(!r)return new k.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:o,factory:r}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==r)})}async $runInTerminal(a,r){return Promise.resolve(void 0)}async $substituteVariables(a,r){let o;const u=await this.getFolder(a);return u&&(o={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,r)}createDebugAdapter(a,r){if(a.type==="implementation")return new p(a.implementation)}createSignService(){}async $startDASession(a,r){const o=this,u=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const s=this.convertToDto(n),h=this.createDebugAdapter(s,u);if(!h)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const _=h;return this._debugAdapters.set(a,_),this.getDebugAdapterTrackers(u).then(L=>(L&&this._debugAdaptersTrackers.set(a,L),_.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const U=M,R={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(U.arguments.value);R.body={signature:z},_.sendResponse(R)}else throw new Error("no signer")}catch(z){R.success=!1,R.message=z.message,_.sendResponse(R)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,S.convertToVSCPaths)(M,!0),o._debugServiceProxy.$acceptDAMessage(a,M)}),_.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(a,M.name,M.message,M.stack)}),_.onExit(M=>{L&&L.onExit&&L.onExit((0,C.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,C.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),_.startSession()))})}$sendDAMessage(a,r){r=(0,S.convertToDAPaths)(r,!1);const o=this._debugAdaptersTrackers.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(r),this._debugAdapters.get(a)?.sendMessage(r)}$stopDASession(a){const r=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),r&&r.onWillStopSession&&r.onWillStopSession();const o=this._debugAdapters.get(a);return this._debugAdapters.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const r=[],o=[],u=[];if(a.added)for(const n of a.added){const s=n.id;if(s&&!this._breakpoints.has(s)){let h;if(n.type==="function")h=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")h=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const _=P.URI.revive(n.uri);h=new k.SourceBreakpoint(new k.Location(_,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}h._id=s,this._breakpoints.set(s,h),r.push(h)}}if(a.removed)for(const n of a.removed){const s=this._breakpoints.get(n);s&&(this._breakpoints.delete(n),o.push(s))}if(a.changed){for(const n of a.changed)if(n.id){const s=this._breakpoints.get(n.id);if(s){if(s instanceof k.FunctionBreakpoint&&n.type==="function"){const h=s;h.enabled=n.enabled,h.condition=n.condition,h.hitCondition=n.hitCondition,h.logMessage=n.logMessage,h.functionName=n.functionName}else if(s instanceof k.SourceBreakpoint&&n.type==="source"){const h=s;h.enabled=n.enabled,h.condition=n.condition,h.hitCondition=n.hitCondition,h.logMessage=n.logMessage,h.location=new k.Location(P.URI.revive(n.uri),new k.Position(n.line,n.character))}u.push(s)}}}this.fireBreakpointChanges(r,o,u)}$provideDebugConfigurations(a,r,o){return(0,l.asPromise)(async()=>{const u=this.getConfigProviderByHandle(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(r);return u.provideDebugConfigurations(n,o)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,r,o,u){return(0,l.asPromise)(async()=>{const n=this.getConfigProviderByHandle(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.getFolder(r);return n.resolveDebugConfiguration(s,o,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,r,o,u){return(0,l.asPromise)(async()=>{const n=this.getConfigProviderByHandle(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.getFolder(r);return n.resolveDebugConfigurationWithSubstitutedVariables(s,o,u)})}async $provideDebugAdapter(a,r){const o=this.getAdapterDescriptorFactoryByHandle(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(r);return this.getAdapterDescriptor(o,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(a){const r=await this.getSession(a);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(a){const r=await this.getSession(a);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,r){(await this.getSession(a))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(a,r){const u={session:await this.getSession(a),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const r=this._adapterFactories.filter(o=>o.type===a);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(a){const r=this._adapterFactories.filter(o=>o.handle===a);if(r.length>0)return r[0].factory}getConfigProviderByHandle(a){const r=this._configProviders.filter(o=>o.handle===a);if(r.length>0)return r[0].provider}definesDebugType(a,r){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const u of o)if(u.label&&u.type&&u.type===r)return!0}}return!1}getDebugAdapterTrackers(a){const o=a.configuration.type,u=this._trackerFactories.filter(n=>n.type===o||n.type==="*").map(n=>(0,l.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(s=>s,s=>null));return Promise.race([Promise.all(u).then(n=>{const s=n.filter(h=>!!h);if(s.length>0)return new c(s)}),new Promise((n,s)=>{const h=setTimeout(()=>{clearTimeout(h),s(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(a,r){const o=r.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new k.DebugAdapterServer(o));if(a){const n=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>a.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,n))).then(s=>{if(s)return s})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,u))}daExecutableFromPackage(a,r){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,r,o){(a.length>0||r.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:r,changed:o}))}async getSession(a){if(a)if(typeof a=="string"){const r=this._debugSessions.get(a);if(r)return r}else{let r=this._debugSessions.get(a.id);if(!r){const o=await this.getFolder(a.folderUri),u=a.parent?this._debugSessions.get(a.parent):void 0;r=new b(this._debugServiceProxy,a.id,a.type,a.name,o,a.configuration,u),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(a){if(a){const r=P.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};m=je([$e(0,A.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,v.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class b{constructor(a,r,o,u,n,s,h){this._debugServiceProxy=a,this._id=r,this._type=o,this._name=u,this._workspaceFolder=n,this._configuration=s,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,r)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=b;class f{constructor(a){this.value=Object.freeze({append(r){a.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=f;class c{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(r=>r.onError?r.onError(a):void 0)}onExit(a,r){this.trackers.forEach(o=>o.onExit?o.onExit(a,r):void 0)}}class p extends T.AbstractDebugAdapter{constructor(a){super(),this.implementation=a,a.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends m{constructor(a,r,o,u,n,s){super(a,r,o,u,n,s)}};i=je([$e(0,A.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,v.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(De[285],Ie([1,0,11,73,2,5,277,13,83,84,25,193,16,54,41,92]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{static async installEarlyHandler(f){const c=f.get(I.ILogService),i=f.get(w.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(d=>{c.error(d);const a=l.transformErrorForSerialization(d);i.$onUnexpectedError(a)})}static async installFullHandler(f){const c=f.get(I.ILogService),p=f.get(w.IExtHostRpcService),i=f.get(S.IExtHostExtensionService),d=f.get(g.IExtHostTelemetry),a=p.getProxy(P.MainContext.MainThreadExtensionService),r=p.getProxy(P.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,s)=>{let h="",_,L;for(const M of s)h+=`
	at ${M.toString()}`,L=M.getFileName(),!_&&L&&(_=o.findSubstr(C.URI.file(L)));return u.set(n,_?.identifier),`${n.name||"Error"}: ${n.message||""}${h}`},l.setUnexpectedErrorHandler(n=>{c.error(n);const s=l.transformErrorForSerialization(n),h=u.get(n);if(!h){r.$onUnexpectedError(s);return}a.$onExtensionRuntimeError(h,s);const _=d.onExtensionError(h,n);c.trace("forwarded error to extension?",_,h)})}}Error.stackTraceLimit=100;class m{constructor(f,c,p,i,d){this._hostUtils=p,this._rpcProtocol=new y.RPCProtocol(f,null,i),c=m._transform(c,this._rpcProtocol);const a=new D.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());a.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...c,messagePorts:d}),a.set(w.IExtHostRpcService,new w.ExtHostRpcService(this._rpcProtocol)),a.set(T.IURITransformerService,new T.URITransformerService(i)),a.set(S.IHostUtils,p);const r=new k.InstantiationService(a,!0);r.invokeFunction(v.installEarlyHandler),this._logService=r.invokeFunction(o=>o.get(I.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",c),this._extensionService=r.invokeFunction(o=>o.get(S.IExtHostExtensionService)),this._extensionService.initialize(),r.invokeFunction(v.installFullHandler)}async asBrowserUri(f){const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,c){f.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation));const d={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(a=>d[a]=C.URI.revive(c.transformIncomingURIs(i.browserNlsBundleUris[a]))),i.browserNlsBundleUris=d)}),f.environment.appRoot=C.URI.revive(c.transformIncomingURIs(f.environment.appRoot));const p=f.environment.extensionDevelopmentLocationURI;return p&&(f.environment.extensionDevelopmentLocationURI=p.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(f.environment.workspaceStorageHome)),f.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=C.URI.revive(c.transformIncomingURIs(f.logsLocation)),f.logFile=C.URI.revive(c.transformIncomingURIs(f.logFile)),f.workspace=c.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=m}),define(De[286],Ie([1,0,18,10,177,192,200,74,58,41,16,40,7,47,33,215,217,34]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let b=class extends I.ExtHostDebugServiceBase{constructor(d,a,r,o,u,n,s){super(d,a,r,o,n,s),this._terminalService=u,this._integratedTerminalInstances=new p}createDebugAdapter(d,a){switch(d.type){case"server":return new g.SocketDebugAdapter(d);case"pipeServer":return new g.NamedPipeDebugAdapter(d);case"executable":return new g.ExecutableDebugAdapter(d,a.type)}return super.createDebugAdapter(d,a)}daExecutableFromPackage(d,a){const r=g.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),d.type);if(r)return new w.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new y.SignService}async $runInTerminal(d,a){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const r=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0),u=this._terminalService.getDefaultShellArgs(!0),n=d.title||C.localize(0,null),s=JSON.stringify({shell:o,shellArgs:u});let h=await this._integratedTerminalInstances.checkout(s,n),_,L=!1;if(h)_=d.cwd;else{const z={shellPath:o,shellArgs:u,cwd:d.cwd,name:n,iconPath:new w.ThemeIcon("debug")};L=!0,h=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,s)}h.show(!0);const M=await h.processId;L?await new Promise(z=>setTimeout(z,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?h.sendText("cls"):o.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const U=(0,v.prepareCommand)(o,d.args,!!d.argsCanBeInterpretedByShell,_,d.env);h.sendText(U);const R=this.onDidTerminateDebugSession(z=>{z.id===a&&(this._integratedTerminalInstances.free(h),R.dispose())});return M}else if(d.kind==="external")return c(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,a)}};b=je([$e(0,A.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,m.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,E.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let f;function c(i,d){if(!f)if(t.isWindows)f=new P.WindowsExternalTerminalService;else if(t.isMacintosh)f=new P.MacExternalTerminalService;else if(t.isLinux)f=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=d.getConfiguration("terminal");return f.runInTerminal(i.title,i.cwd,i.args,i.env||{},a.external||{})}e.runInExternalTerminal=c;class p{constructor(){this._terminalInstances=new Map}async checkout(d,a){const o=[...this._terminalInstances.entries()].map(([u,n])=>(0,l.createCancelablePromise)(async s=>{if(u.name!==a||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await u.processId))return null;const h=Date.now();return n.lastUsedAt+p.minUseDelay>h||s.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=h,u)}));return await(0,l.firstParallel)(o,u=>!!u)}insert(d,a){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:a})}free(d){const a=this._terminalInstances.get(d);a&&(a.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}p.minUseDelay=1e3}),define(De[287],Ie([1,0,9,2,113,33,57,34,45,40,16,25,72,14,13,67,22,82,47]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends w.ExtHostTaskBase{constructor(p,i,d,a,r,o,u,n,s){super(p,i,d,a,r,o,u,n),this.workspaceService=d,this.variableResolver=s,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,i){const d=i;if(!i.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const a=w.TaskHandleDTO.from(d,this.workspaceService),r=await this._proxy.$getTaskExecution(a);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(r,i);return this._proxy.$executeTask(a).catch(()=>{}),o}else{const a=w.TaskDTO.from(i,p);if(a===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(a.execution)&&await this.addCustomExecution(a,i,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(a),i);return this._proxy.$executeTask(a).catch(()=>{}),r}}provideTasksInternal(p,i,d,a){const r=[];if(a)for(const o of a){this.checkDeprecation(o,d),(!o.definition||!p[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const u=w.TaskDTO.from(o,d.extension);u&&(r.push(u),w.CustomExecutionDTO.is(u.execution)&&i.push(this.addCustomExecution(u,o,!0)))}return{tasks:r,extension:d.extension}}async resolveTaskInternal(p){return p}async getAFolder(p){let i=p&&p.length>0?p[0]:void 0;if(!i){const d=t.URI.file((0,m.homedir)());i=new E.WorkspaceFolder({uri:d,name:v.basename(d),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,i){const d=t.URI.revive(p),a={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(d),o=await this._workspaceProvider.getWorkspaceFolders2()??[],u=await this.variableResolver.getResolver(),n=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(const s of i.variables)a.variables[s]=await u.resolveAsync(n,s);if(i.process!==void 0){let s;if(i.process.path!==void 0){s=i.process.path.split(l.delimiter);for(let h=0;h<s.length;h++)s[h]=await u.resolveAsync(n,s[h])}a.process=await C.win32.findExecutable(await u.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await u.resolveAsync(n,i.process.cwd):void 0,s)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(p,i,d){return C.win32.findExecutable(p,i,d)}};f=je([$e(0,A.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,S.ILogService),$e(7,g.IExtHostApiDeprecationService),$e(8,b.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(De[288],Ie([1,0,82,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class C extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=C}),define(De[140],Ie([1,0,17,18,21,50,14,9,22,2,30]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(b,f,c,p){this.query=b,this.provider=f,this.fileUtils=c,this.processType=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,f){const c=this.query.folderQueries||[],p=new C.CancellationTokenSource;return f.onCancellationRequested(()=>p.cancel()),new Promise((i,d)=>{this.collector=new T(b);let a=!1;const r=(o,u)=>{if(!a&&!this.isLimitHit){const n=this.resultSize(o);g(o)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,a=!0,p.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const s=this.resultSize(o);this.resultCount+=s,(s>0||!g(o))&&this.collector.add(o,u)}};Promise.all(c.map((o,u)=>this.searchInFolder(o,n=>r(n,u),p.token))).then(o=>{p.dispose(),this.collector.flush();const u=o.some(n=>!!n&&!!n.limitHit);i({limitHit:this.isLimitHit||u,messages:(0,l.flatten)(o.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},o=>{p.dispose();const u=(0,P.toErrorMessage)(o);d(new Error(u))})})}resultSize(b){return g(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,f){const c=Array.isArray(b.ranges)?b.ranges:[b.ranges],p=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:c.slice(0,f),preview:{matches:p.slice(0,f),text:b.preview.text},uri:b.uri}}async searchInFolder(b,f,c){const p=new A.QueryGlobTester(this.query,b),i=[],d={report:o=>{if(!this.validateProviderResult(o))return;const u=b.folder.scheme===y.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(o.uri))):void 0,n=E.relativePath(b.folder,o.uri);if(n){const s=p.includedInQuery(n,I.basename(n),u);(0,t.isThenable)(s)?i.push(s.then(h=>{h&&f(o)})):s&&f(o)}}},a=this.getSearchOptionsForFolder(b),r=await this.provider.provideTextSearchResults(w(this.query.contentPattern),a,d,c);return i.length&&await Promise.all(i),r}validateProviderResult(b){if(g(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const f=(0,A.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),c=(0,A.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),p={folder:D.URI.from(b.folder),excludes:c,includes:f,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=k;function w(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class T{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,f=>this.sendItems(f))}add(b,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!E.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(S(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=T;function S(m){return g(m)?{preview:{matches:(0,l.mapArrayOrNot)(m.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:m.preview.text},ranges:(0,l.mapArrayOrNot)(m.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function g(m){return!!m.preview}e.extensionResultIsMatch=g;class v{constructor(b,f){this.maxBatchSize=b,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,f){!b||this.addItemToBatch(b,f)}addItems(b,f){!b||this.addItemsToBatch(b,f)}addItemToBatch(b,f){this.batch.push(b),this.batchSize+=f,this.onUpdate()}addItemsToBatch(b,f){this.batch=this.batch.concat(b),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(De[75],Ie([1,0,6,5,4,281,16,54,13,2,140]),function(J,e,l,t,C,P,y,I,E,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(g,v,m){this.extHostRpc=g,this._uriTransformer=v,this._logService=m,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,v){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const m=this._handlePool++;return this._textSearchProvider.set(m,v),this._proxy.$registerTextSearchProvider(m,this._transformScheme(g)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(g,v){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const m=this._handlePool++;return this._fileSearchProvider.set(m,v),this._proxy.$registerFileSearchProvider(m,this._transformScheme(g)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(g,v,m,b){const f=w(m),c=this._fileSearchProvider.get(g);if(c)return this._fileSearchManager.fileSearch(f,c,p=>{this._proxy.$handleFileMatch(g,v,p.map(i=>i.resource))},b);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,v,m,b){const f=this._textSearchProvider.get(g);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const c=w(m);return this.createTextSearchManager(c,f).search(i=>this._proxy.$handleTextMatch(g,v,i),b)}$enableExtensionHostSearch(){}createTextSearchManager(g,v){return new A.TextSearchManager(g,v,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};k=je([$e(0,y.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,E.ILogService)],k),e.ExtHostSearch=k;function w(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(T),extraFileResources:S.extraFileResources&&S.extraFileResources.map(g=>D.URI.revive(g))}}e.reviveQuery=w;function T(S){return{...S,folder:D.URI.revive(S.folder)}}}),define(De[289],Ie([1,0,83,139,33,136,34,39,57,40,72,74,75,95,53,67,138,68,46,94,92,58,137,13,227,47,93]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p,i,d,a,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,l.registerSingleton)(d.ILoggerService,i.ExtHostLoggerService,1),(0,l.registerSingleton)(d.ILogService,a.ExtHostLogService,1),(0,l.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands,!1),(0,l.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,l.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,l.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,!1),(0,l.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,!1),(0,l.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow,!1),(0,l.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,!1),(0,l.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,!1),(0,l.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,l.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,!1),(0,l.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,!1)}),define(De[96],Ie([1,0,17,13,30,71]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=y;function I(k,w,T,S){const g=(0,l.mapArrayOrNot)(T,E),v=new C.TextSearchMatch(w,g,S),m=v.preview.matches;return{ranges:(0,l.mapArrayOrNot)(g,D),uri:k,preview:{text:v.preview.text,matches:(0,l.mapArrayOrNot)(m,D)}}}e.createTextSearchResult=I;function E(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function D(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let A=class{constructor(w,T){this.prefix=w,this.logService=T}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};A=je([$e(1,t.ILogService)],A),e.OutputChannel=A}),define(De[290],Ie([1,0,44,9,80,32,10,8,96,291]),function(J,e,l,t,C,P,y,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(f,c,p,i){const d=w(f,c,p,i),a=c.folder.fsPath;return{cmd:l.spawn(A,d.args,{cwd:a}),rgDiskPath:A,siblingClauses:d.siblingClauses,rgArgs:d,cwd:a}}e.spawnRipgrepCmd=k;function w(f,c,p,i){const d=["--files","--hidden","--case-sensitive"];S([c],p,!1).forEach(r=>{const o=(0,E.anchorGlob)(r);if(d.push("-g",o),y.isMacintosh){const u=(0,C.normalizeNFD)(o);u!==o&&d.push("-g",u)}});const a=T([c],i,void 0,!1);return a.globArgs.forEach(r=>{const o=`!${(0,E.anchorGlob)(r)}`;if(d.push("-g",o),y.isMacintosh){const u=(0,C.normalizeNFD)(o);u!==o&&d.push("-g",u)}}),c.disregardIgnoreFiles!==!1?d.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),c.ignoreSymlinks||d.push("--follow"),f.exists&&d.push("--quiet"),d.push("--no-config"),c.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:a.siblingClauses}}function T(f,c,p,i=!0){const d=[];let a={};return f.forEach(r=>{const o=Object.assign({},r.excludePattern||{},c||{}),u=g(o,i?r.folder.fsPath:void 0,p);d.push(...u.globArgs),u.siblingClauses&&(a=Object.assign(a,u.siblingClauses))}),{globArgs:d,siblingClauses:a}}e.foldersToRgExcludeGlobs=T;function S(f,c,p=!0){const i=[];return f.forEach(d=>{const a=Object.assign({},c||{},d.includePattern||{}),r=g(a,p?d.folder.fsPath:void 0);i.push(...r.globArgs)}),i}e.foldersToIncludeGlobs=S;function g(f,c,p){const i=[],d={};return Object.keys(f).forEach(a=>{if(p&&p.has(a)||!a)return;const r=f[a];a=m(c?v(c,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof r=="boolean"&&r?(a.startsWith("\\\\")&&(a+="**"),i.push(b(a))):r&&r.when&&(d[a]=r)}),{globArgs:i,siblingClauses:d}}function v(f,c){return t.isAbsolute(c)?c:t.join(f,c)}e.getAbsoluteGlob=v;function m(f){return f=I.rtrim(f,"\\"),I.rtrim(f,"/")}function b(f){return P.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=b}),define(De[292],Ie([1,0,44,63,9,293,17,50,37,80,32,10,51,8,12,29,30,290,108]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(a=>a())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&E.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&E.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const u=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),n=o.folder.fsPath;r.folderQueries.map(s=>s.folder.fsPath).filter(s=>s!==n).forEach(s=>{(0,A.isEqualOrParent)(s,n)&&(u[C.relative(n,s)]=!0)}),this.folderExcludePatterns.set(n,new i(u,n))})}cancel(){this.isCanceled=!0,f.forEach(r=>r())}walk(r,o,u,n,s){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return s(null,this.isLimitHit);o.forEach(h=>{const _=C.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,_)||this.matchFile(u,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(r,(h,_)=>{this.call(this.cmdTraversal,this,h,u,n,L=>{if(L){const M=(0,I.toErrorMessage)(L);console.error(M),this.errors.push(M),_(L,void 0)}else _(null,void 0)})},(h,_)=>{this.fileWalkSW.stop();const L=h?y.coalesce(h)[0]:null;s(L,this.isLimitHit)})}parallel(r,o,u){const n=new Array(r.length),s=new Array(r.length);let h=!1,_=0;if(r.length===0)return u(null,[]);r.forEach((L,M)=>{o(L,(U,R)=>{if(U?(h=!0,n[M]=null,s[M]=U):(n[M]=R,s[M]=null),++_===r.length)return u(h?s:null,n)})})}call(r,o,...u){try{r.apply(o,u)}catch(n){u[u.length-1](n)}}cmdTraversal(r,o,u,n){const s=r.folder.fsPath,h=k.isMacintosh,_=()=>z&&z.kill();f.add(_);let L=B=>{f.delete(_),L=()=>{},n(B)},M="";const U=this.initDirectoryTree(),R=(0,m.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression),z=R.cmd,H=!Object.keys(R.siblingClauses).length,N=R.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let V=`${R.rgDiskPath} ${N}
 - cwd: ${R.cwd}`;R.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(R.rgArgs.siblingClauses)}`),u({message:V}),this.cmdResultCount=0,this.collectStdout(z,"utf8",u,(B,F,x)=>{if(B){L(B);return}if(this.isLimitHit){L();return}const Q=(M+(h?D.normalizeNFC(F||""):F)).split(`
`);if(x){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,H){for(const K of Q)if(this.matchFile(o,{base:s,relativePath:K,searchPath:this.getSearchPath(r,K)}),this.isLimitHit){_();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,U,s,Q,o),x&&(this.matchDirectoryTree(U,s,o),L())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),u=o.getBasenameTerms(),n=o.getPathTerms(),s=["-L","."];if(u.length||n.length){s.push("-not","(","(");for(const h of u)s.push("-name",h),s.push("-o");for(const h of n)s.push("-path",h),s.push("-o");s.pop(),s.push(")","-prune",")")}return s.push("-type","f"),l.spawn("find",s,{cwd:r.folder.fsPath})}readStdout(r,o,u){let n="";this.collectStdout(r,o,()=>{},(s,h,_)=>{if(s){u(s);return}n+=h,_&&u(null,n)})}collectStdout(r,o,u,n){let s=(L,M,U)=>{(L||U)&&(s=()=>{},this.cmdSW?.stop()),n(L,M,U)},h=!1;r.stdout?(this.forwardData(r.stdout,o,s),r.stdout.once("data",()=>h=!0)):u({message:"stdout is null"});let _;r.stderr?_=this.collectData(r.stderr):u({message:"stderr is null"}),r.on("error",L=>{s(L)}),r.on("close",L=>{let M;!h&&(M=this.decodeData(_,o))&&d(M)?s(new Error(`command failed with error code ${L}: ${this.decodeData(_,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),s(null,"",!0))})}forwardData(r,o,u){const n=new P.StringDecoder(o);return r.on("data",s=>{u(null,n.write(s))}),n}collectData(r){const o=[];return r.on("data",u=>{o.push(u)}),o}decodeData(r,o){const u=new P.StringDecoder(o);return r.map(n=>u.write(n)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},u,n,s){n.indexOf(this.filePattern)!==-1&&this.matchFile(s,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const h=_=>{const L=C.basename(_),M=C.dirname(_);let U=o[M];U||(U=o[M]=[],h(M)),U.push({base:u,relativePath:_,basename:L,searchPath:this.getSearchPath(r,_)})};n.forEach(h)}matchDirectoryTree({rootEntries:r,pathToEntries:o},u,n){const s=this,h=this.folderExcludePatterns.get(u),_=this.filePattern;function L(M){s.directoriesWalked++;const U=(0,v.hasSiblingFn)(()=>M.map(R=>R.basename));for(let R=0,z=M.length;R<z;R++){const H=M[R],{relativePath:N,basename:V}=H;if(h.test(N,V,_!==V?U:void 0))continue;const B=o[N];if(B)L(B);else{if(s.filesWalked++,N===_)continue;s.matchFile(n,H)}if(s.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,u,n,s){const h=r.folder,_=(0,v.hasSiblingFn)(()=>u);this.parallel(u,(L,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const U=o?[o,L].join(C.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(U,L,this.config.filePattern!==L?_:void 0))return M(null);const R=[h.fsPath,U].join(C.sep);t.lstat(R,(z,H)=>{if(z||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(R,H,(N,V)=>N||this.isCanceled||this.isLimitHit?M(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(R,H,(B,F)=>B||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?M(null):(this.walkedPaths[F]=!0,g.Promises.readdir(R).then(x=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(r,U,x,n,$=>M($||null))},x=>{M(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&S.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(n,{base:h.fsPath,relativePath:U,searchPath:this.getSearchPath(r,U)}),M(null,void 0)))})},L=>{const M=L&&y.coalesce(L);return s(M&&M.length>0?M[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,u){return o.isSymbolicLink()?t.stat(r,u):u(null,o)}realPathIfNeeded(r,o,u){return o.isSymbolicLink()?t.realpath(r,(n,s)=>n?u(n):u(null,s)):u(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=c;class p{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,o,u){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(n,s)=>{u(n,{limitHit:s,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class i{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,u;Object.keys(r).filter(n=>r[n]).forEach(n=>{C.isAbsolute(n)?(o=o||E.getEmptyExpression(),o[n]=r[n]):(u=u||E.getEmptyExpression(),u[n]=r[n])}),this.absoluteParsedExpr=o&&E.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=u&&E.parse(u,{trimForExclusions:!0})}test(r,o,u){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,u)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...E.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...E.getPathTerms(this.relativeParsedExpr)),r}}function d(a){const r=a.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return T.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=d}),define(De[294],Ie([1,0,99,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===a)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,I=512*8,E=512*128;var D;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(r,o){super(r),this.decodeStreamErrorKind=o}}e.DecodeStreamError=A;class k{static async create(r){let o;if(r!==e.UTF8)o=(await new Promise((n,s)=>{J(["@vscode/iconv-lite-umd"],n,s)})).getDecoder(g(r));else{const u=new TextDecoder;o={write(n){return u.decode(n,{stream:!0})},end(){return u.decode()}}}return new k(o)}constructor(r){this.iconvLiteDecoder=r}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function w(a,r){const o=r.minBytesRequiredForDetection??r.guessEncoding?I:y;return new Promise((u,n)=>{const s=(0,l.newWriteableStream)(R=>R.join("")),h=[];let _=0,L,M;const U=async()=>{try{const R=await d({buffer:t.VSBuffer.concat(h),bytesRead:_},r.guessEncoding);if(R.seemsBinary&&r.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);R.encoding=await r.overwriteEncoding(R.encoding),L=await k.create(R.encoding);const z=L.write(t.VSBuffer.concat(h).buffer);s.write(z),h.length=0,_=0,u({stream:s,detected:R})}catch(R){M?.dispose(),s.destroy(),n(R)}};M=(0,l.listenStream)(a,{onData:async R=>{L?s.write(L.write(R.buffer)):(h.push(R),_+=R.byteLength,_>=o&&(a.pause(),await U(),setTimeout(()=>a.resume())))},onError:R=>s.error(R),onEnd:async()=>{L||await U(),s.end(L?.end())}})})}e.toDecodeStream=w;async function T(a,r,o){const n=(await new Promise((_,L)=>{J(["@vscode/iconv-lite-umd"],_,L)})).getEncoder(g(r),o);let s=!1,h=!1;return{read(){if(h)return null;const _=a.read();if(typeof _!="string"){if(h=!0,!s&&o?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(s=!0,t.VSBuffer.wrap(L)):null}return s=!0,t.VSBuffer.wrap(n.write(_))}}}e.toEncodeReadable=T;async function S(a){return(await new Promise((o,u)=>{J(["@vscode/iconv-lite-umd"],o,u)})).encodingExists(g(a))}e.encodingExists=S;function g(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=g;function v(a,r){if(!a||r<e.UTF16be_BOM.length)return null;const o=a.readUInt8(0),u=a.readUInt8(1);if(o===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const n=a.readUInt8(2);return o===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const m=["ascii","utf-16","utf-32"];async function b(a){const r=await new Promise((h,_)=>{J(["jschardet"],h,_)}),o=a.slice(0,E),u=p(o.buffer),n=r.detect(u);if(!n||!n.encoding)return null;const s=n.encoding.toLowerCase();return 0<=m.indexOf(s)?null:c(n.encoding)}const f={ibm866:"cp866",big5:"cp950"};function c(a){const r=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[r]||r}function p(a){let r="";for(let o=0;o<a.length;o++)r+=String.fromCharCode(a[o]);return r}function i(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const r=a.match(/windows(\d+)/);return r?"windows-"+r[1]:a}}}e.toCanonicalName=i;function d({buffer:a,bytesRead:r},o){let u=v(a,r),n=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&a){let s=!0,h=!0,_=!1;for(let L=0;L<r&&L<P;L++){const M=L%2===1,U=a.readUInt8(L)===0;if(U&&(_=!0),s&&(M&&!U||!M&&U)&&(s=!1),h&&(M&&U||!M&&!U)&&(h=!1),U&&!s&&!h)break}_&&(s?u=e.UTF16le:h?u=e.UTF16be:n=!0)}return o&&!n&&!u&&a?b(a.slice(0,r)).then(s=>({seemsBinary:!1,encoding:s})):{seemsBinary:n,encoding:u}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[141],Ie([1,0,294,29,140]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends C.TextSearchManager{constructor(I,E,D=t,A="searchProcess"){super(I,E,{readdir:k=>D.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,l.toCanonicalName)(k)},A)}}e.NativeTextSearchManager=P}),define(De[295],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const P=this._dragOperations.get(C);return this._dragOperations.delete(C),P}}addDragOperationTransfer(C,P){this._dragOperations.set(C,P)}getRenderedTreeElement(C){if(this._renderedElements.has(C))return this._renderedElements.get(C)}addRenderedTreeItemElement(C,P){this._renderedElements.set(C,P)}removeRenderedTreeItemElement(C){this._renderedElements.has(C)&&this._renderedElements.delete(C)}}e.TreeviewsService=l}),define(De[296],Ie([1,0,175,7,22,2,3,6,18,7,12,17,15,21,295,28]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(f,c){if((0,A.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let p;return Array.isArray(f.highlights)&&(p=f.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),p=p.length?p:void 0),{label:f.label,highlights:p}}}class m{constructor(c,p,i){this._proxy=c,this.commands=p,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new S.TreeviewsService;function d(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}p.registerArgumentProcessor({processArgument:a=>d(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(r=>d(r)?this.convertArgument(r):r):a})}registerTreeDataProvider(c,p,i){const d=this.createTreeView(c,{treeDataProvider:p},i);return{dispose:()=>d.dispose()}}createTreeView(c,p,i){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=p.dragAndDropController?.dropMimeTypes??[],a=p.dragAndDropController?.dragMimeTypes??[],r=!!p.dragAndDropController?.handleDrag,o=!!p.dragAndDropController?.handleDrop,u=this.createExtHostTreeView(c,p,i),n=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,dropMimeTypes:d,dragMimeTypes:a,hasHandleDrag:r,hasHandleDrop:o});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,g.checkProposedApiEnabled)(i,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(s){u.message=s},get title(){return u.title},set title(s){u.title=s},get description(){return u.description},set description(s){u.description=s},get badge(){return u.badge},set badge(s){s!==void 0&&D.ViewBadge.isViewBadge(s)?u.badge={value:Math.floor(Math.abs(s.value)),tooltip:s.tooltip}:s===void 0&&(u.badge=void 0)},reveal:(s,h)=>u.reveal(s,h),dispose:async()=>{await n,this.treeViews.delete(c),u.dispose()}}}$getChildren(c,p){const i=this.treeViews.get(c);return i?i.getChildren(p):Promise.reject(new Error((0,l.localize)(0,null,c)))}async $handleDrop(c,p,i,d,a,r,o,u){const n=this.treeViews.get(c);if(!n)return Promise.reject(new Error((0,l.localize)(1,null,c)));const s=w.DataTransfer.toDataTransfer(i,async h=>(await this._proxy.$resolveDropFileData(c,p,h)).buffer);return o===c&&u&&await this.addAdditionalTransferItems(s,n,u,a,r),n.onDrop(s,d,a)}async addAdditionalTransferItems(c,p,i,d,a){const r=this.treeDragAndDropService.removeDragOperationTransfer(a);if(r)(await r)?.forEach((o,u)=>{o&&c.set(u,o)});else if(a&&p.handleDrag){const o=p.handleDrag(i,c,d);this.treeDragAndDropService.addDragOperationTransfer(a,o),await o}return c}async $handleDrag(c,p,i,d){const a=this.treeViews.get(c);if(!a)return Promise.reject(new Error((0,l.localize)(2,null,c)));const r=await this.addAdditionalTransferItems(new t.DataTransfer,a,p,d,i);if(!!r)return w.DataTransfer.toDataTransferDTO(r)}async $hasResolve(c){const p=this.treeViews.get(c);if(!p)throw new Error((0,l.localize)(3,null,c));return p.hasResolve}$resolve(c,p,i){const d=this.treeViews.get(c);if(!d)throw new Error((0,l.localize)(4,null,c));return d.resolveTreeItem(p,i)}$setExpanded(c,p,i){const d=this.treeViews.get(c);if(!d)throw new Error((0,l.localize)(5,null,c));d.setExpanded(p,i)}$setSelection(c,p){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(6,null,c));i.setSelection(p)}$setFocus(c,p){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(7,null,c));i.setFocus(p)}$setVisible(c,p){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(8,null,c));i.setVisible(p)}$changeCheckboxState(c,p){const i=this.treeViews.get(c);if(!i)throw new Error((0,l.localize)(9,null,c));i.setCheckboxState(p)}createExtHostTreeView(c,p,i){const d=new b(c,p,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(c,d),d}convertArgument(c){const p=this.treeViews.get(c.$treeViewId);return p&&"$treeItemHandle"in c?p.getExtensionElement(c.$treeItemHandle):p&&"$focusedTreeItem"in c&&c.$focusedTreeItem?p.focusedElement:null}}e.ExtHostTreeViews=m;class b extends I.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,A.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,p,i,d,a,r){if(super(),this.viewId=c,this.proxy=i,this.commands=d,this.logService=a,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,r.contributes&&r.contributes.views)for(const n in r.contributes.views)for(const s of r.contributes.views[n])s.id===c&&(this._title=s.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let o,u;this._register(y.Event.debounce(this._onDidChangeData.event,(n,s)=>(n||(n={message:!1,elements:[]}),s.element!==!1&&(o||(o=new Promise(h=>u=h),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(s.element)?n.elements.push(...s.element):n.elements.push(s.element)),s.message&&(n.message=!0),n),200,!0)(({message:n,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=u;return o=null,this.refresh(s).then(()=>h())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const p=c?this.getExtensionElement(c):void 0;if(c&&!p)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(c);return i||(i=await this.fetchChildrenNodes(p)),i?i.map(d=>d.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,p){p=p||{select:!0,focus:!1};const i=(0,A.isUndefinedOrNull)(p.select)?!0:p.select,d=(0,A.isUndefinedOrNull)(p.focus)?!1:p.focus,a=(0,A.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(r=>this.resolveTreeNode(c,r[r.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:r.map(u=>u.item)},{select:i,focus:d,expand:a})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:d,expand:a})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=w.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,p){const i=this.getExtensionElement(c);i&&(p?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const p=(await Promise.all(c.map(async i=>{const d=this.getExtensionElement(i.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);p.forEach(i=>{i.treeItem.checkboxState=i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:p.map(i=>[i.extensionItem,i.newState])})}async handleDrag(c,p,i){const d=[];for(const a of c){const r=this.getExtensionElement(a);r&&d.push(r)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,p,i),p}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,p,i){const d=p?this.getExtensionElement(p):void 0;if(!(!d&&p||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,c,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,p){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(c);if(i){const d=this.nodes.get(i);if(d){const a=await this.dataProvider.resolveTreeItem(d.extensionItem,i,p)??d.extensionItem;return this.validateTreeItem(a),d.item.tooltip=this.getTooltip(a.tooltip),d.item.command=this.getCommand(d.disposableStore,a.command),d.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(p=>p?this.resolveUnknownParentChain(p).then(i=>this.resolveTreeNode(p,i[i.length-1]).then(d=>(i.push(d),i))):Promise.resolve([]))}resolveParent(c){const p=this.nodes.get(c);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,p){const i=this.nodes.get(c);return i?Promise.resolve(i):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(d=>this.createHandle(c,d,p,!0)).then(d=>this.getChildren(p?p.item.handle:void 0).then(()=>{const a=this.getExtensionElement(d);if(a){const r=this.nodes.get(a);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(c){if(c){let p;if(typeof c=="string"){const i=this.getExtensionElement(c);p=i?this.nodes.get(i):void 0}else p=c;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const p=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=c?this.nodes.get(c):void 0,d=await this.dataProvider.getChildren(c);if(p.token.isCancellationRequested)return;const a=await Promise.all((0,k.coalesce)(d||[]).map(async r=>{const o=await this.dataProvider.getTreeItem(r);return o&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(r,o,i):null}));return p.token.isCancellationRequested?void 0:(0,k.coalesce)(a)}finally{p.dispose()}}refresh(c){if(c.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(c);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const p=new Set,i=c.map(a=>this.nodes.get(a));for(const a of i)if(a&&!p.has(a.item.handle)){let r=a;for(;r&&r.parent&&i.findIndex(o=>r&&r.parent&&o&&o.item.handle===r.parent.item.handle)===-1;){const o=this.elements.get(r.parent.item.handle);r=o?this.nodes.get(o):void 0}r&&!r.parent&&p.add(a.item.handle)}const d=[];return p.forEach(a=>{const r=this.elements.get(a);if(r){const o=this.nodes.get(r);o&&(!o.parent||!p.has(o.parent.item.handle))&&d.push(a)}}),d}refreshHandles(c){const p={};return Promise.all(c.map(i=>this.refreshNode(i).then(d=>{d&&(p[i]=d.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(c){const p=this.getExtensionElement(c);if(p){const i=this.nodes.get(p);if(i)return this.clearChildren(p),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(d=>{if(d){const a=this.createTreeNode(p,d,i.parent);return this.updateNodeCache(p,a,i,i.parent),i.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,p,i){const d=this.createTreeNode(c,p,i);if(p.id&&this.elements.has(d.item.handle))throw new Error((0,l.localize)(10,null,p.id));return this.addNodeToCache(c,d),this.addNodeToParentCache(d,i),d}getTooltip(c){return D.MarkdownString.isMarkdownString(c)?w.MarkdownString.from(c):c}getCommand(c,p){return p?{...this.commands.toInternal(p,c),originalId:p.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let p,i;return typeof c.checkboxState=="number"?p=c.checkboxState:(p=c.checkboxState.state,i=c.checkboxState.tooltip),{isChecked:p===D.TreeItemCheckboxState.Checked,tooltip:i}}validateTreeItem(c){if(!D.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,p,i){this.validateTreeItem(p);const d=new I.DisposableStore,a=this.createHandle(c,p,i),r=this.getLightIconPath(p);return{item:{handle:a,parentHandle:i?i.item.handle:void 0,label:v(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(d,p.command),contextValue:p.contextValue,icon:r,iconDark:this.getDarkIconPath(p)||r,themeIcon:this.getThemeIcon(p),collapsibleState:(0,A.isUndefinedOrNull)(p.collapsibleState)?D.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation,checkbox:this.getCheckbox(p)},extensionItem:p,parent:i,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(c){return c.iconPath instanceof D.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:p,label:i,resourceUri:d},a,r){if(p)return`${b.ID_HANDLE_PREFIX}/${p}`;const o=v(i,this.extension),u=a?a.item.handle:b.LABEL_HANDLE_PREFIX;let n=o?o.label:d?(0,C.basename)(d):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const s=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,h=this.getChildrenNodes(a)||[];let _,L=0;do{if(_=`${u}/${L}:${n}`,r||!this.elements.has(_)||s===_)break;L++}while(L<=h.length);return _}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof D.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof D.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,p){this.elements.set(p.item.handle,c),this.nodes.set(c,p)}updateNodeCache(c,p,i,d){this.elements.delete(p.item.handle),this.nodes.delete(c),p.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(c,p);const a=this.getChildrenNodes(d)||[],r=a.filter(o=>o.item.handle===i.item.handle)[0];r&&a.splice(a.indexOf(r),1,p)}addNodeToParentCache(c,p){p?(p.children||(p.children=[]),p.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const p=this.nodes.get(c);if(p){if(p.children)for(const i of p.children){const d=this.elements.get(i.item.handle);d&&this.clear(d)}p.children=void 0}}else this.clearAll()}clear(c){const p=this.nodes.get(c);if(p){if(p.children)for(const i of p.children){const d=this.elements.get(i.item.handle);d&&this.clear(d)}this.nodes.delete(c),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(De[297],Ie([1,0,21,11,3,42,2,118,103,148,158,38,5,91,241,240,39,242,34,244,245,246,229,247,57,41,248,249,252,253,254,139,232,258,259,260,95,40,262,296,15,7,265,70,138,33,212,251,85,136,72,74,75,13,54,16,25,255,228,53,67,238,263,69,68,268,266,267,239,46,261,264,94,58,92,256,71,257,14,122,231,208,250,6,28,213,93]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c,p,i,d,a,r,o,u,n,s,h,_,L,M,U,R,z,H,N,V,B,F,x,$,Q,K,de,ee,he,Y,me,be,ke,Re,ze,oe,le,ge,Z,ae,ne,ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve,fe,Ae,Le,Me,Ke,Je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(ot){const it=ot.get(le.IExtHostInitDataService),lt=ot.get(Ce.IExtHostFileSystemInfo),vt=ot.get(G.IExtHostConsumerFileSystem),wt=ot.get(r.IExtHostExtensionService),ft=ot.get(K.IExtHostWorkspace),Et=ot.get(Ye.IExtHostTelemetry),Ft=ot.get(b.IExtHostConfiguration),Mt=ot.get(ze.IURITransformerService),Qe=ot.get(oe.IExtHostRpcService),zt=ot.get(z.IExtHostStorage),Ot=ot.get(j.IExtensionStoragePaths),Pt=ot.get(Re.ILoggerService),gt=ot.get(Re.ILogService),kt=ot.get(ae.IExtHostTunnelService),Pe=ot.get(ne.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),_e=ot.get(qe.IExtHostSecretState),te=ot.get(Ze.IExtHostEditorTabs);Qe.set(w.ExtHostContext.ExtHostFileSystemInfo,lt),Qe.set(w.ExtHostContext.ExtHostLogLevelServiceShape,Pt),Qe.set(w.ExtHostContext.ExtHostWorkspace,ft),Qe.set(w.ExtHostContext.ExtHostConfiguration,Ft),Qe.set(w.ExtHostContext.ExtHostExtensionService,wt),Qe.set(w.ExtHostContext.ExtHostStorage,zt),Qe.set(w.ExtHostContext.ExtHostTunnelService,kt),Qe.set(w.ExtHostContext.ExtHostWindow,Oe),Qe.set(w.ExtHostContext.ExtHostSecretState,_e),Qe.set(w.ExtHostContext.ExtHostTelemetry,Et),Qe.set(w.ExtHostContext.ExtHostEditorTabs,te);const Fe=Qe.set(w.ExtHostContext.ExtHostDecorations,ot.get(Y.IExtHostDecorations)),xe=Qe.set(w.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(a.IExtHostDocumentsAndEditors)),nt=Qe.set(w.ExtHostContext.ExtHostCommands,ot.get(v.IExtHostCommands)),Ge=Qe.set(w.ExtHostContext.ExtHostTerminalService,ot.get(H.IExtHostTerminalService)),rt=Qe.set(w.ExtHostContext.ExtHostDebugService,ot.get(be.IExtHostDebugService)),pt=Qe.set(w.ExtHostContext.ExtHostSearch,ot.get(ke.IExtHostSearch)),St=Qe.set(w.ExtHostContext.ExtHostTask,ot.get(me.IExtHostTask)),Tt=Qe.set(w.ExtHostContext.ExtHostOutputService,ot.get(_.IExtHostOutputService)),It=Qe.set(w.ExtHostContext.ExtHostLocalization,ot.get(Je.IExtHostLocalizationService)),_t=Qe.set(w.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Qe)),bt=Qe.set(w.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Qe,xe)),Ct=Qe.set(w.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Qe,xe,gt)),en=Qe.set(w.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(gt,bt,Qe.getProxy(w.MainContext.MainThreadBulkEdits))),yt=Qe.set(w.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Qe,nt,xe,bt)),qt=Qe.set(w.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(yt)),Ht=Qe.set(w.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(gt,yt)),tn=Qe.set(w.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Qe,it,yt,nt,gt)),un=Qe.set(w.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Qe,yt)),At=Qe.set(w.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Qe,xe)),nn=Qe.set(w.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Qe.getProxy(w.MainContext.MainThreadTreeViews),nt,gt)),dn=Qe.set(w.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Qe.getProxy(w.MainContext.MainThreadEditorInsets),At,it.remote)),Ut=Qe.set(w.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Qe,gt,lt)),Jt=Qe.set(w.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Qe,bt,nt.converter,Mt)),dt=Qe.set(w.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Qe,Mt,bt,nt,Ut,gt,Pe,Et)),hn=Qe.set(w.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Qe,dt)),Nt=Qe.set(w.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Qe,gt,xe)),Gt=Qe.set(w.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Qe,ft,nt)),rn=Qe.set(w.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(Qe,nt,gt)),fn=Qe.set(w.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Qe,nt,bt)),sn=Qe.set(w.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Qe.getProxy(w.MainContext.MainThreadProgress))),mn=Qe.set(w.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Qe)),on=Qe.set(w.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Qe)),Zt=Qe.set(w.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Qe)),gn=Qe.set(w.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Qe,nt)),pn=Qe.set(w.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Qe,it.remote,ft,gt,Pe)),vn=Qe.set(w.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Qe,pn,ft)),bn=Qe.set(w.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(Qe,bt,Ot,pn,vn)),wn=Qe.set(w.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Qe,pn)),Kt=Qe.set(w.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Qe,nt,xe)),En=Qe.set(w.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Qe));Qe.set(w.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Qe,yt,xe,nt,gt));const Fn=Object.values(w.ExtHostContext);Qe.assertRegistered(Fn);const Sn=new ce.ExtHostBulkEdits(Qe,xe),_n=new g.ExtHostClipboard(Qe),yn=new h.ExtHostMessageService(Qe,gt),Tn=new c.ExtHostDialogs(Qe),Pn=new R.ExtHostStatusBar(Qe,nt.converter);return S.ExtHostApiCommands.register(nt),function(He,xt,An){const mt=function(){let ve=!He.isUnderDevelopment;function Se(){ve||(gt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const Dt=ct;typeof Dt.scheme>"u"&&Se(),typeof Dt.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ct}}(),Cn={getSession(ve,Se,Ue){return Zt.getSession(He,ve,Se,Ue)},async hasSession(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"authSession"),!!await Zt.getSession(He,ve,Se,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Ue,ct){return Zt.registerAuthenticationProvider(ve,Se,Ue,ct)}},Mn={registerCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,Se,Ue,void 0,He)},registerTextEditorCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,(...ct)=>{const Dt=At.getActiveTextEditor();if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}return Dt.edit(Rt=>{Se.apply(Ue,[Dt,Rt,...ct])}).then(Rt=>{Rt||gt.warn("Edits from command "+ve+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+ve,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"diffCommand"),nt.registerCommand(!0,ve,async(...ct)=>{const Dt=xe.activeEditor(!0);if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);Se.apply(Ue,[Rt,...ct])},void 0,void 0,He)),executeCommand(ve,...Se){return nt.executeCommand(ve,...Se)},getCommands(ve=!1){return nt.getCommands(ve)}},Rn={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return Ge.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(He,"envShellEvent"),Ge.onDidChangeShell},get isTelemetryEnabled(){return Et.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(it.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.instantiateLogger(He,ve)},openExternal(ve,Se){return Oe.openUri(ve,{allowTunneling:!!it.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===it.environment.appUriScheme)return _t.createAppUri(ve);try{return await Oe.asExternalUri(ve,{allowTunneling:!!it.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ve,se.Schemas.http)||(0,Ee.matchesScheme)(ve,se.Schemas.https))return ve;throw Se}},get remoteName(){return(0,he.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(He,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind},get logLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.getLevel()},get onDidChangeLogLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.onDidChangeLogLevel}};it.environment.extensionTestsLocationURI||Object.freeze(Rn);const Un={createTestController(ve,Se,Ue){return Kt.createTestController(ve,Se,Ue)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.createTestObserver()},runTests(ve){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.runTests(ve)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.results}},Xt=it.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Bn={getExtension(ve,Se){(0,Me.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Ue=xt.mine.getExtensionDescription(ve);if(Ue)return new r.Extension(wt,He.identifier,Ue,Xt,!1);if(Se){const ct=xt.all.getExtensionDescription(ve);if(ct)return new r.Extension(wt,He.identifier,ct,Xt,!0)}},get all(){const ve=[];for(const Se of xt.mine.getAllExtensionDescriptions())ve.push(new r.Extension(wt,He.identifier,Se,Xt,!1));return ve},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(He,"extensionsAny");const ve=new Me.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const ct=!ve.has(Ue.identifier);Se.push(new r.Extension(wt,He.identifier,Ue,Xt,ct))}return Se},get onDidChange(){return(0,Me.isProposedApiEnabled)(He,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},zn={createDiagnosticCollection(ve){return Ut.createDiagnosticCollection(He.identifier,ve)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:ve=>Ut.getDiagnostics(ve),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(ve,Se){return Jt.changeLanguage(ve.uri,Se)},match(ve,Se){const Ue=bt.getDocumentData(Se.uri)?.notebook;return(0,A.score)(B.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(ve,Se,Ue){return dt.registerCodeActionProvider(He,mt(ve),Se,Ue)},registerDocumentPasteEditProvider(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,mt(ve),Se,Ue)},registerCodeLensProvider(ve,Se){return dt.registerCodeLensProvider(He,mt(ve),Se)},registerDefinitionProvider(ve,Se){return dt.registerDefinitionProvider(He,mt(ve),Se)},registerDeclarationProvider(ve,Se){return dt.registerDeclarationProvider(He,mt(ve),Se)},registerImplementationProvider(ve,Se){return dt.registerImplementationProvider(He,mt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return dt.registerTypeDefinitionProvider(He,mt(ve),Se)},registerHoverProvider(ve,Se){return dt.registerHoverProvider(He,mt(ve),Se,He.identifier)},registerEvaluatableExpressionProvider(ve,Se){return dt.registerEvaluatableExpressionProvider(He,mt(ve),Se,He.identifier)},registerInlineValuesProvider(ve,Se){return dt.registerInlineValuesProvider(He,mt(ve),Se,He.identifier)},registerDocumentHighlightProvider(ve,Se){return dt.registerDocumentHighlightProvider(He,mt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return dt.registerLinkedEditingRangeProvider(He,mt(ve),Se)},registerReferenceProvider(ve,Se){return dt.registerReferenceProvider(He,mt(ve),Se)},registerRenameProvider(ve,Se){return dt.registerRenameProvider(He,mt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Ue){return dt.registerDocumentSymbolProvider(He,mt(ve),Se,Ue)},registerWorkspaceSymbolProvider(ve){return dt.registerWorkspaceSymbolProvider(He,ve)},registerDocumentFormattingEditProvider(ve,Se){return dt.registerDocumentFormattingEditProvider(He,mt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return dt.registerDocumentRangeFormattingEditProvider(He,mt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(He,mt(ve),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentSemanticTokensProvider(He,mt(ve),Se,Ue)},registerDocumentRangeSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider(He,mt(ve),Se,Ue)},registerSignatureHelpProvider(ve,Se,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(He,mt(ve),Se,Ue):dt.registerSignatureHelpProvider(He,mt(ve),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(ve,Se,...Ue){return dt.registerCompletionItemProvider(He,mt(ve),Se,Ue)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,mt(ve),Se)},registerInlineCompletionItemProviderNew(ve,Se){if((0,Me.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Me.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,mt(ve),Se)},registerDocumentLinkProvider(ve,Se){return dt.registerDocumentLinkProvider(He,mt(ve),Se)},registerColorProvider(ve,Se){return dt.registerColorProvider(He,mt(ve),Se)},registerFoldingRangeProvider(ve,Se){return dt.registerFoldingRangeProvider(He,mt(ve),Se)},registerSelectionRangeProvider(ve,Se){return dt.registerSelectionRangeProvider(He,ve,Se)},registerCallHierarchyProvider(ve,Se){return dt.registerCallHierarchyProvider(He,ve,Se)},registerTypeHierarchyProvider(ve,Se){return dt.registerTypeHierarchyProvider(He,ve,Se)},setLanguageConfiguration:(ve,Se)=>dt.setLanguageConfiguration(He,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"tokenInformation"),Jt.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return dt.registerInlayHintsProvider(He,ve,Se)},createLanguageStatusItem(ve,Se){return Jt.createLanguageStatusItem(He,ve,Se)},registerDocumentDropEditProvider(ve,Se){return dt.registerDocumentOnDropEditProvider(He,ve,Se)}},Wn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ge.activeTerminal},get terminals(){return Ge.terminals},async showTextDocument(ve,Se,Ue){const ct=await(y.URI.isUri(ve)?Promise.resolve(Ln.openTextDocument(ve)):Promise.resolve(ve));return At.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType(ve){return At.createTextEditorDecorationType(He,ve)},onDidChangeActiveTextEditor(ve,Se,Ue){return At.onDidChangeActiveTextEditor(ve,Se,Ue)},onDidChangeVisibleTextEditors(ve,Se,Ue){return At.onDidChangeVisibleTextEditors(ve,Se,Ue)},onDidChangeTextEditorSelection(ve,Se,Ue){return At.onDidChangeTextEditorSelection(ve,Se,Ue)},onDidChangeTextEditorOptions(ve,Se,Ue){return At.onDidChangeTextEditorOptions(ve,Se,Ue)},onDidChangeTextEditorVisibleRanges(ve,Se,Ue){return At.onDidChangeTextEditorVisibleRanges(ve,Se,Ue)},onDidChangeTextEditorViewColumn(ve,Se,Ue){return At.onDidChangeTextEditorViewColumn(ve,Se,Ue)},onDidCloseTerminal(ve,Se,Ue){return Ge.onDidCloseTerminal(ve,Se,Ue)},onDidOpenTerminal(ve,Se,Ue){return Ge.onDidOpenTerminal(ve,Se,Ue)},onDidChangeActiveTerminal(ve,Se,Ue){return Ge.onDidChangeActiveTerminal(ve,Se,Ue)},onDidChangeTerminalDimensions(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDimensions"),Ge.onDidChangeTerminalDimensions(ve,Se,Ue)},onDidChangeTerminalState(ve,Se,Ue){return Ge.onDidChangeTerminalState(ve,Se,Ue)},onDidWriteTerminalData(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ge.onDidWriteTerminalData(ve,Se,Ue)},get state(){return Oe.state},onDidChangeWindowState(ve,Se,Ue){return Oe.onDidChangeWindowState(ve,Se,Ue)},showInformationMessage(ve,...Se){return yn.showMessage(He,P.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return yn.showMessage(He,P.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return yn.showMessage(He,P.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Ue){return Gt.showQuickPick(ve,Se,Ue)},showWorkspaceFolderPick(ve){return Gt.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return Gt.showInput(ve,Se)},showOpenDialog(ve){return Tn.showOpenDialog(ve)},showSaveDialog(ve){return Tn.showSaveDialog(ve)},createStatusBarItem(ve,Se,Ue){let ct,Dt,Rt;return typeof ve=="string"?(ct=ve,Dt=Se,Rt=Ue):(Dt=ve,Rt=Se),Pn.createStatusBarEntry(He,ct,Dt,Rt)},setStatusBarMessage(ve,Se){return Pn.setStatusBarMessage(ve,Se)},withScmProgress(ve){return Pe.report("window.withScmProgress",He,"Use 'withProgress' instead."),sn.withProgress(He,{location:F.ProgressLocation.SourceControl},(Se,Ue)=>ve({report(ct){}}))},withProgress(ve,Se){return sn.withProgress(He,ve,Se)},createOutputChannel(ve,Se){return Tt.createOutputChannel(ve,Se,He)},createWebviewPanel(ve,Se,Ue,ct){return vn.createWebviewPanel(He,ve,Se,Ue,ct)},createWebviewTextEditorInset(ve,Se,Ue,ct){return(0,Me.checkProposedApiEnabled)(He,"editorInsets"),dn.createWebviewEditorInset(ve,Se,Ue,ct,He)},createTerminal(ve,Se,Ue){return typeof ve=="object"?"pty"in ve?Ge.createExtensionTerminal(ve):Ge.createTerminalFromOptions(ve):Ge.createTerminal(ve,Se,Ue)},registerTerminalLinkProvider(ve){return Ge.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return Ge.registerProfileProvider(He,ve,Se)},registerTreeDataProvider(ve,Se){return nn.registerTreeDataProvider(ve,Se,He)},createTreeView(ve,Se){return nn.createTreeView(ve,Se,He)},registerWebviewPanelSerializer:(ve,Se)=>vn.registerWebviewPanelSerializer(He,ve,Se),registerCustomEditorProvider:(ve,Se,Ue={})=>bn.registerCustomEditorProvider(He,ve,Se,Ue),registerFileDecorationProvider(ve){return Fe.registerFileDecorationProvider(ve,He.identifier)},registerUriHandler(ve){return _t.registerUriHandler(He.identifier,ve)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Ue){return on.onDidChangeActiveColorTheme(ve,Se,Ue)},registerWebviewViewProvider(ve,Se,Ue){return wn.registerWebviewViewProvider(He,ve,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Ue){return yt.onDidChangeActiveNotebookEditor(ve,Se,Ue)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Ue){return Ht.onDidChangeNotebookEditorSelection(ve,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue){return Ht.onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue)},showNotebookDocument(ve,Se){return y.URI.isUri(ve)&&Pe.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),yt.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"externalUriOpener"),En.registerExternalUriOpener(He.identifier,ve,Se,Ue)},get tabGroups(){return te.tabGroups}},Ln={get rootPath(){return Pe.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ve){throw t.readonly()},getWorkspaceFolder(ve){return ft.getWorkspaceFolder(ve)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ve){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ve){throw t.readonly()},updateWorkspaceFolders:(ve,Se,...Ue)=>ft.updateWorkspaceFolders(He,ve,Se||0,...Ue),onDidChangeWorkspaceFolders:function(ve,Se,Ue){return ft.onDidChangeWorkspace(ve,Se,Ue)},asRelativePath:(ve,Se)=>ft.getRelativePath(ve,Se),findFiles:(ve,Se,Ue,ct)=>ft.findFiles(ve,Se,Ue,He.identifier,ct),findTextInFiles:(ve,Se,Ue,ct)=>{(0,Me.checkProposedApiEnabled)(He,"findTextInFiles");let Dt,Rt;return typeof Se=="object"?(Dt=Se,Rt=Ue):(Dt={},Rt=Se,ct=Ue),ft.findTextInFiles(ve,Dt||{},Rt,He.identifier,ct)},saveAll:ve=>ft.saveAll(ve),applyEdit(ve,Se){return Sn.applyWorkspaceEdit(ve,He,Se)},createFileSystemWatcher:(ve,Se,Ue,ct)=>Nt.createFileSystemWatcher(ft,He,ve,Se,Ue,ct),get textDocuments(){return bt.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw t.readonly()},openTextDocument(ve){let Se;const Ue=ve;if(typeof ve=="string")Se=Promise.resolve(y.URI.file(ve));else if(y.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Ue||typeof Ue=="object")Se=bt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>bt.ensureDocumentData(ct).then(Dt=>Dt.document))},onDidOpenTextDocument:(ve,Se,Ue)=>bt.onDidAddDocument(ve,Se,Ue),onDidCloseTextDocument:(ve,Se,Ue)=>bt.onDidRemoveDocument(ve,Se,Ue),onDidChangeTextDocument:(ve,Se,Ue)=>bt.onDidChangeDocument(ve,Se,Ue),onDidSaveTextDocument:(ve,Se,Ue)=>bt.onDidSaveDocument(ve,Se,Ue),onWillSaveTextDocument:(ve,Se,Ue)=>en.getOnWillSaveTextDocumentEvent(He)(ve,Se,Ue),get notebookDocuments(){return yt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Ue;if(y.URI.isUri(ve))Ue=ve,await yt.openNotebookDocument(ve);else if(typeof ve=="string")Ue=y.URI.revive(await yt.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ve,Se,Ue){return qt.onDidSaveNotebookDocument(ve,Se,Ue)},onDidChangeNotebookDocument(ve,Se,Ue){return qt.onDidChangeNotebookDocument(ve,Se,Ue)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Ue,ct){return yt.registerNotebookSerializer(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(ve,Se,Ue,ct)=>((0,Me.checkProposedApiEnabled)(He,"notebookContentProvider"),Pe.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),yt.registerNotebookContentProvider(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(ve,Se,Ue)=>An.onDidChangeConfiguration(ve,Se,Ue),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,An.getConfiguration(ve,Se,He)},registerTextDocumentContentProvider(ve,Se){return Ct.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(Pe.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(He,ve,Se)),registerFileSystemProvider(ve,Se,Ue){return(0,Le.combinedDisposable)(hn.registerFileSystemProvider(He,ve,Se,Ue),vt.addFileSystemProvider(ve,Se))},get fs(){return vt.value},registerFileSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"fileSearchProvider"),pt.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"textSearchProvider"),pt.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),wt.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),mn.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Ue)=>Nt.onDidCreateFile(ve,Se,Ue),onDidDeleteFiles:(ve,Se,Ue)=>Nt.onDidDeleteFile(ve,Se,Ue),onDidRenameFiles:(ve,Se,Ue)=>Nt.onDidRenameFile(ve,Se,Ue),onWillCreateFiles:(ve,Se,Ue)=>Nt.getOnWillCreateFileEvent(He)(ve,Se,Ue),onWillDeleteFiles:(ve,Se,Ue)=>Nt.getOnWillDeleteFileEvent(He)(ve,Se,Ue),onWillRenameFiles:(ve,Se,Ue)=>Nt.getOnWillRenameFileEvent(He)(ve,Se,Ue),openTunnel:ve=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.openTunnel(He,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.onDidChangeTunnels(ve,Se,Ue)),registerPortAttributesProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"portsAttributes"),kt.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"timeline"),gn.registerTimelineProvider(ve,Se,He.identifier,nt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ve=>((0,Me.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Ue)=>ft.onDidGrantWorkspaceTrust(ve,Se,Ue),registerEditSessionIdentityProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ve,Se))},Dn={get inputBox(){return Pe.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),rn.getLastInputBox(He)},createSourceControl(ve,Se,Ue){return rn.createSourceControl(He,ve,Se,Ue)}},Hn={createCommentController(ve,Se){return fn.createCommentController(He,ve,Se)}},Vt={get activeDebugSession(){return rt.activeDebugSession},get activeDebugConsole(){return rt.activeDebugConsole},get breakpoints(){return rt.breakpoints},onDidStartDebugSession(ve,Se,Ue){return rt.onDidStartDebugSession(ve,Se,Ue)},onDidTerminateDebugSession(ve,Se,Ue){return rt.onDidTerminateDebugSession(ve,Se,Ue)},onDidChangeActiveDebugSession(ve,Se,Ue){return rt.onDidChangeActiveDebugSession(ve,Se,Ue)},onDidReceiveDebugSessionCustomEvent(ve,Se,Ue){return rt.onDidReceiveDebugSessionCustomEvent(ve,Se,Ue)},onDidChangeBreakpoints(ve,Se,Ue){return rt.onDidChangeBreakpoints(ve,Se,Ue)},registerDebugConfigurationProvider(ve,Se,Ue){return rt.registerDebugConfigurationProvider(ve,Se,Ue||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return rt.registerDebugAdapterDescriptorFactory(He,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return rt.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?rt.startDebugging(ve,Se,{parentSession:Ue}):rt.startDebugging(ve,Se,Ue||{})},stopDebugging(ve){return rt.stopDebugging(ve)},addBreakpoints(ve){return rt.addBreakpoints(ve)},removeBreakpoints(ve){return rt.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return rt.asDebugSourceUri(ve,Se)}},an={registerTaskProvider:(ve,Se)=>St.registerTaskProvider(He,ve,Se),fetchTasks:ve=>St.fetchTasks(ve),executeTask:ve=>St.executeTask(He,ve),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ve,Se,Ue)=>St.onDidStartTask(ve,Se,Ue),onDidEndTask:(ve,Se,Ue)=>St.onDidEndTask(ve,Se,Ue),onDidStartTaskProcess:(ve,Se,Ue)=>St.onDidStartTaskProcess(ve,Se,Ue),onDidEndTaskProcess:(ve,Se,Ue)=>St.onDidEndTaskProcess(ve,Se,Ue)},$n={createNotebookController(ve,Se,Ue,ct,Dt){return tn.createNotebookController(He,ve,Se,Ue,ct,(0,Me.isProposedApiEnabled)(He,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>yt.registerNotebookCellStatusBarItemProvider(He,ve,Se),createRendererMessaging(ve){return un.createRendererMessaging(He,ve)},onDidChangeNotebookCellExecutionState(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"notebookCellExecutionState"),tn.onDidChangeNotebookCellExecutionState(ve,Se,Ue)}},Bt={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Ue=!ve||typeof ve[0]!="object"?ve:ve[0];return It.getMessage(He.identifier.value,{message:Se,args:Ue})}return It.getMessage(He.identifier.value,ve[0])},get bundle(){return It.getBundle(He.identifier.value)},get uri(){return It.getBundleUri(He.identifier.value)}};return{version:it.version,authentication:Cn,commands:Mn,comments:Hn,debug:Vt,env:Rn,extensions:Bn,l10n:Bt,languages:zn,notebooks:$n,scm:Dn,tasks:an,tests:Un,window:Wn,workspace:Ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:w.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:C.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:D.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,SnippetTextEdit:F.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItem2:F.TreeItem,TreeItemCheckboxState:F.TreeItemCheckboxState,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:T.UIKind,Uri:y.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookControllerAffinity2:F.NotebookControllerAffinity2,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:at.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason,LogLevel:Re.LogLevel}}}e.createApiFactoryAndRegisterActors=st}),define(De[298],Ie([1,0,270,307,308,2,309]),function(J,e,l,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(k,w,T,S,g,v){const m=v.environment.useHostProxy,b=typeof m=="boolean"?m:!v.remote.isRemote,f=(0,y.createProxyResolver)({resolveProxy:p=>k.resolveProxy(p),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(p,i,...d)=>{switch(p){case y.LogLevel.Trace:S.trace(i,...d);break;case y.LogLevel.Debug:S.debug(i,...d);break;case y.LogLevel.Info:S.info(i,...d);break;case y.LogLevel.Warning:S.warn(i,...d);break;case y.LogLevel.Error:S.error(i,...d);break;case y.LogLevel.Critical:S.critical(i,...d);break;case y.LogLevel.Off:break;default:a(p,i,d);break}function a(r,o,...u){S.error("Unknown log level",r),S.error(o,...u)}},getLogLevel:()=>S.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),c=E(w,f);return A(T,c)}e.connectProxyResolver=I;function E(k,w){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(g=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const S={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(g=>{S.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,y.createHttpPatch)(l,w,{config:"off"},S,!0)),on:Object.assign({},l,(0,y.createHttpPatch)(l,w,{config:"on"},S,!0)),override:Object.assign({},l,(0,y.createHttpPatch)(l,w,{config:"override"},S,!0)),onRequest:Object.assign({},l,(0,y.createHttpPatch)(l,w,T,S,!0)),default:Object.assign(l,(0,y.createHttpPatch)(l,w,T,S,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,w,{config:"off"},S,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,w,{config:"on"},S,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,w,{config:"override"},S,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,w,T,S,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,w,T,S,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const D=new Map;function A(k,w){return k.getExtensionPathIndex().then(T=>{const S=J.__$__nodeRequire("module"),g=S._load;S._load=function(m,b,f){if(m==="tls")return w.tls;if(m!=="http"&&m!=="https")return g.apply(this,arguments);const c=w[m],p=T.findSubstr(P.URI.file(b.filename));let i=D.get(p);if(i||D.set(p,i={}),!i[m]){const d=c.default;i[m]={...d}}return i[m]}})}}),define(De[299],Ie([1,0,73,297,284,298,41,272,2,14,7,269,112,271]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class S extends C.RequireInterceptor{_installInterceptor(){const m=this,b=J.__$__nodeRequire("module"),f=b._load;b._load=function(d,a,r){return d=p(d),m._factories.has(d)?m._factories.get(d).load(d,E.URI.file((0,w.realpathSync)(a.filename)),o=>f.apply(this,[o,a,r])):f.apply(this,arguments)};const c=b._resolveLookupPaths;b._resolveLookupPaths=(i,d)=>c.call(this,p(i),d);const p=i=>{for(const d of m._alternatives){const a=d(i);if(a){i=a;break}}return i}}}class g extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const m=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(I.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(S,m,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(m){return m.main}async _loadCommonJSModule(m,b,f){if(b.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let c=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();const p=m?.identifier.value;m&&await this._extHostLocalizationService.initializeLocalizedMessages(m);try{p&&l.mark(`code/extHost/willLoadExtensionCode/${p}`),c=J.__$__nodeRequire(b.fsPath)}finally{p&&l.mark(`code/extHost/didLoadExtensionCode/${p}`),f.codeLoadingStop()}return c}async $setRemoteEnvironment(m){if(!!this._initData.remote.isRemote)for(const b in m){const f=m[b];f===null?delete process.env[b]:process.env[b]=f}}}e.ExtHostExtensionService=g}),define(De[142],Ie([1,0,44,310,293,17,77,37,9,8,2,30,71,311,291,96]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(h){this.outputChannel=h}provideTextSearchResults(h,_,L,M){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({..._,folder:_.folder.toString()})}`),new Promise((U,R)=>{M.onCancellationRequested(()=>$());const z=d(h,_),H=_.folder.fsPath,N=z.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${v} ${N}
 - cwd: ${H}`);let V=l.spawn(v,z,{cwd:H});V.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),R((0,k.serializeSearchError)(new k.SearchError(he&&he.message,k.SearchErrorCode.rgProcessError)))});let B=!1;const F=new c(_.maxResults,H,_.previewOptions);F.on("result",he=>{B=!0,K="",L.report(he)});let x=!1;const $=()=>{x=!0,V?.kill(),F?.cancel()};let Q=!1;F.on("hitLimit",()=>{Q=!0,$()});let K="";V.stdout.on("data",he=>{F.handleData(he),B||(K+=he)});let de=!1;V.stdout.once("data",()=>de=!0);let ee="";V.stderr.on("data",he=>{const Y=he.toString();this.outputChannel.appendLine(Y),ee.length+Y.length<1e6&&(ee+=Y)}),V.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),x)U({limitHit:Q});else{F.flush(),V=null;let he;ee&&!de&&(he=b(ee))?R((0,k.serializeSearchError)(new k.SearchError(he.message,he.code))):U({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function b(s){const h=s.split(`
`),_=h[0].trim();if(h.some(M=>M.startsWith("regex parse error")))return new k.SearchError(f(h),k.SearchErrorCode.regexParseError);const L=_.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(_.startsWith("error parsing glob"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.globParseError);if(_.startsWith("the literal"))return new k.SearchError(_.charAt(0).toUpperCase()+_.substr(1),k.SearchErrorCode.invalidLiteral);if(_.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(_,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function f(s){const h=["Regex parse error"],_=s.filter(L=>L.startsWith("PCRE2:"));if(_.length>=1){const L=_[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const M=L.split(":")[1];h.push(":"+M)}}return h.join("")}e.buildRegexParseError=f;class c extends t.EventEmitter{constructor(h,_,L){super(),this.maxResults=h,this.rootFolder=_,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,_){return super.on(h,_),this}handleData(h){if(this.isDone)return;const _=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(_)}handleDecodedData(h){let _=h.indexOf(`
`);const L=this.remainder+h;if(_>=0)_+=this.remainder.length;else{this.remainder=L;return}let M=0;for(;_>=0;)this.handleLine(L.substring(M,_).trim()),M=_+1,_=L.indexOf(`
`,M);this.remainder=L.substring(M)}handleLine(h){if(this.isDone||!h)return;let _;try{_=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(_.type==="match"){const L=p(_.data.path),M=A.URI.file(E.join(this.rootFolder,L)),U=this.createTextSearchMatch(_.data,M);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(_.type==="context"){const L=p(_.data.path),M=A.URI.file(E.join(this.rootFolder,L));this.createTextSearchContext(_.data,M).forEach(R=>this.onResult(R))}}createTextSearchMatch(h,_){const L=h.line_number-1,M=p(h.lines),U=Buffer.from(M);let R=0,z=0,H=L;h.submatches.length===0&&h.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(h.submatches.map((V,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=p(V.match),x=U.slice(R,V.start).toString(),$=i(x),Q=$.numLines>0?$.lastLineLength:$.lastLineLength+z,K=i(F),de=$.numLines+H,ee=K.numLines+de,he=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return R=V.end,z=he,H=ee,new w.Range(de,Q,ee,he)}));return(0,g.createTextSearchResult)(_,M,N,this.previewOptions)}createTextSearchContext(h,_){const L=p(h.lines),M=h.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((U,R)=>({text:U,uri:_,lineNumber:M+R}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function p(s){return s.bytes?Buffer.from(s.bytes,"base64").toString():s.text}function i(s){const h=/\n/g;let _=0,L=-1,M;for(;M=h.exec(s);)_++,L=M.index;const U=L>=0?s.length-L-1:s.length;return{numLines:_,lastLineLength:U}}function d(s,h){const _=["--hidden"];_.push(s.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:M}=(0,y.groupBy)(h.includes,R=>R.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const R=new Set;M.forEach(z=>{R.add(z)}),_.push("-g","!*"),R.forEach(z=>{a(z).map(g.anchorGlob).forEach(H=>{_.push("-g",H)})})}L&&L.length&&L.forEach(R=>{_.push("-g",R)}),h.excludes.map(g.anchorGlob).forEach(R=>_.push("-g",`!${R}`)),h.maxFileSize&&_.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||_.push("--no-ignore-parent"):_.push("--no-ignore"),h.followSymlinks&&_.push("--follow"),h.encoding&&h.encoding!=="utf8"&&_.push("--encoding",h.encoding),s.pattern==="--"&&(s.isRegExp=!0,s.pattern="\\-\\-"),s.isMultiline&&!s.isRegExp&&(s.pattern=(0,D.escapeRegExpCharacters)(s.pattern),s.isRegExp=!0),h.usePCRE2&&_.push("--pcre2"),_.push("--crlf"),s.isRegExp&&(s.pattern=r(s.pattern),_.push("--engine","auto"));let U;if(s.isWordMatch){const z=(0,D.createRegExp)(s.pattern,!!s.isRegExp,{wholeWord:s.isWordMatch}).source.replace(/\\\//g,"/");_.push("--regexp",z)}else if(s.isRegExp){let R=u(s.pattern);R=n(R),_.push("--regexp",R)}else U=s.pattern,_.push("--fixed-strings");return _.push("--no-config"),h.useGlobalIgnoreFiles||_.push("--no-ignore-global"),_.push("--json"),s.isMultiline&&_.push("--multiline"),h.beforeContext&&_.push("--before-context",h.beforeContext+""),h.afterContext&&_.push("--after-context",h.afterContext+""),_.push("--"),U&&_.push(U),_.push("."),_}function a(s){const h=(0,I.splitGlobAware)(s,"/");return h.map((_,L)=>h.slice(0,L+1).join("/"))}e.spreadGlobComponents=a;function r(s){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;s.match(h);)s=s.replace(h,"$1\\x{$2}");const _=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;s.match(_);)s=s.replace(_,"$1\\x{$2}");return s}e.unicodeEscapesToPCRE2=r;const o=s=>s.type==="Assertion"&&s.kind==="lookbehind";function u(s){let h;try{h=new T.RegExpParser().parsePattern(s)}catch{return s}let _="",L=0;const M=(z,H,N)=>{_+=s.slice(L,z)+N,L=H},U=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const H=U[0];if(!H)M(z.start,z.end,"\\r?\\n");else if(!U.some(o))if(H.type==="CharacterClass")if(H.negate){const N=s.slice(H.start+2,z.start)+s.slice(z.end,H.end-1);H.parent?.type==="Quantifier"?M(H.start,H.end,N?`[^${N}]`:"."):M(H.start,H.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=s.slice(H.start+1,z.start)+s.slice(z.end,H.end-1);M(H.start,H.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else H.type==="Quantifier"&&M(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){U.unshift(z)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(z){U.unshift(z)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(z){U.unshift(z)},onCharacterClassLeave(){U.shift()},onAssertionEnter(z){o(z)&&U.push(z)},onAssertionLeave(z){U[0]===z&&U.shift()}}).visit(h),_+=s.slice(L),_}e.fixRegexNewline=u;function n(s){return s.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(De[300],Ie([1,0,21,142,123,14]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,A,k,w){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:P.Schemas.file})},g=new C.Progress(v=>k.report({...v,uri:v.uri.with({scheme:A.folder.scheme})}));return this.withToken(w,v=>T.provideTextSearchResults(D,S,g,v))}else return this.withToken(w,S=>T.provideTextSearchResults(D,A,k,S))}async withToken(D,A){const k=I(D);this.inProgress.add(k);const w=await A(k.token);return this.inProgress.delete(k),w}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=y;function I(E){const D=new l.CancellationTokenSource;return E.onCancellationRequested(()=>D.cancel()),D}}),define(De[301],Ie([1,0,29,142,141]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(E){this.query=E}search(E,D,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){A({message:T})}},w=new C.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),l);return new Promise((T,S)=>w.search(g=>{D(g.map(y))},E).then(g=>T({limitHit:g.limitHit,type:"success",stats:g.stats}),S))}}e.TextSearchEngineAdapter=P;function y(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((E,D)=>{if(D.ranges){const A=D;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(De[302],Ie([1,0,17,18,11,3,108,9,51,2,38,30,292,301]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class S{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let p;const i=m(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{p=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(w.Engine,i,r=>d.fire(r),a)),p.then(a=>d.fire(a),a=>d.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return d.event}textSearch(c){let p;const i=m(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{p=(0,t.createCancelablePromise)(a=>this.ripgrepTextSearch(i,r=>d.fire(r),a)),p.then(a=>d.fire(a),a=>d.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return d.event}ripgrepTextSearch(c,p,i){return c.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(i,p,p)}doFileSearch(c,p,i){return this.doFileSearchWithEngine(w.Engine,c,p,i)}doFileSearchWithEngine(c,p,i,d,a=S.BATCH_SIZE){let r=0;const o=n=>{Array.isArray(n)?(r+=n.length,i(n.map(s=>this.rawMatchToSearchItem(s)))):n.relativePath?(r++,i(this.rawMatchToSearchItem(n))):i(n)};if(p.sortByScore){let n=this.trySortedSearchFromCache(p,o,d);if(!n){const s=p.maxResults?Object.assign({},p,{maxResults:null}):p,h=new c(s);n=this.doSortedSearch(h,p,i,o,d)}return new Promise((s,h)=>{n.then(([_,L])=>{const M=L.map(U=>this.rawMatchToSearchItem(U));this.sendProgress(M,i,a),s(_)},h)})}const u=new c(p);return this.doSearch(u,o,a,d).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:r,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,I.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,p,i,d,a){const r=new P.Emitter;let o=(0,t.createCancelablePromise)(n=>{let s=[];const h=_=>{Array.isArray(_)?s=_:(d(_),r.fire(_))};return this.doSearch(c,h,-1,n).then(_=>[_,s])}),u;if(p.cacheKey){u=this.getOrCreateCache(p.cacheKey);const n={promise:o,event:r.event,resolved:!1};u.resultsToSearchCache[p.filePattern||""]=n,o.then(()=>{n.resolved=!0},s=>{delete u.resultsToSearchCache[p.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([n,s])=>{const h=u?u.scorerCache:Object.create(null),_=(typeof p.maxResults!="number"||p.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(p,s,h,a).then(L=>{const M=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof p.maxResults=="number"&&s.length>p.maxResults},L]})})}getOrCreateCache(c){const p=this.caches[c];return p||(this.caches[c]=new g)}trySortedSearchFromCache(c,p,i){const d=c.cacheKey&&this.caches[c.cacheKey];if(!d)return;const a=this.getResultsFromCache(d,c.filePattern||"",p,i);if(a)return a.then(([r,o,u])=>{const n=E.StopWatch.create(!1);return this.sortResults(c,o,d.scorerCache,i).then(s=>{const h=n.elapsed(),_={fromCache:!0,detailStats:u,type:this.processType,resultCount:o.length,sortingTime:h};return[{type:"success",limitHit:r.limitHit||typeof c.maxResults=="number"&&o.length>c.maxResults,stats:_},s]})})}sortResults(c,p,i,d){const a=(0,y.prepareQuery)(c.filePattern||""),r=(u,n)=>(0,y.compareItemsByFuzzyScore)(u,n,a,!0,v,i),o=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return l.topAsync(p,r,o,1e4,d)}sendProgress(c,p,i){if(i&&i>0)for(let d=0;d<c.length;d+=i)p(c.slice(d,d+i));else p(c)}getResultsFromCache(c,p,i,d){const a=E.StopWatch.create(!1),r=p.indexOf(I.sep)>=0;let o;for(const h in c.resultsToSearchCache)if(p.startsWith(h)){if(r&&h.indexOf(I.sep)<0&&h!=="")continue;const _=c.resultsToSearchCache[h];o={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!o)return null;const u=a.elapsed(),n=E.StopWatch.create(!1),s=o.event(i);return d&&d.onCancellationRequested(()=>{s.dispose()}),o.promise.then(([h,_])=>{if(d&&d.isCancellationRequested)throw(0,C.canceled)();const L=[],M=(0,y.prepareQuery)(p).normalizedLowercase;for(const U of _)!(0,k.isFilePatternMatch)(U,M)||L.push(U);return[h,L,{cacheWasResolved:o.resolved,cacheLookupTime:u,cacheFilterTime:n.elapsed(),cacheEntryCount:_.length}]})}doSearch(c,p,i,d){return new Promise((a,r)=>{let o=[];d?.onCancellationRequested(()=>c.cancel()),c.search(u=>{u&&(i?(o.push(u),i>0&&o.length>=i&&(p(o),o=[])):p(u))},u=>{p(u)},(u,n)=>{o.length&&p(o),u?r(u):a(n)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,i){return c.then(p,i)}catch(p){return this.then(void 0,p)}finally(p){return c.finally(p)}}}}e.SearchService=S,S.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(f){return(0,I.basename)(f.relativePath)}getItemDescription(f){return(0,I.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>D.URI.revive(c))}}function b(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(De[303],Ie([1,0,6,14,2,29,13,25,16,75,54,30,302,300,96,141]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends D.ExtHostSearch{constructor(b,f,c,p){super(b,c,p),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const i=new S.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(i)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new S.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(t.Schemas.file,new w.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,f){const c=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(b)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(b,f,c,p){const i=(0,D.reviveQuery)(c);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,f,i,p):super.$provideFileSearchResults(b,f,c,p)}doInternalFileSearch(b,f,c,p){const i=d=>{if((0,k.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(b,f,d.map(a=>C.URI.file(a.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,i,p)}$clearCache(b){return this._internalFileSearchProvider?.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,f){return new g.NativeTextSearchManager(b,f,void 0,"textSearchProvider")}};v=je([$e(0,E.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,A.IURITransformerService),$e(3,y.ILogService)],v),e.NativeExtHostSearch=v}),define(De[304],Ie([1,0,83,275,287,286,303,299,276,74,41,75,72,40,53,69,274,273,13,288,47]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(A.IExtHostExtensionService,I.ExtHostExtensionService,!1),(0,l.registerSingleton)(b.ILoggerService,m.ExtHostLoggerService,1),(0,l.registerSingleton)(g.IExtensionStoragePaths,v.ExtensionStoragePaths,!1),(0,l.registerSingleton)(D.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(k.IExtHostSearch,y.NativeExtHostSearch,!1),(0,l.registerSingleton)(w.IExtHostTask,C.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(S.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(c.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,!1)}),define(De[312],Ie([1,0,216,313,73,11,115,116,196,91,285,23,29,112,18,118,211,225,289,304]),function(J,e,l,t,C,P,y,I,E,D,A,k,w,T,S,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=J.__$__nodeRequire("module"),u=o._load;o._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const f=process.exit.bind(process);function c(o){process.exit=function(u){if(o)f(u);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(o){f()};function i(){const o=(0,m.readExtHostConnection)(process.env);if(o.type===3)return new Promise((u,n)=>{const s=h=>{const _=h[0],L=new y.BufferedEmitter;_.on("message",M=>L.fire(k.VSBuffer.wrap(M.data))),_.on("close",()=>{p("renderer closed the MessagePort")}),_.start(),u({onMessage:L.event,send:M=>_.postMessage(M.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,s(h)}else global.vscodePortsCallback=s});if(o.type===2)return new Promise((u,n)=>{let s=null;const h=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),_=108e5,L=3e5,M=new S.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),_),U=new S.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),L);process.on("message",(z,H)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){H.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let V;if(z.skipWebSocketFrames)V=new I.NodeSocket(H,"extHost-socket");else{const B=k.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));V=new I.WebSocketNodeSocket(new I.NodeSocket(H,"extHost-socket"),z.permessageDeflate,B,!1)}s?(M.cancel(),U.cancel(),s.beginAcceptReconnection(V,N),s.endAcceptReconnection(),s.sendResume()):(clearTimeout(h),s=new y.PersistentProtocol(V,N),s.sendResume(),s.onDidDispose(()=>p("renderer disconnected")),u(s),s.onSocketClose(()=>{M.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;M.isScheduled()&&U.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(R)});{const u=o.pipeName;return new Promise((n,s)=>{const h=l.createConnection(u,()=>{h.removeListener("error",s);const _=new y.PersistentProtocol(new I.NodeSocket(h,"extHost-renderer"));_.sendResume(),n(_)});h.once("error",s),h.on("close",()=>{p("renderer closed the socket")})})}}async function d(){const o=await i();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(u=>{(0,D.isMessageOfType)(u,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||o.send(u)}async drain(){if(o.drain)return o.drain()}}}function a(o){return new Promise(u=>{const n=o.onMessage(s=>{n.dispose();const h=JSON.parse(s.toString()),_=h.commit,L=E.default.commit;if(_&&L&&_!==L&&f(55),h.parentPid){let M=0;setInterval(function(){try{process.kill(h.parentPid,0),M=0}catch(R){R&&R.code==="EPERM"?(M++,M>=3&&p(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):p(`parent process ${h.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(h.parentPid)}catch(R){(0,P.onUnexpectedError)(R)}}o.send((0,D.createMessageOfType)(0)),u({protocol:o,initData:h})});o.send((0,D.createMessageOfType)(1))})}async function r(){const o=[];process.on("unhandledRejection",(M,U)=>{o.push(U),setTimeout(()=>{const R=o.indexOf(U);R>=0&&U.catch(z=>{o.splice(R,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const U=o.indexOf(M);U>=0&&o.splice(U,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),C.mark("code/extHost/willConnectToRenderer");const u=await d();C.mark("code/extHost/didConnectToRenderer");const n=await a(u);C.mark("code/extHost/didWaitForInitData");const{initData:s}=n;c(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,s.environment.skipWorkspaceStorageLock=(0,g.boolean)(b.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(U){f(U)}exists(U){return w.Promises.exists(U)}realpath(U){return(0,T.realpath)(U)}};let _=null;s.remote.authority&&b.transformURIs&&(_=(0,v.createURITransformer)(s.remote.authority));const L=new A.ExtensionHostMain(n.protocol,s,h,_);p=M=>L.terminate(M)}e.startExtensionHostProcess=r,r().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ef8e6b87a2a5a25ba1ef946bd1640ca3510956c/core/vs/workbench/api/node/extensionHostProcess.js.map
