/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ne){for(var e=[],s=0,I=ne.length;s<I;s++)e[s]=Ie[ne[s]];return e};define(Ie[76],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function s(_,A){const y=Object.create(null);for(const P of _){const R=A(P);let E=y[R];E||(E=y[R]=[]),E.push(P)}return y}e.groupBy=s;function I(_,A){const y=[],P=[];for(const R of _)A.has(R)||y.push(R);for(const R of A)_.has(R)||P.push(R);return{removed:y,added:P}}e.diffSets=I;function b(_,A){const y=[],P=[];for(const[R,E]of _)A.has(R)||y.push(E);for(const[R,E]of A)_.has(R)||P.push(E);return{removed:y,added:P}}e.diffMaps=b;class N{constructor(){this.map=new Map}add(A,y){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(y)}delete(A,y){const P=this.map.get(A);!P||(P.delete(y),P.size===0&&this.map.delete(A))}forEach(A,y){const P=this.map.get(A);!P||P.forEach(y)}}e.SetMap=N}),define(Ie[57],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(_){return(A,y,P)=>{let R=null,E=null;if(typeof P.value=="function"?(R="value",E=P.value):typeof P.get=="function"&&(R="get",E=P.get),!E)throw new Error("not supported");P[R]=_(E,y)}}e.createDecorator=s;function I(_,A,y){let P=null,R=null;if(typeof y.value=="function"?(P="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",R=y.get),!R)throw new Error("not supported");const E=`$memoize$${A}`;y[P]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[E]}}e.memoize=I;function b(_,A,y){return s((P,R)=>{const E=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...C){this[m]||(this[m]=y?y():void 0),clearTimeout(this[E]),A&&(this[m]=A(this[m],...C),C=[this[m]]),this[E]=setTimeout(()=>{P.apply(this,C),this[m]=y?y():void 0},_)}})}e.debounce=b;function N(_,A,y){return s((P,R)=>{const E=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,C=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...a){if(this[m]||(this[m]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...a)),this[p])return;const l=this[C]+_;l<=Date.now()?(this[C]=Date.now(),P.apply(this,[this[m]]),this[m]=y?y():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[C]=Date.now(),P.apply(this,[this[m]]),this[m]=y?y():void 0},l-Date.now()))}})}e.throttle=N}),define(Ie[77],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(Ie[105],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function _(t,h=!1){let r=0;const n=t.length;let o="",u=0,i=16,c=0;function g(M){let O=0,H=0;for(;O<M;){const W=t.charCodeAt(r);if(W>=48&&W<=57)H=H*16+W-48;else if(W>=65&&W<=70)H=H*16+W-65+10;else if(W>=97&&W<=102)H=H*16+W-97+10;else break;r++,O++}return O<M&&(H=-1),H}function T(M){r=M,o="",u=0,i=16,c=0}function F(){const M=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&P(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&P(t.charCodeAt(r)))for(r++;r<t.length&&P(t.charCodeAt(r));)r++;else return c=3,t.substring(M,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&P(t.charCodeAt(r))){for(r++;r<t.length&&P(t.charCodeAt(r));)r++;O=r}else c=3;return t.substring(M,O)}function j(){let M="",O=r;for(;;){if(r>=n){M+=t.substring(O,r),c=2;break}const H=t.charCodeAt(r);if(H===34){M+=t.substring(O,r),r++;break}if(H===92){if(M+=t.substring(O,r),r++,r>=n){c=2;break}switch(t.charCodeAt(r++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const z=g(4);z>=0?M+=String.fromCharCode(z):c=4;break}default:c=5}O=r;continue}if(H>=0&&H<=31)if(y(H)){M+=t.substring(O,r),c=2;break}else c=6;r++}return M}function U(){if(o="",c=0,u=r,r>=n)return u=n,i=17;let M=t.charCodeAt(r);if(A(M)){do r++,o+=String.fromCharCode(M),M=t.charCodeAt(r);while(A(M));return i=15}if(y(M))return r++,o+=String.fromCharCode(M),M===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),i=14;switch(M){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,o=j(),i=10;case 47:{const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!y(t.charCodeAt(r));)r++;return o=t.substring(O,r),i=12}if(t.charCodeAt(r+1)===42){r+=2;const H=n-1;let W=!1;for(;r<H;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,c=1),o=t.substring(O,r),i=13}return o+=String.fromCharCode(M),r++,i=16}case 45:if(o+=String.fromCharCode(M),r++,r===n||!P(t.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),i=11;default:for(;r<n&&D(M);)r++,M=t.charCodeAt(r);if(u!==r){switch(o=t.substring(u,r),o){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return o+=String.fromCharCode(M),r++,i=16}}function D(M){if(A(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let M;do M=U();while(M>=12&&M<=15);return M}return{setPosition:T,getPosition:()=>r,scan:h?x:U,getToken:()=>i,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>c}}e.createScanner=_;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function E(t,h){const r=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function c(g,T,F,j){u.value=g,u.offset=T,u.length=F,u.type=j,u.colonOffset=void 0,o=u}try{w(t,{onObjectBegin:(g,T)=>{if(h<=g)throw n;o=void 0,i=h>g,r.push("")},onObjectProperty:(g,T,F)=>{if(h<T||(c(g,T,F,"property"),r[r.length-1]=g,h<=T+F))throw n},onObjectEnd:(g,T)=>{if(h<=g)throw n;o=void 0,r.pop()},onArrayBegin:(g,T)=>{if(h<=g)throw n;o=void 0,r.push(0)},onArrayEnd:(g,T)=>{if(h<=g)throw n;o=void 0,r.pop()},onLiteralValue:(g,T,F)=>{if(h<T||(c(g,T,F,S(g)),h<=T+F))throw n},onSeparator:(g,T,F)=>{if(h<=T)throw n;if(g===":"&&o&&o.type==="property")o.colonOffset=T,i=!1,o=void 0;else if(g===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(i=!0,r[r.length-1]=""),o=void 0}}})}catch(g){if(g!==n)throw g}return{path:r,previousNode:o,isAtPropertyKey:i,matches:g=>{let T=0;for(let F=0;T<g.length&&F<r.length;F++)if(g[T]===r[F]||g[T]==="*")T++;else if(g[T]!=="**")return!1;return T===g.length}}}e.getLocation=E;function m(t,h=[],r=N.DEFAULT){let n=null,o=[];const u=[];function i(g){Array.isArray(o)?o.push(g):n!==null&&(o[n]=g)}return w(t,{onObjectBegin:()=>{const g={};i(g),u.push(o),o=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const g=[];i(g),u.push(o),o=g,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:i,onError:(g,T,F)=>{h.push({error:g,offset:T,length:F})}},r),o[0]}e.parse=m;function C(t,h=[],r=N.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function u(g){return n.children.push(g),g}w(t,{onObjectBegin:g=>{n=u({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,T,F)=>{n=u({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:T,length:F,parent:n})},onObjectEnd:(g,T)=>{n.length=g+T-n.offset,n=n.parent,o(g+T)},onArrayBegin:(g,T)=>{n=u({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,T)=>{n.length=g+T-n.offset,n=n.parent,o(g+T)},onLiteralValue:(g,T,F)=>{u({type:S(g),offset:T,length:F,parent:n,value:g}),o(T+F)},onSeparator:(g,T,F)=>{n.type==="property"&&(g===":"?n.colonOffset=T:g===","&&o(T))},onError:(g,T,F)=>{h.push({error:g,offset:T,length:F})}},r);const c=n.children[0];return c&&delete c.parent,c}e.parseTree=C;function p(t,h){if(!t)return;let r=t;for(const n of h)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===n){r=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=p;function a(t){if(!t.parent||!t.parent.children)return[];const h=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;h.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&h.push(r)}return h}e.getNodePath=a;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const h=Object.create(null);for(const r of t.children){const n=r.children[1];n&&(h[r.children[0].value]=l(n))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=l;function f(t,h,r=!1){return h>=t.offset&&h<t.offset+t.length||r&&h===t.offset+t.length}e.contains=f;function v(t,h,r=!1){if(f(t,h,r)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=h;o++){const u=v(n[o],h,r);if(u)return u}return t}}e.findNodeAtOffset=v;function w(t,h,r=N.DEFAULT){const n=_(t,!1);function o(le){return le?()=>le(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(le){return le?fe=>le(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const i=o(h.onObjectBegin),c=u(h.onObjectProperty),g=o(h.onObjectEnd),T=o(h.onArrayBegin),F=o(h.onArrayEnd),j=u(h.onLiteralValue),U=u(h.onSeparator),D=o(h.onComment),x=u(h.onError),M=r&&r.disallowComments,O=r&&r.allowTrailingComma;function H(){for(;;){const le=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:M||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(le){case 12:case 13:M?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return le}}}function W(le,fe=[],Q=[]){if(x(le),fe.length+Q.length>0){let pe=n.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){H();break}else if(Q.indexOf(pe)!==-1)break;pe=H()}}}function z(le){const fe=n.getTokenValue();return le?j(fe):c(fe),H(),!0}function G(){switch(n.getToken()){case 11:{let le=0;try{le=JSON.parse(n.getTokenValue()),typeof le!="number"&&(W(2),le=0)}catch{W(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return H(),!0}function te(){return n.getToken()!==10?(W(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(U(":"),H(),be()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function he(){i(),H();let le=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(le||W(4,[],[]),U(","),H(),n.getToken()===2&&O)break}else le&&W(6,[],[]);te()||W(4,[],[2,5]),le=!0}return g(),n.getToken()!==2?W(7,[2],[]):H(),!0}function re(){T(),H();let le=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(le||W(4,[],[]),U(","),H(),n.getToken()===4&&O)break}else le&&W(6,[],[]);be()||W(4,[],[4,5]),le=!0}return F(),n.getToken()!==4?W(8,[4],[]):H(),!0}function be(){switch(n.getToken()){case 3:return re();case 1:return he();case 10:return z(!0);default:return G()}}return H(),n.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):be()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=w;function d(t,h){const r=_(t),n=[];let o,u=0,i;do switch(i=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:u!==i&&n.push(t.substring(u,i)),h!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,h)),u=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=d;function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[106],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function s(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function I(ke,ye){if(!!ke){if(typeof ke=="string")return b(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return b(ke,ye)}}function b(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function N(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=I(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function A(ke){ne.defaults=ke}var y=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ye){return m[ye]};function p(ke,ye){if(ye){if(y.test(ke))return ke.replace(P,C)}else if(R.test(ke))return ke.replace(E,C);return ke}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ke){return ke.replace(a,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,ee){return ee=ee.source||ee,ee=ee.replace(f,"$1"),ke=ke.replace(ue,ee),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var w=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(l(De)).replace(w,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!d.test(De)&&(De=o(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ke,ye){t[" "+ke]||(h.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=g(ke,"/",!0)),ke=t[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(r,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(n,"$1")+ye:ke+ye}var u={exec:function(){}};function i(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function c(ke,ye){var De=ke.replace(/\|/g,function(ee,Z,k){for(var B=!1,V=Z;--V>=0&&k[V]==="\\";)B=!B;return B?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function g(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ee=ke.charAt(ae-ue-1);if(ee===ye&&!De)ue++;else if(ee!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function T(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function F(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function U(ke,ye,De,ae){var ue=ye.href,ee=ye.title?p(ye.title):null,Z=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var k={type:"link",raw:De,href:ue,title:ee,text:Z,tokens:ae.inlineTokens(Z)};return ae.state.inLink=!1,k}return{type:"image",raw:De,href:ue,title:ee,text:p(Z)}}function D(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var ee=ue.match(/^\s+/);if(ee===null)return ue;var Z=ee[0];return Z.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var x=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:g(ee,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ee=ue[0],Z=D(ee,ue[3]||"");return{type:"code",raw:ee,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ee=ue[2].trim();if(/#$/.test(ee)){var Z=g(ee,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(ee=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ee=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze=ue[1].trim(),Je=ze.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Je?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Je?ze:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=Pe.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=ue[0],ae=ae.substring(ee.length),ce=ue[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ve=ce.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,ve=ce.slice(B),B+=ue[1].length),q=!1,!ce&&/^ *$/.test(J)&&(ee+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Y=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),me=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(Ee=ae.split(`
`,1)[0],ce=Ee,this.options.pedantic&&(ce=ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(ce)||me.test(ce)||nt.test(ce)||X.test(ae)));){if(ce.search(/[^ ]/)>=B||!ce.trim())ve+=`
`+ce.slice(B);else if(!q)ve+=`
`+ce;else break;!q&&!ce.trim()&&(q=!0),ee+=Ee+`
`,ae=ae.substring(Ee.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(ee)&&(oe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ve),Z&&(k=Z[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ee,task:!!Z,checked:k,loose:!1,text:ve}),Ge.raw+=ee}Ge.items[Ge.items.length-1].raw=ee.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var Be=Ge.items.length;for(V=0;V<Be;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var je=Ge.items[V].tokens.filter(function(Ke){return Ke.type==="space"}),et=je.every(function(Ke){for(var Ve=Ke.raw.split(""),it=0,st=N(Ve),ct;!(ct=st()).done;){var at=ct.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&je.length&&et&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]);ee.type="paragraph",ee.text=Z,ee.tokens=this.lexer.inline(Z)}return ee}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ee={type:"table",header:c(ue[1]).map(function(oe){return{text:oe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ue[0];var Z=ee.align.length,k,B,V,q;for(k=0;k<Z;k++)/^ *-+: *$/.test(ee.align[k])?ee.align[k]="right":/^ *:-+: *$/.test(ee.align[k])?ee.align[k]="center":/^ *:-+ *$/.test(ee.align[k])?ee.align[k]="left":ee.align[k]=null;for(Z=ee.rows.length,k=0;k<Z;k++)ee.rows[k]=c(ee.rows[k],ee.header.length).map(function(oe){return{text:oe}});for(Z=ee.header.length,B=0;B<Z;B++)ee.header[B].tokens=this.lexer.inline(ee.header[B].text);for(Z=ee.rows.length,B=0;B<Z;B++)for(q=ee.rows[B],V=0;V<q.length;V++)q[V].tokens=this.lexer.inline(q[V].text);return ee}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ee=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ee,tokens:this.lexer.inline(ee)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:p(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var Z=g(ee.slice(0,-1),"\\");if((ee.length-Z.length)%2===0)return}else{var k=T(ue[2],"()");if(k>-1){var B=ue[0].indexOf("!")===0?5:4,V=B+ue[1].length+k;ue[2]=ue[2].substring(0,k),ue[0]=ue[0].substring(0,V).trim(),ue[3]=""}}var q=ue[2],oe="";if(this.options.pedantic){var ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);ce&&(q=ce[1],oe=ce[3])}else oe=ue[3]?ue[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ee)?q=q.slice(1):q=q.slice(1,-1)),U(ue,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var Z=(ee[2]||ee[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var k=ee[0].charAt(0);return{type:"text",raw:k,text:k}}return U(ee,Z,ee[0],this.lexer)}},ye.emStrong=function(ae,ue,ee){ee===void 0&&(ee="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=Z[1]||Z[2]||"";if(!k||k&&(ee===""||this.rules.inline.punctuation.exec(ee))){var B=Z[0].length-1,V,q,oe=B,ce=0,J=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,ue=ue.slice(-1*ae.length+B);(Z=J.exec(ue))!=null;)if(V=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!V){if(q=V.length,Z[3]||Z[4]){oe+=q;continue}else if((Z[5]||Z[6])&&B%3&&!((B+q)%3)){ce+=q;continue}if(oe-=q,!(oe>0)){if(q=Math.min(q,q+oe+ce),Math.min(B,q)%2){var Ee=ae.slice(1,B+Z.index+q);return{type:"em",raw:ae.slice(0,B+Z.index+q+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=ae.slice(2,B+Z.index+q-1);return{type:"strong",raw:ae.slice(0,B+Z.index+q+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ee=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(ee),k=/^ /.test(ee)&&/ $/.test(ee);return Z&&k&&(ee=ee.substring(1,ee.length-1)),ee=p(ee,!0),{type:"codespan",raw:ue[0],text:ee}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var ee=this.rules.inline.autolink.exec(ae);if(ee){var Z,k;return ee[2]==="@"?(Z=p(this.options.mangle?ue(ee[1]):ee[1]),k="mailto:"+Z):(Z=p(ee[1]),k=Z),{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(ae,ue){var ee;if(ee=this.rules.inline.url.exec(ae)){var Z,k;if(ee[2]==="@")Z=p(this.options.mangle?ue(ee[0]):ee[0]),k="mailto:"+Z;else{var B;do B=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(B!==ee[0]);Z=p(ee[0]),ee[1]==="www."?k="http://"+Z:k=Z}return{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(ae,ue){var ee=this.rules.inline.text.exec(ae);if(ee){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):p(ee[0]):ee[0]:Z=p(this.options.smartypants?ue(ee[0]):ee[0]),{type:"text",raw:ee[0],text:Z}}},ke}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=v(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=v(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=v(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=v(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=v(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=i({},M),M.gfm=i({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=v(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=i({},M.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:v(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=v(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=v(M._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=v(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=v(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=v(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=v(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=v(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=v(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=v(O.reflink).replace("label",O._label).replace("ref",M._label).getRegex(),O.nolink=v(O.nolink).replace("ref",M._label).getRegex(),O.reflinkSearch=v(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=i({},O),O.pedantic=i({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=i({},O.normal,{escape:v(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=v(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=i({},O.gfm,{br:v(O.br).replace("{2,}","*").getRegex(),text:v(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var z=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ne.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:M.normal,inline:O.normal};this.options.pedantic?(ae.block=M.pedantic,ae.inline=O.pedantic):this.options.gfm&&(ae.block=M.gfm,this.options.breaks?ae.inline=O.breaks:ae.inline=O.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var ee=new ke(ue);return ee.lex(ae)},ke.lexInline=function(ae,ue){var ee=new ke(ue);return ee.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,ce,J){return ce+"    ".repeat(J.length)});for(var Z,k,B,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(Z=oe.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.list(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.def(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,ce=ae.slice(1),J=void 0;ee.options.extensions.startBlock.forEach(function(Ee){J=Ee.call({lexer:this},ce),typeof J=="number"&&J>=0&&(oe=Math.min(oe,J))}),oe<1/0&&oe>=0&&(B=ae.substring(0,oe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(B))){k=ue[ue.length-1],V&&k.type==="paragraph"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z),V=B.length!==ae.length,ae=ae.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(ae){var q="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]);var Z,k,B,V=ae,q,oe,ce;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)J.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,q.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(ce=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(Z=ve.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.tag(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.link(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.emStrong(ae,V,ce)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.codespan(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.br(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.del(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.autolink(ae,W)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(ae,W))){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=ae.slice(1),ze=void 0;ee.options.extensions.startInline.forEach(function(Je){ze=Je.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&(B=ae.substring(0,ve+1))}(),Z=this.tokenizer.inlineText(B,H)){ae=ae.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ce=Z.raw.slice(-1)),oe=!0,k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(ae){var Ee="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},s(ke,null,[{key:"rules",get:function(){return{block:M,inline:O}}}]),ke}(),G=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,ee){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(ae,Z);k!=null&&k!==ae&&(ee=!0,ae=k)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+p(Z,!0)+'">'+(ee?ae:p(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:p(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,ee,Z){if(this.options.headerIds){var k=this.options.headerPrefix+Z.slug(ee);return"<h"+ue+' id="'+k+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,ee){var Z=ue?"ol":"ul",k=ue&&ee!==1?' start="'+ee+'"':"";return"<"+Z+k+`>
`+ae+"</"+Z+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var ee=ue.header?"th":"td",Z=ue.align?"<"+ee+' align="'+ue.align+'">':"<"+ee+">";return Z+ae+("</"+ee+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,ee){if(ae=S(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<a href="'+p(ae)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+ee+"</a>",Z},ye.image=function(ae,ue,ee){if(ae=S(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<img src="'+ae+'" alt="'+ee+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(ae){return ae},ke}(),te=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,ee){return""+ee},ye.image=function(ae,ue,ee){return""+ee},ye.br=function(){return""},ke}(),he=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var ee=ae,Z=0;if(this.seen.hasOwnProperty(ee)){Z=this.seen[ae];do Z++,ee=ae+"-"+Z;while(this.seen.hasOwnProperty(ee))}return ue||(this.seen[ae]=Z,this.seen[ee]=0),ee},ye.slug=function(ae,ue){ue===void 0&&(ue={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,ue.dryrun)},ke}(),re=function(){function ke(De){this.options=De||ne.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new he}ke.parse=function(ae,ue){var ee=new ke(ue);return ee.parse(ae)},ke.parseInline=function(ae,ue){var ee=new ke(ue);return ee.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var ee="",Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be=ae.length;for(Z=0;Z<Be;Z++){if(ve=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(me=this.options.extensions.renderers[ve.type].call({parser:this},ve),me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ee+=me||"";continue}switch(ve.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(J="",ce="",V=ve.header.length,k=0;k<V;k++)ce+=this.renderer.tablecell(this.parseInline(ve.header[k].tokens),{header:!0,align:ve.align[k]});for(J+=this.renderer.tablerow(ce),Ee="",V=ve.rows.length,k=0;k<V;k++){for(oe=ve.rows[k],ce="",q=oe.length,B=0;B<q;B++)ce+=this.renderer.tablecell(this.parseInline(oe[B].tokens),{header:!1,align:ve.align[B]});Ee+=this.renderer.tablerow(ce)}ee+=this.renderer.table(J,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),ee+=this.renderer.blockquote(Ee);continue}case"list":{for(Ne=ve.ordered,ze=ve.start,Je=ve.loose,V=ve.items.length,Ee="",k=0;k<V;k++)Pe=ve.items[k],nt=Pe.checked,X=Pe.task,Ge="",Pe.task&&(Y=this.renderer.checkbox(nt),Je?Pe.tokens.length>0&&Pe.tokens[0].type==="paragraph"?(Pe.tokens[0].text=Y+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=Y+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:Y}):Ge+=Y),Ge+=this.parse(Pe.tokens,Je),Ee+=this.renderer.listitem(Ge,X,nt);ee+=this.renderer.list(Ee,Ne,ze);continue}case"html":{ee+=this.renderer.html(ve.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;Z+1<Be&&ae[Z+1].type==="text";)ve=ae[++Z],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ee+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var je='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ee},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var ee="",Z,k,B,V=ae.length;for(Z=0;Z<V;Z++){if(k=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(B=this.options.extensions.renderers[k.type].call({parser:this},k),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){ee+=B||"";continue}switch(k.type){case"escape":{ee+=ue.text(k.text);break}case"html":{ee+=ue.html(k.text);break}case"link":{ee+=ue.link(k.href,k.title,this.parseInline(k.tokens,ue));break}case"image":{ee+=ue.image(k.href,k.title,k.text);break}case"strong":{ee+=ue.strong(this.parseInline(k.tokens,ue));break}case"em":{ee+=ue.em(this.parseInline(k.tokens,ue));break}case"codespan":{ee+=ue.codespan(k.text);break}case"br":{ee+=ue.br();break}case"del":{ee+=ue.del(this.parseInline(k.tokens,ue));break}case"text":{ee+=ue.text(k.text);break}default:{var q='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ee},ke}();function be(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=i({},be.defaults,ye||{}),F(ye),De){var ae=ye.highlight,ue;try{ue=z.lex(ke,ye)}catch(V){return De(V)}var ee=function(q){var oe;if(!q)try{ye.walkTokens&&be.walkTokens(ue,ye.walkTokens),oe=re.parse(ue,ye)}catch(ce){q=ce}return ye.highlight=ae,q?De(q):De(null,oe)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return ee();var Z=0;be.walkTokens(ue,function(V){V.type==="code"&&(Z++,setTimeout(function(){ae(V.text,V.lang,function(q,oe){if(q)return ee(q);oe!=null&&oe!==V.text&&(V.text=oe,V.escaped=!0),Z--,Z===0&&ee()})},0))}),Z===0&&ee();return}function k(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(V.message+"",!0)+"</pre>";throw V}try{var B=z.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(be.walkTokens(B,ye.walkTokens)).then(function(){return re.parse(B,ye)}).catch(k);be.walkTokens(B,ye.walkTokens)}return re.parse(B,ye)}catch(V){k(V)}}be.options=be.setOptions=function(ke){return i(be.defaults,ke),A(be.defaults),be},be.getDefaults=_,be.defaults=ne.defaults,be.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=i.apply(void 0,[{}].concat(ye)),ue=be.defaults.extensions||{renderers:{},childTokens:{}},ee;ye.forEach(function(Z){if(Z.extensions&&(ee=!0,Z.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var V=ue.renderers?ue.renderers[B.name]:null;V?ue.renderers[B.name]=function(){for(var q=arguments.length,oe=new Array(q),ce=0;ce<q;ce++)oe[ce]=arguments[ce];var J=B.renderer.apply(this,oe);return J===!1&&(J=V.apply(this,oe)),J}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),Z.renderer&&function(){var B=be.defaults.renderer||new G,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.renderer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.renderer)V(q);ae.renderer=B}(),Z.tokenizer&&function(){var B=be.defaults.tokenizer||new x,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.tokenizer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.tokenizer)V(q);ae.tokenizer=B}(),Z.walkTokens){var k=be.defaults.walkTokens;ae.walkTokens=function(B){var V=[];return V.push(Z.walkTokens.call(this,B)),k&&(V=V.concat(k.call(this,B))),V}}ee&&(ae.extensions=ue),be.setOptions(ae)})},be.walkTokens=function(ke,ye){for(var De=[],ae=function(){var k=ee.value;switch(De=De.concat(ye.call(be,k)),k.type){case"table":{for(var B=N(k.header),V;!(V=B()).done;){var q=V.value;De=De.concat(be.walkTokens(q.tokens,ye))}for(var oe=N(k.rows),ce;!(ce=oe()).done;)for(var J=ce.value,Ee=N(J),ve;!(ve=Ee()).done;){var Ne=ve.value;De=De.concat(be.walkTokens(Ne.tokens,ye))}break}case"list":{De=De.concat(be.walkTokens(k.items,ye));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[k.type]?be.defaults.extensions.childTokens[k.type].forEach(function(ze){De=De.concat(be.walkTokens(k[ze],ye))}):k.tokens&&(De=De.concat(be.walkTokens(k.tokens,ye)))}},ue=N(ke),ee;!(ee=ue()).done;)ae();return De},be.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=i({},be.defaults,ye||{}),F(ye);try{var De=z.lexInline(ke,ye);return ye.walkTokens&&be.walkTokens(De,ye.walkTokens),re.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(ae.message+"",!0)+"</pre>";throw ae}},be.Parser=re,be.parser=re.parse,be.Renderer=G,be.TextRenderer=te,be.Lexer=z,be.lexer=z.lex,be.Tokenizer=x,be.Slugger=he,be.parse=be;var le=be.options,fe=be.setOptions,Q=be.use,pe=be.walkTokens,Se=be.parseInline,Fe=be,Ue=re.parse,Xe=z.lex;ne.Lexer=z,ne.Parser=re,ne.Renderer=G,ne.Slugger=he,ne.TextRenderer=te,ne.Tokenizer=x,ne.getDefaults=_,ne.lexer=Xe,ne.marked=be,ne.options=le,ne.parse=Fe,ne.parseInline=Se,ne.parser=Ue,ne.setOptions=fe,ne.use=Q,ne.walkTokens=pe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ie[107],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(A,y,P){return Math.min(Math.max(A,y),P)}e.clamp=s;function I(A,y){return(y+A%y)%y}e.rot=I;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class N{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class _{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const P=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ne(b){const N=[];typeof b=="number"&&N.push("code/timeOrigin",b);function _(y){N.push(y,Date.now())}function A(){const y=[];for(let P=0;P<N.length;P+=2)y.push({name:N[P],startTime:N[P+1]});return y}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const _ of performance.getEntriesByType("mark"))N.push({name:_.name,startTime:Math.round(b+_.startTime)});return N}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function s(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=s(I))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var I in s)(typeof exports=="object"?exports:ne)[I]=s[I]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function s(I){if(e[I])return e[I].exports;var b=e[I]={i:I,l:!1,exports:{}};return ne[I].call(b.exports,b,b.exports,s),b.l=!0,b.exports}return s.m=ne,s.c=e,s.d=function(I,b,N){s.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:N})},s.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},s.t=function(I,b){if(1&b&&(I=s(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var N=Object.create(null);if(s.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var _ in I)s.d(N,_,function(A){return I[A]}.bind(null,_));return N},s.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return s.d(b,"a",b),b},s.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},s.p="",s(s.s=0)}([function(ne,e,s){(function(I){var b;e=ne.exports=Q,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],P=0,R=P++;y[R]="0|[1-9]\\d*";var E=P++;y[E]="[0-9]+";var m=P++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=P++;y[C]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var p=P++;y[p]="("+y[E]+")\\.("+y[E]+")\\.("+y[E]+")";var a=P++;y[a]="(?:"+y[R]+"|"+y[m]+")";var l=P++;y[l]="(?:"+y[E]+"|"+y[m]+")";var f=P++;y[f]="(?:-("+y[a]+"(?:\\."+y[a]+")*))";var v=P++;y[v]="(?:-?("+y[l]+"(?:\\."+y[l]+")*))";var w=P++;y[w]="[0-9A-Za-z-]+";var d=P++;y[d]="(?:\\+("+y[w]+"(?:\\."+y[w]+")*))";var S=P++,t="v?"+y[C]+y[f]+"?"+y[d]+"?";y[S]="^"+t+"$";var h="[v=\\s]*"+y[p]+y[v]+"?"+y[d]+"?",r=P++;y[r]="^"+h+"$";var n=P++;y[n]="((?:<|>)?=?)";var o=P++;y[o]=y[E]+"|x|X|\\*";var u=P++;y[u]=y[R]+"|x|X|\\*";var i=P++;y[i]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[f]+")?"+y[d]+"?)?)?";var c=P++;y[c]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[v]+")?"+y[d]+"?)?)?";var g=P++;y[g]="^"+y[n]+"\\s*"+y[i]+"$";var T=P++;y[T]="^"+y[n]+"\\s*"+y[c]+"$";var F=P++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=P++;y[j]="(?:~>?)";var U=P++;y[U]="(\\s*)"+y[j]+"\\s+",A[U]=new RegExp(y[U],"g");var D=P++;y[D]="^"+y[j]+y[i]+"$";var x=P++;y[x]="^"+y[j]+y[c]+"$";var M=P++;y[M]="(?:\\^)";var O=P++;y[O]="(\\s*)"+y[M]+"\\s+",A[O]=new RegExp(y[O],"g");var H=P++;y[H]="^"+y[M]+y[i]+"$";var W=P++;y[W]="^"+y[M]+y[c]+"$";var z=P++;y[z]="^"+y[n]+"\\s*("+h+")$|^$";var G=P++;y[G]="^"+y[n]+"\\s*("+t+")$|^$";var te=P++;y[te]="(\\s*)"+y[n]+"\\s*("+h+"|"+y[i]+")",A[te]=new RegExp(y[te],"g");var he=P++;y[he]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var re=P++;y[re]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var be=P++;y[be]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)b(le,y[le]),A[le]||(A[le]=new RegExp(y[le]));function fe(J,Ee){if(J instanceof Q)return J;if(typeof J!="string"||J.length>N||!(Ee?A[r]:A[S]).test(J))return null;try{return new Q(J,Ee)}catch{return null}}function Q(J,Ee){if(J instanceof Q){if(J.loose===Ee)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Q))return new Q(J,Ee);b("SemVer",J,Ee),this.loose=Ee;var ve=J.trim().match(Ee?A[r]:A[S]);if(!ve)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<_)return ze}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=fe,e.valid=function(J,Ee){var ve=fe(J,Ee);return ve?ve.version:null},e.clean=function(J,Ee){var ve=fe(J.trim().replace(/^[=v]+/,""),Ee);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return b("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),Se(this.major,J.major)||Se(this.minor,J.minor)||Se(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var Ee=0;do{var ve=this.prerelease[Ee],Ne=J.prerelease[Ee];if(b("prerelease compare",Ee,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return Se(ve,Ne)}while(++Ee)},Q.prototype.inc=function(J,Ee){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,Ee,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new Q(J,ve).inc(Ee,Ne).version}catch{return null}},e.diff=function(J,Ee){if(ke(J,Ee))return null;var ve=fe(J),Ne=fe(Ee);if(ve.prerelease.length||Ne.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return ze},e.compareIdentifiers=Se;var pe=/^[0-9]+$/;function Se(J,Ee){var ve=pe.test(J),Ne=pe.test(Ee);return ve&&Ne&&(J=+J,Ee=+Ee),ve&&!Ne?-1:Ne&&!ve?1:J<Ee?-1:J>Ee?1:0}function Fe(J,Ee,ve){return new Q(J,ve).compare(new Q(Ee,ve))}function Ue(J,Ee,ve){return Fe(J,Ee,ve)>0}function Xe(J,Ee,ve){return Fe(J,Ee,ve)<0}function ke(J,Ee,ve){return Fe(J,Ee,ve)===0}function ye(J,Ee,ve){return Fe(J,Ee,ve)!==0}function De(J,Ee,ve){return Fe(J,Ee,ve)>=0}function ae(J,Ee,ve){return Fe(J,Ee,ve)<=0}function ue(J,Ee,ve,Ne){var ze;switch(Ee){case"===":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J===ve;break;case"!==":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J!==ve;break;case"":case"=":case"==":ze=ke(J,ve,Ne);break;case"!=":ze=ye(J,ve,Ne);break;case">":ze=Ue(J,ve,Ne);break;case">=":ze=De(J,ve,Ne);break;case"<":ze=Xe(J,ve,Ne);break;case"<=":ze=ae(J,ve,Ne);break;default:throw new TypeError("Invalid operator: "+Ee)}return ze}function ee(J,Ee){if(J instanceof ee){if(J.loose===Ee)return J;J=J.value}if(!(this instanceof ee))return new ee(J,Ee);b("comparator",J,Ee),this.loose=Ee,this.parse(J),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(J,Ee){return Se(Ee,J)},e.major=function(J,Ee){return new Q(J,Ee).major},e.minor=function(J,Ee){return new Q(J,Ee).minor},e.patch=function(J,Ee){return new Q(J,Ee).patch},e.compare=Fe,e.compareLoose=function(J,Ee){return Fe(J,Ee,!0)},e.rcompare=function(J,Ee,ve){return Fe(Ee,J,ve)},e.sort=function(J,Ee){return J.sort(function(ve,Ne){return e.compare(ve,Ne,Ee)})},e.rsort=function(J,Ee){return J.sort(function(ve,Ne){return e.rcompare(ve,Ne,Ee)})},e.gt=Ue,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=ee;var Z={};function k(J,Ee){if(J instanceof k)return J.loose===Ee?J:new k(J.raw,Ee);if(J instanceof ee)return new k(J.value,Ee);if(!(this instanceof k))return new k(J,Ee);if(this.loose=Ee,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function B(J){return!J||J.toLowerCase()==="x"||J==="*"}function V(J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be){return((Ee=B(ve)?"":B(Ne)?">="+ve+".0.0":B(ze)?">="+ve+"."+Ne+".0":">="+Ee)+" "+(Pe=B(nt)?"":B(X)?"<"+(+nt+1)+".0.0":B(Y)?"<"+nt+"."+(+X+1)+".0":me?"<="+nt+"."+X+"."+Y+"-"+me:"<="+Pe)).trim()}function q(J,Ee){for(var ve=0;ve<J.length;ve++)if(!J[ve].test(Ee))return!1;if(Ee.prerelease.length){for(ve=0;ve<J.length;ve++)if(b(J[ve].semver),J[ve].semver!==Z&&J[ve].semver.prerelease.length>0){var Ne=J[ve].semver;if(Ne.major===Ee.major&&Ne.minor===Ee.minor&&Ne.patch===Ee.patch)return!0}return!1}return!0}function oe(J,Ee,ve){try{Ee=new k(Ee,ve)}catch{return!1}return Ee.test(J)}function ce(J,Ee,ve,Ne){var ze,Je,Ge,Pe,nt;switch(J=new Q(J,Ne),Ee=new k(Ee,Ne),ve){case">":ze=Ue,Je=ae,Ge=Xe,Pe=">",nt=">=";break;case"<":ze=Xe,Je=De,Ge=Ue,Pe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(J,Ee,Ne))return!1;for(var X=0;X<Ee.set.length;++X){var Y=Ee.set[X],me=null,Be=null;if(Y.forEach(function(je){je.semver===Z&&(je=new ee(">=0.0.0")),me=me||je,Be=Be||je,ze(je.semver,me.semver,Ne)?me=je:Ge(je.semver,Be.semver,Ne)&&(Be=je)}),me.operator===Pe||me.operator===nt||(!Be.operator||Be.operator===Pe)&&Je(J,Be.semver)||Be.operator===nt&&Ge(J,Be.semver))return!1}return!0}ee.prototype.parse=function(J){var Ee=this.loose?A[z]:A[G],ve=J.match(Ee);if(!ve)throw new TypeError("Invalid comparator: "+J);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=Z},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(J){return b("Comparator.test",J,this.loose),this.semver===Z||(typeof J=="string"&&(J=new Q(J,this.loose)),ue(J,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(J,Ee){if(!(J instanceof ee))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new k(J.value,Ee),oe(this.value,ve,Ee);if(J.operator==="")return ve=new k(this.value,Ee),oe(J.semver,ve,Ee);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Pe=ue(this.semver,"<",J.semver,Ee)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),nt=ue(this.semver,">",J.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||ze||Je&&Ge||Pe||nt},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(J){var Ee=this.loose;J=J.trim(),b("range",J,Ee);var ve=Ee?A[re]:A[he];J=J.replace(ve,V),b("hyphen replace",J),J=J.replace(A[te],"$1$2$3"),b("comparator trim",J,A[te]),J=(J=(J=J.replace(A[U],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ne=Ee?A[z]:A[G],ze=J.split(" ").map(function(Je){return function(Ge,Pe){return b("comp",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Be){b("caret",me,Be);var je=Be?A[W]:A[H];return me.replace(je,function(et,Ke,Ve,it,st){var ct;return b("caret",me,et,Ke,Ve,it,st),B(Ke)?ct="":B(Ve)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(b("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+st+" <"+(+Ke+1)+".0.0"):(b("no pr"),ct=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+" <"+(+Ke+1)+".0.0"),b("caret return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),b("caret",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Be){var je=Be?A[x]:A[D];return me.replace(je,function(et,Ke,Ve,it,st){var ct;return b("tilde",me,et,Ke,Ve,it,st),B(Ke)?ct="":B(Ve)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(b("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0"):ct=">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0",b("tilde return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),b("tildes",Ge),Ge=function(nt,X){return b("replaceXRanges",nt,X),nt.split(/\s+/).map(function(Y){return function(me,Be){me=me.trim();var je=Be?A[T]:A[g];return me.replace(je,function(et,Ke,Ve,it,st,ct){b("xRange",me,et,Ke,Ve,it,st,ct);var at=B(Ve),rt=at||B(it),_t=rt||B(st);return Ke==="="&&_t&&(Ke=""),at?et=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&_t?(rt&&(it=0),_t&&(st=0),Ke===">"?(Ke=">=",rt?(Ve=+Ve+1,it=0,st=0):_t&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",rt?Ve=+Ve+1:it=+it+1),et=Ke+Ve+"."+it+"."+st):rt?et=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":_t&&(et=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),b("xRange return",et),et})}(Y,X)}).join(" ")}(Ge,Pe),b("xrange",Ge),Ge=function(nt,X){return b("replaceStars",nt,X),nt.trim().replace(A[be],"")}(Ge,Pe),b("stars",Ge),Ge}(Je,Ee)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Je){return!!Je.match(Ne)})),ze=ze.map(function(Je){return new ee(Je,Ee)})},k.prototype.intersects=function(J,Ee){if(!(J instanceof k))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return J.set.some(function(ze){return ze.every(function(Je){return Ne.intersects(Je,Ee)})})})})},e.toComparators=function(J,Ee){return new k(J,Ee).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(q(this.set[Ee],J))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==-1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.minSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.validRange=function(J,Ee){try{return new k(J,Ee).range||"*"}catch{return null}},e.ltr=function(J,Ee,ve){return ce(J,Ee,"<",ve)},e.gtr=function(J,Ee,ve){return ce(J,Ee,">",ve)},e.outside=ce,e.prerelease=function(J,Ee){var ve=fe(J,Ee);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(J,Ee,ve){return J=new k(J,ve),Ee=new k(Ee,ve),J.intersects(Ee)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var Ee=J.match(A[F]);return Ee==null?null:fe((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,s(1))},function(ne,e){var s,I,b=ne.exports={};function N(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(l){if(s===setTimeout)return setTimeout(l,0);if((s===N||!s)&&setTimeout)return s=setTimeout,setTimeout(l,0);try{return s(l,0)}catch{try{return s.call(null,l,0)}catch{return s.call(this,l,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:N}catch{s=N}try{I=typeof clearTimeout=="function"?clearTimeout:_}catch{I=_}})();var y,P=[],R=!1,E=-1;function m(){R&&y&&(R=!1,y.length?P=y.concat(P):E=-1,P.length&&C())}function C(){if(!R){var l=A(m);R=!0;for(var f=P.length;f;){for(y=P,P=[];++E<f;)y&&y[E].run();E=-1,f=P.length}y=null,R=!1,function(v){if(I===clearTimeout)return clearTimeout(v);if((I===_||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(v);try{I(v)}catch{try{return I.call(null,v)}catch{return I.call(this,v)}}}(l)}}function p(l,f){this.fun=l,this.array=f}function a(){}b.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];P.push(new p(l,f)),P.length!==1||R||A(C)},p.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=a,b.addListener=a,b.once=a,b.off=a,b.removeListener=a,b.removeAllListeners=a,b.emit=a,b.prependListener=a,b.prependOnceListener=a,b.listeners=function(l){return[]},b.binding=function(l){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(l){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Ie[108],Ce([1,0,12,7]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(d){const S=d;return S?typeof S.read=="function":!1}e.isReadable=b;function N(d){const S=d;return S?[S.on,S.pause,S.resume,S.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=N;function _(d){const S=d;return S?N(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(d,S){return new y(d,S)}e.newWriteableStream=A;class y{constructor(S,t){this.reducer=S,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(t=>t(S))}emitError(S){this.listeners.error.length===0?(0,s.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(t=>t(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,t){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(S,t){if(this.state.destroyed)return;let h;switch(S){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const r=h.indexOf(t);r>=0&&h.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(d,S){const t=[];let h;for(;(h=d.read())!==null;)t.push(h);return S(t)}e.consumeReadable=P;function R(d,S,t){const h=[];let r;for(;(r=d.read())!==null&&h.length<t;)h.push(r);return r===null&&h.length>0?S(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return d.read()}}}e.peekReadable=R;function E(d,S){return new Promise((t,h)=>{const r=[];m(d,{onData:n=>{S&&r.push(n)},onError:n=>{S?h(n):t(void 0)},onEnd:()=>{t(S?S(r):void 0)}})})}e.consumeStream=E;function m(d,S){let t=!1;return d.on("error",h=>{t||S.onError(h)}),d.on("end",()=>{t||S.onEnd()}),d.on("data",h=>{t||S.onData(h)}),(0,I.toDisposable)(()=>t=!0)}e.listenStream=m;function C(d,S){return new Promise((t,h)=>{const r=new I.DisposableStore,n=[],o=c=>{if(n.push(c),n.length>S)return r.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},u=c=>h(c),i=()=>t({stream:d,buffer:n,ended:!0});r.add((0,I.toDisposable)(()=>d.removeListener("error",u))),d.on("error",u),r.add((0,I.toDisposable)(()=>d.removeListener("end",i))),d.on("end",i),r.add((0,I.toDisposable)(()=>d.removeListener("data",o))),d.on("data",o)})}e.peekStream=C;function p(d,S){const t=A(S);return t.end(d),t}e.toStream=p;function a(){const d=A(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function l(d){let S=!1;return{read:()=>S?null:(S=!0,d)}}e.toReadable=l;function f(d,S,t){const h=A(t);return m(d,{onData:r=>h.write(S.data(r)),onError:r=>h.error(S.error?S.error(r):r),onEnd:()=>h.end()}),h}e.transform=f;function v(d,S,t){let h=!1;return{read:()=>{const r=S.read();return h?r:(h=!0,r!==null?t([d,r]):d)}}}e.prefixedReadable=v;function w(d,S,t){let h=!1;const r=A(t);return m(S,{onData:n=>h?r.write(n):(h=!0,r.write(t([d,n]))),onError:n=>r.error(n),onEnd:()=>{h||(h=!0,r.write(d)),r.end()}}),r}e.prefixedStream=w}),define(Ie[23],Ce([1,0,108]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer<"u";let b,N;class _{static alloc(c){return I?new _(Buffer.allocUnsafe(c)):new _(new Uint8Array(c))}static wrap(c){return I&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new _(c)}static fromString(c,g){return!(g?.dontUseNodeBuffer||!1)&&I?new _(Buffer.from(c)):(b||(b=new TextEncoder),new _(b.encode(c)))}static fromByteArray(c){const g=_.alloc(c.length);for(let T=0,F=c.length;T<F;T++)g.buffer[T]=c[T];return g}static concat(c,g){if(typeof g>"u"){g=0;for(let j=0,U=c.length;j<U;j++)g+=c[j].byteLength}const T=_.alloc(g);let F=0;for(let j=0,U=c.length;j<U;j++){const D=c[j];T.set(D,F),F+=D.byteLength}return T}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=_.alloc(this.byteLength);return c.set(this),c}toString(){return I?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(c,g){return new _(this.buffer.subarray(c,g))}set(c,g){if(c instanceof _)this.buffer.set(c.buffer,g);else if(c instanceof Uint8Array)this.buffer.set(c,g);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),g);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return P(this.buffer,c)}writeUInt32BE(c,g){R(this.buffer,c,g)}readUInt32LE(c){return E(this.buffer,c)}writeUInt32LE(c,g){m(this.buffer,c,g)}readUInt8(c){return C(this.buffer,c)}writeUInt8(c,g){p(this.buffer,c,g)}}e.VSBuffer=_;function A(i,c){return i[c+0]<<0>>>0|i[c+1]<<8>>>0}e.readUInt16LE=A;function y(i,c,g){i[g+0]=c&255,c=c>>>8,i[g+1]=c&255}e.writeUInt16LE=y;function P(i,c){return i[c]*2**24+i[c+1]*2**16+i[c+2]*2**8+i[c+3]}e.readUInt32BE=P;function R(i,c,g){i[g+3]=c,c=c>>>8,i[g+2]=c,c=c>>>8,i[g+1]=c,c=c>>>8,i[g]=c}e.writeUInt32BE=R;function E(i,c){return i[c+0]<<0>>>0|i[c+1]<<8>>>0|i[c+2]<<16>>>0|i[c+3]<<24>>>0}e.readUInt32LE=E;function m(i,c,g){i[g+0]=c&255,c=c>>>8,i[g+1]=c&255,c=c>>>8,i[g+2]=c&255,c=c>>>8,i[g+3]=c&255}e.writeUInt32LE=m;function C(i,c){return i[c]}e.readUInt8=C;function p(i,c,g){i[g]=c}e.writeUInt8=p;function a(i){return s.consumeReadable(i,c=>_.concat(c))}e.readableToBuffer=a;function l(i){return s.toReadable(i)}e.bufferToReadable=l;function f(i){return s.consumeStream(i,c=>_.concat(c))}e.streamToBuffer=f;async function v(i){return i.ended?_.concat(i.buffer):_.concat([...i.buffer,await f(i.stream)])}e.bufferedStreamToBuffer=v;function w(i){return s.toStream(i,c=>_.concat(c))}e.bufferToStream=w;function d(i){return s.transform(i,{data:c=>typeof c=="string"?_.fromString(c):_.wrap(c)},c=>_.concat(c))}e.streamToBufferReadableStream=d;function S(i){return s.newWriteableStream(c=>_.concat(c),i)}e.newWriteableBufferStream=S;function t(i,c){return s.prefixedReadable(i,c,g=>_.concat(g))}e.prefixedBufferReadable=t;function h(i,c){return s.prefixedStream(i,c,g=>_.concat(g))}e.prefixedBufferStream=h;function r(i){let c=0,g=0,T=0;const F=new Uint8Array(Math.floor(i.length/4*3)),j=D=>{switch(g){case 3:F[T++]=c|D,g=0;break;case 2:F[T++]=c|D>>>2,c=D<<6,g=3;break;case 1:F[T++]=c|D>>>4,c=D<<4,g=2;break;default:c=D<<2,g=1}};for(let D=0;D<i.length;D++){const x=i.charCodeAt(D);if(x>=65&&x<=90)j(x-65);else if(x>=97&&x<=122)j(x-97+26);else if(x>=48&&x<=57)j(x-48+52);else if(x===43||x===45)j(62);else if(x===47||x===95)j(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${i[D]}`)}}const U=T;for(;g>0;)j(0);return _.wrap(F).slice(0,U)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:i},c=!0,g=!1){const T=g?o:n;let F="";const j=i.byteLength%3;let U=0;for(;U<i.byteLength-j;U+=3){const D=i[U+0],x=i[U+1],M=i[U+2];F+=T[D>>>2],F+=T[(D<<4|x>>>4)&63],F+=T[(x<<2|M>>>6)&63],F+=T[M&63]}if(j===1){const D=i[U+0];F+=T[D>>>2],F+=T[D<<4&63],c&&(F+="==")}else if(j===2){const D=i[U+0],x=i[U+1];F+=T[D>>>2],F+=T[(D<<4|x>>>4)&63],F+=T[x<<2&63],c&&(F+="=")}return F}e.encodeBase64=u}),define(Ie[38],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(b){return s.test(b)}e.isUUID=I,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const N=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){b(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let y=0,P="";return P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P}}()}),define(Ie[109],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[110],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,P=A.notIn.length;y<P;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(y-2),R=A.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(A,y){for(let P=A;P<=y;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)N(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),N(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),N(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),N(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&N(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=b;function N(_,A,y){_.has(A)?_.get(A).push(y):_.set(A,[y])}}),define(Ie[111],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ie[112],Ce([1,0,111]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,b=I*60,N=b*24,_=N*7,A=N*30,y=N*365;function P(E,m,C){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,s.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,s.localize)(1,null);let a;return p<I?(a=p,m?a===1?C?(0,s.localize)(2,null,a):(0,s.localize)(3,null,a):C?(0,s.localize)(4,null,a):(0,s.localize)(5,null,a):a===1?C?(0,s.localize)(6,null,a):(0,s.localize)(7,null,a):C?(0,s.localize)(8,null,a):(0,s.localize)(9,null,a)):p<b?(a=Math.floor(p/I),m?a===1?C?(0,s.localize)(10,null,a):(0,s.localize)(11,null,a):C?(0,s.localize)(12,null,a):(0,s.localize)(13,null,a):a===1?C?(0,s.localize)(14,null,a):(0,s.localize)(15,null,a):C?(0,s.localize)(16,null,a):(0,s.localize)(17,null,a)):p<N?(a=Math.floor(p/b),m?a===1?C?(0,s.localize)(18,null,a):(0,s.localize)(19,null,a):C?(0,s.localize)(20,null,a):(0,s.localize)(21,null,a):a===1?C?(0,s.localize)(22,null,a):(0,s.localize)(23,null,a):C?(0,s.localize)(24,null,a):(0,s.localize)(25,null,a)):p<_?(a=Math.floor(p/N),m?a===1?(0,s.localize)(26,null,a):(0,s.localize)(27,null,a):a===1?(0,s.localize)(28,null,a):(0,s.localize)(29,null,a)):p<A?(a=Math.floor(p/_),m?a===1?C?(0,s.localize)(30,null,a):(0,s.localize)(31,null,a):C?(0,s.localize)(32,null,a):(0,s.localize)(33,null,a):a===1?C?(0,s.localize)(34,null,a):(0,s.localize)(35,null,a):C?(0,s.localize)(36,null,a):(0,s.localize)(37,null,a)):p<y?(a=Math.floor(p/A),m?a===1?C?(0,s.localize)(38,null,a):(0,s.localize)(39,null,a):C?(0,s.localize)(40,null,a):(0,s.localize)(41,null,a):a===1?C?(0,s.localize)(42,null,a):(0,s.localize)(43,null,a):C?(0,s.localize)(44,null,a):(0,s.localize)(45,null,a)):(a=Math.floor(p/y),m?a===1?C?(0,s.localize)(46,null,a):(0,s.localize)(47,null,a):C?(0,s.localize)(48,null,a):(0,s.localize)(49,null,a):a===1?C?(0,s.localize)(50,null,a):(0,s.localize)(51,null,a):C?(0,s.localize)(52,null,a):(0,s.localize)(53,null,a))}e.fromNow=P;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ie[113],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ie[44],Ce([1,0,18,9,113]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(E,m){return m&&(E.stack||E.stacktrace)?b.localize(0,null,A(E),_(E.stack)||_(E.stacktrace)):A(E)}function _(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?b.localize(1,null,E.message):E.message||b.localize(2,null)}function y(E=null,m=!1){if(!E)return b.localize(3,null);if(Array.isArray(E)){const C=s.coalesce(E),p=y(C[0],m);return C.length>1?b.localize(4,null,p,C.length):p}if(I.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return N(C.error,m);if(C.exception)return N(C.exception,m)}return E.stack?N(E,m):E.message?E.message:b.localize(5,null)}e.toErrorMessage=y;function P(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function R(E,m){let C;return typeof E=="string"?C=new Error(E):C=E,C.actions=m,C}e.createErrorWithActions=R}),define(Ie[78],Ce([1,0,19]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(R){const E=(0,s.extname)(R),m=I[E.toLowerCase()];return m!==void 0?m:_(R)}e.getMediaOrTextMime=N;function _(R){const E=(0,s.extname)(R);return b[E.toLowerCase()]}e.getMediaMime=_;function A(R){for(const E in b)if(b[E]===R)return E}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function P(R,E){const m=y.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:R}e.normalizeMimeType=P}),define(Ie[114],Ce([1,0,4,7]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const b=_=>({onDidChange:s.Event.None,value:_});e.staticObservableValue=b;class N extends I.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new s.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=N}),define(Ie[39],Ce([1,0,19,20,10,9]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function A(o){return o.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=A;function y(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function P(o,u=s.posix.sep){if(!o)return"";const i=o.length,c=o.charCodeAt(0);if(_(c)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let T=3;const F=T;for(;T<i&&!_(o.charCodeAt(T));T++);if(F!==T&&!_(o.charCodeAt(T+1))){for(T+=1;T<i;T++)if(_(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,u)}}return u}else if(f(c)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<i;g++)if(_(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=P;function R(o){if(!I.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let i=2;const c=i;for(;i<o.length&&(u=o.charCodeAt(i),u!==92);i++);return!(c===i||(u=o.charCodeAt(i+1),isNaN(u)||u===92))}e.isUNC=R;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,u=I.isWindows){const i=u?E:m;return!(!o||o.length===0||/^\s+$/.test(o)||(i.lastIndex=0,i.test(o))||u&&C.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function a(o,u,i){const c=o===u;return!i||c?c:!o||!u?!1:(0,b.equalsIgnoreCase)(o,u)}e.isEqual=a;function l(o,u,i,c=s.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(i){if(!(0,b.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let T=u.length;return u.charAt(u.length-1)===c&&T--,o.charAt(T)===c}return u.charAt(u.length-1)!==c&&(u+=c),o.indexOf(u)===0}e.isEqualOrParent=l;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function v(o,u){return I.isWindows&&o.endsWith(":")&&(o+=s.sep),(0,s.isAbsolute)(o)||(o=(0,s.join)(u,o)),o=(0,s.normalize)(o),I.isWindows?(o=(0,b.rtrim)(o,s.sep),o.endsWith(":")&&(o+=s.sep)):(o=(0,b.rtrim)(o,s.sep),o||(o=s.sep)),o}e.sanitizeFilePath=v;function w(o){const u=(0,s.normalize)(o);return I.isWindows?o.length>3?!1:d(u)&&(o.length===2||u.charCodeAt(2)===92):u===s.posix.sep}e.isRootOrDriveLetter=w;function d(o,u=I.isWindows){return u?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function S(o){return d(o)?o[0]:void 0}e.getDriveLetter=S;function t(o,u,i){return u.length>o.length?-1:o===u?0:(i&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=t;function h(o){const u=o.split(":");let i,c,g;for(const T of u){const F=Number(T);(0,N.isNumber)(F)?c===void 0?c=F:g===void 0&&(g=F):i=i?[i,T].join(":"):T}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:c!==void 0?c:void 0,column:g!==void 0?g:c!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,u,i=8){let c="";for(let T=0;T<i;T++)c+=r.charAt(Math.floor(Math.random()*r.length));let g;return u?g=`${u}-${c}`:g=c,o?(0,s.join)(o,g):g}e.randomPath=n}),define(Ie[24],Ce([1,0,18,10]),function(ne,e,s,I){"use strict";var b,N,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(r,n,o){let u=r.get(n);return u===void 0&&(u=o,r.set(n,u)),u}e.getOrSet=A;function y(r){const n=[];return r.forEach((o,u)=>{n.push(`${u} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=y;function P(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),u=this._value.charCodeAt(this._pos);return o-u}value(){return this._value[this._pos]}}e.StringIterator=R;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const u=this._value.charCodeAt(o);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var C;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(C||(C={}));class p{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var l;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(l||(l={}));class f{static forUris(n=()=>!1,o=()=>!1){return new f(new p(n,o))}static forPaths(n=!1){return new f(new m(void 0,!n))}static forStrings(){return new f(new R)}static forConfigKeys(){return new f(new E)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,o){if(o){const u=o.slice(0);(0,s.shuffle)(u);for(const i of u)this.set(i,n)}else{const u=n.slice(0);(0,s.shuffle)(u);for(const i of u)this.set(i[0],i[1])}}set(n,o){const u=this._iter.reset(n);let i;this._root||(this._root=new a,this._root.segment=u.value());const c=[];for(i=this._root;;){const T=u.cmp(i.segment);if(T>0)i.left||(i.left=new a,i.left.segment=u.value()),c.push([-1,i]),i=i.left;else if(T<0)i.right||(i.right=new a,i.right.segment=u.value()),c.push([1,i]),i=i.right;else if(u.hasNext())u.next(),i.mid||(i.mid=new a,i.mid.segment=u.value()),c.push([0,i]),i=i.mid;else break}const g=i.value;i.value=o,i.key=n;for(let T=c.length-1;T>=0;T--){const F=c[T][1];F.updateHeight();const j=F.balanceFactor();if(j<-1||j>1){const U=c[T][0],D=c[T+1][0];if(U===1&&D===1)c[T][1]=F.rotateLeft();else if(U===-1&&D===-1)c[T][1]=F.rotateRight();else if(U===1&&D===-1)F.right=c[T+1][1]=c[T+1][1].rotateRight(),c[T][1]=F.rotateLeft();else if(U===-1&&D===1)F.left=c[T+1][1]=c[T+1][1].rotateLeft(),c[T][1]=F.rotateRight();else throw new Error;if(T>0)switch(c[T-1][0]){case-1:c[T-1][1].left=c[T][1];break;case 1:c[T-1][1].right=c[T][1];break;case 0:c[T-1][1].mid=c[T][1];break}else this._root=c[0][1]}}return g}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let u=this._root;for(;u;){const i=o.cmp(u.segment);if(i>0)u=u.left;else if(i<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else break}return u}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const u=this._iter.reset(n),i=[];let c=this._root;for(;c;){const g=u.cmp(c.segment);if(g>0)i.push([-1,c]),c=c.left;else if(g<0)i.push([1,c]),c=c.right;else if(u.hasNext())u.next(),i.push([0,c]),c=c.mid;else break}if(!!c){if(o?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const g=this._min(c.right);if(g.key){const{key:T,value:F,segment:j}=g;this._delete(g.key,!1),c.key=T,c.value=F,c.segment=j}}else{const g=c.left??c.right;if(i.length>0){const[T,F]=i[i.length-1];switch(T){case-1:F.left=g;break;case 0:F.mid=g;break;case 1:F.right=g;break}}else this._root=g}for(let g=i.length-1;g>=0;g--){const T=i[g][1];T.updateHeight();const F=T.balanceFactor();if(F>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),i[g][1]=T.rotateLeft()):F<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),i[g][1]=T.rotateRight()),g>0)switch(i[g-1][0]){case-1:i[g-1][1].left=i[g][1];break;case 1:i[g-1][1].right=i[g][1];break;case 0:i[g-1][1].mid=i[g][1];break}else this._root=i[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let u=this._root,i;for(;u;){const c=o.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(o.hasNext())o.next(),i=u.value||i,u=u.mid;else break}return u&&u.value||i}findSuperstr(n){const o=this._iter.reset(n);let u=this._root;for(;u;){const i=o.cmp(u.segment);if(i>0)u=u.left;else if(i<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(n){for(const[o,u]of this)n(u,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const u=o.balanceFactor();return u<-1||u>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=f;class v{constructor(n,o){this.uri=n,this.value=o}}class w{constructor(n,o){this[b]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=o??w.defaultToKey):(this.map=new Map,this.toKey=n??w.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new v(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[u,i]of this.map)n(i.value,i.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=w,w.defaultToKey=r=>r.toString();class d{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this._map=new w(n):(this._map=new w(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((u,i)=>n.call(o,i,i,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=d;var S;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const u=this._map.get(n);if(!!u)return o!==0&&this.touch(u,o),u.value}set(n,o,u=0){let i=this._map.get(n);if(i)i.value=o,u!==0&&this.touch(i,u);else{switch(i={key:n,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(n,i),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const u=this._state;let i=this._head;for(;i;){if(o?n.bind(o)(i.value,i.key,this):n(i.value,i.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const n=this,o=this._state;let u=this._head;const i={[Symbol.iterator](){return i},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}values(){const n=this,o=this._state;let u=this._head;const i={[Symbol.iterator](){return i},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}entries(){const n=this,o=this._state;let u=this._head;const i={[Symbol.iterator](){return i},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>n;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,u=n.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const u=n.next,i=n.previous;n===this._tail?(i.next=void 0,this._tail=i):(u.previous=i,i.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const u=n.next,i=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=i,i.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,u)=>{n.push([u,o])}),n}fromJSON(n){this.clear();for(const[o,u]of n)this.set(o,u)}}e.LinkedMap=t;class h extends t{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h}),define(Ie[115],Ce([1,0,24,10]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...ee){return function(Z,k){for(let B=0,V=ee.length;B<V;B++){const q=ee[B](Z,k);if(q)return q}return null}}e.or=b,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(ee,Z,k){if(!k||k.length<Z.length)return null;let B;return ee?B=I.startsWithIgnoreCase(k,Z):B=k.indexOf(Z)===0,B?Z.length>0?[{start:0,end:Z.length}]:[]:null}function _(ee,Z){const k=Z.toLowerCase().indexOf(ee.toLowerCase());return k===-1?null:[{start:k,end:k+ee.length}]}e.matchesContiguousSubString=_;function A(ee,Z){return y(ee.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function y(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]===Z[B]){let V=null;return(V=y(ee,Z,k+1,B+1))?f({start:B,end:B+1},V):null}return y(ee,Z,k,B+1)}function P(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function E(ee){return 48<=ee&&ee<=57}function m(ee){return ee===32||ee===9||ee===10||ee===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>C.add(ee.charCodeAt(0)));function p(ee){return m(ee)||C.has(ee)}function a(ee,Z){return ee===Z||p(ee)&&p(Z)}function l(ee){return P(ee)||R(ee)||E(ee)}function f(ee,Z){return Z.length===0?Z=[ee]:ee.end===Z[0].start?Z[0].start=ee.start:Z.unshift(ee),Z}function v(ee,Z){for(let k=Z;k<ee.length;k++){const B=ee.charCodeAt(k);if(R(B)||E(B)||k>0&&!l(ee.charCodeAt(k-1)))return k}return ee.length}function w(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]!==Z[B].toLowerCase())return null;{let V=null,q=B+1;for(V=w(ee,Z,k+1,B+1);!V&&(q=v(Z,q))<Z.length;)V=w(ee,Z,k+1,q),q++;return V===null?null:f({start:B,end:B+1},V)}}function d(ee){let Z=0,k=0,B=0,V=0,q=0;for(let ve=0;ve<ee.length;ve++)q=ee.charCodeAt(ve),R(q)&&Z++,P(q)&&k++,l(q)&&B++,E(q)&&V++;const oe=Z/ee.length,ce=k/ee.length,J=B/ee.length,Ee=V/ee.length;return{upperPercent:oe,lowerPercent:ce,alphaPercent:J,numericPercent:Ee}}function S(ee){const{upperPercent:Z,lowerPercent:k}=ee;return k===0&&Z>.6}function t(ee){const{upperPercent:Z,lowerPercent:k,alphaPercent:B,numericPercent:V}=ee;return k>.2&&Z<.8&&B>.6&&V<.2}function h(ee){let Z=0,k=0,B=0,V=0;for(let q=0;q<ee.length;q++)B=ee.charCodeAt(q),R(B)&&Z++,P(B)&&k++,m(B)&&V++;return(Z===0||k===0)&&V===0?ee.length<=30:Z<=5}function r(ee,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!h(ee)||Z.length>60)return null;const k=d(Z);if(!t(k)){if(!S(k))return null;Z=Z.toLowerCase()}let B=null,V=0;for(ee=ee.toLowerCase();V<Z.length&&(B=w(ee,Z,0,V))===null;)V=v(Z,V+1);return B}e.matchesCamelCase=r;function n(ee,Z,k=!1){if(!Z||Z.length===0)return null;let B=null,V=0;for(ee=ee.toLowerCase(),Z=Z.toLowerCase();V<Z.length&&(B=o(ee,Z,0,V,k))===null;)V=u(Z,V+1);return B}e.matchesWords=n;function o(ee,Z,k,B,V){if(k===ee.length)return[];if(B===Z.length)return null;if(a(ee.charCodeAt(k),Z.charCodeAt(B))){let q=null,oe=B+1;if(q=o(ee,Z,k+1,B+1,V),!V)for(;!q&&(oe=u(Z,oe))<Z.length;)q=o(ee,Z,k+1,oe,V),oe++;return q?ee.charCodeAt(k)!==Z.charCodeAt(B)?q:f({start:B,end:B+1},q):null}else return null}function u(ee,Z){for(let k=Z;k<ee.length;k++)if(p(ee.charCodeAt(k))||k>0&&p(ee.charCodeAt(k-1)))return k;return ee.length}const i=b(e.matchesPrefix,r,_),c=b(e.matchesPrefix,r,A),g=new s.LRUCache(1e4);function T(ee,Z,k=!1){if(typeof ee!="string"||typeof Z!="string")return null;let B=g.get(ee);B||(B=new RegExp(I.convertSimple2RegExpPattern(ee),"i"),g.set(ee,B));const V=B.exec(Z);return V?[{start:V.index,end:V.index+V[0].length}]:k?c(ee,Z):i(ee,Z)}e.matchesFuzzy=T;function F(ee,Z){const k=Ue(ee,ee.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?U(k):null}e.matchesFuzzy2=F;function j(ee,Z,k,B,V,q){const oe=Math.min(13,ee.length);for(;k<oe;k++){const ce=Ue(ee,Z,k,B,V,q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ce)return ce}return[0,q]}e.anyScore=j;function U(ee){if(typeof ee>"u")return[];const Z=[],k=ee[1];for(let B=ee.length-1;B>1;B--){const V=ee[B]+k,q=Z[Z.length-1];q&&q.end===V?q.end=V+1:Z.push({start:V,end:V+1})}return Z}e.createMatches=U;const D=128;function x(){const ee=[],Z=[];for(let k=0;k<=D;k++)Z[k]=0;for(let k=0;k<=D;k++)ee.push(Z.slice(0));return ee}function M(ee){const Z=[];for(let k=0;k<=ee;k++)Z[k]=0;return Z}const O=M(2*D),H=M(2*D),W=x(),z=x(),G=x(),te=!1;function he(ee,Z,k,B,V){function q(ce,J,Ee=" "){for(;ce.length<J;)ce=Ee+ce;return ce}let oe=` |   |${B.split("").map(ce=>q(ce,3)).join("|")}
`;for(let ce=0;ce<=k;ce++)ce===0?oe+=" |":oe+=`${Z[ce-1]}|`,oe+=ee[ce].slice(0,V+1).map(J=>q(J.toString(),3)).join("|")+`
`;return oe}function re(ee,Z,k,B){ee=ee.substr(Z),k=k.substr(B),console.log(he(z,ee,ee.length,k,k.length)),console.log(he(G,ee,ee.length,k,k.length)),console.log(he(W,ee,ee.length,k,k.length))}function be(ee,Z){if(Z<0||Z>=ee.length)return!1;const k=ee.codePointAt(Z);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(k)}}function le(ee,Z){if(Z<0||Z>=ee.length)return!1;switch(ee.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function fe(ee,Z,k){return Z[ee]!==k[ee]}function Q(ee,Z,k,B,V,q,oe=!1){for(;Z<k&&V<q;)ee[Z]===B[V]&&(oe&&(O[Z]=V),Z+=1),V+=1;return Z===k}e.isPatternInWord=Q;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Se;(function(ee){ee.Default=[-100,0];function Z(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}ee.isDefault=Z})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Z,k){this.firstMatchCanBeWeak=Z,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ue(ee,Z,k,B,V,q,oe=Fe.default){const ce=ee.length>D?D:ee.length,J=B.length>D?D:B.length;if(k>=ce||q>=J||ce-k>J-q||!Q(Z,k,ce,V,q,J,!0))return;Xe(ce,J,k,q,Z,V);let Ee=1,ve=1,Ne=k,ze=q;const Je=[!1];for(Ee=1,Ne=k;Ne<ce;Ee++,Ne++){const Y=O[Ne],me=H[Ne],Be=Ne+1<ce?H[Ne+1]:J;for(ve=Y-q+1,ze=Y;ze<Be;ve++,ze++){let je=Number.MIN_SAFE_INTEGER,et=!1;ze<=me&&(je=ke(ee,Z,Ne,k,B,V,ze,J,q,W[Ee-1][ve-1]===0,Je));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(et=!0,Ke=je+z[Ee-1][ve-1]);const Ve=ze>Y,it=Ve?z[Ee][ve-1]+(W[Ee][ve-1]>0?-5:0):0,st=ze>Y+1&&W[Ee][ve-1]>0,ct=st?z[Ee][ve-2]+(W[Ee][ve-2]>0?-5:0):0;if(st&&(!Ve||ct>=it)&&(!et||ct>=Ke))z[Ee][ve]=ct,G[Ee][ve]=3,W[Ee][ve]=0;else if(Ve&&(!et||it>=Ke))z[Ee][ve]=it,G[Ee][ve]=2,W[Ee][ve]=0;else if(et)z[Ee][ve]=Ke,G[Ee][ve]=1,W[Ee][ve]=W[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(te&&re(ee,k,B,q),!Je[0]&&!oe.firstMatchCanBeWeak)return;Ee--,ve--;const Ge=[z[Ee][ve],q];let Pe=0,nt=0;for(;Ee>=1;){let Y=ve;do{const me=G[Ee][Y];if(me===3)Y=Y-2;else if(me===2)Y=Y-1;else break}while(Y>=1);Pe>1&&Z[k+Ee-1]===V[q+ve-1]&&!fe(Y+q-1,B,V)&&Pe+1>W[Ee][Y]&&(Y=ve),Y===ve?Pe++:Pe=1,nt||(nt=Y),Ee--,ve=Y-1,Ge.push(ve)}J===ce&&oe.boostFullMatch&&(Ge[0]+=2);const X=nt-ce;return Ge[0]-=X,Ge}e.fuzzyScore=Ue;function Xe(ee,Z,k,B,V,q){let oe=ee-1,ce=Z-1;for(;oe>=k&&ce>=B;)V[oe]===q[ce]&&(H[oe]=ce,oe--),ce--}function ke(ee,Z,k,B,V,q,oe,ce,J,Ee,ve){if(Z[k]!==q[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return oe===k-B?Ne=ee[k]===V[oe]?7:5:fe(oe,V,q)&&(oe===0||!fe(oe-1,V,q))?(Ne=ee[k]===V[oe]?7:5,ze=!0):be(q,oe)&&(oe===0||!be(q,oe-1))?Ne=5:(be(q,oe-1)||le(q,oe-1))&&(Ne=5,ze=!0),Ne>1&&k===B&&(ve[0]=!0),ze||(ze=fe(oe,V,q)||be(q,oe-1)||le(q,oe-1)),k===B?oe>J&&(Ne-=ze?3:5):Ee?Ne+=ze?2:0:Ne+=ze?0:1,oe+1===ce&&(Ne-=ze?3:5),Ne}function ye(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!0,oe)}e.fuzzyScoreGracefulAggressive=ye;function De(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!1,oe)}e.fuzzyScoreGraceful=De;function ae(ee,Z,k,B,V,q,oe,ce){let J=Ue(ee,Z,k,B,V,q,ce);if(J&&!oe)return J;if(ee.length>=3){const Ee=Math.min(7,ee.length-1);for(let ve=k+1;ve<Ee;ve++){const Ne=ue(ee,ve);if(Ne){const ze=Ue(Ne,Ne.toLowerCase(),k,B,V,q,ce);ze&&(ze[0]-=3,(!J||ze[0]>J[0])&&(J=ze))}}}return J}function ue(ee,Z){if(Z+1>=ee.length)return;const k=ee[Z],B=ee[Z+1];if(k!==B)return ee.slice(0,Z)+B+k+ee.slice(Z+2)}}),define(Ie[116],Ce([1,0,117,115,10]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const N=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(s.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${N.source}`,"g");function y(l){return l.replace(A,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=y;const P=new RegExp(`\\\\${N.source}`,"g");function R(l){return l.replace(P,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=R;const E=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function m(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(E,(f,v,w,d)=>w?f:v||d||"")}e.stripIcons=m;function C(l){const f=l.indexOf(e.iconStartMarker);return f===-1?{text:l}:p(l,f)}e.parseLabelWithIcons=C;function p(l,f){const v=[];let w="";function d(i){if(i){w+=i;for(const c of i)v.push(h)}}let S=-1,t="",h=0,r,n,o=f;const u=l.length;for(d(l.substr(0,f));o<u;)r=l[o],n=l[o+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(S=o,d(t),t=e.iconStartMarker,o++):r===")"&&S!==-1?(h+=o-S+1,S=-1,t=""):S!==-1?_.test(r)?t+=r:(d(t),S=-1,t=""):d(r),o++;return d(t),{text:w,iconOffsets:v}}function a(l,f,v=!1){const{text:w,iconOffsets:d}=f;if(!d||d.length===0)return(0,I.matchesFuzzy)(l,w,v);const S=(0,b.ltrim)(w," "),t=w.length-S.length,h=(0,I.matchesFuzzy)(l,S,v);if(h)for(const r of h){const n=d[r.start+t]+t;r.start+=n,r.end+=n}return h}e.matchesFuzzyIconAware=a}),define(Ie[29],Ce([1,0,10]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(I||(I={})),function(b){const N="error",_="warning",A="warn",y="info",P="ignore";function R(m){return m?s.equalsIgnoreCase(N,m)?b.Error:s.equalsIgnoreCase(_,m)||s.equalsIgnoreCase(A,m)?b.Warning:s.equalsIgnoreCase(y,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=R;function E(m){switch(m){case b.Error:return N;case b.Warning:return _;case b.Info:return y;default:return P}}b.toString=E}(I||(I={})),e.default=I}),define(Ie[79],Ce([1,0,23,10,2]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(P){return JSON.stringify(P,A)}e.stringify=N;function _(P){let R=JSON.parse(P);return R=y(R),R}e.parse=_;function A(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,I.regExpFlags)(R)}:R}function y(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return b.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof s.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=y(P[E],R+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=y(P[E],R+1))}return P}e.revive=y}),define(Ie[13],Ce([1,0,20,2]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${b.vscodeRemoteResource}`}set(P,R,E){this._hosts[P]=R,this._ports[P]=E}setConnectionToken(P,R){this._connectionTokens[P]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const R=P.authority;let E=this._hosts[R];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const m=this._ports[R],C=this._connectionTokens[R];let p=`path=${encodeURIComponent(P.path)}`;return typeof C=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),I.URI.from({scheme:s.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${E}:${m}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new N;class _{asBrowserUri(P,R){const E=this.toUri(P,R);return E.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===b.file&&(s.isNative||s.isWebWorker&&s.globals.origin===`${b.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?E.with({scheme:b.vscodeFileResource,authority:E.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,R){const E=this.toUri(P,R);return E.scheme===b.vscodeFileResource?E.with({scheme:b.file,authority:E.authority!==_.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,R){return I.URI.isUri(P)?P:I.URI.parse(R.toUrl(P))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(y){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(P.get("3"));const R="vscode-coi";function E(C){let p;typeof C=="string"?p=new URL(C).searchParams:C instanceof URL?p=C.searchParams:I.URI.isUri(C)&&(p=new URL(C.toString(!0)).searchParams);const a=p?.get(R);if(!!a)return P.get(a)}y.getHeadersFromQuery=E;function m(C,p,a){if(!globalThis.crossOriginIsolated)return;const l=p&&a?"3":a?"2":"1";C instanceof URLSearchParams?C.set(R,l):C[R]=l}y.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,20,10,2]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,A.uriToFsPath)(C,!0)}e.originalFSPath=y;class P{constructor(p){this._ignorePathCasing=p}compare(p,a,l=!1){return p===a?0:(0,_.compare)(this.getComparisonKey(p,l),this.getComparisonKey(a,l))}isEqual(p,a,l=!1){return p===a?!0:!p||!a?!1:this.getComparisonKey(p,l)===this.getComparisonKey(a,l)}getComparisonKey(p,a=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,a,l=!1){if(p.scheme===a.scheme){if(p.scheme===I.Schemas.file)return s.isEqualOrParent(y(p),y(a),this._ignorePathCasing(p))&&p.query===a.query&&(l||p.fragment===a.fragment);if((0,e.isEqualAuthority)(p.authority,a.authority))return s.isEqualOrParent(p.path,a.path,this._ignorePathCasing(p),"/")&&p.query===a.query&&(l||p.fragment===a.fragment)}return!1}joinPath(p,...a){return A.URI.joinPath(p,...a)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return b.posix.basename(p.path)}extname(p){return b.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let a;return p.scheme===I.Schemas.file?a=A.URI.file(b.dirname(y(p))).path:(a=b.posix.dirname(p.path),p.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),a="/")),p.with({path:a})}normalizePath(p){if(!p.path.length)return p;let a;return p.scheme===I.Schemas.file?a=A.URI.file(b.normalize(y(p))).path:a=b.posix.normalize(p.path),p.with({path:a})}relativePath(p,a){if(p.scheme!==a.scheme||!(0,e.isEqualAuthority)(p.authority,a.authority))return;if(p.scheme===I.Schemas.file){const v=b.relative(y(p),y(a));return N.isWindows?s.toSlashes(v):v}let l=p.path||"/";const f=a.path||"/";if(this._ignorePathCasing(p)){let v=0;for(const w=Math.min(l.length,f.length);v<w&&!(l.charCodeAt(v)!==f.charCodeAt(v)&&l.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);l=f.substr(0,v)+l.substr(v)}return b.posix.relative(l,f)}resolvePath(p,a){if(p.scheme===I.Schemas.file){const l=A.URI.file(b.resolve(y(p),a));return p.with({authority:l.authority,path:l.path})}return a=s.toPosixPath(a),p.with({path:b.posix.resolve(p.path,a)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,a){return p===a||p!==void 0&&a!==void 0&&(0,_.equalsIgnoreCase)(p,a)}hasTrailingPathSeparator(p,a=b.sep){if(p.scheme===I.Schemas.file){const l=y(p);return l.length>s.getRoot(l).length&&l[l.length-1]===a}else{const l=p.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,a=b.sep){return(0,e.hasTrailingPathSeparator)(p,a)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,a=b.sep){let l=!1;if(p.scheme===I.Schemas.file){const f=y(p);l=f!==void 0&&f.length===s.getRoot(f).length&&f[f.length-1]===a}else{a="/";const f=p.path;l=f.length===1&&f.charCodeAt(f.length-1)===47}return!l&&!(0,e.hasTrailingPathSeparator)(p,a)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(C=>C.scheme===I.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new P(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(C,p){const a=[];for(let l=0;l<C.length;l++){const f=p(C[l]);C.some((v,w)=>w===l?!1:(0,e.isEqualOrParent)(f,p(v)))||a.push(C[l])}return a}e.distinctParents=R;var E;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function p(a){const l=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(w=>{const[d,S]=w.split(":");d&&S&&l.set(d,S)});const v=a.path.substring(0,a.path.indexOf(";"));return v&&l.set(C.META_DATA_MIME,v),l}C.parseMetaData=p})(E=e.DataUri||(e.DataUri={}));function m(C,p,a){if(p){let l=C.path;return l&&l[0]!==b.posix.sep&&(l=b.posix.sep+l),C.with({scheme:a,authority:p,path:l})}return C.with({scheme:a})}e.toLocalResource=m}),define(Ie[15],Ce([1,0,21,12,4,7,22,20]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function P(fe){const Q=new s.CancellationTokenSource,pe=fe(Q.token),Se=new Promise((Fe,Ue)=>{const Xe=Q.token.onCancellationRequested(()=>{Xe.dispose(),Q.dispose(),Ue(new I.CancellationError)});Promise.resolve(pe).then(ke=>{Xe.dispose(),Q.dispose(),Fe(ke)},ke=>{Xe.dispose(),Q.dispose(),Ue(ke)})});return new class{cancel(){Q.cancel()}then(Fe,Ue){return Se.then(Fe,Ue)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Se.finally(Fe)}}}e.createCancelablePromise=P;function R(fe,Q,pe){return new Promise((Se,Fe)=>{const Ue=Q.onCancellationRequested(()=>{Ue.dispose(),Se(pe)});fe.then(Se,Fe).finally(()=>Ue.dispose())})}e.raceCancellation=R;function E(fe,Q){return new Promise((pe,Se)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),Se(new I.CancellationError)});fe.then(pe,Se).finally(()=>Fe.dispose())})}e.raceCancellationError=E;async function m(fe){let Q=-1;const pe=fe.map((Fe,Ue)=>Fe.then(Xe=>(Q=Ue,Xe))),Se=await Promise.race(pe);return fe.forEach((Fe,Ue)=>{Ue!==Q&&Fe.cancel()}),Se}e.raceCancellablePromises=m;function C(fe,Q,pe){let Se;const Fe=setTimeout(()=>{Se?.(void 0),pe?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(Fe)),new Promise(Ue=>Se=Ue)])}e.raceTimeout=C;function p(fe){return new Promise((Q,pe)=>{const Se=fe();y(Se)?Se.then(Q,pe):Q(Se)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(pe,pe).then(Se)})}return new Promise((pe,Se)=>{this.queuedPromise.then(pe,Se)})}return this.activePromise=Q(),new Promise((pe,Se)=>{this.activePromise.then(Fe=>{this.activePromise=null,pe(Fe)},Fe=>{this.activePromise=null,Se(Fe)})})}}e.Throttler=a;class l{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=l;class f{constructor(){this.promiseMap=new Map}queue(Q,pe){const Fe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Q)===Fe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Fe),Fe}}e.SequencerByKey=f;const v=(fe,Q)=>{let pe=!0;const Se=setTimeout(()=>{pe=!1,Q()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Se),pe=!1}}},w=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,pe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Ue)=>{this.doResolve=Fe,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?w(Se):v(pe,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class S{constructor(Q){this.delayer=new d(Q),this.throttler=new a}trigger(Q,pe){return this.delayer.trigger(()=>this.throttler.queue(Q),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class t{constructor(){this._isOpen=!1,this._promise=new Promise((Q,pe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class h extends t{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function r(fe,Q){return Q?new Promise((pe,Se)=>{const Fe=setTimeout(()=>{Ue.dispose(),pe()},fe),Ue=Q.onCancellationRequested(()=>{clearTimeout(Fe),Ue.dispose(),Se(new I.CancellationError)})}):P(pe=>r(fe,pe))}e.timeout=r;function n(fe,Q=0){const pe=setTimeout(fe,Q);return(0,N.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=n;function o(fe){const Q=[];let pe=0;const Se=fe.length;function Fe(){return pe<Se?fe[pe++]():null}function Ue(Xe){Xe!=null&&Q.push(Xe);const ke=Fe();return ke?ke.then(Ue):Promise.resolve(Q)}return Promise.resolve(null).then(Ue)}e.sequence=o;function u(fe,Q=Se=>!!Se,pe=null){let Se=0;const Fe=fe.length,Ue=()=>{if(Se>=Fe)return Promise.resolve(pe);const Xe=fe[Se++];return Promise.resolve(Xe()).then(ye=>Q(ye)?Promise.resolve(ye):Ue())};return Ue()}e.first=u;function i(fe,Q=Se=>!!Se,pe=null){if(fe.length===0)return Promise.resolve(pe);let Se=fe.length;const Fe=()=>{Se=-1;for(const Ue of fe)Ue.cancel?.()};return new Promise((Ue,Xe)=>{for(const ke of fe)ke.then(ye=>{--Se>=0&&Q(ye)?(Fe(),Ue(ye)):Se===0&&Ue(pe)}).catch(ye=>{--Se>=0&&(Fe(),Xe(ye))})})}e.firstParallel=i;class c{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){return this._size++,new Promise((pe,Se)=>{this.outstandingPromises.push({factory:Q,c:pe,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const pe=Q.factory();pe.then(Q.c,Q.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class g extends c{constructor(){super(1)}}e.Queue=g;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new G;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,pe=_.extUri){const Se=pe.getComparisonKey(Q);let Fe=this.queues.get(Se);return Fe||(Fe=new g,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(Q,pe){this._token=-1,typeof Q=="function"&&typeof pe=="number"&&this.setIfNotSet(Q,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},pe)}setIfNotSet(Q,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},pe))}}e.TimeoutTimer=F;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setInterval(()=>{Q()},pe)}}e.IntervalTimer=j;class U{constructor(Q,pe){this.timeoutToken=-1,this.runner=Q,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class D{constructor(Q,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class x extends U{constructor(Q,pe){super(Q,pe),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class M extends N.Disposable{constructor(Q,pe){super(),this.options=Q,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(Q)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(fe,Q)=>{const pe=requestIdleCallback(fe,typeof Q=="number"?{timeout:Q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(pe))}}}}();class O{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function H(fe,Q,pe){let Se;for(let Fe=0;Fe<pe;Fe++)try{return await fe()}catch(Ue){Se=Ue,await r(Q)}throw Se}e.retry=H;class W{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Q,pe,Se){return this._pending={taskId:Q,cancel:()=>Se?.(),promise:pe},pe.then(()=>this.donePending(Q),()=>this.donePending(Q)),pe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let pe,Se;const Fe=new Promise((Ue,Xe)=>{pe=Ue,Se=Xe});this._next={run:Q,promise:Fe,promiseResolve:pe,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class z{constructor(Q,pe=()=>Date.now()){this.interval=Q,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,pe)=>{this.completeCallback=Q,this.errorCallback=pe})}complete(Q){return new Promise(pe=>{this.completeCallback(Q),this.resolved=!0,pe()})}error(Q){return new Promise(pe=>{this.errorCallback(Q),this.rejected=!0,pe()})}cancel(){new Promise(Q=>{this.errorCallback(new I.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=G;var te;(function(fe){async function Q(Se){let Fe;const Ue=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Ue}fe.settled=Q;function pe(Se){return new Promise(async(Fe,Ue)=>{try{await Se(Fe,Ue)}catch(Xe){Ue(Xe)}})}fe.withAsyncBody=pe})(te=e.Promises||(e.Promises={}));var he;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(he||(he={}));class re{static fromArray(Q){return new re(pe=>{pe.emitMany(Q)})}static fromPromise(Q){return new re(async pe=>{pe.emitMany(await Q)})}static fromPromises(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>pe.emitOne(await Se)))})}static merge(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>{for await(const Fe of Se)pe.emitOne(Fe)}))})}constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const pe={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Q(pe)),this.resolve()}catch(Se){this.reject(Se)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,pe){return new re(async Se=>{for await(const Fe of Q)Se.emitOne(pe(Fe))})}map(Q){return re.map(this,Q)}static filter(Q,pe){return new re(async Se=>{for await(const Fe of Q)pe(Fe)&&Se.emitOne(Fe)})}filter(Q){return re.filter(this,Q)}static coalesce(Q){return re.filter(Q,pe=>!!pe)}coalesce(){return re.coalesce(this)}static async toPromise(Q){const pe=[];for await(const Se of Q)pe.push(Se);return pe}toPromise(){return re.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class be extends re{constructor(Q,pe){super(pe),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function le(fe){const Q=new s.CancellationTokenSource,pe=fe(Q.token);return new be(Q,async Se=>{const Fe=Q.token.onCancellationRequested(()=>{Fe.dispose(),Q.dispose(),Se.reject(new I.CancellationError)});try{for await(const Ue of pe){if(Q.token.isCancellationRequested)return;Se.emitOne(Ue)}Fe.dispose(),Q.dispose()}catch(Ue){Fe.dispose(),Q.dispose(),Se.reject(Ue)}})}e.createCancelableAsyncIterable=le}),define(Ie[118],Ce([1,0,15,19]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new s.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),N=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(g,T,F=!1){const j=g||"",U=T||"",D=b.value.collator.compare(j,U);return b.value.collatorIsNumeric&&D===0&&j!==U?j<U?-1:1:D}e.compareFileNames=A;function y(g,T){const F=N.value.collator;return g=g||"",T=T||"",S(F,g,T)}e.compareFileNamesDefault=y;function P(g,T){const F=N.value.collator;return g=g||"",T=T||"",n(g,T)||S(F,g,T)}e.compareFileNamesUpper=P;function R(g,T){const F=N.value.collator;return g=g||"",T=T||"",r(g,T)||S(F,g,T)}e.compareFileNamesLower=R;function E(g,T){return g=g||"",T=T||"",g===T?0:g<T?-1:1}e.compareFileNamesUnicode=E;function m(g,T,F=!1){F||(g=g&&g.toLowerCase(),T=T&&T.toLowerCase());const[j,U]=w(g),[D,x]=w(T);return j!==D?j<D?-1:1:U===x?0:U<x?-1:1}e.noIntlCompareFileNames=m;function C(g,T){const[F,j]=w(g),[U,D]=w(T);let x=b.value.collator.compare(j,D);if(x===0){if(b.value.collatorIsNumeric&&j!==D)return j<D?-1:1;if(x=b.value.collator.compare(F,U),b.value.collatorIsNumeric&&x===0&&F!==U)return F<U?-1:1}return x}e.compareFileExtensions=C;function p(g,T){g=g||"",T=T||"";const F=d(g),j=d(T),U=N.value.collator,D=_.value.collator;return S(D,F,j)||S(U,g,T)}e.compareFileExtensionsDefault=p;function a(g,T){g=g||"",T=T||"";const F=d(g),j=d(T),U=N.value.collator,D=_.value.collator;return S(D,F,j)||n(g,T)||S(U,g,T)}e.compareFileExtensionsUpper=a;function l(g,T){g=g||"",T=T||"";const F=d(g),j=d(T),U=N.value.collator,D=_.value.collator;return S(D,F,j)||r(g,T)||S(U,g,T)}e.compareFileExtensionsLower=l;function f(g,T){g=g||"",T=T||"";const F=d(g).toLowerCase(),j=d(T).toLowerCase();return F!==j?F<j?-1:1:g!==T?g<T?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function w(g,T=!1){const F=g?v.exec(g):[];let j=[F&&F[1]||"",F&&F[3]||""];return T&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function d(g){const T=g?v.exec(g):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function S(g,T,F){const j=g.compare(T,F);return j!==0?j:T.length!==F.length?T.length<F.length?-1:1:0}function t(g){const T=g.charAt(0);return T.toLocaleUpperCase()!==T}function h(g){const T=g.charAt(0);return T.toLocaleLowerCase()!==T}function r(g,T){return t(g)&&h(T)?-1:h(g)&&t(T)?1:0}function n(g,T){return h(g)&&t(T)?-1:t(g)&&h(T)?1:0}function o(g,T,F=!1){return F||(g=g&&g.toLowerCase(),T=T&&T.toLowerCase()),g===T?0:g<T?-1:1}function u(g,T,F=!1){const j=g.split(I.sep),U=T.split(I.sep),D=j.length-1,x=U.length-1;let M,O;for(let H=0;;H++){if(M=D===H,O=x===H,M&&O)return A(j[H],U[H],F);if(M)return-1;if(O)return 1;const W=o(j[H],U[H],F);if(W!==0)return W}}e.comparePaths=u;function i(g,T,F){const j=g.toLowerCase(),U=T.toLowerCase(),D=c(g,T,F);if(D)return D;const x=j.endsWith(F),M=U.endsWith(F);if(x!==M)return x?-1:1;const O=A(j,U);return O!==0?O:j.localeCompare(U)}e.compareAnything=i;function c(g,T,F){const j=g.toLowerCase(),U=T.toLowerCase(),D=j.startsWith(F),x=U.startsWith(F);if(D!==x)return D?-1:1;if(D&&x){if(j.length<U.length)return-1;if(j.length>U.length)return 1}return 0}e.compareByPrefix=c}),define(Ie[34],Ce([1,0,18,15,39,24,19,20,10]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",E="[^/\\\\]",m=/\//g;function C(G,te){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${R}|${E}+${R}${te?`|${R}${E}+`:""})*?`}}function p(G,te){if(!G)return[];const he=[];let re=!1,be=!1,le="";for(const fe of G){switch(fe){case te:if(!re&&!be){he.push(le),le="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":be=!0;break;case"]":be=!1;break}le+=fe}return le&&he.push(le),he}e.splitGlobAware=p;function a(G){if(!G)return"";let te="";const he=p(G,e.GLOB_SPLIT);if(he.every(re=>re===e.GLOBSTAR))te=".*";else{let re=!1;he.forEach((be,le)=>{if(be===e.GLOBSTAR){if(re)return;te+=C(2,le===he.length-1)}else{let fe=!1,Q="",pe=!1,Se="";for(const Fe of be){if(Fe!=="}"&&fe){Q+=Fe;continue}if(pe&&(Fe!=="]"||!Se)){let Ue;Fe==="-"?Ue=Fe:(Fe==="^"||Fe==="!")&&!Se?Ue="^":Fe===e.GLOB_SPLIT?Ue="":Ue=(0,y.escapeRegExpCharacters)(Fe),Se+=Ue;continue}switch(Fe){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{te+=`(?:${p(Q,",").map(ke=>a(ke)).join("|")})`,fe=!1,Q="";break}case"]":{te+="["+Se+"]",pe=!1,Se="";break}case"?":te+=E;continue;case"*":te+=C(1);continue;default:te+=(0,y.escapeRegExpCharacters)(Fe)}}le<he.length-1&&(he[le+1]!==e.GLOBSTAR||le+2<he.length)&&(te+=R)}re=be===e.GLOBSTAR})}return te}const l=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.LRUCache(1e4),h=function(){return!1},r=function(){return null};function n(G,te){if(!G)return r;let he;typeof G!="string"?he=G.pattern:he=G,he=he.trim();const re=`${he}_${!!te.trimForExclusions}`;let be=t.get(re);if(be)return o(be,G);let le;return l.test(he)?be=i(he.substr(4),he):(le=f.exec(u(he,te)))?be=c(le[1],he):(te.trimForExclusions?w:v).test(he)?be=g(he,te):(le=d.exec(u(he,te)))?be=T(le[1].substr(1),he,!0):(le=S.exec(u(he,te)))?be=T(le[1],he,!1):be=F(he),t.set(re,be),o(be,G)}function o(G,te){if(typeof te=="string")return G;const he=function(re,be){return(0,b.isEqualOrParent)(re,te.base,!A.isLinux)?G(re.substr(te.base.length+1),be):null};return he.allBasenames=G.allBasenames,he.allPaths=G.allPaths,he.basenames=G.basenames,he.patterns=G.patterns,he}function u(G,te){return te.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function i(G,te){return function(he,re){return typeof he=="string"&&he.endsWith(G)?te:null}}function c(G,te){const he=`/${G}`,re=`\\${G}`,be=function(fe,Q){return typeof fe!="string"?null:Q?Q===G?te:null:fe===G||fe.endsWith(he)||fe.endsWith(re)?te:null},le=[G];return be.basenames=le,be.patterns=[te],be.allBasenames=le,be}function g(G,te){const he=W(G.slice(1,-1).split(",").map(Q=>n(Q,te)).filter(Q=>Q!==r),G),re=he.length;if(!re)return r;if(re===1)return he[0];const be=function(Q,pe){for(let Se=0,Fe=he.length;Se<Fe;Se++)if(he[Se](Q,pe))return G;return null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function T(G,te,he){const re=_.sep===_.posix.sep,be=re?G:G.replace(m,_.sep),le=_.sep+be,fe=_.posix.sep+G;let Q;return he?Q=function(pe,Se){return typeof pe=="string"&&(pe===be||pe.endsWith(le)||!re&&(pe===G||pe.endsWith(fe)))?te:null}:Q=function(pe,Se){return typeof pe=="string"&&(pe===be||!re&&pe===G)?te:null},Q.allPaths=[(he?"*/":"./")+G],Q}function F(G){try{const te=new RegExp(`^${a(G)}$`);return function(he){return te.lastIndex=0,typeof he=="string"&&te.test(he)?G:null}}catch{return r}}function j(G,te,he){return!G||typeof te!="string"?!1:U(G)(te,void 0,he)}e.match=j;function U(G,te={}){if(!G)return h;if(typeof G=="string"||D(G)){const he=n(G,te);if(he===r)return h;const re=function(be,le){return!!he(be,le)};return he.allBasenames&&(re.allBasenames=he.allBasenames),he.allPaths&&(re.allPaths=he.allPaths),re}return O(G,te)}e.parse=U;function D(G){const te=G;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.isRelativePattern=D;function x(G){return G.allBasenames||[]}e.getBasenameTerms=x;function M(G){return G.allPaths||[]}e.getPathTerms=M;function O(G,te){const he=W(Object.getOwnPropertyNames(G).map(Q=>H(Q,G[Q],te)).filter(Q=>Q!==r)),re=he.length;if(!re)return r;if(!he.some(Q=>!!Q.requiresSiblings)){if(re===1)return he[0];const Q=function(Fe,Ue){let Xe;for(let ke=0,ye=he.length;ke<ye;ke++){const De=he[ke](Fe,Ue);if(typeof De=="string")return De;(0,I.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},pe=he.find(Fe=>!!Fe.allBasenames);pe&&(Q.allBasenames=pe.allBasenames);const Se=he.reduce((Fe,Ue)=>Ue.allPaths?Fe.concat(Ue.allPaths):Fe,[]);return Se.length&&(Q.allPaths=Se),Q}const be=function(Q,pe,Se){let Fe,Ue;for(let Xe=0,ke=he.length;Xe<ke;Xe++){const ye=he[Xe];ye.requiresSiblings&&Se&&(pe||(pe=(0,_.basename)(Q)),Fe||(Fe=pe.substr(0,pe.length-(0,_.extname)(Q).length)));const De=ye(Q,pe,Fe,Se);if(typeof De=="string")return De;(0,I.isThenable)(De)&&(Ue||(Ue=[]),Ue.push(De))}return Ue?(async()=>{for(const Xe of Ue){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function H(G,te,he){if(te===!1)return r;const re=n(G,he);if(re===r)return r;if(typeof te=="boolean")return re;if(te){const be=te.when;if(typeof be=="string"){const le=(fe,Q,pe,Se)=>{if(!Se||!re(fe,Q))return null;const Fe=be.replace("$(basename)",pe),Ue=Se(Fe);return(0,I.isThenable)(Ue)?Ue.then(Xe=>Xe?G:null):Ue?G:null};return le.requiresSiblings=!0,le}}return re}function W(G,te){const he=G.filter(Q=>!!Q.basenames);if(he.length<2)return G;const re=he.reduce((Q,pe)=>{const Se=pe.basenames;return Se?Q.concat(Se):Q},[]);let be;if(te){be=[];for(let Q=0,pe=re.length;Q<pe;Q++)be.push(te)}else be=he.reduce((Q,pe)=>{const Se=pe.patterns;return Se?Q.concat(Se):Q},[]);const le=function(Q,pe){if(typeof Q!="string")return null;if(!pe){let Fe;for(Fe=Q.length;Fe>0;Fe--){const Ue=Q.charCodeAt(Fe-1);if(Ue===47||Ue===92)break}pe=Q.substr(Fe)}const Se=re.indexOf(pe);return Se!==-1?be[Se]:null};le.basenames=re,le.patterns=be,le.allBasenames=re;const fe=G.filter(Q=>!Q.basenames);return fe.push(le),fe}function z(G,te){return(0,s.equals)(G,te,(he,re)=>typeof he=="string"&&typeof re=="string"?he===re:typeof he!="string"&&typeof re!="string"?he.base===re.base&&he.pattern===re.pattern:!1)}e.patternsEquals=z}),define(Ie[80],Ce([1,0,12,116,22,10,2]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=m(this.supportThemeIcons?(0,I.escapeIcons)(f):f).replace(/([ \t]+)/g,(w,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,w){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),w&&(this.value+=` "${this._escape(this._escape(w,'"'),")")}"`),this.value+=")",this}_escape(f,v){const w=new RegExp((0,N.escapeRegExpCharacters)(v),"g");return f.replace(w,(d,S)=>f.charAt(S-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=y;function P(l){return R(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function R(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function E(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons&&l.supportHtml===f.supportHtml&&(l.baseUri===f.baseUri||!!l.baseUri&&!!f.baseUri&&(0,b.isEqual)(_.URI.from(l.baseUri),_.URI.from(f.baseUri)))}e.markdownStringEqual=E;function m(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function C(l){return l.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function p(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function a(l){const f=[],v=l.split("|").map(d=>d.trim());l=v[0];const w=v[1];if(w){const d=/height=(\d+)/.exec(w),S=/width=(\d+)/.exec(w),t=d?d[1]:"",h=S?S[1]:"",r=isFinite(parseInt(h)),n=isFinite(parseInt(t));r&&f.push(`width="${h}"`),n&&f.push(`height="${t}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=a}),define(Ie[81],Ce([1,0,18,39,19,20,22,10]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,n){const{os:o,tildify:u,relative:i}=n;if(i){const T=P(r,i,o);if(typeof T=="string")return T}let c=r.fsPath;if(o===1&&!N.isWindows?c=c.replace(/\//g,"\\"):o!==1&&N.isWindows&&(c=c.replace(/\\/g,"/")),o!==1&&u?.userHome){const T=u.userHome.fsPath;let F;r.scheme!==u.userHome.scheme&&r.path.startsWith(b.posix.sep)?F=u.userHome.with({path:r.path}).fsPath:F=r.fsPath,c=m(F,T,o)}return(o===1?b.win32:b.posix).normalize(R(c,o===1))}e.getPathLabel=y;function P(r,n,o){const u=o===1?b.win32:b.posix,i=o===3?_.extUri:_.extUriIgnorePathCase,c=n.getWorkspace(),g=(0,s.firstOrDefault)(c.folders);if(!g)return;r.scheme!==g.uri.scheme&&r.path.startsWith(b.posix.sep)&&(r=g.uri.with({path:r.path}));const T=n.getWorkspaceFolder(r);if(!T)return;let F;if(i.isEqual(T.uri,r)?F="":F=i.relativePath(T.uri,r)??"",F&&(F=u.normalize(F)),c.folders.length>1&&!n.noPrefix){const j=T.name?T.name:i.basenameOrAuthority(T.uri);F=F?`${j} \u2022 ${F}`:j}return F}function R(r,n=N.isWindows){return(0,I.hasDriveLetter)(r,n)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let E=Object.create(null);function m(r,n,o=N.OS){if(o===1||!r||!n)return r;let u=E.original===n?E.normalized:void 0;u||(u=n,N.isWindows&&(u=(0,I.toSlashes)(u)),u=`${(0,A.rtrim)(u,b.posix.sep)}${b.posix.sep}`,E={original:n,normalized:u});let i=r;return N.isWindows&&(i=(0,I.toSlashes)(i)),(o===3?i.startsWith(u):(0,A.startsWithIgnoreCase)(i,u))?`~/${i.substr(u.length)}`:r}e.tildify=m;function C(r,n){return r.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=C;const p="\u2026",a="\\\\",l="~";function f(r,n=b.sep){const o=new Array(r.length);let u=!1;for(let i=0;i<r.length;i++){const c=r[i];if(c===""){o[i]=`.${n}`;continue}if(!c){o[i]=c;continue}u=!0;let g="",T=c;T.indexOf(a)===0?(g=T.substr(0,T.indexOf(a)+a.length),T=T.substr(T.indexOf(a)+a.length)):T.indexOf(n)===0?(g=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(l)===0&&(g=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length));const F=T.split(n);for(let j=1;u&&j<=F.length;j++)for(let U=F.length-j;u&&U>=0;U--){u=!1;let D=F.slice(U,U+j).join(n);for(let x=0;!u&&x<r.length;x++)if(x!==i&&r[x]&&r[x].indexOf(D)>-1){const M=U+j===F.length,O=U>0&&r[x].indexOf(n)>-1?n+D:D,H=r[x].endsWith(O);u=!M||H}if(!u){let x="";(F[0].endsWith(":")||g!=="")&&(U===1&&(U=0,j++,D=F[0]+n+D),U>0&&(x=F[0]+n),x=g+x),U>0&&(x=x+p+n),x=x+D,U+j<F.length&&(x=x+n+p),o[i]=x}}u&&(o[i]=c)}return o}e.shorten=f;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function w(r,n=Object.create(null)){const o=[];let u=!1,i="";for(const c of r)if(c==="$"||u&&c==="{")i&&o.push({value:i,type:v.TEXT}),i="",u=!0;else if(c==="}"&&u){const g=n[i];if(typeof g=="string")g.length&&o.push({value:g,type:v.VARIABLE});else if(g){const T=o[o.length-1];(!T||T.type!==v.SEPARATOR)&&o.push({value:g.label,type:v.SEPARATOR})}i="",u=!1}else i+=c;return i&&!u&&o.push({value:i,type:v.TEXT}),o.filter((c,g)=>{if(c.type===v.SEPARATOR){const T=o[g-1],F=o[g+1];return[T,F].every(j=>j&&(j.type===v.VARIABLE||j.type===v.TEXT)&&j.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=w;function d(r,n){return N.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function S(r,n){return N.isMacintosh||n?r.replace(/\(&&\w\)|&&/g,""):N.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=S;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function h(r){const n=r.indexOf("/")!==-1?b.posix:b.win32,o=n.basename(r),u=n.dirname(r);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=h}),define(Ie[119],Ce([1,0,2]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(R){return R.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:I(s.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:I(s.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:s.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function N(R,E,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof s.URI)return E.transformOutgoing(R);for(const C in R)if(Object.hasOwnProperty.call(R,C)){const p=N(R[C],E,m+1);p!==null&&(R[C]=p)}}return null}function _(R,E){const m=N(R,E,0);return m===null?R:m}e.transformOutgoingURIs=_;function A(R,E,m,C){if(!R||C>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?s.URI.revive(E.transformIncoming(R)):E.transformIncoming(R);for(const p in R)if(Object.hasOwnProperty.call(R,p)){const a=A(R[p],E,m,C+1);a!==null&&(R[p]=a)}}return null}function y(R,E){const m=A(R,E,!1,0);return m===null?R:m}e.transformIncomingURIs=y;function P(R,E){const m=A(R,E,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=P}),define(Ie[120],Ce([1,0,34,19]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(N,_,A,y,P,R){if(Array.isArray(N)){let E=0;for(const m of N){const C=b(m,_,A,y,P,R);if(C===10)return C;C>E&&(E=C)}return E}else{if(typeof N=="string")return y?N==="*"?5:N===A?10:0:0;if(N){const{language:E,pattern:m,scheme:C,hasAccessToAllModels:p,notebookType:a}=N;if(!y&&!p)return 0;a&&P&&(_=P);let l=0;if(C)if(C===_.scheme)l=10;else if(C==="*")l=5;else return 0;if(E)if(E===A)l=10;else if(E==="*")l=Math.max(l,5);else return 0;if(a)if(a===R)l=10;else if(a==="*"&&R!==void 0)l=Math.max(l,5);else return 0;if(m){let f;if(typeof m=="string"?f=m:f={...m,base:(0,I.normalize)(m.base)},f===_.fsPath||(0,s.match)(f,_.fsPath))l=10;else return 0}return l}else return 0}}e.score=b}),define(Ie[82],Ce([1,0,23,20]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function N(E){for(let m=0,C=E.length;m<C;m+=4){const p=E[m+0],a=E[m+1],l=E[m+2],f=E[m+3];E[m+0]=f,E[m+1]=l,E[m+2]=a,E[m+3]=p}}function _(E){const m=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return I.isLittleEndian()||N(m),s.VSBuffer.wrap(m)}function A(E){const m=E.buffer;if(I.isLittleEndian()||N(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const C=new Uint8Array(m.byteLength);return C.set(m),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(E){const m=new Uint32Array(P(E));let C=0;if(m[C++]=E.id,E.type==="full")m[C++]=1,m[C++]=E.data.length,m.set(E.data,C),C+=E.data.length;else{m[C++]=2,m[C++]=E.deltas.length;for(const p of E.deltas)m[C++]=p.start,m[C++]=p.deleteCount,p.data?(m[C++]=p.data.length,m.set(p.data,C),C+=p.data.length):m[C++]=0}return _(m)}e.encodeSemanticTokensDto=y;function P(E){let m=0;if(m+=1+1,E.type==="full")m+=1+E.data.length;else{m+=1,m+=(1+1+1)*E.deltas.length;for(const C of E.deltas)C.data&&(m+=C.data.length)}return m}function R(E){const m=A(E);let C=0;const p=m[C++];if(m[C++]===1){const v=m[C++],w=m.subarray(C,C+v);return C+=v,{id:p,type:"full",data:w}}const l=m[C++],f=[];for(let v=0;v<l;v++){const w=m[C++],d=m[C++],S=m[C++];let t;S>0&&(t=m.subarray(C,C+S),C+=S),f[v]={start:w,deleteCount:d,data:t}}return{id:p,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Ie[121],Ce([16,17]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ie[122],Ce([1,0,121,20,123,18,25,109]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class E{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return C(Y,me)}compute(Y,me,Be){return Be}}class m{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=m;function C(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new m(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Be=Array.isArray(X)&&Array.isArray(Y)&&N.equals(X,Y);return new m(Y,!Be)}let me=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const je=C(X[Be],Y[Be]);je.didChange&&(X[Be]=je.newValue,me=!0)}return new m(X,me)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return C(Y,me)}validate(Y){return this.defaultValue}}class a{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return C(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Be){return Be}}function l(X,Y){return typeof X>"u"?Y:X==="false"?!1:Boolean(X)}e.boolean=l;class f extends a{constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Be),super(Y,me,Be,je)}validate(Y){return l(Y,this.defaultValue)}}function v(X,Y,me,Be){if(typeof X>"u")return Y;let je=parseInt(X,10);return isNaN(je)?Y:(je=Math.max(me,je),je=Math.min(Be,je),je|0)}e.clampedInt=v;class w extends a{static clampedInt(Y,me,Be,je){return v(Y,me,Be,je)}constructor(Y,me,Be,je,et,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Be,Ke.minimum=je,Ke.maximum=et),super(Y,me,Be,Ke),this.minimum=je,this.maximum=et}validate(Y){return w.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class d extends a{static clamp(Y,me,Be){return Y<me?me:Y>Be?Be:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Be=parseFloat(Y);return isNaN(Be)?me:Be}constructor(Y,me,Be,je,et){typeof et<"u"&&(et.type="number",et.default=Be),super(Y,me,Be,et),this.validationFn=je}validate(Y){return this.validationFn(d.float(Y,this.defaultValue))}}class S extends a{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="string",je.default=Be),super(Y,me,Be,je)}validate(Y){return S.string(Y,this.defaultValue)}}function t(X,Y,me){return typeof X!="string"||me.indexOf(X)===-1?Y:X}e.stringSet=t;class h extends a{constructor(Y,me,Be,je,et=void 0){typeof et<"u"&&(et.type="string",et.enum=je,et.default=Be),super(Y,me,Be,et),this._allowedValues=je}validate(Y){return t(Y,this.defaultValue,this._allowedValues)}}class r extends E{constructor(Y,me,Be,je,et,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=et,Ve.default=je),super(Y,me,Be,Ve),this._allowedValues=et,this._convert=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function n(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",tags:["accessibility"],description:s.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Be){return Be===0?Y.accessibilitySupport:Be}}class u extends E{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:l(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(X){switch(X){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function F(X){switch(X){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class j extends p{constructor(){super(130)}compute(Y,me,Be){const je=["monaco-editor"];return me.get(34)&&je.push(me.get(34)),Y.extraEditorClassName&&je.push(Y.extraEditorClassName),me.get(67)==="default"?je.push("mouse-default"):me.get(67)==="copy"&&je.push("mouse-copy"),me.get(101)&&je.push("showUnused"),me.get(128)&&je.push("showDeprecated"),je.join(" ")}}class U extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Y,me,Be){return Be&&Y.emptySelectionClipboard}}class D extends E{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:s.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:s.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:l(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(me.loop,this.defaultValue.loop)}}}class x extends E{constructor(){super(46,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?x.OFF:Y==="true"?x.ON:Y:Boolean(Y)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class M extends p{constructor(){super(45)}compute(Y,me,Be){return Y.fontInfo}}class O extends a{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Y){const me=d.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(me,6,100)}compute(Y,me,Be){return Y.fontInfo.fontSize}}class H extends E{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(w.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class W extends E{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:s.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:t(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??t(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??t(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??t(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??t(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??t(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends E{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:s.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),delay:w.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:l(me.sticky,this.defaultValue.sticky),above:l(me.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class te extends p{constructor(){super(133)}compute(Y,me,Be){return te.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Be=Y.scrollBeyondLastLine?me-1:0,je=(Y.viewLineCount+Be)/(Y.pixelRatio*Y.height),et=Math.floor(Y.viewLineCount/je);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Be,desiredRatio:je,minimapLineCount:et}}static _computeMinimapLayout(Y,me){const Be=Y.outerWidth,je=Y.outerHeight,et=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=me.stableMinimapLayoutInput,Ve=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,it=Y.lineHeight,st=Y.typicalHalfwidthCharacterWidth,ct=Y.scrollBeyondLastLine,at=Y.minimap.renderCharacters;let rt=et>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const _t=Y.minimap.maxColumn,Rt=Y.minimap.size,Ot=Y.minimap.side,mt=Y.verticalScrollbarWidth,yt=Y.viewLineCount,Lt=Y.remainingWidth,Mt=Y.isViewportWrapping,qe=at?2:3;let zt=Math.floor(et*je);const Ft=zt/et;let Tt=!1,ft=!1,It=qe*rt,_e=rt/et,Te=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:gt,desiredRatio:vt,minimapLineCount:Ct}=te.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:ct,height:je,lineHeight:it,pixelRatio:et});if(yt/Ct>1)Tt=!0,ft=!0,rt=1,It=1,_e=rt/et;else{let Et=!1,pt=rt+1;if(Rt==="fit"){const wt=Math.ceil((yt+gt)*It);Mt&&Ve&&Lt<=me.stableFitRemainingWidth?(Et=!0,pt=me.stableFitMaxMinimapScale):Et=wt>zt}if(Rt==="fill"||Et){Tt=!0;const wt=rt;It=Math.min(it*et,Math.max(1,Math.floor(1/vt))),Mt&&Ve&&Lt<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),rt=Math.min(pt,Math.max(1,Math.floor(It/qe))),rt>wt&&(Te=Math.min(2,rt/wt)),_e=rt/et/Te,zt=Math.ceil(Math.max(tt,yt+gt)*It),Mt?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=Lt,me.stableFitMaxMinimapScale=rt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ge=Math.floor(_t*_e),K=Math.min(ge,Math.max(0,Math.floor((Lt-mt-2)*_e/(st+_e)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(et*K);const Me=Ae/et;Ae=Math.floor(Ae*Te);const Ze=at?1:2,We=Ot==="left"?0:Be-K-mt;return{renderMinimap:Ze,minimapLeft:We,minimapWidth:K,minimapHeightIsEditorHeight:Tt,minimapIsSampling:ft,minimapScale:rt,minimapLineHeight:It,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,me){const Be=me.outerWidth|0,je=me.outerHeight|0,et=me.lineHeight|0,Ke=me.lineNumbersDigitCount|0,Ve=me.typicalHalfwidthCharacterWidth,it=me.maxDigitWidth,st=me.pixelRatio,ct=me.viewLineCount,at=Y.get(125),rt=at==="inherit"?Y.get(124):at,_t=rt==="inherit"?Y.get(120):rt,Rt=Y.get(123),Ot=Y.get(2),mt=me.isDominatedByLongLines,yt=Y.get(51),Lt=Y.get(61).renderType!==0,Mt=Y.get(62),qe=Y.get(95),zt=Y.get(66),Ft=Y.get(93),Tt=Ft.verticalScrollbarSize,ft=Ft.verticalHasArrows,It=Ft.arrowSize,_e=Ft.horizontalScrollbarSize,Te=Y.get(59),ge=Y.get(38),K=Y.get(100)!=="never";let Ae;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const $t=parseFloat(Te.substr(0,Te.length-2));Ae=w.clampedInt($t*Ve,0,0,1e3)}else Ae=w.clampedInt(Te,0,0,1e3);ge&&K&&(Ae+=16);let Me=0;if(Lt){const $t=Math.max(Ke,Mt);Me=Math.round($t*it)}let Ze=0;yt&&(Ze=et);let We=0,tt=We+Ze,gt=tt+Me,vt=gt+Ae;const Ct=Be-Ze-Me-Ae;let Dt=!1,Et=!1,pt=-1;Ot!==2&&(rt==="inherit"&&mt?(Dt=!0,Et=!0):_t==="on"||_t==="bounded"?Et=!0:_t==="wordWrapColumn"&&(pt=Rt));const wt=te._computeMinimapLayout({outerWidth:Be,outerHeight:je,lineHeight:et,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:qe,minimap:zt,verticalScrollbarWidth:Tt,viewLineCount:ct,remainingWidth:Ct,isViewportWrapping:Et},me.memory||new R);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,tt+=wt.minimapWidth,gt+=wt.minimapWidth,vt+=wt.minimapWidth);const ei=Ct-wt.minimapWidth,bt=Math.max(1,Math.floor((ei-Tt-2)/Ve)),qt=ft?It:0;return Et&&(pt=Math.max(1,bt),_t==="bounded"&&(pt=Math.min(pt,Rt))),{width:Be,height:je,glyphMarginLeft:We,glyphMarginWidth:Ze,lineNumbersLeft:tt,lineNumbersWidth:Me,decorationsLeft:gt,decorationsWidth:Ae,contentLeft:vt,contentWidth:ei,minimap:wt,viewportColumn:bt,isWordWrapMinified:Dt,isViewportWrapping:Et,wrappingColumn:pt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:_e,overviewRuler:{top:qt,width:Tt,height:je-2*qt,right:0}}}}e.EditorLayoutInfoComputer=te;class he extends E{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:s.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:l(Y.enabled,this.defaultValue.enabled)}}}class re extends E{constructor(){const Y={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:s.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:s.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),maxLineCount:w.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class be extends E{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:s.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(47,null),s.localize(48,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),s.localize(49,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),s.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:s.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:s.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:s.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:t(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:w.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(me.fontFamily,this.defaultValue.fontFamily),padding:l(me.padding,this.defaultValue.padding)}}}class le extends d{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>d.clamp(Y,0,150),{markdownDescription:s.localize(54,null)})}compute(Y,me,Be){return Y.fontInfo.lineHeight}}class fe extends E{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:s.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:s.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(57,null),s.localize(58,null),s.localize(59,null)],default:Y.size,description:s.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:s.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:s.localize(62,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:s.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:s.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),autohide:l(me.autohide,this.defaultValue.autohide),size:t(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(me.side,this.defaultValue.side,["right","left"]),showSlider:t(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(me.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(me.scale,1,1,3),maxColumn:w.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends E{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(67,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:w.clampedInt(me.top,0,0,1e3),bottom:w.clampedInt(me.bottom,0,0,1e3)}}}class Se extends E{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:s.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:s.localize(69,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),cycle:l(me.cycle,this.defaultValue.cycle)}}}class Fe extends p{constructor(){super(131)}compute(Y,me,Be){return Y.pixelRatio}}class Ue extends E{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(70,null),s.localize(71,null),s.localize(72,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:s.localize(73,null)},comments:{anyOf:me,default:Y.comments,description:s.localize(74,null)},other:{anyOf:me,default:Y.other,description:s.localize(75,null)}},default:Y,markdownDescription:s.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const st=Y?"on":"off";return{comments:st,strings:st,other:st}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Be,strings:je}=Y,et=["on","inline","off"];let Ke,Ve,it;return typeof me=="boolean"?Ke=me?"on":"off":Ke=t(me,this.defaultValue.other,et),typeof Be=="boolean"?Ve=Be?"on":"off":Ve=t(Be,this.defaultValue.comments,et),typeof je=="boolean"?it=je?"on":"off":it=t(je,this.defaultValue.strings,et),{other:Ke,comments:Ve,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends E{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(77,null),s.localize(78,null),s.localize(79,null),s.localize(80,null)],default:"on",description:s.localize(81,null)})}validate(Y){let me=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Be=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Be}}}function ye(X){const Y=X.get(88);return Y==="editable"?X.get(82):Y!=="on"}e.filterValidationDecorations=ye;class De extends E{constructor(){const Y=[],me={type:"number",description:s.localize(82,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:s.localize(83,null),format:"color-hex"}}}]},default:Y,description:s.localize(84,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Be of Y)if(typeof Be=="number")me.push({column:w.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const je=Be;me.push({column:w.clampedInt(je.column,0,0,1e4),color:je.color})}return me.sort((Be,je)=>Be.column-je.column),me}return this.defaultValue}}function ae(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends E{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(85,null),s.localize(86,null),s.localize(87,null)],default:"auto",description:s.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(89,null),s.localize(90,null),s.localize(91,null)],default:"auto",description:s.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:s.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:s.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:s.localize(95,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Be=w.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=w.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(me.vertical,this.defaultValue.vertical),horizontal:ae(me.horizontal,this.defaultValue.horizontal),useShadows:l(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:w.clampedInt(me.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:je,verticalSliderSize:w.clampedInt(me.verticalSliderSize,je,0,1e3),scrollByPage:l(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends E{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:s.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:s.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:s.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:s.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:s.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:s.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:s.localize(102,null)}})}applyUpdate(Y,me){let Be=!1;me.allowedCharacters&&Y&&(_.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Be=!0)),me.allowedLocales&&Y&&(_.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Be=!0));const je=super.applyUpdate(Y,me);return Be?new m(je.newValue,!0):je}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:V(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:V(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:V(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Be={};for(const[je,et]of Object.entries(Y))et===!0&&(Be[je]=!0);return Be}}class Z extends E{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:s.localize(103,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),mode:t(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class k extends E{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:s.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:s.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:l(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends E{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(106,null),s.localize(107,null),s.localize(108,null)],default:Y.bracketPairs,description:s.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(110,null),s.localize(111,null),s.localize(112,null)],default:Y.bracketPairsHorizontal,description:s.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:s.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:s.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(116,null),s.localize(117,null),s.localize(118,null)],default:Y.highlightActiveIndentation,description:s.localize(119,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:V(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:V(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:V(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function V(X,Y,me){const Be=me.indexOf(X);return Be===-1?Y:me[Be]}class q extends E{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(120,null),s.localize(121,null)],default:Y.insertMode,description:s.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:s.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:s.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:s.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:s.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:s.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:s.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:s.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:s.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(162,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:t(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(me.showIcons,this.defaultValue.showIcons),showStatusBar:l(me.showStatusBar,this.defaultValue.showStatusBar),preview:l(me.preview,this.defaultValue.preview),previewMode:t(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(me.showMethods,this.defaultValue.showMethods),showFunctions:l(me.showFunctions,this.defaultValue.showFunctions),showConstructors:l(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(me.showFields,this.defaultValue.showFields),showVariables:l(me.showVariables,this.defaultValue.showVariables),showClasses:l(me.showClasses,this.defaultValue.showClasses),showStructs:l(me.showStructs,this.defaultValue.showStructs),showInterfaces:l(me.showInterfaces,this.defaultValue.showInterfaces),showModules:l(me.showModules,this.defaultValue.showModules),showProperties:l(me.showProperties,this.defaultValue.showProperties),showEvents:l(me.showEvents,this.defaultValue.showEvents),showOperators:l(me.showOperators,this.defaultValue.showOperators),showUnits:l(me.showUnits,this.defaultValue.showUnits),showValues:l(me.showValues,this.defaultValue.showValues),showConstants:l(me.showConstants,this.defaultValue.showConstants),showEnums:l(me.showEnums,this.defaultValue.showEnums),showEnumMembers:l(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(me.showKeywords,this.defaultValue.showKeywords),showWords:l(me.showWords,this.defaultValue.showWords),showColors:l(me.showColors,this.defaultValue.showColors),showFiles:l(me.showFiles,this.defaultValue.showFiles),showReferences:l(me.showReferences,this.defaultValue.showReferences),showFolders:l(me.showFolders,this.defaultValue.showFolders),showTypeParameters:l(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(me.showSnippets,this.defaultValue.showSnippets),showUsers:l(me.showUsers,this.defaultValue.showUsers),showIssues:l(me.showIssues,this.defaultValue.showIssues)}}}class oe extends E{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(163,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends p{constructor(){super(132)}compute(Y,me,Be){return me.get(82)?!0:Y.tabFocusMode}}var J;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function Ee(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends p{constructor(){super(134)}compute(Y,me,Be){const je=me.get(133);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Ne extends E{constructor(){const Y={enabled:!0};super(32,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:s.localize(164,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:l(Y.enabled,this.defaultValue.enabled)}}}const ze="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Je:I.isLinux?Ge:ze,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Pe(X){return e.editorOptionsRegistry[X.id]=X,X}var nt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Pe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(165,null)})),acceptSuggestionOnEnter:Pe(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(166,null),""],markdownDescription:s.localize(167,null)})),accessibilitySupport:Pe(new o),accessibilityPageSize:Pe(new w(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(168,null),tags:["accessibility"]})),ariaLabel:Pe(new S(4,"ariaLabel",s.localize(169,null))),autoClosingBrackets:Pe(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(170,null),s.localize(171,null),""],description:s.localize(172,null)})),autoClosingDelete:Pe(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(173,null),""],description:s.localize(174,null)})),autoClosingOvertype:Pe(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(175,null),""],description:s.localize(176,null)})),autoClosingQuotes:Pe(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(177,null),s.localize(178,null),""],description:s.localize(179,null)})),autoIndent:Pe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[s.localize(180,null),s.localize(181,null),s.localize(182,null),s.localize(183,null),s.localize(184,null)],description:s.localize(185,null)})),automaticLayout:Pe(new f(10,"automaticLayout",!1)),autoSurround:Pe(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(186,null),s.localize(187,null),s.localize(188,null),""],description:s.localize(189,null)})),bracketPairColorization:Pe(new k),bracketPairGuides:Pe(new B),stickyTabStops:Pe(new f(106,"stickyTabStops",!1,{description:s.localize(190,null)})),codeLens:Pe(new f(14,"codeLens",!0,{description:s.localize(191,null)})),codeLensFontFamily:Pe(new S(15,"codeLensFontFamily","",{description:s.localize(192,null)})),codeLensFontSize:Pe(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(193,null)})),colorDecorators:Pe(new f(17,"colorDecorators",!0,{description:s.localize(194,null)})),columnSelection:Pe(new f(18,"columnSelection",!1,{description:s.localize(195,null)})),comments:Pe(new u),contextmenu:Pe(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Pe(new f(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(196,null)})),cursorBlinking:Pe(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:s.localize(197,null)})),cursorSmoothCaretAnimation:Pe(new f(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(198,null)})),cursorStyle:Pe(new r(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(199,null)})),cursorSurroundingLines:Pe(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(200,null)})),cursorSurroundingLinesStyle:Pe(new h(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(201,null),s.localize(202,null)],description:s.localize(203,null)})),cursorWidth:Pe(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(204,null)})),disableLayerHinting:Pe(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Pe(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Pe(new f(30,"domReadOnly",!1)),dragAndDrop:Pe(new f(31,"dragAndDrop",!0,{description:s.localize(205,null)})),emptySelectionClipboard:Pe(new U),dropIntoEditor:Pe(new Ne),stickyScroll:Pe(new re),extraEditorClassName:Pe(new S(34,"extraEditorClassName","")),fastScrollSensitivity:Pe(new d(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(206,null)})),find:Pe(new D),fixedOverflowWidgets:Pe(new f(37,"fixedOverflowWidgets",!1)),folding:Pe(new f(38,"folding",!0,{description:s.localize(207,null)})),foldingStrategy:Pe(new h(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(208,null),s.localize(209,null)],description:s.localize(210,null)})),foldingHighlight:Pe(new f(40,"foldingHighlight",!0,{description:s.localize(211,null)})),foldingImportsByDefault:Pe(new f(41,"foldingImportsByDefault",!1,{description:s.localize(212,null)})),foldingMaximumRegions:Pe(new w(42,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(213,null)})),unfoldOnClickAfterEndOfLine:Pe(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(214,null)})),fontFamily:Pe(new S(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(215,null)})),fontInfo:Pe(new M),fontLigatures2:Pe(new x),fontSize:Pe(new O),fontWeight:Pe(new H),formatOnPaste:Pe(new f(49,"formatOnPaste",!1,{description:s.localize(216,null)})),formatOnType:Pe(new f(50,"formatOnType",!1,{description:s.localize(217,null)})),glyphMargin:Pe(new f(51,"glyphMargin",!0,{description:s.localize(218,null)})),gotoLocation:Pe(new W),hideCursorInOverviewRuler:Pe(new f(53,"hideCursorInOverviewRuler",!1,{description:s.localize(219,null)})),hover:Pe(new z),inDiffEditor:Pe(new f(55,"inDiffEditor",!1)),letterSpacing:Pe(new d(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:s.localize(220,null)})),lightbulb:Pe(new he),lineDecorationsWidth:Pe(new a(59,"lineDecorationsWidth",10)),lineHeight:Pe(new le),lineNumbers:Pe(new ke),lineNumbersMinChars:Pe(new w(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Pe(new f(63,"linkedEditing",!1,{description:s.localize(221,null)})),links:Pe(new f(64,"links",!0,{description:s.localize(222,null)})),matchBrackets:Pe(new h(65,"matchBrackets","always",["always","near","never"],{description:s.localize(223,null)})),minimap:Pe(new fe),mouseStyle:Pe(new h(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Pe(new d(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(224,null)})),mouseWheelZoom:Pe(new f(69,"mouseWheelZoom",!1,{markdownDescription:s.localize(225,null)})),multiCursorMergeOverlapping:Pe(new f(70,"multiCursorMergeOverlapping",!0,{description:s.localize(226,null)})),multiCursorModifier:Pe(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[s.localize(227,null),s.localize(228,null)],markdownDescription:s.localize(229,null)})),multiCursorPaste:Pe(new h(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(230,null),s.localize(231,null)],markdownDescription:s.localize(232,null)})),occurrencesHighlight:Pe(new f(73,"occurrencesHighlight",!0,{description:s.localize(233,null)})),overviewRulerBorder:Pe(new f(74,"overviewRulerBorder",!0,{description:s.localize(234,null)})),overviewRulerLanes:Pe(new w(75,"overviewRulerLanes",3,0,3)),padding:Pe(new pe),parameterHints:Pe(new Se),peekWidgetDefaultFocus:Pe(new h(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(235,null),s.localize(236,null)],description:s.localize(237,null)})),definitionLinkOpensInPeek:Pe(new f(79,"definitionLinkOpensInPeek",!1,{description:s.localize(238,null)})),quickSuggestions:Pe(new Ue),quickSuggestionsDelay:Pe(new w(81,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(239,null)})),readOnly:Pe(new f(82,"readOnly",!1)),renameOnType:Pe(new f(83,"renameOnType",!1,{description:s.localize(240,null),markdownDeprecationMessage:s.localize(241,null)})),renderControlCharacters:Pe(new f(84,"renderControlCharacters",!0,{description:s.localize(242,null),restricted:!0})),renderFinalNewline:Pe(new f(85,"renderFinalNewline",!0,{description:s.localize(243,null)})),renderLineHighlight:Pe(new h(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(244,null)],description:s.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Pe(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(246,null)})),renderValidationDecorations:Pe(new h(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Pe(new h(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(247,null),s.localize(248,null),s.localize(249,null),""],description:s.localize(250,null)})),revealHorizontalRightPadding:Pe(new w(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Pe(new f(91,"roundedSelection",!0,{description:s.localize(251,null)})),rulers:Pe(new De),scrollbar:Pe(new ue),scrollBeyondLastColumn:Pe(new w(94,"scrollBeyondLastColumn",4,0,1073741824,{description:s.localize(252,null)})),scrollBeyondLastLine:Pe(new f(95,"scrollBeyondLastLine",!0,{description:s.localize(253,null)})),scrollPredominantAxis:Pe(new f(96,"scrollPredominantAxis",!0,{description:s.localize(254,null)})),selectionClipboard:Pe(new f(97,"selectionClipboard",!0,{description:s.localize(255,null),included:I.isLinux})),selectionHighlight:Pe(new f(98,"selectionHighlight",!0,{description:s.localize(256,null)})),selectOnLineNumbers:Pe(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Pe(new h(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),showUnused:Pe(new f(101,"showUnused",!0,{description:s.localize(261,null)})),showDeprecated:Pe(new f(128,"showDeprecated",!0,{description:s.localize(262,null)})),inlayHints:Pe(new be),snippetSuggestions:Pe(new h(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(263,null),s.localize(264,null),s.localize(265,null),s.localize(266,null)],description:s.localize(267,null)})),smartSelect:Pe(new oe),smoothScrolling:Pe(new f(104,"smoothScrolling",!1,{description:s.localize(268,null)})),stopRenderingLineAfter:Pe(new w(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Pe(new q),inlineSuggest:Pe(new Z),suggestFontSize:Pe(new w(109,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Pe(new w(110,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Pe(new f(111,"suggestOnTriggerCharacters",!0,{description:s.localize(271,null)})),suggestSelection:Pe(new h(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(272,null),s.localize(273,null),s.localize(274,null)],description:s.localize(275,null)})),tabCompletion:Pe(new h(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(276,null),s.localize(277,null),s.localize(278,null)],description:s.localize(279,null)})),tabIndex:Pe(new w(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Pe(new ee),unusualLineTerminators:Pe(new h(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(280,null),s.localize(281,null),s.localize(282,null)],description:s.localize(283,null)})),useShadowDOM:Pe(new f(117,"useShadowDOM",!0)),useTabStops:Pe(new f(118,"useTabStops",!0,{description:s.localize(284,null)})),wordSeparators:Pe(new S(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:s.localize(285,null)})),wordWrap:Pe(new h(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(286,null),s.localize(287,null),s.localize(288,null),s.localize(289,null)],description:s.localize(290,null)})),wordWrapBreakAfterCharacters:Pe(new S(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Pe(new S(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Pe(new w(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(291,null)})),wordWrapOverride1:Pe(new h(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Pe(new h(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Pe(new r(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ee,{enumDescriptions:[s.localize(292,null),s.localize(293,null),s.localize(294,null),s.localize(295,null)],description:s.localize(296,null)})),wrappingStrategy:Pe(new h(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(297,null),s.localize(298,null)],description:s.localize(299,null)})),editorClassName:Pe(new j),pixelRatio:Pe(new Fe),tabFocusMode:Pe(new ce),layoutInfo:Pe(new te),wrappingInfo:Pe(new ve)}}),define(Ie[124],Ce([16,17]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[125],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[126],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[127],Ce([16,17]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ie[128],Ce([16,17]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ie[129],Ce([16,17]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ie[130],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[131],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[132],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[133],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[134],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[135],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[136],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[137],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ie[138],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[139],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[140],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[141],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[142],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[143],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[144],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[145],Ce([1,0,22,29,126,244]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(f){return f=f.trim(),f==="*"||_.test(f)}e.isValidVersionStr=y;function P(f){if(!y(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function R(f){if(!f)return null;const v=f.majorBase,w=f.majorMustEqual,d=f.minorBase;let S=f.minorMustEqual;const t=f.patchBase;let h=f.patchMustEqual;f.hasCaret&&(v===0||(S=!1),h=!1);let r=0;if(f.preRelease){const n=A.exec(f.preRelease);if(n){const[,o,u,i]=n;r=Date.UTC(Number(o),Number(u)-1,Number(i))}}return{majorBase:v,majorMustEqual:w,minorBase:d,minorMustEqual:S,patchBase:t,patchMustEqual:h,isMinimum:f.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function E(f,v,w){let d;typeof f=="string"?d=R(P(f)):d=f;let S;v instanceof Date?S=v.getTime():typeof v=="string"&&(S=new Date(v).getTime());let t;if(typeof w=="string"?t=R(P(w)):t=w,!d||!t)return!1;const h=d.majorBase,r=d.minorBase,n=d.patchBase;let o=t.majorBase,u=t.minorBase,i=t.patchBase;const c=t.notBefore;let g=t.majorMustEqual,T=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?h>o?!0:h<o?!1:r>u?!0:r<u||S&&S<c?!1:n>=i:(h===1&&o===0&&(!g||!T||!F)&&(o=1,u=0,i=0,g=!0,T=!1,F=!1),h<o?!1:h>o?!g:r<u?!1:r>u?!T:n<i?!1:n>i?!F:!(S&&S<c))}e.isValidVersion=E;function m(f,v,w,d,S){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([I.default.Error,b.localize(0,null)]),t;if(typeof d.name!="string")return t.push([I.default.Error,b.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([I.default.Error,b.localize(2,null,"version")]),t;if(!d.engines)return t.push([I.default.Error,b.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([I.default.Error,b.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!l(d.extensionDependencies))return t.push([I.default.Error,b.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!l(d.activationEvents))return t.push([I.default.Error,b.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([I.default.Error,b.localize(7,null,"activationEvents","main")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([I.default.Warning,b.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([I.default.Error,b.localize(9,null,"main")]),t;{const n=(0,s.joinPath)(w,d.main);(0,s.isEqualOrParent)(n,w)||t.push([I.default.Warning,b.localize(10,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([I.default.Error,b.localize(11,null,"activationEvents","main")]),t}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([I.default.Error,b.localize(12,null,"browser")]),t;{const n=(0,s.joinPath)(w,d.browser);(0,s.isEqualOrParent)(n,w)||t.push([I.default.Warning,b.localize(13,null,n.path,w.path)])}if(typeof d.activationEvents>"u")return t.push([I.default.Error,b.localize(14,null,"activationEvents","browser")]),t}if(!N.valid(d.version))return t.push([I.default.Error,b.localize(15,null)]),t;const h=[];if(!C(f,v,d,S,h))for(const n of h)t.push([I.default.Error,n]);return t}e.validateExtensionManifest=m;function C(f,v,w,d,S){return d||typeof w.main>"u"&&typeof w.browser>"u"?!0:a(f,v,w.engines.vscode,S)}e.isValidExtensionVersion=C;function p(f,v,w){return f==="*"||a(v,w,f)}e.isEngineValid=p;function a(f,v,w,d=[]){const S=R(P(w));if(!S)return d.push(b.localize(16,null,w)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return d.push(b.localize(17,null,w)),!1}else if(!S.majorMustEqual)return d.push(b.localize(18,null,w)),!1;return E(f,v,S)?!0:(d.push(b.localize(19,null,f,w)),!1)}function l(f){if(!Array.isArray(f))return!1;for(let v=0,w=f.length;v<w;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Ie[83],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(b,N=[],_=!1){this.ctor=b,this.staticArguments=N,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=s}),define(Ie[58],Ce([1,0,83]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const I=[];var b;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(b=e.InstantiationType||(e.InstantiationType={}));function N(A,y,P){y instanceof s.SyncDescriptor||(y=new s.SyncDescriptor(y,[],Boolean(P))),I.push([A,y])}e.registerSingleton=N;function _(){return I}e.getSingletonServiceDescriptors=_}),define(Ie[146],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(N,_){this.key=N,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=s;class I{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const _ of this._nodes.values())_.outgoing.size===0&&N.push(_);return N}insertEdge(N,_){const A=this.lookupOrInsertNode(N),y=this.lookupOrInsertNode(_);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(N){const _=this._hashFn(N);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(N){const _=this._hashFn(N);let A=this._nodes.get(_);return A||(A=new s(_,N),this._nodes.set(_,A)),A}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[_,A]of this._nodes)N.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,_]of this._nodes){const A=new Set([N]),y=this._findCycle(_,A);if(y)return y}}_findCycle(N,_){for(const[A,y]of N.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const P=this._findCycle(y,_);if(P)return P;_.delete(A)}}}e.Graph=I}),define(Ie[3],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(s=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function I(_,A,y){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:_,index:y}):(A[s.DI_DEPENDENCIES]=[{id:_,index:y}],A[s.DI_TARGET]=A)}function b(_){if(s.serviceIds.has(_))return s.serviceIds.get(_);const A=function(y,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,y,R)};return A.toString=()=>_,s.serviceIds.set(_,A),A}e.createDecorator=b;function N(_){return _}e.refineServiceDecorator=N}),define(Ie[45],Ce([1,0,9,2,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationOverrides=N;function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function P(f,v){const w=Object.create(null);for(const d in f)R(w,d,f[d],v);return w}e.toValuesTree=P;function R(f,v,w,d){const S=v.split("."),t=S.pop();let h=f;for(let r=0;r<S.length;r++){const n=S[r];let o=h[n];switch(typeof o){case"undefined":o=h[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${v} as ${S.slice(0,r+1).join(".")} is ${JSON.stringify(o)}`);return}h=o}if(typeof h=="object"&&h!==null)try{h[t]=w}catch{d(`Ignoring ${v} as ${S.join(".")} is ${JSON.stringify(h)}`)}else d(`Ignoring ${v} as ${S.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=R;function E(f,v){const w=v.split(".");m(f,w)}e.removeFromValueTree=E;function m(f,v){const w=v.shift();if(v.length===0){delete f[w];return}if(Object.keys(f).indexOf(w)!==-1){const d=f[w];typeof d=="object"&&!Array.isArray(d)&&(m(d,v),Object.keys(d).length===0&&delete f[w])}}function C(f,v,w){function d(h,r){let n=h;for(const o of r){if(typeof n!="object"||n===null)return;n=n[o]}return n}const S=v.split("."),t=d(f,S);return typeof t>"u"?w:t}e.getConfigurationValue=C;function p(f,v,w){Object.keys(v).forEach(d=>{d!=="__proto__"&&(d in f?s.isObject(f[d])&&s.isObject(v[d])?p(f[d],v[d],w):w&&(f[d]=v[d]):f[d]=v[d])})}e.merge=p;function a(f,v,w){const d=f.inspect(v),S=f.inspect(w);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:d.defaultValue}e.getMigratedSettingValue=a;function l(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(Ie[40],Ce([1,0,20,10,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",s.isMacintosh),N.set("isLinux",s.isLinux),N.set("isWindows",s.isWindows),N.set("isWeb",s.isWeb),N.set("isMacNative",s.isMacintosh&&!s.isWeb),N.set("isEdge",s.isEdge),N.set("isFirefox",s.isFirefox),N.set("isChrome",s.isChrome),N.set("isSafari",s.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return E.INSTANCE}static true(){return m.INSTANCE}static has(D){return C.create(D)}static equals(D,x){return p.create(D,x)}static notEquals(D,x){return f.create(D,x)}static regex(D,x){return r.create(D,x)}static in(D,x){return a.create(D,x)}static notIn(D,x){return l.create(D,x)}static not(D){return v.create(D)}static and(...D){return u.create(D,null)}static or(...D){return i.create(D,null,!0)}static greater(D,x){return d.create(D,x)}static greaterEquals(D,x){return S.create(D,x)}static smaller(D,x){return t.create(D,x)}static smallerEquals(D,x){return h.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){const M=D.split("||");return i.create(M.map(O=>this._deserializeAndExpression(O,x)),null,!0)}static _deserializeAndExpression(D,x){const M=D.split("&&");return u.create(M.map(O=>this._deserializeOne(O,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){const M=D.split("!=");return f.create(M[0].trim(),this._deserializeValue(M[1],x))}if(D.indexOf("==")>=0){const M=D.split("==");return p.create(M[0].trim(),this._deserializeValue(M[1],x))}if(D.indexOf("=~")>=0){const M=D.split("=~");return r.create(M[0].trim(),this._deserializeRegexValue(M[1],x))}if(D.indexOf(" not in ")>=0){const M=D.split(" not in ");return l.create(M[0].trim(),this._deserializeValue(M[1],x))}if(D.indexOf(" in ")>=0){const M=D.split(" in ");return a.create(M[0].trim(),this._deserializeValue(M[1],x))}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const M=D.split(">=");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const M=D.split(">");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const M=D.split("<=");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const M=D.split("<");return t.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(D)?v.create(D.substr(1).trim()):C.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const M=/^'([^']*)'$/.exec(D);return M?M[1].trim():D}static _deserializeRegexValue(D,x){if((0,I.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const M=D.indexOf("/"),O=D.lastIndexOf("/");if(M===O||M<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const H=D.slice(M+1,O),W=D[O+1]==="i"?"i":"";try{return new RegExp(H,W)}catch(z){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${z}`);return console.warn(`bad regexp-value '${D}', parse error: ${z}`),null}}}e.ContextKeyExpr=y;function P(U,D){const x=U?U.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!x&&!M?!0:!x||!M?!1:x.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function R(U,D){return U.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class C{static create(D,x=null){const M=N.get(D);return typeof M=="boolean"?M?m.INSTANCE:E.INSTANCE:new C(D,x)}constructor(D,x){this.key=D,this.negated=x,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=N.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class p{static create(D,x,M=null){if(typeof x=="boolean")return x?C.create(D,M):v.create(D,M);const O=N.get(D);return typeof O=="boolean"?x===(O?"true":"false")?m.INSTANCE:E.INSTANCE:new p(D,x,M)}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=N.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class a{static create(D,x){return new a(D,x)}constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),M=D.getValue(this.key);return Array.isArray(x)?x.includes(M):typeof M=="string"&&typeof x=="object"&&x!==null?_.call(x,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=a;class l{static create(D,x){return new l(D,x)}constructor(D,x){this.key=D,this.valueKey=x,this.type=11,this._negated=a.create(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=l;class f{static create(D,x,M=null){if(typeof x=="boolean")return x?v.create(D,M):C.create(D,M);const O=N.get(D);return typeof O=="boolean"?x===(O?"true":"false")?E.INSTANCE:m.INSTANCE:new f(D,x,M)}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=N.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?E.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{static create(D,x=null){const M=N.get(D);return typeof M=="boolean"?M?E.INSTANCE:m.INSTANCE:new v(D,x)}constructor(D,x){this.key=D,this.negated=x,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:g(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=N.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function w(U,D){if(typeof U=="string"){const x=parseFloat(U);isNaN(x)||(U=x)}return typeof U=="string"||typeof U=="number"?D(U):E.INSTANCE}class d{static create(D,x,M=null){return w(x,O=>new d(D,O,M))}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class S{static create(D,x,M=null){return w(x,O=>new S(D,O,M))}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=S;class t{static create(D,x,M=null){return w(x,O=>new t(D,O,M))}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class h{static create(D,x,M=null){return w(x,O=>new h(D,O,M))}constructor(D,x,M){this.key=D,this.value=x,this.negated=M,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class r{static create(D,x){return new r(D,x)}constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return x<M?-1:x>M?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return this.key===D.key&&x===M}return!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{static create(D){return new n(D)}constructor(D){this._actual=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(U){let D=null;for(let x=0,M=U.length;x<M;x++){const O=U[x].substituteConstants();if(U[x]!==O&&D===null){D=[];for(let H=0;H<x;H++)D[H]=U[H]}D!==null&&(D[x]=O)}return D===null?U:D}class u{static create(D,x){return u._normalizeArr(D,x)}constructor(D,x){this.expr=D,this.negated=x,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,M=this.expr.length;x<M;x++){const O=R(this.expr[x],D.expr[x]);if(O!==0)return O}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:u.create(D,this.negated)}evaluate(D){for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const M=[];let O=!1;for(const H of D)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return E.INSTANCE;if(H.type===6){M.push(...H.expr);continue}M.push(H)}if(M.length===0&&O)return m.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(R);for(let H=1;H<M.length;H++)M[H-1].equals(M[H])&&(M.splice(H,1),H--);if(M.length===1)return M[0];for(;M.length>1;){const H=M[M.length-1];if(H.type!==9)break;M.pop();const W=M.pop(),z=M.length===0,G=i.create(H.expr.map(te=>u.create([te,W],null)),null,z);G&&(M.push(G),M.sort(R))}return M.length===1?M[0]:new u(M,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new u(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());this.negated=i.create(D,this,!0)}return this.negated}}class i{static create(D,x,M){return i._normalizeArr(D,x,M)}constructor(D,x){this.expr=D,this.negated=x,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,M=this.expr.length;x<M;x++){const O=R(this.expr[x],D.expr[x]);if(O!==0)return O}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:i.create(D,this.negated,!1)}evaluate(D){for(let x=0,M=this.expr.length;x<M;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,M){let O=[],H=!1;if(D){for(let W=0,z=D.length;W<z;W++){const G=D[W];if(!!G){if(G.type===0){H=!0;continue}if(G.type===1)return m.INSTANCE;if(G.type===9){O=O.concat(G.expr);continue}O.push(G)}}if(O.length===0&&H)return E.INSTANCE;O.sort(R)}if(O.length!==0){if(O.length===1)return O[0];for(let W=1;W<O.length;W++)O[W-1].equals(O[W])&&(O.splice(W,1),W--);if(O.length===1)return O[0];if(M){for(let W=0;W<O.length;W++)for(let z=W+1;z<O.length;z++)F(O[W],O[z])&&(O.splice(z,1),z--);if(O.length===1)return O[0]}return new i(O,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new i(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),M=D.shift(),O=[];for(const W of j(x))for(const z of j(M))O.push(u.create([W,z],null));const H=D.length===0;D.unshift(i.create(O,null,H))}this.negated=D[0]}return this.negated}}class c extends C{static all(){return c._info.values()}constructor(D,x,M){super(D,null),this._defaultValue=x,typeof M=="object"?c._info.push({...M,key:D}):M!==!0&&c._info.push({key:D,description:M,type:x!=null?typeof x:void 0})}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return p.create(this.key,D)}notEqualsTo(D){return f.create(this.key,D)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(U,D){return U<D?-1:U>D?1:0}function T(U,D,x,M){return U<x?-1:U>x?1:D<M?-1:D>M?1:0}function F(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const O of D.expr)if(U.equals(O))return!0}const x=U.negate(),M=j(x).concat(j(D));M.sort(R);for(let O=0;O<M.length;O++){const W=M[O].negate();for(let z=O+1;z<M.length;z++){const G=M[z];if(W.equals(G))return!0}}return!1}e.implies=F;function j(U){return U.type===9?U.expr:[U]}}),define(Ie[147],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],Ce([1,0,125,3]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function N(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function _(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(f,v,w){return A(v,w)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===w?!0:P(w).includes(f)}e.isTargetPlatformCompatible=y;function P(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var C;(function(f){f.Install="install",f.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var p;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var a;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(v,w){super(v),this.code=w,this.name=w}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,s.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,s.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[35],Ce([1,0,24,19,10,9,2,127,3]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=C;function p(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=p;function a(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=a;function l(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function f(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=f;function v(W){return C(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var w;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(z,G){super(z),this.code=G}}e.FileSystemProviderError=d;function S(W,z){const G=new d(W.toString(),z);return h(G,z),G}e.createFileSystemProviderError=S;function t(W){return W||S((0,A.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=t;function h(W,z){return W.name=z?`${z} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=h;function r(W){if(!W)return w.Unknown;if(W instanceof d)return W.code;const z=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!z)return w.Unknown;switch(z[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=r;function n(W){if(W instanceof T)return W.fileOperationResult;switch(r(W)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class u{constructor(z,G,te){this.resource=z,this.operation=G,this.target=te}isOperation(z){return this.operation===z}}e.FileOperationEvent=u;var i;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class c{constructor(z,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const te=new Map;for(const he of z){const re=te.get(he.type);switch(re?re.push([he.resource,he]):te.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,re]of te)switch(he){case 1:this.added=s.TernarySearchTree.forUris(()=>G),this.added.fill(re);break;case 0:this.updated=s.TernarySearchTree.forUris(()=>G),this.updated.fill(re);break;case 2:this.deleted=s.TernarySearchTree.forUris(()=>G),this.deleted.fill(re);break}}contains(z,...G){return this.doContains(z,{includeChildren:!1},...G)}affects(z,...G){return this.doContains(z,{includeChildren:!0},...G)}doContains(z,G,...te){if(!z)return!1;const he=te.length>0;return!!((!he||te.includes(1))&&(this.added?.get(z)||G.includeChildren&&this.added?.findSuperstr(z))||(!he||te.includes(0))&&(this.updated?.get(z)||G.includeChildren&&this.updated?.findSuperstr(z))||(!he||te.includes(2))&&(this.deleted?.findSubstr(z)||G.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function g(W,z,G){return!W||!z||W===z||z.length>W.length?!1:(z.charAt(z.length-1)!==I.sep&&(z+=I.sep),G?(0,b.startsWithIgnoreCase)(W,z):W.indexOf(z)===0)}e.isParent=g;class T extends Error{constructor(z,G,te){super(z),this.fileOperationResult=G,this.options=te}}e.FileOperationError=T;class F extends T{constructor(z,G,te){super(z,2,te),this.stat=G}}e.NotModifiedSinceFileOperationError=F;var j;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function x(W,z){if(!z.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(G=>{const te=z.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===W.scheme&&he.added&&(te.dispose(),G())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,N.isNumber)(z)||(z=0),z<M.KB?(0,A.localize)(1,null,z.toFixed(0)):z<M.MB?(0,A.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,A.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,A.localize)(4,null,(z/M.GB).toFixed(2)):(0,A.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var O;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function H(W){return{maxFileSize:W===0?300*M.MB:16*M.GB,maxHeapSize:W===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=H}),define(Ie[59],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...b){this._entries=new Map;for(const[N,_]of b)this.set(N,_)}set(b,N){const _=this._entries.get(b);return this._entries.set(b,N),_}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=s}),define(Ie[148],Ce([1,0,15,12,7,83,146,3,59,149]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class E extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class m{constructor(l=new y.ServiceCollection,f=!1,v,w=R){this._services=l,this._strict=f,this._parent=v,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=w?v?._globalGraph??new _.Graph(d=>d):void 0}createChild(l){return new m(l,this._strict,this,this._enableTracing)}invokeFunction(l,...f){const v=p.traceInvocation(this._enableTracing,l);let w=!1;try{return l({get:S=>{if(w)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(S,v);if(!t)throw new Error(`[invokeFunction] unknown service '${S}'`);return t}},...f)}finally{w=!0,v.stop()}}createInstance(l,...f){let v,w;return l instanceof N.SyncDescriptor?(v=p.traceCreation(this._enableTracing,l.ctor),w=this._createInstance(l.ctor,l.staticArguments.concat(f),v)):(v=p.traceCreation(this._enableTracing,l),w=this._createInstance(l,f,v)),v.stop(),w}_createInstance(l,f=[],v){const w=A._util.getServiceDependencies(l).sort((t,h)=>t.index-h.index),d=[];for(const t of w){const h=this._getOrCreateServiceInstance(t.id,v);h||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(h)}const S=w.length>0?w[0].index:f.length;if(f.length!==S){console.trace(`[createInstance] First service dependency of ${l.name} at position ${S+1} conflicts with ${f.length} static arguments`);const t=S-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,S)}return Reflect.construct(l,f.concat(d))}_setServiceInstance(l,f){if(this._services.get(l)instanceof N.SyncDescriptor)this._services.set(l,f);else if(this._parent)this._parent._setServiceInstance(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){const f=this._services.get(l);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):f}_getOrCreateServiceInstance(l,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(l));const v=this._getServiceInstanceOrDescriptor(l);return v instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,f.branch(l,!0)):(f.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,f,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,f,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,f,v){const w=new _.Graph(t=>t.id.toString());let d=0;const S=[{id:l,desc:f,_trace:v}];for(;S.length;){const t=S.pop();if(w.lookupOrInsertNode(t),d++>1e3)throw new E(w);for(const h of A._util.getServiceDependencies(t.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(h.id);if(r||this._throwIfStrict(`[createInstance] ${l} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),r instanceof N.SyncDescriptor){const n={id:h.id,desc:r,_trace:t._trace.branch(h.id,!0)};w.insertEdge(t,n),S.push(n)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:h}of t){if(this._getServiceInstanceOrDescriptor(h.id)instanceof N.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}w.removeNode(h)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,f,v=[],w,d){if(this._services.get(l)instanceof N.SyncDescriptor)return this._createServiceInstance(l,f,v,w,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,f,v,w,d);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(l,f,v=[],w,d){if(w){const S=new m(void 0,this._strict,this,this._enableTracing);S._globalGraphImplicitDependency=String(l);const t=new Map,h=new s.IdleValue(()=>{const r=S._createInstance(f,v,d);for(const[n,o]of t){const u=r[n];if(typeof u=="function")for(const i of o)u.apply(r,i)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,n){if(!h.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let i=t.get(n);return i||(i=new P.LinkedList,t.set(n,i)),(g,T,F)=>{const j=i.push([g,T,F]);return(0,b.toDisposable)(j)}}if(n in r)return r[n];const o=h.value;let u=o[n];return typeof u!="function"||(u=u.bind(o),r[n]=u),u},set(r,n,o){return h.value[n]=o,!0}})}else return this._createInstance(f,v,d)}_throwIfStrict(l,f){if(f&&console.warn(l),this._strict)throw new Error(l)}}e.InstantiationService=m;var C;(function(a){a[a.Creation=0]="Creation",a[a.Invocation=1]="Invocation",a[a.Branch=2]="Branch"})(C||(C={}));class p{static traceInvocation(l,f){return l?new p(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(l,f){return l?new p(0,f.name):p._None}constructor(l,f){this.type=l,this.name=f,this._start=Date.now(),this._dep=[]}branch(l,f){const v=new p(2,l.toString());return this._dep.push([l,f,v]),v}stop(){const l=Date.now()-this._start;p._totals+=l;let f=!1;function v(d,S){const t=[],h=new Array(d+1).join("	");for(const[r,n,o]of S._dep)if(n&&o){f=!0,t.push(`${h}CREATES -> ${r}`);const u=v(d+1,o);u&&t.push(u)}else t.push(`${h}uses -> ${r}`);return t.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(l>2||f)&&p.all.add(w.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Ie[11],Ce([1,0,44,4,7,24,20,2,3]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function P(){return new Date().toISOString()}var R;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function E(u,i,c){switch(i){case R.Trace:u.trace(c);break;case R.Debug:u.debug(c);break;case R.Info:u.info(c);break;case R.Warning:u.warn(c);break;case R.Error:u.error(c);break;case R.Critical:u.critical(c);break;default:throw new Error("Invalid log level")}}e.log=E;function m(u){let i="";for(let c=0;c<u.length;c++){let g=u[c];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}i+=(c>0?" ":"")+g}return i}e.format=m;class C extends b.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class p extends C{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...c){this.checkLogLevel(R.Trace)&&this.log(R.Trace,m([i,...c]))}debug(i,...c){this.checkLogLevel(R.Debug)&&this.log(R.Debug,m([i,...c]))}info(i,...c){this.checkLogLevel(R.Info)&&this.log(R.Info,m([i,...c]))}warn(i,...c){this.checkLogLevel(R.Warning)&&this.log(R.Warning,m([i,...c]))}error(i,...c){if(this.checkLogLevel(R.Error))if(i instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=i.stack,this.log(R.Error,m(g))}else this.log(R.Error,m([i,...c]))}critical(i,...c){this.checkLogLevel(R.Critical)&&this.log(R.Critical,m([i,...c]))}flush(){}}e.AbstractMessageLogger=p;class a extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!_.isWindows}trace(i,...c){this.getLevel()<=R.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,i,...c):console.log(`[main ${P()}]`,i,...c))}debug(i,...c){this.getLevel()<=R.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,i,...c):console.log(`[main ${P()}]`,i,...c))}info(i,...c){this.getLevel()<=R.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,i,...c):console.log(`[main ${P()}]`,i,...c))}warn(i,...c){this.getLevel()<=R.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,i,...c):console.warn(`[main ${P()}]`,i,...c))}error(i,...c){this.getLevel()<=R.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,i,...c):console.error(`[main ${P()}]`,i,...c))}critical(i,...c){this.getLevel()<=R.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,i,...c):console.error(`[main ${P()}]`,i,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=a;class l extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...c){this.getLevel()<=R.Trace&&console.log("%cTRACE","color: #888",i,...c)}debug(i,...c){this.getLevel()<=R.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...c)}info(i,...c){this.getLevel()<=R.Info&&console.log("%c INFO","color: #33f",i,...c)}warn(i,...c){this.getLevel()<=R.Warning&&console.log("%c WARN","color: #993",i,...c)}error(i,...c){this.getLevel()<=R.Error&&console.log("%c  ERR","color: #f33",i,...c)}critical(i,...c){this.getLevel()<=R.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...c)}dispose(){}flush(){}}e.ConsoleLogger=l;class f extends C{constructor(i,c=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(c)}trace(i,...c){this.getLevel()<=R.Trace&&this.adapter.log(R.Trace,[this.extractMessage(i),...c])}debug(i,...c){this.getLevel()<=R.Debug&&this.adapter.log(R.Debug,[this.extractMessage(i),...c])}info(i,...c){this.getLevel()<=R.Info&&this.adapter.log(R.Info,[this.extractMessage(i),...c])}warn(i,...c){this.getLevel()<=R.Warning&&this.adapter.log(R.Warning,[this.extractMessage(i),...c])}error(i,...c){this.getLevel()<=R.Error&&this.adapter.log(R.Error,[this.extractMessage(i),...c])}critical(i,...c){this.getLevel()<=R.Critical&&this.adapter.log(R.Critical,[this.extractMessage(i),...c])}extractMessage(i){return typeof i=="string"?i:(0,s.toErrorMessage)(i,this.getLevel()<=R.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class v extends C{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const c of this.logServices)c.setLevel(i);super.setLevel(i)}trace(i,...c){for(const g of this.logServices)g.trace(i,...c)}debug(i,...c){for(const g of this.logServices)g.debug(i,...c)}info(i,...c){for(const g of this.logServices)g.info(i,...c)}warn(i,...c){for(const g of this.logServices)g.warn(i,...c)}error(i,...c){for(const g of this.logServices)g.error(i,...c)}critical(i,...c){for(const g of this.logServices)g.critical(i,...c)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=v;class w extends b.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...c){this.logger.trace(i,...c)}debug(i,...c){this.logger.debug(i,...c)}info(i,...c){this.logger.info(i,...c)}warn(i,...c){this.logger.warn(i,...c)}error(i,...c){this.logger.error(i,...c)}critical(i,...c){this.logger.critical(i,...c)}flush(){this.logger.flush()}}e.LogService=w;class d extends b.Disposable{constructor(i,c){super(),this.logLevel=i,this.loggerItems=new N.ResourceMap,this._register(c(g=>this.setLevel(g)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:i})=>i)}getLogger(i){return this.loggerItems.get(i)?.logger}createLogger(i,c,g){let T=this.loggerItems.get(i)?.logger;return T||(g=c?.always?R.Trace:g,T=this.doCreateLogger(i,g??this.logLevel,c),this.loggerItems.set(i,{logger:T,logLevel:g})),T}setLevel(i,c){const g=A.URI.isUri(i)?i:void 0,T=g?c:i;if(g){const F=this.loggerItems.get(g);F&&F.logLevel!==T&&(F.logLevel=T,F.logger.setLevel(T))}else this.logLevel=T,this.loggerItems.forEach(({logLevel:F,logger:j})=>{F===void 0&&j.setLevel(this.logLevel)})}getLogLevel(i){return this.loggerItems.get(i)?.logLevel}dispose(){this.loggerItems.forEach(({logger:i})=>i.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=d;class S{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(i){}getLevel(){return R.Info}trace(i,...c){}debug(i,...c){}info(i,...c){}warn(i,...c){}error(i,...c){}critical(i,...c){}dispose(){}flush(){}}e.NullLogger=S;class t extends S{}e.NullLogService=t;class h extends d{constructor(){super(R.Info,I.Event.None)}doCreateLogger(i,c,g){return new S}}e.NullLoggerService=h;function r(u){if(u.verbose)return R.Trace;if(typeof u.logLevel=="string"){const i=n(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function n(u){switch(u){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Critical;case"off":return R.Off}}e.parseLogLevel=n;function o(u){switch(u){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Critical:return"critical";case R.Off:return"off"}}e.LogLevelToString=o}),define(Ie[85],Ce([1,0,29,128,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var _;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(p,a){return a-p}y.compare=P;const R=Object.create(null);R[y.Error]=(0,I.localize)(0,null),R[y.Warning]=(0,I.localize)(1,null),R[y.Info]=(0,I.localize)(2,null);function E(p){return R[p]||""}y.toString=E;function m(p){switch(p){case s.default.Error:return y.Error;case s.default.Warning:return y.Warning;case s.default.Info:return y.Info;case s.default.Ignore:return y.Hint}}y.fromSeverity=m;function C(p){switch(p){case y.Error:return s.default.Error;case y.Warning:return s.default.Warning;case y.Info:return s.default.Info;case y.Hint:return s.default.Ignore}}y.toSeverity=C}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const P="";function R(m){return E(m,!0)}y.makeKey=R;function E(m,C){const p=[P];return m.source?p.push(m.source.replace("\xA6","\\\xA6")):p.push(P),m.code?typeof m.code=="string"?p.push(m.code.replace("\xA6","\\\xA6")):p.push(m.code.value.replace("\xA6","\\\xA6")):p.push(P),m.severity!==void 0&&m.severity!==null?p.push(_.toString(m.severity)):p.push(P),m.message&&C?p.push(m.message.replace("\xA6","\\\xA6")):p.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?p.push(m.startLineNumber.toString()):p.push(P),m.startColumn!==void 0&&m.startColumn!==null?p.push(m.startColumn.toString()):p.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?p.push(m.endLineNumber.toString()):p.push(P),m.endColumn!==void 0&&m.endColumn!==null?p.push(m.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}y.makeKeyOptionalMessage=E})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(Ie[150],Ce([1,0,4,29,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,b.createDecorator)("notificationService");var N;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(Ie[86],Ce([1,0,7,10,2,3]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,N.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function _(R,E){return b.URI.isUri(R)?(0,I.equalsIgnoreCase)(R.scheme,E):(0,I.startsWithIgnoreCase)(R,E+":")}e.matchesScheme=_;function A(R,...E){return E.some(m=>_(R,m))}e.matchesSomeScheme=A;function y(R,E){return R.with({fragment:`${E.startLineNumber},${E.startColumn}${E.endLineNumber?`-${E.endLineNumber}${E.endColumn?`,${E.endColumn}`:""}`:""}`})}e.withSelection=y;function P(R){let E;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(E={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:E,uri:R}}e.extractSelection=P}),define(Ie[151],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,s.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(ne,e,s,I){var b=arguments.length,N=b<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,s):I,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ne,e,s,I);else for(var A=ne.length-1;A>=0;A--)(_=ne[A])&&(N=(b<3?_(N):b>3?_(e,s,N):_(e,s))||N);return b>3&&N&&Object.defineProperty(e,s,N),N},$e=this&&this.__param||function(ne,e){return function(s,I){e(s,I,ne)}};define(Ie[152],Ce([1,0,15,21,7,3]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var _;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(E){this.callback=E}report(E){this._value=E,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends b.Disposable{constructor(E,m){super(),this.deferred=new s.DeferredPromise,m.withProgress(E,C=>(this.reporter=C,this.lastStep&&C.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};y=xe([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends b.Disposable{constructor(E){super(),this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const m=++this.currentOperationId,C=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>C.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:C.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,46,9]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(_,A){s.ok(I.isString(_)),s.ok(I.isObject(A)),s.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new b}),define(Ie[87],Ce([1,0,4,30]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class N{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[b(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new N;I.Registry.add(e.Extensions.JSONContribution,_)}),define(Ie[88],Ce([1,0,18,4,9,124,45,87,30]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=y.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const r=this.doRegisterConfigurations(t,h);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(t){const h=this.doDeregisterConfigurations(t);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:t,remove:h}){const r=[];r.push(...this.doDeregisterConfigurations(h)),r.push(...this.doRegisterConfigurations(t,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(r)})}registerDefaultConfigurations(t){const h=[],r=[];for(const{overrides:n,source:o}of t)for(const u in n)if(h.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const i=this.configurationDefaultsOverrides.get(u),c=i?.valuesSources??new Map;if(o)for(const j of Object.keys(n[u]))c.set(j,o);const g={...i?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:g,valuesSources:c});const T=(0,_.getLanguageTagSettingPlainKey)(u),F={type:"object",default:g,description:N.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:b.isString(o)?void 0:o,defaultValueSource:o};r.push(...a(u)),this.configurationProperties[u]=F,this.defaultLanguageConfigurationOverridesNode.properties[u]=F}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:o});const i=this.configurationProperties[u];i&&(this.updatePropertyDefaultValue(u,i),this.updateSchema(u,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const h=[];for(const{overrides:r,source:n}of t)for(const o in r){const u=this.configurationDefaultsOverrides.get(o),i=b.isString(n)?n:n?.id,c=b.isString(u?.source)?u?.source:u?.source?.id;if(i===c)if(h.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const g=this.configurationProperties[o];g&&(this.updatePropertyDefaultValue(o,g),this.updateSchema(o,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const h of t)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,h){const r=[];return t.forEach(n=>{r.push(...this.validateAndRegisterProperties(n,h,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),r}doDeregisterConfigurations(t){const h=[],r=n=>{if(n.properties)for(const o in n.properties){h.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>r(o))};for(const n of t){r(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return h}validateAndRegisterProperties(t,h=!0,r,n,o=3){o=b.isUndefinedOrNull(t.scope)?o:t.scope;const u=[],i=t.properties;if(i)for(const g in i){const T=i[g];if(h&&w(g,T)){delete i[g];continue}if(T.source=r,T.defaultDefaultValue=i[g].default,this.updatePropertyDefaultValue(g,T),e.OVERRIDE_PROPERTY_REGEX.test(g)?T.scope=void 0:(T.scope=b.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=b.isUndefinedOrNull(T.restricted)?!!n?.includes(g):T.restricted),i[g].hasOwnProperty("included")&&!i[g].included){this.excludedConfigurationProperties[g]=i[g],delete i[g];continue}else this.configurationProperties[g]=i[g],i[g].policy?.name&&this.policyConfigurations.set(i[g].policy.name,g);!i[g].deprecationMessage&&i[g].markdownDeprecationMessage&&(i[g].deprecationMessage=i[g].markdownDeprecationMessage),u.push(g)}const c=t.allOf;if(c)for(const g of c)u.push(...this.validateAndRegisterProperties(g,h,r,n,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const h=r=>{const n=r.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);r.allOf?.forEach(h)};h(t)}updateSchema(t,h){switch(e.allSettings.properties[t]=h,h.scope){case 1:e.applicationSettings.properties[t]=h;break;case 2:e.machineSettings.properties[t]=h;break;case 6:e.machineOverridableSettings.properties[t]=h;break;case 3:e.windowSettings.properties[t]=h;break;case 4:e.resourceSettings.properties[t]=h;break;case 5:e.resourceSettings.properties[t]=h,this.resourceLanguageSettingsSchema.properties[t]=h;break}}removeFromSchema(t,h){switch(delete e.allSettings.properties[t],h.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const h=`[${t}]`,r={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,h){const r=this.configurationDefaultsOverrides.get(t);let n=r?.value,o=r?.source;b.isUndefined(n)&&(n=h.defaultDefaultValue,o=void 0),b.isUndefined(n)&&(n=f(h.type)),h.default=n,h.defaultValueSource=o}}const C="\\[([^\\]]+)\\]",p=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(S){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let h=p.exec(S);for(;h?.length;){const r=h[1].trim();r&&t.push(r),h=p.exec(S)}}return(0,s.distinct)(t)}e.overrideIdentifiersFromKey=a;function l(S){return S.reduce((t,h)=>`${t}[${h}]`,"")}e.keyFromOverrideIdentifiers=l;function f(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new m;y.Registry.add(e.Extensions.Configuration,v);function w(S,t){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?N.localize(7,null,S):v.getConfigurationProperties()[S]!==void 0?N.localize(8,null,S):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,S,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.validateProperty=w;function d(){const S=[],t=v.getConfigurationProperties();for(const h of Object.keys(t))S.push([h,t[h].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(Ie[153],Ce([1,0,18,4,105,7,24,25,9,2,45,88,30]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(t={},h=[],r=[],n){this._contents=t,this._keys=h,this._overrides=r,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(h=>{if(h instanceof C)return h;const r=new p("");return r.parseRaw(h),r.configurationModel});this._rawConfiguration=t.reduce((h,r)=>r===h?r:h.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,R.getConfigurationValue)(this.contents,t):this.contents}inspect(t,h){const r=this.rawConfiguration.getValue(t),n=h?this.rawConfiguration.getOverrideValue(t,h):void 0,o=h?this.rawConfiguration.override(h).getValue(t):r;return{value:r,override:n,merged:o}}getOverrideValue(t,h){const r=this.getContentsForOverrideIdentifer(h);return r?t?(0,R.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const h=[];for(const r of this.overrides)r.identifiers.includes(t)&&h.push(...r.keys);return s.distinct(h)}getAllOverrideIdentifiers(){const t=[];for(const h of this.overrides)t.push(...h.identifiers);return s.distinct(t)}override(t){let h=this.overrideConfigurations.get(t);return h||(h=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,h)),h}merge(...t){const h=A.deepClone(this.contents),r=A.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const u of t)if(o.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(h,u.contents);for(const i of u.overrides){const[c]=r.filter(g=>s.equals(g.identifiers,i.identifiers));c?(this.mergeContents(c.contents,i.contents),c.keys.push(...i.keys),c.keys=s.distinct(c.keys)):r.push(A.deepClone(i))}for(const i of u.keys)n.indexOf(i)===-1&&n.push(i)}return new C(h,n,r,o.every(u=>u instanceof C)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new C(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const h=this.getContentsForOverrideIdentifer(t);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const r={};for(const n of s.distinct([...Object.keys(this.contents),...Object.keys(h)])){let o=this.contents[n];const u=h[n];u&&(typeof o=="object"&&typeof u=="object"?(o=A.deepClone(o),this.mergeContents(o,u)):o=u),r[n]=o}return new C(r,this.keys,this.overrides)}mergeContents(t,h){for(const r of Object.keys(h)){if(r in t&&y.isObject(t[r])&&y.isObject(h[r])){this.mergeContents(t[r],h[r]);continue}t[r]=A.deepClone(h[r])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let h=null,r=null;const n=o=>{o&&(r?this.mergeContents(r,o):r=A.deepClone(o))};for(const o of this.overrides)s.equals(o.identifiers,[t])?h=o.contents:o.identifiers.includes(t)&&n(o.contents);return n(h),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,h){this.addKey(t),(0,R.addToValueTree)(this.contents,t,h,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,R.removeFromValueTree)(this.contents,t)}addKey(t){let h=this.keys.length;for(let r=0;r<h;r++)t.indexOf(this.keys[r])===0&&(h=r);this.keys.splice(h,1,t)}removeKey(t){const h=this.keys.indexOf(t);return h!==-1?(this.keys.splice(h,1),!0):!1}}e.ConfigurationModel=C;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,h){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,h)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,h){this._raw=t;const{contents:r,keys:n,overrides:o,restricted:u,hasExcludedProperties:i}=this.doParseRaw(t,h);this._configurationModel=new C(r,n,o,i?[t]:void 0),this._restrictedConfigurations=u||[]}doParseContent(t){let h={},r=null,n=[];const o=[],u=[];function i(g){Array.isArray(n)?n.push(g):r!==null&&(n[r]=g)}const c={onObjectBegin:()=>{const g={};i(g),o.push(n),n=g,r=null},onObjectProperty:g=>{r=g},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const g=[];i(g),o.push(n),n=g,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:i,onError:(g,T,F)=>{u.push({error:g,offset:T,length:F})}};if(t)try{b.visit(t,c),h=n[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return h}doParseRaw(t,h){const r=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,h);t=n.raw;const o=(0,R.toValuesTree)(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`)),u=Object.keys(t),i=this.toOverrides(t,c=>console.error(`Conflict in settings file ${this._name}: ${c}`));return{contents:o,keys:u,overrides:i,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(t,h,r,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const u={},i=[];for(const c in t)if(E.OVERRIDE_PROPERTY_REGEX.test(c)&&r){const g=this.filter(t[c],h,!1,n);u[c]=g.raw,o=o||g.hasExcludedProperties,i.push(...g.restricted)}else{const g=h[c],T=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&i.push(c),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&g?.restricted)?u[c]=t[c]:o=!0}return{raw:u,restricted:i,hasExcludedProperties:o}}toOverrides(t,h){const r=[];for(const n of Object.keys(t))if(E.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const u in t[n])o[u]=t[n][u];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,R.toValuesTree)(o,h)})}return r}}e.ConfigurationModelParser=p;class a extends N.Disposable{constructor(t,h,r,n){super(),this.userSettingsResource=t,this.scopes=h,this.fileService=n,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class l{constructor(t,h,r,n,o=new C,u=new C,i=new _.ResourceMap,c=new C,g=new _.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=h,this._applicationConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=i,this._memoryConfiguration=c,this._memoryConfigurationByResource=g,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,h,r){return this.getConsolidatedConfigurationModel(t,h,r).getValue(t)}updateValue(t,h,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new C,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,h===void 0?n.removeValue(t):n.setValue(t,h),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,h,r){const n=this.getConsolidatedConfigurationModel(t,h,r),o=this.getFolderConfigurationModelForResource(h.resource,r),u=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,i=this._defaultConfiguration.inspect(t,h.overrideIdentifier),c=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(t),g=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(t),T=this.userConfiguration.freeze().inspect(t,h.overrideIdentifier),F=this.localUserConfiguration.freeze().inspect(t,h.overrideIdentifier),j=this.remoteUserConfiguration.freeze().inspect(t,h.overrideIdentifier),U=r?this._workspaceConfiguration.freeze().inspect(t,h.overrideIdentifier):void 0,D=o?o.freeze().inspect(t,h.overrideIdentifier):void 0,x=u.inspect(t,h.overrideIdentifier),M=n.getValue(t),O=s.distinct(n.overrides.map(H=>H.identifiers).flat()).filter(H=>n.getOverrideValue(t,H)!==void 0);return{defaultValue:i?i.merged:void 0,policyValue:c?c.merged:void 0,applicationValue:g?g.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:F?F.merged:void 0,userRemoteValue:j?j.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:D?D.merged:void 0,memoryValue:x?x.merged:void 0,value:M,default:i.value!==void 0||i.override!==void 0?{value:i.value,override:i.override}:void 0,policy:c?.value!==void 0?{value:c.value}:void 0,application:g?.value!==void 0||g?.override!==void 0?{value:g.value,override:g.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:F.value!==void 0||F.override!==void 0?{value:F.value,override:F.override}:void 0,userRemote:j.value!==void 0||j.override!==void 0?{value:j.value,override:j.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:D?.value!==void 0||D?.override!==void 0?{value:D.value,override:D.override}:void 0,memory:x.value!==void 0||x.override!==void 0?{value:x.value,override:x.override}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const h=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:h?h.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,h){this._folderConfigurations.set(t,h),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,h){const r=[];if(!h){const{added:n,updated:o,removed:u}=w(this._defaultConfiguration,t);h=[...n,...o,...u]}for(const n of h)for(const o of(0,E.overrideIdentifiersFromKey)(n)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),i=t.getKeysForOverrideIdentifier(o),c=[...i.filter(g=>u.indexOf(g)===-1),...u.filter(g=>i.indexOf(g)===-1),...u.filter(g=>!A.equals(this._defaultConfiguration.override(o).getValue(g),t.override(o).getValue(g)))];r.push([o,c])}return this.updateDefaultConfiguration(t),{keys:h,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:h,updated:r,removed:n}=w(this._policyConfiguration,t),o=[...h,...r,...n];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:h,updated:r,removed:n,overrides:o}=w(this.applicationConfiguration,t),u=[...h,...r,...n];return u.length&&this.updateApplicationConfiguration(t),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:h,updated:r,removed:n,overrides:o}=w(this.localUserConfiguration,t),u=[...h,...r,...n];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:h,updated:r,removed:n,overrides:o}=w(this.remoteUserConfiguration,t),u=[...h,...r,...n];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:h,updated:r,removed:n,overrides:o}=w(this.workspaceConfiguration,t),u=[...h,...r,...n];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(t,h){const r=this.folderConfigurations.get(t),{added:n,updated:o,removed:u,overrides:i}=w(r,h),c=[...n,...o,...u];return(c.length||!r)&&this.updateFolderConfiguration(t,h),{keys:c,overrides:i}}compareAndDeleteFolderConfiguration(t){const h=this.folderConfigurations.get(t);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:o,overrides:u}=w(h,void 0);return{keys:[...r,...n,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,h,r){let n=this.getConsolidatedConfigurationModelForResource(h,r);return h.overrideIdentifier&&(n=n.override(h.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},h){let r=this.getWorkspaceConsolidatedConfiguration();if(h&&t){const n=h.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let h=this._foldersConsolidatedConfigurations.get(t);if(!h){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(h=r.merge(n),this._freeze&&(h=h.freeze()),this._foldersConsolidatedConfigurations.set(t,h)):h=r}return h}getFolderConfigurationModelForResource(t,h){if(h&&t){const r=h.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,h)=>{const{contents:r,overrides:n,keys:o}=this._folderConfigurations.get(h);return t.push([h,{contents:r,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(h=>t.add(h)),this.userConfiguration.freeze().keys.forEach(h=>t.add(h)),this._workspaceConfiguration.freeze().keys.forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>t.add(h)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>t.add(h)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.freeze().getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>h.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>h.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>h.add(n))),[...h.values()]}static parse(t){const h=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),o=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),i=t.folders.reduce((c,g)=>(c.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),c),new _.ResourceMap);return new l(h,r,n,o,new C,u,i,new C,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new C(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=l;function f(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const t=new Set,h=new Map;for(const n of S)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,u])=>{const i=(0,_.getOrSet)(h,o,new Set);u.forEach(c=>i.add(c))});const r=[];return h.forEach((n,o)=>r.push([o,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=f;class v{constructor(t,h,r,n){this.change=t,this.previous=h,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(i=>o.add(i)),t.overrides.forEach(([,i])=>i.forEach(c=>o.add(c))),this.affectedKeys=[...o.values()];const u=new C;this.affectedKeys.forEach(i=>u.setValue(i,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,h){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(h){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,h,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,h,this.currentWorkspace);return!A.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,h){let r=(0,R.toValuesTree)({[h]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=v;function w(S,t){const{added:h,removed:r,updated:n}=d(t,S),o=[],u=S?.getAllOverrideIdentifiers()||[],i=t?.getAllOverrideIdentifiers()||[];if(t){const c=i.filter(g=>!u.includes(g));for(const g of c)o.push([g,t.getKeysForOverrideIdentifier(g)])}if(S){const c=u.filter(g=>!i.includes(g));for(const g of c)o.push([g,S.getKeysForOverrideIdentifier(g)])}if(t&&S){for(const c of u)if(i.includes(c)){const g=d({contents:S.getOverrideValue(void 0,c)||{},keys:S.getKeysForOverrideIdentifier(c)},{contents:t.getOverrideValue(void 0,c)||{},keys:t.getKeysForOverrideIdentifier(c)});o.push([c,[...g.added,...g.removed,...g.updated]])}}return{added:h,removed:r,updated:n,overrides:o}}function d(S,t){const h=S?t?S.keys.filter(o=>t.keys.indexOf(o)===-1):[...S.keys]:[],r=t?S?t.keys.filter(o=>S.keys.indexOf(o)===-1):[...t.keys]:[],n=[];if(S&&t){for(const o of t.keys)if(S.keys.indexOf(o)!==-1){const u=(0,R.getConfigurationValue)(t.contents,o),i=(0,R.getConfigurationValue)(S.contents,o);A.equals(u,i)||n.push(o)}}return{added:h,removed:r,updated:n}}}),define(Ie[89],Ce([1,0,12,3]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,I.createDecorator)("remoteAuthorityResolverService");var b;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends s.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof N&&A._code===b.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof N&&A._code===b.NoResolverFound}static isHandled(A){return A instanceof N&&A.isHandled}constructor(A,y=b.Unknown,P){super(A),this._message=A,this._code=y,this._detail=P,this.isHandled=y===b.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N}),define(Ie[60],Ce([1,0,13]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function I(P){return P.scheme===s.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=I;function b(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=b;function N(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=N;function _(P){const{host:R,port:E}=y(P);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:E}}e.parseAuthorityWithPort=_;function A(P,R){let{host:E,port:m}=y(P);return typeof m>"u"&&(m=R),{host:E,port:m}}e.parseAuthorityWithOptionalPort=A;function y(P){const R=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,60]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=N;function _(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,l){if(typeof a>"u"||a===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof a=="string"||typeof l=="string"){const f=typeof a=="string"?a:a.value,v=typeof l=="string"?l:l.value;return s.equalsIgnoreCase(f,v)}return a._lower===l._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=P;function R(p){return E(p)}e.isApplicationScopedExtension=R;function E(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function C(p,a){if(a){const l=`onResolveRemoteAuthority:${(0,b.getRemoteName)(a)}`;return p.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[154],Ce([1,0,10,84,26,20,2,12,47]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,s.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(r){const n=r.manifest?r.manifest.version:r.version,o=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new E(r.identifier,n,o)}static parse(r){const n=R.exec(r);return n&&n[1]&&n[2]?new E({id:n[1]},n[2],n[4]||void 0):null}constructor(r,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof E?P(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(h){const r=m.exec(h);return r&&r[1]?[a(r[1]),r[2]]:[a(h),void 0]}e.getIdAndVersion=C;function p(h,r){return`${h}.${r}`}e.getExtensionId=p;function a(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function l(h,r){return a(p(h,r))}e.getGalleryExtensionId=l;function f(h,r){const n=[],o=u=>{for(const i of n)if(i.some(c=>P(r(c),r(u))))return i;return null};for(const u of h){const i=o(u);i?i.push(u):n.push([u])}return n}e.groupByExtension=f;function v(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function w(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function d(h,r){const n=[],o=r.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&n.every(i=>!P(i.identifier,{id:u}))){const i=h.filter(c=>P(c.identifier,{id:u}));i.length===1&&(n.push(i[0]),o.push(...i[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=d;async function S(h,r){if(!N.isLinux)return!1;let n;try{n=(await h.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await h.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){r.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=S;async function t(h,r){const n=await S(h,r),o=(0,I.getTargetPlatform)(n?"alpine":N.platform,y.arch);return r.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Ie[155],Ce([1,0,20,47,2,38]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(P){if(s.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function A(P,R,E,m,C,p,a,l,f,v){const w=Object.create(null);w["common.machineId"]=a,w.sessionID=(0,N.generateUuid)()+Date.now(),w.commitHash=C,w.version=p,w["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,s.PlatformToString)(s.platform),w["common.nodePlatform"]=I.platform,w["common.nodeArch"]=m,w["common.product"]=v||"desktop",l&&(w["common.msftInternal"]=l);let d=0;const S=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),s.isLinuxSnap&&(w["common.snap"]="true");const t=_(E);t&&(w["common.platformDetail"]=t);try{const h=await P.readFile(b.URI.file(f));w["common.source"]=h.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=A;function y(P){const R=I.env.USERDNSDOMAIN;if(!R)return!1;const E=R.toLowerCase();return P.some(m=>E===m)}e.verifyMicrosoftInternalDomain=y}),define(Ie[156],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,s.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,s.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(I=e.TelemetryLevel||(e.TelemetryLevel={}));var b;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(b=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[157],Ce([1,0,25,114,9,45,155,156]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class P{async publicLog(n,o,u){}async publicLogError(n,o,u){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(r,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(o.source),configurationKeys:f(o.sourceConfig)})})}e.configurationTelemetry=R;function E(r,n){return!(n.disableTelemetry||!r.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=E;function m(r){const n=r.getValue(A.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function C(r){const n={},o={},u={};l(r,u);for(let i in u){i=i.length>150?i.substr(i.length-149):i;const c=u[i];typeof c=="number"?o[i]=c:typeof c=="boolean"?o[i]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${c.length}`),n[i]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(n[i]=c)}return{properties:n,measurements:o}}e.validateTelemetryData=C;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function a(r){if(!r)return"none";for(const n of p)if(r.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=a;function l(r,n,o=0,u){if(!!r)for(const i of Object.getOwnPropertyNames(r)){const c=r[i],g=u?u+i:i;Array.isArray(c)?n[g]=(0,s.safeStringify)(c):c instanceof Date?n[g]=c.toISOString():(0,b.isObject)(c)?o<2?l(c,n,o+1,g+"."):n[g]=(0,s.safeStringify)(c):n[g]=c}}function f(r){if(!r)return[];const n=[];return v(n,"",r),n}function v(r,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(u=>v(r,n?`${n}.${u}`:u,o[u])):r.push(n)}function w(r,n){const o=r.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,_.verifyMicrosoftInternalDomain)(o)||u}e.isInternalTelemetry=w;function d(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=d;function S(r,n){let o=r;const u=[];for(const T of n)for(;;){const F=T.exec(r);if(!F)break;u.push([F.index,T.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(o="";;){const T=c.exec(r);if(!T)break;!i.test(T[0])&&u.every(([F,j])=>T.index<F||T.index>=j)&&(o+=r.substring(g,T.index)+"<REDACTED: user-file-path>",g=c.lastIndex)}return g<r.length&&(o+=r.substr(g)),o}function t(r){if(!r)return r;const n=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of o)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return r}function h(r,n){return(0,s.cloneAndChange)(r,o=>{if(typeof o=="string"){let u=o;u=S(u,n);for(const i of n)u=u.replace(i,"");return u=t(u),u}})}e.cleanData=h}),define(Ie[158],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,N,_=5){const A=N(y=>{const P=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(b);if(R){R.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(b),_);R={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,R)});return A}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const N=this._terminalBufferMap.get(b);N&&(this._terminalBufferMap.delete(b),this._callback(b,N.data.join("")))}}e.TerminalDataBufferer=s}),define(Ie[159],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var s;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(s=e.ColorScheme||(e.ColorScheme={}));function I(N){return N===s.HIGH_CONTRAST_DARK||N===s.HIGH_CONTRAST_LIGHT}e.isHighContrast=I;function b(N){return N===s.DARK||N===s.HIGH_CONTRAST_DARK}e.isDark=b}),define(Ie[61],Ce([1,0,117,4,7,3,30,159]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var y;(function(l){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}l.isThemeColor=f})(y=e.ThemeColor||(e.ThemeColor={}));function P(l){return{id:l}}e.themeColorFromId=P;var R;(function(l){function f(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||y.isThemeColor(n.color))}l.isThemeIcon=f;const v=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function w(n){const o=v.exec(n);if(!o)return;const[,u]=o;return{id:u}}l.fromString=w;function d(n){return{id:n}}l.fromId=d;function S(n,o){let u=n.id;const i=u.lastIndexOf("~");return i!==-1&&(u=u.substring(0,i)),o&&(u=`${u}~${o}`),{id:u}}l.modify=S;function t(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}l.getModifier=t;function h(n,o){return n.id===o.id&&n.color?.id===o.color?.id}l.isEqual=h;function r(n,o){return{id:n.id,color:o?P(o):void 0}}l.asThemeIcon=r,l.asClassNameArray=s.CSSIcon.asClassNameArray,l.asClassName=s.CSSIcon.asClassName,l.asCSSSelector=s.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function E(l){switch(l){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,b.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const C=new m;_.Registry.add(e.Extensions.ThemingContribution,C);function p(l){return C.onColorThemeChange(l)}e.registerThemingParticipant=p;class a extends b.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let w=this.theme.getColor(f);return w&&v&&(w=v(w,this.theme)),w?w.toString():null}}e.Themable=a}),define(Ie[160],Ce([1,0,4,20,3,11]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var _;(function(a){a.Http="http",a.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=E;function m(a,l){return l?l!==1&&a<1024:!I.isWindows&&a<1024}e.isPortPrivileged=m;class C{constructor(l,f,v){this.remoteAddress=l,this.localAddress=f,this._dispose=v,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let p=class{constructor(l){this.logService=l,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l){return this._tunnelProvider=l,l?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],f=Array.from(this._tunnels.values());for(const v of f){const w=Array.from(v.values());for(const d of w){const S=await d.value;S&&l.push(S)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:f}of l.values())await f.then(v=>v?.dispose());l.clear()}this._tunnels.clear()}setEnvironmentTunnel(l,f,v,w,d){this.addTunnelToMap(l,f,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:f,localAddress:v,privacy:w,protocol:d,dispose:()=>Promise.resolve()}))}openTunnel(l,f,v,w,d=!1,S,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${w}.`),!l)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.retainOrCreateTunnel(l,f,v,w,d,S,t);return h?h.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const f=this._tunnels.get(l.tunnelRemoteHost);if(f){const v=f.get(l.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,v))}}}}async tryDisposeTunnel(l,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${f}.`);const w=v.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(f),w}}async closeTunnel(l,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${f} `);const v=this._tunnels.get(l);if(v&&v.has(f)){const w=v.get(f);w.refcount=0,await this.tryDisposeTunnel(l,f,w)}}addTunnelToMap(l,f,v){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(l,f){const v=this._tunnels.get(l);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,f){const v=[l];R(l)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):E(l)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const w=v.map(d=>this._tunnels.get(d));for(const d of w){const S=d?.get(f);if(S)return S}}canTunnel(l){return!!P(l)}doIsPortPrivileged(l,f,v,w){if(f)return!1;if(v){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(d?.length===4){const S=parseInt(d[1]),t=parseInt(d[2]);if(S>10||S===10&&t>=14)return!1}}return l<1024}createWithProvider(l,f,v,w,d,S,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${w}.`);const h=v;this._factoryInProgress.add(h);const r=w===void 0?v:w,n={elevationRequired:d?this.isPortPrivileged(r):!1},o={remoteAddress:{host:f,port:v},localAddressPort:w,privacy:S,public:S?S!==A.Private:void 0,protocol:t},u=l.forwardPort(o,n);return u?(this.addTunnelToMap(f,v,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(h)})):this._factoryInProgress.delete(h),u}};p=xe([$e(0,N.ILogService)],p),e.AbstractTunnelService=p}),define(Ie[161],Ce([1,0,13]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(y){return y.scheme!==s.Schemas.file&&y.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=I;function b(y){if(y.folders.length)return y.folders.every(P=>I(P.uri))?y.folders[0].uri:void 0;if(y.configuration&&I(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=b;function N(y){return b(y)?.scheme}e.getVirtualWorkspaceScheme=N;function _(y){return b(y)?.authority}e.getVirtualWorkspaceAuthority=_;function A(y){return b(y)!==void 0}e.isVirtualWorkspace=A}),define(Ie[48],Ce([1,0,129,19,24,22,2,3,13]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(h){const r=h;return typeof r?.id=="string"&&_.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(h,r){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,I.basename)(h)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=h;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=R;function E(h){const r=h;return typeof r?.id=="string"&&_.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=E;function m(h){const r=h;if(r?.uri)return{id:r.id,uri:_.URI.revive(r.uri)};const n=h;if(n?.configPath)return{id:n.id,configPath:_.URI.revive(n.configPath)};if(h?.id)return{id:h.id}}e.reviveIdentifier=m;var C;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function p(h){const r=h;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=p;function a(h){const r=h;return!!(r&&typeof r=="object"&&_.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class l{constructor(r,n,o,u,i){this._id=r,this._transient=o,this._configuration=u,this._ignorePathCasing=i,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class f{constructor(r,n){this.raw=n,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,N.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(h){return new f({uri:h,index:0,name:(0,N.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(h,r){return N.extUriBiasedIgnorePathCase.isEqualOrParent(h,r.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function d(h){let r;return _.URI.isUri(h)?r=h:r=h.configuration,r?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=d;function S(h,r){return!w(h,r)&&!d(h)}e.isSavedWorkspace=S;function t(h){return(typeof h=="string"?(0,I.extname)(h):(0,N.extname)(h))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ie[62],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const N=this._idPool++;return this._data.set(N,b),this.logDebugInfo(),N}get(b,N){return this._data.has(b)?this._data.get(b)[N]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(Ie[36],Ce([1,0,13,22,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(Ie[162],Ce([1,0,15]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(_,A,y){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const E of P.values())E.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let y=this._value[_];return typeof y>"u"&&(y=A),y}update(_,A){this._value[_]=A;const y=this._deferredPromises.get(_);if(y!==void 0)return y.p;const P=new s.DeferredPromise;return this._deferredPromises.set(_,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class b extends I{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}}e.ExtensionGlobalMemento=b}),define(Ie[163],Ce([1,0,4,2]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new s.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,y,P){const E=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(_)).acceptModelChanged(A.value,y,P);this._onDidChangeNotebookDocument.fire(E)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(Ie[14],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class I{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=I});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[164],Ce([1,0,26,4]),function(ne,e,s,I){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(A,y){b.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(A.identifier),Ye(this,b,y,"f"),Oe(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,b,"f").get(this._id,A)}store(A,y){return Oe(this,b,"f").store(this._id,A,y)}delete(A){return Oe(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=N,b=new WeakMap}),define(Ie[63],Ce([1,0,3,160,4,14]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(y){function P(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:E.protocol}}y.fromApiTunnel=P;function R(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==I.TunnelPrivacyId.ConstantPrivate&&E.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}y.fromServiceTunnel=R})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,E,m,C){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=xe([$e(0,N.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[49],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class I{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=I}),define(Ie[165],Ce([1,0,23]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function b(A,y){if(y.serializeBuffersForPostMessage){const P=new I,R=(C,p)=>{if(p instanceof ArrayBuffer){const a=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(p)){const a=N(p);if(a){const l=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:l,view:{type:a,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},E=JSON.stringify(A,R),m=P.buffers.map(C=>{const p=new Uint8Array(C);return s.VSBuffer.wrap(p)});return{message:E,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function N(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,y){const P=y.map(m=>{const C=new ArrayBuffer(m.byteLength);return new Uint8Array(C).set(m.buffer),C}),R=y.length?(m,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const p=C,{index:a}=p,l=P[a];if(p.view)switch(p.view.type){case 1:return new Int8Array(l,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return C}:void 0;return{message:JSON.parse(A,R),arrayBuffers:P}}e.deserializeWebviewMessage=_}),define(Ie[90],Ce([1,0,137,9,2,7,3,30,35,13]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const te=G;return!!te&&typeof te.getSelection=="function"&&!!te.onDidChangeSelection}e.isEditorPaneWithSelection=m;function C(G,te,he){for(const re of he.visibleEditorPanes)if(re.group.id===te&&G.matches(re.input))return re.getViewState()}e.findViewStateForEditor=C;function p(G){if(o(G))return!1;const te=G;return b.URI.isUri(te?.resource)}e.isResourceEditorInput=p;function a(G){if(o(G))return!1;const te=G;return te?.original!==void 0&&te.modified!==void 0}e.isResourceDiffEditorInput=a;function l(G){if(o(G)||a(G))return!1;const te=G;return te?.primary!==void 0&&te.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function f(G){if(o(G))return!1;const te=G;return te?te.resource===void 0||te.resource.scheme===P.Schemas.untitled||te.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const v=/Untitled-\d+/;function w(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!v.test(G.path)}e.isUntitledWithAssociatedResource=w;function d(G){if(o(G))return!1;const te=G;return b.URI.isUri(te?.base?.resource)&&b.URI.isUri(te?.input1?.resource)&&b.URI.isUri(te?.input2?.resource)&&b.URI.isUri(te?.result?.resource)}e.isResourceMergeEditorInput=d;var S;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var t;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t=e.SaveReason||(e.SaveReason={}));class h{constructor(){this.mapIdToSaveSource=new Map}registerSource(te,he){let re=this.mapIdToSaveSource.get(te);return re||(re={source:te,label:he},this.mapIdToSaveSource.set(te,re)),re.source}getSourceLabel(te){return this.mapIdToSaveSource.get(te)?.label??te}}e.SaveSourceRegistry=new h;var r;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends N.Disposable{}e.AbstractEditorInput=n;function o(G){return G instanceof n}e.isEditorInput=o;function u(G){const te=G;return b.URI.isUri(te?.preferredResource)}function i(G){const te=G;return o(te?.primary)&&o(te?.secondary)}e.isSideBySideEditorInput=i;function c(G){const te=G;return o(te?.modified)&&o(te?.original)}e.isDiffEditorInput=c;function g(G){return o(G?.editor)}e.isEditorInputWithOptions=g;function T(G){const te=G;return g(G)&&te?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function F(G){const te=G;return typeof te?.groupId=="number"&&o(te.editor)}e.isEditorIdentifier=F;var j;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var D;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(D=e.SideBySideEditor||(e.SideBySideEditor={}));class x{getOriginalUri(te,he){if(!te)return;if(d(te))return e.EditorResourceAccessor.getOriginalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===D.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===D.ANY)return this.getOriginalUri(be,{filterByScheme:he.filterByScheme})??this.getOriginalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===D.PRIMARY?be:le}}if(a(te)||l(te)||d(te))return;const re=u(te)?te.preferredResource:te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}getSideEditors(te){return i(te)||l(te)?{primary:te.primary,secondary:te.secondary}:c(te)||a(te)?{primary:te.modified,secondary:te.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(te,he){if(!te)return;if(d(te))return e.EditorResourceAccessor.getCanonicalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===D.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===D.ANY)return this.getCanonicalUri(be,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===D.PRIMARY?be:le}}if(a(te)||l(te)||d(te))return;const re=te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}filterUri(te,he){if(Array.isArray(he)){if(he.some(re=>te.scheme===re))return te}else if(he===te.scheme)return te}}e.EditorResourceAccessor=new x;var M;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(te){const he=this.instantiationService=te.get(_.IInstantiationService);for(const[re,be]of this.editorSerializerConstructors)this.createEditorSerializer(re,be,he);this.editorSerializerConstructors.clear()}createEditorSerializer(te,he,re){const be=re.createInstance(he);this.editorSerializerInstances.set(te,be)}registerFileEditorFactory(te){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=te}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(te,he){if(this.editorSerializerConstructors.has(te)||this.editorSerializerInstances.has(te))throw new Error(`A editor serializer with type ID '${te}' was already registered.`);return this.instantiationService?this.createEditorSerializer(te,he,this.instantiationService):this.editorSerializerConstructors.set(te,he),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(te),this.editorSerializerInstances.delete(te)})}getEditorSerializer(te){return this.editorSerializerInstances.get(typeof te=="string"?te:te.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new O);async function H(G,te){return!G||!G.length?[]:await Promise.all(G.map(async he=>{const re=b.URI.revive(he.fileUri);if(!re||!await te.canHandleResource(re))return;let le=he.exists,fe=he.type;if(typeof le!="boolean"||typeof fe!="number")try{fe=(await te.stat(re)).isDirectory?y.FileType.Directory:y.FileType.Unknown,le=!0}catch{le=!1}if(!le&&he.openOnlyIfExists||fe===y.FileType.Directory)return;const Q={...he.options,pinned:!0};return le?{resource:re,options:Q}:{resource:re,options:Q,forceUntitled:!0}}))}e.pathsToEditors=H;var W;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function z(G){const te=G;if(!te)return!1;const he=te;if(he.modified)return z(he.modified);const re=te;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=z}),define(Ie[64],Ce([1,0,13,2]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(A,y){return A.scheme===s.Schemas.http||A.scheme===s.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===s.Schemas.file&&(A=I.URI.from({scheme:s.Schemas.vscodeRemote,authority:y.authority,path:A.path})),I.URI.from({scheme:s.Schemas.https,authority:`${A.scheme}+${N(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function N(A){return A.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=_}),define(Ie[166],Ce([1,0,4,7,64]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(A,y,P){this._proxy=A,this._editors=y,this._remoteInfo=P,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const E of this._insets.values())R.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,P,R,E){let m;for(const w of this._editors.getVisibleTextEditors(!0))if(w.value===A){m=w;break}if(!m)throw new Error("not a visible editor");const C=this,p=this._handlePool++,a=new s.Emitter,l=new s.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(w){return(0,b.asWebviewUri)(w,C._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(w){this._options=w,C._proxy.$setOptions(p,w)}get options(){return this._options}set html(w){this._html=w,C._proxy.$setHtml(p,w)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(w){return C._proxy.$postMessage(p,w)}},v=new class{constructor(){this.editor=A,this.line=y,this.height=P,this.webview=f,this.onDidDispose=l.event}dispose(){C._insets.has(p)&&(C._insets.delete(p),C._proxy.$disposeEditorInset(p),l.fire(),l.dispose(),a.dispose())}};return this._proxy.$createEditorInset(p,m.id,m.value.document.uri,y+1,P,R||{},E.identifier,E.extensionLocation),this._insets.set(p,{editor:A,inset:v,onDidReceiveMessage:a}),v}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=N}),define(Ie[167],Ce([1,0,4,15,138]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,P,R){const E={command:A};if(y&&Object.keys(y).length>0&&(E.arguments=y),this.internalSend("request",E),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const C=this.pendingRequests.get(E.seq);if(C){this.pendingRequests.delete(E.seq);const p={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,b.localize)(0,null,R,A)};C(p)}},R)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,P)=>A.set(P,y)),await(0,I.timeout)(500),A.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Ie[168],Ce([1,0,139,40,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:s.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:s.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:s.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:s.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:s.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:s.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:s.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:s.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:s.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:s.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:s.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:s.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:s.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:s.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:s.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:s.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:s.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:s.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:s.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:s.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:s.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:s.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:s.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new I.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:s.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:s.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:s.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:s.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(50,null)});const N=m=>s.localize(51,null,m);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var E;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[169],Ce([1,0,10,2,19,25,13]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(r,n,o){return r.replace(A,function(u,i){return n&&i.length>0&&i[0]!=="_"?u:o&&o.hasOwnProperty(i)?o[i]:u})}e.formatPII=y;function P(r){const n={};for(const o of Object.keys(r))o.startsWith("!")||(n[o]=r[o]);return n}e.filterExceptionsFromTelemetry=P;function R(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function E(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(n,"extensionhost")||(0,s.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function m(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=m;function C(r,n,o){let u,i=0;const c=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=c.exec(r);){const T=g.index+1,F=T+g[0].length;if(T<=n&&F>=o){u=g[0],i=T;break}}if(u){const T=/\w+/g;let F=null;for(;(F=T.exec(u))&&!(F.index+1+i+F[0].length>=o););F&&(u=u.substring(0,T.lastIndex))}return u?{start:i,end:i+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(r){return!!(r&&r.match(p))}e.isUri=a;function l(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(a(r.path))return I.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return I.URI.file(r.path)}return r.path}function f(r){if(typeof r.path=="object"){const n=I.URI.revive(r.path);if(n)return n.scheme===_.Schemas.file?n.fsPath:n.toString()}return r.path}function v(r,n){const o=n?l:f,u=(0,N.deepClone)(r);return d(u,(i,c)=>{i&&c&&(c.path=o(c))}),u}e.convertToDAPaths=v;function w(r,n){const o=n?l:f,u=(0,N.deepClone)(r);return d(u,(i,c)=>{!i&&c&&(c.path=o(c))}),u}e.convertToVSCPaths=w;function d(r,n){switch(r.type){case"event":{const o=r;switch(o.event){case"output":n(!1,o.body.source);break;case"loadedSource":n(!1,o.body.source);break;case"breakpoint":n(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=r;switch(o.command){case"setBreakpoints":n(!0,o.arguments.source);break;case"breakpointLocations":n(!0,o.arguments.source);break;case"source":n(!0,o.arguments.source);break;case"gotoTargets":n(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(u=>n(!1,u));break;default:break}break}case"response":{const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>n(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>n(!1,u));break;case"scopes":o.body.scopes.forEach(u=>n(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>n(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>n(!1,u.source));break;case"disassemble":o.body?.instructions.forEach(i=>n(!1,i.location));break;default:break}break}}}function S(r){return r.filter(n=>!n.presentation?.hidden).sort((n,o)=>n.presentation?o.presentation?n.presentation.group?o.presentation.group?n.presentation.group!==o.presentation.group?n.presentation.group.localeCompare(o.presentation.group):t(n.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(n.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=S;function t(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function h(r,n){const o=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(o!=="none"&&(await n.saveAll(),o==="allEditorsInActiveGroup")){const u=n.activeEditorPane;u&&u.input.resource?.scheme===_.Schemas.untitled&&await n.save({editor:u.input,groupId:u.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[65],Ce([1,0,23,34,170,78,13,19,20,40]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(H){H[H.WithHardKernelDependency=0]="WithHardKernelDependency",H[H.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",H[H.Pure=2]="Pure",H[H.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(H){H.Always="always",H.Never="never",H.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(H){H[H.ModelChange=1]="ModelChange",H[H.Move=2]="Move",H[H.ChangeCellLanguage=5]="ChangeCellLanguage",H[H.Initialize=6]="Initialize",H[H.ChangeCellMetadata=7]="ChangeCellMetadata",H[H.Output=8]="Output",H[H.OutputItem=9]="OutputItem",H[H.ChangeCellContent=10]="ChangeCellContent",H[H.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",H[H.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",H[H.ChangeCellMime=13]="ChangeCellMime",H[H.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(H){H[H.Handle=0]="Handle",H[H.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(H){H[H.Replace=1]="Replace",H[H.Output=2]="Output",H[H.Metadata=3]="Metadata",H[H.CellLanguage=4]="CellLanguage",H[H.DocumentMetadata=5]="DocumentMetadata",H[H.Move=6]="Move",H[H.OutputItems=7]="OutputItems",H[H.PartialMetadata=8]="PartialMetadata",H[H.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(H){H.scheme=_.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${W.join("")}]+`),G=7;function te(Q,pe){const Se=pe.toString(G),Ue=`${Se.length<W.length?W[Se.length-1]:"z"}${Se}s${(0,s.encodeBase64)(s.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:H.scheme,fragment:Ue})}H.generate=te;function he(Q){if(Q.scheme!==H.scheme)return;const pe=Q.fragment.indexOf("s");if(pe<0)return;const Se=parseInt(Q.fragment.substring(0,pe).replace(z,""),G),Fe=(0,s.decodeBase64)(Q.fragment.substring(pe+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Q.with({scheme:Fe,fragment:null})}}H.parse=he;function re(Q,pe){return Q.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Q.scheme!==_.Schemas.file?Q.scheme:""}`})}H.generateCellOutputUri=re;function be(Q){if(Q.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!pe)return;const Se=pe[1]&&pe[1]!==""?pe[1]:void 0,Fe=pe[2];return{outputId:Se,notebook:Q.with({scheme:Fe||_.Schemas.file,fragment:null})}}H.parseCellOutputUri=be;function le(Q,pe,Se){return H.generate(Q,pe).with({scheme:Se})}H.generateCellPropertyUri=le;function fe(Q,pe){if(Q.scheme===pe)return H.parse(Q.with({scheme:H.scheme}))}H.parseCellPropertyUri=fe})(v=e.CellUri||(e.CellUri={}));const w=H=>y.isWindows?H.replace(/\//g,"\\"):H;class d{constructor(W=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set(W)].map(G=>({pattern:G,matches:I.parse(w(G))}))}sort(W){const z=new Map(b.Iterable.map(W,te=>[te,w(te)]));let G=[];for(const{matches:te}of this.order)for(const[he,re]of z)if(te(re)){G.push(he),z.delete(he);break}return z.size&&(G=G.concat([...z.keys()].sort((te,he)=>this.defaultOrder.indexOf(te)-this.defaultOrder.indexOf(he)))),G}prioritize(W,z){const G=this.findIndex(W);if(G===-1){this.order.unshift({pattern:W,matches:I.parse(w(W))});return}const te=new Set(z.map(re=>this.findIndex(re,G)));te.delete(-1);const he=Array.from(te).sort();this.order.splice(G+1,0,...he.map(re=>this.order[re]));for(let re=he.length-1;re>=0;re--)this.order.splice(he[re],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,z=this.order.length){const G=w(W);for(let te=0;te<z;te++)if(this.order[te].matches(G))return te;return-1}}e.MimeTypeDisplayOrder=d;function S(H,W,z,G=(te,he)=>te===he){const te=[];function he(le,fe,Q){if(fe===0&&Q.length===0)return;const pe=te[te.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=fe,pe.toInsert.push(...Q)):te.push({start:le,deleteCount:fe,toInsert:Q})}let re=0,be=0;for(;;){if(re===H.length){he(re,0,W.slice(be));break}if(be===W.length){he(re,H.length-re,[]);break}const le=H[re],fe=W[be];if(G(le,fe)){re+=1,be+=1;continue}z(fe)?(he(re,1,[]),re+=1):(he(re,0,[fe]),be+=1)}return te}e.diff=S,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(H){H.default="default",H.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function h(H){const W=H;return!!((typeof W.include=="string"||I.isRelativePattern(W.include))&&(typeof W.exclude=="string"||I.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=h;function r(H,W,z){if(Array.isArray(H.viewType)&&H.viewType.indexOf(W)>=0||H.viewType===W)return!0;if(H.filenamePattern){const G=h(H.filenamePattern)?H.filenamePattern.include:H.filenamePattern,te=h(H.filenamePattern)?H.filenamePattern.exclude:void 0;if(I.match(G,(0,A.basename)(z.fsPath).toLowerCase()))return!(te&&I.match(te,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(W){return`${o._prefix}${W}`}static parse(W){if(W.startsWith(o._prefix))return W.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function u(H){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(H)}e.isTextStreamMime=u;const i=new TextDecoder;function c(H){const W=[];let z=!1;for(const G of H)(W.length===0||z)&&(W.push(G),z=!0);return j(W),O(s.VSBuffer.concat(W.map(G=>s.VSBuffer.wrap(G))))}e.compressOutputItemStreams=c;const g=`${String.fromCharCode(27)}[A`,T=g.split("").map(H=>H.charCodeAt(0)),F=10;function j(H){H.forEach((W,z)=>{if(z===0||W.length<g.length)return;const G=H[z-1],te=W.subarray(0,g.length);if(te[0]===T[0]&&te[1]===T[1]&&te[2]===T[2]){const he=G.lastIndexOf(F);if(he===-1)return;H[z-1]=G.subarray(0,he),H[z]=W.subarray(g.length)}})}function U(H){let W=H;do H=W,W=H.replace(/[^\n]\x08/gm,"");while(W.length<H.length);return H}function D(H){for(H=H.replace(/\r+\n/gm,`
`);H.search(/\r[^$]/g)>-1;){const W=H.match(/^(.*)\r+/m)[1];let z=H.match(/\r+(.*)$/m)[1];z=z+W.slice(z.length,W.length),H=H.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return H}const x="\b".charCodeAt(0),M="\r".charCodeAt(0);function O(H){return!H.buffer.includes(x)&&!H.buffer.includes(M)?H:s.VSBuffer.fromString(D(U(i.decode(H.buffer))))}}),define(Ie[171],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(Ie[172],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=s;function I(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=I;function b(_){return Array.from(_.entries()).map(A=>[A[0],s(A[1].map)])}e.serializeEnvironmentVariableCollections=b;function N(_){return new Map(_.map(A=>[A[0],{map:I(A[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ie[41],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(N){N.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class b{static fromExtHostTestItem(_,A,y=_.parent){if(_._isRoot)return new b([A]);const P=[_.id];for(let R=y;R&&R.id!==A;R=R.parent)P.push(R.id);return P.push(A),new b(P.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new b(_.split("\0"))}static join(_,A){return new b([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static parentId(_){const A=_.lastIndexOf("\0");return A===-1?void 0:_.slice(0,A)}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new b(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new b(this.path,_)}compare(_){if(typeof _=="string")return b.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=b}),define(Ie[50],Ce([1,0,2,51,41]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var _;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(i){i.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),i.deserialize=c=>({range:I.Range.lift(c.range),uri:s.URI.revive(c.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var P;(function(i){i.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&A.serialize(c.location)}),i.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&A.deserialize(c.location)})})(P=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(i,c)=>`${c?"s":"e"}${i}`;e.getMarkId=R;var E;(function(i){i.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&A.serialize(c.location)}),i.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&A.deserialize(c.location)})})(E=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(i){i.serialize=c=>c.type===0?P.serialize(c):E.serialize(c),i.deserialize=c=>c.type===0?P.deserialize(c):E.deserialize(c)})(m=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),i.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(m.serialize)}),i.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(m.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",a=(i,c)=>i+p+c;e.namespaceTestTag=a;const l=i=>{const c=i.indexOf(p);return{ctrlId:i.slice(0,c),tagId:i.slice(c+1)}};e.denamespaceTestTag=l;var f;(function(i){i.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),i.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?s.URI.revive(c.uri):void 0,range:c.range?I.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var w;(function(i){i.serialize=c=>({expand:c.expand,item:f.serialize(c.item)}),i.deserialize=c=>({controllerId:b.TestId.root(c.item.extId),expand:c.expand,item:f.deserialize(c.item)})})(w=e.InternalTestItem||(e.InternalTestItem={}));var d;(function(i){i.serialize=c=>{let g;return c.item&&(g={},c.item.label!==void 0&&(g.label=c.item.label),c.item.tags!==void 0&&(g.tags=c.item.tags),c.item.busy!==void 0&&(g.busy=c.item.busy),c.item.uri!==void 0&&(g.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(g.range=c.item.range?.toJSON()),c.item.description!==void 0&&(g.description=c.item.description),c.item.error!==void 0&&(g.error=c.item.error),c.item.sortText!==void 0&&(g.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:g}},i.deserialize=c=>{let g;return c.item&&(g={},c.item.label!==void 0&&(g.label=c.item.label),c.item.tags!==void 0&&(g.tags=c.item.tags),c.item.busy!==void 0&&(g.busy=c.item.busy),c.item.range!==void 0&&(g.range=c.item.range?I.Range.lift(c.item.range):null),c.item.description!==void 0&&(g.description=c.item.description),c.item.error!==void 0&&(g.error=c.item.error),c.item.sortText!==void 0&&(g.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:g}}})(d=e.ITestItemUpdate||(e.ITestItemUpdate={}));const S=(i,c)=>{c.expand!==void 0&&(i.expand=c.expand),c.item!==void 0&&(i.item=i.item?Object.assign(i.item,c.item):c.item)};e.applyTestItemUpdate=S;var t;(function(i){i.serializeWithoutMessages=c=>({...w.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(C.serializeWithoutMessages),retired:c.retired}),i.serialize=c=>({...w.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(C.serialize),retired:c.retired}),i.deserialize=c=>({...w.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(C.deserialize),retired:!0})})(t=e.TestResultItem||(e.TestResultItem={}));var h;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(h=e.DetailType||(e.DetailType={}));var r;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(i){i.deserialize=c=>c.op===0?{op:c.op,item:w.deserialize(c.item)}:c.op===1?{op:c.op,item:d.deserialize(c.item)}:c.op===2?{op:c.op,uri:s.URI.revive(c.uri),docv:c.docv}:c,i.serialize=c=>c.op===0?{op:c.op,item:w.serialize(c.item)}:c.op===1?{op:c.op,item:d.serialize(c.item)}:c})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(c){}update(c){}remove(c,g){}complete(){}}e.IncrementalChangeCollector=o;class u{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const g=this.createChangeCollector();for(const T of c)switch(T.op){case 0:{const F=w.deserialize(T.item),j=b.TestId.parentId(F.item.extId)?.toString();if(j){if(this.items.has(j)){const U=this.items.get(j);U.children.add(F.item.extId);const D=this.createItem(F,U);this.items.set(F.item.extId,D),g.add(D)}}else{const U=this.createItem(F);this.roots.add(U),this.items.set(F.item.extId,U),g.add(U)}F.expand===2&&this.busyControllerCount++;break}case 1:{const F=d.deserialize(T.item),j=this.items.get(F.extId);if(!j)break;F.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,F.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,F),g.update(j);break}case 3:{const F=this.items.get(T.itemId);if(!F)break;const j=b.TestId.parentId(F.item.extId)?.toString();j?this.items.get(j).children.delete(F.item.extId):this.roots.delete(F);const U=[[T.itemId]];for(;U.length;)for(const D of U.pop()){const x=this.items.get(D);x&&(U.push(x.children),this.items.delete(D),g.remove(x,x!==F),x.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this._tags.set(T.tag.id,T.tag);break;case 7:this._tags.delete(T.id);break}g.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=u}),define(Ie[66],Ce([1,0,15,4,7,46,50,41]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(f,v)=>f===v,R={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(f,v)=>!(f.length!==v.length||f.some(w=>!v.includes(w)))},E=(f,v)=>{let w;for(const[d,S]of Object.entries(R))S(f[d],v[d])||(w?w[d]=v[d]:w={[d]:v[d]});return w};class m extends b.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const w of this.diff)if(w.op===2&&w.uri===v.uri){w.docv=v.docv;return}break}case 1:{const w=this.diff[this.diff.length-1];if(w){if(w.op===1&&w.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(w.item,v.item);return}if(w.op===0&&w.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(w.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,w){const d=this.tree.get(v);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const S=this.resolveChildren(d);return S.isOpen()?this.expandChildren(d,w-1):S.wait().then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,w){switch(w.op){case 3:this.removeItem(A.TestId.joinToString(v.fullId,w.id));break;case 0:this.upsertItem(w.item,v);break;case 5:for(const d of w.ops)this.onTestItemEvent(v,d);break;case 1:this.diffTagRefs(w.new,w.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:w.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,N.assertNever)(w)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,w){const d=A.TestId.fromExtHostTestItem(v,this.root.id,w?.actual),S=this.options.getApiFor(v);S.parent&&S.parent!==w?.actual&&this.options.getChildren(S.parent).delete(v.id);let t=this.tree.get(d.toString());if(!t){t={fullId:d,actual:v,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(v,w),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,t,w);return}if(t.actual===v){this.connectItem(v,t,w);return}const h=this.options.getChildren(t.actual),r=t.actual,n=E(this.options.toITestItem(r),this.options.toITestItem(v));this.options.getApiFor(r).listener=void 0,t.actual=v,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,r.tags,d.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(v,t,w);for(const[o,u]of h)this.options.getChildren(v).get(u.id)||this.removeItem(A.TestId.joinToString(d,u.id));this.documentSynced(t.actual.uri)}diffTagRefs(v,w,d){const S=new Set(w.map(t=>t.id));for(const t of v)S.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:d,item:{tags:v.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),S.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const w=this.tags.get(v.id);w?w.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const w=this.tags.get(v);w&&!--w.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,w){this.options.getApiFor(v).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(v,w,d){this.setItemParent(v,d);const S=this.options.getApiFor(v);S.parent=d?.actual,S.listener=t=>this.onTestItemEvent(w,t),this.updateExpandability(w)}connectItemAndChildren(v,w,d){this.connectItem(v,w,d);for(const[S,t]of this.options.getChildren(v))this.upsertItem(t,w)}updateExpandability(v){let w;this._resolveHandler?v.resolveBarrier?w=v.resolveBarrier.isOpen()?3:2:w=v.actual.canResolveChildren?1:0:w=0,w!==v.expand&&(v.expand=w,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:w}}),w===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,w){if(w<0)return;const d=[];for(const[S,t]of this.options.getChildren(v.actual)){const h=this.expand(A.TestId.joinToString(v.fullId,t.id),w);(0,s.isThenable)(h)&&d.push(h)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const t=new s.Barrier;return t.open(),t}v.expand=2,this.pushExpandStateUpdate(v);const w=v.resolveBarrier=new s.Barrier,d=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let S;try{S=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(t){d(t)}return(0,s.isThenable)(S)?S.catch(d).then(()=>{w.open(),this.updateExpandability(v)}):(w.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const w=this.tree.get(v);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const d=[w];for(;d.length;){const S=d.pop();if(!!S){this.options.getApiFor(S.actual).listener=void 0;for(const t of S.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(S.fullId.toString());for(const[t,h]of this.options.getChildren(S.actual))d.push(this.tree.get(A.TestId.joinToString(S.fullId,h.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class C extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=C;class p extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class a extends Error{constructor(v,w,d){super(`TestItem with ID "${v}" is from controller "${w}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=a;const l=(f,v,w)=>{let d=new Map;return{get size(){return d.size},forEach(S,t){for(const h of d.values())S.call(t,h,this)},[Symbol.iterator](){return d.entries()},replace(S){const t=new Map,h=new Set(d.keys()),r={op:5,ops:[]};for(const n of S){if(!(n instanceof w))throw new p(n.id);const o=v(n).controllerId;if(o!==f.controllerId)throw new a(n.id,o,f.controllerId);if(t.has(n.id))throw new C(n.id);t.set(n.id,n),h.delete(n.id),r.ops.push({op:0,item:n})}for(const n of h.keys())r.ops.push({op:3,id:n});f.listener?.(r),d=t},add(S){if(!(S instanceof w))throw new p(S.id);d.set(S.id,S),f.listener?.({op:0,item:S})},delete(S){d.delete(S)&&f.listener?.({op:3,id:S})},get(S){return d.get(S)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=l}),define(Ie[91],Ce([1,0,66]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const I=new WeakMap,b=(_,A)=>{const y={controllerId:A};return I.set(_,y),y};e.createPrivateApiFor=b;const N=_=>{const A=I.get(_);if(!A)throw new s.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=N}),define(Ie[173],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,s.createDecorator)("configurationResolverService");var I;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(I=e.VariableKind||(e.VariableKind={}));class b extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=b}),define(Ie[174],Ce([1,0,19,47,9,25,20,81,142,173,10]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(C,p,a,l){this._contributedVariables=new Map,this._context=C,this._labelService=p,this._userHomePromise=a,l&&(this._envVariablesPromise=l.then(f=>this.prepareEnv(f)))}prepareEnv(C){if(_.isWindows){const p=Object.create(null);return Object.keys(C).forEach(a=>{p[a.toLowerCase()]=C[a]}),p}return C}resolveWithEnvironment(C,p,a){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},p?p.uri:void 0,a)}async resolveAsync(C,p){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,C?C.uri:void 0,p)}async resolveAnyBase(C,p,a,l){const f=N.deepClone(p);_.isWindows&&f.windows?Object.keys(f.windows).forEach(w=>f[w]=f.windows[w]):_.isMacintosh&&f.osx?Object.keys(f.osx).forEach(w=>f[w]=f.osx[w]):_.isLinux&&f.linux&&Object.keys(f.linux).forEach(w=>f[w]=f.linux[w]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,C?C.uri:void 0,f,a,l)}async resolveAnyAsync(C,p,a){return this.resolveAnyBase(C,p,a)}async resolveAnyMap(C,p,a){const l=new Map;return{newConfig:await this.resolveAnyBase(C,p,a,l),resolvedVariables:l}}resolveWithInteractionReplace(C,p,a,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,p,a,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,p){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,p)}async recursiveResolve(C,p,a,l,f){if(b.isString(a))return this.resolveString(C,p,a,l,f);if(Array.isArray(a))return Promise.all(a.map(v=>this.recursiveResolve(C,p,v,l,f)));if(b.isObject(a)){const v=Object.create(null),w=await Promise.all(Object.keys(a).map(async d=>[await this.resolveString(C,p,d,l,f),await this.recursiveResolve(C,p,a[d],l,f)]));for(const[d,S]of w)v[d]=S;return v}return a}resolveString(C,p,a,l,f){return(0,R.replaceAsync)(a,E.VARIABLE_REGEXP,async(v,w)=>{if(w.includes(E.VARIABLE_LHS))return v;let d=await this.evaluateSingleVariable(C,v,w,p,l);return f?.set(w,d),d!==v&&b.isString(d)&&d.match(E.VARIABLE_REGEXP)&&(d=await this.resolveString(C,p,d,l,f)),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,p,a,l,f){let v;const w=a.split(":");w.length>1&&(a=w[0],v=w[1]);const d=h=>{const r=this._context.getFilePath();if(r)return r;throw new P.VariableError(h,(0,y.localize)(0,null,p))},S=h=>{const r=d(h);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new P.VariableError(h,(0,y.localize)(1,null,p,s.basename(r)))},t=h=>{if(v){const r=this._context.getFolderUri(v);if(r)return r;throw new P.VariableError(h,(0,y.localize)(2,null,p,v))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(h,(0,y.localize)(3,null,p)):new P.VariableError(h,(0,y.localize)(4,null,p))};switch(a){case"env":if(v){if(C.env){const h=C.env[_.isWindows?v.toLowerCase():v];if(b.isString(h))return h}return""}throw new P.VariableError(P.VariableKind.Env,(0,y.localize)(5,null,p));case"config":if(v){const h=this._context.getConfigurationValue(l,v);if(b.isUndefinedOrNull(h))throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(6,null,p,v));if(b.isObject(h))throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(7,null,p,v));return h}throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(8,null,p));case"command":return this.resolveFromMap(P.VariableKind.Command,p,v,f,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,p,v,f,"input");case"extensionInstallFolder":if(v){const h=await this._context.getExtension(v);if(!h)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,p,v));return this.fsPath(h.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,p));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.WorkspaceFolder)));case"cwd":return l||v?(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(t(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(C.userHome)return C.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,y.localize)(11,null,p))}case"lineNumber":{const h=this._context.getLineNumber();if(h)return h;throw new P.VariableError(P.VariableKind.LineNumber,(0,y.localize)(12,null,p))}case"selectedText":{const h=this._context.getSelectedText();if(h)return h;throw new P.VariableError(P.VariableKind.SelectedText,(0,y.localize)(13,null,p))}case"file":return d(P.VariableKind.File);case"fileWorkspaceFolder":return S(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||v?s.relative(this.fsPath(t(P.VariableKind.RelativeFile)),d(P.VariableKind.RelativeFile)):d(P.VariableKind.RelativeFile);case"relativeFileDirname":{const h=s.dirname(d(P.VariableKind.RelativeFileDirname));if(l||v){const r=s.relative(this.fsPath(t(P.VariableKind.RelativeFileDirname)),h);return r.length===0?".":r}return h}case"fileDirname":return s.dirname(d(P.VariableKind.FileDirname));case"fileExtname":return s.extname(d(P.VariableKind.FileExtname));case"fileBasename":return s.basename(d(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=s.basename(d(P.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-s.extname(h).length)}case"fileDirnameBasename":return s.basename(s.dirname(d(P.VariableKind.FileDirnameBasename)));case"execPath":{const h=this._context.getExecPath();return h||p}case"execInstallFolder":{const h=this._context.getAppRoot();return h||p}case"pathSeparator":return s.sep;default:try{const h=v?`${a}:${v}`:a;return this.resolveFromMap(P.VariableKind.Unknown,p,h,f,void 0)}catch{return p}}}}resolveFromMap(C,p,a,l,f){if(a&&l){const v=f===void 0?l[a]:l[f+":"+a];if(typeof v=="string")return v;throw new P.VariableError(C,(0,y.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[92],Ce([1,0,3,90]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var b;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var N;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const a=p;return(0,I.isEditorInput)(a?.editor)&&(0,I.isEditorInput)(a?.replacement)}e.isEditorReplacement=P;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function m(p){const a=p;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=m;function C(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(Ie[175],Ce([1,0,3,92]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(N){const _=N;return typeof N=="number"||(0,I.isEditorGroup)(_)}e.isPreferredGroup=b}),define(Ie[176],Ce([1,0,3,147]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(I.IEnvironmentService)}),define(Ie[177],Ce([1,0,26,4,19]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=N;class _{constructor(E){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=E,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const E of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(E.identifier),E),this._extensionsArr.push(E),Array.isArray(E.activationEvents))for(let m of E.activationEvents)m==="onUri"&&(m=`onUri:${s.ExtensionIdentifier.toKey(E.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(E)}}set(E){this._extensionDescriptions=E,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(E,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(E);const C=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,C.map(p=>p.identifier)),this._initialize(),this._onDidChange.fire(void 0),new N(C)}static _findLoopingExtensions(E){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const w=m.getArcs(f);for(let d=0;d<w.length;d++)if(!v.has(w[d]))return!1;return!0}getNodes(){return this._nodesArr}},C=new Map;for(const f of E){const v=s.ExtensionIdentifier.toKey(f.identifier);if(C.set(v,f),f.extensionDependencies)for(const w of f.extensionDependencies){const d=s.ExtensionIdentifier.toKey(w);m.addArc(v,d)}}const p=new Set;m.getNodes().filter(f=>m.getArcs(f).length===0).forEach(f=>p.add(f));const a=m.getNodes().filter(f=>!p.has(f));let l;do{l=!1;for(let f=0;f<a.length;f++){const v=a[f];m.hasOnlyGoodArcs(v,p)&&(a.splice(f,1),f--,p.add(v),l=!0)}}while(l);return a.map(f=>C.get(f))}containsActivationEvent(E){return this._activationMap.has(E)}containsExtension(E){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const m=this._activationMap.get(E);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(E){const m=this._extensionsMap.get(s.ExtensionIdentifier.toKey(E));return m||void 0}getExtensionDescriptionByUUID(E){for(const m of this._extensionsArr)if(m.uuid===E)return m}getExtensionDescriptionByIdOrUUID(E,m){return this.getExtensionDescription(E)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function y(R,E){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,C=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(m!==C)return m-C;const p=b.posix.basename(R.extensionLocation.path),a=b.posix.basename(E.extensionLocation.path);return p<a?-1:p>a?1:0}function P(R,E){const m=new Set;return E.forEach(C=>m.add(s.ExtensionIdentifier.toKey(C))),R.filter(C=>!m.has(s.ExtensionIdentifier.toKey(C.identifier)))}}),define(Ie[67],Ce([1,0,23]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var b;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function _(P){const R=s.VSBuffer.alloc(1);switch(P){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=_;function A(P,R){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var y;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[68],Ce([1,0,3,4,11,27,67,60,157,25,2]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class{constructor(a,l){this.initData=a,this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,console.log(this.initData.environment.extensionTelemetryLogResource),this._outputLogger=l.createLogger(R.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(a,l){const f=this.getTelemetryDetails(),v=new m(l,a,this._outputLogger,this.getBuiltInCommonProperties(a),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(a.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(a,l){this._level=a,this._productConfig=l||{usage:!0,error:!0}}getBuiltInCommonProperties(a){const l={};switch(l["common.extname"]=a.name,l["common.extversion"]=a.version,l["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,l["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,l["common.vscodeversion"]=this.initData.version,l["common.isnewappinstall"]=C(this.initData.telemetryInfo.firstSessionDate),l["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case _.UIKind.Web:l["common.uikind"]="web";break;case _.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),l}$onDidChangeTelemetryLevel(a){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=a;const l=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(a,l){const f=this._telemetryLoggers.get(a.value);return f?(f.logError(l),!0):!1}};E=xe([$e(0,N.IExtHostInitDataService),$e(1,b.ILoggerService)],E),e.ExtHostTelemetry=E;class m{constructor(a,l,f,v,w){this._extension=l,this._logger=f,this._commonProperties=v,this._onDidChangeEnableStates=new I.Emitter,this._appender=a,this._telemetryEnablements={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(a,l){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:a,isErrorsEnabled:l},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(a){return this._appender.ignoreBuiltInCommonProperties||(a=(0,P.mixin)(a,this._commonProperties)),this._appender.additionalCommonProperties&&(a=(0,P.mixin)(a,this._appender.additionalCommonProperties)),a=(0,y.cleanData)(a,[]),a}logEvent(a,l){a=this._extension.identifier.value+"/"+a,l=this.mixInCommonPropsAndCleanData(l||{}),this._appender.logEvent(a,l),this._logger.trace(a,l)}logUsage(a,l){!this._telemetryEnablements.isUsageEnabled||this.logEvent(a,l)}logError(a,l){!this._telemetryEnablements.isErrorsEnabled||(typeof a=="string"?this.logEvent(a,l):this._appender.logException(a,l))}get apiTelemetryLogger(){if(!this._apiObject){const a=this,l={logUsage:a.logUsage,get isUsageEnabled(){return a._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return a._telemetryEnablements.isErrorsEnabled},logError:a.logError,dispose:a.dispose,onDidChangeEnableStates:a._onDidChangeEnableStates.event};this._apiObject=Object.freeze(l)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=m;function C(p){const a=Date.now()-new Date(p).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=C,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(Ie[28],Ce([1,0,4,2,3,26,154]),function(ne,e,s,I,b,N,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class y{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class P{constructor(){this.kind=2,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class E{constructor(u){this.dependency=u}}e.MissingExtensionDependency=E;var m;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class p{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(u,i){const c=[],g=[],T=[],F=[],j=f(this._allExtensions),U=f(u),D=(H,W)=>H.extensionLocation.toString()===W.extensionLocation.toString()||H.isBuiltin===W.isBuiltin||H.isUserBuiltin===W.isUserBuiltin||H.isUnderDevelopment===W.isUnderDevelopment;for(const H of this._allExtensions){const W=U.get(N.ExtensionIdentifier.toKey(H.identifier));if(!W){c.push(H.identifier),j.delete(N.ExtensionIdentifier.toKey(H.identifier));continue}if(!D(H,W)){c.push(H.identifier),j.delete(N.ExtensionIdentifier.toKey(H.identifier));continue}}for(const H of u){const W=j.get(N.ExtensionIdentifier.toKey(H.identifier));if(!W){g.push(H);continue}if(!D(W,H)){c.push(W.identifier),j.delete(N.ExtensionIdentifier.toKey(W.identifier));continue}}const x=l(this._myExtensions),M=l(i);for(const H of this._myExtensions)M.has(N.ExtensionIdentifier.toKey(H))||T.push(H);for(const H of i)x.has(N.ExtensionIdentifier.toKey(H))||F.push(H);const O={toRemove:c,toAdd:g,myToRemove:T,myToAdd:F};return this.delta(O),O}delta(u){const{toRemove:i,toAdd:c,myToRemove:g,myToAdd:T}=u,F=l(i),j=l(g);for(let U=0;U<this._allExtensions.length;U++)F.has(N.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)j.has(N.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of c)this._allExtensions.push(U);for(const U of T)this._myExtensions.push(U)}containsExtension(u){for(const i of this._myExtensions)if(N.ExtensionIdentifier.equals(i,u))return!0;return!1}}e.ExtensionHostExtensions=p;class a{constructor(u){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=N.ExtensionIdentifier.toKey,u)for(const i of u)this.add(i)}get size(){return this._map.size}add(u){return this._map.set(this._toKey(u),u),this}clear(){this._map.clear()}delete(u){return this._map.delete(this._toKey(u))}has(u){return this._map.has(this._toKey(u))}forEach(u,i){this._map.forEach(c=>u.call(i,c,c,this))}*entries(){for(const[u,i]of this._map)yield[i,i]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function l(o){const u=new Set;for(const i of o)u.add(N.ExtensionIdentifier.toKey(i));return u}e.extensionIdentifiersArrayToSet=l;function f(o){const u=new Map;for(const i of o)u.set(N.ExtensionIdentifier.toKey(i.identifier),i);return u}function v(o,u){return o.enabledApiProposals?o.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function w(o,u){if(!v(o,u))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=w;class d{constructor(u,i,c,g){this.codeLoadingTime=u,this.activateCallTime=i,this.activateResolvedTime=c,this.activationReason=g}}e.ActivationTimes=d;class S{constructor(u,i){this.description=u,this.value=i}}e.ExtensionPointContribution=S,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function h(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(o,u){return{identifier:new N.ExtensionIdentifier((0,_.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!u,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=r;class n{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,i){return Promise.resolve(0)}getInspectPorts(u,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,i){return Promise.resolve()}}e.NullExtensionService=n}),define(Ie[178],Ce([1,0,12,26,28,11,15]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(l,f,v,w){this.startup=l,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,f){return l===-1||f===-1?-1:f-l}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class P{constructor(l,f,v,w,d,S){this.activationFailed=l,this.activationFailedError=f,this.activationTimes=v,this.module=w,this.exports=d,this.subscriptions=S}}e.ActivatedExtension=P;class R extends P{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class E extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class m extends P{constructor(l){super(!0,l,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let C=class{constructor(l,f,v,w,d){this._logService=d,this._registry=l,this._resolvedExtensionsSet=new Set,f.forEach(S=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(S))),this._externalExtensionsMap=new Map,v.forEach(S=>this._externalExtensionsMap.set(I.ExtensionIdentifier.toKey(S),S)),this._host=w,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[l,f]of this._operations)f.dispose()}isActivated(l){const f=this._operations.get(I.ExtensionIdentifier.toKey(l));return Boolean(f&&f.value)}getActivatedExtension(l){const f=this._operations.get(I.ExtensionIdentifier.toKey(l));if(!f||!f.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return f.value}async activateByEvent(l,f){if(this._alreadyActivatedEvents[l])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(l);await this._activateExtensions(v.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:l}}))),this._alreadyActivatedEvents[l]=!0}activateById(l,f){const v=this._registry.getExtensionDescription(l);if(!v)throw new Error(`Extension '${l}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(l){const f=l.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(l){if(this._operations.has(I.ExtensionIdentifier.toKey(l.id)))return this._operations.get(I.ExtensionIdentifier.toKey(l.id));if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(l.id)))return this._createAndSaveOperation(l,null,[],null);const f=this._registry.getExtensionDescription(l.id);if(!f){const d=new Error(`Cannot activate unknown extension '${l.id.value}'`),S=this._createAndSaveOperation(l,null,[],new m(d));return this._host.onExtensionActivationError(l.id,d,new b.MissingExtensionDependency(l.id.value)),S}const v=[],w=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const d of w){if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(d)))continue;const S=this._operations.get(I.ExtensionIdentifier.toKey(d));if(S){v.push(S);continue}if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(d))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(I.ExtensionIdentifier.toKey(d)),reason:l.reason}));continue}const t=this._registry.getExtensionDescription(d);if(t){if(!t.main&&!t.browser)continue;v.push(this._handleActivationRequest({id:t.identifier,reason:l.reason}));continue}const h=f.displayName||f.identifier.value,r=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${d}'`),n=this._createAndSaveOperation(l,f.displayName,[],new m(r));return this._host.onExtensionActivationError(f.identifier,r,new b.MissingExtensionDependency(d)),n}return this._createAndSaveOperation(l,f.displayName,v,null)}_createAndSaveOperation(l,f,v,w){const d=new p(l.id,f,l.reason,v,w,this._host,this._logService);return this._operations.set(I.ExtensionIdentifier.toKey(l.id),d),d}};C=xe([$e(4,N.ILogService)],C),e.ExtensionsActivator=C;let p=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(l,f,v,w,d,S,t){this._id=l,this._displayName=f,this._reason=v,this._deps=w,this._value=d,this._host=S,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let l=0;l<this._deps.length;l++){const f=this._deps[l];if(f.value&&!f.value.activationFailed){this._deps.splice(l,1),l--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(l=>l.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(l){const f=new Error;if(l&&l.name&&(f.name=l.name),l&&l.message?f.message=`Activating extension '${this._id.value}' failed: ${l.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${l}.`,l&&l.stack&&(f.stack=l.stack),this._value=new m(f),this._isDisposed&&s.isCancellationError(l))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(l)}}};p=xe([$e(6,N.ILogService)],p)}),define(Ie[179],Ce([1,0,11,27,28]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends s.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:b.ExtensionHostLogFileName}))}};N=xe([$e(0,s.ILoggerService),$e(1,I.IExtHostInitDataService)],N),e.ExtHostLogService=N});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[6],Ce([1,0,18,12,80,24,78,10,9,2,38,35,89,65,28]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p){"use strict";var a,l,f,v,w,d,S,t,h,r,n,o,u,i,c,g,T,F,j,U,D,x,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O($){return Object.assign($,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct($,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct($,[]);{const[ie,...we]=arguments;return Reflect.construct($,we,ie.constructor)}}})}let H=d=class{static from(...L){let ie=L;return new d(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(L){a.set(this,void 0),Ye(this,a,L,"f")}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),Ye(this,a,void 0,"f"))}};a=new WeakMap,H=d=xe([O],H),e.Disposable=H;let W=S=class{static Min(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isBefore(ie)&&(ie=He)}return ie}static Max(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(L){if(!L)return!1;if(L instanceof S)return!0;const{line:ie,character:we}=L;return typeof ie=="number"&&typeof we=="number"}static of(L){if(L instanceof S)return L;if(this.isPosition(L))return new S(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,ie){if(L<0)throw(0,I.illegalArgument)("line must be non-negative");if(ie<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=L,this._character=ie}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ie=0){if(L===null||ie===null)throw(0,I.illegalArgument)();let we;return typeof L>"u"?we=0:typeof L=="number"?we=L:(we=typeof L.lineDelta=="number"?L.lineDelta:0,ie=typeof L.characterDelta=="number"?L.characterDelta:0),we===0&&ie===0?this:new S(this.line+we,this.character+ie)}with(L,ie=this.character){if(L===null||ie===null)throw(0,I.illegalArgument)();let we;return typeof L>"u"?we=this.line:typeof L=="number"?we=L:(we=typeof L.line=="number"?L.line:this.line,ie=typeof L.character=="number"?L.character:this.character),we===this.line&&ie===this.character?this:new S(we,ie)}toJSON(){return{line:this.line,character:this.character}}};W=S=xe([O],W),e.Position=W;let z=t=class{static isRange(L){return L instanceof t?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof t)return L;if(this.isRange(L))return new t(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,ie,we,He){let Qe,lt;if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(L,ie),lt=new W(we,He)):W.isPosition(L)&&W.isPosition(ie)&&(Qe=W.of(L),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(L){return t.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ie=W.Max(L.start,this._start),we=W.Min(L.end,this._end);if(!ie.isAfter(we))return new t(ie,we)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ie=W.Min(L.start,this._start),we=W.Max(L.end,this.end);return new t(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ie=this.end){if(L===null||ie===null)throw(0,I.illegalArgument)();let we;return L?W.isPosition(L)?we=L:(we=L.start||this.start,ie=L.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};z=t=xe([O],z),e.Range=z;let G=h=class extends z{static isSelection(L){return L instanceof h?!0:L?z.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,ie,we,He){let Qe,lt;if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(L,ie),lt=new W(we,He)):W.isPosition(L)&&W.isPosition(ie)&&(Qe=W.of(L),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=h=xe([O],G),e.Selection=G;class te{constructor(L,ie,we){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,I.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,I.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=te;class he extends Error{static NotAvailable(L,ie){return new he(L,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(L){return new he(L,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(L),this._message=L,this._code=ie,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}}e.RemoteAuthorityResolverError=he;var re;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var be;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(be=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=r=class{static isTextEdit(L){return L instanceof r?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ie){return new r(L,ie)}static insert(L,ie){return r.replace(new z(L,L),ie)}static delete(L){return r.replace(L,"")}static setEndOfLine(L){const ie=new r(new z(new W(0,0),new W(0,0)),"");return ie.newEol=L,ie}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,I.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,I.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,I.illegalArgument)("newEol");this._newEol=L}constructor(L,ie){this._range=L,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=r=xe([O],le),e.TextEdit=le;let fe=n=class{static isNotebookCellEdit(L){return L instanceof n?!0:L?Vt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ie){return new n(L,ie)}static insertCells(L,ie){return new n(new Vt(L,L),ie)}static deleteCells(L){return new n(L,[])}static updateCellMetadata(L,ie){const we=new n(new Vt(L,L),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(L){const ie=new n(new Vt(0,0),[]);return ie.newNotebookMetadata=L,ie}constructor(L,ie){this.range=L,this.newCells=ie}};fe=n=xe([O],fe),e.NotebookEdit=fe;class Q{static isSnippetTextEdit(L){return L instanceof Q?!0:L?z.isRange(L.range)&&Fe.isSnippetString(L.snippet):!1}static replace(L,ie){return new Q(L,ie)}static insert(L,ie){return Q.replace(new z(L,L),ie)}constructor(L,ie){this.range=L,this.snippet=ie}}e.SnippetTextEdit=Q;var pe;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ie,we,He){this._edits.push({_type:1,from:L,to:ie,options:we,metadata:He})}createFile(L,ie,we){this._edits.push({_type:1,from:void 0,to:L,options:ie,metadata:we})}deleteFile(L,ie,we){this._edits.push({_type:1,from:L,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(L,ie,we){this._edits.push({_type:3,metadata:we,uri:L,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(L,ie,we,He){const Qe=ie.start,lt=ie.end;(Qe!==lt||we.length>0)&&this._edits.push({_type:5,uri:L,index:Qe,count:lt-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(L,ie,we,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ie,metadata:we}})}replace(L,ie,we,He){this._edits.push({_type:2,uri:L,edit:new le(ie,we),metadata:He})}insert(L,ie,we,He){this.replace(L,new z(ie,ie),we,He)}delete(L,ie,we){this.replace(L,ie,"",we)}has(L){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===L.toString())}set(L,ie){if(ie)for(const we of ie){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,fe.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(L,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(L,He.newNotebookMetadata,Qe):this.replaceNotebookCells(L,He.range,He.newCells,Qe):Q.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:L,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this._edits[we]=void 0);break}}(0,s.coalesceInPlace)(this._edits)}}get(L){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===L.toString()&&ie.push(we.edit);return ie}entries(){const L=new N.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=L.get(ie.uri);we||(we=[ie.uri,[]],L.set(ie.uri,we)),we[1].push(ie.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=xe([O],Se),e.WorkspaceEdit=Se;let Fe=o=class{static isSnippetString(L){return L instanceof o?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=o._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ie=this._tabstop++){if(typeof L=="function"){const we=new o;we._tabstop=this._tabstop,L(we),this._tabstop=we._tabstop,L=we.value}else L=o._escape(L);return this.value+="${",this.value+=ie,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ie=this._tabstop++){const we=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(L,ie){if(typeof ie=="function"){const we=new o;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=o=xe([O],Fe),e.SnippetString=Fe;var Ue;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(Ue=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=u=class{static isLocation(L){return L instanceof u?!0:L?z.isRange(L.range)&&P.URI.isUri(L.uri):!1}constructor(L,ie){if(this.uri=L,ie)if(z.isRange(ie))this.range=z.of(ie);else if(W.isPosition(ie))this.range=new z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=u=xe([O],ke),e.Location=ke;let ye=class{static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}constructor(L,ie){this.location=L,this.message=ie}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.location.range.isEqual(ie.location.range)&&L.location.uri.toString()===ie.location.uri.toString()}};ye=xe([O],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(L,ie,we=Xe.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=L,this.message=ie,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.severity===ie.severity&&L.code===ie.code&&L.severity===ie.severity&&L.source===ie.source&&L.range.isEqual(ie.range)&&(0,s.equals)(L.tags,ie.tags)&&(0,s.equals)(L.relatedInformation,ie.relatedInformation,ye.isEqual)}};De=xe([O],De),e.Diagnostic=De;let ae=class{constructor(L,ie){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ie}};ae=xe([O],ae),e.Hover=ae;var ue;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor(L,ie=ue.Text){this.range=L,this.kind=ie}toJSON(){return{range:this.range,kind:ue[this.kind]}}};ee=xe([O],ee),e.DocumentHighlight=ee;var Z;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Z=e.SymbolKind||(e.SymbolKind={}));var k;(function($){$[$.Deprecated=1]="Deprecated"})(k=e.SymbolTag||(e.SymbolTag={}));let B=i=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ie,we,He,Qe){this.name=L,this.kind=ie,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof z&&(this.location=new ke(He,we)),i.validate(this)}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};B=i=xe([O],B),e.SymbolInformation=B;let V=c=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(c.validate)}constructor(L,ie,we,He,Qe){this.name=L,this.detail=ie,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],c.validate(this)}};V=c=xe([O],V),e.DocumentSymbol=V;var q;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(L,ie){this.title=L,this.kind=ie}};oe=xe([O],oe),e.CodeAction=oe;let ce=g=class{constructor(L){this.value=L}append(L){return new g(this.value?this.value+g.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+g.sep)}};ce.sep=".",ce=g=xe([O],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorMove=ce.Refactor.append("move"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let J=class{constructor(L,ie){if(this.range=L,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=xe([O],J),e.SelectionRange=J;class Ee{constructor(L,ie,we,He,Qe,lt){this.kind=L,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=Ee;class ve{constructor(L,ie){this.fromRanges=ie,this.from=L}}e.CallHierarchyIncomingCall=ve;class Ne{constructor(L,ie){this.fromRanges=ie,this.to=L}}e.CallHierarchyOutgoingCall=Ne;var ze;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(L,ie){this.range=L,this.command=ie}get isResolved(){return!!this.command}};Je=xe([O],Je),e.CodeLens=Je;let Ge=T=class{static isMarkdownString(L){return L instanceof T?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ie=!1){l.set(this,void 0),Ye(this,l,new b.MarkdownString(L,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,l,"f").value}set value(L){Oe(this,l,"f").value=L}get isTrusted(){return Oe(this,l,"f").isTrusted}set isTrusted(L){Oe(this,l,"f").isTrusted=L}get supportThemeIcons(){return Oe(this,l,"f").supportThemeIcons}set supportThemeIcons(L){Oe(this,l,"f").supportThemeIcons=L}get supportHtml(){return Oe(this,l,"f").supportHtml}set supportHtml(L){Oe(this,l,"f").supportHtml=L}get baseUri(){return Oe(this,l,"f").baseUri}set baseUri(L){Oe(this,l,"f").baseUri=L}appendText(L){return Oe(this,l,"f").appendText(L),this}appendMarkdown(L){return Oe(this,l,"f").appendMarkdown(L),this}appendCodeblock(L,ie){return Oe(this,l,"f").appendCodeblock(ie??"",L),this}};l=new WeakMap,Ge=T=xe([O],Ge),e.MarkdownString=Ge;let Pe=class{constructor(L,ie){this.label=L,this.documentation=ie}};Pe=xe([O],Pe),e.ParameterInformation=Pe;let nt=class{constructor(L,ie){this.label=L,this.documentation=ie,this.parameters=[]}};nt=xe([O],nt),e.SignatureInformation=nt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=xe([O],X),e.SignatureHelp=X;var Y;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(L){this.value=L}};Be=xe([O],Be),e.InlayHintLabelPart=Be;let je=class{constructor(L,ie,we){this.position=L,this.label=ie,this.kind=we}};je=xe([O],je),e.InlayHint=je;var et;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function($){$[$.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(L,ie){this.label=L,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=xe([O],it),e.CompletionItem=it;let st=class{constructor(L=[],ie=!1){this.items=L,this.isIncomplete=ie}};st=xe([O],st),e.CompletionList=st;let ct=class{constructor(L,ie,we){this.insertText=L,this.range=ie,this.command=we}};ct=xe([O],ct),e.InlineSuggestion=ct;let at=class{constructor(L){this.commands=void 0,this.items=L}};at=xe([O],at),e.InlineSuggestionList=at;let rt=class{constructor(L,ie,we){this.insertText=L,this.range=ie,this.command=we}};rt=xe([O],rt),e.InlineSuggestionNew=rt;let _t=class{constructor(L,ie){this.items=L,this.commands=ie}};_t=xe([O],_t),e.InlineSuggestionsNew=_t;var Rt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var Ot;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var yt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(yt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Lt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Lt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function L(ie){switch(ie){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=L}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(L,ie){if(ie&&!P.URI.isUri(ie))throw(0,I.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.target=ie}};Ft=xe([O],Ft),e.DocumentLink=Ft;let Tt=class{constructor(L,ie,we,He){this.red=L,this.green=ie,this.blue=we,this.alpha=He}};Tt=xe([O],Tt),e.Color=Tt;let ft=class{constructor(L,ie){if(ie&&!(ie instanceof Tt))throw(0,I.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.color=ie}};ft=xe([O],ft),e.ColorInformation=ft;let It=class{constructor(L){if(!L||typeof L!="string")throw(0,I.illegalArgument)("label");this.label=L}};It=xe([O],It),e.ColorPresentation=It;var _e;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var Te;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Te=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ge;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(ge=e.TerminalExitReason||(e.TerminalExitReason={}));class K{constructor(L,ie,we){if(this.startIndex=L,this.length=ie,this.tooltip=we,typeof L!="number"||L<0)throw(0,I.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,I.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=K;var Ae;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(L){if(this.options=L,typeof L!="object")throw(0,I.illegalArgument)("options")}}e.TerminalProfile=Me;var Ze;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=F=class{static from(L){switch(L){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(L,ie){if(this.label=ie,typeof L!="string"||typeof ie!="string")throw(0,I.illegalArgument)("name");this._id=L}get id(){return this._id}};tt.Clean=new F("clean","Clean"),tt.Build=new F("build","Build"),tt.Rebuild=new F("rebuild","Rebuild"),tt.Test=new F("test","Test"),tt=F=xe([O],tt),e.TaskGroup=tt;function gt($){let L="";for(let ie=0;ie<$.length;ie++)L+=$[ie].replace(/,/g,",,")+",";return L}let vt=class{constructor(L,ie,we){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=L,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)L.push(ie);return gt(L)}};vt=xe([O],vt),e.ProcessExecution=vt;let Ct=class{constructor(L,ie,we){if(this._args=[],Array.isArray(ie)){if(!L)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L,this._args=ie,this._options=we}else{if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)L.push(typeof ie=="string"?ie:ie.value);return gt(L)}};Ct=xe([O],Ct),e.ShellExecution=Ct;var Dt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Dt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=pt;let wt=j=class{constructor(L,ie,we,He,Qe,lt){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=He,dt=Qe,this.__deprecated=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt):(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof vt?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ie=this._definition.type;(j.EmptyType===ie||j.ProcessType===ie||j.ShellType===ie||j.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=j=xe([O],wt),e.Task=wt;var ei;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(ei=e.ProgressLocation||(e.ProgressLocation={}));var bt;(function($){function L(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}$.isViewBadge=L})(bt=e.ViewBadge||(e.ViewBadge={}));let qt=U=class{static isTreeItem(L,ie){if(L instanceof U)return!0;const we=L;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,y.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,y.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<$t.None&&we.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(ie,"treeItemCheckbox");const He=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ti.Checked&&He!==ti.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(L,ie=$t.None){this.collapsibleState=ie,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};qt=U=xe([O],qt),e.TreeItem=qt;var $t;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ti;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(ti=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ci=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L,ie){this.value=L,this.id=ie??(0,R.generateUuid)()}};ci=xe([O],ci),e.DataTransferItem=ci;let kt=class{constructor(L){f.set(this,new Map);for(const[ie,we]of L??[]){const He=Oe(this,f,"f").get(ie);He?He.push(we):Oe(this,f,"f").set(ie,[we])}}get(L){return Oe(this,f,"f").get(L)?.[0]}set(L,ie){Oe(this,f,"f").set(L,[ie])}forEach(L,ie){for(const[we,He]of Oe(this,f,"f"))for(const Qe of He)L.call(ie,Qe,we,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[L,ie]of Oe(this,f,"f"))for(const we of ie)yield[L,we]}};kt=xe([O],kt),e.DataTransfer=kt;let ii=class{constructor(L){this.insertText=L}};ii=xe([O],ii),e.DocumentDropEdit=ii;let ui=class{constructor(L){this.insertText=L}};ui=xe([O],ui),e.DocumentPasteEdit=ui;let Ut=class{constructor(L,ie){this.id=L,this.color=ie}};Ut=xe([O],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(L){this.id=L}};Jt=xe([O],Jt),e.ThemeColor=Jt;var ut;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let di=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=P.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,ie){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,I.illegalArgument)("base");if(typeof ie!="string")throw(0,I.illegalArgument)("pattern");typeof L=="string"?this.baseUri=P.URI.file(L):P.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};di=xe([O],di),e.RelativePattern=di;let Nt=class{constructor(L,ie,we,He){this.enabled=typeof L=="boolean"?L:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=xe([O],Nt),e.Breakpoint=Nt;let Kt=class extends Nt{constructor(L,ie,we,He,Qe){if(super(ie,we,He,Qe),L===null)throw(0,I.illegalArgument)("location");this.location=L}};Kt=xe([O],Kt),e.SourceBreakpoint=Kt;let ni=class extends Nt{constructor(L,ie,we,He,Qe){super(ie,we,He,Qe),this.functionName=L}};ni=xe([O],ni),e.FunctionBreakpoint=ni;let hi=class extends Nt{constructor(L,ie,we,He,Qe,lt,dt){if(super(He,Qe,lt,dt),!ie)throw(0,I.illegalArgument)("dataId");this.label=L,this.dataId=ie,this.canPersist=we}};hi=xe([O],hi),e.DataBreakpoint=hi;let ri=class{constructor(L,ie,we){this.command=L,this.args=ie||[],this.options=we}};ri=xe([O],ri),e.DebugAdapterExecutable=ri;let fi=class{constructor(L,ie){this.port=L,this.host=ie}};fi=xe([O],fi),e.DebugAdapterServer=fi;let si=class{constructor(L){this.path=L}};si=xe([O],si),e.DebugAdapterNamedPipeServer=si;let Zt=class{constructor(L){this.implementation=L}};Zt=xe([O],Zt),e.DebugAdapterInlineImplementation=Zt;let mi=class{constructor(L,ie){this.range=L,this.expression=ie}};mi=xe([O],mi),e.EvaluatableExpression=mi;var gi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var pi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(pi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let vi=class{constructor(L,ie){this.range=L,this.text=ie}};vi=xe([O],vi),e.InlineValueText=vi;let Ei=class{constructor(L,ie,we=!0){this.range=L,this.variableName=ie,this.caseSensitiveLookup=we}};Ei=xe([O],Ei),e.InlineValueVariableLookup=Ei;let Gt=class{constructor(L,ie){this.range=L,this.expression=ie}};Gt=xe([O],Gt),e.InlineValueEvaluatableExpression=Gt;let bi=class{constructor(L,ie){this.frameId=L,this.stoppedLocation=ie}};bi=xe([O],bi),e.InlineValueContext=bi;var Ni;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ni=e.FileChangeType||(e.FileChangeType={}));let wi=D=class extends Error{static FileExists(L){return new D(L,E.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(L){return new D(L,E.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(L){return new D(L,E.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(L){return new D(L,E.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(L){return new D(L,E.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(L){return new D(L,E.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(L,ie=E.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(L)?L.toString(!0):L),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};wi=D=xe([O],wi),e.FileSystemError=wi;let Si=class{constructor(L,ie,we){this.start=L,this.end=ie,this.kind=we}};Si=xe([O],Si),e.FoldingRange=Si;var _i;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ti;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ti=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ki;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(ki=e.CommentMode||(e.CommentMode={}));var Le;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Le=e.CommentThreadState||(e.CommentThreadState={}));class Ht{constructor(L,ie=[]){this.tokenTypes=L,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ht;function Pi($){return typeof $>"u"||(0,y.isStringArray)($)}class ht{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ie=0,we=L.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(L.tokenTypes[ie],ie);for(let ie=0,we=L.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(L.tokenModifiers[ie],ie)}}push(L,ie,we,He,Qe){if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(L,ie,we,He,Qe);if(z.isRange(L)&&typeof ie=="string"&&Pi(we))return this._push(L,ie,we);throw(0,I.illegalArgument)()}_push(L,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Qe=L.start.character,lt=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(ie);let At=0;if(we)for(const xt of we){if(!this._tokenModifierStrToInt.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(xt);At|=1<<Wt>>>0}this._pushEncoded(He,Qe,lt,dt,At)}_pushEncoded(L,ie,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let xt=0,Wt=0;for(let jt=0;jt<At;jt++){let Qt=this._data[5*jt],Ii=this._data[5*jt+1];Qt===0?(Qt=xt,Ii+=Wt):Qt+=xt,this._data[5*jt]=Qt,this._data[5*jt+1]=Ii,xt=Qt,Wt=Ii}}let lt=L,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=L,this._prevChar=ie}static _sortAndDeltaEncode(L){const ie=[],we=L.length/5|0;for(let dt=0;dt<we;dt++)ie[dt]=dt;ie.sort((dt,At)=>{const xt=L[5*dt],Wt=L[5*At];if(xt===Wt){const jt=L[5*dt+1],Qt=L[5*At+1];return jt-Qt}return xt-Wt});const He=new Uint32Array(L.length);let Qe=0,lt=0;for(let dt=0;dt<we;dt++){const At=5*ie[dt],xt=L[At+0],Wt=L[At+1],jt=L[At+2],Qt=L[At+3],Ii=L[At+4],Yi=xt-Qe,In=Yi===0?Wt-lt:Wt,Ci=5*dt;He[Ci+0]=Yi,He[Ci+1]=In,He[Ci+2]=jt,He[Ci+3]=Qt,He[Ci+4]=Ii,Qe=xt,lt=Wt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new yi(new Uint32Array(this._data),L):new yi(ht._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ht;class yi{constructor(L,ie){this.resultId=ie,this.data=L}}e.SemanticTokens=yi;class Li{constructor(L,ie,we){this.start=L,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Li;class Ai{constructor(L,ie){this.resultId=ie,this.edits=L}}e.SemanticTokensEdits=Ai;var Mi;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Mi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=xe([O],Xt),e.QuickInputButtons=Xt;var Ui;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Bi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Bi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class Ri{static validate(L){if(L.badge){let ie=(0,A.nextCharLength)(L.badge,0);if(ie<L.badge.length&&(ie+=(0,A.nextCharLength)(L.badge,ie)),L.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ie,we){this.badge=L,this.tooltip=ie,this.color=we}}e.FileDecoration=Ri;let Di=class{constructor(L){this.kind=L}};Di=xe([O],Di),e.ColorTheme=Di;var xi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(L){return L instanceof Vt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,ie){if(L<0)throw(0,I.illegalArgument)("start must be positive");if(ie<0)throw(0,I.illegalArgument)("end must be positive");L<=ie?(this._start=L,this._end=ie):(this._start=ie,this._end=L)}with(L){let ie=this._start,we=this._end;return L.start!==void 0&&(ie=L.start),L.end!==void 0&&(we=L.end),ie===this._start&&we===this._end?this:new Vt(ie,we)}}e.NotebookRange=Vt;class oi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ie=>oi.isNotebookCellData(ie))}static isNotebookCellData(L){return!0}constructor(L,ie,we,He,Qe,lt,dt){this.kind=L,this.value=ie,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=dt,oi.validate(this)}}e.NotebookCellData=oi;class $i{constructor(L){this.cells=L}}e.NotebookData=$i;class Bt{static isNotebookCellOutputItem(L){return L instanceof Bt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ie={name:L.name,message:L.message,stack:L.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(L){return Bt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Bt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ie="application/octet-stream"){return new Bt(L,ie)}static text(L,ie=_.Mimes.text){const we=Oe(Bt,v,"f",w).encode(String(L));return new Bt(we,ie)}static json(L,ie="text/x-json"){const we=JSON.stringify(L,void 0,"	");return Bt.text(we,ie)}constructor(L,ie){this.data=L,this.mime=ie;const we=(0,_.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Bt,v=Bt,w={value:new TextEncoder};class se{static isNotebookCellOutput(L){return L instanceof se?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ie=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<L.length;Qe++){const lt=L[Qe],dt=(0,_.normalizeMimeType)(lt.mime);if(!we.has(dt)||(0,C.isTextStreamMime)(dt)){we.add(dt);continue}He.add(Qe),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?L:L.filter((Qe,lt)=>!He.has(lt))}constructor(L,ie,we){this.items=se.ensureUniqueMimeTypes(L,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,R.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=se;var de;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(de=e.NotebookCellKind||(e.NotebookCellKind={}));var Re;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(ot=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var St;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(St=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pt{constructor(L,ie){this.text=L,this.alignment=ie}}e.NotebookCellStatusBarItem=Pt;var tn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var nn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(nn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(L,ie=[]){this.uri=L,this.provides=(0,s.asArray)(ie)}}e.NotebookRendererScript=rn;let Wi=class{constructor(L,ie){this.label=L,this.timestamp=ie}};Wi=xe([O],Wi),e.TimelineItem=Wi;var sn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(L,ie){this.ranges=L,this.wordPattern=ie}}e.LinkedEditingRanges=ln;class cn{constructor(L,ie){this._port=L,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=cn;var un;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(L=void 0,ie=void 0,we=void 0){this.include=L,this.exclude=ie,this.profile=we}};Hi=xe([O],Hi),e.TestRunRequest=Hi;let Vi=x=class{static diff(L,ie,we){const He=new x(L);return He.expectedOutput=ie,He.actualOutput=we,He}constructor(L){this.message=L}};Vi=x=xe([O],Vi),e.TestMessage=Vi;let ji=class{constructor(L){this.id=L}};ji=xe([O],ji),e.TestTag=ji;let ai=class{constructor(L,ie){this.covered=L,this.total=ie}};ai=xe([O],ai),e.CoveredCount=ai;let qi=M=class{static fromDetails(L,ie){const we=new ai(0,0),He=new ai(0,0),Qe=new ai(0,0);for(const dt of ie)if("branches"in dt){we.total+=1,we.covered+=dt.executionCount>0?1:0;for(const At of dt.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const lt=new M(L,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=ie,lt}constructor(L,ie,we,He){this.uri=L,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=He}};qi=M=xe([O],qi),e.FileCoverage=qi;let Ki=class{constructor(L,ie,we=[]){this.executionCount=L,this.location=ie,this.branches=we}};Ki=xe([O],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};Gi=xe([O],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};Xi=xe([O],Xi),e.FunctionCoverage=Xi;var hn;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(L,ie,we,He,Qe,lt){this.kind=L,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=gn;class pn{constructor(L){this.uri=L}}e.TextTabInput=pn;class vn{constructor(L,ie){this.original=L,this.modified=ie}}e.TextDiffTabInput=vn;class En{constructor(L,ie,we,He){this.base=L,this.input1=ie,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(L,ie){this.uri=L,this.viewType=ie}}e.CustomEditorTabInput=bn;class wn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=wn;class Sn{constructor(L,ie){this.uri=L,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class _n{constructor(L,ie,we){this.original=L,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(L,ie){this.uri=L,this.inputBoxUri=ie}}e.InteractiveWindowInput=Dn}),define(Ie[93],Ce([1,0,46,13,10,245,123,6,18]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(p,a){a?P.set(p,a):P.delete(p)}e.setWordDefinitionFor=R;function E(p){return P.get(p)}e.getWordDefinitionFor=E;class m extends N.MirrorTextModel{constructor(a,l,f,v,w,d,S,t){super(l,f,v,w),this._proxy=a,this._languageId=d,this._isDirty=S,this.notebook=t,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===I.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(l){return l?a._getTextInRange(l):a.getText()},get eol(){return a._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(l){return a._lineAt(l)},offsetAt(l){return a._offsetAt(l)},positionAt(l){return a._positionAt(l)},validateRange(l){return a._validateRange(l)},validatePosition(l){return a._validatePosition(l)},getWordRangeAtPosition(l,f){return a._getWordRangeAtPosition(l,f)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,s.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,s.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const l=this._validateRange(a);if(l.isEmpty)return"";if(l.isSingleLine)return this._lines[l.start.line].substring(l.start.character,l.end.character);const f=this._eol,v=l.start.line,w=l.end.line,d=[];d.push(this._lines[v].substring(l.start.character));for(let S=v+1;S<w;S++)d.push(this._lines[S]);return d.push(this._lines[w].substring(0,l.end.character)),d.join(f)}_lineAt(a){let l;if(a instanceof A.Position?l=a.line:typeof a=="number"&&(l=a),typeof l!="number"||l<0||l>=this._lines.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new C(l,this._lines[l],l===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),f=this._lines[l.index].length;return new A.Position(l.index,Math.min(l.remainder,f))}_validateRange(a){if(!(a instanceof A.Range))throw new Error("Invalid argument");const l=this._validatePosition(a.start),f=this._validatePosition(a.end);return l===a.start&&f===a.end?a:new A.Range(l.line,l.character,f.line,f.character)}_validatePosition(a){if(!(a instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:l,character:f}=a,v=!1;if(l<0)l=0,f=0,v=!0;else if(l>=this._lines.length)l=this._lines.length-1,f=this._lines[l].length,v=!0;else{const w=this._lines[l].length;f<0?(f=0,v=!0):f>w&&(f=w,v=!0)}return v?new A.Position(l,f):a}_getWordRangeAtPosition(a,l){const f=this._validatePosition(a);if(!l)l=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(f.character+1,(0,_.ensureValidWordDefinition)(l),this._lines[f.line],0);if(v)return new A.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class C{constructor(a,l,f){this._line=a,this._text=l,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(Ie[180],Ce([1,0,6,14,4]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(A){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=s.ColorThemeKind.Light;break;case"hcDark":y=s.ColorThemeKind.HighContrast;break;case"hcLight":y=s.ColorThemeKind.HighContrastLight;break;default:y=s.ColorThemeKind.Dark}this._actual=new s.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};N=xe([$e(0,I.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ie[8],Ce([1,0,18,23,80,24,106,79,25,9,2,51,69,85,91,90,65,41,50,175,6,181]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(_e){function Te(K){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:Ze,positionColumn:We}=K,tt=new d.Position(Ae-1,Me-1),gt=new d.Position(Ze-1,We-1);return new d.Selection(tt,gt)}_e.to=Te;function ge(K){const{anchor:Ae,active:Me}=K;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=ge})(t=e.Selection||(e.Selection={}));var h;(function(_e){function Te(K){if(!K)return;const{start:Ae,end:Me}=K;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=Te;function ge(K){if(!K)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:Ze,endColumn:We}=K;return new d.Range(Ae-1,Me-1,Ze-1,We-1)}_e.to=ge})(h=e.Range||(e.Range={}));var r;(function(_e){function Te(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}_e.to=Te})(r=e.TokenType||(e.TokenType={}));var n;(function(_e){function Te(K){return new d.Position(K.lineNumber-1,K.column-1)}_e.to=Te;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=ge})(n=e.Position||(e.Position={}));var o;(function(_e){function Te(Ae,Me){return(0,s.coalesce)((0,s.asArray)(Ae).map(Ze=>ge(Ze,Me)))}_e.from=Te;function ge(Ae,Me){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:K(Ae.scheme,Me),pattern:me.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function K(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(_e){function Te(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function ge(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}_e.to=ge})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(_e){function Te(K){let Ae;return K.code&&((0,P.isString)(K.code)||(0,P.isNumber)(K.code)?Ae=String(K.code):Ae={value:String(K.code.value),target:K.code.target}),{...h.from(K.range),message:K.message,source:K.source,code:Ae,severity:g.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(c.from),tags:Array.isArray(K.tags)?(0,s.coalesce)(K.tags.map(u.from)):void 0}}_e.from=Te;function ge(K){const Ae=new d.Diagnostic(h.to(K),K.message,g.to(K.severity));return Ae.source=K.source,Ae.code=(0,P.isString)(K.code)?K.code:K.code?.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(c.to),Ae.tags=K.tags&&(0,s.coalesce)(K.tags.map(u.to)),Ae}_e.to=ge})(i=e.Diagnostic||(e.Diagnostic={}));var c;(function(_e){function Te(K){return{...h.from(K.location.range),message:K.message,resource:K.location.uri}}_e.from=Te;function ge(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,h.to(K)),K.message)}_e.to=ge})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(_e){function Te(K){switch(K){case d.DiagnosticSeverity.Error:return C.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return C.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return C.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return C.MarkerSeverity.Hint}return C.MarkerSeverity.Error}_e.from=Te;function ge(K){switch(K){case C.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case C.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case C.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case C.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}_e.to=ge})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(_e){function Te(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?w.SIDE_GROUP:w.ACTIVE_GROUP}_e.from=Te;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=ge})(T=e.ViewColumn||(e.ViewColumn={}));function F(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!F(_e[0])}e.isDecorationOptionsArr=j;var U;(function(_e){function Te(We){return We.map(_e.from)}_e.fromMany=Te;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let tt;if(ge(We)){const{language:Dt,value:Et}=We;tt={value:"```"+Dt+`
`+Et+"\n```\n"}}else d.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const gt=Object.create(null);tt.uris=gt;const vt=Dt=>{try{let Et=R.URI.parse(Dt,!0);Et=Et.with({query:Ae(Et.query,gt)}),gt[Dt]=Et}catch{}return""},Ct=new _.marked.Renderer;return Ct.link=vt,Ct.image=Dt=>typeof Dt=="string"?vt(b.parseHrefAndDimensions(Dt).href):"",(0,_.marked)(tt.value,{renderer:Ct}),tt}_e.from=K;function Ae(We,tt){if(!We)return We;let gt;try{gt=(0,A.parse)(We)}catch{}if(!gt)return We;let vt=!1;return gt=(0,y.cloneAndChange)(gt,Ct=>{if(R.URI.isUri(Ct)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Dt]=Ct,vt=!0,Dt}else return}),vt?JSON.stringify(gt):We}function Me(We){const tt=new d.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,tt}_e.to=Me;function Ze(We){if(!!We)return typeof We=="string"?We:_e.from(We)}_e.fromStrict=Ze})(U=e.MarkdownString||(e.MarkdownString={}));function D(_e){return j(_e)?_e.map(Te=>({range:h.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?U.fromMany(Te.hoverMessage):Te.hoverMessage?U.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:h.from(Te)}))}e.fromRangeOrRangeWithMessage=D;function x(_e){return typeof _e>"u"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=x;var M;(function(_e){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?x(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}_e.from=Te})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(_e){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?x(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(_e){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(_e){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?H.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?O.from(ge.light):void 0,dark:ge.dark?O.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?x(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(_e){function Te(K){return{text:K.newText,eol:K.newEol&&Ge.from(K.newEol),range:h.from(K.range)}}_e.from=Te;function ge(K){const Ae=new d.TextEdit(h.to(K.range),K.text);return Ae.newEol=typeof K.eol>"u"?void 0:Ge.to(K.eol),Ae}_e.to=ge})(z=e.TextEdit||(e.TextEdit={}));var G;(function(_e){function Te(K,Ae){const Me={edits:[]};if(K instanceof d.WorkspaceEdit){const Ze=new N.ResourceSet;for(const We of K._allEntries())We._type===1&&R.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of K._allEntries())We._type===1?Me.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,I.encodeBase64)(I.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Me.edits.push({resource:We.uri,textEdit:z.from(We.edit),versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Me.edits.push({resource:We.uri,textEdit:{range:h.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Me.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Me.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Me}_e.from=Te;function ge(K){const Ae=new d.WorkspaceEdit;for(const Me of K.edits)Me.textEdit?Ae.replace(R.URI.revive(Me.resource),h.to(Me.textEdit.range),Me.textEdit.text):Ae.renameFile(R.URI.revive(Me.oldResource),R.URI.revive(Me.newResource),Me.options);return Ae}_e.to=ge})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(_e){const Te=Object.create(null);Te[d.SymbolKind.File]=0,Te[d.SymbolKind.Module]=1,Te[d.SymbolKind.Namespace]=2,Te[d.SymbolKind.Package]=3,Te[d.SymbolKind.Class]=4,Te[d.SymbolKind.Method]=5,Te[d.SymbolKind.Property]=6,Te[d.SymbolKind.Field]=7,Te[d.SymbolKind.Constructor]=8,Te[d.SymbolKind.Enum]=9,Te[d.SymbolKind.Interface]=10,Te[d.SymbolKind.Function]=11,Te[d.SymbolKind.Variable]=12,Te[d.SymbolKind.Constant]=13,Te[d.SymbolKind.String]=14,Te[d.SymbolKind.Number]=15,Te[d.SymbolKind.Boolean]=16,Te[d.SymbolKind.Array]=17,Te[d.SymbolKind.Object]=18,Te[d.SymbolKind.Key]=19,Te[d.SymbolKind.Null]=20,Te[d.SymbolKind.EnumMember]=21,Te[d.SymbolKind.Struct]=22,Te[d.SymbolKind.Event]=23,Te[d.SymbolKind.Operator]=24,Te[d.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}_e.from=ge;function K(Ae){for(const Me in Te)if(Te[Me]===Ae)return Number(Me);return d.SymbolKind.Property}_e.to=K})(te=e.SymbolKind||(e.SymbolKind={}));var he;(function(_e){function Te(K){switch(K){case d.SymbolTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return d.SymbolTag.Deprecated}}_e.to=ge})(he=e.SymbolTag||(e.SymbolTag={}));var re;(function(_e){function Te(K){return{name:K.name,kind:te.from(K.kind),tags:K.tags&&K.tags.map(he.from),containerName:K.containerName,location:pe.from(K.location)}}_e.from=Te;function ge(K){const Ae=new d.SymbolInformation(K.name,te.to(K.kind),K.containerName,pe.to(K.location));return Ae.tags=K.tags&&K.tags.map(he.to),Ae}_e.to=ge})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var be;(function(_e){function Te(K){const Ae={name:K.name||"!!MISSING: name!!",detail:K.detail,range:h.from(K.range),selectionRange:h.from(K.selectionRange),kind:te.from(K.kind),tags:K.tags?.map(he.from)??[]};return K.children&&(Ae.children=K.children.map(Te)),Ae}_e.from=Te;function ge(K){const Ae=new d.DocumentSymbol(K.name,K.detail,te.to(K.kind),h.to(K.range),h.to(K.selectionRange));return(0,s.isNonEmptyArray)(K.tags)&&(Ae.tags=K.tags.map(he.to)),K.children&&(Ae.children=K.children.map(ge)),Ae}_e.to=ge})(be=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(_e){function Te(K){const Ae=new d.CallHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),h.to(K.range),h.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:K.name,detail:K.detail,kind:te.from(K.kind),uri:K.uri,range:h.from(K.range),selectionRange:h.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(_e){function Te(ge){return new d.CallHierarchyIncomingCall(le.to(ge.from),ge.fromRanges.map(K=>h.to(K)))}_e.to=Te})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(_e){function Te(ge){return new d.CallHierarchyOutgoingCall(le.to(ge.to),ge.fromRanges.map(K=>h.to(K)))}_e.to=Te})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(_e){function Te(K){return{range:K.range&&h.from(K.range),uri:K.uri}}_e.from=Te;function ge(K){return new d.Location(R.URI.revive(K.uri),h.to(K.range))}_e.to=ge})(pe=e.location||(e.location={}));var Se;(function(_e){function Te(K){const Ae=K,Me=K;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:h.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}_e.from=Te;function ge(K){return{targetUri:R.URI.revive(K.uri),targetRange:h.to(K.range),targetSelectionRange:K.targetSelectionRange?h.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?h.to(K.originSelectionRange):void 0}}_e.to=ge})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(_e){function Te(K){return{range:h.from(K.range),contents:U.fromMany(K.contents)}}_e.from=Te;function ge(K){return new d.Hover(K.contents.map(U.to),h.to(K.range))}_e.to=ge})(Fe=e.Hover||(e.Hover={}));var Ue;(function(_e){function Te(K){return{range:h.from(K.range),expression:K.expression}}_e.from=Te;function ge(K){return new d.EvaluatableExpression(h.to(K.range),K.expression)}_e.to=ge})(Ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(K){if(K instanceof d.InlineValueText)return{type:"text",range:h.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:h.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function ge(K){switch(K.type){case"text":return{range:h.to(K.range),text:K.text};case"variable":return{range:h.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:h.to(K.range),expression:K.expression}}}_e.to=ge})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(K){return{frameId:K.frameId,stoppedLocation:h.from(K.stoppedLocation)}}_e.from=Te;function ge(K){return new d.InlineValueContext(K.frameId,h.to(K.stoppedLocation))}_e.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(K){return{range:h.from(K.range),kind:K.kind}}_e.from=Te;function ge(K){return new d.DocumentHighlight(h.to(K.range),K.kind)}_e.to=ge})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(_e){function Te(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}_e.to=Te})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(_e){function Te(ge){return{triggerKind:De.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}_e.to=Te})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(_e){function Te(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}_e.to=ge})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(_e){const Te=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge(Me){return Te.get(Me)??9}_e.from=ge;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ae(Me){return K.get(Me)??d.CompletionItemKind.Property}_e.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(_e){function Te(ge,K){const Ae=new d.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=ee.to(ge.kind),Ae.tags=ge.tags?.map(ue.to),Ae.detail=ge.detail,Ae.documentation=b.isMarkdownString(ge.documentation)?U.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,E.Range.isIRange(ge.range)?Ae.range=h.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:h.to(ge.range.insert),replacing:h.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new d.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof d.Range?new d.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>z.to(Me))),Ae.command=K&&ge.command?K.fromInternal(ge.command):void 0,Ae}_e.to=Te})(Z=e.CompletionItem||(e.CompletionItem={}));var k;(function(_e){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:U.fromStrict(K.documentation)}}_e.from=Te;function ge(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation}}_e.to=ge})(k=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(_e){function Te(K){return{label:K.label,documentation:U.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(k.from):[],activeParameter:K.activeParameter}}_e.from=Te;function ge(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(k.to):[],activeParameter:K.activeParameter}}_e.to=ge})(B=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(_e){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.from):[]}}_e.from=Te;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.to):[]}}_e.to=ge})(V=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(_e){function Te(ge,K){const Ae=new d.InlayHint(n.to(K.position),typeof K.label=="string"?K.label:K.label.map(oe.to.bind(void 0,ge)),K.kind&&ce.to(K.kind));return Ae.textEdits=K.textEdits&&K.textEdits.map(z.to),Ae.tooltip=b.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,Ae.paddingLeft=K.paddingLeft,Ae.paddingRight=K.paddingRight,Ae}_e.to=Te})(q=e.InlayHint||(e.InlayHint={}));var oe;(function(_e){function Te(ge,K){const Ae=new d.InlayHintLabelPart(K.label);return Ae.tooltip=b.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,m.Command.is(K.command)&&(Ae.command=ge.fromInternal(K.command)),K.location&&(Ae.location=pe.to(K.location)),Ae}_e.to=Te})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ce;(function(_e){function Te(K){return K}_e.from=Te;function ge(K){return K}_e.to=ge})(ce=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(_e){function Te(K){return{range:h.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=Te;function ge(K){let Ae;if(K.url)try{Ae=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new d.DocumentLink(h.to(K.range),Ae)}_e.to=ge})(J=e.DocumentLink||(e.DocumentLink={}));var Ee;(function(_e){function Te(K){const Ae=new d.ColorPresentation(K.label);return K.textEdit&&(Ae.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Ae.additionalTextEdits=K.additionalTextEdits.map(Me=>z.to(Me))),Ae}_e.to=Te;function ge(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}_e.from=ge})(Ee=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(K){return new d.Color(K[0],K[1],K[2],K[3])}_e.to=Te;function ge(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=ge})(ve=e.Color||(e.Color={}));var Ne;(function(_e){function Te(K){return{range:h.from(K.range)}}_e.from=Te;function ge(K){return new d.SelectionRange(h.to(K.range))}_e.to=ge})(Ne=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function Te(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function ge(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}_e.to=ge})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(_e){function Te(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}_e.from=Te;function ge(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}_e.to=ge})(Ge=e.EndOfLine||(e.EndOfLine={}));var Pe;(function(_e){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(Pe=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(_e){function Te(ge){const K={start:ge.start+1,end:ge.end+1};return ge.kind&&(K.kind=X.from(ge.kind)),K}_e.from=Te})(nt=e.FoldingRange||(e.FoldingRange={}));var X;(function(_e){function Te(ge){if(ge)switch(ge){case d.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}_e.from=Te})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(_e){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?h.from(ge.selection):void 0,override:typeof ge.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(_e){function Te(Me){return Me instanceof d.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ge(Me)||K(Me)?new d.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}_e.from=Te;function ge(Me){const Ze=Me;return Ze?R.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(Me){const Ze=Me;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new d.RelativePattern(R.URI.revive(Me.baseUri),Me.pattern)}_e.to=Ae})(me=e.GlobPattern||(e.GlobPattern={}));var Be;(function(_e){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:me.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}_e.from=Te})(Be=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(_e){function Te(K){return{start:K.start,end:K.end}}_e.from=Te;function ge(K){return new d.NotebookRange(K.start,K.end)}_e.to=ge})(je=e.NotebookRange||(e.NotebookRange={}));var et;(function(_e){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=Te;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}_e.from=ge})(et=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(_e){function Te(ge){if(ge===l.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===l.NotebookCellExecutionState.Pending)return;if(ge===l.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}_e.to=Te})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(_e){function Te(K){switch(K){case d.NotebookCellKind.Markup:return l.CellKind.Markup;case d.NotebookCellKind.Code:default:return l.CellKind.Code}}_e.from=Te;function ge(K){switch(K){case l.CellKind.Markup:return d.NotebookCellKind.Markup;case l.CellKind.Code:default:return d.NotebookCellKind.Code}}_e.to=ge})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(_e){function Te(K){const Ae={metadata:K.metadata??Object.create(null),cells:[]};for(const Me of K.cells)d.NotebookCellData.validate(Me),Ae.cells.push(st.from(Me));return Ae}_e.from=Te;function ge(K){const Ae=new d.NotebookData(K.cells.map(st.to));return(0,P.isEmptyObject)(K.metadata)||(Ae.metadata=K.metadata),Ae}_e.to=ge})(it=e.NotebookData||(e.NotebookData={}));var st;(function(_e){function Te(K){return{cellKind:Ve.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:et.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(at.from):[]}}_e.from=Te;function ge(K){return new d.NotebookCellData(Ve.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(at.to):void 0,K.metadata,K.internalMetadata?et.to(K.internalMetadata):void 0)}_e.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(_e){function Te(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}_e.from=Te;function ge(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}_e.to=ge})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(_e){function Te(K){return{outputId:K.id,items:K.items.map(ct.from),metadata:K.metadata}}_e.from=Te;function ge(K){const Ae=K.items.map(ct.to);return new d.NotebookCellOutput(Ae,K.outputId,K.metadata)}_e.to=ge})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(_e){function Te(Ae){return K(Ae)?{include:(0,P.withNullAsUndefined)(me.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(me.from(Ae.exclude))}:(0,P.withNullAsUndefined)(me.from(Ae))}_e.from=Te;function ge(Ae){return K(Ae)?{include:me.to(Ae.include),exclude:me.to(Ae.exclude)}:me.to(Ae)}_e.to=ge;function K(Ae){const Me=Ae;return Me?!(0,P.isUndefinedOrNull)(Me.include)&&!(0,P.isUndefinedOrNull)(Me.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function Te(ge,K,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}_e.from=Te})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(_e){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}_e.from=Te})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(_e){function Te(K){return{uri:K.uri,provides:K.provides}}_e.from=Te;function ge(K){return new d.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}_e.to=ge})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(_e){function Te(K){return{message:U.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:h.from(K.location.range),uri:K.location.uri}}}_e.from=Te;function ge(K){const Ae=new d.TestMessage(typeof K.message=="string"?K.message:U.to(K.message));return Ae.actualOutput=K.actual,Ae.expectedOutput=K.expected,Ae.location=K.location?pe.to(K.location):void 0,Ae}_e.to=ge})(mt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=v.namespaceTestTag,_e.denamespace=v.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){function Te(K){const Ae=(0,p.getPrivateApiFor)(K).controllerId;return{extId:f.TestId.fromExtHostTestItem(K,Ae).toString(),label:K.label,uri:R.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Me=>yt.namespace(Ae,Me.id)),range:E.Range.lift(h.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&U.fromStrict(K.error)||null}}_e.from=Te;function ge(K){return{parent:void 0,error:void 0,id:f.TestId.fromString(K.extId).localId,label:K.label,uri:R.URI.revive(K.uri),tags:(K.tags||[]).map(Ae=>{const{tagId:Me}=yt.denamespace(Ae);return new d.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}_e.toPlain=ge})(Lt=e.TestItem||(e.TestItem={})),function(_e){function Te(K){return{id:K.id}}_e.from=Te;function ge(K){return new d.TestTag(K.id)}_e.to=ge}(yt=e.TestTag||(e.TestTag={}));var Mt;(function(_e){const Te=(K,Ae)=>{const Me=[];for(const[We,tt]of Ae)f.TestId.compare(tt.item.extId,We)===2&&(Ae.delete(We),Me.push(tt));const Ze={...Lt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(mt.to)})),children:Me.map(We=>Te(We,Ae))};for(const We of Ze.children)We.parent=Ze;return Ze};function ge(K){const Ae=[],Me=new Map;for(const Ze of K.items){Me.set(Ze.item.extId,Ze);const We=f.TestId.root(Ze.item.extId);K.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Ze.item.extId))&&Ae.push(Ze)}return{completedAt:K.completedAt,results:Ae.map(Ze=>Te(Ze,Me))}}_e.to=ge})(Mt=e.TestResults||(e.TestResults={}));var qe;(function(_e){function Te(Me){return{covered:Me.covered,total:Me.covered}}function ge(Me){return"line"in Me?n.from(Me):h.from(Me)}function K(Me){return"branches"in Me?{count:Me.executionCount,location:ge(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ge(Ze.location)})):void 0}:{type:0,count:Me.executionCount,location:ge(Me.location)}}_e.fromDetailed=K;function Ae(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(K)}}_e.fromFile=Ae})(qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(_e){function Te(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}_e.to=Te})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(_e){function Te(K){const Ae=new d.TypeHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),h.to(K.range),h.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:te.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:h.from(K.range),selectionRange:h.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(_e){function Te(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}_e.from=Te})(Tt=e.ViewBadge||(e.ViewBadge={}));var ft;(function(_e){function Te(ge,K){const Ae=ge.fileData;return Ae?new class extends d.DataTransferItem{asFile(){return{name:Ae.name,uri:R.URI.revive(Ae.uri),data:(0,S.once)(()=>K())}}}("",ge.id):new d.DataTransferItem(ge.asString)}_e.toDataTransferItem=Te})(ft=e.DataTransferItem||(e.DataTransferItem={}));var It;(function(_e){function Te(K,Ae){const Me=K.items.map(([Ze,We])=>[Ze,ft.toDataTransferItem(We,()=>Ae(We.id))]);return new d.DataTransfer(Me)}_e.toDataTransfer=Te;async function ge(K){const Ae={items:[]},Me=[];return K.forEach((Ze,We)=>{Me.push((async()=>{const tt=await Ze.asString(),gt=Ze.asFile();Ae.items.push([We,{id:Ze.id,asString:tt,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(Me),Ae}_e.toDataTransferDTO=ge})(It=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[182],Ce([1,0,2,12,6,8,149]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,R,E,m={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=E,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,E,m)=>{const p={dispose:this._callbacks.push([R,E,P])};return Array.isArray(m)&&m.push(p),p}}async $participateInSave(P,R){const E=s.URI.revive(P);let m=!1;const C=setTimeout(()=>m=!0,this._thresholds.timeout),p=[];try{for(const a of[...this._callbacks]){if(m)break;const l=this._documents.getDocument(E),f=await this._deliverEventAsyncAndBlameBadListeners(a,{document:l,reason:N.TextDocumentSaveReason.to(R)});p.push(f)}}finally{clearTimeout(C)}return p}_deliverEventAsyncAndBlameBadListeners([P,R,E],m){const C=this._badListeners.get(P);return typeof C=="number"&&C>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,R,m).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const a=this._badListeners.get(P);this._badListeners.set(P,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,E,m){const C=[],p=Date.now(),{document:a,reason:l}=m,{version:f}=a,v=Object.freeze({document:a,reason:l,waitUntil(w){if(Object.isFrozen(C))throw(0,I.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(w))}});try{R.apply(E,[v])}catch(w){return Promise.reject(w)}return Object.freeze(C),new Promise((w,d)=>{const S=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(C).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(S),w(t)}).catch(t=>{clearTimeout(S),d(t)})}).then(w=>{const d={edits:[]};for(const S of w)if(Array.isArray(S)&&S.every(t=>t instanceof b.TextEdit))for(const{newText:t,newEol:h,range:r}of S)d.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&N.Range.from(r),text:t,eol:h&&N.EndOfLine.from(h)}});if(d.edits.length!==0)return f===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[183],Ce([1,0,13,2,8,6,65]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(E,m,C,p){this.start=E,this.deletedCount=m,this.deletedItems=C,this.items=p}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(E,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,m,C){this.notebook=E,this._extHostDocument=m,this._cellData=C,this.handle=C.handle,this.uri=I.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const E=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return E._mime},set mime(p){E._mime=p},get outputs(){return E._outputs.slice(0)},get metadata(){return E._metadata},get executionSummary(){return E._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(E){this._outputs=E.map(b.NotebookCellOutput.to)}setOutputItems(E,m,C){const p=C.map(b.NotebookCellOutputItem.to),a=this._outputs.find(l=>l.id===E);if(a&&(m||(a.items.length=0),a.items.push(...p),a.items.length>1&&a.items.every(l=>_.isTextStreamMime(l.mime)))){const l=new Map,f=[];a.items.forEach(v=>{let w;l.has(v.mime)?w=l.get(v.mime):(w=[],l.set(v.mime,w),f.push(v.mime)),w.push(v.data)}),a.items.length=0,f.forEach(v=>{const w=_.compressOutputItemStreams(l.get(v));a.items.push({mime:v,data:w.buffer})})}}setMetadata(E){this._metadata=Object.freeze(E)}setInternalMetadata(E){this._internalMetadata=E,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=y;class P{constructor(E,m,C,p,a){this._proxy=E,this._textDocumentsAndEditors=m,this._textDocuments=C,this.uri=p,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const E=this,m={get uri(){return E.uri},get version(){return E._versionId},get notebookType(){return E._notebookType},get isDirty(){return E._isDirty},get isUntitled(){return E.uri.scheme===s.Schemas.untitled},get isClosed(){return E._disposed},get metadata(){return E._metadata},get cellCount(){return E._cells.length},cellAt(C){return C=E._validateIndex(C),E._cells[C].apiCell},getCells(C){return(C?E._getCells(C):E._cells).map(a=>a.apiCell)},save(){return E._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(E){E.metadata&&(this._metadata=Object.freeze({...this._metadata,...E.metadata}))}acceptDirty(E){this._isDirty=E}acceptModelChanged(E,m,C){this._versionId=E.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:C});const p={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},a=[];for(const f of E.rawEvents)f.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,p.contentChanges):f.kind===_.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,p.contentChanges):f.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),a.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),a.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),a.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===_.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),a.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),a.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const l=new Map;for(let f=0;f<a.length;f++){const v=a[f],w=l.get(v.cell);if(w===void 0){const d=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});l.set(v.cell,d-1)}else p.cellChanges[w]={...p.cellChanges[w],...v}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(E){return E=E|0,E<0?0:E>=this._cells.length?this._cells.length-1:E}_validateRange(E){let m=E.start|0,C=E.end|0;return m<0&&(m=0),C>this._cells.length&&(C=this._cells.length),E.with({start:m,end:C})}_getCells(E){E=this._validateRange(E);const m=[];for(let C=E.start;C<E.end;C++)m.push(this._cells[C]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(E,m,C){if(this._disposed)return;const p=[],a=[],l=[];if(E.reverse().forEach(f=>{const w=f[2].map(t=>{const h=new y(this,this._textDocumentsAndEditors,t);return m||a.push(y.asModelAddData(this.apiNotebook,t)),h}),d=new A(f[0],f[1],[],w),S=this._cells.splice(f[0],f[1],...w);for(const t of S)l.push(t.uri),d.deletedItems.push(t.apiCell);p.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:l}),C)for(const f of p)C.push(f.asApiEvent())}_moveCell(E,m,C){const p=this._cells.splice(E,1);this._cells.splice(m,0,...p);const a=[new A(E,1,p.map(l=>l.apiCell),[]),new A(m,0,[],p)];for(const l of a)C.push(l.asApiEvent())}_setCellOutputs(E,m){this._cells[E].setOutputs(m)}_setCellOutputItems(E,m,C,p){this._cells[E].setOutputItems(m,C,p)}_changeCellLanguage(E,m){const C=this._cells[E];C.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(C.uri,m)}_changeCellMime(E,m){const C=this._cells[E];C.apiCell.mime=m}_changeCellMetadata(E,m){this._cells[E].setMetadata(m)}_changeCellInternalMetadata(E,m){this._cells[E].setInternalMetadata(m)}getCellFromApiCell(E){return this._cells.find(m=>m.apiCell===E)}getCellFromIndex(E){return this._cells[E]}getCell(E){return this._cells.find(m=>m.handle===E)}getCellIndex(E){return this._cells.indexOf(E)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ie[94],Ce([1,0,12,8,6]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(A,y,P,R,E,m){this.id=A,this._proxy=y,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=E,this._visibleRanges=R,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(b.NotebookRange.isNotebookRange))throw(0,s.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,P){A._proxy.$tryRevealRange(A.id,I.NotebookRange.from(y),P??b.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},N.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(I.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Ie[184],Ce([1,0,4,11,8]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const P=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&P._acceptVisibleRanges(y.visibleRanges.ranges.map(b.NotebookRange.to)),y.selections&&P._acceptSelections(y.selections.selections.map(b.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(b.ViewColumn.to(A[y]))}};N=xe([$e(0,I.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ie[185],Ce([1,0,8,152,132,21,57,12]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,C,p){const a=this._handles++,{title:l,location:f,cancellable:v}=C,w={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(a,{location:s.ProgressLocation.from(f),title:l,source:w,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(a,p,!!v)}_withProgress(m,C,p){let a;p&&(a=new N.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,a));const l=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a?.dispose()};let f;try{f=C(new R(this._proxy,m),p&&a?a.token:N.CancellationToken.None)}catch(v){throw l(m),v}return f.then(v=>l(m),v=>l(m)),f}$acceptProgressCanceled(m){const C=this._mapHandleToCancellationSource.get(m);C&&(C.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=y;function P(E,m){return E.message=m.message,typeof m.increment=="number"&&(typeof E.increment=="number"?E.increment+=m.increment:E.increment=m.increment),E}class R extends I.Progress{constructor(m,C){super(p=>this.throttledReport(p)),this._proxy=m,this._handle=C}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}xe([(0,_.throttle)(100,(E,m)=>P(E,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ie[95],Ce([1,0,51,91,41,66,50,8,2]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(w,d,S,t)=>{let h=d;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!S(h,r)){const n=h;h=r,w.listener?.(t(r,n))}}}},R=(w,d)=>w===d,E={range:(w,d)=>w===d?!0:!w||!d?!1:w.isEqual(d),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(w,d)=>!(w.length!==d.length||w.some(S=>!d.find(t=>S.id===t.id)))},m=w=>d=>({op:4,update:w(d)}),C=(w,d)=>({range:(()=>{let S;const t=m(h=>({range:s.Range.lift(A.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return S},set(h){w.listener?.({op:6}),E.range(S,h)||(S=h,w.listener?.(t(h)))}}})(),label:P(w,d,E.label,m(S=>({label:S}))),description:P(w,void 0,E.description,m(S=>({description:S}))),sortText:P(w,void 0,E.sortText,m(S=>({sortText:S}))),canResolveChildren:P(w,!1,E.canResolveChildren,S=>({op:2,state:S})),busy:P(w,!1,E.busy,m(S=>({busy:S}))),error:P(w,void 0,E.error,m(S=>({error:A.MarkdownString.fromStrict(S)||null}))),tags:P(w,[],E.tags,(S,t)=>({op:1,new:S.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),p=w=>{const d=b.TestId.fromString(w.extId),S=new l(d.controllerId,d.localId,w.label,y.URI.revive(w.uri)||void 0);return S.range=A.Range.to(w.range||void 0),S.description=w.description||void 0,S.sortText=w.sortText||void 0,S.tags=w.tags.map(t=>A.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),S},a=w=>{let d;for(const S of w.tests){const t=p(S.item);(0,I.getPrivateApiFor)(t).parent=d,d=t}return d};e.toItemFromContext=a;class l{constructor(d,S,t,h){if(S.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(S)} symbol`);const r=(0,I.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:S,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof f?void 0:r.parent}},children:{value:(0,N.createTestItemChildren)(r,I.getPrivateApiFor,l),enumerable:!0,writable:!1},...C(r,t)})}}e.TestItemImpl=l;class f extends l{constructor(d,S){super(d,d,S,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class v extends N.TestItemCollection{constructor(d,S,t){super({controllerId:d,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:I.getPrivateApiFor,getChildren:h=>h.children,root:new f(d,S),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[96],Ce([1,0,46,12,77,8,6]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,C,p){const a=A._Keys.nextId();m.$registerTextEditorDecorationType(C.identifier,a,N.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){m.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class y{constructor(m,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,C){this._throwIfFinalized();let p=null;if(m instanceof _.Position)p=new _.Range(m,m);else if(m instanceof _.Range)p=m;else throw new Error("Unrecognized location");this._pushEdit(p,C,!1)}insert(m,C){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),C,!0)}delete(m){this._throwIfFinalized();let C=null;if(m instanceof _.Range)C=m;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(m,C,p){const a=this._document.validateRange(m);this._collectedEdits.push({range:a,text:C,forceMoveMarkers:p})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=y;class P{constructor(m,C,p,a){this._proxy=m,this._id=C,this._accept(p),this._logService=a;const l=this;this.value={get tabSize(){return l._tabSize},set tabSize(f){l._setTabSize(f)},get insertSpaces(){return l._insertSpaces},set insertSpaces(f){l._setInsertSpaces(f)},get cursorStyle(){return l._cursorStyle},set cursorStyle(f){l._setCursorStyle(f)},get lineNumbers(){return l._lineNumbers},set lineNumbers(f){l._setLineNumbers(f)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const C=Math.floor(m);return C>0?C:null}if(typeof m=="string"){const C=parseInt(m,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(m){const C=this._validateTabSize(m);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const C=this._validateInsertSpaces(m);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(m)})))}assign(m){const C={};let p=!1;if(typeof m.tabSize<"u"){const a=this._validateTabSize(m.tabSize);a==="auto"?(p=!0,C.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,p=!0,C.tabSize=a)}if(typeof m.insertSpaces<"u"){const a=this._validateInsertSpaces(m.insertSpaces);a==="auto"?(p=!0,C.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,p=!0,C.insertSpaces=a)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,p=!0,C.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,p=!0,C.lineNumbers=N.TextEditorLineNumbersStyle.from(m.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(m,C){C.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class R{constructor(m,C,p,a,l,f,v,w){this.id=m,this._proxy=C,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._options=new P(this._proxy,this.id,f,p),this._visibleRanges=v,this._viewColumn=w;const d=this;this.value=Object.freeze({get document(){return a.getValue()},set document(S){throw(0,I.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(S){if(!(S instanceof _.Selection))throw(0,I.illegalArgument)("selection");d._selections=[S],d._trySetSelection()},get selections(){return d._selections},set selections(S){if(!Array.isArray(S)||S.some(t=>!(t instanceof _.Selection)))throw(0,I.illegalArgument)("selections");d._selections=S,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(S){throw(0,I.readonly)("visibleRanges")},get options(){return d._options.value},set options(S){d._disposed||d._options.assign(S)},get viewColumn(){return d._viewColumn},set viewColumn(S){throw(0,I.readonly)("viewColumn")},edit(S,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new y(a.getValue(),t);return S(h),d._applyEdit(h)},insertSnippet(S,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=d._selections.map(n=>N.Range.from(n));else if(t instanceof _.Position){const{lineNumber:n,column:o}=N.Position.from(t);r=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof _.Range)r=[N.Range.from(t)];else{r=[];for(const n of t)if(n instanceof _.Range)r.push(N.Range.from(n));else{const{lineNumber:o,column:u}=N.Position.from(n);r.push({startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u})}}return C.$tryInsertSnippet(m,a.getValue().version,S.value,r,h)},setDecorations(S,t){const h=t.length===0;h&&!d._hasDecorationsForKey.has(S.key)||(h?d._hasDecorationsForKey.delete(S.key):d._hasDecorationsForKey.add(S.key),d._runOnProxy(()=>{if(N.isDecorationOptionsArr(t))return C.$trySetDecorations(m,S.key,N.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const u=t[n];r[4*n]=u.start.line+1,r[4*n+1]=u.start.character+1,r[4*n+2]=u.end.line+1,r[4*n+3]=u.end.character+1}return C.$trySetDecorationsFast(m,S.key,r)}}))},revealRange(S,t){d._runOnProxy(()=>C.$tryRevealRange(m,N.Range.from(S),t||_.TextEditorRevealType.Default))},show(S){C.$tryShowEditor(m,N.ViewColumn.from(S))},hide(){C.$tryHideEditor(m)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,s.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,s.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,s.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,s.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const C=m.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const p=C.edits.map(l=>l.range);p.sort((l,f)=>l.end.line===f.end.line?l.end.character===f.end.character?l.start.line===f.start.line?l.start.character-f.start.character:l.start.line-f.start.line:l.end.character-f.end.character:l.end.line-f.end.line);for(let l=0,f=p.length-1;l<f;l++){const v=p[l].end;if(p[l+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=C.edits.map(l=>({range:N.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,a,{setEndOfLine:typeof C.setEndOfLine=="number"?N.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=R}),define(Ie[186],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[187],Ce([1,0,143,12,29,84,87,30,26,186,151]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=A.Registry.as(_.Extensions.JSONContribution);class m{constructor(d,S,t){this._messageHandler=d,this._extension=S,this._extensionPointId=t}_msg(d,S){this._messageHandler({type:d,message:S,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(b.default.Error,d)}warn(d){this._msg(b.default.Warning,d)}info(d){this._msg(b.default.Info,d)}}e.ExtensionMessageCollector=m;class C{static _toSet(d){const S=new Set;for(let t=0,h=d.length;t<h;t++)S.add(y.ExtensionIdentifier.toKey(d[t].description.identifier));return S}static compute(d,S){if(!d||!d.length)return new C(S,[]);if(!S||!S.length)return new C([],d);const t=this._toSet(d),h=this._toSet(S),r=S.filter(o=>!t.has(y.ExtensionIdentifier.toKey(o.description.identifier))),n=d.filter(o=>!h.has(y.ExtensionIdentifier.toKey(o.description.identifier)));return new C(r,n)}constructor(d,S){this.added=d,this.removed=S}}e.ExtensionPointUserDelta=C;class p{constructor(d,S){this.name=d,this.defaultExtensionKind=S,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=C.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,I.onUnexpectedError)(d)}}}e.ExtensionPoint=p;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(0,null),s.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:s.localize(2,null),properties:{vscode:{type:"string",description:s.localize(3,null),default:"^1.22.0"}}},publisher:{description:s.localize(4,null),type:"string"},displayName:{description:s.localize(5,null),type:"string"},categories:{description:s.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:s.localize(7,null)}]}},galleryBanner:{type:"object",description:s.localize(8,null),properties:{color:{description:s.localize(9,null),type:"string"},theme:{description:s.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(13,null)},enabledApiProposals:{markdownDescription:s.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:s.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:s.localize(31,null)},{label:"onUri",body:"onUri",description:s.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(36,null)},{label:"onRenderer",description:s.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(39,null)},{label:"*",description:s.localize(40,null),body:"*"}]}},badges:{type:"array",description:s.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(42,null)},href:{type:"string",description:s.localize(43,null)},description:{type:"string",description:s.localize(44,null)}}}},markdown:{type:"string",description:s.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:s.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:s.localize(49,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(50,null)},{body:["workspace"],description:s.localize(51,null)},{body:["ui","workspace"],description:s.localize(52,null)},{body:["workspace","ui"],description:s.localize(53,null)},{body:[],description:s.localize(54,null)}]},capabilities:{description:s.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(58,null),s.localize(59,null),s.localize(60,null)]},description:{type:"string",markdownDescription:s.localize(61,null)}}},untrustedWorkspaces:{description:s.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(64,null),s.localize(65,null),s.localize(66,null)]},restrictedConfigurations:{description:s.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(68,null)}}}}},sponsor:{description:s.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(71,null),type:"string"},"vscode:uninstall":{description:s.localize(72,null),type:"string"}}},icon:{type:"string",description:s.localize(73,null)},l10n:{type:"string",description:s.localize(74,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const S=new p(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,S),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,E.registerSchema(l,e.schema),S}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=A.Registry.as(v.ExtensionsRegistry),E.registerSchema(l,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:s.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ie[188],Ce([1,0,140,9,25,187,40,4]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(2,null),default:""}}};var P;(function(m){function C(p,a,l){if(!p)return;const f=I.isString(p.type)?p.type:void 0;if(!f||f.length===0){l.error(s.localize(3,null));return}const v=[];if(Array.isArray(p.required))for(const w of p.required)I.isString(w)&&v.push(w);return{extensionId:a.value,taskType:f,required:v,properties:p.properties?b.deepClone(p.properties):{},when:p.when?_.ContextKeyExpr.deserialize(p.when):void 0}}m.from=C})(P||(P={}));const R=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:s.localize(4,null),type:"array",items:y}});class E{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,p)=>{R.setHandler((a,l)=>{this._schema=void 0;try{for(const f of l.removed){const v=f.value;for(const w of v)this.taskTypes&&w.type&&this.taskTypes[w.type]&&delete this.taskTypes[w.type]}for(const f of l.added){const v=f.value;for(const w of v){const d=P.from(w,f.description.identifier,f.collector);d&&(this.taskTypes[d.taskType]=d)}}(l.removed.length>0||l.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const p of this.all()){const a={type:"object",additionalProperties:!1};p.required.length>0&&(a.required=p.required.slice(0)),p.properties!==void 0?a.properties=b.deepClone(p.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[p.taskType]},C.push(a)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistryImpl=E,e.TaskDefinitionRegistry=new E}),define(Ie[189],Ce([1,0,141,9,22,25,40,188]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,s.localize(0,null)),e.TASKS_CATEGORY={value:s.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function H(W){if(!W)return O.Strong;switch(W.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=H}(y=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(O){function H(W){switch(W.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=H}(R=e.RevealKind||(e.RevealKind={}));var E;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function H(W){switch(W.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=H}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(O){function H(W){switch(W.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=H}(m=e.PanelKind||(e.PanelKind={}));var C;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:E.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var p;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(p=e.RuntimeType||(e.RuntimeType={})),function(O){function H(z){switch(z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=H;function W(z){switch(z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=W}(p=e.RuntimeType||(e.RuntimeType={}));var a;(function(O){function H(W){return I.isString(W)?W:W.value}O.value=H})(a=e.CommandString||(e.CommandString={}));var l;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function H(z){return z===O.Clean._id||z===O.Build._id||z===O.Rebuild._id||z===O.Test._id}O.is=H;function W(z){if(z!==void 0)return I.isString(z)?H(z)?{_id:z,isDefault:!1}:void 0:z}O.from=W})(l=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function H(W){switch(W){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=H})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var w;(function(O){O.parallel="parallel",O.sequence="sequence"})(w=e.DependsOrder||(e.DependsOrder={}));var d;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(d=e.RunOnOptions||(e.RunOnOptions={}));var S;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:d.default,instanceLimit:1}})(S=e.RunOptions||(e.RunOptions={}));class t{constructor(H,W,z,G,te,he){this._label="",this._id=H,W&&(this._label=W),z&&(this.type=z),this.runOptions=G,this.configurationProperties=te,this._source=he}getDefinition(H){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const H={folder:this.getFolderId(),id:this._id};return JSON.stringify(H)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(H,W=!1){if(H===void 0)return!1;if(I.isString(H))return H===this._label||H===this.configurationProperties.identifier||W&&H===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===H._key}getQualifiedLabel(){const H=this.getWorkspaceFolder();return H?`${this._label} (${H.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(H){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),H&&(this._taskLoadMessages=this._taskLoadMessages.concat(H))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class h extends t{constructor(H,W,z,G,te,he,re,be){super(H,z,void 0,re,be,W),this.command={},this._source=W,this.hasDefinedMatchers=he,te&&(this.command=te)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(H=!1){if(H&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(H){return H instanceof h}getMapKey(){const H=this._source.config.workspaceFolder;return H?`${H.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:W};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(H){return new h(H._id,H._source,H._label,H.type,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.CustomTask=h;class r extends t{constructor(H,W,z,G,te,he,re){super(H,z,G,he,re,W),this._source=W,this.configures=te}static is(H){return H instanceof r}fromObject(H){return H}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:W};return JSON.stringify(z)}}e.ConfiguringTask=r;class n extends t{constructor(H,W,z,G,te,he,re,be,le){super(H,z,G,be,le,W),this.defines=te,this.hasDefinedMatchers=re,this.command=he,this.icon=le.icon,this.hide=le.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(H){return H instanceof n}getMapKey(){const H=this._source.workspaceFolder;return H?`${this._source.scope.toString()}|${H.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const H={type:"contributed",scope:this._source.scope,id:this._id};return H.folder=this.getFolderId(),JSON.stringify(H)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(H){return new n(H._id,H._source,H._label,H.type,H.defines,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.ContributedTask=n;class o extends t{constructor(H,W,z,G,te,he){super(H,z,G,te,he,W),this._source=W}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(H){return H instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(H){return new o(H._id,H._source,H._label,H.type,H.runOptions,H.configurationProperties)}}e.InMemoryTask=o;var u;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor(H){this._order=new Map;for(let W=0;W<H.length;W++)this._order.set(H[W].uri.toString(),W)}compare(H,W){const z=H.getWorkspaceFolder(),G=W.getWorkspaceFolder();if(z&&G){let te=this._order.get(z.uri.toString());te=te===void 0?0:te+1;let he=this._order.get(G.uri.toString());return he=he===void 0?0:he+1,te===he?H._label.localeCompare(W._label):te-he}else return!z&&G?-1:z&&!G?1:0}}e.TaskSorter=c;var g;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(O){O.SingleRun="singleRun",O.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var F;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(F=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(O){function H(W,z,G,te,he){if(z){const re={kind:W,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:z};return W==="start"?(re.terminalId=G,re.resolvedVariables=te):W==="processStarted"?re.processId=G:W==="processEnded"&&(re.exitCode=G),Object.freeze(re)}else return Object.freeze({kind:"changed"})}O.create=H})(j=e.TaskEvent||(e.TaskEvent={}));var U;(function(O){function H(z){const G=Object.keys(z).sort();let te="";for(const he of G){let re=z[he];re instanceof Object?re=H(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),te+=he+","+re+","}return te}function W(z){const te={_key:H(z),type:z.taskType};return Object.assign(te,z),te}O.create=W})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var x;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(x=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(O){function H(W,z){const G=A.TaskDefinitionRegistry.get(W.type);if(G===void 0){const be=N.deepClone(W);return delete be._key,U.create(be)}const te=Object.create(null);te.type=G.taskType;const he=new Set;G.required.forEach(be=>he.add(be));const re=G.properties;for(const be of Object.keys(re)){const le=W[be];if(le!=null)te[be]=le;else if(he.has(be)){const fe=re[be];if(fe.default!==void 0)te[be]=N.deepClone(fe.default);else switch(fe.type){case"boolean":te[be]=!1;break;case"number":case"integer":te[be]=0;break;case"string":te[be]="";break;default:z.error(s.localize(2,null,JSON.stringify(W,void 0,0),be));return}}}return U.create(te)}O.createTaskIdentifier=H})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[190],Ce([1,0,12]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,s.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=I;class b extends I{constructor(){super(),this._hasErr=!0,this._err=new s.CancellationError}}e.CanceledLazyPromise=b}),define(Ie[42],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const I=[];function b(A){const y=new s(A);return I[y.nid]=y,y}e.createProxyIdentifier=b;function N(A){return I[A].sid}e.getStringIdentifierForProxy=N;class _{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=_}),define(Ie[5],Ce([1,0,42]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var b;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(b=e.TabInputKind||(e.TabInputKind={}));var N;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(l){return l._id=E._n++,l}}e.IdObject=E,E._n=0;var m;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,s.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,s.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,s.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,s.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,s.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,s.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,s.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,s.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,s.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,s.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,s.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,s.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,s.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,s.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,s.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,s.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,s.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,s.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,s.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,s.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,s.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,s.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,s.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,s.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,s.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,s.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,s.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,s.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,s.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,s.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,s.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,s.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,s.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,s.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,s.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,s.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,s.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,s.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,s.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,s.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,s.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,s.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,s.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,s.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,s.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,s.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,s.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,s.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,s.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,s.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,s.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,s.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,s.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,s.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,s.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,s.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,s.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,s.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,s.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,s.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,s.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,s.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,s.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,s.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[70],Ce([1,0,3,11,5,14]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(b.MainContext.MainThreadTelemetry)}report(y,P,R){const E=this.getUsageKey(y,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};_=xe([$e(0,N.IExtHostRpcService),$e(1,I.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,P){}})}),define(Ie[191],Ce([1,0,4,5,6,26]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,R,E={}){const m=N.ExtensionIdentifier.toKey(y.identifier),C=this._inFlightRequests.get(m)||[],p=[...R].sort().join(" ");let a=C.find(l=>l.providerId===P&&l.scopes===p);if(a)return a.result;{const l=this._getSession(y,m,P,R,E);a={providerId:P,scopes:p,result:l},C.push(a),this._inFlightRequests.set(m,C);try{await l}finally{const f=C.findIndex(v=>v.providerId===P&&v.scopes===p);f>-1&&(C.splice(f),this._inFlightRequests.set(m,C))}return l}}async _getSession(y,P,R,E,m={}){await this._proxy.$ensureProvider(R);const C=y.displayName||y.name;return this._proxy.$getSession(R,E,P,C,m)}async removeSession(y,P){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,R,E){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:R,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===y)||this._providers.push({id:y,label:P});const m=R.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(y,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const C=this._providers.findIndex(p=>p.id===y);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ie[192],Ce([1,0,5,14,8]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(A,y){this._proxy=A.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>y.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,P){const R=b.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,P?.isRefactoring??!1)}};N=xe([$e(0,I.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ie[193],Ce([1,0,5]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(N){const _=N.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=I});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[37],Ce([1,0,9,6,8,25,5,18,11,79,51,246,2,7,3,14,95,23,42,44]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w){"use strict";var d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(i,c){d.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,S.set(this,void 0),Ye(this,d,i.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=c,Ye(this,S,i.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new h(this,g=>{const T=this._apiCommands.get(g);return T?.result===n.Void?T:void 0},c),this._argumentProcessors=[{processArgument(g){return(0,P.revive)(g)}},{processArgument(g){return(0,N.cloneAndChange)(g,function(T){if(R.Range.isIRange(T))return b.Range.to(T);if(E.Position.isIPosition(T))return b.Position.to(T);if(R.Range.isIRange(T.range)&&m.URI.isUri(T.uri))return b.location.to(T);if(T instanceof f.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const c=this.registerCommand(!1,i.id,async(...g)=>{const T=i.args.map((j,U)=>{if(!j.validate(g[U]))throw new Error(`Invalid argument '${j.name}' when running '${i.id}', received: ${g[U]}`);return j.convert(g[U])}),F=await this.executeCommand(i.internalId,...T);return i.result.convert(F,g,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new I.Disposable(()=>{c.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,c,g,T,F,j){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:g,thisArg:T,description:F,extension:j}),i&&Oe(this,d,"f").$registerCommand(c),new I.Disposable(()=>{this._commands.delete(c)&&i&&Oe(this,d,"f").$unregisterCommand(c)})}executeCommand(i,...c){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,c,!0)}async _doExecuteCommand(i,c,g){if(this._commands.has(i))return Oe(this,d,"f").$fireCommandActivationEvent(i),this._executeContributedCommand(i,c,!1);{let T=!1;const F=(0,N.cloneAndChange)(c,function(j){if(j instanceof I.Position)return b.Position.from(j);if(j instanceof I.Range)return b.Range.from(j);if(j instanceof I.Location)return b.location.from(j);if(I.NotebookRange.isNotebookRange(j))return b.NotebookRange.from(j);if(j instanceof ArrayBuffer)return T=!0,f.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return T=!0,f.VSBuffer.wrap(j);if(j instanceof f.VSBuffer)return T=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,d,"f").$executeCommand(i,T?new v.SerializableObjectWithBuffers(F):F,g);return(0,P.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(i,c,!1);throw j}}}async _executeContributedCommand(i,c,g){const T=this._commands.get(i);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,i);const{callback:F,thisArg:j,description:U}=T;if(U)for(let D=0;D<U.args.length;D++)try{(0,s.validateConstraint)(c[D],U.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${U.args[D].name}' - ${U.args[D].description}`)}try{return await F.apply(j,c)}catch(D){if(i===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...c);x&&(i=x.command)}throw this._logService.error(D,i,T.extension?.identifier),g?new class extends Error{constructor(){super((0,w.toErrorMessage)(D)),this.id=i,this.source=T.extension?.displayName??T.extension?.name}}:D}}_reportTelemetry(i,c){!i.extension||i.extension.isBuiltin||Oe(this,S,"f").$publicLog2("Extension:ActionExecuted",{extensionId:i.extension.identifier.value,id:c})}$executeContributedCommand(i,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(c=c.map(g=>this._argumentProcessors.reduce((T,F)=>F.processArgument(T),g)),this._executeContributedCommand(i,c,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),Oe(this,d,"f").$getCommands().then(c=>(i&&(c=c.filter(g=>g[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(const[c,g]of this._commands){const{description:T}=g;T&&(i[c]=T)}return Promise.resolve(i)}};d=new WeakMap,S=new WeakMap,t=xe([$e(0,a.IExtHostRpcService),$e(1,y.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class h{constructor(i,c,g){this._commands=i,this._lookupApiCommand=c,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,c){if(!i)return;const g={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return g;const T=this._lookupApiCommand(i.command);if(T)g.id=T.internalId,g.arguments=T.args.map((F,j)=>F.convert(i.arguments&&i.arguments[j]));else if((0,A.isNonEmptyArray)(i.arguments)){const F=++this._cachIdPool;this._cache.set(F,i),c.add((0,C.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),g.$ident=F,g.id=this.delegatingCommandId,g.arguments=[F],this._logService.trace("CommandsConverter#CREATE",i.command,F)}return g}fromInternal(i){return typeof i.$ident=="number"?this._cache.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const c=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class r{constructor(i,c,g,T){this.name=i,this.description=c,this.validate=g,this.convert=T}optional(){return new r(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,c){return new r(i??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",u=>m.URI.isUri(u),u=>u),r.Position=new r("position","A position in a text document",u=>I.Position.isPosition(u),b.Position.from),r.Range=new r("range","A range in a text document",u=>I.Range.isRange(u),b.Range.from),r.Selection=new r("selection","A selection in a text document",u=>I.Selection.isSelection(u),b.Selection.from),r.Number=new r("number","",u=>typeof u=="number",u=>u),r.String=new r("string","",u=>typeof u=="string",u=>u),r.CallHierarchyItem=new r("item","A call hierarchy item",u=>u instanceof I.CallHierarchyItem,b.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",u=>u instanceof I.TypeHierarchyItem,b.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",u=>u instanceof l.TestItemImpl,b.TestItem.from);class n{constructor(i,c){this.description=i,this.convert=c}}e.ApiCommandResult=n,n.Void=new n("no result",u=>u);class o{constructor(i,c,g,T,F){this.id=i,this.internalId=c,this.description=g,this.args=T,this.result=F}}e.ApiCommand=o}),define(Ie[194],Ce([1,0,2,8,6,69,37,18,82,86,13]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(I.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,l)=>{if((0,A.isFalsyOrEmpty)(a))return;class f extends b.SymbolInformation{static to(w){const d=new f(w.name,I.SymbolKind.to(w.kind),w.containerName||"",new b.Location(l[0],I.Range.to(w.range)));return d.detail=w.detail,d.range=d.location.range,d.selectionRange=I.Range.to(w.selectionRange),d.children=w.children?w.children.map(f.to):[],d}}return a.map(f.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(I.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(I.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(I.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(I.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(I.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(l=>b.Position.isPosition(l)),a=>a.map(I.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(l=>{let f;for(const v of l.reverse())f=new b.SelectionRange(I.Range.to(v),f);return f}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(I.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:I.Range.to(a.range),placeholder:a.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new b.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const l=(0,y.decodeSemanticTokensDto)(a);if(l.type==="full")return new b.SemanticTokens(l.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new b.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const l=(0,y.decodeSemanticTokensDto)(a);if(l.type==="full")return new b.SemanticTokens(l.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,l,f)=>{if(!a)return new b.CompletionList([]);const v=a.suggestions.map(w=>I.CompletionItem.to(w,f));return new b.CompletionList(v,a.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,l,f)=>C(v=>new b.CodeLens(I.Range.to(v.range),v.command&&f.fromInternal(v.command)))(a))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>b.Range.isRange(a),a=>b.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,l,f)=>C(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const w=new b.CodeAction(v.title,v.kind?new b.CodeActionKind(v.kind):void 0);return v.edit&&(w.edit=I.WorkspaceEdit.to(v.edit)),v.command&&(w.command=f.fromInternal(v.command)),w.isPreferred=v.isPreferred,w}})(a))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(l=>new b.ColorInformation(I.Range.to(l.range),I.Color.to(l.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",a=>a instanceof b.Color,I.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,l,f)=>a.map(I.InlayHint.to.bind(void 0,f)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(l=>I.NotebookExclusiveDocumentPattern.to(l))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>s.URI.isUri(a)||typeof a=="string"&&(0,P.matchesSomeScheme)(a,R.Schemas.http,R.Schemas.https),a=>a),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[I.ViewColumn.from(a),void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[I.ViewColumn.from(a),void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(I.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(I.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(I.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(l){E.forEach(l.registerApiCommand,l)}}e.ExtHostApiCommands=m;function C(a){return l=>{if(Array.isArray(l))return l.map(a)}}function p(a){if(!Array.isArray(a))return;const l=[];for(const f of a)N.isLocationLink(f)?l.push(I.DefinitionLink.to(f)):l.push(I.location.to(f));return l}}),define(Ie[195],Ce([1,0,15,57,4,7,2,69,26,8,6,28,5]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(p,a,l){const f=p.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const i=this._commentControllers.get(u.handle);return i?i.value:u}else if(u&&u.$mid===7){const i=this._commentControllers.get(u.commentControlHandle);if(!i)return u;const c=i.getCommentThread(u.commentThreadHandle);return c?c.value:u}else if(u&&u.$mid===8){const i=this._commentControllers.get(u.thread.commentControlHandle);if(!i)return u;const c=i.getCommentThread(u.thread.commentThreadHandle);return c?{thread:c.value,text:u.text}:u}else if(u&&u.$mid===9){const i=this._commentControllers.get(u.thread.commentControlHandle);if(!i)return u;const c=i.getCommentThread(u.thread.commentThreadHandle);if(!c)return u;const g=u.commentUniqueId,T=c.getCommentByUniqueId(g);return T||u}else if(u&&u.$mid===10){const i=this._commentControllers.get(u.thread.commentControlHandle);if(!i)return u;const c=i.getCommentThread(u.thread.commentThreadHandle);if(!c)return u;const g=u.text,T=u.commentUniqueId,F=c.getCommentByUniqueId(T);return F?(typeof F.body=="string"?F.body=g:F.body.value=g,F):u}return u}})}createCommentController(u,i,c){const g=v.handlePool++,T=new d(u,g,i,c);this._commentControllers.set(T.handle,T);const F=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return F.push(T),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),F),T.value}$createCommentThreadTemplate(u,i,c){const g=this._commentControllers.get(u);!g||g.$createCommentThreadTemplate(i,c)}async $updateCommentThreadTemplate(u,i,c){const g=this._commentControllers.get(u);!g||g.$updateCommentThreadTemplate(i,c)}$deleteCommentThread(u,i){this._commentControllers.get(u)?.$deleteCommentThread(i)}$provideCommentingRanges(u,i,c){const g=this._commentControllers.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const T=l.getDocument(_.URI.revive(i));return(0,s.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(T,c)).then(F=>F?F.map(j=>P.Range.from(j)):void 0)}$toggleReaction(u,i,c,g,T){const F=this._commentControllers.get(u);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const j=F.getCommentThread(i);if(j){const U=j.getCommentByUniqueId(g.uniqueIdInThread);if(F!==void 0&&U&&F.reactionHandler)return F.reactionHandler(U,h(T))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class w{set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(u){(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=u,this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,i,c,g,T,F,j,U){this._commentControllerHandle=i,this._id=c,this._uri=g,this._range=T,this._comments=F,this.extensionDescription=j,this._isTemplate=U,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),f.$createCommentThread(i,this.handle,this._id,this._uri,P.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(i,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(x){D.range=x},get comments(){return D.comments},set comments(x){D.comments=x},get collapsibleState(){return D.collapsibleState},set collapsibleState(x){D.collapsibleState=x},get canReply(){return D.canReply},set canReply(x){D.canReply=x},get contextValue(){return D.contextValue},set contextValue(x){D.contextValue=x},get label(){return D.label},set label(x){D.label=x},get state(){return D.state},set state(x){D.state=x},dispose:()=>{D.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const u=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),i={};u("range")&&(i.range=P.Range.from(this._range)),u("label")&&(i.label=this.label),u("contextValue")&&(i.contextValue=this.contextValue??null),u("comments")&&(i.comments=this._comments.map(c=>S(this,c,this._commentsMap))),u("collapsibleState")&&(i.collapseState=r(this._collapseState)),u("canReply")&&(i.canReply=this.canReply),u("state")&&(i.state=n(this._state)),u("isTemplate")&&(i.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,i)}getCommentByUniqueId(u){for(const i of this._commentsMap){const c=i[0],g=i[1];if(u===g)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}w._handlePool=0,xe([(0,I.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class d{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(u,i,c,g){this._extension=u,this._handle=i,this._id=c,this._label=g,this._threads=new Map,f.$registerCommentController(this.handle,c,g);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(F){T.options=F},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(F){T.commentingRangeProvider=F},get reactionHandler(){return T.reactionHandler},set reactionHandler(F){T.reactionHandler=F},createCommentThread(F,j,U){return T.createCommentThread(F,j,U).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(u,i,c,g){if(typeof u=="string"){const T=new w(this.id,this.handle,u,i,c,g,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new w(this.id,this.handle,void 0,u,i,c,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(u,i){const c=new w(this.id,this.handle,void 0,_.URI.revive(u),P.Range.to(i),[],this._extension,!0);return c.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(u,i){const c=this._threads.get(u);c&&(c.range=P.Range.to(i))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function S(o,u,i){let c=i.get(u);c||(c=++o.commentHandle,i.set(u,c));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:c,body:typeof u.body=="string"?u.body:P.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(T=>t(T)):void 0,timestamp:u.timestamp?.toJSON()}}function t(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function h(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?_.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function r(o){if(o!==void 0)switch(o){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(o){if(o!==void 0)switch(o){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new v}e.createExtHostComments=C}),define(Ie[196],Ce([1,0,25,5,27,14]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(R,E){this._mainThreadConsole=R.getProxy(I.MainContext.MainThreadConsole),this._includeStack=E.consoleForward.includeStack,this._logNative=E.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,E){const m=this,C=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,E,C,arguments)}})}_handleConsoleCall(R,E,m,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:E,arguments:y(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,C)}};_=xe([$e(0,N.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function y(P,R){const E=[];if(P.length)for(let m=0;m<P.length;m++){let C=P[m];if(typeof C>"u")C="undefined";else if(C instanceof Error){const p=C;p.stack?C=p.stack:C=p.toString()}E.push(C)}if(R){const m=new Error().stack;m&&E.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,s.safeStringify)(E);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[97],Ce([1,0,2,5,6,3,14,11,18,10,19]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Oi{constructor(C,p){this._logService=p,this._provider=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,p){const a=Oi._handlePool++;this._provider.set(a,{provider:C,extensionId:p}),this._proxy.$registerDecorationProvider(a,p.value);const l=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(a,null);return}const v=(0,y.asArray)(f);if(v.length<=Oi._maxEventSize){this._proxy.$onDidChange(a,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,v.length);const w=v.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),d=(0,y.groupBy)(w,(t,h)=>t.rank-h.rank||(0,P.compare)(t.uri.path,h.uri.path)),S=[];e:for(const t of d){let h;for(const r of t){const n=(0,R.dirname)(r.uri.path);if(h!==n&&(h=n,S.push(r.uri)>=Oi._maxEventSize))break e}}this._proxy.$onDidChange(a,S)});return new b.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(C,p,a){if(!this._provider.has(C))return Object.create(null);const l=Object.create(null),{provider:f,extensionId:v}=this._provider.get(C);return await Promise.all(p.map(async w=>{try{const{uri:d,id:S}=w,t=await Promise.resolve(f.provideFileDecoration(s.URI.revive(d),a));if(!t)return;try{b.FileDecoration.validate(t),l[S]=[t.propagate,t.tooltip,t.badge,t.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${v.value}': ${h}`)}}catch(d){this._logService.error(d)}})),l}};E._handlePool=0,E._maxEventSize=250,E=xe([$e(0,_.IExtHostRpcService),$e(1,A.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[197],Ce([1,0,130,85,2,5,6,8,4,11,24,36]),function(ne,e,s,I,b,N,_,A,y,P,R,E){"use strict";var m,C,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(v,w,d,S,t,h){this._name=v,this._owner=w,this._maxDiagnosticsPerFile=d,m.set(this,void 0),C.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Ye(this,p,new R.ResourceMap(r=>S.getComparisonKey(r)),"f"),Ye(this,m,t,"f"),Ye(this,C,h,"f")}dispose(){this._isDisposed||(Oe(this,C,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,w){if(!v){this.clear();return}this._checkDisposed();let d=[];if(b.URI.isUri(v)){if(!w){this.delete(v);return}Oe(this,p,"f").set(v,w.slice()),d=[v]}else if(Array.isArray(v)){d=[];let t;v=[...v].sort(a._compareIndexedTuplesByUri);for(const h of v){const[r,n]=h;if((!t||r.toString()!==t.toString())&&(t&&Oe(this,p,"f").get(t).length===0&&Oe(this,p,"f").delete(t),t=r,d.push(r),Oe(this,p,"f").set(r,[])),n)Oe(this,p,"f").get(r)?.push(...n);else{const o=Oe(this,p,"f").get(r);o&&(o.length=0)}}}if(Oe(this,C,"f").fire(d),!Oe(this,m,"f"))return;const S=[];for(const t of d){let h=[];const r=Oe(this,p,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const n=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const u of r)if(u.severity===n[o]&&h.push(A.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;h.push({severity:I.MarkerSeverity.Info,message:(0,s.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(n=>A.Diagnostic.from(n));S.push([t,h])}Oe(this,m,"f").$changeMany(this._owner,S)}delete(v){this._checkDisposed(),Oe(this,C,"f").fire([v]),Oe(this,p,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,C,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,p,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,w){this._checkDisposed();for(const[d,S]of this)v.call(w,d,S,this)}*[(m=new WeakMap,C=new WeakMap,p=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,p,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const w=Oe(this,p,"f").get(v);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,p,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,w){return v[0].toString()<w[0].toString()?-1:v[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=a;let l=class li{static _mapper(v){const w=new R.ResourceMap;for(const d of v)w.set(d,d);return{uris:Object.freeze(Array.from(w.values()))}}constructor(v,w,d){this._logService=w,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=v.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,w){const{_collections:d,_proxy:S,_onDidChangeDiagnostics:t,_logService:h,_fileSystemInfoService:r}=this,n=new class{$changeMany(i,c){S.$changeMany(i,c),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,i,c.length===0?"CLEARING":c)}$clear(i){S.$clear(i),h.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,i)}dispose(){S.dispose()}};let o;if(!w)w="_generated_diagnostic_collection_name_#"+li._idPool++,o=w;else if(!d.has(w))o=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do o=w+li._idPool++;while(d.has(o))}return new class extends a{constructor(){super(w,o,li._maxDiagnosticsPerFile,r.extUri,n,t),d.set(o,this)}dispose(){super.dispose(),d.delete(o)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const w=new Map,d=[];for(const S of this._collections.values())S.forEach((t,h)=>{let r=w.get(t.toString());typeof r>"u"&&(r=d.length,w.set(t.toString(),r),d.push([t,[]])),d[r][1]=d[r][1].concat(...h)});return d}}_getDiagnostics(v){let w=[];for(const d of this._collections.values())d.has(v)&&(w=w.concat(d.get(v)));return w}$acceptMarkersChange(v){if(!this._mirrorCollection){const w="_generated_mirror",d=new a(w,w,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(w,d),this._mirrorCollection=d}for(const[w,d]of v)this._mirrorCollection.set(b.URI.revive(w),d.map(A.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=xe([$e(1,P.ILogService),$e(2,E.IExtHostFileSystemInfo)],l),e.ExtHostDiagnostics=l}),define(Ie[198],Ce([1,0,2,5]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(_){this._proxy=_.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(y=>s.URI.revive(y)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?s.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(Ie[199],Ce([1,0,12,2,6,5,13,21,10]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,m,C){this._documentsAndEditors=m,this._logService=C,this._documentContentProviders=new Map,this._proxy=E.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,m){if(Object.keys(_.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const C=P._handlePool++;this._documentContentProviders.set(C,m),this._proxy.$registerTextContentProvider(C,E);let p;return typeof m.onDidChange=="function"&&(p=m.onDidChange(a=>{if(a.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(C,a).then(l=>{if(!l&&typeof l!="string")return;const f=this._documentsAndEditors.getDocument(a);if(!f)return;const v=(0,y.splitLines)(l);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(a,l)},s.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(E,m){const C=this._documentContentProviders.get(E);return C?Promise.resolve(C.provideTextDocumentContent(I.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ie[200],Ce([1,0,4,7,2,5,93,8,9,25,6]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(C,p){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const l of a)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const l of a)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const p=this._documentsAndEditors.getDocument(C);if(p)return p}getDocument(C){const p=this.getDocumentData(C);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return p.document}ensureDocumentData(C){const p=this._documentsAndEditors.getDocument(C);if(p)return Promise.resolve(p);let a=this._documentLoader.get(C.toString());return a||(a=this._proxy.$tryOpenDocument(C).then(l=>{this._documentLoader.delete(C.toString());const f=b.URI.revive(l);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(f))},l=>(this._documentLoader.delete(C.toString()),Promise.reject(l))),this._documentLoader.set(C.toString(),a)),a}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(p=>b.URI.revive(p))}$acceptModelLanguageChanged(C,p){const a=b.URI.revive(C),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(p),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(C){const p=b.URI.revive(C),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(C,p){const a=b.URI.revive(C),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");l._acceptIsDirty(p),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,p,a){const l=b.URI.revive(C),f=this._documentsAndEditors.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),f.onEvents(p);let v;p.isUndoing?v=R.TextDocumentChangeReason.Undo:p.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:f.document,contentChanges:p.changes.map(w=>({range:A.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text})),reason:v}))}setWordDefinitionFor(C,p){(0,_.setWordDefinitionFor)(C,p)}}e.ExtHostDocuments=E}),define(Ie[52],Ce([1,0,46,4,7,2,3,5,93,14,96,8,11,24,13,170,201]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(d,S){this._extHostRpc=d,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const S=[],t=[],h=[];if(d.removedDocuments)for(const r of d.removedDocuments){const n=N.URI.revive(r),o=this._documents.get(n);o?.unref()&&(this._documents.delete(n),S.push(o.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const n=N.URI.revive(r.uri);let o=this._documents.get(n);if(o&&n.scheme!==p.Schemas.vscodeNotebookCell&&n.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);o||(o=new f(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(d.removedEditors)for(const r of d.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&h.push(n)}if(d.addedEditors)for(const r of d.addedEditors){const n=N.URI.revive(r.documentUri);s.ok(this._documents.has(n),`document '${n}' does not exist`),s.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(n).value,u=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new l.Lazy(()=>o.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(i=>E.Range.to(i)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,u)}d.newActiveEditor!==void 0&&(s.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,b.dispose)(S),(0,b.dispose)(h),d.removedDocuments&&this._onDidRemoveDocuments.fire(S),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return d?S:S?.value}allEditors(){return[...this._editors.values()]}};v=xe([$e(0,P.IExtHostRpcService),$e(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[53],Ce([1,0,8,5,2,4,3,6,14,9,76]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class E{constructor(l,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(l)}get apiObject(){if(!this._apiObject){const l=this,f={get isActive(){return l._dto.id===l._activeTabIdGetter()},get label(){return l._dto.label},get input(){return l._input},get isDirty(){return l._dto.isDirty},get isPinned(){return l._dto.isPinned},get isPreview(){return l._dto.isPreview},get group(){return l._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(l){this._dto=l,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(l,f){this._tabs=[],this._activeTabId="",this._dto=l,this._activeGroupIdGetter=f;for(const v of l.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new E(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const l=this,f={get isActive(){return l._dto.groupId===l._activeGroupIdGetter()},get viewColumn(){return s.ViewColumn.to(l._dto.viewColumn)},get activeTab(){return l._tabs.find(v=>v.tabId===l._activeTabId)?.apiObject},get tabs(){return Object.freeze(l._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(l){this._dto=l}acceptTabOperation(l){if(l.kind===0){const v=new E(l.tabDto,this,()=>this.activeTabId());return this._tabs.splice(l.index,0,v),l.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(l.kind===1){const v=this._tabs.splice(l.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(l.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this._tabs.splice(l.index,0,v),v}const f=this._tabs.find(v=>v.tabId===l.tabDto.id);if(!f)throw new Error("INVALID tab");return l.tabDto.isActive?this._activeTabId=l.tabDto.id:this._activeTabId===l.tabDto.id&&!l.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(l.tabDto),f}activeTabId(){return this._activeTabId}}let C=class{constructor(l){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=l.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const l=this,f={onDidChangeTabGroups:l._onDidChangeTabGroups.event,onDidChangeTabs:l._onDidChangeTabs.event,get all(){return Object.freeze(l._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=l._activeGroupId;return(0,P.assertIsDefined)(l._extHostTabGroups.find(d=>d.groupId===v)?.apiObject)},close:async(v,w)=>{const d=Array.isArray(v)?v:[v];return d.length?p(d[0])?this._closeGroups(d,w):this._closeTabs(d,w):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(l){const f=new Set(this._extHostTabGroups.map(r=>r.groupId)),v=new Set(l.map(r=>r.groupId)),w=(0,R.diffSets)(f,v),d=this._extHostTabGroups.filter(r=>w.removed.includes(r.groupId)).map(r=>r.apiObject),S=[],t=[];this._extHostTabGroups=l.map(r=>{const n=new m(r,()=>this._activeGroupId);return w.added.includes(n.groupId)?S.push(n.apiObject):t.push(n.apiObject),n});const h=(0,P.assertIsDefined)(l.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:S,closed:d,changed:t}))}$acceptTabGroupUpdate(l){const f=this._extHostTabGroups.find(v=>v.groupId===l.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(l),l.isActive&&(this._activeGroupId=l.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const f=this._extHostTabGroups.find(w=>w.groupId===l.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(l);switch(l.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(l){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===l)return v}_findExtHostTabGroupFromApi(l){return this._extHostTabGroups.find(f=>f.apiObject===l)}async _closeTabs(l,f){const v=[];for(const w of l){const d=this._findExtHostTabFromApi(w);if(!d)throw new Error("Tab close: Invalid tab not found!");v.push(d.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(l,f){const v=[];for(const w of l){const d=this._findExtHostTabGroupFromApi(w);if(!d)throw new Error("Group close: Invalid group not found!");v.push(d.groupId)}return this._proxy.$closeGroup(v,f)}};C=xe([$e(0,y.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function p(a){return a.tabs!==void 0}}),define(Ie[202],Ce([1,0,2,5,7,6,8,247,10,23,28]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let l,f,v=14,w=14;for(const d of p){let S=l?(0,y.commonPrefixLength)(l,d):0;for(S===0?f=1:f=w;S<d.length;S++)S+1===d.length?(v=w,w=9):w+=1,a.push([f,d.toUpperCase().charCodeAt(S),w]),a.push([f,d.toLowerCase().charCodeAt(S),w]),f=w;l=d,w=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new A.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],l=A.LinkComputer.computeLinks({getLineContent(f){return p.lineAt(f-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const f of l){const v=_.DocumentLink.to(f);v.target&&a.push(v)}return a}}class m{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new E,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,a,l,f={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,l);let w=2;f.isCaseSensitive&&(w+=1024),f.isReadonly&&(w+=2048),typeof l.copy=="function"&&(w+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),w+=4),this._proxy.$registerFileSystemProvider(v,a,w).catch(S=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${a}`),console.error(S)});const d=l.onDidChangeFile(S=>{const t=[];for(const h of S){const{uri:r,type:n}=h;if(r.scheme!==a)continue;let o;switch(n){case N.FileChangeType.Changed:o=0;break;case N.FileChangeType.Created:o=1;break;case N.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:o})}this._proxy.$onFileSystemChange(v,t)});return(0,b.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(p){const{type:a,ctime:l,mtime:f,size:v,permissions:w}=p;return{type:a,ctime:l,mtime:f,size:v,permissions:w}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(s.URI.revive(a))).then(l=>m._asIStat(l))}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(s.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(s.URI.revive(a))).then(l=>P.VSBuffer.wrap(l))}$writeFile(p,a,l,f){return Promise.resolve(this._getFsProvider(p).writeFile(s.URI.revive(a),l.buffer,f))}$delete(p,a,l){return Promise.resolve(this._getFsProvider(p).delete(s.URI.revive(a),l))}$rename(p,a,l,f){return Promise.resolve(this._getFsProvider(p).rename(s.URI.revive(a),s.URI.revive(l),f))}$copy(p,a,l,f){const v=this._getFsProvider(p);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(s.URI.revive(a),s.URI.revive(l),f))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(s.URI.revive(a)))}$watch(p,a,l,f){const v=this._getFsProvider(p).watch(s.URI.revive(l),f);this._watches.set(a,v)}$unwatch(p,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(p,a,l){const f=this._getFsProvider(p);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(s.URI.revive(a),l))}$close(p,a){const l=this._getFsProvider(p);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(p,a,l,f){const v=this._getFsProvider(p);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const w=P.VSBuffer.alloc(f);return Promise.resolve(v.read(a,l,w.buffer,0,f)).then(d=>w.slice(0,d))}$write(p,a,l,f){const v=this._getFsProvider(p);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,l,f.buffer,0,f.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=m}),define(Ie[54],Ce([1,0,5,35,6,23,3,14,36,7]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(m,C){this._fileSystemProvider=new Map,this._proxy=m.getProxy(s.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(a){try{const l=p._fileSystemProvider.get(a.scheme);if(!l)return await p._proxy.$stat(a);await p._proxy.$ensureActivation(a.scheme);const f=await l.stat(a);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(l){Yt._handleError(l)}},async readDirectory(a){try{const l=p._fileSystemProvider.get(a.scheme);return l?(await p._proxy.$ensureActivation(a.scheme),(await l.readDirectory(a)).slice()):await p._proxy.$readdir(a)}catch(l){return Yt._handleError(l)}},async createDirectory(a){try{return await p._proxy.$mkdir(a)}catch(l){return Yt._handleError(l)}},async readFile(a){try{const l=p._fileSystemProvider.get(a.scheme);return l?(await p._proxy.$ensureActivation(a.scheme),(await l.readFile(a)).slice()):(await p._proxy.$readFile(a)).buffer}catch(l){return Yt._handleError(l)}},async writeFile(a,l){try{return await p._proxy.$writeFile(a,N.VSBuffer.wrap(l))}catch(f){return Yt._handleError(f)}},async delete(a,l){try{const f=p._fileSystemProvider.get(a.scheme);return f?(await p._proxy.$ensureActivation(a.scheme),await f.delete(a,{recursive:!1,...l})):await p._proxy.$delete(a,{recursive:!1,useTrash:!1,...l})}catch(f){return Yt._handleError(f)}},async rename(a,l,f){try{return await p._proxy.$rename(a,l,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},async copy(a,l,f){try{return await p._proxy.$copy(a,l,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},isWritableFileSystem(a){const l=C.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case I.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case I.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case I.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case I.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,C){return this._fileSystemProvider.set(m,C),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=xe([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[203],Ce([1,0,4,34,2,5,8,6]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(E,m,C,p,a,l,f,v){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter;const w=this.ensureWatching(E,C,a);this._config=0,l&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const d=(0,I.parse)(a),S=typeof a=="string",t=p(h=>{if(!l)for(const r of h.created){const n=b.URI.revive(r);d(n.fsPath)&&(!S||m.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!f)for(const r of h.changed){const n=b.URI.revive(r);d(n.fsPath)&&(!S||m.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!v)for(const r of h.deleted){const n=b.URI.revive(r);d(n.fsPath)&&(!S||m.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(w,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(E,m,C){const p=A.Disposable.from();if(typeof C=="string")return p;const a=E.getProxy(N.MainContext.MainThreadFileSystem);let l=!1;(C.pattern.includes(I.GLOBSTAR)||C.pattern.includes(I.GLOB_SPLIT))&&(l=!0);const f=Math.random();return a.$watch(m.identifier.value,f,C.baseUri,{recursive:l,excludes:[]}),A.Disposable.from({dispose:()=>a.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(E,m,C){this._mainContext=E,this._logService=m,this._extHostDocumentsAndEditors=C,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,m,C,p,a,l){return new y(this._mainContext,E,m,this._onFileSystemEvent.event,_.GlobPattern.from(C),p,a,l)}$onFileEvent(E){this._onFileSystemEvent.fire(E)}$onDidRunFileOperation(E,m){switch(E){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(C=>({oldUri:b.URI.revive(C.source),newUri:b.URI.revive(C.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(C=>b.URI.revive(C.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(C=>b.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,m){return(C,p,a)=>{const l=function(v){C.call(p,v)};return l.extension=E,m.event(l,void 0,a)}}async $onWillRunFileOperation(E,m,C,p){switch(E){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(a=>({oldUri:b.URI.revive(a.source),newUri:b.URI.revive(a.target)}))},C,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(a=>b.URI.revive(a.target))},C,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(a=>b.URI.revive(a.target))},C,p)}}async _fireWillEvent(E,m,C,p){const a=new Set,l=[];if(await E.fireAsync(m,p,async(v,w)=>{const d=Date.now(),S=await Promise.resolve(v);S instanceof A.WorkspaceEdit&&(l.push([w.extension,S]),a.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-d>C&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),p.isCancellationRequested||l.length===0)return;const f={edits:[]};for(const[,v]of l){const{edits:w}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:d=>this._extHostDocumentsAndEditors.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(w)}return{edit:f,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=P}),define(Ie[204],Ce([1,0,2,37]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(_,A,y,P,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=P;const E=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new I.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new I.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new I.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new I.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:s.URI.revive(m.notebookUri),inputUri:s.URI.revive(m.inputUri),notebookEditor:C.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:s.URI.revive(m.notebookUri),inputUri:s.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(E)}$willAddInteractiveDocument(_,A,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=b}),define(Ie[205],Ce([1,0,7,5]),function(ne,e,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(_){this._handlePool=0,this._proxy=_.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(Ie[206],Ce([1,0,2,25,8,6,69,5,10,51,18,9,248,21,7,82,77,62,207,12,15,28]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentSymbols(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentSymbols(V,B);if(!(0,R.isFalsyOrEmpty)(q))return q[0]instanceof N.DocumentSymbol?q.map(b.DocumentSymbol.from):t._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((q,oe)=>{let ce=q.location.range.start.compareTo(oe.location.range.start);return ce===0&&(ce=oe.location.range.end.compareTo(q.location.range.end)),ce});const B=[],V=[];for(const q of k){const oe={name:q.name||"!!MISSING: name!!",kind:b.SymbolKind.from(q.kind),tags:q.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:b.Range.from(q.location.range),selectionRange:b.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(oe),B.push(oe);break}const ce=V[V.length-1];if(P.Range.containsRange(ce.range,oe.range)&&!P.Range.equalsRange(ce.range,oe.range)){ce.children?.push(oe),V.push(oe);break}V.pop()}}return B}}class h{constructor(k,B,V){this._documents=k,this._commands=B,this._provider=V,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideCodeLenses(V,B);if(!q||B.isCancellationRequested)return;const oe=this._cache.add(q),ce=new p.DisposableStore;this._disposables.set(oe,ce);const J={cacheId:oe,lenses:[]};for(let Ee=0;Ee<q.length;Ee++)J.lenses.push({cacheId:[oe,Ee],range:b.Range.from(q[Ee].range),command:this._commands.toInternal(q[Ee].command,ce)});return J}async resolveCodeLens(k,B){const V=k.cacheId&&this._cache.get(...k.cacheId);if(!V)return;let q;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?q=V:q=await this._provider.resolveCodeLens(V,B),q||(q=V),B.isCancellationRequested)return;const oe=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!oe)return k.command=this._commands.toInternal(q.command??h._badCmd,oe),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(Z){return Array.isArray(Z)?Z.map(b.DefinitionLink.from):Z?[b.DefinitionLink.from(Z)]:[]}class n{constructor(k,B){this._documents=k,this._provider=B}async provideDefinition(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDefinition(q,oe,V);return r(ce)}}class o{constructor(k,B){this._documents=k,this._provider=B}async provideDeclaration(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDeclaration(q,oe,V);return r(ce)}}class u{constructor(k,B){this._documents=k,this._provider=B}async provideImplementation(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideImplementation(q,oe,V);return r(ce)}}class i{constructor(k,B){this._documents=k,this._provider=B}async provideTypeDefinition(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideTypeDefinition(q,oe,V);return r(ce)}}class c{constructor(k,B){this._documents=k,this._provider=B}async provideHover(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideHover(q,oe,V);if(!(!ce||(0,R.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(oe)),ce.range||(ce.range=new N.Range(oe,oe)),b.Hover.from(ce)}}class g{constructor(k,B){this._documents=k,this._provider=B}async provideEvaluatableExpression(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideEvaluatableExpression(q,oe,V);if(ce)return b.EvaluatableExpression.from(ce)}}class T{constructor(k,B){this._documents=k,this._provider=B}async provideInlineValues(k,B,V,q){const oe=this._documents.getDocument(k),ce=await this._provider.provideInlineValues(oe,b.Range.to(B),b.InlineValueContext.to(V),q);if(Array.isArray(ce))return ce.map(J=>b.InlineValue.from(J))}}class F{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentHighlights(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDocumentHighlights(q,oe,V);if(Array.isArray(ce))return ce.map(b.DocumentHighlight.from)}}class j{constructor(k,B){this._documents=k,this._provider=B}async provideLinkedEditingRanges(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideLinkedEditingRanges(q,oe,V);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,R.coalesce)(ce.ranges.map(b.Range.from)),wordPattern:ce.wordPattern}}}class U{constructor(k,B){this._documents=k,this._provider=B}async provideReferences(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideReferences(oe,ce,V,q);if(Array.isArray(J))return J.map(b.location.from)}}class D{constructor(k,B,V,q,oe,ce,J){this._documents=k,this._commands=B,this._diagnostics=V,this._provider=q,this._logService=oe,this._extension=ce,this._apiDeprecation=J,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,B,V,q){const oe=this._documents.getDocument(k),ce=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),J=[];for(const Ge of this._diagnostics.getDiagnostics(k))if(ce.intersection(Ge.range)&&J.push(Ge)>D._maxCodeActionsPerFile)break;const Ee={diagnostics:J,only:V.only?new N.CodeActionKind(V.only):void 0,triggerKind:b.CodeActionTriggerKind.to(V.trigger)},ve=await this._provider.provideCodeActions(oe,ce,Ee,q);if(!(0,R.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ne=this._cache.add(ve),ze=new p.DisposableStore;this._disposables.set(Ne,ze);const Je=[];for(let Ge=0;Ge<ve.length;Ge++){const Pe=ve[Ge];!Pe||(D._isCommand(Pe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,ze)})):(Ee.only&&(Pe.kind?Ee.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,ze),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(b.Diagnostic.from),edit:Pe.edit&&b.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(k,B){const[V,q]=k,oe=this._cache.get(V,q);if(!oe||D._isCommand(oe)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(oe,B)??oe;return ce?.edit?b.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}D._maxCodeActionsPerFile=1e3;class x{constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async prepareDocumentPaste(k,B,V,q){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(k),ce=B.map(Ee=>b.Range.to(Ee)),J=b.DataTransfer.toDataTransfer(V,()=>{throw new w.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,ce,J,q),b.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=V.map(Ne=>b.Range.to(Ne)),Ee=b.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentPasteEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?b.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class M{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentFormattingEdits(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentFormattingEdits(q,B,V);if(Array.isArray(oe))return oe.map(b.TextEdit.from)}}class O{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeFormattingEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Range.to(B),J=await this._provider.provideDocumentRangeFormattingEdits(oe,ce,V,q);if(Array.isArray(J))return J.map(b.TextEdit.from)}}class H{constructor(k,B){this._documents=k,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,B,V,q,oe){const ce=this._documents.getDocument(k),J=b.Position.to(B),Ee=await this._provider.provideOnTypeFormattingEdits(ce,J,V,q,oe);if(Array.isArray(Ee))return Ee.map(b.TextEdit.from)}}class W{constructor(k,B){this._provider=k,this._logService=B,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,B){const V=await this._provider.provideWorkspaceSymbols(k,B);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const q=this._cache.add(V),oe={cacheId:q,symbols:[]};for(let ce=0;ce<V.length;ce++){const J=V[ce];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}oe.symbols.push({...b.WorkspaceSymbol.from(J),cacheId:[q,ce]})}return oe}async resolveWorkspaceSymbol(k,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const V=this._cache.get(...k.cacheId);if(V){const q=await this._provider.resolveWorkspaceSymbol(V,B);return q&&(0,I.mixin)(k,b.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class z{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideRenameEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B);try{const J=await this._provider.provideRenameEdits(oe,ce,V,q);return J?b.WorkspaceEdit.from(J):void 0}catch(J){const Ee=z._asMessage(J);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(k,B,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(k),oe=b.Position.to(B);try{const ce=await this._provider.prepareRename(q,oe,V);let J,Ee;if(N.Range.isRange(ce)?(J=ce,Ee=q.getText(ce)):(0,E.isObject)(ce)&&(J=ce.range,Ee=ce.placeholder),!J||!Ee)return;if(J.start.line>oe.line||J.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(J),text:Ee}}catch(ce){const J=z._asMessage(ce);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class G{constructor(k,B){this.resultId=k,this.tokens=B}}class te{constructor(k,B){this._documents=k,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=B!==0?this._previousResults.get(B):null;let ce=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,oe.resultId,V):await this._provider.provideDocumentSemanticTokens(q,V);return oe&&this._previousResults.delete(B),ce?(ce=te._fixProvidedSemanticTokens(ce),this._send(te._convertToEdits(oe,ce),ce)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return te._isSemanticTokens(k)?te._isCorrectSemanticTokens(k)?k:new N.SemanticTokens(new Uint32Array(k.data),k.resultId):te._isSemanticTokensEdits(k)?te._isCorrectSemanticTokensEdits(k)?k:new N.SemanticTokensEdits(k.edits.map(B=>new N.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const B of k.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,B){if(!te._isSemanticTokens(B)||!k||!k.tokens)return B;const V=k.tokens,q=V.length,oe=B.data,ce=oe.length;let J=0;const Ee=Math.min(q,ce);for(;J<Ee&&V[J]===oe[J];)J++;if(J===q&&J===ce)return new N.SemanticTokensEdits([],B.resultId);let ve=0;const Ne=Ee-J;for(;ve<Ne&&V[q-ve-1]===oe[ce-ve-1];)ve++;return new N.SemanticTokensEdits([{start:J,deleteCount:q-J-ve,data:oe.subarray(J,ce-ve)}],B.resultId)}_send(k,B){if(te._isSemanticTokens(k)){const V=this._nextResultId++;return this._previousResults.set(V,new G(k.resultId,k.data)),(0,a.encodeSemanticTokensDto)({id:V,type:"full",data:k.data})}if(te._isSemanticTokensEdits(k)){const V=this._nextResultId++;return te._isSemanticTokens(B)?this._previousResults.set(V,new G(B.resultId,B.data)):this._previousResults.set(V,new G(k.resultId)),(0,a.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(k.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}e.DocumentSemanticTokensAdapter=te;class he{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentRangeSemanticTokens(q,b.Range.to(B),V);return oe?this._send(oe):null}_send(k){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=he;class re{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._apiDeprecation=q,this._extension=oe,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=oe.getWordRangeAtPosition(ce)||new N.Range(ce,ce),Ee=J.with({end:ce}),ve=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,ce,q,b.CompletionContext.to(V));if(!Ne||q.isCancellationRequested)return;const ze=Array.isArray(Ne)?new N.CompletionList(Ne):Ne,Je=re.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ge=new p.DisposableStore;this._disposables.set(Je,Ge);const Pe=[],nt={x:Je,b:Pe,a:{replace:b.Range.from(J),insert:b.Range.from(Ee)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let X=0;X<ze.items.length;X++){const Y=ze.items[X],me=this._convertCompletionItem(Y,[Je,X],Ee,J);Pe.push(me)}return nt}async resolveCompletionItem(k,B){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveCompletionItem(V,B);if(!!q)return this._convertCompletionItem(q,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,B,V,q){const oe=this._disposables.get(B[0]);if(!oe)throw Error("DisposableStore is missing...");const ce={x:B,a:k.label,b:k.kind!==void 0?b.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(b.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:b.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(k.command,oe)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=k.textEdit.newText):typeof k.insertText=="string"?ce.h=k.insertText:k.insertText instanceof N.SnippetString&&(ce.h=k.insertText.value,ce.i|=4);let J;return k.textEdit?J=k.textEdit.range:k.range&&(J=k.range),N.Range.isRange(J)?ce.j=b.Range.from(J):J&&(!V?.isEqual(J.inserting)||!q?.isEqual(J.replacing))&&(ce.j={insert:b.Range.from(J.inserting),replace:b.Range.from(J.replacing)}),ce}}class be{async provideInlineCompletions(k,B,V,q){}disposeCompletions(k){}handleDidShowCompletionItem(k,B){}}class le extends be{constructor(k,B,V,q){super(),this._extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this._isAdditionsProposedApiEnabled=(0,S.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,S.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:b.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new p.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new p.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class fe extends be{constructor(k,B,V,q){super(),this.extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this.isAdditionProposedApiEnabled=(0,S.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:b.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new p.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new p.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class Q{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const B=this._idPool++;return this._references.set(B,k),B}disposeReferenceId(k){const B=this._references.get(k);return this._references.delete(k),B}get(k){return this._references.get(k)}}class pe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=this.reviveContext(V),Ee=await this._provider.provideSignatureHelp(oe,ce,q,J);if(Ee){const ve=this._cache.add([Ee]);return{...b.SignatureHelp.from(Ee),id:ve}}}reviveContext(k){let B;if(k.activeSignatureHelp){const V=b.SignatureHelp.to(k.activeSignatureHelp),q=this._cache.get(k.activeSignatureHelp.id,0);q?(B=q,B.activeSignature=V.activeSignature,B.activeParameter=V.activeParameter):B=V}return{...k,activeSignatureHelp:B}}releaseSignatureHelp(k){this._cache.delete(k)}}class Se{constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._logService=q,this._extension=oe,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,B,V){const q=this._documents.getDocument(k),oe=b.Range.to(B),ce=await this._provider.provideInlayHints(q,oe,V);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(V.isCancellationRequested)return;const J=this._cache.add(ce);this._disposables.set(J,new p.DisposableStore);const Ee={hints:[],cacheId:J};for(let ve=0;ve<ce.length;ve++)this._isValidInlayHint(ce[ve],oe)&&Ee.hints.push(this._convertInlayHint(ce[ve],[J,ve]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ee}async resolveInlayHint(k,B){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveInlayHint(V,B);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,B){return k.label.length===0||Array.isArray(k.label)&&k.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(B&&!B.contains(k.position))}_convertInlayHint(k,B){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(k.tooltip),position:b.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(b.TextEdit.from),kind:k.kind&&b.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?q.label=k.label:q.label=k.label.map(oe=>{const ce={label:oe.value};return ce.tooltip=b.MarkdownString.fromStrict(oe.tooltip),N.Location.isLocation(oe.location)&&(ce.location=b.location.from(oe.location)),oe.command&&(ce.command=this._commands.toInternal(oe.command,V)),ce}),q}}class Fe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new f.Cache("DocumentLink")}async provideLinks(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentLinks(V,B);if(!(!Array.isArray(q)||q.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Fe._validateLink).map(b.DocumentLink.from)};{const oe=this._cache.add(q),ce={links:[],cacheId:oe};for(let J=0;J<q.length;J++){if(!Fe._validateLink(q[J]))continue;const Ee=b.DocumentLink.from(q[J]);Ee.cacheId=[oe,J],ce.links.push(Ee)}return ce}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,B){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveDocumentLink(V,B);if(!(!q||!Fe._validateLink(q)))return b.DocumentLink.from(q)}releaseLinks(k){this._cache.delete(k)}}class Ue{constructor(k,B){this._documents=k,this._provider=B}async provideColors(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentColors(V,B);return Array.isArray(q)?q.map(ce=>({color:b.Color.from(ce.color),range:b.Range.from(ce.range)})):[]}async provideColorPresentations(k,B,V){const q=this._documents.getDocument(k),oe=b.Range.to(B.range),ce=b.Color.to(B.color),J=await this._provider.provideColorPresentations(ce,{document:q,range:oe},V);if(!!Array.isArray(J))return J.map(b.ColorPresentation.from)}}class Xe{constructor(k,B){this._documents=k,this._provider=B}async provideFoldingRanges(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideFoldingRanges(q,B,V);if(!!Array.isArray(oe))return oe.map(b.FoldingRange.from)}}class ke{constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideSelectionRanges(k,B,V){const q=this._documents.getDocument(k),oe=B.map(b.Position.to),ce=await this._provider.provideSelectionRanges(q,oe,V);if(!(0,R.isNonEmptyArray)(ce))return[];if(ce.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let Ee=0;Ee<oe.length;Ee++){const ve=[];J.push(ve);let Ne=oe[Ee],ze=ce[Ee];for(;;){if(!ze.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(b.SelectionRange.from(ze)),!ze.parent)break;Ne=ze.range,ze=ze.parent}}return J}}class ye{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.prepareCallHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideCallsTo(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(q,V);if(!!oe)return oe.map(ce=>({from:this._cacheAndConvertItem(k,ce.from),fromRanges:ce.fromRanges.map(J=>b.Range.from(J))}))}async provideCallsFrom(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(q,V);if(!!oe)return oe.map(ce=>({to:this._cacheAndConvertItem(k,ce.to),fromRanges:ce.fromRanges.map(J=>b.Range.from(J))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=b.CallHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class De{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.prepareTypeHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideSupertypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}async provideSubtypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=b.TypeHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class ae{constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async provideDocumentOnDropEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=b.Position.to(V),Ee=b.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentDropEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?b.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ue{constructor(k,B){this.adapter=k,this.extension=B}}class ee{constructor(k,B,V,q,oe,ce,J,Ee){this._uriTransformer=B,this._documents=V,this._commands=q,this._diagnostics=oe,this._logService=ce,this._apiDeprecation=J,this._extensionTelemetry=Ee,this._adapter=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(k){return b.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new N.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return ee._handlePool++}async _withAdapter(k,B,V,q,oe,ce=!1){const J=this._adapter.get(k);if(!J||!(J.adapter instanceof B))return q;const Ee=Date.now();ce||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const ve=V(J.adapter,J.extension);return Promise.resolve(ve).catch(Ne=>{(0,w.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne),this._extensionTelemetry.onExtensionError(J.extension.identifier,Ne))}).finally(()=>{ce||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-Ee}ms`)}),C.CancellationToken.isCancellationToken(oe)?(0,d.raceCancellationError)(ve,oe):ve}_addNewAdapter(k,B){const V=this._nextHandle();return this._adapter.set(V,new ue(k,B)),V}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,B,V,q){const oe=this._addNewAdapter(new t(this._documents,V),k),ce=q&&q.label||ee._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(B),ce),this._createDisposable(oe)}$provideDocumentSymbols(k,B,V){return this._withAdapter(k,t,q=>q.provideDocumentSymbols(s.URI.revive(B),V),void 0,V)}registerCodeLensProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new h(this._documents,this._commands.converter,V),k)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(oe));ce=N.Disposable.from(ce,J)}return ce}$provideCodeLenses(k,B,V){return this._withAdapter(k,h,q=>q.provideCodeLenses(s.URI.revive(B),V),void 0,V)}$resolveCodeLens(k,B,V){return this._withAdapter(k,h,q=>q.resolveCodeLens(B,V),void 0,void 0)}$releaseCodeLenses(k,B){this._withAdapter(k,h,V=>Promise.resolve(V.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(k,B,V){const q=this._addNewAdapter(new n(this._documents,V),k);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDefinition(k,B,V,q){return this._withAdapter(k,n,oe=>oe.provideDefinition(s.URI.revive(B),V,q),[],q)}registerDeclarationProvider(k,B,V){const q=this._addNewAdapter(new o(this._documents,V),k);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDeclaration(k,B,V,q){return this._withAdapter(k,o,oe=>oe.provideDeclaration(s.URI.revive(B),V,q),[],q)}registerImplementationProvider(k,B,V){const q=this._addNewAdapter(new u(this._documents,V),k);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideImplementation(k,B,V,q){return this._withAdapter(k,u,oe=>oe.provideImplementation(s.URI.revive(B),V,q),[],q)}registerTypeDefinitionProvider(k,B,V){const q=this._addNewAdapter(new i(this._documents,V),k);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideTypeDefinition(k,B,V,q){return this._withAdapter(k,i,oe=>oe.provideTypeDefinition(s.URI.revive(B),V,q),[],q)}registerHoverProvider(k,B,V,q){const oe=this._addNewAdapter(new c(this._documents,V),k);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideHover(k,B,V,q){return this._withAdapter(k,c,oe=>oe.provideHover(s.URI.revive(B),V,q),void 0,q)}registerEvaluatableExpressionProvider(k,B,V,q){const oe=this._addNewAdapter(new g(this._documents,V),k);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideEvaluatableExpression(k,B,V,q){return this._withAdapter(k,g,oe=>oe.provideEvaluatableExpression(s.URI.revive(B),V,q),void 0,q)}registerInlineValuesProvider(k,B,V,q){const oe=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new T(this._documents,V),k);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(B),oe);let J=this._createDisposable(ce);if(oe!==void 0){const Ee=V.onDidChangeInlineValues(ve=>this._proxy.$emitInlineValuesEvent(oe));J=N.Disposable.from(J,Ee)}return J}$provideInlineValues(k,B,V,q,oe){return this._withAdapter(k,T,ce=>ce.provideInlineValues(s.URI.revive(B),V,q,oe),void 0,oe)}registerDocumentHighlightProvider(k,B,V){const q=this._addNewAdapter(new F(this._documents,V),k);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentHighlights(k,B,V,q){return this._withAdapter(k,F,oe=>oe.provideDocumentHighlights(s.URI.revive(B),V,q),void 0,q)}registerLinkedEditingRangeProvider(k,B,V){const q=this._addNewAdapter(new j(this._documents,V),k);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideLinkedEditingRanges(k,B,V,q){return this._withAdapter(k,j,async oe=>{const ce=await oe.provideLinkedEditingRanges(s.URI.revive(B),V,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ee._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(k,B,V){const q=this._addNewAdapter(new U(this._documents,V),k);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideReferences(k,B,V,q,oe){return this._withAdapter(k,U,ce=>ce.provideReferences(s.URI.revive(B),V,q,oe),void 0,oe)}registerCodeActionProvider(k,B,V,q){const oe=new p.DisposableStore,ce=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,V,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(B),{providedKinds:q?.providedCodeActionKinds?.map(J=>J.value),documentation:q?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,oe)}))},ee._extLabel(k),Boolean(V.resolveCodeAction)),oe.add(this._createDisposable(ce)),oe}$provideCodeActions(k,B,V,q,oe){return this._withAdapter(k,D,ce=>ce.provideCodeActions(s.URI.revive(B),V,q,oe),void 0,oe)}$resolveCodeAction(k,B,V){return this._withAdapter(k,D,q=>q.resolveCodeAction(B,V),void 0,void 0)}$releaseCodeActions(k,B){this._withAdapter(k,D,V=>Promise.resolve(V.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new M(this._documents,V),k);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentFormattingEdits(k,B,V,q){return this._withAdapter(k,M,oe=>oe.provideDocumentFormattingEdits(s.URI.revive(B),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new O(this._documents,V),k);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(k,B,V,q,oe){return this._withAdapter(k,O,ce=>ce.provideDocumentRangeFormattingEdits(s.URI.revive(B),V,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(k,B,V,q){const oe=this._addNewAdapter(new H(this._documents,V),k);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(B),q,k.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(k,B,V,q,oe,ce){return this._withAdapter(k,H,J=>J.provideOnTypeFormattingEdits(s.URI.revive(B),V,q,oe,ce),void 0,ce)}registerWorkspaceSymbolProvider(k,B){const V=this._addNewAdapter(new W(B,this._logService),k);return this._proxy.$registerNavigateTypeSupport(V,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(k,B,V){return this._withAdapter(k,W,q=>q.provideWorkspaceSymbols(B,V),{symbols:[]},V)}$resolveWorkspaceSymbol(k,B,V){return this._withAdapter(k,W,q=>q.resolveWorkspaceSymbol(B,V),void 0,void 0)}$releaseWorkspaceSymbols(k,B){this._withAdapter(k,W,V=>V.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(k,B,V){const q=this._addNewAdapter(new z(this._documents,V,this._logService),k);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(B),z.supportsResolving(V)),this._createDisposable(q)}$provideRenameEdits(k,B,V,q,oe){return this._withAdapter(k,z,ce=>ce.provideRenameEdits(s.URI.revive(B),V,q,oe),void 0,oe)}$resolveRenameLocation(k,B,V,q){return this._withAdapter(k,z,oe=>oe.resolveRenameLocation(s.URI.revive(B),V,q),void 0,q)}registerDocumentSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new te(this._documents,V),k),ce=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(B),q,ce);let J=this._createDisposable(oe);if(ce){const Ee=V.onDidChangeSemanticTokens(ve=>this._proxy.$emitDocumentSemanticTokensEvent(ce));J=N.Disposable.from(J,Ee)}return J}$provideDocumentSemanticTokens(k,B,V,q){return this._withAdapter(k,te,oe=>oe.provideDocumentSemanticTokens(s.URI.revive(B),V,q),null,q)}$releaseDocumentSemanticTokens(k,B){this._withAdapter(k,te,V=>V.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new he(this._documents,V),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(B),q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(k,B,V,q){return this._withAdapter(k,he,oe=>oe.provideDocumentRangeSemanticTokens(s.URI.revive(B),V,q),null,q)}registerCompletionItemProvider(k,B,V,q){const oe=this._addNewAdapter(new re(this._documents,this._commands.converter,V,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(B),q,re.supportsResolving(V),`${k.identifier.value}(${q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(k,B,V,q,oe){return this._withAdapter(k,re,ce=>ce.provideCompletionItems(s.URI.revive(B),V,q,oe),void 0,oe)}$resolveCompletionItem(k,B,V){return this._withAdapter(k,re,q=>q.resolveCompletionItem(B,V),void 0,V)}$releaseCompletionItems(k,B){this._withAdapter(k,re,V=>V.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(k,B,V){const q=new le(k,this._documents,V,this._commands.converter),oe=this._addNewAdapter(q,k);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(B),q.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(k,B,V){const q=this._addNewAdapter(new fe(k,this._documents,V,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(q,this._transformDocumentSelector(B),!0),this._createDisposable(q)}$provideInlineCompletions(k,B,V,q,oe){return this._withAdapter(k,be,ce=>ce.provideInlineCompletions(s.URI.revive(B),V,q,oe),void 0,oe)}$handleInlineCompletionDidShow(k,B,V){this._withAdapter(k,be,async q=>{q.handleDidShowCompletionItem(B,V)},void 0,void 0)}$freeInlineCompletionsList(k,B){this._withAdapter(k,be,async V=>{V.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(k,B,V,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new pe(this._documents,V),k);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(B),oe),this._createDisposable(ce)}$provideSignatureHelp(k,B,V,q,oe){return this._withAdapter(k,pe,ce=>ce.provideSignatureHelp(s.URI.revive(B),V,q,oe),void 0,oe)}$releaseSignatureHelp(k,B){this._withAdapter(k,pe,V=>V.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(k,B,V){const q=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Se(this._documents,this._commands.converter,V,this._logService,k),k);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(B),typeof V.resolveInlayHint=="function",q,ee._extLabel(k));let ce=this._createDisposable(oe);if(q!==void 0){const J=V.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(q));ce=N.Disposable.from(ce,J)}return ce}$provideInlayHints(k,B,V,q){return this._withAdapter(k,Se,oe=>oe.provideInlayHints(s.URI.revive(B),V,q),void 0,q)}$resolveInlayHint(k,B,V){return this._withAdapter(k,Se,q=>q.resolveInlayHint(B,V),void 0,V)}$releaseInlayHints(k,B){this._withAdapter(k,Se,V=>V.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(k,B,V){const q=this._addNewAdapter(new Fe(this._documents,V),k);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(B),typeof V.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(k,B,V){return this._withAdapter(k,Fe,q=>q.provideLinks(s.URI.revive(B),V),void 0,V,B.scheme==="output")}$resolveDocumentLink(k,B,V){return this._withAdapter(k,Fe,q=>q.resolveLink(B,V),void 0,void 0,!0)}$releaseDocumentLinks(k,B){this._withAdapter(k,Fe,V=>V.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(k,B,V){const q=this._addNewAdapter(new Ue(this._documents,V),k);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentColors(k,B,V){return this._withAdapter(k,Ue,q=>q.provideColors(s.URI.revive(B),V),[],V)}$provideColorPresentations(k,B,V,q){return this._withAdapter(k,Ue,oe=>oe.provideColorPresentations(s.URI.revive(B),V,q),void 0,q)}registerFoldingRangeProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new Xe(this._documents,V),k)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));ce=N.Disposable.from(ce,J)}return ce}$provideFoldingRanges(k,B,V,q){return this._withAdapter(k,Xe,oe=>oe.provideFoldingRanges(s.URI.revive(B),V,q),void 0,q)}registerSelectionRangeProvider(k,B,V){const q=this._addNewAdapter(new ke(this._documents,V,this._logService),k);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideSelectionRanges(k,B,V,q){return this._withAdapter(k,ke,oe=>oe.provideSelectionRanges(s.URI.revive(B),V,q),[],q)}registerCallHierarchyProvider(k,B,V){const q=this._addNewAdapter(new ye(this._documents,V),k);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareCallHierarchy(k,B,V,q){return this._withAdapter(k,ye,oe=>Promise.resolve(oe.prepareSession(s.URI.revive(B),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsTo(B,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsFrom(B,V,q),void 0,q)}$releaseCallHierarchy(k,B){this._withAdapter(k,ye,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(k,B,V){const q=this._addNewAdapter(new De(this._documents,V),k);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareTypeHierarchy(k,B,V,q){return this._withAdapter(k,De,oe=>Promise.resolve(oe.prepareSession(s.URI.revive(B),V,q)),void 0,q)}$provideTypeHierarchySupertypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSupertypes(B,V,q),void 0,q)}$provideTypeHierarchySubtypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSubtypes(B,V,q),void 0,q)}$releaseTypeHierarchy(k,B){this._withAdapter(k,De,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(k,B,V){const q=this._nextHandle();return this._adapter.set(q,new ue(new ae(this._proxy,this._documents,V,q),k)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentOnDropEdits(k,B,V,q,oe,ce){return this._withAdapter(k,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(B,s.URI.revive(V),q,oe,ce)),void 0,void 0)}registerDocumentPasteEditProvider(k,B,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ue(new x(this._proxy,this._documents,V,oe),k)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(B),!!V.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(k,B,V,q,oe){return this._withAdapter(k,x,ce=>ce.prepareDocumentPaste(s.URI.revive(B),V,q,oe),void 0,oe)}$providePasteEdits(k,B,V,q,oe,ce){return this._withAdapter(k,x,J=>J.providePasteEdits(B,s.URI.revive(V),q,oe,ce),void 0,ce)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,y.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:ee._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?ee._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?ee._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:ee._serializeRegExp(k.beforeText),afterText:k.afterText?ee._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?ee._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(ee._serializeOnEnterRule)}setLanguageConfiguration(k,B,V){const{wordPattern:q}=V;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(B,q):this._documents.setWordDefinitionFor(B,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const oe=this._nextHandle(),ce={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ee._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ee._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ee._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,B,ce),this._createDisposable(oe)}$setWordDefinitions(k){for(const B of k)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(Ie[208],Ce([1,0,5,8,6,29,15,7]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(R,E,m,C){this._documents=E,this._commands=m,this._uriTransformer=C,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,E){await this._proxy.$changeLanguage(R,E);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,E){const m=R.version,C=I.Position.from(E),p=await this._proxy.$tokensAtPosition(R.uri,C),a={type:b.StandardTokenType.Other,range:R.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!p)return a;const l={range:I.Range.to(p.range),type:I.TokenType.to(p.type)};return!l.range.contains(E)||m!==R.version?a:l}createLanguageStatusItem(R,E,m){const C=this._handlePool++,p=this._proxy,a=this._ids,l=`${R.identifier.value}/${E}`;if(a.has(l))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);a.add(l);const f={selector:m,id:E,name:R.displayName??R.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const w=new A.DisposableStore,d=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{w.clear(),this._proxy.$setLanguageStatus(C,{id:l,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:I.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===b.LanguageStatusSeverity.Error?N.default.Error:f.severity===b.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:f.command&&this._commands.toInternal(f.command,w),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},S={dispose(){w.dispose(),v?.dispose(),p.$removeLanguageStatus(C),a.delete(l)},get id(){return f.id},get name(){return f.name},set name(t){f.name=t,d()},get selector(){return f.selector},set selector(t){f.selector=t,d()},get text(){return f.text},set text(t){f.text=t,d()},get detail(){return f.detail},set detail(t){f.detail=t,d()},get severity(){return f.severity},set severity(t){f.severity=t,d()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(t){f.accessibilityInformation=t,d()},get command(){return f.command},set command(t){f.command=t,d()},get busy(){return f.busy},set busy(t){f.busy=t,d()}};return d(),S}}e.ExtHostLanguages=y}),define(Ie[71],Ce([1,0,20,10,2,3,11,5,27,14]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(m,C,p){this.logService=p,this.bundleCache=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=m.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===s.LANGUAGE_DEFAULT}getMessage(m,C){const{message:p,args:a,comment:l}=C;if(this.isDefaultLanguage)return(0,I.format2)(p,a??{});let f=p;l&&l.length>0&&(f+=`/${Array.isArray(l)?l.join():l}`);const v=this.bundleCache.get(m)?.contents[f];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,I.format2)(v??f,a??{})}getBundle(m){return this.bundleCache.get(m)?.contents}getBundleUri(m){return this.bundleCache.get(m)?.uri}async initializeLocalizedMessages(m){if(this.isDefaultLanguage||!m.l10n&&!m.isBuiltin||this.bundleCache.has(m.identifier.value))return;let C;const p=await this.getBundleLocation(m);if(!p){this.logService.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(p),l=JSON.parse(a);C=m.isBuiltin?l.contents?.bundle:l}catch(a){this.logService.error(`Failed to load translations for ${m.identifier.value} from ${p}: ${a.message}`);return}C&&this.bundleCache.set(m.identifier.value,{contents:C,uri:p})}async getBundleLocation(m){if(m.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(m.identifier.value);return b.URI.revive(C)}return m.l10n?b.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=xe([$e(0,y.IExtHostInitDataService),$e(1,P.IExtHostRpcService),$e(2,_.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ie[209],Ce([1,0,11,5,27,14,2,4,9]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends s.AbstractLoggerService{constructor(m,C){super(C.logLevel,A.Event.None),this._proxy=m.getProxy(I.MainContext.MainThreadLogger)}$setLevel(m,C){C?this.setLevel(_.URI.revive(C),m):(0,y.isUndefined)(m)||this.setLevel(m)}doCreateLogger(m,C,p){return new R(this._proxy,m,C,p)}};P=xe([$e(0,N.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class R extends s.AbstractMessageLogger{constructor(m,C,p,a){super(a?.always),this.proxy=m,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(C,a).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,C){const p=[[m,C]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(m){this.proxy.$log(this.file,m)}}}),define(Ie[210],Ce([1,0,5,11,28]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(A){return A&&A.title}let _=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(s.MainContext.MainThreadMessageService)}showMessage(y,P,R,E,m){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof E=="string"||N(E)?p=[E,...m]:(C.modal=E?.modal,C.useCustom=E?.useCustom,C.detail=E?.detail,p=m),C.useCustom&&(0,b.checkProposedApiEnabled)(y,"resolvers");const a=[];for(let l=0;l<p.length;l++){const f=p[l];if(typeof f=="string")a.push({title:f,handle:l,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:w}=f;a.push({title:v,isCloseAffordance:!!w,handle:l})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(P,R,C,a).then(l=>{if(typeof l=="number")return p[l]})}};_=xe([$e(1,I.ILogService)],_),e.ExtHostMessageService=_}),define(Ie[211],Ce([1,0,23,4,7,24,10,9,2,62,5,37,8,6,42,183,94]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}constructor(w,d,S,t){this._textDocumentsAndEditors=S,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new N.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=w.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===12){const r=h.notebookEditor?.notebookUri,n=h.cell.handle,u=this._documents.get(r)?.getCell(n);if(u)return u.apiCell}return h}}),f._registerApiCommands(d)}getEditorById(w){const d=this._editors.get(w);if(!d)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(w){for(const[d,S]of this._editors)if(S.apiEditor===w)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,d){const S=this._documents.get(w);if(!S&&!d)throw new Error(`NO notebook document for '${w}'`);return S}_getProviderData(w){const d=this._notebookContentProviders.get(w);if(!d)throw new Error(`NO provider for '${w}'`);return d}registerNotebookContentProvider(w,d,S,t,h){if((0,_.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);return this._notebookContentProviders.set(d,{extension:w,provider:S}),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},d,m.NotebookDocumentContentOptions.from(t),f._convertNotebookRegistrationData(w,h)),new C.Disposable(()=>{this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(w,d){if(!d)return;const S=d.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(d.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:d.displayName,filenamePattern:S,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,d,S){const t=f._notebookStatusBarItemProviderHandlePool++,h=typeof S.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,h,d);let r;return h!==void 0&&(r=S.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(h))),new C.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,h),r?.dispose()})}async createNotebookDocument(w){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&m.NotebookData.from(w.content)});return y.URI.revive(d)}async openNotebookDocument(w){const d=this._documents.get(w);if(d)return d.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(w),t=this._documents.get(y.URI.revive(S));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(w,d){y.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let S;typeof d=="object"?S={position:m.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(m.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:S={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,S),h=t&&this._editors.get(t)?.apiEditor;if(h)return h;throw t?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,d,S,t){const h=this._notebookStatusBarItemProviders.get(w),r=y.URI.revive(d),n=this._documents.get(r);if(!n||!h)return;const o=n.getCellFromIndex(S);if(!o)return;const u=await h.provideCellStatusBarItems(o.apiCell,t);if(!u)return;const i=new b.DisposableStore,c=this._statusBarCache.add([i]),T=(Array.isArray(u)?u:[u]).map(F=>m.NotebookStatusBarItem.from(F,this._commandsConverter,i));return{cacheId:c,items:T}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,d,S,t,h){if((0,_.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,S),this._notebookProxy.$registerNotebookSerializer(r,{id:w.identifier,location:w.extensionLocation},d,m.NotebookDocumentContentOptions.from(t),f._convertNotebookRegistrationData(w,h)),(0,b.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(w,d,S){const t=this._notebookSerializer.get(w);if(!t)throw new Error("NO serializer found");const h=await t.deserializeNotebook(d.buffer,S);return new p.SerializableObjectWithBuffers(m.NotebookData.from(h))}async $notebookToData(w,d,S){const t=this._notebookSerializer.get(w);if(!t)throw new Error("NO serializer found");const h=await t.serializeNotebook(m.NotebookData.to(d.value),S);return s.VSBuffer.wrap(h)}async $openNotebook(w,d,S,t,h){const{provider:r}=this._getProviderData(w),n=await r.openNotebook(y.URI.revive(d),{backupId:S,untitledDocumentData:t?.buffer},h);return new p.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(w,d,S){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const t=new l.ExtHostNotebookEditor(d,this._notebookEditorsProxy,w,S.visibleRanges.map(m.NotebookRange.to),S.selections.map(m.NotebookRange.to),typeof S.viewColumn=="number"?m.ViewColumn.to(S.viewColumn):void 0);this._editors.set(d,t)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const S of w.value.removedDocuments){const t=y.URI.revive(S),h=this._documents.get(t);h&&(h.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(w.value.addedDocuments){const S=[];for(const t of w.value.addedDocuments){const h=y.URI.revive(t.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const r=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,h,t);S.push(...t.cells.map(n=>a.ExtHostCell.asModelAddData(r.apiNotebook,n))),this._documents.get(h)?.dispose(),this._documents.set(h,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(w.value.addedEditors)for(const S of w.value.addedEditors){if(this._editors.has(S.id))return;const t=y.URI.revive(S.documentUri),h=this._documents.get(t);h&&this._createExtHostEditor(h,S.id,S)}const d=[];if(w.value.removedEditors)for(const S of w.value.removedEditors){const t=this._editors.get(S);t&&(this._editors.delete(S),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),d.push(t))}if(w.value.visibleEditors){this._visibleNotebookEditors=w.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const S=new Set;this._visibleNotebookEditors.forEach(t=>S.add(t.id));for(const t of this._editors.values()){const h=S.has(t.id);t._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this._activeNotebookEditor=void 0:w.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(w){const d=E.ApiCommandArgument.String.with("notebookType","A notebook type"),S=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new E.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>s.VSBuffer.wrap(h))],new E.ApiCommandResult("Notebook Data",h=>m.NotebookData.to(h.value))),t=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new p.SerializableObjectWithBuffers(m.NotebookData.from(h)))],new E.ApiCommandResult("Bytes",h=>h.buffer));w.registerApiCommand(S),w.registerApiCommand(t)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(Ie[212],Ce([1,0,18,15,21,4,7,24,2,26,11,5,37,8,6,64,171,28,42]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=class{constructor(n,o,u,i,c){this._initData=o,this._extHostNotebook=u,this._commands=i,this._logService=c,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(E.MainContext.MainThreadNotebookKernels);const g=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const F=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:F}}else if(T&&"notebookEditor"in T){const F=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:F}}return T})],m.ApiCommandResult.Void);this._commands.registerApiCommand(g)}createNotebookController(n,o,u,i,c,g){for(const re of this._kernelData.values())if(re.controller.id===o&&P.ExtensionIdentifier.equals(n.identifier,re.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const T=this._handlePool++,F=this;this._logService.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${o}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${n.identifier}'`);let U=!1;const D=new _.DisposableStore,x=new N.Emitter,M=new N.Emitter,O={id:h(n.identifier,o),notebookType:u,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:i||n.identifier.value,preloads:g?g.map(C.NotebookRendererScript.from):[]};let H=c??j,W;this._proxy.$addKernel(T,O).catch(re=>{console.log(re),U=!0});let z=0;const G=()=>{if(U)return;const re=++z;Promise.resolve().then(()=>{re===z&&this._proxy.$updateKernel(T,O)})},te=new A.ResourceMap,he={get id(){return o},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return O.label},set label(re){O.label=re??n.displayName??n.name,G()},get detail(){return O.detail??""},set detail(re){O.detail=re,G()},get description(){return O.description??""},set description(re){O.description=re,G()},get kind(){return(0,f.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind??""},set kind(re){(0,f.checkProposedApiEnabled)(n,"notebookControllerKind"),O.kind=re,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,G()},get rendererScripts(){return O.preloads?O.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(re){H=re??j},get interruptHandler(){return W},set interruptHandler(re){W=re,O.supportsInterrupt=Boolean(re),G()},createNotebookCellExecution(re){if(U)throw new Error("notebook controller is DISPOSED");if(!te.has(re.notebook.uri))throw F._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return F._createNotebookCellExecution(re,h(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${T}], DISPOSED`),U=!0,this._kernelData.delete(T),D.dispose(),x.dispose(),M.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(re,be){be===p.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),F._proxy.$updateNotebookPriority(T,re.uri,be)},onDidReceiveMessage:M.event,postMessage(re,be){return(0,f.checkProposedApiEnabled)(n,"notebookMessaging"),F._proxy.$postMessage(T,be&&F._extHostNotebook.getIdByEditor(be),re)},asWebviewUri(re){return(0,f.checkProposedApiEnabled)(n,"notebookMessaging"),(0,a.asWebviewUri)(re,F._initData.remote)}};return this._kernelData.set(T,{extensionId:n.identifier,controller:he,onDidReceiveMessage:M,onDidChangeSelection:x,associatedNotebooks:te}),he}getIdByController(n){for(const[o,u]of this._kernelData)if(u.controller===n)return h(u.extensionId,n.id);return null}$acceptNotebookAssociation(n,o,u){const i=this._kernelData.get(n);if(i){const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));u?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,c.uri.toString(),u),i.onDidChangeSelection.fire({selected:u,notebook:c.apiNotebook})}}async $executeCells(n,o,u){const i=this._kernelData.get(n);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(o)),g=[];for(const T of u){const F=c.getCell(T);F&&g.push(F.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,c.uri.toString(),g.length),await i.controller.executeHandler.call(i.controller,g,c.apiNotebook,i.controller)}catch(T){this._logService.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,o,u){const i=this._kernelData.get(n);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(const g of u){const T=c.getCell(g);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,o,u){const i=this._kernelData.get(n);if(!i)return;const c=this._extHostNotebook.getEditorById(o);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:u}))}$cellExecutionChanged(n,o,u){const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(n)).getCell(o);if(c){const g=u?C.NotebookCellExecutionState.to(u):p.NotebookCellExecutionState.Idle;g!==void 0&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:g})}}_createNotebookCellExecution(n,o){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const c=new S(o,i,this._proxy);this._activeExecutions.set(i.uri,c);const g=c.onDidChangeState(()=>{c.state===d.Resolved&&(c.dispose(),g.dispose(),this._activeExecutions.delete(i.uri))});return c.asApiObject()}};w=xe([$e(4,R.ILogService)],w),e.ExtHostNotebookKernels=w;var d;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(d||(d={}));class S extends _.Disposable{get state(){return this._state}constructor(n,o,u){super(),this._cell=o,this._proxy=u,this._handle=S.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new t(10,i=>this.update(i)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const o=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let o=this._cell;if(n&&(o=this._cell.notebook.getCellFromApiCell(n)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(n){return n.map(o=>{const u=p.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return u===o.items?C.NotebookCellOutput.from(o):C.NotebookCellOutput.from({items:u,id:o.id,metadata:o.metadata})})}async updateOutputs(n,o,u){const i=this.cellIndexToHandle(o),c=this.validateAndConvertOutputs((0,s.asArray)(n));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,cellHandle:i,append:u,outputs:c})}async updateOutputItems(n,o,u){return n=p.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(n),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:n.map(C.NotebookCellOutputItem.from),outputId:o.id,append:u})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(u){n._executionOrder=u,n.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(u){if(n._state===d.Resolved||n._state===d.Started)throw new Error("Cannot call start again");n._state=d.Started,n._onDidChangeState.fire(),n.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,i){if(n._state===d.Resolved)throw new Error("Cannot call resolve twice");n._state=d.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new v.SerializableObjectWithBuffers({runEndTime:i,lastRunSuccess:u}))},clearOutput(u){return n.verifyStateForOutput(),n.updateOutputs([],u,!1)},appendOutput(u,i){return n.verifyStateForOutput(),n.updateOutputs(u,i,!0)},replaceOutput(u,i){return n.verifyStateForOutput(),n.updateOutputs(u,i,!1)},appendOutputItems(u,i){return n.verifyStateForOutput(),n.updateOutputItems(u,i,!0)},replaceOutputItems(u,i){return n.verifyStateForOutput(),n.updateOutputItems(u,i,!1)}})}}S.HANDLE=0;class t{constructor(n,o){this.delay=n,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>n.complete())}}function h(r,n){return`${r.value}/${n}`}e.createKernelId=h}),define(Ie[213],Ce([1,0,4,5,94]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,P){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:P})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,E,m)=>this.getOrCreateEmitterFor(y).event(R,E,m),postMessage:(R,E)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,E]=[E,R]);const m=E&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.proxy.$postMessage(m?.id,y,R)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new s.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=N}),define(Ie[214],Ce([1,0,21,4,7,5,2,6,12,18,29,61]),function(ne,e,s,I,b,N,_,A,y,P,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(C,p,a){const l=C.getProxy(N.MainContext.MainThreadQuickOpen);class f{constructor(o,u){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=u}showQuickPick(o,u,i=s.CancellationToken.None){this._onDidSelectItem=void 0;const c=Promise.resolve(o),g=++this._instances,T=l.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},i),F={},j=T.then(()=>F);return Promise.race([j,c]).then(U=>{if(U!==F)return c.then(D=>{const x=[];for(let M=0;M<D.length;M++){const O=D[M];typeof O=="string"?x.push({label:O,handle:M}):O.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:O.label}):x.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:M})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{u.onDidSelectItem(D[M])}),l.$setItems(g,x),T.then(M=>{if(typeof M=="number")return D[M];if(Array.isArray(M))return M.map(O=>D[O])})})}).then(void 0,U=>{if(!(0,y.isCancellationError)(U))return l.$setError(g,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,u=s.CancellationToken.None){return this._validateInput=o?.validateInput,l.$input(o,typeof this._validateInput=="function",u).then(void 0,i=>{if(!(0,y.isCancellationError)(i))return Promise.reject(i)})}async $validateInput(o){if(!this._validateInput)return;const u=await this._validateInput(o);if(!u||typeof u=="string")return u;let i;switch(u.severity){case A.InputBoxValidationSeverity.Info:i=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:i=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:i=R.default.Error;break;default:i=u.message?R.default.Error:R.default.Ignore;break}return{content:u.message,severity:i}}async showWorkspaceFolderPick(o,u=s.CancellationToken.None){const i=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!i)return;const c=await this._workspace.getWorkspaceFolders2();if(!!c)return c.find(g=>g.uri.toString()===i.uri.toString())}createQuickPick(o){const u=new h(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(o){const u=new r(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(o,u){this._sessions.get(o)?._fireDidChangeValue(u)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,u){const i=this._sessions.get(o);i instanceof h&&i._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const i=this._sessions.get(o);i instanceof h&&i._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){this._sessions.get(o)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(o,u,i){const c=this._sessions.get(o);c instanceof h&&c._fireDidTriggerItemButton(u,i)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class v{constructor(o,u){this._extensionId=o,this._onDidDispose=u,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((u,i)=>{const c=u===A.QuickInputButtons.Back?-1:i;this._handlesToButtons.set(c,u)}),this.update({buttons:o.map((u,i)=>({...t(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:i}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const u=this._handlesToButtons.get(o);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),l.$dispose(this._id))}update(o){if(!this._disposed){for(const u of Object.keys(o)){const i=o[u];this._pendingUpdate[u]=i===void 0?null:i}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){l.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function w(n){if(n instanceof A.ThemeIcon)return{id:n.id};const o=S(n),u=d(n);return{dark:typeof o=="string"?_.URI.file(o):o,light:typeof u=="string"?_.URI.file(u):u}}function d(n){return typeof n=="object"&&"light"in n?n.light:n}function S(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const o=w(n.iconPath);let u,i;return"id"in o?i=E.ThemeIcon.asClassName(o):u=o,{iconPath:u,iconClass:i}}class h extends v{constructor(o,u){super(o.identifier,u),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((i,c)=>{this._handlesToItems.set(c,i),this._itemsToHandles.set(i,c)});const u=[];for(let i=0;i<o.length;i++){const c=o[i];c.kind===A.QuickPickItemKind.Separator?u.push({type:"separator",label:c.label}):u.push({handle:i,label:c.label,description:c.description,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons?.map((g,T)=>({...t(g),tooltip:g.tooltip,handle:T}))})}this.update({items:u})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(o){const u=(0,P.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(o){const u=(0,P.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(o,u){const i=this._handlesToItems.get(o);if(!i||!i.buttons||!i.buttons.length)return;const c=i.buttons[u];c&&this._onDidTriggerItemButtonEmitter.fire({button:c,item:i})}}class r extends v{constructor(o,u){super(o.identifier,u),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:R.default.Error}):this.update({validationMessage:o.message,severity:o.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new f(p,a)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s};define(Ie[215],Ce([1,0,2,4,57,7,15,5,18,118,11,26,61,8,28]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p){"use strict";var a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(c){if(c)return typeof c.iconPath=="string"?s.URI.file(c.iconPath):s.URI.isUri(c.iconPath)||m.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function v(c,g){if(!c.iconPath&&!g.iconPath)return 0;if(c.iconPath){if(!g.iconPath)return 1}else return-1;const T=typeof c.iconPath=="string"?c.iconPath:s.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,F=typeof g.iconPath=="string"?g.iconPath:s.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(T,F)}function w(c,g){let T=0;if(c.strikeThrough!==g.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==g.faded)return c.faded?1:-1;if(c.tooltip!==g.tooltip)return(c.tooltip||"").localeCompare(g.tooltip||"");if(T=v(c,g),T!==0)return T;if(c.light&&g.light)T=v(c.light,g.light);else{if(c.light)return 1;if(g.light)return-1}if(T!==0)return T;if(c.dark&&g.dark)T=v(c.dark,g.dark);else{if(c.dark)return 1;if(g.dark)return-1}return T}function d(c,g){if(c.command!==g.command)return c.command<g.command?-1:1;if(c.title!==g.title)return c.title<g.title?-1:1;if(c.tooltip!==g.tooltip){if(c.tooltip!==void 0&&g.tooltip!==void 0)return c.tooltip<g.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(c.arguments===g.arguments)return 0;if(c.arguments)if(g.arguments){if(c.arguments.length!==g.arguments.length)return c.arguments.length-g.arguments.length}else return 1;else return-1;for(let T=0;T<c.arguments.length;T++){const F=c.arguments[T],j=g.arguments[T];if(F!==j)return F<j?-1:1}return 0}function S(c,g){let T=(0,P.comparePaths)(c.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(T!==0)return T;if(c.command&&g.command)T=d(c.command,g.command);else{if(c.command)return 1;if(g.command)return-1}if(T!==0)return T;if(c.decorations&&g.decorations)T=w(c.decorations,g.decorations);else{if(c.decorations)return 1;if(g.decorations)return-1}return T}function t(c,g){for(let T=0;T<c.length;T++)if(c[T]!==g[T])return!1;return!0}function h(c,g){return c.command===g.command&&c.title===g.title&&c.tooltip===g.tooltip&&(c.arguments&&g.arguments?t(c.arguments,g.arguments):c.arguments===g.arguments)}function r(c,g){return(0,y.equals)(c,g,h)}class n{get value(){return this._value}set value(g){g=g??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(g){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get enabled(){return this._enabled}set enabled(g){g=!!g,this._enabled!==g&&(this._enabled=g,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,g))}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,g))}constructor(g,T,F){this._extension=g,this._sourceControlHandle=F,a.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,a,T,"f")}showValidationMessage(g,T){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,g,T)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=n,a=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}constructor(g,T,F,j,U){this._proxy=g,this._commands=T,this._sourceControlHandle=F,this._id=j,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,T){const F=this._resourceStatesCommandsMap.get(g);return F?(0,_.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(S),F=(0,y.sortedDiff)(this._resourceSnapshot,g,S).map(D=>{const x=D.toInsert.map(M=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,M);const H=M.resourceUri;let W;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const pe=new N.DisposableStore;W=this._commands.converter.toInternal(M.command,pe),this._resourceStatesDisposablesMap.set(O,pe)}else this._resourceStatesCommandsMap.set(O,M.command);const z=f(M.decorations),G=M.decorations&&f(M.decorations.light)||z,te=M.decorations&&f(M.decorations.dark)||z,he=[G,te],re=M.decorations&&M.decorations.tooltip||"",be=M.decorations&&!!M.decorations.strikeThrough,le=M.decorations&&!!M.decorations.faded,fe=M.contextValue||"";return{rawResource:[O,H,he,re,be,le,fe,W],handle:O}});return{start:D.start,deleteCount:D.deleteCount,toInsert:x}}),j=F.map(({start:D,deleteCount:x,toInsert:M})=>[D,x,M.map(O=>O.rawResource)]),U=F.reverse();for(const{start:D,deleteCount:x,toInsert:M}of U){const O=M.map(W=>W.handle),H=this._handlesSnapshot.splice(D,x,...O);for(const W of H)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=g,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class u{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,Oe(this,l,"f").$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,Oe(this,l,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,Oe(this,l,"f").$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=g;const T=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);Oe(this,l,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(g){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=g;const T=g!==void 0?{command:this._commands.converter.toInternal(g.command,this._actionButtonDisposables.value),secondaryCommands:g.secondaryCommands?.map(F=>F.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,l,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&r(this._statusBarCommands,g))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=g;const T=(g||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Oe(this,l,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(g,T,F,j,U,D){this._extension=g,this._commands=F,this._id=j,this._label=U,this._rootUri=D,l.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,l,T,"f"),this._inputBox=new n(g,Oe(this,l,"f"),this.handle),Oe(this,l,"f").$registerSourceControl(this.handle,j,U,D)}createResourceGroup(g,T){const F=new o(Oe(this,l,"f"),this._commands,this.handle,g,T),j=I.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const g=[],T=[];for(const[F,j]of this.createdResourceGroups){j.dispose();const U=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});I.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),U.dispose(),this._groups.delete(F.handle),Oe(this,l,"f").$unregisterGroup(this.handle,F.handle)}),g.push([F.handle,F.id,F.label,F.features]);const D=F._takeResourceStateSnapshot();D.length>0&&T.push([F.handle,D]),this._groups.set(F.handle,F)}Oe(this,l,"f").$registerGroups(this.handle,g,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(T=>{const F=T._takeResourceStateSnapshot();F.length!==0&&g.push([T.handle,F])}),g.length>0&&Oe(this,l,"f").$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),Oe(this,l,"f").$unregisterSourceControl(this.handle)}}l=new WeakMap,u._handlePool=0,xe([(0,b.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),xe([(0,b.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let i=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(g,T,F){this._commands=T,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=g.getProxy(A.MainContext.MainThreadSCM),this._telemetry=g.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const U=this._sourceControls.get(j.sourceControlHandle);if(!U)return j;const D=U.getResourceGroup(j.groupHandle);return D?D.getResourceState(j.handle):j}else if(j&&j.$mid===4){const U=this._sourceControls.get(j.sourceControlHandle);return U?U.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const U=this._sourceControls.get(j.handle);return U||j}return j}})}createSourceControl(g,T,F,j){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,T,F,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const U=Ji._handlePool++,D=new u(g,this._proxy,this._commands,T,F,j);this._sourceControls.set(U,D);const x=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier))||[];return x.push(D),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(g.identifier),x),D}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const T=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier)),F=T&&T[T.length-1];return F&&F.inputBox}$provideOriginalResource(g,T,F){const j=s.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,j.toString());const U=this._sourceControls.get(g);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(j,F)).then(D=>D||null)}$onInputBoxValueChange(g,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const F=this._sourceControls.get(g);return F&&F.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(g,T,F,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,T,F);const U=this._sourceControls.get(g);if(!U)return Promise.resolve(void 0);const D=U.getResourceGroup(T);return D?D.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(g,T,F){this.logService.trace("ExtHostSCM#$validateInput",g);const j=this._sourceControls.get(g);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>j.inputBox.validateInput(T,F)).then(U=>{if(!U)return Promise.resolve(void 0);const D=C.MarkdownString.fromStrict(U.message);return D?Promise.resolve([D,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};i._handlePool=0,i=xe([$e(2,R.ILogService)],i),e.ExtHostSCM=i}),define(Ie[72],Ce([1,0,5,4,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,P){return this._proxy.$setPassword(A,y,P)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[216],Ce([1,0,6,5,133,7,8,9]),function(ne,e,s,I,b,N,_,A){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,a,l,f,v=s.StatusBarAlignment.Left,w){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new N.DisposableStore,Ye(this,y,p,"f"),Ye(this,P,a,"f"),this._entryId=R.ID_GEN++,this._extension=l,this._id=f,this._alignment=v,this._priority=this.validatePriority(w)}validatePriority(p){if(!!(0,A.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let a;this._name?a=this._name:a=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=_.MarkdownString.fromStrict(this._tooltip);Oe(this,y,"f").$setEntry(this._entryId,p,a,this._text,f,this._command?.internal,l,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,y=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const a={message:p};return this._messages.unshift(a),this._update(),new s.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(p,a){this._proxy=p.getProxy(I.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new E(this)}createStatusBarEntry(p,a,l,f){return new R(this._proxy,this._commands,p,a,l,f)}setStatusBarMessage(p,a){const l=this._statusMessage.setMessage(p);let f;return typeof a=="number"?f=setTimeout(()=>l.dispose(),a):typeof a<"u"&&a.then(()=>l.dispose(),()=>l.dispose()),new s.Disposable(()=>{l.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=m}),define(Ie[73],Ce([1,0,5,4,3]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,P){return this._proxy.$initializeExtensionStorage(A,y).then(R=>R||P)}setValue(A,y,P){return this._proxy.$setValue(A,y,P)}$acceptValue(A,y,P){this._onDidChangeStorage.fire({shared:A,key:y,value:P})}}e.ExtHostStorage=N,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(Ie[74],Ce([1,0,3,27,11,54,2]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,R,E){this._logService=R,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return _.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return _.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return _.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=xe([$e(0,I.IExtHostInitDataService),$e(1,b.ILogService),$e(2,N.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[55],Ce([1,0,4,5,3,2,14,7,6,134,12,172,21,38,158,61,9,15,8]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class w{constructor(i,c,g,T){this._proxy=i,this._id=c,this._creationOptions=g,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const F=this;this.value={get name(){return F._name||""},get processId(){return F._pidPromise},get creationOptions(){return F._creationOptions},get exitStatus(){return F._exitStatus},get state(){return F._state},sendText(j,U=!0){F._checkDisposed(),F._proxy.$sendText(F._id,j,U)},show(j){F._checkDisposed(),F._proxy.$show(F._id,j)},hide(){F._checkDisposed(),F._proxy.$hide(F._id)},dispose(){F._disposed||(F._disposed=!0,F._proxy.$dispose(F._id))},get dimensions(){if(!(F._cols===void 0||F._rows===void 0))return{columns:F._cols,rows:F._rows}}}}async create(i,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,l.withNullAsUndefined)(i.shellPath),shellArgs:(0,l.withNullAsUndefined)(i.shellArgs),cwd:(0,l.withNullAsUndefined)(i.cwd),env:(0,l.withNullAsUndefined)(i.env),icon:(0,l.withNullAsUndefined)(n(i.iconPath)),color:a.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,l.withNullAsUndefined)(i.message),strictEnv:(0,l.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,l.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,l.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,l.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(i.location,c?.resolvedExtHostIdentifier),isTransient:(0,l.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,c,g,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:a.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(i,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,c){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in i?{viewColumn:v.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitStatus(i,c){this._exitStatus=Object.freeze({code:i,reason:c})}setDimensions(i,c){return i===this._cols&&c===this._rows||i===0||c===0?!1:(this._cols=i,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class d{get onProcessReady(){return this._onProcessReady.event}constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,c){this._pty.setDimensions?.({columns:i,rows:c})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let S=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(i,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new s.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=c.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[g,T]of this._terminalProcesses)T.shutdown(!0)}})}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,c){const g=new w(this._proxy,(0,C.generateUuid)(),i,i.name),T=new d(i.pty);return g.createExtensionTerminal(i.location,this._serializeParentTerminal(i,c).resolvedExtHostIdentifier,n(i.iconPath),o(i.color)).then(F=>{const j=this._setupExtHostProcessListeners(F,T);this._terminalProcessDisposables[F]=j}),this._terminals.push(g),g.value}_serializeParentTerminal(i,c){if(c=c||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const g=i.location.parentTerminal;if(g){const T=this._terminals.find(F=>F.value===g);T&&(c.resolvedExtHostIdentifier=T._id)}}else i.location&&typeof i.location!="object"?c.location=i.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(i,c){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const T=new d(c),F=this._setupExtHostProcessListeners(i,T);this._terminalProcessDisposables[i]=F}async $acceptActiveTerminalChanged(i){const c=this._activeTerminal;if(i===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(i);g&&(this._activeTerminal=g,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,c){const g=this._getTerminalById(i);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:c})}async $acceptTerminalDimensions(i,c,g){const T=this._getTerminalById(i);T&&T.setDimensions(c,g)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(i,c,g){this._terminalProcesses.get(i)?.resize(c,g)}async $acceptTerminalTitleChange(i,c){const g=this._getTerminalById(i);g&&(g.name=c)}async $acceptTerminalClosed(i,c,g){const T=this._getTerminalObjectIndexById(this._terminals,i);if(T!==null){const F=this._terminals.splice(T,1)[0];F.setExitStatus(c,g),this._onDidCloseTerminal.fire(F.value)}}$acceptTerminalOpened(i,c,g,T){if(c){const U=this._getTerminalObjectIndexById(this._terminals,c);if(U!==null){this._terminals[U]._id=i,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const F={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:N.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},j=new w(this._proxy,i,F,g);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(i,c){this._getTerminalById(i)?._setProcessId(c)}async $startExtensionTerminal(i,c){const g=this._getTerminalById(i);if(!g)return{message:(0,P.localize)(0,null,i)};g.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async U=>{U===g.value&&(j.dispose(),F())})});const T=this._terminalProcesses.get(i);T?T.startSendingEvents(c):this._extensionTerminalAwaitingStart[i]={initialDimensions:c}}_setupExtHostProcessListeners(i,c){const g=new A.DisposableStore;g.add(c.onProcessReady(F=>this._proxy.$sendProcessReady(i,F.pid,F.cwd))),g.add(c.onDidChangeProperty(F=>this._proxy.$sendProcessProperty(i,F))),this._bufferer.startBuffering(i,c.onProcessData),g.add(c.onProcessExit(F=>this._onProcessExit(i,F))),this._terminalProcesses.set(i,c);const T=this._extensionTerminalAwaitingStart[i];return T&&c instanceof d&&(c.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),g}$acceptProcessAckDataEvent(i,c){this._terminalProcesses.get(i)?.acknowledgeDataEvent(c)}$acceptProcessInput(i,c){this._terminalProcesses.get(i)?.input(c)}$acceptTerminalInteraction(i){const c=this._getTerminalById(i);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(i,c,g){try{this._terminalProcesses.get(i)?.resize(c,g)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(i,c){this._terminalProcesses.get(i)?.shutdown(c)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(c=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:c}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,c,g){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,g),this._proxy.$registerProfileProvider(c,i.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(i,c){const g=new m.CancellationTokenSource().token;let T=await this._profileProviders.get(i)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,c);return}this.createTerminalFromOptions(T.options,c)}}async $provideLinks(i,c){const g=this._getTerminalById(i);if(!g)return[];this._terminalLinkCache.delete(i),this._terminalLinkCancellationSource.get(i)?.dispose(!0);const F=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,F);const j=[],U={terminal:g.value,line:c},D=[];for(const O of this._linkProviders)D.push(f.Promises.withAsyncBody(async H=>{F.token.onCancellationRequested(()=>H({provider:O,links:[]}));const W=await O.provideTerminalLinks(U,F.token)||[];F.token.isCancellationRequested||H({provider:O,links:W})}));const x=await Promise.all(D);if(F.token.isCancellationRequested)return[];const M=new Map;for(const O of x)O&&O.links.length>0&&j.push(...O.links.map(H=>{const W={id:S++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return M.set(W.id,{provider:O.provider,link:H}),W}));return this._terminalLinkCache.set(i,M),j}$activateLink(i,c){const g=this._terminalLinkCache.get(i)?.get(c);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(i,c){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const g=this._terminalProcessDisposables[i];g&&(g.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,c)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,c){const g=this._getTerminalObjectIndexById(i,c);return g!==null?i[g]:null}_getTerminalObjectIndexById(i,c){let g=null;return i.some((T,F)=>T._id===c?(g=F,!0):!1),g}getEnvironmentVariableCollection(i){let c=this._environmentVariableCollections.get(i.identifier.value);return c||(c=new h,this._setEnvironmentVariableCollection(i.identifier.value,c)),c}_syncEnvironmentVariableCollection(i,c){const g=(0,E.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(i,c.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(i){i.forEach(c=>{const g=c[0],T=new h(c[1]);this._setEnvironmentVariableCollection(g,T)})}$acceptDefaultProfile(i,c){const g=this._defaultProfile;this._defaultProfile=i,this._defaultAutomationProfile=c,g?.path!==i.path&&this._onDidChangeShell.fire(i.path)}_setEnvironmentVariableCollection(i,c){this._environmentVariableCollections.set(i,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,c)})}};t=xe([$e(1,_.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class h{get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,c){this._setIfDiffers(i,{value:c,type:y.EnvironmentVariableMutatorType.Replace})}append(i,c){this._setIfDiffers(i,{value:c,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,c){this._setIfDiffers(i,{value:c,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,c){const g=this.map.get(i);(!g||g.value!==c.value||g.type!==c.type)&&(this.map.set(i,c),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,c){this.map.forEach((g,T)=>i.call(c,T,g,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let r=class extends t{constructor(i){super(!1,i)}createTerminal(i,c,g){throw new R.NotSupportedError}createTerminalFromOptions(i,c){throw new R.NotSupportedError}};r=xe([$e(0,_.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function n(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function o(u){return a.ThemeColor.isThemeColor(u)?u:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s};define(Ie[217],Ce([1,0,18,23,21,4,181,218,7,25,9,38,5,14,95,8,6,41,66,50]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w){"use strict";var d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(U,D,x){this.editors=x,this.resultsChangedEmitter=new N.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(m.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new r(this.proxy),D.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==13)return M;const O=M,H=O.tests[O.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(H))?.collection.tree.get(H)?.actual??(0,p.toItemFromContext)(M)}})}createTestController(U,D,x){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const M=new y.DisposableStore,O=M.add(new p.ExtHostTestItemCollection(U,D,this.editors));O.root.label=D;const H=new Map,W=this.proxy,z={items:O.root.children,get label(){return D},set label(te){D=te,O.root.label=te,W.$updateController(U,{label:D})},get refreshHandler(){return x},set refreshHandler(te){x=te,W.$updateController(U,{canRefresh:!!te})},get id(){return U},createRunProfile:(te,he,re,be,le)=>{let fe=(0,A.hash)(te);for(;H.has(fe);)fe++;return new T(this.proxy,H,U,fe,te,he,re,be,le)},createTestItem(te,he,re){return new p.TestItemImpl(U,te,he,re)},createTestRun:(te,he,re=!0)=>this.runTracker.createTestRun(U,O,te,he,re),set resolveHandler(te){O.resolveHandler=te},get resolveHandler(){return O.resolveHandler},dispose:()=>{M.dispose()}};W.$registerTestController(U,D,!!x),M.add((0,y.toDisposable)(()=>W.$unregisterTestController(U)));const G={controller:z,collection:O,profiles:H};return this.controllers.set(U,G),M.add((0,y.toDisposable)(()=>this.controllers.delete(U))),M.add(O.onDidGenerateDiff(te=>W.$publishDiff(U,te.map(w.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(U,D=b.CancellationToken.None){const x=n(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(x.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(O=>f.TestId.fromExtHostTestItem(O,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:F[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(O=>O.id)},D)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,D,x){return(0,s.mapFind)(this.runTracker.trackers,O=>O.id===U?O.getCoverage(D):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(U,D,x,M){return(0,s.mapFind)(this.runTracker.trackers,H=>H.id===U?H.getCoverage(D):void 0)?.resolveFileCoverage(x,M)??Promise.resolve([])}$configureRunProfile(U,D){this.controllers.get(U)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(U,D){await this.controllers.get(U)?.controller.refreshHandler?.(D)}$publishTestResults(U){this.results=Object.freeze(U.map(D=>(0,P.deepFreeze)(a.TestResults.to(D))).concat(this.results).sort((D,x)=>x.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,D){const x=this.controllers.get(f.TestId.fromString(U).controllerId)?.collection;x&&(await x.expand(U,D<0?1/0:D),x.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(w.TestsDiffOp.deserialize))}async $runControllerTests(U,D){return Promise.all(U.map(x=>this.runControllerTestRequest(x,D)))}async runControllerTestRequest(U,D){const x=this.controllers.get(U.controllerId);if(!x)return{};const{collection:M,profiles:O}=x,H=O.get(U.profileId);if(!H)return{};const W=U.testIds.map(he=>M.tree.get(he)).filter(R.isDefined),z=U.excludeExtIds.map(he=>x.collection.tree.get(he)).filter(R.isDefined).filter(he=>W.some(re=>re.fullId.compare(he.fullId)===2));if(!W.length)return{};const G=new l.TestRunRequest(W.some(he=>he.actual instanceof p.TestItemRootImpl)?void 0:W.map(he=>he.actual),z.map(he=>he.actual),H),te=this.runTracker.prepareForMainThreadTestRun(G,o.fromInternal(U,x.collection),D);try{return await H.runHandler(G,D),{}}catch(he){return{error:String(he)}}finally{te.isRunning&&!D.isCancellationRequested&&await N.Event.toPromise(te.onEnd),te.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};t=xe([$e(0,C.IExtHostRpcService)],t),e.ExtHostTesting=t;class h extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,D,x){super(),this.dto=U,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new N.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const D=this.dto.id,x=this.dto.controllerId,M=(0,E.generateUuid)(),O=new u(this.proxy,D,M),H=te=>(he,...re)=>{if(z){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(he)||(this.ensureTestIsKnown(he),te(he,...re))},W=(te,he)=>{const re=he instanceof Array?he.map(a.TestMessage.from):[a.TestMessage.from(he)];if(te.uri&&te.range){const be={range:a.Range.from(te.range),uri:te.uri};for(const le of re)le.location=le.location||be}this.proxy.$appendTestMessagesInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),re)};let z=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return O.coverageProvider},set coverageProvider(te){O.coverageProvider=te},enqueued:H(te=>{this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),1)}),skipped:H(te=>{this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),5)}),started:H(te=>{this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),2)}),errored:H((te,he,re)=>{W(te,he),this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),6,re)}),failed:H((te,he,re)=>{W(te,he),this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,x).toString(),4,re)}),passed:H((te,he)=>{this.proxy.$updateTestStateInRun(D,M,f.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,he)}),appendOutput:(te,he,re)=>{z||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(D,M,I.VSBuffer.fromString(te),he&&a.location.from(he),re&&f.TestId.fromExtHostTestItem(re,x).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(D,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:G,coverage:O}),this.proxy.$startedTestRunTask(D,{id:M,name:U,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof p.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const D=[],x=this.dto.colllection.root;for(;;){const M=a.TestItem.from(U);if(D.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),U===x))break;U=U.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class r{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,D,x){return this.getTracker(U,D,x)}cancelRunById(U){for(const D of this.tracked.values())if(D.id===U){D.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,D,x,M,O){const H=this.tracked.get(x);if(H)return H.createRun(M);const W=o.fromPublic(U,D,x,O),z=n(x);this.proxy.$startedExtensionTestRun({controllerId:U,profile:z&&{group:F[z.kind],id:z.profileId},exclude:x.exclude?.map(te=>f.TestId.fromExtHostTestItem(te,D.root.id).toString())??[],id:W.id,include:x.include?.map(te=>f.TestId.fromExtHostTestItem(te,D.root.id).toString())??[D.root.id],persist:O});const G=this.getTracker(x,W);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),G.createRun(M)}getTracker(U,D,x){const M=new h(D,this.proxy,x);return this.tracked.set(U,M),M.onEnd(()=>this.tracked.delete(U)),M}}e.TestRunCoordinator=r;const n=j=>{if(!!j.profile){if(!(j.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class o{static fromPublic(U,D,x,M){return new o(U,(0,E.generateUuid)(),x.include?.map(O=>f.TestId.fromExtHostTestItem(O,U).toString())??[U],x.exclude?.map(O=>f.TestId.fromExtHostTestItem(O,U).toString())??[],M,D)}static fromInternal(U,D){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,D)}constructor(U,D,x,M,O,H){this.controllerId=U,this.id=D,this.isPersisted=O,this.colllection=H,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=M.map(W=>W+"\0")}isIncluded(U){const D=f.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(D===x||D.startsWith(x))return!1;for(const x of this.includePrefix)if(D===x||D.startsWith(x))return!0;return!1}}e.TestRunDto=o;class u{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,D,x){this.proxy=U,this.runId=D,this.taskId=x}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(U,D){const x=await this.fileCoverage;let M=x?.[U];return!this._coverageProvider||!x||!M?[]:(M.detailedCoverage||(M=x[U]=await this._coverageProvider.resolveFileCoverage?.(M,D)??M),M.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class i extends w.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const D=f.TestId.parentId(U.item.extId);if(D&&this.alreadyRemoved.has(D.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:D,removed:x}=this;return{get added(){return[...U].map(M=>M.revived)},get updated(){return[...D].map(M=>M.revived)},get removed(){return[...x].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new N.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,D){return{...U,revived:a.TestItem.toPlain(U.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new i(this.changeEmitter)}}e.MirroredTestCollection=c;class g{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(D=>D.revived)},dispose:(0,_.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class T{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,D,x,M,O,H,W,z=!1,G=void 0){this.controllerId=x,this.profileId=M,this._label=O,this.kind=H,this.runHandler=W,this._isDefault=z,this._tag=G,d.set(this,void 0),S.set(this,void 0),Ye(this,d,U,"f"),Ye(this,S,D,"f"),D.set(M,this);const te=F[H];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);Oe(this,d,"f").$publishTestRunProfile({profileId:M,controllerId:x,tag:G?a.TestTag.namespace(this.controllerId,G.id):null,label:O,group:te,isDefault:z,hasConfigurationHandler:!1})}dispose(){Oe(this,S,"f")?.delete(this.profileId)&&(Ye(this,S,void 0,"f"),Oe(this,d,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,d=new WeakMap,S=new WeakMap;const F={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[219],Ce([1,0,18,4,5,96,8,6]),function(ne,e,s,I,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new I.Emitter,this._onDidChangeTextEditorOptions=new I.Emitter,this._onDidChangeTextEditorVisibleRanges=new I.Emitter,this._onDidChangeTextEditorViewColumn=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const E=this._extHostDocumentsAndEditors.allEditors();return R?E:E.map(m=>m.value)}async showTextDocument(R,E,m){let C;typeof E=="number"?C={position:_.ViewColumn.from(E),preserveFocus:m}:typeof E=="object"?C={position:_.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?_.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:C={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,C),a=p&&this._extHostDocumentsAndEditors.getEditor(p);if(a)return a.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,E){return new N.TextEditorDecorationType(this._proxy,R,E).value}$acceptEditorPropertiesChanged(R,E){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(E.options&&m._acceptOptions(E.options),E.selections){const C=E.selections.selections.map(_.Selection.to);m._acceptSelections(C)}if(E.visibleRanges){const C=s.coalesce(E.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(C)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...E.options,lineNumbers:_.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const C=A.TextEditorSelectionChangeKind.fromValue(E.selections.source),p=E.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:p,kind:C})}if(E.visibleRanges){const C=s.coalesce(E.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:C})}}$acceptEditorPositionData(R){for(const E in R){const m=this._extHostDocumentsAndEditors.getEditor(E);if(!m)throw new Error("Unknown text editor");const C=_.ViewColumn.to(R[E]);m.value.viewColumn!==C&&(m._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:C}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y}),define(Ie[220],Ce([1,0,2,3,5,7,6,8,9]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(m,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===11){const a=p.uri===void 0?void 0:s.URI.revive(p.uri);return this._itemsBySourceAndUriMap.get(p.source)?.get(R(a))?.get(p.handle)}return p}})}async $getTimeline(m,C,p,a){return this._providers.get(m)?.provideTimeline(s.URI.revive(C),p,a)}registerTimelineProvider(m,C,p,a){const l=new N.DisposableStore,f=this.convertTimelineItem(C.id,a,l).bind(this);let v;C.onDidChange&&(v=C.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:C.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:m,onDidChange:void 0,async provideTimeline(d,S,t){S?.resetCache&&(l.clear(),w.get(C.id)?.clear());const h=await C.provideTimeline(d,S,t);if(h==null)return;const r=f(d,S);return{...h,source:C.id,items:h.items.map(r)}},dispose(){for(const d of w.values())d.get(C.id)?.clear();v?.dispose(),l.dispose()}})}convertTimelineItem(m,C,p){return(a,l)=>{let f;if(l?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const w=R(a);f=v.get(w),f===void 0&&(f=new Map,v.set(w,f))}return v=>{const{iconPath:w,...d}=v,S=`${m}|${v.id??v.timestamp}`;f?.set(S,v);let t,h,r;v.iconPath&&(w instanceof _.ThemeIcon?r={id:w.id,color:w.color}:s.URI.isUri(w)?(t=w,h=w):{light:t,dark:h}=w);let n;return _.MarkdownString.isMarkdownString(d.tooltip)?n=A.MarkdownString.from(d.tooltip):(0,y.isString)(d.tooltip)?n=d.tooltip:_.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(d.detail)):(0,y.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=d.detail),{...d,id:d.id??void 0,handle:S,source:m,command:v.command?C.toInternal(v.command,p):void 0,icon:t,iconDark:h,themeIcon:r,tooltip:n,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,N.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function R(E){return E?.toString()}}),define(Ie[221],Ce([1,0,7,13,2,5]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(y){this._openers=new Map,this._proxy=y.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,R,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=E.schemes.find(C=>!_.supportedSchemes.has(C));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,E.schemes,y,E.label),(0,s.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,R){const E=this._openers.get(y);if(!E)throw new Error(`Unknown opener with id: ${y}`);const m=b.URI.revive(P);return E.canOpenExternalUri(m,R)}async $openUri(y,P,R){const E=this._openers.get(y);if(!E)throw new Error(`Unknown opener id: '${y}'`);return E.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(Ie[222],Ce([1,0,5,2,7,12,26]),function(ne,e,s,I,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(_.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(P)),this.handlers.set(E,R),this._proxy.$registerUriHandler(E,P),(0,b.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,R){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(I.URI.revive(R))}catch(m){(0,N.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return I.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[56],Ce([1,0,4,13,2,145,165,64,5]),function(ne,e,s,I,b,N,_,A,y){"use strict";var P,R,E,m,C,p,a,l,f,v,w,d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class t{constructor(T,F,j,U,D,x,M){P.set(this,void 0),R.set(this,void 0),E.set(this,void 0),m.set(this,void 0),C.set(this,void 0),p.set(this,void 0),a.set(this,""),l.set(this,void 0),f.set(this,!1),v.set(this,!1),w.set(this,void 0),d.set(this,void 0),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,S.set(this,new s.Emitter),this._onDidDispose=Oe(this,S,"f").event,Ye(this,P,T,"f"),Ye(this,R,F,"f"),Ye(this,l,j,"f"),Ye(this,m,U,"f"),Ye(this,C,D,"f"),Ye(this,p,x,"f"),Ye(this,w,h(x),"f"),Ye(this,d,r(x),"f"),Ye(this,E,M,"f")}dispose(){Ye(this,f,!0,"f"),Oe(this,S,"f").fire(),Oe(this,S,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Ye(this,v,!0,"f"),(0,A.asWebviewUri)(T,Oe(this,m,"f"))}get cspSource(){const T=Oe(this,p,"f").extensionLocation;if(T.scheme===I.Schemas.https||T.scheme===I.Schemas.http){let F=T.toString();return F.endsWith("/")||(F+="/"),F+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(T){this.assertNotDisposed(),Oe(this,a,"f")!==T&&(Ye(this,a,T,"f"),Oe(this,d,"f")&&!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Ye(this,v,!0,"f"),Oe(this,E,"f").report("Webview vscode-resource: uris",Oe(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,P,"f"),this.rewriteOldResourceUrlsIfNeeded(T)))}get options(){return this.assertNotDisposed(),Oe(this,l,"f")}set options(T){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,P,"f"),u(Oe(this,p,"f"),Oe(this,C,"f"),T)),Ye(this,l,T,"f")}async postMessage(T){if(Oe(this,f,"f"))return!1;const F=(0,_.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Oe(this,w,"f")});return Oe(this,R,"f").$postMessage(Oe(this,P,"f"),F.message,...F.buffers)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(T){if(!Oe(this,d,"f"))return T;const F=Oe(this,p,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,j=Oe(this,p,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Oe(this,p,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,D,x,M,O,H)=>{const W=b.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)(W,{isRemote:F,authority:j}).toString();return`${D}${z}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,D,x,M,O,H)=>{const W=b.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)(W,{isRemote:F,authority:j}).toString();return`${D}${z}${H}`})}}e.ExtHostWebview=t,P=new WeakMap,R=new WeakMap,E=new WeakMap,m=new WeakMap,C=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,f=new WeakMap,v=new WeakMap,w=new WeakMap,d=new WeakMap,S=new WeakMap;function h(g){try{const T=(0,N.normalizeVersion)((0,N.parseVersion)(g.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=h;function r(g){try{const T=(0,N.normalizeVersion)((0,N.parseVersion)(g.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class n{constructor(T,F,j,U,D){this.remoteInfo=F,this.workspace=j,this._logService=U,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=T.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(T,F,j){const U=this.getWebview(T);if(U){const{message:D}=(0,_.deserializeWebviewMessage)(F,j.value);U._onMessageEmitter.fire(D)}}$onMissingCsp(T,F){this._logService.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,F,j){const U=new t(T,this._webviewProxy,i(F),this.remoteInfo,this.workspace,j,this._deprecationService);return this._webviews.set(T,U),U._onDidDispose(()=>{this._webviews.delete(T)}),U}deleteWebview(T){this._webviews.delete(T)}getWebview(T){return this._webviews.get(T)}}e.ExtHostWebviews=n;function o(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=o;function u(g,T,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||c(g,T)}}e.serializeWebviewOptions=u;function i(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(T=>b.URI.from(T))}}e.reviveOptions=i;function c(g,T){return[...(T?.getWorkspaceFolders()||[]).map(F=>F.uri),g.extensionLocation]}}),define(Ie[223],Ce([1,0,21,218,7,13,22,2,8,56,62,5,6]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(h,r){this.document=h,this._storagePath=r,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(h){return this._edits.add([h])}async undo(h,r){await this.getEdit(h).undo(),r||this.disposeBackup()}async redo(h,r){await this.getEdit(h).redo(),r||this.disposeBackup()}disposeEdits(h){for(const r of h)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const h=S(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,h)}updateBackup(h){this._backup?.delete(),this._backup=h}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(h){const r=this._edits.get(h,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this._documents=new Map}get(h,r){return this._documents.get(this.key(h,r))}add(h,r,n){const o=this.key(h,r.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${h} resource:${r.uri}`);const u=new C(r,n);return this._documents.set(o,u),u}delete(h,r){const n=this.key(h,r.uri);this._documents.delete(n)}key(h,r){return`${h}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class l{constructor(){this._providers=new Map}addTextProvider(h,r,n){return this.add(0,h,r,n)}addCustomProvider(h,r,n){return this.add(1,h,r,n)}get(h){return this._providers.get(h)}add(h,r,n,o){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:h,extension:n,provider:o}),new m.Disposable(()=>this._providers.delete(r))}}class f{constructor(h,r,n,o,u){this._extHostDocuments=r,this._extensionStoragePaths=n,this._extHostWebview=o,this._extHostWebviewPanels=u,this._editorProviders=new l,this._documents=new p,this._proxy=h.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,r,n,o){const u=new b.DisposableStore;return w(n)?(u.add(this._editorProviders.addTextProvider(r,h,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(h),r,o.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(h))):(u.add(this._editorProviders.addCustomProvider(r,h,n)),v(n)&&u.add(n.onDidChangeCustomDocument(i=>{const c=this.getCustomDocumentEntry(r,i.document.uri);if(d(i)){const g=c.addEdit(i);this._proxy.$onDidEdit(i.document.uri,r,g,i.label)}else this._proxy.$onContentChange(i.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(h),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(h))),m.Disposable.from(u,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(h,r,n,o,u){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const c=A.URI.revive(h),g=await i.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:o?.buffer},u);let T;return v(i.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(r,g,T),{editable:v(i.provider)}}async $disposeCustomDocument(h,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=A.URI.revive(h),{document:u}=this.getCustomDocumentEntry(r,o);this._documents.delete(r,u),u.dispose()}async $resolveWebviewEditor(h,r,n,o,u,i){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const g=y.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(r,o.contentOptions,c.extension),F=this._extHostWebviewPanels.createNewWebviewPanel(r,n,o.title,g,o.options,T,!0),j=A.URI.revive(h);switch(c.type){case 1:{const{document:U}=this.getCustomDocumentEntry(n,j);return c.provider.resolveCustomEditor(U,F,i)}case 0:{const U=this._extHostDocuments.getDocument(j);return c.provider.resolveCustomTextEditor(U,F,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,r,n){this.getCustomDocumentEntry(r,h).disposeEdits(n)}async $onMoveCustomEditor(h,r,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const u=this._extHostWebviewPanels.getWebviewPanel(h);if(!u)throw new Error("No webview found");const i=A.URI.revive(r),c=this._extHostDocuments.getDocument(i);await o.provider.moveCustomTextEditor(c,u,s.CancellationToken.None)}async $undo(h,r,n,o){return this.getCustomDocumentEntry(r,h).undo(n,o)}async $redo(h,r,n,o){return this.getCustomDocumentEntry(r,h).redo(n,o)}async $revert(h,r,n){const o=this.getCustomDocumentEntry(r,h);await this.getCustomEditorProvider(r).revertCustomDocument(o.document,n),o.disposeBackup()}async $onSave(h,r,n){const o=this.getCustomDocumentEntry(r,h);await this.getCustomEditorProvider(r).saveCustomDocument(o.document,n),o.disposeBackup()}async $onSaveAs(h,r,n,o){const u=this.getCustomDocumentEntry(r,h);return this.getCustomEditorProvider(r).saveCustomDocumentAs(u.document,A.URI.revive(n),o)}async $backup(h,r,n){const o=this.getCustomDocumentEntry(r,h),i=await this.getCustomEditorProvider(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},n);return o.updateBackup(i),i.id}getCustomDocumentEntry(h,r){const n=this._documents.get(h,A.URI.revive(r));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(h){const n=this._editorProviders.get(h)?.provider;if(!n||!v(n))throw new Error("Custom document is not editable");return n}}e.ExtHostCustomEditors=f;function v(t){return!!t.onDidChangeCustomDocument}function w(t){return typeof t.resolveCustomTextEditor=="function"}function d(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function S(t){const h=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,I.hash)(h)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[224],Ce([1,0,4,7,2,38,8,56,5,6]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";var R,E,m,C,p,a,l,f,v,w,d,S,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends I.Disposable{constructor(u,i,c,g){super(),R.set(this,void 0),E.set(this,void 0),m.set(this,void 0),C.set(this,void 0),p.set(this,void 0),a.set(this,void 0),l.set(this,void 0),f.set(this,void 0),v.set(this,!0),w.set(this,void 0),d.set(this,!1),S.set(this,this._register(new s.Emitter)),this.onDidDispose=Oe(this,S,"f").event,t.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Ye(this,R,u,"f"),Ye(this,E,i,"f"),Ye(this,C,c,"f"),Ye(this,m,g.viewType,"f"),Ye(this,p,g.panelOptions,"f"),Ye(this,f,g.viewColumn,"f"),Ye(this,a,g.title,"f"),Ye(this,w,g.active,"f")}dispose(){Oe(this,d,"f")||(Ye(this,d,!0,"f"),Oe(this,S,"f").fire(),Oe(this,E,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,C,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,C,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(u){this.assertNotDisposed(),Oe(this,a,"f")!==u&&(Ye(this,a,u,"f"),Oe(this,E,"f").$setTitle(Oe(this,R,"f"),u))}get iconPath(){return this.assertNotDisposed(),Oe(this,l,"f")}set iconPath(u){this.assertNotDisposed(),Oe(this,l,"f")!==u&&(Ye(this,l,u,"f"),Oe(this,E,"f").$setIconPath(Oe(this,R,"f"),b.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Oe(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,f,"f")=="number"&&Oe(this,f,"f")<0))return Oe(this,f,"f")}get active(){return this.assertNotDisposed(),Oe(this,w,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(u){Oe(this,d,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,w,u.active,"f"),Ye(this,v,u.visible,"f"),Ye(this,f,u.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(u,i){this.assertNotDisposed(),Oe(this,E,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof u>"u"?void 0:_.ViewColumn.from(u),preserveFocus:!!i})}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,E=new WeakMap,m=new WeakMap,C=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,f=new WeakMap,v=new WeakMap,w=new WeakMap,d=new WeakMap,S=new WeakMap,t=new WeakMap;class r{static newHandle(){return(0,N.generateUuid)()}constructor(u,i,c){this.webviews=i,this.workspace=c,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,i,c,g,T={}){const F=typeof g=="object"?g.viewColumn:g,j={viewColumn:_.ViewColumn.from(F),preserveFocus:typeof g=="object"&&!!g.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(u),D=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(u),D,i,{title:c,panelOptions:n(T),webviewOptions:(0,A.serializeWebviewOptions)(u,this.workspace,T),serializeBuffersForPostMessage:U},j);const x=this.webviews.createNewWebview(D,T,u);return this.createNewWebviewPanel(D,i,c,F,T,x,!0)}$onDidChangeWebviewPanelViewStates(u){const i=Object.keys(u);i.sort((c,g)=>{const T=u[c],F=u[g];return T.active?1:F.active?-1:+T.visible-+F.visible});for(const c of i){const g=this.getWebviewPanel(c);if(!g)continue;const T=u[c];g._updateViewState({active:T.active,visible:T.visible,viewColumn:_.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,i,c){if(this._serializers.has(i))throw new Error(`Serializer for '${i}' already registered`);return this._serializers.set(i,{serializer:c,extension:u}),this._proxy.$registerSerializer(i,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(u)}),new P.Disposable(()=>{this._serializers.delete(i),this._proxy.$unregisterSerializer(i)})}async $deserializeWebviewPanel(u,i,c,g){const T=this._serializers.get(i);if(!T)throw new Error(`No serializer found for '${i}'`);const{serializer:F,extension:j}=T,U=this.webviews.createNewWebview(u,c.webviewOptions,j),D=this.createNewWebviewPanel(u,i,c.title,g,c.panelOptions,U,c.active);await F.deserializeWebviewPanel(D,c.state)}createNewWebviewPanel(u,i,c,g,T,F,j){const U=new h(u,this._proxy,F,{viewType:i,title:c,viewColumn:g,panelOptions:T,active:j});return this._webviewPanels.set(u,U),U}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=r;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[225],Ce([1,0,4,7,56,8,5,6]),function(ne,e,s,I,b,N,_,A){"use strict";var y,P,R,E,m,C,p,a,l,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(t,h,r,n,o,u,i){super(),y.set(this,void 0),P.set(this,void 0),R.set(this,void 0),E.set(this,void 0),m.set(this,!1),C.set(this,void 0),p.set(this,void 0),a.set(this,void 0),l.set(this,void 0),f.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Oe(this,f,"f").event,v.set(this,this._register(new s.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Ye(this,R,r,"f"),Ye(this,p,n,"f"),Ye(this,y,t,"f"),Ye(this,P,h,"f"),Ye(this,E,o,"f"),Ye(this,C,i,"f")}dispose(){Oe(this,m,"f")||(Ye(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,E,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(t){this.assertNotDisposed(),Oe(this,p,"f")!==t&&(Ye(this,p,t,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,y,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Ye(this,a,t,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,y,"f"),t))}get visible(){return Oe(this,C,"f")}get webview(){return Oe(this,E,"f")}get viewType(){return Oe(this,R,"f")}_setVisible(t){t===Oe(this,C,"f")||Oe(this,m,"f")||(Ye(this,C,t,"f"),Oe(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,l,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,l,"f")?.value&&t?.tooltip===Oe(this,l,"f")?.tooltip)&&(Ye(this,l,N.ViewBadge.from(t),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,y,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,y,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,P=new WeakMap,R=new WeakMap,E=new WeakMap,m=new WeakMap,C=new WeakMap,p=new WeakMap,a=new WeakMap,l=new WeakMap,f=new WeakMap,v=new WeakMap;class d{constructor(t,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,h,r,n){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:r,extension:t}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(t),h,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(t,h,r,n,o){const u=this._viewProviders.get(h);if(!u)throw new Error(`No view provider found for '${h}'`);const{provider:i,extension:c}=u,g=this._extHostWebview.createNewWebview(t,{},c),T=new w(t,this._proxy,h,r,g,c,!0);this._webviewViews.set(t,T),await i.resolveWebviewView(T,{state:n},o)}async $onDidChangeWebviewViewVisibility(t,h){this.getWebviewView(t)._setVisible(h)}async $disposeWebviewView(t){const h=this.getWebviewView(t);this._webviewViews.delete(t),h.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const h=this._webviewViews.get(t);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=d}),define(Ie[98],Ce([1,0,4,5,2,13,10,3,14]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Zi{get state(){return this._state}constructor(E){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=E.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,m){let C;if(typeof E=="string"){C=E;try{E=b.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,_.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,C,m)}async asExternalUri(E,m){if((0,_.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this._proxy.$asExternalUri(E,m);return b.URI.from(C)}};P.InitialState={focused:!0},P=xe([$e(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[226],Ce([1,0,196,27,14]),function(ne,e,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends s.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,P){y.apply(console,P)}};N=xe([$e(0,b.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ie[227],Ce([1,0,15,23,21,12,4,7,119,190,42]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(T,F){try{return JSON.stringify(T,F)}catch{return"null"}}const C="$$ref$$",p={[C]:-1};class a{constructor(F,j){this.jsonString=F,this.referencedBuffers=j}}function l(T,F=null,j=!1){const U=[];return{jsonString:(j?m:JSON.stringify)(T,(x,M)=>{if(typeof M>"u")return p;if(typeof M=="object"){if(M instanceof I.VSBuffer){const O=U.push(M)-1;return{[C]:O}}if(F)return F(x,M)}return M}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=l;function f(T,F,j){return JSON.parse(T,(U,D)=>{if(D){const x=D[C];if(typeof x=="number")return F[x];if(j&&D.$mid===1)return j.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=f;function v(T,F){return JSON.stringify(T,F)}function w(T){return T?(F,j)=>j&&j.$mid===1?T.transformOutgoing(j):j:null}var d;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(F,j=null,U=null){super(),this[E]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=F,this._logger=j,this._uriTransformer=U,this._uriReplacer=w(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,x=R.ProxyIdentifier.count;D<x;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(F=>{this._pendingRPCReplies[F].resolveErr(N.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(F){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(F){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(F){this._responsiveState!==F&&(this._responsiveState=F,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(F){return this._uriTransformer?(0,y.transformIncomingURIs)(F,this._uriTransformer):F}getProxy(F){const{nid:j,sid:U}=F;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,U)),this._proxies[j]}_createProxy(F,j){const U={get:(D,x)=>(typeof x=="string"&&!D[x]&&x.charCodeAt(0)===36&&(D[x]=(...M)=>this._remoteCall(F,x,M)),x===r?j:D[x])};return new Proxy(Object.create(null),U)}set(F,j){return this._locals[F.nid]=j,j}assertRegistered(F){for(let j=0,U=F.length;j<U;j++){const D=F[j];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(F){if(this._isDisposed)return;const j=F.byteLength,U=o.read(F,0),D=U.readUInt8(),x=U.readUInt32();switch(D){case 1:case 2:{let{rpcId:M,method:O,args:H}=i.deserializeRequestJSONArgs(U);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,x,M,O,H,D===2);break}case 3:case 4:{let{rpcId:M,method:O,args:H}=i.deserializeRequestMixedArgs(U);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,x,M,O,H,D===4);break}case 5:{this._logger?.logIncoming(j,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(j,x);break}case 7:{this._receiveReply(j,x,void 0);break}case 9:{let M=i.deserializeReplyOKJSON(U);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(j,x,M);break}case 10:{const M=i.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(j,x,M);break}case 8:{const M=i.deserializeReplyOKVSBuffer(U);this._receiveReply(j,x,M);break}case 11:{let M=i.deserializeReplyErrError(U);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(j,x,M);break}case 12:{this._receiveReplyErr(j,x,void 0);break}default:console.error("received unexpected message"),console.error(F)}}_receiveRequest(F,j,U,D,x,M){this._logger?.logIncoming(F,j,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(U)}.${D}(`,x);const O=String(j);let H,W;if(M){const G=new b.CancellationTokenSource;x.push(G.token),H=this._invokeHandler(U,D,x),W=()=>G.cancel()}else H=this._invokeHandler(U,D,x),W=t;this._cancelInvokedHandlers[O]=W;const z=i.serializeAcknowledged(j);this._logger?.logOutgoing(z.byteLength,j,1,"ack"),this._protocol.send(z),H.then(G=>{delete this._cancelInvokedHandlers[O];const te=i.serializeReplyOK(j,G,this._uriReplacer);this._logger?.logOutgoing(te.byteLength,j,1,"reply:",G),this._protocol.send(te)},G=>{delete this._cancelInvokedHandlers[O];const te=i.serializeReplyErr(j,G);this._logger?.logOutgoing(te.byteLength,j,1,"replyErr:",G),this._protocol.send(te)})}_receiveCancel(F,j){this._logger?.logIncoming(F,j,1,"receiveCancel");const U=String(j);this._cancelInvokedHandlers[U]?.()}_receiveReply(F,j,U){this._logger?.logIncoming(F,j,0,"receiveReply:",U);const D=String(j);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],x.resolveOk(U)}_receiveReplyErr(F,j,U){this._logger?.logIncoming(F,j,0,"receiveReplyErr:",U);const D=String(j);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let M;U&&(U.$isError?(M=new Error,M.name=U.name,M.message=U.message,M.stack=U.stack):M=U),x.resolveErr(M)}_invokeHandler(F,j,U){try{return Promise.resolve(this._doInvokeHandler(F,j,U))}catch(D){return Promise.reject(D)}}_doInvokeHandler(F,j,U){const D=this._locals[F];if(!D)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(F));const x=D[j];if(typeof x!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.getStringIdentifierForProxy)(F));return x.apply(D,U)}_remoteCall(F,j,U){if(this._isDisposed)return new P.CanceledLazyPromise;let D=null;if(U.length>0&&b.CancellationToken.isCancellationToken(U[U.length-1])&&(D=U.pop()),D&&D.isCancellationRequested)return Promise.reject(N.canceled());const x=i.serializeRequestArguments(U,this._uriReplacer),M=++this._lastMessageId,O=String(M),H=new P.LazyPromise;D&&D.onCancellationRequested(()=>{const z=i.serializeCancel(M);this._logger?.logOutgoing(z.byteLength,M,0,"cancel"),this._protocol.send(i.serializeCancel(M))}),this._pendingRPCReplies[O]=H,this._onWillSendRequest(M);const W=i.serializeRequest(M,F,j,x,!!D);return this._logger?.logOutgoing(W.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(F)}.${j}(`,U),this._protocol.send(W),H}}e.RPCProtocol=n,E=h,n.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(F,j,U){const D=new o(I.VSBuffer.alloc(U+1+4),0);return D.writeUInt8(F),D.writeUInt32(j),D}static read(F,j){return new o(F,j)}get buffer(){return this._buff}constructor(F,j){this._buff=F,this._offset=j}static sizeUInt8(){return 1}writeUInt8(F){this._buff.writeUInt8(F,this._offset),this._offset+=1}readUInt8(){const F=this._buff.readUInt8(this._offset);return this._offset+=1,F}writeUInt32(F){this._buff.writeUInt32BE(F,this._offset),this._offset+=4}readUInt32(){const F=this._buff.readUInt32BE(this._offset);return this._offset+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this._buff.writeUInt8(F.byteLength,this._offset),this._offset+=1,this._buff.set(F,this._offset),this._offset+=F.byteLength}readShortString(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,U}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readLongString(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,U}writeBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readVSBuffer(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+F);return this._offset+=F,j}static sizeMixedArray(F){let j=0;j+=1;for(let U=0,D=F.length;U<D;U++){const x=F[U];switch(j+=1,x.type){case 1:j+=this.sizeLongString(x.value);break;case 2:j+=this.sizeVSBuffer(x.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(x.value);for(let M=0;M<x.buffers.length;++M)j+=this.sizeVSBuffer(x.buffers[M]);break;case 4:break}}return j}writeMixedArray(F){this._buff.writeUInt8(F.length,this._offset),this._offset+=1;for(let j=0,U=F.length;j<U;j++){const D=F[j];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let x=0;x<D.buffers.length;++x)this.writeBuffer(D.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(F);for(let U=0;U<F;U++)switch(this.readUInt8()){case 1:j[U]=this.readLongString();break;case 2:j[U]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),M=this.readLongString(),O=[];for(let H=0;H<x;++H)O.push(this.readVSBuffer());j[U]=new R.SerializableObjectWithBuffers(f(M,O,null));break}case 4:j[U]=void 0;break}return j}}o.sizeUInt32=4;var u;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(u||(u={}));class i{static _useMixedArgSerialization(F){for(let j=0,U=F.length;j<U;j++)if(F[j]instanceof I.VSBuffer||F[j]instanceof R.SerializableObjectWithBuffers||typeof F[j]>"u")return!0;return!1}static serializeRequestArguments(F,j){if(this._useMixedArgSerialization(F)){const U=[];for(let D=0,x=F.length;D<x;D++){const M=F[D];if(M instanceof I.VSBuffer)U[D]={type:2,value:M};else if(typeof M>"u")U[D]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:H}=l(M.value,j);U[D]={type:3,value:I.VSBuffer.fromString(O),buffers:H}}else U[D]={type:1,value:I.VSBuffer.fromString(v(M,j))}}return{type:1,args:U}}return{type:0,args:v(F,j)}}static serializeRequest(F,j,U,D,x){switch(D.type){case 0:return this._requestJSONArgs(F,j,U,D.args,x);case 1:return this._requestMixedArgs(F,j,U,D.args,x)}}static _requestJSONArgs(F,j,U,D,x){const M=I.VSBuffer.fromString(U),O=I.VSBuffer.fromString(D);let H=0;H+=o.sizeUInt8(),H+=o.sizeShortString(M),H+=o.sizeLongString(O);const W=o.alloc(x?2:1,F,H);return W.writeUInt8(j),W.writeShortString(M),W.writeLongString(O),W.buffer}static deserializeRequestJSONArgs(F){const j=F.readUInt8(),U=F.readShortString(),D=F.readLongString();return{rpcId:j,method:U,args:JSON.parse(D)}}static _requestMixedArgs(F,j,U,D,x){const M=I.VSBuffer.fromString(U);let O=0;O+=o.sizeUInt8(),O+=o.sizeShortString(M),O+=o.sizeMixedArray(D);const H=o.alloc(x?4:3,F,O);return H.writeUInt8(j),H.writeShortString(M),H.writeMixedArray(D),H.buffer}static deserializeRequestMixedArgs(F){const j=F.readUInt8(),U=F.readShortString(),D=F.readMixedArray(),x=new Array(D.length);for(let M=0,O=D.length;M<O;M++){const H=D[M];typeof H=="string"?x[M]=JSON.parse(H):x[M]=H}return{rpcId:j,method:U,args:x}}static serializeAcknowledged(F){return o.alloc(5,F,0).buffer}static serializeCancel(F){return o.alloc(6,F,0).buffer}static serializeReplyOK(F,j,U){if(typeof j>"u")return this._serializeReplyOKEmpty(F);if(j instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(F,j);if(j instanceof R.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:x}=l(j.value,U,!0);return this._serializeReplyOKJSONWithBuffers(F,D,x)}else return this._serializeReplyOKJSON(F,m(j,U))}static _serializeReplyOKEmpty(F){return o.alloc(7,F,0).buffer}static _serializeReplyOKVSBuffer(F,j){let U=0;U+=o.sizeVSBuffer(j);const D=o.alloc(8,F,U);return D.writeVSBuffer(j),D.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static _serializeReplyOKJSON(F,j){const U=I.VSBuffer.fromString(j);let D=0;D+=o.sizeLongString(U);const x=o.alloc(9,F,D);return x.writeLongString(U),x.buffer}static _serializeReplyOKJSONWithBuffers(F,j,U){const D=I.VSBuffer.fromString(j);let x=0;x+=o.sizeUInt32,x+=o.sizeLongString(D);for(const O of U)x+=o.sizeVSBuffer(O);const M=o.alloc(10,F,x);M.writeUInt32(U.length),M.writeLongString(D);for(const O of U)M.writeBuffer(O);return M.buffer}static deserializeReplyOKJSON(F){const j=F.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(F,j){const U=F.readUInt32(),D=F.readLongString(),x=[];for(let M=0;M<U;++M)x.push(F.readVSBuffer());return new R.SerializableObjectWithBuffers(f(D,x,j))}static serializeReplyErr(F,j){const U=j?m(N.transformErrorForSerialization(j),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(F);const D=I.VSBuffer.fromString(U);let x=0;x+=o.sizeLongString(D);const M=o.alloc(11,F,x);return M.writeLongString(D),M.buffer}static deserializeReplyErrError(F){const j=F.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(F){return o.alloc(12,F,0).buffer}}var c;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var g;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[228],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(N){const _=A=>{self.removeEventListener("message",_);const y=A.data;Object.defineProperties(self,{postMessage:{value(P,R){y.postMessage(P,R)}},onmessage:{get(){return y.onmessage},set(P){y.onmessage=P}}}),y.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",_)}.toString();class I extends EventTarget{constructor(N,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${s})('${_}'))`,P=new Blob([y],{type:"application/javascript"}),R=URL.createObjectURL(P),E=new MessageChannel,m=R,C={type:"_newWorker",id:m,port:E.port2,url:R,options:A};N(C,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(p){E.port1.onmessage=p}},onmessageerror:{get(){return E.port1.onmessageerror},set(p){E.port1.onmessageerror=p}}}),E.port1.addEventListener("messageerror",p=>{const a=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(a)}),E.port1.addEventListener("message",p=>{const a=new MessageEvent("message",{data:p.data});this.dispatchEvent(a)}),E.port1.start()}}e.NestedWorker=I}),define(Ie[229],Ce([1,0,4,30,40,3,35,12,15]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new s.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new s.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(p){this.channels.has(p.id)||(this.channels.set(p.id,p),this._onDidRegisterChannel.fire(p.id))}getChannels(){const p=[];return this.channels.forEach(a=>p.push(a)),p}getChannel(p){return this.channels.get(p)}removeChannel(p){this.channels.delete(p),this._onDidRemoveChannel.fire(p)}}I.Registry.add(e.Extensions.OutputChannels,new R);function E(C,p,a,l,f){return(0,y.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(a,l);const w=I.Registry.as(e.Extensions.OutputChannels);try{await m(a,1,l,f,v),w.registerChannel({id:C,label:p,file:a,log:!0})}catch(d){(0,A.isCancellationError)(d)||f.error("Error while registering log channel",a.toString(),(0,A.getErrorMessage)(d))}})}e.registerLogChannel=E;async function m(C,p,a,l,f){if(!await a.exists(C)){if(f.isCancellationRequested)throw new A.CancellationError;if(p>10)throw new Error("Timed out while waiting for file to be created");l.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",C.toString()),await(0,y.timeout)(1e3,f),await m(C,p+1,a,l,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new b.RawContextKey("activeOutputChannel","")}),define(Ie[99],Ce([1,0,5,3,14,26,11,229,54,27,36,112,23,9,35,4,7,28]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class v extends _.AbstractMessageLogger{get disposed(){return this._disposed}constructor(t,h,r,n,o){super(),this.id=t,this.name=h,this.logger=r,this.proxy=n,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this._register(r.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.logger.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const t=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,t)}replace(t){const h=this.offset;this.info(t),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,h),this.visible&&this.logger.flush()}show(t,h){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof t=="boolean"?t:h))}hide(){this.proxy.$close(this.id)}log(t,h){this.offset+=m.VSBuffer.fromString(h).byteLength,(0,_.log)(this.logger,t,h)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class w extends v{appendLine(t){this.append(t)}}let d=class{constructor(t,h,r,n,o,u){this.initData=h,this.extHostFileSystem=r,this.extHostFileSystemInfo=n,this.loggerService=o,this.logService=u,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=t.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(h.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.visibleChannelId=t;for(const[h,r]of this.channels)r.visible=h===this.visibleChannelId}createOutputChannel(t,h,r){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const n=typeof h=="object"&&h.log;n&&(0,f.checkProposedApiEnabled)(r,"extensionLog");const o=(0,C.isString)(h)?h:void 0;if((0,C.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=this.getDefaultLogLevel(r),i=n?this.doCreateLogOutputChannel(t,u,r):this.doCreateOutputChannel(t,o,r);return i.then(c=>{this.channels.set(c.id,c),c.visible=c.id===this.visibleChannelId}),n?this.createExtHostLogOutputChannel(t,u,i):this.createExtHostOutputChannel(t,i)}async doCreateOutputChannel(t,h,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const n=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(n,`${this.namePool++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),i=await this.proxy.$register(t,o,!1,h,r.identifier.value);return new v(i,t,u,this.proxy,r)}async doCreateLogOutputChannel(t,h,r){const n=await this.createExtensionLogDirectory(r),o=this.extHostFileSystemInfo.extUri.joinPath(n,`${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(o,{name:t},h),i=await this.proxy.$register(t,o,!0,void 0,r.identifier.value);return new w(i,t,u,this.proxy,r)}getDefaultLogLevel(t){let h;const r=this.initData.environment.extensionLogLevel?.find(([n])=>N.ExtensionIdentifier.equals(t.identifier,n))?.[1];return r&&(h=(0,_.parseLogLevel)(r)),h??this.logService.getLevel()}createExtensionLogDirectory(t){let h=this.extensionLogDirectoryPromise.get(t.identifier.value);if(!h){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,t.identifier.value);this.extensionLogDirectoryPromise.set(t.identifier.value,h=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(n){if((0,p.toFileSystemProviderErrorCode)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return r})())}return h}createExtHostOutputChannel(t,h){let r=!1;const n=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return t},append(o){n(),h.then(u=>u.append(o))},appendLine(o){n(),h.then(u=>u.appendLine(o))},clear(){n(),h.then(o=>o.clear())},replace(o){n(),h.then(u=>u.replace(o))},show(o,u){n(),h.then(i=>i.show(o,u))},hide(){n(),h.then(o=>o.hide())},dispose(){r=!0,h.then(o=>o.dispose())}}}createExtHostLogOutputChannel(t,h,r){const n=new l.DisposableStore,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},u=n.add(new a.Emitter);return r.then(i=>{n.add(i),n.add(i.onDidChangeLogLevel(c=>{h=c,u.fire(c)}))}),{...this.createExtHostOutputChannel(t,r),get logLevel(){return h},onDidChangeLogLevel:u.event,trace(i,...c){o(),r.then(g=>g.trace(i,...c))},debug(i,...c){o(),r.then(g=>g.debug(i,...c))},info(i,...c){o(),r.then(g=>g.info(i,...c))},warn(i,...c){o(),r.then(g=>g.warn(i,...c))},error(i,...c){o(),r.then(g=>g.error(i,...c))},dispose(){n.dispose()}}}};d=xe([$e(0,b.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,_.ILoggerService),$e(5,_.ILogService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(Ie[230],Ce([1,0,3]),function(ne,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(Ie[231],Ce([1,0,39,13,19,20,22,2,3,161,48,176,230]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class en{constructor(a,l,f,v){this.localUserHome=a,this.remoteAgentService=l,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome??a})()}hasValidBasename(a,l,f){return typeof l=="string"||typeof l>"u"?this.resolveOS.then(v=>this.doHasValidBasename(a,v,l)):this.doHasValidBasename(a,l,f)}doHasValidBasename(a,l,f){return a.scheme===I.Schemas.file||a.scheme===I.Schemas.vscodeRemote?(0,s.isValidBasename)(f??(0,_.basename)(a),l===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,l){if(a.remoteAuthority)return I.Schemas.vscodeRemote;const f=(0,P.getVirtualWorkspaceScheme)(l.getWorkspace());if(f)return f;const v=l.getWorkspace().folders[0];if(v)return v.uri.scheme;const w=l.getWorkspace().configuration;return w?w.scheme:I.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?b.win32:b.posix)}async fileURI(a){let l="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const v=a.indexOf("/",2);v===-1?(l=a.substring(2),a="/"):(l=a.substring(2,v),a=a.substring(v)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:l,path:a,query:"",fragment:""})}};C=xe([$e(1,m.IRemoteAgentService),$e(2,E.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(Ie[100],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new s(0,0)}with(_){return new s(0,0)}}e.Position=s;class I{constructor(_,A,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(_,A),this.end=new s(y,P)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new I(0,0,0,0)}with(_){return new I(0,0,0,0)}}e.Range=I;var b;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[43],Ce([1,0,18,34,25,39,10,3,19,12,100,15]),function(ne,e,s,I,b,N,_,A,y,P,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",C=" characters skipped \u27EB",p=(m.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var a;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function f(re){return!!re.preview}e.resultIsMatch=f;function v(re){return!!re.resource}e.isFileMatch=v;function w(re){return!!re.message}e.isProgressMessage=w;var d;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(be){this.resource=be,this.results=[]}}e.FileMatch=S;class t{constructor(be,le,fe){this.ranges=le;const Q=Array.isArray(le)?le:[le];if(fe&&fe.matchLines===1&&h(Q)){be=(0,_.getNLines)(be,fe.matchLines);let pe="",Se=0,Fe=0;const Ue=Math.floor(fe.charsPerLine/5),Xe=[];for(const ke of Q){const ye=Math.max(ke.startColumn-Ue,0),De=ke.startColumn+fe.charsPerLine;if(ye>Fe+Ue+p){const ae=m+(ye-Fe)+C;pe+=ae+be.slice(ye,De),Se+=ye-(Fe+ae.length)}else pe+=be.slice(Fe,De);Xe.push(new n(0,ke.startColumn-Se,ke.endColumn-Se)),Fe=De}this.preview={text:pe,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const pe=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:be,matches:(0,s.mapArrayOrNot)(le,Se=>new r(Se.startLineNumber-pe,Se.startColumn,Se.endLineNumber-pe,Se.endColumn))}}}}e.TextSearchMatch=t;function h(re){const be=re[0].startLineNumber;for(const le of re)if(le.startLineNumber!==be||le.endLineNumber!==be)return!1;return!0}class r{constructor(be,le,fe,Q){this.startLineNumber=be,this.startColumn=le,this.endLineNumber=fe,this.endColumn=Q}}e.SearchRange=r;class n extends r{constructor(be,le,fe){super(be,le,be,fe)}}e.OneLineRange=n;var o;(function(re){re.List="list",re.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var u;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function i(re,be=!0){const le=re&&re.files&&re.files.exclude,fe=be&&re&&re.search&&re.search.exclude;if(!le&&!fe)return;if(!le||!fe)return le||fe;let Q=Object.create(null);return Q=b.mixin(Q,b.deepClone(le)),Q=b.mixin(Q,b.deepClone(fe),!0),Q}e.getExcludes=i;function c(re,be){return re.excludePattern&&I.match(re.excludePattern,be)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&I.match(re.includePattern,be)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(le=>{const fe=le.folder.fsPath;if(N.isEqualOrParent(be,fe)){const Q=y.relative(fe,be);return!le.includePattern||!!I.match(le.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var g;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(be,le){super(be),this.code=le}}e.SearchError=T;function F(re){const be=re.message;if((0,P.isCancellationError)(re))return new T(be,g.canceled);try{const le=JSON.parse(be);return new T(le.message,le.code)}catch{return new T(be,g.other)}}e.deserializeSearchError=F;function j(re){const be={message:re.message,code:re.code};return new Error(JSON.stringify(be))}e.serializeSearchError=j;function U(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=U;function D(re){return re.type==="success"}e.isSerializedSearchSuccess=D;function x(re){return!!re.path}e.isSerializedFileMatch=x;function M(re,be){const le=re.searchPath?re.searchPath:re.relativePath;return(0,_.fuzzyContains)(le,be)}e.isFilePatternMatch=M;class O{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function H(re,be){const le={...re||{},...be||{}};return Object.keys(le).filter(fe=>{const Q=le[fe];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=H;class W{constructor(be,le){this._parsedIncludeExpression=null,this._excludeExpression={...be.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let fe=be.includePattern;le.includePattern&&(fe?fe={...fe,...le.includePattern}:fe=le.includePattern),fe&&(this._parsedIncludeExpression=I.parse(fe))}matchesExcludesSync(be,le,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe))}includedInQuerySync(be,le,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(be,le,fe))}includedInQuery(be,le,fe){const Q=this._parsedExcludeExpression(be,le,fe),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(be,le,fe):!0;return(0,E.isThenable)(Q)?Q.then(Se=>Se?!1:pe()):pe()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=W;function z(re){for(const be in re)if(typeof re[be]!="boolean")return!0;return!1}function G(re){if(!re)return;let be;return le=>(be||(be=(re()||Promise.resolve([])).then(fe=>fe?he(fe):{})),be.then(fe=>!!fe[le]))}e.hasSiblingPromiseFn=G;function te(re){if(!re)return;let be;return le=>{if(!be){const fe=re();be=fe?he(fe):{}}return!!be[le]}}e.hasSiblingFn=te;function he(re){const be={};for(const le of re)be[le]=!0;return be}}),define(Ie[31],Ce([1,0,18,15,21,4,7,24,13,107,22,10,9,2,136,3,11,150,48,36,27,14,8,6,49,43,5]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S,t,h,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(D,x,M){return new R.ExtUri(O=>T(O,M)).isEqual(D,x)}function i(D,x,M){return u(D.uri,x.uri,M)?0:(0,E.compare)(D.uri.toString(),x.uri.toString())}function c(D,x,M){return D.index!==x.index?D.index<x.index?-1:1:u(D.uri,x.uri,M)?(0,E.compare)(D.name,x.name):(0,E.compare)(D.uri.toString(),x.uri.toString())}function g(D,x,M,O){const H=D.slice(0).sort((z,G)=>M(z,G,O)),W=x.slice(0).sort((z,G)=>M(z,G,O));return(0,s.delta)(H,W,(z,G)=>M(z,G,O))}function T(D,x){const M=x.getCapabilities(D.scheme);return!(M&&M&1024)}class F extends v.Workspace{static toExtHostWorkspace(x,M,O,H){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:z,folders:G,configuration:te,transient:he,isUntitled:re}=x,be=[],le=M;M?G.forEach((Se,Fe)=>{const Ue=C.URI.revive(Se.uri),Xe=F._findFolder(O||M,Ue,H);Xe?(Xe.name=Se.name,Xe.index=Se.index,be.push(Xe)):be.push({uri:Ue,name:Se.name,index:Fe})}):be.push(...G.map(({uri:Se,name:Fe,index:Ue})=>({uri:C.URI.revive(Se),name:Fe,index:Ue}))),be.sort((Se,Fe)=>Se.index<Fe.index?-1:1);const fe=new F(W,z,be,!!he,te?C.URI.revive(te):null,!!re,Se=>T(Se,H)),{added:Q,removed:pe}=g(le?le.workspaceFolders:[],fe.workspaceFolders,i,H);return{workspace:fe,added:Q,removed:pe}}static _findFolder(x,M,O){for(let H=0;H<x.folders.length;H++){const W=x.workspaceFolders[H];if(u(W.uri,M,O))return W}}constructor(x,M,O,H,W,z,G){super(x,O.map(te=>new v.WorkspaceFolder(te)),H,W,G),this._name=M,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),O.forEach(te=>{this._workspaceFolders.push(te),this._structure.set(te.uri,te)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,M){return M&&this._structure.get(x)&&(x=(0,R.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let j=class{constructor(x,M,O,H,W){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=H,this._extHostFileSystemInfo=O,this._uriTransformerService=W,this._requestIdProvider=new P.Counter,this._barrier=new I.Barrier,this._proxy=x.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(o.MainContext.MainThreadMessageService);const z=M.workspace;this._confirmedWorkspace=z?new F(z.id,z.name,[],!!z.transient,z.configuration?C.URI.revive(z.configuration):null,!!z.isUntitled,G=>T(G,O)):void 0}$initializeWorkspace(x,M){this._trusted=M,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?C.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,M,O,...H){const W=[];if(Array.isArray(H)&&H.forEach(re=>{C.URI.isUri(re.uri)&&!W.some(be=>u(be.uri,re.uri,this._extHostFileSystemInfo))&&W.push({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri)})}),this._unconfirmedWorkspace||[M,O].some(re=>typeof re!="number"||re<0)||O===0&&W.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+O>z.length)return!1;const G=z.slice(0);G.splice(M,O,...W.map(re=>({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri),index:void 0})));for(let re=0;re<G.length;re++){const be=G[re];if(G.some((le,fe)=>fe!==re&&u(be.uri,le.uri,this._extHostFileSystemInfo)))return!1}G.forEach((re,be)=>re.index=be);const{added:te,removed:he}=g(z,G,c,this._extHostFileSystemInfo);if(te.length===0&&he.length===0)return!1;if(this._proxy){const re=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(re,M,O,W).then(void 0,be=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(f.Severity.Error,(0,p.localize)(0,null,re,be.toString()),le,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(x,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,M)}async getWorkspaceFolder2(x,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,M)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,M){let O,H="";if(typeof x=="string"?(O=C.URI.file(x),H=x):typeof x<"u"&&(O=x,H=x.fsPath),!O)return H;const W=this.getWorkspaceFolder(O,!0);if(!W)return H;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)(W.uri,O);return M&&W.name&&(z=`${W.name}/${z}`),z}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=F.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:M,added:O,removed:H}=F.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:H}))}findFiles(x,M,O,H,W=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let z;if(M===null?z=!1:M&&(typeof M=="string"?z=M:z=M.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:te}=U(t.GlobPattern.from(x));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(G),(0,m.withUndefinedAsNull)(te),(0,m.withUndefinedAsNull)(z),(0,m.withUndefinedAsNull)(O),W).then(he=>Array.isArray(he)?he.map(re=>C.URI.revive(re)):[])}async findTextInFiles(x,M,O,H,W=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),G=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:te,folder:he}=U(t.GlobPattern.from(M.include)),re=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,be={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:G,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:te,excludePattern:re},le=!1;if(this._activeSearchCallbacks[z]=fe=>{if(le)return;const Q=C.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,n.resultIsMatch)(pe)?O({uri:Q,preview:{text:pe.preview.text,matches:(0,s.mapArrayOrNot)(pe.preview.matches,Se=>new h.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,s.mapArrayOrNot)(pe.ranges,Se=>new h.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):O({uri:Q,text:pe.text,lineNumber:pe.lineNumber})})},W.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(x,(0,m.withUndefinedAsNull)(he),be,z,W);return delete this._activeSearchCallbacks[z],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[z],fe}}$handleTextSearchResult(x,M){this._activeSearchCallbacks[M]?.(x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,M){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,M);const O=this._uriTransformerService.transformOutgoingScheme(x),H=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(H,O),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(H)})}async $getEditSessionIdentifier(x,M){this._logService.info("Getting edit session identifier for workspaceFolder",x);const O=await this.resolveWorkspaceFolder(C.URI.revive(x));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const H=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!H),!H)return;const W=await H.provideEditSessionIdentity(O,M);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};j=xe([$e(0,S.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,w.IExtHostFileSystemInfo),$e(3,l.ILogService),$e(4,r.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function U(D){let x,M;return D&&(typeof D=="string"?x=D:(x=D.pattern,M=C.URI.revive(D.baseUri))),{includePattern:x,folder:M}}}),define(Ie[32],Ce([1,0,25,4,31,5,6,153,88,9,15,3,14,11,2]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(h,r){if(r){const n=r.split(".");let o=h;for(let u=0;o&&u<n.length;u++)o=o[n[u]];return o}}function l(h){return h instanceof p.URI}function f(h){return h&&h.uri instanceof p.URI&&h.languageId&&typeof h.languageId=="string"}function v(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function w(h){return h&&h.uri instanceof p.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function d(h){if(l(h))return{resource:h};if(f(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(v(h))return{overrideIdentifier:h.languageId};if(w(h))return{resource:h.uri};if(h===null)return{resource:null}}let S=class{constructor(r,n,o){this._proxy=r.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,n))}};S=xe([$e(0,m.IExtHostRpcService),$e(1,b.IExtHostWorkspace),$e(2,C.ILogService)],S),e.ExtHostConfiguration=S;class t{constructor(r,n,o,u){this._onDidChangeConfiguration=new I.Emitter,this._proxy=r,this._logService=u,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(r,n,o){const u=d(n)||{},i=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,u,o?.identifier);function c(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(T){return typeof a(i,T)<"u"},get:(T,F)=>{this._validateConfigurationAccess(r?`${r}.${T}`:T,u,o?.identifier);let j=a(i,T);if(typeof j>"u")j=F;else{let U;const D=(x,M)=>{let O;const H=()=>{U=U||(0,s.deepClone)(i),O=O||a(U,M)};return(0,P.isObject)(x)?new Proxy(x,{get:(W,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return H(),()=>O;if(U)return O=O||a(U,M),O[z];const G=W[z];return typeof z=="string"?D(G,`${M}.${z}`):G},set:(W,z,G)=>(H(),O&&(O[z]=G),!0),deleteProperty:(W,z)=>(H(),O&&delete O[z],!0),defineProperty:(W,z,G)=>(H(),O&&Object.defineProperty(O,z,G),!0)}):x};j=D(j,T)}return j},update:(T,F,j,U)=>{T=r?`${r}.${T}`:T;const D=c(j);return F!==void 0?this._proxy.$updateConfigurationOption(D,T,F,u,U):this._proxy.$removeConfigurationOption(D,T,u,U)},inspect:T=>{T=r?`${r}.${T}`:T;const F=(0,s.deepClone)(this._configuration.inspect(T,u,this._extHostWorkspace.workspace));if(F)return{key:T,defaultValue:F.policy?.value??F.default?.value,globalValue:F.user?.value??F.application?.value,workspaceValue:F.workspace?.value,workspaceFolderValue:F.workspaceFolder?.value,defaultLanguageValue:F.default?.override,globalLanguageValue:F.user?.override??F.application?.override,workspaceLanguageValue:F.workspace?.override,workspaceFolderLanguageValue:F.workspaceFolder?.override,languageIds:F.overrideIdentifiers}}};return typeof i=="object"&&(0,s.mixin)(g,i,!1),Object.freeze(g)}_toReadonlyValue(r){const n=o=>(0,P.isObject)(o)?new Proxy(o,{get:(u,i)=>n(u[i]),set:(u,i,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(u,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(u,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(r)}_validateConfigurationAccess(r,n,o){const u=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),i=o?`[${o.value}] `:"";if(u===4){typeof n?.resource>"u"&&this._logService.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){n?.resource&&this._logService.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const o=new A.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,i)=>o.affectsConfiguration(u,d(i))})}_toMap(r){return r.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[101],Ce([1,0,2,15,4,5,6,31,52,32,21,55,14,27,3,13,20,11,70,189,12]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(M){function O(W){if(W!=null)return W}M.from=O;function H(W){if(W!=null)return W}M.to=H})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(M){function O(W){if(W!=null)return W}M.from=O;function H(W){if(W!=null)return W}M.to=H})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(M){function O(W){if(W!=null)return W}M.from=O;function H(W){if(W!=null)return W}M.to=H})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(M){function O(z){if(z){const G=z;return G&&!!G.process}else return!1}M.is=O;function H(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=r.from(z.options)),G}M.from=H;function W(z){if(z!=null)return new _.ProcessExecution(z.process,z.args,z.options)}M.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(M){function O(W){if(W!=null)return W}M.from=O;function H(W){if(W!=null)return W}M.to=H})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(M){function O(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}M.is=O;function H(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=o.from(z.options)),G}M.from=H;function W(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new _.ShellExecution(z.commandLine,z.options):new _.ShellExecution(z.command,z.args?z.args:[],z.options)}M.to=W})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var i;(function(M){function O(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}M.is=O;function H(z){return{customExecution:"customExecution"}}M.from=H;function W(z,G){return G.get(z)}M.to=W})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(M){function O(H,W){let z;return H.scope!==void 0&&typeof H.scope!="number"?z=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?z=W.workspaceFile:z=w.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:z}}M.from=O})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(M){function O(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}M.from=O})(g=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(M){function O(z,G){if(z==null)return[];const te=[];for(const he of z){const re=H(he,G);re&&te.push(re)}return te}M.fromMany=O;function H(z,G){if(z==null)return;let te;z.execution instanceof _.ProcessExecution?te=n.from(z.execution):z.execution instanceof _.ShellExecution?te=u.from(z.execution):z.execution&&z.execution instanceof _.CustomExecution&&(te=i.from(z.execution));const he=t.from(z.definition);let re;return z.scope?typeof z.scope=="number"?re=z.scope:re=z.scope.uri:re=_.TaskScope.Workspace,!he||!re?void 0:{_id:z._id,definition:he,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:re},execution:te,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:h.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}M.from=H;async function W(z,G,te){if(z==null)return;let he;n.is(z.execution)?he=n.to(z.execution):u.is(z.execution)?he=u.to(z.execution):i.is(z.execution)&&(he=i.to(z._id,te));const re=t.to(z.definition);let be;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?be=z.source.scope:be=await G.resolveWorkspaceFolder(s.URI.revive(z.source.scope)):be=_.TaskScope.Workspace),!re||!be)return;const le=new _.Task(re,be,z.name,z.source.label,he,z.problemMatchers);return z.isBackground!==void 0&&(le.isBackground=z.isBackground),z.group!==void 0&&(le.group=_.TaskGroup.from(z.group._id),le.group&&z.group.isDefault&&(le.group=new _.TaskGroup(le.group.id,le.group.label),z.group.isDefault===!0&&(le.group.isDefault=z.group.isDefault))),z.presentationOptions&&(le.presentationOptions=h.to(z.presentationOptions)),z._id&&(le._id=z._id),z.detail&&(le.detail=z.detail),le}M.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var F;(function(M){function O(W){return W}M.from=O;function H(W){if(!!W)return Object.assign(Object.create(null),W)}M.to=H})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(O,H,W){this._id=H,this._task=W,S.set(this,void 0),Ye(this,S,O,"f")}get task(){return this._task}terminate(){Oe(this,S,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}S=new WeakMap;var U;(function(M){function O(H){return{id:H._id,task:void 0}}M.from=O})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(O,H,W,z,G,te,he,re){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=O.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=z,this._configurationService=G,this._terminalService=te,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=he,this._deprecationService=re,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,H,W){if(!W)return new _.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:H,provider:W,extension:O}),this._proxy.$registerTaskProvider(z,H),new _.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(O,H){this._proxy.$registerTaskSystem(O,H)}fetchTasks(O){return this._proxy.$fetchTasks(F.from(O)).then(async H=>{const W=[];for(const z of H){const G=await T.to(z,this._workspaceProvider,this._providedCustomExecutions2);G&&W.push(G)}return W})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(H=>O.push(H)),O}terminateTask(O){if(!(O instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,H,W){const z=this._providedCustomExecutions2.get(O.id);z&&(this._activeCustomExecutions2.set(O.id,z),this._terminalService.attachPtyToTerminal(H,await z.callback(W))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const H=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:H,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:O.exitCode})}$provideTasks(O,H){const W=this._handlers.get(O);if(!W)return Promise.reject(new Error("no handler found"));const z=[],G=(0,I.asPromise)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(te=>this.provideTasksInternal(H,z,W,te));return new Promise(te=>{G.then(he=>{Promise.all(z).then(()=>{te(he)})})})}async $resolveTask(O,H){const W=this._handlers.get(O);if(!W)return Promise.reject(new Error("no handler found"));if(H.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${W.type}].`);const z=await T.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await W.provider.resolveTask(z,R.CancellationToken.None);if(!G)return;this.checkDeprecation(G,W);const te=T.from(G,W.extension);if(!te)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(te.execution)&&await this.addCustomExecution(te,G,!0),await this.resolveTaskInternal(te)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,H,W){const z=await this._proxy.$createTaskId(O);!W&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,H.execution)),this._providedCustomExecutions2.set(z,H.execution)}async getTaskExecution(O,H){if(typeof O=="string"){const G=this._taskExecutionPromises.get(O);if(!G)throw new d.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const W=this._taskExecutionPromises.get(O.id);if(W)return W;const z=new Promise((G,te)=>{function he(re,be,le){le?G(new j(re,be.id,le)):te("Unexpected: Task does not exist.")}H?he(this,O,H):T.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(re=>he(this,O,re))});return this._taskExecutionPromises.set(O.id,z),z.then(G=>(this._taskExecutions.set(O.id,G),G),G=>Promise.reject(G))}checkDeprecation(O,H){O._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const W=this._notProvidedCustomExecutions.values();let z=W.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=W.next()}};D=xe([$e(0,m.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let x=class extends D{constructor(O,H,W,z,G,te,he,re){super(O,H,W,z,G,te,he,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:l.PlatformToString(0)})}async executeTask(O,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(H,O);if(W===void 0)throw new Error("Task is not valid");if(i.is(W.execution))await this.addCustomExecution(W,H,!1);else throw new d.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),H);return this._proxy.$executeTask(W).catch(G=>{throw new Error(G)}),z}provideTasksInternal(O,H,W,z){const G=[];if(z)for(const te of z){this.checkDeprecation(te,W),(!te.definition||!O[te.definition.type])&&this._logService.warn(`The task [${te.source}, ${te.name}] uses an undefined task type. The task will be ignored in the future.`);const he=T.from(te,W.extension);he&&i.is(he.execution)?(G.push(he),H.push(this.addCustomExecution(he,te,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:W.extension}}async resolveTaskInternal(O){if(i.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,H,W){}};x=xe([$e(0,m.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Ie[232],Ce([1,0,19,21,44,34,22,207,43]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,C,p){this.config=m,this.provider=C,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&N.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&N.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const C=this.config.folderQueries||[];return new Promise((p,a)=>{const l=f=>{this.resultCount++,m(f)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),w=s.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,w)||this.matchFile(l,{base:f,basename:w})}),Promise.all(C.map(f=>this.searchInFolder(f,l))).then(f=>{p({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{a(new Error((0,b.toErrorMessage)(f)))})})}async searchInFolder(m,C){const p=new I.CancellationTokenSource,a=this.getSearchOptionsForFolder(m),l=this.initDirectoryTree(),f=new y.QueryGlobTester(this.config,m),v=!f.hasSiblingExcludeClauses();let w;try{this.activeCancellationTokens.add(p),w=A.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,p.token),S=w.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(h=>{const r=s.posix.relative(m.folder.path,h.path);if(v){const n=s.basename(h.path);this.matchFile(C,{base:m.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(l,m.folder,r,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(l,f,C),{providerTime:S,postProcessTime:t.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(m){const C=(0,y.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),p=(0,y.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:p,includes:C,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},C,p,a){if(p===this.filePattern){const f=s.basename(this.filePattern);this.matchFile(a,{base:C,relativePath:this.filePattern,basename:f})}function l(f){const v=s.basename(f),w=s.dirname(f);let d=m[w];d||(d=m[w]=[],l(w)),d.push({base:C,relativePath:f,basename:v})}l(p)}matchDirectoryTree({rootEntries:m,pathToEntries:C},p,a){const l=this,f=this.filePattern;function v(w){const d=(0,y.hasSiblingFn)(()=>w.map(S=>S.basename));for(let S=0,t=w.length;S<t;S++){const h=w[S],{relativePath:r,basename:n}=h;if(p.matchesExcludesSync(r,n,f!==n?d:void 0))continue;const o=C[r];if(o)v(o);else{if(r===f)continue;l.matchFile(a,h)}if(l.isLimitHit)break}}v(m)}matchFile(m,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(C))}}class R{constructor(){this.sessions=new Map}fileSearch(m,C,p,a){const l=this.getSessionTokenSource(m.cacheKey),f=new P(m,C,l&&l.token);let v=0;const w=d=>{v+=d.length,p(d.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(f,R.BATCH_SIZE,w,a).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:d.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new I.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,C,p,a){a.onCancellationRequested(()=>{m.cancel()});const l=v=>{v&&(f.push(v),C>0&&f.length>=C&&(p(f),f=[]))};let f=[];return m.search(l).then(v=>(f.length&&p(f),v),v=>(f.length&&p(f),Promise.reject(v)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ie[233],Ce([1,0,18,76,34,81,24,13,19,22,10,9,2,249,144,45,11,48,92,231,43]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let S=class{constructor(g,T,F,j,U){this.configurationService=g,this.workspaceContextService=T,this.editorGroupsService=F,this.logService=j,this.pathService=U}text(g,T,F={}){g=this.getContentPattern(g,F);const j=this.configurationService.getValue(),U=T&&T.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(T?.map(f.toWorkspaceFolder),F),type:2,contentPattern:g,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:j.search.usePCRE2||U||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(g,T){const F=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const j={...g,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(g,T)&&(j.isCaseSensitive=!0),this.isMultiline(g)&&(j.isMultiline=!0),j}file(g,T={}){return{...this.commonQuery(g,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(g,T){return g?(g=Array.isArray(g)?g.map(o):o(g),T?this.parseSearchPaths(g):{pattern:h(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],T={}){const F=this.handleIncludeExclude(T.includePattern,T.expandPatterns),j=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),U=g.length>1,D=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,T,j)):g.map(O=>this.getFolderQueryForRoot(O,T,j,U))).filter(O=>!!O),x={_reason:T._reason,folderQueries:D,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:j.pattern,includePattern:F.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const O=s.coalesce(s.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const H=O.filter(z=>(0,d.pathIncludedInQuery)(x,z.fsPath)),W=this.commonQueryFromFileList(H);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...x,...W}}const M=T.extraFileResources&&T.extraFileResources.filter(O=>(0,d.pathIncludedInQuery)(x,O.fsPath));return x.extraFileResources=M&&M.length?M:void 0,x}commonQueryFromFileList(g){const T=[],F=new _.ResourceMap,j={};let U=!1;return g.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(D)){const M=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:y.dirname(D.fsPath)});let O=F.get(M);O||(U=!0,O={folder:M,includePattern:{}},T.push(O),F.set(M,O));const H=y.relative(M.fsPath,D.fsPath);(0,E.assertIsDefined)(O.includePattern)[H.replace(/\\/g,"/")]=!0}else D.fsPath&&(U=!0,j[D.fsPath]=!0)}),{folderQueries:T,includePattern:j,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(g,T){if(T.isSmartCase){if(g.isRegExp){if(R.containsUppercaseCharacter(g.pattern,!0))return!0}else if(R.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,C.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const T=W=>y.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),j=(Array.isArray(g)?g:r(g)).map(W=>{const z=this.pathService.resolvedUserHome;return z?(0,N.untildify)(W,z.scheme===A.Schemas.file?z.fsPath:z.path):W}),U=I.groupBy(j,W=>T(W)?"searchPaths":"exprSegments"),D=(U.exprSegments||[]).map(W=>R.rtrim(W,"/")).map(W=>R.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),x={},M=this.expandSearchPathPatterns(U.searchPaths||[]);M&&M.length&&(x.searchPaths=M);const O=s.flatten(D),H=h(...O);return H&&(x.pattern=H),x}getExcludesForFolder(g,T){return T.disregardExcludeSettings?void 0:(0,d.getExcludes)(g,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const T=s.flatten(g.map(j=>{let{pathPortion:U,globPortion:D}=t(j);D&&(D=u(D));const x=this.expandOneSearchPath(U);return s.flatten(x.map(M=>this.resolveOneSearchPathPattern(M,D)))})),F=new Map;return T.forEach(j=>{const U=j.searchPath.toString(),D=F.get(U);D?j.pattern&&(D.pattern=D.pattern||{},D.pattern[j.pattern]=!0):F.set(U,{searchPath:j.searchPath,pattern:j.pattern?h(j.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(g){if(y.isAbsolute(g)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:g})}]:[{searchPath:m.URI.file(y.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=o(g),g.startsWith("../")||g===".."){const j=y.posix.resolve(T.path,g);return[{searchPath:T.with({path:j})}]}const F=u(g);return[{searchPath:T,pattern:F}]}else{if(g==="./"||g===".\\")return[];{const T=g.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(U=>{const D=T.match(new RegExp(`^${R.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return D?{match:D,folder:U}:null}).filter(E.isDefined);if(j.length)return j.map(U=>{const D=U.match[1];return{searchPath:U.folder.uri,pattern:D&&u(D)}});{const U=g.match(/\.[\/\\](.+)[\/\\]?/),D=U?U[1]:g,x=p.localize(0,null,D);throw new Error(x)}}}}resolveOneSearchPathPattern(g,T){const F=g.pattern&&T?`${g.pattern}/${T}`:g.pattern||T,j=[{searchPath:g.searchPath,pattern:F}];return F&&!F.endsWith("**")&&j.push({searchPath:g.searchPath,pattern:F+"/**"}),j}getFolderQueryForSearchPath(g,T,F){const j=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(g.searchPath),T,F,!1);return j?{...j,includePattern:g.pattern}:null}getFolderQueryForRoot(g,T,F,j){let U;const D=m.URI.isUri(g)?g:g.uri;if(F.searchPaths){const W=F.searchPaths.filter(z=>(0,P.isEqual)(z.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const x=this.configurationService.getValue({resource:D}),O={...this.getExcludesForFolder(x,T)||{},...U||{}},H=m.URI.isUri(g)?(0,P.basename)(g):g.name;return{folder:D,folderName:j?H:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!x.search.followSymlinks}}};S=xe([$e(0,a.IConfigurationService),$e(1,f.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,l.ILogService),$e(4,w.IPathService)],S),e.QueryBuilder=S;function t(c){const g=c.match(/[\*\{\}\(\)\[\]\?]/);if(g){const T=g.index,F=c.substr(0,T).match(/[/|\\][^/\\]*$/);if(F){let j=c.substr(0,F.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:c.substr((F.index||0)+1)}}}return{pathPortion:c}}function h(...c){return c.length?c.reduce((g,T)=>(g[T]=!0,g),Object.create(null)):void 0}function r(c){return b.splitGlobAware(c,",").map(g=>g.trim()).filter(g=>!!g.length)}function n(c){return[`**/${c}/**`,`**/${c}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function o(c){return c.replace(/\\/g,"/")}function u(c){return o(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(c,g){c=s.distinct(c,j=>j.toString());const T=[],F=g.getWorkspace();return c&&c.forEach(j=>{let U;if(g.getWorkbenchState()===2)U=(0,P.relativePath)(F.folders[0].uri,j),U&&U!=="."&&(U="./"+U);else{const D=g.getWorkspaceFolder(j);if(D){const x=D.name;if(F.folders.filter(O=>O.name===x).length===1){const O=(0,P.relativePath)(D.uri,j);O===""?U=`./${D.name}`:U=`./${D.name}/${O}`}else U=j.fsPath}}U&&T.push(U)}),T}e.resolveResourcesForSearchIncludes=i}),define(Ie[234],Ce([1,0,22,2,21,12,3,233,43,48]),function(ne,e,s,I,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function E(a,l){const f=l.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],w=[];for(const n of f)if(/^workspaceContains:/.test(n)){const o=n.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||a.forceUsingSearch?w.push(o):v.push(o)}if(v.length===0&&w.length===0)return Promise.resolve(void 0);let d;const S=new Promise((n,o)=>{d=n}),t=n=>d({activationEvent:n}),h=Promise.all(v.map(n=>m(a,n,t))).then(()=>{}),r=C(a,l.identifier,w,t);return Promise.all([h,r]).then(()=>{d(void 0)}),S}e.checkActivateWorkspaceContainsExtension=E;async function m(a,l,f){for(const v of a.folders)if(await a.exists(s.joinPath(I.URI.revive(v),l))){f(`workspaceContains:${l}`);return}}async function C(a,l,f,v){if(f.length===0)return Promise.resolve(void 0);const w=new b.CancellationTokenSource,d=a.checkExists(a.folders,f,w.token),S=setTimeout(async()=>{w.cancel(),a.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let t=!1;try{t=await d}catch(h){N.isCancellationError(h)||N.onUnexpectedError(h)}w.dispose(),clearTimeout(S),t&&v(`workspaceContains:${f.join(",")}`)}function p(a,l,f,v){const w=a.get(_.IInstantiationService),d=a.get(y.ISearchService),t=w.createInstance(A.QueryBuilder).file(l.map(h=>(0,P.toWorkspaceFolder)(I.URI.revive(h))),{_reason:"checkExists",includePattern:f,exists:!0});return d.fileSearch(t,v).then(h=>!!h.limitHit,h=>N.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=p});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,s,I,b){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?b.call(ne,s):b?b.value=s:e.set(ne,s),s},Oe=this&&this.__classPrivateFieldGet||function(ne,e,s,I){if(s==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?I:s==="a"?I.call(ne):I?I.value:e.get(ne)};define(Ie[33],Ce([1,0,131,19,75,22,15,7,24,2,11,5,32,178,73,31,28,177,12,26,23,162,6,89,3,27,74,14,59,63,55,4,234,72,164,13,71]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S,t,h,r,n,o,u,i,c,g,T,F,j,U,D,x){"use strict";var M,O,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class Fi extends A.Disposable{constructor(le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=Q,this._initData=Ue,this._extHostWorkspace=pe,this._extHostConfiguration=Se,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,l.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(te(this._globalRegistry,ae)),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=le.createChild(new i.ServiceCollection([p.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ue=[],ee=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(k=>!k.main&&!k.browser).map(k=>k.identifier),ee=this._initData.allExtensions.filter(k=>!ae.has(w.ExtensionIdentifier.toKey(k.identifier.value))).filter(k=>(k.main||k.browser)&&k.api==="none").map(k=>k.identifier));const Z=(0,l.extensionIdentifiersArrayToSet)(ee);this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,ue,ee,{onExtensionActivationError:(k,B,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(k,v.transformErrorForSerialization(B),V)},actualActivateExtension:async(k,B)=>{if(Z.has(w.ExtensionIdentifier.toKey(k)))return await this._mainThreadExtensionsProxy.$activateExtension(k,B),new C.HostExtension;const V=this._myRegistry.getExtensionDescription(k);return this._activateExtension(V,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){v.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Q=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),Q]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const fe=await this._mainThreadExtensionsProxy.$getExtension(le);let Q;if(fe?.browserNlsBundleUris){Q={};for(const pe of Object.keys(fe.browserNlsBundleUris))Q[pe]=P.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new w.ExtensionIdentifier(fe.identifier.value),extensionLocation:P.URI.revive(fe.extensionLocation),browserNlsBundleUris:Q}}_activateByEvent(le,fe){return this._activator.activateByEvent(le,fe)}_activateById(le,fe){return this._activator.activateById(le,fe)}activateByIdWithErrors(le,fe){return this._activateById(le,fe).then(()=>{const Q=this._activator.getActivatedExtension(le);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==D.Schemas.file)return le;const fe=await this._hostUtils.realpath(le.fsPath);return P.URI.file(fe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new re(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const fe=y.TernarySearchTree.forUris(Q=>N.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(le.map(async Q=>{if(this._getEntryPoint(Q)){const pe=await this._realPathExtensionUri(Q.extensionLocation);fe.set(pe,Q)}})),fe}_deactivate(le){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return fe;const Q=this._activator.getActivatedExtension(le);if(!Q)return fe;try{typeof Q.module.deactivate=="function"&&(fe=Promise.resolve(Q.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(pe)}try{(0,A.dispose)(Q.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(pe)}return fe}async _activateExtension(le,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,fe).then(Q=>{const pe=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this._logExtensionActivationTimes(le,fe,"success",pe),Q},Q=>{throw this._logExtensionActivationTimes(le,fe,"failure"),Q})}_logExtensionActivationTimes(le,fe,Q,pe){const Se=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...pe||{},outcome:Q})}_doActivateExtension(le,fe){const Q=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const pe=this._getEntryPoint(le);if(!pe)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${le.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Se=new C.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(le,(0,N.joinPath)(le.extensionLocation,pe),Se),this._loadExtensionContext(le)]).then(Fe=>(b.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Fi._callActivate(this._logService,le.identifier,Fe[0],Fe[1],Se))).then(Fe=>(b.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Fe))}_loadExtensionContext(le){const fe=new S.ExtensionGlobalMemento(le,this._storage),Q=new S.ExtensionMemento(le.identifier.value,!1,this._storage),pe=new U.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([fe.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Ue=this;let Xe,ke;const ye=(0,l.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(w.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Q,secrets:pe,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(De){return I.join(le.extensionLocation.fsPath,De)},get storagePath(){return Ue._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return Ue._storagePath.globalValue(le).fsPath},get logPath(){return I.join(Ue._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return P.URI.joinPath(Ue._initData.logsLocation,le.identifier.value)},get storageUri(){return Ue._storagePath.workspaceValue(le)},get globalStorageUri(){return Ue._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new G(Ue,le.identifier,le,Fe,!1)),Xe},get extensionRuntime(){return(0,l.checkProposedApiEnabled)(le,"extensionRuntime"),Ue.extensionRuntime},get environmentVariableCollection(){return Ue._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=T.Event.buffer(T.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(le,fe,Q,pe,Se){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,fe,Q,pe,Se).then(Fe=>new C.ActivatedExtension(!1,null,Se.build(),Q,Fe,pe.subscriptions))}static _callActivateOptional(le,fe,Q,pe,Se){if(typeof Q.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Fe=typeof global=="object"?global:self,Ue=Q.activate.apply(Fe,[pe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Ue).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Q)}_activateOneStartupFinished(le,fe){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:fe}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const fe of le.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(le,fe)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(fe),pe=Promise.all([le,Q]).then(()=>{});return Promise.race([pe,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(le,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,fe){if(this.isActivated(fe.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:le.map(Fe=>Fe.uri),forceUsingSearch:Q,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ue,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ue,Xe)},Se=await(0,F.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!Se)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Se.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:fe}=this._initData.environment;if(!le||!fe)throw new Error(s.localize(0,null));const Q=await this._loadCommonJSModule(null,fe,new C.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(s.localize(1,null,fe.toString()));return new Promise((pe,Se)=>{const Fe=(ke,ye)=>{ke?Se(ke):pe(typeof ye=="number"&&ye>0?1:0)},Ue=(0,N.originalFSPath)(fe),Xe=Q.run(Ue,Fe);Xe&&Xe.then&&Xe.then(()=>{pe(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,fe){return this._resolvers[le]=fe,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const fe=le.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Q=le.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(le,fe){this._logService.info(`$resolveAuthority invoked for authority (${he(le)})`);const{authorityPrefix:Q,resolver:pe}=await this._activateAndGetResolver(le);if(!pe)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),b.mark(`code/extHost/willResolveAuthority/${Q}`);const Se=await pe.resolve(le,{resolveAttempt:fe});b.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const Fe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Ue={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ue,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(b.mark(`code/extHost/didResolveAuthorityError/${Q}`),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,fe){this._logService.info(`$getCanonicalURI invoked for authority (${he(le)})`);const{resolver:Q}=await this._activateAndGetResolver(le);if(!Q)return null;const pe=P.URI.revive(fe);if(typeof Q.getCanonicalURI>"u")return pe;const Se=await(0,_.asPromise)(()=>Q.getCanonicalURI(pe));return Se||pe}static _applyExtensionsDelta(le,fe,Q){const pe=new f.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());pe.deltaExtensions(Q.toAdd,Q.toRemove);const Se=(0,l.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Ue=>Ue.identifier));for(const Ue of Q.myToRemove)Se.delete(w.ExtensionIdentifier.toKey(Ue));for(const Ue of Q.myToAdd)Se.add(w.ExtensionIdentifier.toKey(Ue));const Fe=te(pe,Se);return{globalRegistry:pe,myExtensions:Fe}}$startExtensionHost(le){le.toAdd.forEach(pe=>pe.extensionLocation=P.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),this._startExtensionHost()}$activateByEvent(le,fe){return fe===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(le,!1))}async $activate(le,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,fe),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),pe=await this._createExtensionPathIndex(Q);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const fe=d.VSBuffer.alloc(le),Q=Math.random()%256;for(let pe=0;pe<le;pe++)fe.writeUInt8(Q,pe);return fe}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};W=xe([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,u.IExtHostRpcService),$e(3,a.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,c.IExtHostTunnelService),$e(9,g.IExtHostTerminalService),$e(10,x.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function z(be,le){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class G{constructor(le,fe,Q,pe,Se){M.set(this,void 0),O.set(this,void 0),H.set(this,void 0),Ye(this,M,le,"f"),Ye(this,O,fe,"f"),Ye(this,H,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=I.normalize((0,N.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=pe,this.isFromDifferentExtensionHost=Se}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,M,"f").getExtensionExports(Oe(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,M,"f").activateByIdWithErrors(Oe(this,H,"f"),{startup:!1,extensionId:Oe(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,M=new WeakMap,O=new WeakMap,H=new WeakMap;function te(be,le){return be.getAllExtensionDescriptions().filter(fe=>le.has(w.ExtensionIdentifier.toKey(fe.identifier)))}function he(be){const le=be.indexOf("+");return le===-1?be:be.substring(0,le)}class re{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=re}),define(Ie[235],Ce([1,0,75,2,5,32,28,26,14,27,3,33,47,11,10]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(S,t,h,r,n,o,u){this._apiFactory=S,this._extensionRegistry=t,this._instaService=h,this._extHostConfiguration=r,this._extHostExtensionService=n,this._initData=o,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const S=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,t,this._extensionRegistry,S,this._logService)),this.register(this._instaService.createInstance(v,t)),this.register(this._instaService.createInstance(l)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,t,this._initData.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(const t of S.nodeModuleName)this._factories.set(t,S);else this._factories.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this._alternatives.push(t=>S.alternativeModuleName(t))}};a=xe([$e(2,R.IInstantiationService),$e(3,N.IExtHostConfiguration),$e(4,E.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,C.ILogService)],a),e.RequireInterceptor=a;let l=class Qi{constructor(S){if(S.environment.appRoot&&Qi.aliased.size){const t=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(S.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(S){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(S));if(!t)return;const[,h,r,n]=t,o=Qi.aliased.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),h+o+n}forceForwardSlashes(S){return S.replace(/\\/g,"/")}};l.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),l=xe([$e(0,P.IExtHostInitDataService)],l);class f{constructor(S,t,h,r,n){this._apiFactory=S,this._extensionPaths=t,this._extensionRegistry=h,this._configProvider=r,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(S,t){const h=this._extensionPaths.findSubstr(t);if(h){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(h.identifier));return r||(r=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((n,o)=>r+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(S,t,h){this._extensionPaths=S,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(b.MainContext.MainThreadTelemetry);const{environment:r}=h,n=t.getProxy(b.MainContext.MainThreadKeytar);if(r.appRoot){let o=r.appRoot.fsPath;m.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,u)=>n.$getPassword(o,u),setPassword:(o,u,i)=>n.$setPassword(o,u,i),deletePassword:(o,u)=>n.$deletePassword(o,u),findPassword:o=>n.$findPassword(o),findCredentials(o){return n.$findCredentials(o)}}}load(S,t){const h=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(S){const t=S.length;if(t<=7||!this.alternativeNames)return;const h=t-7;if((S.charAt(h)==="/"||S.charAt(h)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.alternativeNames.has(S)))return"keytar"}};v=xe([$e(1,y.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],v);let w=class{constructor(S,t,h){this._extensionPaths=S,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(b.MainContext.MainThreadTelemetry);const r=h.getProxy(b.MainContext.MainThreadWindow);this._impl=(n,o)=>{const u=I.URI.parse(n);return o?this.callOriginal(n,o):u.scheme==="http"||u.scheme==="https"?r.$openUri(u,n,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?r.$openUri(u,n,{}):this.callOriginal(n,o)}}load(S,t,h){const r=this._extensionPaths.findSubstr(t);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=h(S),this._impl}callOriginal(S,t){return this.sendNoForwardTelemetry(),this._original(S,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=xe([$e(2,y.IExtHostRpcService)],w)}),define(Ie[102],Ce([1,0,201,7,19,47,3,52,53,33,6,31,174,32]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class p extends m.AbstractVariableResolverService{constructor(f,v,w,d,S,t,h){function r(){if(w){const n=w.activeEditor();if(n)return n.document.uri;const o=d.tabGroups.all.find(u=>u.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof R.TextDiffTabInput||o.input instanceof R.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof R.TextTabInput||o.input instanceof R.NotebookEditorTabInput||o.input instanceof R.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:n=>{const o=t.folders.filter(u=>u.name===n);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,o)=>S.getConfiguration(void 0,n).get(o),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=r();if(n)return b.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const n=r();if(n){const o=v.getWorkspaceFolder(n);if(o)return b.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(w){const n=w.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(w){const n=w.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>f.getExtension(n)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(N.env))}}let a=class extends I.Disposable{constructor(f,v,w,d,S){super(),this.extensionService=f,this.workspaceService=v,this.editorService=w,this.configurationService=d,this.editorTabs=S,this._resolver=new s.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};a=xe([$e(0,P.IExtHostExtensionService),$e(1,E.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,C.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ie[103],Ce([1,0,15,4,9,2,3,5,53,33,14,6,31,167,169,32,102]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,n,o,u,i,c){this._workspaceService=n,this._extensionService=o,this._configurationService=u,this._editorTabs=i,this._variableResolver=c,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=r.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new w(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(g=>{g.onDidChange(T=>{this.registerAllDebugTypes(g)}),this.registerAllDebugTypes(g)})}asDebugSourceUri(r,n){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let u=`debug:${encodeURIComponent(o.path||"")}`,i="?";return n&&(u+=`${i}session=${encodeURIComponent(n.id)}`,i="&"),u+=`${i}ref=${o.sourceReference}`,N.URI.parse(u)}else{if(o.path)return N.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const n=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0)for(const i of u)(0,p.isDebuggerMainContribution)(i)&&n.push(i.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(n=>r.push(n)),r}addBreakpoints(r){this.startBreakpoints();const n=r.filter(i=>{const c=i.id;return this._breakpoints.has(c)?!1:(this._breakpoints.set(c,i),!0)});this.fireBreakpointChanges(n,[],[]);const o=[],u=new Map;for(const i of n)if(i instanceof E.SourceBreakpoint){let c=u.get(i.location.uri.toString());c||(c={type:"sourceMulti",uri:i.location.uri,lines:[]},u.set(i.location.uri.toString(),c),o.push(c)),c.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof E.FunctionBreakpoint&&o.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(r){this.startBreakpoints();const n=r.filter(c=>this._breakpoints.delete(c.id));this.fireBreakpointChanges([],n,[]);const o=n.filter(c=>c instanceof E.SourceBreakpoint).map(c=>c.id),u=n.filter(c=>c instanceof E.FunctionBreakpoint).map(c=>c.id),i=n.filter(c=>c instanceof E.DataBreakpoint).map(c=>c.id);return this._debugServiceProxy.$unregisterBreakpoints(o,u,i)}startDebugging(r,n,o){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,n,o){if(!n)return new E.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:u,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,u),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(i=>i.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(r,n,o){if(!o)return new E.Disposable(()=>{});if(!this.definesDebugType(r,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:u,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,u),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(i=>i.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(r,n){if(!n)return new E.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:o,factory:n}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==n)})}async $runInTerminal(r,n){return Promise.resolve(void 0)}async $substituteVariables(r,n){let o;const u=await this.getFolder(r);return u&&(o={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,n)}createDebugAdapter(r,n){if(r.type==="implementation")return new S(r.implementation)}createSignService(){}async $startDASession(r,n){const o=this,u=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const c=this.convertToDto(i),g=this.createDebugAdapter(c,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const T=g;return this._debugAdapters.set(r,T),this.getDebugAdapterTrackers(u).then(F=>(F&&this._debugAdaptersTrackers.set(r,F),T.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const U=j,D={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(U.arguments.value);D.body={signature:x},T.sendResponse(D)}else throw new Error("no signer")}catch(x){D.success=!1,D.message=x.message,T.sendResponse(D)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(j),j=(0,p.convertToVSCPaths)(j,!0),o._debugServiceProxy.$acceptDAMessage(r,j)}),T.onError(j=>{F&&F.onError&&F.onError(j),this._debugServiceProxy.$acceptDAError(r,j.name,j.message,j.stack)}),T.onExit(j=>{F&&F.onExit&&F.onExit((0,b.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,b.withNullAsUndefined)(j),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),T.startSession()))})}$sendDAMessage(r,n){n=(0,p.convertToDAPaths)(n,!1);const o=this._debugAdaptersTrackers.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this._debugAdapters.get(r)?.sendMessage(n)}$stopDASession(r){const n=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),n&&n.onWillStopSession&&n.onWillStopSession();const o=this._debugAdapters.get(r);return this._debugAdapters.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const n=[],o=[],u=[];if(r.added)for(const i of r.added){const c=i.id;if(c&&!this._breakpoints.has(c)){let g;if(i.type==="function")g=new E.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")g=new E.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const T=N.URI.revive(i.uri);g=new E.SourceBreakpoint(new E.Location(T,new E.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}g._id=c,this._breakpoints.set(c,g),n.push(g)}}if(r.removed)for(const i of r.removed){const c=this._breakpoints.get(i);c&&(this._breakpoints.delete(i),o.push(c))}if(r.changed){for(const i of r.changed)if(i.id){const c=this._breakpoints.get(i.id);if(c){if(c instanceof E.FunctionBreakpoint&&i.type==="function"){const g=c;g.enabled=i.enabled,g.condition=i.condition,g.hitCondition=i.hitCondition,g.logMessage=i.logMessage,g.functionName=i.functionName}else if(c instanceof E.SourceBreakpoint&&i.type==="source"){const g=c;g.enabled=i.enabled,g.condition=i.condition,g.hitCondition=i.hitCondition,g.logMessage=i.logMessage,g.location=new E.Location(N.URI.revive(i.uri),new E.Position(i.line,i.character))}u.push(c)}}}this.fireBreakpointChanges(n,o,u)}$provideDebugConfigurations(r,n,o){return(0,s.asPromise)(async()=>{const u=this.getConfigProviderByHandle(r);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.getFolder(n);return u.provideDebugConfigurations(i,o)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(r,n,o,u){return(0,s.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.getFolder(n);return i.resolveDebugConfiguration(c,o,u)})}$resolveDebugConfigurationWithSubstitutedVariables(r,n,o,u){return(0,s.asPromise)(async()=>{const i=this.getConfigProviderByHandle(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.getFolder(n);return i.resolveDebugConfigurationWithSubstitutedVariables(c,o,u)})}async $provideDebugAdapter(r,n){const o=this.getAdapterDescriptorFactoryByHandle(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(n);return this.getAdapterDescriptor(o,u).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(i)})}async $acceptDebugSessionStarted(r){const n=await this.getSession(r);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(r){const n=await this.getSession(r);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,n){(await this.getSession(r))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(r,n){const u={session:await this.getSession(r),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(r){if(r instanceof E.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof E.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const n=this._adapterFactories.filter(o=>o.type===r);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(r){const n=this._adapterFactories.filter(o=>o.handle===r);if(n.length>0)return n[0].factory}getConfigProviderByHandle(r){const n=this._configProviders.filter(o=>o.handle===r);if(n.length>0)return n[0].provider}definesDebugType(r,n){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const u of o)if(u.label&&u.type&&u.type===n)return!0}}return!1}getDebugAdapterTrackers(r){const o=r.configuration.type,u=this._trackerFactories.filter(i=>i.type===o||i.type==="*").map(i=>(0,s.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(c=>c,c=>null));return Promise.race([Promise.all(u).then(i=>{const c=i.filter(g=>!!g);if(c.length>0)return new d(c)}),new Promise((i,c)=>{const g=setTimeout(()=>{clearTimeout(g),c(new Error("timeout"))},1e3)})]).catch(i=>{})}async getAdapterDescriptor(r,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new E.DebugAdapterServer(o));if(r){const i=await this._extensionService.getExtensionRegistry();return(0,s.asPromise)(()=>r.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,i))).then(c=>{if(c)return c})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,u))}daExecutableFromPackage(r,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,n,o){(r.length>0||n.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:n,changed:o}))}async getSession(r){if(r)if(typeof r=="string"){const n=this._debugSessions.get(r);if(n)return n}else{let n=this._debugSessions.get(r.id);if(!n){const o=await this.getFolder(r.folderUri),u=r.parent?this._debugSessions.get(r.parent):void 0;n=new v(this._debugServiceProxy,r.id,r.type,r.name,o,r.configuration,u),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(r){if(r){const n=N.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};f=xe([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,l.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(r,n,o,u,i,c,g){this._debugServiceProxy=r,this._id=n,this._type=o,this._name=u,this._workspaceFolder=i,this._configuration=c,this._parentSession=g}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,n)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=v;class w{constructor(r){this.value=Object.freeze({append(n){r.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=w;class d{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(n=>n.onError?n.onError(r):void 0)}onExit(r,n){this.trackers.forEach(o=>o.onExit?o.onExit(r,n):void 0)}}class S extends C.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends f{constructor(r,n,o,u,i,c){super(r,n,o,u,i,c)}};t=xe([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,l.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ie[236],Ce([1,0,12,75,2,5,227,11,58,59,27,148,14,49,33,68]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class l{static async installEarlyHandler(w){const d=w.get(A.ILogService),t=w.get(m.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);s.setUnexpectedErrorHandler(h=>{d.error(h);const r=s.transformErrorForSerialization(h);t.$onUnexpectedError(r)})}static async installFullHandler(w){const d=w.get(A.ILogService),S=w.get(m.IExtHostRpcService),t=w.get(p.IExtHostExtensionService),h=w.get(a.IExtHostTelemetry),r=S.getProxy(N.MainContext.MainThreadExtensionService),n=S.getProxy(N.MainContext.MainThreadErrors),o=await t.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(i,c)=>{let g="",T,F;for(const j of c)g+=`
	at ${j.toString()}`,F=j.getFileName(),!T&&F&&(T=o.findSubstr(b.URI.file(F)));return u.set(i,T?.identifier),`${i.name||"Error"}: ${i.message||""}${g}`},s.setUnexpectedErrorHandler(i=>{d.error(i);const c=s.transformErrorForSerialization(i),g=u.get(i);if(!g){n.$onUnexpectedError(c);return}r.$onExtensionRuntimeError(g,c);const T=h.onExtensionError(g,i);d.trace("forwarded error to extension?",T,g)})}}Error.stackTraceLimit=100;class f{constructor(w,d,S,t,h){this._hostUtils=S,this._rpcProtocol=new _.RPCProtocol(w,null,t),d=f._transform(d,this._rpcProtocol);const r=new P.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...d,messagePorts:h}),r.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),r.set(C.IURITransformerService,new C.URITransformerService(t)),r.set(p.IHostUtils,S);const n=new E.InstantiationService(r,!0);n.invokeFunction(l.installEarlyHandler),this._logService=n.invokeFunction(o=>o.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",d),this._extensionService=n.invokeFunction(o=>o.get(p.IExtHostExtensionService)),this._extensionService.initialize(),n.invokeFunction(l.installFullHandler)}async asBrowserUri(w){const d=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return b.URI.revive(await d.$asBrowserUri(w))}terminate(w){this._extensionService.terminate(w)}static _transform(w,d){w.allExtensions.forEach(t=>{t.extensionLocation=b.URI.revive(d.transformIncomingURIs(t.extensionLocation));const h={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>h[r]=b.URI.revive(d.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=h)}),w.environment.appRoot=b.URI.revive(d.transformIncomingURIs(w.environment.appRoot));const S=w.environment.extensionDevelopmentLocationURI;return S&&(w.environment.extensionDevelopmentLocationURI=S.map(t=>b.URI.revive(d.transformIncomingURIs(t)))),w.environment.extensionTestsLocationURI=b.URI.revive(d.transformIncomingURIs(w.environment.extensionTestsLocationURI)),w.environment.globalStorageHome=b.URI.revive(d.transformIncomingURIs(w.environment.globalStorageHome)),w.environment.workspaceStorageHome=b.URI.revive(d.transformIncomingURIs(w.environment.workspaceStorageHome)),w.nlsBaseUrl=b.URI.revive(d.transformIncomingURIs(w.nlsBaseUrl)),w.logsLocation=b.URI.revive(d.transformIncomingURIs(w.logsLocation)),w.logFile=b.URI.revive(d.transformIncomingURIs(w.logFile)),w.workspace=d.transformIncomingURIs(w.workspace),w}}e.ExtensionHostMain=f}),define(Ie[237],Ce([1,0,18,15,21,44,13,19,22,2,43]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(v,w,d,S){this.query=v,this.provider=w,this.fileUtils=d,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,w){const d=this.query.folderQueries||[],S=new b.CancellationTokenSource;return w.onCancellationRequested(()=>S.cancel()),new Promise((t,h)=>{this.collector=new C(v);let r=!1;const n=(o,u)=>{if(!r&&!this.isLimitHit){const i=this.resultSize(o);a(o)&&typeof this.query.maxResults=="number"&&this.resultCount+i>this.query.maxResults&&(this.isLimitHit=!0,r=!0,S.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const c=this.resultSize(o);this.resultCount+=c,(c>0||!a(o))&&this.collector.add(o,u)}};Promise.all(d.map((o,u)=>this.searchInFolder(o,i=>n(i,u),S.token))).then(o=>{S.dispose(),this.collector.flush();const u=o.some(i=>!!i&&!!i.limitHit);t({limitHit:this.isLimitHit||u,messages:(0,s.flatten)(o.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.processType}})},o=>{S.dispose();const u=(0,N.toErrorMessage)(o);h(new Error(u))})})}resultSize(v){return a(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,w){const d=Array.isArray(v.ranges)?v.ranges:[v.ranges],S=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:d.slice(0,w),preview:{matches:S.slice(0,w),text:v.preview.text},uri:v.uri}}async searchInFolder(v,w,d){const S=new R.QueryGlobTester(this.query,v),t=[],h={report:o=>{if(!this.validateProviderResult(o))return;const u=v.folder.scheme===_.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(o.uri))):void 0,i=y.relativePath(v.folder,o.uri);if(i){const c=S.includedInQuery(i,A.basename(i),u);(0,I.isThenable)(c)?t.push(c.then(g=>{g&&w(o)})):c&&w(o)}}},r=this.getSearchOptionsForFolder(v),n=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,h,d);return t.length&&await Promise.all(t),n}validateProviderResult(v){if(a(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const w=(0,R.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),d=(0,R.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),S={folder:P.URI.from(v.folder),excludes:d,includes:w,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=E;function m(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class C{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new l(512,w=>this.sendItems(w))}add(v,w){this._currentFileMatch&&(this._currentFolderIdx!==w||!y.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=w,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(p(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=C;function p(f){return a(f)?{preview:{matches:(0,s.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,s.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function a(f){return!!f.preview}e.extensionResultIsMatch=a;class l{constructor(v,w){this.maxBatchSize=v,this.cb=w,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,w){!v||this.addItemToBatch(v,w)}addItems(v,w){!v||this.addItemsToBatch(v,w)}addItemToBatch(v,w){this.batch.push(v),this.batchSize+=w,this.onUpdate()}addItemsToBatch(v,w){this.batch=this.batch.concat(v),this.batchSize+=w,this.onUpdate()}onUpdate(){this.totalNumberCompleted<l.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},l.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=l,l.TIMEOUT=4e3,l.START_BATCH_AFTER_COUNT=50}),define(Ie[104],Ce([1,0,7,5,3,232,14,49,11,2,237]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(a,l,f){this.extHostRpc=a,this._uriTransformer=l,this._logService=f,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,l){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const f=this._handlePool++;return this._textSearchProvider.set(f,l),this._proxy.$registerTextSearchProvider(f,this._transformScheme(a)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(a,l){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const f=this._handlePool++;return this._fileSearchProvider.set(f,l),this._proxy.$registerFileSearchProvider(f,this._transformScheme(a)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(a,l,f,v){const w=m(f),d=this._fileSearchProvider.get(a);if(d)return this._fileSearchManager.fileSearch(w,d,S=>{this._proxy.$handleFileMatch(a,l,S.map(t=>t.resource))},v);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,l,f,v){const w=this._textSearchProvider.get(a);if(!w||!w.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const d=m(f);return this.createTextSearchManager(d,w).search(t=>this._proxy.$handleTextMatch(a,l,t),v)}$enableExtensionHostSearch(){}createTextSearchManager(a,l){return new R.TextSearchManager(a,l,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};E=xe([$e(0,_.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,y.ILogService)],E),e.ExtHostSearch=E;function m(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(C),extraFileResources:p.extraFileResources&&p.extraFileResources.map(a=>P.URI.revive(a))}}e.reviveQuery=m;function C(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(Ie[238],Ce([1,0,58,99,31,97,32,37,52,55,101,103,104,73,63,70,98,54,36,72,68,53,209,11,179,102,71]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S,t,h,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,s.registerSingleton)(h.ILoggerService,t.ExtHostLoggerService,1),(0,s.registerSingleton)(h.ILogService,r.ExtHostLogService,1),(0,s.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,!1),(0,s.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,s.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,s.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,s.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,!1),(0,s.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,!1),(0,s.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,!1),(0,s.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,s.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService,1),(0,s.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,s.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,!1),(0,s.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,s.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,s.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,!1),(0,s.registerSingleton)(l.IExtHostWindow,l.ExtHostWindow,!1),(0,s.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace,!1),(0,s.registerSingleton)(w.IExtHostSecretState,w.ExtHostSecretState,!1),(0,s.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry,!1),(0,s.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs,!1),(0,s.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ie[239],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class s{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const N=this._dragOperations.get(b);return this._dragOperations.delete(b),N}}addDragOperationTransfer(b,N){this._dragOperations.set(b,N)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,N){this._renderedElements.set(b,N)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=s}),define(Ie[240],Ce([1,0,135,6,22,2,4,7,15,6,9,18,8,21,239,28]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(w,d){if((0,R.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let S;return Array.isArray(w.highlights)&&(S=w.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),S=S.length?S:void 0),{label:w.label,highlights:S}}}class f{constructor(d,S,t){this._proxy=d,this.commands=S,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeviewsService;function h(r){return r&&r.$treeViewId&&(r.$treeItemHandle||r.$selectedTreeItems||r.$focusedTreeItem)}S.registerArgumentProcessor({processArgument:r=>h(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(n=>h(n)?this.convertArgument(n):n):r})}registerTreeDataProvider(d,S,t){const h=this.createTreeView(d,{treeDataProvider:S},t);return{dispose:()=>h.dispose()}}createTreeView(d,S,t){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=S.dragAndDropController?.dropMimeTypes??[],r=S.dragAndDropController?.dragMimeTypes??[],n=!!S.dragAndDropController?.handleDrag,o=!!S.dragAndDropController?.handleDrop,u=this.createExtHostTreeView(d,S,t),i=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,dropMimeTypes:h,dragMimeTypes:r,hasHandleDrag:n,hasHandleDrop:o});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,a.checkProposedApiEnabled)(t,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(c){u.message=c},get title(){return u.title},set title(c){u.title=c},get description(){return u.description},set description(c){u.description=c},get badge(){return u.badge},set badge(c){c!==void 0&&P.ViewBadge.isViewBadge(c)?u.badge={value:Math.floor(Math.abs(c.value)),tooltip:c.tooltip}:c===void 0&&(u.badge=void 0)},reveal:(c,g)=>u.reveal(c,g),dispose:async()=>{await i,this.treeViews.delete(d),u.dispose()}}}$getChildren(d,S){const t=this.treeViews.get(d);return t?t.getChildren(S):Promise.reject(new Error((0,s.localize)(0,null,d)))}async $handleDrop(d,S,t,h,r,n,o,u){const i=this.treeViews.get(d);if(!i)return Promise.reject(new Error((0,s.localize)(1,null,d)));const c=m.DataTransfer.toDataTransfer(t,async g=>(await this._proxy.$resolveDropFileData(d,S,g)).buffer);return o===d&&u&&await this.addAdditionalTransferItems(c,i,u,r,n),i.onDrop(c,h,r)}async addAdditionalTransferItems(d,S,t,h,r){const n=this.treeDragAndDropService.removeDragOperationTransfer(r);if(n)(await n)?.forEach((o,u)=>{o&&d.set(u,o)});else if(r&&S.handleDrag){const o=S.handleDrag(t,d,h);this.treeDragAndDropService.addDragOperationTransfer(r,o),await o}return d}async $handleDrag(d,S,t,h){const r=this.treeViews.get(d);if(!r)return Promise.reject(new Error((0,s.localize)(2,null,d)));const n=await this.addAdditionalTransferItems(new I.DataTransfer,r,S,h,t);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(d){const S=this.treeViews.get(d);if(!S)throw new Error((0,s.localize)(3,null,d));return S.hasResolve}$resolve(d,S,t){const h=this.treeViews.get(d);if(!h)throw new Error((0,s.localize)(4,null,d));return h.resolveTreeItem(S,t)}$setExpanded(d,S,t){const h=this.treeViews.get(d);if(!h)throw new Error((0,s.localize)(5,null,d));h.setExpanded(S,t)}$setSelection(d,S){const t=this.treeViews.get(d);if(!t)throw new Error((0,s.localize)(6,null,d));t.setSelection(S)}$setFocus(d,S){const t=this.treeViews.get(d);if(!t)throw new Error((0,s.localize)(7,null,d));t.setFocus(S)}$setVisible(d,S){const t=this.treeViews.get(d);if(!t)throw new Error((0,s.localize)(8,null,d));t.setVisible(S)}$changeCheckboxState(d,S){const t=this.treeViews.get(d);if(!t)throw new Error((0,s.localize)(9,null,d));t.setCheckboxState(S)}createExtHostTreeView(d,S,t){const h=new v(d,S,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(d,h),h}convertArgument(d){const S=this.treeViews.get(d.$treeViewId);return S&&"$treeItemHandle"in d?S.getExtensionElement(d.$treeItemHandle):S&&"$focusedTreeItem"in d&&d.$focusedTreeItem?S.focusedElement:null}}e.ExtHostTreeViews=f;class v extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,R.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,S,t,h,r,n){if(super(),this.viewId=d,this.proxy=t,this.commands=h,this.logService=r,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,n.contributes&&n.contributes.views)for(const i in n.contributes.views)for(const c of n.contributes.views[i])c.id===d&&(this._title=c.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let o,u;this._register(_.Event.debounce(this._onDidChangeData.event,(i,c)=>(i||(i={message:!1,elements:[]}),c.element!==!1&&(o||(o=new Promise(g=>u=g),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(c.element)?i.elements.push(...c.element):i.elements.push(c.element)),c.message&&(i.message=!0),i),200,!0)(({message:i,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=u;return o=null,this.refresh(c).then(()=>g())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(d){const S=d?this.getExtensionElement(d):void 0;if(d&&!S)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(d);return t||(t=await this.fetchChildrenNodes(S)),t?t.map(h=>h.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,S){S=S||{select:!0,focus:!1};const t=(0,R.isUndefinedOrNull)(S.select)?!0:S.select,h=(0,R.isUndefinedOrNull)(S.focus)?!1:S.focus,r=(0,R.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(n=>this.resolveTreeNode(d,n[n.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:n.map(u=>u.item)},{select:t,focus:h,expand:r})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:h,expand:r})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=m.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,S){const t=this.getExtensionElement(d);t&&(S?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(d){(0,E.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(d){this._focusedHandle=d}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const S=(await Promise.all(d.map(async t=>{const h=this.getExtensionElement(t.treeItemHandle);return h?{extensionItem:h,treeItem:await this.dataProvider.getTreeItem(h),newState:t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);S.forEach(t=>{t.treeItem.checkboxState=t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:S.map(t=>[t.extensionItem,t.newState])})}async handleDrag(d,S,t){const h=[];for(const r of d){const n=this.getExtensionElement(r);n&&h.push(n)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,S,t),S}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,S,t){const h=S?this.getExtensionElement(S):void 0;if(!(!h&&S||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,d,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,S){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(d);if(t){const h=this.nodes.get(t);if(h){const r=await this.dataProvider.resolveTreeItem(h.extensionItem,t,S)??h.extensionItem;return this.validateTreeItem(r),h.item.tooltip=this.getTooltip(r.tooltip),h.item.command=this.getCommand(h.disposableStore,r.command),h.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(S=>S?this.resolveUnknownParentChain(S).then(t=>this.resolveTreeNode(S,t[t.length-1]).then(h=>(t.push(h),t))):Promise.resolve([]))}resolveParent(d){const S=this.nodes.get(d);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,S){const t=this.nodes.get(d);return t?Promise.resolve(t):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(h=>this.createHandle(d,h,S,!0)).then(h=>this.getChildren(S?S.item.handle:void 0).then(()=>{const r=this.getExtensionElement(h);if(r){const n=this.nodes.get(r);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(d){if(d){let S;if(typeof d=="string"){const t=this.getExtensionElement(d);S=t?this.nodes.get(t):void 0}else S=d;return S&&S.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const S=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=d?this.nodes.get(d):void 0,h=await this.dataProvider.getChildren(d);if(S.token.isCancellationRequested)return;const r=await Promise.all((0,E.coalesce)(h||[]).map(async n=>{const o=await this.dataProvider.getTreeItem(n);return o&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(n,o,t):null}));return S.token.isCancellationRequested?void 0:(0,E.coalesce)(r)}finally{S.dispose()}}refresh(d){if(d.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(d);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const S=new Set,t=d.map(r=>this.nodes.get(r));for(const r of t)if(r&&!S.has(r.item.handle)){let n=r;for(;n&&n.parent&&t.findIndex(o=>n&&n.parent&&o&&o.item.handle===n.parent.item.handle)===-1;){const o=this.elements.get(n.parent.item.handle);n=o?this.nodes.get(o):void 0}n&&!n.parent&&S.add(r.item.handle)}const h=[];return S.forEach(r=>{const n=this.elements.get(r);if(n){const o=this.nodes.get(n);o&&(!o.parent||!S.has(o.parent.item.handle))&&h.push(r)}}),h}refreshHandles(d){const S={};return Promise.all(d.map(t=>this.refreshNode(t).then(h=>{h&&(S[t]=h.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(d){const S=this.getExtensionElement(d);if(S){const t=this.nodes.get(S);if(t)return this.clearChildren(S),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(h=>{if(h){const r=this.createTreeNode(S,h,t.parent);return this.updateNodeCache(S,r,t,t.parent),t.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,S,t){const h=this.createTreeNode(d,S,t);if(S.id&&this.elements.has(h.item.handle))throw new Error((0,s.localize)(10,null,S.id));return this.addNodeToCache(d,h),this.addNodeToParentCache(h,t),h}getTooltip(d){return P.MarkdownString.isMarkdownString(d)?m.MarkdownString.from(d):d}getCommand(d,S){return S?{...this.commands.toInternal(S,d),originalId:S.command}:void 0}getCheckbox(d){if(!d.checkboxState)return;let S,t;return typeof d.checkboxState=="number"?S=d.checkboxState:(S=d.checkboxState.state,t=d.checkboxState.tooltip),{isChecked:S===P.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(d){if(!P.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,S,t){this.validateTreeItem(S);const h=new A.DisposableStore,r=this.createHandle(d,S,t),n=this.getLightIconPath(S);return{item:{handle:r,parentHandle:t?t.item.handle:void 0,label:l(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(h,S.command),contextValue:S.contextValue,icon:n,iconDark:this.getDarkIconPath(S)||n,themeIcon:this.getThemeIcon(S),collapsibleState:(0,R.isUndefinedOrNull)(S.collapsibleState)?P.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation,checkbox:this.getCheckbox(S)},extensionItem:S,parent:t,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(d){return d.iconPath instanceof P.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:S,label:t,resourceUri:h},r,n){if(S)return`${v.ID_HANDLE_PREFIX}/${S}`;const o=l(t,this.extension),u=r?r.item.handle:v.LABEL_HANDLE_PREFIX;let i=o?o.label:h?(0,b.basename)(h):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const c=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,g=this.getChildrenNodes(r)||[];let T,F=0;do{if(T=`${u}/${F}:${i}`,n||!this.elements.has(T)||c===T)break;F++}while(F<=g.length);return T}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof P.ThemeIcon))return typeof d.iconPath=="string"||N.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof P.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return N.URI.isUri(d)?d:N.URI.file(d)}addNodeToCache(d,S){this.elements.set(S.item.handle,d),this.nodes.set(d,S)}updateNodeCache(d,S,t,h){this.elements.delete(S.item.handle),this.nodes.delete(d),S.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(d,S);const r=this.getChildrenNodes(h)||[],n=r.filter(o=>o.item.handle===t.item.handle)[0];n&&r.splice(r.indexOf(n),1,S)}addNodeToParentCache(d,S){S?(S.children||(S.children=[]),S.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const S=this.nodes.get(d);if(S){if(S.children)for(const t of S.children){const h=this.elements.get(t.item.handle);h&&this.clear(h)}S.children=void 0}}else this.clearAll()}clear(d){const S=this.nodes.get(d);if(S){if(S.children)for(const t of S.children){const h=this.elements.get(t.item.handle);h&&this.clear(h)}this.nodes.delete(d),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ie[241],Ce([1,0,21,12,4,29,2,122,250,110,120,35,5,67,194,193,37,195,32,197,198,199,182,200,52,33,202,203,206,208,210,99,185,214,215,216,73,55,219,240,8,6,222,56,98,31,166,205,60,97,101,103,104,11,49,14,27,211,180,63,70,191,220,74,54,225,223,224,192,36,217,221,72,53,68,212,100,213,13,86,184,163,204,7,28,168,71]),function(ne,e,s,I,b,N,_,A,y,P,R,E,m,C,p,a,l,f,v,w,d,S,t,h,r,n,o,u,i,c,g,T,F,j,U,D,x,M,O,H,W,z,G,te,he,re,be,le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,De,ae,ue,ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be,je,et,Ke,Ve,it,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(at){const rt=at.get(ye.IExtHostInitDataService),_t=at.get(Ee.IExtHostFileSystemInfo),Rt=at.get(V.IExtHostConsumerFileSystem),Ot=at.get(n.IExtHostExtensionService),mt=at.get(re.IExtHostWorkspace),yt=at.get(Ge.IExtHostTelemetry),Lt=at.get(v.IExtHostConfiguration),Mt=at.get(Xe.IURITransformerService),qe=at.get(ke.IExtHostRpcService),zt=at.get(x.IExtHostStorage),Ft=at.get(B.IExtensionStoragePaths),Tt=at.get(Ue.ILoggerService),ft=at.get(Ue.ILogService),It=at.get(ue.IExtHostTunnelService),_e=at.get(ee.IExtHostApiDeprecationService),Te=at.get(he.IExtHostWindow),ge=at.get(ze.IExtHostSecretState),K=at.get(Je.IExtHostEditorTabs);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,_t),qe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Tt),qe.set(m.ExtHostContext.ExtHostWorkspace,mt),qe.set(m.ExtHostContext.ExtHostConfiguration,Lt),qe.set(m.ExtHostContext.ExtHostExtensionService,Ot),qe.set(m.ExtHostContext.ExtHostStorage,zt),qe.set(m.ExtHostContext.ExtHostTunnelService,It),qe.set(m.ExtHostContext.ExtHostWindow,Te),qe.set(m.ExtHostContext.ExtHostSecretState,ge),qe.set(m.ExtHostContext.ExtHostTelemetry,yt),qe.set(m.ExtHostContext.ExtHostEditorTabs,K);const Ae=qe.set(m.ExtHostContext.ExtHostDecorations,at.get(Q.IExtHostDecorations)),Me=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),Ze=qe.set(m.ExtHostContext.ExtHostCommands,at.get(l.IExtHostCommands)),We=qe.set(m.ExtHostContext.ExtHostTerminalService,at.get(M.IExtHostTerminalService)),tt=qe.set(m.ExtHostContext.ExtHostDebugService,at.get(Se.IExtHostDebugService)),gt=qe.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),vt=qe.set(m.ExtHostContext.ExtHostTask,at.get(pe.IExtHostTask)),Ct=qe.set(m.ExtHostContext.ExtHostOutputService,at.get(T.IExtHostOutputService)),Dt=qe.set(m.ExtHostContext.ExtHostLocalization,at.get(st.IExtHostLocalizationService)),Et=qe.set(m.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),pt=qe.set(m.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(qe,Me)),wt=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new S.ExtHostDocumentContentProvider(qe,Me,ft)),ei=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ft,pt,qe.getProxy(m.MainContext.MainThreadBulkEdits))),bt=qe.set(m.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,Ze,Me,pt)),qt=qe.set(m.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(bt)),$t=qe.set(m.ExtHostContext.ExtHostNotebookEditors,new Be.ExtHostNotebookEditors(ft,bt)),ti=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(qe,rt,bt,Ze,ft)),ci=qe.set(m.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,bt)),kt=qe.set(m.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(qe,Me)),ii=qe.set(m.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),Ze,ft)),ui=qe.set(m.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),kt,rt.remote)),Ut=qe.set(m.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(qe,ft,_t)),Jt=qe.set(m.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(qe,pt,Ze.converter,Mt)),ut=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(qe,Mt,pt,Ze,Ut,ft,_e,yt)),di=qe.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(qe,ut)),Nt=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(qe,ft,Me)),Kt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(qe,mt,Ze)),ni=qe.set(m.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,Ze,ft)),hi=qe.set(m.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(qe,Ze,pt)),ri=qe.set(m.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),fi=qe.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(qe)),si=qe.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),Zt=qe.set(m.ExtHostContext.ExtHostAuthentication,new Z.ExtHostAuthentication(qe)),mi=qe.set(m.ExtHostContext.ExtHostTimeline,new k.ExtHostTimeline(qe,Ze)),gi=qe.set(m.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(qe,rt.remote,mt,ft,_e)),pi=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(qe,gi,mt)),vi=qe.set(m.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(qe,pt,Ft,gi,pi)),Ei=qe.set(m.ExtHostContext.ExtHostWebviewViews,new q.ExtHostWebviewViews(qe,gi)),Gt=qe.set(m.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(qe,Ze,Me)),bi=qe.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(m.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(qe,bt,Me,Ze,ft));const Ni=Object.values(m.ExtHostContext);qe.assertRegistered(Ni);const wi=new J.ExtHostBulkEdits(qe,Me),Si=new a.ExtHostClipboard(qe),_i=new g.ExtHostMessageService(qe,ft),Ti=new d.ExtHostDialogs(qe),ki=new D.ExtHostStatusBar(qe,Ze.converter);return p.ExtHostApiCommands.register(Ze),function(Le,Ht,Pi){const ht=function(){let se=!Le.isUnderDevelopment;function de(){se||(ft.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return ot}}(),yi={getSession(se,de,Re){return Zt.getSession(Le,se,de,Re)},async hasSession(se,de){return(0,Ve.checkProposedApiEnabled)(Le,"authSession"),!!await Zt.getSession(Le,se,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,de,Re,ot){return Zt.registerAuthenticationProvider(se,de,Re,ot)}},Li={registerCommand(se,de,Re){return Ze.registerCommand(!0,se,de,Re,void 0,Le)},registerTextEditorCommand(se,de,Re){return Ze.registerCommand(!0,se,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){ft.warn("Cannot execute "+se+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||ft.warn("Edits from command "+se+" were not applied.")},Pt=>{ft.warn("An error occurred while running command "+se,Pt)})},void 0,void 0,Le)},registerDiffInformationCommand:(se,de,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"diffCommand"),Ze.registerCommand(!0,se,async(...ot)=>{const St=Me.activeEditor(!0);if(!St){ft.warn("Cannot execute "+se+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Le)),executeCommand(se,...de){return Ze.executeCommand(se,...de)},getCommands(se=!1){return Ze.getCommands(se)}},Ai={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return We.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Le,"envShellEvent"),We.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.instantiateLogger(Le,se)},openExternal(se,de){return Te.openUri(se,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===rt.environment.appUriScheme)return Et.createAppUri(se);try{return await Te.asExternalUri(se,{allowTunneling:!!rt.remote.authority})}catch(de){if((0,me.matchesScheme)(se,Y.Schemas.http)||(0,me.matchesScheme)(se,Y.Schemas.https))return se;throw de}},get remoteName(){return(0,fe.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Le,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),ft.getLevel()},get onDidChangeLogLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),ft.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Ai);const Mi={createTestController(se,de,Re){return Gt.createTestController(se,de,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.createTestObserver()},runTests(se){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.runTests(se)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.results}},Xt=rt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ui={getExtension(se,de){(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")||(de=!1);const Re=Ht.mine.getExtensionDescription(se);if(Re)return new n.Extension(Ot,Le.identifier,Re,Xt,!1);if(de){const ot=Ht.all.getExtensionDescription(se);if(ot)return new n.Extension(Ot,Le.identifier,ot,Xt,!0)}},get all(){const se=[];for(const de of Ht.mine.getAllExtensionDescriptions())se.push(new n.Extension(Ot,Le.identifier,de,Xt,!1));return se},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Le,"extensionsAny");const se=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);de.push(new n.Extension(Ot,Le.identifier,Re,Xt,ot))}return de},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")?b.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Bi={createDiagnosticCollection(se){return Ut.createDiagnosticCollection(Le.identifier,se)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:se=>Ut.getDiagnostics(se),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(se,de){return Jt.changeLanguage(se.uri,de)},match(se,de){const Re=pt.getDocumentData(de.uri)?.notebook;return(0,R.score)(W.LanguageSelector.from(se),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,de,Re){return ut.registerCodeActionProvider(Le,ht(se),de,Re)},registerDocumentPasteEditProvider(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"documentPaste"),ut.registerDocumentPasteEditProvider(Le,ht(se),de,Re)},registerCodeLensProvider(se,de){return ut.registerCodeLensProvider(Le,ht(se),de)},registerDefinitionProvider(se,de){return ut.registerDefinitionProvider(Le,ht(se),de)},registerDeclarationProvider(se,de){return ut.registerDeclarationProvider(Le,ht(se),de)},registerImplementationProvider(se,de){return ut.registerImplementationProvider(Le,ht(se),de)},registerTypeDefinitionProvider(se,de){return ut.registerTypeDefinitionProvider(Le,ht(se),de)},registerHoverProvider(se,de){return ut.registerHoverProvider(Le,ht(se),de,Le.identifier)},registerEvaluatableExpressionProvider(se,de){return ut.registerEvaluatableExpressionProvider(Le,ht(se),de,Le.identifier)},registerInlineValuesProvider(se,de){return ut.registerInlineValuesProvider(Le,ht(se),de,Le.identifier)},registerDocumentHighlightProvider(se,de){return ut.registerDocumentHighlightProvider(Le,ht(se),de)},registerLinkedEditingRangeProvider(se,de){return ut.registerLinkedEditingRangeProvider(Le,ht(se),de)},registerReferenceProvider(se,de){return ut.registerReferenceProvider(Le,ht(se),de)},registerRenameProvider(se,de){return ut.registerRenameProvider(Le,ht(se),de)},registerDocumentSymbolProvider(se,de,Re){return ut.registerDocumentSymbolProvider(Le,ht(se),de,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Le,se)},registerDocumentFormattingEditProvider(se,de){return ut.registerDocumentFormattingEditProvider(Le,ht(se),de)},registerDocumentRangeFormattingEditProvider(se,de){return ut.registerDocumentRangeFormattingEditProvider(Le,ht(se),de)},registerOnTypeFormattingEditProvider(se,de,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Le,ht(se),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,de,Re){return ut.registerDocumentSemanticTokensProvider(Le,ht(se),de,Re)},registerDocumentRangeSemanticTokensProvider(se,de,Re){return ut.registerDocumentRangeSemanticTokensProvider(Le,ht(se),de,Re)},registerSignatureHelpProvider(se,de,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Le,ht(se),de,Re):ut.registerSignatureHelpProvider(Le,ht(se),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,de,...Re){return ut.registerCompletionItemProvider(Le,ht(se),de,Re)},registerInlineCompletionItemProvider(se,de){return de.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Le,ht(se),de)},registerInlineCompletionItemProviderNew(se,de){if((0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Le,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Le,ht(se),de)},registerDocumentLinkProvider(se,de){return ut.registerDocumentLinkProvider(Le,ht(se),de)},registerColorProvider(se,de){return ut.registerColorProvider(Le,ht(se),de)},registerFoldingRangeProvider(se,de){return ut.registerFoldingRangeProvider(Le,ht(se),de)},registerSelectionRangeProvider(se,de){return ut.registerSelectionRangeProvider(Le,se,de)},registerCallHierarchyProvider(se,de){return ut.registerCallHierarchyProvider(Le,se,de)},registerTypeHierarchyProvider(se,de){return ut.registerTypeHierarchyProvider(Le,se,de)},setLanguageConfiguration:(se,de)=>ut.setLanguageConfiguration(Le,se,de),getTokenInformationAtPosition(se,de){return(0,Ve.checkProposedApiEnabled)(Le,"tokenInformation"),Jt.tokenAtPosition(se,de)},registerInlayHintsProvider(se,de){return ut.registerInlayHintsProvider(Le,se,de)},createLanguageStatusItem(se,de){return Jt.createLanguageStatusItem(Le,se,de)},registerDocumentDropEditProvider(se,de){return ut.registerDocumentOnDropEditProvider(Le,se,de)}},zi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(se,de,Re){const ot=await(_.URI.isUri(se)?Promise.resolve(Ri.openTextDocument(se)):Promise.resolve(se));return kt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(se){return kt.createTextEditorDecorationType(Le,se)},onDidChangeActiveTextEditor(se,de,Re){return kt.onDidChangeActiveTextEditor(se,de,Re)},onDidChangeVisibleTextEditors(se,de,Re){return kt.onDidChangeVisibleTextEditors(se,de,Re)},onDidChangeTextEditorSelection(se,de,Re){return kt.onDidChangeTextEditorSelection(se,de,Re)},onDidChangeTextEditorOptions(se,de,Re){return kt.onDidChangeTextEditorOptions(se,de,Re)},onDidChangeTextEditorVisibleRanges(se,de,Re){return kt.onDidChangeTextEditorVisibleRanges(se,de,Re)},onDidChangeTextEditorViewColumn(se,de,Re){return kt.onDidChangeTextEditorViewColumn(se,de,Re)},onDidCloseTerminal(se,de,Re){return We.onDidCloseTerminal(se,de,Re)},onDidOpenTerminal(se,de,Re){return We.onDidOpenTerminal(se,de,Re)},onDidChangeActiveTerminal(se,de,Re){return We.onDidChangeActiveTerminal(se,de,Re)},onDidChangeTerminalDimensions(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDimensions"),We.onDidChangeTerminalDimensions(se,de,Re)},onDidChangeTerminalState(se,de,Re){return We.onDidChangeTerminalState(se,de,Re)},onDidWriteTerminalData(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),We.onDidWriteTerminalData(se,de,Re)},get state(){return Te.state},onDidChangeWindowState(se,de,Re){return Te.onDidChangeWindowState(se,de,Re)},showInformationMessage(se,...de){return _i.showMessage(Le,N.default.Info,se,de[0],de.slice(1))},showWarningMessage(se,...de){return _i.showMessage(Le,N.default.Warning,se,de[0],de.slice(1))},showErrorMessage(se,...de){return _i.showMessage(Le,N.default.Error,se,de[0],de.slice(1))},showQuickPick(se,de,Re){return Kt.showQuickPick(se,de,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,de){return Kt.showInput(se,de)},showOpenDialog(se){return Ti.showOpenDialog(se)},showSaveDialog(se){return Ti.showSaveDialog(se)},createStatusBarItem(se,de,Re){let ot,St,Pt;return typeof se=="string"?(ot=se,St=de,Pt=Re):(St=se,Pt=de),ki.createStatusBarEntry(Le,ot,St,Pt)},setStatusBarMessage(se,de){return ki.setStatusBarMessage(se,de)},withScmProgress(se){return _e.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ri.withProgress(Le,{location:z.ProgressLocation.SourceControl},(de,Re)=>se({report(ot){}}))},withProgress(se,de){return ri.withProgress(Le,se,de)},createOutputChannel(se,de){return Ct.createOutputChannel(se,de,Le)},createWebviewPanel(se,de,Re,ot){return pi.createWebviewPanel(Le,se,de,Re,ot)},createWebviewTextEditorInset(se,de,Re,ot){return(0,Ve.checkProposedApiEnabled)(Le,"editorInsets"),ui.createWebviewEditorInset(se,de,Re,ot,Le)},createTerminal(se,de,Re){return typeof se=="object"?"pty"in se?We.createExtensionTerminal(se):We.createTerminalFromOptions(se):We.createTerminal(se,de,Re)},registerTerminalLinkProvider(se){return We.registerLinkProvider(se)},registerTerminalProfileProvider(se,de){return We.registerProfileProvider(Le,se,de)},registerTreeDataProvider(se,de){return ii.registerTreeDataProvider(se,de,Le)},createTreeView(se,de){return ii.createTreeView(se,de,Le)},registerWebviewPanelSerializer:(se,de)=>pi.registerWebviewPanelSerializer(Le,se,de),registerCustomEditorProvider:(se,de,Re={})=>vi.registerCustomEditorProvider(Le,se,de,Re),registerFileDecorationProvider(se){return Ae.registerFileDecorationProvider(se,Le.identifier)},registerUriHandler(se){return Et.registerUriHandler(Le.identifier,se)},createQuickPick(){return Kt.createQuickPick(Le)},createInputBox(){return Kt.createInputBox(Le)},get activeColorTheme(){return si.activeColorTheme},onDidChangeActiveColorTheme(se,de,Re){return si.onDidChangeActiveColorTheme(se,de,Re)},registerWebviewViewProvider(se,de,Re){return Ei.registerWebviewViewProvider(Le,se,de,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,de,Re){return bt.onDidChangeActiveNotebookEditor(se,de,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,de,Re){return $t.onDidChangeNotebookEditorSelection(se,de,Re)},onDidChangeNotebookEditorVisibleRanges(se,de,Re){return $t.onDidChangeNotebookEditorVisibleRanges(se,de,Re)},showNotebookDocument(se,de){return _.URI.isUri(se)&&_e.report("window.showNotebookDocument(uri)",Le,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(se,de)},registerExternalUriOpener(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"externalUriOpener"),bi.registerExternalUriOpener(Le.identifier,se,de,Re)},get tabGroups(){return K.tabGroups}},Ri={get rootPath(){return _e.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw I.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw I.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw I.readonly()},updateWorkspaceFolders:(se,de,...Re)=>mt.updateWorkspaceFolders(Le,se,de||0,...Re),onDidChangeWorkspaceFolders:function(se,de,Re){return mt.onDidChangeWorkspace(se,de,Re)},asRelativePath:(se,de)=>mt.getRelativePath(se,de),findFiles:(se,de,Re,ot)=>mt.findFiles(se,de,Re,Le.identifier,ot),findTextInFiles:(se,de,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Le,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),mt.findTextInFiles(se,St||{},Pt,Le.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se,de){return wi.applyWorkspaceEdit(se,Le,de)},createFileSystemWatcher:(se,de,Re,ot)=>Nt.createFileSystemWatcher(mt,Le,se,de,Re,ot),get textDocuments(){return pt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw I.readonly()},openTextDocument(se){let de;const Re=se;if(typeof se=="string")de=Promise.resolve(_.URI.file(se));else if(_.URI.isUri(se))de=Promise.resolve(se);else if(!Re||typeof Re=="object")de=pt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>pt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(se,de,Re)=>pt.onDidAddDocument(se,de,Re),onDidCloseTextDocument:(se,de,Re)=>pt.onDidRemoveDocument(se,de,Re),onDidChangeTextDocument:(se,de,Re)=>pt.onDidChangeDocument(se,de,Re),onDidSaveTextDocument:(se,de,Re)=>pt.onDidSaveDocument(se,de,Re),onWillSaveTextDocument:(se,de,Re)=>ei.getOnWillSaveTextDocumentEvent(Le)(se,de,Re),get notebookDocuments(){return bt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,de){let Re;if(_.URI.isUri(se))Re=se,await bt.openNotebookDocument(se);else if(typeof se=="string")Re=_.URI.revive(await bt.createNotebookDocument({viewType:se,content:de}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,de,Re){return qt.onDidSaveNotebookDocument(se,de,Re)},onDidChangeNotebookDocument(se,de,Re){return qt.onDidChangeNotebookDocument(se,de,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(se,de,Re,ot){return bt.registerNotebookSerializer(Le,se,de,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,de,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Le,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",Le,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Le,se,de,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,de,Re)=>Pi.onDidChangeConfiguration(se,de,Re),getConfiguration(se,de){return de=arguments.length===1?void 0:de,Pi.getConfiguration(se,de,Le)},registerTextDocumentContentProvider(se,de){return wt.registerTextDocumentContentProvider(se,de)},registerTaskProvider:(se,de)=>(_e.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Le,se,de)),registerFileSystemProvider(se,de,Re){return(0,Ke.combinedDisposable)(di.registerFileSystemProvider(Le,se,de,Re),Rt.addFileSystemProvider(se,de))},get fs(){return Rt.value},registerFileSearchProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"fileSearchProvider"),gt.registerFileSearchProvider(se,de)),registerTextSearchProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"textSearchProvider"),gt.registerTextSearchProvider(se,de)),registerRemoteAuthorityResolver:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),Ot.registerRemoteAuthorityResolver(se,de)),registerResourceLabelFormatter:se=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),fi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,de,Re)=>Nt.onDidCreateFile(se,de,Re),onDidDeleteFiles:(se,de,Re)=>Nt.onDidDeleteFile(se,de,Re),onDidRenameFiles:(se,de,Re)=>Nt.onDidRenameFile(se,de,Re),onWillCreateFiles:(se,de,Re)=>Nt.getOnWillCreateFileEvent(Le)(se,de,Re),onWillDeleteFiles:(se,de,Re)=>Nt.getOnWillDeleteFileEvent(Le)(se,de,Re),onWillRenameFiles:(se,de,Re)=>Nt.getOnWillRenameFileEvent(Le)(se,de,Re),openTunnel:se=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.openTunnel(Le,se).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.getTunnels()},onDidChangeTunnels:(se,de,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.onDidChangeTunnels(se,de,Re)),registerPortAttributesProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"portsAttributes"),It.registerPortsAttributesProvider(se,de)),registerTimelineProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"timeline"),mi.registerTimelineProvider(se,de,Le.identifier,Ze.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,Ve.checkProposedApiEnabled)(Le,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,de,Re)=>mt.onDidGrantWorkspaceTrust(se,de,Re),registerEditSessionIdentityProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,de))},Di={get inputBox(){return _e.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Le)},createSourceControl(se,de,Re){return ni.createSourceControl(Le,se,de,Re)}},xi={createCommentController(se,de){return hi.createCommentController(Le,se,de)}},Vt={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(se,de,Re){return tt.onDidStartDebugSession(se,de,Re)},onDidTerminateDebugSession(se,de,Re){return tt.onDidTerminateDebugSession(se,de,Re)},onDidChangeActiveDebugSession(se,de,Re){return tt.onDidChangeActiveDebugSession(se,de,Re)},onDidReceiveDebugSessionCustomEvent(se,de,Re){return tt.onDidReceiveDebugSessionCustomEvent(se,de,Re)},onDidChangeBreakpoints(se,de,Re){return tt.onDidChangeBreakpoints(se,de,Re)},registerDebugConfigurationProvider(se,de,Re){return tt.registerDebugConfigurationProvider(se,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,de){return tt.registerDebugAdapterDescriptorFactory(Le,se,de)},registerDebugAdapterTrackerFactory(se,de){return tt.registerDebugAdapterTrackerFactory(se,de)},startDebugging(se,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?tt.startDebugging(se,de,{parentSession:Re}):tt.startDebugging(se,de,Re||{})},stopDebugging(se){return tt.stopDebugging(se)},addBreakpoints(se){return tt.addBreakpoints(se)},removeBreakpoints(se){return tt.removeBreakpoints(se)},asDebugSourceUri(se,de){return tt.asDebugSourceUri(se,de)}},oi={registerTaskProvider:(se,de)=>vt.registerTaskProvider(Le,se,de),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Le,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,de,Re)=>vt.onDidStartTask(se,de,Re),onDidEndTask:(se,de,Re)=>vt.onDidEndTask(se,de,Re),onDidStartTaskProcess:(se,de,Re)=>vt.onDidStartTaskProcess(se,de,Re),onDidEndTaskProcess:(se,de,Re)=>vt.onDidEndTaskProcess(se,de,Re)},$i={createNotebookController(se,de,Re,ot,St){return ti.createNotebookController(Le,se,de,Re,ot,(0,Ve.isProposedApiEnabled)(Le,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(se,de)=>bt.registerNotebookCellStatusBarItemProvider(Le,se,de),createRendererMessaging(se){return ci.createRendererMessaging(Le,se)},onDidChangeNotebookCellExecutionState(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(se,de,Re)}},Bt={t(...se){if(typeof se[0]=="string"){const de=se.shift(),Re=!se||typeof se[0]!="object"?se:se[0];return Dt.getMessage(Le.identifier.value,{message:de,args:Re})}return Dt.getMessage(Le.identifier.value,se[0])},get bundle(){return Dt.getBundle(Le.identifier.value)},get uri(){return Dt.getBundleUri(Le.identifier.value)}};return{version:rt.version,authentication:yi,commands:Li,comments:xi,debug:Vt,env:Ai,extensions:Ui,l10n:Bt,languages:Bi,notebooks:$i,scm:Di,tasks:oi,tests:Mi,window:zi,workspace:Ri,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:z.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionItemNew:z.InlineSuggestionNew,InlineCompletionList:z.InlineSuggestionList,InlineCompletionListNew:z.InlineSuggestionsNew,Hover:z.Hover,IndentAction:P.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:C.UIKind,Uri:_.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TerminalExitReason:z.TerminalExitReason,LogLevel:Ue.LogLevel}}}e.createApiFactoryAndRegisterActors=ct}),define(Ie[242],Ce([1,0,241,33,2,235,6,15,226]),function(ne,e,s,I,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends N.RequireInterceptor{_installInterceptor(){}getModule(C,p){for(const a of this._alternatives){const l=a(C);if(l){C=l;break}}if(this._factories.has(C))return this._factories.get(C).load(C,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const C=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,C,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(C){return C.browser}async _loadCommonJSModule(C,p,a){p=p.with({path:E(p.path,".js")});const l=C?.identifier.value;l&&performance.mark(`code/extHost/willFetchExtensionCode/${l}`);const f=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),v=await fetch(f.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l}`),v.status!==200)throw new Error(v.statusText);const w=await v.text(),d=`${p.toString(!0)}#vscode-extension`,S=`${w}
//# sourceURL=${d}`;let t;try{t=new Function("module","exports","require",S)}catch(o){throw console.error(l?`Loading code for extension ${l} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${p.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}C&&await this._extHostLocalizationService.initializeLocalizedMessages(C);const h={},r={exports:h},n=o=>{const u=this._fakeModules.getModule(o,p);if(u===void 0)throw new Error(`Cannot load module '${o}'`);return u};try{return a.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l}`),t(r,h,n),r.exports!==h?r.exports:h}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l}`),a.codeLoadingStop()}}async $setRemoteEnvironment(C){}async _waitForDebuggerAttachment(C=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+C;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function E(m,C){return m.endsWith(C)?m:m+C}}),define(Ie[243],Ce([1,0,58,33,74,242]),function(ne,e,s,I,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(I.IExtHostExtensionService,N.ExtHostExtensionService,!1),(0,s.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths,!1)}),define(Ie[251],Ce([1,0,23,4,67,236,228,19,75,13,2,238,243]),function(ne,e,s,I,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function C(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function a(t){self.fetch=async function(h,r){return h instanceof Request||C(String(h))&&(h=(await t(R.URI.parse(String(h)))).toString(!0)),p(h,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,r,n,o,u){(async()=>(C(r.toString())&&(r=(await t(R.URI.parse(r.toString()))).toString(!0)),super.open(h,r,n??!0,o,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(h,r){if(/^file:/i.test(h.toString()))h=P.FileAccess.asBrowserUri(R.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(g){function T(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const F=fetch.bind(self);self.fetch=function(U,D){return U instanceof Request?F(U,D):F(T(U),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,D,x,M,O){return super.open(U,T(D),x??!0,M,O)}};const j=importScripts.bind(self);self.importScripts=(...U)=>{j(...U.map(T))},j(g)}.toString()}('${h}'))`;r=r||{},r.name=r.name||A.basename(h.toString());const u=new Blob([o],{type:"application/javascript"}),i=URL.createObjectURL(u);return new t(i,r)}}else self.Worker=class extends _.NestedWorker{constructor(t,h){super(m,t,{name:A.basename(t.toString()),...h})}};const l=new class{constructor(){this.pid=void 0}exit(t){E()}async exists(t){return!0}async realpath(t){return t}};class f{constructor(){const h=new MessageChannel,r=new I.Emitter;let n=!1;m(h.port2,[h.port2]),h.port1.onmessage=o=>{const{data:u}=o;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const i=s.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,b.isMessageOfType)(i,2)){n=!0,w("received terminate message from renderer");return}r.fire(i)},this.protocol={onMessage:r.event,send:o=>{if(!n){const u=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);h.port1.postMessage(u,[u])}}}}}function v(t){return new Promise(h=>{const r=t.onMessage(n=>{r.dispose();const o=JSON.parse(n.toString());t.send((0,b.createMessageOfType)(0)),h({protocol:t,initData:o})});t.send((0,b.createMessageOfType)(1))})}let w=t=>E();function d(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function S(){y.mark("code/extHost/willConnectToRenderer");const t=new f;return{onmessage(h){!d(h)||v(t.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const n=new N.ExtensionHostMain(r.protocol,r.initData,l,null,h.data);a(o=>n.asBrowserUri(o)),w=o=>n.terminate(o)})}}}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ef8e6b87a2a5a25ba1ef946bd1640ca3510956c/core/vs/workbench/api/worker/extensionHostWorker.js.map
